declare const angular: ng.IAngularStatic;
import { highlightMenuItem } from '../../common/highlight-menu-item';

const states: Array<ng.ui.IState> = [
	{
		name: 'customers.roles',
		url: '/roles',
		abstract: true,
		template: '<ui-view/>',
	},
	{
		name: 'customers.roles.index',
		url: '',
		component: 'rolesPage',
	},
	{
		name: 'customers.roles.create',
		url: '/new',
		component: 'rolePage',
	},
	{
		name: 'customers.roles.edit',
		url: '/:id',
		component: 'rolePage',
	},
];

export const RolesRoutingModule = angular
	.module( 'RolesRoutingModule', [] )
	.config( (
		$stateProvider: ng.ui.IStateProvider,
	) => {
		'ngInject';

		states.forEach( ( state ) => {
			state.onEnter = () => {
				highlightMenuItem( 'customers' );
			};
			$stateProvider.state( state );
		} );
	} )
	.name;
