import React, { useEffect, useState } from 'react';
import { Notice } from '@wordpress/components';

interface Props {
    notices: {
        status: string;
        message: string;
    }[]
}

export const Notices = ( { notices }: Props ) => {
	const [ myNotices, setNotices ] = useState( [] );

	const handleRemove = ( index: number ) => {
		const updatedNotices = [ ...notices ];
		updatedNotices.splice( index, 1 );
		setNotices( updatedNotices );
	};

	useEffect( () => {
		setNotices( notices );
	}, [ notices ] );

	return ( <>
		{ myNotices.map( ( notice, index: number ) =>
			<Notice className="mx-0" key={ index } status={ notice.status } onRemove={ () => handleRemove( index ) } >{ notice.message }</Notice>,
		) }
	</>
	);
};
