import React, { useEffect, useState } from 'react';
import {
	BaseControl,
	Button,
	TextControl,
} from '@wordpress/components';

export const PasswordControl = ( props ) => {
	const [ uuId ] = useState( `password-control-${ new Date().valueOf() }` );
	const [ visible, setVisible ] = useState( false );
	const [ buttonLabel, setButtonLabel ] = useState( 'Show password' );

	useEffect( () => {
		setButtonLabel( visible ? 'Hide password' : 'Show password' );
	}, [ visible ] );

	return (
		<BaseControl id={ uuId } label={ props.label }>
			<div className="row gx-1">
				<div className="col">
					<TextControl id={ uuId } value={ props.value } onChange={ props.onChange } type={ visible ? 'text' : 'password' } autoComplete="new-password" />
				</div>
				<div className="col-auto">
					<Button variant="tertiary" icon={ visible ? 'visibility' : 'hidden' } style={ { height: 'auto' } } onClick={ () => setVisible( ! visible ) } label={ buttonLabel } />
				</div>
			</div>
		</BaseControl>
	);
};
