import React, { SyntheticEvent } from 'react';
import { Button } from '@wordpress/components';

interface Props {
    handleSubmit: ( e:SyntheticEvent ) => void;
    isBusy: boolean;
    q: string;
    setQ: React.Dispatch<React.SetStateAction<string>>;
}

export const SearchBox = ( { handleSubmit, isBusy, q, setQ }: Props ) => {
	return (
		<form onSubmit={ handleSubmit }>
			<fieldset disabled={ isBusy }>
				<div className="input-group mb-3">
					<input id="search-input" name="q" className="form-control" type="search" value={ q } onChange={ ( event ) => setQ( event.target.value ) } />
					<Button isBusy={ isBusy } id="search-submit" variant="secondary" type="submit">Search</Button>
				</div>
			</fieldset>
		</form>
	);
};
