import template from './bs-table-sortable.html';

export const BsTableSortableComponent = {
	bindings: {
		field: '@',
		label: '@',
		onClick: '&',
		params: '<',
	},
	controller: class BsTableSortableController {
		field: string;
		label: string;
		onClick: ( { sortBy, sortType }: {sortBy: string; sortType: string} ) => void;
		isAscending: boolean;
		params: {
			sortBy: string;
			sortType: string;
		};

		$onInit() {
			this.isAscending =
				( this.params.sortBy !== this.field ) ||
				this.params.sortType !== 'desc';
		}

		click( e: Event ) {
			e.preventDefault();
			const { field: sortBy } = this;
			if ( this.params.sortBy === this.field ) {
				this.isAscending = ! this.isAscending;
			}
			const sortType = this.isAscending ? 'asc' : 'desc';
			this.onClick( { sortBy, sortType } );
		}
	},
	template,
};

