declare const angular: ng.IAngularStatic;
import { highlightMenuItem } from '../../common/highlight-menu-item';

const states: Array<ng.ui.IState> = [
	{
		name: 'dashboard',
		url: '/dashboard',
		component: 'dashboardPage',
	},
];

export const DashboardRoutingModule = angular
	.module( 'DashboardRoutingModule', [] )
	.config( (
		$stateProvider: ng.ui.IStateProvider,
		$urlRouterProvider: ng.ui.IUrlRouterProvider,
	) => {
		'ngInject';

		$urlRouterProvider.otherwise( 'dashboard' );

		states.forEach( ( state ) => {
			state.onEnter = () => {
				highlightMenuItem( 'dashboard' );
			};
			$stateProvider.state( state );
		} );
	} )
	.name;
