import template from './logout.component.html';
/**
 * Log Out Component
 *
 * @namespace Components
 */
( function() {
	'use strict';

	angular
		.module( 'vendorfuelApp' )
		.component( 'vfLogout', {
			controller: LogoutController,
			template,
		} );

	LogoutController.$inject = [
		'$state',
		'Admin',
		'Localized',
		'Utils',
	];

	/**
	 * @param {Object} $state    UI Router service
	 * @param {Object} Admin     VendorFuel service
	 * @param {Object} Localized VendorFuel service
	 * @param {Object} Utils     VendorFuel service
	 */
	function LogoutController(
		$state: ng.ui.IStateService,
		Admin: any,
		Localized: any,
		Utils: any,
	) {
		this.$onInit = () => {
			if ( Admin.Authed() ) {
				Admin.Logout();
				$state.go( 'login' );
			} else if ( Localized.api_key ) {
				Utils.setLocation( '/login', true );
			} else {
				Utils.setLocation( '/subscribe', true );
			}
		};
	}
}() );
