declare const localized: any;
export class PromoCodesService {
	private apiRoot = `${ localized.apiURL }/admin/promo-codes`;
	private $http: ng.IHttpService;
	private Localized: any;

	constructor( $http: ng.IHttpService, Localized: any ) {
		'ngInject';
		this.$http = $http;
		this.Localized = Localized;
	}

	delete( id: number ) {
		return this.$http.delete( `${ this.apiRoot }/${ id }` )
			.then( ( response: { data: any } ) => {
				this.Localized.setNotifications( response.data );
			} );
	}

	get( id: number ) {
		return this.$http.get( `${ this.apiRoot }/${ id }` )
			.then( ( response: { data: any } ) => {
				this.Localized.setNotifications( response.data );
				if ( ! response.data.errors.length ) {
					return response.data;
				}
			} );
	}

	query( params?: { string: string } ) {
		return this.$http.get( this.apiRoot, { params } )
			.then( ( response: any ) => {
				this.Localized.setNotifications( response.data );
				if ( ! response.data.errors.length ) {
					return response.data;
				}
			} );
	}

	save( data: {string: string} ) {
		return this.$http.post( this.apiRoot, data )
			.then( ( response: { data: any } ) => {
				this.Localized.setNotifications( response.data );
				return response.data;
			} );
	}

	update( id: number, data: {string: string} ) {
		return this.$http.put( `${ this.apiRoot }/${ id }`, data )
			.then( ( response: { data: any } ) => {
				this.Localized.setNotifications( response.data );
			} );
	}
}
