import { highlightMenuItem } from '../../common/highlight-menu-item';
import { SettingsMappingService } from './settings-mapping/settings-mapping.service';
import { SettingsMappingComponent } from './settings-mapping/settings-mapping.component';
import { SettingsPluginComponent } from './settings-plugin/settings-plugin.component';
import { SettingsAnalyticsComponent } from './settings-analytics/settings-analytics.component';
import { SettingsOptionsComponent } from './settings-options/settings-options.component';
import { SettingsStoreComponent } from './settings-store/settings-store.component';

export const SettingsModule = angular
	.module( 'SettingsModule', [] )
	.config( (
		$stateProvider: ng.ui.IStateProvider,
	) => {
		'ngInject';
		$stateProvider.state( {
			name: 'settings',
			url: '/settings',
			component: 'vfSettings',
			onEnter() {
				highlightMenuItem( 'settings' );
			},
		} );
	} )
	.service( 'SettingsMappingService', SettingsMappingService )
	.component( 'settingsMapping', SettingsMappingComponent )
	.component( 'settingsPlugin', SettingsPluginComponent )
	.component( 'settingsAnalytics', SettingsAnalyticsComponent )
	.component( 'settingsOptions', SettingsOptionsComponent )
	.component( 'settingsStore', SettingsStoreComponent )
	.name;
