/**
 * VF Check Auth component
 *
 * @namespace Components
 */
( function() {
	'use strict';

	angular
		.module( 'vendorfuelApp' )
		.component( 'vfCheckAuth', {
			controller: AuthController,
			// Yes, there's no template for this component.
		} );

	AuthController.$inject = [
		'Admin',
		'Localized',
		'Utils',
	];

	/**
	 * @param {Object} Admin     VendorFuel service
	 * @param {Object} Localized VendorFuel service
	 * @param {Object} Utils     VendorFuel service
	 */
	function AuthController(
		Admin: any,
		Localized: any,
		Utils: any,
	) {
		/**
		 * Initialization
		 */
		this.$onInit = () => {
			if ( ! Admin.Authed() ) {
				if ( Localized.api_key ) {
					Utils.setLocation( '/login', true );
				} else {
					Utils.setLocation( '/subscribe', true );
				}
			}
		};
	}
}() );
