( function() {
	'use strict';

	angular
		.module( 'vendorfuelApp' )
		.controller( 'ContactController', ContactController );

	ContactController.$inject = [
		'$rootScope',
		'$scope',
		'Admin',
		'$state',
	];

	/**
	 * @param {Object} $rootScope Angular service
	 * @param {Object} $scope     Angular service
	 * @param {Object} Admin      VendorFuel service
	 * @param {Object} $state     UI Router service
	 */
	function ContactController(
		$rootScope: any,
		$scope: any,
		Admin: any,
		$state: ng.ui.IStateService,
	) {
		/**
		 * Initialization
		 */
		this.init = () => {
			this.breadcrumbs = [ { name: 'Contact Us', state: null } ];
			$scope.isAuthed = Admin.Authed();
		};
		this.init();

		$scope.goToState = function( stateName: string, tabIndex: number ) {
			$state.go( stateName, { activeTab: tabIndex } );
		};
	}
}() );

