( function() {
	'use strict';

	angular
		.module( 'vendorfuelApp' )
		.controller( 'PaymentProcessorController', PaymentProcessorController );

	PaymentProcessorController.$inject = [
		'$scope',
		'$parse',
	];

	/**
	 * @param {Object} $scope Angular service
	 * @param {Object} $parse Angular service
	 */
	function PaymentProcessorController(
		$scope: any,
		$parse: ng.IParseService,
	) {
		/**
		 * Initialization
		 */
		this.init = () => {
			$scope.attributeCount = 0;
			$scope.enabled = 0;
			$scope.processorIndex = null;

			$scope.$watch( '$viewContentLoaded', function() {
				if ( $scope.$parent.gateways[ $scope.processorIndex ] ) {
					const gateway = $scope.$parent.gateways[ $scope.processorIndex ];
					$scope.enabled = Number( gateway.enabled );
					let i = 1;
					angular.forEach( gateway, function( value, key ) {
						//$scope.attributeCount = i;
						// @ts-ignore
						if ( key !== 'enabled' ) {
							let index = 'atrributeIndex';
							let valueIndex = 'attribute';
							// @ts-ignore
							index = index.concat( i );
							// @ts-ignore
							valueIndex = valueIndex.concat( i );
							// @ts-ignore
							$parse( index ).assign( $scope, key );
							$parse( valueIndex ).assign( $scope, value );
							i++;
						}
					} );
				} else {
					for ( let j = 1; j <= $scope.attributeCount; ) {
						let valueIndex = 'attribute';
						// @ts-ignore
						valueIndex = valueIndex.concat( j );
						$parse( valueIndex ).assign( $scope, '' );
						j++;
					}
				}
			} );
		};
		this.init();

		$scope.updateGateway = function() {
			const gateway: any = {};
			gateway[ $scope.processorIndex ] = {};
			gateway[ $scope.processorIndex ].enabled = $scope.enabled;

			for ( let i = 1; i <= $scope.attributeCount; ) {
				let index = 'attributeIndex';
				let valueIndex = 'attribute';
				index = index.concat( i.toString() );
				valueIndex = valueIndex.concat( i.toString() );
				if ( $scope[ index ] !== 'enabled' ) {
					gateway[ $scope.processorIndex ][ $scope[ index ] ] = $scope[ valueIndex ];
					i++;
				}
			}

			$scope.$parent.gateways[ $scope.processorIndex ] = gateway[ $scope.processorIndex ];
			$scope.$parent.updateGateway( gateway );
		};

		$scope.disableGateway = function() {
			const gateway: any = {};
			gateway[ $scope.processorIndex ] = {};
			gateway[ $scope.processorIndex ].enabled = false;

			$scope.$parent.gateways[ $scope.processorIndex ] = gateway[ $scope.processorIndex ];
			$scope.$parent.disableGateway( gateway ).then();
		};

		$scope.setPrimaryCCProcessor = function() {
			const gateway: any = {};
			gateway[ $scope.processorIndex ] = {};
			if ( $scope.keyIndex !== '' ) {
				gateway[ $scope.processorIndex ][ $scope.keyIndex ] = $scope.key;
			}
			if ( $scope.secretIndex !== '' ) {
				gateway[ $scope.processorIndex ][ $scope.secretIndex ] = $scope.secret;
			}
			gateway[ $scope.processorIndex ].enabled = $scope.enabled;

			$scope.$parent.gateways[ $scope.processorIndex ] = gateway[ $scope.processorIndex ];

			$scope.$parent.setPrimaryCCProcessor( gateway );
		};

		$scope.authorizeAccess = function() {
			$scope.$parent.authorizeAccess( $scope.processorIndex );
		};
		$scope.revokeAccess = function() {
			$scope.$parent.revokeAccess( $scope.processorIndex );
		};
	}
}() );

