(function () {
	'use strict';

	angular
		.module('vendorfuelApp')
		.directive('compileHtml', compileHtmlDirective);

	compileHtmlDirective.$inject = [
		'$compile',
	];

	/**
	 * @param {Object} $compile Angular service
	 * @return {Object} Directive
	 */
	function compileHtmlDirective(
		$compile: ng.ICompileService,
	) {
		return {
			restrict: 'A',
			link(scope: ng.IScope, elem: any, attrs: ng.IAttributes) {
				scope.$watch(function () {
					return scope.$eval(attrs.compileHtml);
				}, function (value) {
					elem.html(value);
					$compile(elem.contents())(scope);
				});
			},
		};
	}
}());
