(function () {
	'use strict';

	angular
		.module('vendorfuelApp')
		.directive('copyToClipboard', copyToClipboardDirective);

	/**
	 * @return {Object} Directive
	 */
	function copyToClipboardDirective() {
		return {
			restrict: 'A',
			link(scope: ng.IScope, elem: ng.IAugmentedJQuery, attrs: ng.IAttributes) {
				elem.on('click', function () {
					if (attrs.copyToClipboard) {
						const $tempInput = jQuery('<input>');
						jQuery('clipboard').append($tempInput);
						$tempInput.val(attrs.copyToClipboard).select();
						document.execCommand('copy');
					}
				});
			},
		};
	}
}());

