(function () {
	'use strict';

	angular
		.module('vendorfuelApp')
		.directive('fileModel', fileModelDirective);

	fileModelDirective.$inject = [
		'$parse',
	];

	/**
	 * @param {Object} $parse Angular service
	 * @return {Object} Directive
	 */
	function fileModelDirective(
		$parse: ng.IParseService,
	) {
		return {
			restrict: 'A',
			link(scope: ng.IScope, element: any, attrs: ng.IAttributes) {
				const model = $parse(attrs.fileModel);
				const modelSetter = model.assign;

				element.on('change', function () {
					scope.$apply(function () {
						modelSetter(scope.$parent.$parent, element[0].files);
					});
				});
			},
		};
	}
}());
