(function () {
	'use strict';

	angular
		.module('vendorfuelApp')
		.directive('format', formatDirective);

	formatDirective.$inject = [
		'$filter',
	];

	/**
	 * @param {Object} $filter Angular service
	 * @return {Object} Directive
	 */
	function formatDirective(
		$filter: any,
	) {
		return {
			require: '?ngModel',
			link(scope: any, elem: any, attrs: any, ctrl: any) {
				if (!ctrl) {
					return;
				}
				ctrl.$formatters.unshift(function () {
					return $filter(attrs.format)(ctrl.$modelValue);
				});
				elem.on('focus', function () {
					elem.val(ctrl.$modelValue);
				});
				elem.on('blur', function () {
					const plainNumber = elem.val().replace(/[^\d|\-+|.+]/g, '');
					elem.val($filter(attrs.format)(plainNumber));
				});
				angular.element(elem).on('keypress', function (e) {
					const newVal = jQuery(this).val() + (e.charCode !== 0 ? String.fromCharCode(e.charCode) : '');
					// @ts-ignore
					if (jQuery(this).val().search(/(.*)\.[0-9][0-9]/) === 0 && newVal.length > jQuery(this).val().length) {
						if (e.charCode !== 8) {
							e.preventDefault();
						}
					}
				});
			},
		};
	}
}());

