/**
 * Debug Factory
 *
 * @namespace Factories
 */
(function () {
	'use strict';

	angular
		.module('vendorfuelApp')
		.factory('Debug', debugFactory);

	debugFactory.$inject = [
		'Localized',
	];

	/**
	 * @param {Object} Localized VendorFuel service
	 * @return {Object} service
	 */
	function debugFactory(
		Localized: any,
	) {
		const service = {
			error,
			log,
		};

		return service;

		/**
		 * @param {...any} params Parameters
		 */
		function log(...params: any[]) {
			if (Localized.debugMode) {
				console.debug(...params);
			}
		}

		/**
		 * @param {...any} params Parameters
		 */
		function error(...params: any[]) {
			if (Localized.debugMode) {
				console.error(...params);
			}
		}
	}
}());
