(function () {
	'use strict';

	angular
		.module('vendorfuelApp')
		.factory('uom', uomFactory);

	/**
	 * @return {Object} Service
	 */
	function uomFactory() {
		const uomCodes = [
			{ name: 'Bag', val: 'BG' },
			{ name: 'Barrel', val: 'BA' },
			{ name: 'Bolt', val: 'BT' },
			{ name: 'Box', val: 'BX' },
			{ name: 'Bunch', val: 'BH' },
			{ name: 'Bundle', val: 'BND' },
			{ name: 'Butt', val: 'BU' },
			{ name: 'Card', val: 'CRD' },
			{ name: 'Case', val: 'CS' },
			{ name: 'Centimeter', val: 'CM' },
			{ name: 'Container', val: 'CON' },
			{ name: 'Crate', val: 'CR' },
			{ name: 'Dozen', val: 'DZ' },
			{ name: 'Each', val: 'EA' },
			{ name: 'Envelope', val: 'EN' },
			{ name: 'Foot', val: 'FT' },
			{ name: 'Kilogram', val: 'KG' },
			{ name: 'Kilograms', val: 'KGS' },
			{ name: 'Liter', val: 'L' },
			{ name: 'Meter', val: 'M' },
			{ name: 'Package', val: 'PK' },
			{ name: 'Packet', val: 'PA' },
			{ name: 'Pallet', val: 'PAL' },
			{ name: 'Piece', val: 'PC' },
			{ name: 'Pieces', val: 'PCS' },
			{ name: 'Pound', val: 'LB' },
			{ name: 'Roll', val: 'ROL' },
			{ name: 'Set', val: 'SET' },
			{ name: 'Square Meter', val: 'SME' },
			{ name: 'Square Ft', val: 'SQFT' },
			{ name: 'Tube', val: 'TUBE' },
			{ name: 'Yard', val: 'YD' },
		];

		const service = {
			uomData: function () {
				const data = {
					uomCodes: uomCodes,
				};
				return data;
			}
		};
		return service;
	}
}());

