(function () {
	'use strict';

	angular
		.module('vendorfuelApp')
		.factory('WarningModal', warningModal);

	warningModal.$inject = [
		'$uibModal',
		'Localized',
		'$sce',
	];

	/**
	 * @param {Object} $uibModal UI Bootstrap service
	 * @param {Object} Localized VendorFuel service
	 * @param {Object} $sce Angular service
	 * @return {Object} Service
	 */
	function warningModal(
		$uibModal: ng.ui.bootstrap.IModalService,
		Localized: any,
		$sce: ng.ISCEService,
	) {
		const service = {
			Show: function (
				callback: any,
				title: any,
				message: any,
				optionConfirm: any,
				backdrop: boolean,
				highlightedButton: number,
			) {
				message = message || '';
				optionConfirm = optionConfirm || 'Confirm';
				backdrop = backdrop || true;
				highlightedButton = highlightedButton || 0;
				const tempConfirmWidth = optionConfirm.length;

				const optionWidth = (tempConfirmWidth * 9) + 24;

				const callbackParams = callback.params || {};
				$uibModal
					.open({
						templateUrl: Localized.root.url + '/assets/app/modals/warning.html',
						backdrop,
						controller($scope: any, $uibModalInstance: ng.ui.bootstrap.IModalInstanceService) {
							$scope.modalTitle = $sce.trustAsHtml(title);
							$scope.modalMessage = $sce.trustAsHtml(message);
							$scope.optionConfirm = optionConfirm;
							$scope.optionWidth = optionWidth;
							$scope.highlightedButton = highlightedButton;
							$scope.Confirm = function () {
								$uibModalInstance.close();
							};
						},
					})
					.result.then(function () {
						if (callback.confirm) {
							callback.confirm(callbackParams);
						}
					});
			}
		};
		return service;
	}
}());

