(function () {
	'use strict';

	angular
		.module('vendorfuelApp')
		.run(runner);

	runner.$inject = [
		'$location',
		'$rootScope',
		'$transitions',
		'Admin',
	];

	/**
	 * @param {Object} $location Angular service
	 * @param {Object} $rootScope Angular service
	 * @param {Object} Admin VendorFuel service
	 */
	function runner(
		$location: any,
		$rootScope: any,
		$transitions: any,
		Admin: any,
	) {
		$rootScope.rootUrl = localized.dir.url;
		$rootScope.wpApiUrl = localized.dir.wpRestApi + 'vendorfuel';
		$rootScope.generalSettings = localized.settings.general;
		$rootScope.vfApiUrl = localized.apiURL;
		$rootScope.api_key = $rootScope.generalSettings.api_key;
		$rootScope.collapsed = false;

		if (!$rootScope.api_key) {
			if (Admin.authed) {
				Admin.Logout();
			}
			$location.path('/subscribe');
		}

		// Scroll to top of page on router transitions.
		$transitions.onSuccess({}, () => {
			document.body.scrollTop = document.documentElement.scrollTop = 0;
		});
	}
}());
