import template from './catalog-sort-by.component.html';
declare const angular: ng.IAngularStatic;
/**
 * @namespace catalogSortBy
 * @memberof Components
 */

( function() {
	'use strict';

	angular
		.module( 'vfApp' )
		.component( 'catalogSortBy', {
			template,
			controller: SortByController,
		} );

	SortByController.$inject = [
		'$location',
		'catalogService',
	];

	/**
	 * @param {Object} $location      Angular service
	 * @param {Object} catalogService Catalog service
	 */
	function SortByController(
		$location,
		catalogService,
	) {
		this.sortByOptions = [
			{
				name: 'Most Relevant',
				value: 'relevance',
				icon: 'bi bi-sort-down',
			}, {
				name: 'Price Low-High',
				value: 'pricea',
				icon: 'bi bi-sort-numeric-down',
			}, {
				name: 'Price High-Low',
				value: 'priced',
				icon: 'bi bi-sort-numeric-down-alt',
			}, {
				name: 'Title Ascending',
				value: 'descriptiona',
				icon: 'bi bi-sort-alpha-down',
			}, {
				name: 'Title Descending',
				value: 'descriptiond',
				icon: 'bi bi-sort-alpha-down-alt',
			},
		];

		this.$onInit = () => {
			this.sortBy = $location.search().sortby ? this.sortByOptions.find( ( element ) => element.value === $location.search().sortby ) : this.sortByOptions[ 0 ];
		};

		/**
		 * @param {Object} sortBy Sort by
		 */
		this.change = ( sortBy ) => {
			this.sortBy = sortBy;
			$location.search( 'pg', null );
			catalogService.changeSortBy( sortBy );
			$location.search( 'sortby', sortBy.value );
		};
	}
}() );
