/**
 * @namespace savedCartItem
 * @memberof Components
 */
( function() {
	'use strict';

	angular
		.module( 'vfApp' )
		.component( 'savedCartItem', {
			templateUrl: 'savedCartItem.html',
			bindings: {
				item: '<',
				onDelete: '&',
			},
			controller: SavedCartItemController,
		} );

	function SavedCartItemController() {
		const vm = this;
		vm.$onInit = $onInit;

		/**
		 * Initialization
		 */
		function $onInit() {
			vm.productSlug = localized.settings.general.product_slug || 'products';
		}

		/**
		 * @function delete
		 */
		vm.delete = () => {
			vm.onDelete( {
				item: vm.item,
			} );
		};
	}
}() );
