/******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ 9669:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

module.exports = __webpack_require__(1609);

/***/ }),

/***/ 5448:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);
var settle = __webpack_require__(6026);
var cookies = __webpack_require__(4372);
var buildURL = __webpack_require__(5327);
var buildFullPath = __webpack_require__(4097);
var parseHeaders = __webpack_require__(4109);
var isURLSameOrigin = __webpack_require__(7985);
var transitionalDefaults = __webpack_require__(7874);
var AxiosError = __webpack_require__(2648);
var CanceledError = __webpack_require__(644);
var parseProtocol = __webpack_require__(205);

module.exports = function xhrAdapter(config) {
  return new Promise(function dispatchXhrRequest(resolve, reject) {
    var requestData = config.data;
    var requestHeaders = config.headers;
    var responseType = config.responseType;
    var onCanceled;
    function done() {
      if (config.cancelToken) {
        config.cancelToken.unsubscribe(onCanceled);
      }

      if (config.signal) {
        config.signal.removeEventListener('abort', onCanceled);
      }
    }

    if (utils.isFormData(requestData) && utils.isStandardBrowserEnv()) {
      delete requestHeaders['Content-Type']; // Let the browser set it
    }

    var request = new XMLHttpRequest();

    // HTTP basic authentication
    if (config.auth) {
      var username = config.auth.username || '';
      var password = config.auth.password ? unescape(encodeURIComponent(config.auth.password)) : '';
      requestHeaders.Authorization = 'Basic ' + btoa(username + ':' + password);
    }

    var fullPath = buildFullPath(config.baseURL, config.url);

    request.open(config.method.toUpperCase(), buildURL(fullPath, config.params, config.paramsSerializer), true);

    // Set the request timeout in MS
    request.timeout = config.timeout;

    function onloadend() {
      if (!request) {
        return;
      }
      // Prepare the response
      var responseHeaders = 'getAllResponseHeaders' in request ? parseHeaders(request.getAllResponseHeaders()) : null;
      var responseData = !responseType || responseType === 'text' ||  responseType === 'json' ?
        request.responseText : request.response;
      var response = {
        data: responseData,
        status: request.status,
        statusText: request.statusText,
        headers: responseHeaders,
        config: config,
        request: request
      };

      settle(function _resolve(value) {
        resolve(value);
        done();
      }, function _reject(err) {
        reject(err);
        done();
      }, response);

      // Clean up request
      request = null;
    }

    if ('onloadend' in request) {
      // Use onloadend if available
      request.onloadend = onloadend;
    } else {
      // Listen for ready state to emulate onloadend
      request.onreadystatechange = function handleLoad() {
        if (!request || request.readyState !== 4) {
          return;
        }

        // The request errored out and we didn't get a response, this will be
        // handled by onerror instead
        // With one exception: request that using file: protocol, most browsers
        // will return status as 0 even though it's a successful request
        if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf('file:') === 0)) {
          return;
        }
        // readystate handler is calling before onerror or ontimeout handlers,
        // so we should call onloadend on the next 'tick'
        setTimeout(onloadend);
      };
    }

    // Handle browser request cancellation (as opposed to a manual cancellation)
    request.onabort = function handleAbort() {
      if (!request) {
        return;
      }

      reject(new AxiosError('Request aborted', AxiosError.ECONNABORTED, config, request));

      // Clean up request
      request = null;
    };

    // Handle low level network errors
    request.onerror = function handleError() {
      // Real errors are hidden from us by the browser
      // onerror should only fire if it's a network error
      reject(new AxiosError('Network Error', AxiosError.ERR_NETWORK, config, request, request));

      // Clean up request
      request = null;
    };

    // Handle timeout
    request.ontimeout = function handleTimeout() {
      var timeoutErrorMessage = config.timeout ? 'timeout of ' + config.timeout + 'ms exceeded' : 'timeout exceeded';
      var transitional = config.transitional || transitionalDefaults;
      if (config.timeoutErrorMessage) {
        timeoutErrorMessage = config.timeoutErrorMessage;
      }
      reject(new AxiosError(
        timeoutErrorMessage,
        transitional.clarifyTimeoutError ? AxiosError.ETIMEDOUT : AxiosError.ECONNABORTED,
        config,
        request));

      // Clean up request
      request = null;
    };

    // Add xsrf header
    // This is only done if running in a standard browser environment.
    // Specifically not if we're in a web worker, or react-native.
    if (utils.isStandardBrowserEnv()) {
      // Add xsrf header
      var xsrfValue = (config.withCredentials || isURLSameOrigin(fullPath)) && config.xsrfCookieName ?
        cookies.read(config.xsrfCookieName) :
        undefined;

      if (xsrfValue) {
        requestHeaders[config.xsrfHeaderName] = xsrfValue;
      }
    }

    // Add headers to the request
    if ('setRequestHeader' in request) {
      utils.forEach(requestHeaders, function setRequestHeader(val, key) {
        if (typeof requestData === 'undefined' && key.toLowerCase() === 'content-type') {
          // Remove Content-Type if data is undefined
          delete requestHeaders[key];
        } else {
          // Otherwise add header to the request
          request.setRequestHeader(key, val);
        }
      });
    }

    // Add withCredentials to request if needed
    if (!utils.isUndefined(config.withCredentials)) {
      request.withCredentials = !!config.withCredentials;
    }

    // Add responseType to request if needed
    if (responseType && responseType !== 'json') {
      request.responseType = config.responseType;
    }

    // Handle progress if needed
    if (typeof config.onDownloadProgress === 'function') {
      request.addEventListener('progress', config.onDownloadProgress);
    }

    // Not all browsers support upload events
    if (typeof config.onUploadProgress === 'function' && request.upload) {
      request.upload.addEventListener('progress', config.onUploadProgress);
    }

    if (config.cancelToken || config.signal) {
      // Handle cancellation
      // eslint-disable-next-line func-names
      onCanceled = function(cancel) {
        if (!request) {
          return;
        }
        reject(!cancel || (cancel && cancel.type) ? new CanceledError() : cancel);
        request.abort();
        request = null;
      };

      config.cancelToken && config.cancelToken.subscribe(onCanceled);
      if (config.signal) {
        config.signal.aborted ? onCanceled() : config.signal.addEventListener('abort', onCanceled);
      }
    }

    if (!requestData) {
      requestData = null;
    }

    var protocol = parseProtocol(fullPath);

    if (protocol && [ 'http', 'https', 'file' ].indexOf(protocol) === -1) {
      reject(new AxiosError('Unsupported protocol ' + protocol + ':', AxiosError.ERR_BAD_REQUEST, config));
      return;
    }


    // Send the request
    request.send(requestData);
  });
};


/***/ }),

/***/ 1609:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);
var bind = __webpack_require__(1849);
var Axios = __webpack_require__(321);
var mergeConfig = __webpack_require__(7185);
var defaults = __webpack_require__(5546);

/**
 * Create an instance of Axios
 *
 * @param {Object} defaultConfig The default config for the instance
 * @return {Axios} A new instance of Axios
 */
function createInstance(defaultConfig) {
  var context = new Axios(defaultConfig);
  var instance = bind(Axios.prototype.request, context);

  // Copy axios.prototype to instance
  utils.extend(instance, Axios.prototype, context);

  // Copy context to instance
  utils.extend(instance, context);

  // Factory for creating new instances
  instance.create = function create(instanceConfig) {
    return createInstance(mergeConfig(defaultConfig, instanceConfig));
  };

  return instance;
}

// Create the default instance to be exported
var axios = createInstance(defaults);

// Expose Axios class to allow class inheritance
axios.Axios = Axios;

// Expose Cancel & CancelToken
axios.CanceledError = __webpack_require__(644);
axios.CancelToken = __webpack_require__(4972);
axios.isCancel = __webpack_require__(6502);
axios.VERSION = (__webpack_require__(7288).version);
axios.toFormData = __webpack_require__(7675);

// Expose AxiosError class
axios.AxiosError = __webpack_require__(2648);

// alias for CanceledError for backward compatibility
axios.Cancel = axios.CanceledError;

// Expose all/spread
axios.all = function all(promises) {
  return Promise.all(promises);
};
axios.spread = __webpack_require__(8713);

// Expose isAxiosError
axios.isAxiosError = __webpack_require__(6268);

module.exports = axios;

// Allow use of default import syntax in TypeScript
module.exports["default"] = axios;


/***/ }),

/***/ 4972:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var CanceledError = __webpack_require__(644);

/**
 * A `CancelToken` is an object that can be used to request cancellation of an operation.
 *
 * @class
 * @param {Function} executor The executor function.
 */
function CancelToken(executor) {
  if (typeof executor !== 'function') {
    throw new TypeError('executor must be a function.');
  }

  var resolvePromise;

  this.promise = new Promise(function promiseExecutor(resolve) {
    resolvePromise = resolve;
  });

  var token = this;

  // eslint-disable-next-line func-names
  this.promise.then(function(cancel) {
    if (!token._listeners) return;

    var i;
    var l = token._listeners.length;

    for (i = 0; i < l; i++) {
      token._listeners[i](cancel);
    }
    token._listeners = null;
  });

  // eslint-disable-next-line func-names
  this.promise.then = function(onfulfilled) {
    var _resolve;
    // eslint-disable-next-line func-names
    var promise = new Promise(function(resolve) {
      token.subscribe(resolve);
      _resolve = resolve;
    }).then(onfulfilled);

    promise.cancel = function reject() {
      token.unsubscribe(_resolve);
    };

    return promise;
  };

  executor(function cancel(message) {
    if (token.reason) {
      // Cancellation has already been requested
      return;
    }

    token.reason = new CanceledError(message);
    resolvePromise(token.reason);
  });
}

/**
 * Throws a `CanceledError` if cancellation has been requested.
 */
CancelToken.prototype.throwIfRequested = function throwIfRequested() {
  if (this.reason) {
    throw this.reason;
  }
};

/**
 * Subscribe to the cancel signal
 */

CancelToken.prototype.subscribe = function subscribe(listener) {
  if (this.reason) {
    listener(this.reason);
    return;
  }

  if (this._listeners) {
    this._listeners.push(listener);
  } else {
    this._listeners = [listener];
  }
};

/**
 * Unsubscribe from the cancel signal
 */

CancelToken.prototype.unsubscribe = function unsubscribe(listener) {
  if (!this._listeners) {
    return;
  }
  var index = this._listeners.indexOf(listener);
  if (index !== -1) {
    this._listeners.splice(index, 1);
  }
};

/**
 * Returns an object that contains a new `CancelToken` and a function that, when called,
 * cancels the `CancelToken`.
 */
CancelToken.source = function source() {
  var cancel;
  var token = new CancelToken(function executor(c) {
    cancel = c;
  });
  return {
    token: token,
    cancel: cancel
  };
};

module.exports = CancelToken;


/***/ }),

/***/ 644:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var AxiosError = __webpack_require__(2648);
var utils = __webpack_require__(4867);

/**
 * A `CanceledError` is an object that is thrown when an operation is canceled.
 *
 * @class
 * @param {string=} message The message.
 */
function CanceledError(message) {
  // eslint-disable-next-line no-eq-null,eqeqeq
  AxiosError.call(this, message == null ? 'canceled' : message, AxiosError.ERR_CANCELED);
  this.name = 'CanceledError';
}

utils.inherits(CanceledError, AxiosError, {
  __CANCEL__: true
});

module.exports = CanceledError;


/***/ }),

/***/ 6502:
/***/ ((module) => {

"use strict";


module.exports = function isCancel(value) {
  return !!(value && value.__CANCEL__);
};


/***/ }),

/***/ 321:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);
var buildURL = __webpack_require__(5327);
var InterceptorManager = __webpack_require__(782);
var dispatchRequest = __webpack_require__(3572);
var mergeConfig = __webpack_require__(7185);
var buildFullPath = __webpack_require__(4097);
var validator = __webpack_require__(4875);

var validators = validator.validators;
/**
 * Create a new instance of Axios
 *
 * @param {Object} instanceConfig The default config for the instance
 */
function Axios(instanceConfig) {
  this.defaults = instanceConfig;
  this.interceptors = {
    request: new InterceptorManager(),
    response: new InterceptorManager()
  };
}

/**
 * Dispatch a request
 *
 * @param {Object} config The config specific for this request (merged with this.defaults)
 */
Axios.prototype.request = function request(configOrUrl, config) {
  /*eslint no-param-reassign:0*/
  // Allow for axios('example/url'[, config]) a la fetch API
  if (typeof configOrUrl === 'string') {
    config = config || {};
    config.url = configOrUrl;
  } else {
    config = configOrUrl || {};
  }

  config = mergeConfig(this.defaults, config);

  // Set config.method
  if (config.method) {
    config.method = config.method.toLowerCase();
  } else if (this.defaults.method) {
    config.method = this.defaults.method.toLowerCase();
  } else {
    config.method = 'get';
  }

  var transitional = config.transitional;

  if (transitional !== undefined) {
    validator.assertOptions(transitional, {
      silentJSONParsing: validators.transitional(validators.boolean),
      forcedJSONParsing: validators.transitional(validators.boolean),
      clarifyTimeoutError: validators.transitional(validators.boolean)
    }, false);
  }

  // filter out skipped interceptors
  var requestInterceptorChain = [];
  var synchronousRequestInterceptors = true;
  this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
    if (typeof interceptor.runWhen === 'function' && interceptor.runWhen(config) === false) {
      return;
    }

    synchronousRequestInterceptors = synchronousRequestInterceptors && interceptor.synchronous;

    requestInterceptorChain.unshift(interceptor.fulfilled, interceptor.rejected);
  });

  var responseInterceptorChain = [];
  this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
    responseInterceptorChain.push(interceptor.fulfilled, interceptor.rejected);
  });

  var promise;

  if (!synchronousRequestInterceptors) {
    var chain = [dispatchRequest, undefined];

    Array.prototype.unshift.apply(chain, requestInterceptorChain);
    chain = chain.concat(responseInterceptorChain);

    promise = Promise.resolve(config);
    while (chain.length) {
      promise = promise.then(chain.shift(), chain.shift());
    }

    return promise;
  }


  var newConfig = config;
  while (requestInterceptorChain.length) {
    var onFulfilled = requestInterceptorChain.shift();
    var onRejected = requestInterceptorChain.shift();
    try {
      newConfig = onFulfilled(newConfig);
    } catch (error) {
      onRejected(error);
      break;
    }
  }

  try {
    promise = dispatchRequest(newConfig);
  } catch (error) {
    return Promise.reject(error);
  }

  while (responseInterceptorChain.length) {
    promise = promise.then(responseInterceptorChain.shift(), responseInterceptorChain.shift());
  }

  return promise;
};

Axios.prototype.getUri = function getUri(config) {
  config = mergeConfig(this.defaults, config);
  var fullPath = buildFullPath(config.baseURL, config.url);
  return buildURL(fullPath, config.params, config.paramsSerializer);
};

// Provide aliases for supported request methods
utils.forEach(['delete', 'get', 'head', 'options'], function forEachMethodNoData(method) {
  /*eslint func-names:0*/
  Axios.prototype[method] = function(url, config) {
    return this.request(mergeConfig(config || {}, {
      method: method,
      url: url,
      data: (config || {}).data
    }));
  };
});

utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  /*eslint func-names:0*/

  function generateHTTPMethod(isForm) {
    return function httpMethod(url, data, config) {
      return this.request(mergeConfig(config || {}, {
        method: method,
        headers: isForm ? {
          'Content-Type': 'multipart/form-data'
        } : {},
        url: url,
        data: data
      }));
    };
  }

  Axios.prototype[method] = generateHTTPMethod();

  Axios.prototype[method + 'Form'] = generateHTTPMethod(true);
});

module.exports = Axios;


/***/ }),

/***/ 2648:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

/**
 * Create an Error with the specified message, config, error code, request and response.
 *
 * @param {string} message The error message.
 * @param {string} [code] The error code (for example, 'ECONNABORTED').
 * @param {Object} [config] The config.
 * @param {Object} [request] The request.
 * @param {Object} [response] The response.
 * @returns {Error} The created error.
 */
function AxiosError(message, code, config, request, response) {
  Error.call(this);
  this.message = message;
  this.name = 'AxiosError';
  code && (this.code = code);
  config && (this.config = config);
  request && (this.request = request);
  response && (this.response = response);
}

utils.inherits(AxiosError, Error, {
  toJSON: function toJSON() {
    return {
      // Standard
      message: this.message,
      name: this.name,
      // Microsoft
      description: this.description,
      number: this.number,
      // Mozilla
      fileName: this.fileName,
      lineNumber: this.lineNumber,
      columnNumber: this.columnNumber,
      stack: this.stack,
      // Axios
      config: this.config,
      code: this.code,
      status: this.response && this.response.status ? this.response.status : null
    };
  }
});

var prototype = AxiosError.prototype;
var descriptors = {};

[
  'ERR_BAD_OPTION_VALUE',
  'ERR_BAD_OPTION',
  'ECONNABORTED',
  'ETIMEDOUT',
  'ERR_NETWORK',
  'ERR_FR_TOO_MANY_REDIRECTS',
  'ERR_DEPRECATED',
  'ERR_BAD_RESPONSE',
  'ERR_BAD_REQUEST',
  'ERR_CANCELED'
// eslint-disable-next-line func-names
].forEach(function(code) {
  descriptors[code] = {value: code};
});

Object.defineProperties(AxiosError, descriptors);
Object.defineProperty(prototype, 'isAxiosError', {value: true});

// eslint-disable-next-line func-names
AxiosError.from = function(error, code, config, request, response, customProps) {
  var axiosError = Object.create(prototype);

  utils.toFlatObject(error, axiosError, function filter(obj) {
    return obj !== Error.prototype;
  });

  AxiosError.call(axiosError, error.message, code, config, request, response);

  axiosError.name = error.name;

  customProps && Object.assign(axiosError, customProps);

  return axiosError;
};

module.exports = AxiosError;


/***/ }),

/***/ 782:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

function InterceptorManager() {
  this.handlers = [];
}

/**
 * Add a new interceptor to the stack
 *
 * @param {Function} fulfilled The function to handle `then` for a `Promise`
 * @param {Function} rejected The function to handle `reject` for a `Promise`
 *
 * @return {Number} An ID used to remove interceptor later
 */
InterceptorManager.prototype.use = function use(fulfilled, rejected, options) {
  this.handlers.push({
    fulfilled: fulfilled,
    rejected: rejected,
    synchronous: options ? options.synchronous : false,
    runWhen: options ? options.runWhen : null
  });
  return this.handlers.length - 1;
};

/**
 * Remove an interceptor from the stack
 *
 * @param {Number} id The ID that was returned by `use`
 */
InterceptorManager.prototype.eject = function eject(id) {
  if (this.handlers[id]) {
    this.handlers[id] = null;
  }
};

/**
 * Iterate over all the registered interceptors
 *
 * This method is particularly useful for skipping over any
 * interceptors that may have become `null` calling `eject`.
 *
 * @param {Function} fn The function to call for each interceptor
 */
InterceptorManager.prototype.forEach = function forEach(fn) {
  utils.forEach(this.handlers, function forEachHandler(h) {
    if (h !== null) {
      fn(h);
    }
  });
};

module.exports = InterceptorManager;


/***/ }),

/***/ 4097:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var isAbsoluteURL = __webpack_require__(1793);
var combineURLs = __webpack_require__(7303);

/**
 * Creates a new URL by combining the baseURL with the requestedURL,
 * only when the requestedURL is not already an absolute URL.
 * If the requestURL is absolute, this function returns the requestedURL untouched.
 *
 * @param {string} baseURL The base URL
 * @param {string} requestedURL Absolute or relative URL to combine
 * @returns {string} The combined full path
 */
module.exports = function buildFullPath(baseURL, requestedURL) {
  if (baseURL && !isAbsoluteURL(requestedURL)) {
    return combineURLs(baseURL, requestedURL);
  }
  return requestedURL;
};


/***/ }),

/***/ 3572:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);
var transformData = __webpack_require__(8527);
var isCancel = __webpack_require__(6502);
var defaults = __webpack_require__(5546);
var CanceledError = __webpack_require__(644);

/**
 * Throws a `CanceledError` if cancellation has been requested.
 */
function throwIfCancellationRequested(config) {
  if (config.cancelToken) {
    config.cancelToken.throwIfRequested();
  }

  if (config.signal && config.signal.aborted) {
    throw new CanceledError();
  }
}

/**
 * Dispatch a request to the server using the configured adapter.
 *
 * @param {object} config The config that is to be used for the request
 * @returns {Promise} The Promise to be fulfilled
 */
module.exports = function dispatchRequest(config) {
  throwIfCancellationRequested(config);

  // Ensure headers exist
  config.headers = config.headers || {};

  // Transform request data
  config.data = transformData.call(
    config,
    config.data,
    config.headers,
    config.transformRequest
  );

  // Flatten headers
  config.headers = utils.merge(
    config.headers.common || {},
    config.headers[config.method] || {},
    config.headers
  );

  utils.forEach(
    ['delete', 'get', 'head', 'post', 'put', 'patch', 'common'],
    function cleanHeaderConfig(method) {
      delete config.headers[method];
    }
  );

  var adapter = config.adapter || defaults.adapter;

  return adapter(config).then(function onAdapterResolution(response) {
    throwIfCancellationRequested(config);

    // Transform response data
    response.data = transformData.call(
      config,
      response.data,
      response.headers,
      config.transformResponse
    );

    return response;
  }, function onAdapterRejection(reason) {
    if (!isCancel(reason)) {
      throwIfCancellationRequested(config);

      // Transform response data
      if (reason && reason.response) {
        reason.response.data = transformData.call(
          config,
          reason.response.data,
          reason.response.headers,
          config.transformResponse
        );
      }
    }

    return Promise.reject(reason);
  });
};


/***/ }),

/***/ 7185:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

/**
 * Config-specific merge-function which creates a new config-object
 * by merging two configuration objects together.
 *
 * @param {Object} config1
 * @param {Object} config2
 * @returns {Object} New object resulting from merging config2 to config1
 */
module.exports = function mergeConfig(config1, config2) {
  // eslint-disable-next-line no-param-reassign
  config2 = config2 || {};
  var config = {};

  function getMergedValue(target, source) {
    if (utils.isPlainObject(target) && utils.isPlainObject(source)) {
      return utils.merge(target, source);
    } else if (utils.isPlainObject(source)) {
      return utils.merge({}, source);
    } else if (utils.isArray(source)) {
      return source.slice();
    }
    return source;
  }

  // eslint-disable-next-line consistent-return
  function mergeDeepProperties(prop) {
    if (!utils.isUndefined(config2[prop])) {
      return getMergedValue(config1[prop], config2[prop]);
    } else if (!utils.isUndefined(config1[prop])) {
      return getMergedValue(undefined, config1[prop]);
    }
  }

  // eslint-disable-next-line consistent-return
  function valueFromConfig2(prop) {
    if (!utils.isUndefined(config2[prop])) {
      return getMergedValue(undefined, config2[prop]);
    }
  }

  // eslint-disable-next-line consistent-return
  function defaultToConfig2(prop) {
    if (!utils.isUndefined(config2[prop])) {
      return getMergedValue(undefined, config2[prop]);
    } else if (!utils.isUndefined(config1[prop])) {
      return getMergedValue(undefined, config1[prop]);
    }
  }

  // eslint-disable-next-line consistent-return
  function mergeDirectKeys(prop) {
    if (prop in config2) {
      return getMergedValue(config1[prop], config2[prop]);
    } else if (prop in config1) {
      return getMergedValue(undefined, config1[prop]);
    }
  }

  var mergeMap = {
    'url': valueFromConfig2,
    'method': valueFromConfig2,
    'data': valueFromConfig2,
    'baseURL': defaultToConfig2,
    'transformRequest': defaultToConfig2,
    'transformResponse': defaultToConfig2,
    'paramsSerializer': defaultToConfig2,
    'timeout': defaultToConfig2,
    'timeoutMessage': defaultToConfig2,
    'withCredentials': defaultToConfig2,
    'adapter': defaultToConfig2,
    'responseType': defaultToConfig2,
    'xsrfCookieName': defaultToConfig2,
    'xsrfHeaderName': defaultToConfig2,
    'onUploadProgress': defaultToConfig2,
    'onDownloadProgress': defaultToConfig2,
    'decompress': defaultToConfig2,
    'maxContentLength': defaultToConfig2,
    'maxBodyLength': defaultToConfig2,
    'beforeRedirect': defaultToConfig2,
    'transport': defaultToConfig2,
    'httpAgent': defaultToConfig2,
    'httpsAgent': defaultToConfig2,
    'cancelToken': defaultToConfig2,
    'socketPath': defaultToConfig2,
    'responseEncoding': defaultToConfig2,
    'validateStatus': mergeDirectKeys
  };

  utils.forEach(Object.keys(config1).concat(Object.keys(config2)), function computeConfigValue(prop) {
    var merge = mergeMap[prop] || mergeDeepProperties;
    var configValue = merge(prop);
    (utils.isUndefined(configValue) && merge !== mergeDirectKeys) || (config[prop] = configValue);
  });

  return config;
};


/***/ }),

/***/ 6026:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var AxiosError = __webpack_require__(2648);

/**
 * Resolve or reject a Promise based on response status.
 *
 * @param {Function} resolve A function that resolves the promise.
 * @param {Function} reject A function that rejects the promise.
 * @param {object} response The response.
 */
module.exports = function settle(resolve, reject, response) {
  var validateStatus = response.config.validateStatus;
  if (!response.status || !validateStatus || validateStatus(response.status)) {
    resolve(response);
  } else {
    reject(new AxiosError(
      'Request failed with status code ' + response.status,
      [AxiosError.ERR_BAD_REQUEST, AxiosError.ERR_BAD_RESPONSE][Math.floor(response.status / 100) - 4],
      response.config,
      response.request,
      response
    ));
  }
};


/***/ }),

/***/ 8527:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);
var defaults = __webpack_require__(5546);

/**
 * Transform the data for a request or a response
 *
 * @param {Object|String} data The data to be transformed
 * @param {Array} headers The headers for the request or response
 * @param {Array|Function} fns A single function or Array of functions
 * @returns {*} The resulting transformed data
 */
module.exports = function transformData(data, headers, fns) {
  var context = this || defaults;
  /*eslint no-param-reassign:0*/
  utils.forEach(fns, function transform(fn) {
    data = fn.call(context, data, headers);
  });

  return data;
};


/***/ }),

/***/ 5546:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);
var normalizeHeaderName = __webpack_require__(6016);
var AxiosError = __webpack_require__(2648);
var transitionalDefaults = __webpack_require__(7874);
var toFormData = __webpack_require__(7675);

var DEFAULT_CONTENT_TYPE = {
  'Content-Type': 'application/x-www-form-urlencoded'
};

function setContentTypeIfUnset(headers, value) {
  if (!utils.isUndefined(headers) && utils.isUndefined(headers['Content-Type'])) {
    headers['Content-Type'] = value;
  }
}

function getDefaultAdapter() {
  var adapter;
  if (typeof XMLHttpRequest !== 'undefined') {
    // For browsers use XHR adapter
    adapter = __webpack_require__(5448);
  } else if (typeof process !== 'undefined' && Object.prototype.toString.call(process) === '[object process]') {
    // For node use HTTP adapter
    adapter = __webpack_require__(5448);
  }
  return adapter;
}

function stringifySafely(rawValue, parser, encoder) {
  if (utils.isString(rawValue)) {
    try {
      (parser || JSON.parse)(rawValue);
      return utils.trim(rawValue);
    } catch (e) {
      if (e.name !== 'SyntaxError') {
        throw e;
      }
    }
  }

  return (encoder || JSON.stringify)(rawValue);
}

var defaults = {

  transitional: transitionalDefaults,

  adapter: getDefaultAdapter(),

  transformRequest: [function transformRequest(data, headers) {
    normalizeHeaderName(headers, 'Accept');
    normalizeHeaderName(headers, 'Content-Type');

    if (utils.isFormData(data) ||
      utils.isArrayBuffer(data) ||
      utils.isBuffer(data) ||
      utils.isStream(data) ||
      utils.isFile(data) ||
      utils.isBlob(data)
    ) {
      return data;
    }
    if (utils.isArrayBufferView(data)) {
      return data.buffer;
    }
    if (utils.isURLSearchParams(data)) {
      setContentTypeIfUnset(headers, 'application/x-www-form-urlencoded;charset=utf-8');
      return data.toString();
    }

    var isObjectPayload = utils.isObject(data);
    var contentType = headers && headers['Content-Type'];

    var isFileList;

    if ((isFileList = utils.isFileList(data)) || (isObjectPayload && contentType === 'multipart/form-data')) {
      var _FormData = this.env && this.env.FormData;
      return toFormData(isFileList ? {'files[]': data} : data, _FormData && new _FormData());
    } else if (isObjectPayload || contentType === 'application/json') {
      setContentTypeIfUnset(headers, 'application/json');
      return stringifySafely(data);
    }

    return data;
  }],

  transformResponse: [function transformResponse(data) {
    var transitional = this.transitional || defaults.transitional;
    var silentJSONParsing = transitional && transitional.silentJSONParsing;
    var forcedJSONParsing = transitional && transitional.forcedJSONParsing;
    var strictJSONParsing = !silentJSONParsing && this.responseType === 'json';

    if (strictJSONParsing || (forcedJSONParsing && utils.isString(data) && data.length)) {
      try {
        return JSON.parse(data);
      } catch (e) {
        if (strictJSONParsing) {
          if (e.name === 'SyntaxError') {
            throw AxiosError.from(e, AxiosError.ERR_BAD_RESPONSE, this, null, this.response);
          }
          throw e;
        }
      }
    }

    return data;
  }],

  /**
   * A timeout in milliseconds to abort a request. If set to 0 (default) a
   * timeout is not created.
   */
  timeout: 0,

  xsrfCookieName: 'XSRF-TOKEN',
  xsrfHeaderName: 'X-XSRF-TOKEN',

  maxContentLength: -1,
  maxBodyLength: -1,

  env: {
    FormData: __webpack_require__(1623)
  },

  validateStatus: function validateStatus(status) {
    return status >= 200 && status < 300;
  },

  headers: {
    common: {
      'Accept': 'application/json, text/plain, */*'
    }
  }
};

utils.forEach(['delete', 'get', 'head'], function forEachMethodNoData(method) {
  defaults.headers[method] = {};
});

utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  defaults.headers[method] = utils.merge(DEFAULT_CONTENT_TYPE);
});

module.exports = defaults;


/***/ }),

/***/ 7874:
/***/ ((module) => {

"use strict";


module.exports = {
  silentJSONParsing: true,
  forcedJSONParsing: true,
  clarifyTimeoutError: false
};


/***/ }),

/***/ 7288:
/***/ ((module) => {

module.exports = {
  "version": "0.27.2"
};

/***/ }),

/***/ 1849:
/***/ ((module) => {

"use strict";


module.exports = function bind(fn, thisArg) {
  return function wrap() {
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }
    return fn.apply(thisArg, args);
  };
};


/***/ }),

/***/ 5327:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

function encode(val) {
  return encodeURIComponent(val).
    replace(/%3A/gi, ':').
    replace(/%24/g, '$').
    replace(/%2C/gi, ',').
    replace(/%20/g, '+').
    replace(/%5B/gi, '[').
    replace(/%5D/gi, ']');
}

/**
 * Build a URL by appending params to the end
 *
 * @param {string} url The base of the url (e.g., http://www.google.com)
 * @param {object} [params] The params to be appended
 * @returns {string} The formatted url
 */
module.exports = function buildURL(url, params, paramsSerializer) {
  /*eslint no-param-reassign:0*/
  if (!params) {
    return url;
  }

  var serializedParams;
  if (paramsSerializer) {
    serializedParams = paramsSerializer(params);
  } else if (utils.isURLSearchParams(params)) {
    serializedParams = params.toString();
  } else {
    var parts = [];

    utils.forEach(params, function serialize(val, key) {
      if (val === null || typeof val === 'undefined') {
        return;
      }

      if (utils.isArray(val)) {
        key = key + '[]';
      } else {
        val = [val];
      }

      utils.forEach(val, function parseValue(v) {
        if (utils.isDate(v)) {
          v = v.toISOString();
        } else if (utils.isObject(v)) {
          v = JSON.stringify(v);
        }
        parts.push(encode(key) + '=' + encode(v));
      });
    });

    serializedParams = parts.join('&');
  }

  if (serializedParams) {
    var hashmarkIndex = url.indexOf('#');
    if (hashmarkIndex !== -1) {
      url = url.slice(0, hashmarkIndex);
    }

    url += (url.indexOf('?') === -1 ? '?' : '&') + serializedParams;
  }

  return url;
};


/***/ }),

/***/ 7303:
/***/ ((module) => {

"use strict";


/**
 * Creates a new URL by combining the specified URLs
 *
 * @param {string} baseURL The base URL
 * @param {string} relativeURL The relative URL
 * @returns {string} The combined URL
 */
module.exports = function combineURLs(baseURL, relativeURL) {
  return relativeURL
    ? baseURL.replace(/\/+$/, '') + '/' + relativeURL.replace(/^\/+/, '')
    : baseURL;
};


/***/ }),

/***/ 4372:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

module.exports = (
  utils.isStandardBrowserEnv() ?

  // Standard browser envs support document.cookie
    (function standardBrowserEnv() {
      return {
        write: function write(name, value, expires, path, domain, secure) {
          var cookie = [];
          cookie.push(name + '=' + encodeURIComponent(value));

          if (utils.isNumber(expires)) {
            cookie.push('expires=' + new Date(expires).toGMTString());
          }

          if (utils.isString(path)) {
            cookie.push('path=' + path);
          }

          if (utils.isString(domain)) {
            cookie.push('domain=' + domain);
          }

          if (secure === true) {
            cookie.push('secure');
          }

          document.cookie = cookie.join('; ');
        },

        read: function read(name) {
          var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
          return (match ? decodeURIComponent(match[3]) : null);
        },

        remove: function remove(name) {
          this.write(name, '', Date.now() - 86400000);
        }
      };
    })() :

  // Non standard browser env (web workers, react-native) lack needed support.
    (function nonStandardBrowserEnv() {
      return {
        write: function write() {},
        read: function read() { return null; },
        remove: function remove() {}
      };
    })()
);


/***/ }),

/***/ 1793:
/***/ ((module) => {

"use strict";


/**
 * Determines whether the specified URL is absolute
 *
 * @param {string} url The URL to test
 * @returns {boolean} True if the specified URL is absolute, otherwise false
 */
module.exports = function isAbsoluteURL(url) {
  // A URL is considered absolute if it begins with "<scheme>://" or "//" (protocol-relative URL).
  // RFC 3986 defines scheme name as a sequence of characters beginning with a letter and followed
  // by any combination of letters, digits, plus, period, or hyphen.
  return /^([a-z][a-z\d+\-.]*:)?\/\//i.test(url);
};


/***/ }),

/***/ 6268:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

/**
 * Determines whether the payload is an error thrown by Axios
 *
 * @param {*} payload The value to test
 * @returns {boolean} True if the payload is an error thrown by Axios, otherwise false
 */
module.exports = function isAxiosError(payload) {
  return utils.isObject(payload) && (payload.isAxiosError === true);
};


/***/ }),

/***/ 7985:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

module.exports = (
  utils.isStandardBrowserEnv() ?

  // Standard browser envs have full support of the APIs needed to test
  // whether the request URL is of the same origin as current location.
    (function standardBrowserEnv() {
      var msie = /(msie|trident)/i.test(navigator.userAgent);
      var urlParsingNode = document.createElement('a');
      var originURL;

      /**
    * Parse a URL to discover it's components
    *
    * @param {String} url The URL to be parsed
    * @returns {Object}
    */
      function resolveURL(url) {
        var href = url;

        if (msie) {
        // IE needs attribute set twice to normalize properties
          urlParsingNode.setAttribute('href', href);
          href = urlParsingNode.href;
        }

        urlParsingNode.setAttribute('href', href);

        // urlParsingNode provides the UrlUtils interface - http://url.spec.whatwg.org/#urlutils
        return {
          href: urlParsingNode.href,
          protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, '') : '',
          host: urlParsingNode.host,
          search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, '') : '',
          hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, '') : '',
          hostname: urlParsingNode.hostname,
          port: urlParsingNode.port,
          pathname: (urlParsingNode.pathname.charAt(0) === '/') ?
            urlParsingNode.pathname :
            '/' + urlParsingNode.pathname
        };
      }

      originURL = resolveURL(window.location.href);

      /**
    * Determine if a URL shares the same origin as the current location
    *
    * @param {String} requestURL The URL to test
    * @returns {boolean} True if URL shares the same origin, otherwise false
    */
      return function isURLSameOrigin(requestURL) {
        var parsed = (utils.isString(requestURL)) ? resolveURL(requestURL) : requestURL;
        return (parsed.protocol === originURL.protocol &&
            parsed.host === originURL.host);
      };
    })() :

  // Non standard browser envs (web workers, react-native) lack needed support.
    (function nonStandardBrowserEnv() {
      return function isURLSameOrigin() {
        return true;
      };
    })()
);


/***/ }),

/***/ 6016:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

module.exports = function normalizeHeaderName(headers, normalizedName) {
  utils.forEach(headers, function processHeader(value, name) {
    if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
      headers[normalizedName] = value;
      delete headers[name];
    }
  });
};


/***/ }),

/***/ 1623:
/***/ ((module) => {

// eslint-disable-next-line strict
module.exports = null;


/***/ }),

/***/ 4109:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

// Headers whose duplicates are ignored by node
// c.f. https://nodejs.org/api/http.html#http_message_headers
var ignoreDuplicateOf = [
  'age', 'authorization', 'content-length', 'content-type', 'etag',
  'expires', 'from', 'host', 'if-modified-since', 'if-unmodified-since',
  'last-modified', 'location', 'max-forwards', 'proxy-authorization',
  'referer', 'retry-after', 'user-agent'
];

/**
 * Parse headers into an object
 *
 * ```
 * Date: Wed, 27 Aug 2014 08:58:49 GMT
 * Content-Type: application/json
 * Connection: keep-alive
 * Transfer-Encoding: chunked
 * ```
 *
 * @param {String} headers Headers needing to be parsed
 * @returns {Object} Headers parsed into an object
 */
module.exports = function parseHeaders(headers) {
  var parsed = {};
  var key;
  var val;
  var i;

  if (!headers) { return parsed; }

  utils.forEach(headers.split('\n'), function parser(line) {
    i = line.indexOf(':');
    key = utils.trim(line.substr(0, i)).toLowerCase();
    val = utils.trim(line.substr(i + 1));

    if (key) {
      if (parsed[key] && ignoreDuplicateOf.indexOf(key) >= 0) {
        return;
      }
      if (key === 'set-cookie') {
        parsed[key] = (parsed[key] ? parsed[key] : []).concat([val]);
      } else {
        parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
      }
    }
  });

  return parsed;
};


/***/ }),

/***/ 205:
/***/ ((module) => {

"use strict";


module.exports = function parseProtocol(url) {
  var match = /^([-+\w]{1,25})(:?\/\/|:)/.exec(url);
  return match && match[1] || '';
};


/***/ }),

/***/ 8713:
/***/ ((module) => {

"use strict";


/**
 * Syntactic sugar for invoking a function and expanding an array for arguments.
 *
 * Common use case would be to use `Function.prototype.apply`.
 *
 *  ```js
 *  function f(x, y, z) {}
 *  var args = [1, 2, 3];
 *  f.apply(null, args);
 *  ```
 *
 * With `spread` this example can be re-written.
 *
 *  ```js
 *  spread(function(x, y, z) {})([1, 2, 3]);
 *  ```
 *
 * @param {Function} callback
 * @returns {Function}
 */
module.exports = function spread(callback) {
  return function wrap(arr) {
    return callback.apply(null, arr);
  };
};


/***/ }),

/***/ 7675:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var utils = __webpack_require__(4867);

/**
 * Convert a data object to FormData
 * @param {Object} obj
 * @param {?Object} [formData]
 * @returns {Object}
 **/

function toFormData(obj, formData) {
  // eslint-disable-next-line no-param-reassign
  formData = formData || new FormData();

  var stack = [];

  function convertValue(value) {
    if (value === null) return '';

    if (utils.isDate(value)) {
      return value.toISOString();
    }

    if (utils.isArrayBuffer(value) || utils.isTypedArray(value)) {
      return typeof Blob === 'function' ? new Blob([value]) : Buffer.from(value);
    }

    return value;
  }

  function build(data, parentKey) {
    if (utils.isPlainObject(data) || utils.isArray(data)) {
      if (stack.indexOf(data) !== -1) {
        throw Error('Circular reference detected in ' + parentKey);
      }

      stack.push(data);

      utils.forEach(data, function each(value, key) {
        if (utils.isUndefined(value)) return;
        var fullKey = parentKey ? parentKey + '.' + key : key;
        var arr;

        if (value && !parentKey && typeof value === 'object') {
          if (utils.endsWith(key, '{}')) {
            // eslint-disable-next-line no-param-reassign
            value = JSON.stringify(value);
          } else if (utils.endsWith(key, '[]') && (arr = utils.toArray(value))) {
            // eslint-disable-next-line func-names
            arr.forEach(function(el) {
              !utils.isUndefined(el) && formData.append(fullKey, convertValue(el));
            });
            return;
          }
        }

        build(value, fullKey);
      });

      stack.pop();
    } else {
      formData.append(parentKey, convertValue(data));
    }
  }

  build(obj);

  return formData;
}

module.exports = toFormData;


/***/ }),

/***/ 4875:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var VERSION = (__webpack_require__(7288).version);
var AxiosError = __webpack_require__(2648);

var validators = {};

// eslint-disable-next-line func-names
['object', 'boolean', 'number', 'function', 'string', 'symbol'].forEach(function(type, i) {
  validators[type] = function validator(thing) {
    return typeof thing === type || 'a' + (i < 1 ? 'n ' : ' ') + type;
  };
});

var deprecatedWarnings = {};

/**
 * Transitional option validator
 * @param {function|boolean?} validator - set to false if the transitional option has been removed
 * @param {string?} version - deprecated version / removed since version
 * @param {string?} message - some message with additional info
 * @returns {function}
 */
validators.transitional = function transitional(validator, version, message) {
  function formatMessage(opt, desc) {
    return '[Axios v' + VERSION + '] Transitional option \'' + opt + '\'' + desc + (message ? '. ' + message : '');
  }

  // eslint-disable-next-line func-names
  return function(value, opt, opts) {
    if (validator === false) {
      throw new AxiosError(
        formatMessage(opt, ' has been removed' + (version ? ' in ' + version : '')),
        AxiosError.ERR_DEPRECATED
      );
    }

    if (version && !deprecatedWarnings[opt]) {
      deprecatedWarnings[opt] = true;
      // eslint-disable-next-line no-console
      console.warn(
        formatMessage(
          opt,
          ' has been deprecated since v' + version + ' and will be removed in the near future'
        )
      );
    }

    return validator ? validator(value, opt, opts) : true;
  };
};

/**
 * Assert object's properties type
 * @param {object} options
 * @param {object} schema
 * @param {boolean?} allowUnknown
 */

function assertOptions(options, schema, allowUnknown) {
  if (typeof options !== 'object') {
    throw new AxiosError('options must be an object', AxiosError.ERR_BAD_OPTION_VALUE);
  }
  var keys = Object.keys(options);
  var i = keys.length;
  while (i-- > 0) {
    var opt = keys[i];
    var validator = schema[opt];
    if (validator) {
      var value = options[opt];
      var result = value === undefined || validator(value, opt, options);
      if (result !== true) {
        throw new AxiosError('option ' + opt + ' must be ' + result, AxiosError.ERR_BAD_OPTION_VALUE);
      }
      continue;
    }
    if (allowUnknown !== true) {
      throw new AxiosError('Unknown option ' + opt, AxiosError.ERR_BAD_OPTION);
    }
  }
}

module.exports = {
  assertOptions: assertOptions,
  validators: validators
};


/***/ }),

/***/ 4867:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var bind = __webpack_require__(1849);

// utils is a library of generic helper functions non-specific to axios

var toString = Object.prototype.toString;

// eslint-disable-next-line func-names
var kindOf = (function(cache) {
  // eslint-disable-next-line func-names
  return function(thing) {
    var str = toString.call(thing);
    return cache[str] || (cache[str] = str.slice(8, -1).toLowerCase());
  };
})(Object.create(null));

function kindOfTest(type) {
  type = type.toLowerCase();
  return function isKindOf(thing) {
    return kindOf(thing) === type;
  };
}

/**
 * Determine if a value is an Array
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an Array, otherwise false
 */
function isArray(val) {
  return Array.isArray(val);
}

/**
 * Determine if a value is undefined
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if the value is undefined, otherwise false
 */
function isUndefined(val) {
  return typeof val === 'undefined';
}

/**
 * Determine if a value is a Buffer
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Buffer, otherwise false
 */
function isBuffer(val) {
  return val !== null && !isUndefined(val) && val.constructor !== null && !isUndefined(val.constructor)
    && typeof val.constructor.isBuffer === 'function' && val.constructor.isBuffer(val);
}

/**
 * Determine if a value is an ArrayBuffer
 *
 * @function
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an ArrayBuffer, otherwise false
 */
var isArrayBuffer = kindOfTest('ArrayBuffer');


/**
 * Determine if a value is a view on an ArrayBuffer
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a view on an ArrayBuffer, otherwise false
 */
function isArrayBufferView(val) {
  var result;
  if ((typeof ArrayBuffer !== 'undefined') && (ArrayBuffer.isView)) {
    result = ArrayBuffer.isView(val);
  } else {
    result = (val) && (val.buffer) && (isArrayBuffer(val.buffer));
  }
  return result;
}

/**
 * Determine if a value is a String
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a String, otherwise false
 */
function isString(val) {
  return typeof val === 'string';
}

/**
 * Determine if a value is a Number
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Number, otherwise false
 */
function isNumber(val) {
  return typeof val === 'number';
}

/**
 * Determine if a value is an Object
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an Object, otherwise false
 */
function isObject(val) {
  return val !== null && typeof val === 'object';
}

/**
 * Determine if a value is a plain Object
 *
 * @param {Object} val The value to test
 * @return {boolean} True if value is a plain Object, otherwise false
 */
function isPlainObject(val) {
  if (kindOf(val) !== 'object') {
    return false;
  }

  var prototype = Object.getPrototypeOf(val);
  return prototype === null || prototype === Object.prototype;
}

/**
 * Determine if a value is a Date
 *
 * @function
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Date, otherwise false
 */
var isDate = kindOfTest('Date');

/**
 * Determine if a value is a File
 *
 * @function
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a File, otherwise false
 */
var isFile = kindOfTest('File');

/**
 * Determine if a value is a Blob
 *
 * @function
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Blob, otherwise false
 */
var isBlob = kindOfTest('Blob');

/**
 * Determine if a value is a FileList
 *
 * @function
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a File, otherwise false
 */
var isFileList = kindOfTest('FileList');

/**
 * Determine if a value is a Function
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Function, otherwise false
 */
function isFunction(val) {
  return toString.call(val) === '[object Function]';
}

/**
 * Determine if a value is a Stream
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Stream, otherwise false
 */
function isStream(val) {
  return isObject(val) && isFunction(val.pipe);
}

/**
 * Determine if a value is a FormData
 *
 * @param {Object} thing The value to test
 * @returns {boolean} True if value is an FormData, otherwise false
 */
function isFormData(thing) {
  var pattern = '[object FormData]';
  return thing && (
    (typeof FormData === 'function' && thing instanceof FormData) ||
    toString.call(thing) === pattern ||
    (isFunction(thing.toString) && thing.toString() === pattern)
  );
}

/**
 * Determine if a value is a URLSearchParams object
 * @function
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a URLSearchParams object, otherwise false
 */
var isURLSearchParams = kindOfTest('URLSearchParams');

/**
 * Trim excess whitespace off the beginning and end of a string
 *
 * @param {String} str The String to trim
 * @returns {String} The String freed of excess whitespace
 */
function trim(str) {
  return str.trim ? str.trim() : str.replace(/^\s+|\s+$/g, '');
}

/**
 * Determine if we're running in a standard browser environment
 *
 * This allows axios to run in a web worker, and react-native.
 * Both environments support XMLHttpRequest, but not fully standard globals.
 *
 * web workers:
 *  typeof window -> undefined
 *  typeof document -> undefined
 *
 * react-native:
 *  navigator.product -> 'ReactNative'
 * nativescript
 *  navigator.product -> 'NativeScript' or 'NS'
 */
function isStandardBrowserEnv() {
  if (typeof navigator !== 'undefined' && (navigator.product === 'ReactNative' ||
                                           navigator.product === 'NativeScript' ||
                                           navigator.product === 'NS')) {
    return false;
  }
  return (
    typeof window !== 'undefined' &&
    typeof document !== 'undefined'
  );
}

/**
 * Iterate over an Array or an Object invoking a function for each item.
 *
 * If `obj` is an Array callback will be called passing
 * the value, index, and complete array for each item.
 *
 * If 'obj' is an Object callback will be called passing
 * the value, key, and complete object for each property.
 *
 * @param {Object|Array} obj The object to iterate
 * @param {Function} fn The callback to invoke for each item
 */
function forEach(obj, fn) {
  // Don't bother if no value provided
  if (obj === null || typeof obj === 'undefined') {
    return;
  }

  // Force an array if not already something iterable
  if (typeof obj !== 'object') {
    /*eslint no-param-reassign:0*/
    obj = [obj];
  }

  if (isArray(obj)) {
    // Iterate over array values
    for (var i = 0, l = obj.length; i < l; i++) {
      fn.call(null, obj[i], i, obj);
    }
  } else {
    // Iterate over object keys
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        fn.call(null, obj[key], key, obj);
      }
    }
  }
}

/**
 * Accepts varargs expecting each argument to be an object, then
 * immutably merges the properties of each object and returns result.
 *
 * When multiple objects contain the same key the later object in
 * the arguments list will take precedence.
 *
 * Example:
 *
 * ```js
 * var result = merge({foo: 123}, {foo: 456});
 * console.log(result.foo); // outputs 456
 * ```
 *
 * @param {Object} obj1 Object to merge
 * @returns {Object} Result of all merge properties
 */
function merge(/* obj1, obj2, obj3, ... */) {
  var result = {};
  function assignValue(val, key) {
    if (isPlainObject(result[key]) && isPlainObject(val)) {
      result[key] = merge(result[key], val);
    } else if (isPlainObject(val)) {
      result[key] = merge({}, val);
    } else if (isArray(val)) {
      result[key] = val.slice();
    } else {
      result[key] = val;
    }
  }

  for (var i = 0, l = arguments.length; i < l; i++) {
    forEach(arguments[i], assignValue);
  }
  return result;
}

/**
 * Extends object a by mutably adding to it the properties of object b.
 *
 * @param {Object} a The object to be extended
 * @param {Object} b The object to copy properties from
 * @param {Object} thisArg The object to bind function to
 * @return {Object} The resulting value of object a
 */
function extend(a, b, thisArg) {
  forEach(b, function assignValue(val, key) {
    if (thisArg && typeof val === 'function') {
      a[key] = bind(val, thisArg);
    } else {
      a[key] = val;
    }
  });
  return a;
}

/**
 * Remove byte order marker. This catches EF BB BF (the UTF-8 BOM)
 *
 * @param {string} content with BOM
 * @return {string} content value without BOM
 */
function stripBOM(content) {
  if (content.charCodeAt(0) === 0xFEFF) {
    content = content.slice(1);
  }
  return content;
}

/**
 * Inherit the prototype methods from one constructor into another
 * @param {function} constructor
 * @param {function} superConstructor
 * @param {object} [props]
 * @param {object} [descriptors]
 */

function inherits(constructor, superConstructor, props, descriptors) {
  constructor.prototype = Object.create(superConstructor.prototype, descriptors);
  constructor.prototype.constructor = constructor;
  props && Object.assign(constructor.prototype, props);
}

/**
 * Resolve object with deep prototype chain to a flat object
 * @param {Object} sourceObj source object
 * @param {Object} [destObj]
 * @param {Function} [filter]
 * @returns {Object}
 */

function toFlatObject(sourceObj, destObj, filter) {
  var props;
  var i;
  var prop;
  var merged = {};

  destObj = destObj || {};

  do {
    props = Object.getOwnPropertyNames(sourceObj);
    i = props.length;
    while (i-- > 0) {
      prop = props[i];
      if (!merged[prop]) {
        destObj[prop] = sourceObj[prop];
        merged[prop] = true;
      }
    }
    sourceObj = Object.getPrototypeOf(sourceObj);
  } while (sourceObj && (!filter || filter(sourceObj, destObj)) && sourceObj !== Object.prototype);

  return destObj;
}

/*
 * determines whether a string ends with the characters of a specified string
 * @param {String} str
 * @param {String} searchString
 * @param {Number} [position= 0]
 * @returns {boolean}
 */
function endsWith(str, searchString, position) {
  str = String(str);
  if (position === undefined || position > str.length) {
    position = str.length;
  }
  position -= searchString.length;
  var lastIndex = str.indexOf(searchString, position);
  return lastIndex !== -1 && lastIndex === position;
}


/**
 * Returns new array from array like object
 * @param {*} [thing]
 * @returns {Array}
 */
function toArray(thing) {
  if (!thing) return null;
  var i = thing.length;
  if (isUndefined(i)) return null;
  var arr = new Array(i);
  while (i-- > 0) {
    arr[i] = thing[i];
  }
  return arr;
}

// eslint-disable-next-line func-names
var isTypedArray = (function(TypedArray) {
  // eslint-disable-next-line func-names
  return function(thing) {
    return TypedArray && thing instanceof TypedArray;
  };
})(typeof Uint8Array !== 'undefined' && Object.getPrototypeOf(Uint8Array));

module.exports = {
  isArray: isArray,
  isArrayBuffer: isArrayBuffer,
  isBuffer: isBuffer,
  isFormData: isFormData,
  isArrayBufferView: isArrayBufferView,
  isString: isString,
  isNumber: isNumber,
  isObject: isObject,
  isPlainObject: isPlainObject,
  isUndefined: isUndefined,
  isDate: isDate,
  isFile: isFile,
  isBlob: isBlob,
  isFunction: isFunction,
  isStream: isStream,
  isURLSearchParams: isURLSearchParams,
  isStandardBrowserEnv: isStandardBrowserEnv,
  forEach: forEach,
  merge: merge,
  extend: extend,
  trim: trim,
  stripBOM: stripBOM,
  inherits: inherits,
  toFlatObject: toFlatObject,
  kindOf: kindOf,
  kindOfTest: kindOfTest,
  endsWith: endsWith,
  toArray: toArray,
  isTypedArray: isTypedArray,
  isFileList: isFileList
};


/***/ }),

/***/ 8227:
/***/ (() => {

/**
 * Catalog Page Component
 *
 * @namespace Components
 */
(function () {
  'use strict';

  DashboardController.$inject = ["$rootScope", "Admin"];
  angular.module('vendorfuelApp').component('vfCatalog', {
    controller: DashboardController,
    templateUrl: "".concat(localized.dir.templates, "/catalog.component.html")
  });
  DashboardController.$inject = ['$rootScope', 'Admin'];
  /**
   * @param {Object} $rootScope AngularJS service
   * @param {Object} Admin      VendorFuel service
   */

  function DashboardController($rootScope, Admin) {
    var _this = this;

    var vm = this;
    /**
     * Initialization
     */

    this.$onInit = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }];
      vm.isAuthed = Admin.Authed();
      vm.sections = [{
        title: 'Categories',
        state: 'catalog-categories({activeTab: 0})',
        icon: 'folder-fill',
        description: 'Manage product categories.',
        sublinks: [{
          title: 'All Categories',
          state: 'catalog-categories({activeTab: 0})'
        }, {
          title: 'Add New',
          state: 'catalog-categories({activeTab: 1})'
        }, {
          title: 'Utilities',
          state: 'catalog-categories({activeTab: 3})'
        }]
      }, {
        title: 'Products',
        state: 'catalog-products({activeTab: 0})',
        icon: 'box',
        description: 'Manage products.',
        sublinks: [{
          title: 'All Products',
          state: 'catalog-products({activeTab: 0})'
        }, {
          title: 'Add New',
          state: 'catalog-products({activeTab: 1})'
        }, {
          title: 'Import',
          state: 'catalog-products({activeTab: 3})'
        }, {
          title: 'Batches',
          state: 'catalog-products({activeTab: 4})'
        }, {
          title: 'Utilities',
          state: 'catalog-products({activeTab: 6})'
        }]
      }, {
        title: 'Reviews',
        state: 'reviews.index',
        icon: 'chat-fill',
        description: 'Manage product reviews.'
      }, {
        title: 'Collections',
        state: 'catalog-collections({activeTab: 0})',
        icon: 'tag-fill',
        description: 'Manage product and category collections.',
        sublinks: [{
          title: 'All Collections',
          state: 'catalog-collections({activeTab: 0})'
        }, {
          title: 'Add New',
          state: 'catalog-collections({activeTab: 1})'
        }]
      }, {
        title: 'Manufacturers',
        state: 'manufacturers.index',
        icon: 'building',
        description: 'Manage product manufacturers.',
        sublinks: [{
          title: 'All Manufacturers',
          state: 'manufacturers.index'
        }, {
          title: 'Add New',
          state: 'manufacturers.create'
        }]
      }, {
        title: 'Banners',
        state: 'catalog-banners({activeTab: 0})',
        icon: 'grid-fill',
        description: 'Manage banners.',
        sublinks: [{
          title: 'All Banners',
          state: 'catalog-banners({activeTab: 0})'
        }, {
          title: 'Add New',
          state: 'catalog-banners({activeTab: 1})'
        }]
      }, {
        title: 'Price Sheets',
        state: 'catalog-pricesheets({activeTab: 0})',
        icon: 'cash-coin',
        description: 'Manage price sheets.',
        sublinks: [{
          title: 'All Price Sheets',
          state: 'catalog-pricesheets({activeTab: 0})'
        }, {
          title: 'Add New',
          state: 'catalog-pricesheets({activeTab: 1})'
        }, {
          title: 'Import',
          state: 'catalog-pricesheets({activeTab: 3})'
        }, {
          title: 'Batches',
          state: 'catalog-pricesheets({activeTab: 4})'
        }]
      }, {
        title: 'Promo Codes',
        state: 'catalog-promocodes({activeTab: 0})',
        icon: 'wallet-fill',
        description: 'Manage promo codes.',
        sublinks: [{
          title: 'All Promo Codes',
          state: 'catalog-promocodes({activeTab: 0})'
        }, {
          title: 'Add New',
          state: 'catalog-promocodes({activeTab: 1})'
        }]
      }, {
        title: 'Units of Measure',
        state: 'catalog-uom({activeTab: 0})',
        icon: 'rulers',
        description: 'Manage units of measure (UoM).',
        sublinks: [{
          title: 'All Units of Measure',
          state: 'catalog-uom({activeTab: 0})'
        }, {
          title: 'Add New',
          state: 'catalog-uom({activeTab: 1})'
        }]
      }];
    };
  }
})();

/***/ }),

/***/ 4999:
/***/ (() => {

/**
 * Catalog Component
 *
 * @namespace Components
 */
(function () {
  'use strict';

  DashboardController.$inject = ["$rootScope", "Admin"];
  angular.module('vendorfuelApp').component('vfCustomers', {
    controller: DashboardController,
    templateUrl: "".concat(localized.dir.templates, "/customers.component.html")
  });
  DashboardController.$inject = ['$rootScope', 'Admin'];
  /**
   * @param {Object} $rootScope AngularJS service
   * @param {Object} Admin      VendorFuel service
   */

  function DashboardController($rootScope, Admin) {
    var _this = this;

    var vm = this;
    /**
     * Initialization
     */

    this.$onInit = function () {
      _this.breadcrumbs = [{
        name: 'Customers',
        state: 'customers.page'
      }];
      vm.isAuthed = Admin.Authed();
      vm.sections = [{
        title: 'Customer Accounts',
        link: 'customers-accounts',
        icon: 'admin-users',
        description: 'Manage customer accounts.',
        sublinks: [{
          title: 'View All Customers',
          tab: 0
        }, {
          title: 'Add New',
          tab: 1
        }, {
          title: 'Upload',
          tab: 3
        }, {
          title: 'Batches',
          tab: 4
        }, {
          title: 'Settings',
          tab: 6
        }]
      }, {
        title: 'Groups',
        link: 'customers-groups',
        icon: 'groups',
        description: 'Manage customer groups.',
        sublinks: [{
          title: 'View All Groups',
          tab: 0
        }, {
          title: 'Add New',
          tab: 1
        }, {
          title: 'Upload',
          tab: 3
        }, {
          title: 'Batches',
          tab: 4
        }]
      }, {
        title: 'Roles',
        link: 'customers.roles.index',
        icon: 'admin-generic',
        description: 'Manage customer roles.',
        sublinks: [{
          title: 'View All Roles',
          state: 'customers.roles.index'
        }, {
          title: 'Add New',
          state: 'customers.roles.create'
        }]
      }];
    };
  }
})();

/***/ }),

/***/ 3685:
/***/ (() => {

/**
 * Header Component
 *
 * @namespace Components
 */
(function () {
  'use strict';

  HeaderController.$inject = ["$state", "$window", "Admin", "Localized"];
  angular.module('vendorfuelApp').component('vfHeader', {
    controller: HeaderController,
    templateUrl: "".concat(localized.dir.templates, "/header.component.html")
  });
  HeaderController.$inject = ['$state', '$window', 'Admin', 'Localized'];
  /**
   * @param {Object} $state    UI Router object
   * @param {Object} $window   AngularJS service
   * @param {Object} Admin     VendorFuel service
   * @param {Object} Localized VendorFuel service
   */

  function HeaderController($state, $window, Admin, Localized) {
    var vm = this;
    /**
     * Initialization
     */

    this.$onInit = function () {
      vm.iconSrc = "".concat(Localized.root.url, "assets/img/vf-icon.svg");
      vm.iconStyle = {
        height: '2rem',
        verticalAlign: 'baseline'
      };
      vm.pluginVersion = Localized.plugin_data.Version;
      startTutorial();
    };
    /**
     * Show tutorial based on cookies.
     */


    function startTutorial() {
      var isShowingTutorial = $window.localStorage.getItem('showTutorial');

      if (isShowingTutorial === 'true' && Admin.Authed()) {
        $state.go('tutorial');
      }
    }
  }
})();

/***/ }),

/***/ 5386:
/***/ (() => {

(function () {
  'use strict';

  ManufacturerController.$inject = ["$http", "$rootScope", "$scope", "$state", "$stateParams", "Localized", "Manufacturers"];
  angular.module('vendorfuelApp').component('manufacturersDetail', {
    controller: ManufacturerController,
    templateUrl: "".concat(localized.dir.templates, "/manufacturers-detail.component.html")
  });
  ManufacturerController.$inject = ['$http', '$rootScope', '$scope', '$state', '$stateParams', 'Localized', 'Manufacturers'];

  function ManufacturerController($http, $rootScope, $scope, $state, $stateParams, Localized, Manufacturers) {
    var _this = this;

    var vm = this;
    vm.changeLogo = changeLogo;
    vm.remove = remove;
    vm.removeLogo = removeLogo;
    vm.selectLogo = selectLogo;
    vm.submit = submit;
    /**
     * Initialization
     */

    this.$onInit = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Manufacturers',
        state: 'manufacturers.index'
      }];

      if ($stateParams.id) {
        _this.getManufacturer($stateParams.id);
      } else {
        _this.createManufacturer();
      }
    };

    function changeLogo(el) {
      $scope.$apply(function () {
        vm.manufacturer.logo = el.files[0];
      });
    }
    /**
     */


    this.createManufacturer = function () {
      vm.isNew = true;
      vm.manufacturer = {};

      _this.updateBreadcrumb();
    };

    this.getManufacturer = function (id) {
      vm.isLoading = true;
      Manufacturers.get({
        id: id
      }).$promise.then(function (manufacturer) {
        vm.manufacturer = manufacturer;

        if (vm.manufacturer.images && vm.manufacturer.images.logo) {
          vm.logoFilename = new URL(vm.manufacturer.images.logo["default"]).pathname.split('/').pop();
        }

        _this.updateBreadcrumb(vm.manufacturer);

        vm.isLoading = false;
      });
    };
    /**
     */


    function remove() {
      vm.isDeleting = true;
      Manufacturers["delete"]({
        id: vm.manufacturer.id
      }).$promise.then(function () {
        vm.isDeleting = false;
        $state.go('manufacturers.index');
      });
    }

    function removeLogo(mediaId) {
      vm.isRemovingLogo = true;
      var endpoint = "".concat(Localized.apiURL, "/admin/manufacturers/").concat(vm.manufacturer.id, "/media/").concat(mediaId);
      $http["delete"](endpoint).then(function () {
        vm.isRemovingLogo = false;
        $state.reload();
      });
    }

    function save() {
      vm.isSaving = true;
      Manufacturers.save(vm.manufacturer).$promise.then(function (response) {
        var id = response.manufacturer.id;
        vm.isSaving = false;
        $state.go('manufacturers.show', {
          id: id
        });
      });
    }
    /**
     * Select a logo using WP Media.
     */


    function selectLogo() {
      // eslint-disable-next-line no-undef
      var fileFrame = wp.media({
        title: 'Select or Upload image',
        library: {
          type: 'image'
        },
        button: {
          text: 'Select'
        },
        multiple: false
      });
      fileFrame.on('select', function () {
        $scope.$apply(function () {
          vm.manufacturer.image_url = fileFrame.state().get('selection').first().toJSON().url;
        });
      });
      fileFrame.open();
    }
    /**
     */


    function submit() {
      if (vm.isNew) {
        save();
      } else {
        update();
      }
    }
    /**
     */


    function update() {
      vm.isUpdating = true;
      Manufacturers.update({
        id: vm.manufacturer.id
      }, vm.manufacturer).$promise.then(function () {
        vm.isUpdating = false;
        $state.reload();
      });
    }
    /**
     * @param {Object} manufacturer Manufacturer
     */


    this.updateBreadcrumb = function (manufacturer) {
      if (manufacturer) {
        _this.breadcrumbs.push({
          name: manufacturer.name,
          state: 'manufacturers.show({ id: vm.manufacturer.id })'
        });
      } else {
        _this.breadcrumbs.push({
          name: 'Add New',
          state: 'manufacturers.create'
        });
      }
    };
  }
})();

/***/ }),

/***/ 9563:
/***/ (() => {

(function () {
  'use strict';

  ManufacturersController.$inject = ["$location", "$state", "Manufacturers"];
  angular.module('vendorfuelApp').component('manufacturersIndex', {
    controller: ManufacturersController,
    templateUrl: "".concat(localized.dir.templates, "/manufacturers-index.component.html")
  });
  ManufacturersController.$inject = ['$location', '$state', 'Manufacturers'];

  function ManufacturersController($location, $state, Manufacturers) {
    var _this = this;

    var vm = this;
    vm.cancelDelete = cancelDelete;
    vm.changePage = changePage;
    vm.changeQuery = changeQuery;
    vm.changeSortBy = changeSortBy;
    vm.remove = remove;
    vm.submit = submit;
    /**
     * Initialization
     */

    this.$onInit = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Manufacturers',
        state: 'manufacturers.index'
      }];
      vm.isConfirmingDeletion = [];
      vm.isDeleting = [];
      vm.params = {
        page: $location.search().page || 1,
        q: $location.search().q || '',
        rpp: 15,
        sortBy: $location.search().sortBy || '',
        sortType: $location.search().sortType || ''
      };
      vm.cachedQ = vm.params.q;
      queryManufacturers();
    };

    function cancelDelete(e, i) {
      e.preventDefault();
      vm.isConfirmingDeletion[i] = false;
    }
    /**
     * @param {Object} e    Click event
     * @param {number} page Page number
     */


    function changePage(e, page) {
      if (e) {
        e.preventDefault();
      }

      vm.params.page = page;
      submit();
    }
    /**
     * @param {string} q Query
     */


    function changeQuery(q) {
      if (!q) {
        submit();
      }
    }
    /**
     * @param {string} sortBy Sortby term
     * @param {Object} e      Click event
     */


    function changeSortBy(sortBy, e) {
      e.preventDefault();

      if (vm.params.sortBy === sortBy) {
        vm.params.sortType = vm.params.sortType === 'desc' ? 'asc' : 'desc';
      } else {
        vm.params.sortType = 'asc';
        vm.params.sortBy = sortBy;
      }

      updateSearchParams();
      queryManufacturers();
    }

    this.confirmDelete = function (e, i) {
      e.preventDefault();
      vm.isConfirmingDeletion[i] = true;
    };
    /**
     * Get the manufacturers
     */


    function queryManufacturers() {
      vm.isLoading = true;
      Manufacturers.query(vm.params).$promise.then(function (manufacturers) {
        vm.manufacturers = manufacturers;
        vm.isLoading = false;
      });
    }

    function remove(e, id, index) {
      e.preventDefault();
      vm.isDeleting[index] = true;
      Manufacturers["delete"]({
        id: id
      }).$promise.then(function () {
        vm.isDeleting[index] = false;
        $state.reload();
      });
    }
    /**
     * Submit the search form.
     */


    function submit() {
      vm.cachedQ = vm.params.q;
      updateSearchParams();
      queryManufacturers();
    }
    /**
     * Update the search params in the URL.
     */


    function updateSearchParams() {
      var _vm$params = vm.params,
          q = _vm$params.q,
          page = _vm$params.page;
      $location.search('q', q ? q : null);
      $location.search('page', page > 1 ? page : null);
    }
  }
})();

/***/ }),

/***/ 3915:
/***/ (() => {

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

(function () {
  'use strict';

  service.$inject = ["$resource", "Localized"];
  angular.module('vendorfuelApp').factory('Manufacturers', service);
  service.$inject = ['$resource', 'Localized'];
  /**
   * @param {Object} $resource Angular service
   * @param {Object} Localized VendorFuel service
   * @return {Object} Manufacturers service
   */

  function service($resource, Localized) {
    var endpoint = "".concat(Localized.apiURL, "/admin/manufacturers/:id");
    return $resource(endpoint, {
      id: '@id'
    }, {
      get: {
        interceptor: {
          response: function response(_response) {
            var manufacturer = _response.resource.manufacturer;
            return manufacturer;
          }
        }
      },
      save: {
        method: 'POST',
        headers: {
          'Content-Type': undefined
        },
        transformRequest: function transformRequest(data) {
          var formData = new FormData();
          Object.entries(data).forEach(function (entry) {
            var _entry = _slicedToArray(entry, 2),
                key = _entry[0],
                value = _entry[1];

            if (value) {
              formData.append(key, value);
            }
          });
          return formData;
        }
      },
      query: {
        isArray: false,
        interceptor: {
          response: function response(_response2) {
            var manufacturers = _response2.resource.manufacturers;
            return manufacturers;
          }
        }
      },
      update: {
        method: 'PUT',
        headers: {
          'Content-Type': undefined
        },
        transformRequest: function transformRequest(data) {
          var formData = new FormData();
          Object.entries(data).forEach(function (entry) {
            var _entry2 = _slicedToArray(entry, 2),
                key = _entry2[0],
                value = _entry2[1];

            if (key !== 'id' && key !== 'images') {
              formData.append(key, value || '');
            }
          });
          return formData;
        }
      }
    });
  }
})();

/***/ }),

/***/ 9537:
/***/ (() => {

(function () {
  'use strict';

  productsFactory.$inject = ["Localized", "Utils"];
  angular.module('vendorfuelApp').factory('Products', productsFactory);
  productsFactory.$inject = ['Localized', 'Utils'];
  /**
   * @param {Object} Localized Angular service
   * @param {Object} Utils Angular service
   * @return {Object} Service
   */

  function productsFactory(Localized, Utils) {
    var categories = [];
    var parcels = [];
    var selectOptions = {
      description: 'Description',
      sku: 'SKU',
      mfg_part_num: 'Mfg Part Num',
      manufacturer: 'Manufacturer'
    };
    var termOptions = {
      like: 'Contains',
      'not like': 'Does Not Contain',
      '=': 'Equals (=)',
      '!=': 'Does Not Equal (!=)',
      '>': 'Greater Than (>)',
      '<': 'Less Than (<)'
    };
    var statuses = {
      active: 'Active',
      discontinued: 'Discontinued',
      inactive: 'Inactive',
      backordered: 'Backordered'
    };
    /**
     * @return {Object} Promise
     */

    function setCategories() {
      var req = {
        method: 'GET',
        url: Localized.apiURL + '/admin/category/',
        params: {
          rpp: 999
        }
      };
      return Utils.getHttpPromise(req).then(function (resp) {
        categories = resp.categories;
        return resp;
      });
    }
    /**
     * @return {Array} Categories
     */


    function getCategories() {
      return categories;
    }
    /**
     * @return {Object} Response
     */


    function setParcels() {
      return Utils.httpGet(Localized.apiURL + '/admin/shipping/parcel').then(function (resp) {
        parcels = resp.parcels;
        return resp;
      });
    }
    /**
     * @return {Array} Parcels
     */


    function getParcels() {
      return parcels;
    }
    /**
     * @return {any} Term Options
     */


    function getTermOptions() {
      return termOptions;
    }
    /**
     * @return {any} Select Options
     */


    function getSelectOptions() {
      return selectOptions;
    }
    /**
     * @return {any} Statuses
     */


    function getStatuses() {
      return statuses;
    }

    return {
      setCategories: setCategories,
      getCategories: getCategories,
      setParcels: setParcels,
      getParcels: getParcels,
      getSelectOptions: getSelectOptions,
      getTermOptions: getTermOptions,
      getStatuses: getStatuses
    };
  }
})();

/***/ }),

/***/ 455:
/***/ (() => {

(function () {
  'use strict';

  ReviewController.$inject = ["$rootScope", "$state", "$stateParams", "Reviews"];
  angular.module('vendorfuelApp').component('reviewsDetail', {
    controller: ReviewController,
    templateUrl: "".concat(localized.dir.templates, "/reviews-detail.component.html")
  });
  ReviewController.$inject = ['$rootScope', '$state', '$stateParams', 'Reviews'];

  function ReviewController($rootScope, $state, $stateParams, Reviews) {
    var _this = this;

    var vm = this;
    vm.approve = approve;
    vm.remove = remove;
    /**
     * Initialization
     */

    this.$onInit = function () {
      vm.productSlug = localized.settings.general.product_slug || 'products';
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Products',
        state: 'catalog-products({ activeTab: 0 })'
      }, {
        name: 'Reviews',
        state: 'reviews.index'
      }];

      if ($stateParams.id) {
        _this.getReview($stateParams.id);
      }
    };

    function approve() {
      var body = {
        status: 'approved'
      };
      Reviews.update({
        id: vm.review.id
      }, body).$promise.then(function () {
        $state.reload();
      });
    }

    this.getReview = function (id) {
      vm.isLoading = true;
      Reviews.get({
        id: id
      }).$promise.then(function (review) {
        vm.review = review;

        _this.updateBreadcrumb(vm.review);

        vm.isLoading = false;
      });
    };

    function remove() {
      vm.isDeleting = true;
      Reviews["delete"]({
        id: vm.review.id
      }).$promise.then(function () {
        vm.isDeleting = false;
        $state.go('reviews.index');
      });
    }

    this.updateBreadcrumb = function (review) {
      if (review) {
        _this.breadcrumbs.push({
          name: review.title,
          state: 'review.show({ id: vm.review.id })'
        });
      }
    };
  }
})();

/***/ }),

/***/ 8134:
/***/ (() => {

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

(function () {
  'use strict';

  service.$inject = ["$resource", "Localized"];
  angular.module('vendorfuelApp').factory('Reviews', service);
  service.$inject = ['$resource', 'Localized'];

  function service($resource, Localized) {
    var endpoint = "".concat(Localized.apiURL, "/admin/products/reviews/:id");
    return $resource(endpoint, {
      id: '@id'
    }, {
      get: {
        method: 'GET',
        interceptor: {
          response: function response(_response) {
            var review = _response.resource.review;
            return review;
          }
        }
      },
      save: {
        method: 'POST',
        headers: {
          'Content-Type': undefined
        },
        transformRequest: function transformRequest(data) {
          var formData = new FormData();
          Object.entries(data).forEach(function (entry) {
            var _entry = _slicedToArray(entry, 2),
                key = _entry[0],
                value = _entry[1];

            if (value) {
              formData.append(key, value);
            }
          });
          return formData;
        }
      },
      query: {
        method: 'GET',
        isArray: false,
        interceptor: {
          response: function response(_response2) {
            var reviews = _response2.resource.reviews;
            return reviews;
          }
        }
      },
      update: {
        method: 'PUT',
        headers: {
          'Content-Type': undefined
        },
        transformRequest: function transformRequest(data) {
          var formData = new FormData();
          Object.entries(data).forEach(function (entry) {
            var _entry2 = _slicedToArray(entry, 2),
                key = _entry2[0],
                value = _entry2[1];

            if (key !== 'id' && key !== 'images') {
              formData.append(key, value || '');
            }
          });
          return formData;
        }
      }
    });
  }
})();

/***/ }),

/***/ 8734:
/***/ (() => {

/**
 * Punchout Component
 */
(function () {
  'use strict';

  PunchoutController.$inject = ["$rootScope"];
  angular.module('vendorfuelApp').component('vfPunchout', {
    controller: PunchoutController,
    templateUrl: "".concat(localized.dir.templates, "/punchout.component.html")
  });
  PunchoutController.$inject = ['$rootScope'];
  /**
   * @param {Object} $rootScope Angular service
   */

  function PunchoutController($rootScope) {
    this.breadcrumbs = [{
      name: 'Punchout',
      state: 'punchout'
    }];
  }
})();

/***/ }),

/***/ 4582:
/***/ (() => {

/**
 * Tutorial Component
 *
 * @namespace Components
 */
(function () {
  'use strict';

  TutorialController.$inject = ["$rootScope", "$state", "$window", "Admin", "Localized", "Utils"];
  angular.module('vendorfuelApp').component('vfTutorial', {
    controller: TutorialController,
    templateUrl: "".concat(localized.dir.templates, "/tutorial.component.html")
  });
  TutorialController.$inject = ['$rootScope', '$state', '$window', 'Admin', 'Localized', 'Utils'];
  /**
   * @param {Object} $rootScope AngularJS service
   * @param {Object} $state     UI Router service
   * @param {Object} $window    AngularJS service
   * @param {Object} Admin      VendorFuel service
   * @param {Object} Localized  VendorFuel service
   * @param {Object} Utils      VendorFuel service
   */

  function TutorialController($rootScope, $state, $window, Admin, Localized, Utils) {
    var _this = this;

    var vm = this;
    vm.goToState = goToState;
    vm.toggle = toggle;
    /**
     * Initialization
     */

    this.$onInit = function () {
      _this.breadcrumbs = [{
        name: 'Tutorial',
        state: null
      }];
      vm.isAuthed = Admin.Authed(); // @ts-ignore

      vm.isShowingTutorial = $window.localStorage.getItem('showTutorial') === true || $window.localStorage.getItem('showTutorial') === 'true' ? true : false;
      vm.isHidingTutorial = !vm.isShowingTutorial;

      if (!Admin.Authed()) {
        if (Localized.api_key) {
          Utils.setLocation('/login', true);
        } else {
          Utils.setLocation('/subscribe', true);
        }
      }
    };
    /**
     * @param {string} stateName State name
     * @param {number} tabIndex  Index
     * @param {Object} event     Click event
     */


    function goToState(stateName, tabIndex, event) {
      event.preventDefault();
      $window.scrollTo({
        top: 0,
        left: 0,
        behavior: 'smooth'
      });
      $state.go(stateName, {
        activeTab: tabIndex
      });
    }
    /**
     * @param {string} key Key
     */


    function toggle(key) {
      // @ts-ignore
      var value = $window.localStorage.getItem(key) === true || $window.localStorage.getItem(key) === 'true' ? true : false; // @ts-ignore

      $window.localStorage.setItem(key, !value);
    }
  }
})();

/***/ }),

/***/ 2588:
/***/ (() => {

/**
 * VF Check Auth component
 *
 * @namespace Components
 */
(function () {
  'use strict';

  AuthController.$inject = ["Admin", "Localized", "Utils"];
  angular.module('vendorfuelApp').component('vfCheckAuth', {
    controller: AuthController // Yes, there's no template for this component.

  });
  AuthController.$inject = ['Admin', 'Localized', 'Utils'];
  /**
   * @param {Object} Admin     VendorFuel service
   * @param {Object} Localized VendorFuel service
   * @param {Object} Utils     VendorFuel service
   */

  function AuthController(Admin, Localized, Utils) {
    /**
     * Initialization
     */
    this.$onInit = function () {
      if (!Admin.Authed()) {
        if (Localized.api_key) {
          Utils.setLocation('/login', true);
        } else {
          Utils.setLocation('/subscribe', true);
        }
      }
    };
  }
})();

/***/ }),

/***/ 6111:
/***/ (() => {

(function () {
  'use strict';

  AdminAccountsController.$inject = ["$scope", "$rootScope", "Admin", "AlertModal", "ConfirmModal", "Settings", "Debug", "Utils", "Localized"];
  angular.module('vendorfuelApp').controller('AdminAccountsController', AdminAccountsController);
  AdminAccountsController.$inject = ['$scope', '$rootScope', 'Admin', 'AlertModal', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} AlertModal   VendorFuel service
   * @param {Object} ConfirmModal VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   */

  function AdminAccountsController($scope, $rootScope, Admin, AlertModal, ConfirmModal, Settings, Debug, Utils, Localized) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Admin Accounts',
        state: 'admin'
      }];
      $scope.activeTab = 0;
      $scope.adminAccountsEndpoint = Localized.apiURL + '/admin/user/';
      $scope.editName = false;
      $scope.isAuthed = Admin.Authed();
      $scope.loading = false;
      $scope.loadingMore = false;
      $scope.newAdmin = {};
      $scope.newAdmin.roles = {};
      $scope.rppValues = [15, 30, 50, 100];
      $scope.saved = false;
      $scope.saving = false;
      $scope.searchParams = {
        page: 1,
        rpp: $scope.rppValues[0]
      };
      $scope.searchTerm = '';
      $scope.selectedAccount = null;
      $scope.showPassword = false;
      $scope.showPasswordConf = false;

      if ($scope.activeTab === null) {
        $scope.activeTab = 0;
      }
    };

    this.init(); //FUNCTIONS

    $scope.LoginCallback = function () {
      $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
    };
    /**
     * Handles tab initialization
     *
     * @param {number} i Index
     */


    $scope.TabChanged = function (i) {
      $scope.activeTab = i;
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      $scope.cancelled = false;
      var req = {
        method: 'GET',
        url: $scope.adminAccountsEndpoint
      };

      switch (i) {
        case 0:
          //First tab selected
          req.params = $scope.searchParams;
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.adminAccounts = resp.admin_users;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          $scope.loading = false;
          break;

        case 2:
          $scope.loading = false;
          break;
      }
    };
    /**
     * Changes a tab
     *
     * @param {number} tabIndex     - The index of the tab to change to
     * @param {number} accountIndex - The index of the selected admin account to load
     */


    $scope.ChangeTab = function (tabIndex, accountIndex) {
      $scope.activeTab = tabIndex;
      $scope.selectedAccount = $scope.adminAccounts.data[accountIndex];

      if (!$scope.selectedAccount.deleted_at) {
        $scope.selectedAccount.active = true;
      } else {
        $scope.selectedAccount.active = false;
      }

      if ($scope.selectedAccount.receive_quotes === 1) {
        $scope.selectedAccount.receive_quotes = true;
      }

      var roles = $scope.selectedAccount.roles;
      $scope.selectedAccount.roles = [];
      angular.forEach(roles, function (role) {
        $scope.selectedAccount.roles[role.slug] = true;
      });
    };
    /**
     * Add new admin user
     */


    $scope.AddUser = function () {
      $scope.saving = true;
      var params = {
        name: $scope.newAdmin.name,
        email: $scope.newAdmin.email,
        password: $scope.newAdmin.password,
        password_confirmation: $scope.newAdmin.confPassword,
        receive_quotes: $scope.newAdmin.receive_quotes
      };

      if ($scope.newAdmin.active === true) {
        params.active = 1;
      } else {
        params.active = 0;
      }

      params.roles = [];
      Object.keys($scope.newAdmin.roles).forEach(function (slug) {
        if ($scope.newAdmin.roles[slug]) {
          params.roles.push(slug);
        }
      });
      var req = {
        method: 'POST',
        url: $scope.adminAccountsEndpoint,
        data: params
      };
      Utils.getHttpPromise(req).then(function (resp) {
        Debug.log(resp);
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
        $scope.saving = false;
        $scope.ChangeTab(0);
      });
    };
    /**
     * Updates Admin User
     */


    $scope.UpdateUser = function () {
      $scope.saving = true;
      var params = {};

      if ($scope.selectedAccount.active === true) {
        params.active = 1;
      } else {
        params.active = 0;
      }

      params.password = $scope.selectedAccount.new_password;
      params.password_confirmation = $scope.selectedAccount.passwordCheck;
      params.email = $scope.selectedAccount.email;
      params.name = $scope.selectedAccount.name;
      params.user_id = $scope.selectedAccount.id;
      params.receive_quotes = $scope.selectedAccount.receive_quotes;
      params.roles = [];
      Object.keys($scope.selectedAccount.roles).forEach(function (slug) {
        if ($scope.selectedAccount.roles[slug]) {
          params.roles.push(slug);
        }
      });
      var req = {
        method: 'PUT',
        url: $scope.adminAccountsEndpoint + $scope.selectedAccount.id,
        data: params
      };
      Utils.getHttpPromise(req).then(function () {
        angular.noop();
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
        $scope.saving = false;
      });
    };

    this.searchAccounts = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: $scope.adminAccountsEndpoint,
        params: $scope.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.adminAccounts = resp.admin_users;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    this.setPage = function (page) {
      $scope.searchParams.page = page;

      _this.searchAccounts();
    };

    this.setRpp = function (rpp) {
      $scope.searchParams.rpp = rpp;

      _this.searchAccounts();
    };

    this.setQuery = function (query) {
      $scope.searchParams.page = 1; // Reset page when query changes.

      $scope.searchParams.q = query;
      $scope.searchTerm = $scope.searchParams.q;

      _this.searchAccounts();
    };
    /**
     * Genereate a REST Api token for selected Admin
     */


    $scope.GenerateRESTAccess = function () {
      var req = {
        method: 'GET',
        url: $scope.adminAccountsEndpoint + 'rest/generate/' + $scope.selectedAccount.id
      };
      var callback = {
        confirm: function confirm() {
          angular.noop();
        }
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          AlertModal.Show(callback, resp.notifications[0], resp.rest_api_key, 'Close');
          $scope.selectedAccount.rest_api_user = resp.rest_api_user;
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        angular.noop();
      });
    };
    /**
     * Revoke the REST Api token for selected Admin
     */


    $scope.RevokeRESTAccess = function () {
      ConfirmModal.Show({
        confirm: function confirm() {
          var req = {
            method: 'GET',
            url: $scope.adminAccountsEndpoint + 'rest/revoke/' + $scope.selectedAccount.id
          };
          Utils.getHttpPromise(req).then(function (resp) {
            if (!resp.errors.length) {
              $scope.selectedAccount.rest_api_user = null;
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            angular.noop();
          });
        },
        cancel: function cancel() {
          angular.noop();
        }
      }, 'Revoke REST API Key/User?', 'This will immediately revoke the current REST API Key/User in use.', 'No', 'Yes');
    };
    /**
     * Toggles showing password characters
     *
     * @param {number} type - The type of password box to toggle
     */


    $scope.ToggleShowPassword = function (type) {
      if (type === 'password') {
        $scope.showPassword = !$scope.showPassword;
      }

      if (type === 'conf') {
        $scope.showPasswordConf = !$scope.showPasswordConf;
      }
    };
  }
})();

/***/ }),

/***/ 154:
/***/ (() => {

(function () {
  'use strict';

  BillingResetPasswordController.$inject = ["$scope", "Admin", "Localized", "Utils", "$location", "$stateParams", "Debug"];
  angular.module('vendorfuelApp').controller('BillingResetPasswordController', BillingResetPasswordController);
  BillingResetPasswordController.$inject = ['$scope', 'Admin', 'Localized', 'Utils', '$location', '$stateParams', 'Debug'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} $location    Angular service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Debug        VendorFuel service
   */

  function BillingResetPasswordController($scope, Admin, Localized, Utils, $location, $stateParams, Debug) {
    /**
     * Initialization
     */
    this.init = function () {
      Admin.login_errors = {};
      Utils.redirecting = false;
      $scope.isAuthed = Admin.Authed();
      $scope.password = '';
      $scope.password_confirmation = '';
      $scope.requesting = false;
      $scope.resetEmail = null;
      $scope.showPassword = false;
      $scope.showPasswordConfirmation = false;

      if ($stateParams.code && $stateParams.auth) {
        $scope.reseting = true;
      }
    };

    this.init();

    $scope.trimExtraSp = function (str) {
      return str.replace(/\s+/g, '');
    };

    $scope.ToggleShowPassword = function () {
      $scope.showPassword = !$scope.showPassword;
    };

    $scope.ToggleShowPasswordConfirmation = function () {
      $scope.showPasswordConfirmation = !$scope.showPasswordConfirmation;
    };

    $scope.requestReset = function () {
      Admin.login_errors = {};
      $scope.requesting = true;
      var req = {
        method: 'POST',
        url: Localized.apiURL + '/tenant/password/request',
        data: {
          email: $scope.resetEmail,
          url: $location.absUrl()
        }
      };
      Utils.getHttpPromise(req).then(function () {
        $scope.requested = true;
        $scope.requesting = false;
      }, function () {})["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.submitReset = function () {
      Admin.login_errors = {};
      $scope.submitting = true;
      var req = {
        method: 'POST',
        url: Localized.apiURL + '/tenant/password/reset',
        data: {
          code: $stateParams.code,
          auth: $stateParams.auth,
          password: $scope.password,
          password_confirmation: $scope.password_confirmation
        }
      };
      Utils.getHttpPromise(req).then(function (resp) {
        Admin.SetTokens(resp.name, resp.tokena, resp.tokenb, false, resp.token);
        Utils.setLocation('/dashboard');
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.submitting = false;
      });
    };
  }
})();

/***/ }),

/***/ 8464:
/***/ (() => {

(function () {
  'use strict';

  BillingController.$inject = ["$scope", "$rootScope", "$state", "$stateParams", "Admin", "Tenant", "ConfirmModal", "Settings", "Debug", "Utils", "Localized"];
  angular.module('vendorfuelApp').controller('BillingController', BillingController);
  BillingController.$inject = ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'Tenant', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $state       UI Router service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Tenant       VendorFuel service
   * @param {Object} ConfirmModal VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   */

  function BillingController($scope, $rootScope, $state, $stateParams, Admin, Tenant, ConfirmModal, Settings, Debug, Utils, Localized) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      _this.breadcrumbs = [{
        name: 'VendorFuel Subscription',
        state: 'billing'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab);
      $scope.isAuthed = Admin.Authed();
      $scope.loading = true;
      $scope.loadedWallet = false;
      $scope.loadingWallet = false;
      $scope.localized = Localized;
      $scope.saved = false;
      $scope.saving = false;
      $scope.settings = Settings;
      $scope.tenant = Tenant;
      $scope.walletUrl = null;
      $scope.utils = Utils;

      if ($stateParams.id) {
        updateBilling($stateParams.id);
      }

      loadBillingSettings();
      window.addEventListener('message', function (event) {
        if (event.origin === 'https://api.vendorfuel.com' || event.origin === 'https://dev.vendorfuel.com') {
          var timer = setInterval(function () {
            clearInterval(timer);
            $scope.walletUrl = null;
            loadBillingSettings();
          }, 3000);
        }
      }, false);
    };

    this.init();
    /**
     * @param {number} id Billing ID
     */

    function updateBilling(id) {
      Settings.billing.saved.cardId = id;
      delete Settings.billing.saved.card;
      var req = {
        method: 'POST',
        url: Localized.apiURL + '/tenant/billing/update',
        data: Settings.billing.saved
      };
      Utils.getHttpPromise(req).then(function (resp) {
        Debug.log(resp);
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    }

    $scope.retrieveWalletUrl = function () {
      if (!$scope.loadingWallet && !$scope.loadedWallet) {
        $scope.loadingWallet = true;
        $scope.loadedWallet = false;
        var req = {
          method: 'GET',
          url: Localized.apiURL + '/tenant/billing/wallet/url',
          params: {
            return_url: Localized.apiURL + '/tenant/PayFabricReturn/'
          }
        };
        Utils.getHttpPromise(req).then(function (resp) {
          $scope.walletUrl = resp.url;
          $scope.loadedWallet = true;
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          $scope.loadingWallet = false;
        });
      }
    }; //FUNCTIONS


    $scope.LoginCallback = function () {
      $scope.loading = true;
      loadBillingSettings();
    };

    $scope.TransitionState = function () {
      $state.go('settings');
    };

    $scope.SubmitUpdate = function (i, form) {
      $scope.UpdateBillingSettings(form);
    };
    /**
     * @param {any} tab Tab
     * @return {Object} Promise
     */


    function getSettings(tab) {
      var promise = tab.Get().then(function successCallback() {
        $scope.loading = false;
      }, function errorCallback() {
        $scope.loading = false;
      });
      return promise;
    }
    /**
     * @param {any}    tab  Tab
     * @param {Object} form Form data
     * @return {Object} Promise
     */


    function updateSettings(tab, form) {
      Settings.errors = {};
      $scope.saving = true;
      $scope.saved = false;
      $scope.cancelled = false;
      var promise = tab.Set().then(function successCallback() {
        $scope.saving = false;
        $scope.saved = Object.keys(Settings.errors).length === 0;
        form.$setPristine();
        form.$setUntouched();
      }, function errorCallback() {
        $scope.saving = false;
      });
      return promise;
    }

    $scope.LoadGatewaysSettings = function () {
      $scope.loading = true;

      if (Admin.Authed()) {
        getSettings(Settings.gateways);
      } else {
        $scope.loading = false;
      }
    };
    /**
     * @param {any} r ?
     */


    function loadBillingSettings(r) {
      if (!r) {
        r = false;
      }

      $scope.loading = true;

      if ($scope.tenant.Authed()) {
        getSettings(Settings.billing);
      } else {
        $scope.loading = false;
      }
    }

    $scope.UpdateGeneralSettings = function (form) {
      if (Settings.general.saved.api_url === '' || Settings.general.saved.api_key === '') {
        Admin.Logout();
      }

      updateSettings(Settings.general, form);
    };

    $scope.UpdateConversionsSettings = function (form) {
      updateSettings(Settings.conversions, form);
    };

    $scope.UpdateImageSettings = function (form) {
      updateSettings(Settings.image, form);
    };

    $scope.UpdateGatewaysSettings = function (form) {
      updateSettings(Settings.gateways, form);
    };

    $scope.UpdateBillingSettings = function (form) {
      updateSettings(Settings.billing, form).then(function () {
        getSettings(Settings.billing);
      });
    };

    $scope.CancelSubscription = function () {
      $scope.saving = true;
      $scope.saved = false;
      $scope.cancelled = false;
      Settings.billing.cancelling = true;
      Settings.billing.Cancel().then(function () {
        getSettings(Settings.billing).then(function () {
          $scope.saving = false;

          if (Settings.billing.saved.status !== 'active') {
            $scope.cancelled = true;
            Settings.billing.cancelling = false;
          }
        });
      });
    };

    $scope.SubscriptionNotcancelled = function () {
      Debug.log('CANCELLATION NOT CONFIRMED!');
    };

    $scope.ConfirmCancelSubscription = function () {
      var callback = {
        confirm: $scope.DoubleCancellation,
        cancel: $scope.SubscriptionNotcancelled
      };
      ConfirmModal.Show(callback, 'Are you sure you want to cancel your subscription?', 'If there is anything we can do to change your mind please let us know.', 'No', 'Yes');
    };

    $scope.DoubleCancellation = function () {
      var callback = {
        confirm: $scope.CancelSubscription,
        cancel: $scope.SubscriptionNotcancelled
      };
      ConfirmModal.Show(callback, 'Are you absolutely sure?', 'We will be sorry to see you go...', 'No', 'Yes');
    };
  }
})();

/***/ }),

/***/ 261:
/***/ (() => {

(function () {
  'use strict';

  CatalogPricesheetsController.$inject = ["$rootScope", "$scope", "$timeout", "$window", "$state", "$stateParams", "Admin", "Debug", "Localized", "PriceSheets", "SearchModal", "Settings", "Utils", "ViewModal"];
  angular.module('vendorfuelApp').controller('CatalogPricesheetsController', CatalogPricesheetsController);
  CatalogPricesheetsController.$inject = ['$rootScope', '$scope', '$timeout', '$window', '$state', '$stateParams', 'Admin', 'Debug', 'Localized', 'PriceSheets', 'SearchModal', 'Settings', 'Utils', 'ViewModal'];
  /**
   * @param {Object} $rootScope   Angular service
   * @param {Object} $scope       Angular service
   * @param {Object} $timeout     Angular service
   * @param {Object} $window      Angular service
   * @param {Object} $state       UI Router service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} PriceSheets  VendorFuel service
   * @param {Object} SearchModal  VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} ViewModal    VendorFuel service
   */

  function CatalogPricesheetsController($rootScope, $scope, $timeout, $window, $state, $stateParams, Admin, Debug, Localized, PriceSheets, SearchModal, Settings, Utils, ViewModal) {
    var _this = this;

    var vm = this;
    vm.changeTab = changeTab;
    vm.deletePricesheet = deletePricesheet;
    /**
     * Initialization
     */

    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Price Sheets',
        state: 'catalog-pricesheets'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab);
      $scope.addParams = {
        products: []
      };
      $scope.batchEndpoint = Localized.apiURL + '/admin/price-sheet/batch/';
      $scope.batchListOptions = {
        any: 'All',
        pending: 'Pending',
        confirmed: 'Confirmed',
        processing: 'Processing',
        processed: 'Processed'
      };
      $scope.editIndex = -1;
      $scope.editName = false;
      $scope.isAuthed = Admin.Authed();
      $scope.loading = true;
      $scope.loadingMore = false;
      $scope.myFile = {};
      $scope.object = Object;
      $scope.pricesheetEndpoint = Localized.apiURL + '/admin/pricesheets/';
      $scope.productEndpoint = Localized.apiURL + '/admin/products/';
      $scope.productsLoading = false;
      $scope.saved = false;
      $scope.saving = false;
      $scope.selectedPricesheet = null;
      $scope.searchTerm = '';
      $scope.showChanges = false;
      $scope.updatedPricesheetItems = [];
      $scope.uploading = false;
      $scope.rppValues = [15, 30, 50, 100];
      vm.searchOptions = {
        price_sheet_id: 'ID',
        sheet: 'Price Sheet',
        site_id: 'Site ID',
        gp_price_sheet: 'GP Price Sheet'
      };
      $scope.searchParams = {
        rpp: $scope.rppValues[0] // Must be defined after rppValues is declared.

      };
      $scope.sortBatchParams = {
        sort_by: 'batch_id',
        sort_type: '',
        status: 'any'
      };
      vm.allPrShSearchParams = {
        page: 1,
        q: '',
        searchBy: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0] // Must be defined after rppValues is declared.

      };
      vm.sortAscending = true; //If the view tab is selected, redirect to the search page since selected product is null

      if ($scope.activeTab === 2 || $scope.activeTab === 5) {
        $scope.activeTab = 0;
        $scope.TransitionState();
      }
    };

    this.init(); //FUNCTIONS

    $scope.LoginCallback = function () {
      $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
    };

    $scope.SearchResults = function (resp) {
      //callback that is used by the search modal
      if ($scope.activeTab === 1) {
        if ($scope.addParams.products) {
          resp.forEach(function (product) {
            $scope.addParams.products.push(product); // eslint-disable-next-line no-shadow

            var currentIds = $scope.addParams.products.map(function (product) {
              return product.value.product_id;
            });

            if (currentIds.includes(product.value.product_id)) {
              $scope.addParams.products[$scope.addParams.products.length - 1].price = product.value.price;
            }
          });
        } else {
          $scope.addParams.products = [];
        }
      } else if ($scope.activeTab === 2) {
        var currentIds = $scope.updatedPricesheetItems.map(function (item) {
          return item.value.product_id;
        });
        $scope.updatedPricesheetItems = [];
        resp.forEach(function (item) {
          var included = currentIds.includes(item.value.product_id);

          if (item.action === 'add') {
            $scope.updatedPricesheetItems.push({
              action: 'add',
              value: {
                product_id: item.value.product_id,
                sku: item.value.sku,
                price: included ? item.value.price : 0.00,
                product: included ? item.value.product : item.value
              }
            });
          } else if (item.action === 'remove') {
            $scope.updatedPricesheetItems.push(item);
          }
        });
      } else if ($scope.activeTab === 3) {
        $scope.uploadPricesheetId = resp[0].value.price_sheet_id;
        $scope.uploadPricesheetName = resp[0].value.sheet;
      }
    };

    $scope.AddPricesheet = function (id) {
      // If id is null, we are adding new price sheet
      $scope.loading = true;
      var updateParams = {
        products: []
      };
      var isMissingNameOrProducts = false;
      var req = {}; // Update price sheet

      if (id) {
        updateParams.sheet = $scope.selectedPricesheet.sheet;
        updateParams.default_price_sheet = $scope.selectedPricesheet.default_price_sheet;
        updateParams.site_id = $scope.selectedPricesheet.site_id;
        updateParams.gp_price_sheet = $scope.selectedPricesheet.gp_price_sheet;

        for (var i = 0; i < $scope.updatedPricesheetItems.length; i++) {
          if ($scope.updatedPricesheetItems[i].value.price.includes('$')) {
            $scope.updatedPricesheetItems[i].value.price = $scope.updatedPricesheetItems[i].value.price.slice(1, $scope.updatedPricesheetItems[i].value.price.length);
          }

          updateParams.products.push({
            product_id: $scope.updatedPricesheetItems[i].value.product_id,
            sku: $scope.updatedPricesheetItems[i].value.sku,
            price: $scope.updatedPricesheetItems[i].action === 'remove' ? 0.00 : $scope.updatedPricesheetItems[i].value.price // 'gsa', 'ability_one', 'core_list'

          });
        }

        req = {
          method: 'PUT',
          url: $scope.pricesheetEndpoint + id,
          data: updateParams
        }; // Add new price sheet
      } else if ($scope.addParams.name && $scope.addParams.products) {
        updateParams.sheet = $scope.addParams.name;
        updateParams.default_price_sheet = $scope.addParams.default_price_sheet || false;
        updateParams.site_id = $scope.addParams.site_id;
        updateParams.gp_price_sheet = $scope.addParams.gp_price_sheet;

        for (var j = 0; j < $scope.addParams.products.length; j++) {
          if ($scope.addParams.products[j].value.price) {
            if ($scope.addParams.products[j].value.price.includes('$')) {
              $scope.addParams.products[j].value.price = $scope.addParams.products[j].value.price.slice(0, $scope.addParams.products[j].value.price.length);
            }

            updateParams.products.push({
              product_id: $scope.addParams.products[j].value.product_id,
              sku: $scope.addParams.products[j].value.sku,
              price: $scope.addParams.products[j].value.price // 'gsa', 'ability_one', 'core_list'

            });
          }
        }

        req = {
          method: 'POST',
          url: $scope.pricesheetEndpoint,
          data: updateParams
        };
      } else {
        isMissingNameOrProducts = true;
      }

      if (!isMissingNameOrProducts) {
        Utils.getHttpPromise(req).then(function (resp) {
          if (!resp.errors.length) {
            if (!id) {
              $scope.selectedPricesheet = {
                price_sheet_id: resp.price_sheet_id,
                sheet: req.data.sheet
              };
              $scope.addParams = {};
              $scope.activeTab = 2;
            } else {
              $scope.TabChanged(2);
              $scope.updatedPricesheetItems = [];
              $scope.showChanges = false;
            }
          }
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          $scope.loading = false;
        });
      } else {
        $scope.loading = false;
      }

      $scope.editName = false;
    };

    $scope.ChangeBatchTab = function (tabIndex, batchIndex) {
      $scope.activeTab = tabIndex;
      $scope.selectedBatch = $scope.batches[batchIndex];
    };

    $scope.ChangeEdit = function () {
      $scope.editName = !$scope.editName;
    };
    /**
     * @param {number} tabIndex        Tab index
     * @param {number} pricesheetIndex Price sheet index
     */


    function changeTab(tabIndex, pricesheetIndex) {
      vm.isConfirmingDeletion = false;
      $scope.activeTab = tabIndex;
      $scope.selectedPricesheet = $scope.pricesheets.data[pricesheetIndex];
    }

    $scope.ConfirmBatch = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: $scope.batchEndpoint + 'confirm',
        data: {
          batch_id: $scope.selectedBatch.batch_id
        }
      };
      Utils.getHttpPromise(req).then(function () {
        $scope.selectedBatch = null;
        $scope.activeTab = 4;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };
    /**
     * @param {number} id Price sheet ID
     */


    function deletePricesheet(id) {
      vm.isDeleting = true;
      PriceSheets.deletePriceSheet(id).then(function () {
        vm.isDeleting = false;
        vm.isConfirmingDeletion = false;
        $scope.activeTab = 0;
        $scope.selectedPricesheet = null;
      });
    }

    $scope.editParams = function (pricesheetItem) {
      for (var i = 0; i < $scope.updatedPricesheetItems.length; i++) {
        if ($scope.updatedPricesheetItems[i].value.product_id === pricesheetItem.product_id) {
          if ($scope.updatedPricesheetItems[i].action === 'remove') {
            return;
          }

          $scope.updatedPricesheetItems[i].value.price = pricesheetItem.price;
          return;
        }
      }

      $scope.updatedPricesheetItems.push({
        action: 'edited',
        value: pricesheetItem
      });
    };

    $scope.EditPrice = function (index) {
      $scope.editIndex = index;
    };

    $scope.RemoveUploadFile = function () {
      $scope.pricesheetUpload = null;
      Localized.setNotification({
        type: 'danger',
        message: 'File Successfully Removed'
      });
    };

    $scope.SearchCancelled = function () {//callback that is used by the search modal
    };

    $scope.SearchPricesheet = function (page) {
      $scope.productsLoading = true;
      $scope.searchParams.page = page || 1;
      var req = {
        method: 'GET',
        url: $scope.pricesheetEndpoint + $scope.selectedPricesheet.price_sheet_id,
        params: $scope.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.selectedPricesheet = resp.pricesheet;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.productsLoading = false;
      });
    };

    this.searchPricesheets = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: $scope.pricesheetEndpoint,
        params: vm.allPrShSearchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.pricesheets = resp.pricesheets;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    this.setPage = function (page) {
      _this.allPrShSearchParams.page = page;

      _this.searchPricesheets();
    };

    this.setRpp = function (rpp) {
      _this.allPrShSearchParams.rpp = rpp;

      _this.searchPricesheets();
    };

    this.setQuery = function (query, searchBy) {
      _this.allPrShSearchParams.page = 1; // Reset page when query changes.

      _this.allPrShSearchParams.q = query;
      _this.allPrShSearchParams.searchBy = searchBy;
      $scope.searchTerm = _this.allPrShSearchParams.q;
      $scope.searchedBy = _this.allPrShSearchParams.searchBy;

      _this.searchPricesheets();
    };

    $scope.SetDefault = function () {
      if ($scope.activeTab === 2) {
        $scope.selectedPricesheet.default_price_sheet = true;
      }

      if ($scope.activeTab === 1) {
        $scope.addParams.default_price_sheet = true;
      }
    };

    $scope.setFile = function (element) {
      // eslint-disable-next-line no-shadow
      $scope.$apply(function ($scope) {
        $scope.theFile = element.files[0];
      });
      var totalBytes = $scope.theFile.size;

      if (totalBytes < 1000000) {
        $scope.fileSize = Math.floor(totalBytes / 1000) + 'KB';
      } else {
        $scope.fileSize = Math.floor(totalBytes / 1000000) + 'MB';
      }

      var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

      if (regex.test($scope.theFile.name.toLowerCase())) {
        if (typeof FileReader !== 'undefined') {
          var reader = new FileReader();

          reader.onload = function () {
            // eslint-disable-next-line no-undef
            Papa.parse(reader.result, {
              complete: function complete(results) {
                var products = [];

                var _loop = function _loop(i) {
                  var info = results.data[i];
                  var product = [];
                  angular.forEach(info, function (val, key) {
                    product[key] = val;
                  });
                  products.push(product);
                };

                for (var i = 0; i <= results.data.length; i++) {
                  _loop(i);
                } // eslint-disable-next-line no-shadow


                $scope.$apply(function ($scope) {
                  $scope.pricesheetUpload = products;
                  $scope.IsVisible = true;
                });
              }
            });
            $scope.setUploading();
          };

          reader.readAsText($scope.theFile);
        } else {
          $window.alert('This browser does not support HTML5.');
        }
      } else {
        $scope.pricesheetUpload = null;
        $scope.theFile = null;
        $scope.setUploading();
        $window.alert('Please upload a valid CSV file.');
      }
    };

    $scope.setUploading = function () {
      // eslint-disable-next-line no-shadow
      $scope.$apply(function ($scope) {
        $scope.uploading = !$scope.uploading;
      });
    };

    $scope.ShowChanges = function () {
      $scope.showChanges = !$scope.showChanges;
    };

    $scope.SortBatchIndex = function (sortBy) {
      vm.sortAscending = $scope.sortBatchParams.sort_by === sortBy ? !vm.sortAscending : true;
      $scope.sortBatchParams.sort_by = sortBy;
      $scope.sortBatchParams.sort_type = vm.sortAscending ? 'asc' : 'desc';
      $scope.SortBatches();
    };

    $scope.SortBatches = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: $scope.batchEndpoint,
        params: $scope.sortBatchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.batches = resp.search_results;

        for (var i = 0; i < $scope.batches.length; i++) {
          if ($scope.batches[i].status === 'processing') {
            $scope.UpdateBatchProgress();
            break;
          }
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    this.changeSortBy = function (sortBy, e) {
      e.preventDefault();
      vm.sortAscending = vm.allPrShSearchParams.sortBy === sortBy ? !vm.sortAscending : true;
      vm.allPrShSearchParams.sortBy = sortBy;
      vm.allPrShSearchParams.sortType = vm.sortAscending ? 'asc' : 'desc';

      _this.searchPricesheets();
    };

    $scope.TabChanged = function (i) {
      $scope.activeTab = i;
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      $scope.cancelled = false;
      var req = {
        method: 'GET',
        url: $scope.pricesheetEndpoint
      }; // use the switch below to call any functions needed for each tab. i.e. api calls, funcitonality, etc.

      switch (i) {
        case 0:
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.pricesheets = resp.pricesheets;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          $scope.loading = false;
          break;

        case 2:
          req.url += $scope.selectedPricesheet.price_sheet_id;
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.selectedPricesheet = resp.pricesheet;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 3:
          $scope.loading = false;
          break;

        case 4:
          req = {
            method: 'GET',
            url: $scope.batchEndpoint,
            params: $scope.sortBatchParams
          };
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.batches = resp.search_results; // eslint-disable-next-line no-shadow

            for (var _i = 0; _i < $scope.batches.length; _i++) {
              if ($scope.batches[_i].status === 'processing') {
                $scope.UpdateBatchProgress();
                break;
              }
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 5:
          req = {
            method: 'GET',
            url: $scope.batchEndpoint + 'view',
            params: {
              batch_id: $scope.selectedBatch.batch_id
            }
          };
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.selectedBatch = resp.batches[0];
            $scope.batchHeaders = resp.batches[0].columns;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;
      }
    };

    $scope.TransitionState = function () {
      $state.go('catalog-pricesheets', {
        activeTab: $scope.activeTab
      });
    };

    $scope.OpenSearchModalAdd = function () {
      var callback = {};
      var config = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.productEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Status: '],
          id: 'product_id',
          selectOne: false
        }],
        updatedItems: $scope.addParams.products
      };
      callback = {
        confirm: $scope.SearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, $scope.addParams.name || 'New Price Sheet', config, 'Add items');
    };

    $scope.OpenSearchModalUpdate = function () {
      var callback = {};
      var config = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.productEndpoint,
            params: {
              q: '',
              excludedField: 'price_sheet_id',
              excludedId: $scope.selectedPricesheet.price_sheet_id,
              excludedTable: 'price_sheets'
            }
          },
          relationships: ['products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Status: '],
          id: 'product_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: $scope.pricesheetEndpoint + $scope.selectedPricesheet.price_sheet_id,
            params: {
              q: ''
            }
          },
          relationships: ['pricesheet', 'pricesheetItems', 'product'],
          fields: ['sku', 'image', 'description', 'price'],
          fieldPrefixes: ['', '', '', 'Price: '],
          id: 'product_id'
        }],
        updatedItems: $scope.updatedPricesheetItems
      };
      callback = {
        confirm: $scope.SearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, $scope.selectedPricesheet.sheet, config, 'Add items');
    };

    $scope.OpenSearchModalPricesheet = function () {
      var callback = {};
      var config = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.pricesheetEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['pricesheets'],
          fields: ['price_sheet_id', 'sheet'],
          fieldPrefixes: ['ID: ', ''],
          id: 'price_sheet_id',
          selectOne: true
        }]
      };
      callback = {
        confirm: $scope.SearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Select Price Sheet', config, 'Add Price Sheet');
    };

    $scope.OpenViewModal = function (product) {
      $scope.callback = {};
      var callback = {
        confirm: function confirm() {
          $scope.TabChanged(3);
        },
        cancel: $scope.SearchCancelled
      };
      ViewModal.Show(callback, 'Quick View: ' + product.sku, product);
    };

    $scope.postUpload = function (index, id) {
      $scope.selectedBatch = {
        batch_id: id
      };
      $scope.activeTab = index;
    };

    $scope.UploadPricesheet = function () {
      $scope.loading = true;
      var fd = new FormData();
      fd.append('file', $scope.theFile);
      fd.append('price_sheet_id', $scope.uploadPricesheetId);
      var req = {
        method: 'POST',
        url: $scope.batchEndpoint + 'upload',
        data: fd,
        transformRequest: angular.identity,
        headers: {
          // eslint-disable-next-line no-undefined
          'Content-Type': undefined
        }
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (resp.errors.length === 0) {
          $scope.postUpload(5, resp.batch_id);
          Localized.setNotification({
            type: 'success',
            message: 'File Successfully Uploaded'
          });
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.UpdateBatchProgress = function () {
      var req = {
        method: 'GET',
        url: $scope.batchEndpoint,
        params: $scope.sortBatchParams
      };
      var again = false;
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.batches = resp.search_results;

        for (var i = 0; i < $scope.batches.length; i++) {
          if ($scope.batches[i].status === 'processing' && $scope.activeTab === 4) {
            again = true;
            break;
          }
        }

        if (again) {
          $timeout(function () {
            $scope.UpdateBatchProgress();
          }, 5000);
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        angular.noop();
      });
    };
  }
})();

/***/ }),

/***/ 6679:
/***/ (() => {

(function () {
  'use strict';

  CatalogPromoCodesController.$inject = ["$scope", "$rootScope", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized", "SearchModal", "PromoCodesService"];
  angular.module('vendorfuelApp').controller('CatalogPromoCodesController', CatalogPromoCodesController);
  CatalogPromoCodesController.$inject = ['$scope', '$rootScope', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', 'PromoCodesService'];
  /**
   * @param {Object} $scope            Angular service
   * @param {Object} $rootScope        Angular service
   * @param {Object} $stateParams      UI Router service
   * @param {Object} Admin             VendorFuel service
   * @param {Object} Settings          VendorFuel service
   * @param {Object} Debug             VendorFuel service
   * @param {Object} Utils             VendorFuel service
   * @param {Object} Localized         VendorFuel service
   * @param {Object} SearchModal       VendorFuel service
   * @param {Object} PromoCodesService service
   */

  function CatalogPromoCodesController($scope, $rootScope, $stateParams, Admin, Settings, Debug, Utils, Localized, SearchModal, PromoCodesService) {
    var _this = this;

    var vm = this;

    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Promo Codes',
        state: 'catalog-promocodes'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab);
      $scope.addParams = {
        auto_add: false,
        require_all_items: false,
        products: {
          data: []
        }
      };
      $scope.customerEndpoint = Localized.apiURL + '/admin/customers/';
      $scope.discountTypes = {
        percentage: 'Percentage',
        discount: 'Discount' // 'price': 'Price'

      };
      $scope.addParams.discount_type = $scope.discountTypes.percentage; // Must be defined after discountTypes declared;

      $scope.isAuthed = Admin.Authed();
      $scope.loading = false;
      $scope.loadingMore = false;
      $scope.object = Object;
      $scope.productEndpoint = Localized.apiURL + '/admin/products/';
      $scope.promocodeEndpoint = Localized.apiURL + '/admin/promo-codes/';
      $scope.rppValues = [15, 30, 50, 100];
      $scope.per_page = $scope.rppValues[0]; // Must be defined after rppValues is declared.

      $scope.promoCode = {};
      $scope.promoCodes = [];
      $scope.saved = false;
      $scope.saving = false;
      $scope.searchProductParams = {
        q: '',
        rpp: $scope.rppValues[0],
        // Must be defined after rppValues is declared.
        searchFields: ['sku', 'description', 'product_id']
      };
      $scope.searchTerm = '';
      $scope.selectedPromocode = null;
      $scope.showChanges = false;
      $scope.updatedProducts = [];
      $scope.addedProducts = [];
      vm.searchParams = {
        page: 1,
        q: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0] // Must be defined after rppValues is declared.

      };
      vm.sortAscending = true; //If the view tab is selected, redirect to the search page since selected product is null

      if ($scope.activeTab === 2) {
        $scope.activeTab = 0;
      }
    };

    this.init(); //FUNCTIONS

    $scope.LoginCallback = function () {
      $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
    };

    $scope.TabChanged = function (i) {
      $scope.activeTab = i; // Settings.errors = {};

      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      $scope.cancelled = false;
      var req = {
        method: 'GET',
        url: $scope.promocodeEndpoint
      };

      switch (i) {
        case 0:
          PromoCodesService.query().then(function (response) {
            $scope.promoCodes = response.promoCodes;
            $scope.loading = false;
          });
          break;

        case 1:
          $scope.loading = false;
          break;

        case 2:
          req.url += $scope.selectedPromocode.promo_code_id;
          req.params = $scope.searchProductParams;
          PromoCodesService.get($scope.selectedPromocode.promo_code_id).then(function (response) {
            $scope.selectedPromocode = response.promoCode;
            $scope.selectedPromocode.auto_add = $scope.selectedPromocode.auto_add ? true : false;
            $scope.selectedPromocode.date_effective = $scope.selectedPromocode.date_effective ? new Date($scope.selectedPromocode.date_effective) : null;
            $scope.selectedPromocode.date_expires = $scope.selectedPromocode.date_expires ? new Date($scope.selectedPromocode.date_expires) : null;
            $scope.selectedPromocode.require_all_items = $scope.selectedPromocode.require_all_items ? true : false;
            $scope.selectedPromocode.customerName = response.promoCode.customer ? response.promoCode.customer.name : '';
            $scope.loading = false;
          });
          break;
      }
    };

    $scope.AddPromoCode = function () {
      $scope.loading = true;

      if ($scope.addedProducts.length) {
        $scope.addParams.products = $scope.addedProducts.map(function (product) {
          return {
            product_id: product.product_id
          };
        });
      }

      var data = $scope.addParams;
      PromoCodesService.save(data).then(function (response) {
        if (!response.errors.length && response.promoCode.promo_code_id) {
          $scope.selectedPromocode = {
            promo_code_id: response.promo_code_id
          };
          $scope.activeTab = 2;
          $scope.addParams = {
            auto_add: false,
            require_all_items: false,
            products: {
              data: []
            },
            discount_type: $scope.discountTypes.percentage
          };
          $scope.addedProducts = [];
        }

        $scope.loading = false;
      });
    };

    $scope.ChangeTab = function (tabIndex, promocodeIndex) {
      $scope.activeTab = tabIndex;
      $scope.selectedPromocode = $scope.promoCodes.data[promocodeIndex];
    };

    $scope.CustomerSearchResults = function (resp) {
      //callback that is used by the search modal
      if (resp.length) {
        if ($scope.activeTab === 1) {
          $scope.addParams.customer_id = resp[0].value.id;
          $scope.addParams.customerName = resp[0].value.name;
          $scope.addParams.email = resp[0].value.email;
        } else {
          $scope.selectedPromocode.customer_id = resp[0].value.id;
          $scope.selectedPromocode.customerName = resp[0].value.name;
          $scope.selectedPromocode.email = resp[0].value.email;
        }
      }
    };

    this.deletePromoCode = function () {
      _this.isDeleting = true;
      var id = $scope.selectedPromocode.promo_code_id;
      PromoCodesService["delete"](id).then(function () {
        _this.isDeleting = false;
        $scope.activeTab = 0;
        $scope.selectedPromocode = null;
      });
    };

    $scope.OpenAddSearchModal = function (type) {
      var callback = {};
      var data = {};

      if (type === 'customer') {
        data = {
          tabs: [{
            http: {
              method: 'GET',
              url: $scope.customerEndpoint,
              params: {
                q: ''
              }
            },
            relationships: ['customers'],
            fields: ['id', 'name', 'email', 'status'],
            fieldPrefixes: ['ID: ', 'Name: ', 'Email: ', 'Status: '],
            id: 'id',
            selectOne: true
          }]
        };
        callback.confirm = $scope.CustomerSearchResults;
      } else if (type === 'product') {
        data = {
          tabs: [{
            http: {
              method: 'GET',
              url: $scope.productEndpoint,
              params: {
                q: ''
              }
            },
            relationships: ['products'],
            fields: ['sku', 'image', 'description', 'status'],
            fieldPrefixes: ['', '', '', 'Status: '],
            id: 'product_id',
            selectOne: false
          }]
        };
        callback.confirm = $scope.ProductSearchResults;
      }

      callback.cancel = function () {
        angular.noop();
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig


      SearchModal.Show(callback, $scope.addParams.code || 'New Promo Code', data, 'Add Customer');
    };

    $scope.OpenUpdateSearchModal = function (type) {
      var callback = {};
      var data = {};

      if (type === 'customer') {
        data = {
          tabs: [{
            http: {
              method: 'GET',
              url: $scope.customerEndpoint,
              params: {
                q: ''
              }
            },
            relationships: ['customers'],
            fields: ['id', 'name', 'email', 'status'],
            fieldPrefixes: ['ID: ', 'Name: ', 'Email: ', 'Status: '],
            id: 'id',
            selectOne: true
          }]
        };
        callback.confirm = $scope.CustomerSearchResults;
      } else if (type === 'product') {
        data = {
          tabs: [{
            http: {
              method: 'GET',
              url: $scope.productEndpoint,
              params: {
                q: ''
              }
            },
            relationships: ['products'],
            fields: ['sku', 'image', 'description', 'status'],
            fieldPrefixes: ['', '', '', 'Status: '],
            id: 'product_id',
            selectOne: false
          }, {
            http: {
              method: 'GET',
              url: $scope.promocodeEndpoint + $scope.selectedPromocode.promo_code_id,
              params: {
                q: ''
              }
            },
            relationships: ['promoCode', 'products'],
            fields: ['sku', 'image', 'description', 'status'],
            fieldPrefixes: ['', '', '', 'Status: '],
            id: 'product_id'
          }]
        };
        callback.confirm = $scope.ProductSearchResults;
      }

      callback.cancel = function () {
        angular.noop();
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig


      SearchModal.Show(callback, $scope.selectedPromocode.code, data, 'Add Items');
    };

    $scope.ProductSearchResults = function (resp) {
      if (resp.length) {
        if ($scope.activeTab === 1) {
          if ($scope.addParams.products && $scope.addParams.products.length) {
            var currentIds = $scope.addParams.products.map(function (product) {
              return product.product_id;
            });

            for (var i = 0; i < resp.length; i++) {
              if (!currentIds.includes(resp[i].value.product_id)) {
                $scope.addedProducts.push(resp[i].value);
              }
            }
          } else {
            resp.forEach(function (item) {
              $scope.addedProducts.push(item.value);
            });
          }
        } else {
          resp.forEach(function (item) {
            var currentIds = $scope.selectedPromocode.products.data.map(function (product) {
              return product.product_id;
            });
            var updatedIds = $scope.updatedProducts.map(function (product) {
              return product.product_id;
            });

            if (item.action === 'add' && !currentIds.includes(item.value.product_id)) {
              $scope.updatedProducts.push(item);
            }

            if (item.action === 'remove' && !updatedIds.includes(item.value.product_id)) {
              $scope.updatedProducts.push(item);
            }
          });
        }
      }
    };

    $scope.SearchProducts = function (page) {
      $scope.loadingMore = true;
      $scope.searchTerm = $scope.searchProductParams.q;
      $scope.searchProductParams.page = page || 1;
      var req = {
        method: 'GET',
        url: $scope.promocodeEndpoint + $scope.selectedPromocode.promo_code_id,
        params: $scope.searchProductParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.selectedPromocode.products = resp.products;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    this.searchPromoCodes = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: $scope.promocodeEndpoint,
        params: vm.searchParams
      };
      PromoCodesService.query(_this.searchParams).then(function (response) {
        $scope.promoCodes = response.promoCodes;
        $scope.loadingMore = false;
      });
    };

    this.setPage = function (page) {
      _this.searchParams.page = page;

      _this.searchPromoCodes();
    };

    this.setRpp = function (rpp) {
      _this.searchParams.rpp = rpp;

      _this.searchPromoCodes();
    };

    this.setQuery = function (query) {
      _this.searchParams.page = 1; // Reset page when query changes.

      _this.searchParams.q = query;
      $scope.searchTerm = _this.searchParams.q;

      _this.searchPromoCodes();
    };

    $scope.ShowChanges = function () {
      $scope.showChanges = !$scope.showChanges;
    };

    this.changeSortBy = function (sortBy, e) {
      e.preventDefault();
      vm.sortAscending = vm.searchParams.sortBy === sortBy ? !vm.sortAscending : true;
      vm.searchParams.sortBy = sortBy;
      vm.searchParams.sortType = vm.sortAscending ? 'asc' : 'desc';

      _this.searchPromoCodes(vm.searchParams.page);
    };

    $scope.UpdatePromoCode = function () {
      $scope.loading = true;
      $scope.selectedPromocode.products = [];
      $scope.selectedPromocode.restricted_products = [];
      angular.forEach($scope.updatedProducts, function (value) {
        $scope.selectedPromocode.products.push(value.value.product_id);
      });
      var id = $scope.selectedPromocode.promo_code_id;
      var data = $scope.selectedPromocode;
      PromoCodesService.update(id, data).then(function () {
        // $scope.TabChanged( 2 );
        $scope.loading = false;
      });
    };
  }
})();

/***/ }),

/***/ 9624:
/***/ (() => {

(function () {
  'use strict';

  CatalogUomController.$inject = ["$scope", "$rootScope", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized", "uom"];
  angular.module('vendorfuelApp').controller('CatalogUomController', CatalogUomController);
  CatalogUomController.$inject = ['$scope', '$rootScope', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'uom'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} uom          VendorFuel service
   */

  function CatalogUomController($scope, $rootScope, $stateParams, Admin, Settings, Debug, Utils, Localized, uom) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'UOM',
        state: 'catalog-uom'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab);
      $scope.addParams = {};
      $scope.appData = uom.uomData();
      $scope.filledUom = {};
      $scope.isAuthed = Admin.Authed();
      $scope.loading = false;
      $scope.loadingMore = false;
      $scope.rppValues = [15, 30, 50, 100];
      $scope.saving = false;
      $scope.searchParams = {
        page: 1,
        q: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0] // Must be defined after rrpValues declared.

      };
      $scope.searchTerm = '';
      $scope.selectedUom = null;
      $scope.uom = {};
      $scope.uomCodes = $scope.appData.uomCodes; // Must be defined after appData declared.

      $scope.uomEndpoint = Localized.apiURL + '/admin/product/uom/';
      $scope.uoms = []; //If the view tab is selected, redirect to the search page since selected product is null

      if ($scope.activeTab === 2) {
        $scope.activeTab = 0;
      }
    };

    this.init(); //FUNCTIONS

    $scope.LoginCallback = function () {
      $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
    };

    $scope.TabChanged = function (i) {
      $scope.activeTab = i;
      Settings.errors = {};
      $scope.loading = true;
      var req = {
        method: 'GET',
        url: $scope.uomEndpoint
      };

      switch (i) {
        case 0:
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.uoms = resp.uoms;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          $scope.loading = false;
          break;

        case 2:
          req.url += $scope.selectedUom.uom_id;
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.uom = resp.uom;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;
      }
    };

    $scope.AddUom = function () {
      $scope.saving = true;
      var req = {
        method: 'POST',
        url: $scope.uomEndpoint,
        data: $scope.addParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.addParams = {};

        if (!resp.errors.length) {
          $scope.selectedUom = {
            uom_id: resp.uom_id
          };
          $scope.TabChanged(2);
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.saving = false;
      });
    };

    $scope.ChangeTab = function (tabIndex, uomIndex) {
      $scope.activeTab = tabIndex;
      $scope.selectedUom = $scope.uoms.data[uomIndex];
    }; // eslint-disable-next-line no-shadow


    $scope.FillUom = function (uom) {
      $scope.filledUom = uom;
      $scope.addParams.uom = uom.name;
      $scope.addParams.description = uom.name;
      $scope.addParams.code = uom.val;
    };

    $scope.DeleteUom = function () {
      $scope.saving = true;
      var req = {
        method: 'DELETE',
        url: $scope.uomEndpoint + $scope.uom.uom_id
      };
      Utils.getHttpPromise(req).then(function () {
        $scope.selectedUom = null;
        $scope.TabChanged(0);
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.saving = false;
        Localized.setNotification({
          type: 'success',
          message: 'Uom Successfully Updates'
        });
      });
    };

    $scope.SearchCancelled = function () {//callback that is used by the search modal
    };

    $scope.SearchResults = function (resp) {
      //callback that is used by the search modal
      Debug.log(resp);
    };

    $scope.searchUoms = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: $scope.uomEndpoint,
        params: $scope.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.uoms = resp.uoms;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    this.setPage = function (page) {
      $scope.searchParams.page = page;
      $scope.searchUoms();
    };

    this.setRpp = function (rpp) {
      $scope.searchParams.rpp = rpp;
      $scope.searchUoms();
    };

    this.setQuery = function (query) {
      $scope.searchParams.page = 1; // Reset page when query changes.

      $scope.searchParams.q = query;
      $scope.searchTerm = $scope.searchParams.q;
      $scope.searchUoms();
    };

    $scope.SortIndex = function (sortBy) {
      $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
      $scope.searchParams.sortBy = sortBy;
      $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
      $scope.searchUoms();
    };

    $scope.UpdateUom = function () {
      $scope.saving = true;
      var req = {
        method: 'PUT',
        url: $scope.uomEndpoint + $scope.uom.uom_id,
        data: $scope.uom
      };
      Utils.getHttpPromise(req).then(function () {
        angular.noop();
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.saving = false;
      });
    };
  }
})();

/***/ }),

/***/ 696:
/***/ (() => {

(function () {
  'use strict';

  ContactController.$inject = ["$rootScope", "$scope", "Admin", "$state"];
  angular.module('vendorfuelApp').controller('ContactController', ContactController);
  ContactController.$inject = ['$rootScope', '$scope', 'Admin', '$state'];
  /**
   * @param {Object} $rootScope Angular service
   * @param {Object} $scope     Angular service
   * @param {Object} Admin      VendorFuel service
   * @param {Object} $state     UI Router service
   */

  function ContactController($rootScope, $scope, Admin, $state) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Contact Us',
        state: null
      }];
      $scope.isAuthed = Admin.Authed();
    };

    this.init();

    $scope.goToState = function (stateName, tabIndex) {
      $state.go(stateName, {
        activeTab: tabIndex
      });
    };
  }
})();

/***/ }),

/***/ 6951:
/***/ (() => {

(function () {
  'use strict';

  GroupsController.$inject = ["$scope", "$rootScope", "$state", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized", "SearchModal", "$window", "$timeout"];
  angular.module('vendorfuelApp').controller('GroupsController', GroupsController);
  GroupsController.$inject = ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', '$window', '$timeout'];
  /**
   * @param {Object} $scope       service
   * @param {Object} $rootScope   service
   * @param {Object} $state       service
   * @param {Object} $stateParams service
   * @param {Object} Admin        service
   * @param {Object} Settings     service
   * @param {Object} Debug        service
   * @param {Object} Utils        service
   * @param {Object} Localized    service
   * @param {Object} SearchModal  service
   * @param {Object} $window      service
   * @param {Object} $timeout     service
   */

  function GroupsController($scope, $rootScope, $state, $stateParams, Admin, Settings, Debug, Utils, Localized, SearchModal, $window, $timeout) {
    var _this = this;

    var vm = this;
    vm.deleteGroup = deleteGroup;
    /**
     * Initialization
     */

    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Customers',
        state: 'customers.page'
      }, {
        name: 'Groups',
        state: 'customers-groups'
      }];
      $scope.batchEndpoint = Localized.apiURL + '/admin/group/batch/';
      $scope.batchListOptions = {
        any: 'All',
        pending: 'Pending',
        confirmed: 'Confirmed',
        processing: 'Processing',
        processed: 'Processed'
      };
      $scope.isAuthed = Admin.Authed();
      $scope.loading = false;
      $scope.loadingMore = false;
      $scope.newGroup = {
        customers: {
          data: []
        },
        group_registration_available: 0,
        shipping_mode: 'default'
      };
      $scope.regValues = [{
        key: 1,
        value: 'Active'
      }, {
        key: 0,
        value: 'Inactive'
      }];
      $scope.rppValues = [15, 30, 50, 100];
      $scope.searchTerm = '';
      $scope.shippingModes = {
        "default": 'Default',
        free: 'Free',
        method: 'Flat Rate',
        parcel: 'Parcel'
      };
      $scope.sortBatchParams = {
        sort_by: 'batch_id',
        sort_type: '',
        status: 'any'
      };
      $scope.updatedRates = [];
      $scope.uploading = false;
      vm.activeTab = parseInt($stateParams.activeTab) || 0;
      vm.groupEndpoint = Localized.apiURL + '/admin/groups/';
      vm.searchOptions = {
        group_id: 'ID',
        name: 'Name',
        parent_group_id: 'Parent ID',
        default_price_sheet: 'Default Price Sheet'
      };
      vm.searchParams = {
        page: 1,
        q: '',
        searchBy: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0] // Must be defined after rppValues is declared.

      };
      vm.sortAscending = true;
    };

    this.init(); //FUNCTIONS

    $scope.LoginCallback = function () {
      $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
    };

    $scope.GroupSearchResults = function (resp) {
      //callback that is used by the search modal
      if (vm.activeTab === 2) {
        vm.selectedGroup.parent_group = resp[0].value;
        vm.selectedGroup.parent_group_id = resp[0].value.group_id;
      } else if (vm.activeTab === 1) {
        $scope.newGroup.parent_group = resp[0].value;
        $scope.newGroup.parent_group_id = resp[0].value.group_id;
      }
    };

    $scope.CustomerSearchResults = function (resp) {
      if (vm.activeTab === 2) {
        var currentIds = vm.selectedGroup.customers.data.map(function (c) {
          return c.customer_id;
        });

        for (var i = 0; i < resp.length; i++) {
          if (currentIds.includes(resp[i].value.customer_id) && resp[i].action === 'remove') {
            for (var j = 0; j < vm.selectedGroup.customers.data.length; j++) {
              if (vm.selectedGroup.customers.data[j].customer_id === resp[i].value.customer_id) {
                vm.selectedGroup.customers.data.splice(j, 1);
                break;
              }
            }
          }

          if (!currentIds.includes(resp[i].value.customer_id)) {
            vm.selectedGroup.customers.data.push(resp[i].value);
          }
        }
      } else if (vm.activeTab === 1) {
        if ($scope.newGroup.customers.data && $scope.newGroup.customers.data.length) {
          var customerIds = $scope.newGroup.customers.data.map(function (c) {
            return c.customer_id;
          });

          for (var k = 0; k < resp.length; k++) {
            if (!customerIds.includes(resp[k].value.customer_id)) {
              $scope.newGroup.customers.data.push(resp[k].value);
            }
          }
        } else {
          for (var l = 0; l < resp.length; l++) {
            $scope.newGroup.customers.data.push(resp[l].value);
          }
        }
      }
    };

    $scope.SearchCancelled = function () {//callback that is used by the search modal
    };

    $scope.Show = function (page) {
      var params = {
        page: page
      };
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      $scope.cancelled = false;
      var req = {
        method: 'GET',
        url: vm.groupEndpoint,
        params: params
      };
      req.url += vm.selectedGroup.group_id;
      Utils.getHttpPromise(req).then(function (resp) {
        vm.selectedGroup = resp.group;
        vm.selectedGroup.shipping_flat_rates = [];
        $scope.priceSheets = resp.price_sheets;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.TabChanged = function (i) {
      vm.activeTab = i;
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      $scope.cancelled = false;
      var req = {
        method: 'GET',
        url: vm.groupEndpoint
      };

      switch (i) {
        case 0:
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.customerGroups = resp.groups;
            $scope.priceSheets = resp.price_sheets;
            $scope.newGroup.default_price_sheet = resp.default_price_sheet;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          //Second tab selected
          if (!$scope.newGroup.default_price_sheet) {
            Utils.getHttpPromise(req).then(function (resp) {
              $scope.priceSheets = resp.price_sheets;
              $scope.newGroup.default_price_sheet = resp.default_price_sheet;
            }, function (errResp) {
              Debug.error(errResp);
            })["finally"](function () {
              $scope.loading = false;
            });
          } else {
            $scope.loading = false;
          }

          break;

        case 2:
          $scope.Show(1);
          break;

        case 3:
          $scope.loading = false;
          break;

        case 4:
          req = {
            method: 'GET',
            url: $scope.batchEndpoint,
            params: $scope.sortBatchParams
          };
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.batches = resp.search_results; // eslint-disable-next-line no-shadow

            for (var _i = 0; _i < $scope.batches.length; _i++) {
              if ($scope.batches[_i].status === 'processing') {
                $scope.UpdateBatchProgress();
                break;
              }
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 5:
          req = {
            method: 'GET',
            url: $scope.batchEndpoint + $scope.selectedBatch.batch_id
          };
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.selectedBatch = resp.batches[0];
            $scope.batchHeaders = resp.batches[0].columns;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;
      }
    };

    $scope.GoToUser = function (user) {
      $state.go('customers-accounts', {
        activeTab: 2,
        customer: user
      });
    };

    $scope.SelectChild = function (groupId) {
      $scope.loading = true;
      var req = {
        method: 'GET',
        url: vm.groupEndpoint
      };
      req.url += groupId;
      Utils.getHttpPromise(req).then(function (resp) {
        vm.selectedGroup = resp.group;
        $scope.priceSheets = resp.price_sheets;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.ChangeTab = function (tabIndex, customerIndex) {
      vm.activeTab = tabIndex;
      vm.selectedGroup = $scope.customerGroups.data[customerIndex];
    };

    this.changeSortBy = function (sortBy, e) {
      e.preventDefault();
      vm.sortAscending = vm.searchParams.sortBy === sortBy ? !vm.sortAscending : true;
      vm.searchParams.sortBy = sortBy;
      vm.searchParams.sortType = vm.sortAscending ? 'asc' : 'desc';

      _this.searchGroups();
    };

    this.searchGroups = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: vm.groupEndpoint,
        params: vm.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.customerGroups = resp.groups;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    this.setPage = function (page) {
      _this.searchParams.page = page;

      _this.searchGroups();
    };

    this.setRpp = function (rpp) {
      _this.searchParams.rpp = rpp;

      _this.searchGroups();
    };

    this.setQuery = function (query, searchBy) {
      _this.searchParams.page = 1; // Reset page when query changes.

      _this.searchParams.q = query;
      _this.searchParams.searchBy = searchBy;
      _this.searchTerm = _this.searchParams.q;
      _this.searchedBy = _this.searchParams.searchBy;

      _this.searchGroups();
    };

    $scope.OpenCustomerSearchModal = function () {
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/customers/',
            params: {
              q: ''
            }
          },
          relationships: ['customers', 'group'],
          fields: ['customer_id', 'name', 'email', '.name'],
          fieldPrefixes: ['ID: ', '', '', 'Group: '],
          id: 'customer_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: vm.groupEndpoint + vm.selectedGroup.group_id,
            params: {
              q: ''
            }
          },
          relationships: ['group', 'customers'],
          fields: ['customer_id', 'name', 'email', 'status'],
          fieldPrefixes: ['ID: ', '', '', 'Status: '],
          id: 'customer_id'
        }]
      };
      callback = {
        confirm: $scope.CustomerSearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Select Customers', data, 'Add items');
    };

    $scope.OpenGroupSearchModal = function () {
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: vm.groupEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['groups'],
          fields: ['group_id', 'parent_group_id', 'name', 'default_price_sheet'],
          fieldPrefixes: ['ID: ', 'Parent ID: ', '', 'Price Sheet: '],
          id: 'group_id',
          selectOne: true
        }]
      };
      callback = {
        confirm: $scope.GroupSearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, $scope.newGroup.name || 'New Group', data, 'Add items');
    };

    $scope.OpenRatesSearchModal = function () {
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/shipping/flat-rate/',
            params: {
              q: '',
              excludedField: 'group_id',
              excludedId: vm.selectedGroup.group_id,
              excludedTable: 'shipping_flat_rate_group'
            }
          },
          relationships: ['shipping_flat_rates'],
          fields: ['id', 'name', 'cost', 'enabled'],
          fieldPrefixes: ['', 'Name: ', 'Cost: ', 'Enabled: '],
          id: 'id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: vm.groupEndpoint + vm.selectedGroup.group_id
          },
          relationships: ['group'],
          fields: ['name', 'cost', 'enabled'],
          fieldPrefixes: ['Name: ', 'Cost: ', 'Enabled: '],
          id: 'id',
          selectOne: false
        }],
        updatedItems: $scope.updatedRates
      };
      callback = {
        confirm: $scope.rateResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Flat Rates', data, 'Add Shipping Rates');
    };

    $scope.rateResults = function (resp) {
      if (vm.activeTab === 2) {
        $scope.updatedRates = [];
        resp.forEach(function (rate) {
          if (rate.action === 'add') {
            $scope.updatedRates.push(rate);
            vm.selectedGroup.shipping_flat_rates.push({
              id: rate.value.id
            });
          }

          if (rate.action === 'unselect') {
            angular.forEach(vm.selectedGroup.shipping_flat_rates, function (val, key) {
              if (val.id === rate.value.id) {
                vm.selectedGroup.shipping_flat_rates.splice(key, 1);
              }
            });
          }

          if (rate.action === 'remove') {
            $scope.updatedRates.push(rate);
            vm.selectedGroup.shipping_flat_rates.push({
              id: rate.value.id,
              deleted: 1
            });
          }

          if (rate.action === 'deselect') {
            angular.forEach(vm.selectedGroup.shipping_flat_rates, function (val, key) {
              if (val.id === rate.value.id) {
                vm.selectedGroup.shipping_flat_rates.splice(key, 1);
              }
            });
          }
        });
      }
    };

    $scope.rateCheck = function (rate) {
      var check = false;
      angular.forEach($scope.updatedRates, function (key) {
        if (key.value.id === rate.id && key.action === 'remove') {
          check = true;
        }
      });
      return check;
    };

    $scope.UpdateGroup = function () {
      $scope.loading = true;
      var req = {
        method: 'PUT',
        url: vm.groupEndpoint + vm.selectedGroup.group_id,
        data: vm.selectedGroup
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (resp.errors.length <= 0) {
          angular.forEach($scope.updatedRates, function (rate) {
            if (rate.action === 'add') {
              vm.selectedGroup.flatrates.push(rate.value);
            } else {
              angular.forEach(vm.selectedGroup.flatrates, function (val, key) {
                if (val.id === rate.value.id) {
                  vm.selectedGroup.flatrates.splice(key, 1);
                }
              });
            }
          });
          $scope.updatedRates = [];
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.AddGroup = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: vm.groupEndpoint,
        data: $scope.newGroup
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (resp.errors.length <= 0) {
          $scope.newGroup = {};
          vm.selectedGroup = {
            group_id: resp.group_id
          };
          vm.activeTab = 2;
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };
    /**
     * Delete a group
     */


    function deleteGroup() {
      vm.isDeleting = true;
      var endpoint = vm.groupEndpoint + vm.selectedGroup.group_id;
      Utils.httpDelete(endpoint).then(function () {
        vm.selectedGroup = null;
        vm.activeTab = 0;
      })["catch"](function (error) {
        Debug.error(error);
      })["finally"](function () {
        vm.isDeleting = false;
      });
    }

    $scope.UpdateBatchProgress = function () {
      var req = {
        method: 'GET',
        url: $scope.batchEndpoint,
        params: $scope.sortBatchParams
      };
      var again = false;
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.batches = resp.search_results;

        for (var i = 0; i < $scope.batches.length; i++) {
          if ($scope.batches[i].status === 'processing' && vm.activeTab === 4) {
            again = true;
            break;
          }
        }

        if (again) {
          $timeout(function () {
            $scope.UpdateBatchProgress();
          }, 5000);
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        angular.noop();
      });
    };

    $scope.SetUploading = function () {
      // eslint-disable-next-line no-shadow
      $scope.$apply(function ($scope) {
        $scope.uploading = !$scope.uploading;
      });
    };

    $scope.SetFile = function (element) {
      // eslint-disable-next-line no-shadow
      $scope.$apply(function ($scope) {
        $scope.theFile = element.files[0];
      });
      var totalBytes = $scope.theFile.size;

      if (totalBytes < 1000000) {
        $scope.fileSize = Math.floor(totalBytes / 1000) + 'KB';
      } else {
        $scope.fileSize = Math.floor(totalBytes / 1000000) + 'MB';
      }

      var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

      if (regex.test($scope.theFile.name.toLowerCase())) {
        if (typeof FileReader !== 'undefined') {
          var reader = new FileReader();

          reader.onload = function () {
            // eslint-disable-next-line no-undef
            Papa.parse(reader.result, {
              complete: function complete(results) {
                var groups = [];

                var _loop = function _loop(i) {
                  var info = results.data[i];
                  var group = [];
                  angular.forEach(info, function (val, key) {
                    group[key] = val;
                  });
                  groups.push(group);
                };

                for (var i = 0; i <= results.data.length; i++) {
                  _loop(i);
                }

                $scope.$apply(function () {
                  $scope.groupSheetUpload = groups;
                  $scope.IsVisible = true;
                });
              }
            });
            $scope.SetUploading();
          };

          reader.readAsText($scope.theFile);
        } else {
          $window.alert('This browser does not support HTML5.');
        }
      } else {
        $scope.groupSheetUpload = null;
        $scope.theFile = null;
        $scope.SetUploading();
        $window.alert('Please upload a valid CSV file.');
      }
    };

    $scope.SortBatchIndex = function (sortBy) {
      vm.sortAscending = $scope.sortBatchParams.sort_by === sortBy ? !vm.sortAscending : true;
      $scope.sortBatchParams.sort_by = sortBy;
      $scope.sortBatchParams.sort_type = vm.sortAscending ? 'asc' : 'desc';
      $scope.SortBatches();
    };

    $scope.SortBatches = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: $scope.batchEndpoint,
        params: $scope.sortBatchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.batches = resp.search_results;

        for (var i = 0; i < $scope.batches.length; i++) {
          if ($scope.batches[i].status === 'processing') {
            $scope.UpdateBatchProgress();
            break;
          }
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    $scope.ChangeBatchTab = function (tabIndex, batchIndex) {
      vm.activeTab = tabIndex;
      $scope.selectedBatch = $scope.batches[batchIndex];
    };

    $scope.postUpload = function (index, id) {
      $scope.selectedBatch = {
        batch_id: id
      };
      vm.activeTab = index;
    };

    $scope.RemoveUploadFile = function () {
      $scope.groupSheetUpload = null;
      Localized.setNotification({
        type: 'danger',
        message: 'File Successfully Removed'
      });
    };

    $scope.UploadGroup = function () {
      $scope.loading = true;
      var fd = new FormData();
      fd.append('file', $scope.theFile);
      var req = {
        method: 'POST',
        url: $scope.batchEndpoint + 'upload',
        data: fd,
        transformRequest: angular.identity,
        headers: {
          // eslint-disable-next-line no-undefined
          'Content-Type': undefined
        }
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.postUpload(5, resp.batch_id);
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
        Localized.setNotification({
          type: 'success',
          message: 'File Successfully Uploaded'
        });
      });
    };

    $scope.ConfirmBatch = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: $scope.batchEndpoint + 'confirm',
        data: {
          batch_id: $scope.selectedBatch.batch_id
        }
      };
      Utils.getHttpPromise(req).then(function () {
        $scope.selectedBatch = null;
        vm.activeTab = 4;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };
    /**
     * Punchout Profiles
     */


    $scope.OpenSupplierSearch = function () {
      $scope.searchModalPage = 'supplier';
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/punchout/supplier',
            params: {
              q: ''
            }
          },
          relationships: ['suppliers'],
          fields: ['id', 'name'],
          fieldPrefixes: ['ID: ', ''],
          id: 'id',
          selectOne: false
        }]
      };
      callback = {
        confirm: function confirm(resp) {
          $scope.selectedGroup.punchout_profiles.push({
            supplier: {
              name: resp[0].value.name,
              id: resp[0].value.id
            }
          });
        },
        cancel: function cancel() {
          angular.noop();
        }
      };
      SearchModal.Show(callback, 'Suppliers', data, 'Add Supplier');
    };

    $scope.RemoveProfile = function (index) {
      $scope.selectedGroup.punchout_profiles[index].deleted = true;
    };
  }
})();

/***/ }),

/***/ 8628:
/***/ (() => {

(function () {
  'use strict';

  LoginController.$inject = ["$scope", "Admin", "Utils", "$state"];
  angular.module('vendorfuelApp').controller('LoginController', LoginController);
  LoginController.$inject = ['$scope', 'Admin', 'Utils', '$state'];
  /**
   * @param {Object} $scope Angular service
   * @param {Object} Admin  VendorFuel service
   * @param {Object} Utils  VendorFuel service
   * @param {Object} $state UI Router service
   */

  function LoginController($scope, Admin, Utils, $state) {
    var parentCallback = $scope.$parent.LoginCallback;

    this.init = function () {
      Admin.login_errors = {};
      Utils.redirecting = false;
      $scope.admin = Admin;
      $scope.loggingIn = false;
      $scope.remember_me = false;
      $scope.user = {
        loginEmail: '',
        loginPassword: ''
      };
    };

    this.init();

    $scope.trimExtraSp = function (str) {
      return str.replace(/\s+/g, '');
    };

    $scope.Login = function () {
      Admin.login_errors = {};
      $scope.loggingIn = true;
      Admin.Login($scope.user.loginEmail, $scope.trimExtraSp($scope.user.loginPassword), $scope.user.loginAuthenticator, $scope.remember_me).then(function () {
        if (parentCallback && Object.keys(Admin.login_errors).length === 0) {
          parentCallback();
        }

        $scope.loggingIn = false;

        if (Object.keys(Admin.login_errors).length === 0) {
          if (!Utils.ReturnLocation) {
            $state.go('dashboard');
          }

          if (Utils.ReturnLocation !== null) {
            Utils.setLocation(Utils.ReturnLocation, false);
            Utils.redirecting = false;
            Utils.ReturnLocation = null;
          }
        }
      });
    };

    $scope.ToggleShowPassword = function (type) {
      if (type === 'password') {
        $scope.showPassword = !$scope.showPassword;
      }

      if (type === 'conf') {
        $scope.showPasswordConf = !$scope.showPasswordConf;
      }
    };
  }
})();

/***/ }),

/***/ 9493:
/***/ (() => {

(function () {
  'use strict';

  PaymentProcessorController.$inject = ["$scope", "$parse"];
  angular.module('vendorfuelApp').controller('PaymentProcessorController', PaymentProcessorController);
  PaymentProcessorController.$inject = ['$scope', '$parse'];
  /**
   * @param {Object} $scope Angular service
   * @param {Object} $parse Angular service
   */

  function PaymentProcessorController($scope, $parse) {
    /**
     * Initialization
     */
    this.init = function () {
      $scope.attributeCount = 0;
      $scope.enabled = 0;
      $scope.processorIndex = null;
      $scope.$watch('$viewContentLoaded', function () {
        if ($scope.$parent.gateways[$scope.processorIndex]) {
          var gateway = $scope.$parent.gateways[$scope.processorIndex];
          $scope.enabled = Number(gateway.enabled);
          var i = 1;
          angular.forEach(gateway, function (value, key) {
            //$scope.attributeCount = i;
            // @ts-ignore
            if (key !== 'enabled') {
              var index = 'atrributeIndex';
              var valueIndex = 'attribute'; // @ts-ignore

              index = index.concat(i); // @ts-ignore

              valueIndex = valueIndex.concat(i); // @ts-ignore

              $parse(index).assign($scope, key);
              $parse(valueIndex).assign($scope, value);
              i++;
            }
          });
        } else {
          for (var j = 1; j <= $scope.attributeCount;) {
            var valueIndex = 'attribute'; // @ts-ignore

            valueIndex = valueIndex.concat(j);
            $parse(valueIndex).assign($scope, '');
            j++;
          }
        }
      });
    };

    this.init();

    $scope.updateGateway = function () {
      var gateway = {};
      gateway[$scope.processorIndex] = {};
      gateway[$scope.processorIndex].enabled = $scope.enabled;

      for (var i = 1; i <= $scope.attributeCount;) {
        var index = 'attributeIndex';
        var valueIndex = 'attribute';
        index = index.concat(i.toString());
        valueIndex = valueIndex.concat(i.toString());

        if ($scope[index] !== 'enabled') {
          gateway[$scope.processorIndex][$scope[index]] = $scope[valueIndex];
          i++;
        }
      }

      $scope.$parent.gateways[$scope.processorIndex] = gateway[$scope.processorIndex];
      $scope.$parent.updateGateway(gateway);
    };

    $scope.disableGateway = function () {
      var gateway = {};
      gateway[$scope.processorIndex] = {};
      gateway[$scope.processorIndex].enabled = false;
      $scope.$parent.gateways[$scope.processorIndex] = gateway[$scope.processorIndex];
      $scope.$parent.disableGateway(gateway).then();
    };

    $scope.setPrimaryCCProcessor = function () {
      var gateway = {};
      gateway[$scope.processorIndex] = {};

      if ($scope.keyIndex !== '') {
        gateway[$scope.processorIndex][$scope.keyIndex] = $scope.key;
      }

      if ($scope.secretIndex !== '') {
        gateway[$scope.processorIndex][$scope.secretIndex] = $scope.secret;
      }

      gateway[$scope.processorIndex].enabled = $scope.enabled;
      $scope.$parent.gateways[$scope.processorIndex] = gateway[$scope.processorIndex];
      $scope.$parent.setPrimaryCCProcessor(gateway);
    };

    $scope.authorizeAccess = function () {
      $scope.$parent.authorizeAccess($scope.processorIndex);
    };

    $scope.revokeAccess = function () {
      $scope.$parent.revokeAccess($scope.processorIndex);
    };
  }
})();

/***/ }),

/***/ 6962:
/***/ (() => {

(function () {
  'use strict';

  PaymentsController.$inject = ["$filter", "$scope", "$rootScope", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized"];
  angular.module('vendorfuelApp').controller('PaymentsController', PaymentsController);
  PaymentsController.$inject = ['$filter', '$scope', '$rootScope', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized'];
  /**
   * @param {Object} $filter      Angular service
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   */

  function PaymentsController($filter, $scope, $rootScope, $stateParams, Admin, Settings, Debug, Utils, Localized) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Payments',
        state: 'payments'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab) || 0;
      $scope.addParams = {};
      $scope.gateway = {};
      $scope.gateways = [];
      $scope.gatewaysEndpoint = Localized.apiURL + '/admin/gateways/';
      $scope.isAuthed = Admin.Authed();
      $scope.loading = false;
      $scope.rppValues = [15, 30, 50, 100];
      $scope.searchParams = {
        q: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0]
      };
      $scope.selectedGateway = null;
      $scope.templates = [{
        name: 'Qualpay',
        url: localized.dir.url + '/assets/app/templates/payment_processors/QualPay.html'
      }, {
        name: 'AuthorizeNet',
        url: localized.dir.url + '/assets/app/templates/payment_processors/AuthorizeNet.html'
      }, {
        name: 'PayPal',
        url: localized.dir.url + '/assets/app/templates/payment_processors/PayPal.html'
      }, {
        name: 'PayFabric',
        url: localized.dir.url + '/assets/app/templates/payment_processors/PayFabric.html'
      }, {
        name: 'Stripe',
        url: localized.dir.url + '/assets/app/templates/payment_processors/Stripe.html'
      }, {
        name: 'SquareUp',
        url: localized.dir.url + '/assets/app/templates/payment_processors/SquareUp.html'
      }];
      $scope.template = $scope.templates[0]; // Must come after templates declaration.
    };

    this.init(); //FUNCTIONS

    $scope.LoginCallback = function () {
      $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
    };

    $scope.retrieveGateways = function () {
      $scope.loading = true;
      var req = {
        method: 'GET',
        url: $scope.gatewaysEndpoint
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.gateways = resp.gateways;
        angular.forEach($scope.gateways, function (value, key) {
          if (value.enabled && value.enabled !== 0) {
            $scope.template = $filter('filter')($scope.templates, {
              name: key
            })[0];
          }
        });
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.TabChanged = function (i) {
      $scope.activeTab = i;
      Settings.errors = {};
      $scope.retrieveGateways();
    };

    $scope.disableGateway = function (gateway) {
      var data = {
        gateways: gateway
      };
      var req = {
        method: 'PUT',
        url: $scope.gatewaysEndpoint,
        data: data
      };
      Utils.getHttpPromise(req).then(function () {
        if ('paypal' in gateway) {
          Utils.httpDelete(Localized.wpRestUrl + '/settings/paypal', {}, {
            paypal_client_id: gateway.paypal.client_id
          });
        }

        if ('authnet' in gateway) {
          Utils.httpDelete(Localized.wpRestUrl + '/settings/authnet', {}, {
            public_key: gateway.authnet.key,
            id: gateway.authnet.id
          });
        }

        if ('stripe' in gateway) {
          Utils.httpDelete(Localized.wpRestUrl + '/settings/stripe', {}, {
            stripe_pk: gateway.stripe.publishableKey
          });
        }

        if ('squareup' in gateway) {
          Utils.httpDelete(Localized.wpRestUrl + '/settings/squareup', {}, {
            location_id: gateway.squareup.locationID
          });
        }

        Utils.httpPut(Localized.wpRestUrl + '/payment/enabled', {}, {
          gateway: gateway
        });
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
        $scope.retrieveGateways();
      });
    };

    $scope.updateGateway = function (gateway) {
      var data = {
        gateways: gateway
      };
      var req = {
        method: 'PUT',
        url: $scope.gatewaysEndpoint,
        data: data
      };
      Utils.getHttpPromise(req).then(function () {
        if ('paypal' in gateway) {
          Utils.httpPut(Localized.wpRestUrl + '/settings/paypal', {}, {
            paypal_client_id: gateway.paypal.client_id
          });
        }

        if ('authnet' in gateway) {
          Utils.httpPut(Localized.wpRestUrl + '/settings/authnet', {}, {
            public_key: gateway.authnet.key,
            id: gateway.authnet.id
          });
        }

        if ('stripe' in gateway) {
          Utils.httpPut(Localized.wpRestUrl + '/settings/stripe', {}, {
            stripe_pk: gateway.stripe.publishableKey
          });
        }

        if ('squareup' in gateway) {
          Utils.httpPut(Localized.wpRestUrl + '/settings/squareup', {}, {
            location_id: gateway.squareup.locationID
          });
        }

        Utils.httpPut(Localized.wpRestUrl + '/payment/enabled', {}, {
          gateway: gateway
        });
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.authorizeAccess = function (processorIndex) {
      $scope.loading = true;
      var req = {
        method: 'GET',
        url: Localized.apiURL + '/admin/payments/' + processorIndex + '/authorize'
      };
      Utils.getHttpPromise(req).then(function (resp) {
        window.open(resp.auth_url, '_blank');
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.revokeAccess = function (processorIndex) {
      $scope.loading = true;
      var req = {
        method: 'GET',
        url: Localized.apiURL + '/admin/payments/' + processorIndex + '/revoke'
      };
      Utils.getHttpPromise(req).then(function () {//window.open(resp.auth_url,'_blank');
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.ChangeTab = function (tabIndex) {
      $scope.activeTab = tabIndex;
    };
  }
})();

/***/ }),

/***/ 3599:
/***/ (() => {

(function () {
  'use strict';

  PunchoutSuppliersController.$inject = ["$scope", "$rootScope", "$state", "$stateParams", "Admin", "ConfirmModal", "Settings", "Debug", "Utils", "Localized"];
  angular.module('vendorfuelApp').controller('PunchoutSuppliersController', PunchoutSuppliersController);
  PunchoutSuppliersController.$inject = ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $state       UI Router service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} ConfirmModal VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   */

  function PunchoutSuppliersController($scope, $rootScope, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
    this.breadcrumbs = [{
      name: 'Punchout',
      state: 'punchout'
    }, {
      name: 'Suppliers',
      state: 'punchout-suppliers'
    }];
    /**
     * Sets the active tab based on whether it matches a index of accessible tabs.
     *
     * @param {number} tab
     * @return {number | Object} Sets activeTab to the tab number, or reloads the state to reset the activeTab.
     */

    var setActiveTab = function setActiveTab(tab) {
      var index = [0, 1];

      if (index.includes(tab)) {
        return $scope.activeTab = tab;
      }

      return $state.go($state.current, {
        activeTab: 0
      }, {
        reload: true
      });
    };

    setActiveTab(parseInt($stateParams.activeTab));
    $scope.addParams = {};
    $scope.addParams.domain_type = 'DUNS';
    $scope.admin = Admin;
    $scope.confirm = ConfirmModal;
    $scope.endpointBase = Localized.apiURL + '/admin/punchout/supplier/';
    $scope.loading = false;
    $scope.loadingMore = false;
    $scope.localized = Localized;
    $scope.model = {};
    $scope.models = [];
    $scope.rppValues = [15, 30, 50, 100];
    $scope.saved = false;
    $scope.saving = false;
    $scope.searchParams = {
      q: '',
      sortBy: '',
      sortType: 'asc',
      rpp: $scope.rppValues[0]
    };
    $scope.settings = Settings;
    $scope.utils = Utils; //FUNCTIONS

    this.selectSupplier = function (id) {
      $scope.model.id = id;
      $scope.activeTab = 2;
    };

    $scope.LoginCallback = function () {
      $scope.loading = true;
    };

    $scope.SortIndex = function (sortBy) {
      $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
      $scope.searchParams.sortBy = sortBy;
      $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
      $scope.Index($scope.searchParams.page);
    };

    $scope.TabChanged = function (i) {
      $scope.activeTab = i;

      switch ($scope.activeTab) {
        case 0:
          if (!$scope.models.data) {
            $scope.Index();
          }

          break;

        case 2:
          if ($scope.model.id) {
            $scope.Show($scope.model.id);
          }

          break;
      }
    }; //RESTful Functions
    //Index


    $scope.Index = function (page) {
      $scope.loadingMore = true;
      $scope.searchParams.page = page || 1;
      var req = {
        method: 'GET',
        url: $scope.endpointBase,
        params: $scope.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.models = resp.suppliers;
      }, function (errResp) {
        Debug.log(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
        $scope.loading = false;
      });
    }; //Show


    $scope.Show = function (id) {
      $scope.loading = true;
      $scope.model.id = id;
      var req = {
        method: 'GET',
        url: $scope.endpointBase + id
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.model = resp.supplier;
      }, function (errResp) {
        Debug.log(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    }; //Store


    $scope.Store = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: $scope.endpointBase,
        data: $scope.addParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          $scope.addParams = {};
          $scope.Show(resp.supplier.id);
          $scope.TabChanged(2);
        }
      }, function (errResp) {
        Debug.log(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    }; //Update


    $scope.Update = function (id) {
      $scope.loading = true;
      var req = {
        method: 'PUT',
        url: $scope.endpointBase + id,
        data: $scope.model
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.log(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    }; //Delete


    $scope.Delete = function (id) {
      var callback = {
        confirm: function confirm() {
          $scope.loading = true;
          var req = {
            method: 'DELETE',
            url: $scope.endpointBase + id
          };
          Utils.getHttpPromise(req).then(function () {
            $scope.model = {};
            $scope.activeTab = 0;
            $scope.Index();
          }, function (errResp) {
            Debug.log(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
        },
        cancel: function cancel() {}
      };
      $scope.confirm.Show(callback, 'Delete Supplier?', 'This action cannot be undone.', 'Back', 'DELETE');
    };

    $scope.AddEndpoint = function (endpoints) {
      endpoints.push({
        transaction: '',
        url: ''
      });
    };

    $scope.RemoveEndpoint = function (endpoints, index) {
      endpoints.splice(index, 1);
    };

    $scope.RefreshEndpoints = function (id) {
      $scope.loading = true;
      var req = {
        method: 'GET',
        url: $scope.endpointBase + id + '/endpoints/refresh'
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.model = resp.supplier;
      }, function (errResp) {
        Debug.log(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };
  }
})();

/***/ }),

/***/ 7072:
/***/ (() => {

(function () {
  'use strict';

  ReportsController.$inject = ["$scope", "$rootScope", "$cookies", "$timeout", "Admin", "Reports", "Debug", "Settings", "Localized", "Utils", "$stateParams"];
  angular.module('vendorfuelApp').controller('ReportsController', ReportsController);
  ReportsController.$inject = ['$scope', '$rootScope', '$cookies', '$timeout', 'Admin', 'Reports', 'Debug', 'Settings', 'Localized', 'Utils', '$stateParams'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $cookies     Angular service
   * @param {Object} $timeout     Angular service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Reports      VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} $stateParams UI Router service
   */

  function ReportsController($scope, $rootScope, $cookies, $timeout, Admin, Reports, Debug, Settings, Localized, Utils, $stateParams) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Reports',
        state: 'reports'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab) || 0;
      $scope.allColumns = []; // Columns of all selected tables

      $scope.allTables = Reports.getAllTables();
      $scope.clear = true;
      $scope.comparators = Reports.getComparators();
      $scope.downloads = []; // List of downloaded reports

      $scope.filterOperators = ['OR', 'AND'];
      $scope.frequencies = {
        daily: 'Daily',
        weekly: 'Weekly',
        monthly: 'Monthly',
        quarterly: 'Quarterly',
        clear: 'Clear Schedule'
      };
      $scope.isAuthed = Admin.Authed();
      $scope.joinTypes = {
        standard: 'Standard',
        left: 'Left',
        right: 'Right'
      };
      $scope.loading = false;
      $scope.reportLoading = false;
      $scope.reportsEndpoint = Localized.apiURL + '/admin/reports/';
      $scope.reportData = {};
      $scope.reportHeaders = [];
      $scope.rppValues = [15, 30, 50, 100];
      $scope.per_page = $scope.rppValues[0]; // Must be after rrpValues is defined.

      $scope.savedReports = []; // List of person/shared reports that were saved

      $scope.scheduleSaveError = false;
      $scope.scheduleSaveSuccessful = false;
      $scope.storeTables = Reports.getStoreTables();
    };

    this.init();

    $scope.TabChanged = function (i) {
      $scope.activeTab = i;
      $scope.loading = true;
      Settings.errors = {};
      var req = {
        method: 'GET',
        url: $scope.reportsEndpoint
      };

      switch (i) {
        case 0:
          // Initialize reports page
          // Request saved reports from API, populate saved reports list
          req.url += 'all';
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.savedReports = [];
            angular.forEach(resp.personal_reports, function (value) {
              $scope.savedReports.push(value);
            });
            angular.forEach(resp.shared_reports, function (value) {
              $scope.savedReports.push(value);
            });
            $scope.AssignReport(null);
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          req.url += 'download';
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.downloads = resp.reports;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 2:
          req.url += 'all';
          $scope.scheduleReports = {};
          $scope.scheduleReports.id = [];
          $scope.scheduleReports.frequency = [];
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.savedReports = [];
            angular.forEach(resp.personal_reports, function (value) {
              $scope.savedReports.push(value);
            });
            angular.forEach(resp.shared_reports, function (value) {
              $scope.savedReports.push(value);
            });
            $scope.AssignReport(null);
            angular.forEach($scope.savedReports, function (value) {
              $scope.scheduleReports.id.push(value.id);
              $scope.scheduleReports.frequency.push(value.frequency);
            });
            $scope.UpdateScheduleModel(0);
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;
      }
    };

    $scope.AddJoinRow = function () {
      var initJoin = $scope.allTables.admin_groups[0];
      $scope.selectedParams.joinTable.push(initJoin.table);
      $scope.UpdateColumns(initJoin.table, '');
      $scope.selectedParams.joinSelect.push(initJoin.value);
      $scope.selectedParams.joinTerm.push('=');
      $scope.selectedParams.joinValue.push('');
      $scope.selectedParams.joinIsNested.push(false);
      $scope.selectedParams.joinType.push('standard');
    };

    $scope.AddFilterRow = function () {
      if ($scope.selectedParams.filterSelect.push('') === 1) {
        $scope.selectedParams.filterToken.push('(', 'ex', ')');
      } else {
        $scope.selectedParams.filterToken.splice($scope.selectedParams.filterToken.length - 1, 0, 'ex');
      }

      $scope.selectedParams.filterTerm.push($scope.comparators[0]);
      $scope.selectedParams.filterValue.push('');
      $scope.selectedParams.filterOperator.push('OR');
    };

    $scope.AddGroupFilter = function (index, type) {
      var tokenGroup = ['(', 'ex', ')'];
      var exCount = 0;

      for (var i = 0; i < $scope.selectedParams.filterToken.length; i++) {
        if ($scope.selectedParams.filterToken[i] === 'ex') {
          if (index === exCount) {
            if (type === 'group') {
              $scope.selectedParams.filterToken.splice.apply($scope.selectedParams.filterToken, [i + 1, 0].concat(tokenGroup));
            } else {
              $scope.selectedParams.filterToken.splice(i + 1, 0, 'ex');
            }

            break;
          }

          exCount++;
        }
      }

      $scope.selectedParams.filterSelect.splice(index + 1, 0, '');
      $scope.selectedParams.filterTerm.splice(index + 1, 0, $scope.comparators[0]);
      $scope.selectedParams.filterValue.splice(index + 1, 0, '');
      $scope.selectedParams.filterOperator.splice(index + 1, 0, 'OR');
    }; // Populate selectedParams object with selected saved report


    $scope.AssignReport = function (selectedReport) {
      // Reset report parameters
      // Parameters to use in request with the API
      $scope.clear = false;
      $scope.selectedParams = {};
      $scope.selectedParams.tables = [];
      $scope.selectedParams.headers = [];
      $scope.selectedParams.joinTable = [];
      $scope.selectedParams.joinSelect = [];
      $scope.selectedParams.joinTerm = [];
      $scope.selectedParams.joinValue = [];
      $scope.selectedParams.joinType = [];
      $scope.selectedParams.joinIsNested = [];
      $scope.selectedParams.filterSelect = [];
      $scope.selectedParams.filterTerm = [];
      $scope.selectedParams.filterValue = [];
      $scope.selectedParams.filterOperator = [];
      $scope.selectedParams.filterToken = [];
      $scope.selectedParams.groupBy = [];
      $scope.selectedParams.nestedQuery = []; // Only supported in the JOIN clause right now

      $scope.selectedParams.direction = 'asc';
      $scope.selectedParams.shared = false;
      $scope.allColumns = [];

      if (!selectedReport) {
        return;
      }

      $scope.selectedParams.tables.push(selectedReport.tables.value[0]);
      $scope.UpdateColumns($scope.selectedParams.tables[0], '');

      if (selectedReport.joins.table) {
        for (var i = 0; i < selectedReport.joins.table.length; i++) {
          $scope.selectedParams.joinTable[i] = selectedReport.joins.table[i];
          $scope.selectedParams.joinSelect[i] = selectedReport.joins.select[i];
          $scope.selectedParams.joinTerm[i] = selectedReport.joins.term[i];
          $scope.selectedParams.joinValue[i] = selectedReport.joins.value[i];
          $scope.selectedParams.joinType[i] = selectedReport.joins.type[i];
          $scope.selectedParams.joinIsNested[i] = selectedReport.joins.isNested[i];
          $scope.UpdateColumns($scope.selectedParams.joinTable[i], '');
        }
      }

      if (selectedReport.filters.select) {
        for (var j = 0; j < selectedReport.filters.select.length; j++) {
          $scope.selectedParams.filterSelect[j] = selectedReport.filters.select[j];
          $scope.selectedParams.filterTerm[j] = selectedReport.filters.term[j];
          $scope.selectedParams.filterValue[j] = selectedReport.filters.value[j];
          $scope.selectedParams.filterOperator[j] = selectedReport.filters.operator[j];
        }

        for (var l = 0; l < selectedReport.filters.token.length; l++) {
          $scope.selectedParams.filterToken[l] = selectedReport.filters.token[l];
        }
      }

      for (var p = 0; p < selectedReport.headers.value.length; p++) {
        $scope.selectedParams.headers[p] = selectedReport.headers.value[p];
      }

      $scope.selectedParams.shared = selectedReport.shared;
      $scope.selectedParams.report_id = selectedReport.id;
      $scope.selectedParams.order = selectedReport.order;
      $scope.selectedParams.direction = selectedReport.direction;
      $scope.selectedParams.name = selectedReport.name;
      $scope.selectedParams.frequency = selectedReport.frequency;
    };

    $scope.AssignReport(null);

    $scope.ClearReport = function () {
      $scope.reportData = {};
      $scope.AssignReport(null);
      $scope.clear = true;
    };

    $scope.DeleteReport = function (selectedReport) {
      var callback = {
        confirm: function confirm() {
          $scope.loading = true;
          var req = {
            method: 'DELETE',
            url: $scope.reportsEndpoint + selectedReport.id
          };
          Utils.getHttpPromise(req).then(function () {
            $scope.TabChanged(0);
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
        },
        cancel: function cancel() {}
      };
      $scope.confirm.Show(callback, 'Delete Report?', 'This action cannot be undone.', 'Back', 'DELETE');
    };

    $scope.Download = function (downloadId) {
      var tokenA = $cookies.get('vendorfuel-admin-tokena');
      var tokenB = $cookies.get('vendorfuel-admin-tokenb');
      var req = $scope.reportsEndpoint + 'download/' + downloadId + '?apikey=' + Localized.api_key + '&tokena=' + tokenA + '&tokenb=' + tokenB;
      window.open(req, '_blank');
    };

    $scope.DownloadReport = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: $scope.reportsEndpoint + 'export',
        data: $scope.selectedParams
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.GroupNumber = function (index) {
      var exCount = 0;
      var depth = 0;

      for (var i = 0; i < $scope.selectedParams.filterToken.length; i++) {
        if ($scope.selectedParams.filterToken[i] === '(') {
          depth++;
        }

        if ($scope.selectedParams.filterToken[i] === ')') {
          depth--;
        }

        if ($scope.selectedParams.filterToken[i] === 'ex') {
          if (index === exCount) {
            break;
          }

          exCount++;
        }
      }

      return depth - 1;
    };

    $scope.RemoveJoin = function (index) {
      $scope.selectedParams.joinSelect.splice(index, 1);
      $scope.selectedParams.joinTerm.splice(index, 1);
      $scope.selectedParams.joinValue.splice(index, 1);
      $scope.selectedParams.joinIsNested.splice(index, 1);
      $scope.selectedParams.joinType.splice(index, 1);
      var removedJoin = $scope.selectedParams.joinTable.splice(index, 1);
      $scope.UpdateColumns('', removedJoin[0]);
    };

    $scope.RemoveFilter = function (index) {
      var exCount = 0;

      for (var i = 0; i < $scope.selectedParams.filterToken.length; i++) {
        if ($scope.selectedParams.filterToken[i] === 'ex') {
          if (exCount === index) {
            var x = 1;

            while ($scope.selectedParams.filterToken[i - x] === '(' && $scope.selectedParams.filterToken[i + x] === ')') {
              $scope.selectedParams.filterToken[i - x] = ' ';
              $scope.selectedParams.filterToken[i + x] = ' ';
              x++;
            }

            $scope.selectedParams.filterToken[i] = ' ';
            break;
          }

          exCount++;
        }
      }

      for (var _i = $scope.selectedParams.filterToken.length - 1; _i >= 0; _i--) {
        if ($scope.selectedParams.filterToken[_i] === ' ') {
          $scope.selectedParams.filterToken.splice(_i, 1);
        }
      }

      $scope.selectedParams.filterSelect.splice(index, 1);
      $scope.selectedParams.filterTerm.splice(index, 1);
      $scope.selectedParams.filterValue.splice(index, 1);
      $scope.selectedParams.filterOperator.splice(index, 1);
    };

    $scope.RunReport = function (rpp, page) {
      $scope.reportRan = false;
      $scope.reportLoading = true; // $scope.loading = true;

      $scope.selectedParams.rpp = rpp;
      $scope.selectedParams.page = page;
      var req = {
        method: 'POST',
        url: $scope.reportsEndpoint + 'run',
        data: $scope.selectedParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.reportData = resp.results;

        if (resp.results && resp.results.data && resp.results.data.length) {
          $scope.reportHeaders = Object.keys(resp.results.data[0]);
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        // $scope.loading = false;
        $scope.reportLoading = false;
        $scope.reportRan = true;
      });
    };

    $scope.SaveReport = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: $scope.reportsEndpoint,
        data: $scope.selectedParams
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.Test = function () {
      Debug.log($scope.scheduleReports);
      Debug.log($scope.selectedParams);
    }; // Update table columns


    $scope.UpdateColumns = function (newValue, oldValue) {
      // If removing columns
      if (oldValue !== '') {
        // Check if table we're switching from is not selected on another table/join, else skip
        if (!$scope.selectedParams.tables.includes(oldValue) && !$scope.selectedParams.joinTable.includes(oldValue)) {
          var i = $scope.allColumns.length;
          var found = false;

          while (i-- && !found) {
            // Find table we're switching from and remove from list
            if ($scope.allColumns[i].table === oldValue) {
              for (var j = 0; j < $scope.allTables[oldValue].length; j++) {
                $scope.allColumns.splice(i--, 1);
              }

              found = true;
            }
          }
        }
      } // If adding columns


      if (newValue !== '') {
        var tableExists = false,
            k = $scope.allColumns.length - 1;

        while (!tableExists && k >= 0) {
          // Check if new table/join is already in list
          if ($scope.allColumns[k].table === newValue) {
            tableExists = true;
          }

          k--;
        }

        if (!tableExists) {
          // If table not in list, add
          angular.forEach($scope.allTables[newValue], function (value) {
            $scope.allColumns.push(value);
          });
        }
      }
    };

    $scope.UpdateReport = function (selectedReport) {
      $scope.loading = true;
      var req = {
        method: 'PUT',
        url: $scope.reportsEndpoint + selectedReport.id,
        data: $scope.selectedParams
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.UpdateScheduleModel = function (index) {
      $scope.selectedId = $scope.savedReports[index].id;
      $scope.scheduleReports.selectedIndex = index;
    };

    $scope.UpdateSchedules = function () {
      $scope.loading = true;
      angular.forEach($scope.scheduleReports.frequency, function (value, key) {
        if (value === 'Clear Schedule') {
          $scope.scheduleReports.frequency[key] = 'null';
        }
      });
      var req = {
        method: 'POST',
        url: $scope.reportsEndpoint + 'schedule',
        data: $scope.scheduleReports
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          $scope.scheduleSaveSuccessful = true;
          $timeout(function () {
            $scope.scheduleSaveSuccessful = false;
          }, 5000);
        } else {
          $scope.scheduleSaveError = true;
          $timeout(function () {
            $scope.scheduleSaveError = false;
          }, 5000);
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };
  }
})();

/***/ }),

/***/ 5077:
/***/ (() => {

(function () {
  'use strict';

  ResetPasswordController.$inject = ["$scope", "Admin", "Localized", "Utils", "$location", "$stateParams"];
  angular.module('vendorfuelApp').controller('ResetPasswordController', ResetPasswordController);
  ResetPasswordController.$inject = ['$scope', 'Admin', 'Localized', 'Utils', '$location', '$stateParams'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} $location    Angular service
   * @param {Object} $stateParams UI Router service
   */

  function ResetPasswordController($scope, Admin, Localized, Utils, $location, $stateParams) {
    /**
     * Initialization
     */
    this.init = function () {
      Admin.login_errors = {};
      Utils.redirecting = false;
      $scope.isAuthed = Admin.Authed();
      $scope.password = '';
      $scope.password_confirmation = '';
      $scope.requesting = false;
      $scope.resetEmail = null;
      $scope.showPassword = false;
      $scope.showPasswordConfirmation = false;

      if ($stateParams.code && $stateParams.auth) {
        $scope.reseting = true;
      }
    };

    this.init();

    $scope.ToggleShowPassword = function () {
      $scope.showPassword = !$scope.showPassword;
    };

    $scope.ToggleShowPasswordConfirmation = function () {
      $scope.showPasswordConfirmation = !$scope.showPasswordConfirmation;
    };

    $scope.requestReset = function () {
      Admin.login_errors = {};
      $scope.requesting = true;
      var req = {
        method: 'POST',
        url: Localized.apiURL + '/admin/password-reset/request',
        data: {
          email: $scope.resetEmail,
          url: $location.absUrl()
        }
      };
      Utils.getHttpPromise(req).then(function (response) {
        if (!response.errors.length) {
          $scope.requesting = false;
          $scope.requested = true;
        }

        $scope.loading = false;
      });
    };

    $scope.submitReset = function () {
      Admin.login_errors = {};
      $scope.submitting = true;
      var req = {
        method: 'POST',
        url: Localized.apiURL + '/admin/password-reset/submit',
        data: {
          code: $stateParams.code,
          auth: $stateParams.auth,
          password: $scope.password,
          password_confirmation: $scope.password_confirmation
        }
      };
      Utils.getHttpPromise(req).then(function (response) {
        if (!response.errors.length) {
          Admin.SetTokens(response.name, response.tokena, response.tokenb, false, response.token);
          Utils.setLocation('/dashboard');
        }

        $scope.submitting = false;
      });
    };
  }
})();

/***/ }),

/***/ 4104:
/***/ (() => {

(function () {
  'use strict';

  ShippingFlatRatesController.$inject = ["$scope", "$rootScope", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized", "SearchModal"];
  angular.module('vendorfuelApp').controller('ShippingFlatRatesController', ShippingFlatRatesController);
  ShippingFlatRatesController.$inject = ['$scope', '$rootScope', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} SearchModal  VendorFuel service
   */

  function ShippingFlatRatesController($scope, $rootScope, $stateParams, Admin, Settings, Debug, Utils, Localized, SearchModal) {
    var _this = this;

    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Shipping',
        state: 'shipping'
      }, {
        name: 'Flat Rates',
        state: 'shipping-flat-rates'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab) || 0;
      $scope.createFlatRate = {
        name: '',
        label: '',
        amount: 0.00,
        free_if_total: 0,
        free_order_total: 0.00,
        enabled: 0,
        modifiers: []
      };
      $scope.del = 0;
      $scope.isAuthed = Admin.Authed();
      $scope.loading = true;
      $scope.rppValues = [15, 30, 50, 100];
      $scope.saved = false;
      $scope.saving = false;
      $scope.searchParams = {
        q: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0]
      };
      $scope.selectedFlatRate = null;
      $scope.shippingFlatRateEndpoint = Localized.apiURL + '/admin/shipping/flat-rate/';
      $scope.updatedCustomers = [];
    };

    this.init();

    this.isNotApplied = function () {
      if ($scope.selectedFlatRate) {
        if (!$scope.selectedFlatRate.customers.length && !$scope.selectedFlatRate.groups.length && !$scope.selectedFlatRate.pricesheets.length) {
          return true;
        }
      }
    }; //FUNCTIONS


    $scope.updateModifiers = function (rateType, modType, index) {
      if (modType === 0) {
        if (rateType.modifiers.length - $scope.del < 5) {
          rateType.modifiers.push({
            amount: 0,
            order_total_min: 0,
            order_total_max: 0
          });
        }
      } else if (modType === 1) {
        $scope.del += 1; // eslint-disable-next-line no-prototype-builtins

        if (rateType.modifiers[index].hasOwnProperty('id')) {
          rateType.modifiers[index].deleted = 1;
        } else {
          rateType.modifiers.splice(index, 1);
        }
      }

      return false;
    };

    $scope.TabChanged = function (i) {
      $scope.modifiers = [];

      if ($scope.selectedFlatRate && $scope.selectedFlatRate.modifiers) {
        $scope.selectedFlatRate.modifiers = [];
      }

      Localized.deleteNotifications();
      $scope.activeTab = i;
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      var req = {
        method: 'GET',
        url: $scope.shippingFlatRateEndpoint
      };

      switch (i) {
        case 0:
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.flatRates = resp.shipping_flat_rates;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          $scope.createFlatRate = {
            name: '',
            label: '',
            amount: 0.00,
            free_if_total: 0,
            free_order_total: 0.00,
            enabled: 0,
            modifiers: []
          };
          $scope.loading = false;
          break;

        case 2:
          $scope.ShowFlatRate($scope.selectedFlatRate.id);
          break;
      }
    };

    $scope.ShowFlatRate = function (id) {
      var req = {
        method: 'GET',
        url: $scope.shippingFlatRateEndpoint
      };
      req.url += id;
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.selectedFlatRate = resp.shipping_flat_rate;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        if ($scope.selectedFlatRate && $scope.selectedFlatRate.modifiers) {
          $scope.modifiers = angular.copy($scope.selectedFlatRate.modifiers);
        }

        $scope.loading = false;
      });
    };

    $scope.DeleteFlatRate = function () {
      $scope.deleting = true;
      var req = {
        method: 'DELETE',
        url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id
      };
      Utils.getHttpPromise(req).then(function () {
        $scope.selectedFlatRate = null;
        $scope.activeTab = 0;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.deleting = false;
      });
    };

    $scope.ChangeTab = function (tabIndex, flatRateIndex) {
      $scope.activeTab = tabIndex;
      $scope.selectedFlatRate = $scope.flatRates.data[flatRateIndex];
    };

    $scope.CreateFlatRate = function () {
      $scope.updating = true;
      var params = $scope.createFlatRate;
      var req = {
        method: 'POST',
        url: $scope.shippingFlatRateEndpoint,
        data: params
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors || resp.errors.length <= 0) {
          $scope.selectedFlatRate = {
            id: resp.id
          };
          $scope.createFlatRate = {
            name: '',
            label: '',
            amount: 0.00,
            free_if_total: 0,
            free_order_total: 0.00,
            enabled: 0,
            modifiers: []
          };
          $scope.activeTab = 2;
          Localized.setNotification({
            type: 'success',
            message: 'Map Successfully Removed'
          });
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.updating = false;
      });
    };

    $scope.OpenCustomerSearchModal = function () {
      var callback = {};
      var config = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/customers/',
            params: {
              q: '',
              excludedField: 'shipping_flat_rate_id',
              excludedId: $scope.selectedFlatRate.id,
              excludedTable: 'shipping_flat_rate_customer'
            }
          },
          relationships: ['customers'],
          fields: ['customer_id', 'name', 'email', 'status'],
          fieldPrefixes: ['ID: ', '', '', 'Status: '],
          id: 'customer_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
            params: {
              q: ''
            }
          },
          relationships: ['shipping_flat_rate', 'customerSearchItems'],
          fields: ['customer_id', 'name', 'email', 'status'],
          fieldPrefixes: ['ID: ', '', '', 'Status: '],
          id: 'customer_id'
        }],
        updatedItems: $scope.updatedCustomers
      };
      callback = {
        confirm: $scope.customerSearchResults,
        cancel: function cancel() {//Cancelled
        }
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Select Customers', config, 'Add items');
    };

    $scope.OpenGroupSearchModal = function () {
      var callback = {};
      var config = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/groups/',
            params: {
              q: '',
              excludedField: 'shipping_flat_rate_id',
              excludedId: $scope.selectedFlatRate.id,
              excludedTable: 'shipping_flat_rate_group'
            }
          },
          relationships: ['groups'],
          fields: ['group_id', 'name'],
          fieldPrefixes: ['ID: ', ''],
          id: 'group_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
            params: {
              q: ''
            }
          },
          relationships: ['shipping_flat_rate', 'groupSearchItems'],
          fields: ['group_id', 'name'],
          fieldPrefixes: ['ID: ', ''],
          id: 'group_id'
        }],
        updatedItems: $scope.updatedGroups
      };
      callback = {
        confirm: $scope.groupSearchResults,
        cancel: function cancel() {//Cancelled
        }
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Select Groups', config, 'Add items');
    };

    $scope.OpenPriceSheetSearchModal = function () {
      var callback = {};
      var config = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/pricesheets/',
            params: {
              q: '',
              excludedField: 'shipping_flat_rate_id',
              excludedId: $scope.selectedFlatRate.id,
              excludedTable: 'shipping_flat_rate_price_sheet'
            }
          },
          relationships: ['pricesheets'],
          fields: ['price_sheet_id', 'sheet'],
          fieldPrefixes: ['ID: ', ''],
          id: 'price_sheet_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
            params: {
              q: ''
            }
          },
          relationships: ['shipping_flat_rate', 'priceSheetSearchItems'],
          fields: ['price_sheet_id', 'sheet'],
          fieldPrefixes: ['ID: ', ''],
          id: 'price_sheet_id'
        }],
        updatedItems: $scope.updatedSheets
      };
      callback = {
        confirm: $scope.sheetSearchResults,
        cancel: function cancel() {//Cancelled
        }
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Select Price Sheets', config, 'Add items');
    };

    $scope.customerSearchResults = function (resp) {
      if ($scope.activeTab === 2) {
        $scope.updatedCustomers = [];
        resp.forEach(function (result) {
          if (result.action === 'add') {
            $scope.updatedCustomers.push(result);
            $scope.selectedFlatRate.customers.push({
              customer_id: result.value.customer_id,
              status: result.value.status,
              name: result.value.name,
              email: result.value.email,
              action: 'add'
            });
          }

          if (result.action === 'unselect') {
            angular.forEach($scope.selectedFlatRate.customers, function (val, key) {
              if (val.customer_id === result.value.customer_id) {
                $scope.selectedFlatRate.customers.splice(key, 1);
              }
            });
          }

          if (result.action === 'remove') {
            $scope.updatedCustomers.push(result);
            angular.forEach($scope.selectedFlatRate.customers, function (val, key) {
              if (val.customer_id === result.value.customer_id) {
                $scope.selectedFlatRate.customers[key].deleted = 1;
                $scope.selectedFlatRate.customers[key].action = 'remove';
              }
            });
          }

          if (result.action === 'deselect') {
            angular.forEach($scope.selectedFlatRate.customers, function (val, key) {
              if (val.customer_id === result.value.customer_id) {
                $scope.selectedFlatRate.customers.splice(key, 1);
              }
            });
          }
        });
      }
    };

    $scope.customerCheck = function (customer) {
      var check = false;
      angular.forEach($scope.updatedCustomers, function (key) {
        if (key.value.id === customer.customer_id && key.action === 'remove') {
          check = true;
        }
      });
      return check;
    };

    $scope.groupSearchResults = function (resp) {
      if ($scope.activeTab === 2) {
        $scope.updatedGroups = [];
        resp.forEach(function (result) {
          if (result.action === 'add') {
            $scope.updatedGroups.push(result);
            $scope.selectedFlatRate.groups.push({
              group_id: result.value.group_id,
              name: result.value.name,
              action: 'add'
            });
          }

          if (result.action === 'unselect') {
            angular.forEach($scope.selectedFlatRate.groups, function (val, key) {
              if (val.group_id === result.value.group_id) {
                $scope.selectedFlatRate.groups.splice(key, 1);
              }
            });
          }

          if (result.action === 'remove') {
            $scope.updatedGroups.push(result);
            angular.forEach($scope.selectedFlatRate.groups, function (val, key) {
              if (val.group_id === result.value.group_id) {
                $scope.selectedFlatRate.groups[key].deleted = 1;
                $scope.selectedFlatRate.groups[key].action = 'remove';
              }
            });
          }

          if (result.action === 'deselect') {
            angular.forEach($scope.selectedFlatRate.groups, function (val, key) {
              if (val.group_id === result.value.group_id) {
                $scope.selectedFlatRate.groups.splice(key, 1);
              }
            });
          }
        });
      }
    };

    $scope.SearchShippingFlatRates = function (page, query) {
      $scope.loadingMore = true;
      $scope.searchParams.q = query;
      $scope.searchTerm = $scope.searchParams.q;
      $scope.searchParams.page = page || 1;
      var endpoint = $scope.shippingFlatRateEndpoint;
      var params = $scope.searchParams;
      Utils.httpGet(endpoint, params).then(function (resp) {
        $scope.flatRates = resp.shipping_flat_rates;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    $scope.OpenProductSearchModal = function () {
      var callback = {};
      var config = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/products/',
            params: {
              q: '',
              excludedField: 'shipping_flat_rate_id',
              excludedId: $scope.selectedFlatRate.id,
              excludedTable: 'shipping_flat_rate_restricted_items'
            }
          },
          relationships: ['products'],
          fields: ['product_id', 'description'],
          fieldPrefixes: ['ID: ', ''],
          id: 'product_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
            params: {
              q: ''
            }
          },
          relationships: ['shipping_flat_rate', 'restrictedSearchItems'],
          fields: ['product_id', 'description'],
          fieldPrefixes: ['ID: ', ''],
          id: 'product_id'
        }],
        updatedItems: $scope.updatedProducts
      };
      callback = {
        confirm: $scope.productSearchResults,
        cancel: function cancel() {//Cancelled
        }
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Select Products', config, 'Add products');
    };

    $scope.productSearchResults = function (resp) {
      if ($scope.activeTab === 2) {
        $scope.updatedProducts = [];
        resp.forEach(function (result) {
          if (result.action === 'add') {
            $scope.updatedProducts.push(result);
            $scope.selectedFlatRate.restricted_items.push({
              product_id: result.value.product_id,
              action: 'add'
            });
          }

          if (result.action === 'unselect') {
            angular.forEach($scope.selectedFlatRate.restricted_items, function (val, key) {
              if (val.product_id === result.value.product_id) {
                $scope.selectedFlatRate.restricted_items.splice(key, 1);
              }
            });
          }

          if (result.action === 'remove') {
            $scope.updatedProducts.push(result);
            angular.forEach($scope.selectedFlatRate.restricted_items, function (val, key) {
              if (val.product_id === result.value.product_id) {
                $scope.selectedFlatRate.restricted_items[key].deleted = 1;
                $scope.selectedFlatRate.restricted_items[key].action = 'remove';
              }
            });
          }

          if (result.action === 'deselect') {
            angular.forEach($scope.selectedFlatRate.restricted_items, function (val, key) {
              if (val.product_id === result.value.product_id) {
                $scope.selectedFlatRate.restricted_items.splice(key, 1);
              }
            });
          }
        });
      }
    };

    $scope.sheetSearchResults = function (resp) {
      if ($scope.activeTab === 2) {
        $scope.updatedSheets = [];
        resp.forEach(function (result) {
          if (result.action === 'add') {
            $scope.updatedSheets.push(result);
            $scope.selectedFlatRate.pricesheets.push({
              id: result.value.price_sheet_id,
              price_sheet_id: result.value.price_sheet_id,
              name: result.value.sheet,
              action: 'add'
            });
          }

          if (result.action === 'unselect') {
            angular.forEach($scope.selectedFlatRate.pricesheets, function (val, key) {
              if (val.price_sheet_id === result.value.price_sheet_id) {
                $scope.selectedFlatRate.pricesheets.splice(key, 1);
              }
            });
          }

          if (result.action === 'remove') {
            $scope.updatedSheets.push(result);
            angular.forEach($scope.selectedFlatRate.pricesheets, function (val, key) {
              if (val.price_sheet_id === result.value.price_sheet_id) {
                $scope.selectedFlatRate.pricesheets[key].deleted = 1;
                $scope.selectedFlatRate.pricesheets[key].action = 'remove';
              }
            });
          }

          if (result.action === 'deselect') {
            angular.forEach($scope.selectedFlatRate.pricesheets, function (val, key) {
              if (val.price_sheet_id === result.value.price_sheet_id) {
                $scope.selectedFlatRate.pricesheets.splice(key, 1);
              }
            });
          }
        });
      }
    };

    $scope.UpdateFlatRate = function () {
      $scope.updating = true;
      var req = {
        method: 'PUT',
        url: $scope.shippingFlatRateEndpoint + $scope.selectedFlatRate.id,
        data: $scope.selectedFlatRate
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (resp.errors.length <= 0) {
          $scope.updateResults();
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.updating = false;
        $scope.ShowFlatRate($scope.selectedFlatRate.id);
      });
    };

    $scope.updateResults = function () {
      angular.forEach($scope.updatedCustomers, function (result) {
        if (result.action === 'remove') {
          angular.forEach($scope.selectedFlatRate.customers, function (val, key) {
            if (val.customer_id === result.value.customer_id) {
              $scope.selectedFlatRate.customers.splice(key, 1);
            }
          });
        }
      });
      angular.forEach($scope.updatedGroups, function (result) {
        if (result.action === 'remove') {
          angular.forEach($scope.selectedFlatRate.groups, function (val, key) {
            if (val.group_id === result.value.group_id) {
              $scope.selectedFlatRate.groups.splice(key, 1);
            }
          });
        }
      });
      angular.forEach($scope.updatedSheets, function (result) {
        if (result.action === 'remove') {
          angular.forEach($scope.selectedFlatRate.pricesheets, function (val, key) {
            if (val.price_sheet_id === result.value.price_sheet_id) {
              $scope.selectedFlatRate.pricesheets.splice(key, 1);
            }
          });
        }
      });
      $scope.updatedGroups = [];
      $scope.updatedCustomers = [];
      $scope.updatedPriceSheets = [];
    };
  }
})();

/***/ }),

/***/ 7930:
/***/ (() => {

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

(function () {
  'use strict';

  ShippingParcelsController.$inject = ["$scope", "$rootScope", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized"];
  angular.module('vendorfuelApp').controller('ShippingParcelsController', ShippingParcelsController);
  ShippingParcelsController.$inject = ['$scope', '$rootScope', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   */

  function ShippingParcelsController($scope, $rootScope, $stateParams, Admin, Settings, Debug, Utils, Localized) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Shipping',
        state: 'shipping'
      }, {
        name: 'Shipping Parcels',
        state: 'shipping-parcels'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab) || 0;
      $scope.createParcel = {};
      $scope.distanceUnits = {
        "in": 'Inches',
        cm: 'Centimeters'
      };
      $scope.gateways = {};
      $scope.isAuthed = Admin.Authed();
      $scope.loading = true;
      $scope.rppValues = [15, 30, 50, 100];
      $scope.saved = false;
      $scope.saving = false;
      $scope.searchParams = {
        q: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0]
      };
      $scope.selectedParcel = null;
      $scope.shippingParcelEndpoint = Localized.apiURL + '/admin/shipping/parcel/';
      $scope.warehouse = {};

      if ($scope.activeTab === 2 && !$scope.selectedParcel) {
        $scope.activeTab = 0;
      }
    };

    this.init(); //FUNCTIONS

    $scope.TabChanged = function (i) {
      $scope.activeTab = i;
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      var req = {
        method: 'GET',
        url: $scope.shippingParcelEndpoint
      };

      switch (i) {
        case 0:
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.shippingParcels = resp.parcels;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          $scope.loading = false;
          break;

        case 2:
          req.url += $scope.selectedParcel.id;
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.selectedParcel = resp.parcel;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 3:
          req.url = Localized.apiURL + '/admin/shipping/gateways';
          Utils.getHttpPromise(req).then(function (resp) {
            if (resp.gateways) {
              $scope.gateways = resp.gateways;

              if (_typeof($scope.gateways.shippo) === 'object' && ($scope.gateways.shippo.key || $scope.gateways.shippo.key === '')) {
                $scope.gateways.shippo = $scope.gateways.shippo.key;
              }
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 4:
          req.url = Localized.apiURL + '/admin/shipping/warehouse';
          Utils.getHttpPromise(req).then(function (resp) {
            if (resp.warehouse) {
              $scope.warehouse = resp.warehouse;
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;
      }
    };

    $scope.ChangeTab = function (tabIndex, index) {
      $scope.activeTab = tabIndex;
      $scope.selectedParcel = $scope.shippingParcels.data[index];
    };

    $scope.CreateParcel = function () {
      $scope.loading = true;
      var params = $scope.createParcel;
      var req = {
        method: 'POST',
        url: $scope.shippingParcelEndpoint,
        data: params
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          $scope.selectedParcel = {
            id: resp.parcel.id
          };
          $scope.createParcel = {};
          $scope.activeTab = 2;
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.SearchParcels = function (page, query) {
      $scope.loadingMore = true;
      $scope.searchParams.page = page || 1;
      $scope.searchParams.q = query;
      var req = {
        method: 'GET',
        url: $scope.shippingParcelEndpoint,
        params: $scope.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.shippingParcels = resp.parcels;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    $scope.UpdateParcel = function () {
      $scope.loading = true;
      var req = {
        method: 'PUT',
        url: $scope.shippingParcelEndpoint + $scope.selectedParcel.id,
        data: $scope.selectedParcel
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.UpdateWarehouse = function () {
      $scope.loading = true;
      var params = $scope.warehouse;
      var req = {
        method: 'PUT',
        url: Localized.apiURL + '/admin/shipping/warehouse',
        data: params
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.UpdateGateways = function () {
      $scope.loading = true;
      var params = {
        gateways: $scope.gateways
      };
      var req = {
        method: 'PUT',
        url: Localized.apiURL + '/admin/shipping/gateways',
        data: params
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
        Localized.setNotification({
          type: 'success',
          message: 'Gateway Successfully Updated'
        });
      });
    };
  }
})();

/***/ }),

/***/ 7199:
/***/ (() => {

(function () {
  'use strict';

  ShippingController.$inject = ["$scope", "$rootScope", "$stateParams", "Admin", "Debug", "Utils", "Localized"];
  angular.module('vendorfuelApp').controller('ShippingController', ShippingController);
  ShippingController.$inject = ['$scope', '$rootScope', '$stateParams', 'Admin', 'Debug', 'Utils', 'Localized'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   */

  function ShippingController($scope, $rootScope, $stateParams, Admin, Debug, Utils, Localized) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Shipping',
        state: 'shipping'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab) || 0;
      $scope.isAuthed = Admin.Authed();
      $scope.loading = true;
      $scope.modeEndpoint = Localized.apiURL + '/admin/shipping/mode/';
      $scope.shippingMode = null;
      $scope.updating = false;
    };

    this.init();

    $scope.GetModeSetting = function () {
      var req = {
        method: 'GET',
        url: $scope.modeEndpoint
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.shippingMode = resp;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.UpdateModeSetting = function () {
      $scope.updating = true;
      var req = {
        method: 'PUT',
        url: $scope.modeEndpoint,
        data: $scope.shippingMode
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.updating = false;
        Localized.setNotification({
          type: 'success',
          message: 'Shipping Mode Successfully Updated'
        });
      });
    };
  }
})();

/***/ }),

/***/ 8147:
/***/ (() => {

(function () {
  'use strict';

  SubscribeController.$inject = ["$rootScope", "$scope", "$http", "$filter", "Utils", "Settings", "Localized", "$timeout"];
  angular.module('vendorfuelApp').controller('SubscribeController', SubscribeController);
  SubscribeController.$inject = ['$rootScope', '$scope', '$http', '$filter', 'Utils', 'Settings', 'Localized', '$timeout'];
  /**
   * @param {Object} $rootScope Angular service
   * @param {Object} $scope     Angular service
   * @param {Object} $http      Angular service
   * @param {Object} $filter    Angular service
   * @param {Object} Utils      VendorFuel service
   * @param {Object} Settings   VendorFuel service
   * @param {Object} Localized  VendorFuel service
   * @param {Object} $timeout   Angular service
   */

  function SubscribeController($rootScope, $scope, $http, $filter, Utils, Settings, Localized, $timeout) {
    var _this = this;

    /**
     * Initialization
     */
    this.init = function () {
      Utils.redirecting = false;
      _this.breadcrumbs = [{
        name: 'Subscribe',
        state: 'billing'
      }];
      $scope.store = {
        name: '',
        url: '',
        first_name: '',
        last_name: '',
        email: '',
        emailConfirmation: '',
        password: '',
        passwordConfirmation: '',
        phone: ''
      };
      $scope.billing = {
        firstName: '',
        lastName: '',
        addressLineOne: '',
        addressLineTwo: '',
        city: '',
        state: '',
        postalCode: ''
      };
      $scope.formValidation = $scope.store.name || $scope.store.url || $scope.store.first_name || $scope.store.last_name || $scope.store.email || $scope.store.emailConfirmation || $scope.store.password || $scope.store.passwordConfirm;
      $scope.orderComplete = false;
      $scope.payment = {
        cardNumber: '',
        expMonth: '',
        expYear: '',
        cvv: ''
      };
      $scope.selectedTier = null;
      $scope.signUpDisable = '!store.name || !store.url || !store.first_name || !store.last_name || !store.email || !store.emailConfirmation || !store.password || !store.passwordConfirm ||!terms || !privacy';
      $scope.store = {
        storeName: '',
        storeUrl: '',
        first_name: '',
        last_name: '',
        email: '',
        password: '',
        passwordConfirm: ''
      };
      $scope.submittingOrder = false;
      $scope.tiers = [{
        description: 'Kindling',
        pricesheets: '1',
        products: '5',
        price: 0,
        value: 4,
        selected: false
      }, {
        description: 'Ember',
        pricesheets: '1',
        products: '25',
        price: 19,
        value: 1,
        selected: false
      }, {
        description: 'Inferno',
        pricesheets: 'Unlimited',
        products: 'Unlimited',
        price: 99,
        value: 3,
        selected: false
      }, {
        description: 'Flame',
        pricesheets: '2',
        products: '100',
        price: 49,
        value: 2,
        selected: false
      }];
      $scope.vfApiUrl = $rootScope.vfApiUrl;
      Utils.httpGet(Localized.wpRestUrl + '/wp/site/info').then(function successCallback(response) {
        $scope.store.name = response.name;
        $scope.store.url = response.url;
      });
    };

    this.init(); // $scope.cleanErrorMessages = function(str){
    // 	return str.toString().trim()
    // }

    $scope.selectTier = function (tier) {
      $scope.selectedTier = tier;
      angular.forEach($scope.tiers, function (value) {
        if (tier.value === value.value) {
          value.selected = true;
        } else {
          value.selected = false;
        }
      });
    };

    $scope.ToggleShowPassword = function (type) {
      if (type === 'password') {
        $scope.showPassword = !$scope.showPassword;
      }

      if (type === 'conf') {
        $scope.showPasswordConf = !$scope.showPasswordConf;
      }
    };

    $scope.SignUp = function () {
      $scope.errors = [];
      $scope.submittingOrder = true;
      $scope.orderComplete = false;
      var req = {
        method: 'POST',
        url: Localized.apiURL + '/tenant/stores',
        data: {
          store: {
            tier: $scope.selectedTier.value,
            name: $scope.store.name,
            url: $scope.store.url
          },
          user: {
            first_name: $scope.store.first_name,
            last_name: $scope.store.last_name,
            email: $scope.store.email,
            email_confirmation: $scope.store.emailConfirmation,
            password: $scope.store.password,
            password_confirmation: $scope.store.passwordConfirm,
            phone: $scope.store.phone
          }
        }
      };
      $http(req).then(function (resp) {
        angular.forEach(resp.data.errors, function (value) {
          Localized.setNotification({
            type: 'danger',
            message: value
          });
        });
        $scope.storeDetails = resp.data.store;
        $scope.storeDetails.billing = resp.data.billing;
        $timeout(function () {
          if (resp.data && resp.data.errors && resp.data.errors.length > 0) {
            $scope.errors = resp.data.errors;
          } else {
            //TODO: set api_key
            $scope.storeDetails.term = '1 Month';
            $scope.storeDetails.nextBillDate = $filter('date')($scope.storeDetails.billing.next_payment_due, 'longDate');
            Localized.api_key = $scope.storeDetails.api_key;
            Settings.general.Get().then(function successCallback() {
              Settings.general.saved.api_key = Localized.api_key;
              Settings.general.Set();
              $scope.orderComplete = true;
            });
          }

          if (Utils.ReturnLocation !== null) {
            Utils.setLocation(Utils.ReturnLocation, false);
            Utils.ReturnLocation = null;
            Utils.redirecting = false;
          }

          $scope.submittingOrder = false;
        }, 1500);
      }, function (response) {
        if (response.data && response.data.errors) {
          angular.forEach(response.data.errors, function (value) {
            var err = Utils.cleanErrorMessages(value);
            $scope.errors.push(err);
          });
        }

        $scope.submittingOrder = false;
        return response;
      });
    };
  }
})();

/***/ }),

/***/ 5069:
/***/ (() => {

(function () {
  'use strict';

  TenantLoginController.$inject = ["$scope", "Tenant", "Utils", "Admin", "Debug"];
  angular.module('vendorfuelApp').controller('TenantLoginController', TenantLoginController);
  TenantLoginController.$inject = ['$scope', 'Tenant', 'Utils', 'Admin', 'Debug'];
  /**
   * @param {Object} $scope Angular service
   * @param {Object} Tenant VendorFuel service
   * @param {Object} Utils  VendorFuel service
   * @param {Object} Admin  VendorFuel service
   * @param {Object} Debug  VendorFuel service
   */

  function TenantLoginController($scope, Tenant, Utils, Admin, Debug) {
    var parentCallback = $scope.$parent.LoginCallback;
    /**
     * Initialization
     */

    this.init = function () {
      Tenant.login_errors = {};
      Utils.redirecting = false;
      $scope.isAuthed = Admin.Authed();
      $scope.loginErrors = [];
      $scope.loggingIn = false;
      $scope.tenant = Tenant;
      $scope.user = {
        loginEmail: '',
        loginPassword: ''
      };
    };

    this.init();

    $scope.Login = function () {
      Tenant.login_errors = {};
      $scope.loggingIn = true;
      Tenant.Login($scope.user.loginEmail, $scope.user.loginPassword).then(function successCallback() {
        if (parentCallback && Object.keys(Tenant.login_errors).length === 0) {
          parentCallback();
        }

        if (Object.keys(Tenant.login_errors).length) {
          $scope.loginErrors.push(Tenant.login_errors.toString());
          Debug.error($scope.loginErrors);
          Debug.error(Tenant.login_errors);
          $scope.loggingIn = false;
        }

        if (Object.keys(Tenant.login_errors).length === 0) {
          if (Utils.ReturnLocation !== null) {
            Utils.setLocation(Utils.ReturnLocation, false);
            Utils.redirecting = false;
            Utils.ReturnLocation = null;
          }
        }
      });
    };

    $scope.ToggleShowPassword = function (type) {
      if (type === 'password') {
        $scope.showPassword = !$scope.showPassword;
      }
    };
  }
})();

/***/ }),

/***/ 5211:
/***/ (() => {

(function () {
  'use strict';

  compileHtmlDirective.$inject = ["$compile"];
  angular.module('vendorfuelApp').directive('compileHtml', compileHtmlDirective);
  compileHtmlDirective.$inject = ['$compile'];
  /**
   * @param {Object} $compile Angular service
   * @return {Object} Directive
   */

  function compileHtmlDirective($compile) {
    return {
      restrict: 'A',
      link: function link(scope, elem, attrs) {
        scope.$watch(function () {
          return scope.$eval(attrs.compileHtml);
        }, function (value) {
          elem.html(value);
          $compile(elem.contents())(scope);
        });
      }
    };
  }
})();

/***/ }),

/***/ 4562:
/***/ (() => {

(function () {
  'use strict';

  angular.module('vendorfuelApp').directive('copyToClipboard', copyToClipboardDirective);
  /**
   * @return {Object} Directive
   */

  function copyToClipboardDirective() {
    return {
      restrict: 'A',
      link: function link(scope, elem, attrs) {
        elem.on('click', function () {
          if (attrs.copyToClipboard) {
            var $tempInput = jQuery('<input>');
            jQuery('clipboard').append($tempInput);
            $tempInput.val(attrs.copyToClipboard).select();
            document.execCommand('copy');
          }
        });
      }
    };
  }
})();

/***/ }),

/***/ 3264:
/***/ (() => {

(function () {
  'use strict';

  fileModelDirective.$inject = ["$parse"];
  angular.module('vendorfuelApp').directive('fileModel', fileModelDirective);
  fileModelDirective.$inject = ['$parse'];
  /**
   * @param {Object} $parse Angular service
   * @return {Object} Directive
   */

  function fileModelDirective($parse) {
    return {
      restrict: 'A',
      link: function link(scope, element, attrs) {
        var model = $parse(attrs.fileModel);
        var modelSetter = model.assign;
        element.on('change', function () {
          scope.$apply(function () {
            modelSetter(scope.$parent.$parent, element[0].files);
          });
        });
      }
    };
  }
})();

/***/ }),

/***/ 7942:
/***/ (() => {

(function () {
  'use strict';

  formatDirective.$inject = ["$filter"];
  angular.module('vendorfuelApp').directive('format', formatDirective);
  formatDirective.$inject = ['$filter'];
  /**
   * @param {Object} $filter Angular service
   * @return {Object} Directive
   */

  function formatDirective($filter) {
    return {
      require: '?ngModel',
      link: function link(scope, elem, attrs, ctrl) {
        if (!ctrl) {
          return;
        }

        ctrl.$formatters.unshift(function () {
          return $filter(attrs.format)(ctrl.$modelValue);
        });
        elem.on('focus', function () {
          elem.val(ctrl.$modelValue);
        });
        elem.on('blur', function () {
          var plainNumber = elem.val().replace(/[^\d|\-+|.+]/g, '');
          elem.val($filter(attrs.format)(plainNumber));
        });
        angular.element(elem).on('keypress', function (e) {
          var newVal = jQuery(this).val() + (e.charCode !== 0 ? String.fromCharCode(e.charCode) : ''); // @ts-ignore

          if (jQuery(this).val().search(/(.*)\.[0-9][0-9]/) === 0 && newVal.length > jQuery(this).val().length) {
            if (e.charCode !== 8) {
              e.preventDefault();
            }
          }
        });
      }
    };
  }
})();

/***/ }),

/***/ 9457:
/***/ (() => {

(function () {
  'use strict';

  groupFileDirective.$inject = ["$parse"];
  angular.module('vendorfuelApp').directive('groupFile', groupFileDirective);
  groupFileDirective.$inject = ['$parse'];
  /**
   * @param {Object} $parse Angular service
   * @return {Object} Directive
   */

  function groupFileDirective($parse) {
    return {
      restrict: 'A',
      link: function link(scope, element, attrs) {
        var model = $parse(attrs.groupFile);
        var modelSetter = model.assign;
        element.on('change', function () {
          scope.$apply(function () {
            modelSetter(scope.$parent.$parent.$parent.$parent, element[0].files[0]);
          });
        });
      }
    };
  }
})();

/***/ }),

/***/ 1908:
/***/ (() => {

(function () {
  'use strict';

  resizeDirective.$inject = ["$window"];
  angular.module('vendorfuelApp').directive('resize', resizeDirective);
  resizeDirective.$inject = ['$window'];
  /**
   * @param {Object} $window Angular service
   * @return {Object} Directive
   */

  function resizeDirective($window) {
    return function ($scope) {
      getSizing();
      angular.element($window).on('resize', function () {
        $scope.$apply(function () {
          getSizing();
        });
      });
      /**
       *
       */

      function getSizing() {
        $scope.width = $window.innerWidth;
        checkSizing($scope.width);
      }
      /**
       * @param {number} w Width
       */


      function checkSizing(w) {
        if (w < 576) {
          setBools(true);
        } else if (w >= 576 && w < 768) {
          setBools(false, true);
        } else if (w >= 768 && w < 992) {
          setBools(false, false, true);
        } else if (w >= 992 && w < 1200) {
          setBools(false, false, false, true);
        } else if (w >= 1200) {
          setBools(false, false, false, false, true);
        }
      }
      /**
       * @param {boolean} xs Viewport size
       * @param {boolean} sm Viewport size
       * @param {boolean} md Viewport size
       * @param {boolean} lg Viewport size
       * @param {boolean} xl Viewport size
       */


      function setBools(xs, sm, md, lg, xl) {
        $scope.isXS = xs || false;
        $scope.isSM = sm || false;
        $scope.isMD = md || false;
        $scope.isLG = lg || false;
        $scope.isXL = xl || false;
      }
    };
  }
})();

/***/ }),

/***/ 9402:
/***/ (() => {

/**
 * Tel Input Directive
 *
 * @namespace Directives
 */
(function () {
  'use strict';

  telInputDirective.$inject = ["$filter", "$browser"];
  angular.module('vendorfuelApp').directive('telInput', telInputDirective);
  telInputDirective.$inject = ['$filter', '$browser'];
  /**
   * @param {Object} $filter Angular service
   * @param {Object} $browser Angular service
   * @return {Object} Directive
   */

  function telInputDirective($filter, $browser) {
    return {
      require: 'ngModel',
      link: function link($scope, $element, $attrs, ngModelCtrl) {
        var listener = function listener() {
          var value = $element.val().replace(/[^0-9]/g, '');
          $element.val($filter('tel')(value, false));
        }; // This runs when we update the text field


        ngModelCtrl.$parsers.push(function (viewValue) {
          return viewValue.replace(/[^0-9]/g, '').slice(0, 10);
        }); // This runs when the model gets updated on the scope directly and keeps our view in sync

        ngModelCtrl.$render = function () {
          $element.val($filter('tel')(ngModelCtrl.$viewValue, false));
        };

        $element.on('change', listener);
        $element.on('keydown', function (event) {
          var key = event.keyCode; // If the keys include the CTRL, SHIFT, ALT, or META keys, or the arrow keys, do nothing.
          // This lets us support copy and paste too

          if (key === 91 || 15 < key && key < 19 || 37 <= key && key <= 40) {
            return;
          }

          $browser.defer(listener); // Have to do this or changes don't get picked up properly
        });
        $element.on('paste cut', function () {
          $browser.defer(listener);
        });
      }
    };
  }
})();

/***/ }),

/***/ 1569:
/***/ (() => {

/**
 * Tel Filter
 *
 * @namespace Filters
 */
(function () {
  'use strict';

  angular.module('vendorfuelApp').filter('tel', telFilter);
  /**
   * @return {Object} Directive
   */

  function telFilter() {
    return function (tel) {
      if (!tel) {
        return '';
      }

      var regex = '/^+/';
      var value = tel.toString().trim().replace(regex, '');

      if (value.match(/[^0-9]/)) {
        return tel;
      }

      var country, city, number;

      switch (value.length) {
        case 1:
        case 2:
        case 3:
          city = value;
          break;

        default:
          if (value.length === 11) {
            country = value.slice(0, 1);
            city = value.slice(1, 4);
            number = value.slice(4);
          } else {
            city = value.slice(0, 3);
            number = value.slice(3);
          }

      }

      if (number && value.length === 11) {
        // country = '1';
        number = number.slice(0, 3) + '-' + number.slice(3, 7);
        return (country + ' (' + city + ') ' + number).trim();
      } else if (number) {
        if (number.length > 3) {
          number = number.slice(0, 3) + '-' + number.slice(3, 7);
        }

        return ('(' + city + ') ' + number).trim();
      }

      return '(' + city;
    };
  }
})();

/***/ }),

/***/ 2233:
/***/ (() => {

(function () {
  'use strict';

  adminFactory.$inject = ["$http", "$cookies", "Localized", "Debug", "TwoFactorModal"];
  angular.module('vendorfuelApp').factory('Admin', adminFactory);
  adminFactory.$inject = ['$http', '$cookies', 'Localized', 'Debug', 'TwoFactorModal'];
  /**
   * @param {Object} $http          Angular service
   * @param {Object} $cookies       Angular service
   * @param {Object} Localized      VendorFuel service
   * @param {Object} Debug          VendorFuel service
   * @param {Object} TwoFactorModal VendorFuel service
   * @return {Object} Service
   */

  function adminFactory($http, $cookies, Localized, Debug, TwoFactorModal) {
    var admin = {
      authed: false,
      name: '',
      tokens: {
        a: '',
        b: '',
        jwt: ''
      }
    };
    var service = {
      login_errors: {},
      Login: function Login(e, p, a, rememberMe) {
        //TODO: get api url from settings factory
        var request = {
          method: 'POST',
          url: Localized.apiURL + '/admin/login',
          data: {
            email: e,
            password: p,
            authenticator: a
          }
        };
        var promise = $http(request).then(function successCallback(response) {
          if (Object.keys(response.data.errors).length > 0) {
            Debug.error('Login errors: ', response.data.errors);
            service.login_errors = response.data.errors;
          } else {
            if (response.data.token_2fa) {
              var callback = {
                confirm: function confirm(confirmResponse) {
                  var req = {
                    method: 'POST',
                    url: Localized.apiURL + '/admin/authenticate',
                    data: {
                      token_2fa: response.data.token_2fa,
                      auth_code: confirmResponse.code_2fa
                    }
                  };
                  $http(req).then(function (resp) {
                    service.SetTokens(resp.data.name, resp.data.tokena, resp.data.tokenb, rememberMe);
                  }, function (errResp) {
                    Debug.error(errResp);
                  });
                },
                cancel: function cancel() {
                  var req = {
                    method: 'POST',
                    url: Localized.apiURL + '/admin/clear-secret',
                    data: {
                      token_2fa: response.data.token_2fa
                    }
                  };
                  $http(req).then(function () {}, function (errResp) {
                    Debug.error(errResp);
                  });
                },
                params: {
                  imgSrc: response.data.qrCodeUrl,
                  code_2fa: ''
                }
              };
              var modalMessage = '<p>Scan the QR code then enter your VendorFuel authentication code from your mobile app</p>';
              modalMessage += '<label for=\'mdlMsg\'>Authenticator: </label>';
              modalMessage += '<input id=\'mdlMsg\' type=\'text\' ng-model=\'callbackParams.code_2fa\' ng-change=\'ApplyChangeToCallback()\'>';
              TwoFactorModal.Show(callback, 'Google 2-Factor Authentication', modalMessage, 'Back', 'Complete');
            } else {
              service.SetTokens(response.data.name, response.data.tokena, response.data.tokenb, rememberMe);
            }

            var wpReq1 = {
              method: 'GET',
              url: Localized.wpRestUrl + '/templatesJS/'
            };
            $http(wpReq1).then(function (resp) {
              if (resp.data === '' || resp === false) {
                var wpReq2 = {
                  method: 'GET',
                  url: Localized.apiURL + '/templates/combined-js'
                }; // eslint-disable-next-line no-shadow

                $http(wpReq2).then(function (resp) {
                  if (resp.data.js) {
                    var wpReq3 = {
                      method: 'PUT',
                      url: Localized.wpRestUrl + '/templatesJS/',
                      params: {},
                      data: {
                        templateJS: resp.data.js
                      }
                    };
                    $http(wpReq3).then(function () {});
                  }
                }, function (errResp) {
                  Debug.error(errResp);
                });
              }
            }, function (errResp) {
              Debug.error(errResp);
            });
          }

          return response;
        }, function errorCallback(response) {
          if (response.xhrStatus === 'error') {
            service.login_errors.error = 'Invalid VendorFuel API URL.';
          }

          if (Object.keys(response.data.errors).length > 0) {
            Debug.error('Login errors: ', response.data.errors);
            service.login_errors = response.data.errors;
          }

          return response;
        });
        document.getElementById('vf-menu-item-logout').style.display = 'block';
        return promise;
      },
      LoginErrors: function LoginErrors() {
        return service.login_errors;
      },
      Download: function Download(req) {
        return req + '?apikey=' + Localized.api_key + '&tokena=' + $cookies.get('vendorfuel-admin-tokena') + '&tokenb=' + $cookies.get('vendorfuel-admin-tokenb');
      },
      Logout: function Logout() {
        var config = {
          path: '/',
          samesite: 'strict',
          secure: true,
          session: 'none'
        };
        admin.name = null;
        $cookies.remove('vendorfuel-admin-name', config);
        admin.tokens.a = null;
        $cookies.remove('vendorfuel-admin-tokena', config);
        admin.tokens.b = null;
        $cookies.remove('vendorfuel-admin-tokenb', config);
        admin.tokens.jwt = null;
        $cookies.remove('vendorfuel-tenant-token', config);
        admin.authed = false;
        document.getElementById('vf-menu-item-logout').style.display = 'none';
      },
      Authed: function Authed() {
        var tokenA = $cookies.get('vendorfuel-admin-tokena');
        var tokenB = $cookies.get('vendorfuel-admin-tokenb');

        if (tokenA && tokenB) {
          admin.authed = true;
        } else {
          admin.authed = false;
        }

        if (admin.authed) {
          jQuery('#vf-menu-item-logout').parent().parent().removeClass('logout');
        } else {
          jQuery('#vf-menu-item-logout').parent().parent().addClass('logout');
        }

        return admin.authed;
      },
      SetTokens: function SetTokens(name, tokena, tokenb, rememberMe, jwt) {
        var config = {
          path: '/',
          samesite: 'strict',
          secure: true,
          session: 'none'
        };

        if (rememberMe) {
          var d = new Date();
          d.setTime(d.getTime() + 7 * 24 * 60 * 60 * 1000);
          config.expires = d.toUTCString();
        }

        admin.name = name;
        $cookies.put('vendorfuel-admin-name', admin.name);
        admin.tokens.a = tokena;
        $cookies.put('vendorfuel-admin-tokena', admin.tokens.a, config);
        admin.tokens.b = tokenb;
        $cookies.put('vendorfuel-admin-tokenb', admin.tokens.b, config);

        if (jwt) {
          admin.tokens.jwt = jwt;
          $cookies.put('vendorfuel-tenant-token', admin.tokens.jwt, config);
        }

        admin.authed = true;
        return admin.authed;
      }
    };

    if (service.Authed()) {
      jQuery('#vf-menu-item-logout').css('display', 'block');
    }

    return service;
  }
})();

/***/ }),

/***/ 8099:
/***/ (() => {

(function () {
  'use strict';

  customerAccountsFactory.$inject = ["$cookies"];
  angular.module('vendorfuelApp').factory('customerAccounts', customerAccountsFactory);
  customerAccountsFactory.$inject = ['$cookies'];
  /**
   * @param {Object} $cookies Angular service
   * @return {Object} Service
   */

  function customerAccountsFactory($cookies) {
    //Select State DATA
    var states = [{
      name: 'Alabama',
      val: 'AL'
    }, {
      name: 'Alaska',
      val: 'AK'
    }, {
      name: 'Arizona',
      val: 'AZ'
    }, {
      name: 'Arkansas',
      val: 'AR'
    }, {
      name: 'California',
      val: 'CA'
    }, {
      name: 'Colorado',
      val: 'CO'
    }, {
      name: 'Connecticut',
      val: 'CT'
    }, {
      name: 'Delaware',
      val: 'DE'
    }, {
      name: 'Florida',
      val: 'FL'
    }, {
      name: 'Georgia',
      val: 'GA'
    }, {
      name: 'Hawaii',
      val: 'HI'
    }, {
      name: 'Idaho',
      val: 'ID'
    }, {
      name: 'Illinois',
      val: 'IL'
    }, {
      name: 'Indiana',
      val: 'IN'
    }, {
      name: 'Iowa',
      val: 'IA'
    }, {
      name: 'Kansas',
      val: 'KS'
    }, {
      name: 'Kentucky',
      val: 'KY'
    }, {
      name: 'Louisiana',
      val: 'LA'
    }, {
      name: 'Maine',
      val: 'ME'
    }, {
      name: 'Maryland',
      val: 'MD'
    }, {
      name: 'Massachusetts',
      val: 'MA'
    }, {
      name: 'Michigan',
      val: 'MI'
    }, {
      name: 'Minnesota',
      val: 'MN'
    }, {
      name: 'Mississippi',
      val: 'MS'
    }, {
      name: 'Missouri',
      val: 'MO'
    }, {
      name: 'Montana',
      val: 'MT'
    }, {
      name: 'Nebraska',
      val: 'NE'
    }, {
      name: 'Nevada',
      val: 'NV'
    }, {
      name: 'New Hampshire',
      val: 'NH'
    }, {
      name: 'New Jersey',
      val: 'NJ'
    }, {
      name: 'New Mexico',
      val: 'NM'
    }, {
      name: 'New York',
      val: 'NY'
    }, {
      name: 'North Carolina',
      val: 'NC'
    }, {
      name: 'North Dakota',
      val: 'ND'
    }, {
      name: 'Ohio',
      val: 'OH'
    }, {
      name: 'Oklahoma',
      val: 'OK'
    }, {
      name: 'Oregon',
      val: 'OR'
    }, {
      name: 'Pennsylvania',
      val: 'PA'
    }, {
      name: 'Rhode Island',
      val: 'RI'
    }, {
      name: 'South Carolina',
      val: 'SC'
    }, {
      name: 'South Dakota',
      val: 'SD'
    }, {
      name: 'Tennessee',
      val: 'TN'
    }, {
      name: 'Texas',
      val: 'TX'
    }, {
      name: 'Utah',
      val: 'UT'
    }, {
      name: 'Vermont',
      val: 'VT'
    }, {
      name: 'Virgin Islands',
      val: 'VI'
    }, {
      name: 'Virginia',
      val: 'VA'
    }, {
      name: 'Washington',
      val: 'WA'
    }, {
      name: 'West Virginia',
      val: 'WV'
    }, {
      name: 'Wisconsin',
      val: 'WI'
    }, {
      name: 'Wyoming',
      val: 'WY'
    }];
    var service = {
      customerData: function customerData() {
        var data = {
          states: states
        };
        return data;
      },
      clearCookies: function clearCookies() {
        $cookies.remove('vf.user.name', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.email', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.group_admin', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.approver', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.is-guest', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.group', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.remember', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.last_login', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.cart.cartCount', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.punchoutOnly', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.mixedPunchout', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.company', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.defaultShippingProfile', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.defaultBillingProfile', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.group_id', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.group_parent_id', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.price_availability', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.cost_center_is_required', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.user.currentGroup_id', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.cart', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.auth.token', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('vf.cart.cartCount', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
        $cookies.remove('force_password', {
          samesite: 'none',
          secure: true,
          path: '/'
        });
      }
    };
    /**
     *
     */

    return service;
  }
})();

/***/ }),

/***/ 9574:
/***/ (() => {

/**
 * Debug Factory
 *
 * @namespace Factories
 */
(function () {
  'use strict';

  debugFactory.$inject = ["Localized"];
  angular.module('vendorfuelApp').factory('Debug', debugFactory);
  debugFactory.$inject = ['Localized'];
  /**
   * @param {Object} Localized VendorFuel service
   * @return {Object} service
   */

  function debugFactory(Localized) {
    var service = {
      error: error,
      log: log
    };
    return service;
    /**
     * @param {...any} params Parameters
     */

    function log() {
      if (Localized.debugMode) {
        var _console;

        (_console = console).debug.apply(_console, arguments);
      }
    }
    /**
     * @param {...any} params Parameters
     */


    function error() {
      if (Localized.debugMode) {
        var _console2;

        (_console2 = console).error.apply(_console2, arguments);
      }
    }
  }
})();

/***/ }),

/***/ 6314:
/***/ (() => {

(function () {
  'use strict';

  angular.module('vendorfuelApp').factory('EmailsData', emailsDataFactory);
  /**
   * @return {Object} Service
   */

  function emailsDataFactory() {
    var shipmentOptions = [{
      name: 'Site Name',
      value: '%[site-name]%'
    }, {
      name: 'Customer Name',
      value: '%[customer-name]%'
    }, {
      name: 'Shipping Name',
      value: '%[shipping-name]%'
    }, {
      name: 'Shipping Address 1',
      value: '%[shipping-address1]%'
    }, {
      name: 'Shipping Address 2',
      value: '%[shipping-address2]%'
    }, {
      name: 'Shipping City',
      value: '%[shipping-city]%'
    }, {
      name: 'Shipping State',
      value: '%[shipping-state]%'
    }, {
      name: 'Shipping Zip',
      value: '%[shipping-zip]%'
    }, {
      name: 'Shipping Phone',
      value: '%[shipping-phone]%'
    }, {
      name: 'Shipping Email',
      value: '%[shipping-email]%'
    }, {
      name: 'Payment Method',
      value: '%[payment-method]%'
    }, {
      name: 'Subtotal',
      value: '%[subtotal]%'
    }, {
      name: 'Shipping Total',
      value: '%[shipping-total]%'
    }, {
      name: 'Tax Rate',
      value: '%[tax-rate]%'
    }, {
      name: 'Tax Total',
      value: '%[tax-total]%'
    }, {
      name: 'Total',
      value: '%[total]%'
    }, {
      name: 'Billing Name',
      value: '%[billing-name]%'
    }, {
      name: 'Billing Address 1',
      value: '%[billing-address1]%'
    }, {
      name: 'Billing Address 2',
      value: '%[billing-address2]%'
    }, {
      name: 'Billing City',
      value: '%[billing-city]%'
    }, {
      name: 'Billing State',
      value: '%[billing-state]%'
    }, {
      name: 'Billing Zip',
      value: '%[billing-zip]%'
    }, {
      name: 'Billing Email',
      value: '%[billing-email]%'
    }, {
      name: 'Billing Phone',
      value: '%[billing-phone]%'
    }, {
      name: 'First Name',
      value: '%[first-name]%'
    }, {
      name: 'Last Name',
      value: '%[last-name]%'
    }, {
      name: 'Cost Center Code',
      value: '%[cost-center-code]%'
    }, {
      name: 'Purchase Order',
      value: '%[purchase-order]%'
    }, {
      name: 'Issuing Office',
      value: '%[issuing-office]%'
    }, {
      name: 'Notes',
      value: '%[notes]%'
    }, {
      name: 'Organization',
      value: '%[organization]%'
    }, {
      name: 'Attention',
      value: '%[attention]%'
    }, {
      name: 'Approver',
      value: '%[approver]%'
    }, {
      name: 'Approver Notes',
      value: '%[approver-notes]%'
    }, {
      name: 'Promotion Discount',
      value: '%[promo-discount]%'
    }, {
      name: 'EBT Discount',
      value: '%[ebt-discount]%'
    }, {
      name: 'F1 Name',
      value: '%[f1-name]%'
    }, {
      name: 'F1 valueue',
      value: '%[f1-name]%'
    }, {
      name: 'F2 Name',
      value: '%[f2-name]%'
    }, {
      name: 'F2 value',
      value: '%[f2-name]%'
    }, {
      name: 'F3 Name',
      value: '%[f3-name]%'
    }, {
      name: 'F3 value',
      value: '%[f3-name]%'
    }, {
      name: 'F4 Name',
      value: '%[f4-name]%'
    }, {
      name: 'F4 value',
      value: '%[f4-name]%'
    }, {
      name: 'F5 Name',
      value: '%[f5-name]%'
    }, {
      name: 'F5 value',
      value: '%[f5-name]%'
    }, {
      name: 'F6 Name',
      value: '%[f6-name]%'
    }, {
      name: 'F6 value',
      value: '%[f6-name]%'
    }, {
      name: 'RMA Purchase ID',
      value: '%[rma-purchase-id]%'
    }, {
      name: 'RMA Product ID',
      value: '%[rma-product-id]%'
    }, {
      name: 'RMA Sku',
      value: '%[rma-sku]%'
    }, {
      name: 'RMA Description',
      value: '%[rma-description]%'
    }, {
      name: 'RMA Purchase Date',
      value: '%[rma-purchase-date]%'
    }, {
      name: 'RMA Reason',
      value: '%[rma-reason]%'
    }, {
      name: 'RMA Quantity',
      value: '%[rma-quantity]%'
    }, {
      name: 'RMA Email',
      value: '%[rma-email]%'
    }, {
      name: 'RMA Notes',
      value: '%[rma-notes]%'
    }, {
      name: 'RMA Id',
      value: '%[rma-id]%'
    }, {
      name: 'Shipping Date',
      value: '%[shipping-date]%'
    }, {
      name: 'Shipping Carrier',
      value: '%[shipping-carrier]%'
    }, {
      name: 'Shipping Code',
      value: '%[shipping-code]%'
    }, {
      name: 'Order Date',
      value: '%[order-date]%'
    }, {
      name: 'Shipping Id',
      value: '%[shipping-id]%'
    }];
    var shipmentConditionals = [{
      name: 'Site Name',
      value: '%{[site-name] %[site-name]% }%'
    }, {
      name: 'Customer Name',
      value: '%{[customer-name] %[customer-name]% }%'
    }, {
      name: 'Shipping Name',
      value: '%{[shipping-name] %[shipping-name]% }%'
    }, {
      name: 'Shipping Address 1',
      value: '%{[shipping-address1] %[shipping-address1]% }%'
    }, {
      name: 'Shipping Address 2',
      value: '%{[shipping-address2] %[shipping-address2]% }%'
    }, {
      name: 'Shipping City',
      value: '%{[shipping-city] %[shipping-city]% }%'
    }, {
      name: 'Shipping State',
      value: '%{[shipping-state] %[shipping-state]% }%'
    }, {
      name: 'Shipping Zip',
      value: '%{[shipping-zip] %[shipping-zip]% }%'
    }, {
      name: 'Shipping Phone',
      value: '%{[shipping-phone] %[shipping-phone]% }%'
    }, {
      name: 'Shipping Email',
      value: '%{[shipping-email] %[shipping-email]% }%'
    }, {
      name: 'Payment Method',
      value: '%{[payment-method] %[payment-method]% }%'
    }, {
      name: 'Subtotal',
      value: '%{[subtotal] %[subtotal]% }%'
    }, {
      name: 'Shipping Total',
      value: '%{[shipping-total] %[shipping-total]% }%'
    }, {
      name: 'Tax Rate',
      value: '%{[tax-rate] %[tax-rate]% }%'
    }, {
      name: 'Tax Total',
      value: '%{[tax-total] %[tax-total]% }%'
    }, {
      name: 'Total',
      value: '%{[total] %[total]% }%'
    }, {
      name: 'Billing Name',
      value: '%{[billing-name] %[billing-name]% }%'
    }, {
      name: 'Billing Address 1',
      value: '%{[billing-address1] %[billing-address1]% }%'
    }, {
      name: 'Billing Address 2',
      value: '%{[billing-address2] %[billing-address2]% }%'
    }, {
      name: 'Billing City',
      value: '%{[billing-city] %[billing-city]% }%'
    }, {
      name: 'Billing State',
      value: '%{[billing-state] %[billing-state]% }%'
    }, {
      name: 'Billing Zip',
      value: '%{[billing-zip] %[billing-zip]% }%'
    }, {
      name: 'Billing Email',
      value: '%{[billing-email] %[billing-email]% }%'
    }, {
      name: 'Billing Phone',
      value: '%{[billing-phone] %[billing-phone]% }%'
    }, {
      name: 'First Name',
      value: '%{[first-name] %[first-name]% }%'
    }, {
      name: 'Last Name',
      value: '%{[last-name] %[last-name]% }%'
    }, {
      name: 'Cost Center Code',
      value: '%{[cost-center-code] %[cost-center-code]% }%'
    }, {
      name: 'Purchase Order',
      value: '%{[purchase-order] %[purchase-order]% }%'
    }, {
      name: 'Issuing Office',
      value: '%{[issuing-office] %[issuing-office]% }%'
    }, {
      name: 'Notes',
      value: '%{[notes] %[notes]% }%'
    }, {
      name: 'Organization',
      value: '%{[organization] %[organization]% }%'
    }, {
      name: 'Attention',
      value: '%{[attention] %[attention]% }%'
    }, {
      name: 'Approver',
      value: '%{[approver] %[approver]% }%'
    }, {
      name: 'Approver Notes',
      value: '%{[approver-notes] %[approver-notes]% }%'
    }, {
      name: 'Promotion Discount',
      value: '%{[promo-discount] %[promo-discount]% }%'
    }, {
      name: 'EBT Discount',
      value: '%{[ebt-discount] %[ebt-discount]% }%'
    }, {
      name: 'F1 Name',
      value: '%{[f1-name] %[f1-name]% }%'
    }, {
      name: 'F1 value',
      value: '%{[f1-value] %[f1-value]% }%'
    }, {
      name: 'F2 Name',
      value: '%{[f2-name] %[f2-name]% }%'
    }, {
      name: 'F2 value',
      value: '%{[f2-value] %[f2-value]% }%'
    }, {
      name: 'F3 Name',
      value: '%{[f3-name] %[f3-name]% }%'
    }, {
      name: 'F3 value',
      value: '%{[f3-value] %[f3-value]% }%'
    }, {
      name: 'F4 Name',
      value: '%{[f4-name] %[f4-name]% }%'
    }, {
      name: 'F4 value',
      value: '%{[f4-value] %[f4-value]% }%'
    }, {
      name: 'F5 Name',
      value: '%{[f5-name] %[f5-name]% }%'
    }, {
      name: 'F5 value',
      value: '%{[f5-value] %[f5-value]% }%'
    }, {
      name: 'F6 Name',
      value: '%{[f6-name] %[f6-name]% }%'
    }, {
      name: 'F6 value',
      value: '%{[f6-value] %[f6-value]% }%'
    }, {
      name: 'RMA Purchase ID',
      value: '%{[rma-purchase-id] %[rma-purchase-id]% }%'
    }, {
      name: 'RMA Product ID',
      value: '%{[rma-product-id] %[rma-product-id]% }%'
    }, {
      name: 'RMA Sku',
      value: '%{[rma-sku] %[rma-sku]% }%'
    }, {
      name: 'RMA Description',
      value: '%{[rma-description] %[rma-description]% }%'
    }, {
      name: 'RMA Purchase Date',
      value: '%{[rma-purchase-date] %[rma-purchase-date]% }%'
    }, {
      name: 'RMA Reason',
      value: '%{[rma-reason] %[rma-reason]% }%'
    }, {
      name: 'RMA Quantity',
      value: '%{[rma-quantity] %[rma-quantity]% }%'
    }, {
      name: 'RMA Email',
      value: '%{[rma-email] %[rma-email]% }%'
    }, {
      name: 'RMA Notes',
      value: '%{[rma-notes] %[rma-notes]% }%'
    }, {
      name: 'RMA Id',
      value: '%{[rma-id] %[rma-id]% }%'
    }, {
      name: 'Shipping Date',
      value: '%{[shipping-date] %[shipping-date]% }%'
    }, {
      name: 'Shipping Carrier',
      value: '%{[shipping-carrier] %[shipping-carrier]% }%'
    }, {
      name: 'Shipping Code',
      value: '%{[shipping-code] %[shipping-code]% }%'
    }, {
      name: 'Order Date',
      value: '%{[order-date] %[order-date]% }%'
    }, {
      name: 'Shipping Id',
      value: '%{[shipping-id] %[shipping-id]% }%'
    }];
    var checkoutOptions = [{
      name: 'Site Name',
      value: '%[site-name]%'
    }, {
      name: 'Customer Name',
      value: '%[customer-name]%'
    }, {
      name: 'Shipping Name',
      value: '%[shipping-name]%'
    }, {
      name: 'Shipping Address 1',
      value: '%[shipping-address1]%'
    }, {
      name: 'Shipping Address 2',
      value: '%[shipping-address2]%'
    }, {
      name: 'Shipping City',
      value: '%[shipping-city]%'
    }, {
      name: 'Shipping State',
      value: '%[shipping-state]%'
    }, {
      name: 'Shipping Zip',
      value: '%[shipping-zip]%'
    }, {
      name: 'Shipping Phone',
      value: '%[shipping-phone]%'
    }, {
      name: 'Shipping Email',
      value: '%[shipping-email]%'
    }, {
      name: 'Payment Method',
      value: '%[payment-method]%'
    }, {
      name: 'Subtotal',
      value: '%[subtotal]%'
    }, {
      name: 'Shipping Total',
      value: '%[shipping-total]%'
    }, {
      name: 'Tax Rate',
      value: '%[tax-rate]%'
    }, {
      name: 'Tax Total',
      value: '%[tax-total]%'
    }, {
      name: 'Total',
      value: '%[total]%'
    }, {
      name: 'Billing Name',
      value: '%[billing-name]%'
    }, {
      name: 'Billing Address 1',
      value: '%[billing-address1]%'
    }, {
      name: 'Billing Address 2',
      value: '%[billing-address2]%'
    }, {
      name: 'Billing City',
      value: '%[billing-city]%'
    }, {
      name: 'Billing State',
      value: '%[billing-state]%'
    }, {
      name: 'Billing Zip',
      value: '%[billing-zip]%'
    }, {
      name: 'Billing Email',
      value: '%[billing-email]%'
    }, {
      name: 'Billing Phone',
      value: '%[billing-phone]%'
    }, {
      name: 'First Name',
      value: '%[first-name]%'
    }, {
      name: 'Last Name',
      value: '%[last-name]%'
    }, {
      name: 'Cost Center Code',
      value: '%[cost-center-code]%'
    }, {
      name: 'Purchase Order',
      value: '%[purchase-order]%'
    }, {
      name: 'Issuing Office',
      value: '%[issuing-office]%'
    }, {
      name: 'Notes',
      value: '%[notes]%'
    }, {
      name: 'Organization',
      value: '%[organization]%'
    }, {
      name: 'Attention',
      value: '%[attention]%'
    }, {
      name: 'Approver',
      value: '%[approver]%'
    }, {
      name: 'Approver Notes',
      value: '%[approver-notes]%'
    }, {
      name: 'Promotion Discount',
      value: '%[promo-discount]%'
    }, {
      name: 'EBT Discount',
      value: '%[ebt-discount]%'
    }, {
      name: 'F1 Name',
      value: '%[f1-name]%'
    }, {
      name: 'F1 valueue',
      value: '%[f1-name]%'
    }, {
      name: 'F2 Name',
      value: '%[f2-name]%'
    }, {
      name: 'F2 value',
      value: '%[f2-name]%'
    }, {
      name: 'F3 Name',
      value: '%[f3-name]%'
    }, {
      name: 'F3 value',
      value: '%[f3-name]%'
    }, {
      name: 'F4 Name',
      value: '%[f4-name]%'
    }, {
      name: 'F4 value',
      value: '%[f4-name]%'
    }, {
      name: 'F5 Name',
      value: '%[f5-name]%'
    }, {
      name: 'F5 value',
      value: '%[f5-name]%'
    }, {
      name: 'F6 Name',
      value: '%[f6-name]%'
    }, {
      name: 'F6 value',
      value: '%[f6-name]%'
    }, {
      name: 'Order Date',
      value: '%[order-date]%'
    }];
    var checkoutConditionals = [{
      name: 'Site Name',
      value: '%{[site-name] %[site-name]% }%'
    }, {
      name: 'Customer Name',
      value: '%{[customer-name] %[customer-name]% }%'
    }, {
      name: 'Shipping Name',
      value: '%{[shipping-name] %[shipping-name]% }%'
    }, {
      name: 'Shipping Address 1',
      value: '%{[shipping-address1] %[shipping-address1]% }%'
    }, {
      name: 'Shipping Address 2',
      value: '%{[shipping-address2] %[shipping-address2]% }%'
    }, {
      name: 'Shipping City',
      value: '%{[shipping-city] %[shipping-city]% }%'
    }, {
      name: 'Shipping State',
      value: '%{[shipping-state] %[shipping-state]% }%'
    }, {
      name: 'Shipping Zip',
      value: '%{[shipping-zip] %[shipping-zip]% }%'
    }, {
      name: 'Shipping Phone',
      value: '%{[shipping-phone] %[shipping-phone]% }%'
    }, {
      name: 'Shipping Email',
      value: '%{[shipping-email] %[shipping-email]% }%'
    }, {
      name: 'Payment Method',
      value: '%{[payment-method] %[payment-method]% }%'
    }, {
      name: 'Subtotal',
      value: '%{[subtotal] %[subtotal]% }%'
    }, {
      name: 'Shipping Total',
      value: '%{[shipping-total] %[shipping-total]% }%'
    }, {
      name: 'Tax Rate',
      value: '%{[tax-rate] %[tax-rate]% }%'
    }, {
      name: 'Tax Total',
      value: '%{[tax-total] %[tax-total]% }%'
    }, {
      name: 'Total',
      value: '%{[total] %[total]% }%'
    }, {
      name: 'Billing Name',
      value: '%{[billing-name] %[billing-name]% }%'
    }, {
      name: 'Billing Address 1',
      value: '%{[billing-address1] %[billing-address1]% }%'
    }, {
      name: 'Billing Address 2',
      value: '%{[billing-address2] %[billing-address2]% }%'
    }, {
      name: 'Billing City',
      value: '%{[billing-city] %[billing-city]% }%'
    }, {
      name: 'Billing State',
      value: '%{[billing-state] %[billing-state]% }%'
    }, {
      name: 'Billing Zip',
      value: '%{[billing-zip] %[billing-zip]% }%'
    }, {
      name: 'Billing Email',
      value: '%{[billing-email] %[billing-email]% }%'
    }, {
      name: 'Billing Phone',
      value: '%{[billing-phone] %[billing-phone]% }%'
    }, {
      name: 'First Name',
      value: '%{[first-name] %[first-name]% }%'
    }, {
      name: 'Last Name',
      value: '%{[last-name] %[last-name]% }%'
    }, {
      name: 'Cost Center Code',
      value: '%{[cost-center-code] %[cost-center-code]% }%'
    }, {
      name: 'Purchase Order',
      value: '%{[purchase-order] %[purchase-order]% }%'
    }, {
      name: 'Issuing Office',
      value: '%{[issuing-office] %[issuing-office]% }%'
    }, {
      name: 'Notes',
      value: '%{[notes] %[notes]% }%'
    }, {
      name: 'Organization',
      value: '%{[organization] %[organization]% }%'
    }, {
      name: 'Attention',
      value: '%{[attention] %[attention]% }%'
    }, {
      name: 'Approver',
      value: '%{[approver] %[approver]% }%'
    }, {
      name: 'Approver Notes',
      value: '%{[approver-notes] %[approver-notes]% }%'
    }, {
      name: 'Promotion Discount',
      value: '%{[promo-discount] %[promo-discount]% }%'
    }, {
      name: 'EBT Discount',
      value: '%{[ebt-discount] %[ebt-discount]% }%'
    }, {
      name: 'F1 Name',
      value: '%{[f1-name] %[f1-name]% }%'
    }, {
      name: 'F1 value',
      value: '%{[f1-value] %[f1-value]% }%'
    }, {
      name: 'F2 Name',
      value: '%{[f2-name] %[f2-name]% }%'
    }, {
      name: 'F2 value',
      value: '%{[f2-value] %[f2-value]% }%'
    }, {
      name: 'F3 Name',
      value: '%{[f3-name] %[f3-name]% }%'
    }, {
      name: 'F3 value',
      value: '%{[f3-value] %[f3-value]% }%'
    }, {
      name: 'F4 Name',
      value: '%{[f4-name] %[f4-name]% }%'
    }, {
      name: 'F4 value',
      value: '%{[f4-value] %[f4-value]% }%'
    }, {
      name: 'F5 Name',
      value: '%{[f5-name] %[f5-name]% }%'
    }, {
      name: 'F5 value',
      value: '%{[f5-value] %[f5-value]% }%'
    }, {
      name: 'F6 Name',
      value: '%{[f6-name] %[f6-name]% }%'
    }, {
      name: 'F6 value',
      value: '%{[f6-value] %[f6-value]% }%'
    }, {
      name: 'Order Date',
      value: '%{[order-date] %[order-date]% }%'
    }];
    var registerOptions = [{
      name: 'Customer Name',
      value: '%[registration-name]%'
    }, {
      name: 'Site Name',
      value: '%[site-name]%'
    }];
    var rmaOptions = [{
      name: 'RMA Purchase ID',
      value: '%[rma-purchase-id]%'
    }, {
      name: 'RMA Product ID',
      value: '%[rma-product-id]%'
    }, {
      name: 'RMA SKU',
      value: '%[rma-sku]%'
    }, {
      name: 'RMA Description',
      value: '%[rma-description]%'
    }, {
      name: 'RMA Purchase Date',
      value: '%[rma-purchase-date]%'
    }, {
      name: 'RMA Reason',
      value: '%[rma-reason]%'
    }, {
      name: 'RMA Quantity',
      value: '%[rma-quantity]%'
    }, {
      name: 'RMA Contact',
      value: '%[rma-contact]%'
    }, {
      name: 'RMA Notes',
      value: '%[rma-notes]%'
    }, {
      name: 'RMA Request Date',
      value: '%[rma-request-date]%'
    }, {
      name: 'RMA Status',
      value: '%[rma-status]%'
    }];
    var service = {
      dataEmail: function dataEmail() {
        var data = {
          shipmentOptions: shipmentOptions,
          shipmentConditionals: shipmentConditionals,
          checkoutOptions: checkoutOptions,
          checkoutConditionals: checkoutConditionals,
          registerOptions: registerOptions,
          rmaOptions: rmaOptions
        };
        return data;
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 6905:
/***/ (() => {

(function () {
  'use strict';

  interceptorFactory.$inject = ["$q", "$cookies", "Localized", "Debug"];
  angular.module('vendorfuelApp').factory('vfAdminInterceptor', interceptorFactory);
  interceptorFactory.$inject = ['$q', '$cookies', 'Localized', 'Debug'];
  /**
   * @param {Object} $q AngularJS service
   * @param {Object} $cookies AngularJS service
   * @param {Object} Localized VendorFuel service
   * @param {Object} Debug VendorFuel service
   * @return {Object} service
   */

  function interceptorFactory($q, $cookies, Localized, Debug) {
    var service = {
      request: request,
      requestError: requestError,
      response: response,
      responseError: responseError
    };
    return service;
    /**
     * @param {any} config Config
     * @return {Object} Promise
     */

    function request(config) {
      var tokenA = null;
      var tokenB = null;
      var adminJwt = null;
      var logTitle = null;

      if (config.url.includes(Localized.apiURL)) {
        tokenA = $cookies.get('vendorfuel-admin-tokena');
        tokenB = $cookies.get('vendorfuel-admin-tokenb');
        adminJwt = $cookies.get('vendorfuel-tenant-token');
        config.params = config.params || {};

        if (tokenA) {
          config.params.tokena = tokenA;
        }

        if (tokenB) {
          config.params.tokenb = tokenB;
        }

        if (adminJwt) {
          config.params.token = adminJwt;
        }

        if (Localized.api_key) {
          config.params.apikey = Localized.api_key;
        }

        logTitle = 'VF API Request - ' + config.method + config.url.replace(Localized.apiURL, ': ');
      } else if (config.url.includes(Localized.wpRestUrl)) {
        var wpNonce = Localized.wpNonce;
        config.headers = config.headers || {};
        config.headers['x-wp-nonce'] = wpNonce;
        config.headers.tokena = $cookies.get('vendorfuel-admin-tokena');
        config.headers.tokenb = $cookies.get('vendorfuel-admin-tokenb');
        logTitle = 'WP REST API Request - ' + config.method + config.url.replace(Localized.wpRestUrl, ': ');
      }

      if (logTitle) {
        Debug.log(logTitle, config);
      }

      return config || $q.when(config);
    }
    /**
     * @param {any} rejection Rejection
     * @return {Object} Promise
     */


    function requestError(rejection) {
      var logTitle = '';

      if (rejection.config.url.includes(Localized.apiURL)) {
        logTitle = 'VF API Request ERROR';
      } else if (rejection.config.url.includes(Localized.wpRestUrl)) {
        logTitle = 'WP REST API Request ERROR';
      }

      if (logTitle !== '') {
        Debug.log(logTitle, rejection);
      }

      return $q.reject(rejection);
    }
    /**
     * @param {Object} resp Response
     * @return {Object} Promise
     */


    function response(resp) {
      var logTitle = '';

      if (resp.config.url.includes(Localized.apiURL)) {
        if (resp.data.errors && resp.data.errors.length > 0) {
          logTitle = 'VF API Response ERROR - ' + resp.config.method + resp.config.url.replace(Localized.apiURL, ': ') + ' [' + resp.data.errors[0] + ']';
        } else {
          logTitle = 'VF API Response - ' + resp.config.method + resp.config.url.replace(Localized.apiURL, ': ');
        }
      } else if (resp.config.url.includes(Localized.wpRestUrl)) {
        logTitle = 'WP REST API Response - ' + resp.config.method + resp.config.url.replace(Localized.wpRestUrl, ': ');
      }

      if (logTitle !== '') {
        if (resp.title) {
          logTitle += ' - ' + resp.method + ': ' + resp.title;
        }

        Debug.log(logTitle, resp);
      }

      return resp || $q.when(resp);
    }
    /**
     * @param {any} rejection Rejection
     * @return {Object} Promise
     */


    function responseError(rejection) {
      var logTitle = '';

      if (rejection.config.url.includes(Localized.apiURL)) {
        logTitle = 'VF API Response ERROR - ' + rejection.config.method + rejection.config.url.replace(Localized.apiURL, ': ');
      } else if (rejection.config.url.includes(Localized.wpRestUrl)) {
        logTitle = 'WP REST API Response ERROR - ' + rejection.config.method + rejection.config.url.replace(Localized.wpRestUrl, ': ');
      }

      if (logTitle !== '') {
        if (rejection.title) {
          logTitle += ' - ' + rejection.method + ': ' + rejection.title;
        }

        Debug.log(logTitle, rejection);
      }

      return $q.reject(rejection);
    }
  }
})();

/***/ }),

/***/ 2350:
/***/ (() => {

(function () {
  'use strict';

  alertModalFactory.$inject = ["$uibModal", "Localized", "$sce"];
  angular.module('vendorfuelApp').factory('AlertModal', alertModalFactory);
  alertModalFactory.$inject = ['$uibModal', 'Localized', '$sce', '$window', 'Debug'];
  /**
   * @param {Object} $uibModal UI Bootstrap service
   * @param {Object} Localized VendorFuel service
   * @param {Object} $sce Angular service
   * @return {Object} service
   */

  function alertModalFactory($uibModal, Localized, $sce) {
    var service = {
      Show: function Show(callback, title, message, optionConfirm, backdrop, highlightedButton) {
        message = message || '';
        optionConfirm = optionConfirm || 'Confirm';
        backdrop = backdrop || true;
        highlightedButton = highlightedButton || 0;
        var tempConfirmWidth = optionConfirm.length;
        var optionWidth = tempConfirmWidth * 9 + 24;
        var callbackParams = callback.params || {};
        $uibModal.open({
          templateUrl: Localized.root.url + '/assets/app/modals/alert.html',
          backdrop: backdrop,
          controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
            $scope.modalTitle = $sce.trustAsHtml(title);
            $scope.modalMessage = $sce.trustAsHtml(message);
            $scope.optionConfirm = optionConfirm;
            $scope.optionWidth = optionWidth;
            $scope.highlightedButton = highlightedButton;

            $scope.Confirm = function () {
              $uibModalInstance.close();
            };
          }]
        }).result.then(function () {
          callback.confirm(callbackParams);
        }, function () {
          callback.confirm(callbackParams);
        });
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 5492:
/***/ (() => {

(function () {
  'use strict';

  confirmModalFactory.$inject = ["$uibModal", "Localized", "$sce"];
  angular.module('vendorfuelApp').factory('ConfirmModal', confirmModalFactory);
  confirmModalFactory.$inject = ['$uibModal', 'Localized', '$sce'];
  /**
   * @param {Object} $uibModal UI Bootstrap service
   * @param {Object} Localized VendorFuel service
   * @param {Object} $sce Angular service
   * @return {Object} service
   */

  function confirmModalFactory($uibModal, Localized, $sce) {
    var service = {
      Show: function Show(callback, title, message, optionCancel, optionConfirm, backdrop, highlightedButton) {
        message = message || '';
        optionCancel = optionCancel || 'Cancel';
        optionConfirm = optionConfirm || 'Confirm';
        backdrop = backdrop || true;
        highlightedButton = highlightedButton || 0;
        var optionWidth;
        var tempCancelWidth = optionCancel.length;
        var tempConfirmWidth = optionConfirm.length;

        if (tempCancelWidth > tempConfirmWidth) {
          optionWidth = tempCancelWidth * 9 + 24;
        } else {
          optionWidth = tempConfirmWidth * 9 + 24;
        }

        var callbackParams = callback.params || {};
        $uibModal.open({
          templateUrl: Localized.root.url + '/assets/app/modals/confirm.html',
          backdrop: backdrop,
          controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
            $scope.callbackParams = callbackParams;
            $scope.modalTitle = $sce.trustAsHtml(title);
            $scope.modalMessage = $sce.trustAsHtml(message);
            $scope.modalImg = callbackParams.imgSrc;
            $scope.optionCancel = optionCancel;
            $scope.optionConfirm = optionConfirm;
            $scope.optionWidth = optionWidth;
            $scope.highlightedButton = highlightedButton;

            $scope.Cancel = function () {
              $uibModalInstance.dismiss();
            };

            $scope.Confirm = function () {
              $uibModalInstance.close();
            };

            $scope.ApplyChangeToCallback = function () {
              callbackParams = $scope.callbackParams;
            };
          }]
        }).result.then(function () {
          if (callback.confirm) {
            callback.confirm(callbackParams);
          }
        }, function () {
          if (callback.cancel) {
            callback.cancel(callbackParams);
          }
        });
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 9828:
/***/ (() => {

(function () {
  'use strict';

  editModalFactory.$inject = ["$uibModal", "Localized", "$sce"];
  angular.module('vendorfuelApp').factory('EditModal', editModalFactory);
  editModalFactory.$inject = ['$uibModal', 'Localized', '$sce'];
  /**
   * @param {Object} $uibModal UI Bootstrap service
   * @param {Object} Localized VendorFuel service
   * @param {Object} $sce Angular service
   * @return {Object} service
   */

  function editModalFactory($uibModal, Localized, $sce) {
    var service = {
      Show: function Show(callback, valueObj, title, message, optionCancel, optionConfirm, backdrop, highlightedButton) {
        message = message || '';
        optionCancel = optionCancel || 'Cancel';
        optionConfirm = optionConfirm || 'Confirm';
        backdrop = backdrop || true;
        highlightedButton = highlightedButton || 0;
        var optionWidth;
        var tempCancelWidth = optionCancel.length;
        var tempConfirmWidth = optionConfirm.length;

        if (tempCancelWidth > tempConfirmWidth) {
          optionWidth = tempCancelWidth * 9 + 24;
        } else {
          optionWidth = tempConfirmWidth * 9 + 24;
        }

        var callbackParams = callback.params || {};
        $uibModal.open({
          templateUrl: Localized.root.url + '/assets/app/modals/edit.html',
          backdrop: backdrop,
          controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
            $scope.modalTitle = $sce.trustAsHtml(title);
            $scope.modalMessage = $sce.trustAsHtml(message);
            $scope.optionCancel = optionCancel;
            $scope.optionConfirm = optionConfirm;
            $scope.optionWidth = optionWidth;
            $scope.highlightedButton = highlightedButton;
            $scope.valueObj = valueObj;

            $scope.Cancel = function () {
              $uibModalInstance.dismiss();
            };

            $scope.Confirm = function () {
              $uibModalInstance.close();
            };
          }]
        }).result.then(function () {
          if (callback.confirm) {
            callback.confirm(callbackParams, valueObj);
          }
        }, function () {
          if (callback.cancel) {
            callback.cancel(callbackParams, valueObj);
          }
        });
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 1386:
/***/ (() => {

(function () {
  'use strict';

  searchModalFactory.$inject = ["$uibModal", "Localized", "RelationshipSearch"];
  angular.module('vendorfuelApp').factory('SearchModal', searchModalFactory);
  searchModalFactory.$inject = ['$uibModal', 'Localized', 'RelationshipSearch'];
  /**
   * @param {Object} $uibModal UI Bootstrap service
   * @param {Object} Localized VendorFuel service
   * @param {Object} RelationshipSearch VendorFuel service
   * @return {Object} service
   */

  function searchModalFactory($uibModal, Localized, RelationshipSearch) {
    var service = {
      Show: function Show(callback, title, pageConfig, message, optionCancel, optionConfirm, backdrop) {
        message = message || '';
        optionCancel = optionCancel || 'Cancel';
        optionConfirm = optionConfirm || 'Confirm';
        backdrop = backdrop || true;
        var optionWidth;
        var tempCancelWidth = optionCancel.length;
        var tempConfirmWidth = optionConfirm.length;

        if (tempCancelWidth > tempConfirmWidth) {
          optionWidth = tempCancelWidth * 9 + 24;
        } else {
          optionWidth = tempConfirmWidth * 9 + 24;
        }

        $uibModal.open({
          templateUrl: Localized.root.url + '/assets/app/modals/search.html',
          backdrop: backdrop,
          size: 'lg',
          controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
            $scope.relationshipSearch = RelationshipSearch; //Service containing the main functionality for searching and matching relationships

            $scope.modalTitle = title;
            $scope.modalMessage = message;
            $scope.optionCancel = optionCancel;
            $scope.optionConfirm = optionConfirm;
            $scope.optionWidth = optionWidth;
            $scope.pageConfig = pageConfig;
            $scope.removedIds = [];
            $scope.removedObjs = [];
            $scope.addedIds = [];
            $scope.addedObjs = [];
            $scope.deselectedIds = [];
            $scope.deselectedObjs = [];
            $scope.unselectedIds = [];
            $scope.unselectedObjs = [];
            $scope.loading = true;
            $scope.filterBy = ['Search For', 'Search For'];
            $scope.rppValues = [15, 30, 50, 100];
            $scope.per_page = [$scope.rppValues[0], $scope.rppValues[0]];
            $scope.tab = 0;
            $scope.hasOneTab = false;

            if (pageConfig.tabs.length === 1) {
              $scope.hasOneTab = true;
            }

            $scope.results = [[], []];
            $scope.rawResults = [[], []];
            $scope.pagination = [];

            $scope.TabChanged = function (i) {
              $scope.tab = i;
            };

            $scope.selectItem = function (index, tab) {
              var id = $scope.rawResults[tab][index][pageConfig.tabs[tab].id];

              if (tab === 0) {
                if (pageConfig.tabs[0].selectOne) {
                  if ($scope.addedIds.length) {
                    if ($scope.addedIds.includes(id)) {
                      var i = $scope.addedIds.indexOf(id);
                      $scope.addedIds.splice(i, 1);
                      $scope.addedObjs.splice(i, 1);
                    } else {
                      var j = $scope.addedIds.indexOf(id);
                      $scope.addedIds.splice(j, 1);
                      $scope.addedObjs.splice(j, 1);
                      $scope.addedIds.push(id);
                      $scope.addedObjs.push($scope.rawResults[tab][index]);
                    }
                  } else {
                    $scope.addedIds.push(id);
                    $scope.addedObjs.push($scope.rawResults[tab][index]);
                  }
                } else if ($scope.addedIds.includes(id)) {
                  var k = $scope.addedIds.indexOf(id);
                  $scope.addedIds.splice(k, 1);
                  $scope.addedObjs.splice(k, 1);
                  $scope.unselectedIds.push(id);
                  $scope.unselectedObjs.push($scope.rawResults[tab][index]);
                } else {
                  if ($scope.unselectedIds.includes(id)) {
                    var l = $scope.deselectedIds.indexOf(id);
                    $scope.unselectedIds.splice(l, 1);
                    $scope.unselectedObjs.splice(l, 1);
                  }

                  $scope.addedIds.push(id);
                  $scope.addedObjs.push($scope.rawResults[tab][index]);
                }
              }

              if (tab === 1) {
                if ($scope.removedIds.includes(id)) {
                  var q = $scope.removedIds.indexOf(id);
                  $scope.removedIds.splice(q, 1);
                  $scope.removedObjs.splice(q, 1);
                  $scope.deselectedIds.push(id);
                  $scope.deselectedObjs.push($scope.rawResults[tab][index]);
                } else {
                  if ($scope.deselectedIds.includes(id)) {
                    var r = $scope.deselectedIds.indexOf(id);
                    $scope.deselectedIds.splice(r, 1);
                    $scope.deselectedObjs.splice(r, 1);
                  }

                  $scope.removedIds.push(id);
                  $scope.removedObjs.push($scope.rawResults[tab][index]);
                }
              }
            };

            $scope.Init = function () {
              var total = pageConfig.tabs.length;
              var done = 0;

              if (pageConfig.updatedItems) {
                for (var i = 0; i < pageConfig.updatedItems.length; i++) {
                  if (pageConfig.updatedItems[i].action === 'add') {
                    $scope.addedIds.push(pageConfig.updatedItems[i].value[pageConfig.tabs[0].id]);
                    $scope.addedObjs.push(pageConfig.updatedItems[i].value);
                  }

                  if (pageConfig.updatedItems[i].action === 'remove' && !$scope.hasOneTab) {
                    $scope.removedIds.push(pageConfig.updatedItems[i].value[pageConfig.tabs[0].id]);
                    $scope.removedObjs.push(pageConfig.updatedItems[i].value);
                  }
                }
              }

              $scope.relationshipSearch.Init(pageConfig.tabs[0].http).then(function (resp) {
                $scope.pagination[0] = resp[pageConfig.tabs[0].relationships[0]];
                resp[pageConfig.tabs[0].relationships[0]].data.forEach(function (val) {
                  $scope.rawResults[0].push(val);
                  $scope.results[0].push($scope.relationshipSearch.ProcessResults(0, pageConfig, val));
                });
              })["finally"](function () {
                if (++done >= total) {
                  $scope.loading = false;
                }
              });

              if (!$scope.hasOneTab) {
                $scope.relationshipSearch.Init(pageConfig.tabs[1].http).then(function (resp) {
                  $scope.pagination[1] = resp[pageConfig.tabs[1].relationships[0]][pageConfig.tabs[1].relationships[1]];
                  resp[pageConfig.tabs[1].relationships[0]][pageConfig.tabs[1].relationships[1]].data.forEach(function (val) {
                    $scope.rawResults[1].push(val);
                    $scope.results[1].push($scope.relationshipSearch.ProcessResults(1, pageConfig, val));
                  });
                })["finally"](function () {
                  if (++done >= total) {
                    $scope.loading = false;
                  }
                });
              }
            };

            $scope.Cancel = function () {
              $uibModalInstance.dismiss();
            };

            $scope.Confirm = function () {
              var callbackResults = [];

              if ($scope.removedObjs.length) {
                for (var i = 0; i < $scope.removedObjs.length; i++) {
                  callbackResults.push({
                    action: 'remove',
                    value: $scope.removedObjs[i]
                  });
                }
              }

              if ($scope.addedObjs.length) {
                for (var j = 0; j < $scope.addedObjs.length; j++) {
                  callbackResults.push({
                    action: 'add',
                    value: $scope.addedObjs[j]
                  });
                }
              }

              if ($scope.unselectedObjs.length) {
                for (var k = 0; k < $scope.unselectedObjs.length; k++) {
                  callbackResults.push({
                    action: 'unselect',
                    value: $scope.unselectedObjs[k]
                  });
                }
              }

              if ($scope.deselectedObjs.length) {
                for (var l = 0; l < $scope.deselectedObjs.length; l++) {
                  callbackResults.push({
                    action: 'deselect',
                    value: $scope.deselectedObjs[l]
                  });
                }
              }

              $uibModalInstance.close(callbackResults);
            };

            $scope.Search = function (rpp, page) {
              $scope.loading = true;
              $scope.pageConfig.tabs[$scope.tab].http.params.rpp = rpp;
              $scope.pageConfig.tabs[$scope.tab].http.params.page = page || 1;

              if ($scope.filterBy[$scope.tab] === 'Filter Results') {
                $scope.pageConfig.tabs[$scope.tab].http.params.q = '';
              }

              $scope.relationshipSearch.Search($scope.pageConfig.tabs[$scope.tab].http).then(function (resp) {
                if ($scope.tab === 0) {
                  $scope.results[0] = [];
                  $scope.rawResults[0] = [];
                  $scope.pagination[0] = resp[pageConfig.tabs[0].relationships[0]];
                  resp[pageConfig.tabs[0].relationships[0]].data.forEach(function (val) {
                    $scope.rawResults[0].push(val);
                    $scope.results[0].push($scope.relationshipSearch.ProcessResults(0, pageConfig, val));
                  });
                } else {
                  $scope.results[1] = [];
                  $scope.rawResults[1] = [];
                  $scope.pagination[1] = resp[pageConfig.tabs[1].relationships[0]][pageConfig.tabs[1].relationships[1]];
                  resp[pageConfig.tabs[1].relationships[0]][pageConfig.tabs[1].relationships[1]].data.forEach(function (val) {
                    $scope.rawResults[1].push(val);
                    $scope.results[1].push($scope.relationshipSearch.ProcessResults(1, pageConfig, val));
                  });
                }
              })["finally"](function () {
                $scope.loading = false;
              });
            };

            $scope.Init();
          }]
        }).result.then(function (resp) {
          callback.confirm(resp);
        }, function () {
          callback.cancel();
        });
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 4682:
/***/ (() => {

(function () {
  'use strict';

  selectModalFactory.$inject = ["$uibModal", "Localized", "$sce"];
  angular.module('vendorfuelApp').factory('SelectModal', selectModalFactory);
  selectModalFactory.$inject = ['$uibModal', 'Localized', '$sce'];
  /**
   * @param {Object} $uibModal UI Bootstrap service
   * @param {Object} Localized VendorFuel service
   * @param {Object} $sce Angular service
   * @return {Object} service
   */

  function selectModalFactory($uibModal, Localized, $sce) {
    var service = {
      /**
       * @param {any} callback Callback
       * @param {any} title Modal title
       * @param {any} optionArr Option array
       * @param {any} optionCancel Cancel options
       * @param {any} optionConfirm Confirm options
       * @param {boolean} backdrop Display backdrop
       * @param {number} highlightedButton Button index.
       * @function Show
       * Takes in an array of options and allows for activating/deactivating each option individually, or en-mass. Each option is an object with the following parameters: name, value, and active. This array of options is returned to the callback function for handling
       */
      Show: function Show(callback, title, optionArr, optionCancel, optionConfirm, backdrop, highlightedButton) {
        optionCancel = optionCancel || 'Cancel';
        optionConfirm = optionConfirm || 'Confirm';
        backdrop = backdrop || true;
        highlightedButton = highlightedButton || 0;
        var optionWidth;
        var tempCancelWidth = optionCancel.length;
        var tempConfirmWidth = optionConfirm.length;

        if (tempCancelWidth > tempConfirmWidth) {
          optionWidth = tempCancelWidth * 9 + 24;
        } else {
          optionWidth = tempConfirmWidth * 9 + 24;
        }

        var callbackParams = callback.params || {};
        $uibModal.open({
          templateUrl: Localized.root.url + '/assets/app/modals/select.html',
          backdrop: backdrop,
          controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
            $scope.modalTitle = $sce.trustAsHtml(title);
            $scope.options = optionArr;
            $scope.optionCancel = optionCancel;
            $scope.optionConfirm = optionConfirm;
            $scope.optionWidth = optionWidth;
            $scope.highlightedButton = highlightedButton;
            /**
             * Used to filter the options
             *
             * @type {string}
             */

            $scope.filterTerm = '';
            /**
             * Array of options
             *
             * @type {Array}
             */

            callbackParams = $scope.options;
            /**
             * @param {Object} row Row
             * @function OptionFilter
             * @return {number} Matching
             * Filter the array of options based on the filterTerm variable and return only matching results
             */

            $scope.OptionFilter = function (row) {
              return row.name.indexOf($scope.filterTerm || '') !== -1 || row.value.indexOf($scope.filterTerm || '') !== -1;
            };
            /**
             * @function SelectAll
             * Activate all options using the MassSelect function
             */


            $scope.SelectAll = function () {
              massSelect(true);
            };
            /**
             * @function SelectNone
             * Deactivate all options using the MassSelect function
             */


            $scope.SelectNone = function () {
              massSelect(false);
            };
            /**
             * @param {boolean} value Value
             * @function MassSelect
             * Activate/Deactivate all options
             */


            function massSelect(value) {
              angular.forEach($scope.options, function (option) {
                option.active = value;
              });
            }

            $scope.Cancel = function () {
              $uibModalInstance.dismiss();
            };

            $scope.Confirm = function () {
              $uibModalInstance.close();
            };
          }]
        }).result.then(function () {
          if (callback.confirm) {
            callback.confirm(callbackParams);
          }
        }, function () {
          if (callback.cancel) {
            callback.cancel(callbackParams);
          }
        });
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 8027:
/***/ (() => {

(function () {
  'use strict';

  twoFactorModalFactory.$inject = ["$uibModal", "Localized", "$sce"];
  angular.module('vendorfuelApp').factory('TwoFactorModal', twoFactorModalFactory);
  twoFactorModalFactory.$inject = ['$uibModal', 'Localized', '$sce'];
  /**
   * @param {Object} $uibModal UI Bootstrap service
   * @param {Object} Localized VendorFuel service
   * @param {Object} $sce Angular service
   * @return {Object} service
   */

  function twoFactorModalFactory($uibModal, Localized, $sce) {
    var service = {
      Show: function Show(callback, title, message, optionCancel, optionConfirm, backdrop, highlightedButton) {
        message = message || '';
        optionCancel = optionCancel || 'Cancel';
        optionConfirm = optionConfirm || 'Confirm';
        backdrop = backdrop || true;
        highlightedButton = highlightedButton || 0;
        var optionWidth;
        var tempCancelWidth = optionCancel.length;
        var tempConfirmWidth = optionConfirm.length;

        if (tempCancelWidth > tempConfirmWidth) {
          optionWidth = tempCancelWidth * 9 + 24;
        } else {
          optionWidth = tempConfirmWidth * 9 + 24;
        }

        var callbackParams = callback.params || {};
        $uibModal.open({
          templateUrl: Localized.root.url + '/assets/app/modals/two-factor.html',
          backdrop: backdrop,
          controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
            $scope.callbackParams = callbackParams;
            $scope.modalTitle = $sce.trustAsHtml(title);
            $scope.modalMessage = $sce.trustAsHtml(message);
            $scope.modalImg = callbackParams.imgSrc;
            $scope.optionCancel = optionCancel;
            $scope.optionConfirm = optionConfirm;
            $scope.optionWidth = optionWidth;
            $scope.highlightedButton = highlightedButton;

            $scope.Cancel = function () {
              $uibModalInstance.dismiss();
            };

            $scope.Confirm = function () {
              $uibModalInstance.close();
            };

            $scope.ApplyChangeToCallback = function () {
              callbackParams = $scope.callbackParams;
            };
          }]
        }).result.then(function () {
          if (callback.confirm) {
            callback.confirm(callbackParams);
          }
        }, function () {
          if (callback.cancel) {
            callback.cancel(callbackParams);
          }
        });
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 9504:
/***/ (() => {

(function () {
  'use strict';

  viewModalFactory.$inject = ["$uibModal", "Localized", "Utils"];
  angular.module('vendorfuelApp').factory('ViewModal', viewModalFactory);
  viewModalFactory.$inject = ['$uibModal', 'Localized', 'Utils'];
  /**
   * @param {Object} $uibModal UI Bootstrap service
   * @param {Object} Localized VendorFuel service
   * @param {Object} Utils VendorFuel service
   * @return {Object} service
   */

  function viewModalFactory($uibModal, Localized, Utils) {
    var service = {
      Show: function Show(callback, title, dataSet, message, optionCancel, optionConfirm, backdrop) {
        message = message || '';
        optionCancel = optionCancel || 'Cancel';
        optionConfirm = optionConfirm || 'Confirm';
        backdrop = backdrop || true;
        var optionWidth;
        var tempCancelWidth = optionCancel.length;
        var tempConfirmWidth = optionConfirm.length;

        if (tempCancelWidth > tempConfirmWidth) {
          optionWidth = tempCancelWidth * 9 + 24;
        } else {
          optionWidth = tempConfirmWidth * 9 + 24;
        }

        $uibModal.open({
          templateUrl: Localized.root.url + '/assets/app/modals/view.html',
          backdrop: backdrop,
          size: 'lg',
          controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
            $scope.modalTitle = title;
            $scope.modalMessage = message;
            $scope.optionCancel = optionCancel;
            $scope.optionConfirm = optionConfirm;
            $scope.optionWidth = optionWidth;
            $scope.result = dataSet;
            $scope.loading = false;
            $scope.editable = false;
            $scope.priceIndex = 0;
            $scope.priceSheet = $scope.result.pricesheets[$scope.priceIndex].price_sheet_id;

            $scope.Cancel = function () {
              $uibModalInstance.dismiss();
            };

            $scope.Confirm = function () {
              if ($scope.form1.$dirty || $scope.form2.$dirty) {
                $scope.loading = true;
                var req = {
                  method: 'POST',
                  url: Localized.apiURL + '/admin/product/modify/',
                  data: $scope.result
                };
                Utils.getHttpPromise(req).then(function () {
                  $uibModalInstance.close();
                })["finally"](function () {
                  $scope.loading = false;
                });
              } else {
                $scope.Cancel();
              }
            };

            $scope.changePricesheet = function () {
              $scope.priceIndex = $scope.result.pricesheets.map(function (e) {
                return e.price_sheet_id;
              }).indexOf($scope.priceSheet);
            };
          }]
        }).result.then(function (results) {
          callback.confirm(results);
        }, function () {
          callback.cancel();
        });
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 5590:
/***/ (() => {

(function () {
  'use strict';

  priceSheetsFactory.$inject = ["Localized", "Utils", "Admin"];
  angular.module('vendorfuelApp').factory('PriceSheets', priceSheetsFactory);
  priceSheetsFactory.$inject = ['Localized', 'Utils', 'Admin'];
  /**
   * @param {Object} Localized Angular service
   * @param {Object} Utils Angular service
   * @param {Object} Admin Angular service
   * @return {Object} Service
   */

  function priceSheetsFactory(Localized, Utils, Admin) {
    var service = {
      deletePriceSheet: deletePriceSheet,
      errors: {},
      list: {
        name: 'list',
        saved: {},
        Get: function Get() {
          return getPriceSheets(service.list, '/admin/price-sheet/list');
        },
        Set: function Set() {
          var params = {
            settings: JSON.stringify(service.list)
          };
          return postPriceSheets(service.list, params).then(function () {
            if (service.list.api_url !== Localized.apiURL) {
              Localized.apiURL = service.list.api_url;
              Admin.Logout();
            }

            if (service.list.api_key !== Localized.api_key) {
              Localized.api_key = service.list.api_key;
              Admin.Logout();
            }
          });
        }
      }
    };
    /**
     * Delete a price sheet.
     *
     * @param {number} id Price sheet ID
     * @return {Promise} Promise
     */

    function deletePriceSheet(id) {
      var endpoint = "".concat(Localized.apiURL, "/admin/pricesheets/").concat(id);
      return Utils.httpDelete(endpoint);
    }
    /**
     * @param {any} tab Tab
     * @param {string} url URL
     * @return {Object} Promise
     */


    function getPriceSheets(tab, url) {
      var httpUrl = Localized.apiURL + url;

      if (!url) {
        httpUrl = Localized.wpRestUrl + '/admin/price-sheet/' + tab.name + '/get';
      }

      var promise = Utils.httpGet(httpUrl).then(function successCallback(response) {
        tab.saved = response;
      }, function errorCallback(response) {
        tab.saved = response;
      });
      return promise;
    }
    /**
     * @param {any} tab Tab
     * @param {Object} params Parameters
     * @param {string} url URL
     * @return {Object} Promise
     */


    function postPriceSheets(tab, params, url) {
      var httpUrl = Localized.apiURL + url;

      if (!url) {
        httpUrl = Localized.wpRestUrl + '/admin/price-sheet/' + tab.name + '/post';
      }

      var promise = Utils.httpPost(httpUrl, params).then(function successCallback(response) {
        if (response.errors) {
          service.errors = response.errors;
        }
      }, function errorCallback(response) {
        if (response.errors) {
          service.errors = response.errors;
        }
      });
      return promise;
    }

    return service;
  }
})();

/***/ }),

/***/ 8379:
/***/ (() => {

(function () {
  'use strict';

  relationshipSearchFactory.$inject = ["Utils"];
  angular.module('vendorfuelApp').factory('RelationshipSearch', relationshipSearchFactory);
  relationshipSearchFactory.$inject = ['Utils'];
  /**
   * @param {Object} Utils VendorFuel service
   * @return {Object} service
   */

  function relationshipSearchFactory(Utils) {
    var service = {
      Init: function Init(req) {
        return Utils.getHttpPromise(req).then(function (resp) {
          return resp;
        });
      },
      Search: function Search(req) {
        return Utils.getHttpPromise(req).then(function (resp) {
          return resp;
        });
      },
      ProcessResults: function ProcessResults(tab, pageConfig, item) {
        var fields = {};
        var level;
        var levelItem;
        var duplicate;
        var returnField = '';
        fields[pageConfig.tabs[tab].id] = item[pageConfig.tabs[tab].id];

        for (var i = 0; i < pageConfig.tabs[tab].fields.length; i++) {
          levelItem = item;
          level = tab ? 1 : 0;
          duplicate = false;
          returnField = pageConfig.tabs[tab].fields[i];

          if (pageConfig.tabs[tab].fields[i].indexOf('.') > -1) {
            if (levelItem[pageConfig.tabs[tab].relationships[level + 1]]) {
              levelItem = levelItem[pageConfig.tabs[tab].relationships[++level]];
            } else {
              levelItem = levelItem[pageConfig.tabs[tab].relationships[level]];
            }

            pageConfig.tabs[tab].fields[i] = pageConfig.tabs[tab].fields[i].replace('.', '');
            duplicate = true;
          }

          if (pageConfig.tabs[tab].fields[i] === 'image' && levelItem.image) {
            fields[returnField] = levelItem.image.thumb_url;
          } else if (levelItem) {
            fields[returnField] = levelItem[pageConfig.tabs[tab].fields[i]] ? pageConfig.tabs[tab].fieldPrefixes[i] + levelItem[pageConfig.tabs[tab].fields[i]] : levelItem[pageConfig.tabs[tab].fields[i]];
          } else {
            fields[returnField] = pageConfig.tabs[tab].fieldPrefixes[i] + 'N/A';
          }

          if (duplicate) {
            pageConfig.tabs[tab].fields[i] = '.' + pageConfig.tabs[tab].fields[i];
          }
        }

        return fields;
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 8374:
/***/ (() => {

(function () {
  'use strict';

  angular.module('vendorfuelApp').factory('Reports', reportsFactory);
  /**
   * @return {Object} Service
   */

  function reportsFactory() {
    var storeTables = {
      admin_groups: [{
        name: 'Group Id',
        value: 'admin_groups.group_id',
        table: 'admin_groups'
      }, {
        name: 'Type',
        value: 'admin_groups.type',
        table: 'admin_groups'
      }, {
        name: 'Group',
        value: 'admin_groups.group',
        table: 'admin_groups'
      }, {
        name: 'Description',
        value: 'admin_groups.description',
        table: 'admin_groups'
      }, {
        name: 'Users',
        value: 'admin_groups.users',
        table: 'admin_groups'
      }],
      admin_users: [{
        name: 'Admin User Id',
        value: 'admin_users.id',
        table: 'admin_users'
      }, {
        name: 'Name',
        value: 'admin_users.name',
        table: 'admin_users'
      }, {
        name: 'Email',
        value: 'admin_users.email',
        table: 'admin_users'
      }, {
        name: 'Last Login',
        value: 'admin_users.last_login_at',
        table: 'admin_users'
      }, {
        name: 'Created',
        value: 'admin_users.created_at',
        table: 'admin_users'
      }],
      banner_areas: [{
        name: 'Area Id',
        value: 'banner_areas.area_id',
        table: 'banner_areas'
      }, {
        name: 'Name',
        value: 'banner_areas.name',
        table: 'banner_areas'
      }, {
        name: 'Description',
        value: 'banner_areas.description',
        table: 'banner_areas'
      }],
      categories: [{
        name: 'Category Id',
        value: 'categories.cat_id',
        table: 'categories'
      }, {
        name: 'Parent Id',
        value: 'categories.parent_id',
        table: 'categories'
      }, {
        name: 'Title',
        value: 'categories.title',
        table: 'categories'
      }, {
        name: 'UNSPSC',
        value: 'categories.unspsc',
        table: 'categories'
      }, {
        name: 'Slug',
        value: 'categories.slug',
        table: 'categories'
      }],
      customers: [{
        name: 'Name',
        value: 'customers.name',
        table: 'customers'
      }, {
        name: 'Customer Id',
        value: 'customers.id',
        table: 'customers'
      }, {
        name: 'Email',
        value: 'customers.email',
        table: 'customers'
      }, {
        name: 'Punchout Identity',
        value: 'customers.punchout_identity',
        table: 'customers'
      }, {
        name: 'Shared Secret',
        value: 'customers.punchout_secret',
        table: 'customers'
      }, {
        name: 'Terms',
        value: 'customers.terms',
        table: 'customers'
      }, {
        name: 'Order Prefix',
        value: 'customers.order_prefix',
        table: 'customers'
      }, {
        name: 'Limit Type',
        value: 'customers.limit_type',
        table: 'customers'
      }, {
        name: 'Limit',
        value: 'customers.limit',
        table: 'customers'
      }, {
        name: 'Group ',
        value: 'customers.group_id',
        table: 'customers'
      }, {
        name: 'Price Sheet Id',
        value: 'customers.price_sheet_id',
        table: 'customers'
      }, {
        name: 'Credit Line',
        value: 'customers.credit_line',
        table: 'customers'
      }, {
        name: 'Email Optin',
        value: 'customers.optin',
        table: 'customers'
      }, {
        name: 'Taxable',
        value: 'customers.taxable',
        table: 'customers'
      }, {
        name: 'Punchout Only',
        value: 'customers.punchout_only',
        table: 'customers'
      }, {
        name: 'Lock Billing',
        value: 'customers.lock_billing',
        table: 'customers'
      }, {
        name: 'Lock Shipping',
        value: 'customers.lock_shipping',
        table: 'customers'
      }, {
        name: 'Change Password',
        value: 'customers.change_pw',
        table: 'customers'
      }, {
        name: 'Pending Emails',
        value: 'customers.pending_emails',
        table: 'customers'
      }],
      customer_groups: [{
        name: 'Group Id',
        value: 'customer_groups.group_id',
        table: 'customer_groups'
      }, {
        name: 'Parent Group Id',
        value: 'customer_groups.parent_group_id',
        table: 'customer_groups'
      }, {
        name: 'Name',
        value: 'customer_groups.name',
        table: 'customer_groups'
      }, {
        name: 'Default Price Sheet',
        value: 'customer_groups.default_price_sheet',
        table: 'customer_groups'
      }, {
        name: 'Group Invite Code',
        value: 'customer_groups.group_invite_code',
        table: 'customer_groups'
      }, {
        name: 'Authorized Emails',
        value: 'customer_groups.authorized_emails',
        table: 'customer_groups'
      }, {
        name: 'Group Registration Available',
        value: 'customer_groups.group_registration_available',
        table: 'customer_groups'
      }, {
        name: 'Order Prefix',
        value: 'customer_groups.order_prefix',
        table: 'customer_groups'
      }, {
        name: 'Terms',
        value: 'customer_groups.terms',
        table: 'customer_groups'
      }, {
        name: 'Punchout Identity',
        value: 'customer_groups.punchout_identity',
        table: 'customer_groups'
      }, {
        name: 'Punchout Secret',
        value: 'customer_groups.punchout_secret',
        table: 'customer_groups'
      }, {
        name: 'Shipping Mode',
        value: 'customer_groups.shipping_mode',
        table: 'customer_groups'
      }],
      email_templates: [{
        name: 'Template Id',
        value: 'email_templates.id',
        table: 'email_templates'
      }, {
        name: 'Type',
        value: 'email_templates.type',
        table: 'email_templates'
      }, {
        name: 'Sender Name',
        value: 'email_templates.sender_name',
        table: 'email_templates'
      }, {
        name: 'Sender Email',
        value: 'email_templates.sender_email',
        table: 'email_templates'
      }, {
        name: 'Subject',
        value: 'email_templates.subject',
        table: 'email_templates'
      }, {
        name: 'Message',
        value: 'email_templates.message',
        table: 'email_templates'
      }, {
        name: 'Notification Emails',
        value: 'email_templates.notification_emails',
        table: 'email_templates'
      }],
      manufacturers: [{
        name: 'Manufacturer Id',
        value: 'manufacturers.id',
        table: 'manufacturers'
      }, {
        name: 'Manufacturer',
        value: 'manufacturers.name',
        table: 'manufacturers'
      }, {
        name: 'Info',
        value: 'manufacturers.info',
        table: 'manufacturers'
      }, {
        name: 'Website',
        value: 'manufacturers.website',
        table: 'manufacturers'
      }],
      parcels: [{
        name: 'Parcel Id',
        value: 'parcels.id',
        table: 'parcels'
      }, {
        name: 'Title',
        value: 'parcels.title',
        table: 'parcels'
      }, {
        name: 'Length',
        value: 'parcels.length',
        table: 'parcels'
      }, {
        name: 'Width',
        value: 'parcels.width',
        table: 'parcels'
      }, {
        name: 'Height',
        value: 'parcels.height',
        table: 'parcels'
      }, {
        name: 'Units',
        value: 'parcels.distance_unit',
        table: 'parcels'
      }],
      collections: [{
        name: 'Collection Id',
        value: 'collections.id',
        table: 'collections'
      }, {
        name: 'Name',
        value: 'collections.name',
        table: 'collections'
      }],
      order_notifications: [{
        name: 'Notification Id',
        value: 'order_notifications.notification_id',
        table: 'order_notifications'
      }, {
        name: 'Order Id',
        value: 'order_notifications.order_id',
        table: 'order_notifications'
      }, {
        name: 'Status',
        value: 'order_notifications.status',
        table: 'order_notifications'
      }, {
        name: 'Type',
        value: 'order_notifications.type',
        table: 'order_notifications'
      }, {
        name: 'Recipient',
        value: 'order_notifications.recipient',
        table: 'order_notifications'
      }, {
        name: 'body',
        value: 'order_notifications.body',
        table: 'order_notifications'
      }, {
        name: 'Response',
        value: 'order_notifications.response',
        table: 'order_notifications'
      }],
      product_uom: [{
        name: 'uom Id',
        value: 'product_uom.uom_id',
        table: 'product_uom'
      }, {
        name: 'uom',
        value: 'product_uom.uom',
        table: 'product_uom'
      }, {
        name: 'Code',
        value: 'product_uom.code',
        table: 'product_uom'
      }, {
        name: 'Description',
        value: 'product_uom.description',
        table: 'product_uom'
      }],
      price_sheets_index: [{
        name: 'Price Sheet Id',
        value: 'price_sheets_index.price_sheet_id',
        table: 'price_sheets_index'
      }, {
        name: 'Sheet',
        value: 'price_sheets_index.sheet',
        table: 'price_sheets_index'
      }, {
        name: 'Site Id',
        value: 'price_sheets_index.site_id',
        table: 'price_sheets_index'
      }, {
        name: 'GP Price Sheet',
        value: 'price_sheets_index.gp_price_sheet',
        table: 'price_sheets_index'
      }],
      products: [{
        name: 'Product Id',
        value: 'products.product_id',
        table: 'products'
      }, {
        name: 'SKU',
        value: 'products.sku',
        table: 'products'
      }, {
        name: 'Slug',
        value: 'products.slug',
        table: 'products'
      }, {
        name: 'UPC',
        value: 'products.upc',
        table: 'products'
      }, {
        name: 'Qty',
        value: 'products.qty',
        table: 'products'
      }, {
        name: 'Manufacturer Id',
        value: 'products.manufacturer_id',
        table: 'products'
      }, {
        name: 'Brand Name',
        value: 'products.brand_name',
        table: 'products'
      }, {
        name: 'Country',
        value: 'products.country',
        table: 'products'
      }, {
        name: 'Device',
        value: 'products.device',
        table: 'products'
      }, {
        name: 'Family',
        value: 'products.family',
        table: 'products'
      }, {
        name: 'Green',
        value: 'products.green',
        table: 'products'
      }, {
        name: 'Green Attributes',
        value: 'products.green_attributes',
        table: 'products'
      }, {
        name: 'Hazmat',
        value: 'products.hazmat',
        table: 'products'
      }, {
        name: 'Includes',
        value: 'products.includes',
        table: 'products'
      }, {
        name: 'Keywords',
        value: 'products.keywords',
        table: 'products'
      }, {
        name: 'Model',
        value: 'products.model',
        table: 'products'
      }, {
        name: 'Msds',
        value: 'products.msds',
        table: 'products'
      }, {
        name: 'Rebate',
        value: 'products.rebate',
        table: 'products'
      }, {
        name: 'Related',
        value: 'products.related',
        table: 'products'
      }, {
        name: 'Alternates',
        value: 'products.alternates',
        table: 'products'
      }, {
        name: 'Truck Only',
        value: 'products.truck_only',
        table: 'products'
      }, {
        name: 'Category',
        value: 'products.category_id',
        table: 'products'
      }, {
        name: 'UoM ID',
        value: 'products.uomid',
        table: 'products'
      }, {
        name: 'UoM Qty',
        value: 'products.uomqty',
        table: 'products'
      }, {
        name: 'UoM Desc',
        value: 'products.uomdesc',
        table: 'products'
      }, {
        name: 'Description',
        value: 'products.description',
        table: 'products'
      }, {
        name: 'Long Description',
        value: 'products.long_description',
        table: 'products'
      }, {
        name: 'Attribute 1 Name',
        value: 'products.att1n',
        table: 'products'
      }, {
        name: 'Attribute 1 Data',
        value: 'products.att1d',
        table: 'products'
      }, {
        name: 'Attribute 2 Name',
        value: 'products.att2n',
        table: 'products'
      }, {
        name: 'Attribute 2 Data',
        value: 'products.att2d',
        table: 'products'
      }, {
        name: 'Attribute 3 Name',
        value: 'products.att3n',
        table: 'products'
      }, {
        name: 'Attribute 3 Data',
        value: 'products.att3d',
        table: 'products'
      }, {
        name: 'Attribute 4 Name',
        value: 'products.att4n',
        table: 'products'
      }, {
        name: 'Attribute 4 Data',
        value: 'products.att4d',
        table: 'products'
      }, {
        name: 'Attribute 5 Name',
        value: 'products.att5n',
        table: 'products'
      }, {
        name: 'Attribute 5 Data',
        value: 'products.att5d',
        table: 'products'
      }, {
        name: 'Attribute 6 Name',
        value: 'products.att6n',
        table: 'products'
      }, {
        name: 'Attribute 6 Data',
        value: 'products.att6d',
        table: 'products'
      }, {
        name: 'Attribute 7 Name',
        value: 'products.att7n',
        table: 'products'
      }, {
        name: 'Attribute 7 Data',
        value: 'products.att7d',
        table: 'products'
      }, {
        name: 'Attribute 8 Name',
        value: 'products.att8n',
        table: 'products'
      }, {
        name: 'Attribute 8 Data',
        value: 'products.att8d',
        table: 'products'
      }, {
        name: 'Attribute 9 Name',
        value: 'products.att9n',
        table: 'products'
      }, {
        name: 'Attribute 9 Data',
        value: 'products.att9d',
        table: 'products'
      }, {
        name: 'Attribute 10 Name',
        value: 'products.att10n',
        table: 'products'
      }, {
        name: 'Attribute 10 Data',
        value: 'products.att10d',
        table: 'products'
      }, {
        name: 'Attribute 11 Name',
        value: 'products.att11n',
        table: 'products'
      }, {
        name: 'Attribute 11 Data',
        value: 'products.att11d',
        table: 'products'
      }, {
        name: 'Attribute 12 Name',
        value: 'products.att12n',
        table: 'products'
      }, {
        name: 'Attribute 12 Data',
        value: 'products.att12d',
        table: 'products'
      }, {
        name: 'Attribute 13 Name',
        value: 'products.att13n',
        table: 'products'
      }, {
        name: 'Attribute 13 Data',
        value: 'products.att13d',
        table: 'products'
      }, {
        name: 'Attribute 14 Name',
        value: 'products.att14n',
        table: 'products'
      }, {
        name: 'Attribute 14 Data',
        value: 'products.att14d',
        table: 'products'
      }, {
        name: 'Attribute 15 Name',
        value: 'products.att15n',
        table: 'products'
      }, {
        name: 'Attribute 15 Data',
        value: 'products.att15d',
        table: 'products'
      }, {
        name: 'Attribute 16 Name',
        value: 'products.att16n',
        table: 'products'
      }, {
        name: 'Attribute 16 Data',
        value: 'products.att16d',
        table: 'products'
      }, {
        name: 'Attribute 17 Name',
        value: 'products.att17n',
        table: 'products'
      }, {
        name: 'Attribute 17 Data',
        value: 'products.att17d',
        table: 'products'
      }, {
        name: 'Attribute 18 Name',
        value: 'products.att18n',
        table: 'products'
      }, {
        name: 'Attribute 18 Data',
        value: 'products.att18d',
        table: 'products'
      }, {
        name: 'Mfg Part #',
        value: 'products.mfg_part_num',
        table: 'products'
      }, {
        name: 'Ability One Sku',
        value: 'products.ability_one_sku',
        table: 'products'
      }, {
        name: 'Status',
        value: 'products.status',
        table: 'products'
      }, {
        name: 'Rating',
        value: 'products.average_rating',
        table: 'products'
      }],
      orders: [{
        name: 'Order Id',
        value: 'orders.order_id',
        table: 'orders'
      }, {
        name: 'Group Id',
        value: 'orders.group_id',
        table: 'orders'
      }, {
        name: 'Customer Id',
        value: 'orders.customer_id',
        table: 'orders'
      }, {
        name: 'Approver Id',
        value: 'orders.approver_id',
        table: 'orders'
      }, {
        name: 'Shipping Id',
        value: 'orders.shipping_id',
        table: 'orders'
      }, {
        name: 'Billing Id',
        value: 'orders.billing_id',
        table: 'orders'
      }, {
        name: 'Cost Center Id',
        value: 'orders.cost_center_id',
        table: 'orders'
      }, {
        name: 'Shipping Rule Id',
        value: 'orders.shipping_rule_id',
        table: 'orders'
      }, {
        name: 'Cost Center Code',
        value: 'orders.cost_center_code',
        table: 'orders'
      }, {
        name: 'Price Sheet',
        value: 'orders.price_sheet',
        table: 'orders'
      }, {
        name: 'Loc Id',
        value: 'orders.loc_id',
        table: 'orders'
      }, {
        name: 'Trx Redeemed',
        value: 'orders.trx_redeemed',
        table: 'orders'
      }, {
        name: 'Status',
        value: 'orders.status',
        table: 'orders'
      }, {
        name: 'Order Shipped',
        value: 'orders.order_shipped',
        table: 'orders'
      }, {
        name: 'Tracking Code',
        value: 'orders.tracking_code',
        table: 'orders'
      }, {
        name: 'Shipping Method',
        value: 'orders.shipping_method',
        table: 'orders'
      }, {
        name: 'Shipping Carrier',
        value: 'orders.shipping_carrier',
        table: 'orders'
      }, {
        name: 'Order Date',
        value: 'orders.order_date',
        table: 'orders'
      }, {
        name: 'Subtotal',
        value: 'orders.subtotal',
        table: 'orders'
      }, {
        name: 'Tax',
        value: 'orders.tax',
        table: 'orders'
      }, {
        name: 'Tax Rate',
        value: 'orders.tax_rate',
        table: 'orders'
      }, {
        name: 'Shipping',
        value: 'orders.shipping',
        table: 'orders'
      }, {
        name: 'Discount',
        value: 'orders.discount',
        table: 'orders'
      }, {
        name: 'Promo Discount',
        value: 'orders.promo_discount',
        table: 'orders'
      }, {
        name: 'Total Amount',
        value: 'orders.total_amt',
        table: 'orders'
      }, {
        name: 'RR PO Num',
        value: 'orders.rr_po_num',
        table: 'orders'
      }, {
        name: 'Issuing Office',
        value: 'orders.issuing_office',
        table: 'orders'
      }, {
        name: 'Approver',
        value: 'orders.approver',
        table: 'orders'
      }, {
        name: 'Attention',
        value: 'orders.attention',
        table: 'orders'
      }, {
        name: 'Organization',
        value: 'orders.organization',
        table: 'orders'
      }, {
        name: 'First Name',
        value: 'orders.first_name',
        table: 'orders'
      }, {
        name: 'Last Name',
        value: 'orders.last_name',
        table: 'orders'
      }, {
        name: 'Email',
        value: 'orders.email',
        table: 'orders'
      }, {
        name: 'Phone',
        value: 'orders.phone',
        table: 'orders'
      }, {
        name: 'Billing First Name',
        value: 'orders.bill_first_name',
        table: 'orders'
      }, {
        name: 'Billing Last Name',
        value: 'orders.bill_last_name',
        table: 'orders'
      }, {
        name: 'Billing Email',
        value: 'orders.bill_email',
        table: 'orders'
      }, {
        name: 'Billing Phone',
        value: 'orders.bill_phone',
        table: 'orders'
      }, {
        name: 'Payment Method',
        value: 'orders.payment_method',
        table: 'orders'
      }, {
        name: 'Credit Line',
        value: 'orders.credit_line',
        table: 'orders'
      }, {
        name: 'Credit Card',
        value: 'orders.credit_card',
        table: 'orders'
      }, {
        name: 'CC Type',
        value: 'orders.cctype',
        table: 'orders'
      }, {
        name: 'Shipping Profile',
        value: 'orders.shipping_profile',
        table: 'orders'
      }, {
        name: 'Address 1',
        value: 'orders.address1',
        table: 'orders'
      }, {
        name: 'Address 2',
        value: 'orders.address2',
        table: 'orders'
      }, {
        name: 'City',
        value: 'orders.city',
        table: 'orders'
      }, {
        name: 'State',
        value: 'orders.state',
        table: 'orders'
      }, {
        name: 'Zip',
        value: 'orders.zip',
        table: 'orders'
      }, {
        name: 'Billing Address 1',
        value: 'orders.bill_address1',
        table: 'orders'
      }, {
        name: 'Billing Address 2',
        value: 'orders.bill_address2',
        table: 'orders'
      }, {
        name: 'Billing City',
        value: 'orders.bill_city',
        table: 'orders'
      }, {
        name: 'Billing State',
        value: 'orders.bill_state',
        table: 'orders'
      }, {
        name: 'Billing Zip',
        value: 'orders.bill_zip',
        table: 'orders'
      }, {
        name: 'Notes',
        value: 'orders.notes',
        table: 'orders'
      }, {
        name: 'GSA Total',
        value: 'orders.gsa_total',
        table: 'orders'
      }, {
        name: 'Other Total',
        value: 'orders.other_total',
        table: 'orders'
      }, {
        name: 'Approver Notes',
        value: 'orders.approver_notes',
        table: 'orders'
      }, {
        name: 'Promo Codes',
        value: 'orders.promo_codes',
        table: 'orders'
      }, {
        name: 'F1 Replace Field',
        value: 'orders.f1_replace_field',
        table: 'orders'
      }, {
        name: 'F1 Name',
        value: 'orders.f1_name',
        table: 'orders'
      }, {
        name: 'F1 XML Location',
        value: 'orders.f1_xml_location',
        table: 'orders'
      }, {
        name: 'F1 Value',
        value: 'orders.f1_value',
        table: 'orders'
      }, {
        name: 'F2 Replace Field',
        value: 'orders.f2_replace_field',
        table: 'orders'
      }, {
        name: 'F2 Name',
        value: 'orders.f2_name',
        table: 'orders'
      }, {
        name: 'F2 XML Location',
        value: 'orders.f2_xml_location',
        table: 'orders'
      }, {
        name: 'F2 Value',
        value: 'orders.f2_value',
        table: 'orders'
      }, {
        name: 'F3 Name',
        value: 'orders.f3_name',
        table: 'orders'
      }, {
        name: 'F3 Value',
        value: 'orders.f3_name',
        table: 'orders'
      }, {
        name: 'F4 Name',
        value: 'orders.f4_name',
        table: 'orders'
      }, {
        name: 'F4 Value',
        value: 'orders.f4_name',
        table: 'orders'
      }, {
        name: 'F5 Name',
        value: 'orders.f5_name',
        table: 'orders'
      }, {
        name: 'F5 Value',
        value: 'orders.f5_name',
        table: 'orders'
      }, {
        name: 'F6 Name',
        value: 'orders.f6_name',
        table: 'orders'
      }, {
        name: 'F6 Value',
        value: 'orders.f6_name',
        table: 'orders'
      }, {
        name: 'Reference Id',
        value: 'orders.reference_id',
        table: 'orders'
      }, {
        name: 'Payload Id',
        value: 'orders.payload_id',
        table: 'orders'
      }, {
        name: 'Postback Url',
        value: 'orders.postback_url',
        table: 'orders'
      }, {
        name: 'Shipping Token',
        value: 'orders.shipping_token',
        table: 'orders'
      }]
    };
    var joinTables = {
      group_admins: [{
        name: 'Customer ID',
        value: 'group_admins.customer_id',
        table: 'group_admins'
      }, {
        name: 'Group ID',
        value: 'group_admins.group_id',
        table: 'group_admins'
      }],
      group_approvers: [{
        name: 'Customer ID',
        value: 'group_approvers.customer_id',
        table: 'group_approvers'
      }, {
        name: 'Group ID',
        value: 'group_approvers.group_id',
        table: 'group_approvers'
      }],
      inventory_logs: [{
        name: 'Id',
        value: 'inventory_logs.id',
        table: 'inventory_logs'
      }, {
        name: 'Product Id',
        value: 'inventory_logs.product_id',
        table: 'inventory_logs'
      }, {
        name: 'In',
        value: 'inventory_logs.inventory_in',
        table: 'inventory_logs'
      }, {
        name: 'Out',
        value: 'inventory_logs.inventory_out',
        table: 'inventory_logs'
      }, {
        name: 'Date',
        value: 'inventory_logs.created_at',
        table: 'inventory_logs'
      }],
      pending_items: [{
        name: 'Id',
        value: 'pending_items.pend_id',
        table: 'pending_items'
      }, {
        name: 'Cart Items Id',
        value: 'pending_items.cart_item_id',
        table: 'pending_items'
      }, {
        name: 'Order Id',
        value: 'pending_items.order_id',
        table: 'pending_items'
      }, {
        name: 'Product Id',
        value: 'pending_items.product_id',
        table: 'pending_items'
      }, {
        name: 'Qty',
        value: 'pending_items.qty',
        table: 'pending_items'
      }, {
        name: 'Price',
        value: 'pending_items.price',
        table: 'pending_items'
      }],
      price_sheets: [{
        name: 'Id',
        value: 'price_sheets.ps_item_id',
        table: 'price_sheets'
      }, {
        name: 'Price Sheet Id',
        value: 'price_sheets.price_sheet_id',
        table: 'price_sheets'
      }, {
        name: 'Product Id',
        value: 'price_sheets.product_id',
        table: 'price_sheets'
      }, {
        name: 'Sku',
        value: 'price_sheets.sku',
        table: 'price_sheets'
      }, {
        name: 'GSA',
        value: 'price_sheets.gsa',
        table: 'price_sheets'
      }, {
        name: 'Ability One',
        value: 'price_sheets.ability_one',
        table: 'price_sheets'
      }, {
        name: 'Core List',
        value: 'price_sheets.core_list',
        table: 'price_sheets'
      }, {
        name: 'Price',
        value: 'price_sheets.price',
        table: 'price_sheets'
      }],
      product_collection: [{
        name: 'Collection Id',
        value: 'product_collection.collection_id',
        table: 'product_collection'
      }, {
        name: 'Product ID',
        value: 'product_collection.product_id',
        table: 'product_collection'
      }],
      purchased_items: [{
        name: 'Purchase Id',
        value: 'purchased_items.purch_id',
        table: 'purchased_items'
      }, {
        name: 'Customer Id',
        value: 'purchased_items.customer_id',
        table: 'purchased_items'
      }, {
        name: 'Order Id',
        value: 'purchased_items.order_id',
        table: 'purchased_items'
      }, {
        name: 'Product Id',
        value: 'purchased_items.product_id',
        table: 'purchased_items'
      }, {
        name: 'Purchase Date',
        value: 'purchased_items.purchase_date',
        table: 'purchased_items'
      }, {
        name: 'Quantity',
        value: 'purchased_items.qty',
        table: 'purchased_items'
      }, {
        name: 'Price',
        value: 'purchased_items.price',
        table: 'purchased_items'
      }, {
        name: 'GSA',
        value: 'purchased_items.gsa',
        table: 'purchased_items'
      }, {
        name: 'Ability One',
        value: 'purchased_items.ability_one',
        table: 'purchased_items'
      }, {
        name: 'Core List',
        value: 'purchased_items.core_list',
        table: 'purchased_items'
      }, {
        name: 'Return Status',
        value: 'purchased_items.return_status',
        table: 'purchased_items'
      }, {
        name: 'Return Request Date',
        value: 'purchased_items.return_request_date',
        table: 'purchased_items'
      }, {
        name: 'Return Respone Notes',
        value: 'purchased_items.return_response_notes',
        table: 'purchased_items'
      }, {
        name: 'Return Reason',
        value: 'purchased_items.return_reason',
        table: 'purchased_items'
      }, {
        name: 'Return Qty',
        value: 'purchased_items.return_qty',
        table: 'purchased_items'
      }, {
        name: 'Return Contact',
        value: 'purchased_items.return_contact',
        table: 'purchased_items'
      }, {
        name: 'Return Boxes',
        value: 'purchased_items.return_boxes',
        table: 'purchased_items'
      }],
      saved_billing: [{
        name: 'Id',
        value: 'saved_billing.billing_id',
        table: 'saved_billing'
      }, {
        name: 'Customer Id',
        value: 'saved_billing.customer_id',
        table: 'saved_billing'
      }, {
        name: 'Name',
        value: 'saved_billing.billing_name',
        table: 'saved_billing'
      }, {
        name: 'First Name',
        value: 'saved_billing.first_name',
        table: 'saved_billing'
      }, {
        name: 'Last Name',
        value: 'saved_billing.last_name',
        table: 'saved_billing'
      }, {
        name: 'Email',
        value: 'saved_billing.email',
        table: 'saved_billing'
      }, {
        name: 'Address 1',
        value: 'saved_billing.address1',
        table: 'saved_billing'
      }, {
        name: 'Address 2',
        value: 'saved_billing.address2',
        table: 'saved_billing'
      }, {
        name: 'City',
        value: 'saved_billing.city',
        table: 'saved_billing'
      }, {
        name: 'State',
        value: 'saved_billing.state',
        table: 'saved_billing'
      }, {
        name: 'Zip',
        value: 'saved_billing.zip',
        table: 'saved_billing'
      }, {
        name: 'Area Code',
        value: 'saved_billing.areacode',
        table: 'saved_billing'
      }, {
        name: 'Phone',
        value: 'saved_billing.phone',
        table: 'saved_billing'
      }, {
        name: 'Active',
        value: 'saved_billing.active',
        table: 'saved_billing'
      }],
      saved_shipping: [{
        name: 'Id',
        value: 'saved_shipping.shipping_id',
        table: 'saved_shipping'
      }, {
        name: 'Customer Id',
        value: 'saved_shipping.customer_id',
        table: 'saved_shipping'
      }, {
        name: 'Name',
        value: 'saved_shipping.shipping_name',
        table: 'saved_shipping'
      }, {
        name: 'First Name',
        value: 'saved_shipping.first_name',
        table: 'saved_shipping'
      }, {
        name: 'Last Name',
        value: 'saved_shipping.last_name',
        table: 'saved_shipping'
      }, {
        name: 'Email',
        value: 'saved_shipping.email',
        table: 'saved_shipping'
      }, {
        name: 'Address 1',
        value: 'saved_shipping.address1',
        table: 'saved_shipping'
      }, {
        name: 'Address 2',
        value: 'saved_shipping.address2',
        table: 'saved_shipping'
      }, {
        name: 'City',
        value: 'saved_shipping.city',
        table: 'saved_shipping'
      }, {
        name: 'State',
        value: 'saved_shipping.state',
        table: 'saved_shipping'
      }, {
        name: 'Zip',
        value: 'saved_shipping.zip',
        table: 'saved_shipping'
      }, {
        name: 'Area Code',
        value: 'saved_shipping.areacode',
        table: 'saved_shipping'
      }, {
        name: 'Phone',
        value: 'saved_shipping.phone',
        table: 'saved_shipping'
      }, {
        name: 'Active',
        value: 'saved_shipping.active',
        table: 'saved_shipping'
      }]
    };
    var allTables = {};
    var service = {
      getStoreTables: function getStoreTables() {
        return storeTables;
      },
      getAllTables: function getAllTables() {
        return allTables;
      },
      getComparators: function getComparators() {
        return ['contains', '!contains', '=', '!=', '>', '<', 'begins', '!begins', 'ends', '!ends'];
      }
    };
    allTables = Object.assign({}, storeTables);
    allTables.inventory_logs = joinTables.inventory_logs;
    allTables.group_admins = joinTables.group_admins;
    allTables.group_approvers = joinTables.group_approvers;
    allTables.pending_items = joinTables.pending_items;
    allTables.price_sheets = joinTables.price_sheets;
    allTables.purchased_items = joinTables.purchased_items;
    allTables.saved_billing = joinTables.saved_billing;
    allTables.saved_shipping = joinTables.saved_shipping;
    return service;
  }
})();

/***/ }),

/***/ 1310:
/***/ (() => {

(function () {
  'use strict';

  settingsFactory.$inject = ["$timeout", "$window", "Localized", "Utils", "Admin"];
  angular.module('vendorfuelApp').factory('Settings', settingsFactory);
  settingsFactory.$inject = ['$timeout', '$window', 'Localized', 'Utils', 'Admin'];
  /**
   * @param {Object} $timeout Angular service
   * @param {Object} $window Angular service
   * @param {Object} Localized VendorFuel service
   * @param {Object} Utils VendorFuel service
   * @param {Object} Admin VendorFuel service
   * @return {Object} Service
   */

  function settingsFactory($timeout, $window, Localized, Utils, Admin) {
    /**
     * @param {any} tab Tab
     * @param {string} url URL
     * @return {Object} Promise
     */
    function getSettings(tab, url) {
      var httpUrl = Localized.apiURL + url;

      if (!url) {
        httpUrl = Localized.wpRestUrl + '/settings/' + tab.name;
      }

      var promise = Utils.httpGet(httpUrl).then(function successCallback(response) {
        tab.saved = response;
      }, function errorCallback(response) {
        tab.saved = response;
      });
      return promise;
    }
    /**
     * @param {any} tab Tab
     * @param {Object} params Params
     * @param {string} url URL
     * @param {Object} data Data
     * @return {Object} Promise
     */


    function postSettings(tab, params, url, data) {
      var httpUrl = Localized.apiURL + url;

      if (!url) {
        httpUrl = Localized.wpRestUrl + '/settings/' + tab.name;
      }

      var promise = Utils.httpPost(httpUrl, params, data).then(function successCallback(response) {
        if (response.errors) {
          service.errors = response.errors;
        }
      }, function errorCallback(response) {
        if (response.errors) {
          service.errors = response.errors;
        }
      });
      return promise;
    }
    /**
     * @param {any} tab Tab
     * @param {Object} params Params
     * @param {string} url URL
     * @param {Object} data Data
     * @return {Object} Promise
     */


    function putSettings(tab, params, url, data) {
      var httpUrl = Localized.apiURL + url;

      if (!url) {
        httpUrl = Localized.wpRestUrl + '/settings/' + tab.name + '/post';
      }

      var promise = Utils.httpPut(httpUrl, params, data).then(function successCallback(response) {
        if (response.errors) {
          service.errors = response.errors;
        }
      }, function errorCallback(response) {
        if (response.errors) {
          service.errors = response.errors;
        }
      });
      return promise;
    }

    var service = {
      errors: {},
      resetTutorial: resetTutorial,
      general: {
        name: 'general',
        saved: {},
        Get: function Get() {
          return getSettings(service.general);
        },
        Set: function Set() {
          var params = {
            settings: JSON.stringify(service.general.saved)
          };
          return postSettings(service.general, params).then(function () {
            if (service.general.saved.api_url !== Localized.apiURL) {
              Localized.apiURL = service.general.saved.api_url;
              Admin.Logout();
            }

            if (service.general.saved.api_key !== Localized.api_key) {
              Localized.api_key = service.general.saved.api_key;
              Admin.Logout();
            }
          });
        }
      },
      store: {
        name: 'store',
        saved: {},
        Get: function Get() {
          return getSettings(service.store, '/stores').then(function () {
            service.store.saved = service.store.saved.store;
          });
        },
        Set: function Set() {
          var params = {
            name: service.store.saved.name,
            url: service.store.saved.url,
            default_order_prefix: service.store.saved.default_order_prefix,
            default_customer_prefix: service.store.saved.default_customer_prefix,
            options: service.store.saved.options,
            checkout: service.store.saved.checkout
          };
          postSettings(service.store, params);
          return putSettings(service.store, null, '/stores', params);
        },
        Changed: function Changed() {}
      },
      analytics: {
        name: 'analytics',
        saved: {},
        Get: function Get() {
          return getSettings(service.analytics);
        },
        Set: function Set() {
          var params = {
            settings: JSON.stringify(service.analytics.saved)
          };
          return postSettings(service.analytics, params);
        },
        Changed: function Changed(enabled) {
          if (!enabled) {
            service.analytics.saved.google.id = '';
            service.analytics.saved.google.label = '';
            service.analytics.saved.google.tracking = false;
          }
        }
      },
      image: {
        name: 'image',
        saved: {},
        Get: function Get() {
          return getSettings(service.image).then(function () {
            service.image.ChangeRepo();
          });
        },
        Set: function Set() {
          var params = {
            settings: JSON.stringify(service.image.saved)
          };
          return postSettings(service.image, params);
        },
        repositories: [{
          name: 'Local',
          value: 0
        }, {
          name: 'Amazon S3',
          value: 1
        }, {
          name: 'MaxCDN',
          value: 2
        }],
        apiKeyRequired: false,
        Changed: function Changed() {
          service.image.saved.storage.repository = service.image.saved.imageRepository.value;

          if (service.image.saved.imageRepository.value === 1) {
            service.image.apiKeyRequired = true;
          } else {
            service.image.apiKeyRequired = false;
            service.image.saved.storage.api_key = '';
          }
        }
      },
      anguledit: {
        name: 'anguledit',
        saved: {},
        Get: function Get() {
          return getSettings(service.anguledit);
        },
        Set: function Set() {
          var params = {
            settings: JSON.stringify(service.anguledit.saved)
          };
          return postSettings(service.anguledit, params).then(function () {});
        }
      },
      gateways: {
        name: 'gateways',
        saved: {},
        Get: function Get() {
          return getSettings(service.gateways, '/admin/gateways').then(function () {
            service.gateways.saved.gateways.authnet.enabled = service.gateways.saved.gateways.authnet.enabled === 'true';
            service.gateways.saved.gateways.paypal.enabled = service.gateways.saved.gateways.paypal.enabled === 'true';
            service.gateways.Changed(0, service.gateways.saved.gateways.authnet.enabled);
            service.gateways.Changed(1, service.gateways.saved.gateways.paypal.enabled);
          });
        },
        Set: function Set() {
          var params = {
            'gateways[authnet][enabled]': service.gateways.saved.gateways.authnet.enabled,
            'gateways[authnet][id]': service.gateways.saved.gateways.authnet.id,
            'gateways[authnet][key]': service.gateways.saved.gateways.authnet.key,
            'gateways[paypal][enabled]': service.gateways.saved.gateways.paypal.enabled,
            'gateways[paypal][client_id]': service.gateways.saved.gateways.paypal.client_id,
            'gateways[paypal][secret]': service.gateways.saved.gateways.paypal.secret
          };
          return putSettings(service.gateways, params, '/admin/gateways');
        },
        Changed: function Changed(i, enabled) {
          if (!enabled && i === 0) {
            service.gateways.saved.gateways.authnet.id = '';
            service.gateways.saved.gateways.authnet.key = '';
          } else if (!enabled && i === 1) {
            service.gateways.saved.gateways.paypal.client_id = '';
            service.gateways.saved.gateways.paypal.secret = '';
          }
        }
      },
      billing: {
        name: 'billing',
        saved: {},
        Get: function Get() {
          return getSettings(service.billing, '/tenant/billing/check');
        },
        Set: function Set() {
          var params = {
            firstName: service.billing.saved.first_name,
            lastName: service.billing.saved.last_name,
            number: service.billing.saved.card.number,
            expiryMonth: service.billing.saved.card.expMonth,
            expiryYear: service.billing.saved.card.expYear,
            cvv: service.billing.saved.card.cvv
          };
          return postSettings(service.billing, params, '/tenant/billing/update');
        },
        Cancel: function Cancel() {
          var params = {
            store: service.billing.saved.store.id
          };
          return postSettings(service.billing, params, '/tenant/billing/cancel');
        },
        cancelling: false
      }
    };
    return service;
    /**
     * @return {any} Timeout
     */

    function resetTutorial() {
      return $timeout(function () {
        $window.localStorage.setItem('tutorialComplete', 'false');
        $window.localStorage.setItem('showTutorial', 'true');
      }, 1000).then(function () {
        Localized.setNotification({
          type: 'success',
          message: 'Tutorial cookies have been reset.'
        });
      });
    }
  }
})();

/***/ }),

/***/ 4150:
/***/ (() => {

(function () {
  'use strict';

  tenantFactory.$inject = ["$http", "$cookies", "Localized", "Debug"];
  angular.module('vendorfuelApp').factory('Tenant', tenantFactory);
  tenantFactory.$inject = ['$http', '$cookies', 'Localized', 'Debug'];
  /**
   * @param {Object} $http Angular service
   * @param {Object} $cookies Angular service
   * @param {Object} Localized VendorFuel service
   * @param {Object} Debug VendorFuel service
   * @return {Object} Service
   */

  function tenantFactory($http, $cookies, Localized, Debug) {
    var service = {
      login_errors: {},
      Login: function Login(e, p) {
        //TODO: get api url from settings factory
        var req = {
          method: 'POST',
          url: Localized.apiURL + '/tenant/login',
          data: {
            email: e,
            password: p
          }
        };
        var promise = $http(req).then(function successCallback(response) {
          if (Object.keys(response.data.errors).length > 0) {
            Debug.error('Login errors: ', response.data.errors);
            service.login_errors = response.data.errors;
          } else {
            tenant.name = response.data.name;
            $cookies.put('vendorfuel-tenant-name', tenant.name);
            tenant.tokens.jwt = response.data.token;
            $cookies.put('vendorfuel-tenant-token', tenant.tokens.jwt);
            tenant.authed = true;
          }

          return response;
        }, function errorCallback(response) {
          if (response.xhrStatus === 'error') {
            service.login_errors.error = 'Invalid VendorFuel API URL.';
          }

          if (Object.keys(response.data.errors).length > 0) {
            Debug.error('Login errors: ', response.data.errors);
            service.login_errors = response.data.errors;
          }

          return response;
        });
        return promise;
      },
      LoginErrors: function LoginErrors() {
        return service.login_errors;
      },
      Logout: function Logout() {
        tenant.name = null;
        $cookies.remove('vendorfuel-tenant-name');
        tenant.tokens.jwt = null;
        $cookies.remove('vendorfuel-tenant-token');
        tenant.authed = false;
      },
      Authed: function Authed() {
        var token = $cookies.get('vendorfuel-tenant-token');

        if (token) {
          tenant.authed = true;
        } else {
          tenant.authed = false;
        }

        return tenant.authed;
      }
    };
    var tenant = {
      authed: false,
      name: '',
      tokens: {
        a: '',
        b: '',
        jwt: ''
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 3922:
/***/ (() => {

(function () {
  'use strict';

  angular.module('vendorfuelApp').factory('uom', uomFactory);
  /**
   * @return {Object} Service
   */

  function uomFactory() {
    var uomCodes = [{
      name: 'Bag',
      val: 'BG'
    }, {
      name: 'Barrel',
      val: 'BA'
    }, {
      name: 'Bolt',
      val: 'BT'
    }, {
      name: 'Box',
      val: 'BX'
    }, {
      name: 'Bunch',
      val: 'BH'
    }, {
      name: 'Bundle',
      val: 'BND'
    }, {
      name: 'Butt',
      val: 'BU'
    }, {
      name: 'Card',
      val: 'CRD'
    }, {
      name: 'Case',
      val: 'CS'
    }, {
      name: 'Centimeter',
      val: 'CM'
    }, {
      name: 'Container',
      val: 'CON'
    }, {
      name: 'Crate',
      val: 'CR'
    }, {
      name: 'Dozen',
      val: 'DZ'
    }, {
      name: 'Each',
      val: 'EA'
    }, {
      name: 'Envelope',
      val: 'EN'
    }, {
      name: 'Foot',
      val: 'FT'
    }, {
      name: 'Kilogram',
      val: 'KG'
    }, {
      name: 'Kilograms',
      val: 'KGS'
    }, {
      name: 'Liter',
      val: 'L'
    }, {
      name: 'Meter',
      val: 'M'
    }, {
      name: 'Package',
      val: 'PK'
    }, {
      name: 'Packet',
      val: 'PA'
    }, {
      name: 'Pallet',
      val: 'PAL'
    }, {
      name: 'Piece',
      val: 'PC'
    }, {
      name: 'Pieces',
      val: 'PCS'
    }, {
      name: 'Pound',
      val: 'LB'
    }, {
      name: 'Roll',
      val: 'ROL'
    }, {
      name: 'Set',
      val: 'SET'
    }, {
      name: 'Square Meter',
      val: 'SME'
    }, {
      name: 'Square Ft',
      val: 'SQFT'
    }, {
      name: 'Tube',
      val: 'TUBE'
    }, {
      name: 'Yard',
      val: 'YD'
    }];
    var service = {
      uomData: function uomData() {
        var data = {
          uomCodes: uomCodes
        };
        return data;
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 6065:
/***/ (() => {

(function () {
  'use strict';

  utilsFactory.$inject = ["$http", "$location", "Admin", "Localized", "Tenant"];
  angular.module('vendorfuelApp').factory('Utils', utilsFactory);
  utilsFactory.$inject = ['$http', '$location', 'Admin', 'Localized', 'Tenant'];
  /**
   * @param {Object} $http     Angular service
   * @param {Object} $location Angular service
   * @param {Object} Admin     VendorFuel service
   * @param {Object} Localized VendorFuel service
   * @param {Object} Tenant    VendorFuel service
   * @return {Object} Utils factory
   */

  function utilsFactory($http, $location, Admin, Localized, Tenant) {
    /**
     * @param {Object} request HTTP request
     * @return {Object} Promise
     */
    function httpPromise(request) {
      var promise = $http(request).then(function successCallback(response) {
        Localized.deleteNotifications();

        if (response.data) {
          if (response.data.notifications) {
            for (var i = 0; i < response.data.notifications.length; i++) {
              Localized.setNotification({
                type: 'success',
                message: response.data.notifications[i]
              });
            }
          }

          if (response.data.warnings) {
            for (var j = 0; j < response.data.warnings.length; j++) {
              Localized.setNotification({
                type: 'warning',
                message: response.data.warnings[j]
              });
            }
          }

          if (response.data.errors) {
            for (var _j = 0; _j < response.data.errors.length; _j++) {
              Localized.setNotification({
                type: 'error',
                message: response.data.errors[_j]
              });
            }
          }

          return response.data;
        }

        Localized.setNotification({
          type: 'danger',
          message: response.statusText
        });
        return response;
      }, function errorCallback(response) {
        if (response.status === 401) {
          if (!response.config.url.includes('tenant')) {
            Admin.Logout();
          } else {
            Tenant.Logout();
          }
        }

        Localized.setNotification({
          type: 'danger',
          message: response.statusText
        });
        return response;
      });
      return promise;
    }

    var service = {
      httpGet: httpGet,
      httpPost: httpPost,
      httpPut: httpPut,
      httpDelete: httpDelete,
      getHttpPromise: getHttpPromise,
      setLocation: setLocation,
      cleanKey: cleanKey,
      cleanErrorMessages: cleanErrorMessages,
      trimExtraSp: trimExtraSp
    };
    return service;
    /**
     * Get all items.
     *
     * @param {string} endpoint REST API endpoint
     * @param {Object} params   Parameters
     * @param {Object} data     Data
     * @return {Object} Promise
     */

    function httpGet(endpoint, params, data) {
      params = params || {};
      data = data || {};
      var req = {
        method: 'GET',
        url: endpoint,
        params: params,
        data: data
      };
      return httpPromise(req);
    }
    /**
     * Create an item.
     *
     * @param {string} endpoint REST API endpoint
     * @param {Object} params   Parameters
     * @param {Object} data     Data
     * @return {Object} Promise
     */


    function httpPost(endpoint, params, data) {
      params = params || {};
      data = data || {};
      var req = {
        method: 'POST',
        url: endpoint,
        params: params,
        data: data
      };
      return httpPromise(req);
    }
    /**
     * Update an existing item.
     *
     * @param {string} endpoint REST API endpoint
     * @param {Object} params   Parameters
     * @param {Object} data     Data
     * @return {Object} Promise
     */


    function httpPut(endpoint, params, data) {
      params = params || {};
      data = data || {};
      var req = {
        method: 'PUT',
        url: endpoint,
        params: params,
        data: data
      };
      return httpPromise(req);
    }
    /**
     * Delete an item.
     *
     * @param {string} endpoint REST API endpoint
     * @param {Object} params   Parameters
     * @param {Object} data     Data
     * @return {Object} Promise
     */


    function httpDelete(endpoint, params, data) {
      params = params || {};
      data = data || {};
      var req = {
        method: 'DELETE',
        url: endpoint,
        params: params,
        data: data
      };
      return httpPromise(req);
    }
    /**
     * @param {Object} req Request
     * @return {Object} Promise
     */


    function getHttpPromise(req) {
      return httpPromise(req);
    }
    /**
     * @param {string}  location     Path
     * @param {boolean} shouldReturn Should return
     */


    function setLocation(location, shouldReturn) {
      if (!service.redirecting) {
        service.redirecting = true;

        if (shouldReturn === true) {
          service.ReturnLocation = $location.url();
        }

        $location.path(location);
      }
    }
    /**
     * @param {string} str Key
     * @return {string} Cleaned key
     */


    function cleanKey(str) {
      return str.toLowerCase().replace(/\s+/g, '-');
    }
    /**
     * @param {string} str Message
     * @return {string} Trimmed message
     */


    function cleanErrorMessages(str) {
      return str.toString().trim();
    }
    /**
     * @param {string} str String
     * @return {string} Trimmed string
     */


    function trimExtraSp(str) {
      return str.replace(/\s+/g, '');
    }
  }
})();

/***/ }),

/***/ 8726:
/***/ (() => {

(function () {
  'use strict';

  warningModal.$inject = ["$uibModal", "Localized", "$sce"];
  angular.module('vendorfuelApp').factory('WarningModal', warningModal);
  warningModal.$inject = ['$uibModal', 'Localized', '$sce'];
  /**
   * @param {Object} $uibModal UI Bootstrap service
   * @param {Object} Localized VendorFuel service
   * @param {Object} $sce Angular service
   * @return {Object} Service
   */

  function warningModal($uibModal, Localized, $sce) {
    var service = {
      Show: function Show(callback, title, message, optionConfirm, backdrop, highlightedButton) {
        message = message || '';
        optionConfirm = optionConfirm || 'Confirm';
        backdrop = backdrop || true;
        highlightedButton = highlightedButton || 0;
        var tempConfirmWidth = optionConfirm.length;
        var optionWidth = tempConfirmWidth * 9 + 24;
        var callbackParams = callback.params || {};
        $uibModal.open({
          templateUrl: Localized.root.url + '/assets/app/modals/warning.html',
          backdrop: backdrop,
          controller: ["$scope", "$uibModalInstance", function controller($scope, $uibModalInstance) {
            $scope.modalTitle = $sce.trustAsHtml(title);
            $scope.modalMessage = $sce.trustAsHtml(message);
            $scope.optionConfirm = optionConfirm;
            $scope.optionWidth = optionWidth;
            $scope.highlightedButton = highlightedButton;

            $scope.Confirm = function () {
              $uibModalInstance.close();
            };
          }]
        }).result.then(function () {
          if (callback.confirm) {
            callback.confirm(callbackParams);
          }
        });
      }
    };
    return service;
  }
})();

/***/ }),

/***/ 9061:
/***/ (() => {

(function () {
  'use strict';

  runner.$inject = ["$location", "$rootScope", "$transitions", "Admin"];
  angular.module('vendorfuelApp').run(runner);
  runner.$inject = ['$location', '$rootScope', '$transitions', 'Admin'];
  /**
   * @param {Object} $location Angular service
   * @param {Object} $rootScope Angular service
   * @param {Object} Admin VendorFuel service
   */

  function runner($location, $rootScope, $transitions, Admin) {
    $rootScope.rootUrl = localized.dir.url;
    $rootScope.wpApiUrl = localized.dir.wpRestApi + 'vendorfuel';
    $rootScope.generalSettings = localized.settings.general;
    $rootScope.vfApiUrl = localized.apiURL;
    $rootScope.api_key = $rootScope.generalSettings.api_key;
    $rootScope.collapsed = false;

    if (!$rootScope.api_key) {
      if (Admin.authed) {
        Admin.Logout();
      }

      $location.path('/subscribe');
    } // Scroll to top of page on router transitions.


    $transitions.onSuccess({}, function () {
      document.body.scrollTop = document.documentElement.scrollTop = 0;
    });
  }
})();

/***/ }),

/***/ 4184:
/***/ ((module, exports) => {

var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;/*!
  Copyright (c) 2018 Jed Watson.
  Licensed under the MIT License (MIT), see
  http://jedwatson.github.io/classnames
*/
/* global define */

(function () {
	'use strict';

	var hasOwn = {}.hasOwnProperty;

	function classNames() {
		var classes = [];

		for (var i = 0; i < arguments.length; i++) {
			var arg = arguments[i];
			if (!arg) continue;

			var argType = typeof arg;

			if (argType === 'string' || argType === 'number') {
				classes.push(arg);
			} else if (Array.isArray(arg)) {
				if (arg.length) {
					var inner = classNames.apply(null, arg);
					if (inner) {
						classes.push(inner);
					}
				}
			} else if (argType === 'object') {
				if (arg.toString === Object.prototype.toString) {
					for (var key in arg) {
						if (hasOwn.call(arg, key) && arg[key]) {
							classes.push(key);
						}
					}
				} else {
					classes.push(arg.toString());
				}
			}
		}

		return classes.join(' ');
	}

	if ( true && module.exports) {
		classNames.default = classNames;
		module.exports = classNames;
	} else if (true) {
		// register as 'classnames', consistent with npm package name
		!(__WEBPACK_AMD_DEFINE_ARRAY__ = [], __WEBPACK_AMD_DEFINE_RESULT__ = (function () {
			return classNames;
		}).apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	} else {}
}());


/***/ }),

/***/ 6489:
/***/ ((__unused_webpack_module, exports) => {

"use strict";
/*!
 * cookie
 * Copyright(c) 2012-2014 Roman Shtylman
 * Copyright(c) 2015 Douglas Christopher Wilson
 * MIT Licensed
 */



/**
 * Module exports.
 * @public
 */

exports.Q = parse;
exports.q = serialize;

/**
 * Module variables.
 * @private
 */

var decode = decodeURIComponent;
var encode = encodeURIComponent;

/**
 * RegExp to match field-content in RFC 7230 sec 3.2
 *
 * field-content = field-vchar [ 1*( SP / HTAB ) field-vchar ]
 * field-vchar   = VCHAR / obs-text
 * obs-text      = %x80-FF
 */

var fieldContentRegExp = /^[\u0009\u0020-\u007e\u0080-\u00ff]+$/;

/**
 * Parse a cookie header.
 *
 * Parse the given cookie header string into an object
 * The object has the various cookies as keys(names) => values
 *
 * @param {string} str
 * @param {object} [options]
 * @return {object}
 * @public
 */

function parse(str, options) {
  if (typeof str !== 'string') {
    throw new TypeError('argument str must be a string');
  }

  var obj = {}
  var opt = options || {};
  var pairs = str.split(';')
  var dec = opt.decode || decode;

  for (var i = 0; i < pairs.length; i++) {
    var pair = pairs[i];
    var index = pair.indexOf('=')

    // skip things that don't look like key=value
    if (index < 0) {
      continue;
    }

    var key = pair.substring(0, index).trim()

    // only assign once
    if (undefined == obj[key]) {
      var val = pair.substring(index + 1, pair.length).trim()

      // quoted values
      if (val[0] === '"') {
        val = val.slice(1, -1)
      }

      obj[key] = tryDecode(val, dec);
    }
  }

  return obj;
}

/**
 * Serialize data into a cookie header.
 *
 * Serialize the a name value pair into a cookie string suitable for
 * http headers. An optional options object specified cookie parameters.
 *
 * serialize('foo', 'bar', { httpOnly: true })
 *   => "foo=bar; httpOnly"
 *
 * @param {string} name
 * @param {string} val
 * @param {object} [options]
 * @return {string}
 * @public
 */

function serialize(name, val, options) {
  var opt = options || {};
  var enc = opt.encode || encode;

  if (typeof enc !== 'function') {
    throw new TypeError('option encode is invalid');
  }

  if (!fieldContentRegExp.test(name)) {
    throw new TypeError('argument name is invalid');
  }

  var value = enc(val);

  if (value && !fieldContentRegExp.test(value)) {
    throw new TypeError('argument val is invalid');
  }

  var str = name + '=' + value;

  if (null != opt.maxAge) {
    var maxAge = opt.maxAge - 0;

    if (isNaN(maxAge) || !isFinite(maxAge)) {
      throw new TypeError('option maxAge is invalid')
    }

    str += '; Max-Age=' + Math.floor(maxAge);
  }

  if (opt.domain) {
    if (!fieldContentRegExp.test(opt.domain)) {
      throw new TypeError('option domain is invalid');
    }

    str += '; Domain=' + opt.domain;
  }

  if (opt.path) {
    if (!fieldContentRegExp.test(opt.path)) {
      throw new TypeError('option path is invalid');
    }

    str += '; Path=' + opt.path;
  }

  if (opt.expires) {
    if (typeof opt.expires.toUTCString !== 'function') {
      throw new TypeError('option expires is invalid');
    }

    str += '; Expires=' + opt.expires.toUTCString();
  }

  if (opt.httpOnly) {
    str += '; HttpOnly';
  }

  if (opt.secure) {
    str += '; Secure';
  }

  if (opt.sameSite) {
    var sameSite = typeof opt.sameSite === 'string'
      ? opt.sameSite.toLowerCase() : opt.sameSite;

    switch (sameSite) {
      case true:
        str += '; SameSite=Strict';
        break;
      case 'lax':
        str += '; SameSite=Lax';
        break;
      case 'strict':
        str += '; SameSite=Strict';
        break;
      case 'none':
        str += '; SameSite=None';
        break;
      default:
        throw new TypeError('option sameSite is invalid');
    }
  }

  return str;
}

/**
 * Try decoding a string using a decoding function.
 *
 * @param {string} str
 * @param {function} decode
 * @private
 */

function tryDecode(str, decode) {
  try {
    return decode(str);
  } catch (e) {
    return str;
  }
}


/***/ }),

/***/ 9010:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var util = __webpack_require__(4657);

function scrollIntoView(elem, container, config) {
  config = config || {};
  // document 归一化到 window
  if (container.nodeType === 9) {
    container = util.getWindow(container);
  }

  var allowHorizontalScroll = config.allowHorizontalScroll;
  var onlyScrollIfNeeded = config.onlyScrollIfNeeded;
  var alignWithTop = config.alignWithTop;
  var alignWithLeft = config.alignWithLeft;
  var offsetTop = config.offsetTop || 0;
  var offsetLeft = config.offsetLeft || 0;
  var offsetBottom = config.offsetBottom || 0;
  var offsetRight = config.offsetRight || 0;

  allowHorizontalScroll = allowHorizontalScroll === undefined ? true : allowHorizontalScroll;

  var isWin = util.isWindow(container);
  var elemOffset = util.offset(elem);
  var eh = util.outerHeight(elem);
  var ew = util.outerWidth(elem);
  var containerOffset = undefined;
  var ch = undefined;
  var cw = undefined;
  var containerScroll = undefined;
  var diffTop = undefined;
  var diffBottom = undefined;
  var win = undefined;
  var winScroll = undefined;
  var ww = undefined;
  var wh = undefined;

  if (isWin) {
    win = container;
    wh = util.height(win);
    ww = util.width(win);
    winScroll = {
      left: util.scrollLeft(win),
      top: util.scrollTop(win)
    };
    // elem 相对 container 可视视窗的距离
    diffTop = {
      left: elemOffset.left - winScroll.left - offsetLeft,
      top: elemOffset.top - winScroll.top - offsetTop
    };
    diffBottom = {
      left: elemOffset.left + ew - (winScroll.left + ww) + offsetRight,
      top: elemOffset.top + eh - (winScroll.top + wh) + offsetBottom
    };
    containerScroll = winScroll;
  } else {
    containerOffset = util.offset(container);
    ch = container.clientHeight;
    cw = container.clientWidth;
    containerScroll = {
      left: container.scrollLeft,
      top: container.scrollTop
    };
    // elem 相对 container 可视视窗的距离
    // 注意边框, offset 是边框到根节点
    diffTop = {
      left: elemOffset.left - (containerOffset.left + (parseFloat(util.css(container, 'borderLeftWidth')) || 0)) - offsetLeft,
      top: elemOffset.top - (containerOffset.top + (parseFloat(util.css(container, 'borderTopWidth')) || 0)) - offsetTop
    };
    diffBottom = {
      left: elemOffset.left + ew - (containerOffset.left + cw + (parseFloat(util.css(container, 'borderRightWidth')) || 0)) + offsetRight,
      top: elemOffset.top + eh - (containerOffset.top + ch + (parseFloat(util.css(container, 'borderBottomWidth')) || 0)) + offsetBottom
    };
  }

  if (diffTop.top < 0 || diffBottom.top > 0) {
    // 强制向上
    if (alignWithTop === true) {
      util.scrollTop(container, containerScroll.top + diffTop.top);
    } else if (alignWithTop === false) {
      util.scrollTop(container, containerScroll.top + diffBottom.top);
    } else {
      // 自动调整
      if (diffTop.top < 0) {
        util.scrollTop(container, containerScroll.top + diffTop.top);
      } else {
        util.scrollTop(container, containerScroll.top + diffBottom.top);
      }
    }
  } else {
    if (!onlyScrollIfNeeded) {
      alignWithTop = alignWithTop === undefined ? true : !!alignWithTop;
      if (alignWithTop) {
        util.scrollTop(container, containerScroll.top + diffTop.top);
      } else {
        util.scrollTop(container, containerScroll.top + diffBottom.top);
      }
    }
  }

  if (allowHorizontalScroll) {
    if (diffTop.left < 0 || diffBottom.left > 0) {
      // 强制向上
      if (alignWithLeft === true) {
        util.scrollLeft(container, containerScroll.left + diffTop.left);
      } else if (alignWithLeft === false) {
        util.scrollLeft(container, containerScroll.left + diffBottom.left);
      } else {
        // 自动调整
        if (diffTop.left < 0) {
          util.scrollLeft(container, containerScroll.left + diffTop.left);
        } else {
          util.scrollLeft(container, containerScroll.left + diffBottom.left);
        }
      }
    } else {
      if (!onlyScrollIfNeeded) {
        alignWithLeft = alignWithLeft === undefined ? true : !!alignWithLeft;
        if (alignWithLeft) {
          util.scrollLeft(container, containerScroll.left + diffTop.left);
        } else {
          util.scrollLeft(container, containerScroll.left + diffBottom.left);
        }
      }
    }
  }
}

module.exports = scrollIntoView;

/***/ }),

/***/ 4979:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


module.exports = __webpack_require__(9010);

/***/ }),

/***/ 4657:
/***/ ((module) => {

"use strict";


var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var RE_NUM = /[\-+]?(?:\d*\.|)\d+(?:[eE][\-+]?\d+|)/.source;

function getClientPosition(elem) {
  var box = undefined;
  var x = undefined;
  var y = undefined;
  var doc = elem.ownerDocument;
  var body = doc.body;
  var docElem = doc && doc.documentElement;
  // 根据 GBS 最新数据，A-Grade Browsers 都已支持 getBoundingClientRect 方法，不用再考虑传统的实现方式
  box = elem.getBoundingClientRect();

  // 注：jQuery 还考虑减去 docElem.clientLeft/clientTop
  // 但测试发现，这样反而会导致当 html 和 body 有边距/边框样式时，获取的值不正确
  // 此外，ie6 会忽略 html 的 margin 值，幸运地是没有谁会去设置 html 的 margin

  x = box.left;
  y = box.top;

  // In IE, most of the time, 2 extra pixels are added to the top and left
  // due to the implicit 2-pixel inset border.  In IE6/7 quirks mode and
  // IE6 standards mode, this border can be overridden by setting the
  // document element's border to zero -- thus, we cannot rely on the
  // offset always being 2 pixels.

  // In quirks mode, the offset can be determined by querying the body's
  // clientLeft/clientTop, but in standards mode, it is found by querying
  // the document element's clientLeft/clientTop.  Since we already called
  // getClientBoundingRect we have already forced a reflow, so it is not
  // too expensive just to query them all.

  // ie 下应该减去窗口的边框吧，毕竟默认 absolute 都是相对窗口定位的
  // 窗口边框标准是设 documentElement ,quirks 时设置 body
  // 最好禁止在 body 和 html 上边框 ，但 ie < 9 html 默认有 2px ，减去
  // 但是非 ie 不可能设置窗口边框，body html 也不是窗口 ,ie 可以通过 html,body 设置
  // 标准 ie 下 docElem.clientTop 就是 border-top
  // ie7 html 即窗口边框改变不了。永远为 2
  // 但标准 firefox/chrome/ie9 下 docElem.clientTop 是窗口边框，即使设了 border-top 也为 0

  x -= docElem.clientLeft || body.clientLeft || 0;
  y -= docElem.clientTop || body.clientTop || 0;

  return {
    left: x,
    top: y
  };
}

function getScroll(w, top) {
  var ret = w['page' + (top ? 'Y' : 'X') + 'Offset'];
  var method = 'scroll' + (top ? 'Top' : 'Left');
  if (typeof ret !== 'number') {
    var d = w.document;
    // ie6,7,8 standard mode
    ret = d.documentElement[method];
    if (typeof ret !== 'number') {
      // quirks mode
      ret = d.body[method];
    }
  }
  return ret;
}

function getScrollLeft(w) {
  return getScroll(w);
}

function getScrollTop(w) {
  return getScroll(w, true);
}

function getOffset(el) {
  var pos = getClientPosition(el);
  var doc = el.ownerDocument;
  var w = doc.defaultView || doc.parentWindow;
  pos.left += getScrollLeft(w);
  pos.top += getScrollTop(w);
  return pos;
}
function _getComputedStyle(elem, name, computedStyle_) {
  var val = '';
  var d = elem.ownerDocument;
  var computedStyle = computedStyle_ || d.defaultView.getComputedStyle(elem, null);

  // https://github.com/kissyteam/kissy/issues/61
  if (computedStyle) {
    val = computedStyle.getPropertyValue(name) || computedStyle[name];
  }

  return val;
}

var _RE_NUM_NO_PX = new RegExp('^(' + RE_NUM + ')(?!px)[a-z%]+$', 'i');
var RE_POS = /^(top|right|bottom|left)$/;
var CURRENT_STYLE = 'currentStyle';
var RUNTIME_STYLE = 'runtimeStyle';
var LEFT = 'left';
var PX = 'px';

function _getComputedStyleIE(elem, name) {
  // currentStyle maybe null
  // http://msdn.microsoft.com/en-us/library/ms535231.aspx
  var ret = elem[CURRENT_STYLE] && elem[CURRENT_STYLE][name];

  // 当 width/height 设置为百分比时，通过 pixelLeft 方式转换的 width/height 值
  // 一开始就处理了! CUSTOM_STYLE.height,CUSTOM_STYLE.width ,cssHook 解决@2011-08-19
  // 在 ie 下不对，需要直接用 offset 方式
  // borderWidth 等值也有问题，但考虑到 borderWidth 设为百分比的概率很小，这里就不考虑了

  // From the awesome hack by Dean Edwards
  // http://erik.eae.net/archives/2007/07/27/18.54.15/#comment-102291
  // If we're not dealing with a regular pixel number
  // but a number that has a weird ending, we need to convert it to pixels
  // exclude left right for relativity
  if (_RE_NUM_NO_PX.test(ret) && !RE_POS.test(name)) {
    // Remember the original values
    var style = elem.style;
    var left = style[LEFT];
    var rsLeft = elem[RUNTIME_STYLE][LEFT];

    // prevent flashing of content
    elem[RUNTIME_STYLE][LEFT] = elem[CURRENT_STYLE][LEFT];

    // Put in the new values to get a computed value out
    style[LEFT] = name === 'fontSize' ? '1em' : ret || 0;
    ret = style.pixelLeft + PX;

    // Revert the changed values
    style[LEFT] = left;

    elem[RUNTIME_STYLE][LEFT] = rsLeft;
  }
  return ret === '' ? 'auto' : ret;
}

var getComputedStyleX = undefined;
if (typeof window !== 'undefined') {
  getComputedStyleX = window.getComputedStyle ? _getComputedStyle : _getComputedStyleIE;
}

function each(arr, fn) {
  for (var i = 0; i < arr.length; i++) {
    fn(arr[i]);
  }
}

function isBorderBoxFn(elem) {
  return getComputedStyleX(elem, 'boxSizing') === 'border-box';
}

var BOX_MODELS = ['margin', 'border', 'padding'];
var CONTENT_INDEX = -1;
var PADDING_INDEX = 2;
var BORDER_INDEX = 1;
var MARGIN_INDEX = 0;

function swap(elem, options, callback) {
  var old = {};
  var style = elem.style;
  var name = undefined;

  // Remember the old values, and insert the new ones
  for (name in options) {
    if (options.hasOwnProperty(name)) {
      old[name] = style[name];
      style[name] = options[name];
    }
  }

  callback.call(elem);

  // Revert the old values
  for (name in options) {
    if (options.hasOwnProperty(name)) {
      style[name] = old[name];
    }
  }
}

function getPBMWidth(elem, props, which) {
  var value = 0;
  var prop = undefined;
  var j = undefined;
  var i = undefined;
  for (j = 0; j < props.length; j++) {
    prop = props[j];
    if (prop) {
      for (i = 0; i < which.length; i++) {
        var cssProp = undefined;
        if (prop === 'border') {
          cssProp = prop + which[i] + 'Width';
        } else {
          cssProp = prop + which[i];
        }
        value += parseFloat(getComputedStyleX(elem, cssProp)) || 0;
      }
    }
  }
  return value;
}

/**
 * A crude way of determining if an object is a window
 * @member util
 */
function isWindow(obj) {
  // must use == for ie8
  /* eslint eqeqeq:0 */
  return obj != null && obj == obj.window;
}

var domUtils = {};

each(['Width', 'Height'], function (name) {
  domUtils['doc' + name] = function (refWin) {
    var d = refWin.document;
    return Math.max(
    // firefox chrome documentElement.scrollHeight< body.scrollHeight
    // ie standard mode : documentElement.scrollHeight> body.scrollHeight
    d.documentElement['scroll' + name],
    // quirks : documentElement.scrollHeight 最大等于可视窗口多一点？
    d.body['scroll' + name], domUtils['viewport' + name](d));
  };

  domUtils['viewport' + name] = function (win) {
    // pc browser includes scrollbar in window.innerWidth
    var prop = 'client' + name;
    var doc = win.document;
    var body = doc.body;
    var documentElement = doc.documentElement;
    var documentElementProp = documentElement[prop];
    // 标准模式取 documentElement
    // backcompat 取 body
    return doc.compatMode === 'CSS1Compat' && documentElementProp || body && body[prop] || documentElementProp;
  };
});

/*
 得到元素的大小信息
 @param elem
 @param name
 @param {String} [extra]  'padding' : (css width) + padding
 'border' : (css width) + padding + border
 'margin' : (css width) + padding + border + margin
 */
function getWH(elem, name, extra) {
  if (isWindow(elem)) {
    return name === 'width' ? domUtils.viewportWidth(elem) : domUtils.viewportHeight(elem);
  } else if (elem.nodeType === 9) {
    return name === 'width' ? domUtils.docWidth(elem) : domUtils.docHeight(elem);
  }
  var which = name === 'width' ? ['Left', 'Right'] : ['Top', 'Bottom'];
  var borderBoxValue = name === 'width' ? elem.offsetWidth : elem.offsetHeight;
  var computedStyle = getComputedStyleX(elem);
  var isBorderBox = isBorderBoxFn(elem, computedStyle);
  var cssBoxValue = 0;
  if (borderBoxValue == null || borderBoxValue <= 0) {
    borderBoxValue = undefined;
    // Fall back to computed then un computed css if necessary
    cssBoxValue = getComputedStyleX(elem, name);
    if (cssBoxValue == null || Number(cssBoxValue) < 0) {
      cssBoxValue = elem.style[name] || 0;
    }
    // Normalize '', auto, and prepare for extra
    cssBoxValue = parseFloat(cssBoxValue) || 0;
  }
  if (extra === undefined) {
    extra = isBorderBox ? BORDER_INDEX : CONTENT_INDEX;
  }
  var borderBoxValueOrIsBorderBox = borderBoxValue !== undefined || isBorderBox;
  var val = borderBoxValue || cssBoxValue;
  if (extra === CONTENT_INDEX) {
    if (borderBoxValueOrIsBorderBox) {
      return val - getPBMWidth(elem, ['border', 'padding'], which, computedStyle);
    }
    return cssBoxValue;
  }
  if (borderBoxValueOrIsBorderBox) {
    var padding = extra === PADDING_INDEX ? -getPBMWidth(elem, ['border'], which, computedStyle) : getPBMWidth(elem, ['margin'], which, computedStyle);
    return val + (extra === BORDER_INDEX ? 0 : padding);
  }
  return cssBoxValue + getPBMWidth(elem, BOX_MODELS.slice(extra), which, computedStyle);
}

var cssShow = {
  position: 'absolute',
  visibility: 'hidden',
  display: 'block'
};

// fix #119 : https://github.com/kissyteam/kissy/issues/119
function getWHIgnoreDisplay(elem) {
  var val = undefined;
  var args = arguments;
  // in case elem is window
  // elem.offsetWidth === undefined
  if (elem.offsetWidth !== 0) {
    val = getWH.apply(undefined, args);
  } else {
    swap(elem, cssShow, function () {
      val = getWH.apply(undefined, args);
    });
  }
  return val;
}

function css(el, name, v) {
  var value = v;
  if ((typeof name === 'undefined' ? 'undefined' : _typeof(name)) === 'object') {
    for (var i in name) {
      if (name.hasOwnProperty(i)) {
        css(el, i, name[i]);
      }
    }
    return undefined;
  }
  if (typeof value !== 'undefined') {
    if (typeof value === 'number') {
      value += 'px';
    }
    el.style[name] = value;
    return undefined;
  }
  return getComputedStyleX(el, name);
}

each(['width', 'height'], function (name) {
  var first = name.charAt(0).toUpperCase() + name.slice(1);
  domUtils['outer' + first] = function (el, includeMargin) {
    return el && getWHIgnoreDisplay(el, name, includeMargin ? MARGIN_INDEX : BORDER_INDEX);
  };
  var which = name === 'width' ? ['Left', 'Right'] : ['Top', 'Bottom'];

  domUtils[name] = function (elem, val) {
    if (val !== undefined) {
      if (elem) {
        var computedStyle = getComputedStyleX(elem);
        var isBorderBox = isBorderBoxFn(elem);
        if (isBorderBox) {
          val += getPBMWidth(elem, ['padding', 'border'], which, computedStyle);
        }
        return css(elem, name, val);
      }
      return undefined;
    }
    return elem && getWHIgnoreDisplay(elem, name, CONTENT_INDEX);
  };
});

// 设置 elem 相对 elem.ownerDocument 的坐标
function setOffset(elem, offset) {
  // set position first, in-case top/left are set even on static elem
  if (css(elem, 'position') === 'static') {
    elem.style.position = 'relative';
  }

  var old = getOffset(elem);
  var ret = {};
  var current = undefined;
  var key = undefined;

  for (key in offset) {
    if (offset.hasOwnProperty(key)) {
      current = parseFloat(css(elem, key)) || 0;
      ret[key] = current + offset[key] - old[key];
    }
  }
  css(elem, ret);
}

module.exports = _extends({
  getWindow: function getWindow(node) {
    var doc = node.ownerDocument || node;
    return doc.defaultView || doc.parentWindow;
  },
  offset: function offset(el, value) {
    if (typeof value !== 'undefined') {
      setOffset(el, value);
    } else {
      return getOffset(el);
    }
  },

  isWindow: isWindow,
  each: each,
  css: css,
  clone: function clone(obj) {
    var ret = {};
    for (var i in obj) {
      if (obj.hasOwnProperty(i)) {
        ret[i] = obj[i];
      }
    }
    var overflow = obj.overflow;
    if (overflow) {
      for (var i in obj) {
        if (obj.hasOwnProperty(i)) {
          ret.overflow[i] = obj.overflow[i];
        }
      }
    }
    return ret;
  },
  scrollLeft: function scrollLeft(w, v) {
    if (isWindow(w)) {
      if (v === undefined) {
        return getScrollLeft(w);
      }
      window.scrollTo(v, getScrollTop(w));
    } else {
      if (v === undefined) {
        return w.scrollLeft;
      }
      w.scrollLeft = v;
    }
  },
  scrollTop: function scrollTop(w, v) {
    if (isWindow(w)) {
      if (v === undefined) {
        return getScrollTop(w);
      }
      window.scrollTo(getScrollLeft(w), v);
    } else {
      if (v === undefined) {
        return w.scrollTop;
      }
      w.scrollTop = v;
    }
  },

  viewportWidth: 0,
  viewportHeight: 0
}, domUtils);

/***/ }),

/***/ 6928:
/***/ ((module) => {

module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __nested_webpack_require_187__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __nested_webpack_require_187__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__nested_webpack_require_187__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__nested_webpack_require_187__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__nested_webpack_require_187__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __nested_webpack_require_187__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __nested_webpack_require_1468__) {

	module.exports = __nested_webpack_require_1468__(1);


/***/ }),
/* 1 */
/***/ (function(module, exports, __nested_webpack_require_1587__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _utils = __nested_webpack_require_1587__(2);
	
	Object.defineProperty(exports, 'combineChunks', {
	  enumerable: true,
	  get: function get() {
	    return _utils.combineChunks;
	  }
	});
	Object.defineProperty(exports, 'fillInChunks', {
	  enumerable: true,
	  get: function get() {
	    return _utils.fillInChunks;
	  }
	});
	Object.defineProperty(exports, 'findAll', {
	  enumerable: true,
	  get: function get() {
	    return _utils.findAll;
	  }
	});
	Object.defineProperty(exports, 'findChunks', {
	  enumerable: true,
	  get: function get() {
	    return _utils.findChunks;
	  }
	});

/***/ }),
/* 2 */
/***/ (function(module, exports) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	
	/**
	 * Creates an array of chunk objects representing both higlightable and non highlightable pieces of text that match each search word.
	 * @return Array of "chunks" (where a Chunk is { start:number, end:number, highlight:boolean })
	 */
	var findAll = exports.findAll = function findAll(_ref) {
	  var autoEscape = _ref.autoEscape,
	      _ref$caseSensitive = _ref.caseSensitive,
	      caseSensitive = _ref$caseSensitive === undefined ? false : _ref$caseSensitive,
	      _ref$findChunks = _ref.findChunks,
	      findChunks = _ref$findChunks === undefined ? defaultFindChunks : _ref$findChunks,
	      sanitize = _ref.sanitize,
	      searchWords = _ref.searchWords,
	      textToHighlight = _ref.textToHighlight;
	  return fillInChunks({
	    chunksToHighlight: combineChunks({
	      chunks: findChunks({
	        autoEscape: autoEscape,
	        caseSensitive: caseSensitive,
	        sanitize: sanitize,
	        searchWords: searchWords,
	        textToHighlight: textToHighlight
	      })
	    }),
	    totalLength: textToHighlight ? textToHighlight.length : 0
	  });
	};
	
	/**
	 * Takes an array of {start:number, end:number} objects and combines chunks that overlap into single chunks.
	 * @return {start:number, end:number}[]
	 */
	
	
	var combineChunks = exports.combineChunks = function combineChunks(_ref2) {
	  var chunks = _ref2.chunks;
	
	  chunks = chunks.sort(function (first, second) {
	    return first.start - second.start;
	  }).reduce(function (processedChunks, nextChunk) {
	    // First chunk just goes straight in the array...
	    if (processedChunks.length === 0) {
	      return [nextChunk];
	    } else {
	      // ... subsequent chunks get checked to see if they overlap...
	      var prevChunk = processedChunks.pop();
	      if (nextChunk.start <= prevChunk.end) {
	        // It may be the case that prevChunk completely surrounds nextChunk, so take the
	        // largest of the end indeces.
	        var endIndex = Math.max(prevChunk.end, nextChunk.end);
	        processedChunks.push({ highlight: false, start: prevChunk.start, end: endIndex });
	      } else {
	        processedChunks.push(prevChunk, nextChunk);
	      }
	      return processedChunks;
	    }
	  }, []);
	
	  return chunks;
	};
	
	/**
	 * Examine text for any matches.
	 * If we find matches, add them to the returned array as a "chunk" object ({start:number, end:number}).
	 * @return {start:number, end:number}[]
	 */
	var defaultFindChunks = function defaultFindChunks(_ref3) {
	  var autoEscape = _ref3.autoEscape,
	      caseSensitive = _ref3.caseSensitive,
	      _ref3$sanitize = _ref3.sanitize,
	      sanitize = _ref3$sanitize === undefined ? defaultSanitize : _ref3$sanitize,
	      searchWords = _ref3.searchWords,
	      textToHighlight = _ref3.textToHighlight;
	
	  textToHighlight = sanitize(textToHighlight);
	
	  return searchWords.filter(function (searchWord) {
	    return searchWord;
	  }) // Remove empty words
	  .reduce(function (chunks, searchWord) {
	    searchWord = sanitize(searchWord);
	
	    if (autoEscape) {
	      searchWord = escapeRegExpFn(searchWord);
	    }
	
	    var regex = new RegExp(searchWord, caseSensitive ? 'g' : 'gi');
	
	    var match = void 0;
	    while (match = regex.exec(textToHighlight)) {
	      var _start = match.index;
	      var _end = regex.lastIndex;
	      // We do not return zero-length matches
	      if (_end > _start) {
	        chunks.push({ highlight: false, start: _start, end: _end });
	      }
	
	      // Prevent browsers like Firefox from getting stuck in an infinite loop
	      // See http://www.regexguru.com/2008/04/watch-out-for-zero-length-matches/
	      if (match.index === regex.lastIndex) {
	        regex.lastIndex++;
	      }
	    }
	
	    return chunks;
	  }, []);
	};
	// Allow the findChunks to be overridden in findAll,
	// but for backwards compatibility we export as the old name
	exports.findChunks = defaultFindChunks;
	
	/**
	 * Given a set of chunks to highlight, create an additional set of chunks
	 * to represent the bits of text between the highlighted text.
	 * @param chunksToHighlight {start:number, end:number}[]
	 * @param totalLength number
	 * @return {start:number, end:number, highlight:boolean}[]
	 */
	
	var fillInChunks = exports.fillInChunks = function fillInChunks(_ref4) {
	  var chunksToHighlight = _ref4.chunksToHighlight,
	      totalLength = _ref4.totalLength;
	
	  var allChunks = [];
	  var append = function append(start, end, highlight) {
	    if (end - start > 0) {
	      allChunks.push({
	        start: start,
	        end: end,
	        highlight: highlight
	      });
	    }
	  };
	
	  if (chunksToHighlight.length === 0) {
	    append(0, totalLength, false);
	  } else {
	    var lastIndex = 0;
	    chunksToHighlight.forEach(function (chunk) {
	      append(lastIndex, chunk.start, false);
	      append(chunk.start, chunk.end, true);
	      lastIndex = chunk.end;
	    });
	    append(lastIndex, totalLength, false);
	  }
	  return allChunks;
	};
	
	function defaultSanitize(string) {
	  return string;
	}
	
	function escapeRegExpFn(string) {
	  return string.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
	}

/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map

/***/ }),

/***/ 8679:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


var reactIs = __webpack_require__(1296);

/**
 * Copyright 2015, Yahoo! Inc.
 * Copyrights licensed under the New BSD License. See the accompanying LICENSE file for terms.
 */
var REACT_STATICS = {
  childContextTypes: true,
  contextType: true,
  contextTypes: true,
  defaultProps: true,
  displayName: true,
  getDefaultProps: true,
  getDerivedStateFromError: true,
  getDerivedStateFromProps: true,
  mixins: true,
  propTypes: true,
  type: true
};
var KNOWN_STATICS = {
  name: true,
  length: true,
  prototype: true,
  caller: true,
  callee: true,
  arguments: true,
  arity: true
};
var FORWARD_REF_STATICS = {
  '$$typeof': true,
  render: true,
  defaultProps: true,
  displayName: true,
  propTypes: true
};
var MEMO_STATICS = {
  '$$typeof': true,
  compare: true,
  defaultProps: true,
  displayName: true,
  propTypes: true,
  type: true
};
var TYPE_STATICS = {};
TYPE_STATICS[reactIs.ForwardRef] = FORWARD_REF_STATICS;
TYPE_STATICS[reactIs.Memo] = MEMO_STATICS;

function getStatics(component) {
  // React v16.11 and below
  if (reactIs.isMemo(component)) {
    return MEMO_STATICS;
  } // React v16.12 and above


  return TYPE_STATICS[component['$$typeof']] || REACT_STATICS;
}

var defineProperty = Object.defineProperty;
var getOwnPropertyNames = Object.getOwnPropertyNames;
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
var getPrototypeOf = Object.getPrototypeOf;
var objectPrototype = Object.prototype;
function hoistNonReactStatics(targetComponent, sourceComponent, blacklist) {
  if (typeof sourceComponent !== 'string') {
    // don't hoist over string (html) components
    if (objectPrototype) {
      var inheritedComponent = getPrototypeOf(sourceComponent);

      if (inheritedComponent && inheritedComponent !== objectPrototype) {
        hoistNonReactStatics(targetComponent, inheritedComponent, blacklist);
      }
    }

    var keys = getOwnPropertyNames(sourceComponent);

    if (getOwnPropertySymbols) {
      keys = keys.concat(getOwnPropertySymbols(sourceComponent));
    }

    var targetStatics = getStatics(targetComponent);
    var sourceStatics = getStatics(sourceComponent);

    for (var i = 0; i < keys.length; ++i) {
      var key = keys[i];

      if (!KNOWN_STATICS[key] && !(blacklist && blacklist[key]) && !(sourceStatics && sourceStatics[key]) && !(targetStatics && targetStatics[key])) {
        var descriptor = getOwnPropertyDescriptor(sourceComponent, key);

        try {
          // Avoid failures from read-only properties
          defineProperty(targetComponent, key, descriptor);
        } catch (e) {}
      }
    }
  }

  return targetComponent;
}

module.exports = hoistNonReactStatics;


/***/ }),

/***/ 6103:
/***/ ((__unused_webpack_module, exports) => {

"use strict";
/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}exports.AsyncMode=l;exports.ConcurrentMode=m;exports.ContextConsumer=k;exports.ContextProvider=h;exports.Element=c;exports.ForwardRef=n;exports.Fragment=e;exports.Lazy=t;exports.Memo=r;exports.Portal=d;
exports.Profiler=g;exports.StrictMode=f;exports.Suspense=p;exports.isAsyncMode=function(a){return A(a)||z(a)===l};exports.isConcurrentMode=A;exports.isContextConsumer=function(a){return z(a)===k};exports.isContextProvider=function(a){return z(a)===h};exports.isElement=function(a){return"object"===typeof a&&null!==a&&a.$$typeof===c};exports.isForwardRef=function(a){return z(a)===n};exports.isFragment=function(a){return z(a)===e};exports.isLazy=function(a){return z(a)===t};
exports.isMemo=function(a){return z(a)===r};exports.isPortal=function(a){return z(a)===d};exports.isProfiler=function(a){return z(a)===g};exports.isStrictMode=function(a){return z(a)===f};exports.isSuspense=function(a){return z(a)===p};
exports.isValidElementType=function(a){return"string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};exports.typeOf=z;


/***/ }),

/***/ 1296:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


if (true) {
  module.exports = __webpack_require__(6103);
} else {}


/***/ }),

/***/ 1813:
/***/ ((module) => {

/**
 * lodash 4.0.1 (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright 2012-2016 The Dojo Foundation <http://dojofoundation.org/>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright 2009-2016 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 * Available under MIT license <https://lodash.com/license>
 */

/**
 * The inverse of `_.toPairs`; this method returns an object composed
 * from key-value `pairs`.
 *
 * @static
 * @memberOf _
 * @category Array
 * @param {Array} pairs The key-value pairs.
 * @returns {Object} Returns the new object.
 * @example
 *
 * _.fromPairs([['fred', 30], ['barney', 40]]);
 * // => { 'fred': 30, 'barney': 40 }
 */
function fromPairs(pairs) {
  var index = -1,
      length = pairs ? pairs.length : 0,
      result = {};

  while (++index < length) {
    var pair = pairs[index];
    result[pair[0]] = pair[1];
  }
  return result;
}

module.exports = fromPairs;


/***/ }),

/***/ 8552:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(852),
    root = __webpack_require__(5639);

/* Built-in method references that are verified to be native. */
var DataView = getNative(root, 'DataView');

module.exports = DataView;


/***/ }),

/***/ 1989:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var hashClear = __webpack_require__(1789),
    hashDelete = __webpack_require__(401),
    hashGet = __webpack_require__(7667),
    hashHas = __webpack_require__(1327),
    hashSet = __webpack_require__(1866);

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `Hash`.
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

module.exports = Hash;


/***/ }),

/***/ 8407:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var listCacheClear = __webpack_require__(7040),
    listCacheDelete = __webpack_require__(4125),
    listCacheGet = __webpack_require__(2117),
    listCacheHas = __webpack_require__(7529),
    listCacheSet = __webpack_require__(4705);

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `ListCache`.
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

module.exports = ListCache;


/***/ }),

/***/ 7071:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(852),
    root = __webpack_require__(5639);

/* Built-in method references that are verified to be native. */
var Map = getNative(root, 'Map');

module.exports = Map;


/***/ }),

/***/ 3369:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var mapCacheClear = __webpack_require__(4785),
    mapCacheDelete = __webpack_require__(1285),
    mapCacheGet = __webpack_require__(6000),
    mapCacheHas = __webpack_require__(9916),
    mapCacheSet = __webpack_require__(5265);

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache(entries) {
  var index = -1,
      length = entries == null ? 0 : entries.length;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

// Add methods to `MapCache`.
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

module.exports = MapCache;


/***/ }),

/***/ 3818:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(852),
    root = __webpack_require__(5639);

/* Built-in method references that are verified to be native. */
var Promise = getNative(root, 'Promise');

module.exports = Promise;


/***/ }),

/***/ 8525:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(852),
    root = __webpack_require__(5639);

/* Built-in method references that are verified to be native. */
var Set = getNative(root, 'Set');

module.exports = Set;


/***/ }),

/***/ 8668:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var MapCache = __webpack_require__(3369),
    setCacheAdd = __webpack_require__(619),
    setCacheHas = __webpack_require__(2385);

/**
 *
 * Creates an array cache object to store unique values.
 *
 * @private
 * @constructor
 * @param {Array} [values] The values to cache.
 */
function SetCache(values) {
  var index = -1,
      length = values == null ? 0 : values.length;

  this.__data__ = new MapCache;
  while (++index < length) {
    this.add(values[index]);
  }
}

// Add methods to `SetCache`.
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
SetCache.prototype.has = setCacheHas;

module.exports = SetCache;


/***/ }),

/***/ 6384:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var ListCache = __webpack_require__(8407),
    stackClear = __webpack_require__(7465),
    stackDelete = __webpack_require__(3779),
    stackGet = __webpack_require__(7599),
    stackHas = __webpack_require__(4758),
    stackSet = __webpack_require__(4309);

/**
 * Creates a stack cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Stack(entries) {
  var data = this.__data__ = new ListCache(entries);
  this.size = data.size;
}

// Add methods to `Stack`.
Stack.prototype.clear = stackClear;
Stack.prototype['delete'] = stackDelete;
Stack.prototype.get = stackGet;
Stack.prototype.has = stackHas;
Stack.prototype.set = stackSet;

module.exports = Stack;


/***/ }),

/***/ 2705:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var root = __webpack_require__(5639);

/** Built-in value references. */
var Symbol = root.Symbol;

module.exports = Symbol;


/***/ }),

/***/ 1149:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var root = __webpack_require__(5639);

/** Built-in value references. */
var Uint8Array = root.Uint8Array;

module.exports = Uint8Array;


/***/ }),

/***/ 577:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(852),
    root = __webpack_require__(5639);

/* Built-in method references that are verified to be native. */
var WeakMap = getNative(root, 'WeakMap');

module.exports = WeakMap;


/***/ }),

/***/ 6874:
/***/ ((module) => {

/**
 * A faster alternative to `Function#apply`, this function invokes `func`
 * with the `this` binding of `thisArg` and the arguments of `args`.
 *
 * @private
 * @param {Function} func The function to invoke.
 * @param {*} thisArg The `this` binding of `func`.
 * @param {Array} args The arguments to invoke `func` with.
 * @returns {*} Returns the result of `func`.
 */
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0: return func.call(thisArg);
    case 1: return func.call(thisArg, args[0]);
    case 2: return func.call(thisArg, args[0], args[1]);
    case 3: return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}

module.exports = apply;


/***/ }),

/***/ 4963:
/***/ ((module) => {

/**
 * A specialized version of `_.filter` for arrays without support for
 * iteratee shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {Array} Returns the new filtered array.
 */
function arrayFilter(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}

module.exports = arrayFilter;


/***/ }),

/***/ 4636:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseTimes = __webpack_require__(2545),
    isArguments = __webpack_require__(5694),
    isArray = __webpack_require__(1469),
    isBuffer = __webpack_require__(4144),
    isIndex = __webpack_require__(5776),
    isTypedArray = __webpack_require__(6719);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Creates an array of the enumerable property names of the array-like `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @param {boolean} inherited Specify returning inherited property names.
 * @returns {Array} Returns the array of property names.
 */
function arrayLikeKeys(value, inherited) {
  var isArr = isArray(value),
      isArg = !isArr && isArguments(value),
      isBuff = !isArr && !isArg && isBuffer(value),
      isType = !isArr && !isArg && !isBuff && isTypedArray(value),
      skipIndexes = isArr || isArg || isBuff || isType,
      result = skipIndexes ? baseTimes(value.length, String) : [],
      length = result.length;

  for (var key in value) {
    if ((inherited || hasOwnProperty.call(value, key)) &&
        !(skipIndexes && (
           // Safari 9 has enumerable `arguments.length` in strict mode.
           key == 'length' ||
           // Node.js 0.10 has enumerable non-index properties on buffers.
           (isBuff && (key == 'offset' || key == 'parent')) ||
           // PhantomJS 2 has enumerable non-index properties on typed arrays.
           (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
           // Skip index properties.
           isIndex(key, length)
        ))) {
      result.push(key);
    }
  }
  return result;
}

module.exports = arrayLikeKeys;


/***/ }),

/***/ 9932:
/***/ ((module) => {

/**
 * A specialized version of `_.map` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the new mapped array.
 */
function arrayMap(array, iteratee) {
  var index = -1,
      length = array == null ? 0 : array.length,
      result = Array(length);

  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}

module.exports = arrayMap;


/***/ }),

/***/ 2488:
/***/ ((module) => {

/**
 * Appends the elements of `values` to `array`.
 *
 * @private
 * @param {Array} array The array to modify.
 * @param {Array} values The values to append.
 * @returns {Array} Returns `array`.
 */
function arrayPush(array, values) {
  var index = -1,
      length = values.length,
      offset = array.length;

  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}

module.exports = arrayPush;


/***/ }),

/***/ 2908:
/***/ ((module) => {

/**
 * A specialized version of `_.some` for arrays without support for iteratee
 * shorthands.
 *
 * @private
 * @param {Array} [array] The array to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function arraySome(array, predicate) {
  var index = -1,
      length = array == null ? 0 : array.length;

  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}

module.exports = arraySome;


/***/ }),

/***/ 4865:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseAssignValue = __webpack_require__(9465),
    eq = __webpack_require__(7813);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function assignValue(object, key, value) {
  var objValue = object[key];
  if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
      (value === undefined && !(key in object))) {
    baseAssignValue(object, key, value);
  }
}

module.exports = assignValue;


/***/ }),

/***/ 8470:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var eq = __webpack_require__(7813);

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

module.exports = assocIndexOf;


/***/ }),

/***/ 9465:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var defineProperty = __webpack_require__(8777);

/**
 * The base implementation of `assignValue` and `assignMergeValue` without
 * value checks.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */
function baseAssignValue(object, key, value) {
  if (key == '__proto__' && defineProperty) {
    defineProperty(object, key, {
      'configurable': true,
      'enumerable': true,
      'value': value,
      'writable': true
    });
  } else {
    object[key] = value;
  }
}

module.exports = baseAssignValue;


/***/ }),

/***/ 9881:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseForOwn = __webpack_require__(7816),
    createBaseEach = __webpack_require__(9291);

/**
 * The base implementation of `_.forEach` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array|Object} Returns `collection`.
 */
var baseEach = createBaseEach(baseForOwn);

module.exports = baseEach;


/***/ }),

/***/ 8483:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var createBaseFor = __webpack_require__(5063);

/**
 * The base implementation of `baseForOwn` which iterates over `object`
 * properties returned by `keysFunc` and invokes `iteratee` for each property.
 * Iteratee functions may exit iteration early by explicitly returning `false`.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @returns {Object} Returns `object`.
 */
var baseFor = createBaseFor();

module.exports = baseFor;


/***/ }),

/***/ 7816:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseFor = __webpack_require__(8483),
    keys = __webpack_require__(3674);

/**
 * The base implementation of `_.forOwn` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to iterate over.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Object} Returns `object`.
 */
function baseForOwn(object, iteratee) {
  return object && baseFor(object, iteratee, keys);
}

module.exports = baseForOwn;


/***/ }),

/***/ 7786:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var castPath = __webpack_require__(1811),
    toKey = __webpack_require__(327);

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = castPath(path, object);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

module.exports = baseGet;


/***/ }),

/***/ 8866:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayPush = __webpack_require__(2488),
    isArray = __webpack_require__(1469);

/**
 * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
 * `keysFunc` and `symbolsFunc` to get the enumerable property names and
 * symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Function} keysFunc The function to get the keys of `object`.
 * @param {Function} symbolsFunc The function to get the symbols of `object`.
 * @returns {Array} Returns the array of property names and symbols.
 */
function baseGetAllKeys(object, keysFunc, symbolsFunc) {
  var result = keysFunc(object);
  return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
}

module.exports = baseGetAllKeys;


/***/ }),

/***/ 4239:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(2705),
    getRawTag = __webpack_require__(9607),
    objectToString = __webpack_require__(2333);

/** `Object#toString` result references. */
var nullTag = '[object Null]',
    undefinedTag = '[object Undefined]';

/** Built-in value references. */
var symToStringTag = Symbol ? Symbol.toStringTag : undefined;

/**
 * The base implementation of `getTag` without fallbacks for buggy environments.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
function baseGetTag(value) {
  if (value == null) {
    return value === undefined ? undefinedTag : nullTag;
  }
  return (symToStringTag && symToStringTag in Object(value))
    ? getRawTag(value)
    : objectToString(value);
}

module.exports = baseGetTag;


/***/ }),

/***/ 13:
/***/ ((module) => {

/**
 * The base implementation of `_.hasIn` without support for deep paths.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {Array|string} key The key to check.
 * @returns {boolean} Returns `true` if `key` exists, else `false`.
 */
function baseHasIn(object, key) {
  return object != null && key in Object(object);
}

module.exports = baseHasIn;


/***/ }),

/***/ 9454:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(4239),
    isObjectLike = __webpack_require__(7005);

/** `Object#toString` result references. */
var argsTag = '[object Arguments]';

/**
 * The base implementation of `_.isArguments`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 */
function baseIsArguments(value) {
  return isObjectLike(value) && baseGetTag(value) == argsTag;
}

module.exports = baseIsArguments;


/***/ }),

/***/ 939:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsEqualDeep = __webpack_require__(2492),
    isObjectLike = __webpack_require__(7005);

/**
 * The base implementation of `_.isEqual` which supports partial comparisons
 * and tracks traversed objects.
 *
 * @private
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @param {boolean} bitmask The bitmask flags.
 *  1 - Unordered comparison
 *  2 - Partial comparison
 * @param {Function} [customizer] The function to customize comparisons.
 * @param {Object} [stack] Tracks traversed `value` and `other` objects.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 */
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
}

module.exports = baseIsEqual;


/***/ }),

/***/ 2492:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Stack = __webpack_require__(6384),
    equalArrays = __webpack_require__(7114),
    equalByTag = __webpack_require__(8351),
    equalObjects = __webpack_require__(6096),
    getTag = __webpack_require__(4160),
    isArray = __webpack_require__(1469),
    isBuffer = __webpack_require__(4144),
    isTypedArray = __webpack_require__(6719);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    objectTag = '[object Object]';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqual` for arrays and objects which performs
 * deep comparisons and tracks traversed objects enabling objects with circular
 * references to be compared.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} [stack] Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray(object),
      othIsArr = isArray(other),
      objTag = objIsArr ? arrayTag : getTag(object),
      othTag = othIsArr ? arrayTag : getTag(other);

  objTag = objTag == argsTag ? objectTag : objTag;
  othTag = othTag == argsTag ? objectTag : othTag;

  var objIsObj = objTag == objectTag,
      othIsObj = othTag == objectTag,
      isSameTag = objTag == othTag;

  if (isSameTag && isBuffer(object)) {
    if (!isBuffer(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack);
    return (objIsArr || isTypedArray(object))
      ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
      : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
    var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
        othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object.value() : object,
          othUnwrapped = othIsWrapped ? other.value() : other;

      stack || (stack = new Stack);
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack);
  return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
}

module.exports = baseIsEqualDeep;


/***/ }),

/***/ 2958:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Stack = __webpack_require__(6384),
    baseIsEqual = __webpack_require__(939);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.isMatch` without support for iteratee shorthands.
 *
 * @private
 * @param {Object} object The object to inspect.
 * @param {Object} source The object of property values to match.
 * @param {Array} matchData The property names, values, and compare flags to match.
 * @param {Function} [customizer] The function to customize comparisons.
 * @returns {boolean} Returns `true` if `object` is a match, else `false`.
 */
function baseIsMatch(object, source, matchData, customizer) {
  var index = matchData.length,
      length = index,
      noCustomizer = !customizer;

  if (object == null) {
    return !length;
  }
  object = Object(object);
  while (index--) {
    var data = matchData[index];
    if ((noCustomizer && data[2])
          ? data[1] !== object[data[0]]
          : !(data[0] in object)
        ) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0],
        objValue = object[key],
        srcValue = data[1];

    if (noCustomizer && data[2]) {
      if (objValue === undefined && !(key in object)) {
        return false;
      }
    } else {
      var stack = new Stack;
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object, source, stack);
      }
      if (!(result === undefined
            ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack)
            : result
          )) {
        return false;
      }
    }
  }
  return true;
}

module.exports = baseIsMatch;


/***/ }),

/***/ 8458:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isFunction = __webpack_require__(3560),
    isMasked = __webpack_require__(5346),
    isObject = __webpack_require__(3218),
    toSource = __webpack_require__(346);

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Used for built-in method references. */
var funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

module.exports = baseIsNative;


/***/ }),

/***/ 8749:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(4239),
    isLength = __webpack_require__(1780),
    isObjectLike = __webpack_require__(7005);

/** `Object#toString` result references. */
var argsTag = '[object Arguments]',
    arrayTag = '[object Array]',
    boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    funcTag = '[object Function]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    objectTag = '[object Object]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    weakMapTag = '[object WeakMap]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]',
    float32Tag = '[object Float32Array]',
    float64Tag = '[object Float64Array]',
    int8Tag = '[object Int8Array]',
    int16Tag = '[object Int16Array]',
    int32Tag = '[object Int32Array]',
    uint8Tag = '[object Uint8Array]',
    uint8ClampedTag = '[object Uint8ClampedArray]',
    uint16Tag = '[object Uint16Array]',
    uint32Tag = '[object Uint32Array]';

/** Used to identify `toStringTag` values of typed arrays. */
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
typedArrayTags[errorTag] = typedArrayTags[funcTag] =
typedArrayTags[mapTag] = typedArrayTags[numberTag] =
typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
typedArrayTags[setTag] = typedArrayTags[stringTag] =
typedArrayTags[weakMapTag] = false;

/**
 * The base implementation of `_.isTypedArray` without Node.js optimizations.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 */
function baseIsTypedArray(value) {
  return isObjectLike(value) &&
    isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
}

module.exports = baseIsTypedArray;


/***/ }),

/***/ 7206:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseMatches = __webpack_require__(1573),
    baseMatchesProperty = __webpack_require__(6432),
    identity = __webpack_require__(6557),
    isArray = __webpack_require__(1469),
    property = __webpack_require__(9601);

/**
 * The base implementation of `_.iteratee`.
 *
 * @private
 * @param {*} [value=_.identity] The value to convert to an iteratee.
 * @returns {Function} Returns the iteratee.
 */
function baseIteratee(value) {
  // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
  // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
  if (typeof value == 'function') {
    return value;
  }
  if (value == null) {
    return identity;
  }
  if (typeof value == 'object') {
    return isArray(value)
      ? baseMatchesProperty(value[0], value[1])
      : baseMatches(value);
  }
  return property(value);
}

module.exports = baseIteratee;


/***/ }),

/***/ 280:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isPrototype = __webpack_require__(5726),
    nativeKeys = __webpack_require__(6916);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 */
function baseKeys(object) {
  if (!isPrototype(object)) {
    return nativeKeys(object);
  }
  var result = [];
  for (var key in Object(object)) {
    if (hasOwnProperty.call(object, key) && key != 'constructor') {
      result.push(key);
    }
  }
  return result;
}

module.exports = baseKeys;


/***/ }),

/***/ 1573:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsMatch = __webpack_require__(2958),
    getMatchData = __webpack_require__(1499),
    matchesStrictComparable = __webpack_require__(2634);

/**
 * The base implementation of `_.matches` which doesn't clone `source`.
 *
 * @private
 * @param {Object} source The object of property values to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatches(source) {
  var matchData = getMatchData(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable(matchData[0][0], matchData[0][1]);
  }
  return function(object) {
    return object === source || baseIsMatch(object, source, matchData);
  };
}

module.exports = baseMatches;


/***/ }),

/***/ 6432:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsEqual = __webpack_require__(939),
    get = __webpack_require__(7361),
    hasIn = __webpack_require__(9095),
    isKey = __webpack_require__(5403),
    isStrictComparable = __webpack_require__(9162),
    matchesStrictComparable = __webpack_require__(2634),
    toKey = __webpack_require__(327);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
 *
 * @private
 * @param {string} path The path of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function baseMatchesProperty(path, srcValue) {
  if (isKey(path) && isStrictComparable(srcValue)) {
    return matchesStrictComparable(toKey(path), srcValue);
  }
  return function(object) {
    var objValue = get(object, path);
    return (objValue === undefined && objValue === srcValue)
      ? hasIn(object, path)
      : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
  };
}

module.exports = baseMatchesProperty;


/***/ }),

/***/ 371:
/***/ ((module) => {

/**
 * The base implementation of `_.property` without support for deep paths.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function baseProperty(key) {
  return function(object) {
    return object == null ? undefined : object[key];
  };
}

module.exports = baseProperty;


/***/ }),

/***/ 9152:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGet = __webpack_require__(7786);

/**
 * A specialized version of `baseProperty` which supports deep paths.
 *
 * @private
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 */
function basePropertyDeep(path) {
  return function(object) {
    return baseGet(object, path);
  };
}

module.exports = basePropertyDeep;


/***/ }),

/***/ 5976:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var identity = __webpack_require__(6557),
    overRest = __webpack_require__(5357),
    setToString = __webpack_require__(61);

/**
 * The base implementation of `_.rest` which doesn't validate or coerce arguments.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @returns {Function} Returns the new function.
 */
function baseRest(func, start) {
  return setToString(overRest(func, start, identity), func + '');
}

module.exports = baseRest;


/***/ }),

/***/ 6560:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var constant = __webpack_require__(5703),
    defineProperty = __webpack_require__(8777),
    identity = __webpack_require__(6557);

/**
 * The base implementation of `setToString` without support for hot loop shorting.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var baseSetToString = !defineProperty ? identity : function(func, string) {
  return defineProperty(func, 'toString', {
    'configurable': true,
    'enumerable': false,
    'value': constant(string),
    'writable': true
  });
};

module.exports = baseSetToString;


/***/ }),

/***/ 5076:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseEach = __webpack_require__(9881);

/**
 * The base implementation of `_.some` without support for iteratee shorthands.
 *
 * @private
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} predicate The function invoked per iteration.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 */
function baseSome(collection, predicate) {
  var result;

  baseEach(collection, function(value, index, collection) {
    result = predicate(value, index, collection);
    return !result;
  });
  return !!result;
}

module.exports = baseSome;


/***/ }),

/***/ 2545:
/***/ ((module) => {

/**
 * The base implementation of `_.times` without support for iteratee shorthands
 * or max array length checks.
 *
 * @private
 * @param {number} n The number of times to invoke `iteratee`.
 * @param {Function} iteratee The function invoked per iteration.
 * @returns {Array} Returns the array of results.
 */
function baseTimes(n, iteratee) {
  var index = -1,
      result = Array(n);

  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}

module.exports = baseTimes;


/***/ }),

/***/ 531:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(2705),
    arrayMap = __webpack_require__(9932),
    isArray = __webpack_require__(1469),
    isSymbol = __webpack_require__(3448);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isArray(value)) {
    // Recursively convert values (susceptible to call stack limits).
    return arrayMap(value, baseToString) + '';
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = baseToString;


/***/ }),

/***/ 7518:
/***/ ((module) => {

/**
 * The base implementation of `_.unary` without support for storing metadata.
 *
 * @private
 * @param {Function} func The function to cap arguments for.
 * @returns {Function} Returns the new capped function.
 */
function baseUnary(func) {
  return function(value) {
    return func(value);
  };
}

module.exports = baseUnary;


/***/ }),

/***/ 4757:
/***/ ((module) => {

/**
 * Checks if a `cache` value for `key` exists.
 *
 * @private
 * @param {Object} cache The cache to query.
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function cacheHas(cache, key) {
  return cache.has(key);
}

module.exports = cacheHas;


/***/ }),

/***/ 1811:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isArray = __webpack_require__(1469),
    isKey = __webpack_require__(5403),
    stringToPath = __webpack_require__(5514),
    toString = __webpack_require__(9833);

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @param {Object} [object] The object to query keys on.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value, object) {
  if (isArray(value)) {
    return value;
  }
  return isKey(value, object) ? [value] : stringToPath(toString(value));
}

module.exports = castPath;


/***/ }),

/***/ 8363:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assignValue = __webpack_require__(4865),
    baseAssignValue = __webpack_require__(9465);

/**
 * Copies properties of `source` to `object`.
 *
 * @private
 * @param {Object} source The object to copy properties from.
 * @param {Array} props The property identifiers to copy.
 * @param {Object} [object={}] The object to copy properties to.
 * @param {Function} [customizer] The function to customize copied values.
 * @returns {Object} Returns `object`.
 */
function copyObject(source, props, object, customizer) {
  var isNew = !object;
  object || (object = {});

  var index = -1,
      length = props.length;

  while (++index < length) {
    var key = props[index];

    var newValue = customizer
      ? customizer(object[key], source[key], key, object, source)
      : undefined;

    if (newValue === undefined) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue(object, key, newValue);
    } else {
      assignValue(object, key, newValue);
    }
  }
  return object;
}

module.exports = copyObject;


/***/ }),

/***/ 4429:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var root = __webpack_require__(5639);

/** Used to detect overreaching core-js shims. */
var coreJsData = root['__core-js_shared__'];

module.exports = coreJsData;


/***/ }),

/***/ 1463:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseRest = __webpack_require__(5976),
    isIterateeCall = __webpack_require__(6612);

/**
 * Creates a function like `_.assign`.
 *
 * @private
 * @param {Function} assigner The function to assign values.
 * @returns {Function} Returns the new assigner function.
 */
function createAssigner(assigner) {
  return baseRest(function(object, sources) {
    var index = -1,
        length = sources.length,
        customizer = length > 1 ? sources[length - 1] : undefined,
        guard = length > 2 ? sources[2] : undefined;

    customizer = (assigner.length > 3 && typeof customizer == 'function')
      ? (length--, customizer)
      : undefined;

    if (guard && isIterateeCall(sources[0], sources[1], guard)) {
      customizer = length < 3 ? undefined : customizer;
      length = 1;
    }
    object = Object(object);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object, source, index, customizer);
      }
    }
    return object;
  });
}

module.exports = createAssigner;


/***/ }),

/***/ 9291:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isArrayLike = __webpack_require__(8612);

/**
 * Creates a `baseEach` or `baseEachRight` function.
 *
 * @private
 * @param {Function} eachFunc The function to iterate over a collection.
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseEach(eachFunc, fromRight) {
  return function(collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length,
        index = fromRight ? length : -1,
        iterable = Object(collection);

    while ((fromRight ? index-- : ++index < length)) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}

module.exports = createBaseEach;


/***/ }),

/***/ 5063:
/***/ ((module) => {

/**
 * Creates a base function for methods like `_.forIn` and `_.forOwn`.
 *
 * @private
 * @param {boolean} [fromRight] Specify iterating from right to left.
 * @returns {Function} Returns the new base function.
 */
function createBaseFor(fromRight) {
  return function(object, iteratee, keysFunc) {
    var index = -1,
        iterable = Object(object),
        props = keysFunc(object),
        length = props.length;

    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object;
  };
}

module.exports = createBaseFor;


/***/ }),

/***/ 8777:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(852);

var defineProperty = (function() {
  try {
    var func = getNative(Object, 'defineProperty');
    func({}, '', {});
    return func;
  } catch (e) {}
}());

module.exports = defineProperty;


/***/ }),

/***/ 7114:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var SetCache = __webpack_require__(8668),
    arraySome = __webpack_require__(2908),
    cacheHas = __webpack_require__(4757);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/**
 * A specialized version of `baseIsEqualDeep` for arrays with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Array} array The array to compare.
 * @param {Array} other The other array to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `array` and `other` objects.
 * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
 */
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      arrLength = array.length,
      othLength = other.length;

  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  // Check that cyclic values are equal.
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1,
      result = true,
      seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined;

  stack.set(array, other);
  stack.set(other, array);

  // Ignore non-index properties.
  while (++index < arrLength) {
    var arrValue = array[index],
        othValue = other[index];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, arrValue, index, other, array, stack)
        : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== undefined) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    // Recursively compare arrays (susceptible to call stack limits).
    if (seen) {
      if (!arraySome(other, function(othValue, othIndex) {
            if (!cacheHas(seen, othIndex) &&
                (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
        result = false;
        break;
      }
    } else if (!(
          arrValue === othValue ||
            equalFunc(arrValue, othValue, bitmask, customizer, stack)
        )) {
      result = false;
      break;
    }
  }
  stack['delete'](array);
  stack['delete'](other);
  return result;
}

module.exports = equalArrays;


/***/ }),

/***/ 8351:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(2705),
    Uint8Array = __webpack_require__(1149),
    eq = __webpack_require__(7813),
    equalArrays = __webpack_require__(7114),
    mapToArray = __webpack_require__(8776),
    setToArray = __webpack_require__(1814);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1,
    COMPARE_UNORDERED_FLAG = 2;

/** `Object#toString` result references. */
var boolTag = '[object Boolean]',
    dateTag = '[object Date]',
    errorTag = '[object Error]',
    mapTag = '[object Map]',
    numberTag = '[object Number]',
    regexpTag = '[object RegExp]',
    setTag = '[object Set]',
    stringTag = '[object String]',
    symbolTag = '[object Symbol]';

var arrayBufferTag = '[object ArrayBuffer]',
    dataViewTag = '[object DataView]';

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol ? Symbol.prototype : undefined,
    symbolValueOf = symbolProto ? symbolProto.valueOf : undefined;

/**
 * A specialized version of `baseIsEqualDeep` for comparing objects of
 * the same `toStringTag`.
 *
 * **Note:** This function only supports comparing values with tags of
 * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {string} tag The `toStringTag` of the objects to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag:
      if ((object.byteLength != other.byteLength) ||
          (object.byteOffset != other.byteOffset)) {
        return false;
      }
      object = object.buffer;
      other = other.buffer;

    case arrayBufferTag:
      if ((object.byteLength != other.byteLength) ||
          !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
        return false;
      }
      return true;

    case boolTag:
    case dateTag:
    case numberTag:
      // Coerce booleans to `1` or `0` and dates to milliseconds.
      // Invalid dates are coerced to `NaN`.
      return eq(+object, +other);

    case errorTag:
      return object.name == other.name && object.message == other.message;

    case regexpTag:
    case stringTag:
      // Coerce regexes to strings and treat strings, primitives and objects,
      // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
      // for more details.
      return object == (other + '');

    case mapTag:
      var convert = mapToArray;

    case setTag:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
      convert || (convert = setToArray);

      if (object.size != other.size && !isPartial) {
        return false;
      }
      // Assume cyclic values are equal.
      var stacked = stack.get(object);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG;

      // Recursively compare objects (susceptible to call stack limits).
      stack.set(object, other);
      var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
      stack['delete'](object);
      return result;

    case symbolTag:
      if (symbolValueOf) {
        return symbolValueOf.call(object) == symbolValueOf.call(other);
      }
  }
  return false;
}

module.exports = equalByTag;


/***/ }),

/***/ 6096:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getAllKeys = __webpack_require__(8234);

/** Used to compose bitmasks for value comparisons. */
var COMPARE_PARTIAL_FLAG = 1;

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * A specialized version of `baseIsEqualDeep` for objects with support for
 * partial deep comparisons.
 *
 * @private
 * @param {Object} object The object to compare.
 * @param {Object} other The other object to compare.
 * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
 * @param {Function} customizer The function to customize comparisons.
 * @param {Function} equalFunc The function to determine equivalents of values.
 * @param {Object} stack Tracks traversed `object` and `other` objects.
 * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
 */
function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
      objProps = getAllKeys(object),
      objLength = objProps.length,
      othProps = getAllKeys(other),
      othLength = othProps.length;

  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
      return false;
    }
  }
  // Check that cyclic values are equal.
  var objStacked = stack.get(object);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object;
  }
  var result = true;
  stack.set(object, other);
  stack.set(other, object);

  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object[key],
        othValue = other[key];

    if (customizer) {
      var compared = isPartial
        ? customizer(othValue, objValue, key, other, object, stack)
        : customizer(objValue, othValue, key, object, other, stack);
    }
    // Recursively compare objects (susceptible to call stack limits).
    if (!(compared === undefined
          ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
          : compared
        )) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == 'constructor');
  }
  if (result && !skipCtor) {
    var objCtor = object.constructor,
        othCtor = other.constructor;

    // Non `Object` object instances with different constructors are not equal.
    if (objCtor != othCtor &&
        ('constructor' in object && 'constructor' in other) &&
        !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
          typeof othCtor == 'function' && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack['delete'](object);
  stack['delete'](other);
  return result;
}

module.exports = equalObjects;


/***/ }),

/***/ 1957:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof __webpack_require__.g == 'object' && __webpack_require__.g && __webpack_require__.g.Object === Object && __webpack_require__.g;

module.exports = freeGlobal;


/***/ }),

/***/ 8234:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetAllKeys = __webpack_require__(8866),
    getSymbols = __webpack_require__(9551),
    keys = __webpack_require__(3674);

/**
 * Creates an array of own enumerable property names and symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names and symbols.
 */
function getAllKeys(object) {
  return baseGetAllKeys(object, keys, getSymbols);
}

module.exports = getAllKeys;


/***/ }),

/***/ 5050:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isKeyable = __webpack_require__(7019);

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

module.exports = getMapData;


/***/ }),

/***/ 1499:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isStrictComparable = __webpack_require__(9162),
    keys = __webpack_require__(3674);

/**
 * Gets the property names, values, and compare flags of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the match data of `object`.
 */
function getMatchData(object) {
  var result = keys(object),
      length = result.length;

  while (length--) {
    var key = result[length],
        value = object[key];

    result[length] = [key, value, isStrictComparable(value)];
  }
  return result;
}

module.exports = getMatchData;


/***/ }),

/***/ 852:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsNative = __webpack_require__(8458),
    getValue = __webpack_require__(7801);

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

module.exports = getNative;


/***/ }),

/***/ 9607:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Symbol = __webpack_require__(2705);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto.toString;

/** Built-in value references. */
var symToStringTag = Symbol ? Symbol.toStringTag : undefined;

/**
 * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the raw `toStringTag`.
 */
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag),
      tag = value[symToStringTag];

  try {
    value[symToStringTag] = undefined;
    var unmasked = true;
  } catch (e) {}

  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}

module.exports = getRawTag;


/***/ }),

/***/ 9551:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayFilter = __webpack_require__(4963),
    stubArray = __webpack_require__(479);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeGetSymbols = Object.getOwnPropertySymbols;

/**
 * Creates an array of the own enumerable symbols of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of symbols.
 */
var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
  if (object == null) {
    return [];
  }
  object = Object(object);
  return arrayFilter(nativeGetSymbols(object), function(symbol) {
    return propertyIsEnumerable.call(object, symbol);
  });
};

module.exports = getSymbols;


/***/ }),

/***/ 4160:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var DataView = __webpack_require__(8552),
    Map = __webpack_require__(7071),
    Promise = __webpack_require__(3818),
    Set = __webpack_require__(8525),
    WeakMap = __webpack_require__(577),
    baseGetTag = __webpack_require__(4239),
    toSource = __webpack_require__(346);

/** `Object#toString` result references. */
var mapTag = '[object Map]',
    objectTag = '[object Object]',
    promiseTag = '[object Promise]',
    setTag = '[object Set]',
    weakMapTag = '[object WeakMap]';

var dataViewTag = '[object DataView]';

/** Used to detect maps, sets, and weakmaps. */
var dataViewCtorString = toSource(DataView),
    mapCtorString = toSource(Map),
    promiseCtorString = toSource(Promise),
    setCtorString = toSource(Set),
    weakMapCtorString = toSource(WeakMap);

/**
 * Gets the `toStringTag` of `value`.
 *
 * @private
 * @param {*} value The value to query.
 * @returns {string} Returns the `toStringTag`.
 */
var getTag = baseGetTag;

// Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
    (Map && getTag(new Map) != mapTag) ||
    (Promise && getTag(Promise.resolve()) != promiseTag) ||
    (Set && getTag(new Set) != setTag) ||
    (WeakMap && getTag(new WeakMap) != weakMapTag)) {
  getTag = function(value) {
    var result = baseGetTag(value),
        Ctor = result == objectTag ? value.constructor : undefined,
        ctorString = Ctor ? toSource(Ctor) : '';

    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString: return dataViewTag;
        case mapCtorString: return mapTag;
        case promiseCtorString: return promiseTag;
        case setCtorString: return setTag;
        case weakMapCtorString: return weakMapTag;
      }
    }
    return result;
  };
}

module.exports = getTag;


/***/ }),

/***/ 7801:
/***/ ((module) => {

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

module.exports = getValue;


/***/ }),

/***/ 222:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var castPath = __webpack_require__(1811),
    isArguments = __webpack_require__(5694),
    isArray = __webpack_require__(1469),
    isIndex = __webpack_require__(5776),
    isLength = __webpack_require__(1780),
    toKey = __webpack_require__(327);

/**
 * Checks if `path` exists on `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @param {Function} hasFunc The function to check properties.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 */
function hasPath(object, path, hasFunc) {
  path = castPath(path, object);

  var index = -1,
      length = path.length,
      result = false;

  while (++index < length) {
    var key = toKey(path[index]);
    if (!(result = object != null && hasFunc(object, key))) {
      break;
    }
    object = object[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object == null ? 0 : object.length;
  return !!length && isLength(length) && isIndex(key, length) &&
    (isArray(object) || isArguments(object));
}

module.exports = hasPath;


/***/ }),

/***/ 1789:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var nativeCreate = __webpack_require__(4536);

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
  this.size = 0;
}

module.exports = hashClear;


/***/ }),

/***/ 401:
/***/ ((module) => {

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}

module.exports = hashDelete;


/***/ }),

/***/ 7667:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var nativeCreate = __webpack_require__(4536);

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }
  return hasOwnProperty.call(data, key) ? data[key] : undefined;
}

module.exports = hashGet;


/***/ }),

/***/ 1327:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var nativeCreate = __webpack_require__(4536);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? (data[key] !== undefined) : hasOwnProperty.call(data, key);
}

module.exports = hashHas;


/***/ }),

/***/ 1866:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var nativeCreate = __webpack_require__(4536);

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
  return this;
}

module.exports = hashSet;


/***/ }),

/***/ 5776:
/***/ ((module) => {

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/** Used to detect unsigned integer values. */
var reIsUint = /^(?:0|[1-9]\d*)$/;

/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */
function isIndex(value, length) {
  var type = typeof value;
  length = length == null ? MAX_SAFE_INTEGER : length;

  return !!length &&
    (type == 'number' ||
      (type != 'symbol' && reIsUint.test(value))) &&
        (value > -1 && value % 1 == 0 && value < length);
}

module.exports = isIndex;


/***/ }),

/***/ 6612:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var eq = __webpack_require__(7813),
    isArrayLike = __webpack_require__(8612),
    isIndex = __webpack_require__(5776),
    isObject = __webpack_require__(3218);

/**
 * Checks if the given arguments are from an iteratee call.
 *
 * @private
 * @param {*} value The potential iteratee value argument.
 * @param {*} index The potential iteratee index or key argument.
 * @param {*} object The potential iteratee object argument.
 * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
 *  else `false`.
 */
function isIterateeCall(value, index, object) {
  if (!isObject(object)) {
    return false;
  }
  var type = typeof index;
  if (type == 'number'
        ? (isArrayLike(object) && isIndex(index, object.length))
        : (type == 'string' && index in object)
      ) {
    return eq(object[index], value);
  }
  return false;
}

module.exports = isIterateeCall;


/***/ }),

/***/ 5403:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isArray = __webpack_require__(1469),
    isSymbol = __webpack_require__(3448);

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/;

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isArray(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

module.exports = isKey;


/***/ }),

/***/ 7019:
/***/ ((module) => {

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

module.exports = isKeyable;


/***/ }),

/***/ 5346:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var coreJsData = __webpack_require__(4429);

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

module.exports = isMasked;


/***/ }),

/***/ 5726:
/***/ ((module) => {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Checks if `value` is likely a prototype object.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
 */
function isPrototype(value) {
  var Ctor = value && value.constructor,
      proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

  return value === proto;
}

module.exports = isPrototype;


/***/ }),

/***/ 9162:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isObject = __webpack_require__(3218);

/**
 * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` if suitable for strict
 *  equality comparisons, else `false`.
 */
function isStrictComparable(value) {
  return value === value && !isObject(value);
}

module.exports = isStrictComparable;


/***/ }),

/***/ 7040:
/***/ ((module) => {

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}

module.exports = listCacheClear;


/***/ }),

/***/ 4125:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assocIndexOf = __webpack_require__(8470);

/** Used for built-in method references. */
var arrayProto = Array.prototype;

/** Built-in value references. */
var splice = arrayProto.splice;

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}

module.exports = listCacheDelete;


/***/ }),

/***/ 2117:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assocIndexOf = __webpack_require__(8470);

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  return index < 0 ? undefined : data[index][1];
}

module.exports = listCacheGet;


/***/ }),

/***/ 7529:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assocIndexOf = __webpack_require__(8470);

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}

module.exports = listCacheHas;


/***/ }),

/***/ 4705:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assocIndexOf = __webpack_require__(8470);

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

module.exports = listCacheSet;


/***/ }),

/***/ 4785:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var Hash = __webpack_require__(1989),
    ListCache = __webpack_require__(8407),
    Map = __webpack_require__(7071);

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map || ListCache),
    'string': new Hash
  };
}

module.exports = mapCacheClear;


/***/ }),

/***/ 1285:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getMapData = __webpack_require__(5050);

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete(key) {
  var result = getMapData(this, key)['delete'](key);
  this.size -= result ? 1 : 0;
  return result;
}

module.exports = mapCacheDelete;


/***/ }),

/***/ 6000:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getMapData = __webpack_require__(5050);

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}

module.exports = mapCacheGet;


/***/ }),

/***/ 9916:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getMapData = __webpack_require__(5050);

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}

module.exports = mapCacheHas;


/***/ }),

/***/ 5265:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getMapData = __webpack_require__(5050);

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet(key, value) {
  var data = getMapData(this, key),
      size = data.size;

  data.set(key, value);
  this.size += data.size == size ? 0 : 1;
  return this;
}

module.exports = mapCacheSet;


/***/ }),

/***/ 8776:
/***/ ((module) => {

/**
 * Converts `map` to its key-value pairs.
 *
 * @private
 * @param {Object} map The map to convert.
 * @returns {Array} Returns the key-value pairs.
 */
function mapToArray(map) {
  var index = -1,
      result = Array(map.size);

  map.forEach(function(value, key) {
    result[++index] = [key, value];
  });
  return result;
}

module.exports = mapToArray;


/***/ }),

/***/ 2634:
/***/ ((module) => {

/**
 * A specialized version of `matchesProperty` for source values suitable
 * for strict equality comparisons, i.e. `===`.
 *
 * @private
 * @param {string} key The key of the property to get.
 * @param {*} srcValue The value to match.
 * @returns {Function} Returns the new spec function.
 */
function matchesStrictComparable(key, srcValue) {
  return function(object) {
    if (object == null) {
      return false;
    }
    return object[key] === srcValue &&
      (srcValue !== undefined || (key in Object(object)));
  };
}

module.exports = matchesStrictComparable;


/***/ }),

/***/ 4523:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var memoize = __webpack_require__(8306);

/** Used as the maximum memoize cache size. */
var MAX_MEMOIZE_SIZE = 500;

/**
 * A specialized version of `_.memoize` which clears the memoized function's
 * cache when it exceeds `MAX_MEMOIZE_SIZE`.
 *
 * @private
 * @param {Function} func The function to have its output memoized.
 * @returns {Function} Returns the new memoized function.
 */
function memoizeCapped(func) {
  var result = memoize(func, function(key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });

  var cache = result.cache;
  return result;
}

module.exports = memoizeCapped;


/***/ }),

/***/ 4536:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var getNative = __webpack_require__(852);

/* Built-in method references that are verified to be native. */
var nativeCreate = getNative(Object, 'create');

module.exports = nativeCreate;


/***/ }),

/***/ 6916:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var overArg = __webpack_require__(5569);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeKeys = overArg(Object.keys, Object);

module.exports = nativeKeys;


/***/ }),

/***/ 1167:
/***/ ((module, exports, __webpack_require__) => {

/* module decorator */ module = __webpack_require__.nmd(module);
var freeGlobal = __webpack_require__(1957);

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && "object" == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Detect free variable `process` from Node.js. */
var freeProcess = moduleExports && freeGlobal.process;

/** Used to access faster Node.js helpers. */
var nodeUtil = (function() {
  try {
    // Use `util.types` for Node.js 10+.
    var types = freeModule && freeModule.require && freeModule.require('util').types;

    if (types) {
      return types;
    }

    // Legacy `process.binding('util')` for Node.js < 10.
    return freeProcess && freeProcess.binding && freeProcess.binding('util');
  } catch (e) {}
}());

module.exports = nodeUtil;


/***/ }),

/***/ 2333:
/***/ ((module) => {

/** Used for built-in method references. */
var objectProto = Object.prototype;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var nativeObjectToString = objectProto.toString;

/**
 * Converts `value` to a string using `Object.prototype.toString`.
 *
 * @private
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 */
function objectToString(value) {
  return nativeObjectToString.call(value);
}

module.exports = objectToString;


/***/ }),

/***/ 5569:
/***/ ((module) => {

/**
 * Creates a unary function that invokes `func` with its argument transformed.
 *
 * @private
 * @param {Function} func The function to wrap.
 * @param {Function} transform The argument transform.
 * @returns {Function} Returns the new function.
 */
function overArg(func, transform) {
  return function(arg) {
    return func(transform(arg));
  };
}

module.exports = overArg;


/***/ }),

/***/ 5357:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var apply = __webpack_require__(6874);

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeMax = Math.max;

/**
 * A specialized version of `baseRest` which transforms the rest array.
 *
 * @private
 * @param {Function} func The function to apply a rest parameter to.
 * @param {number} [start=func.length-1] The start position of the rest parameter.
 * @param {Function} transform The rest array transform.
 * @returns {Function} Returns the new function.
 */
function overRest(func, start, transform) {
  start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
  return function() {
    var args = arguments,
        index = -1,
        length = nativeMax(args.length - start, 0),
        array = Array(length);

    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform(array);
    return apply(func, this, otherArgs);
  };
}

module.exports = overRest;


/***/ }),

/***/ 5639:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var freeGlobal = __webpack_require__(1957);

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

module.exports = root;


/***/ }),

/***/ 619:
/***/ ((module) => {

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/**
 * Adds `value` to the array cache.
 *
 * @private
 * @name add
 * @memberOf SetCache
 * @alias push
 * @param {*} value The value to cache.
 * @returns {Object} Returns the cache instance.
 */
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED);
  return this;
}

module.exports = setCacheAdd;


/***/ }),

/***/ 2385:
/***/ ((module) => {

/**
 * Checks if `value` is in the array cache.
 *
 * @private
 * @name has
 * @memberOf SetCache
 * @param {*} value The value to search for.
 * @returns {number} Returns `true` if `value` is found, else `false`.
 */
function setCacheHas(value) {
  return this.__data__.has(value);
}

module.exports = setCacheHas;


/***/ }),

/***/ 1814:
/***/ ((module) => {

/**
 * Converts `set` to an array of its values.
 *
 * @private
 * @param {Object} set The set to convert.
 * @returns {Array} Returns the values.
 */
function setToArray(set) {
  var index = -1,
      result = Array(set.size);

  set.forEach(function(value) {
    result[++index] = value;
  });
  return result;
}

module.exports = setToArray;


/***/ }),

/***/ 61:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseSetToString = __webpack_require__(6560),
    shortOut = __webpack_require__(1275);

/**
 * Sets the `toString` method of `func` to return `string`.
 *
 * @private
 * @param {Function} func The function to modify.
 * @param {Function} string The `toString` result.
 * @returns {Function} Returns `func`.
 */
var setToString = shortOut(baseSetToString);

module.exports = setToString;


/***/ }),

/***/ 1275:
/***/ ((module) => {

/** Used to detect hot functions by number of calls within a span of milliseconds. */
var HOT_COUNT = 800,
    HOT_SPAN = 16;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeNow = Date.now;

/**
 * Creates a function that'll short out and invoke `identity` instead
 * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
 * milliseconds.
 *
 * @private
 * @param {Function} func The function to restrict.
 * @returns {Function} Returns the new shortable function.
 */
function shortOut(func) {
  var count = 0,
      lastCalled = 0;

  return function() {
    var stamp = nativeNow(),
        remaining = HOT_SPAN - (stamp - lastCalled);

    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(undefined, arguments);
  };
}

module.exports = shortOut;


/***/ }),

/***/ 7465:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var ListCache = __webpack_require__(8407);

/**
 * Removes all key-value entries from the stack.
 *
 * @private
 * @name clear
 * @memberOf Stack
 */
function stackClear() {
  this.__data__ = new ListCache;
  this.size = 0;
}

module.exports = stackClear;


/***/ }),

/***/ 3779:
/***/ ((module) => {

/**
 * Removes `key` and its value from the stack.
 *
 * @private
 * @name delete
 * @memberOf Stack
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function stackDelete(key) {
  var data = this.__data__,
      result = data['delete'](key);

  this.size = data.size;
  return result;
}

module.exports = stackDelete;


/***/ }),

/***/ 7599:
/***/ ((module) => {

/**
 * Gets the stack value for `key`.
 *
 * @private
 * @name get
 * @memberOf Stack
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function stackGet(key) {
  return this.__data__.get(key);
}

module.exports = stackGet;


/***/ }),

/***/ 4758:
/***/ ((module) => {

/**
 * Checks if a stack value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Stack
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function stackHas(key) {
  return this.__data__.has(key);
}

module.exports = stackHas;


/***/ }),

/***/ 4309:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var ListCache = __webpack_require__(8407),
    Map = __webpack_require__(7071),
    MapCache = __webpack_require__(3369);

/** Used as the size to enable large array optimizations. */
var LARGE_ARRAY_SIZE = 200;

/**
 * Sets the stack `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Stack
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the stack cache instance.
 */
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache) {
    var pairs = data.__data__;
    if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
      pairs.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache(pairs);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}

module.exports = stackSet;


/***/ }),

/***/ 5514:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var memoizeCapped = __webpack_require__(4523);

/** Used to match property names within property paths. */
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = memoizeCapped(function(string) {
  var result = [];
  if (string.charCodeAt(0) === 46 /* . */) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

module.exports = stringToPath;


/***/ }),

/***/ 327:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isSymbol = __webpack_require__(3448);

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

module.exports = toKey;


/***/ }),

/***/ 346:
/***/ ((module) => {

/** Used for built-in method references. */
var funcProto = Function.prototype;

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to convert.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

module.exports = toSource;


/***/ }),

/***/ 8583:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var assignValue = __webpack_require__(4865),
    copyObject = __webpack_require__(8363),
    createAssigner = __webpack_require__(1463),
    isArrayLike = __webpack_require__(8612),
    isPrototype = __webpack_require__(5726),
    keys = __webpack_require__(3674);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Assigns own enumerable string keyed properties of source objects to the
 * destination object. Source objects are applied from left to right.
 * Subsequent sources overwrite property assignments of previous sources.
 *
 * **Note:** This method mutates `object` and is loosely based on
 * [`Object.assign`](https://mdn.io/Object/assign).
 *
 * @static
 * @memberOf _
 * @since 0.10.0
 * @category Object
 * @param {Object} object The destination object.
 * @param {...Object} [sources] The source objects.
 * @returns {Object} Returns `object`.
 * @see _.assignIn
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 * }
 *
 * function Bar() {
 *   this.c = 3;
 * }
 *
 * Foo.prototype.b = 2;
 * Bar.prototype.d = 4;
 *
 * _.assign({ 'a': 0 }, new Foo, new Bar);
 * // => { 'a': 1, 'c': 3 }
 */
var assign = createAssigner(function(object, source) {
  if (isPrototype(source) || isArrayLike(source)) {
    copyObject(source, keys(source), object);
    return;
  }
  for (var key in source) {
    if (hasOwnProperty.call(source, key)) {
      assignValue(object, key, source[key]);
    }
  }
});

module.exports = assign;


/***/ }),

/***/ 5703:
/***/ ((module) => {

/**
 * Creates a function that returns `value`.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {*} value The value to return from the new function.
 * @returns {Function} Returns the new constant function.
 * @example
 *
 * var objects = _.times(2, _.constant({ 'a': 1 }));
 *
 * console.log(objects);
 * // => [{ 'a': 1 }, { 'a': 1 }]
 *
 * console.log(objects[0] === objects[1]);
 * // => true
 */
function constant(value) {
  return function() {
    return value;
  };
}

module.exports = constant;


/***/ }),

/***/ 7813:
/***/ ((module) => {

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

module.exports = eq;


/***/ }),

/***/ 7361:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGet = __webpack_require__(7786);

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

module.exports = get;


/***/ }),

/***/ 9095:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseHasIn = __webpack_require__(13),
    hasPath = __webpack_require__(222);

/**
 * Checks if `path` is a direct or inherited property of `object`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path to check.
 * @returns {boolean} Returns `true` if `path` exists, else `false`.
 * @example
 *
 * var object = _.create({ 'a': _.create({ 'b': 2 }) });
 *
 * _.hasIn(object, 'a');
 * // => true
 *
 * _.hasIn(object, 'a.b');
 * // => true
 *
 * _.hasIn(object, ['a', 'b']);
 * // => true
 *
 * _.hasIn(object, 'b');
 * // => false
 */
function hasIn(object, path) {
  return object != null && hasPath(object, path, baseHasIn);
}

module.exports = hasIn;


/***/ }),

/***/ 6557:
/***/ ((module) => {

/**
 * This method returns the first argument it receives.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Util
 * @param {*} value Any value.
 * @returns {*} Returns `value`.
 * @example
 *
 * var object = { 'a': 1 };
 *
 * console.log(_.identity(object) === object);
 * // => true
 */
function identity(value) {
  return value;
}

module.exports = identity;


/***/ }),

/***/ 5694:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsArguments = __webpack_require__(9454),
    isObjectLike = __webpack_require__(7005);

/** Used for built-in method references. */
var objectProto = Object.prototype;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/** Built-in value references. */
var propertyIsEnumerable = objectProto.propertyIsEnumerable;

/**
 * Checks if `value` is likely an `arguments` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an `arguments` object,
 *  else `false`.
 * @example
 *
 * _.isArguments(function() { return arguments; }());
 * // => true
 *
 * _.isArguments([1, 2, 3]);
 * // => false
 */
var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
  return isObjectLike(value) && hasOwnProperty.call(value, 'callee') &&
    !propertyIsEnumerable.call(value, 'callee');
};

module.exports = isArguments;


/***/ }),

/***/ 1469:
/***/ ((module) => {

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

module.exports = isArray;


/***/ }),

/***/ 8612:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var isFunction = __webpack_require__(3560),
    isLength = __webpack_require__(1780);

/**
 * Checks if `value` is array-like. A value is considered array-like if it's
 * not a function and has a `value.length` that's an integer greater than or
 * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
 * @example
 *
 * _.isArrayLike([1, 2, 3]);
 * // => true
 *
 * _.isArrayLike(document.body.children);
 * // => true
 *
 * _.isArrayLike('abc');
 * // => true
 *
 * _.isArrayLike(_.noop);
 * // => false
 */
function isArrayLike(value) {
  return value != null && isLength(value.length) && !isFunction(value);
}

module.exports = isArrayLike;


/***/ }),

/***/ 4144:
/***/ ((module, exports, __webpack_require__) => {

/* module decorator */ module = __webpack_require__.nmd(module);
var root = __webpack_require__(5639),
    stubFalse = __webpack_require__(5062);

/** Detect free variable `exports`. */
var freeExports =  true && exports && !exports.nodeType && exports;

/** Detect free variable `module`. */
var freeModule = freeExports && "object" == 'object' && module && !module.nodeType && module;

/** Detect the popular CommonJS extension `module.exports`. */
var moduleExports = freeModule && freeModule.exports === freeExports;

/** Built-in value references. */
var Buffer = moduleExports ? root.Buffer : undefined;

/* Built-in method references for those with the same name as other `lodash` methods. */
var nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined;

/**
 * Checks if `value` is a buffer.
 *
 * @static
 * @memberOf _
 * @since 4.3.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
 * @example
 *
 * _.isBuffer(new Buffer(2));
 * // => true
 *
 * _.isBuffer(new Uint8Array(2));
 * // => false
 */
var isBuffer = nativeIsBuffer || stubFalse;

module.exports = isBuffer;


/***/ }),

/***/ 3560:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(4239),
    isObject = __webpack_require__(3218);

/** `Object#toString` result references. */
var asyncTag = '[object AsyncFunction]',
    funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    proxyTag = '[object Proxy]';

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  if (!isObject(value)) {
    return false;
  }
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 9 which returns 'object' for typed arrays and other constructors.
  var tag = baseGetTag(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}

module.exports = isFunction;


/***/ }),

/***/ 1780:
/***/ ((module) => {

/** Used as references for various `Number` constants. */
var MAX_SAFE_INTEGER = 9007199254740991;

/**
 * Checks if `value` is a valid array-like length.
 *
 * **Note:** This method is loosely based on
 * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
 * @example
 *
 * _.isLength(3);
 * // => true
 *
 * _.isLength(Number.MIN_VALUE);
 * // => false
 *
 * _.isLength(Infinity);
 * // => false
 *
 * _.isLength('3');
 * // => false
 */
function isLength(value) {
  return typeof value == 'number' &&
    value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
}

module.exports = isLength;


/***/ }),

/***/ 3218:
/***/ ((module) => {

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return value != null && (type == 'object' || type == 'function');
}

module.exports = isObject;


/***/ }),

/***/ 7005:
/***/ ((module) => {

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return value != null && typeof value == 'object';
}

module.exports = isObjectLike;


/***/ }),

/***/ 3448:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseGetTag = __webpack_require__(4239),
    isObjectLike = __webpack_require__(7005);

/** `Object#toString` result references. */
var symbolTag = '[object Symbol]';

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && baseGetTag(value) == symbolTag);
}

module.exports = isSymbol;


/***/ }),

/***/ 6719:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseIsTypedArray = __webpack_require__(8749),
    baseUnary = __webpack_require__(7518),
    nodeUtil = __webpack_require__(1167);

/* Node.js helper references. */
var nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

/**
 * Checks if `value` is classified as a typed array.
 *
 * @static
 * @memberOf _
 * @since 3.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
 * @example
 *
 * _.isTypedArray(new Uint8Array);
 * // => true
 *
 * _.isTypedArray([]);
 * // => false
 */
var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

module.exports = isTypedArray;


/***/ }),

/***/ 3674:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayLikeKeys = __webpack_require__(4636),
    baseKeys = __webpack_require__(280),
    isArrayLike = __webpack_require__(8612);

/**
 * Creates an array of the own enumerable property names of `object`.
 *
 * **Note:** Non-object values are coerced to objects. See the
 * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
 * for more details.
 *
 * @static
 * @since 0.1.0
 * @memberOf _
 * @category Object
 * @param {Object} object The object to query.
 * @returns {Array} Returns the array of property names.
 * @example
 *
 * function Foo() {
 *   this.a = 1;
 *   this.b = 2;
 * }
 *
 * Foo.prototype.c = 3;
 *
 * _.keys(new Foo);
 * // => ['a', 'b'] (iteration order is not guaranteed)
 *
 * _.keys('hi');
 * // => ['0', '1']
 */
function keys(object) {
  return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
}

module.exports = keys;


/***/ }),

/***/ 6486:
/***/ (function(module, exports, __webpack_require__) {

/* module decorator */ module = __webpack_require__.nmd(module);
var __WEBPACK_AMD_DEFINE_RESULT__;/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
;(function() {

  /** Used as a safe reference for `undefined` in pre-ES5 environments. */
  var undefined;

  /** Used as the semantic version number. */
  var VERSION = '4.17.21';

  /** Used as the size to enable large array optimizations. */
  var LARGE_ARRAY_SIZE = 200;

  /** Error message constants. */
  var CORE_ERROR_TEXT = 'Unsupported core-js use. Try https://npms.io/search?q=ponyfill.',
      FUNC_ERROR_TEXT = 'Expected a function',
      INVALID_TEMPL_VAR_ERROR_TEXT = 'Invalid `variable` option passed into `_.template`';

  /** Used to stand-in for `undefined` hash values. */
  var HASH_UNDEFINED = '__lodash_hash_undefined__';

  /** Used as the maximum memoize cache size. */
  var MAX_MEMOIZE_SIZE = 500;

  /** Used as the internal argument placeholder. */
  var PLACEHOLDER = '__lodash_placeholder__';

  /** Used to compose bitmasks for cloning. */
  var CLONE_DEEP_FLAG = 1,
      CLONE_FLAT_FLAG = 2,
      CLONE_SYMBOLS_FLAG = 4;

  /** Used to compose bitmasks for value comparisons. */
  var COMPARE_PARTIAL_FLAG = 1,
      COMPARE_UNORDERED_FLAG = 2;

  /** Used to compose bitmasks for function metadata. */
  var WRAP_BIND_FLAG = 1,
      WRAP_BIND_KEY_FLAG = 2,
      WRAP_CURRY_BOUND_FLAG = 4,
      WRAP_CURRY_FLAG = 8,
      WRAP_CURRY_RIGHT_FLAG = 16,
      WRAP_PARTIAL_FLAG = 32,
      WRAP_PARTIAL_RIGHT_FLAG = 64,
      WRAP_ARY_FLAG = 128,
      WRAP_REARG_FLAG = 256,
      WRAP_FLIP_FLAG = 512;

  /** Used as default options for `_.truncate`. */
  var DEFAULT_TRUNC_LENGTH = 30,
      DEFAULT_TRUNC_OMISSION = '...';

  /** Used to detect hot functions by number of calls within a span of milliseconds. */
  var HOT_COUNT = 800,
      HOT_SPAN = 16;

  /** Used to indicate the type of lazy iteratees. */
  var LAZY_FILTER_FLAG = 1,
      LAZY_MAP_FLAG = 2,
      LAZY_WHILE_FLAG = 3;

  /** Used as references for various `Number` constants. */
  var INFINITY = 1 / 0,
      MAX_SAFE_INTEGER = 9007199254740991,
      MAX_INTEGER = 1.7976931348623157e+308,
      NAN = 0 / 0;

  /** Used as references for the maximum length and index of an array. */
  var MAX_ARRAY_LENGTH = 4294967295,
      MAX_ARRAY_INDEX = MAX_ARRAY_LENGTH - 1,
      HALF_MAX_ARRAY_LENGTH = MAX_ARRAY_LENGTH >>> 1;

  /** Used to associate wrap methods with their bit flags. */
  var wrapFlags = [
    ['ary', WRAP_ARY_FLAG],
    ['bind', WRAP_BIND_FLAG],
    ['bindKey', WRAP_BIND_KEY_FLAG],
    ['curry', WRAP_CURRY_FLAG],
    ['curryRight', WRAP_CURRY_RIGHT_FLAG],
    ['flip', WRAP_FLIP_FLAG],
    ['partial', WRAP_PARTIAL_FLAG],
    ['partialRight', WRAP_PARTIAL_RIGHT_FLAG],
    ['rearg', WRAP_REARG_FLAG]
  ];

  /** `Object#toString` result references. */
  var argsTag = '[object Arguments]',
      arrayTag = '[object Array]',
      asyncTag = '[object AsyncFunction]',
      boolTag = '[object Boolean]',
      dateTag = '[object Date]',
      domExcTag = '[object DOMException]',
      errorTag = '[object Error]',
      funcTag = '[object Function]',
      genTag = '[object GeneratorFunction]',
      mapTag = '[object Map]',
      numberTag = '[object Number]',
      nullTag = '[object Null]',
      objectTag = '[object Object]',
      promiseTag = '[object Promise]',
      proxyTag = '[object Proxy]',
      regexpTag = '[object RegExp]',
      setTag = '[object Set]',
      stringTag = '[object String]',
      symbolTag = '[object Symbol]',
      undefinedTag = '[object Undefined]',
      weakMapTag = '[object WeakMap]',
      weakSetTag = '[object WeakSet]';

  var arrayBufferTag = '[object ArrayBuffer]',
      dataViewTag = '[object DataView]',
      float32Tag = '[object Float32Array]',
      float64Tag = '[object Float64Array]',
      int8Tag = '[object Int8Array]',
      int16Tag = '[object Int16Array]',
      int32Tag = '[object Int32Array]',
      uint8Tag = '[object Uint8Array]',
      uint8ClampedTag = '[object Uint8ClampedArray]',
      uint16Tag = '[object Uint16Array]',
      uint32Tag = '[object Uint32Array]';

  /** Used to match empty string literals in compiled template source. */
  var reEmptyStringLeading = /\b__p \+= '';/g,
      reEmptyStringMiddle = /\b(__p \+=) '' \+/g,
      reEmptyStringTrailing = /(__e\(.*?\)|\b__t\)) \+\n'';/g;

  /** Used to match HTML entities and HTML characters. */
  var reEscapedHtml = /&(?:amp|lt|gt|quot|#39);/g,
      reUnescapedHtml = /[&<>"']/g,
      reHasEscapedHtml = RegExp(reEscapedHtml.source),
      reHasUnescapedHtml = RegExp(reUnescapedHtml.source);

  /** Used to match template delimiters. */
  var reEscape = /<%-([\s\S]+?)%>/g,
      reEvaluate = /<%([\s\S]+?)%>/g,
      reInterpolate = /<%=([\s\S]+?)%>/g;

  /** Used to match property names within property paths. */
  var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
      reIsPlainProp = /^\w*$/,
      rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

  /**
   * Used to match `RegExp`
   * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
   */
  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g,
      reHasRegExpChar = RegExp(reRegExpChar.source);

  /** Used to match leading whitespace. */
  var reTrimStart = /^\s+/;

  /** Used to match a single whitespace character. */
  var reWhitespace = /\s/;

  /** Used to match wrap detail comments. */
  var reWrapComment = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/,
      reWrapDetails = /\{\n\/\* \[wrapped with (.+)\] \*/,
      reSplitDetails = /,? & /;

  /** Used to match words composed of alphanumeric characters. */
  var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;

  /**
   * Used to validate the `validate` option in `_.template` variable.
   *
   * Forbids characters which could potentially change the meaning of the function argument definition:
   * - "()," (modification of function parameters)
   * - "=" (default value)
   * - "[]{}" (destructuring of function parameters)
   * - "/" (beginning of a comment)
   * - whitespace
   */
  var reForbiddenIdentifierChars = /[()=,{}\[\]\/\s]/;

  /** Used to match backslashes in property paths. */
  var reEscapeChar = /\\(\\)?/g;

  /**
   * Used to match
   * [ES template delimiters](http://ecma-international.org/ecma-262/7.0/#sec-template-literal-lexical-components).
   */
  var reEsTemplate = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g;

  /** Used to match `RegExp` flags from their coerced string values. */
  var reFlags = /\w*$/;

  /** Used to detect bad signed hexadecimal string values. */
  var reIsBadHex = /^[-+]0x[0-9a-f]+$/i;

  /** Used to detect binary string values. */
  var reIsBinary = /^0b[01]+$/i;

  /** Used to detect host constructors (Safari). */
  var reIsHostCtor = /^\[object .+?Constructor\]$/;

  /** Used to detect octal string values. */
  var reIsOctal = /^0o[0-7]+$/i;

  /** Used to detect unsigned integer values. */
  var reIsUint = /^(?:0|[1-9]\d*)$/;

  /** Used to match Latin Unicode letters (excluding mathematical operators). */
  var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;

  /** Used to ensure capturing order of template delimiters. */
  var reNoMatch = /($^)/;

  /** Used to match unescaped characters in compiled string literals. */
  var reUnescapedString = /['\n\r\u2028\u2029\\]/g;

  /** Used to compose unicode character classes. */
  var rsAstralRange = '\\ud800-\\udfff',
      rsComboMarksRange = '\\u0300-\\u036f',
      reComboHalfMarksRange = '\\ufe20-\\ufe2f',
      rsComboSymbolsRange = '\\u20d0-\\u20ff',
      rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange,
      rsDingbatRange = '\\u2700-\\u27bf',
      rsLowerRange = 'a-z\\xdf-\\xf6\\xf8-\\xff',
      rsMathOpRange = '\\xac\\xb1\\xd7\\xf7',
      rsNonCharRange = '\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf',
      rsPunctuationRange = '\\u2000-\\u206f',
      rsSpaceRange = ' \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000',
      rsUpperRange = 'A-Z\\xc0-\\xd6\\xd8-\\xde',
      rsVarRange = '\\ufe0e\\ufe0f',
      rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;

  /** Used to compose unicode capture groups. */
  var rsApos = "['\u2019]",
      rsAstral = '[' + rsAstralRange + ']',
      rsBreak = '[' + rsBreakRange + ']',
      rsCombo = '[' + rsComboRange + ']',
      rsDigits = '\\d+',
      rsDingbat = '[' + rsDingbatRange + ']',
      rsLower = '[' + rsLowerRange + ']',
      rsMisc = '[^' + rsAstralRange + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + ']',
      rsFitz = '\\ud83c[\\udffb-\\udfff]',
      rsModifier = '(?:' + rsCombo + '|' + rsFitz + ')',
      rsNonAstral = '[^' + rsAstralRange + ']',
      rsRegional = '(?:\\ud83c[\\udde6-\\uddff]){2}',
      rsSurrPair = '[\\ud800-\\udbff][\\udc00-\\udfff]',
      rsUpper = '[' + rsUpperRange + ']',
      rsZWJ = '\\u200d';

  /** Used to compose unicode regexes. */
  var rsMiscLower = '(?:' + rsLower + '|' + rsMisc + ')',
      rsMiscUpper = '(?:' + rsUpper + '|' + rsMisc + ')',
      rsOptContrLower = '(?:' + rsApos + '(?:d|ll|m|re|s|t|ve))?',
      rsOptContrUpper = '(?:' + rsApos + '(?:D|LL|M|RE|S|T|VE))?',
      reOptMod = rsModifier + '?',
      rsOptVar = '[' + rsVarRange + ']?',
      rsOptJoin = '(?:' + rsZWJ + '(?:' + [rsNonAstral, rsRegional, rsSurrPair].join('|') + ')' + rsOptVar + reOptMod + ')*',
      rsOrdLower = '\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])',
      rsOrdUpper = '\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])',
      rsSeq = rsOptVar + reOptMod + rsOptJoin,
      rsEmoji = '(?:' + [rsDingbat, rsRegional, rsSurrPair].join('|') + ')' + rsSeq,
      rsSymbol = '(?:' + [rsNonAstral + rsCombo + '?', rsCombo, rsRegional, rsSurrPair, rsAstral].join('|') + ')';

  /** Used to match apostrophes. */
  var reApos = RegExp(rsApos, 'g');

  /**
   * Used to match [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks) and
   * [combining diacritical marks for symbols](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks_for_Symbols).
   */
  var reComboMark = RegExp(rsCombo, 'g');

  /** Used to match [string symbols](https://mathiasbynens.be/notes/javascript-unicode). */
  var reUnicode = RegExp(rsFitz + '(?=' + rsFitz + ')|' + rsSymbol + rsSeq, 'g');

  /** Used to match complex or compound words. */
  var reUnicodeWord = RegExp([
    rsUpper + '?' + rsLower + '+' + rsOptContrLower + '(?=' + [rsBreak, rsUpper, '$'].join('|') + ')',
    rsMiscUpper + '+' + rsOptContrUpper + '(?=' + [rsBreak, rsUpper + rsMiscLower, '$'].join('|') + ')',
    rsUpper + '?' + rsMiscLower + '+' + rsOptContrLower,
    rsUpper + '+' + rsOptContrUpper,
    rsOrdUpper,
    rsOrdLower,
    rsDigits,
    rsEmoji
  ].join('|'), 'g');

  /** Used to detect strings with [zero-width joiners or code points from the astral planes](http://eev.ee/blog/2015/09/12/dark-corners-of-unicode/). */
  var reHasUnicode = RegExp('[' + rsZWJ + rsAstralRange  + rsComboRange + rsVarRange + ']');

  /** Used to detect strings that need a more robust regexp to match words. */
  var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;

  /** Used to assign default `context` object properties. */
  var contextProps = [
    'Array', 'Buffer', 'DataView', 'Date', 'Error', 'Float32Array', 'Float64Array',
    'Function', 'Int8Array', 'Int16Array', 'Int32Array', 'Map', 'Math', 'Object',
    'Promise', 'RegExp', 'Set', 'String', 'Symbol', 'TypeError', 'Uint8Array',
    'Uint8ClampedArray', 'Uint16Array', 'Uint32Array', 'WeakMap',
    '_', 'clearTimeout', 'isFinite', 'parseInt', 'setTimeout'
  ];

  /** Used to make template sourceURLs easier to identify. */
  var templateCounter = -1;

  /** Used to identify `toStringTag` values of typed arrays. */
  var typedArrayTags = {};
  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] =
  typedArrayTags[int8Tag] = typedArrayTags[int16Tag] =
  typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] =
  typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] =
  typedArrayTags[uint32Tag] = true;
  typedArrayTags[argsTag] = typedArrayTags[arrayTag] =
  typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] =
  typedArrayTags[dataViewTag] = typedArrayTags[dateTag] =
  typedArrayTags[errorTag] = typedArrayTags[funcTag] =
  typedArrayTags[mapTag] = typedArrayTags[numberTag] =
  typedArrayTags[objectTag] = typedArrayTags[regexpTag] =
  typedArrayTags[setTag] = typedArrayTags[stringTag] =
  typedArrayTags[weakMapTag] = false;

  /** Used to identify `toStringTag` values supported by `_.clone`. */
  var cloneableTags = {};
  cloneableTags[argsTag] = cloneableTags[arrayTag] =
  cloneableTags[arrayBufferTag] = cloneableTags[dataViewTag] =
  cloneableTags[boolTag] = cloneableTags[dateTag] =
  cloneableTags[float32Tag] = cloneableTags[float64Tag] =
  cloneableTags[int8Tag] = cloneableTags[int16Tag] =
  cloneableTags[int32Tag] = cloneableTags[mapTag] =
  cloneableTags[numberTag] = cloneableTags[objectTag] =
  cloneableTags[regexpTag] = cloneableTags[setTag] =
  cloneableTags[stringTag] = cloneableTags[symbolTag] =
  cloneableTags[uint8Tag] = cloneableTags[uint8ClampedTag] =
  cloneableTags[uint16Tag] = cloneableTags[uint32Tag] = true;
  cloneableTags[errorTag] = cloneableTags[funcTag] =
  cloneableTags[weakMapTag] = false;

  /** Used to map Latin Unicode letters to basic Latin letters. */
  var deburredLetters = {
    // Latin-1 Supplement block.
    '\xc0': 'A',  '\xc1': 'A', '\xc2': 'A', '\xc3': 'A', '\xc4': 'A', '\xc5': 'A',
    '\xe0': 'a',  '\xe1': 'a', '\xe2': 'a', '\xe3': 'a', '\xe4': 'a', '\xe5': 'a',
    '\xc7': 'C',  '\xe7': 'c',
    '\xd0': 'D',  '\xf0': 'd',
    '\xc8': 'E',  '\xc9': 'E', '\xca': 'E', '\xcb': 'E',
    '\xe8': 'e',  '\xe9': 'e', '\xea': 'e', '\xeb': 'e',
    '\xcc': 'I',  '\xcd': 'I', '\xce': 'I', '\xcf': 'I',
    '\xec': 'i',  '\xed': 'i', '\xee': 'i', '\xef': 'i',
    '\xd1': 'N',  '\xf1': 'n',
    '\xd2': 'O',  '\xd3': 'O', '\xd4': 'O', '\xd5': 'O', '\xd6': 'O', '\xd8': 'O',
    '\xf2': 'o',  '\xf3': 'o', '\xf4': 'o', '\xf5': 'o', '\xf6': 'o', '\xf8': 'o',
    '\xd9': 'U',  '\xda': 'U', '\xdb': 'U', '\xdc': 'U',
    '\xf9': 'u',  '\xfa': 'u', '\xfb': 'u', '\xfc': 'u',
    '\xdd': 'Y',  '\xfd': 'y', '\xff': 'y',
    '\xc6': 'Ae', '\xe6': 'ae',
    '\xde': 'Th', '\xfe': 'th',
    '\xdf': 'ss',
    // Latin Extended-A block.
    '\u0100': 'A',  '\u0102': 'A', '\u0104': 'A',
    '\u0101': 'a',  '\u0103': 'a', '\u0105': 'a',
    '\u0106': 'C',  '\u0108': 'C', '\u010a': 'C', '\u010c': 'C',
    '\u0107': 'c',  '\u0109': 'c', '\u010b': 'c', '\u010d': 'c',
    '\u010e': 'D',  '\u0110': 'D', '\u010f': 'd', '\u0111': 'd',
    '\u0112': 'E',  '\u0114': 'E', '\u0116': 'E', '\u0118': 'E', '\u011a': 'E',
    '\u0113': 'e',  '\u0115': 'e', '\u0117': 'e', '\u0119': 'e', '\u011b': 'e',
    '\u011c': 'G',  '\u011e': 'G', '\u0120': 'G', '\u0122': 'G',
    '\u011d': 'g',  '\u011f': 'g', '\u0121': 'g', '\u0123': 'g',
    '\u0124': 'H',  '\u0126': 'H', '\u0125': 'h', '\u0127': 'h',
    '\u0128': 'I',  '\u012a': 'I', '\u012c': 'I', '\u012e': 'I', '\u0130': 'I',
    '\u0129': 'i',  '\u012b': 'i', '\u012d': 'i', '\u012f': 'i', '\u0131': 'i',
    '\u0134': 'J',  '\u0135': 'j',
    '\u0136': 'K',  '\u0137': 'k', '\u0138': 'k',
    '\u0139': 'L',  '\u013b': 'L', '\u013d': 'L', '\u013f': 'L', '\u0141': 'L',
    '\u013a': 'l',  '\u013c': 'l', '\u013e': 'l', '\u0140': 'l', '\u0142': 'l',
    '\u0143': 'N',  '\u0145': 'N', '\u0147': 'N', '\u014a': 'N',
    '\u0144': 'n',  '\u0146': 'n', '\u0148': 'n', '\u014b': 'n',
    '\u014c': 'O',  '\u014e': 'O', '\u0150': 'O',
    '\u014d': 'o',  '\u014f': 'o', '\u0151': 'o',
    '\u0154': 'R',  '\u0156': 'R', '\u0158': 'R',
    '\u0155': 'r',  '\u0157': 'r', '\u0159': 'r',
    '\u015a': 'S',  '\u015c': 'S', '\u015e': 'S', '\u0160': 'S',
    '\u015b': 's',  '\u015d': 's', '\u015f': 's', '\u0161': 's',
    '\u0162': 'T',  '\u0164': 'T', '\u0166': 'T',
    '\u0163': 't',  '\u0165': 't', '\u0167': 't',
    '\u0168': 'U',  '\u016a': 'U', '\u016c': 'U', '\u016e': 'U', '\u0170': 'U', '\u0172': 'U',
    '\u0169': 'u',  '\u016b': 'u', '\u016d': 'u', '\u016f': 'u', '\u0171': 'u', '\u0173': 'u',
    '\u0174': 'W',  '\u0175': 'w',
    '\u0176': 'Y',  '\u0177': 'y', '\u0178': 'Y',
    '\u0179': 'Z',  '\u017b': 'Z', '\u017d': 'Z',
    '\u017a': 'z',  '\u017c': 'z', '\u017e': 'z',
    '\u0132': 'IJ', '\u0133': 'ij',
    '\u0152': 'Oe', '\u0153': 'oe',
    '\u0149': "'n", '\u017f': 's'
  };

  /** Used to map characters to HTML entities. */
  var htmlEscapes = {
    '&': '&amp;',
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&#39;'
  };

  /** Used to map HTML entities to characters. */
  var htmlUnescapes = {
    '&amp;': '&',
    '&lt;': '<',
    '&gt;': '>',
    '&quot;': '"',
    '&#39;': "'"
  };

  /** Used to escape characters for inclusion in compiled string literals. */
  var stringEscapes = {
    '\\': '\\',
    "'": "'",
    '\n': 'n',
    '\r': 'r',
    '\u2028': 'u2028',
    '\u2029': 'u2029'
  };

  /** Built-in method references without a dependency on `root`. */
  var freeParseFloat = parseFloat,
      freeParseInt = parseInt;

  /** Detect free variable `global` from Node.js. */
  var freeGlobal = typeof __webpack_require__.g == 'object' && __webpack_require__.g && __webpack_require__.g.Object === Object && __webpack_require__.g;

  /** Detect free variable `self`. */
  var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

  /** Used as a reference to the global object. */
  var root = freeGlobal || freeSelf || Function('return this')();

  /** Detect free variable `exports`. */
  var freeExports =  true && exports && !exports.nodeType && exports;

  /** Detect free variable `module`. */
  var freeModule = freeExports && "object" == 'object' && module && !module.nodeType && module;

  /** Detect the popular CommonJS extension `module.exports`. */
  var moduleExports = freeModule && freeModule.exports === freeExports;

  /** Detect free variable `process` from Node.js. */
  var freeProcess = moduleExports && freeGlobal.process;

  /** Used to access faster Node.js helpers. */
  var nodeUtil = (function() {
    try {
      // Use `util.types` for Node.js 10+.
      var types = freeModule && freeModule.require && freeModule.require('util').types;

      if (types) {
        return types;
      }

      // Legacy `process.binding('util')` for Node.js < 10.
      return freeProcess && freeProcess.binding && freeProcess.binding('util');
    } catch (e) {}
  }());

  /* Node.js helper references. */
  var nodeIsArrayBuffer = nodeUtil && nodeUtil.isArrayBuffer,
      nodeIsDate = nodeUtil && nodeUtil.isDate,
      nodeIsMap = nodeUtil && nodeUtil.isMap,
      nodeIsRegExp = nodeUtil && nodeUtil.isRegExp,
      nodeIsSet = nodeUtil && nodeUtil.isSet,
      nodeIsTypedArray = nodeUtil && nodeUtil.isTypedArray;

  /*--------------------------------------------------------------------------*/

  /**
   * A faster alternative to `Function#apply`, this function invokes `func`
   * with the `this` binding of `thisArg` and the arguments of `args`.
   *
   * @private
   * @param {Function} func The function to invoke.
   * @param {*} thisArg The `this` binding of `func`.
   * @param {Array} args The arguments to invoke `func` with.
   * @returns {*} Returns the result of `func`.
   */
  function apply(func, thisArg, args) {
    switch (args.length) {
      case 0: return func.call(thisArg);
      case 1: return func.call(thisArg, args[0]);
      case 2: return func.call(thisArg, args[0], args[1]);
      case 3: return func.call(thisArg, args[0], args[1], args[2]);
    }
    return func.apply(thisArg, args);
  }

  /**
   * A specialized version of `baseAggregator` for arrays.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} setter The function to set `accumulator` values.
   * @param {Function} iteratee The iteratee to transform keys.
   * @param {Object} accumulator The initial aggregated object.
   * @returns {Function} Returns `accumulator`.
   */
  function arrayAggregator(array, setter, iteratee, accumulator) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      var value = array[index];
      setter(accumulator, value, iteratee(value), array);
    }
    return accumulator;
  }

  /**
   * A specialized version of `_.forEach` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns `array`.
   */
  function arrayEach(array, iteratee) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      if (iteratee(array[index], index, array) === false) {
        break;
      }
    }
    return array;
  }

  /**
   * A specialized version of `_.forEachRight` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns `array`.
   */
  function arrayEachRight(array, iteratee) {
    var length = array == null ? 0 : array.length;

    while (length--) {
      if (iteratee(array[length], length, array) === false) {
        break;
      }
    }
    return array;
  }

  /**
   * A specialized version of `_.every` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {boolean} Returns `true` if all elements pass the predicate check,
   *  else `false`.
   */
  function arrayEvery(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      if (!predicate(array[index], index, array)) {
        return false;
      }
    }
    return true;
  }

  /**
   * A specialized version of `_.filter` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {Array} Returns the new filtered array.
   */
  function arrayFilter(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length,
        resIndex = 0,
        result = [];

    while (++index < length) {
      var value = array[index];
      if (predicate(value, index, array)) {
        result[resIndex++] = value;
      }
    }
    return result;
  }

  /**
   * A specialized version of `_.includes` for arrays without support for
   * specifying an index to search from.
   *
   * @private
   * @param {Array} [array] The array to inspect.
   * @param {*} target The value to search for.
   * @returns {boolean} Returns `true` if `target` is found, else `false`.
   */
  function arrayIncludes(array, value) {
    var length = array == null ? 0 : array.length;
    return !!length && baseIndexOf(array, value, 0) > -1;
  }

  /**
   * This function is like `arrayIncludes` except that it accepts a comparator.
   *
   * @private
   * @param {Array} [array] The array to inspect.
   * @param {*} target The value to search for.
   * @param {Function} comparator The comparator invoked per element.
   * @returns {boolean} Returns `true` if `target` is found, else `false`.
   */
  function arrayIncludesWith(array, value, comparator) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      if (comparator(value, array[index])) {
        return true;
      }
    }
    return false;
  }

  /**
   * A specialized version of `_.map` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the new mapped array.
   */
  function arrayMap(array, iteratee) {
    var index = -1,
        length = array == null ? 0 : array.length,
        result = Array(length);

    while (++index < length) {
      result[index] = iteratee(array[index], index, array);
    }
    return result;
  }

  /**
   * Appends the elements of `values` to `array`.
   *
   * @private
   * @param {Array} array The array to modify.
   * @param {Array} values The values to append.
   * @returns {Array} Returns `array`.
   */
  function arrayPush(array, values) {
    var index = -1,
        length = values.length,
        offset = array.length;

    while (++index < length) {
      array[offset + index] = values[index];
    }
    return array;
  }

  /**
   * A specialized version of `_.reduce` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {*} [accumulator] The initial value.
   * @param {boolean} [initAccum] Specify using the first element of `array` as
   *  the initial value.
   * @returns {*} Returns the accumulated value.
   */
  function arrayReduce(array, iteratee, accumulator, initAccum) {
    var index = -1,
        length = array == null ? 0 : array.length;

    if (initAccum && length) {
      accumulator = array[++index];
    }
    while (++index < length) {
      accumulator = iteratee(accumulator, array[index], index, array);
    }
    return accumulator;
  }

  /**
   * A specialized version of `_.reduceRight` for arrays without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {*} [accumulator] The initial value.
   * @param {boolean} [initAccum] Specify using the last element of `array` as
   *  the initial value.
   * @returns {*} Returns the accumulated value.
   */
  function arrayReduceRight(array, iteratee, accumulator, initAccum) {
    var length = array == null ? 0 : array.length;
    if (initAccum && length) {
      accumulator = array[--length];
    }
    while (length--) {
      accumulator = iteratee(accumulator, array[length], length, array);
    }
    return accumulator;
  }

  /**
   * A specialized version of `_.some` for arrays without support for iteratee
   * shorthands.
   *
   * @private
   * @param {Array} [array] The array to iterate over.
   * @param {Function} predicate The function invoked per iteration.
   * @returns {boolean} Returns `true` if any element passes the predicate check,
   *  else `false`.
   */
  function arraySome(array, predicate) {
    var index = -1,
        length = array == null ? 0 : array.length;

    while (++index < length) {
      if (predicate(array[index], index, array)) {
        return true;
      }
    }
    return false;
  }

  /**
   * Gets the size of an ASCII `string`.
   *
   * @private
   * @param {string} string The string inspect.
   * @returns {number} Returns the string size.
   */
  var asciiSize = baseProperty('length');

  /**
   * Converts an ASCII `string` to an array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the converted array.
   */
  function asciiToArray(string) {
    return string.split('');
  }

  /**
   * Splits an ASCII `string` into an array of its words.
   *
   * @private
   * @param {string} The string to inspect.
   * @returns {Array} Returns the words of `string`.
   */
  function asciiWords(string) {
    return string.match(reAsciiWord) || [];
  }

  /**
   * The base implementation of methods like `_.findKey` and `_.findLastKey`,
   * without support for iteratee shorthands, which iterates over `collection`
   * using `eachFunc`.
   *
   * @private
   * @param {Array|Object} collection The collection to inspect.
   * @param {Function} predicate The function invoked per iteration.
   * @param {Function} eachFunc The function to iterate over `collection`.
   * @returns {*} Returns the found element or its key, else `undefined`.
   */
  function baseFindKey(collection, predicate, eachFunc) {
    var result;
    eachFunc(collection, function(value, key, collection) {
      if (predicate(value, key, collection)) {
        result = key;
        return false;
      }
    });
    return result;
  }

  /**
   * The base implementation of `_.findIndex` and `_.findLastIndex` without
   * support for iteratee shorthands.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {Function} predicate The function invoked per iteration.
   * @param {number} fromIndex The index to search from.
   * @param {boolean} [fromRight] Specify iterating from right to left.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function baseFindIndex(array, predicate, fromIndex, fromRight) {
    var length = array.length,
        index = fromIndex + (fromRight ? 1 : -1);

    while ((fromRight ? index-- : ++index < length)) {
      if (predicate(array[index], index, array)) {
        return index;
      }
    }
    return -1;
  }

  /**
   * The base implementation of `_.indexOf` without `fromIndex` bounds checks.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} value The value to search for.
   * @param {number} fromIndex The index to search from.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function baseIndexOf(array, value, fromIndex) {
    return value === value
      ? strictIndexOf(array, value, fromIndex)
      : baseFindIndex(array, baseIsNaN, fromIndex);
  }

  /**
   * This function is like `baseIndexOf` except that it accepts a comparator.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} value The value to search for.
   * @param {number} fromIndex The index to search from.
   * @param {Function} comparator The comparator invoked per element.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function baseIndexOfWith(array, value, fromIndex, comparator) {
    var index = fromIndex - 1,
        length = array.length;

    while (++index < length) {
      if (comparator(array[index], value)) {
        return index;
      }
    }
    return -1;
  }

  /**
   * The base implementation of `_.isNaN` without support for number objects.
   *
   * @private
   * @param {*} value The value to check.
   * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
   */
  function baseIsNaN(value) {
    return value !== value;
  }

  /**
   * The base implementation of `_.mean` and `_.meanBy` without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} array The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {number} Returns the mean.
   */
  function baseMean(array, iteratee) {
    var length = array == null ? 0 : array.length;
    return length ? (baseSum(array, iteratee) / length) : NAN;
  }

  /**
   * The base implementation of `_.property` without support for deep paths.
   *
   * @private
   * @param {string} key The key of the property to get.
   * @returns {Function} Returns the new accessor function.
   */
  function baseProperty(key) {
    return function(object) {
      return object == null ? undefined : object[key];
    };
  }

  /**
   * The base implementation of `_.propertyOf` without support for deep paths.
   *
   * @private
   * @param {Object} object The object to query.
   * @returns {Function} Returns the new accessor function.
   */
  function basePropertyOf(object) {
    return function(key) {
      return object == null ? undefined : object[key];
    };
  }

  /**
   * The base implementation of `_.reduce` and `_.reduceRight`, without support
   * for iteratee shorthands, which iterates over `collection` using `eachFunc`.
   *
   * @private
   * @param {Array|Object} collection The collection to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @param {*} accumulator The initial value.
   * @param {boolean} initAccum Specify using the first or last element of
   *  `collection` as the initial value.
   * @param {Function} eachFunc The function to iterate over `collection`.
   * @returns {*} Returns the accumulated value.
   */
  function baseReduce(collection, iteratee, accumulator, initAccum, eachFunc) {
    eachFunc(collection, function(value, index, collection) {
      accumulator = initAccum
        ? (initAccum = false, value)
        : iteratee(accumulator, value, index, collection);
    });
    return accumulator;
  }

  /**
   * The base implementation of `_.sortBy` which uses `comparer` to define the
   * sort order of `array` and replaces criteria objects with their corresponding
   * values.
   *
   * @private
   * @param {Array} array The array to sort.
   * @param {Function} comparer The function to define sort order.
   * @returns {Array} Returns `array`.
   */
  function baseSortBy(array, comparer) {
    var length = array.length;

    array.sort(comparer);
    while (length--) {
      array[length] = array[length].value;
    }
    return array;
  }

  /**
   * The base implementation of `_.sum` and `_.sumBy` without support for
   * iteratee shorthands.
   *
   * @private
   * @param {Array} array The array to iterate over.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {number} Returns the sum.
   */
  function baseSum(array, iteratee) {
    var result,
        index = -1,
        length = array.length;

    while (++index < length) {
      var current = iteratee(array[index]);
      if (current !== undefined) {
        result = result === undefined ? current : (result + current);
      }
    }
    return result;
  }

  /**
   * The base implementation of `_.times` without support for iteratee shorthands
   * or max array length checks.
   *
   * @private
   * @param {number} n The number of times to invoke `iteratee`.
   * @param {Function} iteratee The function invoked per iteration.
   * @returns {Array} Returns the array of results.
   */
  function baseTimes(n, iteratee) {
    var index = -1,
        result = Array(n);

    while (++index < n) {
      result[index] = iteratee(index);
    }
    return result;
  }

  /**
   * The base implementation of `_.toPairs` and `_.toPairsIn` which creates an array
   * of key-value pairs for `object` corresponding to the property names of `props`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array} props The property names to get values for.
   * @returns {Object} Returns the key-value pairs.
   */
  function baseToPairs(object, props) {
    return arrayMap(props, function(key) {
      return [key, object[key]];
    });
  }

  /**
   * The base implementation of `_.trim`.
   *
   * @private
   * @param {string} string The string to trim.
   * @returns {string} Returns the trimmed string.
   */
  function baseTrim(string) {
    return string
      ? string.slice(0, trimmedEndIndex(string) + 1).replace(reTrimStart, '')
      : string;
  }

  /**
   * The base implementation of `_.unary` without support for storing metadata.
   *
   * @private
   * @param {Function} func The function to cap arguments for.
   * @returns {Function} Returns the new capped function.
   */
  function baseUnary(func) {
    return function(value) {
      return func(value);
    };
  }

  /**
   * The base implementation of `_.values` and `_.valuesIn` which creates an
   * array of `object` property values corresponding to the property names
   * of `props`.
   *
   * @private
   * @param {Object} object The object to query.
   * @param {Array} props The property names to get values for.
   * @returns {Object} Returns the array of property values.
   */
  function baseValues(object, props) {
    return arrayMap(props, function(key) {
      return object[key];
    });
  }

  /**
   * Checks if a `cache` value for `key` exists.
   *
   * @private
   * @param {Object} cache The cache to query.
   * @param {string} key The key of the entry to check.
   * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
   */
  function cacheHas(cache, key) {
    return cache.has(key);
  }

  /**
   * Used by `_.trim` and `_.trimStart` to get the index of the first string symbol
   * that is not found in the character symbols.
   *
   * @private
   * @param {Array} strSymbols The string symbols to inspect.
   * @param {Array} chrSymbols The character symbols to find.
   * @returns {number} Returns the index of the first unmatched string symbol.
   */
  function charsStartIndex(strSymbols, chrSymbols) {
    var index = -1,
        length = strSymbols.length;

    while (++index < length && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
    return index;
  }

  /**
   * Used by `_.trim` and `_.trimEnd` to get the index of the last string symbol
   * that is not found in the character symbols.
   *
   * @private
   * @param {Array} strSymbols The string symbols to inspect.
   * @param {Array} chrSymbols The character symbols to find.
   * @returns {number} Returns the index of the last unmatched string symbol.
   */
  function charsEndIndex(strSymbols, chrSymbols) {
    var index = strSymbols.length;

    while (index-- && baseIndexOf(chrSymbols, strSymbols[index], 0) > -1) {}
    return index;
  }

  /**
   * Gets the number of `placeholder` occurrences in `array`.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} placeholder The placeholder to search for.
   * @returns {number} Returns the placeholder count.
   */
  function countHolders(array, placeholder) {
    var length = array.length,
        result = 0;

    while (length--) {
      if (array[length] === placeholder) {
        ++result;
      }
    }
    return result;
  }

  /**
   * Used by `_.deburr` to convert Latin-1 Supplement and Latin Extended-A
   * letters to basic Latin letters.
   *
   * @private
   * @param {string} letter The matched letter to deburr.
   * @returns {string} Returns the deburred letter.
   */
  var deburrLetter = basePropertyOf(deburredLetters);

  /**
   * Used by `_.escape` to convert characters to HTML entities.
   *
   * @private
   * @param {string} chr The matched character to escape.
   * @returns {string} Returns the escaped character.
   */
  var escapeHtmlChar = basePropertyOf(htmlEscapes);

  /**
   * Used by `_.template` to escape characters for inclusion in compiled string literals.
   *
   * @private
   * @param {string} chr The matched character to escape.
   * @returns {string} Returns the escaped character.
   */
  function escapeStringChar(chr) {
    return '\\' + stringEscapes[chr];
  }

  /**
   * Gets the value at `key` of `object`.
   *
   * @private
   * @param {Object} [object] The object to query.
   * @param {string} key The key of the property to get.
   * @returns {*} Returns the property value.
   */
  function getValue(object, key) {
    return object == null ? undefined : object[key];
  }

  /**
   * Checks if `string` contains Unicode symbols.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {boolean} Returns `true` if a symbol is found, else `false`.
   */
  function hasUnicode(string) {
    return reHasUnicode.test(string);
  }

  /**
   * Checks if `string` contains a word composed of Unicode symbols.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {boolean} Returns `true` if a word is found, else `false`.
   */
  function hasUnicodeWord(string) {
    return reHasUnicodeWord.test(string);
  }

  /**
   * Converts `iterator` to an array.
   *
   * @private
   * @param {Object} iterator The iterator to convert.
   * @returns {Array} Returns the converted array.
   */
  function iteratorToArray(iterator) {
    var data,
        result = [];

    while (!(data = iterator.next()).done) {
      result.push(data.value);
    }
    return result;
  }

  /**
   * Converts `map` to its key-value pairs.
   *
   * @private
   * @param {Object} map The map to convert.
   * @returns {Array} Returns the key-value pairs.
   */
  function mapToArray(map) {
    var index = -1,
        result = Array(map.size);

    map.forEach(function(value, key) {
      result[++index] = [key, value];
    });
    return result;
  }

  /**
   * Creates a unary function that invokes `func` with its argument transformed.
   *
   * @private
   * @param {Function} func The function to wrap.
   * @param {Function} transform The argument transform.
   * @returns {Function} Returns the new function.
   */
  function overArg(func, transform) {
    return function(arg) {
      return func(transform(arg));
    };
  }

  /**
   * Replaces all `placeholder` elements in `array` with an internal placeholder
   * and returns an array of their indexes.
   *
   * @private
   * @param {Array} array The array to modify.
   * @param {*} placeholder The placeholder to replace.
   * @returns {Array} Returns the new array of placeholder indexes.
   */
  function replaceHolders(array, placeholder) {
    var index = -1,
        length = array.length,
        resIndex = 0,
        result = [];

    while (++index < length) {
      var value = array[index];
      if (value === placeholder || value === PLACEHOLDER) {
        array[index] = PLACEHOLDER;
        result[resIndex++] = index;
      }
    }
    return result;
  }

  /**
   * Converts `set` to an array of its values.
   *
   * @private
   * @param {Object} set The set to convert.
   * @returns {Array} Returns the values.
   */
  function setToArray(set) {
    var index = -1,
        result = Array(set.size);

    set.forEach(function(value) {
      result[++index] = value;
    });
    return result;
  }

  /**
   * Converts `set` to its value-value pairs.
   *
   * @private
   * @param {Object} set The set to convert.
   * @returns {Array} Returns the value-value pairs.
   */
  function setToPairs(set) {
    var index = -1,
        result = Array(set.size);

    set.forEach(function(value) {
      result[++index] = [value, value];
    });
    return result;
  }

  /**
   * A specialized version of `_.indexOf` which performs strict equality
   * comparisons of values, i.e. `===`.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} value The value to search for.
   * @param {number} fromIndex The index to search from.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function strictIndexOf(array, value, fromIndex) {
    var index = fromIndex - 1,
        length = array.length;

    while (++index < length) {
      if (array[index] === value) {
        return index;
      }
    }
    return -1;
  }

  /**
   * A specialized version of `_.lastIndexOf` which performs strict equality
   * comparisons of values, i.e. `===`.
   *
   * @private
   * @param {Array} array The array to inspect.
   * @param {*} value The value to search for.
   * @param {number} fromIndex The index to search from.
   * @returns {number} Returns the index of the matched value, else `-1`.
   */
  function strictLastIndexOf(array, value, fromIndex) {
    var index = fromIndex + 1;
    while (index--) {
      if (array[index] === value) {
        return index;
      }
    }
    return index;
  }

  /**
   * Gets the number of symbols in `string`.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {number} Returns the string size.
   */
  function stringSize(string) {
    return hasUnicode(string)
      ? unicodeSize(string)
      : asciiSize(string);
  }

  /**
   * Converts `string` to an array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the converted array.
   */
  function stringToArray(string) {
    return hasUnicode(string)
      ? unicodeToArray(string)
      : asciiToArray(string);
  }

  /**
   * Used by `_.trim` and `_.trimEnd` to get the index of the last non-whitespace
   * character of `string`.
   *
   * @private
   * @param {string} string The string to inspect.
   * @returns {number} Returns the index of the last non-whitespace character.
   */
  function trimmedEndIndex(string) {
    var index = string.length;

    while (index-- && reWhitespace.test(string.charAt(index))) {}
    return index;
  }

  /**
   * Used by `_.unescape` to convert HTML entities to characters.
   *
   * @private
   * @param {string} chr The matched character to unescape.
   * @returns {string} Returns the unescaped character.
   */
  var unescapeHtmlChar = basePropertyOf(htmlUnescapes);

  /**
   * Gets the size of a Unicode `string`.
   *
   * @private
   * @param {string} string The string inspect.
   * @returns {number} Returns the string size.
   */
  function unicodeSize(string) {
    var result = reUnicode.lastIndex = 0;
    while (reUnicode.test(string)) {
      ++result;
    }
    return result;
  }

  /**
   * Converts a Unicode `string` to an array.
   *
   * @private
   * @param {string} string The string to convert.
   * @returns {Array} Returns the converted array.
   */
  function unicodeToArray(string) {
    return string.match(reUnicode) || [];
  }

  /**
   * Splits a Unicode `string` into an array of its words.
   *
   * @private
   * @param {string} The string to inspect.
   * @returns {Array} Returns the words of `string`.
   */
  function unicodeWords(string) {
    return string.match(reUnicodeWord) || [];
  }

  /*--------------------------------------------------------------------------*/

  /**
   * Create a new pristine `lodash` function using the `context` object.
   *
   * @static
   * @memberOf _
   * @since 1.1.0
   * @category Util
   * @param {Object} [context=root] The context object.
   * @returns {Function} Returns a new `lodash` function.
   * @example
   *
   * _.mixin({ 'foo': _.constant('foo') });
   *
   * var lodash = _.runInContext();
   * lodash.mixin({ 'bar': lodash.constant('bar') });
   *
   * _.isFunction(_.foo);
   * // => true
   * _.isFunction(_.bar);
   * // => false
   *
   * lodash.isFunction(lodash.foo);
   * // => false
   * lodash.isFunction(lodash.bar);
   * // => true
   *
   * // Create a suped-up `defer` in Node.js.
   * var defer = _.runInContext({ 'setTimeout': setImmediate }).defer;
   */
  var runInContext = (function runInContext(context) {
    context = context == null ? root : _.defaults(root.Object(), context, _.pick(root, contextProps));

    /** Built-in constructor references. */
    var Array = context.Array,
        Date = context.Date,
        Error = context.Error,
        Function = context.Function,
        Math = context.Math,
        Object = context.Object,
        RegExp = context.RegExp,
        String = context.String,
        TypeError = context.TypeError;

    /** Used for built-in method references. */
    var arrayProto = Array.prototype,
        funcProto = Function.prototype,
        objectProto = Object.prototype;

    /** Used to detect overreaching core-js shims. */
    var coreJsData = context['__core-js_shared__'];

    /** Used to resolve the decompiled source of functions. */
    var funcToString = funcProto.toString;

    /** Used to check objects for own properties. */
    var hasOwnProperty = objectProto.hasOwnProperty;

    /** Used to generate unique IDs. */
    var idCounter = 0;

    /** Used to detect methods masquerading as native. */
    var maskSrcKey = (function() {
      var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
      return uid ? ('Symbol(src)_1.' + uid) : '';
    }());

    /**
     * Used to resolve the
     * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
     * of values.
     */
    var nativeObjectToString = objectProto.toString;

    /** Used to infer the `Object` constructor. */
    var objectCtorString = funcToString.call(Object);

    /** Used to restore the original `_` reference in `_.noConflict`. */
    var oldDash = root._;

    /** Used to detect if a method is native. */
    var reIsNative = RegExp('^' +
      funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
      .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
    );

    /** Built-in value references. */
    var Buffer = moduleExports ? context.Buffer : undefined,
        Symbol = context.Symbol,
        Uint8Array = context.Uint8Array,
        allocUnsafe = Buffer ? Buffer.allocUnsafe : undefined,
        getPrototype = overArg(Object.getPrototypeOf, Object),
        objectCreate = Object.create,
        propertyIsEnumerable = objectProto.propertyIsEnumerable,
        splice = arrayProto.splice,
        spreadableSymbol = Symbol ? Symbol.isConcatSpreadable : undefined,
        symIterator = Symbol ? Symbol.iterator : undefined,
        symToStringTag = Symbol ? Symbol.toStringTag : undefined;

    var defineProperty = (function() {
      try {
        var func = getNative(Object, 'defineProperty');
        func({}, '', {});
        return func;
      } catch (e) {}
    }());

    /** Mocked built-ins. */
    var ctxClearTimeout = context.clearTimeout !== root.clearTimeout && context.clearTimeout,
        ctxNow = Date && Date.now !== root.Date.now && Date.now,
        ctxSetTimeout = context.setTimeout !== root.setTimeout && context.setTimeout;

    /* Built-in method references for those with the same name as other `lodash` methods. */
    var nativeCeil = Math.ceil,
        nativeFloor = Math.floor,
        nativeGetSymbols = Object.getOwnPropertySymbols,
        nativeIsBuffer = Buffer ? Buffer.isBuffer : undefined,
        nativeIsFinite = context.isFinite,
        nativeJoin = arrayProto.join,
        nativeKeys = overArg(Object.keys, Object),
        nativeMax = Math.max,
        nativeMin = Math.min,
        nativeNow = Date.now,
        nativeParseInt = context.parseInt,
        nativeRandom = Math.random,
        nativeReverse = arrayProto.reverse;

    /* Built-in method references that are verified to be native. */
    var DataView = getNative(context, 'DataView'),
        Map = getNative(context, 'Map'),
        Promise = getNative(context, 'Promise'),
        Set = getNative(context, 'Set'),
        WeakMap = getNative(context, 'WeakMap'),
        nativeCreate = getNative(Object, 'create');

    /** Used to store function metadata. */
    var metaMap = WeakMap && new WeakMap;

    /** Used to lookup unminified function names. */
    var realNames = {};

    /** Used to detect maps, sets, and weakmaps. */
    var dataViewCtorString = toSource(DataView),
        mapCtorString = toSource(Map),
        promiseCtorString = toSource(Promise),
        setCtorString = toSource(Set),
        weakMapCtorString = toSource(WeakMap);

    /** Used to convert symbols to primitives and strings. */
    var symbolProto = Symbol ? Symbol.prototype : undefined,
        symbolValueOf = symbolProto ? symbolProto.valueOf : undefined,
        symbolToString = symbolProto ? symbolProto.toString : undefined;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a `lodash` object which wraps `value` to enable implicit method
     * chain sequences. Methods that operate on and return arrays, collections,
     * and functions can be chained together. Methods that retrieve a single value
     * or may return a primitive value will automatically end the chain sequence
     * and return the unwrapped value. Otherwise, the value must be unwrapped
     * with `_#value`.
     *
     * Explicit chain sequences, which must be unwrapped with `_#value`, may be
     * enabled using `_.chain`.
     *
     * The execution of chained methods is lazy, that is, it's deferred until
     * `_#value` is implicitly or explicitly called.
     *
     * Lazy evaluation allows several methods to support shortcut fusion.
     * Shortcut fusion is an optimization to merge iteratee calls; this avoids
     * the creation of intermediate arrays and can greatly reduce the number of
     * iteratee executions. Sections of a chain sequence qualify for shortcut
     * fusion if the section is applied to an array and iteratees accept only
     * one argument. The heuristic for whether a section qualifies for shortcut
     * fusion is subject to change.
     *
     * Chaining is supported in custom builds as long as the `_#value` method is
     * directly or indirectly included in the build.
     *
     * In addition to lodash methods, wrappers have `Array` and `String` methods.
     *
     * The wrapper `Array` methods are:
     * `concat`, `join`, `pop`, `push`, `shift`, `sort`, `splice`, and `unshift`
     *
     * The wrapper `String` methods are:
     * `replace` and `split`
     *
     * The wrapper methods that support shortcut fusion are:
     * `at`, `compact`, `drop`, `dropRight`, `dropWhile`, `filter`, `find`,
     * `findLast`, `head`, `initial`, `last`, `map`, `reject`, `reverse`, `slice`,
     * `tail`, `take`, `takeRight`, `takeRightWhile`, `takeWhile`, and `toArray`
     *
     * The chainable wrapper methods are:
     * `after`, `ary`, `assign`, `assignIn`, `assignInWith`, `assignWith`, `at`,
     * `before`, `bind`, `bindAll`, `bindKey`, `castArray`, `chain`, `chunk`,
     * `commit`, `compact`, `concat`, `conforms`, `constant`, `countBy`, `create`,
     * `curry`, `debounce`, `defaults`, `defaultsDeep`, `defer`, `delay`,
     * `difference`, `differenceBy`, `differenceWith`, `drop`, `dropRight`,
     * `dropRightWhile`, `dropWhile`, `extend`, `extendWith`, `fill`, `filter`,
     * `flatMap`, `flatMapDeep`, `flatMapDepth`, `flatten`, `flattenDeep`,
     * `flattenDepth`, `flip`, `flow`, `flowRight`, `fromPairs`, `functions`,
     * `functionsIn`, `groupBy`, `initial`, `intersection`, `intersectionBy`,
     * `intersectionWith`, `invert`, `invertBy`, `invokeMap`, `iteratee`, `keyBy`,
     * `keys`, `keysIn`, `map`, `mapKeys`, `mapValues`, `matches`, `matchesProperty`,
     * `memoize`, `merge`, `mergeWith`, `method`, `methodOf`, `mixin`, `negate`,
     * `nthArg`, `omit`, `omitBy`, `once`, `orderBy`, `over`, `overArgs`,
     * `overEvery`, `overSome`, `partial`, `partialRight`, `partition`, `pick`,
     * `pickBy`, `plant`, `property`, `propertyOf`, `pull`, `pullAll`, `pullAllBy`,
     * `pullAllWith`, `pullAt`, `push`, `range`, `rangeRight`, `rearg`, `reject`,
     * `remove`, `rest`, `reverse`, `sampleSize`, `set`, `setWith`, `shuffle`,
     * `slice`, `sort`, `sortBy`, `splice`, `spread`, `tail`, `take`, `takeRight`,
     * `takeRightWhile`, `takeWhile`, `tap`, `throttle`, `thru`, `toArray`,
     * `toPairs`, `toPairsIn`, `toPath`, `toPlainObject`, `transform`, `unary`,
     * `union`, `unionBy`, `unionWith`, `uniq`, `uniqBy`, `uniqWith`, `unset`,
     * `unshift`, `unzip`, `unzipWith`, `update`, `updateWith`, `values`,
     * `valuesIn`, `without`, `wrap`, `xor`, `xorBy`, `xorWith`, `zip`,
     * `zipObject`, `zipObjectDeep`, and `zipWith`
     *
     * The wrapper methods that are **not** chainable by default are:
     * `add`, `attempt`, `camelCase`, `capitalize`, `ceil`, `clamp`, `clone`,
     * `cloneDeep`, `cloneDeepWith`, `cloneWith`, `conformsTo`, `deburr`,
     * `defaultTo`, `divide`, `each`, `eachRight`, `endsWith`, `eq`, `escape`,
     * `escapeRegExp`, `every`, `find`, `findIndex`, `findKey`, `findLast`,
     * `findLastIndex`, `findLastKey`, `first`, `floor`, `forEach`, `forEachRight`,
     * `forIn`, `forInRight`, `forOwn`, `forOwnRight`, `get`, `gt`, `gte`, `has`,
     * `hasIn`, `head`, `identity`, `includes`, `indexOf`, `inRange`, `invoke`,
     * `isArguments`, `isArray`, `isArrayBuffer`, `isArrayLike`, `isArrayLikeObject`,
     * `isBoolean`, `isBuffer`, `isDate`, `isElement`, `isEmpty`, `isEqual`,
     * `isEqualWith`, `isError`, `isFinite`, `isFunction`, `isInteger`, `isLength`,
     * `isMap`, `isMatch`, `isMatchWith`, `isNaN`, `isNative`, `isNil`, `isNull`,
     * `isNumber`, `isObject`, `isObjectLike`, `isPlainObject`, `isRegExp`,
     * `isSafeInteger`, `isSet`, `isString`, `isUndefined`, `isTypedArray`,
     * `isWeakMap`, `isWeakSet`, `join`, `kebabCase`, `last`, `lastIndexOf`,
     * `lowerCase`, `lowerFirst`, `lt`, `lte`, `max`, `maxBy`, `mean`, `meanBy`,
     * `min`, `minBy`, `multiply`, `noConflict`, `noop`, `now`, `nth`, `pad`,
     * `padEnd`, `padStart`, `parseInt`, `pop`, `random`, `reduce`, `reduceRight`,
     * `repeat`, `result`, `round`, `runInContext`, `sample`, `shift`, `size`,
     * `snakeCase`, `some`, `sortedIndex`, `sortedIndexBy`, `sortedLastIndex`,
     * `sortedLastIndexBy`, `startCase`, `startsWith`, `stubArray`, `stubFalse`,
     * `stubObject`, `stubString`, `stubTrue`, `subtract`, `sum`, `sumBy`,
     * `template`, `times`, `toFinite`, `toInteger`, `toJSON`, `toLength`,
     * `toLower`, `toNumber`, `toSafeInteger`, `toString`, `toUpper`, `trim`,
     * `trimEnd`, `trimStart`, `truncate`, `unescape`, `uniqueId`, `upperCase`,
     * `upperFirst`, `value`, and `words`
     *
     * @name _
     * @constructor
     * @category Seq
     * @param {*} value The value to wrap in a `lodash` instance.
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var wrapped = _([1, 2, 3]);
     *
     * // Returns an unwrapped value.
     * wrapped.reduce(_.add);
     * // => 6
     *
     * // Returns a wrapped value.
     * var squares = wrapped.map(square);
     *
     * _.isArray(squares);
     * // => false
     *
     * _.isArray(squares.value());
     * // => true
     */
    function lodash(value) {
      if (isObjectLike(value) && !isArray(value) && !(value instanceof LazyWrapper)) {
        if (value instanceof LodashWrapper) {
          return value;
        }
        if (hasOwnProperty.call(value, '__wrapped__')) {
          return wrapperClone(value);
        }
      }
      return new LodashWrapper(value);
    }

    /**
     * The base implementation of `_.create` without support for assigning
     * properties to the created object.
     *
     * @private
     * @param {Object} proto The object to inherit from.
     * @returns {Object} Returns the new object.
     */
    var baseCreate = (function() {
      function object() {}
      return function(proto) {
        if (!isObject(proto)) {
          return {};
        }
        if (objectCreate) {
          return objectCreate(proto);
        }
        object.prototype = proto;
        var result = new object;
        object.prototype = undefined;
        return result;
      };
    }());

    /**
     * The function whose prototype chain sequence wrappers inherit from.
     *
     * @private
     */
    function baseLodash() {
      // No operation performed.
    }

    /**
     * The base constructor for creating `lodash` wrapper objects.
     *
     * @private
     * @param {*} value The value to wrap.
     * @param {boolean} [chainAll] Enable explicit method chain sequences.
     */
    function LodashWrapper(value, chainAll) {
      this.__wrapped__ = value;
      this.__actions__ = [];
      this.__chain__ = !!chainAll;
      this.__index__ = 0;
      this.__values__ = undefined;
    }

    /**
     * By default, the template delimiters used by lodash are like those in
     * embedded Ruby (ERB) as well as ES2015 template strings. Change the
     * following template settings to use alternative delimiters.
     *
     * @static
     * @memberOf _
     * @type {Object}
     */
    lodash.templateSettings = {

      /**
       * Used to detect `data` property values to be HTML-escaped.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      'escape': reEscape,

      /**
       * Used to detect code to be evaluated.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      'evaluate': reEvaluate,

      /**
       * Used to detect `data` property values to inject.
       *
       * @memberOf _.templateSettings
       * @type {RegExp}
       */
      'interpolate': reInterpolate,

      /**
       * Used to reference the data object in the template text.
       *
       * @memberOf _.templateSettings
       * @type {string}
       */
      'variable': '',

      /**
       * Used to import variables into the compiled template.
       *
       * @memberOf _.templateSettings
       * @type {Object}
       */
      'imports': {

        /**
         * A reference to the `lodash` function.
         *
         * @memberOf _.templateSettings.imports
         * @type {Function}
         */
        '_': lodash
      }
    };

    // Ensure wrappers are instances of `baseLodash`.
    lodash.prototype = baseLodash.prototype;
    lodash.prototype.constructor = lodash;

    LodashWrapper.prototype = baseCreate(baseLodash.prototype);
    LodashWrapper.prototype.constructor = LodashWrapper;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a lazy wrapper object which wraps `value` to enable lazy evaluation.
     *
     * @private
     * @constructor
     * @param {*} value The value to wrap.
     */
    function LazyWrapper(value) {
      this.__wrapped__ = value;
      this.__actions__ = [];
      this.__dir__ = 1;
      this.__filtered__ = false;
      this.__iteratees__ = [];
      this.__takeCount__ = MAX_ARRAY_LENGTH;
      this.__views__ = [];
    }

    /**
     * Creates a clone of the lazy wrapper object.
     *
     * @private
     * @name clone
     * @memberOf LazyWrapper
     * @returns {Object} Returns the cloned `LazyWrapper` object.
     */
    function lazyClone() {
      var result = new LazyWrapper(this.__wrapped__);
      result.__actions__ = copyArray(this.__actions__);
      result.__dir__ = this.__dir__;
      result.__filtered__ = this.__filtered__;
      result.__iteratees__ = copyArray(this.__iteratees__);
      result.__takeCount__ = this.__takeCount__;
      result.__views__ = copyArray(this.__views__);
      return result;
    }

    /**
     * Reverses the direction of lazy iteration.
     *
     * @private
     * @name reverse
     * @memberOf LazyWrapper
     * @returns {Object} Returns the new reversed `LazyWrapper` object.
     */
    function lazyReverse() {
      if (this.__filtered__) {
        var result = new LazyWrapper(this);
        result.__dir__ = -1;
        result.__filtered__ = true;
      } else {
        result = this.clone();
        result.__dir__ *= -1;
      }
      return result;
    }

    /**
     * Extracts the unwrapped value from its lazy wrapper.
     *
     * @private
     * @name value
     * @memberOf LazyWrapper
     * @returns {*} Returns the unwrapped value.
     */
    function lazyValue() {
      var array = this.__wrapped__.value(),
          dir = this.__dir__,
          isArr = isArray(array),
          isRight = dir < 0,
          arrLength = isArr ? array.length : 0,
          view = getView(0, arrLength, this.__views__),
          start = view.start,
          end = view.end,
          length = end - start,
          index = isRight ? end : (start - 1),
          iteratees = this.__iteratees__,
          iterLength = iteratees.length,
          resIndex = 0,
          takeCount = nativeMin(length, this.__takeCount__);

      if (!isArr || (!isRight && arrLength == length && takeCount == length)) {
        return baseWrapperValue(array, this.__actions__);
      }
      var result = [];

      outer:
      while (length-- && resIndex < takeCount) {
        index += dir;

        var iterIndex = -1,
            value = array[index];

        while (++iterIndex < iterLength) {
          var data = iteratees[iterIndex],
              iteratee = data.iteratee,
              type = data.type,
              computed = iteratee(value);

          if (type == LAZY_MAP_FLAG) {
            value = computed;
          } else if (!computed) {
            if (type == LAZY_FILTER_FLAG) {
              continue outer;
            } else {
              break outer;
            }
          }
        }
        result[resIndex++] = value;
      }
      return result;
    }

    // Ensure `LazyWrapper` is an instance of `baseLodash`.
    LazyWrapper.prototype = baseCreate(baseLodash.prototype);
    LazyWrapper.prototype.constructor = LazyWrapper;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a hash object.
     *
     * @private
     * @constructor
     * @param {Array} [entries] The key-value pairs to cache.
     */
    function Hash(entries) {
      var index = -1,
          length = entries == null ? 0 : entries.length;

      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }

    /**
     * Removes all key-value entries from the hash.
     *
     * @private
     * @name clear
     * @memberOf Hash
     */
    function hashClear() {
      this.__data__ = nativeCreate ? nativeCreate(null) : {};
      this.size = 0;
    }

    /**
     * Removes `key` and its value from the hash.
     *
     * @private
     * @name delete
     * @memberOf Hash
     * @param {Object} hash The hash to modify.
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function hashDelete(key) {
      var result = this.has(key) && delete this.__data__[key];
      this.size -= result ? 1 : 0;
      return result;
    }

    /**
     * Gets the hash value for `key`.
     *
     * @private
     * @name get
     * @memberOf Hash
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function hashGet(key) {
      var data = this.__data__;
      if (nativeCreate) {
        var result = data[key];
        return result === HASH_UNDEFINED ? undefined : result;
      }
      return hasOwnProperty.call(data, key) ? data[key] : undefined;
    }

    /**
     * Checks if a hash value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf Hash
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function hashHas(key) {
      var data = this.__data__;
      return nativeCreate ? (data[key] !== undefined) : hasOwnProperty.call(data, key);
    }

    /**
     * Sets the hash `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf Hash
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the hash instance.
     */
    function hashSet(key, value) {
      var data = this.__data__;
      this.size += this.has(key) ? 0 : 1;
      data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
      return this;
    }

    // Add methods to `Hash`.
    Hash.prototype.clear = hashClear;
    Hash.prototype['delete'] = hashDelete;
    Hash.prototype.get = hashGet;
    Hash.prototype.has = hashHas;
    Hash.prototype.set = hashSet;

    /*------------------------------------------------------------------------*/

    /**
     * Creates an list cache object.
     *
     * @private
     * @constructor
     * @param {Array} [entries] The key-value pairs to cache.
     */
    function ListCache(entries) {
      var index = -1,
          length = entries == null ? 0 : entries.length;

      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }

    /**
     * Removes all key-value entries from the list cache.
     *
     * @private
     * @name clear
     * @memberOf ListCache
     */
    function listCacheClear() {
      this.__data__ = [];
      this.size = 0;
    }

    /**
     * Removes `key` and its value from the list cache.
     *
     * @private
     * @name delete
     * @memberOf ListCache
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function listCacheDelete(key) {
      var data = this.__data__,
          index = assocIndexOf(data, key);

      if (index < 0) {
        return false;
      }
      var lastIndex = data.length - 1;
      if (index == lastIndex) {
        data.pop();
      } else {
        splice.call(data, index, 1);
      }
      --this.size;
      return true;
    }

    /**
     * Gets the list cache value for `key`.
     *
     * @private
     * @name get
     * @memberOf ListCache
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function listCacheGet(key) {
      var data = this.__data__,
          index = assocIndexOf(data, key);

      return index < 0 ? undefined : data[index][1];
    }

    /**
     * Checks if a list cache value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf ListCache
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function listCacheHas(key) {
      return assocIndexOf(this.__data__, key) > -1;
    }

    /**
     * Sets the list cache `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf ListCache
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the list cache instance.
     */
    function listCacheSet(key, value) {
      var data = this.__data__,
          index = assocIndexOf(data, key);

      if (index < 0) {
        ++this.size;
        data.push([key, value]);
      } else {
        data[index][1] = value;
      }
      return this;
    }

    // Add methods to `ListCache`.
    ListCache.prototype.clear = listCacheClear;
    ListCache.prototype['delete'] = listCacheDelete;
    ListCache.prototype.get = listCacheGet;
    ListCache.prototype.has = listCacheHas;
    ListCache.prototype.set = listCacheSet;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a map cache object to store key-value pairs.
     *
     * @private
     * @constructor
     * @param {Array} [entries] The key-value pairs to cache.
     */
    function MapCache(entries) {
      var index = -1,
          length = entries == null ? 0 : entries.length;

      this.clear();
      while (++index < length) {
        var entry = entries[index];
        this.set(entry[0], entry[1]);
      }
    }

    /**
     * Removes all key-value entries from the map.
     *
     * @private
     * @name clear
     * @memberOf MapCache
     */
    function mapCacheClear() {
      this.size = 0;
      this.__data__ = {
        'hash': new Hash,
        'map': new (Map || ListCache),
        'string': new Hash
      };
    }

    /**
     * Removes `key` and its value from the map.
     *
     * @private
     * @name delete
     * @memberOf MapCache
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function mapCacheDelete(key) {
      var result = getMapData(this, key)['delete'](key);
      this.size -= result ? 1 : 0;
      return result;
    }

    /**
     * Gets the map value for `key`.
     *
     * @private
     * @name get
     * @memberOf MapCache
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function mapCacheGet(key) {
      return getMapData(this, key).get(key);
    }

    /**
     * Checks if a map value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf MapCache
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function mapCacheHas(key) {
      return getMapData(this, key).has(key);
    }

    /**
     * Sets the map `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf MapCache
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the map cache instance.
     */
    function mapCacheSet(key, value) {
      var data = getMapData(this, key),
          size = data.size;

      data.set(key, value);
      this.size += data.size == size ? 0 : 1;
      return this;
    }

    // Add methods to `MapCache`.
    MapCache.prototype.clear = mapCacheClear;
    MapCache.prototype['delete'] = mapCacheDelete;
    MapCache.prototype.get = mapCacheGet;
    MapCache.prototype.has = mapCacheHas;
    MapCache.prototype.set = mapCacheSet;

    /*------------------------------------------------------------------------*/

    /**
     *
     * Creates an array cache object to store unique values.
     *
     * @private
     * @constructor
     * @param {Array} [values] The values to cache.
     */
    function SetCache(values) {
      var index = -1,
          length = values == null ? 0 : values.length;

      this.__data__ = new MapCache;
      while (++index < length) {
        this.add(values[index]);
      }
    }

    /**
     * Adds `value` to the array cache.
     *
     * @private
     * @name add
     * @memberOf SetCache
     * @alias push
     * @param {*} value The value to cache.
     * @returns {Object} Returns the cache instance.
     */
    function setCacheAdd(value) {
      this.__data__.set(value, HASH_UNDEFINED);
      return this;
    }

    /**
     * Checks if `value` is in the array cache.
     *
     * @private
     * @name has
     * @memberOf SetCache
     * @param {*} value The value to search for.
     * @returns {number} Returns `true` if `value` is found, else `false`.
     */
    function setCacheHas(value) {
      return this.__data__.has(value);
    }

    // Add methods to `SetCache`.
    SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
    SetCache.prototype.has = setCacheHas;

    /*------------------------------------------------------------------------*/

    /**
     * Creates a stack cache object to store key-value pairs.
     *
     * @private
     * @constructor
     * @param {Array} [entries] The key-value pairs to cache.
     */
    function Stack(entries) {
      var data = this.__data__ = new ListCache(entries);
      this.size = data.size;
    }

    /**
     * Removes all key-value entries from the stack.
     *
     * @private
     * @name clear
     * @memberOf Stack
     */
    function stackClear() {
      this.__data__ = new ListCache;
      this.size = 0;
    }

    /**
     * Removes `key` and its value from the stack.
     *
     * @private
     * @name delete
     * @memberOf Stack
     * @param {string} key The key of the value to remove.
     * @returns {boolean} Returns `true` if the entry was removed, else `false`.
     */
    function stackDelete(key) {
      var data = this.__data__,
          result = data['delete'](key);

      this.size = data.size;
      return result;
    }

    /**
     * Gets the stack value for `key`.
     *
     * @private
     * @name get
     * @memberOf Stack
     * @param {string} key The key of the value to get.
     * @returns {*} Returns the entry value.
     */
    function stackGet(key) {
      return this.__data__.get(key);
    }

    /**
     * Checks if a stack value for `key` exists.
     *
     * @private
     * @name has
     * @memberOf Stack
     * @param {string} key The key of the entry to check.
     * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
     */
    function stackHas(key) {
      return this.__data__.has(key);
    }

    /**
     * Sets the stack `key` to `value`.
     *
     * @private
     * @name set
     * @memberOf Stack
     * @param {string} key The key of the value to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns the stack cache instance.
     */
    function stackSet(key, value) {
      var data = this.__data__;
      if (data instanceof ListCache) {
        var pairs = data.__data__;
        if (!Map || (pairs.length < LARGE_ARRAY_SIZE - 1)) {
          pairs.push([key, value]);
          this.size = ++data.size;
          return this;
        }
        data = this.__data__ = new MapCache(pairs);
      }
      data.set(key, value);
      this.size = data.size;
      return this;
    }

    // Add methods to `Stack`.
    Stack.prototype.clear = stackClear;
    Stack.prototype['delete'] = stackDelete;
    Stack.prototype.get = stackGet;
    Stack.prototype.has = stackHas;
    Stack.prototype.set = stackSet;

    /*------------------------------------------------------------------------*/

    /**
     * Creates an array of the enumerable property names of the array-like `value`.
     *
     * @private
     * @param {*} value The value to query.
     * @param {boolean} inherited Specify returning inherited property names.
     * @returns {Array} Returns the array of property names.
     */
    function arrayLikeKeys(value, inherited) {
      var isArr = isArray(value),
          isArg = !isArr && isArguments(value),
          isBuff = !isArr && !isArg && isBuffer(value),
          isType = !isArr && !isArg && !isBuff && isTypedArray(value),
          skipIndexes = isArr || isArg || isBuff || isType,
          result = skipIndexes ? baseTimes(value.length, String) : [],
          length = result.length;

      for (var key in value) {
        if ((inherited || hasOwnProperty.call(value, key)) &&
            !(skipIndexes && (
               // Safari 9 has enumerable `arguments.length` in strict mode.
               key == 'length' ||
               // Node.js 0.10 has enumerable non-index properties on buffers.
               (isBuff && (key == 'offset' || key == 'parent')) ||
               // PhantomJS 2 has enumerable non-index properties on typed arrays.
               (isType && (key == 'buffer' || key == 'byteLength' || key == 'byteOffset')) ||
               // Skip index properties.
               isIndex(key, length)
            ))) {
          result.push(key);
        }
      }
      return result;
    }

    /**
     * A specialized version of `_.sample` for arrays.
     *
     * @private
     * @param {Array} array The array to sample.
     * @returns {*} Returns the random element.
     */
    function arraySample(array) {
      var length = array.length;
      return length ? array[baseRandom(0, length - 1)] : undefined;
    }

    /**
     * A specialized version of `_.sampleSize` for arrays.
     *
     * @private
     * @param {Array} array The array to sample.
     * @param {number} n The number of elements to sample.
     * @returns {Array} Returns the random elements.
     */
    function arraySampleSize(array, n) {
      return shuffleSelf(copyArray(array), baseClamp(n, 0, array.length));
    }

    /**
     * A specialized version of `_.shuffle` for arrays.
     *
     * @private
     * @param {Array} array The array to shuffle.
     * @returns {Array} Returns the new shuffled array.
     */
    function arrayShuffle(array) {
      return shuffleSelf(copyArray(array));
    }

    /**
     * This function is like `assignValue` except that it doesn't assign
     * `undefined` values.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {string} key The key of the property to assign.
     * @param {*} value The value to assign.
     */
    function assignMergeValue(object, key, value) {
      if ((value !== undefined && !eq(object[key], value)) ||
          (value === undefined && !(key in object))) {
        baseAssignValue(object, key, value);
      }
    }

    /**
     * Assigns `value` to `key` of `object` if the existing value is not equivalent
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {string} key The key of the property to assign.
     * @param {*} value The value to assign.
     */
    function assignValue(object, key, value) {
      var objValue = object[key];
      if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) ||
          (value === undefined && !(key in object))) {
        baseAssignValue(object, key, value);
      }
    }

    /**
     * Gets the index at which the `key` is found in `array` of key-value pairs.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {*} key The key to search for.
     * @returns {number} Returns the index of the matched value, else `-1`.
     */
    function assocIndexOf(array, key) {
      var length = array.length;
      while (length--) {
        if (eq(array[length][0], key)) {
          return length;
        }
      }
      return -1;
    }

    /**
     * Aggregates elements of `collection` on `accumulator` with keys transformed
     * by `iteratee` and values set by `setter`.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} setter The function to set `accumulator` values.
     * @param {Function} iteratee The iteratee to transform keys.
     * @param {Object} accumulator The initial aggregated object.
     * @returns {Function} Returns `accumulator`.
     */
    function baseAggregator(collection, setter, iteratee, accumulator) {
      baseEach(collection, function(value, key, collection) {
        setter(accumulator, value, iteratee(value), collection);
      });
      return accumulator;
    }

    /**
     * The base implementation of `_.assign` without support for multiple sources
     * or `customizer` functions.
     *
     * @private
     * @param {Object} object The destination object.
     * @param {Object} source The source object.
     * @returns {Object} Returns `object`.
     */
    function baseAssign(object, source) {
      return object && copyObject(source, keys(source), object);
    }

    /**
     * The base implementation of `_.assignIn` without support for multiple sources
     * or `customizer` functions.
     *
     * @private
     * @param {Object} object The destination object.
     * @param {Object} source The source object.
     * @returns {Object} Returns `object`.
     */
    function baseAssignIn(object, source) {
      return object && copyObject(source, keysIn(source), object);
    }

    /**
     * The base implementation of `assignValue` and `assignMergeValue` without
     * value checks.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {string} key The key of the property to assign.
     * @param {*} value The value to assign.
     */
    function baseAssignValue(object, key, value) {
      if (key == '__proto__' && defineProperty) {
        defineProperty(object, key, {
          'configurable': true,
          'enumerable': true,
          'value': value,
          'writable': true
        });
      } else {
        object[key] = value;
      }
    }

    /**
     * The base implementation of `_.at` without support for individual paths.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {string[]} paths The property paths to pick.
     * @returns {Array} Returns the picked elements.
     */
    function baseAt(object, paths) {
      var index = -1,
          length = paths.length,
          result = Array(length),
          skip = object == null;

      while (++index < length) {
        result[index] = skip ? undefined : get(object, paths[index]);
      }
      return result;
    }

    /**
     * The base implementation of `_.clamp` which doesn't coerce arguments.
     *
     * @private
     * @param {number} number The number to clamp.
     * @param {number} [lower] The lower bound.
     * @param {number} upper The upper bound.
     * @returns {number} Returns the clamped number.
     */
    function baseClamp(number, lower, upper) {
      if (number === number) {
        if (upper !== undefined) {
          number = number <= upper ? number : upper;
        }
        if (lower !== undefined) {
          number = number >= lower ? number : lower;
        }
      }
      return number;
    }

    /**
     * The base implementation of `_.clone` and `_.cloneDeep` which tracks
     * traversed objects.
     *
     * @private
     * @param {*} value The value to clone.
     * @param {boolean} bitmask The bitmask flags.
     *  1 - Deep clone
     *  2 - Flatten inherited properties
     *  4 - Clone symbols
     * @param {Function} [customizer] The function to customize cloning.
     * @param {string} [key] The key of `value`.
     * @param {Object} [object] The parent object of `value`.
     * @param {Object} [stack] Tracks traversed objects and their clone counterparts.
     * @returns {*} Returns the cloned value.
     */
    function baseClone(value, bitmask, customizer, key, object, stack) {
      var result,
          isDeep = bitmask & CLONE_DEEP_FLAG,
          isFlat = bitmask & CLONE_FLAT_FLAG,
          isFull = bitmask & CLONE_SYMBOLS_FLAG;

      if (customizer) {
        result = object ? customizer(value, key, object, stack) : customizer(value);
      }
      if (result !== undefined) {
        return result;
      }
      if (!isObject(value)) {
        return value;
      }
      var isArr = isArray(value);
      if (isArr) {
        result = initCloneArray(value);
        if (!isDeep) {
          return copyArray(value, result);
        }
      } else {
        var tag = getTag(value),
            isFunc = tag == funcTag || tag == genTag;

        if (isBuffer(value)) {
          return cloneBuffer(value, isDeep);
        }
        if (tag == objectTag || tag == argsTag || (isFunc && !object)) {
          result = (isFlat || isFunc) ? {} : initCloneObject(value);
          if (!isDeep) {
            return isFlat
              ? copySymbolsIn(value, baseAssignIn(result, value))
              : copySymbols(value, baseAssign(result, value));
          }
        } else {
          if (!cloneableTags[tag]) {
            return object ? value : {};
          }
          result = initCloneByTag(value, tag, isDeep);
        }
      }
      // Check for circular references and return its corresponding clone.
      stack || (stack = new Stack);
      var stacked = stack.get(value);
      if (stacked) {
        return stacked;
      }
      stack.set(value, result);

      if (isSet(value)) {
        value.forEach(function(subValue) {
          result.add(baseClone(subValue, bitmask, customizer, subValue, value, stack));
        });
      } else if (isMap(value)) {
        value.forEach(function(subValue, key) {
          result.set(key, baseClone(subValue, bitmask, customizer, key, value, stack));
        });
      }

      var keysFunc = isFull
        ? (isFlat ? getAllKeysIn : getAllKeys)
        : (isFlat ? keysIn : keys);

      var props = isArr ? undefined : keysFunc(value);
      arrayEach(props || value, function(subValue, key) {
        if (props) {
          key = subValue;
          subValue = value[key];
        }
        // Recursively populate clone (susceptible to call stack limits).
        assignValue(result, key, baseClone(subValue, bitmask, customizer, key, value, stack));
      });
      return result;
    }

    /**
     * The base implementation of `_.conforms` which doesn't clone `source`.
     *
     * @private
     * @param {Object} source The object of property predicates to conform to.
     * @returns {Function} Returns the new spec function.
     */
    function baseConforms(source) {
      var props = keys(source);
      return function(object) {
        return baseConformsTo(object, source, props);
      };
    }

    /**
     * The base implementation of `_.conformsTo` which accepts `props` to check.
     *
     * @private
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property predicates to conform to.
     * @returns {boolean} Returns `true` if `object` conforms, else `false`.
     */
    function baseConformsTo(object, source, props) {
      var length = props.length;
      if (object == null) {
        return !length;
      }
      object = Object(object);
      while (length--) {
        var key = props[length],
            predicate = source[key],
            value = object[key];

        if ((value === undefined && !(key in object)) || !predicate(value)) {
          return false;
        }
      }
      return true;
    }

    /**
     * The base implementation of `_.delay` and `_.defer` which accepts `args`
     * to provide to `func`.
     *
     * @private
     * @param {Function} func The function to delay.
     * @param {number} wait The number of milliseconds to delay invocation.
     * @param {Array} args The arguments to provide to `func`.
     * @returns {number|Object} Returns the timer id or timeout object.
     */
    function baseDelay(func, wait, args) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      return setTimeout(function() { func.apply(undefined, args); }, wait);
    }

    /**
     * The base implementation of methods like `_.difference` without support
     * for excluding multiple arrays or iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {Array} values The values to exclude.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     */
    function baseDifference(array, values, iteratee, comparator) {
      var index = -1,
          includes = arrayIncludes,
          isCommon = true,
          length = array.length,
          result = [],
          valuesLength = values.length;

      if (!length) {
        return result;
      }
      if (iteratee) {
        values = arrayMap(values, baseUnary(iteratee));
      }
      if (comparator) {
        includes = arrayIncludesWith;
        isCommon = false;
      }
      else if (values.length >= LARGE_ARRAY_SIZE) {
        includes = cacheHas;
        isCommon = false;
        values = new SetCache(values);
      }
      outer:
      while (++index < length) {
        var value = array[index],
            computed = iteratee == null ? value : iteratee(value);

        value = (comparator || value !== 0) ? value : 0;
        if (isCommon && computed === computed) {
          var valuesIndex = valuesLength;
          while (valuesIndex--) {
            if (values[valuesIndex] === computed) {
              continue outer;
            }
          }
          result.push(value);
        }
        else if (!includes(values, computed, comparator)) {
          result.push(value);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.forEach` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     */
    var baseEach = createBaseEach(baseForOwn);

    /**
     * The base implementation of `_.forEachRight` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     */
    var baseEachRight = createBaseEach(baseForOwnRight, true);

    /**
     * The base implementation of `_.every` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} predicate The function invoked per iteration.
     * @returns {boolean} Returns `true` if all elements pass the predicate check,
     *  else `false`
     */
    function baseEvery(collection, predicate) {
      var result = true;
      baseEach(collection, function(value, index, collection) {
        result = !!predicate(value, index, collection);
        return result;
      });
      return result;
    }

    /**
     * The base implementation of methods like `_.max` and `_.min` which accepts a
     * `comparator` to determine the extremum value.
     *
     * @private
     * @param {Array} array The array to iterate over.
     * @param {Function} iteratee The iteratee invoked per iteration.
     * @param {Function} comparator The comparator used to compare values.
     * @returns {*} Returns the extremum value.
     */
    function baseExtremum(array, iteratee, comparator) {
      var index = -1,
          length = array.length;

      while (++index < length) {
        var value = array[index],
            current = iteratee(value);

        if (current != null && (computed === undefined
              ? (current === current && !isSymbol(current))
              : comparator(current, computed)
            )) {
          var computed = current,
              result = value;
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.fill` without an iteratee call guard.
     *
     * @private
     * @param {Array} array The array to fill.
     * @param {*} value The value to fill `array` with.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns `array`.
     */
    function baseFill(array, value, start, end) {
      var length = array.length;

      start = toInteger(start);
      if (start < 0) {
        start = -start > length ? 0 : (length + start);
      }
      end = (end === undefined || end > length) ? length : toInteger(end);
      if (end < 0) {
        end += length;
      }
      end = start > end ? 0 : toLength(end);
      while (start < end) {
        array[start++] = value;
      }
      return array;
    }

    /**
     * The base implementation of `_.filter` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} predicate The function invoked per iteration.
     * @returns {Array} Returns the new filtered array.
     */
    function baseFilter(collection, predicate) {
      var result = [];
      baseEach(collection, function(value, index, collection) {
        if (predicate(value, index, collection)) {
          result.push(value);
        }
      });
      return result;
    }

    /**
     * The base implementation of `_.flatten` with support for restricting flattening.
     *
     * @private
     * @param {Array} array The array to flatten.
     * @param {number} depth The maximum recursion depth.
     * @param {boolean} [predicate=isFlattenable] The function invoked per iteration.
     * @param {boolean} [isStrict] Restrict to values that pass `predicate` checks.
     * @param {Array} [result=[]] The initial result value.
     * @returns {Array} Returns the new flattened array.
     */
    function baseFlatten(array, depth, predicate, isStrict, result) {
      var index = -1,
          length = array.length;

      predicate || (predicate = isFlattenable);
      result || (result = []);

      while (++index < length) {
        var value = array[index];
        if (depth > 0 && predicate(value)) {
          if (depth > 1) {
            // Recursively flatten arrays (susceptible to call stack limits).
            baseFlatten(value, depth - 1, predicate, isStrict, result);
          } else {
            arrayPush(result, value);
          }
        } else if (!isStrict) {
          result[result.length] = value;
        }
      }
      return result;
    }

    /**
     * The base implementation of `baseForOwn` which iterates over `object`
     * properties returned by `keysFunc` and invokes `iteratee` for each property.
     * Iteratee functions may exit iteration early by explicitly returning `false`.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @param {Function} keysFunc The function to get the keys of `object`.
     * @returns {Object} Returns `object`.
     */
    var baseFor = createBaseFor();

    /**
     * This function is like `baseFor` except that it iterates over properties
     * in the opposite order.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @param {Function} keysFunc The function to get the keys of `object`.
     * @returns {Object} Returns `object`.
     */
    var baseForRight = createBaseFor(true);

    /**
     * The base implementation of `_.forOwn` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Object} Returns `object`.
     */
    function baseForOwn(object, iteratee) {
      return object && baseFor(object, iteratee, keys);
    }

    /**
     * The base implementation of `_.forOwnRight` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Object} Returns `object`.
     */
    function baseForOwnRight(object, iteratee) {
      return object && baseForRight(object, iteratee, keys);
    }

    /**
     * The base implementation of `_.functions` which creates an array of
     * `object` function property names filtered from `props`.
     *
     * @private
     * @param {Object} object The object to inspect.
     * @param {Array} props The property names to filter.
     * @returns {Array} Returns the function names.
     */
    function baseFunctions(object, props) {
      return arrayFilter(props, function(key) {
        return isFunction(object[key]);
      });
    }

    /**
     * The base implementation of `_.get` without support for default values.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the property to get.
     * @returns {*} Returns the resolved value.
     */
    function baseGet(object, path) {
      path = castPath(path, object);

      var index = 0,
          length = path.length;

      while (object != null && index < length) {
        object = object[toKey(path[index++])];
      }
      return (index && index == length) ? object : undefined;
    }

    /**
     * The base implementation of `getAllKeys` and `getAllKeysIn` which uses
     * `keysFunc` and `symbolsFunc` to get the enumerable property names and
     * symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Function} keysFunc The function to get the keys of `object`.
     * @param {Function} symbolsFunc The function to get the symbols of `object`.
     * @returns {Array} Returns the array of property names and symbols.
     */
    function baseGetAllKeys(object, keysFunc, symbolsFunc) {
      var result = keysFunc(object);
      return isArray(object) ? result : arrayPush(result, symbolsFunc(object));
    }

    /**
     * The base implementation of `getTag` without fallbacks for buggy environments.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the `toStringTag`.
     */
    function baseGetTag(value) {
      if (value == null) {
        return value === undefined ? undefinedTag : nullTag;
      }
      return (symToStringTag && symToStringTag in Object(value))
        ? getRawTag(value)
        : objectToString(value);
    }

    /**
     * The base implementation of `_.gt` which doesn't coerce arguments.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is greater than `other`,
     *  else `false`.
     */
    function baseGt(value, other) {
      return value > other;
    }

    /**
     * The base implementation of `_.has` without support for deep paths.
     *
     * @private
     * @param {Object} [object] The object to query.
     * @param {Array|string} key The key to check.
     * @returns {boolean} Returns `true` if `key` exists, else `false`.
     */
    function baseHas(object, key) {
      return object != null && hasOwnProperty.call(object, key);
    }

    /**
     * The base implementation of `_.hasIn` without support for deep paths.
     *
     * @private
     * @param {Object} [object] The object to query.
     * @param {Array|string} key The key to check.
     * @returns {boolean} Returns `true` if `key` exists, else `false`.
     */
    function baseHasIn(object, key) {
      return object != null && key in Object(object);
    }

    /**
     * The base implementation of `_.inRange` which doesn't coerce arguments.
     *
     * @private
     * @param {number} number The number to check.
     * @param {number} start The start of the range.
     * @param {number} end The end of the range.
     * @returns {boolean} Returns `true` if `number` is in the range, else `false`.
     */
    function baseInRange(number, start, end) {
      return number >= nativeMin(start, end) && number < nativeMax(start, end);
    }

    /**
     * The base implementation of methods like `_.intersection`, without support
     * for iteratee shorthands, that accepts an array of arrays to inspect.
     *
     * @private
     * @param {Array} arrays The arrays to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of shared values.
     */
    function baseIntersection(arrays, iteratee, comparator) {
      var includes = comparator ? arrayIncludesWith : arrayIncludes,
          length = arrays[0].length,
          othLength = arrays.length,
          othIndex = othLength,
          caches = Array(othLength),
          maxLength = Infinity,
          result = [];

      while (othIndex--) {
        var array = arrays[othIndex];
        if (othIndex && iteratee) {
          array = arrayMap(array, baseUnary(iteratee));
        }
        maxLength = nativeMin(array.length, maxLength);
        caches[othIndex] = !comparator && (iteratee || (length >= 120 && array.length >= 120))
          ? new SetCache(othIndex && array)
          : undefined;
      }
      array = arrays[0];

      var index = -1,
          seen = caches[0];

      outer:
      while (++index < length && result.length < maxLength) {
        var value = array[index],
            computed = iteratee ? iteratee(value) : value;

        value = (comparator || value !== 0) ? value : 0;
        if (!(seen
              ? cacheHas(seen, computed)
              : includes(result, computed, comparator)
            )) {
          othIndex = othLength;
          while (--othIndex) {
            var cache = caches[othIndex];
            if (!(cache
                  ? cacheHas(cache, computed)
                  : includes(arrays[othIndex], computed, comparator))
                ) {
              continue outer;
            }
          }
          if (seen) {
            seen.push(computed);
          }
          result.push(value);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.invert` and `_.invertBy` which inverts
     * `object` with values transformed by `iteratee` and set by `setter`.
     *
     * @private
     * @param {Object} object The object to iterate over.
     * @param {Function} setter The function to set `accumulator` values.
     * @param {Function} iteratee The iteratee to transform values.
     * @param {Object} accumulator The initial inverted object.
     * @returns {Function} Returns `accumulator`.
     */
    function baseInverter(object, setter, iteratee, accumulator) {
      baseForOwn(object, function(value, key, object) {
        setter(accumulator, iteratee(value), key, object);
      });
      return accumulator;
    }

    /**
     * The base implementation of `_.invoke` without support for individual
     * method arguments.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the method to invoke.
     * @param {Array} args The arguments to invoke the method with.
     * @returns {*} Returns the result of the invoked method.
     */
    function baseInvoke(object, path, args) {
      path = castPath(path, object);
      object = parent(object, path);
      var func = object == null ? object : object[toKey(last(path))];
      return func == null ? undefined : apply(func, object, args);
    }

    /**
     * The base implementation of `_.isArguments`.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an `arguments` object,
     */
    function baseIsArguments(value) {
      return isObjectLike(value) && baseGetTag(value) == argsTag;
    }

    /**
     * The base implementation of `_.isArrayBuffer` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array buffer, else `false`.
     */
    function baseIsArrayBuffer(value) {
      return isObjectLike(value) && baseGetTag(value) == arrayBufferTag;
    }

    /**
     * The base implementation of `_.isDate` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a date object, else `false`.
     */
    function baseIsDate(value) {
      return isObjectLike(value) && baseGetTag(value) == dateTag;
    }

    /**
     * The base implementation of `_.isEqual` which supports partial comparisons
     * and tracks traversed objects.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @param {boolean} bitmask The bitmask flags.
     *  1 - Unordered comparison
     *  2 - Partial comparison
     * @param {Function} [customizer] The function to customize comparisons.
     * @param {Object} [stack] Tracks traversed `value` and `other` objects.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     */
    function baseIsEqual(value, other, bitmask, customizer, stack) {
      if (value === other) {
        return true;
      }
      if (value == null || other == null || (!isObjectLike(value) && !isObjectLike(other))) {
        return value !== value && other !== other;
      }
      return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
    }

    /**
     * A specialized version of `baseIsEqual` for arrays and objects which performs
     * deep comparisons and tracks traversed objects enabling objects with circular
     * references to be compared.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
     * @param {Function} customizer The function to customize comparisons.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Object} [stack] Tracks traversed `object` and `other` objects.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
      var objIsArr = isArray(object),
          othIsArr = isArray(other),
          objTag = objIsArr ? arrayTag : getTag(object),
          othTag = othIsArr ? arrayTag : getTag(other);

      objTag = objTag == argsTag ? objectTag : objTag;
      othTag = othTag == argsTag ? objectTag : othTag;

      var objIsObj = objTag == objectTag,
          othIsObj = othTag == objectTag,
          isSameTag = objTag == othTag;

      if (isSameTag && isBuffer(object)) {
        if (!isBuffer(other)) {
          return false;
        }
        objIsArr = true;
        objIsObj = false;
      }
      if (isSameTag && !objIsObj) {
        stack || (stack = new Stack);
        return (objIsArr || isTypedArray(object))
          ? equalArrays(object, other, bitmask, customizer, equalFunc, stack)
          : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
      }
      if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
        var objIsWrapped = objIsObj && hasOwnProperty.call(object, '__wrapped__'),
            othIsWrapped = othIsObj && hasOwnProperty.call(other, '__wrapped__');

        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object.value() : object,
              othUnwrapped = othIsWrapped ? other.value() : other;

          stack || (stack = new Stack);
          return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
        }
      }
      if (!isSameTag) {
        return false;
      }
      stack || (stack = new Stack);
      return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
    }

    /**
     * The base implementation of `_.isMap` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a map, else `false`.
     */
    function baseIsMap(value) {
      return isObjectLike(value) && getTag(value) == mapTag;
    }

    /**
     * The base implementation of `_.isMatch` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property values to match.
     * @param {Array} matchData The property names, values, and compare flags to match.
     * @param {Function} [customizer] The function to customize comparisons.
     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
     */
    function baseIsMatch(object, source, matchData, customizer) {
      var index = matchData.length,
          length = index,
          noCustomizer = !customizer;

      if (object == null) {
        return !length;
      }
      object = Object(object);
      while (index--) {
        var data = matchData[index];
        if ((noCustomizer && data[2])
              ? data[1] !== object[data[0]]
              : !(data[0] in object)
            ) {
          return false;
        }
      }
      while (++index < length) {
        data = matchData[index];
        var key = data[0],
            objValue = object[key],
            srcValue = data[1];

        if (noCustomizer && data[2]) {
          if (objValue === undefined && !(key in object)) {
            return false;
          }
        } else {
          var stack = new Stack;
          if (customizer) {
            var result = customizer(objValue, srcValue, key, object, source, stack);
          }
          if (!(result === undefined
                ? baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG, customizer, stack)
                : result
              )) {
            return false;
          }
        }
      }
      return true;
    }

    /**
     * The base implementation of `_.isNative` without bad shim checks.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a native function,
     *  else `false`.
     */
    function baseIsNative(value) {
      if (!isObject(value) || isMasked(value)) {
        return false;
      }
      var pattern = isFunction(value) ? reIsNative : reIsHostCtor;
      return pattern.test(toSource(value));
    }

    /**
     * The base implementation of `_.isRegExp` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.
     */
    function baseIsRegExp(value) {
      return isObjectLike(value) && baseGetTag(value) == regexpTag;
    }

    /**
     * The base implementation of `_.isSet` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a set, else `false`.
     */
    function baseIsSet(value) {
      return isObjectLike(value) && getTag(value) == setTag;
    }

    /**
     * The base implementation of `_.isTypedArray` without Node.js optimizations.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
     */
    function baseIsTypedArray(value) {
      return isObjectLike(value) &&
        isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
    }

    /**
     * The base implementation of `_.iteratee`.
     *
     * @private
     * @param {*} [value=_.identity] The value to convert to an iteratee.
     * @returns {Function} Returns the iteratee.
     */
    function baseIteratee(value) {
      // Don't store the `typeof` result in a variable to avoid a JIT bug in Safari 9.
      // See https://bugs.webkit.org/show_bug.cgi?id=156034 for more details.
      if (typeof value == 'function') {
        return value;
      }
      if (value == null) {
        return identity;
      }
      if (typeof value == 'object') {
        return isArray(value)
          ? baseMatchesProperty(value[0], value[1])
          : baseMatches(value);
      }
      return property(value);
    }

    /**
     * The base implementation of `_.keys` which doesn't treat sparse arrays as dense.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     */
    function baseKeys(object) {
      if (!isPrototype(object)) {
        return nativeKeys(object);
      }
      var result = [];
      for (var key in Object(object)) {
        if (hasOwnProperty.call(object, key) && key != 'constructor') {
          result.push(key);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.keysIn` which doesn't treat sparse arrays as dense.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     */
    function baseKeysIn(object) {
      if (!isObject(object)) {
        return nativeKeysIn(object);
      }
      var isProto = isPrototype(object),
          result = [];

      for (var key in object) {
        if (!(key == 'constructor' && (isProto || !hasOwnProperty.call(object, key)))) {
          result.push(key);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.lt` which doesn't coerce arguments.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is less than `other`,
     *  else `false`.
     */
    function baseLt(value, other) {
      return value < other;
    }

    /**
     * The base implementation of `_.map` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} iteratee The function invoked per iteration.
     * @returns {Array} Returns the new mapped array.
     */
    function baseMap(collection, iteratee) {
      var index = -1,
          result = isArrayLike(collection) ? Array(collection.length) : [];

      baseEach(collection, function(value, key, collection) {
        result[++index] = iteratee(value, key, collection);
      });
      return result;
    }

    /**
     * The base implementation of `_.matches` which doesn't clone `source`.
     *
     * @private
     * @param {Object} source The object of property values to match.
     * @returns {Function} Returns the new spec function.
     */
    function baseMatches(source) {
      var matchData = getMatchData(source);
      if (matchData.length == 1 && matchData[0][2]) {
        return matchesStrictComparable(matchData[0][0], matchData[0][1]);
      }
      return function(object) {
        return object === source || baseIsMatch(object, source, matchData);
      };
    }

    /**
     * The base implementation of `_.matchesProperty` which doesn't clone `srcValue`.
     *
     * @private
     * @param {string} path The path of the property to get.
     * @param {*} srcValue The value to match.
     * @returns {Function} Returns the new spec function.
     */
    function baseMatchesProperty(path, srcValue) {
      if (isKey(path) && isStrictComparable(srcValue)) {
        return matchesStrictComparable(toKey(path), srcValue);
      }
      return function(object) {
        var objValue = get(object, path);
        return (objValue === undefined && objValue === srcValue)
          ? hasIn(object, path)
          : baseIsEqual(srcValue, objValue, COMPARE_PARTIAL_FLAG | COMPARE_UNORDERED_FLAG);
      };
    }

    /**
     * The base implementation of `_.merge` without support for multiple sources.
     *
     * @private
     * @param {Object} object The destination object.
     * @param {Object} source The source object.
     * @param {number} srcIndex The index of `source`.
     * @param {Function} [customizer] The function to customize merged values.
     * @param {Object} [stack] Tracks traversed source values and their merged
     *  counterparts.
     */
    function baseMerge(object, source, srcIndex, customizer, stack) {
      if (object === source) {
        return;
      }
      baseFor(source, function(srcValue, key) {
        stack || (stack = new Stack);
        if (isObject(srcValue)) {
          baseMergeDeep(object, source, key, srcIndex, baseMerge, customizer, stack);
        }
        else {
          var newValue = customizer
            ? customizer(safeGet(object, key), srcValue, (key + ''), object, source, stack)
            : undefined;

          if (newValue === undefined) {
            newValue = srcValue;
          }
          assignMergeValue(object, key, newValue);
        }
      }, keysIn);
    }

    /**
     * A specialized version of `baseMerge` for arrays and objects which performs
     * deep merges and tracks traversed objects enabling objects with circular
     * references to be merged.
     *
     * @private
     * @param {Object} object The destination object.
     * @param {Object} source The source object.
     * @param {string} key The key of the value to merge.
     * @param {number} srcIndex The index of `source`.
     * @param {Function} mergeFunc The function to merge values.
     * @param {Function} [customizer] The function to customize assigned values.
     * @param {Object} [stack] Tracks traversed source values and their merged
     *  counterparts.
     */
    function baseMergeDeep(object, source, key, srcIndex, mergeFunc, customizer, stack) {
      var objValue = safeGet(object, key),
          srcValue = safeGet(source, key),
          stacked = stack.get(srcValue);

      if (stacked) {
        assignMergeValue(object, key, stacked);
        return;
      }
      var newValue = customizer
        ? customizer(objValue, srcValue, (key + ''), object, source, stack)
        : undefined;

      var isCommon = newValue === undefined;

      if (isCommon) {
        var isArr = isArray(srcValue),
            isBuff = !isArr && isBuffer(srcValue),
            isTyped = !isArr && !isBuff && isTypedArray(srcValue);

        newValue = srcValue;
        if (isArr || isBuff || isTyped) {
          if (isArray(objValue)) {
            newValue = objValue;
          }
          else if (isArrayLikeObject(objValue)) {
            newValue = copyArray(objValue);
          }
          else if (isBuff) {
            isCommon = false;
            newValue = cloneBuffer(srcValue, true);
          }
          else if (isTyped) {
            isCommon = false;
            newValue = cloneTypedArray(srcValue, true);
          }
          else {
            newValue = [];
          }
        }
        else if (isPlainObject(srcValue) || isArguments(srcValue)) {
          newValue = objValue;
          if (isArguments(objValue)) {
            newValue = toPlainObject(objValue);
          }
          else if (!isObject(objValue) || isFunction(objValue)) {
            newValue = initCloneObject(srcValue);
          }
        }
        else {
          isCommon = false;
        }
      }
      if (isCommon) {
        // Recursively merge objects and arrays (susceptible to call stack limits).
        stack.set(srcValue, newValue);
        mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
        stack['delete'](srcValue);
      }
      assignMergeValue(object, key, newValue);
    }

    /**
     * The base implementation of `_.nth` which doesn't coerce arguments.
     *
     * @private
     * @param {Array} array The array to query.
     * @param {number} n The index of the element to return.
     * @returns {*} Returns the nth element of `array`.
     */
    function baseNth(array, n) {
      var length = array.length;
      if (!length) {
        return;
      }
      n += n < 0 ? length : 0;
      return isIndex(n, length) ? array[n] : undefined;
    }

    /**
     * The base implementation of `_.orderBy` without param guards.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function[]|Object[]|string[]} iteratees The iteratees to sort by.
     * @param {string[]} orders The sort orders of `iteratees`.
     * @returns {Array} Returns the new sorted array.
     */
    function baseOrderBy(collection, iteratees, orders) {
      if (iteratees.length) {
        iteratees = arrayMap(iteratees, function(iteratee) {
          if (isArray(iteratee)) {
            return function(value) {
              return baseGet(value, iteratee.length === 1 ? iteratee[0] : iteratee);
            }
          }
          return iteratee;
        });
      } else {
        iteratees = [identity];
      }

      var index = -1;
      iteratees = arrayMap(iteratees, baseUnary(getIteratee()));

      var result = baseMap(collection, function(value, key, collection) {
        var criteria = arrayMap(iteratees, function(iteratee) {
          return iteratee(value);
        });
        return { 'criteria': criteria, 'index': ++index, 'value': value };
      });

      return baseSortBy(result, function(object, other) {
        return compareMultiple(object, other, orders);
      });
    }

    /**
     * The base implementation of `_.pick` without support for individual
     * property identifiers.
     *
     * @private
     * @param {Object} object The source object.
     * @param {string[]} paths The property paths to pick.
     * @returns {Object} Returns the new object.
     */
    function basePick(object, paths) {
      return basePickBy(object, paths, function(value, path) {
        return hasIn(object, path);
      });
    }

    /**
     * The base implementation of  `_.pickBy` without support for iteratee shorthands.
     *
     * @private
     * @param {Object} object The source object.
     * @param {string[]} paths The property paths to pick.
     * @param {Function} predicate The function invoked per property.
     * @returns {Object} Returns the new object.
     */
    function basePickBy(object, paths, predicate) {
      var index = -1,
          length = paths.length,
          result = {};

      while (++index < length) {
        var path = paths[index],
            value = baseGet(object, path);

        if (predicate(value, path)) {
          baseSet(result, castPath(path, object), value);
        }
      }
      return result;
    }

    /**
     * A specialized version of `baseProperty` which supports deep paths.
     *
     * @private
     * @param {Array|string} path The path of the property to get.
     * @returns {Function} Returns the new accessor function.
     */
    function basePropertyDeep(path) {
      return function(object) {
        return baseGet(object, path);
      };
    }

    /**
     * The base implementation of `_.pullAllBy` without support for iteratee
     * shorthands.
     *
     * @private
     * @param {Array} array The array to modify.
     * @param {Array} values The values to remove.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns `array`.
     */
    function basePullAll(array, values, iteratee, comparator) {
      var indexOf = comparator ? baseIndexOfWith : baseIndexOf,
          index = -1,
          length = values.length,
          seen = array;

      if (array === values) {
        values = copyArray(values);
      }
      if (iteratee) {
        seen = arrayMap(array, baseUnary(iteratee));
      }
      while (++index < length) {
        var fromIndex = 0,
            value = values[index],
            computed = iteratee ? iteratee(value) : value;

        while ((fromIndex = indexOf(seen, computed, fromIndex, comparator)) > -1) {
          if (seen !== array) {
            splice.call(seen, fromIndex, 1);
          }
          splice.call(array, fromIndex, 1);
        }
      }
      return array;
    }

    /**
     * The base implementation of `_.pullAt` without support for individual
     * indexes or capturing the removed elements.
     *
     * @private
     * @param {Array} array The array to modify.
     * @param {number[]} indexes The indexes of elements to remove.
     * @returns {Array} Returns `array`.
     */
    function basePullAt(array, indexes) {
      var length = array ? indexes.length : 0,
          lastIndex = length - 1;

      while (length--) {
        var index = indexes[length];
        if (length == lastIndex || index !== previous) {
          var previous = index;
          if (isIndex(index)) {
            splice.call(array, index, 1);
          } else {
            baseUnset(array, index);
          }
        }
      }
      return array;
    }

    /**
     * The base implementation of `_.random` without support for returning
     * floating-point numbers.
     *
     * @private
     * @param {number} lower The lower bound.
     * @param {number} upper The upper bound.
     * @returns {number} Returns the random number.
     */
    function baseRandom(lower, upper) {
      return lower + nativeFloor(nativeRandom() * (upper - lower + 1));
    }

    /**
     * The base implementation of `_.range` and `_.rangeRight` which doesn't
     * coerce arguments.
     *
     * @private
     * @param {number} start The start of the range.
     * @param {number} end The end of the range.
     * @param {number} step The value to increment or decrement by.
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Array} Returns the range of numbers.
     */
    function baseRange(start, end, step, fromRight) {
      var index = -1,
          length = nativeMax(nativeCeil((end - start) / (step || 1)), 0),
          result = Array(length);

      while (length--) {
        result[fromRight ? length : ++index] = start;
        start += step;
      }
      return result;
    }

    /**
     * The base implementation of `_.repeat` which doesn't coerce arguments.
     *
     * @private
     * @param {string} string The string to repeat.
     * @param {number} n The number of times to repeat the string.
     * @returns {string} Returns the repeated string.
     */
    function baseRepeat(string, n) {
      var result = '';
      if (!string || n < 1 || n > MAX_SAFE_INTEGER) {
        return result;
      }
      // Leverage the exponentiation by squaring algorithm for a faster repeat.
      // See https://en.wikipedia.org/wiki/Exponentiation_by_squaring for more details.
      do {
        if (n % 2) {
          result += string;
        }
        n = nativeFloor(n / 2);
        if (n) {
          string += string;
        }
      } while (n);

      return result;
    }

    /**
     * The base implementation of `_.rest` which doesn't validate or coerce arguments.
     *
     * @private
     * @param {Function} func The function to apply a rest parameter to.
     * @param {number} [start=func.length-1] The start position of the rest parameter.
     * @returns {Function} Returns the new function.
     */
    function baseRest(func, start) {
      return setToString(overRest(func, start, identity), func + '');
    }

    /**
     * The base implementation of `_.sample`.
     *
     * @private
     * @param {Array|Object} collection The collection to sample.
     * @returns {*} Returns the random element.
     */
    function baseSample(collection) {
      return arraySample(values(collection));
    }

    /**
     * The base implementation of `_.sampleSize` without param guards.
     *
     * @private
     * @param {Array|Object} collection The collection to sample.
     * @param {number} n The number of elements to sample.
     * @returns {Array} Returns the random elements.
     */
    function baseSampleSize(collection, n) {
      var array = values(collection);
      return shuffleSelf(array, baseClamp(n, 0, array.length));
    }

    /**
     * The base implementation of `_.set`.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {*} value The value to set.
     * @param {Function} [customizer] The function to customize path creation.
     * @returns {Object} Returns `object`.
     */
    function baseSet(object, path, value, customizer) {
      if (!isObject(object)) {
        return object;
      }
      path = castPath(path, object);

      var index = -1,
          length = path.length,
          lastIndex = length - 1,
          nested = object;

      while (nested != null && ++index < length) {
        var key = toKey(path[index]),
            newValue = value;

        if (key === '__proto__' || key === 'constructor' || key === 'prototype') {
          return object;
        }

        if (index != lastIndex) {
          var objValue = nested[key];
          newValue = customizer ? customizer(objValue, key, nested) : undefined;
          if (newValue === undefined) {
            newValue = isObject(objValue)
              ? objValue
              : (isIndex(path[index + 1]) ? [] : {});
          }
        }
        assignValue(nested, key, newValue);
        nested = nested[key];
      }
      return object;
    }

    /**
     * The base implementation of `setData` without support for hot loop shorting.
     *
     * @private
     * @param {Function} func The function to associate metadata with.
     * @param {*} data The metadata.
     * @returns {Function} Returns `func`.
     */
    var baseSetData = !metaMap ? identity : function(func, data) {
      metaMap.set(func, data);
      return func;
    };

    /**
     * The base implementation of `setToString` without support for hot loop shorting.
     *
     * @private
     * @param {Function} func The function to modify.
     * @param {Function} string The `toString` result.
     * @returns {Function} Returns `func`.
     */
    var baseSetToString = !defineProperty ? identity : function(func, string) {
      return defineProperty(func, 'toString', {
        'configurable': true,
        'enumerable': false,
        'value': constant(string),
        'writable': true
      });
    };

    /**
     * The base implementation of `_.shuffle`.
     *
     * @private
     * @param {Array|Object} collection The collection to shuffle.
     * @returns {Array} Returns the new shuffled array.
     */
    function baseShuffle(collection) {
      return shuffleSelf(values(collection));
    }

    /**
     * The base implementation of `_.slice` without an iteratee call guard.
     *
     * @private
     * @param {Array} array The array to slice.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns the slice of `array`.
     */
    function baseSlice(array, start, end) {
      var index = -1,
          length = array.length;

      if (start < 0) {
        start = -start > length ? 0 : (length + start);
      }
      end = end > length ? length : end;
      if (end < 0) {
        end += length;
      }
      length = start > end ? 0 : ((end - start) >>> 0);
      start >>>= 0;

      var result = Array(length);
      while (++index < length) {
        result[index] = array[index + start];
      }
      return result;
    }

    /**
     * The base implementation of `_.some` without support for iteratee shorthands.
     *
     * @private
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} predicate The function invoked per iteration.
     * @returns {boolean} Returns `true` if any element passes the predicate check,
     *  else `false`.
     */
    function baseSome(collection, predicate) {
      var result;

      baseEach(collection, function(value, index, collection) {
        result = predicate(value, index, collection);
        return !result;
      });
      return !!result;
    }

    /**
     * The base implementation of `_.sortedIndex` and `_.sortedLastIndex` which
     * performs a binary search of `array` to determine the index at which `value`
     * should be inserted into `array` in order to maintain its sort order.
     *
     * @private
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @param {boolean} [retHighest] Specify returning the highest qualified index.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     */
    function baseSortedIndex(array, value, retHighest) {
      var low = 0,
          high = array == null ? low : array.length;

      if (typeof value == 'number' && value === value && high <= HALF_MAX_ARRAY_LENGTH) {
        while (low < high) {
          var mid = (low + high) >>> 1,
              computed = array[mid];

          if (computed !== null && !isSymbol(computed) &&
              (retHighest ? (computed <= value) : (computed < value))) {
            low = mid + 1;
          } else {
            high = mid;
          }
        }
        return high;
      }
      return baseSortedIndexBy(array, value, identity, retHighest);
    }

    /**
     * The base implementation of `_.sortedIndexBy` and `_.sortedLastIndexBy`
     * which invokes `iteratee` for `value` and each element of `array` to compute
     * their sort ranking. The iteratee is invoked with one argument; (value).
     *
     * @private
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @param {Function} iteratee The iteratee invoked per element.
     * @param {boolean} [retHighest] Specify returning the highest qualified index.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     */
    function baseSortedIndexBy(array, value, iteratee, retHighest) {
      var low = 0,
          high = array == null ? 0 : array.length;
      if (high === 0) {
        return 0;
      }

      value = iteratee(value);
      var valIsNaN = value !== value,
          valIsNull = value === null,
          valIsSymbol = isSymbol(value),
          valIsUndefined = value === undefined;

      while (low < high) {
        var mid = nativeFloor((low + high) / 2),
            computed = iteratee(array[mid]),
            othIsDefined = computed !== undefined,
            othIsNull = computed === null,
            othIsReflexive = computed === computed,
            othIsSymbol = isSymbol(computed);

        if (valIsNaN) {
          var setLow = retHighest || othIsReflexive;
        } else if (valIsUndefined) {
          setLow = othIsReflexive && (retHighest || othIsDefined);
        } else if (valIsNull) {
          setLow = othIsReflexive && othIsDefined && (retHighest || !othIsNull);
        } else if (valIsSymbol) {
          setLow = othIsReflexive && othIsDefined && !othIsNull && (retHighest || !othIsSymbol);
        } else if (othIsNull || othIsSymbol) {
          setLow = false;
        } else {
          setLow = retHighest ? (computed <= value) : (computed < value);
        }
        if (setLow) {
          low = mid + 1;
        } else {
          high = mid;
        }
      }
      return nativeMin(high, MAX_ARRAY_INDEX);
    }

    /**
     * The base implementation of `_.sortedUniq` and `_.sortedUniqBy` without
     * support for iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     */
    function baseSortedUniq(array, iteratee) {
      var index = -1,
          length = array.length,
          resIndex = 0,
          result = [];

      while (++index < length) {
        var value = array[index],
            computed = iteratee ? iteratee(value) : value;

        if (!index || !eq(computed, seen)) {
          var seen = computed;
          result[resIndex++] = value === 0 ? 0 : value;
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.toNumber` which doesn't ensure correct
     * conversions of binary, hexadecimal, or octal string values.
     *
     * @private
     * @param {*} value The value to process.
     * @returns {number} Returns the number.
     */
    function baseToNumber(value) {
      if (typeof value == 'number') {
        return value;
      }
      if (isSymbol(value)) {
        return NAN;
      }
      return +value;
    }

    /**
     * The base implementation of `_.toString` which doesn't convert nullish
     * values to empty strings.
     *
     * @private
     * @param {*} value The value to process.
     * @returns {string} Returns the string.
     */
    function baseToString(value) {
      // Exit early for strings to avoid a performance hit in some environments.
      if (typeof value == 'string') {
        return value;
      }
      if (isArray(value)) {
        // Recursively convert values (susceptible to call stack limits).
        return arrayMap(value, baseToString) + '';
      }
      if (isSymbol(value)) {
        return symbolToString ? symbolToString.call(value) : '';
      }
      var result = (value + '');
      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
    }

    /**
     * The base implementation of `_.uniqBy` without support for iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     */
    function baseUniq(array, iteratee, comparator) {
      var index = -1,
          includes = arrayIncludes,
          length = array.length,
          isCommon = true,
          result = [],
          seen = result;

      if (comparator) {
        isCommon = false;
        includes = arrayIncludesWith;
      }
      else if (length >= LARGE_ARRAY_SIZE) {
        var set = iteratee ? null : createSet(array);
        if (set) {
          return setToArray(set);
        }
        isCommon = false;
        includes = cacheHas;
        seen = new SetCache;
      }
      else {
        seen = iteratee ? [] : result;
      }
      outer:
      while (++index < length) {
        var value = array[index],
            computed = iteratee ? iteratee(value) : value;

        value = (comparator || value !== 0) ? value : 0;
        if (isCommon && computed === computed) {
          var seenIndex = seen.length;
          while (seenIndex--) {
            if (seen[seenIndex] === computed) {
              continue outer;
            }
          }
          if (iteratee) {
            seen.push(computed);
          }
          result.push(value);
        }
        else if (!includes(seen, computed, comparator)) {
          if (seen !== result) {
            seen.push(computed);
          }
          result.push(value);
        }
      }
      return result;
    }

    /**
     * The base implementation of `_.unset`.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {Array|string} path The property path to unset.
     * @returns {boolean} Returns `true` if the property is deleted, else `false`.
     */
    function baseUnset(object, path) {
      path = castPath(path, object);
      object = parent(object, path);
      return object == null || delete object[toKey(last(path))];
    }

    /**
     * The base implementation of `_.update`.
     *
     * @private
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to update.
     * @param {Function} updater The function to produce the updated value.
     * @param {Function} [customizer] The function to customize path creation.
     * @returns {Object} Returns `object`.
     */
    function baseUpdate(object, path, updater, customizer) {
      return baseSet(object, path, updater(baseGet(object, path)), customizer);
    }

    /**
     * The base implementation of methods like `_.dropWhile` and `_.takeWhile`
     * without support for iteratee shorthands.
     *
     * @private
     * @param {Array} array The array to query.
     * @param {Function} predicate The function invoked per iteration.
     * @param {boolean} [isDrop] Specify dropping elements instead of taking them.
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Array} Returns the slice of `array`.
     */
    function baseWhile(array, predicate, isDrop, fromRight) {
      var length = array.length,
          index = fromRight ? length : -1;

      while ((fromRight ? index-- : ++index < length) &&
        predicate(array[index], index, array)) {}

      return isDrop
        ? baseSlice(array, (fromRight ? 0 : index), (fromRight ? index + 1 : length))
        : baseSlice(array, (fromRight ? index + 1 : 0), (fromRight ? length : index));
    }

    /**
     * The base implementation of `wrapperValue` which returns the result of
     * performing a sequence of actions on the unwrapped `value`, where each
     * successive action is supplied the return value of the previous.
     *
     * @private
     * @param {*} value The unwrapped value.
     * @param {Array} actions Actions to perform to resolve the unwrapped value.
     * @returns {*} Returns the resolved value.
     */
    function baseWrapperValue(value, actions) {
      var result = value;
      if (result instanceof LazyWrapper) {
        result = result.value();
      }
      return arrayReduce(actions, function(result, action) {
        return action.func.apply(action.thisArg, arrayPush([result], action.args));
      }, result);
    }

    /**
     * The base implementation of methods like `_.xor`, without support for
     * iteratee shorthands, that accepts an array of arrays to inspect.
     *
     * @private
     * @param {Array} arrays The arrays to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of values.
     */
    function baseXor(arrays, iteratee, comparator) {
      var length = arrays.length;
      if (length < 2) {
        return length ? baseUniq(arrays[0]) : [];
      }
      var index = -1,
          result = Array(length);

      while (++index < length) {
        var array = arrays[index],
            othIndex = -1;

        while (++othIndex < length) {
          if (othIndex != index) {
            result[index] = baseDifference(result[index] || array, arrays[othIndex], iteratee, comparator);
          }
        }
      }
      return baseUniq(baseFlatten(result, 1), iteratee, comparator);
    }

    /**
     * This base implementation of `_.zipObject` which assigns values using `assignFunc`.
     *
     * @private
     * @param {Array} props The property identifiers.
     * @param {Array} values The property values.
     * @param {Function} assignFunc The function to assign values.
     * @returns {Object} Returns the new object.
     */
    function baseZipObject(props, values, assignFunc) {
      var index = -1,
          length = props.length,
          valsLength = values.length,
          result = {};

      while (++index < length) {
        var value = index < valsLength ? values[index] : undefined;
        assignFunc(result, props[index], value);
      }
      return result;
    }

    /**
     * Casts `value` to an empty array if it's not an array like object.
     *
     * @private
     * @param {*} value The value to inspect.
     * @returns {Array|Object} Returns the cast array-like object.
     */
    function castArrayLikeObject(value) {
      return isArrayLikeObject(value) ? value : [];
    }

    /**
     * Casts `value` to `identity` if it's not a function.
     *
     * @private
     * @param {*} value The value to inspect.
     * @returns {Function} Returns cast function.
     */
    function castFunction(value) {
      return typeof value == 'function' ? value : identity;
    }

    /**
     * Casts `value` to a path array if it's not one.
     *
     * @private
     * @param {*} value The value to inspect.
     * @param {Object} [object] The object to query keys on.
     * @returns {Array} Returns the cast property path array.
     */
    function castPath(value, object) {
      if (isArray(value)) {
        return value;
      }
      return isKey(value, object) ? [value] : stringToPath(toString(value));
    }

    /**
     * A `baseRest` alias which can be replaced with `identity` by module
     * replacement plugins.
     *
     * @private
     * @type {Function}
     * @param {Function} func The function to apply a rest parameter to.
     * @returns {Function} Returns the new function.
     */
    var castRest = baseRest;

    /**
     * Casts `array` to a slice if it's needed.
     *
     * @private
     * @param {Array} array The array to inspect.
     * @param {number} start The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns the cast slice.
     */
    function castSlice(array, start, end) {
      var length = array.length;
      end = end === undefined ? length : end;
      return (!start && end >= length) ? array : baseSlice(array, start, end);
    }

    /**
     * A simple wrapper around the global [`clearTimeout`](https://mdn.io/clearTimeout).
     *
     * @private
     * @param {number|Object} id The timer id or timeout object of the timer to clear.
     */
    var clearTimeout = ctxClearTimeout || function(id) {
      return root.clearTimeout(id);
    };

    /**
     * Creates a clone of  `buffer`.
     *
     * @private
     * @param {Buffer} buffer The buffer to clone.
     * @param {boolean} [isDeep] Specify a deep clone.
     * @returns {Buffer} Returns the cloned buffer.
     */
    function cloneBuffer(buffer, isDeep) {
      if (isDeep) {
        return buffer.slice();
      }
      var length = buffer.length,
          result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);

      buffer.copy(result);
      return result;
    }

    /**
     * Creates a clone of `arrayBuffer`.
     *
     * @private
     * @param {ArrayBuffer} arrayBuffer The array buffer to clone.
     * @returns {ArrayBuffer} Returns the cloned array buffer.
     */
    function cloneArrayBuffer(arrayBuffer) {
      var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
      new Uint8Array(result).set(new Uint8Array(arrayBuffer));
      return result;
    }

    /**
     * Creates a clone of `dataView`.
     *
     * @private
     * @param {Object} dataView The data view to clone.
     * @param {boolean} [isDeep] Specify a deep clone.
     * @returns {Object} Returns the cloned data view.
     */
    function cloneDataView(dataView, isDeep) {
      var buffer = isDeep ? cloneArrayBuffer(dataView.buffer) : dataView.buffer;
      return new dataView.constructor(buffer, dataView.byteOffset, dataView.byteLength);
    }

    /**
     * Creates a clone of `regexp`.
     *
     * @private
     * @param {Object} regexp The regexp to clone.
     * @returns {Object} Returns the cloned regexp.
     */
    function cloneRegExp(regexp) {
      var result = new regexp.constructor(regexp.source, reFlags.exec(regexp));
      result.lastIndex = regexp.lastIndex;
      return result;
    }

    /**
     * Creates a clone of the `symbol` object.
     *
     * @private
     * @param {Object} symbol The symbol object to clone.
     * @returns {Object} Returns the cloned symbol object.
     */
    function cloneSymbol(symbol) {
      return symbolValueOf ? Object(symbolValueOf.call(symbol)) : {};
    }

    /**
     * Creates a clone of `typedArray`.
     *
     * @private
     * @param {Object} typedArray The typed array to clone.
     * @param {boolean} [isDeep] Specify a deep clone.
     * @returns {Object} Returns the cloned typed array.
     */
    function cloneTypedArray(typedArray, isDeep) {
      var buffer = isDeep ? cloneArrayBuffer(typedArray.buffer) : typedArray.buffer;
      return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
    }

    /**
     * Compares values to sort them in ascending order.
     *
     * @private
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {number} Returns the sort order indicator for `value`.
     */
    function compareAscending(value, other) {
      if (value !== other) {
        var valIsDefined = value !== undefined,
            valIsNull = value === null,
            valIsReflexive = value === value,
            valIsSymbol = isSymbol(value);

        var othIsDefined = other !== undefined,
            othIsNull = other === null,
            othIsReflexive = other === other,
            othIsSymbol = isSymbol(other);

        if ((!othIsNull && !othIsSymbol && !valIsSymbol && value > other) ||
            (valIsSymbol && othIsDefined && othIsReflexive && !othIsNull && !othIsSymbol) ||
            (valIsNull && othIsDefined && othIsReflexive) ||
            (!valIsDefined && othIsReflexive) ||
            !valIsReflexive) {
          return 1;
        }
        if ((!valIsNull && !valIsSymbol && !othIsSymbol && value < other) ||
            (othIsSymbol && valIsDefined && valIsReflexive && !valIsNull && !valIsSymbol) ||
            (othIsNull && valIsDefined && valIsReflexive) ||
            (!othIsDefined && valIsReflexive) ||
            !othIsReflexive) {
          return -1;
        }
      }
      return 0;
    }

    /**
     * Used by `_.orderBy` to compare multiple properties of a value to another
     * and stable sort them.
     *
     * If `orders` is unspecified, all values are sorted in ascending order. Otherwise,
     * specify an order of "desc" for descending or "asc" for ascending sort order
     * of corresponding values.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {boolean[]|string[]} orders The order to sort by for each property.
     * @returns {number} Returns the sort order indicator for `object`.
     */
    function compareMultiple(object, other, orders) {
      var index = -1,
          objCriteria = object.criteria,
          othCriteria = other.criteria,
          length = objCriteria.length,
          ordersLength = orders.length;

      while (++index < length) {
        var result = compareAscending(objCriteria[index], othCriteria[index]);
        if (result) {
          if (index >= ordersLength) {
            return result;
          }
          var order = orders[index];
          return result * (order == 'desc' ? -1 : 1);
        }
      }
      // Fixes an `Array#sort` bug in the JS engine embedded in Adobe applications
      // that causes it, under certain circumstances, to provide the same value for
      // `object` and `other`. See https://github.com/jashkenas/underscore/pull/1247
      // for more details.
      //
      // This also ensures a stable sort in V8 and other engines.
      // See https://bugs.chromium.org/p/v8/issues/detail?id=90 for more details.
      return object.index - other.index;
    }

    /**
     * Creates an array that is the composition of partially applied arguments,
     * placeholders, and provided arguments into a single array of arguments.
     *
     * @private
     * @param {Array} args The provided arguments.
     * @param {Array} partials The arguments to prepend to those provided.
     * @param {Array} holders The `partials` placeholder indexes.
     * @params {boolean} [isCurried] Specify composing for a curried function.
     * @returns {Array} Returns the new array of composed arguments.
     */
    function composeArgs(args, partials, holders, isCurried) {
      var argsIndex = -1,
          argsLength = args.length,
          holdersLength = holders.length,
          leftIndex = -1,
          leftLength = partials.length,
          rangeLength = nativeMax(argsLength - holdersLength, 0),
          result = Array(leftLength + rangeLength),
          isUncurried = !isCurried;

      while (++leftIndex < leftLength) {
        result[leftIndex] = partials[leftIndex];
      }
      while (++argsIndex < holdersLength) {
        if (isUncurried || argsIndex < argsLength) {
          result[holders[argsIndex]] = args[argsIndex];
        }
      }
      while (rangeLength--) {
        result[leftIndex++] = args[argsIndex++];
      }
      return result;
    }

    /**
     * This function is like `composeArgs` except that the arguments composition
     * is tailored for `_.partialRight`.
     *
     * @private
     * @param {Array} args The provided arguments.
     * @param {Array} partials The arguments to append to those provided.
     * @param {Array} holders The `partials` placeholder indexes.
     * @params {boolean} [isCurried] Specify composing for a curried function.
     * @returns {Array} Returns the new array of composed arguments.
     */
    function composeArgsRight(args, partials, holders, isCurried) {
      var argsIndex = -1,
          argsLength = args.length,
          holdersIndex = -1,
          holdersLength = holders.length,
          rightIndex = -1,
          rightLength = partials.length,
          rangeLength = nativeMax(argsLength - holdersLength, 0),
          result = Array(rangeLength + rightLength),
          isUncurried = !isCurried;

      while (++argsIndex < rangeLength) {
        result[argsIndex] = args[argsIndex];
      }
      var offset = argsIndex;
      while (++rightIndex < rightLength) {
        result[offset + rightIndex] = partials[rightIndex];
      }
      while (++holdersIndex < holdersLength) {
        if (isUncurried || argsIndex < argsLength) {
          result[offset + holders[holdersIndex]] = args[argsIndex++];
        }
      }
      return result;
    }

    /**
     * Copies the values of `source` to `array`.
     *
     * @private
     * @param {Array} source The array to copy values from.
     * @param {Array} [array=[]] The array to copy values to.
     * @returns {Array} Returns `array`.
     */
    function copyArray(source, array) {
      var index = -1,
          length = source.length;

      array || (array = Array(length));
      while (++index < length) {
        array[index] = source[index];
      }
      return array;
    }

    /**
     * Copies properties of `source` to `object`.
     *
     * @private
     * @param {Object} source The object to copy properties from.
     * @param {Array} props The property identifiers to copy.
     * @param {Object} [object={}] The object to copy properties to.
     * @param {Function} [customizer] The function to customize copied values.
     * @returns {Object} Returns `object`.
     */
    function copyObject(source, props, object, customizer) {
      var isNew = !object;
      object || (object = {});

      var index = -1,
          length = props.length;

      while (++index < length) {
        var key = props[index];

        var newValue = customizer
          ? customizer(object[key], source[key], key, object, source)
          : undefined;

        if (newValue === undefined) {
          newValue = source[key];
        }
        if (isNew) {
          baseAssignValue(object, key, newValue);
        } else {
          assignValue(object, key, newValue);
        }
      }
      return object;
    }

    /**
     * Copies own symbols of `source` to `object`.
     *
     * @private
     * @param {Object} source The object to copy symbols from.
     * @param {Object} [object={}] The object to copy symbols to.
     * @returns {Object} Returns `object`.
     */
    function copySymbols(source, object) {
      return copyObject(source, getSymbols(source), object);
    }

    /**
     * Copies own and inherited symbols of `source` to `object`.
     *
     * @private
     * @param {Object} source The object to copy symbols from.
     * @param {Object} [object={}] The object to copy symbols to.
     * @returns {Object} Returns `object`.
     */
    function copySymbolsIn(source, object) {
      return copyObject(source, getSymbolsIn(source), object);
    }

    /**
     * Creates a function like `_.groupBy`.
     *
     * @private
     * @param {Function} setter The function to set accumulator values.
     * @param {Function} [initializer] The accumulator object initializer.
     * @returns {Function} Returns the new aggregator function.
     */
    function createAggregator(setter, initializer) {
      return function(collection, iteratee) {
        var func = isArray(collection) ? arrayAggregator : baseAggregator,
            accumulator = initializer ? initializer() : {};

        return func(collection, setter, getIteratee(iteratee, 2), accumulator);
      };
    }

    /**
     * Creates a function like `_.assign`.
     *
     * @private
     * @param {Function} assigner The function to assign values.
     * @returns {Function} Returns the new assigner function.
     */
    function createAssigner(assigner) {
      return baseRest(function(object, sources) {
        var index = -1,
            length = sources.length,
            customizer = length > 1 ? sources[length - 1] : undefined,
            guard = length > 2 ? sources[2] : undefined;

        customizer = (assigner.length > 3 && typeof customizer == 'function')
          ? (length--, customizer)
          : undefined;

        if (guard && isIterateeCall(sources[0], sources[1], guard)) {
          customizer = length < 3 ? undefined : customizer;
          length = 1;
        }
        object = Object(object);
        while (++index < length) {
          var source = sources[index];
          if (source) {
            assigner(object, source, index, customizer);
          }
        }
        return object;
      });
    }

    /**
     * Creates a `baseEach` or `baseEachRight` function.
     *
     * @private
     * @param {Function} eachFunc The function to iterate over a collection.
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new base function.
     */
    function createBaseEach(eachFunc, fromRight) {
      return function(collection, iteratee) {
        if (collection == null) {
          return collection;
        }
        if (!isArrayLike(collection)) {
          return eachFunc(collection, iteratee);
        }
        var length = collection.length,
            index = fromRight ? length : -1,
            iterable = Object(collection);

        while ((fromRight ? index-- : ++index < length)) {
          if (iteratee(iterable[index], index, iterable) === false) {
            break;
          }
        }
        return collection;
      };
    }

    /**
     * Creates a base function for methods like `_.forIn` and `_.forOwn`.
     *
     * @private
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new base function.
     */
    function createBaseFor(fromRight) {
      return function(object, iteratee, keysFunc) {
        var index = -1,
            iterable = Object(object),
            props = keysFunc(object),
            length = props.length;

        while (length--) {
          var key = props[fromRight ? length : ++index];
          if (iteratee(iterable[key], key, iterable) === false) {
            break;
          }
        }
        return object;
      };
    }

    /**
     * Creates a function that wraps `func` to invoke it with the optional `this`
     * binding of `thisArg`.
     *
     * @private
     * @param {Function} func The function to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {*} [thisArg] The `this` binding of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createBind(func, bitmask, thisArg) {
      var isBind = bitmask & WRAP_BIND_FLAG,
          Ctor = createCtor(func);

      function wrapper() {
        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;
        return fn.apply(isBind ? thisArg : this, arguments);
      }
      return wrapper;
    }

    /**
     * Creates a function like `_.lowerFirst`.
     *
     * @private
     * @param {string} methodName The name of the `String` case method to use.
     * @returns {Function} Returns the new case function.
     */
    function createCaseFirst(methodName) {
      return function(string) {
        string = toString(string);

        var strSymbols = hasUnicode(string)
          ? stringToArray(string)
          : undefined;

        var chr = strSymbols
          ? strSymbols[0]
          : string.charAt(0);

        var trailing = strSymbols
          ? castSlice(strSymbols, 1).join('')
          : string.slice(1);

        return chr[methodName]() + trailing;
      };
    }

    /**
     * Creates a function like `_.camelCase`.
     *
     * @private
     * @param {Function} callback The function to combine each word.
     * @returns {Function} Returns the new compounder function.
     */
    function createCompounder(callback) {
      return function(string) {
        return arrayReduce(words(deburr(string).replace(reApos, '')), callback, '');
      };
    }

    /**
     * Creates a function that produces an instance of `Ctor` regardless of
     * whether it was invoked as part of a `new` expression or by `call` or `apply`.
     *
     * @private
     * @param {Function} Ctor The constructor to wrap.
     * @returns {Function} Returns the new wrapped function.
     */
    function createCtor(Ctor) {
      return function() {
        // Use a `switch` statement to work with class constructors. See
        // http://ecma-international.org/ecma-262/7.0/#sec-ecmascript-function-objects-call-thisargument-argumentslist
        // for more details.
        var args = arguments;
        switch (args.length) {
          case 0: return new Ctor;
          case 1: return new Ctor(args[0]);
          case 2: return new Ctor(args[0], args[1]);
          case 3: return new Ctor(args[0], args[1], args[2]);
          case 4: return new Ctor(args[0], args[1], args[2], args[3]);
          case 5: return new Ctor(args[0], args[1], args[2], args[3], args[4]);
          case 6: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5]);
          case 7: return new Ctor(args[0], args[1], args[2], args[3], args[4], args[5], args[6]);
        }
        var thisBinding = baseCreate(Ctor.prototype),
            result = Ctor.apply(thisBinding, args);

        // Mimic the constructor's `return` behavior.
        // See https://es5.github.io/#x13.2.2 for more details.
        return isObject(result) ? result : thisBinding;
      };
    }

    /**
     * Creates a function that wraps `func` to enable currying.
     *
     * @private
     * @param {Function} func The function to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {number} arity The arity of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createCurry(func, bitmask, arity) {
      var Ctor = createCtor(func);

      function wrapper() {
        var length = arguments.length,
            args = Array(length),
            index = length,
            placeholder = getHolder(wrapper);

        while (index--) {
          args[index] = arguments[index];
        }
        var holders = (length < 3 && args[0] !== placeholder && args[length - 1] !== placeholder)
          ? []
          : replaceHolders(args, placeholder);

        length -= holders.length;
        if (length < arity) {
          return createRecurry(
            func, bitmask, createHybrid, wrapper.placeholder, undefined,
            args, holders, undefined, undefined, arity - length);
        }
        var fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;
        return apply(fn, this, args);
      }
      return wrapper;
    }

    /**
     * Creates a `_.find` or `_.findLast` function.
     *
     * @private
     * @param {Function} findIndexFunc The function to find the collection index.
     * @returns {Function} Returns the new find function.
     */
    function createFind(findIndexFunc) {
      return function(collection, predicate, fromIndex) {
        var iterable = Object(collection);
        if (!isArrayLike(collection)) {
          var iteratee = getIteratee(predicate, 3);
          collection = keys(collection);
          predicate = function(key) { return iteratee(iterable[key], key, iterable); };
        }
        var index = findIndexFunc(collection, predicate, fromIndex);
        return index > -1 ? iterable[iteratee ? collection[index] : index] : undefined;
      };
    }

    /**
     * Creates a `_.flow` or `_.flowRight` function.
     *
     * @private
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new flow function.
     */
    function createFlow(fromRight) {
      return flatRest(function(funcs) {
        var length = funcs.length,
            index = length,
            prereq = LodashWrapper.prototype.thru;

        if (fromRight) {
          funcs.reverse();
        }
        while (index--) {
          var func = funcs[index];
          if (typeof func != 'function') {
            throw new TypeError(FUNC_ERROR_TEXT);
          }
          if (prereq && !wrapper && getFuncName(func) == 'wrapper') {
            var wrapper = new LodashWrapper([], true);
          }
        }
        index = wrapper ? index : length;
        while (++index < length) {
          func = funcs[index];

          var funcName = getFuncName(func),
              data = funcName == 'wrapper' ? getData(func) : undefined;

          if (data && isLaziable(data[0]) &&
                data[1] == (WRAP_ARY_FLAG | WRAP_CURRY_FLAG | WRAP_PARTIAL_FLAG | WRAP_REARG_FLAG) &&
                !data[4].length && data[9] == 1
              ) {
            wrapper = wrapper[getFuncName(data[0])].apply(wrapper, data[3]);
          } else {
            wrapper = (func.length == 1 && isLaziable(func))
              ? wrapper[funcName]()
              : wrapper.thru(func);
          }
        }
        return function() {
          var args = arguments,
              value = args[0];

          if (wrapper && args.length == 1 && isArray(value)) {
            return wrapper.plant(value).value();
          }
          var index = 0,
              result = length ? funcs[index].apply(this, args) : value;

          while (++index < length) {
            result = funcs[index].call(this, result);
          }
          return result;
        };
      });
    }

    /**
     * Creates a function that wraps `func` to invoke it with optional `this`
     * binding of `thisArg`, partial application, and currying.
     *
     * @private
     * @param {Function|string} func The function or method name to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {*} [thisArg] The `this` binding of `func`.
     * @param {Array} [partials] The arguments to prepend to those provided to
     *  the new function.
     * @param {Array} [holders] The `partials` placeholder indexes.
     * @param {Array} [partialsRight] The arguments to append to those provided
     *  to the new function.
     * @param {Array} [holdersRight] The `partialsRight` placeholder indexes.
     * @param {Array} [argPos] The argument positions of the new function.
     * @param {number} [ary] The arity cap of `func`.
     * @param {number} [arity] The arity of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createHybrid(func, bitmask, thisArg, partials, holders, partialsRight, holdersRight, argPos, ary, arity) {
      var isAry = bitmask & WRAP_ARY_FLAG,
          isBind = bitmask & WRAP_BIND_FLAG,
          isBindKey = bitmask & WRAP_BIND_KEY_FLAG,
          isCurried = bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG),
          isFlip = bitmask & WRAP_FLIP_FLAG,
          Ctor = isBindKey ? undefined : createCtor(func);

      function wrapper() {
        var length = arguments.length,
            args = Array(length),
            index = length;

        while (index--) {
          args[index] = arguments[index];
        }
        if (isCurried) {
          var placeholder = getHolder(wrapper),
              holdersCount = countHolders(args, placeholder);
        }
        if (partials) {
          args = composeArgs(args, partials, holders, isCurried);
        }
        if (partialsRight) {
          args = composeArgsRight(args, partialsRight, holdersRight, isCurried);
        }
        length -= holdersCount;
        if (isCurried && length < arity) {
          var newHolders = replaceHolders(args, placeholder);
          return createRecurry(
            func, bitmask, createHybrid, wrapper.placeholder, thisArg,
            args, newHolders, argPos, ary, arity - length
          );
        }
        var thisBinding = isBind ? thisArg : this,
            fn = isBindKey ? thisBinding[func] : func;

        length = args.length;
        if (argPos) {
          args = reorder(args, argPos);
        } else if (isFlip && length > 1) {
          args.reverse();
        }
        if (isAry && ary < length) {
          args.length = ary;
        }
        if (this && this !== root && this instanceof wrapper) {
          fn = Ctor || createCtor(fn);
        }
        return fn.apply(thisBinding, args);
      }
      return wrapper;
    }

    /**
     * Creates a function like `_.invertBy`.
     *
     * @private
     * @param {Function} setter The function to set accumulator values.
     * @param {Function} toIteratee The function to resolve iteratees.
     * @returns {Function} Returns the new inverter function.
     */
    function createInverter(setter, toIteratee) {
      return function(object, iteratee) {
        return baseInverter(object, setter, toIteratee(iteratee), {});
      };
    }

    /**
     * Creates a function that performs a mathematical operation on two values.
     *
     * @private
     * @param {Function} operator The function to perform the operation.
     * @param {number} [defaultValue] The value used for `undefined` arguments.
     * @returns {Function} Returns the new mathematical operation function.
     */
    function createMathOperation(operator, defaultValue) {
      return function(value, other) {
        var result;
        if (value === undefined && other === undefined) {
          return defaultValue;
        }
        if (value !== undefined) {
          result = value;
        }
        if (other !== undefined) {
          if (result === undefined) {
            return other;
          }
          if (typeof value == 'string' || typeof other == 'string') {
            value = baseToString(value);
            other = baseToString(other);
          } else {
            value = baseToNumber(value);
            other = baseToNumber(other);
          }
          result = operator(value, other);
        }
        return result;
      };
    }

    /**
     * Creates a function like `_.over`.
     *
     * @private
     * @param {Function} arrayFunc The function to iterate over iteratees.
     * @returns {Function} Returns the new over function.
     */
    function createOver(arrayFunc) {
      return flatRest(function(iteratees) {
        iteratees = arrayMap(iteratees, baseUnary(getIteratee()));
        return baseRest(function(args) {
          var thisArg = this;
          return arrayFunc(iteratees, function(iteratee) {
            return apply(iteratee, thisArg, args);
          });
        });
      });
    }

    /**
     * Creates the padding for `string` based on `length`. The `chars` string
     * is truncated if the number of characters exceeds `length`.
     *
     * @private
     * @param {number} length The padding length.
     * @param {string} [chars=' '] The string used as padding.
     * @returns {string} Returns the padding for `string`.
     */
    function createPadding(length, chars) {
      chars = chars === undefined ? ' ' : baseToString(chars);

      var charsLength = chars.length;
      if (charsLength < 2) {
        return charsLength ? baseRepeat(chars, length) : chars;
      }
      var result = baseRepeat(chars, nativeCeil(length / stringSize(chars)));
      return hasUnicode(chars)
        ? castSlice(stringToArray(result), 0, length).join('')
        : result.slice(0, length);
    }

    /**
     * Creates a function that wraps `func` to invoke it with the `this` binding
     * of `thisArg` and `partials` prepended to the arguments it receives.
     *
     * @private
     * @param {Function} func The function to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {*} thisArg The `this` binding of `func`.
     * @param {Array} partials The arguments to prepend to those provided to
     *  the new function.
     * @returns {Function} Returns the new wrapped function.
     */
    function createPartial(func, bitmask, thisArg, partials) {
      var isBind = bitmask & WRAP_BIND_FLAG,
          Ctor = createCtor(func);

      function wrapper() {
        var argsIndex = -1,
            argsLength = arguments.length,
            leftIndex = -1,
            leftLength = partials.length,
            args = Array(leftLength + argsLength),
            fn = (this && this !== root && this instanceof wrapper) ? Ctor : func;

        while (++leftIndex < leftLength) {
          args[leftIndex] = partials[leftIndex];
        }
        while (argsLength--) {
          args[leftIndex++] = arguments[++argsIndex];
        }
        return apply(fn, isBind ? thisArg : this, args);
      }
      return wrapper;
    }

    /**
     * Creates a `_.range` or `_.rangeRight` function.
     *
     * @private
     * @param {boolean} [fromRight] Specify iterating from right to left.
     * @returns {Function} Returns the new range function.
     */
    function createRange(fromRight) {
      return function(start, end, step) {
        if (step && typeof step != 'number' && isIterateeCall(start, end, step)) {
          end = step = undefined;
        }
        // Ensure the sign of `-0` is preserved.
        start = toFinite(start);
        if (end === undefined) {
          end = start;
          start = 0;
        } else {
          end = toFinite(end);
        }
        step = step === undefined ? (start < end ? 1 : -1) : toFinite(step);
        return baseRange(start, end, step, fromRight);
      };
    }

    /**
     * Creates a function that performs a relational operation on two values.
     *
     * @private
     * @param {Function} operator The function to perform the operation.
     * @returns {Function} Returns the new relational operation function.
     */
    function createRelationalOperation(operator) {
      return function(value, other) {
        if (!(typeof value == 'string' && typeof other == 'string')) {
          value = toNumber(value);
          other = toNumber(other);
        }
        return operator(value, other);
      };
    }

    /**
     * Creates a function that wraps `func` to continue currying.
     *
     * @private
     * @param {Function} func The function to wrap.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @param {Function} wrapFunc The function to create the `func` wrapper.
     * @param {*} placeholder The placeholder value.
     * @param {*} [thisArg] The `this` binding of `func`.
     * @param {Array} [partials] The arguments to prepend to those provided to
     *  the new function.
     * @param {Array} [holders] The `partials` placeholder indexes.
     * @param {Array} [argPos] The argument positions of the new function.
     * @param {number} [ary] The arity cap of `func`.
     * @param {number} [arity] The arity of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createRecurry(func, bitmask, wrapFunc, placeholder, thisArg, partials, holders, argPos, ary, arity) {
      var isCurry = bitmask & WRAP_CURRY_FLAG,
          newHolders = isCurry ? holders : undefined,
          newHoldersRight = isCurry ? undefined : holders,
          newPartials = isCurry ? partials : undefined,
          newPartialsRight = isCurry ? undefined : partials;

      bitmask |= (isCurry ? WRAP_PARTIAL_FLAG : WRAP_PARTIAL_RIGHT_FLAG);
      bitmask &= ~(isCurry ? WRAP_PARTIAL_RIGHT_FLAG : WRAP_PARTIAL_FLAG);

      if (!(bitmask & WRAP_CURRY_BOUND_FLAG)) {
        bitmask &= ~(WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG);
      }
      var newData = [
        func, bitmask, thisArg, newPartials, newHolders, newPartialsRight,
        newHoldersRight, argPos, ary, arity
      ];

      var result = wrapFunc.apply(undefined, newData);
      if (isLaziable(func)) {
        setData(result, newData);
      }
      result.placeholder = placeholder;
      return setWrapToString(result, func, bitmask);
    }

    /**
     * Creates a function like `_.round`.
     *
     * @private
     * @param {string} methodName The name of the `Math` method to use when rounding.
     * @returns {Function} Returns the new round function.
     */
    function createRound(methodName) {
      var func = Math[methodName];
      return function(number, precision) {
        number = toNumber(number);
        precision = precision == null ? 0 : nativeMin(toInteger(precision), 292);
        if (precision && nativeIsFinite(number)) {
          // Shift with exponential notation to avoid floating-point issues.
          // See [MDN](https://mdn.io/round#Examples) for more details.
          var pair = (toString(number) + 'e').split('e'),
              value = func(pair[0] + 'e' + (+pair[1] + precision));

          pair = (toString(value) + 'e').split('e');
          return +(pair[0] + 'e' + (+pair[1] - precision));
        }
        return func(number);
      };
    }

    /**
     * Creates a set object of `values`.
     *
     * @private
     * @param {Array} values The values to add to the set.
     * @returns {Object} Returns the new set.
     */
    var createSet = !(Set && (1 / setToArray(new Set([,-0]))[1]) == INFINITY) ? noop : function(values) {
      return new Set(values);
    };

    /**
     * Creates a `_.toPairs` or `_.toPairsIn` function.
     *
     * @private
     * @param {Function} keysFunc The function to get the keys of a given object.
     * @returns {Function} Returns the new pairs function.
     */
    function createToPairs(keysFunc) {
      return function(object) {
        var tag = getTag(object);
        if (tag == mapTag) {
          return mapToArray(object);
        }
        if (tag == setTag) {
          return setToPairs(object);
        }
        return baseToPairs(object, keysFunc(object));
      };
    }

    /**
     * Creates a function that either curries or invokes `func` with optional
     * `this` binding and partially applied arguments.
     *
     * @private
     * @param {Function|string} func The function or method name to wrap.
     * @param {number} bitmask The bitmask flags.
     *    1 - `_.bind`
     *    2 - `_.bindKey`
     *    4 - `_.curry` or `_.curryRight` of a bound function
     *    8 - `_.curry`
     *   16 - `_.curryRight`
     *   32 - `_.partial`
     *   64 - `_.partialRight`
     *  128 - `_.rearg`
     *  256 - `_.ary`
     *  512 - `_.flip`
     * @param {*} [thisArg] The `this` binding of `func`.
     * @param {Array} [partials] The arguments to be partially applied.
     * @param {Array} [holders] The `partials` placeholder indexes.
     * @param {Array} [argPos] The argument positions of the new function.
     * @param {number} [ary] The arity cap of `func`.
     * @param {number} [arity] The arity of `func`.
     * @returns {Function} Returns the new wrapped function.
     */
    function createWrap(func, bitmask, thisArg, partials, holders, argPos, ary, arity) {
      var isBindKey = bitmask & WRAP_BIND_KEY_FLAG;
      if (!isBindKey && typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      var length = partials ? partials.length : 0;
      if (!length) {
        bitmask &= ~(WRAP_PARTIAL_FLAG | WRAP_PARTIAL_RIGHT_FLAG);
        partials = holders = undefined;
      }
      ary = ary === undefined ? ary : nativeMax(toInteger(ary), 0);
      arity = arity === undefined ? arity : toInteger(arity);
      length -= holders ? holders.length : 0;

      if (bitmask & WRAP_PARTIAL_RIGHT_FLAG) {
        var partialsRight = partials,
            holdersRight = holders;

        partials = holders = undefined;
      }
      var data = isBindKey ? undefined : getData(func);

      var newData = [
        func, bitmask, thisArg, partials, holders, partialsRight, holdersRight,
        argPos, ary, arity
      ];

      if (data) {
        mergeData(newData, data);
      }
      func = newData[0];
      bitmask = newData[1];
      thisArg = newData[2];
      partials = newData[3];
      holders = newData[4];
      arity = newData[9] = newData[9] === undefined
        ? (isBindKey ? 0 : func.length)
        : nativeMax(newData[9] - length, 0);

      if (!arity && bitmask & (WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG)) {
        bitmask &= ~(WRAP_CURRY_FLAG | WRAP_CURRY_RIGHT_FLAG);
      }
      if (!bitmask || bitmask == WRAP_BIND_FLAG) {
        var result = createBind(func, bitmask, thisArg);
      } else if (bitmask == WRAP_CURRY_FLAG || bitmask == WRAP_CURRY_RIGHT_FLAG) {
        result = createCurry(func, bitmask, arity);
      } else if ((bitmask == WRAP_PARTIAL_FLAG || bitmask == (WRAP_BIND_FLAG | WRAP_PARTIAL_FLAG)) && !holders.length) {
        result = createPartial(func, bitmask, thisArg, partials);
      } else {
        result = createHybrid.apply(undefined, newData);
      }
      var setter = data ? baseSetData : setData;
      return setWrapToString(setter(result, newData), func, bitmask);
    }

    /**
     * Used by `_.defaults` to customize its `_.assignIn` use to assign properties
     * of source objects to the destination object for all destination properties
     * that resolve to `undefined`.
     *
     * @private
     * @param {*} objValue The destination value.
     * @param {*} srcValue The source value.
     * @param {string} key The key of the property to assign.
     * @param {Object} object The parent object of `objValue`.
     * @returns {*} Returns the value to assign.
     */
    function customDefaultsAssignIn(objValue, srcValue, key, object) {
      if (objValue === undefined ||
          (eq(objValue, objectProto[key]) && !hasOwnProperty.call(object, key))) {
        return srcValue;
      }
      return objValue;
    }

    /**
     * Used by `_.defaultsDeep` to customize its `_.merge` use to merge source
     * objects into destination objects that are passed thru.
     *
     * @private
     * @param {*} objValue The destination value.
     * @param {*} srcValue The source value.
     * @param {string} key The key of the property to merge.
     * @param {Object} object The parent object of `objValue`.
     * @param {Object} source The parent object of `srcValue`.
     * @param {Object} [stack] Tracks traversed source values and their merged
     *  counterparts.
     * @returns {*} Returns the value to assign.
     */
    function customDefaultsMerge(objValue, srcValue, key, object, source, stack) {
      if (isObject(objValue) && isObject(srcValue)) {
        // Recursively merge objects and arrays (susceptible to call stack limits).
        stack.set(srcValue, objValue);
        baseMerge(objValue, srcValue, undefined, customDefaultsMerge, stack);
        stack['delete'](srcValue);
      }
      return objValue;
    }

    /**
     * Used by `_.omit` to customize its `_.cloneDeep` use to only clone plain
     * objects.
     *
     * @private
     * @param {*} value The value to inspect.
     * @param {string} key The key of the property to inspect.
     * @returns {*} Returns the uncloned value or `undefined` to defer cloning to `_.cloneDeep`.
     */
    function customOmitClone(value) {
      return isPlainObject(value) ? undefined : value;
    }

    /**
     * A specialized version of `baseIsEqualDeep` for arrays with support for
     * partial deep comparisons.
     *
     * @private
     * @param {Array} array The array to compare.
     * @param {Array} other The other array to compare.
     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
     * @param {Function} customizer The function to customize comparisons.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Object} stack Tracks traversed `array` and `other` objects.
     * @returns {boolean} Returns `true` if the arrays are equivalent, else `false`.
     */
    function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
          arrLength = array.length,
          othLength = other.length;

      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
        return false;
      }
      // Check that cyclic values are equal.
      var arrStacked = stack.get(array);
      var othStacked = stack.get(other);
      if (arrStacked && othStacked) {
        return arrStacked == other && othStacked == array;
      }
      var index = -1,
          result = true,
          seen = (bitmask & COMPARE_UNORDERED_FLAG) ? new SetCache : undefined;

      stack.set(array, other);
      stack.set(other, array);

      // Ignore non-index properties.
      while (++index < arrLength) {
        var arrValue = array[index],
            othValue = other[index];

        if (customizer) {
          var compared = isPartial
            ? customizer(othValue, arrValue, index, other, array, stack)
            : customizer(arrValue, othValue, index, array, other, stack);
        }
        if (compared !== undefined) {
          if (compared) {
            continue;
          }
          result = false;
          break;
        }
        // Recursively compare arrays (susceptible to call stack limits).
        if (seen) {
          if (!arraySome(other, function(othValue, othIndex) {
                if (!cacheHas(seen, othIndex) &&
                    (arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
                  return seen.push(othIndex);
                }
              })) {
            result = false;
            break;
          }
        } else if (!(
              arrValue === othValue ||
                equalFunc(arrValue, othValue, bitmask, customizer, stack)
            )) {
          result = false;
          break;
        }
      }
      stack['delete'](array);
      stack['delete'](other);
      return result;
    }

    /**
     * A specialized version of `baseIsEqualDeep` for comparing objects of
     * the same `toStringTag`.
     *
     * **Note:** This function only supports comparing values with tags of
     * `Boolean`, `Date`, `Error`, `Number`, `RegExp`, or `String`.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {string} tag The `toStringTag` of the objects to compare.
     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
     * @param {Function} customizer The function to customize comparisons.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Object} stack Tracks traversed `object` and `other` objects.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
      switch (tag) {
        case dataViewTag:
          if ((object.byteLength != other.byteLength) ||
              (object.byteOffset != other.byteOffset)) {
            return false;
          }
          object = object.buffer;
          other = other.buffer;

        case arrayBufferTag:
          if ((object.byteLength != other.byteLength) ||
              !equalFunc(new Uint8Array(object), new Uint8Array(other))) {
            return false;
          }
          return true;

        case boolTag:
        case dateTag:
        case numberTag:
          // Coerce booleans to `1` or `0` and dates to milliseconds.
          // Invalid dates are coerced to `NaN`.
          return eq(+object, +other);

        case errorTag:
          return object.name == other.name && object.message == other.message;

        case regexpTag:
        case stringTag:
          // Coerce regexes to strings and treat strings, primitives and objects,
          // as equal. See http://www.ecma-international.org/ecma-262/7.0/#sec-regexp.prototype.tostring
          // for more details.
          return object == (other + '');

        case mapTag:
          var convert = mapToArray;

        case setTag:
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG;
          convert || (convert = setToArray);

          if (object.size != other.size && !isPartial) {
            return false;
          }
          // Assume cyclic values are equal.
          var stacked = stack.get(object);
          if (stacked) {
            return stacked == other;
          }
          bitmask |= COMPARE_UNORDERED_FLAG;

          // Recursively compare objects (susceptible to call stack limits).
          stack.set(object, other);
          var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
          stack['delete'](object);
          return result;

        case symbolTag:
          if (symbolValueOf) {
            return symbolValueOf.call(object) == symbolValueOf.call(other);
          }
      }
      return false;
    }

    /**
     * A specialized version of `baseIsEqualDeep` for objects with support for
     * partial deep comparisons.
     *
     * @private
     * @param {Object} object The object to compare.
     * @param {Object} other The other object to compare.
     * @param {number} bitmask The bitmask flags. See `baseIsEqual` for more details.
     * @param {Function} customizer The function to customize comparisons.
     * @param {Function} equalFunc The function to determine equivalents of values.
     * @param {Object} stack Tracks traversed `object` and `other` objects.
     * @returns {boolean} Returns `true` if the objects are equivalent, else `false`.
     */
    function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG,
          objProps = getAllKeys(object),
          objLength = objProps.length,
          othProps = getAllKeys(other),
          othLength = othProps.length;

      if (objLength != othLength && !isPartial) {
        return false;
      }
      var index = objLength;
      while (index--) {
        var key = objProps[index];
        if (!(isPartial ? key in other : hasOwnProperty.call(other, key))) {
          return false;
        }
      }
      // Check that cyclic values are equal.
      var objStacked = stack.get(object);
      var othStacked = stack.get(other);
      if (objStacked && othStacked) {
        return objStacked == other && othStacked == object;
      }
      var result = true;
      stack.set(object, other);
      stack.set(other, object);

      var skipCtor = isPartial;
      while (++index < objLength) {
        key = objProps[index];
        var objValue = object[key],
            othValue = other[key];

        if (customizer) {
          var compared = isPartial
            ? customizer(othValue, objValue, key, other, object, stack)
            : customizer(objValue, othValue, key, object, other, stack);
        }
        // Recursively compare objects (susceptible to call stack limits).
        if (!(compared === undefined
              ? (objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack))
              : compared
            )) {
          result = false;
          break;
        }
        skipCtor || (skipCtor = key == 'constructor');
      }
      if (result && !skipCtor) {
        var objCtor = object.constructor,
            othCtor = other.constructor;

        // Non `Object` object instances with different constructors are not equal.
        if (objCtor != othCtor &&
            ('constructor' in object && 'constructor' in other) &&
            !(typeof objCtor == 'function' && objCtor instanceof objCtor &&
              typeof othCtor == 'function' && othCtor instanceof othCtor)) {
          result = false;
        }
      }
      stack['delete'](object);
      stack['delete'](other);
      return result;
    }

    /**
     * A specialized version of `baseRest` which flattens the rest array.
     *
     * @private
     * @param {Function} func The function to apply a rest parameter to.
     * @returns {Function} Returns the new function.
     */
    function flatRest(func) {
      return setToString(overRest(func, undefined, flatten), func + '');
    }

    /**
     * Creates an array of own enumerable property names and symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names and symbols.
     */
    function getAllKeys(object) {
      return baseGetAllKeys(object, keys, getSymbols);
    }

    /**
     * Creates an array of own and inherited enumerable property names and
     * symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names and symbols.
     */
    function getAllKeysIn(object) {
      return baseGetAllKeys(object, keysIn, getSymbolsIn);
    }

    /**
     * Gets metadata for `func`.
     *
     * @private
     * @param {Function} func The function to query.
     * @returns {*} Returns the metadata for `func`.
     */
    var getData = !metaMap ? noop : function(func) {
      return metaMap.get(func);
    };

    /**
     * Gets the name of `func`.
     *
     * @private
     * @param {Function} func The function to query.
     * @returns {string} Returns the function name.
     */
    function getFuncName(func) {
      var result = (func.name + ''),
          array = realNames[result],
          length = hasOwnProperty.call(realNames, result) ? array.length : 0;

      while (length--) {
        var data = array[length],
            otherFunc = data.func;
        if (otherFunc == null || otherFunc == func) {
          return data.name;
        }
      }
      return result;
    }

    /**
     * Gets the argument placeholder value for `func`.
     *
     * @private
     * @param {Function} func The function to inspect.
     * @returns {*} Returns the placeholder value.
     */
    function getHolder(func) {
      var object = hasOwnProperty.call(lodash, 'placeholder') ? lodash : func;
      return object.placeholder;
    }

    /**
     * Gets the appropriate "iteratee" function. If `_.iteratee` is customized,
     * this function returns the custom method, otherwise it returns `baseIteratee`.
     * If arguments are provided, the chosen function is invoked with them and
     * its result is returned.
     *
     * @private
     * @param {*} [value] The value to convert to an iteratee.
     * @param {number} [arity] The arity of the created iteratee.
     * @returns {Function} Returns the chosen function or its result.
     */
    function getIteratee() {
      var result = lodash.iteratee || iteratee;
      result = result === iteratee ? baseIteratee : result;
      return arguments.length ? result(arguments[0], arguments[1]) : result;
    }

    /**
     * Gets the data for `map`.
     *
     * @private
     * @param {Object} map The map to query.
     * @param {string} key The reference key.
     * @returns {*} Returns the map data.
     */
    function getMapData(map, key) {
      var data = map.__data__;
      return isKeyable(key)
        ? data[typeof key == 'string' ? 'string' : 'hash']
        : data.map;
    }

    /**
     * Gets the property names, values, and compare flags of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the match data of `object`.
     */
    function getMatchData(object) {
      var result = keys(object),
          length = result.length;

      while (length--) {
        var key = result[length],
            value = object[key];

        result[length] = [key, value, isStrictComparable(value)];
      }
      return result;
    }

    /**
     * Gets the native function at `key` of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {string} key The key of the method to get.
     * @returns {*} Returns the function if it's native, else `undefined`.
     */
    function getNative(object, key) {
      var value = getValue(object, key);
      return baseIsNative(value) ? value : undefined;
    }

    /**
     * A specialized version of `baseGetTag` which ignores `Symbol.toStringTag` values.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the raw `toStringTag`.
     */
    function getRawTag(value) {
      var isOwn = hasOwnProperty.call(value, symToStringTag),
          tag = value[symToStringTag];

      try {
        value[symToStringTag] = undefined;
        var unmasked = true;
      } catch (e) {}

      var result = nativeObjectToString.call(value);
      if (unmasked) {
        if (isOwn) {
          value[symToStringTag] = tag;
        } else {
          delete value[symToStringTag];
        }
      }
      return result;
    }

    /**
     * Creates an array of the own enumerable symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of symbols.
     */
    var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
      if (object == null) {
        return [];
      }
      object = Object(object);
      return arrayFilter(nativeGetSymbols(object), function(symbol) {
        return propertyIsEnumerable.call(object, symbol);
      });
    };

    /**
     * Creates an array of the own and inherited enumerable symbols of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of symbols.
     */
    var getSymbolsIn = !nativeGetSymbols ? stubArray : function(object) {
      var result = [];
      while (object) {
        arrayPush(result, getSymbols(object));
        object = getPrototype(object);
      }
      return result;
    };

    /**
     * Gets the `toStringTag` of `value`.
     *
     * @private
     * @param {*} value The value to query.
     * @returns {string} Returns the `toStringTag`.
     */
    var getTag = baseGetTag;

    // Fallback for data views, maps, sets, and weak maps in IE 11 and promises in Node.js < 6.
    if ((DataView && getTag(new DataView(new ArrayBuffer(1))) != dataViewTag) ||
        (Map && getTag(new Map) != mapTag) ||
        (Promise && getTag(Promise.resolve()) != promiseTag) ||
        (Set && getTag(new Set) != setTag) ||
        (WeakMap && getTag(new WeakMap) != weakMapTag)) {
      getTag = function(value) {
        var result = baseGetTag(value),
            Ctor = result == objectTag ? value.constructor : undefined,
            ctorString = Ctor ? toSource(Ctor) : '';

        if (ctorString) {
          switch (ctorString) {
            case dataViewCtorString: return dataViewTag;
            case mapCtorString: return mapTag;
            case promiseCtorString: return promiseTag;
            case setCtorString: return setTag;
            case weakMapCtorString: return weakMapTag;
          }
        }
        return result;
      };
    }

    /**
     * Gets the view, applying any `transforms` to the `start` and `end` positions.
     *
     * @private
     * @param {number} start The start of the view.
     * @param {number} end The end of the view.
     * @param {Array} transforms The transformations to apply to the view.
     * @returns {Object} Returns an object containing the `start` and `end`
     *  positions of the view.
     */
    function getView(start, end, transforms) {
      var index = -1,
          length = transforms.length;

      while (++index < length) {
        var data = transforms[index],
            size = data.size;

        switch (data.type) {
          case 'drop':      start += size; break;
          case 'dropRight': end -= size; break;
          case 'take':      end = nativeMin(end, start + size); break;
          case 'takeRight': start = nativeMax(start, end - size); break;
        }
      }
      return { 'start': start, 'end': end };
    }

    /**
     * Extracts wrapper details from the `source` body comment.
     *
     * @private
     * @param {string} source The source to inspect.
     * @returns {Array} Returns the wrapper details.
     */
    function getWrapDetails(source) {
      var match = source.match(reWrapDetails);
      return match ? match[1].split(reSplitDetails) : [];
    }

    /**
     * Checks if `path` exists on `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @param {Function} hasFunc The function to check properties.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     */
    function hasPath(object, path, hasFunc) {
      path = castPath(path, object);

      var index = -1,
          length = path.length,
          result = false;

      while (++index < length) {
        var key = toKey(path[index]);
        if (!(result = object != null && hasFunc(object, key))) {
          break;
        }
        object = object[key];
      }
      if (result || ++index != length) {
        return result;
      }
      length = object == null ? 0 : object.length;
      return !!length && isLength(length) && isIndex(key, length) &&
        (isArray(object) || isArguments(object));
    }

    /**
     * Initializes an array clone.
     *
     * @private
     * @param {Array} array The array to clone.
     * @returns {Array} Returns the initialized clone.
     */
    function initCloneArray(array) {
      var length = array.length,
          result = new array.constructor(length);

      // Add properties assigned by `RegExp#exec`.
      if (length && typeof array[0] == 'string' && hasOwnProperty.call(array, 'index')) {
        result.index = array.index;
        result.input = array.input;
      }
      return result;
    }

    /**
     * Initializes an object clone.
     *
     * @private
     * @param {Object} object The object to clone.
     * @returns {Object} Returns the initialized clone.
     */
    function initCloneObject(object) {
      return (typeof object.constructor == 'function' && !isPrototype(object))
        ? baseCreate(getPrototype(object))
        : {};
    }

    /**
     * Initializes an object clone based on its `toStringTag`.
     *
     * **Note:** This function only supports cloning values with tags of
     * `Boolean`, `Date`, `Error`, `Map`, `Number`, `RegExp`, `Set`, or `String`.
     *
     * @private
     * @param {Object} object The object to clone.
     * @param {string} tag The `toStringTag` of the object to clone.
     * @param {boolean} [isDeep] Specify a deep clone.
     * @returns {Object} Returns the initialized clone.
     */
    function initCloneByTag(object, tag, isDeep) {
      var Ctor = object.constructor;
      switch (tag) {
        case arrayBufferTag:
          return cloneArrayBuffer(object);

        case boolTag:
        case dateTag:
          return new Ctor(+object);

        case dataViewTag:
          return cloneDataView(object, isDeep);

        case float32Tag: case float64Tag:
        case int8Tag: case int16Tag: case int32Tag:
        case uint8Tag: case uint8ClampedTag: case uint16Tag: case uint32Tag:
          return cloneTypedArray(object, isDeep);

        case mapTag:
          return new Ctor;

        case numberTag:
        case stringTag:
          return new Ctor(object);

        case regexpTag:
          return cloneRegExp(object);

        case setTag:
          return new Ctor;

        case symbolTag:
          return cloneSymbol(object);
      }
    }

    /**
     * Inserts wrapper `details` in a comment at the top of the `source` body.
     *
     * @private
     * @param {string} source The source to modify.
     * @returns {Array} details The details to insert.
     * @returns {string} Returns the modified source.
     */
    function insertWrapDetails(source, details) {
      var length = details.length;
      if (!length) {
        return source;
      }
      var lastIndex = length - 1;
      details[lastIndex] = (length > 1 ? '& ' : '') + details[lastIndex];
      details = details.join(length > 2 ? ', ' : ' ');
      return source.replace(reWrapComment, '{\n/* [wrapped with ' + details + '] */\n');
    }

    /**
     * Checks if `value` is a flattenable `arguments` object or array.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is flattenable, else `false`.
     */
    function isFlattenable(value) {
      return isArray(value) || isArguments(value) ||
        !!(spreadableSymbol && value && value[spreadableSymbol]);
    }

    /**
     * Checks if `value` is a valid array-like index.
     *
     * @private
     * @param {*} value The value to check.
     * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
     * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
     */
    function isIndex(value, length) {
      var type = typeof value;
      length = length == null ? MAX_SAFE_INTEGER : length;

      return !!length &&
        (type == 'number' ||
          (type != 'symbol' && reIsUint.test(value))) &&
            (value > -1 && value % 1 == 0 && value < length);
    }

    /**
     * Checks if the given arguments are from an iteratee call.
     *
     * @private
     * @param {*} value The potential iteratee value argument.
     * @param {*} index The potential iteratee index or key argument.
     * @param {*} object The potential iteratee object argument.
     * @returns {boolean} Returns `true` if the arguments are from an iteratee call,
     *  else `false`.
     */
    function isIterateeCall(value, index, object) {
      if (!isObject(object)) {
        return false;
      }
      var type = typeof index;
      if (type == 'number'
            ? (isArrayLike(object) && isIndex(index, object.length))
            : (type == 'string' && index in object)
          ) {
        return eq(object[index], value);
      }
      return false;
    }

    /**
     * Checks if `value` is a property name and not a property path.
     *
     * @private
     * @param {*} value The value to check.
     * @param {Object} [object] The object to query keys on.
     * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
     */
    function isKey(value, object) {
      if (isArray(value)) {
        return false;
      }
      var type = typeof value;
      if (type == 'number' || type == 'symbol' || type == 'boolean' ||
          value == null || isSymbol(value)) {
        return true;
      }
      return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
        (object != null && value in Object(object));
    }

    /**
     * Checks if `value` is suitable for use as unique object key.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
     */
    function isKeyable(value) {
      var type = typeof value;
      return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
        ? (value !== '__proto__')
        : (value === null);
    }

    /**
     * Checks if `func` has a lazy counterpart.
     *
     * @private
     * @param {Function} func The function to check.
     * @returns {boolean} Returns `true` if `func` has a lazy counterpart,
     *  else `false`.
     */
    function isLaziable(func) {
      var funcName = getFuncName(func),
          other = lodash[funcName];

      if (typeof other != 'function' || !(funcName in LazyWrapper.prototype)) {
        return false;
      }
      if (func === other) {
        return true;
      }
      var data = getData(other);
      return !!data && func === data[0];
    }

    /**
     * Checks if `func` has its source masked.
     *
     * @private
     * @param {Function} func The function to check.
     * @returns {boolean} Returns `true` if `func` is masked, else `false`.
     */
    function isMasked(func) {
      return !!maskSrcKey && (maskSrcKey in func);
    }

    /**
     * Checks if `func` is capable of being masked.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `func` is maskable, else `false`.
     */
    var isMaskable = coreJsData ? isFunction : stubFalse;

    /**
     * Checks if `value` is likely a prototype object.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a prototype, else `false`.
     */
    function isPrototype(value) {
      var Ctor = value && value.constructor,
          proto = (typeof Ctor == 'function' && Ctor.prototype) || objectProto;

      return value === proto;
    }

    /**
     * Checks if `value` is suitable for strict equality comparisons, i.e. `===`.
     *
     * @private
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` if suitable for strict
     *  equality comparisons, else `false`.
     */
    function isStrictComparable(value) {
      return value === value && !isObject(value);
    }

    /**
     * A specialized version of `matchesProperty` for source values suitable
     * for strict equality comparisons, i.e. `===`.
     *
     * @private
     * @param {string} key The key of the property to get.
     * @param {*} srcValue The value to match.
     * @returns {Function} Returns the new spec function.
     */
    function matchesStrictComparable(key, srcValue) {
      return function(object) {
        if (object == null) {
          return false;
        }
        return object[key] === srcValue &&
          (srcValue !== undefined || (key in Object(object)));
      };
    }

    /**
     * A specialized version of `_.memoize` which clears the memoized function's
     * cache when it exceeds `MAX_MEMOIZE_SIZE`.
     *
     * @private
     * @param {Function} func The function to have its output memoized.
     * @returns {Function} Returns the new memoized function.
     */
    function memoizeCapped(func) {
      var result = memoize(func, function(key) {
        if (cache.size === MAX_MEMOIZE_SIZE) {
          cache.clear();
        }
        return key;
      });

      var cache = result.cache;
      return result;
    }

    /**
     * Merges the function metadata of `source` into `data`.
     *
     * Merging metadata reduces the number of wrappers used to invoke a function.
     * This is possible because methods like `_.bind`, `_.curry`, and `_.partial`
     * may be applied regardless of execution order. Methods like `_.ary` and
     * `_.rearg` modify function arguments, making the order in which they are
     * executed important, preventing the merging of metadata. However, we make
     * an exception for a safe combined case where curried functions have `_.ary`
     * and or `_.rearg` applied.
     *
     * @private
     * @param {Array} data The destination metadata.
     * @param {Array} source The source metadata.
     * @returns {Array} Returns `data`.
     */
    function mergeData(data, source) {
      var bitmask = data[1],
          srcBitmask = source[1],
          newBitmask = bitmask | srcBitmask,
          isCommon = newBitmask < (WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG | WRAP_ARY_FLAG);

      var isCombo =
        ((srcBitmask == WRAP_ARY_FLAG) && (bitmask == WRAP_CURRY_FLAG)) ||
        ((srcBitmask == WRAP_ARY_FLAG) && (bitmask == WRAP_REARG_FLAG) && (data[7].length <= source[8])) ||
        ((srcBitmask == (WRAP_ARY_FLAG | WRAP_REARG_FLAG)) && (source[7].length <= source[8]) && (bitmask == WRAP_CURRY_FLAG));

      // Exit early if metadata can't be merged.
      if (!(isCommon || isCombo)) {
        return data;
      }
      // Use source `thisArg` if available.
      if (srcBitmask & WRAP_BIND_FLAG) {
        data[2] = source[2];
        // Set when currying a bound function.
        newBitmask |= bitmask & WRAP_BIND_FLAG ? 0 : WRAP_CURRY_BOUND_FLAG;
      }
      // Compose partial arguments.
      var value = source[3];
      if (value) {
        var partials = data[3];
        data[3] = partials ? composeArgs(partials, value, source[4]) : value;
        data[4] = partials ? replaceHolders(data[3], PLACEHOLDER) : source[4];
      }
      // Compose partial right arguments.
      value = source[5];
      if (value) {
        partials = data[5];
        data[5] = partials ? composeArgsRight(partials, value, source[6]) : value;
        data[6] = partials ? replaceHolders(data[5], PLACEHOLDER) : source[6];
      }
      // Use source `argPos` if available.
      value = source[7];
      if (value) {
        data[7] = value;
      }
      // Use source `ary` if it's smaller.
      if (srcBitmask & WRAP_ARY_FLAG) {
        data[8] = data[8] == null ? source[8] : nativeMin(data[8], source[8]);
      }
      // Use source `arity` if one is not provided.
      if (data[9] == null) {
        data[9] = source[9];
      }
      // Use source `func` and merge bitmasks.
      data[0] = source[0];
      data[1] = newBitmask;

      return data;
    }

    /**
     * This function is like
     * [`Object.keys`](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
     * except that it includes inherited enumerable properties.
     *
     * @private
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     */
    function nativeKeysIn(object) {
      var result = [];
      if (object != null) {
        for (var key in Object(object)) {
          result.push(key);
        }
      }
      return result;
    }

    /**
     * Converts `value` to a string using `Object.prototype.toString`.
     *
     * @private
     * @param {*} value The value to convert.
     * @returns {string} Returns the converted string.
     */
    function objectToString(value) {
      return nativeObjectToString.call(value);
    }

    /**
     * A specialized version of `baseRest` which transforms the rest array.
     *
     * @private
     * @param {Function} func The function to apply a rest parameter to.
     * @param {number} [start=func.length-1] The start position of the rest parameter.
     * @param {Function} transform The rest array transform.
     * @returns {Function} Returns the new function.
     */
    function overRest(func, start, transform) {
      start = nativeMax(start === undefined ? (func.length - 1) : start, 0);
      return function() {
        var args = arguments,
            index = -1,
            length = nativeMax(args.length - start, 0),
            array = Array(length);

        while (++index < length) {
          array[index] = args[start + index];
        }
        index = -1;
        var otherArgs = Array(start + 1);
        while (++index < start) {
          otherArgs[index] = args[index];
        }
        otherArgs[start] = transform(array);
        return apply(func, this, otherArgs);
      };
    }

    /**
     * Gets the parent value at `path` of `object`.
     *
     * @private
     * @param {Object} object The object to query.
     * @param {Array} path The path to get the parent value of.
     * @returns {*} Returns the parent value.
     */
    function parent(object, path) {
      return path.length < 2 ? object : baseGet(object, baseSlice(path, 0, -1));
    }

    /**
     * Reorder `array` according to the specified indexes where the element at
     * the first index is assigned as the first element, the element at
     * the second index is assigned as the second element, and so on.
     *
     * @private
     * @param {Array} array The array to reorder.
     * @param {Array} indexes The arranged array indexes.
     * @returns {Array} Returns `array`.
     */
    function reorder(array, indexes) {
      var arrLength = array.length,
          length = nativeMin(indexes.length, arrLength),
          oldArray = copyArray(array);

      while (length--) {
        var index = indexes[length];
        array[length] = isIndex(index, arrLength) ? oldArray[index] : undefined;
      }
      return array;
    }

    /**
     * Gets the value at `key`, unless `key` is "__proto__" or "constructor".
     *
     * @private
     * @param {Object} object The object to query.
     * @param {string} key The key of the property to get.
     * @returns {*} Returns the property value.
     */
    function safeGet(object, key) {
      if (key === 'constructor' && typeof object[key] === 'function') {
        return;
      }

      if (key == '__proto__') {
        return;
      }

      return object[key];
    }

    /**
     * Sets metadata for `func`.
     *
     * **Note:** If this function becomes hot, i.e. is invoked a lot in a short
     * period of time, it will trip its breaker and transition to an identity
     * function to avoid garbage collection pauses in V8. See
     * [V8 issue 2070](https://bugs.chromium.org/p/v8/issues/detail?id=2070)
     * for more details.
     *
     * @private
     * @param {Function} func The function to associate metadata with.
     * @param {*} data The metadata.
     * @returns {Function} Returns `func`.
     */
    var setData = shortOut(baseSetData);

    /**
     * A simple wrapper around the global [`setTimeout`](https://mdn.io/setTimeout).
     *
     * @private
     * @param {Function} func The function to delay.
     * @param {number} wait The number of milliseconds to delay invocation.
     * @returns {number|Object} Returns the timer id or timeout object.
     */
    var setTimeout = ctxSetTimeout || function(func, wait) {
      return root.setTimeout(func, wait);
    };

    /**
     * Sets the `toString` method of `func` to return `string`.
     *
     * @private
     * @param {Function} func The function to modify.
     * @param {Function} string The `toString` result.
     * @returns {Function} Returns `func`.
     */
    var setToString = shortOut(baseSetToString);

    /**
     * Sets the `toString` method of `wrapper` to mimic the source of `reference`
     * with wrapper details in a comment at the top of the source body.
     *
     * @private
     * @param {Function} wrapper The function to modify.
     * @param {Function} reference The reference function.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @returns {Function} Returns `wrapper`.
     */
    function setWrapToString(wrapper, reference, bitmask) {
      var source = (reference + '');
      return setToString(wrapper, insertWrapDetails(source, updateWrapDetails(getWrapDetails(source), bitmask)));
    }

    /**
     * Creates a function that'll short out and invoke `identity` instead
     * of `func` when it's called `HOT_COUNT` or more times in `HOT_SPAN`
     * milliseconds.
     *
     * @private
     * @param {Function} func The function to restrict.
     * @returns {Function} Returns the new shortable function.
     */
    function shortOut(func) {
      var count = 0,
          lastCalled = 0;

      return function() {
        var stamp = nativeNow(),
            remaining = HOT_SPAN - (stamp - lastCalled);

        lastCalled = stamp;
        if (remaining > 0) {
          if (++count >= HOT_COUNT) {
            return arguments[0];
          }
        } else {
          count = 0;
        }
        return func.apply(undefined, arguments);
      };
    }

    /**
     * A specialized version of `_.shuffle` which mutates and sets the size of `array`.
     *
     * @private
     * @param {Array} array The array to shuffle.
     * @param {number} [size=array.length] The size of `array`.
     * @returns {Array} Returns `array`.
     */
    function shuffleSelf(array, size) {
      var index = -1,
          length = array.length,
          lastIndex = length - 1;

      size = size === undefined ? length : size;
      while (++index < size) {
        var rand = baseRandom(index, lastIndex),
            value = array[rand];

        array[rand] = array[index];
        array[index] = value;
      }
      array.length = size;
      return array;
    }

    /**
     * Converts `string` to a property path array.
     *
     * @private
     * @param {string} string The string to convert.
     * @returns {Array} Returns the property path array.
     */
    var stringToPath = memoizeCapped(function(string) {
      var result = [];
      if (string.charCodeAt(0) === 46 /* . */) {
        result.push('');
      }
      string.replace(rePropName, function(match, number, quote, subString) {
        result.push(quote ? subString.replace(reEscapeChar, '$1') : (number || match));
      });
      return result;
    });

    /**
     * Converts `value` to a string key if it's not a string or symbol.
     *
     * @private
     * @param {*} value The value to inspect.
     * @returns {string|symbol} Returns the key.
     */
    function toKey(value) {
      if (typeof value == 'string' || isSymbol(value)) {
        return value;
      }
      var result = (value + '');
      return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
    }

    /**
     * Converts `func` to its source code.
     *
     * @private
     * @param {Function} func The function to convert.
     * @returns {string} Returns the source code.
     */
    function toSource(func) {
      if (func != null) {
        try {
          return funcToString.call(func);
        } catch (e) {}
        try {
          return (func + '');
        } catch (e) {}
      }
      return '';
    }

    /**
     * Updates wrapper `details` based on `bitmask` flags.
     *
     * @private
     * @returns {Array} details The details to modify.
     * @param {number} bitmask The bitmask flags. See `createWrap` for more details.
     * @returns {Array} Returns `details`.
     */
    function updateWrapDetails(details, bitmask) {
      arrayEach(wrapFlags, function(pair) {
        var value = '_.' + pair[0];
        if ((bitmask & pair[1]) && !arrayIncludes(details, value)) {
          details.push(value);
        }
      });
      return details.sort();
    }

    /**
     * Creates a clone of `wrapper`.
     *
     * @private
     * @param {Object} wrapper The wrapper to clone.
     * @returns {Object} Returns the cloned wrapper.
     */
    function wrapperClone(wrapper) {
      if (wrapper instanceof LazyWrapper) {
        return wrapper.clone();
      }
      var result = new LodashWrapper(wrapper.__wrapped__, wrapper.__chain__);
      result.__actions__ = copyArray(wrapper.__actions__);
      result.__index__  = wrapper.__index__;
      result.__values__ = wrapper.__values__;
      return result;
    }

    /*------------------------------------------------------------------------*/

    /**
     * Creates an array of elements split into groups the length of `size`.
     * If `array` can't be split evenly, the final chunk will be the remaining
     * elements.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to process.
     * @param {number} [size=1] The length of each chunk
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the new array of chunks.
     * @example
     *
     * _.chunk(['a', 'b', 'c', 'd'], 2);
     * // => [['a', 'b'], ['c', 'd']]
     *
     * _.chunk(['a', 'b', 'c', 'd'], 3);
     * // => [['a', 'b', 'c'], ['d']]
     */
    function chunk(array, size, guard) {
      if ((guard ? isIterateeCall(array, size, guard) : size === undefined)) {
        size = 1;
      } else {
        size = nativeMax(toInteger(size), 0);
      }
      var length = array == null ? 0 : array.length;
      if (!length || size < 1) {
        return [];
      }
      var index = 0,
          resIndex = 0,
          result = Array(nativeCeil(length / size));

      while (index < length) {
        result[resIndex++] = baseSlice(array, index, (index += size));
      }
      return result;
    }

    /**
     * Creates an array with all falsey values removed. The values `false`, `null`,
     * `0`, `""`, `undefined`, and `NaN` are falsey.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to compact.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * _.compact([0, 1, false, 2, '', 3]);
     * // => [1, 2, 3]
     */
    function compact(array) {
      var index = -1,
          length = array == null ? 0 : array.length,
          resIndex = 0,
          result = [];

      while (++index < length) {
        var value = array[index];
        if (value) {
          result[resIndex++] = value;
        }
      }
      return result;
    }

    /**
     * Creates a new array concatenating `array` with any additional arrays
     * and/or values.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to concatenate.
     * @param {...*} [values] The values to concatenate.
     * @returns {Array} Returns the new concatenated array.
     * @example
     *
     * var array = [1];
     * var other = _.concat(array, 2, [3], [[4]]);
     *
     * console.log(other);
     * // => [1, 2, 3, [4]]
     *
     * console.log(array);
     * // => [1]
     */
    function concat() {
      var length = arguments.length;
      if (!length) {
        return [];
      }
      var args = Array(length - 1),
          array = arguments[0],
          index = length;

      while (index--) {
        args[index - 1] = arguments[index];
      }
      return arrayPush(isArray(array) ? copyArray(array) : [array], baseFlatten(args, 1));
    }

    /**
     * Creates an array of `array` values not included in the other given arrays
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons. The order and references of result values are
     * determined by the first array.
     *
     * **Note:** Unlike `_.pullAll`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {...Array} [values] The values to exclude.
     * @returns {Array} Returns the new array of filtered values.
     * @see _.without, _.xor
     * @example
     *
     * _.difference([2, 1], [2, 3]);
     * // => [1]
     */
    var difference = baseRest(function(array, values) {
      return isArrayLikeObject(array)
        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true))
        : [];
    });

    /**
     * This method is like `_.difference` except that it accepts `iteratee` which
     * is invoked for each element of `array` and `values` to generate the criterion
     * by which they're compared. The order and references of result values are
     * determined by the first array. The iteratee is invoked with one argument:
     * (value).
     *
     * **Note:** Unlike `_.pullAllBy`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {...Array} [values] The values to exclude.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * _.differenceBy([2.1, 1.2], [2.3, 3.4], Math.floor);
     * // => [1.2]
     *
     * // The `_.property` iteratee shorthand.
     * _.differenceBy([{ 'x': 2 }, { 'x': 1 }], [{ 'x': 1 }], 'x');
     * // => [{ 'x': 2 }]
     */
    var differenceBy = baseRest(function(array, values) {
      var iteratee = last(values);
      if (isArrayLikeObject(iteratee)) {
        iteratee = undefined;
      }
      return isArrayLikeObject(array)
        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), getIteratee(iteratee, 2))
        : [];
    });

    /**
     * This method is like `_.difference` except that it accepts `comparator`
     * which is invoked to compare elements of `array` to `values`. The order and
     * references of result values are determined by the first array. The comparator
     * is invoked with two arguments: (arrVal, othVal).
     *
     * **Note:** Unlike `_.pullAllWith`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {...Array} [values] The values to exclude.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
     *
     * _.differenceWith(objects, [{ 'x': 1, 'y': 2 }], _.isEqual);
     * // => [{ 'x': 2, 'y': 1 }]
     */
    var differenceWith = baseRest(function(array, values) {
      var comparator = last(values);
      if (isArrayLikeObject(comparator)) {
        comparator = undefined;
      }
      return isArrayLikeObject(array)
        ? baseDifference(array, baseFlatten(values, 1, isArrayLikeObject, true), undefined, comparator)
        : [];
    });

    /**
     * Creates a slice of `array` with `n` elements dropped from the beginning.
     *
     * @static
     * @memberOf _
     * @since 0.5.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=1] The number of elements to drop.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.drop([1, 2, 3]);
     * // => [2, 3]
     *
     * _.drop([1, 2, 3], 2);
     * // => [3]
     *
     * _.drop([1, 2, 3], 5);
     * // => []
     *
     * _.drop([1, 2, 3], 0);
     * // => [1, 2, 3]
     */
    function drop(array, n, guard) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      n = (guard || n === undefined) ? 1 : toInteger(n);
      return baseSlice(array, n < 0 ? 0 : n, length);
    }

    /**
     * Creates a slice of `array` with `n` elements dropped from the end.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=1] The number of elements to drop.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.dropRight([1, 2, 3]);
     * // => [1, 2]
     *
     * _.dropRight([1, 2, 3], 2);
     * // => [1]
     *
     * _.dropRight([1, 2, 3], 5);
     * // => []
     *
     * _.dropRight([1, 2, 3], 0);
     * // => [1, 2, 3]
     */
    function dropRight(array, n, guard) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      n = (guard || n === undefined) ? 1 : toInteger(n);
      n = length - n;
      return baseSlice(array, 0, n < 0 ? 0 : n);
    }

    /**
     * Creates a slice of `array` excluding elements dropped from the end.
     * Elements are dropped until `predicate` returns falsey. The predicate is
     * invoked with three arguments: (value, index, array).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': true },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': false }
     * ];
     *
     * _.dropRightWhile(users, function(o) { return !o.active; });
     * // => objects for ['barney']
     *
     * // The `_.matches` iteratee shorthand.
     * _.dropRightWhile(users, { 'user': 'pebbles', 'active': false });
     * // => objects for ['barney', 'fred']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.dropRightWhile(users, ['active', false]);
     * // => objects for ['barney']
     *
     * // The `_.property` iteratee shorthand.
     * _.dropRightWhile(users, 'active');
     * // => objects for ['barney', 'fred', 'pebbles']
     */
    function dropRightWhile(array, predicate) {
      return (array && array.length)
        ? baseWhile(array, getIteratee(predicate, 3), true, true)
        : [];
    }

    /**
     * Creates a slice of `array` excluding elements dropped from the beginning.
     * Elements are dropped until `predicate` returns falsey. The predicate is
     * invoked with three arguments: (value, index, array).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': false },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': true }
     * ];
     *
     * _.dropWhile(users, function(o) { return !o.active; });
     * // => objects for ['pebbles']
     *
     * // The `_.matches` iteratee shorthand.
     * _.dropWhile(users, { 'user': 'barney', 'active': false });
     * // => objects for ['fred', 'pebbles']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.dropWhile(users, ['active', false]);
     * // => objects for ['pebbles']
     *
     * // The `_.property` iteratee shorthand.
     * _.dropWhile(users, 'active');
     * // => objects for ['barney', 'fred', 'pebbles']
     */
    function dropWhile(array, predicate) {
      return (array && array.length)
        ? baseWhile(array, getIteratee(predicate, 3), true)
        : [];
    }

    /**
     * Fills elements of `array` with `value` from `start` up to, but not
     * including, `end`.
     *
     * **Note:** This method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 3.2.0
     * @category Array
     * @param {Array} array The array to fill.
     * @param {*} value The value to fill `array` with.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = [1, 2, 3];
     *
     * _.fill(array, 'a');
     * console.log(array);
     * // => ['a', 'a', 'a']
     *
     * _.fill(Array(3), 2);
     * // => [2, 2, 2]
     *
     * _.fill([4, 6, 8, 10], '*', 1, 3);
     * // => [4, '*', '*', 10]
     */
    function fill(array, value, start, end) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      if (start && typeof start != 'number' && isIterateeCall(array, value, start)) {
        start = 0;
        end = length;
      }
      return baseFill(array, value, start, end);
    }

    /**
     * This method is like `_.find` except that it returns the index of the first
     * element `predicate` returns truthy for instead of the element itself.
     *
     * @static
     * @memberOf _
     * @since 1.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param {number} [fromIndex=0] The index to search from.
     * @returns {number} Returns the index of the found element, else `-1`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': false },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': true }
     * ];
     *
     * _.findIndex(users, function(o) { return o.user == 'barney'; });
     * // => 0
     *
     * // The `_.matches` iteratee shorthand.
     * _.findIndex(users, { 'user': 'fred', 'active': false });
     * // => 1
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.findIndex(users, ['active', false]);
     * // => 0
     *
     * // The `_.property` iteratee shorthand.
     * _.findIndex(users, 'active');
     * // => 2
     */
    function findIndex(array, predicate, fromIndex) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return -1;
      }
      var index = fromIndex == null ? 0 : toInteger(fromIndex);
      if (index < 0) {
        index = nativeMax(length + index, 0);
      }
      return baseFindIndex(array, getIteratee(predicate, 3), index);
    }

    /**
     * This method is like `_.findIndex` except that it iterates over elements
     * of `collection` from right to left.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param {number} [fromIndex=array.length-1] The index to search from.
     * @returns {number} Returns the index of the found element, else `-1`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': true },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': false }
     * ];
     *
     * _.findLastIndex(users, function(o) { return o.user == 'pebbles'; });
     * // => 2
     *
     * // The `_.matches` iteratee shorthand.
     * _.findLastIndex(users, { 'user': 'barney', 'active': true });
     * // => 0
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.findLastIndex(users, ['active', false]);
     * // => 2
     *
     * // The `_.property` iteratee shorthand.
     * _.findLastIndex(users, 'active');
     * // => 0
     */
    function findLastIndex(array, predicate, fromIndex) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return -1;
      }
      var index = length - 1;
      if (fromIndex !== undefined) {
        index = toInteger(fromIndex);
        index = fromIndex < 0
          ? nativeMax(length + index, 0)
          : nativeMin(index, length - 1);
      }
      return baseFindIndex(array, getIteratee(predicate, 3), index, true);
    }

    /**
     * Flattens `array` a single level deep.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to flatten.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * _.flatten([1, [2, [3, [4]], 5]]);
     * // => [1, 2, [3, [4]], 5]
     */
    function flatten(array) {
      var length = array == null ? 0 : array.length;
      return length ? baseFlatten(array, 1) : [];
    }

    /**
     * Recursively flattens `array`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to flatten.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * _.flattenDeep([1, [2, [3, [4]], 5]]);
     * // => [1, 2, 3, 4, 5]
     */
    function flattenDeep(array) {
      var length = array == null ? 0 : array.length;
      return length ? baseFlatten(array, INFINITY) : [];
    }

    /**
     * Recursively flatten `array` up to `depth` times.
     *
     * @static
     * @memberOf _
     * @since 4.4.0
     * @category Array
     * @param {Array} array The array to flatten.
     * @param {number} [depth=1] The maximum recursion depth.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * var array = [1, [2, [3, [4]], 5]];
     *
     * _.flattenDepth(array, 1);
     * // => [1, 2, [3, [4]], 5]
     *
     * _.flattenDepth(array, 2);
     * // => [1, 2, 3, [4], 5]
     */
    function flattenDepth(array, depth) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      depth = depth === undefined ? 1 : toInteger(depth);
      return baseFlatten(array, depth);
    }

    /**
     * The inverse of `_.toPairs`; this method returns an object composed
     * from key-value `pairs`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} pairs The key-value pairs.
     * @returns {Object} Returns the new object.
     * @example
     *
     * _.fromPairs([['a', 1], ['b', 2]]);
     * // => { 'a': 1, 'b': 2 }
     */
    function fromPairs(pairs) {
      var index = -1,
          length = pairs == null ? 0 : pairs.length,
          result = {};

      while (++index < length) {
        var pair = pairs[index];
        result[pair[0]] = pair[1];
      }
      return result;
    }

    /**
     * Gets the first element of `array`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @alias first
     * @category Array
     * @param {Array} array The array to query.
     * @returns {*} Returns the first element of `array`.
     * @example
     *
     * _.head([1, 2, 3]);
     * // => 1
     *
     * _.head([]);
     * // => undefined
     */
    function head(array) {
      return (array && array.length) ? array[0] : undefined;
    }

    /**
     * Gets the index at which the first occurrence of `value` is found in `array`
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons. If `fromIndex` is negative, it's used as the
     * offset from the end of `array`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {*} value The value to search for.
     * @param {number} [fromIndex=0] The index to search from.
     * @returns {number} Returns the index of the matched value, else `-1`.
     * @example
     *
     * _.indexOf([1, 2, 1, 2], 2);
     * // => 1
     *
     * // Search from the `fromIndex`.
     * _.indexOf([1, 2, 1, 2], 2, 2);
     * // => 3
     */
    function indexOf(array, value, fromIndex) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return -1;
      }
      var index = fromIndex == null ? 0 : toInteger(fromIndex);
      if (index < 0) {
        index = nativeMax(length + index, 0);
      }
      return baseIndexOf(array, value, index);
    }

    /**
     * Gets all but the last element of `array`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to query.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.initial([1, 2, 3]);
     * // => [1, 2]
     */
    function initial(array) {
      var length = array == null ? 0 : array.length;
      return length ? baseSlice(array, 0, -1) : [];
    }

    /**
     * Creates an array of unique values that are included in all given arrays
     * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons. The order and references of result values are
     * determined by the first array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @returns {Array} Returns the new array of intersecting values.
     * @example
     *
     * _.intersection([2, 1], [2, 3]);
     * // => [2]
     */
    var intersection = baseRest(function(arrays) {
      var mapped = arrayMap(arrays, castArrayLikeObject);
      return (mapped.length && mapped[0] === arrays[0])
        ? baseIntersection(mapped)
        : [];
    });

    /**
     * This method is like `_.intersection` except that it accepts `iteratee`
     * which is invoked for each element of each `arrays` to generate the criterion
     * by which they're compared. The order and references of result values are
     * determined by the first array. The iteratee is invoked with one argument:
     * (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new array of intersecting values.
     * @example
     *
     * _.intersectionBy([2.1, 1.2], [2.3, 3.4], Math.floor);
     * // => [2.1]
     *
     * // The `_.property` iteratee shorthand.
     * _.intersectionBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
     * // => [{ 'x': 1 }]
     */
    var intersectionBy = baseRest(function(arrays) {
      var iteratee = last(arrays),
          mapped = arrayMap(arrays, castArrayLikeObject);

      if (iteratee === last(mapped)) {
        iteratee = undefined;
      } else {
        mapped.pop();
      }
      return (mapped.length && mapped[0] === arrays[0])
        ? baseIntersection(mapped, getIteratee(iteratee, 2))
        : [];
    });

    /**
     * This method is like `_.intersection` except that it accepts `comparator`
     * which is invoked to compare elements of `arrays`. The order and references
     * of result values are determined by the first array. The comparator is
     * invoked with two arguments: (arrVal, othVal).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of intersecting values.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
     *
     * _.intersectionWith(objects, others, _.isEqual);
     * // => [{ 'x': 1, 'y': 2 }]
     */
    var intersectionWith = baseRest(function(arrays) {
      var comparator = last(arrays),
          mapped = arrayMap(arrays, castArrayLikeObject);

      comparator = typeof comparator == 'function' ? comparator : undefined;
      if (comparator) {
        mapped.pop();
      }
      return (mapped.length && mapped[0] === arrays[0])
        ? baseIntersection(mapped, undefined, comparator)
        : [];
    });

    /**
     * Converts all elements in `array` into a string separated by `separator`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to convert.
     * @param {string} [separator=','] The element separator.
     * @returns {string} Returns the joined string.
     * @example
     *
     * _.join(['a', 'b', 'c'], '~');
     * // => 'a~b~c'
     */
    function join(array, separator) {
      return array == null ? '' : nativeJoin.call(array, separator);
    }

    /**
     * Gets the last element of `array`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to query.
     * @returns {*} Returns the last element of `array`.
     * @example
     *
     * _.last([1, 2, 3]);
     * // => 3
     */
    function last(array) {
      var length = array == null ? 0 : array.length;
      return length ? array[length - 1] : undefined;
    }

    /**
     * This method is like `_.indexOf` except that it iterates over elements of
     * `array` from right to left.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {*} value The value to search for.
     * @param {number} [fromIndex=array.length-1] The index to search from.
     * @returns {number} Returns the index of the matched value, else `-1`.
     * @example
     *
     * _.lastIndexOf([1, 2, 1, 2], 2);
     * // => 3
     *
     * // Search from the `fromIndex`.
     * _.lastIndexOf([1, 2, 1, 2], 2, 2);
     * // => 1
     */
    function lastIndexOf(array, value, fromIndex) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return -1;
      }
      var index = length;
      if (fromIndex !== undefined) {
        index = toInteger(fromIndex);
        index = index < 0 ? nativeMax(length + index, 0) : nativeMin(index, length - 1);
      }
      return value === value
        ? strictLastIndexOf(array, value, index)
        : baseFindIndex(array, baseIsNaN, index, true);
    }

    /**
     * Gets the element at index `n` of `array`. If `n` is negative, the nth
     * element from the end is returned.
     *
     * @static
     * @memberOf _
     * @since 4.11.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=0] The index of the element to return.
     * @returns {*} Returns the nth element of `array`.
     * @example
     *
     * var array = ['a', 'b', 'c', 'd'];
     *
     * _.nth(array, 1);
     * // => 'b'
     *
     * _.nth(array, -2);
     * // => 'c';
     */
    function nth(array, n) {
      return (array && array.length) ? baseNth(array, toInteger(n)) : undefined;
    }

    /**
     * Removes all given values from `array` using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * **Note:** Unlike `_.without`, this method mutates `array`. Use `_.remove`
     * to remove elements from an array by predicate.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {...*} [values] The values to remove.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = ['a', 'b', 'c', 'a', 'b', 'c'];
     *
     * _.pull(array, 'a', 'c');
     * console.log(array);
     * // => ['b', 'b']
     */
    var pull = baseRest(pullAll);

    /**
     * This method is like `_.pull` except that it accepts an array of values to remove.
     *
     * **Note:** Unlike `_.difference`, this method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {Array} values The values to remove.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = ['a', 'b', 'c', 'a', 'b', 'c'];
     *
     * _.pullAll(array, ['a', 'c']);
     * console.log(array);
     * // => ['b', 'b']
     */
    function pullAll(array, values) {
      return (array && array.length && values && values.length)
        ? basePullAll(array, values)
        : array;
    }

    /**
     * This method is like `_.pullAll` except that it accepts `iteratee` which is
     * invoked for each element of `array` and `values` to generate the criterion
     * by which they're compared. The iteratee is invoked with one argument: (value).
     *
     * **Note:** Unlike `_.differenceBy`, this method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {Array} values The values to remove.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = [{ 'x': 1 }, { 'x': 2 }, { 'x': 3 }, { 'x': 1 }];
     *
     * _.pullAllBy(array, [{ 'x': 1 }, { 'x': 3 }], 'x');
     * console.log(array);
     * // => [{ 'x': 2 }]
     */
    function pullAllBy(array, values, iteratee) {
      return (array && array.length && values && values.length)
        ? basePullAll(array, values, getIteratee(iteratee, 2))
        : array;
    }

    /**
     * This method is like `_.pullAll` except that it accepts `comparator` which
     * is invoked to compare elements of `array` to `values`. The comparator is
     * invoked with two arguments: (arrVal, othVal).
     *
     * **Note:** Unlike `_.differenceWith`, this method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 4.6.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {Array} values The values to remove.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = [{ 'x': 1, 'y': 2 }, { 'x': 3, 'y': 4 }, { 'x': 5, 'y': 6 }];
     *
     * _.pullAllWith(array, [{ 'x': 3, 'y': 4 }], _.isEqual);
     * console.log(array);
     * // => [{ 'x': 1, 'y': 2 }, { 'x': 5, 'y': 6 }]
     */
    function pullAllWith(array, values, comparator) {
      return (array && array.length && values && values.length)
        ? basePullAll(array, values, undefined, comparator)
        : array;
    }

    /**
     * Removes elements from `array` corresponding to `indexes` and returns an
     * array of removed elements.
     *
     * **Note:** Unlike `_.at`, this method mutates `array`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {...(number|number[])} [indexes] The indexes of elements to remove.
     * @returns {Array} Returns the new array of removed elements.
     * @example
     *
     * var array = ['a', 'b', 'c', 'd'];
     * var pulled = _.pullAt(array, [1, 3]);
     *
     * console.log(array);
     * // => ['a', 'c']
     *
     * console.log(pulled);
     * // => ['b', 'd']
     */
    var pullAt = flatRest(function(array, indexes) {
      var length = array == null ? 0 : array.length,
          result = baseAt(array, indexes);

      basePullAt(array, arrayMap(indexes, function(index) {
        return isIndex(index, length) ? +index : index;
      }).sort(compareAscending));

      return result;
    });

    /**
     * Removes all elements from `array` that `predicate` returns truthy for
     * and returns an array of the removed elements. The predicate is invoked
     * with three arguments: (value, index, array).
     *
     * **Note:** Unlike `_.filter`, this method mutates `array`. Use `_.pull`
     * to pull elements from an array by value.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new array of removed elements.
     * @example
     *
     * var array = [1, 2, 3, 4];
     * var evens = _.remove(array, function(n) {
     *   return n % 2 == 0;
     * });
     *
     * console.log(array);
     * // => [1, 3]
     *
     * console.log(evens);
     * // => [2, 4]
     */
    function remove(array, predicate) {
      var result = [];
      if (!(array && array.length)) {
        return result;
      }
      var index = -1,
          indexes = [],
          length = array.length;

      predicate = getIteratee(predicate, 3);
      while (++index < length) {
        var value = array[index];
        if (predicate(value, index, array)) {
          result.push(value);
          indexes.push(index);
        }
      }
      basePullAt(array, indexes);
      return result;
    }

    /**
     * Reverses `array` so that the first element becomes the last, the second
     * element becomes the second to last, and so on.
     *
     * **Note:** This method mutates `array` and is based on
     * [`Array#reverse`](https://mdn.io/Array/reverse).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to modify.
     * @returns {Array} Returns `array`.
     * @example
     *
     * var array = [1, 2, 3];
     *
     * _.reverse(array);
     * // => [3, 2, 1]
     *
     * console.log(array);
     * // => [3, 2, 1]
     */
    function reverse(array) {
      return array == null ? array : nativeReverse.call(array);
    }

    /**
     * Creates a slice of `array` from `start` up to, but not including, `end`.
     *
     * **Note:** This method is used instead of
     * [`Array#slice`](https://mdn.io/Array/slice) to ensure dense arrays are
     * returned.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to slice.
     * @param {number} [start=0] The start position.
     * @param {number} [end=array.length] The end position.
     * @returns {Array} Returns the slice of `array`.
     */
    function slice(array, start, end) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      if (end && typeof end != 'number' && isIterateeCall(array, start, end)) {
        start = 0;
        end = length;
      }
      else {
        start = start == null ? 0 : toInteger(start);
        end = end === undefined ? length : toInteger(end);
      }
      return baseSlice(array, start, end);
    }

    /**
     * Uses a binary search to determine the lowest index at which `value`
     * should be inserted into `array` in order to maintain its sort order.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     * @example
     *
     * _.sortedIndex([30, 50], 40);
     * // => 1
     */
    function sortedIndex(array, value) {
      return baseSortedIndex(array, value);
    }

    /**
     * This method is like `_.sortedIndex` except that it accepts `iteratee`
     * which is invoked for `value` and each element of `array` to compute their
     * sort ranking. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     * @example
     *
     * var objects = [{ 'x': 4 }, { 'x': 5 }];
     *
     * _.sortedIndexBy(objects, { 'x': 4 }, function(o) { return o.x; });
     * // => 0
     *
     * // The `_.property` iteratee shorthand.
     * _.sortedIndexBy(objects, { 'x': 4 }, 'x');
     * // => 0
     */
    function sortedIndexBy(array, value, iteratee) {
      return baseSortedIndexBy(array, value, getIteratee(iteratee, 2));
    }

    /**
     * This method is like `_.indexOf` except that it performs a binary
     * search on a sorted `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {*} value The value to search for.
     * @returns {number} Returns the index of the matched value, else `-1`.
     * @example
     *
     * _.sortedIndexOf([4, 5, 5, 5, 6], 5);
     * // => 1
     */
    function sortedIndexOf(array, value) {
      var length = array == null ? 0 : array.length;
      if (length) {
        var index = baseSortedIndex(array, value);
        if (index < length && eq(array[index], value)) {
          return index;
        }
      }
      return -1;
    }

    /**
     * This method is like `_.sortedIndex` except that it returns the highest
     * index at which `value` should be inserted into `array` in order to
     * maintain its sort order.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     * @example
     *
     * _.sortedLastIndex([4, 5, 5, 5, 6], 5);
     * // => 4
     */
    function sortedLastIndex(array, value) {
      return baseSortedIndex(array, value, true);
    }

    /**
     * This method is like `_.sortedLastIndex` except that it accepts `iteratee`
     * which is invoked for `value` and each element of `array` to compute their
     * sort ranking. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The sorted array to inspect.
     * @param {*} value The value to evaluate.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {number} Returns the index at which `value` should be inserted
     *  into `array`.
     * @example
     *
     * var objects = [{ 'x': 4 }, { 'x': 5 }];
     *
     * _.sortedLastIndexBy(objects, { 'x': 4 }, function(o) { return o.x; });
     * // => 1
     *
     * // The `_.property` iteratee shorthand.
     * _.sortedLastIndexBy(objects, { 'x': 4 }, 'x');
     * // => 1
     */
    function sortedLastIndexBy(array, value, iteratee) {
      return baseSortedIndexBy(array, value, getIteratee(iteratee, 2), true);
    }

    /**
     * This method is like `_.lastIndexOf` except that it performs a binary
     * search on a sorted `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {*} value The value to search for.
     * @returns {number} Returns the index of the matched value, else `-1`.
     * @example
     *
     * _.sortedLastIndexOf([4, 5, 5, 5, 6], 5);
     * // => 3
     */
    function sortedLastIndexOf(array, value) {
      var length = array == null ? 0 : array.length;
      if (length) {
        var index = baseSortedIndex(array, value, true) - 1;
        if (eq(array[index], value)) {
          return index;
        }
      }
      return -1;
    }

    /**
     * This method is like `_.uniq` except that it's designed and optimized
     * for sorted arrays.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * _.sortedUniq([1, 1, 2]);
     * // => [1, 2]
     */
    function sortedUniq(array) {
      return (array && array.length)
        ? baseSortedUniq(array)
        : [];
    }

    /**
     * This method is like `_.uniqBy` except that it's designed and optimized
     * for sorted arrays.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [iteratee] The iteratee invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * _.sortedUniqBy([1.1, 1.2, 2.3, 2.4], Math.floor);
     * // => [1.1, 2.3]
     */
    function sortedUniqBy(array, iteratee) {
      return (array && array.length)
        ? baseSortedUniq(array, getIteratee(iteratee, 2))
        : [];
    }

    /**
     * Gets all but the first element of `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.tail([1, 2, 3]);
     * // => [2, 3]
     */
    function tail(array) {
      var length = array == null ? 0 : array.length;
      return length ? baseSlice(array, 1, length) : [];
    }

    /**
     * Creates a slice of `array` with `n` elements taken from the beginning.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=1] The number of elements to take.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.take([1, 2, 3]);
     * // => [1]
     *
     * _.take([1, 2, 3], 2);
     * // => [1, 2]
     *
     * _.take([1, 2, 3], 5);
     * // => [1, 2, 3]
     *
     * _.take([1, 2, 3], 0);
     * // => []
     */
    function take(array, n, guard) {
      if (!(array && array.length)) {
        return [];
      }
      n = (guard || n === undefined) ? 1 : toInteger(n);
      return baseSlice(array, 0, n < 0 ? 0 : n);
    }

    /**
     * Creates a slice of `array` with `n` elements taken from the end.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {number} [n=1] The number of elements to take.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * _.takeRight([1, 2, 3]);
     * // => [3]
     *
     * _.takeRight([1, 2, 3], 2);
     * // => [2, 3]
     *
     * _.takeRight([1, 2, 3], 5);
     * // => [1, 2, 3]
     *
     * _.takeRight([1, 2, 3], 0);
     * // => []
     */
    function takeRight(array, n, guard) {
      var length = array == null ? 0 : array.length;
      if (!length) {
        return [];
      }
      n = (guard || n === undefined) ? 1 : toInteger(n);
      n = length - n;
      return baseSlice(array, n < 0 ? 0 : n, length);
    }

    /**
     * Creates a slice of `array` with elements taken from the end. Elements are
     * taken until `predicate` returns falsey. The predicate is invoked with
     * three arguments: (value, index, array).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': true },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': false }
     * ];
     *
     * _.takeRightWhile(users, function(o) { return !o.active; });
     * // => objects for ['fred', 'pebbles']
     *
     * // The `_.matches` iteratee shorthand.
     * _.takeRightWhile(users, { 'user': 'pebbles', 'active': false });
     * // => objects for ['pebbles']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.takeRightWhile(users, ['active', false]);
     * // => objects for ['fred', 'pebbles']
     *
     * // The `_.property` iteratee shorthand.
     * _.takeRightWhile(users, 'active');
     * // => []
     */
    function takeRightWhile(array, predicate) {
      return (array && array.length)
        ? baseWhile(array, getIteratee(predicate, 3), false, true)
        : [];
    }

    /**
     * Creates a slice of `array` with elements taken from the beginning. Elements
     * are taken until `predicate` returns falsey. The predicate is invoked with
     * three arguments: (value, index, array).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Array
     * @param {Array} array The array to query.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the slice of `array`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'active': false },
     *   { 'user': 'fred',    'active': false },
     *   { 'user': 'pebbles', 'active': true }
     * ];
     *
     * _.takeWhile(users, function(o) { return !o.active; });
     * // => objects for ['barney', 'fred']
     *
     * // The `_.matches` iteratee shorthand.
     * _.takeWhile(users, { 'user': 'barney', 'active': false });
     * // => objects for ['barney']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.takeWhile(users, ['active', false]);
     * // => objects for ['barney', 'fred']
     *
     * // The `_.property` iteratee shorthand.
     * _.takeWhile(users, 'active');
     * // => []
     */
    function takeWhile(array, predicate) {
      return (array && array.length)
        ? baseWhile(array, getIteratee(predicate, 3))
        : [];
    }

    /**
     * Creates an array of unique values, in order, from all given arrays using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @returns {Array} Returns the new array of combined values.
     * @example
     *
     * _.union([2], [1, 2]);
     * // => [2, 1]
     */
    var union = baseRest(function(arrays) {
      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true));
    });

    /**
     * This method is like `_.union` except that it accepts `iteratee` which is
     * invoked for each element of each `arrays` to generate the criterion by
     * which uniqueness is computed. Result values are chosen from the first
     * array in which the value occurs. The iteratee is invoked with one argument:
     * (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new array of combined values.
     * @example
     *
     * _.unionBy([2.1], [1.2, 2.3], Math.floor);
     * // => [2.1, 1.2]
     *
     * // The `_.property` iteratee shorthand.
     * _.unionBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
     * // => [{ 'x': 1 }, { 'x': 2 }]
     */
    var unionBy = baseRest(function(arrays) {
      var iteratee = last(arrays);
      if (isArrayLikeObject(iteratee)) {
        iteratee = undefined;
      }
      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), getIteratee(iteratee, 2));
    });

    /**
     * This method is like `_.union` except that it accepts `comparator` which
     * is invoked to compare elements of `arrays`. Result values are chosen from
     * the first array in which the value occurs. The comparator is invoked
     * with two arguments: (arrVal, othVal).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of combined values.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
     *
     * _.unionWith(objects, others, _.isEqual);
     * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]
     */
    var unionWith = baseRest(function(arrays) {
      var comparator = last(arrays);
      comparator = typeof comparator == 'function' ? comparator : undefined;
      return baseUniq(baseFlatten(arrays, 1, isArrayLikeObject, true), undefined, comparator);
    });

    /**
     * Creates a duplicate-free version of an array, using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons, in which only the first occurrence of each element
     * is kept. The order of result values is determined by the order they occur
     * in the array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * _.uniq([2, 1, 2]);
     * // => [2, 1]
     */
    function uniq(array) {
      return (array && array.length) ? baseUniq(array) : [];
    }

    /**
     * This method is like `_.uniq` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the criterion by which
     * uniqueness is computed. The order of result values is determined by the
     * order they occur in the array. The iteratee is invoked with one argument:
     * (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * _.uniqBy([2.1, 1.2, 2.3], Math.floor);
     * // => [2.1, 1.2]
     *
     * // The `_.property` iteratee shorthand.
     * _.uniqBy([{ 'x': 1 }, { 'x': 2 }, { 'x': 1 }], 'x');
     * // => [{ 'x': 1 }, { 'x': 2 }]
     */
    function uniqBy(array, iteratee) {
      return (array && array.length) ? baseUniq(array, getIteratee(iteratee, 2)) : [];
    }

    /**
     * This method is like `_.uniq` except that it accepts `comparator` which
     * is invoked to compare elements of `array`. The order of result values is
     * determined by the order they occur in the array.The comparator is invoked
     * with two arguments: (arrVal, othVal).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new duplicate free array.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }, { 'x': 1, 'y': 2 }];
     *
     * _.uniqWith(objects, _.isEqual);
     * // => [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }]
     */
    function uniqWith(array, comparator) {
      comparator = typeof comparator == 'function' ? comparator : undefined;
      return (array && array.length) ? baseUniq(array, undefined, comparator) : [];
    }

    /**
     * This method is like `_.zip` except that it accepts an array of grouped
     * elements and creates an array regrouping the elements to their pre-zip
     * configuration.
     *
     * @static
     * @memberOf _
     * @since 1.2.0
     * @category Array
     * @param {Array} array The array of grouped elements to process.
     * @returns {Array} Returns the new array of regrouped elements.
     * @example
     *
     * var zipped = _.zip(['a', 'b'], [1, 2], [true, false]);
     * // => [['a', 1, true], ['b', 2, false]]
     *
     * _.unzip(zipped);
     * // => [['a', 'b'], [1, 2], [true, false]]
     */
    function unzip(array) {
      if (!(array && array.length)) {
        return [];
      }
      var length = 0;
      array = arrayFilter(array, function(group) {
        if (isArrayLikeObject(group)) {
          length = nativeMax(group.length, length);
          return true;
        }
      });
      return baseTimes(length, function(index) {
        return arrayMap(array, baseProperty(index));
      });
    }

    /**
     * This method is like `_.unzip` except that it accepts `iteratee` to specify
     * how regrouped values should be combined. The iteratee is invoked with the
     * elements of each group: (...group).
     *
     * @static
     * @memberOf _
     * @since 3.8.0
     * @category Array
     * @param {Array} array The array of grouped elements to process.
     * @param {Function} [iteratee=_.identity] The function to combine
     *  regrouped values.
     * @returns {Array} Returns the new array of regrouped elements.
     * @example
     *
     * var zipped = _.zip([1, 2], [10, 20], [100, 200]);
     * // => [[1, 10, 100], [2, 20, 200]]
     *
     * _.unzipWith(zipped, _.add);
     * // => [3, 30, 300]
     */
    function unzipWith(array, iteratee) {
      if (!(array && array.length)) {
        return [];
      }
      var result = unzip(array);
      if (iteratee == null) {
        return result;
      }
      return arrayMap(result, function(group) {
        return apply(iteratee, undefined, group);
      });
    }

    /**
     * Creates an array excluding all given values using
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * for equality comparisons.
     *
     * **Note:** Unlike `_.pull`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {Array} array The array to inspect.
     * @param {...*} [values] The values to exclude.
     * @returns {Array} Returns the new array of filtered values.
     * @see _.difference, _.xor
     * @example
     *
     * _.without([2, 1, 2, 3], 1, 2);
     * // => [3]
     */
    var without = baseRest(function(array, values) {
      return isArrayLikeObject(array)
        ? baseDifference(array, values)
        : [];
    });

    /**
     * Creates an array of unique values that is the
     * [symmetric difference](https://en.wikipedia.org/wiki/Symmetric_difference)
     * of the given arrays. The order of result values is determined by the order
     * they occur in the arrays.
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @returns {Array} Returns the new array of filtered values.
     * @see _.difference, _.without
     * @example
     *
     * _.xor([2, 1], [2, 3]);
     * // => [1, 3]
     */
    var xor = baseRest(function(arrays) {
      return baseXor(arrayFilter(arrays, isArrayLikeObject));
    });

    /**
     * This method is like `_.xor` except that it accepts `iteratee` which is
     * invoked for each element of each `arrays` to generate the criterion by
     * which by which they're compared. The order of result values is determined
     * by the order they occur in the arrays. The iteratee is invoked with one
     * argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * _.xorBy([2.1, 1.2], [2.3, 3.4], Math.floor);
     * // => [1.2, 3.4]
     *
     * // The `_.property` iteratee shorthand.
     * _.xorBy([{ 'x': 1 }], [{ 'x': 2 }, { 'x': 1 }], 'x');
     * // => [{ 'x': 2 }]
     */
    var xorBy = baseRest(function(arrays) {
      var iteratee = last(arrays);
      if (isArrayLikeObject(iteratee)) {
        iteratee = undefined;
      }
      return baseXor(arrayFilter(arrays, isArrayLikeObject), getIteratee(iteratee, 2));
    });

    /**
     * This method is like `_.xor` except that it accepts `comparator` which is
     * invoked to compare elements of `arrays`. The order of result values is
     * determined by the order they occur in the arrays. The comparator is invoked
     * with two arguments: (arrVal, othVal).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Array
     * @param {...Array} [arrays] The arrays to inspect.
     * @param {Function} [comparator] The comparator invoked per element.
     * @returns {Array} Returns the new array of filtered values.
     * @example
     *
     * var objects = [{ 'x': 1, 'y': 2 }, { 'x': 2, 'y': 1 }];
     * var others = [{ 'x': 1, 'y': 1 }, { 'x': 1, 'y': 2 }];
     *
     * _.xorWith(objects, others, _.isEqual);
     * // => [{ 'x': 2, 'y': 1 }, { 'x': 1, 'y': 1 }]
     */
    var xorWith = baseRest(function(arrays) {
      var comparator = last(arrays);
      comparator = typeof comparator == 'function' ? comparator : undefined;
      return baseXor(arrayFilter(arrays, isArrayLikeObject), undefined, comparator);
    });

    /**
     * Creates an array of grouped elements, the first of which contains the
     * first elements of the given arrays, the second of which contains the
     * second elements of the given arrays, and so on.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Array
     * @param {...Array} [arrays] The arrays to process.
     * @returns {Array} Returns the new array of grouped elements.
     * @example
     *
     * _.zip(['a', 'b'], [1, 2], [true, false]);
     * // => [['a', 1, true], ['b', 2, false]]
     */
    var zip = baseRest(unzip);

    /**
     * This method is like `_.fromPairs` except that it accepts two arrays,
     * one of property identifiers and one of corresponding values.
     *
     * @static
     * @memberOf _
     * @since 0.4.0
     * @category Array
     * @param {Array} [props=[]] The property identifiers.
     * @param {Array} [values=[]] The property values.
     * @returns {Object} Returns the new object.
     * @example
     *
     * _.zipObject(['a', 'b'], [1, 2]);
     * // => { 'a': 1, 'b': 2 }
     */
    function zipObject(props, values) {
      return baseZipObject(props || [], values || [], assignValue);
    }

    /**
     * This method is like `_.zipObject` except that it supports property paths.
     *
     * @static
     * @memberOf _
     * @since 4.1.0
     * @category Array
     * @param {Array} [props=[]] The property identifiers.
     * @param {Array} [values=[]] The property values.
     * @returns {Object} Returns the new object.
     * @example
     *
     * _.zipObjectDeep(['a.b[0].c', 'a.b[1].d'], [1, 2]);
     * // => { 'a': { 'b': [{ 'c': 1 }, { 'd': 2 }] } }
     */
    function zipObjectDeep(props, values) {
      return baseZipObject(props || [], values || [], baseSet);
    }

    /**
     * This method is like `_.zip` except that it accepts `iteratee` to specify
     * how grouped values should be combined. The iteratee is invoked with the
     * elements of each group: (...group).
     *
     * @static
     * @memberOf _
     * @since 3.8.0
     * @category Array
     * @param {...Array} [arrays] The arrays to process.
     * @param {Function} [iteratee=_.identity] The function to combine
     *  grouped values.
     * @returns {Array} Returns the new array of grouped elements.
     * @example
     *
     * _.zipWith([1, 2], [10, 20], [100, 200], function(a, b, c) {
     *   return a + b + c;
     * });
     * // => [111, 222]
     */
    var zipWith = baseRest(function(arrays) {
      var length = arrays.length,
          iteratee = length > 1 ? arrays[length - 1] : undefined;

      iteratee = typeof iteratee == 'function' ? (arrays.pop(), iteratee) : undefined;
      return unzipWith(arrays, iteratee);
    });

    /*------------------------------------------------------------------------*/

    /**
     * Creates a `lodash` wrapper instance that wraps `value` with explicit method
     * chain sequences enabled. The result of such sequences must be unwrapped
     * with `_#value`.
     *
     * @static
     * @memberOf _
     * @since 1.3.0
     * @category Seq
     * @param {*} value The value to wrap.
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'age': 36 },
     *   { 'user': 'fred',    'age': 40 },
     *   { 'user': 'pebbles', 'age': 1 }
     * ];
     *
     * var youngest = _
     *   .chain(users)
     *   .sortBy('age')
     *   .map(function(o) {
     *     return o.user + ' is ' + o.age;
     *   })
     *   .head()
     *   .value();
     * // => 'pebbles is 1'
     */
    function chain(value) {
      var result = lodash(value);
      result.__chain__ = true;
      return result;
    }

    /**
     * This method invokes `interceptor` and returns `value`. The interceptor
     * is invoked with one argument; (value). The purpose of this method is to
     * "tap into" a method chain sequence in order to modify intermediate results.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Seq
     * @param {*} value The value to provide to `interceptor`.
     * @param {Function} interceptor The function to invoke.
     * @returns {*} Returns `value`.
     * @example
     *
     * _([1, 2, 3])
     *  .tap(function(array) {
     *    // Mutate input array.
     *    array.pop();
     *  })
     *  .reverse()
     *  .value();
     * // => [2, 1]
     */
    function tap(value, interceptor) {
      interceptor(value);
      return value;
    }

    /**
     * This method is like `_.tap` except that it returns the result of `interceptor`.
     * The purpose of this method is to "pass thru" values replacing intermediate
     * results in a method chain sequence.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Seq
     * @param {*} value The value to provide to `interceptor`.
     * @param {Function} interceptor The function to invoke.
     * @returns {*} Returns the result of `interceptor`.
     * @example
     *
     * _('  abc  ')
     *  .chain()
     *  .trim()
     *  .thru(function(value) {
     *    return [value];
     *  })
     *  .value();
     * // => ['abc']
     */
    function thru(value, interceptor) {
      return interceptor(value);
    }

    /**
     * This method is the wrapper version of `_.at`.
     *
     * @name at
     * @memberOf _
     * @since 1.0.0
     * @category Seq
     * @param {...(string|string[])} [paths] The property paths to pick.
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }, 4] };
     *
     * _(object).at(['a[0].b.c', 'a[1]']).value();
     * // => [3, 4]
     */
    var wrapperAt = flatRest(function(paths) {
      var length = paths.length,
          start = length ? paths[0] : 0,
          value = this.__wrapped__,
          interceptor = function(object) { return baseAt(object, paths); };

      if (length > 1 || this.__actions__.length ||
          !(value instanceof LazyWrapper) || !isIndex(start)) {
        return this.thru(interceptor);
      }
      value = value.slice(start, +start + (length ? 1 : 0));
      value.__actions__.push({
        'func': thru,
        'args': [interceptor],
        'thisArg': undefined
      });
      return new LodashWrapper(value, this.__chain__).thru(function(array) {
        if (length && !array.length) {
          array.push(undefined);
        }
        return array;
      });
    });

    /**
     * Creates a `lodash` wrapper instance with explicit method chain sequences enabled.
     *
     * @name chain
     * @memberOf _
     * @since 0.1.0
     * @category Seq
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36 },
     *   { 'user': 'fred',   'age': 40 }
     * ];
     *
     * // A sequence without explicit chaining.
     * _(users).head();
     * // => { 'user': 'barney', 'age': 36 }
     *
     * // A sequence with explicit chaining.
     * _(users)
     *   .chain()
     *   .head()
     *   .pick('user')
     *   .value();
     * // => { 'user': 'barney' }
     */
    function wrapperChain() {
      return chain(this);
    }

    /**
     * Executes the chain sequence and returns the wrapped result.
     *
     * @name commit
     * @memberOf _
     * @since 3.2.0
     * @category Seq
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var array = [1, 2];
     * var wrapped = _(array).push(3);
     *
     * console.log(array);
     * // => [1, 2]
     *
     * wrapped = wrapped.commit();
     * console.log(array);
     * // => [1, 2, 3]
     *
     * wrapped.last();
     * // => 3
     *
     * console.log(array);
     * // => [1, 2, 3]
     */
    function wrapperCommit() {
      return new LodashWrapper(this.value(), this.__chain__);
    }

    /**
     * Gets the next value on a wrapped object following the
     * [iterator protocol](https://mdn.io/iteration_protocols#iterator).
     *
     * @name next
     * @memberOf _
     * @since 4.0.0
     * @category Seq
     * @returns {Object} Returns the next iterator value.
     * @example
     *
     * var wrapped = _([1, 2]);
     *
     * wrapped.next();
     * // => { 'done': false, 'value': 1 }
     *
     * wrapped.next();
     * // => { 'done': false, 'value': 2 }
     *
     * wrapped.next();
     * // => { 'done': true, 'value': undefined }
     */
    function wrapperNext() {
      if (this.__values__ === undefined) {
        this.__values__ = toArray(this.value());
      }
      var done = this.__index__ >= this.__values__.length,
          value = done ? undefined : this.__values__[this.__index__++];

      return { 'done': done, 'value': value };
    }

    /**
     * Enables the wrapper to be iterable.
     *
     * @name Symbol.iterator
     * @memberOf _
     * @since 4.0.0
     * @category Seq
     * @returns {Object} Returns the wrapper object.
     * @example
     *
     * var wrapped = _([1, 2]);
     *
     * wrapped[Symbol.iterator]() === wrapped;
     * // => true
     *
     * Array.from(wrapped);
     * // => [1, 2]
     */
    function wrapperToIterator() {
      return this;
    }

    /**
     * Creates a clone of the chain sequence planting `value` as the wrapped value.
     *
     * @name plant
     * @memberOf _
     * @since 3.2.0
     * @category Seq
     * @param {*} value The value to plant.
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var wrapped = _([1, 2]).map(square);
     * var other = wrapped.plant([3, 4]);
     *
     * other.value();
     * // => [9, 16]
     *
     * wrapped.value();
     * // => [1, 4]
     */
    function wrapperPlant(value) {
      var result,
          parent = this;

      while (parent instanceof baseLodash) {
        var clone = wrapperClone(parent);
        clone.__index__ = 0;
        clone.__values__ = undefined;
        if (result) {
          previous.__wrapped__ = clone;
        } else {
          result = clone;
        }
        var previous = clone;
        parent = parent.__wrapped__;
      }
      previous.__wrapped__ = value;
      return result;
    }

    /**
     * This method is the wrapper version of `_.reverse`.
     *
     * **Note:** This method mutates the wrapped array.
     *
     * @name reverse
     * @memberOf _
     * @since 0.1.0
     * @category Seq
     * @returns {Object} Returns the new `lodash` wrapper instance.
     * @example
     *
     * var array = [1, 2, 3];
     *
     * _(array).reverse().value()
     * // => [3, 2, 1]
     *
     * console.log(array);
     * // => [3, 2, 1]
     */
    function wrapperReverse() {
      var value = this.__wrapped__;
      if (value instanceof LazyWrapper) {
        var wrapped = value;
        if (this.__actions__.length) {
          wrapped = new LazyWrapper(this);
        }
        wrapped = wrapped.reverse();
        wrapped.__actions__.push({
          'func': thru,
          'args': [reverse],
          'thisArg': undefined
        });
        return new LodashWrapper(wrapped, this.__chain__);
      }
      return this.thru(reverse);
    }

    /**
     * Executes the chain sequence to resolve the unwrapped value.
     *
     * @name value
     * @memberOf _
     * @since 0.1.0
     * @alias toJSON, valueOf
     * @category Seq
     * @returns {*} Returns the resolved unwrapped value.
     * @example
     *
     * _([1, 2, 3]).value();
     * // => [1, 2, 3]
     */
    function wrapperValue() {
      return baseWrapperValue(this.__wrapped__, this.__actions__);
    }

    /*------------------------------------------------------------------------*/

    /**
     * Creates an object composed of keys generated from the results of running
     * each element of `collection` thru `iteratee`. The corresponding value of
     * each key is the number of times the key was returned by `iteratee`. The
     * iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 0.5.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
     * @returns {Object} Returns the composed aggregate object.
     * @example
     *
     * _.countBy([6.1, 4.2, 6.3], Math.floor);
     * // => { '4': 1, '6': 2 }
     *
     * // The `_.property` iteratee shorthand.
     * _.countBy(['one', 'two', 'three'], 'length');
     * // => { '3': 2, '5': 1 }
     */
    var countBy = createAggregator(function(result, value, key) {
      if (hasOwnProperty.call(result, key)) {
        ++result[key];
      } else {
        baseAssignValue(result, key, 1);
      }
    });

    /**
     * Checks if `predicate` returns truthy for **all** elements of `collection`.
     * Iteration is stopped once `predicate` returns falsey. The predicate is
     * invoked with three arguments: (value, index|key, collection).
     *
     * **Note:** This method returns `true` for
     * [empty collections](https://en.wikipedia.org/wiki/Empty_set) because
     * [everything is true](https://en.wikipedia.org/wiki/Vacuous_truth) of
     * elements of empty collections.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {boolean} Returns `true` if all elements pass the predicate check,
     *  else `false`.
     * @example
     *
     * _.every([true, 1, null, 'yes'], Boolean);
     * // => false
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36, 'active': false },
     *   { 'user': 'fred',   'age': 40, 'active': false }
     * ];
     *
     * // The `_.matches` iteratee shorthand.
     * _.every(users, { 'user': 'barney', 'active': false });
     * // => false
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.every(users, ['active', false]);
     * // => true
     *
     * // The `_.property` iteratee shorthand.
     * _.every(users, 'active');
     * // => false
     */
    function every(collection, predicate, guard) {
      var func = isArray(collection) ? arrayEvery : baseEvery;
      if (guard && isIterateeCall(collection, predicate, guard)) {
        predicate = undefined;
      }
      return func(collection, getIteratee(predicate, 3));
    }

    /**
     * Iterates over elements of `collection`, returning an array of all elements
     * `predicate` returns truthy for. The predicate is invoked with three
     * arguments: (value, index|key, collection).
     *
     * **Note:** Unlike `_.remove`, this method returns a new array.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new filtered array.
     * @see _.reject
     * @example
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36, 'active': true },
     *   { 'user': 'fred',   'age': 40, 'active': false }
     * ];
     *
     * _.filter(users, function(o) { return !o.active; });
     * // => objects for ['fred']
     *
     * // The `_.matches` iteratee shorthand.
     * _.filter(users, { 'age': 36, 'active': true });
     * // => objects for ['barney']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.filter(users, ['active', false]);
     * // => objects for ['fred']
     *
     * // The `_.property` iteratee shorthand.
     * _.filter(users, 'active');
     * // => objects for ['barney']
     *
     * // Combining several predicates using `_.overEvery` or `_.overSome`.
     * _.filter(users, _.overSome([{ 'age': 36 }, ['age', 40]]));
     * // => objects for ['fred', 'barney']
     */
    function filter(collection, predicate) {
      var func = isArray(collection) ? arrayFilter : baseFilter;
      return func(collection, getIteratee(predicate, 3));
    }

    /**
     * Iterates over elements of `collection`, returning the first element
     * `predicate` returns truthy for. The predicate is invoked with three
     * arguments: (value, index|key, collection).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param {number} [fromIndex=0] The index to search from.
     * @returns {*} Returns the matched element, else `undefined`.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'age': 36, 'active': true },
     *   { 'user': 'fred',    'age': 40, 'active': false },
     *   { 'user': 'pebbles', 'age': 1,  'active': true }
     * ];
     *
     * _.find(users, function(o) { return o.age < 40; });
     * // => object for 'barney'
     *
     * // The `_.matches` iteratee shorthand.
     * _.find(users, { 'age': 1, 'active': true });
     * // => object for 'pebbles'
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.find(users, ['active', false]);
     * // => object for 'fred'
     *
     * // The `_.property` iteratee shorthand.
     * _.find(users, 'active');
     * // => object for 'barney'
     */
    var find = createFind(findIndex);

    /**
     * This method is like `_.find` except that it iterates over elements of
     * `collection` from right to left.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param {number} [fromIndex=collection.length-1] The index to search from.
     * @returns {*} Returns the matched element, else `undefined`.
     * @example
     *
     * _.findLast([1, 2, 3, 4], function(n) {
     *   return n % 2 == 1;
     * });
     * // => 3
     */
    var findLast = createFind(findLastIndex);

    /**
     * Creates a flattened array of values by running each element in `collection`
     * thru `iteratee` and flattening the mapped results. The iteratee is invoked
     * with three arguments: (value, index|key, collection).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * function duplicate(n) {
     *   return [n, n];
     * }
     *
     * _.flatMap([1, 2], duplicate);
     * // => [1, 1, 2, 2]
     */
    function flatMap(collection, iteratee) {
      return baseFlatten(map(collection, iteratee), 1);
    }

    /**
     * This method is like `_.flatMap` except that it recursively flattens the
     * mapped results.
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * function duplicate(n) {
     *   return [[[n, n]]];
     * }
     *
     * _.flatMapDeep([1, 2], duplicate);
     * // => [1, 1, 2, 2]
     */
    function flatMapDeep(collection, iteratee) {
      return baseFlatten(map(collection, iteratee), INFINITY);
    }

    /**
     * This method is like `_.flatMap` except that it recursively flattens the
     * mapped results up to `depth` times.
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @param {number} [depth=1] The maximum recursion depth.
     * @returns {Array} Returns the new flattened array.
     * @example
     *
     * function duplicate(n) {
     *   return [[[n, n]]];
     * }
     *
     * _.flatMapDepth([1, 2], duplicate, 2);
     * // => [[1, 1], [2, 2]]
     */
    function flatMapDepth(collection, iteratee, depth) {
      depth = depth === undefined ? 1 : toInteger(depth);
      return baseFlatten(map(collection, iteratee), depth);
    }

    /**
     * Iterates over elements of `collection` and invokes `iteratee` for each element.
     * The iteratee is invoked with three arguments: (value, index|key, collection).
     * Iteratee functions may exit iteration early by explicitly returning `false`.
     *
     * **Note:** As with other "Collections" methods, objects with a "length"
     * property are iterated like arrays. To avoid this behavior use `_.forIn`
     * or `_.forOwn` for object iteration.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @alias each
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     * @see _.forEachRight
     * @example
     *
     * _.forEach([1, 2], function(value) {
     *   console.log(value);
     * });
     * // => Logs `1` then `2`.
     *
     * _.forEach({ 'a': 1, 'b': 2 }, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'a' then 'b' (iteration order is not guaranteed).
     */
    function forEach(collection, iteratee) {
      var func = isArray(collection) ? arrayEach : baseEach;
      return func(collection, getIteratee(iteratee, 3));
    }

    /**
     * This method is like `_.forEach` except that it iterates over elements of
     * `collection` from right to left.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @alias eachRight
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array|Object} Returns `collection`.
     * @see _.forEach
     * @example
     *
     * _.forEachRight([1, 2], function(value) {
     *   console.log(value);
     * });
     * // => Logs `2` then `1`.
     */
    function forEachRight(collection, iteratee) {
      var func = isArray(collection) ? arrayEachRight : baseEachRight;
      return func(collection, getIteratee(iteratee, 3));
    }

    /**
     * Creates an object composed of keys generated from the results of running
     * each element of `collection` thru `iteratee`. The order of grouped values
     * is determined by the order they occur in `collection`. The corresponding
     * value of each key is an array of elements responsible for generating the
     * key. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
     * @returns {Object} Returns the composed aggregate object.
     * @example
     *
     * _.groupBy([6.1, 4.2, 6.3], Math.floor);
     * // => { '4': [4.2], '6': [6.1, 6.3] }
     *
     * // The `_.property` iteratee shorthand.
     * _.groupBy(['one', 'two', 'three'], 'length');
     * // => { '3': ['one', 'two'], '5': ['three'] }
     */
    var groupBy = createAggregator(function(result, value, key) {
      if (hasOwnProperty.call(result, key)) {
        result[key].push(value);
      } else {
        baseAssignValue(result, key, [value]);
      }
    });

    /**
     * Checks if `value` is in `collection`. If `collection` is a string, it's
     * checked for a substring of `value`, otherwise
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * is used for equality comparisons. If `fromIndex` is negative, it's used as
     * the offset from the end of `collection`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object|string} collection The collection to inspect.
     * @param {*} value The value to search for.
     * @param {number} [fromIndex=0] The index to search from.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
     * @returns {boolean} Returns `true` if `value` is found, else `false`.
     * @example
     *
     * _.includes([1, 2, 3], 1);
     * // => true
     *
     * _.includes([1, 2, 3], 1, 2);
     * // => false
     *
     * _.includes({ 'a': 1, 'b': 2 }, 1);
     * // => true
     *
     * _.includes('abcd', 'bc');
     * // => true
     */
    function includes(collection, value, fromIndex, guard) {
      collection = isArrayLike(collection) ? collection : values(collection);
      fromIndex = (fromIndex && !guard) ? toInteger(fromIndex) : 0;

      var length = collection.length;
      if (fromIndex < 0) {
        fromIndex = nativeMax(length + fromIndex, 0);
      }
      return isString(collection)
        ? (fromIndex <= length && collection.indexOf(value, fromIndex) > -1)
        : (!!length && baseIndexOf(collection, value, fromIndex) > -1);
    }

    /**
     * Invokes the method at `path` of each element in `collection`, returning
     * an array of the results of each invoked method. Any additional arguments
     * are provided to each invoked method. If `path` is a function, it's invoked
     * for, and `this` bound to, each element in `collection`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Array|Function|string} path The path of the method to invoke or
     *  the function invoked per iteration.
     * @param {...*} [args] The arguments to invoke each method with.
     * @returns {Array} Returns the array of results.
     * @example
     *
     * _.invokeMap([[5, 1, 7], [3, 2, 1]], 'sort');
     * // => [[1, 5, 7], [1, 2, 3]]
     *
     * _.invokeMap([123, 456], String.prototype.split, '');
     * // => [['1', '2', '3'], ['4', '5', '6']]
     */
    var invokeMap = baseRest(function(collection, path, args) {
      var index = -1,
          isFunc = typeof path == 'function',
          result = isArrayLike(collection) ? Array(collection.length) : [];

      baseEach(collection, function(value) {
        result[++index] = isFunc ? apply(path, value, args) : baseInvoke(value, path, args);
      });
      return result;
    });

    /**
     * Creates an object composed of keys generated from the results of running
     * each element of `collection` thru `iteratee`. The corresponding value of
     * each key is the last element responsible for generating the key. The
     * iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee to transform keys.
     * @returns {Object} Returns the composed aggregate object.
     * @example
     *
     * var array = [
     *   { 'dir': 'left', 'code': 97 },
     *   { 'dir': 'right', 'code': 100 }
     * ];
     *
     * _.keyBy(array, function(o) {
     *   return String.fromCharCode(o.code);
     * });
     * // => { 'a': { 'dir': 'left', 'code': 97 }, 'd': { 'dir': 'right', 'code': 100 } }
     *
     * _.keyBy(array, 'dir');
     * // => { 'left': { 'dir': 'left', 'code': 97 }, 'right': { 'dir': 'right', 'code': 100 } }
     */
    var keyBy = createAggregator(function(result, value, key) {
      baseAssignValue(result, key, value);
    });

    /**
     * Creates an array of values by running each element in `collection` thru
     * `iteratee`. The iteratee is invoked with three arguments:
     * (value, index|key, collection).
     *
     * Many lodash methods are guarded to work as iteratees for methods like
     * `_.every`, `_.filter`, `_.map`, `_.mapValues`, `_.reject`, and `_.some`.
     *
     * The guarded methods are:
     * `ary`, `chunk`, `curry`, `curryRight`, `drop`, `dropRight`, `every`,
     * `fill`, `invert`, `parseInt`, `random`, `range`, `rangeRight`, `repeat`,
     * `sampleSize`, `slice`, `some`, `sortBy`, `split`, `take`, `takeRight`,
     * `template`, `trim`, `trimEnd`, `trimStart`, and `words`
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new mapped array.
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * _.map([4, 8], square);
     * // => [16, 64]
     *
     * _.map({ 'a': 4, 'b': 8 }, square);
     * // => [16, 64] (iteration order is not guaranteed)
     *
     * var users = [
     *   { 'user': 'barney' },
     *   { 'user': 'fred' }
     * ];
     *
     * // The `_.property` iteratee shorthand.
     * _.map(users, 'user');
     * // => ['barney', 'fred']
     */
    function map(collection, iteratee) {
      var func = isArray(collection) ? arrayMap : baseMap;
      return func(collection, getIteratee(iteratee, 3));
    }

    /**
     * This method is like `_.sortBy` except that it allows specifying the sort
     * orders of the iteratees to sort by. If `orders` is unspecified, all values
     * are sorted in ascending order. Otherwise, specify an order of "desc" for
     * descending or "asc" for ascending sort order of corresponding values.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Array[]|Function[]|Object[]|string[]} [iteratees=[_.identity]]
     *  The iteratees to sort by.
     * @param {string[]} [orders] The sort orders of `iteratees`.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.reduce`.
     * @returns {Array} Returns the new sorted array.
     * @example
     *
     * var users = [
     *   { 'user': 'fred',   'age': 48 },
     *   { 'user': 'barney', 'age': 34 },
     *   { 'user': 'fred',   'age': 40 },
     *   { 'user': 'barney', 'age': 36 }
     * ];
     *
     * // Sort by `user` in ascending order and by `age` in descending order.
     * _.orderBy(users, ['user', 'age'], ['asc', 'desc']);
     * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 40]]
     */
    function orderBy(collection, iteratees, orders, guard) {
      if (collection == null) {
        return [];
      }
      if (!isArray(iteratees)) {
        iteratees = iteratees == null ? [] : [iteratees];
      }
      orders = guard ? undefined : orders;
      if (!isArray(orders)) {
        orders = orders == null ? [] : [orders];
      }
      return baseOrderBy(collection, iteratees, orders);
    }

    /**
     * Creates an array of elements split into two groups, the first of which
     * contains elements `predicate` returns truthy for, the second of which
     * contains elements `predicate` returns falsey for. The predicate is
     * invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the array of grouped elements.
     * @example
     *
     * var users = [
     *   { 'user': 'barney',  'age': 36, 'active': false },
     *   { 'user': 'fred',    'age': 40, 'active': true },
     *   { 'user': 'pebbles', 'age': 1,  'active': false }
     * ];
     *
     * _.partition(users, function(o) { return o.active; });
     * // => objects for [['fred'], ['barney', 'pebbles']]
     *
     * // The `_.matches` iteratee shorthand.
     * _.partition(users, { 'age': 1, 'active': false });
     * // => objects for [['pebbles'], ['barney', 'fred']]
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.partition(users, ['active', false]);
     * // => objects for [['barney', 'pebbles'], ['fred']]
     *
     * // The `_.property` iteratee shorthand.
     * _.partition(users, 'active');
     * // => objects for [['fred'], ['barney', 'pebbles']]
     */
    var partition = createAggregator(function(result, value, key) {
      result[key ? 0 : 1].push(value);
    }, function() { return [[], []]; });

    /**
     * Reduces `collection` to a value which is the accumulated result of running
     * each element in `collection` thru `iteratee`, where each successive
     * invocation is supplied the return value of the previous. If `accumulator`
     * is not given, the first element of `collection` is used as the initial
     * value. The iteratee is invoked with four arguments:
     * (accumulator, value, index|key, collection).
     *
     * Many lodash methods are guarded to work as iteratees for methods like
     * `_.reduce`, `_.reduceRight`, and `_.transform`.
     *
     * The guarded methods are:
     * `assign`, `defaults`, `defaultsDeep`, `includes`, `merge`, `orderBy`,
     * and `sortBy`
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @param {*} [accumulator] The initial value.
     * @returns {*} Returns the accumulated value.
     * @see _.reduceRight
     * @example
     *
     * _.reduce([1, 2], function(sum, n) {
     *   return sum + n;
     * }, 0);
     * // => 3
     *
     * _.reduce({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {
     *   (result[value] || (result[value] = [])).push(key);
     *   return result;
     * }, {});
     * // => { '1': ['a', 'c'], '2': ['b'] } (iteration order is not guaranteed)
     */
    function reduce(collection, iteratee, accumulator) {
      var func = isArray(collection) ? arrayReduce : baseReduce,
          initAccum = arguments.length < 3;

      return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEach);
    }

    /**
     * This method is like `_.reduce` except that it iterates over elements of
     * `collection` from right to left.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @param {*} [accumulator] The initial value.
     * @returns {*} Returns the accumulated value.
     * @see _.reduce
     * @example
     *
     * var array = [[0, 1], [2, 3], [4, 5]];
     *
     * _.reduceRight(array, function(flattened, other) {
     *   return flattened.concat(other);
     * }, []);
     * // => [4, 5, 2, 3, 0, 1]
     */
    function reduceRight(collection, iteratee, accumulator) {
      var func = isArray(collection) ? arrayReduceRight : baseReduce,
          initAccum = arguments.length < 3;

      return func(collection, getIteratee(iteratee, 4), accumulator, initAccum, baseEachRight);
    }

    /**
     * The opposite of `_.filter`; this method returns the elements of `collection`
     * that `predicate` does **not** return truthy for.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the new filtered array.
     * @see _.filter
     * @example
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36, 'active': false },
     *   { 'user': 'fred',   'age': 40, 'active': true }
     * ];
     *
     * _.reject(users, function(o) { return !o.active; });
     * // => objects for ['fred']
     *
     * // The `_.matches` iteratee shorthand.
     * _.reject(users, { 'age': 40, 'active': true });
     * // => objects for ['barney']
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.reject(users, ['active', false]);
     * // => objects for ['fred']
     *
     * // The `_.property` iteratee shorthand.
     * _.reject(users, 'active');
     * // => objects for ['barney']
     */
    function reject(collection, predicate) {
      var func = isArray(collection) ? arrayFilter : baseFilter;
      return func(collection, negate(getIteratee(predicate, 3)));
    }

    /**
     * Gets a random element from `collection`.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to sample.
     * @returns {*} Returns the random element.
     * @example
     *
     * _.sample([1, 2, 3, 4]);
     * // => 2
     */
    function sample(collection) {
      var func = isArray(collection) ? arraySample : baseSample;
      return func(collection);
    }

    /**
     * Gets `n` random elements at unique keys from `collection` up to the
     * size of `collection`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Collection
     * @param {Array|Object} collection The collection to sample.
     * @param {number} [n=1] The number of elements to sample.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the random elements.
     * @example
     *
     * _.sampleSize([1, 2, 3], 2);
     * // => [3, 1]
     *
     * _.sampleSize([1, 2, 3], 4);
     * // => [2, 3, 1]
     */
    function sampleSize(collection, n, guard) {
      if ((guard ? isIterateeCall(collection, n, guard) : n === undefined)) {
        n = 1;
      } else {
        n = toInteger(n);
      }
      var func = isArray(collection) ? arraySampleSize : baseSampleSize;
      return func(collection, n);
    }

    /**
     * Creates an array of shuffled values, using a version of the
     * [Fisher-Yates shuffle](https://en.wikipedia.org/wiki/Fisher-Yates_shuffle).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to shuffle.
     * @returns {Array} Returns the new shuffled array.
     * @example
     *
     * _.shuffle([1, 2, 3, 4]);
     * // => [4, 1, 3, 2]
     */
    function shuffle(collection) {
      var func = isArray(collection) ? arrayShuffle : baseShuffle;
      return func(collection);
    }

    /**
     * Gets the size of `collection` by returning its length for array-like
     * values or the number of own enumerable string keyed properties for objects.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object|string} collection The collection to inspect.
     * @returns {number} Returns the collection size.
     * @example
     *
     * _.size([1, 2, 3]);
     * // => 3
     *
     * _.size({ 'a': 1, 'b': 2 });
     * // => 2
     *
     * _.size('pebbles');
     * // => 7
     */
    function size(collection) {
      if (collection == null) {
        return 0;
      }
      if (isArrayLike(collection)) {
        return isString(collection) ? stringSize(collection) : collection.length;
      }
      var tag = getTag(collection);
      if (tag == mapTag || tag == setTag) {
        return collection.size;
      }
      return baseKeys(collection).length;
    }

    /**
     * Checks if `predicate` returns truthy for **any** element of `collection`.
     * Iteration is stopped once `predicate` returns truthy. The predicate is
     * invoked with three arguments: (value, index|key, collection).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {boolean} Returns `true` if any element passes the predicate check,
     *  else `false`.
     * @example
     *
     * _.some([null, 0, 'yes', false], Boolean);
     * // => true
     *
     * var users = [
     *   { 'user': 'barney', 'active': true },
     *   { 'user': 'fred',   'active': false }
     * ];
     *
     * // The `_.matches` iteratee shorthand.
     * _.some(users, { 'user': 'barney', 'active': false });
     * // => false
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.some(users, ['active', false]);
     * // => true
     *
     * // The `_.property` iteratee shorthand.
     * _.some(users, 'active');
     * // => true
     */
    function some(collection, predicate, guard) {
      var func = isArray(collection) ? arraySome : baseSome;
      if (guard && isIterateeCall(collection, predicate, guard)) {
        predicate = undefined;
      }
      return func(collection, getIteratee(predicate, 3));
    }

    /**
     * Creates an array of elements, sorted in ascending order by the results of
     * running each element in a collection thru each iteratee. This method
     * performs a stable sort, that is, it preserves the original sort order of
     * equal elements. The iteratees are invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Collection
     * @param {Array|Object} collection The collection to iterate over.
     * @param {...(Function|Function[])} [iteratees=[_.identity]]
     *  The iteratees to sort by.
     * @returns {Array} Returns the new sorted array.
     * @example
     *
     * var users = [
     *   { 'user': 'fred',   'age': 48 },
     *   { 'user': 'barney', 'age': 36 },
     *   { 'user': 'fred',   'age': 30 },
     *   { 'user': 'barney', 'age': 34 }
     * ];
     *
     * _.sortBy(users, [function(o) { return o.user; }]);
     * // => objects for [['barney', 36], ['barney', 34], ['fred', 48], ['fred', 30]]
     *
     * _.sortBy(users, ['user', 'age']);
     * // => objects for [['barney', 34], ['barney', 36], ['fred', 30], ['fred', 48]]
     */
    var sortBy = baseRest(function(collection, iteratees) {
      if (collection == null) {
        return [];
      }
      var length = iteratees.length;
      if (length > 1 && isIterateeCall(collection, iteratees[0], iteratees[1])) {
        iteratees = [];
      } else if (length > 2 && isIterateeCall(iteratees[0], iteratees[1], iteratees[2])) {
        iteratees = [iteratees[0]];
      }
      return baseOrderBy(collection, baseFlatten(iteratees, 1), []);
    });

    /*------------------------------------------------------------------------*/

    /**
     * Gets the timestamp of the number of milliseconds that have elapsed since
     * the Unix epoch (1 January 1970 00:00:00 UTC).
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Date
     * @returns {number} Returns the timestamp.
     * @example
     *
     * _.defer(function(stamp) {
     *   console.log(_.now() - stamp);
     * }, _.now());
     * // => Logs the number of milliseconds it took for the deferred invocation.
     */
    var now = ctxNow || function() {
      return root.Date.now();
    };

    /*------------------------------------------------------------------------*/

    /**
     * The opposite of `_.before`; this method creates a function that invokes
     * `func` once it's called `n` or more times.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {number} n The number of calls before `func` is invoked.
     * @param {Function} func The function to restrict.
     * @returns {Function} Returns the new restricted function.
     * @example
     *
     * var saves = ['profile', 'settings'];
     *
     * var done = _.after(saves.length, function() {
     *   console.log('done saving!');
     * });
     *
     * _.forEach(saves, function(type) {
     *   asyncSave({ 'type': type, 'complete': done });
     * });
     * // => Logs 'done saving!' after the two async saves have completed.
     */
    function after(n, func) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      n = toInteger(n);
      return function() {
        if (--n < 1) {
          return func.apply(this, arguments);
        }
      };
    }

    /**
     * Creates a function that invokes `func`, with up to `n` arguments,
     * ignoring any additional arguments.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {Function} func The function to cap arguments for.
     * @param {number} [n=func.length] The arity cap.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Function} Returns the new capped function.
     * @example
     *
     * _.map(['6', '8', '10'], _.ary(parseInt, 1));
     * // => [6, 8, 10]
     */
    function ary(func, n, guard) {
      n = guard ? undefined : n;
      n = (func && n == null) ? func.length : n;
      return createWrap(func, WRAP_ARY_FLAG, undefined, undefined, undefined, undefined, n);
    }

    /**
     * Creates a function that invokes `func`, with the `this` binding and arguments
     * of the created function, while it's called less than `n` times. Subsequent
     * calls to the created function return the result of the last `func` invocation.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {number} n The number of calls at which `func` is no longer invoked.
     * @param {Function} func The function to restrict.
     * @returns {Function} Returns the new restricted function.
     * @example
     *
     * jQuery(element).on('click', _.before(5, addContactToList));
     * // => Allows adding up to 4 contacts to the list.
     */
    function before(n, func) {
      var result;
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      n = toInteger(n);
      return function() {
        if (--n > 0) {
          result = func.apply(this, arguments);
        }
        if (n <= 1) {
          func = undefined;
        }
        return result;
      };
    }

    /**
     * Creates a function that invokes `func` with the `this` binding of `thisArg`
     * and `partials` prepended to the arguments it receives.
     *
     * The `_.bind.placeholder` value, which defaults to `_` in monolithic builds,
     * may be used as a placeholder for partially applied arguments.
     *
     * **Note:** Unlike native `Function#bind`, this method doesn't set the "length"
     * property of bound functions.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to bind.
     * @param {*} thisArg The `this` binding of `func`.
     * @param {...*} [partials] The arguments to be partially applied.
     * @returns {Function} Returns the new bound function.
     * @example
     *
     * function greet(greeting, punctuation) {
     *   return greeting + ' ' + this.user + punctuation;
     * }
     *
     * var object = { 'user': 'fred' };
     *
     * var bound = _.bind(greet, object, 'hi');
     * bound('!');
     * // => 'hi fred!'
     *
     * // Bound with placeholders.
     * var bound = _.bind(greet, object, _, '!');
     * bound('hi');
     * // => 'hi fred!'
     */
    var bind = baseRest(function(func, thisArg, partials) {
      var bitmask = WRAP_BIND_FLAG;
      if (partials.length) {
        var holders = replaceHolders(partials, getHolder(bind));
        bitmask |= WRAP_PARTIAL_FLAG;
      }
      return createWrap(func, bitmask, thisArg, partials, holders);
    });

    /**
     * Creates a function that invokes the method at `object[key]` with `partials`
     * prepended to the arguments it receives.
     *
     * This method differs from `_.bind` by allowing bound functions to reference
     * methods that may be redefined or don't yet exist. See
     * [Peter Michaux's article](http://peter.michaux.ca/articles/lazy-function-definition-pattern)
     * for more details.
     *
     * The `_.bindKey.placeholder` value, which defaults to `_` in monolithic
     * builds, may be used as a placeholder for partially applied arguments.
     *
     * @static
     * @memberOf _
     * @since 0.10.0
     * @category Function
     * @param {Object} object The object to invoke the method on.
     * @param {string} key The key of the method.
     * @param {...*} [partials] The arguments to be partially applied.
     * @returns {Function} Returns the new bound function.
     * @example
     *
     * var object = {
     *   'user': 'fred',
     *   'greet': function(greeting, punctuation) {
     *     return greeting + ' ' + this.user + punctuation;
     *   }
     * };
     *
     * var bound = _.bindKey(object, 'greet', 'hi');
     * bound('!');
     * // => 'hi fred!'
     *
     * object.greet = function(greeting, punctuation) {
     *   return greeting + 'ya ' + this.user + punctuation;
     * };
     *
     * bound('!');
     * // => 'hiya fred!'
     *
     * // Bound with placeholders.
     * var bound = _.bindKey(object, 'greet', _, '!');
     * bound('hi');
     * // => 'hiya fred!'
     */
    var bindKey = baseRest(function(object, key, partials) {
      var bitmask = WRAP_BIND_FLAG | WRAP_BIND_KEY_FLAG;
      if (partials.length) {
        var holders = replaceHolders(partials, getHolder(bindKey));
        bitmask |= WRAP_PARTIAL_FLAG;
      }
      return createWrap(key, bitmask, object, partials, holders);
    });

    /**
     * Creates a function that accepts arguments of `func` and either invokes
     * `func` returning its result, if at least `arity` number of arguments have
     * been provided, or returns a function that accepts the remaining `func`
     * arguments, and so on. The arity of `func` may be specified if `func.length`
     * is not sufficient.
     *
     * The `_.curry.placeholder` value, which defaults to `_` in monolithic builds,
     * may be used as a placeholder for provided arguments.
     *
     * **Note:** This method doesn't set the "length" property of curried functions.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Function
     * @param {Function} func The function to curry.
     * @param {number} [arity=func.length] The arity of `func`.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Function} Returns the new curried function.
     * @example
     *
     * var abc = function(a, b, c) {
     *   return [a, b, c];
     * };
     *
     * var curried = _.curry(abc);
     *
     * curried(1)(2)(3);
     * // => [1, 2, 3]
     *
     * curried(1, 2)(3);
     * // => [1, 2, 3]
     *
     * curried(1, 2, 3);
     * // => [1, 2, 3]
     *
     * // Curried with placeholders.
     * curried(1)(_, 3)(2);
     * // => [1, 2, 3]
     */
    function curry(func, arity, guard) {
      arity = guard ? undefined : arity;
      var result = createWrap(func, WRAP_CURRY_FLAG, undefined, undefined, undefined, undefined, undefined, arity);
      result.placeholder = curry.placeholder;
      return result;
    }

    /**
     * This method is like `_.curry` except that arguments are applied to `func`
     * in the manner of `_.partialRight` instead of `_.partial`.
     *
     * The `_.curryRight.placeholder` value, which defaults to `_` in monolithic
     * builds, may be used as a placeholder for provided arguments.
     *
     * **Note:** This method doesn't set the "length" property of curried functions.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {Function} func The function to curry.
     * @param {number} [arity=func.length] The arity of `func`.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Function} Returns the new curried function.
     * @example
     *
     * var abc = function(a, b, c) {
     *   return [a, b, c];
     * };
     *
     * var curried = _.curryRight(abc);
     *
     * curried(3)(2)(1);
     * // => [1, 2, 3]
     *
     * curried(2, 3)(1);
     * // => [1, 2, 3]
     *
     * curried(1, 2, 3);
     * // => [1, 2, 3]
     *
     * // Curried with placeholders.
     * curried(3)(1, _)(2);
     * // => [1, 2, 3]
     */
    function curryRight(func, arity, guard) {
      arity = guard ? undefined : arity;
      var result = createWrap(func, WRAP_CURRY_RIGHT_FLAG, undefined, undefined, undefined, undefined, undefined, arity);
      result.placeholder = curryRight.placeholder;
      return result;
    }

    /**
     * Creates a debounced function that delays invoking `func` until after `wait`
     * milliseconds have elapsed since the last time the debounced function was
     * invoked. The debounced function comes with a `cancel` method to cancel
     * delayed `func` invocations and a `flush` method to immediately invoke them.
     * Provide `options` to indicate whether `func` should be invoked on the
     * leading and/or trailing edge of the `wait` timeout. The `func` is invoked
     * with the last arguments provided to the debounced function. Subsequent
     * calls to the debounced function return the result of the last `func`
     * invocation.
     *
     * **Note:** If `leading` and `trailing` options are `true`, `func` is
     * invoked on the trailing edge of the timeout only if the debounced function
     * is invoked more than once during the `wait` timeout.
     *
     * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
     * until to the next tick, similar to `setTimeout` with a timeout of `0`.
     *
     * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
     * for details over the differences between `_.debounce` and `_.throttle`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to debounce.
     * @param {number} [wait=0] The number of milliseconds to delay.
     * @param {Object} [options={}] The options object.
     * @param {boolean} [options.leading=false]
     *  Specify invoking on the leading edge of the timeout.
     * @param {number} [options.maxWait]
     *  The maximum time `func` is allowed to be delayed before it's invoked.
     * @param {boolean} [options.trailing=true]
     *  Specify invoking on the trailing edge of the timeout.
     * @returns {Function} Returns the new debounced function.
     * @example
     *
     * // Avoid costly calculations while the window size is in flux.
     * jQuery(window).on('resize', _.debounce(calculateLayout, 150));
     *
     * // Invoke `sendMail` when clicked, debouncing subsequent calls.
     * jQuery(element).on('click', _.debounce(sendMail, 300, {
     *   'leading': true,
     *   'trailing': false
     * }));
     *
     * // Ensure `batchLog` is invoked once after 1 second of debounced calls.
     * var debounced = _.debounce(batchLog, 250, { 'maxWait': 1000 });
     * var source = new EventSource('/stream');
     * jQuery(source).on('message', debounced);
     *
     * // Cancel the trailing debounced invocation.
     * jQuery(window).on('popstate', debounced.cancel);
     */
    function debounce(func, wait, options) {
      var lastArgs,
          lastThis,
          maxWait,
          result,
          timerId,
          lastCallTime,
          lastInvokeTime = 0,
          leading = false,
          maxing = false,
          trailing = true;

      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      wait = toNumber(wait) || 0;
      if (isObject(options)) {
        leading = !!options.leading;
        maxing = 'maxWait' in options;
        maxWait = maxing ? nativeMax(toNumber(options.maxWait) || 0, wait) : maxWait;
        trailing = 'trailing' in options ? !!options.trailing : trailing;
      }

      function invokeFunc(time) {
        var args = lastArgs,
            thisArg = lastThis;

        lastArgs = lastThis = undefined;
        lastInvokeTime = time;
        result = func.apply(thisArg, args);
        return result;
      }

      function leadingEdge(time) {
        // Reset any `maxWait` timer.
        lastInvokeTime = time;
        // Start the timer for the trailing edge.
        timerId = setTimeout(timerExpired, wait);
        // Invoke the leading edge.
        return leading ? invokeFunc(time) : result;
      }

      function remainingWait(time) {
        var timeSinceLastCall = time - lastCallTime,
            timeSinceLastInvoke = time - lastInvokeTime,
            timeWaiting = wait - timeSinceLastCall;

        return maxing
          ? nativeMin(timeWaiting, maxWait - timeSinceLastInvoke)
          : timeWaiting;
      }

      function shouldInvoke(time) {
        var timeSinceLastCall = time - lastCallTime,
            timeSinceLastInvoke = time - lastInvokeTime;

        // Either this is the first call, activity has stopped and we're at the
        // trailing edge, the system time has gone backwards and we're treating
        // it as the trailing edge, or we've hit the `maxWait` limit.
        return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
          (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait));
      }

      function timerExpired() {
        var time = now();
        if (shouldInvoke(time)) {
          return trailingEdge(time);
        }
        // Restart the timer.
        timerId = setTimeout(timerExpired, remainingWait(time));
      }

      function trailingEdge(time) {
        timerId = undefined;

        // Only invoke if we have `lastArgs` which means `func` has been
        // debounced at least once.
        if (trailing && lastArgs) {
          return invokeFunc(time);
        }
        lastArgs = lastThis = undefined;
        return result;
      }

      function cancel() {
        if (timerId !== undefined) {
          clearTimeout(timerId);
        }
        lastInvokeTime = 0;
        lastArgs = lastCallTime = lastThis = timerId = undefined;
      }

      function flush() {
        return timerId === undefined ? result : trailingEdge(now());
      }

      function debounced() {
        var time = now(),
            isInvoking = shouldInvoke(time);

        lastArgs = arguments;
        lastThis = this;
        lastCallTime = time;

        if (isInvoking) {
          if (timerId === undefined) {
            return leadingEdge(lastCallTime);
          }
          if (maxing) {
            // Handle invocations in a tight loop.
            clearTimeout(timerId);
            timerId = setTimeout(timerExpired, wait);
            return invokeFunc(lastCallTime);
          }
        }
        if (timerId === undefined) {
          timerId = setTimeout(timerExpired, wait);
        }
        return result;
      }
      debounced.cancel = cancel;
      debounced.flush = flush;
      return debounced;
    }

    /**
     * Defers invoking the `func` until the current call stack has cleared. Any
     * additional arguments are provided to `func` when it's invoked.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to defer.
     * @param {...*} [args] The arguments to invoke `func` with.
     * @returns {number} Returns the timer id.
     * @example
     *
     * _.defer(function(text) {
     *   console.log(text);
     * }, 'deferred');
     * // => Logs 'deferred' after one millisecond.
     */
    var defer = baseRest(function(func, args) {
      return baseDelay(func, 1, args);
    });

    /**
     * Invokes `func` after `wait` milliseconds. Any additional arguments are
     * provided to `func` when it's invoked.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to delay.
     * @param {number} wait The number of milliseconds to delay invocation.
     * @param {...*} [args] The arguments to invoke `func` with.
     * @returns {number} Returns the timer id.
     * @example
     *
     * _.delay(function(text) {
     *   console.log(text);
     * }, 1000, 'later');
     * // => Logs 'later' after one second.
     */
    var delay = baseRest(function(func, wait, args) {
      return baseDelay(func, toNumber(wait) || 0, args);
    });

    /**
     * Creates a function that invokes `func` with arguments reversed.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Function
     * @param {Function} func The function to flip arguments for.
     * @returns {Function} Returns the new flipped function.
     * @example
     *
     * var flipped = _.flip(function() {
     *   return _.toArray(arguments);
     * });
     *
     * flipped('a', 'b', 'c', 'd');
     * // => ['d', 'c', 'b', 'a']
     */
    function flip(func) {
      return createWrap(func, WRAP_FLIP_FLAG);
    }

    /**
     * Creates a function that memoizes the result of `func`. If `resolver` is
     * provided, it determines the cache key for storing the result based on the
     * arguments provided to the memoized function. By default, the first argument
     * provided to the memoized function is used as the map cache key. The `func`
     * is invoked with the `this` binding of the memoized function.
     *
     * **Note:** The cache is exposed as the `cache` property on the memoized
     * function. Its creation may be customized by replacing the `_.memoize.Cache`
     * constructor with one whose instances implement the
     * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
     * method interface of `clear`, `delete`, `get`, `has`, and `set`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to have its output memoized.
     * @param {Function} [resolver] The function to resolve the cache key.
     * @returns {Function} Returns the new memoized function.
     * @example
     *
     * var object = { 'a': 1, 'b': 2 };
     * var other = { 'c': 3, 'd': 4 };
     *
     * var values = _.memoize(_.values);
     * values(object);
     * // => [1, 2]
     *
     * values(other);
     * // => [3, 4]
     *
     * object.a = 2;
     * values(object);
     * // => [1, 2]
     *
     * // Modify the result cache.
     * values.cache.set(object, ['a', 'b']);
     * values(object);
     * // => ['a', 'b']
     *
     * // Replace `_.memoize.Cache`.
     * _.memoize.Cache = WeakMap;
     */
    function memoize(func, resolver) {
      if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      var memoized = function() {
        var args = arguments,
            key = resolver ? resolver.apply(this, args) : args[0],
            cache = memoized.cache;

        if (cache.has(key)) {
          return cache.get(key);
        }
        var result = func.apply(this, args);
        memoized.cache = cache.set(key, result) || cache;
        return result;
      };
      memoized.cache = new (memoize.Cache || MapCache);
      return memoized;
    }

    // Expose `MapCache`.
    memoize.Cache = MapCache;

    /**
     * Creates a function that negates the result of the predicate `func`. The
     * `func` predicate is invoked with the `this` binding and arguments of the
     * created function.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {Function} predicate The predicate to negate.
     * @returns {Function} Returns the new negated function.
     * @example
     *
     * function isEven(n) {
     *   return n % 2 == 0;
     * }
     *
     * _.filter([1, 2, 3, 4, 5, 6], _.negate(isEven));
     * // => [1, 3, 5]
     */
    function negate(predicate) {
      if (typeof predicate != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      return function() {
        var args = arguments;
        switch (args.length) {
          case 0: return !predicate.call(this);
          case 1: return !predicate.call(this, args[0]);
          case 2: return !predicate.call(this, args[0], args[1]);
          case 3: return !predicate.call(this, args[0], args[1], args[2]);
        }
        return !predicate.apply(this, args);
      };
    }

    /**
     * Creates a function that is restricted to invoking `func` once. Repeat calls
     * to the function return the value of the first invocation. The `func` is
     * invoked with the `this` binding and arguments of the created function.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to restrict.
     * @returns {Function} Returns the new restricted function.
     * @example
     *
     * var initialize = _.once(createApplication);
     * initialize();
     * initialize();
     * // => `createApplication` is invoked once
     */
    function once(func) {
      return before(2, func);
    }

    /**
     * Creates a function that invokes `func` with its arguments transformed.
     *
     * @static
     * @since 4.0.0
     * @memberOf _
     * @category Function
     * @param {Function} func The function to wrap.
     * @param {...(Function|Function[])} [transforms=[_.identity]]
     *  The argument transforms.
     * @returns {Function} Returns the new function.
     * @example
     *
     * function doubled(n) {
     *   return n * 2;
     * }
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var func = _.overArgs(function(x, y) {
     *   return [x, y];
     * }, [square, doubled]);
     *
     * func(9, 3);
     * // => [81, 6]
     *
     * func(10, 5);
     * // => [100, 10]
     */
    var overArgs = castRest(function(func, transforms) {
      transforms = (transforms.length == 1 && isArray(transforms[0]))
        ? arrayMap(transforms[0], baseUnary(getIteratee()))
        : arrayMap(baseFlatten(transforms, 1), baseUnary(getIteratee()));

      var funcsLength = transforms.length;
      return baseRest(function(args) {
        var index = -1,
            length = nativeMin(args.length, funcsLength);

        while (++index < length) {
          args[index] = transforms[index].call(this, args[index]);
        }
        return apply(func, this, args);
      });
    });

    /**
     * Creates a function that invokes `func` with `partials` prepended to the
     * arguments it receives. This method is like `_.bind` except it does **not**
     * alter the `this` binding.
     *
     * The `_.partial.placeholder` value, which defaults to `_` in monolithic
     * builds, may be used as a placeholder for partially applied arguments.
     *
     * **Note:** This method doesn't set the "length" property of partially
     * applied functions.
     *
     * @static
     * @memberOf _
     * @since 0.2.0
     * @category Function
     * @param {Function} func The function to partially apply arguments to.
     * @param {...*} [partials] The arguments to be partially applied.
     * @returns {Function} Returns the new partially applied function.
     * @example
     *
     * function greet(greeting, name) {
     *   return greeting + ' ' + name;
     * }
     *
     * var sayHelloTo = _.partial(greet, 'hello');
     * sayHelloTo('fred');
     * // => 'hello fred'
     *
     * // Partially applied with placeholders.
     * var greetFred = _.partial(greet, _, 'fred');
     * greetFred('hi');
     * // => 'hi fred'
     */
    var partial = baseRest(function(func, partials) {
      var holders = replaceHolders(partials, getHolder(partial));
      return createWrap(func, WRAP_PARTIAL_FLAG, undefined, partials, holders);
    });

    /**
     * This method is like `_.partial` except that partially applied arguments
     * are appended to the arguments it receives.
     *
     * The `_.partialRight.placeholder` value, which defaults to `_` in monolithic
     * builds, may be used as a placeholder for partially applied arguments.
     *
     * **Note:** This method doesn't set the "length" property of partially
     * applied functions.
     *
     * @static
     * @memberOf _
     * @since 1.0.0
     * @category Function
     * @param {Function} func The function to partially apply arguments to.
     * @param {...*} [partials] The arguments to be partially applied.
     * @returns {Function} Returns the new partially applied function.
     * @example
     *
     * function greet(greeting, name) {
     *   return greeting + ' ' + name;
     * }
     *
     * var greetFred = _.partialRight(greet, 'fred');
     * greetFred('hi');
     * // => 'hi fred'
     *
     * // Partially applied with placeholders.
     * var sayHelloTo = _.partialRight(greet, 'hello', _);
     * sayHelloTo('fred');
     * // => 'hello fred'
     */
    var partialRight = baseRest(function(func, partials) {
      var holders = replaceHolders(partials, getHolder(partialRight));
      return createWrap(func, WRAP_PARTIAL_RIGHT_FLAG, undefined, partials, holders);
    });

    /**
     * Creates a function that invokes `func` with arguments arranged according
     * to the specified `indexes` where the argument value at the first index is
     * provided as the first argument, the argument value at the second index is
     * provided as the second argument, and so on.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Function
     * @param {Function} func The function to rearrange arguments for.
     * @param {...(number|number[])} indexes The arranged argument indexes.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var rearged = _.rearg(function(a, b, c) {
     *   return [a, b, c];
     * }, [2, 0, 1]);
     *
     * rearged('b', 'c', 'a')
     * // => ['a', 'b', 'c']
     */
    var rearg = flatRest(function(func, indexes) {
      return createWrap(func, WRAP_REARG_FLAG, undefined, undefined, undefined, indexes);
    });

    /**
     * Creates a function that invokes `func` with the `this` binding of the
     * created function and arguments from `start` and beyond provided as
     * an array.
     *
     * **Note:** This method is based on the
     * [rest parameter](https://mdn.io/rest_parameters).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Function
     * @param {Function} func The function to apply a rest parameter to.
     * @param {number} [start=func.length-1] The start position of the rest parameter.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var say = _.rest(function(what, names) {
     *   return what + ' ' + _.initial(names).join(', ') +
     *     (_.size(names) > 1 ? ', & ' : '') + _.last(names);
     * });
     *
     * say('hello', 'fred', 'barney', 'pebbles');
     * // => 'hello fred, barney, & pebbles'
     */
    function rest(func, start) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      start = start === undefined ? start : toInteger(start);
      return baseRest(func, start);
    }

    /**
     * Creates a function that invokes `func` with the `this` binding of the
     * create function and an array of arguments much like
     * [`Function#apply`](http://www.ecma-international.org/ecma-262/7.0/#sec-function.prototype.apply).
     *
     * **Note:** This method is based on the
     * [spread operator](https://mdn.io/spread_operator).
     *
     * @static
     * @memberOf _
     * @since 3.2.0
     * @category Function
     * @param {Function} func The function to spread arguments over.
     * @param {number} [start=0] The start position of the spread.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var say = _.spread(function(who, what) {
     *   return who + ' says ' + what;
     * });
     *
     * say(['fred', 'hello']);
     * // => 'fred says hello'
     *
     * var numbers = Promise.all([
     *   Promise.resolve(40),
     *   Promise.resolve(36)
     * ]);
     *
     * numbers.then(_.spread(function(x, y) {
     *   return x + y;
     * }));
     * // => a Promise of 76
     */
    function spread(func, start) {
      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      start = start == null ? 0 : nativeMax(toInteger(start), 0);
      return baseRest(function(args) {
        var array = args[start],
            otherArgs = castSlice(args, 0, start);

        if (array) {
          arrayPush(otherArgs, array);
        }
        return apply(func, this, otherArgs);
      });
    }

    /**
     * Creates a throttled function that only invokes `func` at most once per
     * every `wait` milliseconds. The throttled function comes with a `cancel`
     * method to cancel delayed `func` invocations and a `flush` method to
     * immediately invoke them. Provide `options` to indicate whether `func`
     * should be invoked on the leading and/or trailing edge of the `wait`
     * timeout. The `func` is invoked with the last arguments provided to the
     * throttled function. Subsequent calls to the throttled function return the
     * result of the last `func` invocation.
     *
     * **Note:** If `leading` and `trailing` options are `true`, `func` is
     * invoked on the trailing edge of the timeout only if the throttled function
     * is invoked more than once during the `wait` timeout.
     *
     * If `wait` is `0` and `leading` is `false`, `func` invocation is deferred
     * until to the next tick, similar to `setTimeout` with a timeout of `0`.
     *
     * See [David Corbacho's article](https://css-tricks.com/debouncing-throttling-explained-examples/)
     * for details over the differences between `_.throttle` and `_.debounce`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {Function} func The function to throttle.
     * @param {number} [wait=0] The number of milliseconds to throttle invocations to.
     * @param {Object} [options={}] The options object.
     * @param {boolean} [options.leading=true]
     *  Specify invoking on the leading edge of the timeout.
     * @param {boolean} [options.trailing=true]
     *  Specify invoking on the trailing edge of the timeout.
     * @returns {Function} Returns the new throttled function.
     * @example
     *
     * // Avoid excessively updating the position while scrolling.
     * jQuery(window).on('scroll', _.throttle(updatePosition, 100));
     *
     * // Invoke `renewToken` when the click event is fired, but not more than once every 5 minutes.
     * var throttled = _.throttle(renewToken, 300000, { 'trailing': false });
     * jQuery(element).on('click', throttled);
     *
     * // Cancel the trailing throttled invocation.
     * jQuery(window).on('popstate', throttled.cancel);
     */
    function throttle(func, wait, options) {
      var leading = true,
          trailing = true;

      if (typeof func != 'function') {
        throw new TypeError(FUNC_ERROR_TEXT);
      }
      if (isObject(options)) {
        leading = 'leading' in options ? !!options.leading : leading;
        trailing = 'trailing' in options ? !!options.trailing : trailing;
      }
      return debounce(func, wait, {
        'leading': leading,
        'maxWait': wait,
        'trailing': trailing
      });
    }

    /**
     * Creates a function that accepts up to one argument, ignoring any
     * additional arguments.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Function
     * @param {Function} func The function to cap arguments for.
     * @returns {Function} Returns the new capped function.
     * @example
     *
     * _.map(['6', '8', '10'], _.unary(parseInt));
     * // => [6, 8, 10]
     */
    function unary(func) {
      return ary(func, 1);
    }

    /**
     * Creates a function that provides `value` to `wrapper` as its first
     * argument. Any additional arguments provided to the function are appended
     * to those provided to the `wrapper`. The wrapper is invoked with the `this`
     * binding of the created function.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Function
     * @param {*} value The value to wrap.
     * @param {Function} [wrapper=identity] The wrapper function.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var p = _.wrap(_.escape, function(func, text) {
     *   return '<p>' + func(text) + '</p>';
     * });
     *
     * p('fred, barney, & pebbles');
     * // => '<p>fred, barney, &amp; pebbles</p>'
     */
    function wrap(value, wrapper) {
      return partial(castFunction(wrapper), value);
    }

    /*------------------------------------------------------------------------*/

    /**
     * Casts `value` as an array if it's not one.
     *
     * @static
     * @memberOf _
     * @since 4.4.0
     * @category Lang
     * @param {*} value The value to inspect.
     * @returns {Array} Returns the cast array.
     * @example
     *
     * _.castArray(1);
     * // => [1]
     *
     * _.castArray({ 'a': 1 });
     * // => [{ 'a': 1 }]
     *
     * _.castArray('abc');
     * // => ['abc']
     *
     * _.castArray(null);
     * // => [null]
     *
     * _.castArray(undefined);
     * // => [undefined]
     *
     * _.castArray();
     * // => []
     *
     * var array = [1, 2, 3];
     * console.log(_.castArray(array) === array);
     * // => true
     */
    function castArray() {
      if (!arguments.length) {
        return [];
      }
      var value = arguments[0];
      return isArray(value) ? value : [value];
    }

    /**
     * Creates a shallow clone of `value`.
     *
     * **Note:** This method is loosely based on the
     * [structured clone algorithm](https://mdn.io/Structured_clone_algorithm)
     * and supports cloning arrays, array buffers, booleans, date objects, maps,
     * numbers, `Object` objects, regexes, sets, strings, symbols, and typed
     * arrays. The own enumerable properties of `arguments` objects are cloned
     * as plain objects. An empty object is returned for uncloneable values such
     * as error objects, functions, DOM nodes, and WeakMaps.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to clone.
     * @returns {*} Returns the cloned value.
     * @see _.cloneDeep
     * @example
     *
     * var objects = [{ 'a': 1 }, { 'b': 2 }];
     *
     * var shallow = _.clone(objects);
     * console.log(shallow[0] === objects[0]);
     * // => true
     */
    function clone(value) {
      return baseClone(value, CLONE_SYMBOLS_FLAG);
    }

    /**
     * This method is like `_.clone` except that it accepts `customizer` which
     * is invoked to produce the cloned value. If `customizer` returns `undefined`,
     * cloning is handled by the method instead. The `customizer` is invoked with
     * up to four arguments; (value [, index|key, object, stack]).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to clone.
     * @param {Function} [customizer] The function to customize cloning.
     * @returns {*} Returns the cloned value.
     * @see _.cloneDeepWith
     * @example
     *
     * function customizer(value) {
     *   if (_.isElement(value)) {
     *     return value.cloneNode(false);
     *   }
     * }
     *
     * var el = _.cloneWith(document.body, customizer);
     *
     * console.log(el === document.body);
     * // => false
     * console.log(el.nodeName);
     * // => 'BODY'
     * console.log(el.childNodes.length);
     * // => 0
     */
    function cloneWith(value, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return baseClone(value, CLONE_SYMBOLS_FLAG, customizer);
    }

    /**
     * This method is like `_.clone` except that it recursively clones `value`.
     *
     * @static
     * @memberOf _
     * @since 1.0.0
     * @category Lang
     * @param {*} value The value to recursively clone.
     * @returns {*} Returns the deep cloned value.
     * @see _.clone
     * @example
     *
     * var objects = [{ 'a': 1 }, { 'b': 2 }];
     *
     * var deep = _.cloneDeep(objects);
     * console.log(deep[0] === objects[0]);
     * // => false
     */
    function cloneDeep(value) {
      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG);
    }

    /**
     * This method is like `_.cloneWith` except that it recursively clones `value`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to recursively clone.
     * @param {Function} [customizer] The function to customize cloning.
     * @returns {*} Returns the deep cloned value.
     * @see _.cloneWith
     * @example
     *
     * function customizer(value) {
     *   if (_.isElement(value)) {
     *     return value.cloneNode(true);
     *   }
     * }
     *
     * var el = _.cloneDeepWith(document.body, customizer);
     *
     * console.log(el === document.body);
     * // => false
     * console.log(el.nodeName);
     * // => 'BODY'
     * console.log(el.childNodes.length);
     * // => 20
     */
    function cloneDeepWith(value, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return baseClone(value, CLONE_DEEP_FLAG | CLONE_SYMBOLS_FLAG, customizer);
    }

    /**
     * Checks if `object` conforms to `source` by invoking the predicate
     * properties of `source` with the corresponding property values of `object`.
     *
     * **Note:** This method is equivalent to `_.conforms` when `source` is
     * partially applied.
     *
     * @static
     * @memberOf _
     * @since 4.14.0
     * @category Lang
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property predicates to conform to.
     * @returns {boolean} Returns `true` if `object` conforms, else `false`.
     * @example
     *
     * var object = { 'a': 1, 'b': 2 };
     *
     * _.conformsTo(object, { 'b': function(n) { return n > 1; } });
     * // => true
     *
     * _.conformsTo(object, { 'b': function(n) { return n > 2; } });
     * // => false
     */
    function conformsTo(object, source) {
      return source == null || baseConformsTo(object, source, keys(source));
    }

    /**
     * Performs a
     * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
     * comparison between two values to determine if they are equivalent.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     * @example
     *
     * var object = { 'a': 1 };
     * var other = { 'a': 1 };
     *
     * _.eq(object, object);
     * // => true
     *
     * _.eq(object, other);
     * // => false
     *
     * _.eq('a', 'a');
     * // => true
     *
     * _.eq('a', Object('a'));
     * // => false
     *
     * _.eq(NaN, NaN);
     * // => true
     */
    function eq(value, other) {
      return value === other || (value !== value && other !== other);
    }

    /**
     * Checks if `value` is greater than `other`.
     *
     * @static
     * @memberOf _
     * @since 3.9.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is greater than `other`,
     *  else `false`.
     * @see _.lt
     * @example
     *
     * _.gt(3, 1);
     * // => true
     *
     * _.gt(3, 3);
     * // => false
     *
     * _.gt(1, 3);
     * // => false
     */
    var gt = createRelationalOperation(baseGt);

    /**
     * Checks if `value` is greater than or equal to `other`.
     *
     * @static
     * @memberOf _
     * @since 3.9.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is greater than or equal to
     *  `other`, else `false`.
     * @see _.lte
     * @example
     *
     * _.gte(3, 1);
     * // => true
     *
     * _.gte(3, 3);
     * // => true
     *
     * _.gte(1, 3);
     * // => false
     */
    var gte = createRelationalOperation(function(value, other) {
      return value >= other;
    });

    /**
     * Checks if `value` is likely an `arguments` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an `arguments` object,
     *  else `false`.
     * @example
     *
     * _.isArguments(function() { return arguments; }());
     * // => true
     *
     * _.isArguments([1, 2, 3]);
     * // => false
     */
    var isArguments = baseIsArguments(function() { return arguments; }()) ? baseIsArguments : function(value) {
      return isObjectLike(value) && hasOwnProperty.call(value, 'callee') &&
        !propertyIsEnumerable.call(value, 'callee');
    };

    /**
     * Checks if `value` is classified as an `Array` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array, else `false`.
     * @example
     *
     * _.isArray([1, 2, 3]);
     * // => true
     *
     * _.isArray(document.body.children);
     * // => false
     *
     * _.isArray('abc');
     * // => false
     *
     * _.isArray(_.noop);
     * // => false
     */
    var isArray = Array.isArray;

    /**
     * Checks if `value` is classified as an `ArrayBuffer` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array buffer, else `false`.
     * @example
     *
     * _.isArrayBuffer(new ArrayBuffer(2));
     * // => true
     *
     * _.isArrayBuffer(new Array(2));
     * // => false
     */
    var isArrayBuffer = nodeIsArrayBuffer ? baseUnary(nodeIsArrayBuffer) : baseIsArrayBuffer;

    /**
     * Checks if `value` is array-like. A value is considered array-like if it's
     * not a function and has a `value.length` that's an integer greater than or
     * equal to `0` and less than or equal to `Number.MAX_SAFE_INTEGER`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is array-like, else `false`.
     * @example
     *
     * _.isArrayLike([1, 2, 3]);
     * // => true
     *
     * _.isArrayLike(document.body.children);
     * // => true
     *
     * _.isArrayLike('abc');
     * // => true
     *
     * _.isArrayLike(_.noop);
     * // => false
     */
    function isArrayLike(value) {
      return value != null && isLength(value.length) && !isFunction(value);
    }

    /**
     * This method is like `_.isArrayLike` except that it also checks if `value`
     * is an object.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an array-like object,
     *  else `false`.
     * @example
     *
     * _.isArrayLikeObject([1, 2, 3]);
     * // => true
     *
     * _.isArrayLikeObject(document.body.children);
     * // => true
     *
     * _.isArrayLikeObject('abc');
     * // => false
     *
     * _.isArrayLikeObject(_.noop);
     * // => false
     */
    function isArrayLikeObject(value) {
      return isObjectLike(value) && isArrayLike(value);
    }

    /**
     * Checks if `value` is classified as a boolean primitive or object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a boolean, else `false`.
     * @example
     *
     * _.isBoolean(false);
     * // => true
     *
     * _.isBoolean(null);
     * // => false
     */
    function isBoolean(value) {
      return value === true || value === false ||
        (isObjectLike(value) && baseGetTag(value) == boolTag);
    }

    /**
     * Checks if `value` is a buffer.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a buffer, else `false`.
     * @example
     *
     * _.isBuffer(new Buffer(2));
     * // => true
     *
     * _.isBuffer(new Uint8Array(2));
     * // => false
     */
    var isBuffer = nativeIsBuffer || stubFalse;

    /**
     * Checks if `value` is classified as a `Date` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a date object, else `false`.
     * @example
     *
     * _.isDate(new Date);
     * // => true
     *
     * _.isDate('Mon April 23 2012');
     * // => false
     */
    var isDate = nodeIsDate ? baseUnary(nodeIsDate) : baseIsDate;

    /**
     * Checks if `value` is likely a DOM element.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a DOM element, else `false`.
     * @example
     *
     * _.isElement(document.body);
     * // => true
     *
     * _.isElement('<body>');
     * // => false
     */
    function isElement(value) {
      return isObjectLike(value) && value.nodeType === 1 && !isPlainObject(value);
    }

    /**
     * Checks if `value` is an empty object, collection, map, or set.
     *
     * Objects are considered empty if they have no own enumerable string keyed
     * properties.
     *
     * Array-like values such as `arguments` objects, arrays, buffers, strings, or
     * jQuery-like collections are considered empty if they have a `length` of `0`.
     * Similarly, maps and sets are considered empty if they have a `size` of `0`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is empty, else `false`.
     * @example
     *
     * _.isEmpty(null);
     * // => true
     *
     * _.isEmpty(true);
     * // => true
     *
     * _.isEmpty(1);
     * // => true
     *
     * _.isEmpty([1, 2, 3]);
     * // => false
     *
     * _.isEmpty({ 'a': 1 });
     * // => false
     */
    function isEmpty(value) {
      if (value == null) {
        return true;
      }
      if (isArrayLike(value) &&
          (isArray(value) || typeof value == 'string' || typeof value.splice == 'function' ||
            isBuffer(value) || isTypedArray(value) || isArguments(value))) {
        return !value.length;
      }
      var tag = getTag(value);
      if (tag == mapTag || tag == setTag) {
        return !value.size;
      }
      if (isPrototype(value)) {
        return !baseKeys(value).length;
      }
      for (var key in value) {
        if (hasOwnProperty.call(value, key)) {
          return false;
        }
      }
      return true;
    }

    /**
     * Performs a deep comparison between two values to determine if they are
     * equivalent.
     *
     * **Note:** This method supports comparing arrays, array buffers, booleans,
     * date objects, error objects, maps, numbers, `Object` objects, regexes,
     * sets, strings, symbols, and typed arrays. `Object` objects are compared
     * by their own, not inherited, enumerable properties. Functions and DOM
     * nodes are compared by strict equality, i.e. `===`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     * @example
     *
     * var object = { 'a': 1 };
     * var other = { 'a': 1 };
     *
     * _.isEqual(object, other);
     * // => true
     *
     * object === other;
     * // => false
     */
    function isEqual(value, other) {
      return baseIsEqual(value, other);
    }

    /**
     * This method is like `_.isEqual` except that it accepts `customizer` which
     * is invoked to compare values. If `customizer` returns `undefined`, comparisons
     * are handled by the method instead. The `customizer` is invoked with up to
     * six arguments: (objValue, othValue [, index|key, object, other, stack]).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @param {Function} [customizer] The function to customize comparisons.
     * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
     * @example
     *
     * function isGreeting(value) {
     *   return /^h(?:i|ello)$/.test(value);
     * }
     *
     * function customizer(objValue, othValue) {
     *   if (isGreeting(objValue) && isGreeting(othValue)) {
     *     return true;
     *   }
     * }
     *
     * var array = ['hello', 'goodbye'];
     * var other = ['hi', 'goodbye'];
     *
     * _.isEqualWith(array, other, customizer);
     * // => true
     */
    function isEqualWith(value, other, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      var result = customizer ? customizer(value, other) : undefined;
      return result === undefined ? baseIsEqual(value, other, undefined, customizer) : !!result;
    }

    /**
     * Checks if `value` is an `Error`, `EvalError`, `RangeError`, `ReferenceError`,
     * `SyntaxError`, `TypeError`, or `URIError` object.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an error object, else `false`.
     * @example
     *
     * _.isError(new Error);
     * // => true
     *
     * _.isError(Error);
     * // => false
     */
    function isError(value) {
      if (!isObjectLike(value)) {
        return false;
      }
      var tag = baseGetTag(value);
      return tag == errorTag || tag == domExcTag ||
        (typeof value.message == 'string' && typeof value.name == 'string' && !isPlainObject(value));
    }

    /**
     * Checks if `value` is a finite primitive number.
     *
     * **Note:** This method is based on
     * [`Number.isFinite`](https://mdn.io/Number/isFinite).
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a finite number, else `false`.
     * @example
     *
     * _.isFinite(3);
     * // => true
     *
     * _.isFinite(Number.MIN_VALUE);
     * // => true
     *
     * _.isFinite(Infinity);
     * // => false
     *
     * _.isFinite('3');
     * // => false
     */
    function isFinite(value) {
      return typeof value == 'number' && nativeIsFinite(value);
    }

    /**
     * Checks if `value` is classified as a `Function` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a function, else `false`.
     * @example
     *
     * _.isFunction(_);
     * // => true
     *
     * _.isFunction(/abc/);
     * // => false
     */
    function isFunction(value) {
      if (!isObject(value)) {
        return false;
      }
      // The use of `Object#toString` avoids issues with the `typeof` operator
      // in Safari 9 which returns 'object' for typed arrays and other constructors.
      var tag = baseGetTag(value);
      return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
    }

    /**
     * Checks if `value` is an integer.
     *
     * **Note:** This method is based on
     * [`Number.isInteger`](https://mdn.io/Number/isInteger).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an integer, else `false`.
     * @example
     *
     * _.isInteger(3);
     * // => true
     *
     * _.isInteger(Number.MIN_VALUE);
     * // => false
     *
     * _.isInteger(Infinity);
     * // => false
     *
     * _.isInteger('3');
     * // => false
     */
    function isInteger(value) {
      return typeof value == 'number' && value == toInteger(value);
    }

    /**
     * Checks if `value` is a valid array-like length.
     *
     * **Note:** This method is loosely based on
     * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a valid length, else `false`.
     * @example
     *
     * _.isLength(3);
     * // => true
     *
     * _.isLength(Number.MIN_VALUE);
     * // => false
     *
     * _.isLength(Infinity);
     * // => false
     *
     * _.isLength('3');
     * // => false
     */
    function isLength(value) {
      return typeof value == 'number' &&
        value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
    }

    /**
     * Checks if `value` is the
     * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
     * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is an object, else `false`.
     * @example
     *
     * _.isObject({});
     * // => true
     *
     * _.isObject([1, 2, 3]);
     * // => true
     *
     * _.isObject(_.noop);
     * // => true
     *
     * _.isObject(null);
     * // => false
     */
    function isObject(value) {
      var type = typeof value;
      return value != null && (type == 'object' || type == 'function');
    }

    /**
     * Checks if `value` is object-like. A value is object-like if it's not `null`
     * and has a `typeof` result of "object".
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
     * @example
     *
     * _.isObjectLike({});
     * // => true
     *
     * _.isObjectLike([1, 2, 3]);
     * // => true
     *
     * _.isObjectLike(_.noop);
     * // => false
     *
     * _.isObjectLike(null);
     * // => false
     */
    function isObjectLike(value) {
      return value != null && typeof value == 'object';
    }

    /**
     * Checks if `value` is classified as a `Map` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a map, else `false`.
     * @example
     *
     * _.isMap(new Map);
     * // => true
     *
     * _.isMap(new WeakMap);
     * // => false
     */
    var isMap = nodeIsMap ? baseUnary(nodeIsMap) : baseIsMap;

    /**
     * Performs a partial deep comparison between `object` and `source` to
     * determine if `object` contains equivalent property values.
     *
     * **Note:** This method is equivalent to `_.matches` when `source` is
     * partially applied.
     *
     * Partial comparisons will match empty array and empty object `source`
     * values against any array or object value, respectively. See `_.isEqual`
     * for a list of supported value comparisons.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property values to match.
     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
     * @example
     *
     * var object = { 'a': 1, 'b': 2 };
     *
     * _.isMatch(object, { 'b': 2 });
     * // => true
     *
     * _.isMatch(object, { 'b': 1 });
     * // => false
     */
    function isMatch(object, source) {
      return object === source || baseIsMatch(object, source, getMatchData(source));
    }

    /**
     * This method is like `_.isMatch` except that it accepts `customizer` which
     * is invoked to compare values. If `customizer` returns `undefined`, comparisons
     * are handled by the method instead. The `customizer` is invoked with five
     * arguments: (objValue, srcValue, index|key, object, source).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {Object} object The object to inspect.
     * @param {Object} source The object of property values to match.
     * @param {Function} [customizer] The function to customize comparisons.
     * @returns {boolean} Returns `true` if `object` is a match, else `false`.
     * @example
     *
     * function isGreeting(value) {
     *   return /^h(?:i|ello)$/.test(value);
     * }
     *
     * function customizer(objValue, srcValue) {
     *   if (isGreeting(objValue) && isGreeting(srcValue)) {
     *     return true;
     *   }
     * }
     *
     * var object = { 'greeting': 'hello' };
     * var source = { 'greeting': 'hi' };
     *
     * _.isMatchWith(object, source, customizer);
     * // => true
     */
    function isMatchWith(object, source, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return baseIsMatch(object, source, getMatchData(source), customizer);
    }

    /**
     * Checks if `value` is `NaN`.
     *
     * **Note:** This method is based on
     * [`Number.isNaN`](https://mdn.io/Number/isNaN) and is not the same as
     * global [`isNaN`](https://mdn.io/isNaN) which returns `true` for
     * `undefined` and other non-number values.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is `NaN`, else `false`.
     * @example
     *
     * _.isNaN(NaN);
     * // => true
     *
     * _.isNaN(new Number(NaN));
     * // => true
     *
     * isNaN(undefined);
     * // => true
     *
     * _.isNaN(undefined);
     * // => false
     */
    function isNaN(value) {
      // An `NaN` primitive is the only value that is not equal to itself.
      // Perform the `toStringTag` check first to avoid errors with some
      // ActiveX objects in IE.
      return isNumber(value) && value != +value;
    }

    /**
     * Checks if `value` is a pristine native function.
     *
     * **Note:** This method can't reliably detect native functions in the presence
     * of the core-js package because core-js circumvents this kind of detection.
     * Despite multiple requests, the core-js maintainer has made it clear: any
     * attempt to fix the detection will be obstructed. As a result, we're left
     * with little choice but to throw an error. Unfortunately, this also affects
     * packages, like [babel-polyfill](https://www.npmjs.com/package/babel-polyfill),
     * which rely on core-js.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a native function,
     *  else `false`.
     * @example
     *
     * _.isNative(Array.prototype.push);
     * // => true
     *
     * _.isNative(_);
     * // => false
     */
    function isNative(value) {
      if (isMaskable(value)) {
        throw new Error(CORE_ERROR_TEXT);
      }
      return baseIsNative(value);
    }

    /**
     * Checks if `value` is `null`.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is `null`, else `false`.
     * @example
     *
     * _.isNull(null);
     * // => true
     *
     * _.isNull(void 0);
     * // => false
     */
    function isNull(value) {
      return value === null;
    }

    /**
     * Checks if `value` is `null` or `undefined`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is nullish, else `false`.
     * @example
     *
     * _.isNil(null);
     * // => true
     *
     * _.isNil(void 0);
     * // => true
     *
     * _.isNil(NaN);
     * // => false
     */
    function isNil(value) {
      return value == null;
    }

    /**
     * Checks if `value` is classified as a `Number` primitive or object.
     *
     * **Note:** To exclude `Infinity`, `-Infinity`, and `NaN`, which are
     * classified as numbers, use the `_.isFinite` method.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a number, else `false`.
     * @example
     *
     * _.isNumber(3);
     * // => true
     *
     * _.isNumber(Number.MIN_VALUE);
     * // => true
     *
     * _.isNumber(Infinity);
     * // => true
     *
     * _.isNumber('3');
     * // => false
     */
    function isNumber(value) {
      return typeof value == 'number' ||
        (isObjectLike(value) && baseGetTag(value) == numberTag);
    }

    /**
     * Checks if `value` is a plain object, that is, an object created by the
     * `Object` constructor or one with a `[[Prototype]]` of `null`.
     *
     * @static
     * @memberOf _
     * @since 0.8.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a plain object, else `false`.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     * }
     *
     * _.isPlainObject(new Foo);
     * // => false
     *
     * _.isPlainObject([1, 2, 3]);
     * // => false
     *
     * _.isPlainObject({ 'x': 0, 'y': 0 });
     * // => true
     *
     * _.isPlainObject(Object.create(null));
     * // => true
     */
    function isPlainObject(value) {
      if (!isObjectLike(value) || baseGetTag(value) != objectTag) {
        return false;
      }
      var proto = getPrototype(value);
      if (proto === null) {
        return true;
      }
      var Ctor = hasOwnProperty.call(proto, 'constructor') && proto.constructor;
      return typeof Ctor == 'function' && Ctor instanceof Ctor &&
        funcToString.call(Ctor) == objectCtorString;
    }

    /**
     * Checks if `value` is classified as a `RegExp` object.
     *
     * @static
     * @memberOf _
     * @since 0.1.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a regexp, else `false`.
     * @example
     *
     * _.isRegExp(/abc/);
     * // => true
     *
     * _.isRegExp('/abc/');
     * // => false
     */
    var isRegExp = nodeIsRegExp ? baseUnary(nodeIsRegExp) : baseIsRegExp;

    /**
     * Checks if `value` is a safe integer. An integer is safe if it's an IEEE-754
     * double precision number which isn't the result of a rounded unsafe integer.
     *
     * **Note:** This method is based on
     * [`Number.isSafeInteger`](https://mdn.io/Number/isSafeInteger).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a safe integer, else `false`.
     * @example
     *
     * _.isSafeInteger(3);
     * // => true
     *
     * _.isSafeInteger(Number.MIN_VALUE);
     * // => false
     *
     * _.isSafeInteger(Infinity);
     * // => false
     *
     * _.isSafeInteger('3');
     * // => false
     */
    function isSafeInteger(value) {
      return isInteger(value) && value >= -MAX_SAFE_INTEGER && value <= MAX_SAFE_INTEGER;
    }

    /**
     * Checks if `value` is classified as a `Set` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a set, else `false`.
     * @example
     *
     * _.isSet(new Set);
     * // => true
     *
     * _.isSet(new WeakSet);
     * // => false
     */
    var isSet = nodeIsSet ? baseUnary(nodeIsSet) : baseIsSet;

    /**
     * Checks if `value` is classified as a `String` primitive or object.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a string, else `false`.
     * @example
     *
     * _.isString('abc');
     * // => true
     *
     * _.isString(1);
     * // => false
     */
    function isString(value) {
      return typeof value == 'string' ||
        (!isArray(value) && isObjectLike(value) && baseGetTag(value) == stringTag);
    }

    /**
     * Checks if `value` is classified as a `Symbol` primitive or object.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
     * @example
     *
     * _.isSymbol(Symbol.iterator);
     * // => true
     *
     * _.isSymbol('abc');
     * // => false
     */
    function isSymbol(value) {
      return typeof value == 'symbol' ||
        (isObjectLike(value) && baseGetTag(value) == symbolTag);
    }

    /**
     * Checks if `value` is classified as a typed array.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a typed array, else `false`.
     * @example
     *
     * _.isTypedArray(new Uint8Array);
     * // => true
     *
     * _.isTypedArray([]);
     * // => false
     */
    var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;

    /**
     * Checks if `value` is `undefined`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is `undefined`, else `false`.
     * @example
     *
     * _.isUndefined(void 0);
     * // => true
     *
     * _.isUndefined(null);
     * // => false
     */
    function isUndefined(value) {
      return value === undefined;
    }

    /**
     * Checks if `value` is classified as a `WeakMap` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a weak map, else `false`.
     * @example
     *
     * _.isWeakMap(new WeakMap);
     * // => true
     *
     * _.isWeakMap(new Map);
     * // => false
     */
    function isWeakMap(value) {
      return isObjectLike(value) && getTag(value) == weakMapTag;
    }

    /**
     * Checks if `value` is classified as a `WeakSet` object.
     *
     * @static
     * @memberOf _
     * @since 4.3.0
     * @category Lang
     * @param {*} value The value to check.
     * @returns {boolean} Returns `true` if `value` is a weak set, else `false`.
     * @example
     *
     * _.isWeakSet(new WeakSet);
     * // => true
     *
     * _.isWeakSet(new Set);
     * // => false
     */
    function isWeakSet(value) {
      return isObjectLike(value) && baseGetTag(value) == weakSetTag;
    }

    /**
     * Checks if `value` is less than `other`.
     *
     * @static
     * @memberOf _
     * @since 3.9.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is less than `other`,
     *  else `false`.
     * @see _.gt
     * @example
     *
     * _.lt(1, 3);
     * // => true
     *
     * _.lt(3, 3);
     * // => false
     *
     * _.lt(3, 1);
     * // => false
     */
    var lt = createRelationalOperation(baseLt);

    /**
     * Checks if `value` is less than or equal to `other`.
     *
     * @static
     * @memberOf _
     * @since 3.9.0
     * @category Lang
     * @param {*} value The value to compare.
     * @param {*} other The other value to compare.
     * @returns {boolean} Returns `true` if `value` is less than or equal to
     *  `other`, else `false`.
     * @see _.gte
     * @example
     *
     * _.lte(1, 3);
     * // => true
     *
     * _.lte(3, 3);
     * // => true
     *
     * _.lte(3, 1);
     * // => false
     */
    var lte = createRelationalOperation(function(value, other) {
      return value <= other;
    });

    /**
     * Converts `value` to an array.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {Array} Returns the converted array.
     * @example
     *
     * _.toArray({ 'a': 1, 'b': 2 });
     * // => [1, 2]
     *
     * _.toArray('abc');
     * // => ['a', 'b', 'c']
     *
     * _.toArray(1);
     * // => []
     *
     * _.toArray(null);
     * // => []
     */
    function toArray(value) {
      if (!value) {
        return [];
      }
      if (isArrayLike(value)) {
        return isString(value) ? stringToArray(value) : copyArray(value);
      }
      if (symIterator && value[symIterator]) {
        return iteratorToArray(value[symIterator]());
      }
      var tag = getTag(value),
          func = tag == mapTag ? mapToArray : (tag == setTag ? setToArray : values);

      return func(value);
    }

    /**
     * Converts `value` to a finite number.
     *
     * @static
     * @memberOf _
     * @since 4.12.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted number.
     * @example
     *
     * _.toFinite(3.2);
     * // => 3.2
     *
     * _.toFinite(Number.MIN_VALUE);
     * // => 5e-324
     *
     * _.toFinite(Infinity);
     * // => 1.7976931348623157e+308
     *
     * _.toFinite('3.2');
     * // => 3.2
     */
    function toFinite(value) {
      if (!value) {
        return value === 0 ? value : 0;
      }
      value = toNumber(value);
      if (value === INFINITY || value === -INFINITY) {
        var sign = (value < 0 ? -1 : 1);
        return sign * MAX_INTEGER;
      }
      return value === value ? value : 0;
    }

    /**
     * Converts `value` to an integer.
     *
     * **Note:** This method is loosely based on
     * [`ToInteger`](http://www.ecma-international.org/ecma-262/7.0/#sec-tointeger).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.toInteger(3.2);
     * // => 3
     *
     * _.toInteger(Number.MIN_VALUE);
     * // => 0
     *
     * _.toInteger(Infinity);
     * // => 1.7976931348623157e+308
     *
     * _.toInteger('3.2');
     * // => 3
     */
    function toInteger(value) {
      var result = toFinite(value),
          remainder = result % 1;

      return result === result ? (remainder ? result - remainder : result) : 0;
    }

    /**
     * Converts `value` to an integer suitable for use as the length of an
     * array-like object.
     *
     * **Note:** This method is based on
     * [`ToLength`](http://ecma-international.org/ecma-262/7.0/#sec-tolength).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.toLength(3.2);
     * // => 3
     *
     * _.toLength(Number.MIN_VALUE);
     * // => 0
     *
     * _.toLength(Infinity);
     * // => 4294967295
     *
     * _.toLength('3.2');
     * // => 3
     */
    function toLength(value) {
      return value ? baseClamp(toInteger(value), 0, MAX_ARRAY_LENGTH) : 0;
    }

    /**
     * Converts `value` to a number.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to process.
     * @returns {number} Returns the number.
     * @example
     *
     * _.toNumber(3.2);
     * // => 3.2
     *
     * _.toNumber(Number.MIN_VALUE);
     * // => 5e-324
     *
     * _.toNumber(Infinity);
     * // => Infinity
     *
     * _.toNumber('3.2');
     * // => 3.2
     */
    function toNumber(value) {
      if (typeof value == 'number') {
        return value;
      }
      if (isSymbol(value)) {
        return NAN;
      }
      if (isObject(value)) {
        var other = typeof value.valueOf == 'function' ? value.valueOf() : value;
        value = isObject(other) ? (other + '') : other;
      }
      if (typeof value != 'string') {
        return value === 0 ? value : +value;
      }
      value = baseTrim(value);
      var isBinary = reIsBinary.test(value);
      return (isBinary || reIsOctal.test(value))
        ? freeParseInt(value.slice(2), isBinary ? 2 : 8)
        : (reIsBadHex.test(value) ? NAN : +value);
    }

    /**
     * Converts `value` to a plain object flattening inherited enumerable string
     * keyed properties of `value` to own properties of the plain object.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {Object} Returns the converted plain object.
     * @example
     *
     * function Foo() {
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.assign({ 'a': 1 }, new Foo);
     * // => { 'a': 1, 'b': 2 }
     *
     * _.assign({ 'a': 1 }, _.toPlainObject(new Foo));
     * // => { 'a': 1, 'b': 2, 'c': 3 }
     */
    function toPlainObject(value) {
      return copyObject(value, keysIn(value));
    }

    /**
     * Converts `value` to a safe integer. A safe integer can be compared and
     * represented correctly.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.toSafeInteger(3.2);
     * // => 3
     *
     * _.toSafeInteger(Number.MIN_VALUE);
     * // => 0
     *
     * _.toSafeInteger(Infinity);
     * // => 9007199254740991
     *
     * _.toSafeInteger('3.2');
     * // => 3
     */
    function toSafeInteger(value) {
      return value
        ? baseClamp(toInteger(value), -MAX_SAFE_INTEGER, MAX_SAFE_INTEGER)
        : (value === 0 ? value : 0);
    }

    /**
     * Converts `value` to a string. An empty string is returned for `null`
     * and `undefined` values. The sign of `-0` is preserved.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Lang
     * @param {*} value The value to convert.
     * @returns {string} Returns the converted string.
     * @example
     *
     * _.toString(null);
     * // => ''
     *
     * _.toString(-0);
     * // => '-0'
     *
     * _.toString([1, 2, 3]);
     * // => '1,2,3'
     */
    function toString(value) {
      return value == null ? '' : baseToString(value);
    }

    /*------------------------------------------------------------------------*/

    /**
     * Assigns own enumerable string keyed properties of source objects to the
     * destination object. Source objects are applied from left to right.
     * Subsequent sources overwrite property assignments of previous sources.
     *
     * **Note:** This method mutates `object` and is loosely based on
     * [`Object.assign`](https://mdn.io/Object/assign).
     *
     * @static
     * @memberOf _
     * @since 0.10.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @see _.assignIn
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     * }
     *
     * function Bar() {
     *   this.c = 3;
     * }
     *
     * Foo.prototype.b = 2;
     * Bar.prototype.d = 4;
     *
     * _.assign({ 'a': 0 }, new Foo, new Bar);
     * // => { 'a': 1, 'c': 3 }
     */
    var assign = createAssigner(function(object, source) {
      if (isPrototype(source) || isArrayLike(source)) {
        copyObject(source, keys(source), object);
        return;
      }
      for (var key in source) {
        if (hasOwnProperty.call(source, key)) {
          assignValue(object, key, source[key]);
        }
      }
    });

    /**
     * This method is like `_.assign` except that it iterates over own and
     * inherited source properties.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @alias extend
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @see _.assign
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     * }
     *
     * function Bar() {
     *   this.c = 3;
     * }
     *
     * Foo.prototype.b = 2;
     * Bar.prototype.d = 4;
     *
     * _.assignIn({ 'a': 0 }, new Foo, new Bar);
     * // => { 'a': 1, 'b': 2, 'c': 3, 'd': 4 }
     */
    var assignIn = createAssigner(function(object, source) {
      copyObject(source, keysIn(source), object);
    });

    /**
     * This method is like `_.assignIn` except that it accepts `customizer`
     * which is invoked to produce the assigned values. If `customizer` returns
     * `undefined`, assignment is handled by the method instead. The `customizer`
     * is invoked with five arguments: (objValue, srcValue, key, object, source).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @alias extendWith
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} sources The source objects.
     * @param {Function} [customizer] The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @see _.assignWith
     * @example
     *
     * function customizer(objValue, srcValue) {
     *   return _.isUndefined(objValue) ? srcValue : objValue;
     * }
     *
     * var defaults = _.partialRight(_.assignInWith, customizer);
     *
     * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
     * // => { 'a': 1, 'b': 2 }
     */
    var assignInWith = createAssigner(function(object, source, srcIndex, customizer) {
      copyObject(source, keysIn(source), object, customizer);
    });

    /**
     * This method is like `_.assign` except that it accepts `customizer`
     * which is invoked to produce the assigned values. If `customizer` returns
     * `undefined`, assignment is handled by the method instead. The `customizer`
     * is invoked with five arguments: (objValue, srcValue, key, object, source).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} sources The source objects.
     * @param {Function} [customizer] The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @see _.assignInWith
     * @example
     *
     * function customizer(objValue, srcValue) {
     *   return _.isUndefined(objValue) ? srcValue : objValue;
     * }
     *
     * var defaults = _.partialRight(_.assignWith, customizer);
     *
     * defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
     * // => { 'a': 1, 'b': 2 }
     */
    var assignWith = createAssigner(function(object, source, srcIndex, customizer) {
      copyObject(source, keys(source), object, customizer);
    });

    /**
     * Creates an array of values corresponding to `paths` of `object`.
     *
     * @static
     * @memberOf _
     * @since 1.0.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {...(string|string[])} [paths] The property paths to pick.
     * @returns {Array} Returns the picked values.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }, 4] };
     *
     * _.at(object, ['a[0].b.c', 'a[1]']);
     * // => [3, 4]
     */
    var at = flatRest(baseAt);

    /**
     * Creates an object that inherits from the `prototype` object. If a
     * `properties` object is given, its own enumerable string keyed properties
     * are assigned to the created object.
     *
     * @static
     * @memberOf _
     * @since 2.3.0
     * @category Object
     * @param {Object} prototype The object to inherit from.
     * @param {Object} [properties] The properties to assign to the object.
     * @returns {Object} Returns the new object.
     * @example
     *
     * function Shape() {
     *   this.x = 0;
     *   this.y = 0;
     * }
     *
     * function Circle() {
     *   Shape.call(this);
     * }
     *
     * Circle.prototype = _.create(Shape.prototype, {
     *   'constructor': Circle
     * });
     *
     * var circle = new Circle;
     * circle instanceof Circle;
     * // => true
     *
     * circle instanceof Shape;
     * // => true
     */
    function create(prototype, properties) {
      var result = baseCreate(prototype);
      return properties == null ? result : baseAssign(result, properties);
    }

    /**
     * Assigns own and inherited enumerable string keyed properties of source
     * objects to the destination object for all destination properties that
     * resolve to `undefined`. Source objects are applied from left to right.
     * Once a property is set, additional values of the same property are ignored.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @see _.defaultsDeep
     * @example
     *
     * _.defaults({ 'a': 1 }, { 'b': 2 }, { 'a': 3 });
     * // => { 'a': 1, 'b': 2 }
     */
    var defaults = baseRest(function(object, sources) {
      object = Object(object);

      var index = -1;
      var length = sources.length;
      var guard = length > 2 ? sources[2] : undefined;

      if (guard && isIterateeCall(sources[0], sources[1], guard)) {
        length = 1;
      }

      while (++index < length) {
        var source = sources[index];
        var props = keysIn(source);
        var propsIndex = -1;
        var propsLength = props.length;

        while (++propsIndex < propsLength) {
          var key = props[propsIndex];
          var value = object[key];

          if (value === undefined ||
              (eq(value, objectProto[key]) && !hasOwnProperty.call(object, key))) {
            object[key] = source[key];
          }
        }
      }

      return object;
    });

    /**
     * This method is like `_.defaults` except that it recursively assigns
     * default properties.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 3.10.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @see _.defaults
     * @example
     *
     * _.defaultsDeep({ 'a': { 'b': 2 } }, { 'a': { 'b': 1, 'c': 3 } });
     * // => { 'a': { 'b': 2, 'c': 3 } }
     */
    var defaultsDeep = baseRest(function(args) {
      args.push(undefined, customDefaultsMerge);
      return apply(mergeWith, undefined, args);
    });

    /**
     * This method is like `_.find` except that it returns the key of the first
     * element `predicate` returns truthy for instead of the element itself.
     *
     * @static
     * @memberOf _
     * @since 1.1.0
     * @category Object
     * @param {Object} object The object to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {string|undefined} Returns the key of the matched element,
     *  else `undefined`.
     * @example
     *
     * var users = {
     *   'barney':  { 'age': 36, 'active': true },
     *   'fred':    { 'age': 40, 'active': false },
     *   'pebbles': { 'age': 1,  'active': true }
     * };
     *
     * _.findKey(users, function(o) { return o.age < 40; });
     * // => 'barney' (iteration order is not guaranteed)
     *
     * // The `_.matches` iteratee shorthand.
     * _.findKey(users, { 'age': 1, 'active': true });
     * // => 'pebbles'
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.findKey(users, ['active', false]);
     * // => 'fred'
     *
     * // The `_.property` iteratee shorthand.
     * _.findKey(users, 'active');
     * // => 'barney'
     */
    function findKey(object, predicate) {
      return baseFindKey(object, getIteratee(predicate, 3), baseForOwn);
    }

    /**
     * This method is like `_.findKey` except that it iterates over elements of
     * a collection in the opposite order.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Object
     * @param {Object} object The object to inspect.
     * @param {Function} [predicate=_.identity] The function invoked per iteration.
     * @returns {string|undefined} Returns the key of the matched element,
     *  else `undefined`.
     * @example
     *
     * var users = {
     *   'barney':  { 'age': 36, 'active': true },
     *   'fred':    { 'age': 40, 'active': false },
     *   'pebbles': { 'age': 1,  'active': true }
     * };
     *
     * _.findLastKey(users, function(o) { return o.age < 40; });
     * // => returns 'pebbles' assuming `_.findKey` returns 'barney'
     *
     * // The `_.matches` iteratee shorthand.
     * _.findLastKey(users, { 'age': 36, 'active': true });
     * // => 'barney'
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.findLastKey(users, ['active', false]);
     * // => 'fred'
     *
     * // The `_.property` iteratee shorthand.
     * _.findLastKey(users, 'active');
     * // => 'pebbles'
     */
    function findLastKey(object, predicate) {
      return baseFindKey(object, getIteratee(predicate, 3), baseForOwnRight);
    }

    /**
     * Iterates over own and inherited enumerable string keyed properties of an
     * object and invokes `iteratee` for each property. The iteratee is invoked
     * with three arguments: (value, key, object). Iteratee functions may exit
     * iteration early by explicitly returning `false`.
     *
     * @static
     * @memberOf _
     * @since 0.3.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns `object`.
     * @see _.forInRight
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.forIn(new Foo, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'a', 'b', then 'c' (iteration order is not guaranteed).
     */
    function forIn(object, iteratee) {
      return object == null
        ? object
        : baseFor(object, getIteratee(iteratee, 3), keysIn);
    }

    /**
     * This method is like `_.forIn` except that it iterates over properties of
     * `object` in the opposite order.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns `object`.
     * @see _.forIn
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.forInRight(new Foo, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'c', 'b', then 'a' assuming `_.forIn` logs 'a', 'b', then 'c'.
     */
    function forInRight(object, iteratee) {
      return object == null
        ? object
        : baseForRight(object, getIteratee(iteratee, 3), keysIn);
    }

    /**
     * Iterates over own enumerable string keyed properties of an object and
     * invokes `iteratee` for each property. The iteratee is invoked with three
     * arguments: (value, key, object). Iteratee functions may exit iteration
     * early by explicitly returning `false`.
     *
     * @static
     * @memberOf _
     * @since 0.3.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns `object`.
     * @see _.forOwnRight
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.forOwn(new Foo, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'a' then 'b' (iteration order is not guaranteed).
     */
    function forOwn(object, iteratee) {
      return object && baseForOwn(object, getIteratee(iteratee, 3));
    }

    /**
     * This method is like `_.forOwn` except that it iterates over properties of
     * `object` in the opposite order.
     *
     * @static
     * @memberOf _
     * @since 2.0.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns `object`.
     * @see _.forOwn
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.forOwnRight(new Foo, function(value, key) {
     *   console.log(key);
     * });
     * // => Logs 'b' then 'a' assuming `_.forOwn` logs 'a' then 'b'.
     */
    function forOwnRight(object, iteratee) {
      return object && baseForOwnRight(object, getIteratee(iteratee, 3));
    }

    /**
     * Creates an array of function property names from own enumerable properties
     * of `object`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to inspect.
     * @returns {Array} Returns the function names.
     * @see _.functionsIn
     * @example
     *
     * function Foo() {
     *   this.a = _.constant('a');
     *   this.b = _.constant('b');
     * }
     *
     * Foo.prototype.c = _.constant('c');
     *
     * _.functions(new Foo);
     * // => ['a', 'b']
     */
    function functions(object) {
      return object == null ? [] : baseFunctions(object, keys(object));
    }

    /**
     * Creates an array of function property names from own and inherited
     * enumerable properties of `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to inspect.
     * @returns {Array} Returns the function names.
     * @see _.functions
     * @example
     *
     * function Foo() {
     *   this.a = _.constant('a');
     *   this.b = _.constant('b');
     * }
     *
     * Foo.prototype.c = _.constant('c');
     *
     * _.functionsIn(new Foo);
     * // => ['a', 'b', 'c']
     */
    function functionsIn(object) {
      return object == null ? [] : baseFunctions(object, keysIn(object));
    }

    /**
     * Gets the value at `path` of `object`. If the resolved value is
     * `undefined`, the `defaultValue` is returned in its place.
     *
     * @static
     * @memberOf _
     * @since 3.7.0
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the property to get.
     * @param {*} [defaultValue] The value returned for `undefined` resolved values.
     * @returns {*} Returns the resolved value.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
     *
     * _.get(object, 'a[0].b.c');
     * // => 3
     *
     * _.get(object, ['a', '0', 'b', 'c']);
     * // => 3
     *
     * _.get(object, 'a.b.c', 'default');
     * // => 'default'
     */
    function get(object, path, defaultValue) {
      var result = object == null ? undefined : baseGet(object, path);
      return result === undefined ? defaultValue : result;
    }

    /**
     * Checks if `path` is a direct property of `object`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     * @example
     *
     * var object = { 'a': { 'b': 2 } };
     * var other = _.create({ 'a': _.create({ 'b': 2 }) });
     *
     * _.has(object, 'a');
     * // => true
     *
     * _.has(object, 'a.b');
     * // => true
     *
     * _.has(object, ['a', 'b']);
     * // => true
     *
     * _.has(other, 'a');
     * // => false
     */
    function has(object, path) {
      return object != null && hasPath(object, path, baseHas);
    }

    /**
     * Checks if `path` is a direct or inherited property of `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path to check.
     * @returns {boolean} Returns `true` if `path` exists, else `false`.
     * @example
     *
     * var object = _.create({ 'a': _.create({ 'b': 2 }) });
     *
     * _.hasIn(object, 'a');
     * // => true
     *
     * _.hasIn(object, 'a.b');
     * // => true
     *
     * _.hasIn(object, ['a', 'b']);
     * // => true
     *
     * _.hasIn(object, 'b');
     * // => false
     */
    function hasIn(object, path) {
      return object != null && hasPath(object, path, baseHasIn);
    }

    /**
     * Creates an object composed of the inverted keys and values of `object`.
     * If `object` contains duplicate values, subsequent values overwrite
     * property assignments of previous values.
     *
     * @static
     * @memberOf _
     * @since 0.7.0
     * @category Object
     * @param {Object} object The object to invert.
     * @returns {Object} Returns the new inverted object.
     * @example
     *
     * var object = { 'a': 1, 'b': 2, 'c': 1 };
     *
     * _.invert(object);
     * // => { '1': 'c', '2': 'b' }
     */
    var invert = createInverter(function(result, value, key) {
      if (value != null &&
          typeof value.toString != 'function') {
        value = nativeObjectToString.call(value);
      }

      result[value] = key;
    }, constant(identity));

    /**
     * This method is like `_.invert` except that the inverted object is generated
     * from the results of running each element of `object` thru `iteratee`. The
     * corresponding inverted value of each inverted key is an array of keys
     * responsible for generating the inverted value. The iteratee is invoked
     * with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.1.0
     * @category Object
     * @param {Object} object The object to invert.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {Object} Returns the new inverted object.
     * @example
     *
     * var object = { 'a': 1, 'b': 2, 'c': 1 };
     *
     * _.invertBy(object);
     * // => { '1': ['a', 'c'], '2': ['b'] }
     *
     * _.invertBy(object, function(value) {
     *   return 'group' + value;
     * });
     * // => { 'group1': ['a', 'c'], 'group2': ['b'] }
     */
    var invertBy = createInverter(function(result, value, key) {
      if (value != null &&
          typeof value.toString != 'function') {
        value = nativeObjectToString.call(value);
      }

      if (hasOwnProperty.call(result, value)) {
        result[value].push(key);
      } else {
        result[value] = [key];
      }
    }, getIteratee);

    /**
     * Invokes the method at `path` of `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the method to invoke.
     * @param {...*} [args] The arguments to invoke the method with.
     * @returns {*} Returns the result of the invoked method.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': [1, 2, 3, 4] } }] };
     *
     * _.invoke(object, 'a[0].b.c.slice', 1, 3);
     * // => [2, 3]
     */
    var invoke = baseRest(baseInvoke);

    /**
     * Creates an array of the own enumerable property names of `object`.
     *
     * **Note:** Non-object values are coerced to objects. See the
     * [ES spec](http://ecma-international.org/ecma-262/7.0/#sec-object.keys)
     * for more details.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.keys(new Foo);
     * // => ['a', 'b'] (iteration order is not guaranteed)
     *
     * _.keys('hi');
     * // => ['0', '1']
     */
    function keys(object) {
      return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
    }

    /**
     * Creates an array of the own and inherited enumerable property names of `object`.
     *
     * **Note:** Non-object values are coerced to objects.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property names.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.keysIn(new Foo);
     * // => ['a', 'b', 'c'] (iteration order is not guaranteed)
     */
    function keysIn(object) {
      return isArrayLike(object) ? arrayLikeKeys(object, true) : baseKeysIn(object);
    }

    /**
     * The opposite of `_.mapValues`; this method creates an object with the
     * same values as `object` and keys generated by running each own enumerable
     * string keyed property of `object` thru `iteratee`. The iteratee is invoked
     * with three arguments: (value, key, object).
     *
     * @static
     * @memberOf _
     * @since 3.8.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns the new mapped object.
     * @see _.mapValues
     * @example
     *
     * _.mapKeys({ 'a': 1, 'b': 2 }, function(value, key) {
     *   return key + value;
     * });
     * // => { 'a1': 1, 'b2': 2 }
     */
    function mapKeys(object, iteratee) {
      var result = {};
      iteratee = getIteratee(iteratee, 3);

      baseForOwn(object, function(value, key, object) {
        baseAssignValue(result, iteratee(value, key, object), value);
      });
      return result;
    }

    /**
     * Creates an object with the same keys as `object` and values generated
     * by running each own enumerable string keyed property of `object` thru
     * `iteratee`. The iteratee is invoked with three arguments:
     * (value, key, object).
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Object} Returns the new mapped object.
     * @see _.mapKeys
     * @example
     *
     * var users = {
     *   'fred':    { 'user': 'fred',    'age': 40 },
     *   'pebbles': { 'user': 'pebbles', 'age': 1 }
     * };
     *
     * _.mapValues(users, function(o) { return o.age; });
     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
     *
     * // The `_.property` iteratee shorthand.
     * _.mapValues(users, 'age');
     * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
     */
    function mapValues(object, iteratee) {
      var result = {};
      iteratee = getIteratee(iteratee, 3);

      baseForOwn(object, function(value, key, object) {
        baseAssignValue(result, key, iteratee(value, key, object));
      });
      return result;
    }

    /**
     * This method is like `_.assign` except that it recursively merges own and
     * inherited enumerable string keyed properties of source objects into the
     * destination object. Source properties that resolve to `undefined` are
     * skipped if a destination value exists. Array and plain object properties
     * are merged recursively. Other objects and value types are overridden by
     * assignment. Source objects are applied from left to right. Subsequent
     * sources overwrite property assignments of previous sources.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 0.5.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} [sources] The source objects.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = {
     *   'a': [{ 'b': 2 }, { 'd': 4 }]
     * };
     *
     * var other = {
     *   'a': [{ 'c': 3 }, { 'e': 5 }]
     * };
     *
     * _.merge(object, other);
     * // => { 'a': [{ 'b': 2, 'c': 3 }, { 'd': 4, 'e': 5 }] }
     */
    var merge = createAssigner(function(object, source, srcIndex) {
      baseMerge(object, source, srcIndex);
    });

    /**
     * This method is like `_.merge` except that it accepts `customizer` which
     * is invoked to produce the merged values of the destination and source
     * properties. If `customizer` returns `undefined`, merging is handled by the
     * method instead. The `customizer` is invoked with six arguments:
     * (objValue, srcValue, key, object, source, stack).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The destination object.
     * @param {...Object} sources The source objects.
     * @param {Function} customizer The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @example
     *
     * function customizer(objValue, srcValue) {
     *   if (_.isArray(objValue)) {
     *     return objValue.concat(srcValue);
     *   }
     * }
     *
     * var object = { 'a': [1], 'b': [2] };
     * var other = { 'a': [3], 'b': [4] };
     *
     * _.mergeWith(object, other, customizer);
     * // => { 'a': [1, 3], 'b': [2, 4] }
     */
    var mergeWith = createAssigner(function(object, source, srcIndex, customizer) {
      baseMerge(object, source, srcIndex, customizer);
    });

    /**
     * The opposite of `_.pick`; this method creates an object composed of the
     * own and inherited enumerable property paths of `object` that are not omitted.
     *
     * **Note:** This method is considerably slower than `_.pick`.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The source object.
     * @param {...(string|string[])} [paths] The property paths to omit.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.omit(object, ['a', 'c']);
     * // => { 'b': '2' }
     */
    var omit = flatRest(function(object, paths) {
      var result = {};
      if (object == null) {
        return result;
      }
      var isDeep = false;
      paths = arrayMap(paths, function(path) {
        path = castPath(path, object);
        isDeep || (isDeep = path.length > 1);
        return path;
      });
      copyObject(object, getAllKeysIn(object), result);
      if (isDeep) {
        result = baseClone(result, CLONE_DEEP_FLAG | CLONE_FLAT_FLAG | CLONE_SYMBOLS_FLAG, customOmitClone);
      }
      var length = paths.length;
      while (length--) {
        baseUnset(result, paths[length]);
      }
      return result;
    });

    /**
     * The opposite of `_.pickBy`; this method creates an object composed of
     * the own and inherited enumerable string keyed properties of `object` that
     * `predicate` doesn't return truthy for. The predicate is invoked with two
     * arguments: (value, key).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The source object.
     * @param {Function} [predicate=_.identity] The function invoked per property.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.omitBy(object, _.isNumber);
     * // => { 'b': '2' }
     */
    function omitBy(object, predicate) {
      return pickBy(object, negate(getIteratee(predicate)));
    }

    /**
     * Creates an object composed of the picked `object` properties.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The source object.
     * @param {...(string|string[])} [paths] The property paths to pick.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.pick(object, ['a', 'c']);
     * // => { 'a': 1, 'c': 3 }
     */
    var pick = flatRest(function(object, paths) {
      return object == null ? {} : basePick(object, paths);
    });

    /**
     * Creates an object composed of the `object` properties `predicate` returns
     * truthy for. The predicate is invoked with two arguments: (value, key).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The source object.
     * @param {Function} [predicate=_.identity] The function invoked per property.
     * @returns {Object} Returns the new object.
     * @example
     *
     * var object = { 'a': 1, 'b': '2', 'c': 3 };
     *
     * _.pickBy(object, _.isNumber);
     * // => { 'a': 1, 'c': 3 }
     */
    function pickBy(object, predicate) {
      if (object == null) {
        return {};
      }
      var props = arrayMap(getAllKeysIn(object), function(prop) {
        return [prop];
      });
      predicate = getIteratee(predicate);
      return basePickBy(object, props, function(value, path) {
        return predicate(value, path[0]);
      });
    }

    /**
     * This method is like `_.get` except that if the resolved value is a
     * function it's invoked with the `this` binding of its parent object and
     * its result is returned.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @param {Array|string} path The path of the property to resolve.
     * @param {*} [defaultValue] The value returned for `undefined` resolved values.
     * @returns {*} Returns the resolved value.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c1': 3, 'c2': _.constant(4) } }] };
     *
     * _.result(object, 'a[0].b.c1');
     * // => 3
     *
     * _.result(object, 'a[0].b.c2');
     * // => 4
     *
     * _.result(object, 'a[0].b.c3', 'default');
     * // => 'default'
     *
     * _.result(object, 'a[0].b.c3', _.constant('default'));
     * // => 'default'
     */
    function result(object, path, defaultValue) {
      path = castPath(path, object);

      var index = -1,
          length = path.length;

      // Ensure the loop is entered when path is empty.
      if (!length) {
        length = 1;
        object = undefined;
      }
      while (++index < length) {
        var value = object == null ? undefined : object[toKey(path[index])];
        if (value === undefined) {
          index = length;
          value = defaultValue;
        }
        object = isFunction(value) ? value.call(object) : value;
      }
      return object;
    }

    /**
     * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
     * it's created. Arrays are created for missing index properties while objects
     * are created for all other missing properties. Use `_.setWith` to customize
     * `path` creation.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 3.7.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {*} value The value to set.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
     *
     * _.set(object, 'a[0].b.c', 4);
     * console.log(object.a[0].b.c);
     * // => 4
     *
     * _.set(object, ['x', '0', 'y', 'z'], 5);
     * console.log(object.x[0].y.z);
     * // => 5
     */
    function set(object, path, value) {
      return object == null ? object : baseSet(object, path, value);
    }

    /**
     * This method is like `_.set` except that it accepts `customizer` which is
     * invoked to produce the objects of `path`.  If `customizer` returns `undefined`
     * path creation is handled by the method instead. The `customizer` is invoked
     * with three arguments: (nsValue, key, nsObject).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {*} value The value to set.
     * @param {Function} [customizer] The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = {};
     *
     * _.setWith(object, '[0][1]', 'a', Object);
     * // => { '0': { '1': 'a' } }
     */
    function setWith(object, path, value, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return object == null ? object : baseSet(object, path, value, customizer);
    }

    /**
     * Creates an array of own enumerable string keyed-value pairs for `object`
     * which can be consumed by `_.fromPairs`. If `object` is a map or set, its
     * entries are returned.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @alias entries
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the key-value pairs.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.toPairs(new Foo);
     * // => [['a', 1], ['b', 2]] (iteration order is not guaranteed)
     */
    var toPairs = createToPairs(keys);

    /**
     * Creates an array of own and inherited enumerable string keyed-value pairs
     * for `object` which can be consumed by `_.fromPairs`. If `object` is a map
     * or set, its entries are returned.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @alias entriesIn
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the key-value pairs.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.toPairsIn(new Foo);
     * // => [['a', 1], ['b', 2], ['c', 3]] (iteration order is not guaranteed)
     */
    var toPairsIn = createToPairs(keysIn);

    /**
     * An alternative to `_.reduce`; this method transforms `object` to a new
     * `accumulator` object which is the result of running each of its own
     * enumerable string keyed properties thru `iteratee`, with each invocation
     * potentially mutating the `accumulator` object. If `accumulator` is not
     * provided, a new object with the same `[[Prototype]]` will be used. The
     * iteratee is invoked with four arguments: (accumulator, value, key, object).
     * Iteratee functions may exit iteration early by explicitly returning `false`.
     *
     * @static
     * @memberOf _
     * @since 1.3.0
     * @category Object
     * @param {Object} object The object to iterate over.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @param {*} [accumulator] The custom accumulator value.
     * @returns {*} Returns the accumulated value.
     * @example
     *
     * _.transform([2, 3, 4], function(result, n) {
     *   result.push(n *= n);
     *   return n % 2 == 0;
     * }, []);
     * // => [4, 9]
     *
     * _.transform({ 'a': 1, 'b': 2, 'c': 1 }, function(result, value, key) {
     *   (result[value] || (result[value] = [])).push(key);
     * }, {});
     * // => { '1': ['a', 'c'], '2': ['b'] }
     */
    function transform(object, iteratee, accumulator) {
      var isArr = isArray(object),
          isArrLike = isArr || isBuffer(object) || isTypedArray(object);

      iteratee = getIteratee(iteratee, 4);
      if (accumulator == null) {
        var Ctor = object && object.constructor;
        if (isArrLike) {
          accumulator = isArr ? new Ctor : [];
        }
        else if (isObject(object)) {
          accumulator = isFunction(Ctor) ? baseCreate(getPrototype(object)) : {};
        }
        else {
          accumulator = {};
        }
      }
      (isArrLike ? arrayEach : baseForOwn)(object, function(value, index, object) {
        return iteratee(accumulator, value, index, object);
      });
      return accumulator;
    }

    /**
     * Removes the property at `path` of `object`.
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to unset.
     * @returns {boolean} Returns `true` if the property is deleted, else `false`.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 7 } }] };
     * _.unset(object, 'a[0].b.c');
     * // => true
     *
     * console.log(object);
     * // => { 'a': [{ 'b': {} }] };
     *
     * _.unset(object, ['a', '0', 'b', 'c']);
     * // => true
     *
     * console.log(object);
     * // => { 'a': [{ 'b': {} }] };
     */
    function unset(object, path) {
      return object == null ? true : baseUnset(object, path);
    }

    /**
     * This method is like `_.set` except that accepts `updater` to produce the
     * value to set. Use `_.updateWith` to customize `path` creation. The `updater`
     * is invoked with one argument: (value).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.6.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {Function} updater The function to produce the updated value.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = { 'a': [{ 'b': { 'c': 3 } }] };
     *
     * _.update(object, 'a[0].b.c', function(n) { return n * n; });
     * console.log(object.a[0].b.c);
     * // => 9
     *
     * _.update(object, 'x[0].y.z', function(n) { return n ? n + 1 : 0; });
     * console.log(object.x[0].y.z);
     * // => 0
     */
    function update(object, path, updater) {
      return object == null ? object : baseUpdate(object, path, castFunction(updater));
    }

    /**
     * This method is like `_.update` except that it accepts `customizer` which is
     * invoked to produce the objects of `path`.  If `customizer` returns `undefined`
     * path creation is handled by the method instead. The `customizer` is invoked
     * with three arguments: (nsValue, key, nsObject).
     *
     * **Note:** This method mutates `object`.
     *
     * @static
     * @memberOf _
     * @since 4.6.0
     * @category Object
     * @param {Object} object The object to modify.
     * @param {Array|string} path The path of the property to set.
     * @param {Function} updater The function to produce the updated value.
     * @param {Function} [customizer] The function to customize assigned values.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var object = {};
     *
     * _.updateWith(object, '[0][1]', _.constant('a'), Object);
     * // => { '0': { '1': 'a' } }
     */
    function updateWith(object, path, updater, customizer) {
      customizer = typeof customizer == 'function' ? customizer : undefined;
      return object == null ? object : baseUpdate(object, path, castFunction(updater), customizer);
    }

    /**
     * Creates an array of the own enumerable string keyed property values of `object`.
     *
     * **Note:** Non-object values are coerced to objects.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property values.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.values(new Foo);
     * // => [1, 2] (iteration order is not guaranteed)
     *
     * _.values('hi');
     * // => ['h', 'i']
     */
    function values(object) {
      return object == null ? [] : baseValues(object, keys(object));
    }

    /**
     * Creates an array of the own and inherited enumerable string keyed property
     * values of `object`.
     *
     * **Note:** Non-object values are coerced to objects.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Object
     * @param {Object} object The object to query.
     * @returns {Array} Returns the array of property values.
     * @example
     *
     * function Foo() {
     *   this.a = 1;
     *   this.b = 2;
     * }
     *
     * Foo.prototype.c = 3;
     *
     * _.valuesIn(new Foo);
     * // => [1, 2, 3] (iteration order is not guaranteed)
     */
    function valuesIn(object) {
      return object == null ? [] : baseValues(object, keysIn(object));
    }

    /*------------------------------------------------------------------------*/

    /**
     * Clamps `number` within the inclusive `lower` and `upper` bounds.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Number
     * @param {number} number The number to clamp.
     * @param {number} [lower] The lower bound.
     * @param {number} upper The upper bound.
     * @returns {number} Returns the clamped number.
     * @example
     *
     * _.clamp(-10, -5, 5);
     * // => -5
     *
     * _.clamp(10, -5, 5);
     * // => 5
     */
    function clamp(number, lower, upper) {
      if (upper === undefined) {
        upper = lower;
        lower = undefined;
      }
      if (upper !== undefined) {
        upper = toNumber(upper);
        upper = upper === upper ? upper : 0;
      }
      if (lower !== undefined) {
        lower = toNumber(lower);
        lower = lower === lower ? lower : 0;
      }
      return baseClamp(toNumber(number), lower, upper);
    }

    /**
     * Checks if `n` is between `start` and up to, but not including, `end`. If
     * `end` is not specified, it's set to `start` with `start` then set to `0`.
     * If `start` is greater than `end` the params are swapped to support
     * negative ranges.
     *
     * @static
     * @memberOf _
     * @since 3.3.0
     * @category Number
     * @param {number} number The number to check.
     * @param {number} [start=0] The start of the range.
     * @param {number} end The end of the range.
     * @returns {boolean} Returns `true` if `number` is in the range, else `false`.
     * @see _.range, _.rangeRight
     * @example
     *
     * _.inRange(3, 2, 4);
     * // => true
     *
     * _.inRange(4, 8);
     * // => true
     *
     * _.inRange(4, 2);
     * // => false
     *
     * _.inRange(2, 2);
     * // => false
     *
     * _.inRange(1.2, 2);
     * // => true
     *
     * _.inRange(5.2, 4);
     * // => false
     *
     * _.inRange(-3, -2, -6);
     * // => true
     */
    function inRange(number, start, end) {
      start = toFinite(start);
      if (end === undefined) {
        end = start;
        start = 0;
      } else {
        end = toFinite(end);
      }
      number = toNumber(number);
      return baseInRange(number, start, end);
    }

    /**
     * Produces a random number between the inclusive `lower` and `upper` bounds.
     * If only one argument is provided a number between `0` and the given number
     * is returned. If `floating` is `true`, or either `lower` or `upper` are
     * floats, a floating-point number is returned instead of an integer.
     *
     * **Note:** JavaScript follows the IEEE-754 standard for resolving
     * floating-point values which can produce unexpected results.
     *
     * @static
     * @memberOf _
     * @since 0.7.0
     * @category Number
     * @param {number} [lower=0] The lower bound.
     * @param {number} [upper=1] The upper bound.
     * @param {boolean} [floating] Specify returning a floating-point number.
     * @returns {number} Returns the random number.
     * @example
     *
     * _.random(0, 5);
     * // => an integer between 0 and 5
     *
     * _.random(5);
     * // => also an integer between 0 and 5
     *
     * _.random(5, true);
     * // => a floating-point number between 0 and 5
     *
     * _.random(1.2, 5.2);
     * // => a floating-point number between 1.2 and 5.2
     */
    function random(lower, upper, floating) {
      if (floating && typeof floating != 'boolean' && isIterateeCall(lower, upper, floating)) {
        upper = floating = undefined;
      }
      if (floating === undefined) {
        if (typeof upper == 'boolean') {
          floating = upper;
          upper = undefined;
        }
        else if (typeof lower == 'boolean') {
          floating = lower;
          lower = undefined;
        }
      }
      if (lower === undefined && upper === undefined) {
        lower = 0;
        upper = 1;
      }
      else {
        lower = toFinite(lower);
        if (upper === undefined) {
          upper = lower;
          lower = 0;
        } else {
          upper = toFinite(upper);
        }
      }
      if (lower > upper) {
        var temp = lower;
        lower = upper;
        upper = temp;
      }
      if (floating || lower % 1 || upper % 1) {
        var rand = nativeRandom();
        return nativeMin(lower + (rand * (upper - lower + freeParseFloat('1e-' + ((rand + '').length - 1)))), upper);
      }
      return baseRandom(lower, upper);
    }

    /*------------------------------------------------------------------------*/

    /**
     * Converts `string` to [camel case](https://en.wikipedia.org/wiki/CamelCase).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the camel cased string.
     * @example
     *
     * _.camelCase('Foo Bar');
     * // => 'fooBar'
     *
     * _.camelCase('--foo-bar--');
     * // => 'fooBar'
     *
     * _.camelCase('__FOO_BAR__');
     * // => 'fooBar'
     */
    var camelCase = createCompounder(function(result, word, index) {
      word = word.toLowerCase();
      return result + (index ? capitalize(word) : word);
    });

    /**
     * Converts the first character of `string` to upper case and the remaining
     * to lower case.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to capitalize.
     * @returns {string} Returns the capitalized string.
     * @example
     *
     * _.capitalize('FRED');
     * // => 'Fred'
     */
    function capitalize(string) {
      return upperFirst(toString(string).toLowerCase());
    }

    /**
     * Deburrs `string` by converting
     * [Latin-1 Supplement](https://en.wikipedia.org/wiki/Latin-1_Supplement_(Unicode_block)#Character_table)
     * and [Latin Extended-A](https://en.wikipedia.org/wiki/Latin_Extended-A)
     * letters to basic Latin letters and removing
     * [combining diacritical marks](https://en.wikipedia.org/wiki/Combining_Diacritical_Marks).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to deburr.
     * @returns {string} Returns the deburred string.
     * @example
     *
     * _.deburr('déjà vu');
     * // => 'deja vu'
     */
    function deburr(string) {
      string = toString(string);
      return string && string.replace(reLatin, deburrLetter).replace(reComboMark, '');
    }

    /**
     * Checks if `string` ends with the given target string.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to inspect.
     * @param {string} [target] The string to search for.
     * @param {number} [position=string.length] The position to search up to.
     * @returns {boolean} Returns `true` if `string` ends with `target`,
     *  else `false`.
     * @example
     *
     * _.endsWith('abc', 'c');
     * // => true
     *
     * _.endsWith('abc', 'b');
     * // => false
     *
     * _.endsWith('abc', 'b', 2);
     * // => true
     */
    function endsWith(string, target, position) {
      string = toString(string);
      target = baseToString(target);

      var length = string.length;
      position = position === undefined
        ? length
        : baseClamp(toInteger(position), 0, length);

      var end = position;
      position -= target.length;
      return position >= 0 && string.slice(position, end) == target;
    }

    /**
     * Converts the characters "&", "<", ">", '"', and "'" in `string` to their
     * corresponding HTML entities.
     *
     * **Note:** No other characters are escaped. To escape additional
     * characters use a third-party library like [_he_](https://mths.be/he).
     *
     * Though the ">" character is escaped for symmetry, characters like
     * ">" and "/" don't need escaping in HTML and have no special meaning
     * unless they're part of a tag or unquoted attribute value. See
     * [Mathias Bynens's article](https://mathiasbynens.be/notes/ambiguous-ampersands)
     * (under "semi-related fun fact") for more details.
     *
     * When working with HTML you should always
     * [quote attribute values](http://wonko.com/post/html-escaping) to reduce
     * XSS vectors.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category String
     * @param {string} [string=''] The string to escape.
     * @returns {string} Returns the escaped string.
     * @example
     *
     * _.escape('fred, barney, & pebbles');
     * // => 'fred, barney, &amp; pebbles'
     */
    function escape(string) {
      string = toString(string);
      return (string && reHasUnescapedHtml.test(string))
        ? string.replace(reUnescapedHtml, escapeHtmlChar)
        : string;
    }

    /**
     * Escapes the `RegExp` special characters "^", "$", "\", ".", "*", "+",
     * "?", "(", ")", "[", "]", "{", "}", and "|" in `string`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to escape.
     * @returns {string} Returns the escaped string.
     * @example
     *
     * _.escapeRegExp('[lodash](https://lodash.com/)');
     * // => '\[lodash\]\(https://lodash\.com/\)'
     */
    function escapeRegExp(string) {
      string = toString(string);
      return (string && reHasRegExpChar.test(string))
        ? string.replace(reRegExpChar, '\\$&')
        : string;
    }

    /**
     * Converts `string` to
     * [kebab case](https://en.wikipedia.org/wiki/Letter_case#Special_case_styles).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the kebab cased string.
     * @example
     *
     * _.kebabCase('Foo Bar');
     * // => 'foo-bar'
     *
     * _.kebabCase('fooBar');
     * // => 'foo-bar'
     *
     * _.kebabCase('__FOO_BAR__');
     * // => 'foo-bar'
     */
    var kebabCase = createCompounder(function(result, word, index) {
      return result + (index ? '-' : '') + word.toLowerCase();
    });

    /**
     * Converts `string`, as space separated words, to lower case.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the lower cased string.
     * @example
     *
     * _.lowerCase('--Foo-Bar--');
     * // => 'foo bar'
     *
     * _.lowerCase('fooBar');
     * // => 'foo bar'
     *
     * _.lowerCase('__FOO_BAR__');
     * // => 'foo bar'
     */
    var lowerCase = createCompounder(function(result, word, index) {
      return result + (index ? ' ' : '') + word.toLowerCase();
    });

    /**
     * Converts the first character of `string` to lower case.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the converted string.
     * @example
     *
     * _.lowerFirst('Fred');
     * // => 'fred'
     *
     * _.lowerFirst('FRED');
     * // => 'fRED'
     */
    var lowerFirst = createCaseFirst('toLowerCase');

    /**
     * Pads `string` on the left and right sides if it's shorter than `length`.
     * Padding characters are truncated if they can't be evenly divided by `length`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to pad.
     * @param {number} [length=0] The padding length.
     * @param {string} [chars=' '] The string used as padding.
     * @returns {string} Returns the padded string.
     * @example
     *
     * _.pad('abc', 8);
     * // => '  abc   '
     *
     * _.pad('abc', 8, '_-');
     * // => '_-abc_-_'
     *
     * _.pad('abc', 3);
     * // => 'abc'
     */
    function pad(string, length, chars) {
      string = toString(string);
      length = toInteger(length);

      var strLength = length ? stringSize(string) : 0;
      if (!length || strLength >= length) {
        return string;
      }
      var mid = (length - strLength) / 2;
      return (
        createPadding(nativeFloor(mid), chars) +
        string +
        createPadding(nativeCeil(mid), chars)
      );
    }

    /**
     * Pads `string` on the right side if it's shorter than `length`. Padding
     * characters are truncated if they exceed `length`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to pad.
     * @param {number} [length=0] The padding length.
     * @param {string} [chars=' '] The string used as padding.
     * @returns {string} Returns the padded string.
     * @example
     *
     * _.padEnd('abc', 6);
     * // => 'abc   '
     *
     * _.padEnd('abc', 6, '_-');
     * // => 'abc_-_'
     *
     * _.padEnd('abc', 3);
     * // => 'abc'
     */
    function padEnd(string, length, chars) {
      string = toString(string);
      length = toInteger(length);

      var strLength = length ? stringSize(string) : 0;
      return (length && strLength < length)
        ? (string + createPadding(length - strLength, chars))
        : string;
    }

    /**
     * Pads `string` on the left side if it's shorter than `length`. Padding
     * characters are truncated if they exceed `length`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to pad.
     * @param {number} [length=0] The padding length.
     * @param {string} [chars=' '] The string used as padding.
     * @returns {string} Returns the padded string.
     * @example
     *
     * _.padStart('abc', 6);
     * // => '   abc'
     *
     * _.padStart('abc', 6, '_-');
     * // => '_-_abc'
     *
     * _.padStart('abc', 3);
     * // => 'abc'
     */
    function padStart(string, length, chars) {
      string = toString(string);
      length = toInteger(length);

      var strLength = length ? stringSize(string) : 0;
      return (length && strLength < length)
        ? (createPadding(length - strLength, chars) + string)
        : string;
    }

    /**
     * Converts `string` to an integer of the specified radix. If `radix` is
     * `undefined` or `0`, a `radix` of `10` is used unless `value` is a
     * hexadecimal, in which case a `radix` of `16` is used.
     *
     * **Note:** This method aligns with the
     * [ES5 implementation](https://es5.github.io/#x15.1.2.2) of `parseInt`.
     *
     * @static
     * @memberOf _
     * @since 1.1.0
     * @category String
     * @param {string} string The string to convert.
     * @param {number} [radix=10] The radix to interpret `value` by.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {number} Returns the converted integer.
     * @example
     *
     * _.parseInt('08');
     * // => 8
     *
     * _.map(['6', '08', '10'], _.parseInt);
     * // => [6, 8, 10]
     */
    function parseInt(string, radix, guard) {
      if (guard || radix == null) {
        radix = 0;
      } else if (radix) {
        radix = +radix;
      }
      return nativeParseInt(toString(string).replace(reTrimStart, ''), radix || 0);
    }

    /**
     * Repeats the given string `n` times.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to repeat.
     * @param {number} [n=1] The number of times to repeat the string.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {string} Returns the repeated string.
     * @example
     *
     * _.repeat('*', 3);
     * // => '***'
     *
     * _.repeat('abc', 2);
     * // => 'abcabc'
     *
     * _.repeat('abc', 0);
     * // => ''
     */
    function repeat(string, n, guard) {
      if ((guard ? isIterateeCall(string, n, guard) : n === undefined)) {
        n = 1;
      } else {
        n = toInteger(n);
      }
      return baseRepeat(toString(string), n);
    }

    /**
     * Replaces matches for `pattern` in `string` with `replacement`.
     *
     * **Note:** This method is based on
     * [`String#replace`](https://mdn.io/String/replace).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to modify.
     * @param {RegExp|string} pattern The pattern to replace.
     * @param {Function|string} replacement The match replacement.
     * @returns {string} Returns the modified string.
     * @example
     *
     * _.replace('Hi Fred', 'Fred', 'Barney');
     * // => 'Hi Barney'
     */
    function replace() {
      var args = arguments,
          string = toString(args[0]);

      return args.length < 3 ? string : string.replace(args[1], args[2]);
    }

    /**
     * Converts `string` to
     * [snake case](https://en.wikipedia.org/wiki/Snake_case).
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the snake cased string.
     * @example
     *
     * _.snakeCase('Foo Bar');
     * // => 'foo_bar'
     *
     * _.snakeCase('fooBar');
     * // => 'foo_bar'
     *
     * _.snakeCase('--FOO-BAR--');
     * // => 'foo_bar'
     */
    var snakeCase = createCompounder(function(result, word, index) {
      return result + (index ? '_' : '') + word.toLowerCase();
    });

    /**
     * Splits `string` by `separator`.
     *
     * **Note:** This method is based on
     * [`String#split`](https://mdn.io/String/split).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to split.
     * @param {RegExp|string} separator The separator pattern to split by.
     * @param {number} [limit] The length to truncate results to.
     * @returns {Array} Returns the string segments.
     * @example
     *
     * _.split('a-b-c', '-', 2);
     * // => ['a', 'b']
     */
    function split(string, separator, limit) {
      if (limit && typeof limit != 'number' && isIterateeCall(string, separator, limit)) {
        separator = limit = undefined;
      }
      limit = limit === undefined ? MAX_ARRAY_LENGTH : limit >>> 0;
      if (!limit) {
        return [];
      }
      string = toString(string);
      if (string && (
            typeof separator == 'string' ||
            (separator != null && !isRegExp(separator))
          )) {
        separator = baseToString(separator);
        if (!separator && hasUnicode(string)) {
          return castSlice(stringToArray(string), 0, limit);
        }
      }
      return string.split(separator, limit);
    }

    /**
     * Converts `string` to
     * [start case](https://en.wikipedia.org/wiki/Letter_case#Stylistic_or_specialised_usage).
     *
     * @static
     * @memberOf _
     * @since 3.1.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the start cased string.
     * @example
     *
     * _.startCase('--foo-bar--');
     * // => 'Foo Bar'
     *
     * _.startCase('fooBar');
     * // => 'Foo Bar'
     *
     * _.startCase('__FOO_BAR__');
     * // => 'FOO BAR'
     */
    var startCase = createCompounder(function(result, word, index) {
      return result + (index ? ' ' : '') + upperFirst(word);
    });

    /**
     * Checks if `string` starts with the given target string.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to inspect.
     * @param {string} [target] The string to search for.
     * @param {number} [position=0] The position to search from.
     * @returns {boolean} Returns `true` if `string` starts with `target`,
     *  else `false`.
     * @example
     *
     * _.startsWith('abc', 'a');
     * // => true
     *
     * _.startsWith('abc', 'b');
     * // => false
     *
     * _.startsWith('abc', 'b', 1);
     * // => true
     */
    function startsWith(string, target, position) {
      string = toString(string);
      position = position == null
        ? 0
        : baseClamp(toInteger(position), 0, string.length);

      target = baseToString(target);
      return string.slice(position, position + target.length) == target;
    }

    /**
     * Creates a compiled template function that can interpolate data properties
     * in "interpolate" delimiters, HTML-escape interpolated data properties in
     * "escape" delimiters, and execute JavaScript in "evaluate" delimiters. Data
     * properties may be accessed as free variables in the template. If a setting
     * object is given, it takes precedence over `_.templateSettings` values.
     *
     * **Note:** In the development build `_.template` utilizes
     * [sourceURLs](http://www.html5rocks.com/en/tutorials/developertools/sourcemaps/#toc-sourceurl)
     * for easier debugging.
     *
     * For more information on precompiling templates see
     * [lodash's custom builds documentation](https://lodash.com/custom-builds).
     *
     * For more information on Chrome extension sandboxes see
     * [Chrome's extensions documentation](https://developer.chrome.com/extensions/sandboxingEval).
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category String
     * @param {string} [string=''] The template string.
     * @param {Object} [options={}] The options object.
     * @param {RegExp} [options.escape=_.templateSettings.escape]
     *  The HTML "escape" delimiter.
     * @param {RegExp} [options.evaluate=_.templateSettings.evaluate]
     *  The "evaluate" delimiter.
     * @param {Object} [options.imports=_.templateSettings.imports]
     *  An object to import into the template as free variables.
     * @param {RegExp} [options.interpolate=_.templateSettings.interpolate]
     *  The "interpolate" delimiter.
     * @param {string} [options.sourceURL='lodash.templateSources[n]']
     *  The sourceURL of the compiled template.
     * @param {string} [options.variable='obj']
     *  The data object variable name.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Function} Returns the compiled template function.
     * @example
     *
     * // Use the "interpolate" delimiter to create a compiled template.
     * var compiled = _.template('hello <%= user %>!');
     * compiled({ 'user': 'fred' });
     * // => 'hello fred!'
     *
     * // Use the HTML "escape" delimiter to escape data property values.
     * var compiled = _.template('<b><%- value %></b>');
     * compiled({ 'value': '<script>' });
     * // => '<b>&lt;script&gt;</b>'
     *
     * // Use the "evaluate" delimiter to execute JavaScript and generate HTML.
     * var compiled = _.template('<% _.forEach(users, function(user) { %><li><%- user %></li><% }); %>');
     * compiled({ 'users': ['fred', 'barney'] });
     * // => '<li>fred</li><li>barney</li>'
     *
     * // Use the internal `print` function in "evaluate" delimiters.
     * var compiled = _.template('<% print("hello " + user); %>!');
     * compiled({ 'user': 'barney' });
     * // => 'hello barney!'
     *
     * // Use the ES template literal delimiter as an "interpolate" delimiter.
     * // Disable support by replacing the "interpolate" delimiter.
     * var compiled = _.template('hello ${ user }!');
     * compiled({ 'user': 'pebbles' });
     * // => 'hello pebbles!'
     *
     * // Use backslashes to treat delimiters as plain text.
     * var compiled = _.template('<%= "\\<%- value %\\>" %>');
     * compiled({ 'value': 'ignored' });
     * // => '<%- value %>'
     *
     * // Use the `imports` option to import `jQuery` as `jq`.
     * var text = '<% jq.each(users, function(user) { %><li><%- user %></li><% }); %>';
     * var compiled = _.template(text, { 'imports': { 'jq': jQuery } });
     * compiled({ 'users': ['fred', 'barney'] });
     * // => '<li>fred</li><li>barney</li>'
     *
     * // Use the `sourceURL` option to specify a custom sourceURL for the template.
     * var compiled = _.template('hello <%= user %>!', { 'sourceURL': '/basic/greeting.jst' });
     * compiled(data);
     * // => Find the source of "greeting.jst" under the Sources tab or Resources panel of the web inspector.
     *
     * // Use the `variable` option to ensure a with-statement isn't used in the compiled template.
     * var compiled = _.template('hi <%= data.user %>!', { 'variable': 'data' });
     * compiled.source;
     * // => function(data) {
     * //   var __t, __p = '';
     * //   __p += 'hi ' + ((__t = ( data.user )) == null ? '' : __t) + '!';
     * //   return __p;
     * // }
     *
     * // Use custom template delimiters.
     * _.templateSettings.interpolate = /{{([\s\S]+?)}}/g;
     * var compiled = _.template('hello {{ user }}!');
     * compiled({ 'user': 'mustache' });
     * // => 'hello mustache!'
     *
     * // Use the `source` property to inline compiled templates for meaningful
     * // line numbers in error messages and stack traces.
     * fs.writeFileSync(path.join(process.cwd(), 'jst.js'), '\
     *   var JST = {\
     *     "main": ' + _.template(mainText).source + '\
     *   };\
     * ');
     */
    function template(string, options, guard) {
      // Based on John Resig's `tmpl` implementation
      // (http://ejohn.org/blog/javascript-micro-templating/)
      // and Laura Doktorova's doT.js (https://github.com/olado/doT).
      var settings = lodash.templateSettings;

      if (guard && isIterateeCall(string, options, guard)) {
        options = undefined;
      }
      string = toString(string);
      options = assignInWith({}, options, settings, customDefaultsAssignIn);

      var imports = assignInWith({}, options.imports, settings.imports, customDefaultsAssignIn),
          importsKeys = keys(imports),
          importsValues = baseValues(imports, importsKeys);

      var isEscaping,
          isEvaluating,
          index = 0,
          interpolate = options.interpolate || reNoMatch,
          source = "__p += '";

      // Compile the regexp to match each delimiter.
      var reDelimiters = RegExp(
        (options.escape || reNoMatch).source + '|' +
        interpolate.source + '|' +
        (interpolate === reInterpolate ? reEsTemplate : reNoMatch).source + '|' +
        (options.evaluate || reNoMatch).source + '|$'
      , 'g');

      // Use a sourceURL for easier debugging.
      // The sourceURL gets injected into the source that's eval-ed, so be careful
      // to normalize all kinds of whitespace, so e.g. newlines (and unicode versions of it) can't sneak in
      // and escape the comment, thus injecting code that gets evaled.
      var sourceURL = '//# sourceURL=' +
        (hasOwnProperty.call(options, 'sourceURL')
          ? (options.sourceURL + '').replace(/\s/g, ' ')
          : ('lodash.templateSources[' + (++templateCounter) + ']')
        ) + '\n';

      string.replace(reDelimiters, function(match, escapeValue, interpolateValue, esTemplateValue, evaluateValue, offset) {
        interpolateValue || (interpolateValue = esTemplateValue);

        // Escape characters that can't be included in string literals.
        source += string.slice(index, offset).replace(reUnescapedString, escapeStringChar);

        // Replace delimiters with snippets.
        if (escapeValue) {
          isEscaping = true;
          source += "' +\n__e(" + escapeValue + ") +\n'";
        }
        if (evaluateValue) {
          isEvaluating = true;
          source += "';\n" + evaluateValue + ";\n__p += '";
        }
        if (interpolateValue) {
          source += "' +\n((__t = (" + interpolateValue + ")) == null ? '' : __t) +\n'";
        }
        index = offset + match.length;

        // The JS engine embedded in Adobe products needs `match` returned in
        // order to produce the correct `offset` value.
        return match;
      });

      source += "';\n";

      // If `variable` is not specified wrap a with-statement around the generated
      // code to add the data object to the top of the scope chain.
      var variable = hasOwnProperty.call(options, 'variable') && options.variable;
      if (!variable) {
        source = 'with (obj) {\n' + source + '\n}\n';
      }
      // Throw an error if a forbidden character was found in `variable`, to prevent
      // potential command injection attacks.
      else if (reForbiddenIdentifierChars.test(variable)) {
        throw new Error(INVALID_TEMPL_VAR_ERROR_TEXT);
      }

      // Cleanup code by stripping empty strings.
      source = (isEvaluating ? source.replace(reEmptyStringLeading, '') : source)
        .replace(reEmptyStringMiddle, '$1')
        .replace(reEmptyStringTrailing, '$1;');

      // Frame code as the function body.
      source = 'function(' + (variable || 'obj') + ') {\n' +
        (variable
          ? ''
          : 'obj || (obj = {});\n'
        ) +
        "var __t, __p = ''" +
        (isEscaping
           ? ', __e = _.escape'
           : ''
        ) +
        (isEvaluating
          ? ', __j = Array.prototype.join;\n' +
            "function print() { __p += __j.call(arguments, '') }\n"
          : ';\n'
        ) +
        source +
        'return __p\n}';

      var result = attempt(function() {
        return Function(importsKeys, sourceURL + 'return ' + source)
          .apply(undefined, importsValues);
      });

      // Provide the compiled function's source by its `toString` method or
      // the `source` property as a convenience for inlining compiled templates.
      result.source = source;
      if (isError(result)) {
        throw result;
      }
      return result;
    }

    /**
     * Converts `string`, as a whole, to lower case just like
     * [String#toLowerCase](https://mdn.io/toLowerCase).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the lower cased string.
     * @example
     *
     * _.toLower('--Foo-Bar--');
     * // => '--foo-bar--'
     *
     * _.toLower('fooBar');
     * // => 'foobar'
     *
     * _.toLower('__FOO_BAR__');
     * // => '__foo_bar__'
     */
    function toLower(value) {
      return toString(value).toLowerCase();
    }

    /**
     * Converts `string`, as a whole, to upper case just like
     * [String#toUpperCase](https://mdn.io/toUpperCase).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the upper cased string.
     * @example
     *
     * _.toUpper('--foo-bar--');
     * // => '--FOO-BAR--'
     *
     * _.toUpper('fooBar');
     * // => 'FOOBAR'
     *
     * _.toUpper('__foo_bar__');
     * // => '__FOO_BAR__'
     */
    function toUpper(value) {
      return toString(value).toUpperCase();
    }

    /**
     * Removes leading and trailing whitespace or specified characters from `string`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to trim.
     * @param {string} [chars=whitespace] The characters to trim.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {string} Returns the trimmed string.
     * @example
     *
     * _.trim('  abc  ');
     * // => 'abc'
     *
     * _.trim('-_-abc-_-', '_-');
     * // => 'abc'
     *
     * _.map(['  foo  ', '  bar  '], _.trim);
     * // => ['foo', 'bar']
     */
    function trim(string, chars, guard) {
      string = toString(string);
      if (string && (guard || chars === undefined)) {
        return baseTrim(string);
      }
      if (!string || !(chars = baseToString(chars))) {
        return string;
      }
      var strSymbols = stringToArray(string),
          chrSymbols = stringToArray(chars),
          start = charsStartIndex(strSymbols, chrSymbols),
          end = charsEndIndex(strSymbols, chrSymbols) + 1;

      return castSlice(strSymbols, start, end).join('');
    }

    /**
     * Removes trailing whitespace or specified characters from `string`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to trim.
     * @param {string} [chars=whitespace] The characters to trim.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {string} Returns the trimmed string.
     * @example
     *
     * _.trimEnd('  abc  ');
     * // => '  abc'
     *
     * _.trimEnd('-_-abc-_-', '_-');
     * // => '-_-abc'
     */
    function trimEnd(string, chars, guard) {
      string = toString(string);
      if (string && (guard || chars === undefined)) {
        return string.slice(0, trimmedEndIndex(string) + 1);
      }
      if (!string || !(chars = baseToString(chars))) {
        return string;
      }
      var strSymbols = stringToArray(string),
          end = charsEndIndex(strSymbols, stringToArray(chars)) + 1;

      return castSlice(strSymbols, 0, end).join('');
    }

    /**
     * Removes leading whitespace or specified characters from `string`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to trim.
     * @param {string} [chars=whitespace] The characters to trim.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {string} Returns the trimmed string.
     * @example
     *
     * _.trimStart('  abc  ');
     * // => 'abc  '
     *
     * _.trimStart('-_-abc-_-', '_-');
     * // => 'abc-_-'
     */
    function trimStart(string, chars, guard) {
      string = toString(string);
      if (string && (guard || chars === undefined)) {
        return string.replace(reTrimStart, '');
      }
      if (!string || !(chars = baseToString(chars))) {
        return string;
      }
      var strSymbols = stringToArray(string),
          start = charsStartIndex(strSymbols, stringToArray(chars));

      return castSlice(strSymbols, start).join('');
    }

    /**
     * Truncates `string` if it's longer than the given maximum string length.
     * The last characters of the truncated string are replaced with the omission
     * string which defaults to "...".
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to truncate.
     * @param {Object} [options={}] The options object.
     * @param {number} [options.length=30] The maximum string length.
     * @param {string} [options.omission='...'] The string to indicate text is omitted.
     * @param {RegExp|string} [options.separator] The separator pattern to truncate to.
     * @returns {string} Returns the truncated string.
     * @example
     *
     * _.truncate('hi-diddly-ho there, neighborino');
     * // => 'hi-diddly-ho there, neighbo...'
     *
     * _.truncate('hi-diddly-ho there, neighborino', {
     *   'length': 24,
     *   'separator': ' '
     * });
     * // => 'hi-diddly-ho there,...'
     *
     * _.truncate('hi-diddly-ho there, neighborino', {
     *   'length': 24,
     *   'separator': /,? +/
     * });
     * // => 'hi-diddly-ho there...'
     *
     * _.truncate('hi-diddly-ho there, neighborino', {
     *   'omission': ' [...]'
     * });
     * // => 'hi-diddly-ho there, neig [...]'
     */
    function truncate(string, options) {
      var length = DEFAULT_TRUNC_LENGTH,
          omission = DEFAULT_TRUNC_OMISSION;

      if (isObject(options)) {
        var separator = 'separator' in options ? options.separator : separator;
        length = 'length' in options ? toInteger(options.length) : length;
        omission = 'omission' in options ? baseToString(options.omission) : omission;
      }
      string = toString(string);

      var strLength = string.length;
      if (hasUnicode(string)) {
        var strSymbols = stringToArray(string);
        strLength = strSymbols.length;
      }
      if (length >= strLength) {
        return string;
      }
      var end = length - stringSize(omission);
      if (end < 1) {
        return omission;
      }
      var result = strSymbols
        ? castSlice(strSymbols, 0, end).join('')
        : string.slice(0, end);

      if (separator === undefined) {
        return result + omission;
      }
      if (strSymbols) {
        end += (result.length - end);
      }
      if (isRegExp(separator)) {
        if (string.slice(end).search(separator)) {
          var match,
              substring = result;

          if (!separator.global) {
            separator = RegExp(separator.source, toString(reFlags.exec(separator)) + 'g');
          }
          separator.lastIndex = 0;
          while ((match = separator.exec(substring))) {
            var newEnd = match.index;
          }
          result = result.slice(0, newEnd === undefined ? end : newEnd);
        }
      } else if (string.indexOf(baseToString(separator), end) != end) {
        var index = result.lastIndexOf(separator);
        if (index > -1) {
          result = result.slice(0, index);
        }
      }
      return result + omission;
    }

    /**
     * The inverse of `_.escape`; this method converts the HTML entities
     * `&amp;`, `&lt;`, `&gt;`, `&quot;`, and `&#39;` in `string` to
     * their corresponding characters.
     *
     * **Note:** No other HTML entities are unescaped. To unescape additional
     * HTML entities use a third-party library like [_he_](https://mths.be/he).
     *
     * @static
     * @memberOf _
     * @since 0.6.0
     * @category String
     * @param {string} [string=''] The string to unescape.
     * @returns {string} Returns the unescaped string.
     * @example
     *
     * _.unescape('fred, barney, &amp; pebbles');
     * // => 'fred, barney, & pebbles'
     */
    function unescape(string) {
      string = toString(string);
      return (string && reHasEscapedHtml.test(string))
        ? string.replace(reEscapedHtml, unescapeHtmlChar)
        : string;
    }

    /**
     * Converts `string`, as space separated words, to upper case.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the upper cased string.
     * @example
     *
     * _.upperCase('--foo-bar');
     * // => 'FOO BAR'
     *
     * _.upperCase('fooBar');
     * // => 'FOO BAR'
     *
     * _.upperCase('__foo_bar__');
     * // => 'FOO BAR'
     */
    var upperCase = createCompounder(function(result, word, index) {
      return result + (index ? ' ' : '') + word.toUpperCase();
    });

    /**
     * Converts the first character of `string` to upper case.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category String
     * @param {string} [string=''] The string to convert.
     * @returns {string} Returns the converted string.
     * @example
     *
     * _.upperFirst('fred');
     * // => 'Fred'
     *
     * _.upperFirst('FRED');
     * // => 'FRED'
     */
    var upperFirst = createCaseFirst('toUpperCase');

    /**
     * Splits `string` into an array of its words.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category String
     * @param {string} [string=''] The string to inspect.
     * @param {RegExp|string} [pattern] The pattern to match words.
     * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
     * @returns {Array} Returns the words of `string`.
     * @example
     *
     * _.words('fred, barney, & pebbles');
     * // => ['fred', 'barney', 'pebbles']
     *
     * _.words('fred, barney, & pebbles', /[^, ]+/g);
     * // => ['fred', 'barney', '&', 'pebbles']
     */
    function words(string, pattern, guard) {
      string = toString(string);
      pattern = guard ? undefined : pattern;

      if (pattern === undefined) {
        return hasUnicodeWord(string) ? unicodeWords(string) : asciiWords(string);
      }
      return string.match(pattern) || [];
    }

    /*------------------------------------------------------------------------*/

    /**
     * Attempts to invoke `func`, returning either the result or the caught error
     * object. Any additional arguments are provided to `func` when it's invoked.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Util
     * @param {Function} func The function to attempt.
     * @param {...*} [args] The arguments to invoke `func` with.
     * @returns {*} Returns the `func` result or error object.
     * @example
     *
     * // Avoid throwing errors for invalid selectors.
     * var elements = _.attempt(function(selector) {
     *   return document.querySelectorAll(selector);
     * }, '>_>');
     *
     * if (_.isError(elements)) {
     *   elements = [];
     * }
     */
    var attempt = baseRest(function(func, args) {
      try {
        return apply(func, undefined, args);
      } catch (e) {
        return isError(e) ? e : new Error(e);
      }
    });

    /**
     * Binds methods of an object to the object itself, overwriting the existing
     * method.
     *
     * **Note:** This method doesn't set the "length" property of bound functions.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {Object} object The object to bind and assign the bound methods to.
     * @param {...(string|string[])} methodNames The object method names to bind.
     * @returns {Object} Returns `object`.
     * @example
     *
     * var view = {
     *   'label': 'docs',
     *   'click': function() {
     *     console.log('clicked ' + this.label);
     *   }
     * };
     *
     * _.bindAll(view, ['click']);
     * jQuery(element).on('click', view.click);
     * // => Logs 'clicked docs' when clicked.
     */
    var bindAll = flatRest(function(object, methodNames) {
      arrayEach(methodNames, function(key) {
        key = toKey(key);
        baseAssignValue(object, key, bind(object[key], object));
      });
      return object;
    });

    /**
     * Creates a function that iterates over `pairs` and invokes the corresponding
     * function of the first predicate to return truthy. The predicate-function
     * pairs are invoked with the `this` binding and arguments of the created
     * function.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {Array} pairs The predicate-function pairs.
     * @returns {Function} Returns the new composite function.
     * @example
     *
     * var func = _.cond([
     *   [_.matches({ 'a': 1 }),           _.constant('matches A')],
     *   [_.conforms({ 'b': _.isNumber }), _.constant('matches B')],
     *   [_.stubTrue,                      _.constant('no match')]
     * ]);
     *
     * func({ 'a': 1, 'b': 2 });
     * // => 'matches A'
     *
     * func({ 'a': 0, 'b': 1 });
     * // => 'matches B'
     *
     * func({ 'a': '1', 'b': '2' });
     * // => 'no match'
     */
    function cond(pairs) {
      var length = pairs == null ? 0 : pairs.length,
          toIteratee = getIteratee();

      pairs = !length ? [] : arrayMap(pairs, function(pair) {
        if (typeof pair[1] != 'function') {
          throw new TypeError(FUNC_ERROR_TEXT);
        }
        return [toIteratee(pair[0]), pair[1]];
      });

      return baseRest(function(args) {
        var index = -1;
        while (++index < length) {
          var pair = pairs[index];
          if (apply(pair[0], this, args)) {
            return apply(pair[1], this, args);
          }
        }
      });
    }

    /**
     * Creates a function that invokes the predicate properties of `source` with
     * the corresponding property values of a given object, returning `true` if
     * all predicates return truthy, else `false`.
     *
     * **Note:** The created function is equivalent to `_.conformsTo` with
     * `source` partially applied.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {Object} source The object of property predicates to conform to.
     * @returns {Function} Returns the new spec function.
     * @example
     *
     * var objects = [
     *   { 'a': 2, 'b': 1 },
     *   { 'a': 1, 'b': 2 }
     * ];
     *
     * _.filter(objects, _.conforms({ 'b': function(n) { return n > 1; } }));
     * // => [{ 'a': 1, 'b': 2 }]
     */
    function conforms(source) {
      return baseConforms(baseClone(source, CLONE_DEEP_FLAG));
    }

    /**
     * Creates a function that returns `value`.
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Util
     * @param {*} value The value to return from the new function.
     * @returns {Function} Returns the new constant function.
     * @example
     *
     * var objects = _.times(2, _.constant({ 'a': 1 }));
     *
     * console.log(objects);
     * // => [{ 'a': 1 }, { 'a': 1 }]
     *
     * console.log(objects[0] === objects[1]);
     * // => true
     */
    function constant(value) {
      return function() {
        return value;
      };
    }

    /**
     * Checks `value` to determine whether a default value should be returned in
     * its place. The `defaultValue` is returned if `value` is `NaN`, `null`,
     * or `undefined`.
     *
     * @static
     * @memberOf _
     * @since 4.14.0
     * @category Util
     * @param {*} value The value to check.
     * @param {*} defaultValue The default value.
     * @returns {*} Returns the resolved value.
     * @example
     *
     * _.defaultTo(1, 10);
     * // => 1
     *
     * _.defaultTo(undefined, 10);
     * // => 10
     */
    function defaultTo(value, defaultValue) {
      return (value == null || value !== value) ? defaultValue : value;
    }

    /**
     * Creates a function that returns the result of invoking the given functions
     * with the `this` binding of the created function, where each successive
     * invocation is supplied the return value of the previous.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Util
     * @param {...(Function|Function[])} [funcs] The functions to invoke.
     * @returns {Function} Returns the new composite function.
     * @see _.flowRight
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var addSquare = _.flow([_.add, square]);
     * addSquare(1, 2);
     * // => 9
     */
    var flow = createFlow();

    /**
     * This method is like `_.flow` except that it creates a function that
     * invokes the given functions from right to left.
     *
     * @static
     * @since 3.0.0
     * @memberOf _
     * @category Util
     * @param {...(Function|Function[])} [funcs] The functions to invoke.
     * @returns {Function} Returns the new composite function.
     * @see _.flow
     * @example
     *
     * function square(n) {
     *   return n * n;
     * }
     *
     * var addSquare = _.flowRight([square, _.add]);
     * addSquare(1, 2);
     * // => 9
     */
    var flowRight = createFlow(true);

    /**
     * This method returns the first argument it receives.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {*} value Any value.
     * @returns {*} Returns `value`.
     * @example
     *
     * var object = { 'a': 1 };
     *
     * console.log(_.identity(object) === object);
     * // => true
     */
    function identity(value) {
      return value;
    }

    /**
     * Creates a function that invokes `func` with the arguments of the created
     * function. If `func` is a property name, the created function returns the
     * property value for a given element. If `func` is an array or object, the
     * created function returns `true` for elements that contain the equivalent
     * source properties, otherwise it returns `false`.
     *
     * @static
     * @since 4.0.0
     * @memberOf _
     * @category Util
     * @param {*} [func=_.identity] The value to convert to a callback.
     * @returns {Function} Returns the callback.
     * @example
     *
     * var users = [
     *   { 'user': 'barney', 'age': 36, 'active': true },
     *   { 'user': 'fred',   'age': 40, 'active': false }
     * ];
     *
     * // The `_.matches` iteratee shorthand.
     * _.filter(users, _.iteratee({ 'user': 'barney', 'active': true }));
     * // => [{ 'user': 'barney', 'age': 36, 'active': true }]
     *
     * // The `_.matchesProperty` iteratee shorthand.
     * _.filter(users, _.iteratee(['user', 'fred']));
     * // => [{ 'user': 'fred', 'age': 40 }]
     *
     * // The `_.property` iteratee shorthand.
     * _.map(users, _.iteratee('user'));
     * // => ['barney', 'fred']
     *
     * // Create custom iteratee shorthands.
     * _.iteratee = _.wrap(_.iteratee, function(iteratee, func) {
     *   return !_.isRegExp(func) ? iteratee(func) : function(string) {
     *     return func.test(string);
     *   };
     * });
     *
     * _.filter(['abc', 'def'], /ef/);
     * // => ['def']
     */
    function iteratee(func) {
      return baseIteratee(typeof func == 'function' ? func : baseClone(func, CLONE_DEEP_FLAG));
    }

    /**
     * Creates a function that performs a partial deep comparison between a given
     * object and `source`, returning `true` if the given object has equivalent
     * property values, else `false`.
     *
     * **Note:** The created function is equivalent to `_.isMatch` with `source`
     * partially applied.
     *
     * Partial comparisons will match empty array and empty object `source`
     * values against any array or object value, respectively. See `_.isEqual`
     * for a list of supported value comparisons.
     *
     * **Note:** Multiple values can be checked by combining several matchers
     * using `_.overSome`
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Util
     * @param {Object} source The object of property values to match.
     * @returns {Function} Returns the new spec function.
     * @example
     *
     * var objects = [
     *   { 'a': 1, 'b': 2, 'c': 3 },
     *   { 'a': 4, 'b': 5, 'c': 6 }
     * ];
     *
     * _.filter(objects, _.matches({ 'a': 4, 'c': 6 }));
     * // => [{ 'a': 4, 'b': 5, 'c': 6 }]
     *
     * // Checking for several possible values
     * _.filter(objects, _.overSome([_.matches({ 'a': 1 }), _.matches({ 'a': 4 })]));
     * // => [{ 'a': 1, 'b': 2, 'c': 3 }, { 'a': 4, 'b': 5, 'c': 6 }]
     */
    function matches(source) {
      return baseMatches(baseClone(source, CLONE_DEEP_FLAG));
    }

    /**
     * Creates a function that performs a partial deep comparison between the
     * value at `path` of a given object to `srcValue`, returning `true` if the
     * object value is equivalent, else `false`.
     *
     * **Note:** Partial comparisons will match empty array and empty object
     * `srcValue` values against any array or object value, respectively. See
     * `_.isEqual` for a list of supported value comparisons.
     *
     * **Note:** Multiple values can be checked by combining several matchers
     * using `_.overSome`
     *
     * @static
     * @memberOf _
     * @since 3.2.0
     * @category Util
     * @param {Array|string} path The path of the property to get.
     * @param {*} srcValue The value to match.
     * @returns {Function} Returns the new spec function.
     * @example
     *
     * var objects = [
     *   { 'a': 1, 'b': 2, 'c': 3 },
     *   { 'a': 4, 'b': 5, 'c': 6 }
     * ];
     *
     * _.find(objects, _.matchesProperty('a', 4));
     * // => { 'a': 4, 'b': 5, 'c': 6 }
     *
     * // Checking for several possible values
     * _.filter(objects, _.overSome([_.matchesProperty('a', 1), _.matchesProperty('a', 4)]));
     * // => [{ 'a': 1, 'b': 2, 'c': 3 }, { 'a': 4, 'b': 5, 'c': 6 }]
     */
    function matchesProperty(path, srcValue) {
      return baseMatchesProperty(path, baseClone(srcValue, CLONE_DEEP_FLAG));
    }

    /**
     * Creates a function that invokes the method at `path` of a given object.
     * Any additional arguments are provided to the invoked method.
     *
     * @static
     * @memberOf _
     * @since 3.7.0
     * @category Util
     * @param {Array|string} path The path of the method to invoke.
     * @param {...*} [args] The arguments to invoke the method with.
     * @returns {Function} Returns the new invoker function.
     * @example
     *
     * var objects = [
     *   { 'a': { 'b': _.constant(2) } },
     *   { 'a': { 'b': _.constant(1) } }
     * ];
     *
     * _.map(objects, _.method('a.b'));
     * // => [2, 1]
     *
     * _.map(objects, _.method(['a', 'b']));
     * // => [2, 1]
     */
    var method = baseRest(function(path, args) {
      return function(object) {
        return baseInvoke(object, path, args);
      };
    });

    /**
     * The opposite of `_.method`; this method creates a function that invokes
     * the method at a given path of `object`. Any additional arguments are
     * provided to the invoked method.
     *
     * @static
     * @memberOf _
     * @since 3.7.0
     * @category Util
     * @param {Object} object The object to query.
     * @param {...*} [args] The arguments to invoke the method with.
     * @returns {Function} Returns the new invoker function.
     * @example
     *
     * var array = _.times(3, _.constant),
     *     object = { 'a': array, 'b': array, 'c': array };
     *
     * _.map(['a[2]', 'c[0]'], _.methodOf(object));
     * // => [2, 0]
     *
     * _.map([['a', '2'], ['c', '0']], _.methodOf(object));
     * // => [2, 0]
     */
    var methodOf = baseRest(function(object, args) {
      return function(path) {
        return baseInvoke(object, path, args);
      };
    });

    /**
     * Adds all own enumerable string keyed function properties of a source
     * object to the destination object. If `object` is a function, then methods
     * are added to its prototype as well.
     *
     * **Note:** Use `_.runInContext` to create a pristine `lodash` function to
     * avoid conflicts caused by modifying the original.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {Function|Object} [object=lodash] The destination object.
     * @param {Object} source The object of functions to add.
     * @param {Object} [options={}] The options object.
     * @param {boolean} [options.chain=true] Specify whether mixins are chainable.
     * @returns {Function|Object} Returns `object`.
     * @example
     *
     * function vowels(string) {
     *   return _.filter(string, function(v) {
     *     return /[aeiou]/i.test(v);
     *   });
     * }
     *
     * _.mixin({ 'vowels': vowels });
     * _.vowels('fred');
     * // => ['e']
     *
     * _('fred').vowels().value();
     * // => ['e']
     *
     * _.mixin({ 'vowels': vowels }, { 'chain': false });
     * _('fred').vowels();
     * // => ['e']
     */
    function mixin(object, source, options) {
      var props = keys(source),
          methodNames = baseFunctions(source, props);

      if (options == null &&
          !(isObject(source) && (methodNames.length || !props.length))) {
        options = source;
        source = object;
        object = this;
        methodNames = baseFunctions(source, keys(source));
      }
      var chain = !(isObject(options) && 'chain' in options) || !!options.chain,
          isFunc = isFunction(object);

      arrayEach(methodNames, function(methodName) {
        var func = source[methodName];
        object[methodName] = func;
        if (isFunc) {
          object.prototype[methodName] = function() {
            var chainAll = this.__chain__;
            if (chain || chainAll) {
              var result = object(this.__wrapped__),
                  actions = result.__actions__ = copyArray(this.__actions__);

              actions.push({ 'func': func, 'args': arguments, 'thisArg': object });
              result.__chain__ = chainAll;
              return result;
            }
            return func.apply(object, arrayPush([this.value()], arguments));
          };
        }
      });

      return object;
    }

    /**
     * Reverts the `_` variable to its previous value and returns a reference to
     * the `lodash` function.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @returns {Function} Returns the `lodash` function.
     * @example
     *
     * var lodash = _.noConflict();
     */
    function noConflict() {
      if (root._ === this) {
        root._ = oldDash;
      }
      return this;
    }

    /**
     * This method returns `undefined`.
     *
     * @static
     * @memberOf _
     * @since 2.3.0
     * @category Util
     * @example
     *
     * _.times(2, _.noop);
     * // => [undefined, undefined]
     */
    function noop() {
      // No operation performed.
    }

    /**
     * Creates a function that gets the argument at index `n`. If `n` is negative,
     * the nth argument from the end is returned.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {number} [n=0] The index of the argument to return.
     * @returns {Function} Returns the new pass-thru function.
     * @example
     *
     * var func = _.nthArg(1);
     * func('a', 'b', 'c', 'd');
     * // => 'b'
     *
     * var func = _.nthArg(-2);
     * func('a', 'b', 'c', 'd');
     * // => 'c'
     */
    function nthArg(n) {
      n = toInteger(n);
      return baseRest(function(args) {
        return baseNth(args, n);
      });
    }

    /**
     * Creates a function that invokes `iteratees` with the arguments it receives
     * and returns their results.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {...(Function|Function[])} [iteratees=[_.identity]]
     *  The iteratees to invoke.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var func = _.over([Math.max, Math.min]);
     *
     * func(1, 2, 3, 4);
     * // => [4, 1]
     */
    var over = createOver(arrayMap);

    /**
     * Creates a function that checks if **all** of the `predicates` return
     * truthy when invoked with the arguments it receives.
     *
     * Following shorthands are possible for providing predicates.
     * Pass an `Object` and it will be used as an parameter for `_.matches` to create the predicate.
     * Pass an `Array` of parameters for `_.matchesProperty` and the predicate will be created using them.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {...(Function|Function[])} [predicates=[_.identity]]
     *  The predicates to check.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var func = _.overEvery([Boolean, isFinite]);
     *
     * func('1');
     * // => true
     *
     * func(null);
     * // => false
     *
     * func(NaN);
     * // => false
     */
    var overEvery = createOver(arrayEvery);

    /**
     * Creates a function that checks if **any** of the `predicates` return
     * truthy when invoked with the arguments it receives.
     *
     * Following shorthands are possible for providing predicates.
     * Pass an `Object` and it will be used as an parameter for `_.matches` to create the predicate.
     * Pass an `Array` of parameters for `_.matchesProperty` and the predicate will be created using them.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {...(Function|Function[])} [predicates=[_.identity]]
     *  The predicates to check.
     * @returns {Function} Returns the new function.
     * @example
     *
     * var func = _.overSome([Boolean, isFinite]);
     *
     * func('1');
     * // => true
     *
     * func(null);
     * // => true
     *
     * func(NaN);
     * // => false
     *
     * var matchesFunc = _.overSome([{ 'a': 1 }, { 'a': 2 }])
     * var matchesPropertyFunc = _.overSome([['a', 1], ['a', 2]])
     */
    var overSome = createOver(arraySome);

    /**
     * Creates a function that returns the value at `path` of a given object.
     *
     * @static
     * @memberOf _
     * @since 2.4.0
     * @category Util
     * @param {Array|string} path The path of the property to get.
     * @returns {Function} Returns the new accessor function.
     * @example
     *
     * var objects = [
     *   { 'a': { 'b': 2 } },
     *   { 'a': { 'b': 1 } }
     * ];
     *
     * _.map(objects, _.property('a.b'));
     * // => [2, 1]
     *
     * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
     * // => [1, 2]
     */
    function property(path) {
      return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
    }

    /**
     * The opposite of `_.property`; this method creates a function that returns
     * the value at a given path of `object`.
     *
     * @static
     * @memberOf _
     * @since 3.0.0
     * @category Util
     * @param {Object} object The object to query.
     * @returns {Function} Returns the new accessor function.
     * @example
     *
     * var array = [0, 1, 2],
     *     object = { 'a': array, 'b': array, 'c': array };
     *
     * _.map(['a[2]', 'c[0]'], _.propertyOf(object));
     * // => [2, 0]
     *
     * _.map([['a', '2'], ['c', '0']], _.propertyOf(object));
     * // => [2, 0]
     */
    function propertyOf(object) {
      return function(path) {
        return object == null ? undefined : baseGet(object, path);
      };
    }

    /**
     * Creates an array of numbers (positive and/or negative) progressing from
     * `start` up to, but not including, `end`. A step of `-1` is used if a negative
     * `start` is specified without an `end` or `step`. If `end` is not specified,
     * it's set to `start` with `start` then set to `0`.
     *
     * **Note:** JavaScript follows the IEEE-754 standard for resolving
     * floating-point values which can produce unexpected results.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {number} [start=0] The start of the range.
     * @param {number} end The end of the range.
     * @param {number} [step=1] The value to increment or decrement by.
     * @returns {Array} Returns the range of numbers.
     * @see _.inRange, _.rangeRight
     * @example
     *
     * _.range(4);
     * // => [0, 1, 2, 3]
     *
     * _.range(-4);
     * // => [0, -1, -2, -3]
     *
     * _.range(1, 5);
     * // => [1, 2, 3, 4]
     *
     * _.range(0, 20, 5);
     * // => [0, 5, 10, 15]
     *
     * _.range(0, -4, -1);
     * // => [0, -1, -2, -3]
     *
     * _.range(1, 4, 0);
     * // => [1, 1, 1]
     *
     * _.range(0);
     * // => []
     */
    var range = createRange();

    /**
     * This method is like `_.range` except that it populates values in
     * descending order.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {number} [start=0] The start of the range.
     * @param {number} end The end of the range.
     * @param {number} [step=1] The value to increment or decrement by.
     * @returns {Array} Returns the range of numbers.
     * @see _.inRange, _.range
     * @example
     *
     * _.rangeRight(4);
     * // => [3, 2, 1, 0]
     *
     * _.rangeRight(-4);
     * // => [-3, -2, -1, 0]
     *
     * _.rangeRight(1, 5);
     * // => [4, 3, 2, 1]
     *
     * _.rangeRight(0, 20, 5);
     * // => [15, 10, 5, 0]
     *
     * _.rangeRight(0, -4, -1);
     * // => [-3, -2, -1, 0]
     *
     * _.rangeRight(1, 4, 0);
     * // => [1, 1, 1]
     *
     * _.rangeRight(0);
     * // => []
     */
    var rangeRight = createRange(true);

    /**
     * This method returns a new empty array.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {Array} Returns the new empty array.
     * @example
     *
     * var arrays = _.times(2, _.stubArray);
     *
     * console.log(arrays);
     * // => [[], []]
     *
     * console.log(arrays[0] === arrays[1]);
     * // => false
     */
    function stubArray() {
      return [];
    }

    /**
     * This method returns `false`.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {boolean} Returns `false`.
     * @example
     *
     * _.times(2, _.stubFalse);
     * // => [false, false]
     */
    function stubFalse() {
      return false;
    }

    /**
     * This method returns a new empty object.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {Object} Returns the new empty object.
     * @example
     *
     * var objects = _.times(2, _.stubObject);
     *
     * console.log(objects);
     * // => [{}, {}]
     *
     * console.log(objects[0] === objects[1]);
     * // => false
     */
    function stubObject() {
      return {};
    }

    /**
     * This method returns an empty string.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {string} Returns the empty string.
     * @example
     *
     * _.times(2, _.stubString);
     * // => ['', '']
     */
    function stubString() {
      return '';
    }

    /**
     * This method returns `true`.
     *
     * @static
     * @memberOf _
     * @since 4.13.0
     * @category Util
     * @returns {boolean} Returns `true`.
     * @example
     *
     * _.times(2, _.stubTrue);
     * // => [true, true]
     */
    function stubTrue() {
      return true;
    }

    /**
     * Invokes the iteratee `n` times, returning an array of the results of
     * each invocation. The iteratee is invoked with one argument; (index).
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {number} n The number of times to invoke `iteratee`.
     * @param {Function} [iteratee=_.identity] The function invoked per iteration.
     * @returns {Array} Returns the array of results.
     * @example
     *
     * _.times(3, String);
     * // => ['0', '1', '2']
     *
     *  _.times(4, _.constant(0));
     * // => [0, 0, 0, 0]
     */
    function times(n, iteratee) {
      n = toInteger(n);
      if (n < 1 || n > MAX_SAFE_INTEGER) {
        return [];
      }
      var index = MAX_ARRAY_LENGTH,
          length = nativeMin(n, MAX_ARRAY_LENGTH);

      iteratee = getIteratee(iteratee);
      n -= MAX_ARRAY_LENGTH;

      var result = baseTimes(length, iteratee);
      while (++index < n) {
        iteratee(index);
      }
      return result;
    }

    /**
     * Converts `value` to a property path array.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Util
     * @param {*} value The value to convert.
     * @returns {Array} Returns the new property path array.
     * @example
     *
     * _.toPath('a.b.c');
     * // => ['a', 'b', 'c']
     *
     * _.toPath('a[0].b.c');
     * // => ['a', '0', 'b', 'c']
     */
    function toPath(value) {
      if (isArray(value)) {
        return arrayMap(value, toKey);
      }
      return isSymbol(value) ? [value] : copyArray(stringToPath(toString(value)));
    }

    /**
     * Generates a unique ID. If `prefix` is given, the ID is appended to it.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Util
     * @param {string} [prefix=''] The value to prefix the ID with.
     * @returns {string} Returns the unique ID.
     * @example
     *
     * _.uniqueId('contact_');
     * // => 'contact_104'
     *
     * _.uniqueId();
     * // => '105'
     */
    function uniqueId(prefix) {
      var id = ++idCounter;
      return toString(prefix) + id;
    }

    /*------------------------------------------------------------------------*/

    /**
     * Adds two numbers.
     *
     * @static
     * @memberOf _
     * @since 3.4.0
     * @category Math
     * @param {number} augend The first number in an addition.
     * @param {number} addend The second number in an addition.
     * @returns {number} Returns the total.
     * @example
     *
     * _.add(6, 4);
     * // => 10
     */
    var add = createMathOperation(function(augend, addend) {
      return augend + addend;
    }, 0);

    /**
     * Computes `number` rounded up to `precision`.
     *
     * @static
     * @memberOf _
     * @since 3.10.0
     * @category Math
     * @param {number} number The number to round up.
     * @param {number} [precision=0] The precision to round up to.
     * @returns {number} Returns the rounded up number.
     * @example
     *
     * _.ceil(4.006);
     * // => 5
     *
     * _.ceil(6.004, 2);
     * // => 6.01
     *
     * _.ceil(6040, -2);
     * // => 6100
     */
    var ceil = createRound('ceil');

    /**
     * Divide two numbers.
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Math
     * @param {number} dividend The first number in a division.
     * @param {number} divisor The second number in a division.
     * @returns {number} Returns the quotient.
     * @example
     *
     * _.divide(6, 4);
     * // => 1.5
     */
    var divide = createMathOperation(function(dividend, divisor) {
      return dividend / divisor;
    }, 1);

    /**
     * Computes `number` rounded down to `precision`.
     *
     * @static
     * @memberOf _
     * @since 3.10.0
     * @category Math
     * @param {number} number The number to round down.
     * @param {number} [precision=0] The precision to round down to.
     * @returns {number} Returns the rounded down number.
     * @example
     *
     * _.floor(4.006);
     * // => 4
     *
     * _.floor(0.046, 2);
     * // => 0.04
     *
     * _.floor(4060, -2);
     * // => 4000
     */
    var floor = createRound('floor');

    /**
     * Computes the maximum value of `array`. If `array` is empty or falsey,
     * `undefined` is returned.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Math
     * @param {Array} array The array to iterate over.
     * @returns {*} Returns the maximum value.
     * @example
     *
     * _.max([4, 2, 8, 6]);
     * // => 8
     *
     * _.max([]);
     * // => undefined
     */
    function max(array) {
      return (array && array.length)
        ? baseExtremum(array, identity, baseGt)
        : undefined;
    }

    /**
     * This method is like `_.max` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the criterion by which
     * the value is ranked. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {*} Returns the maximum value.
     * @example
     *
     * var objects = [{ 'n': 1 }, { 'n': 2 }];
     *
     * _.maxBy(objects, function(o) { return o.n; });
     * // => { 'n': 2 }
     *
     * // The `_.property` iteratee shorthand.
     * _.maxBy(objects, 'n');
     * // => { 'n': 2 }
     */
    function maxBy(array, iteratee) {
      return (array && array.length)
        ? baseExtremum(array, getIteratee(iteratee, 2), baseGt)
        : undefined;
    }

    /**
     * Computes the mean of the values in `array`.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @returns {number} Returns the mean.
     * @example
     *
     * _.mean([4, 2, 8, 6]);
     * // => 5
     */
    function mean(array) {
      return baseMean(array, identity);
    }

    /**
     * This method is like `_.mean` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the value to be averaged.
     * The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {number} Returns the mean.
     * @example
     *
     * var objects = [{ 'n': 4 }, { 'n': 2 }, { 'n': 8 }, { 'n': 6 }];
     *
     * _.meanBy(objects, function(o) { return o.n; });
     * // => 5
     *
     * // The `_.property` iteratee shorthand.
     * _.meanBy(objects, 'n');
     * // => 5
     */
    function meanBy(array, iteratee) {
      return baseMean(array, getIteratee(iteratee, 2));
    }

    /**
     * Computes the minimum value of `array`. If `array` is empty or falsey,
     * `undefined` is returned.
     *
     * @static
     * @since 0.1.0
     * @memberOf _
     * @category Math
     * @param {Array} array The array to iterate over.
     * @returns {*} Returns the minimum value.
     * @example
     *
     * _.min([4, 2, 8, 6]);
     * // => 2
     *
     * _.min([]);
     * // => undefined
     */
    function min(array) {
      return (array && array.length)
        ? baseExtremum(array, identity, baseLt)
        : undefined;
    }

    /**
     * This method is like `_.min` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the criterion by which
     * the value is ranked. The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {*} Returns the minimum value.
     * @example
     *
     * var objects = [{ 'n': 1 }, { 'n': 2 }];
     *
     * _.minBy(objects, function(o) { return o.n; });
     * // => { 'n': 1 }
     *
     * // The `_.property` iteratee shorthand.
     * _.minBy(objects, 'n');
     * // => { 'n': 1 }
     */
    function minBy(array, iteratee) {
      return (array && array.length)
        ? baseExtremum(array, getIteratee(iteratee, 2), baseLt)
        : undefined;
    }

    /**
     * Multiply two numbers.
     *
     * @static
     * @memberOf _
     * @since 4.7.0
     * @category Math
     * @param {number} multiplier The first number in a multiplication.
     * @param {number} multiplicand The second number in a multiplication.
     * @returns {number} Returns the product.
     * @example
     *
     * _.multiply(6, 4);
     * // => 24
     */
    var multiply = createMathOperation(function(multiplier, multiplicand) {
      return multiplier * multiplicand;
    }, 1);

    /**
     * Computes `number` rounded to `precision`.
     *
     * @static
     * @memberOf _
     * @since 3.10.0
     * @category Math
     * @param {number} number The number to round.
     * @param {number} [precision=0] The precision to round to.
     * @returns {number} Returns the rounded number.
     * @example
     *
     * _.round(4.006);
     * // => 4
     *
     * _.round(4.006, 2);
     * // => 4.01
     *
     * _.round(4060, -2);
     * // => 4100
     */
    var round = createRound('round');

    /**
     * Subtract two numbers.
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {number} minuend The first number in a subtraction.
     * @param {number} subtrahend The second number in a subtraction.
     * @returns {number} Returns the difference.
     * @example
     *
     * _.subtract(6, 4);
     * // => 2
     */
    var subtract = createMathOperation(function(minuend, subtrahend) {
      return minuend - subtrahend;
    }, 0);

    /**
     * Computes the sum of the values in `array`.
     *
     * @static
     * @memberOf _
     * @since 3.4.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @returns {number} Returns the sum.
     * @example
     *
     * _.sum([4, 2, 8, 6]);
     * // => 20
     */
    function sum(array) {
      return (array && array.length)
        ? baseSum(array, identity)
        : 0;
    }

    /**
     * This method is like `_.sum` except that it accepts `iteratee` which is
     * invoked for each element in `array` to generate the value to be summed.
     * The iteratee is invoked with one argument: (value).
     *
     * @static
     * @memberOf _
     * @since 4.0.0
     * @category Math
     * @param {Array} array The array to iterate over.
     * @param {Function} [iteratee=_.identity] The iteratee invoked per element.
     * @returns {number} Returns the sum.
     * @example
     *
     * var objects = [{ 'n': 4 }, { 'n': 2 }, { 'n': 8 }, { 'n': 6 }];
     *
     * _.sumBy(objects, function(o) { return o.n; });
     * // => 20
     *
     * // The `_.property` iteratee shorthand.
     * _.sumBy(objects, 'n');
     * // => 20
     */
    function sumBy(array, iteratee) {
      return (array && array.length)
        ? baseSum(array, getIteratee(iteratee, 2))
        : 0;
    }

    /*------------------------------------------------------------------------*/

    // Add methods that return wrapped values in chain sequences.
    lodash.after = after;
    lodash.ary = ary;
    lodash.assign = assign;
    lodash.assignIn = assignIn;
    lodash.assignInWith = assignInWith;
    lodash.assignWith = assignWith;
    lodash.at = at;
    lodash.before = before;
    lodash.bind = bind;
    lodash.bindAll = bindAll;
    lodash.bindKey = bindKey;
    lodash.castArray = castArray;
    lodash.chain = chain;
    lodash.chunk = chunk;
    lodash.compact = compact;
    lodash.concat = concat;
    lodash.cond = cond;
    lodash.conforms = conforms;
    lodash.constant = constant;
    lodash.countBy = countBy;
    lodash.create = create;
    lodash.curry = curry;
    lodash.curryRight = curryRight;
    lodash.debounce = debounce;
    lodash.defaults = defaults;
    lodash.defaultsDeep = defaultsDeep;
    lodash.defer = defer;
    lodash.delay = delay;
    lodash.difference = difference;
    lodash.differenceBy = differenceBy;
    lodash.differenceWith = differenceWith;
    lodash.drop = drop;
    lodash.dropRight = dropRight;
    lodash.dropRightWhile = dropRightWhile;
    lodash.dropWhile = dropWhile;
    lodash.fill = fill;
    lodash.filter = filter;
    lodash.flatMap = flatMap;
    lodash.flatMapDeep = flatMapDeep;
    lodash.flatMapDepth = flatMapDepth;
    lodash.flatten = flatten;
    lodash.flattenDeep = flattenDeep;
    lodash.flattenDepth = flattenDepth;
    lodash.flip = flip;
    lodash.flow = flow;
    lodash.flowRight = flowRight;
    lodash.fromPairs = fromPairs;
    lodash.functions = functions;
    lodash.functionsIn = functionsIn;
    lodash.groupBy = groupBy;
    lodash.initial = initial;
    lodash.intersection = intersection;
    lodash.intersectionBy = intersectionBy;
    lodash.intersectionWith = intersectionWith;
    lodash.invert = invert;
    lodash.invertBy = invertBy;
    lodash.invokeMap = invokeMap;
    lodash.iteratee = iteratee;
    lodash.keyBy = keyBy;
    lodash.keys = keys;
    lodash.keysIn = keysIn;
    lodash.map = map;
    lodash.mapKeys = mapKeys;
    lodash.mapValues = mapValues;
    lodash.matches = matches;
    lodash.matchesProperty = matchesProperty;
    lodash.memoize = memoize;
    lodash.merge = merge;
    lodash.mergeWith = mergeWith;
    lodash.method = method;
    lodash.methodOf = methodOf;
    lodash.mixin = mixin;
    lodash.negate = negate;
    lodash.nthArg = nthArg;
    lodash.omit = omit;
    lodash.omitBy = omitBy;
    lodash.once = once;
    lodash.orderBy = orderBy;
    lodash.over = over;
    lodash.overArgs = overArgs;
    lodash.overEvery = overEvery;
    lodash.overSome = overSome;
    lodash.partial = partial;
    lodash.partialRight = partialRight;
    lodash.partition = partition;
    lodash.pick = pick;
    lodash.pickBy = pickBy;
    lodash.property = property;
    lodash.propertyOf = propertyOf;
    lodash.pull = pull;
    lodash.pullAll = pullAll;
    lodash.pullAllBy = pullAllBy;
    lodash.pullAllWith = pullAllWith;
    lodash.pullAt = pullAt;
    lodash.range = range;
    lodash.rangeRight = rangeRight;
    lodash.rearg = rearg;
    lodash.reject = reject;
    lodash.remove = remove;
    lodash.rest = rest;
    lodash.reverse = reverse;
    lodash.sampleSize = sampleSize;
    lodash.set = set;
    lodash.setWith = setWith;
    lodash.shuffle = shuffle;
    lodash.slice = slice;
    lodash.sortBy = sortBy;
    lodash.sortedUniq = sortedUniq;
    lodash.sortedUniqBy = sortedUniqBy;
    lodash.split = split;
    lodash.spread = spread;
    lodash.tail = tail;
    lodash.take = take;
    lodash.takeRight = takeRight;
    lodash.takeRightWhile = takeRightWhile;
    lodash.takeWhile = takeWhile;
    lodash.tap = tap;
    lodash.throttle = throttle;
    lodash.thru = thru;
    lodash.toArray = toArray;
    lodash.toPairs = toPairs;
    lodash.toPairsIn = toPairsIn;
    lodash.toPath = toPath;
    lodash.toPlainObject = toPlainObject;
    lodash.transform = transform;
    lodash.unary = unary;
    lodash.union = union;
    lodash.unionBy = unionBy;
    lodash.unionWith = unionWith;
    lodash.uniq = uniq;
    lodash.uniqBy = uniqBy;
    lodash.uniqWith = uniqWith;
    lodash.unset = unset;
    lodash.unzip = unzip;
    lodash.unzipWith = unzipWith;
    lodash.update = update;
    lodash.updateWith = updateWith;
    lodash.values = values;
    lodash.valuesIn = valuesIn;
    lodash.without = without;
    lodash.words = words;
    lodash.wrap = wrap;
    lodash.xor = xor;
    lodash.xorBy = xorBy;
    lodash.xorWith = xorWith;
    lodash.zip = zip;
    lodash.zipObject = zipObject;
    lodash.zipObjectDeep = zipObjectDeep;
    lodash.zipWith = zipWith;

    // Add aliases.
    lodash.entries = toPairs;
    lodash.entriesIn = toPairsIn;
    lodash.extend = assignIn;
    lodash.extendWith = assignInWith;

    // Add methods to `lodash.prototype`.
    mixin(lodash, lodash);

    /*------------------------------------------------------------------------*/

    // Add methods that return unwrapped values in chain sequences.
    lodash.add = add;
    lodash.attempt = attempt;
    lodash.camelCase = camelCase;
    lodash.capitalize = capitalize;
    lodash.ceil = ceil;
    lodash.clamp = clamp;
    lodash.clone = clone;
    lodash.cloneDeep = cloneDeep;
    lodash.cloneDeepWith = cloneDeepWith;
    lodash.cloneWith = cloneWith;
    lodash.conformsTo = conformsTo;
    lodash.deburr = deburr;
    lodash.defaultTo = defaultTo;
    lodash.divide = divide;
    lodash.endsWith = endsWith;
    lodash.eq = eq;
    lodash.escape = escape;
    lodash.escapeRegExp = escapeRegExp;
    lodash.every = every;
    lodash.find = find;
    lodash.findIndex = findIndex;
    lodash.findKey = findKey;
    lodash.findLast = findLast;
    lodash.findLastIndex = findLastIndex;
    lodash.findLastKey = findLastKey;
    lodash.floor = floor;
    lodash.forEach = forEach;
    lodash.forEachRight = forEachRight;
    lodash.forIn = forIn;
    lodash.forInRight = forInRight;
    lodash.forOwn = forOwn;
    lodash.forOwnRight = forOwnRight;
    lodash.get = get;
    lodash.gt = gt;
    lodash.gte = gte;
    lodash.has = has;
    lodash.hasIn = hasIn;
    lodash.head = head;
    lodash.identity = identity;
    lodash.includes = includes;
    lodash.indexOf = indexOf;
    lodash.inRange = inRange;
    lodash.invoke = invoke;
    lodash.isArguments = isArguments;
    lodash.isArray = isArray;
    lodash.isArrayBuffer = isArrayBuffer;
    lodash.isArrayLike = isArrayLike;
    lodash.isArrayLikeObject = isArrayLikeObject;
    lodash.isBoolean = isBoolean;
    lodash.isBuffer = isBuffer;
    lodash.isDate = isDate;
    lodash.isElement = isElement;
    lodash.isEmpty = isEmpty;
    lodash.isEqual = isEqual;
    lodash.isEqualWith = isEqualWith;
    lodash.isError = isError;
    lodash.isFinite = isFinite;
    lodash.isFunction = isFunction;
    lodash.isInteger = isInteger;
    lodash.isLength = isLength;
    lodash.isMap = isMap;
    lodash.isMatch = isMatch;
    lodash.isMatchWith = isMatchWith;
    lodash.isNaN = isNaN;
    lodash.isNative = isNative;
    lodash.isNil = isNil;
    lodash.isNull = isNull;
    lodash.isNumber = isNumber;
    lodash.isObject = isObject;
    lodash.isObjectLike = isObjectLike;
    lodash.isPlainObject = isPlainObject;
    lodash.isRegExp = isRegExp;
    lodash.isSafeInteger = isSafeInteger;
    lodash.isSet = isSet;
    lodash.isString = isString;
    lodash.isSymbol = isSymbol;
    lodash.isTypedArray = isTypedArray;
    lodash.isUndefined = isUndefined;
    lodash.isWeakMap = isWeakMap;
    lodash.isWeakSet = isWeakSet;
    lodash.join = join;
    lodash.kebabCase = kebabCase;
    lodash.last = last;
    lodash.lastIndexOf = lastIndexOf;
    lodash.lowerCase = lowerCase;
    lodash.lowerFirst = lowerFirst;
    lodash.lt = lt;
    lodash.lte = lte;
    lodash.max = max;
    lodash.maxBy = maxBy;
    lodash.mean = mean;
    lodash.meanBy = meanBy;
    lodash.min = min;
    lodash.minBy = minBy;
    lodash.stubArray = stubArray;
    lodash.stubFalse = stubFalse;
    lodash.stubObject = stubObject;
    lodash.stubString = stubString;
    lodash.stubTrue = stubTrue;
    lodash.multiply = multiply;
    lodash.nth = nth;
    lodash.noConflict = noConflict;
    lodash.noop = noop;
    lodash.now = now;
    lodash.pad = pad;
    lodash.padEnd = padEnd;
    lodash.padStart = padStart;
    lodash.parseInt = parseInt;
    lodash.random = random;
    lodash.reduce = reduce;
    lodash.reduceRight = reduceRight;
    lodash.repeat = repeat;
    lodash.replace = replace;
    lodash.result = result;
    lodash.round = round;
    lodash.runInContext = runInContext;
    lodash.sample = sample;
    lodash.size = size;
    lodash.snakeCase = snakeCase;
    lodash.some = some;
    lodash.sortedIndex = sortedIndex;
    lodash.sortedIndexBy = sortedIndexBy;
    lodash.sortedIndexOf = sortedIndexOf;
    lodash.sortedLastIndex = sortedLastIndex;
    lodash.sortedLastIndexBy = sortedLastIndexBy;
    lodash.sortedLastIndexOf = sortedLastIndexOf;
    lodash.startCase = startCase;
    lodash.startsWith = startsWith;
    lodash.subtract = subtract;
    lodash.sum = sum;
    lodash.sumBy = sumBy;
    lodash.template = template;
    lodash.times = times;
    lodash.toFinite = toFinite;
    lodash.toInteger = toInteger;
    lodash.toLength = toLength;
    lodash.toLower = toLower;
    lodash.toNumber = toNumber;
    lodash.toSafeInteger = toSafeInteger;
    lodash.toString = toString;
    lodash.toUpper = toUpper;
    lodash.trim = trim;
    lodash.trimEnd = trimEnd;
    lodash.trimStart = trimStart;
    lodash.truncate = truncate;
    lodash.unescape = unescape;
    lodash.uniqueId = uniqueId;
    lodash.upperCase = upperCase;
    lodash.upperFirst = upperFirst;

    // Add aliases.
    lodash.each = forEach;
    lodash.eachRight = forEachRight;
    lodash.first = head;

    mixin(lodash, (function() {
      var source = {};
      baseForOwn(lodash, function(func, methodName) {
        if (!hasOwnProperty.call(lodash.prototype, methodName)) {
          source[methodName] = func;
        }
      });
      return source;
    }()), { 'chain': false });

    /*------------------------------------------------------------------------*/

    /**
     * The semantic version number.
     *
     * @static
     * @memberOf _
     * @type {string}
     */
    lodash.VERSION = VERSION;

    // Assign default placeholders.
    arrayEach(['bind', 'bindKey', 'curry', 'curryRight', 'partial', 'partialRight'], function(methodName) {
      lodash[methodName].placeholder = lodash;
    });

    // Add `LazyWrapper` methods for `_.drop` and `_.take` variants.
    arrayEach(['drop', 'take'], function(methodName, index) {
      LazyWrapper.prototype[methodName] = function(n) {
        n = n === undefined ? 1 : nativeMax(toInteger(n), 0);

        var result = (this.__filtered__ && !index)
          ? new LazyWrapper(this)
          : this.clone();

        if (result.__filtered__) {
          result.__takeCount__ = nativeMin(n, result.__takeCount__);
        } else {
          result.__views__.push({
            'size': nativeMin(n, MAX_ARRAY_LENGTH),
            'type': methodName + (result.__dir__ < 0 ? 'Right' : '')
          });
        }
        return result;
      };

      LazyWrapper.prototype[methodName + 'Right'] = function(n) {
        return this.reverse()[methodName](n).reverse();
      };
    });

    // Add `LazyWrapper` methods that accept an `iteratee` value.
    arrayEach(['filter', 'map', 'takeWhile'], function(methodName, index) {
      var type = index + 1,
          isFilter = type == LAZY_FILTER_FLAG || type == LAZY_WHILE_FLAG;

      LazyWrapper.prototype[methodName] = function(iteratee) {
        var result = this.clone();
        result.__iteratees__.push({
          'iteratee': getIteratee(iteratee, 3),
          'type': type
        });
        result.__filtered__ = result.__filtered__ || isFilter;
        return result;
      };
    });

    // Add `LazyWrapper` methods for `_.head` and `_.last`.
    arrayEach(['head', 'last'], function(methodName, index) {
      var takeName = 'take' + (index ? 'Right' : '');

      LazyWrapper.prototype[methodName] = function() {
        return this[takeName](1).value()[0];
      };
    });

    // Add `LazyWrapper` methods for `_.initial` and `_.tail`.
    arrayEach(['initial', 'tail'], function(methodName, index) {
      var dropName = 'drop' + (index ? '' : 'Right');

      LazyWrapper.prototype[methodName] = function() {
        return this.__filtered__ ? new LazyWrapper(this) : this[dropName](1);
      };
    });

    LazyWrapper.prototype.compact = function() {
      return this.filter(identity);
    };

    LazyWrapper.prototype.find = function(predicate) {
      return this.filter(predicate).head();
    };

    LazyWrapper.prototype.findLast = function(predicate) {
      return this.reverse().find(predicate);
    };

    LazyWrapper.prototype.invokeMap = baseRest(function(path, args) {
      if (typeof path == 'function') {
        return new LazyWrapper(this);
      }
      return this.map(function(value) {
        return baseInvoke(value, path, args);
      });
    });

    LazyWrapper.prototype.reject = function(predicate) {
      return this.filter(negate(getIteratee(predicate)));
    };

    LazyWrapper.prototype.slice = function(start, end) {
      start = toInteger(start);

      var result = this;
      if (result.__filtered__ && (start > 0 || end < 0)) {
        return new LazyWrapper(result);
      }
      if (start < 0) {
        result = result.takeRight(-start);
      } else if (start) {
        result = result.drop(start);
      }
      if (end !== undefined) {
        end = toInteger(end);
        result = end < 0 ? result.dropRight(-end) : result.take(end - start);
      }
      return result;
    };

    LazyWrapper.prototype.takeRightWhile = function(predicate) {
      return this.reverse().takeWhile(predicate).reverse();
    };

    LazyWrapper.prototype.toArray = function() {
      return this.take(MAX_ARRAY_LENGTH);
    };

    // Add `LazyWrapper` methods to `lodash.prototype`.
    baseForOwn(LazyWrapper.prototype, function(func, methodName) {
      var checkIteratee = /^(?:filter|find|map|reject)|While$/.test(methodName),
          isTaker = /^(?:head|last)$/.test(methodName),
          lodashFunc = lodash[isTaker ? ('take' + (methodName == 'last' ? 'Right' : '')) : methodName],
          retUnwrapped = isTaker || /^find/.test(methodName);

      if (!lodashFunc) {
        return;
      }
      lodash.prototype[methodName] = function() {
        var value = this.__wrapped__,
            args = isTaker ? [1] : arguments,
            isLazy = value instanceof LazyWrapper,
            iteratee = args[0],
            useLazy = isLazy || isArray(value);

        var interceptor = function(value) {
          var result = lodashFunc.apply(lodash, arrayPush([value], args));
          return (isTaker && chainAll) ? result[0] : result;
        };

        if (useLazy && checkIteratee && typeof iteratee == 'function' && iteratee.length != 1) {
          // Avoid lazy use if the iteratee has a "length" value other than `1`.
          isLazy = useLazy = false;
        }
        var chainAll = this.__chain__,
            isHybrid = !!this.__actions__.length,
            isUnwrapped = retUnwrapped && !chainAll,
            onlyLazy = isLazy && !isHybrid;

        if (!retUnwrapped && useLazy) {
          value = onlyLazy ? value : new LazyWrapper(this);
          var result = func.apply(value, args);
          result.__actions__.push({ 'func': thru, 'args': [interceptor], 'thisArg': undefined });
          return new LodashWrapper(result, chainAll);
        }
        if (isUnwrapped && onlyLazy) {
          return func.apply(this, args);
        }
        result = this.thru(interceptor);
        return isUnwrapped ? (isTaker ? result.value()[0] : result.value()) : result;
      };
    });

    // Add `Array` methods to `lodash.prototype`.
    arrayEach(['pop', 'push', 'shift', 'sort', 'splice', 'unshift'], function(methodName) {
      var func = arrayProto[methodName],
          chainName = /^(?:push|sort|unshift)$/.test(methodName) ? 'tap' : 'thru',
          retUnwrapped = /^(?:pop|shift)$/.test(methodName);

      lodash.prototype[methodName] = function() {
        var args = arguments;
        if (retUnwrapped && !this.__chain__) {
          var value = this.value();
          return func.apply(isArray(value) ? value : [], args);
        }
        return this[chainName](function(value) {
          return func.apply(isArray(value) ? value : [], args);
        });
      };
    });

    // Map minified method names to their real names.
    baseForOwn(LazyWrapper.prototype, function(func, methodName) {
      var lodashFunc = lodash[methodName];
      if (lodashFunc) {
        var key = lodashFunc.name + '';
        if (!hasOwnProperty.call(realNames, key)) {
          realNames[key] = [];
        }
        realNames[key].push({ 'name': methodName, 'func': lodashFunc });
      }
    });

    realNames[createHybrid(undefined, WRAP_BIND_KEY_FLAG).name] = [{
      'name': 'wrapper',
      'func': undefined
    }];

    // Add methods to `LazyWrapper`.
    LazyWrapper.prototype.clone = lazyClone;
    LazyWrapper.prototype.reverse = lazyReverse;
    LazyWrapper.prototype.value = lazyValue;

    // Add chain sequence methods to the `lodash` wrapper.
    lodash.prototype.at = wrapperAt;
    lodash.prototype.chain = wrapperChain;
    lodash.prototype.commit = wrapperCommit;
    lodash.prototype.next = wrapperNext;
    lodash.prototype.plant = wrapperPlant;
    lodash.prototype.reverse = wrapperReverse;
    lodash.prototype.toJSON = lodash.prototype.valueOf = lodash.prototype.value = wrapperValue;

    // Add lazy aliases.
    lodash.prototype.first = lodash.prototype.head;

    if (symIterator) {
      lodash.prototype[symIterator] = wrapperToIterator;
    }
    return lodash;
  });

  /*--------------------------------------------------------------------------*/

  // Export lodash.
  var _ = runInContext();

  // Some AMD build optimizers, like r.js, check for condition patterns like:
  if (true) {
    // Expose Lodash on the global object to prevent errors when Lodash is
    // loaded by a script tag in the presence of an AMD loader.
    // See http://requirejs.org/docs/errors.html#mismatch for more details.
    // Use `_.noConflict` to remove Lodash from the global object.
    root._ = _;

    // Define as an anonymous module so, through path mapping, it can be
    // referenced as the "underscore" module.
    !(__WEBPACK_AMD_DEFINE_RESULT__ = (function() {
      return _;
    }).call(exports, __webpack_require__, exports, module),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
  }
  // Check for `exports` after `define` in case a build optimizer adds it.
  else {}
}.call(this));


/***/ }),

/***/ 6604:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseAssignValue = __webpack_require__(9465),
    baseForOwn = __webpack_require__(7816),
    baseIteratee = __webpack_require__(7206);

/**
 * Creates an object with the same keys as `object` and values generated
 * by running each own enumerable string keyed property of `object` thru
 * `iteratee`. The iteratee is invoked with three arguments:
 * (value, key, object).
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Object
 * @param {Object} object The object to iterate over.
 * @param {Function} [iteratee=_.identity] The function invoked per iteration.
 * @returns {Object} Returns the new mapped object.
 * @see _.mapKeys
 * @example
 *
 * var users = {
 *   'fred':    { 'user': 'fred',    'age': 40 },
 *   'pebbles': { 'user': 'pebbles', 'age': 1 }
 * };
 *
 * _.mapValues(users, function(o) { return o.age; });
 * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
 *
 * // The `_.property` iteratee shorthand.
 * _.mapValues(users, 'age');
 * // => { 'fred': 40, 'pebbles': 1 } (iteration order is not guaranteed)
 */
function mapValues(object, iteratee) {
  var result = {};
  iteratee = baseIteratee(iteratee, 3);

  baseForOwn(object, function(value, key, object) {
    baseAssignValue(result, key, iteratee(value, key, object));
  });
  return result;
}

module.exports = mapValues;


/***/ }),

/***/ 8306:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var MapCache = __webpack_require__(3369);

/** Error message constants. */
var FUNC_ERROR_TEXT = 'Expected a function';

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `clear`, `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver != null && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache);
  return memoized;
}

// Expose `MapCache`.
memoize.Cache = MapCache;

module.exports = memoize;


/***/ }),

/***/ 9601:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseProperty = __webpack_require__(371),
    basePropertyDeep = __webpack_require__(9152),
    isKey = __webpack_require__(5403),
    toKey = __webpack_require__(327);

/**
 * Creates a function that returns the value at `path` of a given object.
 *
 * @static
 * @memberOf _
 * @since 2.4.0
 * @category Util
 * @param {Array|string} path The path of the property to get.
 * @returns {Function} Returns the new accessor function.
 * @example
 *
 * var objects = [
 *   { 'a': { 'b': 2 } },
 *   { 'a': { 'b': 1 } }
 * ];
 *
 * _.map(objects, _.property('a.b'));
 * // => [2, 1]
 *
 * _.map(_.sortBy(objects, _.property(['a', 'b'])), 'a.b');
 * // => [1, 2]
 */
function property(path) {
  return isKey(path) ? baseProperty(toKey(path)) : basePropertyDeep(path);
}

module.exports = property;


/***/ }),

/***/ 9704:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arraySome = __webpack_require__(2908),
    baseIteratee = __webpack_require__(7206),
    baseSome = __webpack_require__(5076),
    isArray = __webpack_require__(1469),
    isIterateeCall = __webpack_require__(6612);

/**
 * Checks if `predicate` returns truthy for **any** element of `collection`.
 * Iteration is stopped once `predicate` returns truthy. The predicate is
 * invoked with three arguments: (value, index|key, collection).
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Collection
 * @param {Array|Object} collection The collection to iterate over.
 * @param {Function} [predicate=_.identity] The function invoked per iteration.
 * @param- {Object} [guard] Enables use as an iteratee for methods like `_.map`.
 * @returns {boolean} Returns `true` if any element passes the predicate check,
 *  else `false`.
 * @example
 *
 * _.some([null, 0, 'yes', false], Boolean);
 * // => true
 *
 * var users = [
 *   { 'user': 'barney', 'active': true },
 *   { 'user': 'fred',   'active': false }
 * ];
 *
 * // The `_.matches` iteratee shorthand.
 * _.some(users, { 'user': 'barney', 'active': false });
 * // => false
 *
 * // The `_.matchesProperty` iteratee shorthand.
 * _.some(users, ['active', false]);
 * // => true
 *
 * // The `_.property` iteratee shorthand.
 * _.some(users, 'active');
 * // => true
 */
function some(collection, predicate, guard) {
  var func = isArray(collection) ? arraySome : baseSome;
  if (guard && isIterateeCall(collection, predicate, guard)) {
    predicate = undefined;
  }
  return func(collection, baseIteratee(predicate, 3));
}

module.exports = some;


/***/ }),

/***/ 479:
/***/ ((module) => {

/**
 * This method returns a new empty array.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {Array} Returns the new empty array.
 * @example
 *
 * var arrays = _.times(2, _.stubArray);
 *
 * console.log(arrays);
 * // => [[], []]
 *
 * console.log(arrays[0] === arrays[1]);
 * // => false
 */
function stubArray() {
  return [];
}

module.exports = stubArray;


/***/ }),

/***/ 5062:
/***/ ((module) => {

/**
 * This method returns `false`.
 *
 * @static
 * @memberOf _
 * @since 4.13.0
 * @category Util
 * @returns {boolean} Returns `false`.
 * @example
 *
 * _.times(2, _.stubFalse);
 * // => [false, false]
 */
function stubFalse() {
  return false;
}

module.exports = stubFalse;


/***/ }),

/***/ 9833:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var baseToString = __webpack_require__(531);

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to convert.
 * @returns {string} Returns the converted string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

module.exports = toString;


/***/ }),

/***/ 9588:
/***/ ((module) => {

/**
 * Memize options object.
 *
 * @typedef MemizeOptions
 *
 * @property {number} [maxSize] Maximum size of the cache.
 */

/**
 * Internal cache entry.
 *
 * @typedef MemizeCacheNode
 *
 * @property {?MemizeCacheNode|undefined} [prev] Previous node.
 * @property {?MemizeCacheNode|undefined} [next] Next node.
 * @property {Array<*>}                   args   Function arguments for cache
 *                                               entry.
 * @property {*}                          val    Function result.
 */

/**
 * Properties of the enhanced function for controlling cache.
 *
 * @typedef MemizeMemoizedFunction
 *
 * @property {()=>void} clear Clear the cache.
 */

/**
 * Accepts a function to be memoized, and returns a new memoized function, with
 * optional options.
 *
 * @template {Function} F
 *
 * @param {F}             fn        Function to memoize.
 * @param {MemizeOptions} [options] Options object.
 *
 * @return {F & MemizeMemoizedFunction} Memoized function.
 */
function memize( fn, options ) {
	var size = 0;

	/** @type {?MemizeCacheNode|undefined} */
	var head;

	/** @type {?MemizeCacheNode|undefined} */
	var tail;

	options = options || {};

	function memoized( /* ...args */ ) {
		var node = head,
			len = arguments.length,
			args, i;

		searchCache: while ( node ) {
			// Perform a shallow equality test to confirm that whether the node
			// under test is a candidate for the arguments passed. Two arrays
			// are shallowly equal if their length matches and each entry is
			// strictly equal between the two sets. Avoid abstracting to a
			// function which could incur an arguments leaking deoptimization.

			// Check whether node arguments match arguments length
			if ( node.args.length !== arguments.length ) {
				node = node.next;
				continue;
			}

			// Check whether node arguments match arguments values
			for ( i = 0; i < len; i++ ) {
				if ( node.args[ i ] !== arguments[ i ] ) {
					node = node.next;
					continue searchCache;
				}
			}

			// At this point we can assume we've found a match

			// Surface matched node to head if not already
			if ( node !== head ) {
				// As tail, shift to previous. Must only shift if not also
				// head, since if both head and tail, there is no previous.
				if ( node === tail ) {
					tail = node.prev;
				}

				// Adjust siblings to point to each other. If node was tail,
				// this also handles new tail's empty `next` assignment.
				/** @type {MemizeCacheNode} */ ( node.prev ).next = node.next;
				if ( node.next ) {
					node.next.prev = node.prev;
				}

				node.next = head;
				node.prev = null;
				/** @type {MemizeCacheNode} */ ( head ).prev = node;
				head = node;
			}

			// Return immediately
			return node.val;
		}

		// No cached value found. Continue to insertion phase:

		// Create a copy of arguments (avoid leaking deoptimization)
		args = new Array( len );
		for ( i = 0; i < len; i++ ) {
			args[ i ] = arguments[ i ];
		}

		node = {
			args: args,

			// Generate the result from original function
			val: fn.apply( null, args ),
		};

		// Don't need to check whether node is already head, since it would
		// have been returned above already if it was

		// Shift existing head down list
		if ( head ) {
			head.prev = node;
			node.next = head;
		} else {
			// If no head, follows that there's no tail (at initial or reset)
			tail = node;
		}

		// Trim tail if we're reached max size and are pending cache insertion
		if ( size === /** @type {MemizeOptions} */ ( options ).maxSize ) {
			tail = /** @type {MemizeCacheNode} */ ( tail ).prev;
			/** @type {MemizeCacheNode} */ ( tail ).next = null;
		} else {
			size++;
		}

		head = node;

		return node.val;
	}

	memoized.clear = function() {
		head = null;
		tail = null;
		size = 0;
	};

	if ( false ) {}

	// Ignore reason: There's not a clear solution to create an intersection of
	// the function with additional properties, where the goal is to retain the
	// function signature of the incoming argument and add control properties
	// on the return value.

	// @ts-ignore
	return memoized;
}

module.exports = memize;


/***/ }),

/***/ 9052:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";

Object.defineProperty(exports, "__esModule", ({ value: true }));
var assign = __webpack_require__(8583);
var mapValues = __webpack_require__(6604);
var some = __webpack_require__(9704);
var NgComponent = /** @class */ (function () {
    function NgComponent() {
        this.__isFirstRender = true;
        this.state = {};
        this.props = {};
    }
    /*
      eg. {
        as: {currentValue: [1, 2, 3], previousValue: [1, 2]},
        bs: {currentValue: 42, previousValue: undefined}
      }
    */
    // nb: this method is explicity exposed for unit testing
    NgComponent.prototype.$onChanges = function (changes) {
        var oldProps = this.props;
        // TODO: fix Lodash typings upstream
        var newProps = mapValues(changes, 'currentValue');
        // TODO: implement nextState (which also means implement this.setState)
        var nextProps = assign({}, this.props, newProps);
        if (this.__isFirstRender) {
            assign(this, { props: nextProps });
            this.componentWillMount();
            this.render();
            this.__isFirstRender = false;
        }
        else {
            if (!this.didPropsChange(newProps, oldProps))
                return;
            this.componentWillReceiveProps(nextProps);
            var shouldUpdate = this.shouldComponentUpdate(nextProps, this.state);
            assign(this, { props: nextProps });
            if (!shouldUpdate)
                return;
            this.componentWillUpdate(this.props, this.state);
            this.render();
            this.componentDidUpdate(this.props, this.state);
        }
    };
    NgComponent.prototype.$postLink = function () {
        this.componentDidMount();
    };
    NgComponent.prototype.$onDestroy = function () {
        this.componentWillUnmount();
    };
    NgComponent.prototype.didPropsChange = function (newProps, oldProps) {
        return some(newProps, function (v, k) { return v !== oldProps[k]; });
    };
    /*
      lifecycle hooks
    */
    NgComponent.prototype.componentWillMount = function () { };
    NgComponent.prototype.componentDidMount = function () { };
    NgComponent.prototype.componentWillReceiveProps = function (_props) { };
    NgComponent.prototype.shouldComponentUpdate = function (_nextProps, _nextState) { return true; };
    NgComponent.prototype.componentWillUpdate = function (_props, _state) { };
    NgComponent.prototype.componentDidUpdate = function (_props, _state) { };
    NgComponent.prototype.componentWillUnmount = function () { };
    NgComponent.prototype.render = function () { };
    return NgComponent;
}());
exports["default"] = NgComponent;
//# sourceMappingURL=index.js.map

/***/ }),

/***/ 7418:
/***/ ((module) => {

"use strict";
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/


/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

module.exports = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};


/***/ }),

/***/ 4448:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";
/** @license React v17.0.2
 * react-dom.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
/*
 Modernizr 3.0.0pre (Custom Build) | MIT
*/
var aa=__webpack_require__(7294),m=__webpack_require__(7418),r=__webpack_require__(3840);function y(a){for(var b="https://reactjs.org/docs/error-decoder.html?invariant="+a,c=1;c<arguments.length;c++)b+="&args[]="+encodeURIComponent(arguments[c]);return"Minified React error #"+a+"; visit "+b+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}if(!aa)throw Error(y(227));var ba=new Set,ca={};function da(a,b){ea(a,b);ea(a+"Capture",b)}
function ea(a,b){ca[a]=b;for(a=0;a<b.length;a++)ba.add(b[a])}
var fa=!("undefined"===typeof window||"undefined"===typeof window.document||"undefined"===typeof window.document.createElement),ha=/^[:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD][:A-Z_a-z\u00C0-\u00D6\u00D8-\u00F6\u00F8-\u02FF\u0370-\u037D\u037F-\u1FFF\u200C-\u200D\u2070-\u218F\u2C00-\u2FEF\u3001-\uD7FF\uF900-\uFDCF\uFDF0-\uFFFD\-.0-9\u00B7\u0300-\u036F\u203F-\u2040]*$/,ia=Object.prototype.hasOwnProperty,
ja={},ka={};function la(a){if(ia.call(ka,a))return!0;if(ia.call(ja,a))return!1;if(ha.test(a))return ka[a]=!0;ja[a]=!0;return!1}function ma(a,b,c,d){if(null!==c&&0===c.type)return!1;switch(typeof b){case "function":case "symbol":return!0;case "boolean":if(d)return!1;if(null!==c)return!c.acceptsBooleans;a=a.toLowerCase().slice(0,5);return"data-"!==a&&"aria-"!==a;default:return!1}}
function na(a,b,c,d){if(null===b||"undefined"===typeof b||ma(a,b,c,d))return!0;if(d)return!1;if(null!==c)switch(c.type){case 3:return!b;case 4:return!1===b;case 5:return isNaN(b);case 6:return isNaN(b)||1>b}return!1}function B(a,b,c,d,e,f,g){this.acceptsBooleans=2===b||3===b||4===b;this.attributeName=d;this.attributeNamespace=e;this.mustUseProperty=c;this.propertyName=a;this.type=b;this.sanitizeURL=f;this.removeEmptyString=g}var D={};
"children dangerouslySetInnerHTML defaultValue defaultChecked innerHTML suppressContentEditableWarning suppressHydrationWarning style".split(" ").forEach(function(a){D[a]=new B(a,0,!1,a,null,!1,!1)});[["acceptCharset","accept-charset"],["className","class"],["htmlFor","for"],["httpEquiv","http-equiv"]].forEach(function(a){var b=a[0];D[b]=new B(b,1,!1,a[1],null,!1,!1)});["contentEditable","draggable","spellCheck","value"].forEach(function(a){D[a]=new B(a,2,!1,a.toLowerCase(),null,!1,!1)});
["autoReverse","externalResourcesRequired","focusable","preserveAlpha"].forEach(function(a){D[a]=new B(a,2,!1,a,null,!1,!1)});"allowFullScreen async autoFocus autoPlay controls default defer disabled disablePictureInPicture disableRemotePlayback formNoValidate hidden loop noModule noValidate open playsInline readOnly required reversed scoped seamless itemScope".split(" ").forEach(function(a){D[a]=new B(a,3,!1,a.toLowerCase(),null,!1,!1)});
["checked","multiple","muted","selected"].forEach(function(a){D[a]=new B(a,3,!0,a,null,!1,!1)});["capture","download"].forEach(function(a){D[a]=new B(a,4,!1,a,null,!1,!1)});["cols","rows","size","span"].forEach(function(a){D[a]=new B(a,6,!1,a,null,!1,!1)});["rowSpan","start"].forEach(function(a){D[a]=new B(a,5,!1,a.toLowerCase(),null,!1,!1)});var oa=/[\-:]([a-z])/g;function pa(a){return a[1].toUpperCase()}
"accent-height alignment-baseline arabic-form baseline-shift cap-height clip-path clip-rule color-interpolation color-interpolation-filters color-profile color-rendering dominant-baseline enable-background fill-opacity fill-rule flood-color flood-opacity font-family font-size font-size-adjust font-stretch font-style font-variant font-weight glyph-name glyph-orientation-horizontal glyph-orientation-vertical horiz-adv-x horiz-origin-x image-rendering letter-spacing lighting-color marker-end marker-mid marker-start overline-position overline-thickness paint-order panose-1 pointer-events rendering-intent shape-rendering stop-color stop-opacity strikethrough-position strikethrough-thickness stroke-dasharray stroke-dashoffset stroke-linecap stroke-linejoin stroke-miterlimit stroke-opacity stroke-width text-anchor text-decoration text-rendering underline-position underline-thickness unicode-bidi unicode-range units-per-em v-alphabetic v-hanging v-ideographic v-mathematical vector-effect vert-adv-y vert-origin-x vert-origin-y word-spacing writing-mode xmlns:xlink x-height".split(" ").forEach(function(a){var b=a.replace(oa,
pa);D[b]=new B(b,1,!1,a,null,!1,!1)});"xlink:actuate xlink:arcrole xlink:role xlink:show xlink:title xlink:type".split(" ").forEach(function(a){var b=a.replace(oa,pa);D[b]=new B(b,1,!1,a,"http://www.w3.org/1999/xlink",!1,!1)});["xml:base","xml:lang","xml:space"].forEach(function(a){var b=a.replace(oa,pa);D[b]=new B(b,1,!1,a,"http://www.w3.org/XML/1998/namespace",!1,!1)});["tabIndex","crossOrigin"].forEach(function(a){D[a]=new B(a,1,!1,a.toLowerCase(),null,!1,!1)});
D.xlinkHref=new B("xlinkHref",1,!1,"xlink:href","http://www.w3.org/1999/xlink",!0,!1);["src","href","action","formAction"].forEach(function(a){D[a]=new B(a,1,!1,a.toLowerCase(),null,!0,!0)});
function qa(a,b,c,d){var e=D.hasOwnProperty(b)?D[b]:null;var f=null!==e?0===e.type:d?!1:!(2<b.length)||"o"!==b[0]&&"O"!==b[0]||"n"!==b[1]&&"N"!==b[1]?!1:!0;f||(na(b,c,e,d)&&(c=null),d||null===e?la(b)&&(null===c?a.removeAttribute(b):a.setAttribute(b,""+c)):e.mustUseProperty?a[e.propertyName]=null===c?3===e.type?!1:"":c:(b=e.attributeName,d=e.attributeNamespace,null===c?a.removeAttribute(b):(e=e.type,c=3===e||4===e&&!0===c?"":""+c,d?a.setAttributeNS(d,b,c):a.setAttribute(b,c))))}
var ra=aa.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED,sa=60103,ta=60106,ua=60107,wa=60108,xa=60114,ya=60109,za=60110,Aa=60112,Ba=60113,Ca=60120,Da=60115,Ea=60116,Fa=60121,Ga=60128,Ha=60129,Ia=60130,Ja=60131;
if("function"===typeof Symbol&&Symbol.for){var E=Symbol.for;sa=E("react.element");ta=E("react.portal");ua=E("react.fragment");wa=E("react.strict_mode");xa=E("react.profiler");ya=E("react.provider");za=E("react.context");Aa=E("react.forward_ref");Ba=E("react.suspense");Ca=E("react.suspense_list");Da=E("react.memo");Ea=E("react.lazy");Fa=E("react.block");E("react.scope");Ga=E("react.opaque.id");Ha=E("react.debug_trace_mode");Ia=E("react.offscreen");Ja=E("react.legacy_hidden")}
var Ka="function"===typeof Symbol&&Symbol.iterator;function La(a){if(null===a||"object"!==typeof a)return null;a=Ka&&a[Ka]||a["@@iterator"];return"function"===typeof a?a:null}var Ma;function Na(a){if(void 0===Ma)try{throw Error();}catch(c){var b=c.stack.trim().match(/\n( *(at )?)/);Ma=b&&b[1]||""}return"\n"+Ma+a}var Oa=!1;
function Pa(a,b){if(!a||Oa)return"";Oa=!0;var c=Error.prepareStackTrace;Error.prepareStackTrace=void 0;try{if(b)if(b=function(){throw Error();},Object.defineProperty(b.prototype,"props",{set:function(){throw Error();}}),"object"===typeof Reflect&&Reflect.construct){try{Reflect.construct(b,[])}catch(k){var d=k}Reflect.construct(a,[],b)}else{try{b.call()}catch(k){d=k}a.call(b.prototype)}else{try{throw Error();}catch(k){d=k}a()}}catch(k){if(k&&d&&"string"===typeof k.stack){for(var e=k.stack.split("\n"),
f=d.stack.split("\n"),g=e.length-1,h=f.length-1;1<=g&&0<=h&&e[g]!==f[h];)h--;for(;1<=g&&0<=h;g--,h--)if(e[g]!==f[h]){if(1!==g||1!==h){do if(g--,h--,0>h||e[g]!==f[h])return"\n"+e[g].replace(" at new "," at ");while(1<=g&&0<=h)}break}}}finally{Oa=!1,Error.prepareStackTrace=c}return(a=a?a.displayName||a.name:"")?Na(a):""}
function Qa(a){switch(a.tag){case 5:return Na(a.type);case 16:return Na("Lazy");case 13:return Na("Suspense");case 19:return Na("SuspenseList");case 0:case 2:case 15:return a=Pa(a.type,!1),a;case 11:return a=Pa(a.type.render,!1),a;case 22:return a=Pa(a.type._render,!1),a;case 1:return a=Pa(a.type,!0),a;default:return""}}
function Ra(a){if(null==a)return null;if("function"===typeof a)return a.displayName||a.name||null;if("string"===typeof a)return a;switch(a){case ua:return"Fragment";case ta:return"Portal";case xa:return"Profiler";case wa:return"StrictMode";case Ba:return"Suspense";case Ca:return"SuspenseList"}if("object"===typeof a)switch(a.$$typeof){case za:return(a.displayName||"Context")+".Consumer";case ya:return(a._context.displayName||"Context")+".Provider";case Aa:var b=a.render;b=b.displayName||b.name||"";
return a.displayName||(""!==b?"ForwardRef("+b+")":"ForwardRef");case Da:return Ra(a.type);case Fa:return Ra(a._render);case Ea:b=a._payload;a=a._init;try{return Ra(a(b))}catch(c){}}return null}function Sa(a){switch(typeof a){case "boolean":case "number":case "object":case "string":case "undefined":return a;default:return""}}function Ta(a){var b=a.type;return(a=a.nodeName)&&"input"===a.toLowerCase()&&("checkbox"===b||"radio"===b)}
function Ua(a){var b=Ta(a)?"checked":"value",c=Object.getOwnPropertyDescriptor(a.constructor.prototype,b),d=""+a[b];if(!a.hasOwnProperty(b)&&"undefined"!==typeof c&&"function"===typeof c.get&&"function"===typeof c.set){var e=c.get,f=c.set;Object.defineProperty(a,b,{configurable:!0,get:function(){return e.call(this)},set:function(a){d=""+a;f.call(this,a)}});Object.defineProperty(a,b,{enumerable:c.enumerable});return{getValue:function(){return d},setValue:function(a){d=""+a},stopTracking:function(){a._valueTracker=
null;delete a[b]}}}}function Va(a){a._valueTracker||(a._valueTracker=Ua(a))}function Wa(a){if(!a)return!1;var b=a._valueTracker;if(!b)return!0;var c=b.getValue();var d="";a&&(d=Ta(a)?a.checked?"true":"false":a.value);a=d;return a!==c?(b.setValue(a),!0):!1}function Xa(a){a=a||("undefined"!==typeof document?document:void 0);if("undefined"===typeof a)return null;try{return a.activeElement||a.body}catch(b){return a.body}}
function Ya(a,b){var c=b.checked;return m({},b,{defaultChecked:void 0,defaultValue:void 0,value:void 0,checked:null!=c?c:a._wrapperState.initialChecked})}function Za(a,b){var c=null==b.defaultValue?"":b.defaultValue,d=null!=b.checked?b.checked:b.defaultChecked;c=Sa(null!=b.value?b.value:c);a._wrapperState={initialChecked:d,initialValue:c,controlled:"checkbox"===b.type||"radio"===b.type?null!=b.checked:null!=b.value}}function $a(a,b){b=b.checked;null!=b&&qa(a,"checked",b,!1)}
function ab(a,b){$a(a,b);var c=Sa(b.value),d=b.type;if(null!=c)if("number"===d){if(0===c&&""===a.value||a.value!=c)a.value=""+c}else a.value!==""+c&&(a.value=""+c);else if("submit"===d||"reset"===d){a.removeAttribute("value");return}b.hasOwnProperty("value")?bb(a,b.type,c):b.hasOwnProperty("defaultValue")&&bb(a,b.type,Sa(b.defaultValue));null==b.checked&&null!=b.defaultChecked&&(a.defaultChecked=!!b.defaultChecked)}
function cb(a,b,c){if(b.hasOwnProperty("value")||b.hasOwnProperty("defaultValue")){var d=b.type;if(!("submit"!==d&&"reset"!==d||void 0!==b.value&&null!==b.value))return;b=""+a._wrapperState.initialValue;c||b===a.value||(a.value=b);a.defaultValue=b}c=a.name;""!==c&&(a.name="");a.defaultChecked=!!a._wrapperState.initialChecked;""!==c&&(a.name=c)}
function bb(a,b,c){if("number"!==b||Xa(a.ownerDocument)!==a)null==c?a.defaultValue=""+a._wrapperState.initialValue:a.defaultValue!==""+c&&(a.defaultValue=""+c)}function db(a){var b="";aa.Children.forEach(a,function(a){null!=a&&(b+=a)});return b}function eb(a,b){a=m({children:void 0},b);if(b=db(b.children))a.children=b;return a}
function fb(a,b,c,d){a=a.options;if(b){b={};for(var e=0;e<c.length;e++)b["$"+c[e]]=!0;for(c=0;c<a.length;c++)e=b.hasOwnProperty("$"+a[c].value),a[c].selected!==e&&(a[c].selected=e),e&&d&&(a[c].defaultSelected=!0)}else{c=""+Sa(c);b=null;for(e=0;e<a.length;e++){if(a[e].value===c){a[e].selected=!0;d&&(a[e].defaultSelected=!0);return}null!==b||a[e].disabled||(b=a[e])}null!==b&&(b.selected=!0)}}
function gb(a,b){if(null!=b.dangerouslySetInnerHTML)throw Error(y(91));return m({},b,{value:void 0,defaultValue:void 0,children:""+a._wrapperState.initialValue})}function hb(a,b){var c=b.value;if(null==c){c=b.children;b=b.defaultValue;if(null!=c){if(null!=b)throw Error(y(92));if(Array.isArray(c)){if(!(1>=c.length))throw Error(y(93));c=c[0]}b=c}null==b&&(b="");c=b}a._wrapperState={initialValue:Sa(c)}}
function ib(a,b){var c=Sa(b.value),d=Sa(b.defaultValue);null!=c&&(c=""+c,c!==a.value&&(a.value=c),null==b.defaultValue&&a.defaultValue!==c&&(a.defaultValue=c));null!=d&&(a.defaultValue=""+d)}function jb(a){var b=a.textContent;b===a._wrapperState.initialValue&&""!==b&&null!==b&&(a.value=b)}var kb={html:"http://www.w3.org/1999/xhtml",mathml:"http://www.w3.org/1998/Math/MathML",svg:"http://www.w3.org/2000/svg"};
function lb(a){switch(a){case "svg":return"http://www.w3.org/2000/svg";case "math":return"http://www.w3.org/1998/Math/MathML";default:return"http://www.w3.org/1999/xhtml"}}function mb(a,b){return null==a||"http://www.w3.org/1999/xhtml"===a?lb(b):"http://www.w3.org/2000/svg"===a&&"foreignObject"===b?"http://www.w3.org/1999/xhtml":a}
var nb,ob=function(a){return"undefined"!==typeof MSApp&&MSApp.execUnsafeLocalFunction?function(b,c,d,e){MSApp.execUnsafeLocalFunction(function(){return a(b,c,d,e)})}:a}(function(a,b){if(a.namespaceURI!==kb.svg||"innerHTML"in a)a.innerHTML=b;else{nb=nb||document.createElement("div");nb.innerHTML="<svg>"+b.valueOf().toString()+"</svg>";for(b=nb.firstChild;a.firstChild;)a.removeChild(a.firstChild);for(;b.firstChild;)a.appendChild(b.firstChild)}});
function pb(a,b){if(b){var c=a.firstChild;if(c&&c===a.lastChild&&3===c.nodeType){c.nodeValue=b;return}}a.textContent=b}
var qb={animationIterationCount:!0,borderImageOutset:!0,borderImageSlice:!0,borderImageWidth:!0,boxFlex:!0,boxFlexGroup:!0,boxOrdinalGroup:!0,columnCount:!0,columns:!0,flex:!0,flexGrow:!0,flexPositive:!0,flexShrink:!0,flexNegative:!0,flexOrder:!0,gridArea:!0,gridRow:!0,gridRowEnd:!0,gridRowSpan:!0,gridRowStart:!0,gridColumn:!0,gridColumnEnd:!0,gridColumnSpan:!0,gridColumnStart:!0,fontWeight:!0,lineClamp:!0,lineHeight:!0,opacity:!0,order:!0,orphans:!0,tabSize:!0,widows:!0,zIndex:!0,zoom:!0,fillOpacity:!0,
floodOpacity:!0,stopOpacity:!0,strokeDasharray:!0,strokeDashoffset:!0,strokeMiterlimit:!0,strokeOpacity:!0,strokeWidth:!0},rb=["Webkit","ms","Moz","O"];Object.keys(qb).forEach(function(a){rb.forEach(function(b){b=b+a.charAt(0).toUpperCase()+a.substring(1);qb[b]=qb[a]})});function sb(a,b,c){return null==b||"boolean"===typeof b||""===b?"":c||"number"!==typeof b||0===b||qb.hasOwnProperty(a)&&qb[a]?(""+b).trim():b+"px"}
function tb(a,b){a=a.style;for(var c in b)if(b.hasOwnProperty(c)){var d=0===c.indexOf("--"),e=sb(c,b[c],d);"float"===c&&(c="cssFloat");d?a.setProperty(c,e):a[c]=e}}var ub=m({menuitem:!0},{area:!0,base:!0,br:!0,col:!0,embed:!0,hr:!0,img:!0,input:!0,keygen:!0,link:!0,meta:!0,param:!0,source:!0,track:!0,wbr:!0});
function vb(a,b){if(b){if(ub[a]&&(null!=b.children||null!=b.dangerouslySetInnerHTML))throw Error(y(137,a));if(null!=b.dangerouslySetInnerHTML){if(null!=b.children)throw Error(y(60));if(!("object"===typeof b.dangerouslySetInnerHTML&&"__html"in b.dangerouslySetInnerHTML))throw Error(y(61));}if(null!=b.style&&"object"!==typeof b.style)throw Error(y(62));}}
function wb(a,b){if(-1===a.indexOf("-"))return"string"===typeof b.is;switch(a){case "annotation-xml":case "color-profile":case "font-face":case "font-face-src":case "font-face-uri":case "font-face-format":case "font-face-name":case "missing-glyph":return!1;default:return!0}}function xb(a){a=a.target||a.srcElement||window;a.correspondingUseElement&&(a=a.correspondingUseElement);return 3===a.nodeType?a.parentNode:a}var yb=null,zb=null,Ab=null;
function Bb(a){if(a=Cb(a)){if("function"!==typeof yb)throw Error(y(280));var b=a.stateNode;b&&(b=Db(b),yb(a.stateNode,a.type,b))}}function Eb(a){zb?Ab?Ab.push(a):Ab=[a]:zb=a}function Fb(){if(zb){var a=zb,b=Ab;Ab=zb=null;Bb(a);if(b)for(a=0;a<b.length;a++)Bb(b[a])}}function Gb(a,b){return a(b)}function Hb(a,b,c,d,e){return a(b,c,d,e)}function Ib(){}var Jb=Gb,Kb=!1,Lb=!1;function Mb(){if(null!==zb||null!==Ab)Ib(),Fb()}
function Nb(a,b,c){if(Lb)return a(b,c);Lb=!0;try{return Jb(a,b,c)}finally{Lb=!1,Mb()}}
function Ob(a,b){var c=a.stateNode;if(null===c)return null;var d=Db(c);if(null===d)return null;c=d[b];a:switch(b){case "onClick":case "onClickCapture":case "onDoubleClick":case "onDoubleClickCapture":case "onMouseDown":case "onMouseDownCapture":case "onMouseMove":case "onMouseMoveCapture":case "onMouseUp":case "onMouseUpCapture":case "onMouseEnter":(d=!d.disabled)||(a=a.type,d=!("button"===a||"input"===a||"select"===a||"textarea"===a));a=!d;break a;default:a=!1}if(a)return null;if(c&&"function"!==
typeof c)throw Error(y(231,b,typeof c));return c}var Pb=!1;if(fa)try{var Qb={};Object.defineProperty(Qb,"passive",{get:function(){Pb=!0}});window.addEventListener("test",Qb,Qb);window.removeEventListener("test",Qb,Qb)}catch(a){Pb=!1}function Rb(a,b,c,d,e,f,g,h,k){var l=Array.prototype.slice.call(arguments,3);try{b.apply(c,l)}catch(n){this.onError(n)}}var Sb=!1,Tb=null,Ub=!1,Vb=null,Wb={onError:function(a){Sb=!0;Tb=a}};function Xb(a,b,c,d,e,f,g,h,k){Sb=!1;Tb=null;Rb.apply(Wb,arguments)}
function Yb(a,b,c,d,e,f,g,h,k){Xb.apply(this,arguments);if(Sb){if(Sb){var l=Tb;Sb=!1;Tb=null}else throw Error(y(198));Ub||(Ub=!0,Vb=l)}}function Zb(a){var b=a,c=a;if(a.alternate)for(;b.return;)b=b.return;else{a=b;do b=a,0!==(b.flags&1026)&&(c=b.return),a=b.return;while(a)}return 3===b.tag?c:null}function $b(a){if(13===a.tag){var b=a.memoizedState;null===b&&(a=a.alternate,null!==a&&(b=a.memoizedState));if(null!==b)return b.dehydrated}return null}function ac(a){if(Zb(a)!==a)throw Error(y(188));}
function bc(a){var b=a.alternate;if(!b){b=Zb(a);if(null===b)throw Error(y(188));return b!==a?null:a}for(var c=a,d=b;;){var e=c.return;if(null===e)break;var f=e.alternate;if(null===f){d=e.return;if(null!==d){c=d;continue}break}if(e.child===f.child){for(f=e.child;f;){if(f===c)return ac(e),a;if(f===d)return ac(e),b;f=f.sibling}throw Error(y(188));}if(c.return!==d.return)c=e,d=f;else{for(var g=!1,h=e.child;h;){if(h===c){g=!0;c=e;d=f;break}if(h===d){g=!0;d=e;c=f;break}h=h.sibling}if(!g){for(h=f.child;h;){if(h===
c){g=!0;c=f;d=e;break}if(h===d){g=!0;d=f;c=e;break}h=h.sibling}if(!g)throw Error(y(189));}}if(c.alternate!==d)throw Error(y(190));}if(3!==c.tag)throw Error(y(188));return c.stateNode.current===c?a:b}function cc(a){a=bc(a);if(!a)return null;for(var b=a;;){if(5===b.tag||6===b.tag)return b;if(b.child)b.child.return=b,b=b.child;else{if(b===a)break;for(;!b.sibling;){if(!b.return||b.return===a)return null;b=b.return}b.sibling.return=b.return;b=b.sibling}}return null}
function dc(a,b){for(var c=a.alternate;null!==b;){if(b===a||b===c)return!0;b=b.return}return!1}var ec,fc,gc,hc,ic=!1,jc=[],kc=null,lc=null,mc=null,nc=new Map,oc=new Map,pc=[],qc="mousedown mouseup touchcancel touchend touchstart auxclick dblclick pointercancel pointerdown pointerup dragend dragstart drop compositionend compositionstart keydown keypress keyup input textInput copy cut paste click change contextmenu reset submit".split(" ");
function rc(a,b,c,d,e){return{blockedOn:a,domEventName:b,eventSystemFlags:c|16,nativeEvent:e,targetContainers:[d]}}function sc(a,b){switch(a){case "focusin":case "focusout":kc=null;break;case "dragenter":case "dragleave":lc=null;break;case "mouseover":case "mouseout":mc=null;break;case "pointerover":case "pointerout":nc.delete(b.pointerId);break;case "gotpointercapture":case "lostpointercapture":oc.delete(b.pointerId)}}
function tc(a,b,c,d,e,f){if(null===a||a.nativeEvent!==f)return a=rc(b,c,d,e,f),null!==b&&(b=Cb(b),null!==b&&fc(b)),a;a.eventSystemFlags|=d;b=a.targetContainers;null!==e&&-1===b.indexOf(e)&&b.push(e);return a}
function uc(a,b,c,d,e){switch(b){case "focusin":return kc=tc(kc,a,b,c,d,e),!0;case "dragenter":return lc=tc(lc,a,b,c,d,e),!0;case "mouseover":return mc=tc(mc,a,b,c,d,e),!0;case "pointerover":var f=e.pointerId;nc.set(f,tc(nc.get(f)||null,a,b,c,d,e));return!0;case "gotpointercapture":return f=e.pointerId,oc.set(f,tc(oc.get(f)||null,a,b,c,d,e)),!0}return!1}
function vc(a){var b=wc(a.target);if(null!==b){var c=Zb(b);if(null!==c)if(b=c.tag,13===b){if(b=$b(c),null!==b){a.blockedOn=b;hc(a.lanePriority,function(){r.unstable_runWithPriority(a.priority,function(){gc(c)})});return}}else if(3===b&&c.stateNode.hydrate){a.blockedOn=3===c.tag?c.stateNode.containerInfo:null;return}}a.blockedOn=null}
function xc(a){if(null!==a.blockedOn)return!1;for(var b=a.targetContainers;0<b.length;){var c=yc(a.domEventName,a.eventSystemFlags,b[0],a.nativeEvent);if(null!==c)return b=Cb(c),null!==b&&fc(b),a.blockedOn=c,!1;b.shift()}return!0}function zc(a,b,c){xc(a)&&c.delete(b)}
function Ac(){for(ic=!1;0<jc.length;){var a=jc[0];if(null!==a.blockedOn){a=Cb(a.blockedOn);null!==a&&ec(a);break}for(var b=a.targetContainers;0<b.length;){var c=yc(a.domEventName,a.eventSystemFlags,b[0],a.nativeEvent);if(null!==c){a.blockedOn=c;break}b.shift()}null===a.blockedOn&&jc.shift()}null!==kc&&xc(kc)&&(kc=null);null!==lc&&xc(lc)&&(lc=null);null!==mc&&xc(mc)&&(mc=null);nc.forEach(zc);oc.forEach(zc)}
function Bc(a,b){a.blockedOn===b&&(a.blockedOn=null,ic||(ic=!0,r.unstable_scheduleCallback(r.unstable_NormalPriority,Ac)))}
function Cc(a){function b(b){return Bc(b,a)}if(0<jc.length){Bc(jc[0],a);for(var c=1;c<jc.length;c++){var d=jc[c];d.blockedOn===a&&(d.blockedOn=null)}}null!==kc&&Bc(kc,a);null!==lc&&Bc(lc,a);null!==mc&&Bc(mc,a);nc.forEach(b);oc.forEach(b);for(c=0;c<pc.length;c++)d=pc[c],d.blockedOn===a&&(d.blockedOn=null);for(;0<pc.length&&(c=pc[0],null===c.blockedOn);)vc(c),null===c.blockedOn&&pc.shift()}
function Dc(a,b){var c={};c[a.toLowerCase()]=b.toLowerCase();c["Webkit"+a]="webkit"+b;c["Moz"+a]="moz"+b;return c}var Ec={animationend:Dc("Animation","AnimationEnd"),animationiteration:Dc("Animation","AnimationIteration"),animationstart:Dc("Animation","AnimationStart"),transitionend:Dc("Transition","TransitionEnd")},Fc={},Gc={};
fa&&(Gc=document.createElement("div").style,"AnimationEvent"in window||(delete Ec.animationend.animation,delete Ec.animationiteration.animation,delete Ec.animationstart.animation),"TransitionEvent"in window||delete Ec.transitionend.transition);function Hc(a){if(Fc[a])return Fc[a];if(!Ec[a])return a;var b=Ec[a],c;for(c in b)if(b.hasOwnProperty(c)&&c in Gc)return Fc[a]=b[c];return a}
var Ic=Hc("animationend"),Jc=Hc("animationiteration"),Kc=Hc("animationstart"),Lc=Hc("transitionend"),Mc=new Map,Nc=new Map,Oc=["abort","abort",Ic,"animationEnd",Jc,"animationIteration",Kc,"animationStart","canplay","canPlay","canplaythrough","canPlayThrough","durationchange","durationChange","emptied","emptied","encrypted","encrypted","ended","ended","error","error","gotpointercapture","gotPointerCapture","load","load","loadeddata","loadedData","loadedmetadata","loadedMetadata","loadstart","loadStart",
"lostpointercapture","lostPointerCapture","playing","playing","progress","progress","seeking","seeking","stalled","stalled","suspend","suspend","timeupdate","timeUpdate",Lc,"transitionEnd","waiting","waiting"];function Pc(a,b){for(var c=0;c<a.length;c+=2){var d=a[c],e=a[c+1];e="on"+(e[0].toUpperCase()+e.slice(1));Nc.set(d,b);Mc.set(d,e);da(e,[d])}}var Qc=r.unstable_now;Qc();var F=8;
function Rc(a){if(0!==(1&a))return F=15,1;if(0!==(2&a))return F=14,2;if(0!==(4&a))return F=13,4;var b=24&a;if(0!==b)return F=12,b;if(0!==(a&32))return F=11,32;b=192&a;if(0!==b)return F=10,b;if(0!==(a&256))return F=9,256;b=3584&a;if(0!==b)return F=8,b;if(0!==(a&4096))return F=7,4096;b=4186112&a;if(0!==b)return F=6,b;b=62914560&a;if(0!==b)return F=5,b;if(a&67108864)return F=4,67108864;if(0!==(a&134217728))return F=3,134217728;b=805306368&a;if(0!==b)return F=2,b;if(0!==(1073741824&a))return F=1,1073741824;
F=8;return a}function Sc(a){switch(a){case 99:return 15;case 98:return 10;case 97:case 96:return 8;case 95:return 2;default:return 0}}function Tc(a){switch(a){case 15:case 14:return 99;case 13:case 12:case 11:case 10:return 98;case 9:case 8:case 7:case 6:case 4:case 5:return 97;case 3:case 2:case 1:return 95;case 0:return 90;default:throw Error(y(358,a));}}
function Uc(a,b){var c=a.pendingLanes;if(0===c)return F=0;var d=0,e=0,f=a.expiredLanes,g=a.suspendedLanes,h=a.pingedLanes;if(0!==f)d=f,e=F=15;else if(f=c&134217727,0!==f){var k=f&~g;0!==k?(d=Rc(k),e=F):(h&=f,0!==h&&(d=Rc(h),e=F))}else f=c&~g,0!==f?(d=Rc(f),e=F):0!==h&&(d=Rc(h),e=F);if(0===d)return 0;d=31-Vc(d);d=c&((0>d?0:1<<d)<<1)-1;if(0!==b&&b!==d&&0===(b&g)){Rc(b);if(e<=F)return b;F=e}b=a.entangledLanes;if(0!==b)for(a=a.entanglements,b&=d;0<b;)c=31-Vc(b),e=1<<c,d|=a[c],b&=~e;return d}
function Wc(a){a=a.pendingLanes&-1073741825;return 0!==a?a:a&1073741824?1073741824:0}function Xc(a,b){switch(a){case 15:return 1;case 14:return 2;case 12:return a=Yc(24&~b),0===a?Xc(10,b):a;case 10:return a=Yc(192&~b),0===a?Xc(8,b):a;case 8:return a=Yc(3584&~b),0===a&&(a=Yc(4186112&~b),0===a&&(a=512)),a;case 2:return b=Yc(805306368&~b),0===b&&(b=268435456),b}throw Error(y(358,a));}function Yc(a){return a&-a}function Zc(a){for(var b=[],c=0;31>c;c++)b.push(a);return b}
function $c(a,b,c){a.pendingLanes|=b;var d=b-1;a.suspendedLanes&=d;a.pingedLanes&=d;a=a.eventTimes;b=31-Vc(b);a[b]=c}var Vc=Math.clz32?Math.clz32:ad,bd=Math.log,cd=Math.LN2;function ad(a){return 0===a?32:31-(bd(a)/cd|0)|0}var dd=r.unstable_UserBlockingPriority,ed=r.unstable_runWithPriority,fd=!0;function gd(a,b,c,d){Kb||Ib();var e=hd,f=Kb;Kb=!0;try{Hb(e,a,b,c,d)}finally{(Kb=f)||Mb()}}function id(a,b,c,d){ed(dd,hd.bind(null,a,b,c,d))}
function hd(a,b,c,d){if(fd){var e;if((e=0===(b&4))&&0<jc.length&&-1<qc.indexOf(a))a=rc(null,a,b,c,d),jc.push(a);else{var f=yc(a,b,c,d);if(null===f)e&&sc(a,d);else{if(e){if(-1<qc.indexOf(a)){a=rc(f,a,b,c,d);jc.push(a);return}if(uc(f,a,b,c,d))return;sc(a,d)}jd(a,b,d,null,c)}}}}
function yc(a,b,c,d){var e=xb(d);e=wc(e);if(null!==e){var f=Zb(e);if(null===f)e=null;else{var g=f.tag;if(13===g){e=$b(f);if(null!==e)return e;e=null}else if(3===g){if(f.stateNode.hydrate)return 3===f.tag?f.stateNode.containerInfo:null;e=null}else f!==e&&(e=null)}}jd(a,b,d,e,c);return null}var kd=null,ld=null,md=null;
function nd(){if(md)return md;var a,b=ld,c=b.length,d,e="value"in kd?kd.value:kd.textContent,f=e.length;for(a=0;a<c&&b[a]===e[a];a++);var g=c-a;for(d=1;d<=g&&b[c-d]===e[f-d];d++);return md=e.slice(a,1<d?1-d:void 0)}function od(a){var b=a.keyCode;"charCode"in a?(a=a.charCode,0===a&&13===b&&(a=13)):a=b;10===a&&(a=13);return 32<=a||13===a?a:0}function pd(){return!0}function qd(){return!1}
function rd(a){function b(b,d,e,f,g){this._reactName=b;this._targetInst=e;this.type=d;this.nativeEvent=f;this.target=g;this.currentTarget=null;for(var c in a)a.hasOwnProperty(c)&&(b=a[c],this[c]=b?b(f):f[c]);this.isDefaultPrevented=(null!=f.defaultPrevented?f.defaultPrevented:!1===f.returnValue)?pd:qd;this.isPropagationStopped=qd;return this}m(b.prototype,{preventDefault:function(){this.defaultPrevented=!0;var a=this.nativeEvent;a&&(a.preventDefault?a.preventDefault():"unknown"!==typeof a.returnValue&&
(a.returnValue=!1),this.isDefaultPrevented=pd)},stopPropagation:function(){var a=this.nativeEvent;a&&(a.stopPropagation?a.stopPropagation():"unknown"!==typeof a.cancelBubble&&(a.cancelBubble=!0),this.isPropagationStopped=pd)},persist:function(){},isPersistent:pd});return b}
var sd={eventPhase:0,bubbles:0,cancelable:0,timeStamp:function(a){return a.timeStamp||Date.now()},defaultPrevented:0,isTrusted:0},td=rd(sd),ud=m({},sd,{view:0,detail:0}),vd=rd(ud),wd,xd,yd,Ad=m({},ud,{screenX:0,screenY:0,clientX:0,clientY:0,pageX:0,pageY:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,getModifierState:zd,button:0,buttons:0,relatedTarget:function(a){return void 0===a.relatedTarget?a.fromElement===a.srcElement?a.toElement:a.fromElement:a.relatedTarget},movementX:function(a){if("movementX"in
a)return a.movementX;a!==yd&&(yd&&"mousemove"===a.type?(wd=a.screenX-yd.screenX,xd=a.screenY-yd.screenY):xd=wd=0,yd=a);return wd},movementY:function(a){return"movementY"in a?a.movementY:xd}}),Bd=rd(Ad),Cd=m({},Ad,{dataTransfer:0}),Dd=rd(Cd),Ed=m({},ud,{relatedTarget:0}),Fd=rd(Ed),Gd=m({},sd,{animationName:0,elapsedTime:0,pseudoElement:0}),Hd=rd(Gd),Id=m({},sd,{clipboardData:function(a){return"clipboardData"in a?a.clipboardData:window.clipboardData}}),Jd=rd(Id),Kd=m({},sd,{data:0}),Ld=rd(Kd),Md={Esc:"Escape",
Spacebar:" ",Left:"ArrowLeft",Up:"ArrowUp",Right:"ArrowRight",Down:"ArrowDown",Del:"Delete",Win:"OS",Menu:"ContextMenu",Apps:"ContextMenu",Scroll:"ScrollLock",MozPrintableKey:"Unidentified"},Nd={8:"Backspace",9:"Tab",12:"Clear",13:"Enter",16:"Shift",17:"Control",18:"Alt",19:"Pause",20:"CapsLock",27:"Escape",32:" ",33:"PageUp",34:"PageDown",35:"End",36:"Home",37:"ArrowLeft",38:"ArrowUp",39:"ArrowRight",40:"ArrowDown",45:"Insert",46:"Delete",112:"F1",113:"F2",114:"F3",115:"F4",116:"F5",117:"F6",118:"F7",
119:"F8",120:"F9",121:"F10",122:"F11",123:"F12",144:"NumLock",145:"ScrollLock",224:"Meta"},Od={Alt:"altKey",Control:"ctrlKey",Meta:"metaKey",Shift:"shiftKey"};function Pd(a){var b=this.nativeEvent;return b.getModifierState?b.getModifierState(a):(a=Od[a])?!!b[a]:!1}function zd(){return Pd}
var Qd=m({},ud,{key:function(a){if(a.key){var b=Md[a.key]||a.key;if("Unidentified"!==b)return b}return"keypress"===a.type?(a=od(a),13===a?"Enter":String.fromCharCode(a)):"keydown"===a.type||"keyup"===a.type?Nd[a.keyCode]||"Unidentified":""},code:0,location:0,ctrlKey:0,shiftKey:0,altKey:0,metaKey:0,repeat:0,locale:0,getModifierState:zd,charCode:function(a){return"keypress"===a.type?od(a):0},keyCode:function(a){return"keydown"===a.type||"keyup"===a.type?a.keyCode:0},which:function(a){return"keypress"===
a.type?od(a):"keydown"===a.type||"keyup"===a.type?a.keyCode:0}}),Rd=rd(Qd),Sd=m({},Ad,{pointerId:0,width:0,height:0,pressure:0,tangentialPressure:0,tiltX:0,tiltY:0,twist:0,pointerType:0,isPrimary:0}),Td=rd(Sd),Ud=m({},ud,{touches:0,targetTouches:0,changedTouches:0,altKey:0,metaKey:0,ctrlKey:0,shiftKey:0,getModifierState:zd}),Vd=rd(Ud),Wd=m({},sd,{propertyName:0,elapsedTime:0,pseudoElement:0}),Xd=rd(Wd),Yd=m({},Ad,{deltaX:function(a){return"deltaX"in a?a.deltaX:"wheelDeltaX"in a?-a.wheelDeltaX:0},
deltaY:function(a){return"deltaY"in a?a.deltaY:"wheelDeltaY"in a?-a.wheelDeltaY:"wheelDelta"in a?-a.wheelDelta:0},deltaZ:0,deltaMode:0}),Zd=rd(Yd),$d=[9,13,27,32],ae=fa&&"CompositionEvent"in window,be=null;fa&&"documentMode"in document&&(be=document.documentMode);var ce=fa&&"TextEvent"in window&&!be,de=fa&&(!ae||be&&8<be&&11>=be),ee=String.fromCharCode(32),fe=!1;
function ge(a,b){switch(a){case "keyup":return-1!==$d.indexOf(b.keyCode);case "keydown":return 229!==b.keyCode;case "keypress":case "mousedown":case "focusout":return!0;default:return!1}}function he(a){a=a.detail;return"object"===typeof a&&"data"in a?a.data:null}var ie=!1;function je(a,b){switch(a){case "compositionend":return he(b);case "keypress":if(32!==b.which)return null;fe=!0;return ee;case "textInput":return a=b.data,a===ee&&fe?null:a;default:return null}}
function ke(a,b){if(ie)return"compositionend"===a||!ae&&ge(a,b)?(a=nd(),md=ld=kd=null,ie=!1,a):null;switch(a){case "paste":return null;case "keypress":if(!(b.ctrlKey||b.altKey||b.metaKey)||b.ctrlKey&&b.altKey){if(b.char&&1<b.char.length)return b.char;if(b.which)return String.fromCharCode(b.which)}return null;case "compositionend":return de&&"ko"!==b.locale?null:b.data;default:return null}}
var le={color:!0,date:!0,datetime:!0,"datetime-local":!0,email:!0,month:!0,number:!0,password:!0,range:!0,search:!0,tel:!0,text:!0,time:!0,url:!0,week:!0};function me(a){var b=a&&a.nodeName&&a.nodeName.toLowerCase();return"input"===b?!!le[a.type]:"textarea"===b?!0:!1}function ne(a,b,c,d){Eb(d);b=oe(b,"onChange");0<b.length&&(c=new td("onChange","change",null,c,d),a.push({event:c,listeners:b}))}var pe=null,qe=null;function re(a){se(a,0)}function te(a){var b=ue(a);if(Wa(b))return a}
function ve(a,b){if("change"===a)return b}var we=!1;if(fa){var xe;if(fa){var ye="oninput"in document;if(!ye){var ze=document.createElement("div");ze.setAttribute("oninput","return;");ye="function"===typeof ze.oninput}xe=ye}else xe=!1;we=xe&&(!document.documentMode||9<document.documentMode)}function Ae(){pe&&(pe.detachEvent("onpropertychange",Be),qe=pe=null)}function Be(a){if("value"===a.propertyName&&te(qe)){var b=[];ne(b,qe,a,xb(a));a=re;if(Kb)a(b);else{Kb=!0;try{Gb(a,b)}finally{Kb=!1,Mb()}}}}
function Ce(a,b,c){"focusin"===a?(Ae(),pe=b,qe=c,pe.attachEvent("onpropertychange",Be)):"focusout"===a&&Ae()}function De(a){if("selectionchange"===a||"keyup"===a||"keydown"===a)return te(qe)}function Ee(a,b){if("click"===a)return te(b)}function Fe(a,b){if("input"===a||"change"===a)return te(b)}function Ge(a,b){return a===b&&(0!==a||1/a===1/b)||a!==a&&b!==b}var He="function"===typeof Object.is?Object.is:Ge,Ie=Object.prototype.hasOwnProperty;
function Je(a,b){if(He(a,b))return!0;if("object"!==typeof a||null===a||"object"!==typeof b||null===b)return!1;var c=Object.keys(a),d=Object.keys(b);if(c.length!==d.length)return!1;for(d=0;d<c.length;d++)if(!Ie.call(b,c[d])||!He(a[c[d]],b[c[d]]))return!1;return!0}function Ke(a){for(;a&&a.firstChild;)a=a.firstChild;return a}
function Le(a,b){var c=Ke(a);a=0;for(var d;c;){if(3===c.nodeType){d=a+c.textContent.length;if(a<=b&&d>=b)return{node:c,offset:b-a};a=d}a:{for(;c;){if(c.nextSibling){c=c.nextSibling;break a}c=c.parentNode}c=void 0}c=Ke(c)}}function Me(a,b){return a&&b?a===b?!0:a&&3===a.nodeType?!1:b&&3===b.nodeType?Me(a,b.parentNode):"contains"in a?a.contains(b):a.compareDocumentPosition?!!(a.compareDocumentPosition(b)&16):!1:!1}
function Ne(){for(var a=window,b=Xa();b instanceof a.HTMLIFrameElement;){try{var c="string"===typeof b.contentWindow.location.href}catch(d){c=!1}if(c)a=b.contentWindow;else break;b=Xa(a.document)}return b}function Oe(a){var b=a&&a.nodeName&&a.nodeName.toLowerCase();return b&&("input"===b&&("text"===a.type||"search"===a.type||"tel"===a.type||"url"===a.type||"password"===a.type)||"textarea"===b||"true"===a.contentEditable)}
var Pe=fa&&"documentMode"in document&&11>=document.documentMode,Qe=null,Re=null,Se=null,Te=!1;
function Ue(a,b,c){var d=c.window===c?c.document:9===c.nodeType?c:c.ownerDocument;Te||null==Qe||Qe!==Xa(d)||(d=Qe,"selectionStart"in d&&Oe(d)?d={start:d.selectionStart,end:d.selectionEnd}:(d=(d.ownerDocument&&d.ownerDocument.defaultView||window).getSelection(),d={anchorNode:d.anchorNode,anchorOffset:d.anchorOffset,focusNode:d.focusNode,focusOffset:d.focusOffset}),Se&&Je(Se,d)||(Se=d,d=oe(Re,"onSelect"),0<d.length&&(b=new td("onSelect","select",null,b,c),a.push({event:b,listeners:d}),b.target=Qe)))}
Pc("cancel cancel click click close close contextmenu contextMenu copy copy cut cut auxclick auxClick dblclick doubleClick dragend dragEnd dragstart dragStart drop drop focusin focus focusout blur input input invalid invalid keydown keyDown keypress keyPress keyup keyUp mousedown mouseDown mouseup mouseUp paste paste pause pause play play pointercancel pointerCancel pointerdown pointerDown pointerup pointerUp ratechange rateChange reset reset seeked seeked submit submit touchcancel touchCancel touchend touchEnd touchstart touchStart volumechange volumeChange".split(" "),
0);Pc("drag drag dragenter dragEnter dragexit dragExit dragleave dragLeave dragover dragOver mousemove mouseMove mouseout mouseOut mouseover mouseOver pointermove pointerMove pointerout pointerOut pointerover pointerOver scroll scroll toggle toggle touchmove touchMove wheel wheel".split(" "),1);Pc(Oc,2);for(var Ve="change selectionchange textInput compositionstart compositionend compositionupdate".split(" "),We=0;We<Ve.length;We++)Nc.set(Ve[We],0);ea("onMouseEnter",["mouseout","mouseover"]);
ea("onMouseLeave",["mouseout","mouseover"]);ea("onPointerEnter",["pointerout","pointerover"]);ea("onPointerLeave",["pointerout","pointerover"]);da("onChange","change click focusin focusout input keydown keyup selectionchange".split(" "));da("onSelect","focusout contextmenu dragend focusin keydown keyup mousedown mouseup selectionchange".split(" "));da("onBeforeInput",["compositionend","keypress","textInput","paste"]);da("onCompositionEnd","compositionend focusout keydown keypress keyup mousedown".split(" "));
da("onCompositionStart","compositionstart focusout keydown keypress keyup mousedown".split(" "));da("onCompositionUpdate","compositionupdate focusout keydown keypress keyup mousedown".split(" "));var Xe="abort canplay canplaythrough durationchange emptied encrypted ended error loadeddata loadedmetadata loadstart pause play playing progress ratechange seeked seeking stalled suspend timeupdate volumechange waiting".split(" "),Ye=new Set("cancel close invalid load scroll toggle".split(" ").concat(Xe));
function Ze(a,b,c){var d=a.type||"unknown-event";a.currentTarget=c;Yb(d,b,void 0,a);a.currentTarget=null}
function se(a,b){b=0!==(b&4);for(var c=0;c<a.length;c++){var d=a[c],e=d.event;d=d.listeners;a:{var f=void 0;if(b)for(var g=d.length-1;0<=g;g--){var h=d[g],k=h.instance,l=h.currentTarget;h=h.listener;if(k!==f&&e.isPropagationStopped())break a;Ze(e,h,l);f=k}else for(g=0;g<d.length;g++){h=d[g];k=h.instance;l=h.currentTarget;h=h.listener;if(k!==f&&e.isPropagationStopped())break a;Ze(e,h,l);f=k}}}if(Ub)throw a=Vb,Ub=!1,Vb=null,a;}
function G(a,b){var c=$e(b),d=a+"__bubble";c.has(d)||(af(b,a,2,!1),c.add(d))}var bf="_reactListening"+Math.random().toString(36).slice(2);function cf(a){a[bf]||(a[bf]=!0,ba.forEach(function(b){Ye.has(b)||df(b,!1,a,null);df(b,!0,a,null)}))}
function df(a,b,c,d){var e=4<arguments.length&&void 0!==arguments[4]?arguments[4]:0,f=c;"selectionchange"===a&&9!==c.nodeType&&(f=c.ownerDocument);if(null!==d&&!b&&Ye.has(a)){if("scroll"!==a)return;e|=2;f=d}var g=$e(f),h=a+"__"+(b?"capture":"bubble");g.has(h)||(b&&(e|=4),af(f,a,e,b),g.add(h))}
function af(a,b,c,d){var e=Nc.get(b);switch(void 0===e?2:e){case 0:e=gd;break;case 1:e=id;break;default:e=hd}c=e.bind(null,b,c,a);e=void 0;!Pb||"touchstart"!==b&&"touchmove"!==b&&"wheel"!==b||(e=!0);d?void 0!==e?a.addEventListener(b,c,{capture:!0,passive:e}):a.addEventListener(b,c,!0):void 0!==e?a.addEventListener(b,c,{passive:e}):a.addEventListener(b,c,!1)}
function jd(a,b,c,d,e){var f=d;if(0===(b&1)&&0===(b&2)&&null!==d)a:for(;;){if(null===d)return;var g=d.tag;if(3===g||4===g){var h=d.stateNode.containerInfo;if(h===e||8===h.nodeType&&h.parentNode===e)break;if(4===g)for(g=d.return;null!==g;){var k=g.tag;if(3===k||4===k)if(k=g.stateNode.containerInfo,k===e||8===k.nodeType&&k.parentNode===e)return;g=g.return}for(;null!==h;){g=wc(h);if(null===g)return;k=g.tag;if(5===k||6===k){d=f=g;continue a}h=h.parentNode}}d=d.return}Nb(function(){var d=f,e=xb(c),g=[];
a:{var h=Mc.get(a);if(void 0!==h){var k=td,x=a;switch(a){case "keypress":if(0===od(c))break a;case "keydown":case "keyup":k=Rd;break;case "focusin":x="focus";k=Fd;break;case "focusout":x="blur";k=Fd;break;case "beforeblur":case "afterblur":k=Fd;break;case "click":if(2===c.button)break a;case "auxclick":case "dblclick":case "mousedown":case "mousemove":case "mouseup":case "mouseout":case "mouseover":case "contextmenu":k=Bd;break;case "drag":case "dragend":case "dragenter":case "dragexit":case "dragleave":case "dragover":case "dragstart":case "drop":k=
Dd;break;case "touchcancel":case "touchend":case "touchmove":case "touchstart":k=Vd;break;case Ic:case Jc:case Kc:k=Hd;break;case Lc:k=Xd;break;case "scroll":k=vd;break;case "wheel":k=Zd;break;case "copy":case "cut":case "paste":k=Jd;break;case "gotpointercapture":case "lostpointercapture":case "pointercancel":case "pointerdown":case "pointermove":case "pointerout":case "pointerover":case "pointerup":k=Td}var w=0!==(b&4),z=!w&&"scroll"===a,u=w?null!==h?h+"Capture":null:h;w=[];for(var t=d,q;null!==
t;){q=t;var v=q.stateNode;5===q.tag&&null!==v&&(q=v,null!==u&&(v=Ob(t,u),null!=v&&w.push(ef(t,v,q))));if(z)break;t=t.return}0<w.length&&(h=new k(h,x,null,c,e),g.push({event:h,listeners:w}))}}if(0===(b&7)){a:{h="mouseover"===a||"pointerover"===a;k="mouseout"===a||"pointerout"===a;if(h&&0===(b&16)&&(x=c.relatedTarget||c.fromElement)&&(wc(x)||x[ff]))break a;if(k||h){h=e.window===e?e:(h=e.ownerDocument)?h.defaultView||h.parentWindow:window;if(k){if(x=c.relatedTarget||c.toElement,k=d,x=x?wc(x):null,null!==
x&&(z=Zb(x),x!==z||5!==x.tag&&6!==x.tag))x=null}else k=null,x=d;if(k!==x){w=Bd;v="onMouseLeave";u="onMouseEnter";t="mouse";if("pointerout"===a||"pointerover"===a)w=Td,v="onPointerLeave",u="onPointerEnter",t="pointer";z=null==k?h:ue(k);q=null==x?h:ue(x);h=new w(v,t+"leave",k,c,e);h.target=z;h.relatedTarget=q;v=null;wc(e)===d&&(w=new w(u,t+"enter",x,c,e),w.target=q,w.relatedTarget=z,v=w);z=v;if(k&&x)b:{w=k;u=x;t=0;for(q=w;q;q=gf(q))t++;q=0;for(v=u;v;v=gf(v))q++;for(;0<t-q;)w=gf(w),t--;for(;0<q-t;)u=
gf(u),q--;for(;t--;){if(w===u||null!==u&&w===u.alternate)break b;w=gf(w);u=gf(u)}w=null}else w=null;null!==k&&hf(g,h,k,w,!1);null!==x&&null!==z&&hf(g,z,x,w,!0)}}}a:{h=d?ue(d):window;k=h.nodeName&&h.nodeName.toLowerCase();if("select"===k||"input"===k&&"file"===h.type)var J=ve;else if(me(h))if(we)J=Fe;else{J=De;var K=Ce}else(k=h.nodeName)&&"input"===k.toLowerCase()&&("checkbox"===h.type||"radio"===h.type)&&(J=Ee);if(J&&(J=J(a,d))){ne(g,J,c,e);break a}K&&K(a,h,d);"focusout"===a&&(K=h._wrapperState)&&
K.controlled&&"number"===h.type&&bb(h,"number",h.value)}K=d?ue(d):window;switch(a){case "focusin":if(me(K)||"true"===K.contentEditable)Qe=K,Re=d,Se=null;break;case "focusout":Se=Re=Qe=null;break;case "mousedown":Te=!0;break;case "contextmenu":case "mouseup":case "dragend":Te=!1;Ue(g,c,e);break;case "selectionchange":if(Pe)break;case "keydown":case "keyup":Ue(g,c,e)}var Q;if(ae)b:{switch(a){case "compositionstart":var L="onCompositionStart";break b;case "compositionend":L="onCompositionEnd";break b;
case "compositionupdate":L="onCompositionUpdate";break b}L=void 0}else ie?ge(a,c)&&(L="onCompositionEnd"):"keydown"===a&&229===c.keyCode&&(L="onCompositionStart");L&&(de&&"ko"!==c.locale&&(ie||"onCompositionStart"!==L?"onCompositionEnd"===L&&ie&&(Q=nd()):(kd=e,ld="value"in kd?kd.value:kd.textContent,ie=!0)),K=oe(d,L),0<K.length&&(L=new Ld(L,a,null,c,e),g.push({event:L,listeners:K}),Q?L.data=Q:(Q=he(c),null!==Q&&(L.data=Q))));if(Q=ce?je(a,c):ke(a,c))d=oe(d,"onBeforeInput"),0<d.length&&(e=new Ld("onBeforeInput",
"beforeinput",null,c,e),g.push({event:e,listeners:d}),e.data=Q)}se(g,b)})}function ef(a,b,c){return{instance:a,listener:b,currentTarget:c}}function oe(a,b){for(var c=b+"Capture",d=[];null!==a;){var e=a,f=e.stateNode;5===e.tag&&null!==f&&(e=f,f=Ob(a,c),null!=f&&d.unshift(ef(a,f,e)),f=Ob(a,b),null!=f&&d.push(ef(a,f,e)));a=a.return}return d}function gf(a){if(null===a)return null;do a=a.return;while(a&&5!==a.tag);return a?a:null}
function hf(a,b,c,d,e){for(var f=b._reactName,g=[];null!==c&&c!==d;){var h=c,k=h.alternate,l=h.stateNode;if(null!==k&&k===d)break;5===h.tag&&null!==l&&(h=l,e?(k=Ob(c,f),null!=k&&g.unshift(ef(c,k,h))):e||(k=Ob(c,f),null!=k&&g.push(ef(c,k,h))));c=c.return}0!==g.length&&a.push({event:b,listeners:g})}function jf(){}var kf=null,lf=null;function mf(a,b){switch(a){case "button":case "input":case "select":case "textarea":return!!b.autoFocus}return!1}
function nf(a,b){return"textarea"===a||"option"===a||"noscript"===a||"string"===typeof b.children||"number"===typeof b.children||"object"===typeof b.dangerouslySetInnerHTML&&null!==b.dangerouslySetInnerHTML&&null!=b.dangerouslySetInnerHTML.__html}var of="function"===typeof setTimeout?setTimeout:void 0,pf="function"===typeof clearTimeout?clearTimeout:void 0;function qf(a){1===a.nodeType?a.textContent="":9===a.nodeType&&(a=a.body,null!=a&&(a.textContent=""))}
function rf(a){for(;null!=a;a=a.nextSibling){var b=a.nodeType;if(1===b||3===b)break}return a}function sf(a){a=a.previousSibling;for(var b=0;a;){if(8===a.nodeType){var c=a.data;if("$"===c||"$!"===c||"$?"===c){if(0===b)return a;b--}else"/$"===c&&b++}a=a.previousSibling}return null}var tf=0;function uf(a){return{$$typeof:Ga,toString:a,valueOf:a}}var vf=Math.random().toString(36).slice(2),wf="__reactFiber$"+vf,xf="__reactProps$"+vf,ff="__reactContainer$"+vf,yf="__reactEvents$"+vf;
function wc(a){var b=a[wf];if(b)return b;for(var c=a.parentNode;c;){if(b=c[ff]||c[wf]){c=b.alternate;if(null!==b.child||null!==c&&null!==c.child)for(a=sf(a);null!==a;){if(c=a[wf])return c;a=sf(a)}return b}a=c;c=a.parentNode}return null}function Cb(a){a=a[wf]||a[ff];return!a||5!==a.tag&&6!==a.tag&&13!==a.tag&&3!==a.tag?null:a}function ue(a){if(5===a.tag||6===a.tag)return a.stateNode;throw Error(y(33));}function Db(a){return a[xf]||null}
function $e(a){var b=a[yf];void 0===b&&(b=a[yf]=new Set);return b}var zf=[],Af=-1;function Bf(a){return{current:a}}function H(a){0>Af||(a.current=zf[Af],zf[Af]=null,Af--)}function I(a,b){Af++;zf[Af]=a.current;a.current=b}var Cf={},M=Bf(Cf),N=Bf(!1),Df=Cf;
function Ef(a,b){var c=a.type.contextTypes;if(!c)return Cf;var d=a.stateNode;if(d&&d.__reactInternalMemoizedUnmaskedChildContext===b)return d.__reactInternalMemoizedMaskedChildContext;var e={},f;for(f in c)e[f]=b[f];d&&(a=a.stateNode,a.__reactInternalMemoizedUnmaskedChildContext=b,a.__reactInternalMemoizedMaskedChildContext=e);return e}function Ff(a){a=a.childContextTypes;return null!==a&&void 0!==a}function Gf(){H(N);H(M)}function Hf(a,b,c){if(M.current!==Cf)throw Error(y(168));I(M,b);I(N,c)}
function If(a,b,c){var d=a.stateNode;a=b.childContextTypes;if("function"!==typeof d.getChildContext)return c;d=d.getChildContext();for(var e in d)if(!(e in a))throw Error(y(108,Ra(b)||"Unknown",e));return m({},c,d)}function Jf(a){a=(a=a.stateNode)&&a.__reactInternalMemoizedMergedChildContext||Cf;Df=M.current;I(M,a);I(N,N.current);return!0}function Kf(a,b,c){var d=a.stateNode;if(!d)throw Error(y(169));c?(a=If(a,b,Df),d.__reactInternalMemoizedMergedChildContext=a,H(N),H(M),I(M,a)):H(N);I(N,c)}
var Lf=null,Mf=null,Nf=r.unstable_runWithPriority,Of=r.unstable_scheduleCallback,Pf=r.unstable_cancelCallback,Qf=r.unstable_shouldYield,Rf=r.unstable_requestPaint,Sf=r.unstable_now,Tf=r.unstable_getCurrentPriorityLevel,Uf=r.unstable_ImmediatePriority,Vf=r.unstable_UserBlockingPriority,Wf=r.unstable_NormalPriority,Xf=r.unstable_LowPriority,Yf=r.unstable_IdlePriority,Zf={},$f=void 0!==Rf?Rf:function(){},ag=null,bg=null,cg=!1,dg=Sf(),O=1E4>dg?Sf:function(){return Sf()-dg};
function eg(){switch(Tf()){case Uf:return 99;case Vf:return 98;case Wf:return 97;case Xf:return 96;case Yf:return 95;default:throw Error(y(332));}}function fg(a){switch(a){case 99:return Uf;case 98:return Vf;case 97:return Wf;case 96:return Xf;case 95:return Yf;default:throw Error(y(332));}}function gg(a,b){a=fg(a);return Nf(a,b)}function hg(a,b,c){a=fg(a);return Of(a,b,c)}function ig(){if(null!==bg){var a=bg;bg=null;Pf(a)}jg()}
function jg(){if(!cg&&null!==ag){cg=!0;var a=0;try{var b=ag;gg(99,function(){for(;a<b.length;a++){var c=b[a];do c=c(!0);while(null!==c)}});ag=null}catch(c){throw null!==ag&&(ag=ag.slice(a+1)),Of(Uf,ig),c;}finally{cg=!1}}}var kg=ra.ReactCurrentBatchConfig;function lg(a,b){if(a&&a.defaultProps){b=m({},b);a=a.defaultProps;for(var c in a)void 0===b[c]&&(b[c]=a[c]);return b}return b}var mg=Bf(null),ng=null,og=null,pg=null;function qg(){pg=og=ng=null}
function rg(a){var b=mg.current;H(mg);a.type._context._currentValue=b}function sg(a,b){for(;null!==a;){var c=a.alternate;if((a.childLanes&b)===b)if(null===c||(c.childLanes&b)===b)break;else c.childLanes|=b;else a.childLanes|=b,null!==c&&(c.childLanes|=b);a=a.return}}function tg(a,b){ng=a;pg=og=null;a=a.dependencies;null!==a&&null!==a.firstContext&&(0!==(a.lanes&b)&&(ug=!0),a.firstContext=null)}
function vg(a,b){if(pg!==a&&!1!==b&&0!==b){if("number"!==typeof b||1073741823===b)pg=a,b=1073741823;b={context:a,observedBits:b,next:null};if(null===og){if(null===ng)throw Error(y(308));og=b;ng.dependencies={lanes:0,firstContext:b,responders:null}}else og=og.next=b}return a._currentValue}var wg=!1;function xg(a){a.updateQueue={baseState:a.memoizedState,firstBaseUpdate:null,lastBaseUpdate:null,shared:{pending:null},effects:null}}
function yg(a,b){a=a.updateQueue;b.updateQueue===a&&(b.updateQueue={baseState:a.baseState,firstBaseUpdate:a.firstBaseUpdate,lastBaseUpdate:a.lastBaseUpdate,shared:a.shared,effects:a.effects})}function zg(a,b){return{eventTime:a,lane:b,tag:0,payload:null,callback:null,next:null}}function Ag(a,b){a=a.updateQueue;if(null!==a){a=a.shared;var c=a.pending;null===c?b.next=b:(b.next=c.next,c.next=b);a.pending=b}}
function Bg(a,b){var c=a.updateQueue,d=a.alternate;if(null!==d&&(d=d.updateQueue,c===d)){var e=null,f=null;c=c.firstBaseUpdate;if(null!==c){do{var g={eventTime:c.eventTime,lane:c.lane,tag:c.tag,payload:c.payload,callback:c.callback,next:null};null===f?e=f=g:f=f.next=g;c=c.next}while(null!==c);null===f?e=f=b:f=f.next=b}else e=f=b;c={baseState:d.baseState,firstBaseUpdate:e,lastBaseUpdate:f,shared:d.shared,effects:d.effects};a.updateQueue=c;return}a=c.lastBaseUpdate;null===a?c.firstBaseUpdate=b:a.next=
b;c.lastBaseUpdate=b}
function Cg(a,b,c,d){var e=a.updateQueue;wg=!1;var f=e.firstBaseUpdate,g=e.lastBaseUpdate,h=e.shared.pending;if(null!==h){e.shared.pending=null;var k=h,l=k.next;k.next=null;null===g?f=l:g.next=l;g=k;var n=a.alternate;if(null!==n){n=n.updateQueue;var A=n.lastBaseUpdate;A!==g&&(null===A?n.firstBaseUpdate=l:A.next=l,n.lastBaseUpdate=k)}}if(null!==f){A=e.baseState;g=0;n=l=k=null;do{h=f.lane;var p=f.eventTime;if((d&h)===h){null!==n&&(n=n.next={eventTime:p,lane:0,tag:f.tag,payload:f.payload,callback:f.callback,
next:null});a:{var C=a,x=f;h=b;p=c;switch(x.tag){case 1:C=x.payload;if("function"===typeof C){A=C.call(p,A,h);break a}A=C;break a;case 3:C.flags=C.flags&-4097|64;case 0:C=x.payload;h="function"===typeof C?C.call(p,A,h):C;if(null===h||void 0===h)break a;A=m({},A,h);break a;case 2:wg=!0}}null!==f.callback&&(a.flags|=32,h=e.effects,null===h?e.effects=[f]:h.push(f))}else p={eventTime:p,lane:h,tag:f.tag,payload:f.payload,callback:f.callback,next:null},null===n?(l=n=p,k=A):n=n.next=p,g|=h;f=f.next;if(null===
f)if(h=e.shared.pending,null===h)break;else f=h.next,h.next=null,e.lastBaseUpdate=h,e.shared.pending=null}while(1);null===n&&(k=A);e.baseState=k;e.firstBaseUpdate=l;e.lastBaseUpdate=n;Dg|=g;a.lanes=g;a.memoizedState=A}}function Eg(a,b,c){a=b.effects;b.effects=null;if(null!==a)for(b=0;b<a.length;b++){var d=a[b],e=d.callback;if(null!==e){d.callback=null;d=c;if("function"!==typeof e)throw Error(y(191,e));e.call(d)}}}var Fg=(new aa.Component).refs;
function Gg(a,b,c,d){b=a.memoizedState;c=c(d,b);c=null===c||void 0===c?b:m({},b,c);a.memoizedState=c;0===a.lanes&&(a.updateQueue.baseState=c)}
var Kg={isMounted:function(a){return(a=a._reactInternals)?Zb(a)===a:!1},enqueueSetState:function(a,b,c){a=a._reactInternals;var d=Hg(),e=Ig(a),f=zg(d,e);f.payload=b;void 0!==c&&null!==c&&(f.callback=c);Ag(a,f);Jg(a,e,d)},enqueueReplaceState:function(a,b,c){a=a._reactInternals;var d=Hg(),e=Ig(a),f=zg(d,e);f.tag=1;f.payload=b;void 0!==c&&null!==c&&(f.callback=c);Ag(a,f);Jg(a,e,d)},enqueueForceUpdate:function(a,b){a=a._reactInternals;var c=Hg(),d=Ig(a),e=zg(c,d);e.tag=2;void 0!==b&&null!==b&&(e.callback=
b);Ag(a,e);Jg(a,d,c)}};function Lg(a,b,c,d,e,f,g){a=a.stateNode;return"function"===typeof a.shouldComponentUpdate?a.shouldComponentUpdate(d,f,g):b.prototype&&b.prototype.isPureReactComponent?!Je(c,d)||!Je(e,f):!0}
function Mg(a,b,c){var d=!1,e=Cf;var f=b.contextType;"object"===typeof f&&null!==f?f=vg(f):(e=Ff(b)?Df:M.current,d=b.contextTypes,f=(d=null!==d&&void 0!==d)?Ef(a,e):Cf);b=new b(c,f);a.memoizedState=null!==b.state&&void 0!==b.state?b.state:null;b.updater=Kg;a.stateNode=b;b._reactInternals=a;d&&(a=a.stateNode,a.__reactInternalMemoizedUnmaskedChildContext=e,a.__reactInternalMemoizedMaskedChildContext=f);return b}
function Ng(a,b,c,d){a=b.state;"function"===typeof b.componentWillReceiveProps&&b.componentWillReceiveProps(c,d);"function"===typeof b.UNSAFE_componentWillReceiveProps&&b.UNSAFE_componentWillReceiveProps(c,d);b.state!==a&&Kg.enqueueReplaceState(b,b.state,null)}
function Og(a,b,c,d){var e=a.stateNode;e.props=c;e.state=a.memoizedState;e.refs=Fg;xg(a);var f=b.contextType;"object"===typeof f&&null!==f?e.context=vg(f):(f=Ff(b)?Df:M.current,e.context=Ef(a,f));Cg(a,c,e,d);e.state=a.memoizedState;f=b.getDerivedStateFromProps;"function"===typeof f&&(Gg(a,b,f,c),e.state=a.memoizedState);"function"===typeof b.getDerivedStateFromProps||"function"===typeof e.getSnapshotBeforeUpdate||"function"!==typeof e.UNSAFE_componentWillMount&&"function"!==typeof e.componentWillMount||
(b=e.state,"function"===typeof e.componentWillMount&&e.componentWillMount(),"function"===typeof e.UNSAFE_componentWillMount&&e.UNSAFE_componentWillMount(),b!==e.state&&Kg.enqueueReplaceState(e,e.state,null),Cg(a,c,e,d),e.state=a.memoizedState);"function"===typeof e.componentDidMount&&(a.flags|=4)}var Pg=Array.isArray;
function Qg(a,b,c){a=c.ref;if(null!==a&&"function"!==typeof a&&"object"!==typeof a){if(c._owner){c=c._owner;if(c){if(1!==c.tag)throw Error(y(309));var d=c.stateNode}if(!d)throw Error(y(147,a));var e=""+a;if(null!==b&&null!==b.ref&&"function"===typeof b.ref&&b.ref._stringRef===e)return b.ref;b=function(a){var b=d.refs;b===Fg&&(b=d.refs={});null===a?delete b[e]:b[e]=a};b._stringRef=e;return b}if("string"!==typeof a)throw Error(y(284));if(!c._owner)throw Error(y(290,a));}return a}
function Rg(a,b){if("textarea"!==a.type)throw Error(y(31,"[object Object]"===Object.prototype.toString.call(b)?"object with keys {"+Object.keys(b).join(", ")+"}":b));}
function Sg(a){function b(b,c){if(a){var d=b.lastEffect;null!==d?(d.nextEffect=c,b.lastEffect=c):b.firstEffect=b.lastEffect=c;c.nextEffect=null;c.flags=8}}function c(c,d){if(!a)return null;for(;null!==d;)b(c,d),d=d.sibling;return null}function d(a,b){for(a=new Map;null!==b;)null!==b.key?a.set(b.key,b):a.set(b.index,b),b=b.sibling;return a}function e(a,b){a=Tg(a,b);a.index=0;a.sibling=null;return a}function f(b,c,d){b.index=d;if(!a)return c;d=b.alternate;if(null!==d)return d=d.index,d<c?(b.flags=2,
c):d;b.flags=2;return c}function g(b){a&&null===b.alternate&&(b.flags=2);return b}function h(a,b,c,d){if(null===b||6!==b.tag)return b=Ug(c,a.mode,d),b.return=a,b;b=e(b,c);b.return=a;return b}function k(a,b,c,d){if(null!==b&&b.elementType===c.type)return d=e(b,c.props),d.ref=Qg(a,b,c),d.return=a,d;d=Vg(c.type,c.key,c.props,null,a.mode,d);d.ref=Qg(a,b,c);d.return=a;return d}function l(a,b,c,d){if(null===b||4!==b.tag||b.stateNode.containerInfo!==c.containerInfo||b.stateNode.implementation!==c.implementation)return b=
Wg(c,a.mode,d),b.return=a,b;b=e(b,c.children||[]);b.return=a;return b}function n(a,b,c,d,f){if(null===b||7!==b.tag)return b=Xg(c,a.mode,d,f),b.return=a,b;b=e(b,c);b.return=a;return b}function A(a,b,c){if("string"===typeof b||"number"===typeof b)return b=Ug(""+b,a.mode,c),b.return=a,b;if("object"===typeof b&&null!==b){switch(b.$$typeof){case sa:return c=Vg(b.type,b.key,b.props,null,a.mode,c),c.ref=Qg(a,null,b),c.return=a,c;case ta:return b=Wg(b,a.mode,c),b.return=a,b}if(Pg(b)||La(b))return b=Xg(b,
a.mode,c,null),b.return=a,b;Rg(a,b)}return null}function p(a,b,c,d){var e=null!==b?b.key:null;if("string"===typeof c||"number"===typeof c)return null!==e?null:h(a,b,""+c,d);if("object"===typeof c&&null!==c){switch(c.$$typeof){case sa:return c.key===e?c.type===ua?n(a,b,c.props.children,d,e):k(a,b,c,d):null;case ta:return c.key===e?l(a,b,c,d):null}if(Pg(c)||La(c))return null!==e?null:n(a,b,c,d,null);Rg(a,c)}return null}function C(a,b,c,d,e){if("string"===typeof d||"number"===typeof d)return a=a.get(c)||
null,h(b,a,""+d,e);if("object"===typeof d&&null!==d){switch(d.$$typeof){case sa:return a=a.get(null===d.key?c:d.key)||null,d.type===ua?n(b,a,d.props.children,e,d.key):k(b,a,d,e);case ta:return a=a.get(null===d.key?c:d.key)||null,l(b,a,d,e)}if(Pg(d)||La(d))return a=a.get(c)||null,n(b,a,d,e,null);Rg(b,d)}return null}function x(e,g,h,k){for(var l=null,t=null,u=g,z=g=0,q=null;null!==u&&z<h.length;z++){u.index>z?(q=u,u=null):q=u.sibling;var n=p(e,u,h[z],k);if(null===n){null===u&&(u=q);break}a&&u&&null===
n.alternate&&b(e,u);g=f(n,g,z);null===t?l=n:t.sibling=n;t=n;u=q}if(z===h.length)return c(e,u),l;if(null===u){for(;z<h.length;z++)u=A(e,h[z],k),null!==u&&(g=f(u,g,z),null===t?l=u:t.sibling=u,t=u);return l}for(u=d(e,u);z<h.length;z++)q=C(u,e,z,h[z],k),null!==q&&(a&&null!==q.alternate&&u.delete(null===q.key?z:q.key),g=f(q,g,z),null===t?l=q:t.sibling=q,t=q);a&&u.forEach(function(a){return b(e,a)});return l}function w(e,g,h,k){var l=La(h);if("function"!==typeof l)throw Error(y(150));h=l.call(h);if(null==
h)throw Error(y(151));for(var t=l=null,u=g,z=g=0,q=null,n=h.next();null!==u&&!n.done;z++,n=h.next()){u.index>z?(q=u,u=null):q=u.sibling;var w=p(e,u,n.value,k);if(null===w){null===u&&(u=q);break}a&&u&&null===w.alternate&&b(e,u);g=f(w,g,z);null===t?l=w:t.sibling=w;t=w;u=q}if(n.done)return c(e,u),l;if(null===u){for(;!n.done;z++,n=h.next())n=A(e,n.value,k),null!==n&&(g=f(n,g,z),null===t?l=n:t.sibling=n,t=n);return l}for(u=d(e,u);!n.done;z++,n=h.next())n=C(u,e,z,n.value,k),null!==n&&(a&&null!==n.alternate&&
u.delete(null===n.key?z:n.key),g=f(n,g,z),null===t?l=n:t.sibling=n,t=n);a&&u.forEach(function(a){return b(e,a)});return l}return function(a,d,f,h){var k="object"===typeof f&&null!==f&&f.type===ua&&null===f.key;k&&(f=f.props.children);var l="object"===typeof f&&null!==f;if(l)switch(f.$$typeof){case sa:a:{l=f.key;for(k=d;null!==k;){if(k.key===l){switch(k.tag){case 7:if(f.type===ua){c(a,k.sibling);d=e(k,f.props.children);d.return=a;a=d;break a}break;default:if(k.elementType===f.type){c(a,k.sibling);
d=e(k,f.props);d.ref=Qg(a,k,f);d.return=a;a=d;break a}}c(a,k);break}else b(a,k);k=k.sibling}f.type===ua?(d=Xg(f.props.children,a.mode,h,f.key),d.return=a,a=d):(h=Vg(f.type,f.key,f.props,null,a.mode,h),h.ref=Qg(a,d,f),h.return=a,a=h)}return g(a);case ta:a:{for(k=f.key;null!==d;){if(d.key===k)if(4===d.tag&&d.stateNode.containerInfo===f.containerInfo&&d.stateNode.implementation===f.implementation){c(a,d.sibling);d=e(d,f.children||[]);d.return=a;a=d;break a}else{c(a,d);break}else b(a,d);d=d.sibling}d=
Wg(f,a.mode,h);d.return=a;a=d}return g(a)}if("string"===typeof f||"number"===typeof f)return f=""+f,null!==d&&6===d.tag?(c(a,d.sibling),d=e(d,f),d.return=a,a=d):(c(a,d),d=Ug(f,a.mode,h),d.return=a,a=d),g(a);if(Pg(f))return x(a,d,f,h);if(La(f))return w(a,d,f,h);l&&Rg(a,f);if("undefined"===typeof f&&!k)switch(a.tag){case 1:case 22:case 0:case 11:case 15:throw Error(y(152,Ra(a.type)||"Component"));}return c(a,d)}}var Yg=Sg(!0),Zg=Sg(!1),$g={},ah=Bf($g),bh=Bf($g),ch=Bf($g);
function dh(a){if(a===$g)throw Error(y(174));return a}function eh(a,b){I(ch,b);I(bh,a);I(ah,$g);a=b.nodeType;switch(a){case 9:case 11:b=(b=b.documentElement)?b.namespaceURI:mb(null,"");break;default:a=8===a?b.parentNode:b,b=a.namespaceURI||null,a=a.tagName,b=mb(b,a)}H(ah);I(ah,b)}function fh(){H(ah);H(bh);H(ch)}function gh(a){dh(ch.current);var b=dh(ah.current);var c=mb(b,a.type);b!==c&&(I(bh,a),I(ah,c))}function hh(a){bh.current===a&&(H(ah),H(bh))}var P=Bf(0);
function ih(a){for(var b=a;null!==b;){if(13===b.tag){var c=b.memoizedState;if(null!==c&&(c=c.dehydrated,null===c||"$?"===c.data||"$!"===c.data))return b}else if(19===b.tag&&void 0!==b.memoizedProps.revealOrder){if(0!==(b.flags&64))return b}else if(null!==b.child){b.child.return=b;b=b.child;continue}if(b===a)break;for(;null===b.sibling;){if(null===b.return||b.return===a)return null;b=b.return}b.sibling.return=b.return;b=b.sibling}return null}var jh=null,kh=null,lh=!1;
function mh(a,b){var c=nh(5,null,null,0);c.elementType="DELETED";c.type="DELETED";c.stateNode=b;c.return=a;c.flags=8;null!==a.lastEffect?(a.lastEffect.nextEffect=c,a.lastEffect=c):a.firstEffect=a.lastEffect=c}function oh(a,b){switch(a.tag){case 5:var c=a.type;b=1!==b.nodeType||c.toLowerCase()!==b.nodeName.toLowerCase()?null:b;return null!==b?(a.stateNode=b,!0):!1;case 6:return b=""===a.pendingProps||3!==b.nodeType?null:b,null!==b?(a.stateNode=b,!0):!1;case 13:return!1;default:return!1}}
function ph(a){if(lh){var b=kh;if(b){var c=b;if(!oh(a,b)){b=rf(c.nextSibling);if(!b||!oh(a,b)){a.flags=a.flags&-1025|2;lh=!1;jh=a;return}mh(jh,c)}jh=a;kh=rf(b.firstChild)}else a.flags=a.flags&-1025|2,lh=!1,jh=a}}function qh(a){for(a=a.return;null!==a&&5!==a.tag&&3!==a.tag&&13!==a.tag;)a=a.return;jh=a}
function rh(a){if(a!==jh)return!1;if(!lh)return qh(a),lh=!0,!1;var b=a.type;if(5!==a.tag||"head"!==b&&"body"!==b&&!nf(b,a.memoizedProps))for(b=kh;b;)mh(a,b),b=rf(b.nextSibling);qh(a);if(13===a.tag){a=a.memoizedState;a=null!==a?a.dehydrated:null;if(!a)throw Error(y(317));a:{a=a.nextSibling;for(b=0;a;){if(8===a.nodeType){var c=a.data;if("/$"===c){if(0===b){kh=rf(a.nextSibling);break a}b--}else"$"!==c&&"$!"!==c&&"$?"!==c||b++}a=a.nextSibling}kh=null}}else kh=jh?rf(a.stateNode.nextSibling):null;return!0}
function sh(){kh=jh=null;lh=!1}var th=[];function uh(){for(var a=0;a<th.length;a++)th[a]._workInProgressVersionPrimary=null;th.length=0}var vh=ra.ReactCurrentDispatcher,wh=ra.ReactCurrentBatchConfig,xh=0,R=null,S=null,T=null,yh=!1,zh=!1;function Ah(){throw Error(y(321));}function Bh(a,b){if(null===b)return!1;for(var c=0;c<b.length&&c<a.length;c++)if(!He(a[c],b[c]))return!1;return!0}
function Ch(a,b,c,d,e,f){xh=f;R=b;b.memoizedState=null;b.updateQueue=null;b.lanes=0;vh.current=null===a||null===a.memoizedState?Dh:Eh;a=c(d,e);if(zh){f=0;do{zh=!1;if(!(25>f))throw Error(y(301));f+=1;T=S=null;b.updateQueue=null;vh.current=Fh;a=c(d,e)}while(zh)}vh.current=Gh;b=null!==S&&null!==S.next;xh=0;T=S=R=null;yh=!1;if(b)throw Error(y(300));return a}function Hh(){var a={memoizedState:null,baseState:null,baseQueue:null,queue:null,next:null};null===T?R.memoizedState=T=a:T=T.next=a;return T}
function Ih(){if(null===S){var a=R.alternate;a=null!==a?a.memoizedState:null}else a=S.next;var b=null===T?R.memoizedState:T.next;if(null!==b)T=b,S=a;else{if(null===a)throw Error(y(310));S=a;a={memoizedState:S.memoizedState,baseState:S.baseState,baseQueue:S.baseQueue,queue:S.queue,next:null};null===T?R.memoizedState=T=a:T=T.next=a}return T}function Jh(a,b){return"function"===typeof b?b(a):b}
function Kh(a){var b=Ih(),c=b.queue;if(null===c)throw Error(y(311));c.lastRenderedReducer=a;var d=S,e=d.baseQueue,f=c.pending;if(null!==f){if(null!==e){var g=e.next;e.next=f.next;f.next=g}d.baseQueue=e=f;c.pending=null}if(null!==e){e=e.next;d=d.baseState;var h=g=f=null,k=e;do{var l=k.lane;if((xh&l)===l)null!==h&&(h=h.next={lane:0,action:k.action,eagerReducer:k.eagerReducer,eagerState:k.eagerState,next:null}),d=k.eagerReducer===a?k.eagerState:a(d,k.action);else{var n={lane:l,action:k.action,eagerReducer:k.eagerReducer,
eagerState:k.eagerState,next:null};null===h?(g=h=n,f=d):h=h.next=n;R.lanes|=l;Dg|=l}k=k.next}while(null!==k&&k!==e);null===h?f=d:h.next=g;He(d,b.memoizedState)||(ug=!0);b.memoizedState=d;b.baseState=f;b.baseQueue=h;c.lastRenderedState=d}return[b.memoizedState,c.dispatch]}
function Lh(a){var b=Ih(),c=b.queue;if(null===c)throw Error(y(311));c.lastRenderedReducer=a;var d=c.dispatch,e=c.pending,f=b.memoizedState;if(null!==e){c.pending=null;var g=e=e.next;do f=a(f,g.action),g=g.next;while(g!==e);He(f,b.memoizedState)||(ug=!0);b.memoizedState=f;null===b.baseQueue&&(b.baseState=f);c.lastRenderedState=f}return[f,d]}
function Mh(a,b,c){var d=b._getVersion;d=d(b._source);var e=b._workInProgressVersionPrimary;if(null!==e)a=e===d;else if(a=a.mutableReadLanes,a=(xh&a)===a)b._workInProgressVersionPrimary=d,th.push(b);if(a)return c(b._source);th.push(b);throw Error(y(350));}
function Nh(a,b,c,d){var e=U;if(null===e)throw Error(y(349));var f=b._getVersion,g=f(b._source),h=vh.current,k=h.useState(function(){return Mh(e,b,c)}),l=k[1],n=k[0];k=T;var A=a.memoizedState,p=A.refs,C=p.getSnapshot,x=A.source;A=A.subscribe;var w=R;a.memoizedState={refs:p,source:b,subscribe:d};h.useEffect(function(){p.getSnapshot=c;p.setSnapshot=l;var a=f(b._source);if(!He(g,a)){a=c(b._source);He(n,a)||(l(a),a=Ig(w),e.mutableReadLanes|=a&e.pendingLanes);a=e.mutableReadLanes;e.entangledLanes|=a;for(var d=
e.entanglements,h=a;0<h;){var k=31-Vc(h),v=1<<k;d[k]|=a;h&=~v}}},[c,b,d]);h.useEffect(function(){return d(b._source,function(){var a=p.getSnapshot,c=p.setSnapshot;try{c(a(b._source));var d=Ig(w);e.mutableReadLanes|=d&e.pendingLanes}catch(q){c(function(){throw q;})}})},[b,d]);He(C,c)&&He(x,b)&&He(A,d)||(a={pending:null,dispatch:null,lastRenderedReducer:Jh,lastRenderedState:n},a.dispatch=l=Oh.bind(null,R,a),k.queue=a,k.baseQueue=null,n=Mh(e,b,c),k.memoizedState=k.baseState=n);return n}
function Ph(a,b,c){var d=Ih();return Nh(d,a,b,c)}function Qh(a){var b=Hh();"function"===typeof a&&(a=a());b.memoizedState=b.baseState=a;a=b.queue={pending:null,dispatch:null,lastRenderedReducer:Jh,lastRenderedState:a};a=a.dispatch=Oh.bind(null,R,a);return[b.memoizedState,a]}
function Rh(a,b,c,d){a={tag:a,create:b,destroy:c,deps:d,next:null};b=R.updateQueue;null===b?(b={lastEffect:null},R.updateQueue=b,b.lastEffect=a.next=a):(c=b.lastEffect,null===c?b.lastEffect=a.next=a:(d=c.next,c.next=a,a.next=d,b.lastEffect=a));return a}function Sh(a){var b=Hh();a={current:a};return b.memoizedState=a}function Th(){return Ih().memoizedState}function Uh(a,b,c,d){var e=Hh();R.flags|=a;e.memoizedState=Rh(1|b,c,void 0,void 0===d?null:d)}
function Vh(a,b,c,d){var e=Ih();d=void 0===d?null:d;var f=void 0;if(null!==S){var g=S.memoizedState;f=g.destroy;if(null!==d&&Bh(d,g.deps)){Rh(b,c,f,d);return}}R.flags|=a;e.memoizedState=Rh(1|b,c,f,d)}function Wh(a,b){return Uh(516,4,a,b)}function Xh(a,b){return Vh(516,4,a,b)}function Yh(a,b){return Vh(4,2,a,b)}function Zh(a,b){if("function"===typeof b)return a=a(),b(a),function(){b(null)};if(null!==b&&void 0!==b)return a=a(),b.current=a,function(){b.current=null}}
function $h(a,b,c){c=null!==c&&void 0!==c?c.concat([a]):null;return Vh(4,2,Zh.bind(null,b,a),c)}function ai(){}function bi(a,b){var c=Ih();b=void 0===b?null:b;var d=c.memoizedState;if(null!==d&&null!==b&&Bh(b,d[1]))return d[0];c.memoizedState=[a,b];return a}function ci(a,b){var c=Ih();b=void 0===b?null:b;var d=c.memoizedState;if(null!==d&&null!==b&&Bh(b,d[1]))return d[0];a=a();c.memoizedState=[a,b];return a}
function di(a,b){var c=eg();gg(98>c?98:c,function(){a(!0)});gg(97<c?97:c,function(){var c=wh.transition;wh.transition=1;try{a(!1),b()}finally{wh.transition=c}})}
function Oh(a,b,c){var d=Hg(),e=Ig(a),f={lane:e,action:c,eagerReducer:null,eagerState:null,next:null},g=b.pending;null===g?f.next=f:(f.next=g.next,g.next=f);b.pending=f;g=a.alternate;if(a===R||null!==g&&g===R)zh=yh=!0;else{if(0===a.lanes&&(null===g||0===g.lanes)&&(g=b.lastRenderedReducer,null!==g))try{var h=b.lastRenderedState,k=g(h,c);f.eagerReducer=g;f.eagerState=k;if(He(k,h))return}catch(l){}finally{}Jg(a,e,d)}}
var Gh={readContext:vg,useCallback:Ah,useContext:Ah,useEffect:Ah,useImperativeHandle:Ah,useLayoutEffect:Ah,useMemo:Ah,useReducer:Ah,useRef:Ah,useState:Ah,useDebugValue:Ah,useDeferredValue:Ah,useTransition:Ah,useMutableSource:Ah,useOpaqueIdentifier:Ah,unstable_isNewReconciler:!1},Dh={readContext:vg,useCallback:function(a,b){Hh().memoizedState=[a,void 0===b?null:b];return a},useContext:vg,useEffect:Wh,useImperativeHandle:function(a,b,c){c=null!==c&&void 0!==c?c.concat([a]):null;return Uh(4,2,Zh.bind(null,
b,a),c)},useLayoutEffect:function(a,b){return Uh(4,2,a,b)},useMemo:function(a,b){var c=Hh();b=void 0===b?null:b;a=a();c.memoizedState=[a,b];return a},useReducer:function(a,b,c){var d=Hh();b=void 0!==c?c(b):b;d.memoizedState=d.baseState=b;a=d.queue={pending:null,dispatch:null,lastRenderedReducer:a,lastRenderedState:b};a=a.dispatch=Oh.bind(null,R,a);return[d.memoizedState,a]},useRef:Sh,useState:Qh,useDebugValue:ai,useDeferredValue:function(a){var b=Qh(a),c=b[0],d=b[1];Wh(function(){var b=wh.transition;
wh.transition=1;try{d(a)}finally{wh.transition=b}},[a]);return c},useTransition:function(){var a=Qh(!1),b=a[0];a=di.bind(null,a[1]);Sh(a);return[a,b]},useMutableSource:function(a,b,c){var d=Hh();d.memoizedState={refs:{getSnapshot:b,setSnapshot:null},source:a,subscribe:c};return Nh(d,a,b,c)},useOpaqueIdentifier:function(){if(lh){var a=!1,b=uf(function(){a||(a=!0,c("r:"+(tf++).toString(36)));throw Error(y(355));}),c=Qh(b)[1];0===(R.mode&2)&&(R.flags|=516,Rh(5,function(){c("r:"+(tf++).toString(36))},
void 0,null));return b}b="r:"+(tf++).toString(36);Qh(b);return b},unstable_isNewReconciler:!1},Eh={readContext:vg,useCallback:bi,useContext:vg,useEffect:Xh,useImperativeHandle:$h,useLayoutEffect:Yh,useMemo:ci,useReducer:Kh,useRef:Th,useState:function(){return Kh(Jh)},useDebugValue:ai,useDeferredValue:function(a){var b=Kh(Jh),c=b[0],d=b[1];Xh(function(){var b=wh.transition;wh.transition=1;try{d(a)}finally{wh.transition=b}},[a]);return c},useTransition:function(){var a=Kh(Jh)[0];return[Th().current,
a]},useMutableSource:Ph,useOpaqueIdentifier:function(){return Kh(Jh)[0]},unstable_isNewReconciler:!1},Fh={readContext:vg,useCallback:bi,useContext:vg,useEffect:Xh,useImperativeHandle:$h,useLayoutEffect:Yh,useMemo:ci,useReducer:Lh,useRef:Th,useState:function(){return Lh(Jh)},useDebugValue:ai,useDeferredValue:function(a){var b=Lh(Jh),c=b[0],d=b[1];Xh(function(){var b=wh.transition;wh.transition=1;try{d(a)}finally{wh.transition=b}},[a]);return c},useTransition:function(){var a=Lh(Jh)[0];return[Th().current,
a]},useMutableSource:Ph,useOpaqueIdentifier:function(){return Lh(Jh)[0]},unstable_isNewReconciler:!1},ei=ra.ReactCurrentOwner,ug=!1;function fi(a,b,c,d){b.child=null===a?Zg(b,null,c,d):Yg(b,a.child,c,d)}function gi(a,b,c,d,e){c=c.render;var f=b.ref;tg(b,e);d=Ch(a,b,c,d,f,e);if(null!==a&&!ug)return b.updateQueue=a.updateQueue,b.flags&=-517,a.lanes&=~e,hi(a,b,e);b.flags|=1;fi(a,b,d,e);return b.child}
function ii(a,b,c,d,e,f){if(null===a){var g=c.type;if("function"===typeof g&&!ji(g)&&void 0===g.defaultProps&&null===c.compare&&void 0===c.defaultProps)return b.tag=15,b.type=g,ki(a,b,g,d,e,f);a=Vg(c.type,null,d,b,b.mode,f);a.ref=b.ref;a.return=b;return b.child=a}g=a.child;if(0===(e&f)&&(e=g.memoizedProps,c=c.compare,c=null!==c?c:Je,c(e,d)&&a.ref===b.ref))return hi(a,b,f);b.flags|=1;a=Tg(g,d);a.ref=b.ref;a.return=b;return b.child=a}
function ki(a,b,c,d,e,f){if(null!==a&&Je(a.memoizedProps,d)&&a.ref===b.ref)if(ug=!1,0!==(f&e))0!==(a.flags&16384)&&(ug=!0);else return b.lanes=a.lanes,hi(a,b,f);return li(a,b,c,d,f)}
function mi(a,b,c){var d=b.pendingProps,e=d.children,f=null!==a?a.memoizedState:null;if("hidden"===d.mode||"unstable-defer-without-hiding"===d.mode)if(0===(b.mode&4))b.memoizedState={baseLanes:0},ni(b,c);else if(0!==(c&1073741824))b.memoizedState={baseLanes:0},ni(b,null!==f?f.baseLanes:c);else return a=null!==f?f.baseLanes|c:c,b.lanes=b.childLanes=1073741824,b.memoizedState={baseLanes:a},ni(b,a),null;else null!==f?(d=f.baseLanes|c,b.memoizedState=null):d=c,ni(b,d);fi(a,b,e,c);return b.child}
function oi(a,b){var c=b.ref;if(null===a&&null!==c||null!==a&&a.ref!==c)b.flags|=128}function li(a,b,c,d,e){var f=Ff(c)?Df:M.current;f=Ef(b,f);tg(b,e);c=Ch(a,b,c,d,f,e);if(null!==a&&!ug)return b.updateQueue=a.updateQueue,b.flags&=-517,a.lanes&=~e,hi(a,b,e);b.flags|=1;fi(a,b,c,e);return b.child}
function pi(a,b,c,d,e){if(Ff(c)){var f=!0;Jf(b)}else f=!1;tg(b,e);if(null===b.stateNode)null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2),Mg(b,c,d),Og(b,c,d,e),d=!0;else if(null===a){var g=b.stateNode,h=b.memoizedProps;g.props=h;var k=g.context,l=c.contextType;"object"===typeof l&&null!==l?l=vg(l):(l=Ff(c)?Df:M.current,l=Ef(b,l));var n=c.getDerivedStateFromProps,A="function"===typeof n||"function"===typeof g.getSnapshotBeforeUpdate;A||"function"!==typeof g.UNSAFE_componentWillReceiveProps&&
"function"!==typeof g.componentWillReceiveProps||(h!==d||k!==l)&&Ng(b,g,d,l);wg=!1;var p=b.memoizedState;g.state=p;Cg(b,d,g,e);k=b.memoizedState;h!==d||p!==k||N.current||wg?("function"===typeof n&&(Gg(b,c,n,d),k=b.memoizedState),(h=wg||Lg(b,c,h,d,p,k,l))?(A||"function"!==typeof g.UNSAFE_componentWillMount&&"function"!==typeof g.componentWillMount||("function"===typeof g.componentWillMount&&g.componentWillMount(),"function"===typeof g.UNSAFE_componentWillMount&&g.UNSAFE_componentWillMount()),"function"===
typeof g.componentDidMount&&(b.flags|=4)):("function"===typeof g.componentDidMount&&(b.flags|=4),b.memoizedProps=d,b.memoizedState=k),g.props=d,g.state=k,g.context=l,d=h):("function"===typeof g.componentDidMount&&(b.flags|=4),d=!1)}else{g=b.stateNode;yg(a,b);h=b.memoizedProps;l=b.type===b.elementType?h:lg(b.type,h);g.props=l;A=b.pendingProps;p=g.context;k=c.contextType;"object"===typeof k&&null!==k?k=vg(k):(k=Ff(c)?Df:M.current,k=Ef(b,k));var C=c.getDerivedStateFromProps;(n="function"===typeof C||
"function"===typeof g.getSnapshotBeforeUpdate)||"function"!==typeof g.UNSAFE_componentWillReceiveProps&&"function"!==typeof g.componentWillReceiveProps||(h!==A||p!==k)&&Ng(b,g,d,k);wg=!1;p=b.memoizedState;g.state=p;Cg(b,d,g,e);var x=b.memoizedState;h!==A||p!==x||N.current||wg?("function"===typeof C&&(Gg(b,c,C,d),x=b.memoizedState),(l=wg||Lg(b,c,l,d,p,x,k))?(n||"function"!==typeof g.UNSAFE_componentWillUpdate&&"function"!==typeof g.componentWillUpdate||("function"===typeof g.componentWillUpdate&&g.componentWillUpdate(d,
x,k),"function"===typeof g.UNSAFE_componentWillUpdate&&g.UNSAFE_componentWillUpdate(d,x,k)),"function"===typeof g.componentDidUpdate&&(b.flags|=4),"function"===typeof g.getSnapshotBeforeUpdate&&(b.flags|=256)):("function"!==typeof g.componentDidUpdate||h===a.memoizedProps&&p===a.memoizedState||(b.flags|=4),"function"!==typeof g.getSnapshotBeforeUpdate||h===a.memoizedProps&&p===a.memoizedState||(b.flags|=256),b.memoizedProps=d,b.memoizedState=x),g.props=d,g.state=x,g.context=k,d=l):("function"!==typeof g.componentDidUpdate||
h===a.memoizedProps&&p===a.memoizedState||(b.flags|=4),"function"!==typeof g.getSnapshotBeforeUpdate||h===a.memoizedProps&&p===a.memoizedState||(b.flags|=256),d=!1)}return qi(a,b,c,d,f,e)}
function qi(a,b,c,d,e,f){oi(a,b);var g=0!==(b.flags&64);if(!d&&!g)return e&&Kf(b,c,!1),hi(a,b,f);d=b.stateNode;ei.current=b;var h=g&&"function"!==typeof c.getDerivedStateFromError?null:d.render();b.flags|=1;null!==a&&g?(b.child=Yg(b,a.child,null,f),b.child=Yg(b,null,h,f)):fi(a,b,h,f);b.memoizedState=d.state;e&&Kf(b,c,!0);return b.child}function ri(a){var b=a.stateNode;b.pendingContext?Hf(a,b.pendingContext,b.pendingContext!==b.context):b.context&&Hf(a,b.context,!1);eh(a,b.containerInfo)}
var si={dehydrated:null,retryLane:0};
function ti(a,b,c){var d=b.pendingProps,e=P.current,f=!1,g;(g=0!==(b.flags&64))||(g=null!==a&&null===a.memoizedState?!1:0!==(e&2));g?(f=!0,b.flags&=-65):null!==a&&null===a.memoizedState||void 0===d.fallback||!0===d.unstable_avoidThisFallback||(e|=1);I(P,e&1);if(null===a){void 0!==d.fallback&&ph(b);a=d.children;e=d.fallback;if(f)return a=ui(b,a,e,c),b.child.memoizedState={baseLanes:c},b.memoizedState=si,a;if("number"===typeof d.unstable_expectedLoadTime)return a=ui(b,a,e,c),b.child.memoizedState={baseLanes:c},
b.memoizedState=si,b.lanes=33554432,a;c=vi({mode:"visible",children:a},b.mode,c,null);c.return=b;return b.child=c}if(null!==a.memoizedState){if(f)return d=wi(a,b,d.children,d.fallback,c),f=b.child,e=a.child.memoizedState,f.memoizedState=null===e?{baseLanes:c}:{baseLanes:e.baseLanes|c},f.childLanes=a.childLanes&~c,b.memoizedState=si,d;c=xi(a,b,d.children,c);b.memoizedState=null;return c}if(f)return d=wi(a,b,d.children,d.fallback,c),f=b.child,e=a.child.memoizedState,f.memoizedState=null===e?{baseLanes:c}:
{baseLanes:e.baseLanes|c},f.childLanes=a.childLanes&~c,b.memoizedState=si,d;c=xi(a,b,d.children,c);b.memoizedState=null;return c}function ui(a,b,c,d){var e=a.mode,f=a.child;b={mode:"hidden",children:b};0===(e&2)&&null!==f?(f.childLanes=0,f.pendingProps=b):f=vi(b,e,0,null);c=Xg(c,e,d,null);f.return=a;c.return=a;f.sibling=c;a.child=f;return c}
function xi(a,b,c,d){var e=a.child;a=e.sibling;c=Tg(e,{mode:"visible",children:c});0===(b.mode&2)&&(c.lanes=d);c.return=b;c.sibling=null;null!==a&&(a.nextEffect=null,a.flags=8,b.firstEffect=b.lastEffect=a);return b.child=c}
function wi(a,b,c,d,e){var f=b.mode,g=a.child;a=g.sibling;var h={mode:"hidden",children:c};0===(f&2)&&b.child!==g?(c=b.child,c.childLanes=0,c.pendingProps=h,g=c.lastEffect,null!==g?(b.firstEffect=c.firstEffect,b.lastEffect=g,g.nextEffect=null):b.firstEffect=b.lastEffect=null):c=Tg(g,h);null!==a?d=Tg(a,d):(d=Xg(d,f,e,null),d.flags|=2);d.return=b;c.return=b;c.sibling=d;b.child=c;return d}function yi(a,b){a.lanes|=b;var c=a.alternate;null!==c&&(c.lanes|=b);sg(a.return,b)}
function zi(a,b,c,d,e,f){var g=a.memoizedState;null===g?a.memoizedState={isBackwards:b,rendering:null,renderingStartTime:0,last:d,tail:c,tailMode:e,lastEffect:f}:(g.isBackwards=b,g.rendering=null,g.renderingStartTime=0,g.last=d,g.tail=c,g.tailMode=e,g.lastEffect=f)}
function Ai(a,b,c){var d=b.pendingProps,e=d.revealOrder,f=d.tail;fi(a,b,d.children,c);d=P.current;if(0!==(d&2))d=d&1|2,b.flags|=64;else{if(null!==a&&0!==(a.flags&64))a:for(a=b.child;null!==a;){if(13===a.tag)null!==a.memoizedState&&yi(a,c);else if(19===a.tag)yi(a,c);else if(null!==a.child){a.child.return=a;a=a.child;continue}if(a===b)break a;for(;null===a.sibling;){if(null===a.return||a.return===b)break a;a=a.return}a.sibling.return=a.return;a=a.sibling}d&=1}I(P,d);if(0===(b.mode&2))b.memoizedState=
null;else switch(e){case "forwards":c=b.child;for(e=null;null!==c;)a=c.alternate,null!==a&&null===ih(a)&&(e=c),c=c.sibling;c=e;null===c?(e=b.child,b.child=null):(e=c.sibling,c.sibling=null);zi(b,!1,e,c,f,b.lastEffect);break;case "backwards":c=null;e=b.child;for(b.child=null;null!==e;){a=e.alternate;if(null!==a&&null===ih(a)){b.child=e;break}a=e.sibling;e.sibling=c;c=e;e=a}zi(b,!0,c,null,f,b.lastEffect);break;case "together":zi(b,!1,null,null,void 0,b.lastEffect);break;default:b.memoizedState=null}return b.child}
function hi(a,b,c){null!==a&&(b.dependencies=a.dependencies);Dg|=b.lanes;if(0!==(c&b.childLanes)){if(null!==a&&b.child!==a.child)throw Error(y(153));if(null!==b.child){a=b.child;c=Tg(a,a.pendingProps);b.child=c;for(c.return=b;null!==a.sibling;)a=a.sibling,c=c.sibling=Tg(a,a.pendingProps),c.return=b;c.sibling=null}return b.child}return null}var Bi,Ci,Di,Ei;
Bi=function(a,b){for(var c=b.child;null!==c;){if(5===c.tag||6===c.tag)a.appendChild(c.stateNode);else if(4!==c.tag&&null!==c.child){c.child.return=c;c=c.child;continue}if(c===b)break;for(;null===c.sibling;){if(null===c.return||c.return===b)return;c=c.return}c.sibling.return=c.return;c=c.sibling}};Ci=function(){};
Di=function(a,b,c,d){var e=a.memoizedProps;if(e!==d){a=b.stateNode;dh(ah.current);var f=null;switch(c){case "input":e=Ya(a,e);d=Ya(a,d);f=[];break;case "option":e=eb(a,e);d=eb(a,d);f=[];break;case "select":e=m({},e,{value:void 0});d=m({},d,{value:void 0});f=[];break;case "textarea":e=gb(a,e);d=gb(a,d);f=[];break;default:"function"!==typeof e.onClick&&"function"===typeof d.onClick&&(a.onclick=jf)}vb(c,d);var g;c=null;for(l in e)if(!d.hasOwnProperty(l)&&e.hasOwnProperty(l)&&null!=e[l])if("style"===
l){var h=e[l];for(g in h)h.hasOwnProperty(g)&&(c||(c={}),c[g]="")}else"dangerouslySetInnerHTML"!==l&&"children"!==l&&"suppressContentEditableWarning"!==l&&"suppressHydrationWarning"!==l&&"autoFocus"!==l&&(ca.hasOwnProperty(l)?f||(f=[]):(f=f||[]).push(l,null));for(l in d){var k=d[l];h=null!=e?e[l]:void 0;if(d.hasOwnProperty(l)&&k!==h&&(null!=k||null!=h))if("style"===l)if(h){for(g in h)!h.hasOwnProperty(g)||k&&k.hasOwnProperty(g)||(c||(c={}),c[g]="");for(g in k)k.hasOwnProperty(g)&&h[g]!==k[g]&&(c||
(c={}),c[g]=k[g])}else c||(f||(f=[]),f.push(l,c)),c=k;else"dangerouslySetInnerHTML"===l?(k=k?k.__html:void 0,h=h?h.__html:void 0,null!=k&&h!==k&&(f=f||[]).push(l,k)):"children"===l?"string"!==typeof k&&"number"!==typeof k||(f=f||[]).push(l,""+k):"suppressContentEditableWarning"!==l&&"suppressHydrationWarning"!==l&&(ca.hasOwnProperty(l)?(null!=k&&"onScroll"===l&&G("scroll",a),f||h===k||(f=[])):"object"===typeof k&&null!==k&&k.$$typeof===Ga?k.toString():(f=f||[]).push(l,k))}c&&(f=f||[]).push("style",
c);var l=f;if(b.updateQueue=l)b.flags|=4}};Ei=function(a,b,c,d){c!==d&&(b.flags|=4)};function Fi(a,b){if(!lh)switch(a.tailMode){case "hidden":b=a.tail;for(var c=null;null!==b;)null!==b.alternate&&(c=b),b=b.sibling;null===c?a.tail=null:c.sibling=null;break;case "collapsed":c=a.tail;for(var d=null;null!==c;)null!==c.alternate&&(d=c),c=c.sibling;null===d?b||null===a.tail?a.tail=null:a.tail.sibling=null:d.sibling=null}}
function Gi(a,b,c){var d=b.pendingProps;switch(b.tag){case 2:case 16:case 15:case 0:case 11:case 7:case 8:case 12:case 9:case 14:return null;case 1:return Ff(b.type)&&Gf(),null;case 3:fh();H(N);H(M);uh();d=b.stateNode;d.pendingContext&&(d.context=d.pendingContext,d.pendingContext=null);if(null===a||null===a.child)rh(b)?b.flags|=4:d.hydrate||(b.flags|=256);Ci(b);return null;case 5:hh(b);var e=dh(ch.current);c=b.type;if(null!==a&&null!=b.stateNode)Di(a,b,c,d,e),a.ref!==b.ref&&(b.flags|=128);else{if(!d){if(null===
b.stateNode)throw Error(y(166));return null}a=dh(ah.current);if(rh(b)){d=b.stateNode;c=b.type;var f=b.memoizedProps;d[wf]=b;d[xf]=f;switch(c){case "dialog":G("cancel",d);G("close",d);break;case "iframe":case "object":case "embed":G("load",d);break;case "video":case "audio":for(a=0;a<Xe.length;a++)G(Xe[a],d);break;case "source":G("error",d);break;case "img":case "image":case "link":G("error",d);G("load",d);break;case "details":G("toggle",d);break;case "input":Za(d,f);G("invalid",d);break;case "select":d._wrapperState=
{wasMultiple:!!f.multiple};G("invalid",d);break;case "textarea":hb(d,f),G("invalid",d)}vb(c,f);a=null;for(var g in f)f.hasOwnProperty(g)&&(e=f[g],"children"===g?"string"===typeof e?d.textContent!==e&&(a=["children",e]):"number"===typeof e&&d.textContent!==""+e&&(a=["children",""+e]):ca.hasOwnProperty(g)&&null!=e&&"onScroll"===g&&G("scroll",d));switch(c){case "input":Va(d);cb(d,f,!0);break;case "textarea":Va(d);jb(d);break;case "select":case "option":break;default:"function"===typeof f.onClick&&(d.onclick=
jf)}d=a;b.updateQueue=d;null!==d&&(b.flags|=4)}else{g=9===e.nodeType?e:e.ownerDocument;a===kb.html&&(a=lb(c));a===kb.html?"script"===c?(a=g.createElement("div"),a.innerHTML="<script>\x3c/script>",a=a.removeChild(a.firstChild)):"string"===typeof d.is?a=g.createElement(c,{is:d.is}):(a=g.createElement(c),"select"===c&&(g=a,d.multiple?g.multiple=!0:d.size&&(g.size=d.size))):a=g.createElementNS(a,c);a[wf]=b;a[xf]=d;Bi(a,b,!1,!1);b.stateNode=a;g=wb(c,d);switch(c){case "dialog":G("cancel",a);G("close",a);
e=d;break;case "iframe":case "object":case "embed":G("load",a);e=d;break;case "video":case "audio":for(e=0;e<Xe.length;e++)G(Xe[e],a);e=d;break;case "source":G("error",a);e=d;break;case "img":case "image":case "link":G("error",a);G("load",a);e=d;break;case "details":G("toggle",a);e=d;break;case "input":Za(a,d);e=Ya(a,d);G("invalid",a);break;case "option":e=eb(a,d);break;case "select":a._wrapperState={wasMultiple:!!d.multiple};e=m({},d,{value:void 0});G("invalid",a);break;case "textarea":hb(a,d);e=
gb(a,d);G("invalid",a);break;default:e=d}vb(c,e);var h=e;for(f in h)if(h.hasOwnProperty(f)){var k=h[f];"style"===f?tb(a,k):"dangerouslySetInnerHTML"===f?(k=k?k.__html:void 0,null!=k&&ob(a,k)):"children"===f?"string"===typeof k?("textarea"!==c||""!==k)&&pb(a,k):"number"===typeof k&&pb(a,""+k):"suppressContentEditableWarning"!==f&&"suppressHydrationWarning"!==f&&"autoFocus"!==f&&(ca.hasOwnProperty(f)?null!=k&&"onScroll"===f&&G("scroll",a):null!=k&&qa(a,f,k,g))}switch(c){case "input":Va(a);cb(a,d,!1);
break;case "textarea":Va(a);jb(a);break;case "option":null!=d.value&&a.setAttribute("value",""+Sa(d.value));break;case "select":a.multiple=!!d.multiple;f=d.value;null!=f?fb(a,!!d.multiple,f,!1):null!=d.defaultValue&&fb(a,!!d.multiple,d.defaultValue,!0);break;default:"function"===typeof e.onClick&&(a.onclick=jf)}mf(c,d)&&(b.flags|=4)}null!==b.ref&&(b.flags|=128)}return null;case 6:if(a&&null!=b.stateNode)Ei(a,b,a.memoizedProps,d);else{if("string"!==typeof d&&null===b.stateNode)throw Error(y(166));
c=dh(ch.current);dh(ah.current);rh(b)?(d=b.stateNode,c=b.memoizedProps,d[wf]=b,d.nodeValue!==c&&(b.flags|=4)):(d=(9===c.nodeType?c:c.ownerDocument).createTextNode(d),d[wf]=b,b.stateNode=d)}return null;case 13:H(P);d=b.memoizedState;if(0!==(b.flags&64))return b.lanes=c,b;d=null!==d;c=!1;null===a?void 0!==b.memoizedProps.fallback&&rh(b):c=null!==a.memoizedState;if(d&&!c&&0!==(b.mode&2))if(null===a&&!0!==b.memoizedProps.unstable_avoidThisFallback||0!==(P.current&1))0===V&&(V=3);else{if(0===V||3===V)V=
4;null===U||0===(Dg&134217727)&&0===(Hi&134217727)||Ii(U,W)}if(d||c)b.flags|=4;return null;case 4:return fh(),Ci(b),null===a&&cf(b.stateNode.containerInfo),null;case 10:return rg(b),null;case 17:return Ff(b.type)&&Gf(),null;case 19:H(P);d=b.memoizedState;if(null===d)return null;f=0!==(b.flags&64);g=d.rendering;if(null===g)if(f)Fi(d,!1);else{if(0!==V||null!==a&&0!==(a.flags&64))for(a=b.child;null!==a;){g=ih(a);if(null!==g){b.flags|=64;Fi(d,!1);f=g.updateQueue;null!==f&&(b.updateQueue=f,b.flags|=4);
null===d.lastEffect&&(b.firstEffect=null);b.lastEffect=d.lastEffect;d=c;for(c=b.child;null!==c;)f=c,a=d,f.flags&=2,f.nextEffect=null,f.firstEffect=null,f.lastEffect=null,g=f.alternate,null===g?(f.childLanes=0,f.lanes=a,f.child=null,f.memoizedProps=null,f.memoizedState=null,f.updateQueue=null,f.dependencies=null,f.stateNode=null):(f.childLanes=g.childLanes,f.lanes=g.lanes,f.child=g.child,f.memoizedProps=g.memoizedProps,f.memoizedState=g.memoizedState,f.updateQueue=g.updateQueue,f.type=g.type,a=g.dependencies,
f.dependencies=null===a?null:{lanes:a.lanes,firstContext:a.firstContext}),c=c.sibling;I(P,P.current&1|2);return b.child}a=a.sibling}null!==d.tail&&O()>Ji&&(b.flags|=64,f=!0,Fi(d,!1),b.lanes=33554432)}else{if(!f)if(a=ih(g),null!==a){if(b.flags|=64,f=!0,c=a.updateQueue,null!==c&&(b.updateQueue=c,b.flags|=4),Fi(d,!0),null===d.tail&&"hidden"===d.tailMode&&!g.alternate&&!lh)return b=b.lastEffect=d.lastEffect,null!==b&&(b.nextEffect=null),null}else 2*O()-d.renderingStartTime>Ji&&1073741824!==c&&(b.flags|=
64,f=!0,Fi(d,!1),b.lanes=33554432);d.isBackwards?(g.sibling=b.child,b.child=g):(c=d.last,null!==c?c.sibling=g:b.child=g,d.last=g)}return null!==d.tail?(c=d.tail,d.rendering=c,d.tail=c.sibling,d.lastEffect=b.lastEffect,d.renderingStartTime=O(),c.sibling=null,b=P.current,I(P,f?b&1|2:b&1),c):null;case 23:case 24:return Ki(),null!==a&&null!==a.memoizedState!==(null!==b.memoizedState)&&"unstable-defer-without-hiding"!==d.mode&&(b.flags|=4),null}throw Error(y(156,b.tag));}
function Li(a){switch(a.tag){case 1:Ff(a.type)&&Gf();var b=a.flags;return b&4096?(a.flags=b&-4097|64,a):null;case 3:fh();H(N);H(M);uh();b=a.flags;if(0!==(b&64))throw Error(y(285));a.flags=b&-4097|64;return a;case 5:return hh(a),null;case 13:return H(P),b=a.flags,b&4096?(a.flags=b&-4097|64,a):null;case 19:return H(P),null;case 4:return fh(),null;case 10:return rg(a),null;case 23:case 24:return Ki(),null;default:return null}}
function Mi(a,b){try{var c="",d=b;do c+=Qa(d),d=d.return;while(d);var e=c}catch(f){e="\nError generating stack: "+f.message+"\n"+f.stack}return{value:a,source:b,stack:e}}function Ni(a,b){try{console.error(b.value)}catch(c){setTimeout(function(){throw c;})}}var Oi="function"===typeof WeakMap?WeakMap:Map;function Pi(a,b,c){c=zg(-1,c);c.tag=3;c.payload={element:null};var d=b.value;c.callback=function(){Qi||(Qi=!0,Ri=d);Ni(a,b)};return c}
function Si(a,b,c){c=zg(-1,c);c.tag=3;var d=a.type.getDerivedStateFromError;if("function"===typeof d){var e=b.value;c.payload=function(){Ni(a,b);return d(e)}}var f=a.stateNode;null!==f&&"function"===typeof f.componentDidCatch&&(c.callback=function(){"function"!==typeof d&&(null===Ti?Ti=new Set([this]):Ti.add(this),Ni(a,b));var c=b.stack;this.componentDidCatch(b.value,{componentStack:null!==c?c:""})});return c}var Ui="function"===typeof WeakSet?WeakSet:Set;
function Vi(a){var b=a.ref;if(null!==b)if("function"===typeof b)try{b(null)}catch(c){Wi(a,c)}else b.current=null}function Xi(a,b){switch(b.tag){case 0:case 11:case 15:case 22:return;case 1:if(b.flags&256&&null!==a){var c=a.memoizedProps,d=a.memoizedState;a=b.stateNode;b=a.getSnapshotBeforeUpdate(b.elementType===b.type?c:lg(b.type,c),d);a.__reactInternalSnapshotBeforeUpdate=b}return;case 3:b.flags&256&&qf(b.stateNode.containerInfo);return;case 5:case 6:case 4:case 17:return}throw Error(y(163));}
function Yi(a,b,c){switch(c.tag){case 0:case 11:case 15:case 22:b=c.updateQueue;b=null!==b?b.lastEffect:null;if(null!==b){a=b=b.next;do{if(3===(a.tag&3)){var d=a.create;a.destroy=d()}a=a.next}while(a!==b)}b=c.updateQueue;b=null!==b?b.lastEffect:null;if(null!==b){a=b=b.next;do{var e=a;d=e.next;e=e.tag;0!==(e&4)&&0!==(e&1)&&(Zi(c,a),$i(c,a));a=d}while(a!==b)}return;case 1:a=c.stateNode;c.flags&4&&(null===b?a.componentDidMount():(d=c.elementType===c.type?b.memoizedProps:lg(c.type,b.memoizedProps),a.componentDidUpdate(d,
b.memoizedState,a.__reactInternalSnapshotBeforeUpdate)));b=c.updateQueue;null!==b&&Eg(c,b,a);return;case 3:b=c.updateQueue;if(null!==b){a=null;if(null!==c.child)switch(c.child.tag){case 5:a=c.child.stateNode;break;case 1:a=c.child.stateNode}Eg(c,b,a)}return;case 5:a=c.stateNode;null===b&&c.flags&4&&mf(c.type,c.memoizedProps)&&a.focus();return;case 6:return;case 4:return;case 12:return;case 13:null===c.memoizedState&&(c=c.alternate,null!==c&&(c=c.memoizedState,null!==c&&(c=c.dehydrated,null!==c&&Cc(c))));
return;case 19:case 17:case 20:case 21:case 23:case 24:return}throw Error(y(163));}
function aj(a,b){for(var c=a;;){if(5===c.tag){var d=c.stateNode;if(b)d=d.style,"function"===typeof d.setProperty?d.setProperty("display","none","important"):d.display="none";else{d=c.stateNode;var e=c.memoizedProps.style;e=void 0!==e&&null!==e&&e.hasOwnProperty("display")?e.display:null;d.style.display=sb("display",e)}}else if(6===c.tag)c.stateNode.nodeValue=b?"":c.memoizedProps;else if((23!==c.tag&&24!==c.tag||null===c.memoizedState||c===a)&&null!==c.child){c.child.return=c;c=c.child;continue}if(c===
a)break;for(;null===c.sibling;){if(null===c.return||c.return===a)return;c=c.return}c.sibling.return=c.return;c=c.sibling}}
function bj(a,b){if(Mf&&"function"===typeof Mf.onCommitFiberUnmount)try{Mf.onCommitFiberUnmount(Lf,b)}catch(f){}switch(b.tag){case 0:case 11:case 14:case 15:case 22:a=b.updateQueue;if(null!==a&&(a=a.lastEffect,null!==a)){var c=a=a.next;do{var d=c,e=d.destroy;d=d.tag;if(void 0!==e)if(0!==(d&4))Zi(b,c);else{d=b;try{e()}catch(f){Wi(d,f)}}c=c.next}while(c!==a)}break;case 1:Vi(b);a=b.stateNode;if("function"===typeof a.componentWillUnmount)try{a.props=b.memoizedProps,a.state=b.memoizedState,a.componentWillUnmount()}catch(f){Wi(b,
f)}break;case 5:Vi(b);break;case 4:cj(a,b)}}function dj(a){a.alternate=null;a.child=null;a.dependencies=null;a.firstEffect=null;a.lastEffect=null;a.memoizedProps=null;a.memoizedState=null;a.pendingProps=null;a.return=null;a.updateQueue=null}function ej(a){return 5===a.tag||3===a.tag||4===a.tag}
function fj(a){a:{for(var b=a.return;null!==b;){if(ej(b))break a;b=b.return}throw Error(y(160));}var c=b;b=c.stateNode;switch(c.tag){case 5:var d=!1;break;case 3:b=b.containerInfo;d=!0;break;case 4:b=b.containerInfo;d=!0;break;default:throw Error(y(161));}c.flags&16&&(pb(b,""),c.flags&=-17);a:b:for(c=a;;){for(;null===c.sibling;){if(null===c.return||ej(c.return)){c=null;break a}c=c.return}c.sibling.return=c.return;for(c=c.sibling;5!==c.tag&&6!==c.tag&&18!==c.tag;){if(c.flags&2)continue b;if(null===
c.child||4===c.tag)continue b;else c.child.return=c,c=c.child}if(!(c.flags&2)){c=c.stateNode;break a}}d?gj(a,c,b):hj(a,c,b)}
function gj(a,b,c){var d=a.tag,e=5===d||6===d;if(e)a=e?a.stateNode:a.stateNode.instance,b?8===c.nodeType?c.parentNode.insertBefore(a,b):c.insertBefore(a,b):(8===c.nodeType?(b=c.parentNode,b.insertBefore(a,c)):(b=c,b.appendChild(a)),c=c._reactRootContainer,null!==c&&void 0!==c||null!==b.onclick||(b.onclick=jf));else if(4!==d&&(a=a.child,null!==a))for(gj(a,b,c),a=a.sibling;null!==a;)gj(a,b,c),a=a.sibling}
function hj(a,b,c){var d=a.tag,e=5===d||6===d;if(e)a=e?a.stateNode:a.stateNode.instance,b?c.insertBefore(a,b):c.appendChild(a);else if(4!==d&&(a=a.child,null!==a))for(hj(a,b,c),a=a.sibling;null!==a;)hj(a,b,c),a=a.sibling}
function cj(a,b){for(var c=b,d=!1,e,f;;){if(!d){d=c.return;a:for(;;){if(null===d)throw Error(y(160));e=d.stateNode;switch(d.tag){case 5:f=!1;break a;case 3:e=e.containerInfo;f=!0;break a;case 4:e=e.containerInfo;f=!0;break a}d=d.return}d=!0}if(5===c.tag||6===c.tag){a:for(var g=a,h=c,k=h;;)if(bj(g,k),null!==k.child&&4!==k.tag)k.child.return=k,k=k.child;else{if(k===h)break a;for(;null===k.sibling;){if(null===k.return||k.return===h)break a;k=k.return}k.sibling.return=k.return;k=k.sibling}f?(g=e,h=c.stateNode,
8===g.nodeType?g.parentNode.removeChild(h):g.removeChild(h)):e.removeChild(c.stateNode)}else if(4===c.tag){if(null!==c.child){e=c.stateNode.containerInfo;f=!0;c.child.return=c;c=c.child;continue}}else if(bj(a,c),null!==c.child){c.child.return=c;c=c.child;continue}if(c===b)break;for(;null===c.sibling;){if(null===c.return||c.return===b)return;c=c.return;4===c.tag&&(d=!1)}c.sibling.return=c.return;c=c.sibling}}
function ij(a,b){switch(b.tag){case 0:case 11:case 14:case 15:case 22:var c=b.updateQueue;c=null!==c?c.lastEffect:null;if(null!==c){var d=c=c.next;do 3===(d.tag&3)&&(a=d.destroy,d.destroy=void 0,void 0!==a&&a()),d=d.next;while(d!==c)}return;case 1:return;case 5:c=b.stateNode;if(null!=c){d=b.memoizedProps;var e=null!==a?a.memoizedProps:d;a=b.type;var f=b.updateQueue;b.updateQueue=null;if(null!==f){c[xf]=d;"input"===a&&"radio"===d.type&&null!=d.name&&$a(c,d);wb(a,e);b=wb(a,d);for(e=0;e<f.length;e+=
2){var g=f[e],h=f[e+1];"style"===g?tb(c,h):"dangerouslySetInnerHTML"===g?ob(c,h):"children"===g?pb(c,h):qa(c,g,h,b)}switch(a){case "input":ab(c,d);break;case "textarea":ib(c,d);break;case "select":a=c._wrapperState.wasMultiple,c._wrapperState.wasMultiple=!!d.multiple,f=d.value,null!=f?fb(c,!!d.multiple,f,!1):a!==!!d.multiple&&(null!=d.defaultValue?fb(c,!!d.multiple,d.defaultValue,!0):fb(c,!!d.multiple,d.multiple?[]:"",!1))}}}return;case 6:if(null===b.stateNode)throw Error(y(162));b.stateNode.nodeValue=
b.memoizedProps;return;case 3:c=b.stateNode;c.hydrate&&(c.hydrate=!1,Cc(c.containerInfo));return;case 12:return;case 13:null!==b.memoizedState&&(jj=O(),aj(b.child,!0));kj(b);return;case 19:kj(b);return;case 17:return;case 23:case 24:aj(b,null!==b.memoizedState);return}throw Error(y(163));}function kj(a){var b=a.updateQueue;if(null!==b){a.updateQueue=null;var c=a.stateNode;null===c&&(c=a.stateNode=new Ui);b.forEach(function(b){var d=lj.bind(null,a,b);c.has(b)||(c.add(b),b.then(d,d))})}}
function mj(a,b){return null!==a&&(a=a.memoizedState,null===a||null!==a.dehydrated)?(b=b.memoizedState,null!==b&&null===b.dehydrated):!1}var nj=Math.ceil,oj=ra.ReactCurrentDispatcher,pj=ra.ReactCurrentOwner,X=0,U=null,Y=null,W=0,qj=0,rj=Bf(0),V=0,sj=null,tj=0,Dg=0,Hi=0,uj=0,vj=null,jj=0,Ji=Infinity;function wj(){Ji=O()+500}var Z=null,Qi=!1,Ri=null,Ti=null,xj=!1,yj=null,zj=90,Aj=[],Bj=[],Cj=null,Dj=0,Ej=null,Fj=-1,Gj=0,Hj=0,Ij=null,Jj=!1;function Hg(){return 0!==(X&48)?O():-1!==Fj?Fj:Fj=O()}
function Ig(a){a=a.mode;if(0===(a&2))return 1;if(0===(a&4))return 99===eg()?1:2;0===Gj&&(Gj=tj);if(0!==kg.transition){0!==Hj&&(Hj=null!==vj?vj.pendingLanes:0);a=Gj;var b=4186112&~Hj;b&=-b;0===b&&(a=4186112&~a,b=a&-a,0===b&&(b=8192));return b}a=eg();0!==(X&4)&&98===a?a=Xc(12,Gj):(a=Sc(a),a=Xc(a,Gj));return a}
function Jg(a,b,c){if(50<Dj)throw Dj=0,Ej=null,Error(y(185));a=Kj(a,b);if(null===a)return null;$c(a,b,c);a===U&&(Hi|=b,4===V&&Ii(a,W));var d=eg();1===b?0!==(X&8)&&0===(X&48)?Lj(a):(Mj(a,c),0===X&&(wj(),ig())):(0===(X&4)||98!==d&&99!==d||(null===Cj?Cj=new Set([a]):Cj.add(a)),Mj(a,c));vj=a}function Kj(a,b){a.lanes|=b;var c=a.alternate;null!==c&&(c.lanes|=b);c=a;for(a=a.return;null!==a;)a.childLanes|=b,c=a.alternate,null!==c&&(c.childLanes|=b),c=a,a=a.return;return 3===c.tag?c.stateNode:null}
function Mj(a,b){for(var c=a.callbackNode,d=a.suspendedLanes,e=a.pingedLanes,f=a.expirationTimes,g=a.pendingLanes;0<g;){var h=31-Vc(g),k=1<<h,l=f[h];if(-1===l){if(0===(k&d)||0!==(k&e)){l=b;Rc(k);var n=F;f[h]=10<=n?l+250:6<=n?l+5E3:-1}}else l<=b&&(a.expiredLanes|=k);g&=~k}d=Uc(a,a===U?W:0);b=F;if(0===d)null!==c&&(c!==Zf&&Pf(c),a.callbackNode=null,a.callbackPriority=0);else{if(null!==c){if(a.callbackPriority===b)return;c!==Zf&&Pf(c)}15===b?(c=Lj.bind(null,a),null===ag?(ag=[c],bg=Of(Uf,jg)):ag.push(c),
c=Zf):14===b?c=hg(99,Lj.bind(null,a)):(c=Tc(b),c=hg(c,Nj.bind(null,a)));a.callbackPriority=b;a.callbackNode=c}}
function Nj(a){Fj=-1;Hj=Gj=0;if(0!==(X&48))throw Error(y(327));var b=a.callbackNode;if(Oj()&&a.callbackNode!==b)return null;var c=Uc(a,a===U?W:0);if(0===c)return null;var d=c;var e=X;X|=16;var f=Pj();if(U!==a||W!==d)wj(),Qj(a,d);do try{Rj();break}catch(h){Sj(a,h)}while(1);qg();oj.current=f;X=e;null!==Y?d=0:(U=null,W=0,d=V);if(0!==(tj&Hi))Qj(a,0);else if(0!==d){2===d&&(X|=64,a.hydrate&&(a.hydrate=!1,qf(a.containerInfo)),c=Wc(a),0!==c&&(d=Tj(a,c)));if(1===d)throw b=sj,Qj(a,0),Ii(a,c),Mj(a,O()),b;a.finishedWork=
a.current.alternate;a.finishedLanes=c;switch(d){case 0:case 1:throw Error(y(345));case 2:Uj(a);break;case 3:Ii(a,c);if((c&62914560)===c&&(d=jj+500-O(),10<d)){if(0!==Uc(a,0))break;e=a.suspendedLanes;if((e&c)!==c){Hg();a.pingedLanes|=a.suspendedLanes&e;break}a.timeoutHandle=of(Uj.bind(null,a),d);break}Uj(a);break;case 4:Ii(a,c);if((c&4186112)===c)break;d=a.eventTimes;for(e=-1;0<c;){var g=31-Vc(c);f=1<<g;g=d[g];g>e&&(e=g);c&=~f}c=e;c=O()-c;c=(120>c?120:480>c?480:1080>c?1080:1920>c?1920:3E3>c?3E3:4320>
c?4320:1960*nj(c/1960))-c;if(10<c){a.timeoutHandle=of(Uj.bind(null,a),c);break}Uj(a);break;case 5:Uj(a);break;default:throw Error(y(329));}}Mj(a,O());return a.callbackNode===b?Nj.bind(null,a):null}function Ii(a,b){b&=~uj;b&=~Hi;a.suspendedLanes|=b;a.pingedLanes&=~b;for(a=a.expirationTimes;0<b;){var c=31-Vc(b),d=1<<c;a[c]=-1;b&=~d}}
function Lj(a){if(0!==(X&48))throw Error(y(327));Oj();if(a===U&&0!==(a.expiredLanes&W)){var b=W;var c=Tj(a,b);0!==(tj&Hi)&&(b=Uc(a,b),c=Tj(a,b))}else b=Uc(a,0),c=Tj(a,b);0!==a.tag&&2===c&&(X|=64,a.hydrate&&(a.hydrate=!1,qf(a.containerInfo)),b=Wc(a),0!==b&&(c=Tj(a,b)));if(1===c)throw c=sj,Qj(a,0),Ii(a,b),Mj(a,O()),c;a.finishedWork=a.current.alternate;a.finishedLanes=b;Uj(a);Mj(a,O());return null}
function Vj(){if(null!==Cj){var a=Cj;Cj=null;a.forEach(function(a){a.expiredLanes|=24&a.pendingLanes;Mj(a,O())})}ig()}function Wj(a,b){var c=X;X|=1;try{return a(b)}finally{X=c,0===X&&(wj(),ig())}}function Xj(a,b){var c=X;X&=-2;X|=8;try{return a(b)}finally{X=c,0===X&&(wj(),ig())}}function ni(a,b){I(rj,qj);qj|=b;tj|=b}function Ki(){qj=rj.current;H(rj)}
function Qj(a,b){a.finishedWork=null;a.finishedLanes=0;var c=a.timeoutHandle;-1!==c&&(a.timeoutHandle=-1,pf(c));if(null!==Y)for(c=Y.return;null!==c;){var d=c;switch(d.tag){case 1:d=d.type.childContextTypes;null!==d&&void 0!==d&&Gf();break;case 3:fh();H(N);H(M);uh();break;case 5:hh(d);break;case 4:fh();break;case 13:H(P);break;case 19:H(P);break;case 10:rg(d);break;case 23:case 24:Ki()}c=c.return}U=a;Y=Tg(a.current,null);W=qj=tj=b;V=0;sj=null;uj=Hi=Dg=0}
function Sj(a,b){do{var c=Y;try{qg();vh.current=Gh;if(yh){for(var d=R.memoizedState;null!==d;){var e=d.queue;null!==e&&(e.pending=null);d=d.next}yh=!1}xh=0;T=S=R=null;zh=!1;pj.current=null;if(null===c||null===c.return){V=1;sj=b;Y=null;break}a:{var f=a,g=c.return,h=c,k=b;b=W;h.flags|=2048;h.firstEffect=h.lastEffect=null;if(null!==k&&"object"===typeof k&&"function"===typeof k.then){var l=k;if(0===(h.mode&2)){var n=h.alternate;n?(h.updateQueue=n.updateQueue,h.memoizedState=n.memoizedState,h.lanes=n.lanes):
(h.updateQueue=null,h.memoizedState=null)}var A=0!==(P.current&1),p=g;do{var C;if(C=13===p.tag){var x=p.memoizedState;if(null!==x)C=null!==x.dehydrated?!0:!1;else{var w=p.memoizedProps;C=void 0===w.fallback?!1:!0!==w.unstable_avoidThisFallback?!0:A?!1:!0}}if(C){var z=p.updateQueue;if(null===z){var u=new Set;u.add(l);p.updateQueue=u}else z.add(l);if(0===(p.mode&2)){p.flags|=64;h.flags|=16384;h.flags&=-2981;if(1===h.tag)if(null===h.alternate)h.tag=17;else{var t=zg(-1,1);t.tag=2;Ag(h,t)}h.lanes|=1;break a}k=
void 0;h=b;var q=f.pingCache;null===q?(q=f.pingCache=new Oi,k=new Set,q.set(l,k)):(k=q.get(l),void 0===k&&(k=new Set,q.set(l,k)));if(!k.has(h)){k.add(h);var v=Yj.bind(null,f,l,h);l.then(v,v)}p.flags|=4096;p.lanes=b;break a}p=p.return}while(null!==p);k=Error((Ra(h.type)||"A React component")+" suspended while rendering, but no fallback UI was specified.\n\nAdd a <Suspense fallback=...> component higher in the tree to provide a loading indicator or placeholder to display.")}5!==V&&(V=2);k=Mi(k,h);p=
g;do{switch(p.tag){case 3:f=k;p.flags|=4096;b&=-b;p.lanes|=b;var J=Pi(p,f,b);Bg(p,J);break a;case 1:f=k;var K=p.type,Q=p.stateNode;if(0===(p.flags&64)&&("function"===typeof K.getDerivedStateFromError||null!==Q&&"function"===typeof Q.componentDidCatch&&(null===Ti||!Ti.has(Q)))){p.flags|=4096;b&=-b;p.lanes|=b;var L=Si(p,f,b);Bg(p,L);break a}}p=p.return}while(null!==p)}Zj(c)}catch(va){b=va;Y===c&&null!==c&&(Y=c=c.return);continue}break}while(1)}
function Pj(){var a=oj.current;oj.current=Gh;return null===a?Gh:a}function Tj(a,b){var c=X;X|=16;var d=Pj();U===a&&W===b||Qj(a,b);do try{ak();break}catch(e){Sj(a,e)}while(1);qg();X=c;oj.current=d;if(null!==Y)throw Error(y(261));U=null;W=0;return V}function ak(){for(;null!==Y;)bk(Y)}function Rj(){for(;null!==Y&&!Qf();)bk(Y)}function bk(a){var b=ck(a.alternate,a,qj);a.memoizedProps=a.pendingProps;null===b?Zj(a):Y=b;pj.current=null}
function Zj(a){var b=a;do{var c=b.alternate;a=b.return;if(0===(b.flags&2048)){c=Gi(c,b,qj);if(null!==c){Y=c;return}c=b;if(24!==c.tag&&23!==c.tag||null===c.memoizedState||0!==(qj&1073741824)||0===(c.mode&4)){for(var d=0,e=c.child;null!==e;)d|=e.lanes|e.childLanes,e=e.sibling;c.childLanes=d}null!==a&&0===(a.flags&2048)&&(null===a.firstEffect&&(a.firstEffect=b.firstEffect),null!==b.lastEffect&&(null!==a.lastEffect&&(a.lastEffect.nextEffect=b.firstEffect),a.lastEffect=b.lastEffect),1<b.flags&&(null!==
a.lastEffect?a.lastEffect.nextEffect=b:a.firstEffect=b,a.lastEffect=b))}else{c=Li(b);if(null!==c){c.flags&=2047;Y=c;return}null!==a&&(a.firstEffect=a.lastEffect=null,a.flags|=2048)}b=b.sibling;if(null!==b){Y=b;return}Y=b=a}while(null!==b);0===V&&(V=5)}function Uj(a){var b=eg();gg(99,dk.bind(null,a,b));return null}
function dk(a,b){do Oj();while(null!==yj);if(0!==(X&48))throw Error(y(327));var c=a.finishedWork;if(null===c)return null;a.finishedWork=null;a.finishedLanes=0;if(c===a.current)throw Error(y(177));a.callbackNode=null;var d=c.lanes|c.childLanes,e=d,f=a.pendingLanes&~e;a.pendingLanes=e;a.suspendedLanes=0;a.pingedLanes=0;a.expiredLanes&=e;a.mutableReadLanes&=e;a.entangledLanes&=e;e=a.entanglements;for(var g=a.eventTimes,h=a.expirationTimes;0<f;){var k=31-Vc(f),l=1<<k;e[k]=0;g[k]=-1;h[k]=-1;f&=~l}null!==
Cj&&0===(d&24)&&Cj.has(a)&&Cj.delete(a);a===U&&(Y=U=null,W=0);1<c.flags?null!==c.lastEffect?(c.lastEffect.nextEffect=c,d=c.firstEffect):d=c:d=c.firstEffect;if(null!==d){e=X;X|=32;pj.current=null;kf=fd;g=Ne();if(Oe(g)){if("selectionStart"in g)h={start:g.selectionStart,end:g.selectionEnd};else a:if(h=(h=g.ownerDocument)&&h.defaultView||window,(l=h.getSelection&&h.getSelection())&&0!==l.rangeCount){h=l.anchorNode;f=l.anchorOffset;k=l.focusNode;l=l.focusOffset;try{h.nodeType,k.nodeType}catch(va){h=null;
break a}var n=0,A=-1,p=-1,C=0,x=0,w=g,z=null;b:for(;;){for(var u;;){w!==h||0!==f&&3!==w.nodeType||(A=n+f);w!==k||0!==l&&3!==w.nodeType||(p=n+l);3===w.nodeType&&(n+=w.nodeValue.length);if(null===(u=w.firstChild))break;z=w;w=u}for(;;){if(w===g)break b;z===h&&++C===f&&(A=n);z===k&&++x===l&&(p=n);if(null!==(u=w.nextSibling))break;w=z;z=w.parentNode}w=u}h=-1===A||-1===p?null:{start:A,end:p}}else h=null;h=h||{start:0,end:0}}else h=null;lf={focusedElem:g,selectionRange:h};fd=!1;Ij=null;Jj=!1;Z=d;do try{ek()}catch(va){if(null===
Z)throw Error(y(330));Wi(Z,va);Z=Z.nextEffect}while(null!==Z);Ij=null;Z=d;do try{for(g=a;null!==Z;){var t=Z.flags;t&16&&pb(Z.stateNode,"");if(t&128){var q=Z.alternate;if(null!==q){var v=q.ref;null!==v&&("function"===typeof v?v(null):v.current=null)}}switch(t&1038){case 2:fj(Z);Z.flags&=-3;break;case 6:fj(Z);Z.flags&=-3;ij(Z.alternate,Z);break;case 1024:Z.flags&=-1025;break;case 1028:Z.flags&=-1025;ij(Z.alternate,Z);break;case 4:ij(Z.alternate,Z);break;case 8:h=Z;cj(g,h);var J=h.alternate;dj(h);null!==
J&&dj(J)}Z=Z.nextEffect}}catch(va){if(null===Z)throw Error(y(330));Wi(Z,va);Z=Z.nextEffect}while(null!==Z);v=lf;q=Ne();t=v.focusedElem;g=v.selectionRange;if(q!==t&&t&&t.ownerDocument&&Me(t.ownerDocument.documentElement,t)){null!==g&&Oe(t)&&(q=g.start,v=g.end,void 0===v&&(v=q),"selectionStart"in t?(t.selectionStart=q,t.selectionEnd=Math.min(v,t.value.length)):(v=(q=t.ownerDocument||document)&&q.defaultView||window,v.getSelection&&(v=v.getSelection(),h=t.textContent.length,J=Math.min(g.start,h),g=void 0===
g.end?J:Math.min(g.end,h),!v.extend&&J>g&&(h=g,g=J,J=h),h=Le(t,J),f=Le(t,g),h&&f&&(1!==v.rangeCount||v.anchorNode!==h.node||v.anchorOffset!==h.offset||v.focusNode!==f.node||v.focusOffset!==f.offset)&&(q=q.createRange(),q.setStart(h.node,h.offset),v.removeAllRanges(),J>g?(v.addRange(q),v.extend(f.node,f.offset)):(q.setEnd(f.node,f.offset),v.addRange(q))))));q=[];for(v=t;v=v.parentNode;)1===v.nodeType&&q.push({element:v,left:v.scrollLeft,top:v.scrollTop});"function"===typeof t.focus&&t.focus();for(t=
0;t<q.length;t++)v=q[t],v.element.scrollLeft=v.left,v.element.scrollTop=v.top}fd=!!kf;lf=kf=null;a.current=c;Z=d;do try{for(t=a;null!==Z;){var K=Z.flags;K&36&&Yi(t,Z.alternate,Z);if(K&128){q=void 0;var Q=Z.ref;if(null!==Q){var L=Z.stateNode;switch(Z.tag){case 5:q=L;break;default:q=L}"function"===typeof Q?Q(q):Q.current=q}}Z=Z.nextEffect}}catch(va){if(null===Z)throw Error(y(330));Wi(Z,va);Z=Z.nextEffect}while(null!==Z);Z=null;$f();X=e}else a.current=c;if(xj)xj=!1,yj=a,zj=b;else for(Z=d;null!==Z;)b=
Z.nextEffect,Z.nextEffect=null,Z.flags&8&&(K=Z,K.sibling=null,K.stateNode=null),Z=b;d=a.pendingLanes;0===d&&(Ti=null);1===d?a===Ej?Dj++:(Dj=0,Ej=a):Dj=0;c=c.stateNode;if(Mf&&"function"===typeof Mf.onCommitFiberRoot)try{Mf.onCommitFiberRoot(Lf,c,void 0,64===(c.current.flags&64))}catch(va){}Mj(a,O());if(Qi)throw Qi=!1,a=Ri,Ri=null,a;if(0!==(X&8))return null;ig();return null}
function ek(){for(;null!==Z;){var a=Z.alternate;Jj||null===Ij||(0!==(Z.flags&8)?dc(Z,Ij)&&(Jj=!0):13===Z.tag&&mj(a,Z)&&dc(Z,Ij)&&(Jj=!0));var b=Z.flags;0!==(b&256)&&Xi(a,Z);0===(b&512)||xj||(xj=!0,hg(97,function(){Oj();return null}));Z=Z.nextEffect}}function Oj(){if(90!==zj){var a=97<zj?97:zj;zj=90;return gg(a,fk)}return!1}function $i(a,b){Aj.push(b,a);xj||(xj=!0,hg(97,function(){Oj();return null}))}function Zi(a,b){Bj.push(b,a);xj||(xj=!0,hg(97,function(){Oj();return null}))}
function fk(){if(null===yj)return!1;var a=yj;yj=null;if(0!==(X&48))throw Error(y(331));var b=X;X|=32;var c=Bj;Bj=[];for(var d=0;d<c.length;d+=2){var e=c[d],f=c[d+1],g=e.destroy;e.destroy=void 0;if("function"===typeof g)try{g()}catch(k){if(null===f)throw Error(y(330));Wi(f,k)}}c=Aj;Aj=[];for(d=0;d<c.length;d+=2){e=c[d];f=c[d+1];try{var h=e.create;e.destroy=h()}catch(k){if(null===f)throw Error(y(330));Wi(f,k)}}for(h=a.current.firstEffect;null!==h;)a=h.nextEffect,h.nextEffect=null,h.flags&8&&(h.sibling=
null,h.stateNode=null),h=a;X=b;ig();return!0}function gk(a,b,c){b=Mi(c,b);b=Pi(a,b,1);Ag(a,b);b=Hg();a=Kj(a,1);null!==a&&($c(a,1,b),Mj(a,b))}
function Wi(a,b){if(3===a.tag)gk(a,a,b);else for(var c=a.return;null!==c;){if(3===c.tag){gk(c,a,b);break}else if(1===c.tag){var d=c.stateNode;if("function"===typeof c.type.getDerivedStateFromError||"function"===typeof d.componentDidCatch&&(null===Ti||!Ti.has(d))){a=Mi(b,a);var e=Si(c,a,1);Ag(c,e);e=Hg();c=Kj(c,1);if(null!==c)$c(c,1,e),Mj(c,e);else if("function"===typeof d.componentDidCatch&&(null===Ti||!Ti.has(d)))try{d.componentDidCatch(b,a)}catch(f){}break}}c=c.return}}
function Yj(a,b,c){var d=a.pingCache;null!==d&&d.delete(b);b=Hg();a.pingedLanes|=a.suspendedLanes&c;U===a&&(W&c)===c&&(4===V||3===V&&(W&62914560)===W&&500>O()-jj?Qj(a,0):uj|=c);Mj(a,b)}function lj(a,b){var c=a.stateNode;null!==c&&c.delete(b);b=0;0===b&&(b=a.mode,0===(b&2)?b=1:0===(b&4)?b=99===eg()?1:2:(0===Gj&&(Gj=tj),b=Yc(62914560&~Gj),0===b&&(b=4194304)));c=Hg();a=Kj(a,b);null!==a&&($c(a,b,c),Mj(a,c))}var ck;
ck=function(a,b,c){var d=b.lanes;if(null!==a)if(a.memoizedProps!==b.pendingProps||N.current)ug=!0;else if(0!==(c&d))ug=0!==(a.flags&16384)?!0:!1;else{ug=!1;switch(b.tag){case 3:ri(b);sh();break;case 5:gh(b);break;case 1:Ff(b.type)&&Jf(b);break;case 4:eh(b,b.stateNode.containerInfo);break;case 10:d=b.memoizedProps.value;var e=b.type._context;I(mg,e._currentValue);e._currentValue=d;break;case 13:if(null!==b.memoizedState){if(0!==(c&b.child.childLanes))return ti(a,b,c);I(P,P.current&1);b=hi(a,b,c);return null!==
b?b.sibling:null}I(P,P.current&1);break;case 19:d=0!==(c&b.childLanes);if(0!==(a.flags&64)){if(d)return Ai(a,b,c);b.flags|=64}e=b.memoizedState;null!==e&&(e.rendering=null,e.tail=null,e.lastEffect=null);I(P,P.current);if(d)break;else return null;case 23:case 24:return b.lanes=0,mi(a,b,c)}return hi(a,b,c)}else ug=!1;b.lanes=0;switch(b.tag){case 2:d=b.type;null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2);a=b.pendingProps;e=Ef(b,M.current);tg(b,c);e=Ch(null,b,d,a,e,c);b.flags|=1;if("object"===
typeof e&&null!==e&&"function"===typeof e.render&&void 0===e.$$typeof){b.tag=1;b.memoizedState=null;b.updateQueue=null;if(Ff(d)){var f=!0;Jf(b)}else f=!1;b.memoizedState=null!==e.state&&void 0!==e.state?e.state:null;xg(b);var g=d.getDerivedStateFromProps;"function"===typeof g&&Gg(b,d,g,a);e.updater=Kg;b.stateNode=e;e._reactInternals=b;Og(b,d,a,c);b=qi(null,b,d,!0,f,c)}else b.tag=0,fi(null,b,e,c),b=b.child;return b;case 16:e=b.elementType;a:{null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2);
a=b.pendingProps;f=e._init;e=f(e._payload);b.type=e;f=b.tag=hk(e);a=lg(e,a);switch(f){case 0:b=li(null,b,e,a,c);break a;case 1:b=pi(null,b,e,a,c);break a;case 11:b=gi(null,b,e,a,c);break a;case 14:b=ii(null,b,e,lg(e.type,a),d,c);break a}throw Error(y(306,e,""));}return b;case 0:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:lg(d,e),li(a,b,d,e,c);case 1:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:lg(d,e),pi(a,b,d,e,c);case 3:ri(b);d=b.updateQueue;if(null===a||null===d)throw Error(y(282));
d=b.pendingProps;e=b.memoizedState;e=null!==e?e.element:null;yg(a,b);Cg(b,d,null,c);d=b.memoizedState.element;if(d===e)sh(),b=hi(a,b,c);else{e=b.stateNode;if(f=e.hydrate)kh=rf(b.stateNode.containerInfo.firstChild),jh=b,f=lh=!0;if(f){a=e.mutableSourceEagerHydrationData;if(null!=a)for(e=0;e<a.length;e+=2)f=a[e],f._workInProgressVersionPrimary=a[e+1],th.push(f);c=Zg(b,null,d,c);for(b.child=c;c;)c.flags=c.flags&-3|1024,c=c.sibling}else fi(a,b,d,c),sh();b=b.child}return b;case 5:return gh(b),null===a&&
ph(b),d=b.type,e=b.pendingProps,f=null!==a?a.memoizedProps:null,g=e.children,nf(d,e)?g=null:null!==f&&nf(d,f)&&(b.flags|=16),oi(a,b),fi(a,b,g,c),b.child;case 6:return null===a&&ph(b),null;case 13:return ti(a,b,c);case 4:return eh(b,b.stateNode.containerInfo),d=b.pendingProps,null===a?b.child=Yg(b,null,d,c):fi(a,b,d,c),b.child;case 11:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:lg(d,e),gi(a,b,d,e,c);case 7:return fi(a,b,b.pendingProps,c),b.child;case 8:return fi(a,b,b.pendingProps.children,
c),b.child;case 12:return fi(a,b,b.pendingProps.children,c),b.child;case 10:a:{d=b.type._context;e=b.pendingProps;g=b.memoizedProps;f=e.value;var h=b.type._context;I(mg,h._currentValue);h._currentValue=f;if(null!==g)if(h=g.value,f=He(h,f)?0:("function"===typeof d._calculateChangedBits?d._calculateChangedBits(h,f):1073741823)|0,0===f){if(g.children===e.children&&!N.current){b=hi(a,b,c);break a}}else for(h=b.child,null!==h&&(h.return=b);null!==h;){var k=h.dependencies;if(null!==k){g=h.child;for(var l=
k.firstContext;null!==l;){if(l.context===d&&0!==(l.observedBits&f)){1===h.tag&&(l=zg(-1,c&-c),l.tag=2,Ag(h,l));h.lanes|=c;l=h.alternate;null!==l&&(l.lanes|=c);sg(h.return,c);k.lanes|=c;break}l=l.next}}else g=10===h.tag?h.type===b.type?null:h.child:h.child;if(null!==g)g.return=h;else for(g=h;null!==g;){if(g===b){g=null;break}h=g.sibling;if(null!==h){h.return=g.return;g=h;break}g=g.return}h=g}fi(a,b,e.children,c);b=b.child}return b;case 9:return e=b.type,f=b.pendingProps,d=f.children,tg(b,c),e=vg(e,
f.unstable_observedBits),d=d(e),b.flags|=1,fi(a,b,d,c),b.child;case 14:return e=b.type,f=lg(e,b.pendingProps),f=lg(e.type,f),ii(a,b,e,f,d,c);case 15:return ki(a,b,b.type,b.pendingProps,d,c);case 17:return d=b.type,e=b.pendingProps,e=b.elementType===d?e:lg(d,e),null!==a&&(a.alternate=null,b.alternate=null,b.flags|=2),b.tag=1,Ff(d)?(a=!0,Jf(b)):a=!1,tg(b,c),Mg(b,d,e),Og(b,d,e,c),qi(null,b,d,!0,a,c);case 19:return Ai(a,b,c);case 23:return mi(a,b,c);case 24:return mi(a,b,c)}throw Error(y(156,b.tag));
};function ik(a,b,c,d){this.tag=a;this.key=c;this.sibling=this.child=this.return=this.stateNode=this.type=this.elementType=null;this.index=0;this.ref=null;this.pendingProps=b;this.dependencies=this.memoizedState=this.updateQueue=this.memoizedProps=null;this.mode=d;this.flags=0;this.lastEffect=this.firstEffect=this.nextEffect=null;this.childLanes=this.lanes=0;this.alternate=null}function nh(a,b,c,d){return new ik(a,b,c,d)}function ji(a){a=a.prototype;return!(!a||!a.isReactComponent)}
function hk(a){if("function"===typeof a)return ji(a)?1:0;if(void 0!==a&&null!==a){a=a.$$typeof;if(a===Aa)return 11;if(a===Da)return 14}return 2}
function Tg(a,b){var c=a.alternate;null===c?(c=nh(a.tag,b,a.key,a.mode),c.elementType=a.elementType,c.type=a.type,c.stateNode=a.stateNode,c.alternate=a,a.alternate=c):(c.pendingProps=b,c.type=a.type,c.flags=0,c.nextEffect=null,c.firstEffect=null,c.lastEffect=null);c.childLanes=a.childLanes;c.lanes=a.lanes;c.child=a.child;c.memoizedProps=a.memoizedProps;c.memoizedState=a.memoizedState;c.updateQueue=a.updateQueue;b=a.dependencies;c.dependencies=null===b?null:{lanes:b.lanes,firstContext:b.firstContext};
c.sibling=a.sibling;c.index=a.index;c.ref=a.ref;return c}
function Vg(a,b,c,d,e,f){var g=2;d=a;if("function"===typeof a)ji(a)&&(g=1);else if("string"===typeof a)g=5;else a:switch(a){case ua:return Xg(c.children,e,f,b);case Ha:g=8;e|=16;break;case wa:g=8;e|=1;break;case xa:return a=nh(12,c,b,e|8),a.elementType=xa,a.type=xa,a.lanes=f,a;case Ba:return a=nh(13,c,b,e),a.type=Ba,a.elementType=Ba,a.lanes=f,a;case Ca:return a=nh(19,c,b,e),a.elementType=Ca,a.lanes=f,a;case Ia:return vi(c,e,f,b);case Ja:return a=nh(24,c,b,e),a.elementType=Ja,a.lanes=f,a;default:if("object"===
typeof a&&null!==a)switch(a.$$typeof){case ya:g=10;break a;case za:g=9;break a;case Aa:g=11;break a;case Da:g=14;break a;case Ea:g=16;d=null;break a;case Fa:g=22;break a}throw Error(y(130,null==a?a:typeof a,""));}b=nh(g,c,b,e);b.elementType=a;b.type=d;b.lanes=f;return b}function Xg(a,b,c,d){a=nh(7,a,d,b);a.lanes=c;return a}function vi(a,b,c,d){a=nh(23,a,d,b);a.elementType=Ia;a.lanes=c;return a}function Ug(a,b,c){a=nh(6,a,null,b);a.lanes=c;return a}
function Wg(a,b,c){b=nh(4,null!==a.children?a.children:[],a.key,b);b.lanes=c;b.stateNode={containerInfo:a.containerInfo,pendingChildren:null,implementation:a.implementation};return b}
function jk(a,b,c){this.tag=b;this.containerInfo=a;this.finishedWork=this.pingCache=this.current=this.pendingChildren=null;this.timeoutHandle=-1;this.pendingContext=this.context=null;this.hydrate=c;this.callbackNode=null;this.callbackPriority=0;this.eventTimes=Zc(0);this.expirationTimes=Zc(-1);this.entangledLanes=this.finishedLanes=this.mutableReadLanes=this.expiredLanes=this.pingedLanes=this.suspendedLanes=this.pendingLanes=0;this.entanglements=Zc(0);this.mutableSourceEagerHydrationData=null}
function kk(a,b,c){var d=3<arguments.length&&void 0!==arguments[3]?arguments[3]:null;return{$$typeof:ta,key:null==d?null:""+d,children:a,containerInfo:b,implementation:c}}
function lk(a,b,c,d){var e=b.current,f=Hg(),g=Ig(e);a:if(c){c=c._reactInternals;b:{if(Zb(c)!==c||1!==c.tag)throw Error(y(170));var h=c;do{switch(h.tag){case 3:h=h.stateNode.context;break b;case 1:if(Ff(h.type)){h=h.stateNode.__reactInternalMemoizedMergedChildContext;break b}}h=h.return}while(null!==h);throw Error(y(171));}if(1===c.tag){var k=c.type;if(Ff(k)){c=If(c,k,h);break a}}c=h}else c=Cf;null===b.context?b.context=c:b.pendingContext=c;b=zg(f,g);b.payload={element:a};d=void 0===d?null:d;null!==
d&&(b.callback=d);Ag(e,b);Jg(e,g,f);return g}function mk(a){a=a.current;if(!a.child)return null;switch(a.child.tag){case 5:return a.child.stateNode;default:return a.child.stateNode}}function nk(a,b){a=a.memoizedState;if(null!==a&&null!==a.dehydrated){var c=a.retryLane;a.retryLane=0!==c&&c<b?c:b}}function ok(a,b){nk(a,b);(a=a.alternate)&&nk(a,b)}function pk(){return null}
function qk(a,b,c){var d=null!=c&&null!=c.hydrationOptions&&c.hydrationOptions.mutableSources||null;c=new jk(a,b,null!=c&&!0===c.hydrate);b=nh(3,null,null,2===b?7:1===b?3:0);c.current=b;b.stateNode=c;xg(b);a[ff]=c.current;cf(8===a.nodeType?a.parentNode:a);if(d)for(a=0;a<d.length;a++){b=d[a];var e=b._getVersion;e=e(b._source);null==c.mutableSourceEagerHydrationData?c.mutableSourceEagerHydrationData=[b,e]:c.mutableSourceEagerHydrationData.push(b,e)}this._internalRoot=c}
qk.prototype.render=function(a){lk(a,this._internalRoot,null,null)};qk.prototype.unmount=function(){var a=this._internalRoot,b=a.containerInfo;lk(null,a,null,function(){b[ff]=null})};function rk(a){return!(!a||1!==a.nodeType&&9!==a.nodeType&&11!==a.nodeType&&(8!==a.nodeType||" react-mount-point-unstable "!==a.nodeValue))}
function sk(a,b){b||(b=a?9===a.nodeType?a.documentElement:a.firstChild:null,b=!(!b||1!==b.nodeType||!b.hasAttribute("data-reactroot")));if(!b)for(var c;c=a.lastChild;)a.removeChild(c);return new qk(a,0,b?{hydrate:!0}:void 0)}
function tk(a,b,c,d,e){var f=c._reactRootContainer;if(f){var g=f._internalRoot;if("function"===typeof e){var h=e;e=function(){var a=mk(g);h.call(a)}}lk(b,g,a,e)}else{f=c._reactRootContainer=sk(c,d);g=f._internalRoot;if("function"===typeof e){var k=e;e=function(){var a=mk(g);k.call(a)}}Xj(function(){lk(b,g,a,e)})}return mk(g)}ec=function(a){if(13===a.tag){var b=Hg();Jg(a,4,b);ok(a,4)}};fc=function(a){if(13===a.tag){var b=Hg();Jg(a,67108864,b);ok(a,67108864)}};
gc=function(a){if(13===a.tag){var b=Hg(),c=Ig(a);Jg(a,c,b);ok(a,c)}};hc=function(a,b){return b()};
yb=function(a,b,c){switch(b){case "input":ab(a,c);b=c.name;if("radio"===c.type&&null!=b){for(c=a;c.parentNode;)c=c.parentNode;c=c.querySelectorAll("input[name="+JSON.stringify(""+b)+'][type="radio"]');for(b=0;b<c.length;b++){var d=c[b];if(d!==a&&d.form===a.form){var e=Db(d);if(!e)throw Error(y(90));Wa(d);ab(d,e)}}}break;case "textarea":ib(a,c);break;case "select":b=c.value,null!=b&&fb(a,!!c.multiple,b,!1)}};Gb=Wj;
Hb=function(a,b,c,d,e){var f=X;X|=4;try{return gg(98,a.bind(null,b,c,d,e))}finally{X=f,0===X&&(wj(),ig())}};Ib=function(){0===(X&49)&&(Vj(),Oj())};Jb=function(a,b){var c=X;X|=2;try{return a(b)}finally{X=c,0===X&&(wj(),ig())}};function uk(a,b){var c=2<arguments.length&&void 0!==arguments[2]?arguments[2]:null;if(!rk(b))throw Error(y(200));return kk(a,b,null,c)}var vk={Events:[Cb,ue,Db,Eb,Fb,Oj,{current:!1}]},wk={findFiberByHostInstance:wc,bundleType:0,version:"17.0.2",rendererPackageName:"react-dom"};
var xk={bundleType:wk.bundleType,version:wk.version,rendererPackageName:wk.rendererPackageName,rendererConfig:wk.rendererConfig,overrideHookState:null,overrideHookStateDeletePath:null,overrideHookStateRenamePath:null,overrideProps:null,overridePropsDeletePath:null,overridePropsRenamePath:null,setSuspenseHandler:null,scheduleUpdate:null,currentDispatcherRef:ra.ReactCurrentDispatcher,findHostInstanceByFiber:function(a){a=cc(a);return null===a?null:a.stateNode},findFiberByHostInstance:wk.findFiberByHostInstance||
pk,findHostInstancesForRefresh:null,scheduleRefresh:null,scheduleRoot:null,setRefreshHandler:null,getCurrentFiber:null};if("undefined"!==typeof __REACT_DEVTOOLS_GLOBAL_HOOK__){var yk=__REACT_DEVTOOLS_GLOBAL_HOOK__;if(!yk.isDisabled&&yk.supportsFiber)try{Lf=yk.inject(xk),Mf=yk}catch(a){}}exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=vk;exports.createPortal=uk;
exports.findDOMNode=function(a){if(null==a)return null;if(1===a.nodeType)return a;var b=a._reactInternals;if(void 0===b){if("function"===typeof a.render)throw Error(y(188));throw Error(y(268,Object.keys(a)));}a=cc(b);a=null===a?null:a.stateNode;return a};exports.flushSync=function(a,b){var c=X;if(0!==(c&48))return a(b);X|=1;try{if(a)return gg(99,a.bind(null,b))}finally{X=c,ig()}};exports.hydrate=function(a,b,c){if(!rk(b))throw Error(y(200));return tk(null,a,b,!0,c)};
exports.render=function(a,b,c){if(!rk(b))throw Error(y(200));return tk(null,a,b,!1,c)};exports.unmountComponentAtNode=function(a){if(!rk(a))throw Error(y(40));return a._reactRootContainer?(Xj(function(){tk(null,null,a,!1,function(){a._reactRootContainer=null;a[ff]=null})}),!0):!1};exports.unstable_batchedUpdates=Wj;exports.unstable_createPortal=function(a,b){return uk(a,b,2<arguments.length&&void 0!==arguments[2]?arguments[2]:null)};
exports.unstable_renderSubtreeIntoContainer=function(a,b,c,d){if(!rk(c))throw Error(y(200));if(null==a||void 0===a._reactInternals)throw Error(y(38));return tk(a,b,c,!1,d)};exports.version="17.0.2";


/***/ }),

/***/ 3935:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


function checkDCE() {
  /* global __REACT_DEVTOOLS_GLOBAL_HOOK__ */
  if (
    typeof __REACT_DEVTOOLS_GLOBAL_HOOK__ === 'undefined' ||
    typeof __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE !== 'function'
  ) {
    return;
  }
  if (false) {}
  try {
    // Verify that the code above has been dead code eliminated (DCE'd).
    __REACT_DEVTOOLS_GLOBAL_HOOK__.checkDCE(checkDCE);
  } catch (err) {
    // DevTools shouldn't crash React, no matter what.
    // We should still report in case we break this code.
    console.error(err);
  }
}

if (true) {
  // DCE check should happen before ReactDOM bundle executes so that
  // DevTools can report bad minification during injection.
  checkDCE();
  module.exports = __webpack_require__(4448);
} else {}


/***/ }),

/***/ 6563:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

"use strict";

var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
var fromPairs = __webpack_require__(1813);
var ngcomponent_1 = __webpack_require__(9052);
var React = __webpack_require__(7294);
var react_dom_1 = __webpack_require__(3935);
/**
 * Wraps a React component in Angular. Returns a new Angular component.
 *
 * Usage:
 *
 *   ```ts
 *   type Props = { foo: number }
 *   class ReactComponent extends React.Component<Props, S> {}
 *   const AngularComponent = react2angular(ReactComponent, ['foo'])
 *   ```
 */
function react2angular(Class, bindingNames, injectNames) {
    if (bindingNames === void 0) { bindingNames = null; }
    if (injectNames === void 0) { injectNames = []; }
    var names = bindingNames
        || (Class.propTypes && Object.keys(Class.propTypes))
        || [];
    return {
        bindings: fromPairs(names.map(function (_) { return [_, '<']; })),
        controller: ['$element'].concat(injectNames, [/** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1($element) {
                    var injectedProps = [];
                    for (var _i = 1; _i < arguments.length; _i++) {
                        injectedProps[_i - 1] = arguments[_i];
                    }
                    var _this = _super.call(this) || this;
                    _this.$element = $element;
                    _this.isDestroyed = false;
                    _this.injectedProps = {};
                    injectNames.forEach(function (name, i) {
                        _this.injectedProps[name] = injectedProps[i];
                    });
                    return _this;
                }
                Object.defineProperty(class_1, "$$ngIsClass", {
                    get: function () {
                        return true;
                    },
                    enumerable: true,
                    configurable: true
                });
                class_1.prototype.render = function () {
                    if (!this.isDestroyed) {
                        react_dom_1.render(React.createElement(Class, __assign({}, this.props, this.injectedProps)), this.$element[0]);
                    }
                };
                class_1.prototype.componentWillUnmount = function () {
                    this.isDestroyed = true;
                    react_dom_1.unmountComponentAtNode(this.$element[0]);
                };
                return class_1;
            }(ngcomponent_1.default))])
    };
}
exports.react2angular = react2angular;
//# sourceMappingURL=index.js.map

/***/ }),

/***/ 5251:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
__webpack_require__(7418);var f=__webpack_require__(7294),g=60103;exports.Fragment=60107;if("function"===typeof Symbol&&Symbol.for){var h=Symbol.for;g=h("react.element");exports.Fragment=h("react.fragment")}var m=f.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner,n=Object.prototype.hasOwnProperty,p={key:!0,ref:!0,__self:!0,__source:!0};
function q(c,a,k){var b,d={},e=null,l=null;void 0!==k&&(e=""+k);void 0!==a.key&&(e=""+a.key);void 0!==a.ref&&(l=a.ref);for(b in a)n.call(a,b)&&!p.hasOwnProperty(b)&&(d[b]=a[b]);if(c&&c.defaultProps)for(b in a=c.defaultProps,a)void 0===d[b]&&(d[b]=a[b]);return{$$typeof:g,type:c,key:e,ref:l,props:d,_owner:m.current}}exports.jsx=q;exports.jsxs=q;


/***/ }),

/***/ 2408:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

"use strict";
/** @license React v17.0.2
 * react.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var l=__webpack_require__(7418),n=60103,p=60106;exports.Fragment=60107;exports.StrictMode=60108;exports.Profiler=60114;var q=60109,r=60110,t=60112;exports.Suspense=60113;var u=60115,v=60116;
if("function"===typeof Symbol&&Symbol.for){var w=Symbol.for;n=w("react.element");p=w("react.portal");exports.Fragment=w("react.fragment");exports.StrictMode=w("react.strict_mode");exports.Profiler=w("react.profiler");q=w("react.provider");r=w("react.context");t=w("react.forward_ref");exports.Suspense=w("react.suspense");u=w("react.memo");v=w("react.lazy")}var x="function"===typeof Symbol&&Symbol.iterator;
function y(a){if(null===a||"object"!==typeof a)return null;a=x&&a[x]||a["@@iterator"];return"function"===typeof a?a:null}function z(a){for(var b="https://reactjs.org/docs/error-decoder.html?invariant="+a,c=1;c<arguments.length;c++)b+="&args[]="+encodeURIComponent(arguments[c]);return"Minified React error #"+a+"; visit "+b+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}
var A={isMounted:function(){return!1},enqueueForceUpdate:function(){},enqueueReplaceState:function(){},enqueueSetState:function(){}},B={};function C(a,b,c){this.props=a;this.context=b;this.refs=B;this.updater=c||A}C.prototype.isReactComponent={};C.prototype.setState=function(a,b){if("object"!==typeof a&&"function"!==typeof a&&null!=a)throw Error(z(85));this.updater.enqueueSetState(this,a,b,"setState")};C.prototype.forceUpdate=function(a){this.updater.enqueueForceUpdate(this,a,"forceUpdate")};
function D(){}D.prototype=C.prototype;function E(a,b,c){this.props=a;this.context=b;this.refs=B;this.updater=c||A}var F=E.prototype=new D;F.constructor=E;l(F,C.prototype);F.isPureReactComponent=!0;var G={current:null},H=Object.prototype.hasOwnProperty,I={key:!0,ref:!0,__self:!0,__source:!0};
function J(a,b,c){var e,d={},k=null,h=null;if(null!=b)for(e in void 0!==b.ref&&(h=b.ref),void 0!==b.key&&(k=""+b.key),b)H.call(b,e)&&!I.hasOwnProperty(e)&&(d[e]=b[e]);var g=arguments.length-2;if(1===g)d.children=c;else if(1<g){for(var f=Array(g),m=0;m<g;m++)f[m]=arguments[m+2];d.children=f}if(a&&a.defaultProps)for(e in g=a.defaultProps,g)void 0===d[e]&&(d[e]=g[e]);return{$$typeof:n,type:a,key:k,ref:h,props:d,_owner:G.current}}
function K(a,b){return{$$typeof:n,type:a.type,key:b,ref:a.ref,props:a.props,_owner:a._owner}}function L(a){return"object"===typeof a&&null!==a&&a.$$typeof===n}function escape(a){var b={"=":"=0",":":"=2"};return"$"+a.replace(/[=:]/g,function(a){return b[a]})}var M=/\/+/g;function N(a,b){return"object"===typeof a&&null!==a&&null!=a.key?escape(""+a.key):b.toString(36)}
function O(a,b,c,e,d){var k=typeof a;if("undefined"===k||"boolean"===k)a=null;var h=!1;if(null===a)h=!0;else switch(k){case "string":case "number":h=!0;break;case "object":switch(a.$$typeof){case n:case p:h=!0}}if(h)return h=a,d=d(h),a=""===e?"."+N(h,0):e,Array.isArray(d)?(c="",null!=a&&(c=a.replace(M,"$&/")+"/"),O(d,b,c,"",function(a){return a})):null!=d&&(L(d)&&(d=K(d,c+(!d.key||h&&h.key===d.key?"":(""+d.key).replace(M,"$&/")+"/")+a)),b.push(d)),1;h=0;e=""===e?".":e+":";if(Array.isArray(a))for(var g=
0;g<a.length;g++){k=a[g];var f=e+N(k,g);h+=O(k,b,c,f,d)}else if(f=y(a),"function"===typeof f)for(a=f.call(a),g=0;!(k=a.next()).done;)k=k.value,f=e+N(k,g++),h+=O(k,b,c,f,d);else if("object"===k)throw b=""+a,Error(z(31,"[object Object]"===b?"object with keys {"+Object.keys(a).join(", ")+"}":b));return h}function P(a,b,c){if(null==a)return a;var e=[],d=0;O(a,e,"","",function(a){return b.call(c,a,d++)});return e}
function Q(a){if(-1===a._status){var b=a._result;b=b();a._status=0;a._result=b;b.then(function(b){0===a._status&&(b=b.default,a._status=1,a._result=b)},function(b){0===a._status&&(a._status=2,a._result=b)})}if(1===a._status)return a._result;throw a._result;}var R={current:null};function S(){var a=R.current;if(null===a)throw Error(z(321));return a}var T={ReactCurrentDispatcher:R,ReactCurrentBatchConfig:{transition:0},ReactCurrentOwner:G,IsSomeRendererActing:{current:!1},assign:l};
exports.Children={map:P,forEach:function(a,b,c){P(a,function(){b.apply(this,arguments)},c)},count:function(a){var b=0;P(a,function(){b++});return b},toArray:function(a){return P(a,function(a){return a})||[]},only:function(a){if(!L(a))throw Error(z(143));return a}};exports.Component=C;exports.PureComponent=E;exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=T;
exports.cloneElement=function(a,b,c){if(null===a||void 0===a)throw Error(z(267,a));var e=l({},a.props),d=a.key,k=a.ref,h=a._owner;if(null!=b){void 0!==b.ref&&(k=b.ref,h=G.current);void 0!==b.key&&(d=""+b.key);if(a.type&&a.type.defaultProps)var g=a.type.defaultProps;for(f in b)H.call(b,f)&&!I.hasOwnProperty(f)&&(e[f]=void 0===b[f]&&void 0!==g?g[f]:b[f])}var f=arguments.length-2;if(1===f)e.children=c;else if(1<f){g=Array(f);for(var m=0;m<f;m++)g[m]=arguments[m+2];e.children=g}return{$$typeof:n,type:a.type,
key:d,ref:k,props:e,_owner:h}};exports.createContext=function(a,b){void 0===b&&(b=null);a={$$typeof:r,_calculateChangedBits:b,_currentValue:a,_currentValue2:a,_threadCount:0,Provider:null,Consumer:null};a.Provider={$$typeof:q,_context:a};return a.Consumer=a};exports.createElement=J;exports.createFactory=function(a){var b=J.bind(null,a);b.type=a;return b};exports.createRef=function(){return{current:null}};exports.forwardRef=function(a){return{$$typeof:t,render:a}};exports.isValidElement=L;
exports.lazy=function(a){return{$$typeof:v,_payload:{_status:-1,_result:a},_init:Q}};exports.memo=function(a,b){return{$$typeof:u,type:a,compare:void 0===b?null:b}};exports.useCallback=function(a,b){return S().useCallback(a,b)};exports.useContext=function(a,b){return S().useContext(a,b)};exports.useDebugValue=function(){};exports.useEffect=function(a,b){return S().useEffect(a,b)};exports.useImperativeHandle=function(a,b,c){return S().useImperativeHandle(a,b,c)};
exports.useLayoutEffect=function(a,b){return S().useLayoutEffect(a,b)};exports.useMemo=function(a,b){return S().useMemo(a,b)};exports.useReducer=function(a,b,c){return S().useReducer(a,b,c)};exports.useRef=function(a){return S().useRef(a)};exports.useState=function(a){return S().useState(a)};exports.version="17.0.2";


/***/ }),

/***/ 7294:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


if (true) {
  module.exports = __webpack_require__(2408);
} else {}


/***/ }),

/***/ 5893:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


if (true) {
  module.exports = __webpack_require__(5251);
} else {}


/***/ }),

/***/ 53:
/***/ ((__unused_webpack_module, exports) => {

"use strict";
/** @license React v0.20.2
 * scheduler.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var f,g,h,k;if("object"===typeof performance&&"function"===typeof performance.now){var l=performance;exports.unstable_now=function(){return l.now()}}else{var p=Date,q=p.now();exports.unstable_now=function(){return p.now()-q}}
if("undefined"===typeof window||"function"!==typeof MessageChannel){var t=null,u=null,w=function(){if(null!==t)try{var a=exports.unstable_now();t(!0,a);t=null}catch(b){throw setTimeout(w,0),b;}};f=function(a){null!==t?setTimeout(f,0,a):(t=a,setTimeout(w,0))};g=function(a,b){u=setTimeout(a,b)};h=function(){clearTimeout(u)};exports.unstable_shouldYield=function(){return!1};k=exports.unstable_forceFrameRate=function(){}}else{var x=window.setTimeout,y=window.clearTimeout;if("undefined"!==typeof console){var z=
window.cancelAnimationFrame;"function"!==typeof window.requestAnimationFrame&&console.error("This browser doesn't support requestAnimationFrame. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills");"function"!==typeof z&&console.error("This browser doesn't support cancelAnimationFrame. Make sure that you load a polyfill in older browsers. https://reactjs.org/link/react-polyfills")}var A=!1,B=null,C=-1,D=5,E=0;exports.unstable_shouldYield=function(){return exports.unstable_now()>=
E};k=function(){};exports.unstable_forceFrameRate=function(a){0>a||125<a?console.error("forceFrameRate takes a positive int between 0 and 125, forcing frame rates higher than 125 fps is not supported"):D=0<a?Math.floor(1E3/a):5};var F=new MessageChannel,G=F.port2;F.port1.onmessage=function(){if(null!==B){var a=exports.unstable_now();E=a+D;try{B(!0,a)?G.postMessage(null):(A=!1,B=null)}catch(b){throw G.postMessage(null),b;}}else A=!1};f=function(a){B=a;A||(A=!0,G.postMessage(null))};g=function(a,b){C=
x(function(){a(exports.unstable_now())},b)};h=function(){y(C);C=-1}}function H(a,b){var c=a.length;a.push(b);a:for(;;){var d=c-1>>>1,e=a[d];if(void 0!==e&&0<I(e,b))a[d]=b,a[c]=e,c=d;else break a}}function J(a){a=a[0];return void 0===a?null:a}
function K(a){var b=a[0];if(void 0!==b){var c=a.pop();if(c!==b){a[0]=c;a:for(var d=0,e=a.length;d<e;){var m=2*(d+1)-1,n=a[m],v=m+1,r=a[v];if(void 0!==n&&0>I(n,c))void 0!==r&&0>I(r,n)?(a[d]=r,a[v]=c,d=v):(a[d]=n,a[m]=c,d=m);else if(void 0!==r&&0>I(r,c))a[d]=r,a[v]=c,d=v;else break a}}return b}return null}function I(a,b){var c=a.sortIndex-b.sortIndex;return 0!==c?c:a.id-b.id}var L=[],M=[],N=1,O=null,P=3,Q=!1,R=!1,S=!1;
function T(a){for(var b=J(M);null!==b;){if(null===b.callback)K(M);else if(b.startTime<=a)K(M),b.sortIndex=b.expirationTime,H(L,b);else break;b=J(M)}}function U(a){S=!1;T(a);if(!R)if(null!==J(L))R=!0,f(V);else{var b=J(M);null!==b&&g(U,b.startTime-a)}}
function V(a,b){R=!1;S&&(S=!1,h());Q=!0;var c=P;try{T(b);for(O=J(L);null!==O&&(!(O.expirationTime>b)||a&&!exports.unstable_shouldYield());){var d=O.callback;if("function"===typeof d){O.callback=null;P=O.priorityLevel;var e=d(O.expirationTime<=b);b=exports.unstable_now();"function"===typeof e?O.callback=e:O===J(L)&&K(L);T(b)}else K(L);O=J(L)}if(null!==O)var m=!0;else{var n=J(M);null!==n&&g(U,n.startTime-b);m=!1}return m}finally{O=null,P=c,Q=!1}}var W=k;exports.unstable_IdlePriority=5;
exports.unstable_ImmediatePriority=1;exports.unstable_LowPriority=4;exports.unstable_NormalPriority=3;exports.unstable_Profiling=null;exports.unstable_UserBlockingPriority=2;exports.unstable_cancelCallback=function(a){a.callback=null};exports.unstable_continueExecution=function(){R||Q||(R=!0,f(V))};exports.unstable_getCurrentPriorityLevel=function(){return P};exports.unstable_getFirstCallbackNode=function(){return J(L)};
exports.unstable_next=function(a){switch(P){case 1:case 2:case 3:var b=3;break;default:b=P}var c=P;P=b;try{return a()}finally{P=c}};exports.unstable_pauseExecution=function(){};exports.unstable_requestPaint=W;exports.unstable_runWithPriority=function(a,b){switch(a){case 1:case 2:case 3:case 4:case 5:break;default:a=3}var c=P;P=a;try{return b()}finally{P=c}};
exports.unstable_scheduleCallback=function(a,b,c){var d=exports.unstable_now();"object"===typeof c&&null!==c?(c=c.delay,c="number"===typeof c&&0<c?d+c:d):c=d;switch(a){case 1:var e=-1;break;case 2:e=250;break;case 5:e=1073741823;break;case 4:e=1E4;break;default:e=5E3}e=c+e;a={id:N++,callback:b,priorityLevel:a,startTime:c,expirationTime:e,sortIndex:-1};c>d?(a.sortIndex=c,H(M,a),null===J(L)&&a===J(M)&&(S?h():S=!0,g(U,c-d))):(a.sortIndex=e,H(L,a),R||Q||(R=!0,f(V)));return a};
exports.unstable_wrapCallback=function(a){var b=P;return function(){var c=P;P=b;try{return a.apply(this,arguments)}finally{P=c}}};


/***/ }),

/***/ 3840:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

"use strict";


if (true) {
  module.exports = __webpack_require__(53);
} else {}


/***/ }),

/***/ 8975:
/***/ ((module, exports, __webpack_require__) => {

var __WEBPACK_AMD_DEFINE_RESULT__;/* global window, exports, define */

!function() {
    'use strict'

    var re = {
        not_string: /[^s]/,
        not_bool: /[^t]/,
        not_type: /[^T]/,
        not_primitive: /[^v]/,
        number: /[diefg]/,
        numeric_arg: /[bcdiefguxX]/,
        json: /[j]/,
        not_json: /[^j]/,
        text: /^[^\x25]+/,
        modulo: /^\x25{2}/,
        placeholder: /^\x25(?:([1-9]\d*)\$|\(([^)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-gijostTuvxX])/,
        key: /^([a-z_][a-z_\d]*)/i,
        key_access: /^\.([a-z_][a-z_\d]*)/i,
        index_access: /^\[(\d+)\]/,
        sign: /^[+-]/
    }

    function sprintf(key) {
        // `arguments` is not an array, but should be fine for this call
        return sprintf_format(sprintf_parse(key), arguments)
    }

    function vsprintf(fmt, argv) {
        return sprintf.apply(null, [fmt].concat(argv || []))
    }

    function sprintf_format(parse_tree, argv) {
        var cursor = 1, tree_length = parse_tree.length, arg, output = '', i, k, ph, pad, pad_character, pad_length, is_positive, sign
        for (i = 0; i < tree_length; i++) {
            if (typeof parse_tree[i] === 'string') {
                output += parse_tree[i]
            }
            else if (typeof parse_tree[i] === 'object') {
                ph = parse_tree[i] // convenience purposes only
                if (ph.keys) { // keyword argument
                    arg = argv[cursor]
                    for (k = 0; k < ph.keys.length; k++) {
                        if (arg == undefined) {
                            throw new Error(sprintf('[sprintf] Cannot access property "%s" of undefined value "%s"', ph.keys[k], ph.keys[k-1]))
                        }
                        arg = arg[ph.keys[k]]
                    }
                }
                else if (ph.param_no) { // positional argument (explicit)
                    arg = argv[ph.param_no]
                }
                else { // positional argument (implicit)
                    arg = argv[cursor++]
                }

                if (re.not_type.test(ph.type) && re.not_primitive.test(ph.type) && arg instanceof Function) {
                    arg = arg()
                }

                if (re.numeric_arg.test(ph.type) && (typeof arg !== 'number' && isNaN(arg))) {
                    throw new TypeError(sprintf('[sprintf] expecting number but found %T', arg))
                }

                if (re.number.test(ph.type)) {
                    is_positive = arg >= 0
                }

                switch (ph.type) {
                    case 'b':
                        arg = parseInt(arg, 10).toString(2)
                        break
                    case 'c':
                        arg = String.fromCharCode(parseInt(arg, 10))
                        break
                    case 'd':
                    case 'i':
                        arg = parseInt(arg, 10)
                        break
                    case 'j':
                        arg = JSON.stringify(arg, null, ph.width ? parseInt(ph.width) : 0)
                        break
                    case 'e':
                        arg = ph.precision ? parseFloat(arg).toExponential(ph.precision) : parseFloat(arg).toExponential()
                        break
                    case 'f':
                        arg = ph.precision ? parseFloat(arg).toFixed(ph.precision) : parseFloat(arg)
                        break
                    case 'g':
                        arg = ph.precision ? String(Number(arg.toPrecision(ph.precision))) : parseFloat(arg)
                        break
                    case 'o':
                        arg = (parseInt(arg, 10) >>> 0).toString(8)
                        break
                    case 's':
                        arg = String(arg)
                        arg = (ph.precision ? arg.substring(0, ph.precision) : arg)
                        break
                    case 't':
                        arg = String(!!arg)
                        arg = (ph.precision ? arg.substring(0, ph.precision) : arg)
                        break
                    case 'T':
                        arg = Object.prototype.toString.call(arg).slice(8, -1).toLowerCase()
                        arg = (ph.precision ? arg.substring(0, ph.precision) : arg)
                        break
                    case 'u':
                        arg = parseInt(arg, 10) >>> 0
                        break
                    case 'v':
                        arg = arg.valueOf()
                        arg = (ph.precision ? arg.substring(0, ph.precision) : arg)
                        break
                    case 'x':
                        arg = (parseInt(arg, 10) >>> 0).toString(16)
                        break
                    case 'X':
                        arg = (parseInt(arg, 10) >>> 0).toString(16).toUpperCase()
                        break
                }
                if (re.json.test(ph.type)) {
                    output += arg
                }
                else {
                    if (re.number.test(ph.type) && (!is_positive || ph.sign)) {
                        sign = is_positive ? '+' : '-'
                        arg = arg.toString().replace(re.sign, '')
                    }
                    else {
                        sign = ''
                    }
                    pad_character = ph.pad_char ? ph.pad_char === '0' ? '0' : ph.pad_char.charAt(1) : ' '
                    pad_length = ph.width - (sign + arg).length
                    pad = ph.width ? (pad_length > 0 ? pad_character.repeat(pad_length) : '') : ''
                    output += ph.align ? sign + arg + pad : (pad_character === '0' ? sign + pad + arg : pad + sign + arg)
                }
            }
        }
        return output
    }

    var sprintf_cache = Object.create(null)

    function sprintf_parse(fmt) {
        if (sprintf_cache[fmt]) {
            return sprintf_cache[fmt]
        }

        var _fmt = fmt, match, parse_tree = [], arg_names = 0
        while (_fmt) {
            if ((match = re.text.exec(_fmt)) !== null) {
                parse_tree.push(match[0])
            }
            else if ((match = re.modulo.exec(_fmt)) !== null) {
                parse_tree.push('%')
            }
            else if ((match = re.placeholder.exec(_fmt)) !== null) {
                if (match[2]) {
                    arg_names |= 1
                    var field_list = [], replacement_field = match[2], field_match = []
                    if ((field_match = re.key.exec(replacement_field)) !== null) {
                        field_list.push(field_match[1])
                        while ((replacement_field = replacement_field.substring(field_match[0].length)) !== '') {
                            if ((field_match = re.key_access.exec(replacement_field)) !== null) {
                                field_list.push(field_match[1])
                            }
                            else if ((field_match = re.index_access.exec(replacement_field)) !== null) {
                                field_list.push(field_match[1])
                            }
                            else {
                                throw new SyntaxError('[sprintf] failed to parse named argument key')
                            }
                        }
                    }
                    else {
                        throw new SyntaxError('[sprintf] failed to parse named argument key')
                    }
                    match[2] = field_list
                }
                else {
                    arg_names |= 2
                }
                if (arg_names === 3) {
                    throw new Error('[sprintf] mixing positional and named placeholders is not (yet) supported')
                }

                parse_tree.push(
                    {
                        placeholder: match[0],
                        param_no:    match[1],
                        keys:        match[2],
                        sign:        match[3],
                        pad_char:    match[4],
                        align:       match[5],
                        width:       match[6],
                        precision:   match[7],
                        type:        match[8]
                    }
                )
            }
            else {
                throw new SyntaxError('[sprintf] unexpected placeholder')
            }
            _fmt = _fmt.substring(match[0].length)
        }
        return sprintf_cache[fmt] = parse_tree
    }

    /**
     * export to either browser or node.js
     */
    /* eslint-disable quote-props */
    if (true) {
        exports.sprintf = sprintf
        exports.vsprintf = vsprintf
    }
    if (typeof window !== 'undefined') {
        window['sprintf'] = sprintf
        window['vsprintf'] = vsprintf

        if (true) {
            !(__WEBPACK_AMD_DEFINE_RESULT__ = (function() {
                return {
                    'sprintf': sprintf,
                    'vsprintf': vsprintf
                }
            }).call(exports, __webpack_require__, exports, module),
		__WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__))
        }
    }
    /* eslint-enable quote-props */
}(); // eslint-disable-line


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			loaded: false,
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/create fake namespace object */
/******/ 	(() => {
/******/ 		var getProto = Object.getPrototypeOf ? (obj) => (Object.getPrototypeOf(obj)) : (obj) => (obj.__proto__);
/******/ 		var leafPrototypes;
/******/ 		// create a fake namespace object
/******/ 		// mode & 1: value is a module id, require it
/******/ 		// mode & 2: merge all properties of value into the ns
/******/ 		// mode & 4: return value when already ns object
/******/ 		// mode & 16: return value when it's Promise-like
/******/ 		// mode & 8|1: behave like require
/******/ 		__webpack_require__.t = function(value, mode) {
/******/ 			if(mode & 1) value = this(value);
/******/ 			if(mode & 8) return value;
/******/ 			if(typeof value === 'object' && value) {
/******/ 				if((mode & 4) && value.__esModule) return value;
/******/ 				if((mode & 16) && typeof value.then === 'function') return value;
/******/ 			}
/******/ 			var ns = Object.create(null);
/******/ 			__webpack_require__.r(ns);
/******/ 			var def = {};
/******/ 			leafPrototypes = leafPrototypes || [null, getProto({}), getProto([]), getProto(getProto)];
/******/ 			for(var current = mode & 2 && value; typeof current == 'object' && !~leafPrototypes.indexOf(current); current = getProto(current)) {
/******/ 				Object.getOwnPropertyNames(current).forEach((key) => (def[key] = () => (value[key])));
/******/ 			}
/******/ 			def['default'] = () => (value);
/******/ 			__webpack_require__.d(ns, def);
/******/ 			return ns;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/node module decorator */
/******/ 	(() => {
/******/ 		__webpack_require__.nmd = (module) => {
/******/ 			module.paths = [];
/******/ 			if (!module.children) module.children = [];
/******/ 			return module;
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";

// NAMESPACE OBJECT: ./node_modules/@wordpress/dom/build-module/focusable.js
var focusable_namespaceObject = {};
__webpack_require__.r(focusable_namespaceObject);
__webpack_require__.d(focusable_namespaceObject, {
  "find": () => (find)
});

// NAMESPACE OBJECT: ./node_modules/@wordpress/dom/build-module/tabbable.js
var tabbable_namespaceObject = {};
__webpack_require__.r(tabbable_namespaceObject);
__webpack_require__.d(tabbable_namespaceObject, {
  "find": () => (tabbable_find),
  "findNext": () => (findNext),
  "findPrevious": () => (findPrevious),
  "isTabbableIndex": () => (isTabbableIndex)
});

// NAMESPACE OBJECT: ./node_modules/@wordpress/components/build-module/text/styles.js
var text_styles_namespaceObject = {};
__webpack_require__.r(text_styles_namespaceObject);
__webpack_require__.d(text_styles_namespaceObject, {
  "Text": () => (Text),
  "block": () => (styles_block),
  "destructive": () => (destructive),
  "highlighterText": () => (highlighterText),
  "muted": () => (muted),
  "positive": () => (positive),
  "upperCase": () => (upperCase)
});

;// CONCATENATED MODULE: ./assets/app/dev/common/highlight-menu-item.ts
function highlightMenuItem(key) {
  var menuItem = document.querySelector("#vf-menu-item-".concat(key));
  var submenu = document.querySelectorAll('li.toplevel_page_vendorfuel ul li');

  if (menuItem) {
    submenu.forEach(function (element) {
      element.classList.remove('current');
    });
    menuItem.parentElement.parentElement.classList.add('current');
  }
}
// EXTERNAL MODULE: ./node_modules/react2angular/index.js
var react2angular = __webpack_require__(6563);
// EXTERNAL MODULE: ./node_modules/react/index.js
var react = __webpack_require__(7294);
var react_namespaceObject = /*#__PURE__*/__webpack_require__.t(react, 2);
;// CONCATENATED MODULE: ./node_modules/@babel/runtime/helpers/esm/extends.js
function extends_extends() {
  extends_extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };
  return extends_extends.apply(this, arguments);
}
;// CONCATENATED MODULE: ./node_modules/@emotion/sheet/dist/emotion-sheet.browser.esm.js
/*

Based off glamor's StyleSheet, thanks Sunil ❤️

high performance StyleSheet for css-in-js systems

- uses multiple style tags behind the scenes for millions of rules
- uses `insertRule` for appending in production for *much* faster performance

// usage

import { StyleSheet } from '@emotion/sheet'

let styleSheet = new StyleSheet({ key: '', container: document.head })

styleSheet.insert('#box { border: 1px solid red; }')
- appends a css rule into the stylesheet

styleSheet.flush()
- empties the stylesheet of all its contents

*/
// $FlowFixMe
function sheetForTag(tag) {
  if (tag.sheet) {
    // $FlowFixMe
    return tag.sheet;
  } // this weirdness brought to you by firefox

  /* istanbul ignore next */


  for (var i = 0; i < document.styleSheets.length; i++) {
    if (document.styleSheets[i].ownerNode === tag) {
      // $FlowFixMe
      return document.styleSheets[i];
    }
  }
}

function createStyleElement(options) {
  var tag = document.createElement('style');
  tag.setAttribute('data-emotion', options.key);

  if (options.nonce !== undefined) {
    tag.setAttribute('nonce', options.nonce);
  }

  tag.appendChild(document.createTextNode(''));
  tag.setAttribute('data-s', '');
  return tag;
}

var StyleSheet = /*#__PURE__*/function () {
  // Using Node instead of HTMLElement since container may be a ShadowRoot
  function StyleSheet(options) {
    var _this = this;

    this._insertTag = function (tag) {
      var before;

      if (_this.tags.length === 0) {
        if (_this.insertionPoint) {
          before = _this.insertionPoint.nextSibling;
        } else if (_this.prepend) {
          before = _this.container.firstChild;
        } else {
          before = _this.before;
        }
      } else {
        before = _this.tags[_this.tags.length - 1].nextSibling;
      }

      _this.container.insertBefore(tag, before);

      _this.tags.push(tag);
    };

    this.isSpeedy = options.speedy === undefined ? "production" === 'production' : options.speedy;
    this.tags = [];
    this.ctr = 0;
    this.nonce = options.nonce; // key is the value of the data-emotion attribute, it's used to identify different sheets

    this.key = options.key;
    this.container = options.container;
    this.prepend = options.prepend;
    this.insertionPoint = options.insertionPoint;
    this.before = null;
  }

  var _proto = StyleSheet.prototype;

  _proto.hydrate = function hydrate(nodes) {
    nodes.forEach(this._insertTag);
  };

  _proto.insert = function insert(rule) {
    // the max length is how many rules we have per style tag, it's 65000 in speedy mode
    // it's 1 in dev because we insert source maps that map a single rule to a location
    // and you can only have one source map per style tag
    if (this.ctr % (this.isSpeedy ? 65000 : 1) === 0) {
      this._insertTag(createStyleElement(this));
    }

    var tag = this.tags[this.tags.length - 1];

    if (false) { var isImportRule; }

    if (this.isSpeedy) {
      var sheet = sheetForTag(tag);

      try {
        // this is the ultrafast version, works across browsers
        // the big drawback is that the css won't be editable in devtools
        sheet.insertRule(rule, sheet.cssRules.length);
      } catch (e) {
        if (false) {}
      }
    } else {
      tag.appendChild(document.createTextNode(rule));
    }

    this.ctr++;
  };

  _proto.flush = function flush() {
    // $FlowFixMe
    this.tags.forEach(function (tag) {
      return tag.parentNode && tag.parentNode.removeChild(tag);
    });
    this.tags = [];
    this.ctr = 0;

    if (false) {}
  };

  return StyleSheet;
}();



;// CONCATENATED MODULE: ./node_modules/stylis/src/Utility.js
/**
 * @param {number}
 * @return {number}
 */
var abs = Math.abs

/**
 * @param {number}
 * @return {string}
 */
var Utility_from = String.fromCharCode

/**
 * @param {object}
 * @return {object}
 */
var Utility_assign = Object.assign

/**
 * @param {string} value
 * @param {number} length
 * @return {number}
 */
function hash (value, length) {
	return (((((((length << 2) ^ Utility_charat(value, 0)) << 2) ^ Utility_charat(value, 1)) << 2) ^ Utility_charat(value, 2)) << 2) ^ Utility_charat(value, 3)
}

/**
 * @param {string} value
 * @return {string}
 */
function trim (value) {
	return value.trim()
}

/**
 * @param {string} value
 * @param {RegExp} pattern
 * @return {string?}
 */
function match (value, pattern) {
	return (value = pattern.exec(value)) ? value[0] : value
}

/**
 * @param {string} value
 * @param {(string|RegExp)} pattern
 * @param {string} replacement
 * @return {string}
 */
function replace (value, pattern, replacement) {
	return value.replace(pattern, replacement)
}

/**
 * @param {string} value
 * @param {string} search
 * @return {number}
 */
function indexof (value, search) {
	return value.indexOf(search)
}

/**
 * @param {string} value
 * @param {number} index
 * @return {number}
 */
function Utility_charat (value, index) {
	return value.charCodeAt(index) | 0
}

/**
 * @param {string} value
 * @param {number} begin
 * @param {number} end
 * @return {string}
 */
function Utility_substr (value, begin, end) {
	return value.slice(begin, end)
}

/**
 * @param {string} value
 * @return {number}
 */
function Utility_strlen (value) {
	return value.length
}

/**
 * @param {any[]} value
 * @return {number}
 */
function Utility_sizeof (value) {
	return value.length
}

/**
 * @param {any} value
 * @param {any[]} array
 * @return {any}
 */
function Utility_append (value, array) {
	return array.push(value), value
}

/**
 * @param {string[]} array
 * @param {function} callback
 * @return {string}
 */
function Utility_combine (array, callback) {
	return array.map(callback).join('')
}

;// CONCATENATED MODULE: ./node_modules/stylis/src/Tokenizer.js


var line = 1
var column = 1
var Tokenizer_length = 0
var position = 0
var character = 0
var characters = ''

/**
 * @param {string} value
 * @param {object | null} root
 * @param {object | null} parent
 * @param {string} type
 * @param {string[] | string} props
 * @param {object[] | string} children
 * @param {number} length
 */
function node (value, root, parent, type, props, children, length) {
	return {value: value, root: root, parent: parent, type: type, props: props, children: children, line: line, column: column, length: length, return: ''}
}

/**
 * @param {object} root
 * @param {object} props
 * @return {object}
 */
function copy (root, props) {
	return Utility_assign(node('', null, null, '', null, null, 0), root, {length: -root.length}, props)
}

/**
 * @return {number}
 */
function Tokenizer_char () {
	return character
}

/**
 * @return {number}
 */
function prev () {
	character = position > 0 ? Utility_charat(characters, --position) : 0

	if (column--, character === 10)
		column = 1, line--

	return character
}

/**
 * @return {number}
 */
function next () {
	character = position < Tokenizer_length ? Utility_charat(characters, position++) : 0

	if (column++, character === 10)
		column = 1, line++

	return character
}

/**
 * @return {number}
 */
function peek () {
	return Utility_charat(characters, position)
}

/**
 * @return {number}
 */
function caret () {
	return position
}

/**
 * @param {number} begin
 * @param {number} end
 * @return {string}
 */
function slice (begin, end) {
	return Utility_substr(characters, begin, end)
}

/**
 * @param {number} type
 * @return {number}
 */
function token (type) {
	switch (type) {
		// \0 \t \n \r \s whitespace token
		case 0: case 9: case 10: case 13: case 32:
			return 5
		// ! + , / > @ ~ isolate token
		case 33: case 43: case 44: case 47: case 62: case 64: case 126:
		// ; { } breakpoint token
		case 59: case 123: case 125:
			return 4
		// : accompanied token
		case 58:
			return 3
		// " ' ( [ opening delimit token
		case 34: case 39: case 40: case 91:
			return 2
		// ) ] closing delimit token
		case 41: case 93:
			return 1
	}

	return 0
}

/**
 * @param {string} value
 * @return {any[]}
 */
function alloc (value) {
	return line = column = 1, Tokenizer_length = Utility_strlen(characters = value), position = 0, []
}

/**
 * @param {any} value
 * @return {any}
 */
function dealloc (value) {
	return characters = '', value
}

/**
 * @param {number} type
 * @return {string}
 */
function delimit (type) {
	return trim(slice(position - 1, delimiter(type === 91 ? type + 2 : type === 40 ? type + 1 : type)))
}

/**
 * @param {string} value
 * @return {string[]}
 */
function Tokenizer_tokenize (value) {
	return dealloc(tokenizer(alloc(value)))
}

/**
 * @param {number} type
 * @return {string}
 */
function whitespace (type) {
	while (character = peek())
		if (character < 33)
			next()
		else
			break

	return token(type) > 2 || token(character) > 3 ? '' : ' '
}

/**
 * @param {string[]} children
 * @return {string[]}
 */
function tokenizer (children) {
	while (next())
		switch (token(character)) {
			case 0: append(identifier(position - 1), children)
				break
			case 2: append(delimit(character), children)
				break
			default: append(from(character), children)
		}

	return children
}

/**
 * @param {number} index
 * @param {number} count
 * @return {string}
 */
function escaping (index, count) {
	while (--count && next())
		// not 0-9 A-F a-f
		if (character < 48 || character > 102 || (character > 57 && character < 65) || (character > 70 && character < 97))
			break

	return slice(index, caret() + (count < 6 && peek() == 32 && next() == 32))
}

/**
 * @param {number} type
 * @return {number}
 */
function delimiter (type) {
	while (next())
		switch (character) {
			// ] ) " '
			case type:
				return position
			// " '
			case 34: case 39:
				if (type !== 34 && type !== 39)
					delimiter(character)
				break
			// (
			case 40:
				if (type === 41)
					delimiter(type)
				break
			// \
			case 92:
				next()
				break
		}

	return position
}

/**
 * @param {number} type
 * @param {number} index
 * @return {number}
 */
function commenter (type, index) {
	while (next())
		// //
		if (type + character === 47 + 10)
			break
		// /*
		else if (type + character === 42 + 42 && peek() === 47)
			break

	return '/*' + slice(index, position - 1) + '*' + Utility_from(type === 47 ? type : next())
}

/**
 * @param {number} index
 * @return {string}
 */
function identifier (index) {
	while (!token(peek()))
		next()

	return slice(index, position)
}

;// CONCATENATED MODULE: ./node_modules/stylis/src/Enum.js
var MS = '-ms-'
var MOZ = '-moz-'
var WEBKIT = '-webkit-'

var COMMENT = 'comm'
var Enum_RULESET = 'rule'
var DECLARATION = 'decl'

var PAGE = '@page'
var MEDIA = '@media'
var IMPORT = '@import'
var CHARSET = '@charset'
var VIEWPORT = '@viewport'
var SUPPORTS = '@supports'
var DOCUMENT = '@document'
var NAMESPACE = '@namespace'
var KEYFRAMES = '@keyframes'
var FONT_FACE = '@font-face'
var COUNTER_STYLE = '@counter-style'
var FONT_FEATURE_VALUES = '@font-feature-values'

;// CONCATENATED MODULE: ./node_modules/stylis/src/Serializer.js



/**
 * @param {object[]} children
 * @param {function} callback
 * @return {string}
 */
function serialize (children, callback) {
	var output = ''
	var length = Utility_sizeof(children)

	for (var i = 0; i < length; i++)
		output += callback(children[i], i, children, callback) || ''

	return output
}

/**
 * @param {object} element
 * @param {number} index
 * @param {object[]} children
 * @param {function} callback
 * @return {string}
 */
function stringify (element, index, children, callback) {
	switch (element.type) {
		case IMPORT: case DECLARATION: return element.return = element.return || element.value
		case COMMENT: return ''
		case KEYFRAMES: return element.return = element.value + '{' + serialize(element.children, callback) + '}'
		case Enum_RULESET: element.value = element.props.join(',')
	}

	return Utility_strlen(children = serialize(element.children, callback)) ? element.return = element.value + '{' + children + '}' : ''
}

;// CONCATENATED MODULE: ./node_modules/stylis/src/Prefixer.js



/**
 * @param {string} value
 * @param {number} length
 * @return {string}
 */
function prefix (value, length) {
	switch (hash(value, length)) {
		// color-adjust
		case 5103:
			return WEBKIT + 'print-' + value + value
		// animation, animation-(delay|direction|duration|fill-mode|iteration-count|name|play-state|timing-function)
		case 5737: case 4201: case 3177: case 3433: case 1641: case 4457: case 2921:
		// text-decoration, filter, clip-path, backface-visibility, column, box-decoration-break
		case 5572: case 6356: case 5844: case 3191: case 6645: case 3005:
		// mask, mask-image, mask-(mode|clip|size), mask-(repeat|origin), mask-position, mask-composite,
		case 6391: case 5879: case 5623: case 6135: case 4599: case 4855:
		// background-clip, columns, column-(count|fill|gap|rule|rule-color|rule-style|rule-width|span|width)
		case 4215: case 6389: case 5109: case 5365: case 5621: case 3829:
			return WEBKIT + value + value
		// appearance, user-select, transform, hyphens, text-size-adjust
		case 5349: case 4246: case 4810: case 6968: case 2756:
			return WEBKIT + value + MOZ + value + MS + value + value
		// flex, flex-direction
		case 6828: case 4268:
			return WEBKIT + value + MS + value + value
		// order
		case 6165:
			return WEBKIT + value + MS + 'flex-' + value + value
		// align-items
		case 5187:
			return WEBKIT + value + replace(value, /(\w+).+(:[^]+)/, WEBKIT + 'box-$1$2' + MS + 'flex-$1$2') + value
		// align-self
		case 5443:
			return WEBKIT + value + MS + 'flex-item-' + replace(value, /flex-|-self/, '') + value
		// align-content
		case 4675:
			return WEBKIT + value + MS + 'flex-line-pack' + replace(value, /align-content|flex-|-self/, '') + value
		// flex-shrink
		case 5548:
			return WEBKIT + value + MS + replace(value, 'shrink', 'negative') + value
		// flex-basis
		case 5292:
			return WEBKIT + value + MS + replace(value, 'basis', 'preferred-size') + value
		// flex-grow
		case 6060:
			return WEBKIT + 'box-' + replace(value, '-grow', '') + WEBKIT + value + MS + replace(value, 'grow', 'positive') + value
		// transition
		case 4554:
			return WEBKIT + replace(value, /([^-])(transform)/g, '$1' + WEBKIT + '$2') + value
		// cursor
		case 6187:
			return replace(replace(replace(value, /(zoom-|grab)/, WEBKIT + '$1'), /(image-set)/, WEBKIT + '$1'), value, '') + value
		// background, background-image
		case 5495: case 3959:
			return replace(value, /(image-set\([^]*)/, WEBKIT + '$1' + '$`$1')
		// justify-content
		case 4968:
			return replace(replace(value, /(.+:)(flex-)?(.*)/, WEBKIT + 'box-pack:$3' + MS + 'flex-pack:$3'), /s.+-b[^;]+/, 'justify') + WEBKIT + value + value
		// (margin|padding)-inline-(start|end)
		case 4095: case 3583: case 4068: case 2532:
			return replace(value, /(.+)-inline(.+)/, WEBKIT + '$1$2') + value
		// (min|max)?(width|height|inline-size|block-size)
		case 8116: case 7059: case 5753: case 5535:
		case 5445: case 5701: case 4933: case 4677:
		case 5533: case 5789: case 5021: case 4765:
			// stretch, max-content, min-content, fill-available
			if (Utility_strlen(value) - 1 - length > 6)
				switch (Utility_charat(value, length + 1)) {
					// (m)ax-content, (m)in-content
					case 109:
						// -
						if (Utility_charat(value, length + 4) !== 45)
							break
					// (f)ill-available, (f)it-content
					case 102:
						return replace(value, /(.+:)(.+)-([^]+)/, '$1' + WEBKIT + '$2-$3' + '$1' + MOZ + (Utility_charat(value, length + 3) == 108 ? '$3' : '$2-$3')) + value
					// (s)tretch
					case 115:
						return ~indexof(value, 'stretch') ? prefix(replace(value, 'stretch', 'fill-available'), length) + value : value
				}
			break
		// position: sticky
		case 4949:
			// (s)ticky?
			if (Utility_charat(value, length + 1) !== 115)
				break
		// display: (flex|inline-flex)
		case 6444:
			switch (Utility_charat(value, Utility_strlen(value) - 3 - (~indexof(value, '!important') && 10))) {
				// stic(k)y
				case 107:
					return replace(value, ':', ':' + WEBKIT) + value
				// (inline-)?fl(e)x
				case 101:
					return replace(value, /(.+:)([^;!]+)(;|!.+)?/, '$1' + WEBKIT + (Utility_charat(value, 14) === 45 ? 'inline-' : '') + 'box$3' + '$1' + WEBKIT + '$2$3' + '$1' + MS + '$2box$3') + value
			}
			break
		// writing-mode
		case 5936:
			switch (Utility_charat(value, length + 11)) {
				// vertical-l(r)
				case 114:
					return WEBKIT + value + MS + replace(value, /[svh]\w+-[tblr]{2}/, 'tb') + value
				// vertical-r(l)
				case 108:
					return WEBKIT + value + MS + replace(value, /[svh]\w+-[tblr]{2}/, 'tb-rl') + value
				// horizontal(-)tb
				case 45:
					return WEBKIT + value + MS + replace(value, /[svh]\w+-[tblr]{2}/, 'lr') + value
			}

			return WEBKIT + value + MS + value + value
	}

	return value
}

;// CONCATENATED MODULE: ./node_modules/stylis/src/Middleware.js






/**
 * @param {function[]} collection
 * @return {function}
 */
function middleware (collection) {
	var length = Utility_sizeof(collection)

	return function (element, index, children, callback) {
		var output = ''

		for (var i = 0; i < length; i++)
			output += collection[i](element, index, children, callback) || ''

		return output
	}
}

/**
 * @param {function} callback
 * @return {function}
 */
function rulesheet (callback) {
	return function (element) {
		if (!element.root)
			if (element = element.return)
				callback(element)
	}
}

/**
 * @param {object} element
 * @param {number} index
 * @param {object[]} children
 * @param {function} callback
 */
function prefixer (element, index, children, callback) {
	if (element.length > -1)
		if (!element.return)
			switch (element.type) {
				case DECLARATION: element.return = prefix(element.value, element.length)
					break
				case KEYFRAMES:
					return serialize([copy(element, {value: replace(element.value, '@', '@' + WEBKIT)})], callback)
				case Enum_RULESET:
					if (element.length)
						return Utility_combine(element.props, function (value) {
							switch (match(value, /(::plac\w+|:read-\w+)/)) {
								// :read-(only|write)
								case ':read-only': case ':read-write':
									return serialize([copy(element, {props: [replace(value, /:(read-\w+)/, ':' + MOZ + '$1')]})], callback)
								// :placeholder
								case '::placeholder':
									return serialize([
										copy(element, {props: [replace(value, /:(plac\w+)/, ':' + WEBKIT + 'input-$1')]}),
										copy(element, {props: [replace(value, /:(plac\w+)/, ':' + MOZ + '$1')]}),
										copy(element, {props: [replace(value, /:(plac\w+)/, MS + 'input-$1')]})
									], callback)
							}

							return ''
						})
			}
}

/**
 * @param {object} element
 * @param {number} index
 * @param {object[]} children
 */
function namespace (element) {
	switch (element.type) {
		case RULESET:
			element.props = element.props.map(function (value) {
				return combine(tokenize(value), function (value, index, children) {
					switch (charat(value, 0)) {
						// \f
						case 12:
							return substr(value, 1, strlen(value))
						// \0 ( + > ~
						case 0: case 40: case 43: case 62: case 126:
							return value
						// :
						case 58:
							if (children[++index] === 'global')
								children[index] = '', children[++index] = '\f' + substr(children[index], index = 1, -1)
						// \s
						case 32:
							return index === 1 ? '' : value
						default:
							switch (index) {
								case 0: element = value
									return sizeof(children) > 1 ? '' : value
								case index = sizeof(children) - 1: case 2:
									return index === 2 ? value + element + element : value + element
								default:
									return value
							}
					}
				})
			})
	}
}

;// CONCATENATED MODULE: ./node_modules/stylis/src/Parser.js




/**
 * @param {string} value
 * @return {object[]}
 */
function compile (value) {
	return dealloc(parse('', null, null, null, [''], value = alloc(value), 0, [0], value))
}

/**
 * @param {string} value
 * @param {object} root
 * @param {object?} parent
 * @param {string[]} rule
 * @param {string[]} rules
 * @param {string[]} rulesets
 * @param {number[]} pseudo
 * @param {number[]} points
 * @param {string[]} declarations
 * @return {object}
 */
function parse (value, root, parent, rule, rules, rulesets, pseudo, points, declarations) {
	var index = 0
	var offset = 0
	var length = pseudo
	var atrule = 0
	var property = 0
	var previous = 0
	var variable = 1
	var scanning = 1
	var ampersand = 1
	var character = 0
	var type = ''
	var props = rules
	var children = rulesets
	var reference = rule
	var characters = type

	while (scanning)
		switch (previous = character, character = next()) {
			// (
			case 40:
				if (previous != 108 && characters.charCodeAt(length - 1) == 58) {
					if (indexof(characters += replace(delimit(character), '&', '&\f'), '&\f') != -1)
						ampersand = -1
					break
				}
			// " ' [
			case 34: case 39: case 91:
				characters += delimit(character)
				break
			// \t \n \r \s
			case 9: case 10: case 13: case 32:
				characters += whitespace(previous)
				break
			// \
			case 92:
				characters += escaping(caret() - 1, 7)
				continue
			// /
			case 47:
				switch (peek()) {
					case 42: case 47:
						Utility_append(comment(commenter(next(), caret()), root, parent), declarations)
						break
					default:
						characters += '/'
				}
				break
			// {
			case 123 * variable:
				points[index++] = Utility_strlen(characters) * ampersand
			// } ; \0
			case 125 * variable: case 59: case 0:
				switch (character) {
					// \0 }
					case 0: case 125: scanning = 0
					// ;
					case 59 + offset:
						if (property > 0 && (Utility_strlen(characters) - length))
							Utility_append(property > 32 ? declaration(characters + ';', rule, parent, length - 1) : declaration(replace(characters, ' ', '') + ';', rule, parent, length - 2), declarations)
						break
					// @ ;
					case 59: characters += ';'
					// { rule/at-rule
					default:
						Utility_append(reference = ruleset(characters, root, parent, index, offset, rules, points, type, props = [], children = [], length), rulesets)

						if (character === 123)
							if (offset === 0)
								parse(characters, root, reference, reference, props, rulesets, length, points, children)
							else
								switch (atrule) {
									// d m s
									case 100: case 109: case 115:
										parse(value, reference, reference, rule && Utility_append(ruleset(value, reference, reference, 0, 0, rules, points, type, rules, props = [], length), children), rules, children, length, points, rule ? props : children)
										break
									default:
										parse(characters, reference, reference, reference, [''], children, 0, points, children)
								}
				}

				index = offset = property = 0, variable = ampersand = 1, type = characters = '', length = pseudo
				break
			// :
			case 58:
				length = 1 + Utility_strlen(characters), property = previous
			default:
				if (variable < 1)
					if (character == 123)
						--variable
					else if (character == 125 && variable++ == 0 && prev() == 125)
						continue

				switch (characters += Utility_from(character), character * variable) {
					// &
					case 38:
						ampersand = offset > 0 ? 1 : (characters += '\f', -1)
						break
					// ,
					case 44:
						points[index++] = (Utility_strlen(characters) - 1) * ampersand, ampersand = 1
						break
					// @
					case 64:
						// -
						if (peek() === 45)
							characters += delimit(next())

						atrule = peek(), offset = length = Utility_strlen(type = characters += identifier(caret())), character++
						break
					// -
					case 45:
						if (previous === 45 && Utility_strlen(characters) == 2)
							variable = 0
				}
		}

	return rulesets
}

/**
 * @param {string} value
 * @param {object} root
 * @param {object?} parent
 * @param {number} index
 * @param {number} offset
 * @param {string[]} rules
 * @param {number[]} points
 * @param {string} type
 * @param {string[]} props
 * @param {string[]} children
 * @param {number} length
 * @return {object}
 */
function ruleset (value, root, parent, index, offset, rules, points, type, props, children, length) {
	var post = offset - 1
	var rule = offset === 0 ? rules : ['']
	var size = Utility_sizeof(rule)

	for (var i = 0, j = 0, k = 0; i < index; ++i)
		for (var x = 0, y = Utility_substr(value, post + 1, post = abs(j = points[i])), z = value; x < size; ++x)
			if (z = trim(j > 0 ? rule[x] + ' ' + y : replace(y, /&\f/g, rule[x])))
				props[k++] = z

	return node(value, root, parent, offset === 0 ? Enum_RULESET : type, props, children, length)
}

/**
 * @param {number} value
 * @param {object} root
 * @param {object?} parent
 * @return {object}
 */
function comment (value, root, parent) {
	return node(value, root, parent, COMMENT, Utility_from(Tokenizer_char()), Utility_substr(value, 2, -2), 0)
}

/**
 * @param {string} value
 * @param {object} root
 * @param {object?} parent
 * @param {number} length
 * @return {object}
 */
function declaration (value, root, parent, length) {
	return node(value, root, parent, DECLARATION, Utility_substr(value, 0, length), Utility_substr(value, length + 1, -1), length)
}

;// CONCATENATED MODULE: ./node_modules/@emotion/cache/dist/emotion-cache.browser.esm.js





var last = function last(arr) {
  return arr.length ? arr[arr.length - 1] : null;
}; // based on https://github.com/thysultan/stylis.js/blob/e6843c373ebcbbfade25ebcc23f540ed8508da0a/src/Tokenizer.js#L239-L244


var identifierWithPointTracking = function identifierWithPointTracking(begin, points, index) {
  var previous = 0;
  var character = 0;

  while (true) {
    previous = character;
    character = peek(); // &\f

    if (previous === 38 && character === 12) {
      points[index] = 1;
    }

    if (token(character)) {
      break;
    }

    next();
  }

  return slice(begin, position);
};

var toRules = function toRules(parsed, points) {
  // pretend we've started with a comma
  var index = -1;
  var character = 44;

  do {
    switch (token(character)) {
      case 0:
        // &\f
        if (character === 38 && peek() === 12) {
          // this is not 100% correct, we don't account for literal sequences here - like for example quoted strings
          // stylis inserts \f after & to know when & where it should replace this sequence with the context selector
          // and when it should just concatenate the outer and inner selectors
          // it's very unlikely for this sequence to actually appear in a different context, so we just leverage this fact here
          points[index] = 1;
        }

        parsed[index] += identifierWithPointTracking(position - 1, points, index);
        break;

      case 2:
        parsed[index] += delimit(character);
        break;

      case 4:
        // comma
        if (character === 44) {
          // colon
          parsed[++index] = peek() === 58 ? '&\f' : '';
          points[index] = parsed[index].length;
          break;
        }

      // fallthrough

      default:
        parsed[index] += Utility_from(character);
    }
  } while (character = next());

  return parsed;
};

var getRules = function getRules(value, points) {
  return dealloc(toRules(alloc(value), points));
}; // WeakSet would be more appropriate, but only WeakMap is supported in IE11


var fixedElements = /* #__PURE__ */new WeakMap();
var compat = function compat(element) {
  if (element.type !== 'rule' || !element.parent || // positive .length indicates that this rule contains pseudo
  // negative .length indicates that this rule has been already prefixed
  element.length < 1) {
    return;
  }

  var value = element.value,
      parent = element.parent;
  var isImplicitRule = element.column === parent.column && element.line === parent.line;

  while (parent.type !== 'rule') {
    parent = parent.parent;
    if (!parent) return;
  } // short-circuit for the simplest case


  if (element.props.length === 1 && value.charCodeAt(0) !== 58
  /* colon */
  && !fixedElements.get(parent)) {
    return;
  } // if this is an implicitly inserted rule (the one eagerly inserted at the each new nested level)
  // then the props has already been manipulated beforehand as they that array is shared between it and its "rule parent"


  if (isImplicitRule) {
    return;
  }

  fixedElements.set(element, true);
  var points = [];
  var rules = getRules(value, points);
  var parentRules = parent.props;

  for (var i = 0, k = 0; i < rules.length; i++) {
    for (var j = 0; j < parentRules.length; j++, k++) {
      element.props[k] = points[i] ? rules[i].replace(/&\f/g, parentRules[j]) : parentRules[j] + " " + rules[i];
    }
  }
};
var removeLabel = function removeLabel(element) {
  if (element.type === 'decl') {
    var value = element.value;

    if ( // charcode for l
    value.charCodeAt(0) === 108 && // charcode for b
    value.charCodeAt(2) === 98) {
      // this ignores label
      element["return"] = '';
      element.value = '';
    }
  }
};
var ignoreFlag = 'emotion-disable-server-rendering-unsafe-selector-warning-please-do-not-use-this-the-warning-exists-for-a-reason';

var isIgnoringComment = function isIgnoringComment(element) {
  return !!element && element.type === 'comm' && element.children.indexOf(ignoreFlag) > -1;
};

var createUnsafeSelectorsAlarm = function createUnsafeSelectorsAlarm(cache) {
  return function (element, index, children) {
    if (element.type !== 'rule') return;
    var unsafePseudoClasses = element.value.match(/(:first|:nth|:nth-last)-child/g);

    if (unsafePseudoClasses && cache.compat !== true) {
      var prevElement = index > 0 ? children[index - 1] : null;

      if (prevElement && isIgnoringComment(last(prevElement.children))) {
        return;
      }

      unsafePseudoClasses.forEach(function (unsafePseudoClass) {
        console.error("The pseudo class \"" + unsafePseudoClass + "\" is potentially unsafe when doing server-side rendering. Try changing it to \"" + unsafePseudoClass.split('-child')[0] + "-of-type\".");
      });
    }
  };
};

var isImportRule = function isImportRule(element) {
  return element.type.charCodeAt(1) === 105 && element.type.charCodeAt(0) === 64;
};

var isPrependedWithRegularRules = function isPrependedWithRegularRules(index, children) {
  for (var i = index - 1; i >= 0; i--) {
    if (!isImportRule(children[i])) {
      return true;
    }
  }

  return false;
}; // use this to remove incorrect elements from further processing
// so they don't get handed to the `sheet` (or anything else)
// as that could potentially lead to additional logs which in turn could be overhelming to the user


var nullifyElement = function nullifyElement(element) {
  element.type = '';
  element.value = '';
  element["return"] = '';
  element.children = '';
  element.props = '';
};

var incorrectImportAlarm = function incorrectImportAlarm(element, index, children) {
  if (!isImportRule(element)) {
    return;
  }

  if (element.parent) {
    console.error("`@import` rules can't be nested inside other rules. Please move it to the top level and put it before regular rules. Keep in mind that they can only be used within global styles.");
    nullifyElement(element);
  } else if (isPrependedWithRegularRules(index, children)) {
    console.error("`@import` rules can't be after other rules. Please put your `@import` rules before your other rules.");
    nullifyElement(element);
  }
};

var defaultStylisPlugins = [prefixer];

var createCache = function createCache(options) {
  var key = options.key;

  if (false) {}

  if ( key === 'css') {
    var ssrStyles = document.querySelectorAll("style[data-emotion]:not([data-s])"); // get SSRed styles out of the way of React's hydration
    // document.head is a safe place to move them to(though note document.head is not necessarily the last place they will be)
    // note this very very intentionally targets all style elements regardless of the key to ensure
    // that creating a cache works inside of render of a React component

    Array.prototype.forEach.call(ssrStyles, function (node) {
      // we want to only move elements which have a space in the data-emotion attribute value
      // because that indicates that it is an Emotion 11 server-side rendered style elements
      // while we will already ignore Emotion 11 client-side inserted styles because of the :not([data-s]) part in the selector
      // Emotion 10 client-side inserted styles did not have data-s (but importantly did not have a space in their data-emotion attributes)
      // so checking for the space ensures that loading Emotion 11 after Emotion 10 has inserted some styles
      // will not result in the Emotion 10 styles being destroyed
      var dataEmotionAttribute = node.getAttribute('data-emotion');

      if (dataEmotionAttribute.indexOf(' ') === -1) {
        return;
      }
      document.head.appendChild(node);
      node.setAttribute('data-s', '');
    });
  }

  var stylisPlugins = options.stylisPlugins || defaultStylisPlugins;

  if (false) {}

  var inserted = {};
  var container;
  var nodesToHydrate = [];

  {
    container = options.container || document.head;
    Array.prototype.forEach.call( // this means we will ignore elements which don't have a space in them which
    // means that the style elements we're looking at are only Emotion 11 server-rendered style elements
    document.querySelectorAll("style[data-emotion^=\"" + key + " \"]"), function (node) {
      var attrib = node.getAttribute("data-emotion").split(' '); // $FlowFixMe

      for (var i = 1; i < attrib.length; i++) {
        inserted[attrib[i]] = true;
      }

      nodesToHydrate.push(node);
    });
  }

  var _insert;

  var omnipresentPlugins = [compat, removeLabel];

  if (false) {}

  {
    var currentSheet;
    var finalizingPlugins = [stringify,  false ? 0 : rulesheet(function (rule) {
      currentSheet.insert(rule);
    })];
    var serializer = middleware(omnipresentPlugins.concat(stylisPlugins, finalizingPlugins));

    var stylis = function stylis(styles) {
      return serialize(compile(styles), serializer);
    };

    _insert = function insert(selector, serialized, sheet, shouldCache) {
      currentSheet = sheet;

      if (false) {}

      stylis(selector ? selector + "{" + serialized.styles + "}" : serialized.styles);

      if (shouldCache) {
        cache.inserted[serialized.name] = true;
      }
    };
  }

  var cache = {
    key: key,
    sheet: new StyleSheet({
      key: key,
      container: container,
      nonce: options.nonce,
      speedy: options.speedy,
      prepend: options.prepend,
      insertionPoint: options.insertionPoint
    }),
    nonce: options.nonce,
    inserted: inserted,
    registered: {},
    insert: _insert
  };
  cache.sheet.hydrate(nodesToHydrate);
  return cache;
};

/* harmony default export */ const emotion_cache_browser_esm = (createCache);

// EXTERNAL MODULE: ./node_modules/hoist-non-react-statics/dist/hoist-non-react-statics.cjs.js
var hoist_non_react_statics_cjs = __webpack_require__(8679);
;// CONCATENATED MODULE: ./node_modules/@emotion/hash/dist/hash.browser.esm.js
/* eslint-disable */
// Inspired by https://github.com/garycourt/murmurhash-js
// Ported from https://github.com/aappleby/smhasher/blob/61a0530f28277f2e850bfc39600ce61d02b518de/src/MurmurHash2.cpp#L37-L86
function murmur2(str) {
  // 'm' and 'r' are mixing constants generated offline.
  // They're not really 'magic', they just happen to work well.
  // const m = 0x5bd1e995;
  // const r = 24;
  // Initialize the hash
  var h = 0; // Mix 4 bytes at a time into the hash

  var k,
      i = 0,
      len = str.length;

  for (; len >= 4; ++i, len -= 4) {
    k = str.charCodeAt(i) & 0xff | (str.charCodeAt(++i) & 0xff) << 8 | (str.charCodeAt(++i) & 0xff) << 16 | (str.charCodeAt(++i) & 0xff) << 24;
    k =
    /* Math.imul(k, m): */
    (k & 0xffff) * 0x5bd1e995 + ((k >>> 16) * 0xe995 << 16);
    k ^=
    /* k >>> r: */
    k >>> 24;
    h =
    /* Math.imul(k, m): */
    (k & 0xffff) * 0x5bd1e995 + ((k >>> 16) * 0xe995 << 16) ^
    /* Math.imul(h, m): */
    (h & 0xffff) * 0x5bd1e995 + ((h >>> 16) * 0xe995 << 16);
  } // Handle the last few bytes of the input array


  switch (len) {
    case 3:
      h ^= (str.charCodeAt(i + 2) & 0xff) << 16;

    case 2:
      h ^= (str.charCodeAt(i + 1) & 0xff) << 8;

    case 1:
      h ^= str.charCodeAt(i) & 0xff;
      h =
      /* Math.imul(h, m): */
      (h & 0xffff) * 0x5bd1e995 + ((h >>> 16) * 0xe995 << 16);
  } // Do a few final mixes of the hash to ensure the last few
  // bytes are well-incorporated.


  h ^= h >>> 13;
  h =
  /* Math.imul(h, m): */
  (h & 0xffff) * 0x5bd1e995 + ((h >>> 16) * 0xe995 << 16);
  return ((h ^ h >>> 15) >>> 0).toString(36);
}

/* harmony default export */ const hash_browser_esm = (murmur2);

;// CONCATENATED MODULE: ./node_modules/@emotion/unitless/dist/unitless.browser.esm.js
var unitlessKeys = {
  animationIterationCount: 1,
  borderImageOutset: 1,
  borderImageSlice: 1,
  borderImageWidth: 1,
  boxFlex: 1,
  boxFlexGroup: 1,
  boxOrdinalGroup: 1,
  columnCount: 1,
  columns: 1,
  flex: 1,
  flexGrow: 1,
  flexPositive: 1,
  flexShrink: 1,
  flexNegative: 1,
  flexOrder: 1,
  gridRow: 1,
  gridRowEnd: 1,
  gridRowSpan: 1,
  gridRowStart: 1,
  gridColumn: 1,
  gridColumnEnd: 1,
  gridColumnSpan: 1,
  gridColumnStart: 1,
  msGridRow: 1,
  msGridRowSpan: 1,
  msGridColumn: 1,
  msGridColumnSpan: 1,
  fontWeight: 1,
  lineHeight: 1,
  opacity: 1,
  order: 1,
  orphans: 1,
  tabSize: 1,
  widows: 1,
  zIndex: 1,
  zoom: 1,
  WebkitLineClamp: 1,
  // SVG-related properties
  fillOpacity: 1,
  floodOpacity: 1,
  stopOpacity: 1,
  strokeDasharray: 1,
  strokeDashoffset: 1,
  strokeMiterlimit: 1,
  strokeOpacity: 1,
  strokeWidth: 1
};

/* harmony default export */ const unitless_browser_esm = (unitlessKeys);

;// CONCATENATED MODULE: ./node_modules/@emotion/memoize/dist/emotion-memoize.browser.esm.js
function memoize(fn) {
  var cache = Object.create(null);
  return function (arg) {
    if (cache[arg] === undefined) cache[arg] = fn(arg);
    return cache[arg];
  };
}

/* harmony default export */ const emotion_memoize_browser_esm = (memoize);

;// CONCATENATED MODULE: ./node_modules/@emotion/serialize/dist/emotion-serialize.browser.esm.js




var ILLEGAL_ESCAPE_SEQUENCE_ERROR = "You have illegal escape sequence in your template literal, most likely inside content's property value.\nBecause you write your CSS inside a JavaScript string you actually have to do double escaping, so for example \"content: '\\00d7';\" should become \"content: '\\\\00d7';\".\nYou can read more about this here:\nhttps://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#ES2018_revision_of_illegal_escape_sequences";
var UNDEFINED_AS_OBJECT_KEY_ERROR = "You have passed in falsy value as style object's key (can happen when in example you pass unexported component as computed key).";
var hyphenateRegex = /[A-Z]|^ms/g;
var animationRegex = /_EMO_([^_]+?)_([^]*?)_EMO_/g;

var isCustomProperty = function isCustomProperty(property) {
  return property.charCodeAt(1) === 45;
};

var isProcessableValue = function isProcessableValue(value) {
  return value != null && typeof value !== 'boolean';
};

var processStyleName = /* #__PURE__ */emotion_memoize_browser_esm(function (styleName) {
  return isCustomProperty(styleName) ? styleName : styleName.replace(hyphenateRegex, '-$&').toLowerCase();
});

var processStyleValue = function processStyleValue(key, value) {
  switch (key) {
    case 'animation':
    case 'animationName':
      {
        if (typeof value === 'string') {
          return value.replace(animationRegex, function (match, p1, p2) {
            cursor = {
              name: p1,
              styles: p2,
              next: cursor
            };
            return p1;
          });
        }
      }
  }

  if (unitless_browser_esm[key] !== 1 && !isCustomProperty(key) && typeof value === 'number' && value !== 0) {
    return value + 'px';
  }

  return value;
};

if (false) { var hyphenatedCache, hyphenPattern, msPattern, oldProcessStyleValue, contentValues, contentValuePattern; }

var noComponentSelectorMessage = (/* unused pure expression or super */ null && ('Component selectors can only be used in conjunction with ' + '@emotion/babel-plugin, the swc Emotion plugin, or another Emotion-aware ' + 'compiler transform.'));

function handleInterpolation(mergedProps, registered, interpolation) {
  if (interpolation == null) {
    return '';
  }

  if (interpolation.__emotion_styles !== undefined) {
    if (false) {}

    return interpolation;
  }

  switch (typeof interpolation) {
    case 'boolean':
      {
        return '';
      }

    case 'object':
      {
        if (interpolation.anim === 1) {
          cursor = {
            name: interpolation.name,
            styles: interpolation.styles,
            next: cursor
          };
          return interpolation.name;
        }

        if (interpolation.styles !== undefined) {
          var next = interpolation.next;

          if (next !== undefined) {
            // not the most efficient thing ever but this is a pretty rare case
            // and there will be very few iterations of this generally
            while (next !== undefined) {
              cursor = {
                name: next.name,
                styles: next.styles,
                next: cursor
              };
              next = next.next;
            }
          }

          var styles = interpolation.styles + ";";

          if (false) {}

          return styles;
        }

        return createStringFromObject(mergedProps, registered, interpolation);
      }

    case 'function':
      {
        if (mergedProps !== undefined) {
          var previousCursor = cursor;
          var result = interpolation(mergedProps);
          cursor = previousCursor;
          return handleInterpolation(mergedProps, registered, result);
        } else if (false) {}

        break;
      }

    case 'string':
      if (false) { var replaced, matched; }

      break;
  } // finalize string values (regular strings and functions interpolated into css calls)


  if (registered == null) {
    return interpolation;
  }

  var cached = registered[interpolation];
  return cached !== undefined ? cached : interpolation;
}

function createStringFromObject(mergedProps, registered, obj) {
  var string = '';

  if (Array.isArray(obj)) {
    for (var i = 0; i < obj.length; i++) {
      string += handleInterpolation(mergedProps, registered, obj[i]) + ";";
    }
  } else {
    for (var _key in obj) {
      var value = obj[_key];

      if (typeof value !== 'object') {
        if (registered != null && registered[value] !== undefined) {
          string += _key + "{" + registered[value] + "}";
        } else if (isProcessableValue(value)) {
          string += processStyleName(_key) + ":" + processStyleValue(_key, value) + ";";
        }
      } else {
        if (_key === 'NO_COMPONENT_SELECTOR' && "production" !== 'production') {}

        if (Array.isArray(value) && typeof value[0] === 'string' && (registered == null || registered[value[0]] === undefined)) {
          for (var _i = 0; _i < value.length; _i++) {
            if (isProcessableValue(value[_i])) {
              string += processStyleName(_key) + ":" + processStyleValue(_key, value[_i]) + ";";
            }
          }
        } else {
          var interpolated = handleInterpolation(mergedProps, registered, value);

          switch (_key) {
            case 'animation':
            case 'animationName':
              {
                string += processStyleName(_key) + ":" + interpolated + ";";
                break;
              }

            default:
              {
                if (false) {}

                string += _key + "{" + interpolated + "}";
              }
          }
        }
      }
    }
  }

  return string;
}

var labelPattern = /label:\s*([^\s;\n{]+)\s*(;|$)/g;
var sourceMapPattern;

if (false) {} // this is the cursor for keyframes
// keyframes are stored on the SerializedStyles object as a linked list


var cursor;
var emotion_serialize_browser_esm_serializeStyles = function serializeStyles(args, registered, mergedProps) {
  if (args.length === 1 && typeof args[0] === 'object' && args[0] !== null && args[0].styles !== undefined) {
    return args[0];
  }

  var stringMode = true;
  var styles = '';
  cursor = undefined;
  var strings = args[0];

  if (strings == null || strings.raw === undefined) {
    stringMode = false;
    styles += handleInterpolation(mergedProps, registered, strings);
  } else {
    if (false) {}

    styles += strings[0];
  } // we start at 1 since we've already handled the first arg


  for (var i = 1; i < args.length; i++) {
    styles += handleInterpolation(mergedProps, registered, args[i]);

    if (stringMode) {
      if (false) {}

      styles += strings[i];
    }
  }

  var sourceMap;

  if (false) {} // using a global regex with .exec is stateful so lastIndex has to be reset each time


  labelPattern.lastIndex = 0;
  var identifierName = '';
  var match; // https://esbench.com/bench/5b809c2cf2949800a0f61fb5

  while ((match = labelPattern.exec(styles)) !== null) {
    identifierName += '-' + // $FlowFixMe we know it's not null
    match[1];
  }

  var name = hash_browser_esm(styles) + identifierName;

  if (false) {}

  return {
    name: name,
    styles: styles,
    next: cursor
  };
};



;// CONCATENATED MODULE: ./node_modules/@emotion/react/dist/emotion-react.browser.esm.js












var pkg = {
	name: "@emotion/react",
	version: "11.9.3",
	main: "dist/emotion-react.cjs.js",
	module: "dist/emotion-react.esm.js",
	browser: {
		"./dist/emotion-react.cjs.js": "./dist/emotion-react.browser.cjs.js",
		"./dist/emotion-react.esm.js": "./dist/emotion-react.browser.esm.js"
	},
	types: "types/index.d.ts",
	files: [
		"src",
		"dist",
		"jsx-runtime",
		"jsx-dev-runtime",
		"_isolated-hnrs",
		"types/*.d.ts",
		"macro.js",
		"macro.d.ts",
		"macro.js.flow"
	],
	sideEffects: false,
	author: "Emotion Contributors",
	license: "MIT",
	scripts: {
		"test:typescript": "dtslint types"
	},
	dependencies: {
		"@babel/runtime": "^7.13.10",
		"@emotion/babel-plugin": "^11.7.1",
		"@emotion/cache": "^11.9.3",
		"@emotion/serialize": "^1.0.4",
		"@emotion/utils": "^1.1.0",
		"@emotion/weak-memoize": "^0.2.5",
		"hoist-non-react-statics": "^3.3.1"
	},
	peerDependencies: {
		"@babel/core": "^7.0.0",
		react: ">=16.8.0"
	},
	peerDependenciesMeta: {
		"@babel/core": {
			optional: true
		},
		"@types/react": {
			optional: true
		}
	},
	devDependencies: {
		"@babel/core": "^7.13.10",
		"@definitelytyped/dtslint": "0.0.112",
		"@emotion/css": "11.9.0",
		"@emotion/css-prettifier": "1.0.1",
		"@emotion/server": "11.4.0",
		"@emotion/styled": "11.9.3",
		"html-tag-names": "^1.1.2",
		react: "16.14.0",
		"svg-tag-names": "^1.1.1",
		typescript: "^4.5.5"
	},
	repository: "https://github.com/emotion-js/emotion/tree/main/packages/react",
	publishConfig: {
		access: "public"
	},
	"umd:main": "dist/emotion-react.umd.min.js",
	preconstruct: {
		entrypoints: [
			"./index.js",
			"./jsx-runtime.js",
			"./jsx-dev-runtime.js",
			"./_isolated-hnrs.js"
		],
		umdName: "emotionReact"
	}
};

var jsx = function jsx(type, props) {
  var args = arguments;

  if (props == null || !hasOwnProperty.call(props, 'css')) {
    // $FlowFixMe
    return createElement.apply(undefined, args);
  }

  var argsLength = args.length;
  var createElementArgArray = new Array(argsLength);
  createElementArgArray[0] = Emotion;
  createElementArgArray[1] = createEmotionProps(type, props);

  for (var i = 2; i < argsLength; i++) {
    createElementArgArray[i] = args[i];
  } // $FlowFixMe


  return createElement.apply(null, createElementArgArray);
};

var useInsertionEffect = react_namespaceObject['useInsertion' + 'Effect'] ? react_namespaceObject['useInsertion' + 'Effect'] : react.useLayoutEffect;
var warnedAboutCssPropForGlobal = false; // maintain place over rerenders.
// initial render from browser, insertBefore context.sheet.tags[0] or if a style hasn't been inserted there yet, appendChild
// initial client-side render from SSR, use place of hydrating tag

var Global = /* #__PURE__ */(/* unused pure expression or super */ null && (withEmotionCache(function (props, cache) {
  if (false) {}

  var styles = props.styles;
  var serialized = serializeStyles([styles], undefined, useContext(ThemeContext));
  // but it is based on a constant that will never change at runtime
  // it's effectively like having two implementations and switching them out
  // so it's not actually breaking anything


  var sheetRef = useRef();
  useInsertionEffect(function () {
    var key = cache.key + "-global"; // use case of https://github.com/emotion-js/emotion/issues/2675

    var sheet = new cache.sheet.constructor({
      key: key,
      nonce: cache.sheet.nonce,
      container: cache.sheet.container,
      speedy: cache.sheet.isSpeedy
    });
    var rehydrating = false; // $FlowFixMe

    var node = document.querySelector("style[data-emotion=\"" + key + " " + serialized.name + "\"]");

    if (cache.sheet.tags.length) {
      sheet.before = cache.sheet.tags[0];
    }

    if (node !== null) {
      rehydrating = true; // clear the hash so this node won't be recognizable as rehydratable by other <Global/>s

      node.setAttribute('data-emotion', key);
      sheet.hydrate([node]);
    }

    sheetRef.current = [sheet, rehydrating];
    return function () {
      sheet.flush();
    };
  }, [cache]);
  useInsertionEffect(function () {
    var sheetRefCurrent = sheetRef.current;
    var sheet = sheetRefCurrent[0],
        rehydrating = sheetRefCurrent[1];

    if (rehydrating) {
      sheetRefCurrent[1] = false;
      return;
    }

    if (serialized.next !== undefined) {
      // insert keyframes
      insertStyles(cache, serialized.next, true);
    }

    if (sheet.tags.length) {
      // if this doesn't exist then it will be null so the style element will be appended
      var element = sheet.tags[sheet.tags.length - 1].nextElementSibling;
      sheet.before = element;
      sheet.flush();
    }

    cache.insert("", serialized, sheet, false);
  }, [cache, serialized.name]);
  return null;
})));

if (false) {}

function css() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  return emotion_serialize_browser_esm_serializeStyles(args);
}

var keyframes = function keyframes() {
  var insertable = css.apply(void 0, arguments);
  var name = "animation-" + insertable.name; // $FlowFixMe

  return {
    name: name,
    styles: "@keyframes " + name + "{" + insertable.styles + "}",
    anim: 1,
    toString: function toString() {
      return "_EMO_" + this.name + "_" + this.styles + "_EMO_";
    }
  };
};

var classnames = function classnames(args) {
  var len = args.length;
  var i = 0;
  var cls = '';

  for (; i < len; i++) {
    var arg = args[i];
    if (arg == null) continue;
    var toAdd = void 0;

    switch (typeof arg) {
      case 'boolean':
        break;

      case 'object':
        {
          if (Array.isArray(arg)) {
            toAdd = classnames(arg);
          } else {
            if (false) {}

            toAdd = '';

            for (var k in arg) {
              if (arg[k] && k) {
                toAdd && (toAdd += ' ');
                toAdd += k;
              }
            }
          }

          break;
        }

      default:
        {
          toAdd = arg;
        }
    }

    if (toAdd) {
      cls && (cls += ' ');
      cls += toAdd;
    }
  }

  return cls;
};

function merge(registered, css, className) {
  var registeredStyles = [];
  var rawClassName = getRegisteredStyles(registered, registeredStyles, className);

  if (registeredStyles.length < 2) {
    return className;
  }

  return rawClassName + css(registeredStyles);
}

var Insertion = function Insertion(_ref) {
  var cache = _ref.cache,
      serializedArr = _ref.serializedArr;
  var rules = useInsertionEffectMaybe(function () {

    for (var i = 0; i < serializedArr.length; i++) {
      var res = insertStyles(cache, serializedArr[i], false);
    }
  });

  return null;
};

var ClassNames = /* #__PURE__ */(/* unused pure expression or super */ null && (withEmotionCache(function (props, cache) {
  var hasRendered = false;
  var serializedArr = [];

  var css = function css() {
    if (hasRendered && "production" !== 'production') {}

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var serialized = serializeStyles(args, cache.registered);
    serializedArr.push(serialized); // registration has to happen here as the result of this might get consumed by `cx`

    registerStyles(cache, serialized, false);
    return cache.key + "-" + serialized.name;
  };

  var cx = function cx() {
    if (hasRendered && "production" !== 'production') {}

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return merge(cache.registered, css, classnames(args));
  };

  var content = {
    css: css,
    cx: cx,
    theme: useContext(ThemeContext)
  };
  var ele = props.children(content);
  hasRendered = true;
  return /*#__PURE__*/createElement(Fragment, null, /*#__PURE__*/createElement(Insertion, {
    cache: cache,
    serializedArr: serializedArr
  }), ele);
})));

if (false) {}

if (false) { var globalKey, globalContext, isJest, isBrowser; }



// EXTERNAL MODULE: ./node_modules/lodash/lodash.js
var lodash = __webpack_require__(6486);
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/context/context-system-provider.js


/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */



const ComponentsContext = (0,react.createContext)(
/** @type {Record<string, any>} */
{});
const useComponentsContext = () => (0,react.useContext)(ComponentsContext);
/**
 * Runs an effect only on update (i.e., ignores the first render)
 *
 * @param {import('react').EffectCallback} effect
 * @param {import('react').DependencyList} deps
 */

function useUpdateEffect(effect, deps) {
  const mounted = (0,react.useRef)(false);
  (0,react.useEffect)(() => {
    if (mounted.current) {
      return effect();
    }

    mounted.current = true;
    return undefined;
  }, deps);
}
/**
 * Consolidates incoming ContextSystem values with a (potential) parent ContextSystem value.
 *
 * Note: This function will warn if it detects an un-memoized `value`
 *
 * @param {Object}              props
 * @param {Record<string, any>} props.value
 * @return {Record<string, any>} The consolidated value.
 */


function useContextSystemBridge(_ref) {
  let {
    value
  } = _ref;
  const parentContext = useComponentsContext();
  const valueRef = (0,react.useRef)(value);
  useUpdateEffect(() => {
    if ( // Objects are equivalent.
    (0,lodash.isEqual)(valueRef.current, value) && // But not the same reference.
    valueRef.current !== value) {
      typeof process !== "undefined" && process.env && "production" !== "production" ? 0 : void 0;
    }
  }, [value]); // `parentContext` will always be memoized (i.e., the result of this hook itself)
  // or the default value from when the `ComponentsContext` was originally
  // initialized (which will never change, it's a static variable)
  // so this memoization will prevent `merge` and `cloneDeep` from rerunning unless
  // the references to `value` change OR the `parentContext` has an actual material change
  // (because again, it's guaranteed to be memoized or a static reference to the empty object
  // so we know that the only changes for `parentContext` are material ones... i.e., why we
  // don't have to warn in the `useUpdateEffect` hook above for `parentContext` and we only
  // need to bother with the `value`). The `useUpdateEffect` above will ensure that we are
  // correctly warning when the `value` isn't being properly memoized. All of that to say
  // that this should be super safe to assume that `useMemo` will only run on actual
  // changes to the two dependencies, therefore saving us calls to `merge` and `cloneDeep`!

  const config = (0,react.useMemo)(() => {
    return (0,lodash.merge)((0,lodash.cloneDeep)(parentContext), value);
  }, [parentContext, value]);
  return config;
}
/**
 * A Provider component that can modify props for connected components within
 * the Context system.
 *
 * @example
 * ```jsx
 * <ContextSystemProvider value={{ Button: { size: 'small' }}}>
 *   <Button>...</Button>
 * </ContextSystemProvider>
 * ```
 *
 * @template {Record<string, any>} T
 * @param {Object}                    options
 * @param {import('react').ReactNode} options.children Children to render.
 * @param {T}                         options.value    Props to render into connected components.
 * @return {JSX.Element} A Provider wrapped component.
 */


const BaseContextSystemProvider = _ref2 => {
  let {
    children,
    value
  } = _ref2;
  const contextValue = useContextSystemBridge({
    value
  });
  return (0,react.createElement)(ComponentsContext.Provider, {
    value: contextValue
  }, children);
};

const ContextSystemProvider = (0,react.memo)(BaseContextSystemProvider);
//# sourceMappingURL=context-system-provider.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/context/constants.js
const REACT_TYPEOF_KEY = '$$typeof';
const COMPONENT_NAMESPACE = 'data-wp-component';
const CONNECTED_NAMESPACE = 'data-wp-c16t';
const CONTEXT_COMPONENT_NAMESPACE = 'data-wp-c5tc8t';
/**
 * Special key where the connected namespaces are stored.
 * This is attached to Context connected components as a static property.
 */

const CONNECT_STATIC_NAMESPACE = '__contextSystemKey__';
//# sourceMappingURL=constants.js.map
// EXTERNAL MODULE: ./node_modules/memize/index.js
var memize = __webpack_require__(9588);
var memize_default = /*#__PURE__*/__webpack_require__.n(memize);
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/context/get-styled-class-name-from-key.js
/**
 * External dependencies
 */


/**
 * Generates the connected component CSS className based on the namespace.
 *
 * @param  namespace The name of the connected component.
 * @return The generated CSS className.
 */

function getStyledClassName(namespace) {
  const kebab = (0,lodash.kebabCase)(namespace);
  return `components-${kebab}`;
}

const getStyledClassNameFromKey = memize_default()(getStyledClassName);
//# sourceMappingURL=get-styled-class-name-from-key.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/context/context-connect.js
/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */




/**
 * Forwards ref (React.ForwardRef) and "Connects" (or registers) a component
 * within the Context system under a specified namespace.
 *
 * This is an (experimental) evolution of the initial connect() HOC.
 * The hope is that we can improve render performance by removing functional
 * component wrappers.
 *
 * @param  Component The component to register into the Context system.
 * @param  namespace The namespace to register the component under.
 * @param  options
 * @return The connected WordPressComponent
 */
function contextConnect(Component, namespace) {
  let options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  const {
    memo: memoProp = false
  } = options;
  let WrappedComponent = (0,react.forwardRef)(Component);

  if (memoProp) {
    // @ts-ignore
    WrappedComponent = (0,react.memo)(WrappedComponent);
  }

  if (typeof namespace === 'undefined') {
    typeof process !== "undefined" && process.env && "production" !== "production" ? 0 : void 0;
  } // @ts-ignore internal property


  let mergedNamespace = WrappedComponent[CONNECT_STATIC_NAMESPACE] || [namespace];
  /**
   * Consolidate (merge) namespaces before attaching it to the WrappedComponent.
   */

  if (Array.isArray(namespace)) {
    mergedNamespace = [...mergedNamespace, ...namespace];
  }

  if (typeof namespace === 'string') {
    mergedNamespace = [...mergedNamespace, namespace];
  }

  WrappedComponent.displayName = namespace; // @ts-ignore internal property

  WrappedComponent[CONNECT_STATIC_NAMESPACE] = (0,lodash.uniq)(mergedNamespace); // @ts-ignore WordPressComponent property

  WrappedComponent.selector = `.${getStyledClassNameFromKey(namespace)}`; // @ts-ignore

  return WrappedComponent;
}
/**
 * Attempts to retrieve the connected namespace from a component.
 *
 * @param  Component The component to retrieve a namespace from.
 * @return The connected namespaces.
 */

function getConnectNamespace(Component) {
  if (!Component) return [];
  let namespaces = []; // @ts-ignore internal property

  if (Component[CONNECT_STATIC_NAMESPACE]) {
    // @ts-ignore internal property
    namespaces = Component[CONNECT_STATIC_NAMESPACE];
  } // @ts-ignore


  if (Component.type && Component.type[CONNECT_STATIC_NAMESPACE]) {
    // @ts-ignore
    namespaces = Component.type[CONNECT_STATIC_NAMESPACE];
  }

  return namespaces;
}
/**
 * Checks to see if a component is connected within the Context system.
 *
 * @param  Component The component to retrieve a namespace from.
 * @param  match     The namespace to check.
 */

function hasConnectNamespace(Component, match) {
  if (!Component) return false;

  if (typeof match === 'string') {
    return getConnectNamespace(Component).includes(match);
  }

  if (Array.isArray(match)) {
    return match.some(result => getConnectNamespace(Component).includes(result));
  }

  return false;
}
//# sourceMappingURL=context-connect.js.map
;// CONCATENATED MODULE: ./node_modules/@emotion/is-prop-valid/dist/emotion-is-prop-valid.browser.esm.js


var reactPropsRegex = /^((children|dangerouslySetInnerHTML|key|ref|autoFocus|defaultValue|defaultChecked|innerHTML|suppressContentEditableWarning|suppressHydrationWarning|valueLink|abbr|accept|acceptCharset|accessKey|action|allow|allowUserMedia|allowPaymentRequest|allowFullScreen|allowTransparency|alt|async|autoComplete|autoPlay|capture|cellPadding|cellSpacing|challenge|charSet|checked|cite|classID|className|cols|colSpan|content|contentEditable|contextMenu|controls|controlsList|coords|crossOrigin|data|dateTime|decoding|default|defer|dir|disabled|disablePictureInPicture|download|draggable|encType|enterKeyHint|form|formAction|formEncType|formMethod|formNoValidate|formTarget|frameBorder|headers|height|hidden|high|href|hrefLang|htmlFor|httpEquiv|id|inputMode|integrity|is|keyParams|keyType|kind|label|lang|list|loading|loop|low|marginHeight|marginWidth|max|maxLength|media|mediaGroup|method|min|minLength|multiple|muted|name|nonce|noValidate|open|optimum|pattern|placeholder|playsInline|poster|preload|profile|radioGroup|readOnly|referrerPolicy|rel|required|reversed|role|rows|rowSpan|sandbox|scope|scoped|scrolling|seamless|selected|shape|size|sizes|slot|span|spellCheck|src|srcDoc|srcLang|srcSet|start|step|style|summary|tabIndex|target|title|translate|type|useMap|value|width|wmode|wrap|about|datatype|inlist|prefix|property|resource|typeof|vocab|autoCapitalize|autoCorrect|autoSave|color|incremental|fallback|inert|itemProp|itemScope|itemType|itemID|itemRef|on|option|results|security|unselectable|accentHeight|accumulate|additive|alignmentBaseline|allowReorder|alphabetic|amplitude|arabicForm|ascent|attributeName|attributeType|autoReverse|azimuth|baseFrequency|baselineShift|baseProfile|bbox|begin|bias|by|calcMode|capHeight|clip|clipPathUnits|clipPath|clipRule|colorInterpolation|colorInterpolationFilters|colorProfile|colorRendering|contentScriptType|contentStyleType|cursor|cx|cy|d|decelerate|descent|diffuseConstant|direction|display|divisor|dominantBaseline|dur|dx|dy|edgeMode|elevation|enableBackground|end|exponent|externalResourcesRequired|fill|fillOpacity|fillRule|filter|filterRes|filterUnits|floodColor|floodOpacity|focusable|fontFamily|fontSize|fontSizeAdjust|fontStretch|fontStyle|fontVariant|fontWeight|format|from|fr|fx|fy|g1|g2|glyphName|glyphOrientationHorizontal|glyphOrientationVertical|glyphRef|gradientTransform|gradientUnits|hanging|horizAdvX|horizOriginX|ideographic|imageRendering|in|in2|intercept|k|k1|k2|k3|k4|kernelMatrix|kernelUnitLength|kerning|keyPoints|keySplines|keyTimes|lengthAdjust|letterSpacing|lightingColor|limitingConeAngle|local|markerEnd|markerMid|markerStart|markerHeight|markerUnits|markerWidth|mask|maskContentUnits|maskUnits|mathematical|mode|numOctaves|offset|opacity|operator|order|orient|orientation|origin|overflow|overlinePosition|overlineThickness|panose1|paintOrder|pathLength|patternContentUnits|patternTransform|patternUnits|pointerEvents|points|pointsAtX|pointsAtY|pointsAtZ|preserveAlpha|preserveAspectRatio|primitiveUnits|r|radius|refX|refY|renderingIntent|repeatCount|repeatDur|requiredExtensions|requiredFeatures|restart|result|rotate|rx|ry|scale|seed|shapeRendering|slope|spacing|specularConstant|specularExponent|speed|spreadMethod|startOffset|stdDeviation|stemh|stemv|stitchTiles|stopColor|stopOpacity|strikethroughPosition|strikethroughThickness|string|stroke|strokeDasharray|strokeDashoffset|strokeLinecap|strokeLinejoin|strokeMiterlimit|strokeOpacity|strokeWidth|surfaceScale|systemLanguage|tableValues|targetX|targetY|textAnchor|textDecoration|textRendering|textLength|to|transform|u1|u2|underlinePosition|underlineThickness|unicode|unicodeBidi|unicodeRange|unitsPerEm|vAlphabetic|vHanging|vIdeographic|vMathematical|values|vectorEffect|version|vertAdvY|vertOriginX|vertOriginY|viewBox|viewTarget|visibility|widths|wordSpacing|writingMode|x|xHeight|x1|x2|xChannelSelector|xlinkActuate|xlinkArcrole|xlinkHref|xlinkRole|xlinkShow|xlinkTitle|xlinkType|xmlBase|xmlns|xmlnsXlink|xmlLang|xmlSpace|y|y1|y2|yChannelSelector|z|zoomAndPan|for|class|autofocus)|(([Dd][Aa][Tt][Aa]|[Aa][Rr][Ii][Aa]|x)-.*))$/; // https://esbench.com/bench/5bfee68a4cd7e6009ef61d23

var isPropValid = /* #__PURE__ */emotion_memoize_browser_esm(function (prop) {
  return reactPropsRegex.test(prop) || prop.charCodeAt(0) === 111
  /* o */
  && prop.charCodeAt(1) === 110
  /* n */
  && prop.charCodeAt(2) < 91;
}
/* Z+1 */
);

/* harmony default export */ const emotion_is_prop_valid_browser_esm = (isPropValid);

;// CONCATENATED MODULE: ./node_modules/@emotion/react/dist/emotion-element-cbed451f.browser.esm.js









var emotion_element_cbed451f_browser_esm_hasOwnProperty = {}.hasOwnProperty;

var EmotionCacheContext = /* #__PURE__ */(0,react.createContext)( // we're doing this to avoid preconstruct's dead code elimination in this one case
// because this module is primarily intended for the browser and node
// but it's also required in react native and similar environments sometimes
// and we could have a special build just for that
// but this is much easier and the native packages
// might use a different theme context in the future anyway
typeof HTMLElement !== 'undefined' ? /* #__PURE__ */emotion_cache_browser_esm({
  key: 'css'
}) : null);

if (false) {}

var CacheProvider = EmotionCacheContext.Provider;
var __unsafe_useEmotionCache = function useEmotionCache() {
  return (0,react.useContext)(EmotionCacheContext);
};

var emotion_element_cbed451f_browser_esm_withEmotionCache = function withEmotionCache(func) {
  // $FlowFixMe
  return /*#__PURE__*/(0,react.forwardRef)(function (props, ref) {
    // the cache will never be null in the browser
    var cache = (0,react.useContext)(EmotionCacheContext);
    return func(props, cache, ref);
  });
};

var emotion_element_cbed451f_browser_esm_ThemeContext = /* #__PURE__ */(0,react.createContext)({});

if (false) {}

var useTheme = function useTheme() {
  return useContext(emotion_element_cbed451f_browser_esm_ThemeContext);
};

var getTheme = function getTheme(outerTheme, theme) {
  if (typeof theme === 'function') {
    var mergedTheme = theme(outerTheme);

    if (false) {}

    return mergedTheme;
  }

  if (false) {}

  return _extends({}, outerTheme, theme);
};

var createCacheWithTheme = /* #__PURE__ */(/* unused pure expression or super */ null && (weakMemoize(function (outerTheme) {
  return weakMemoize(function (theme) {
    return getTheme(outerTheme, theme);
  });
})));
var ThemeProvider = function ThemeProvider(props) {
  var theme = useContext(emotion_element_cbed451f_browser_esm_ThemeContext);

  if (props.theme !== theme) {
    theme = createCacheWithTheme(theme)(props.theme);
  }

  return /*#__PURE__*/createElement(emotion_element_cbed451f_browser_esm_ThemeContext.Provider, {
    value: theme
  }, props.children);
};
function withTheme(Component) {
  var componentName = Component.displayName || Component.name || 'Component';

  var render = function render(props, ref) {
    var theme = useContext(emotion_element_cbed451f_browser_esm_ThemeContext);
    return /*#__PURE__*/createElement(Component, _extends({
      theme: theme,
      ref: ref
    }, props));
  }; // $FlowFixMe


  var WithTheme = /*#__PURE__*/forwardRef(render);
  WithTheme.displayName = "WithTheme(" + componentName + ")";
  return hoistNonReactStatics(WithTheme, Component);
}

var getLastPart = function getLastPart(functionName) {
  // The match may be something like 'Object.createEmotionProps' or
  // 'Loader.prototype.render'
  var parts = functionName.split('.');
  return parts[parts.length - 1];
};

var getFunctionNameFromStackTraceLine = function getFunctionNameFromStackTraceLine(line) {
  // V8
  var match = /^\s+at\s+([A-Za-z0-9$.]+)\s/.exec(line);
  if (match) return getLastPart(match[1]); // Safari / Firefox

  match = /^([A-Za-z0-9$.]+)@/.exec(line);
  if (match) return getLastPart(match[1]);
  return undefined;
};

var internalReactFunctionNames = /* #__PURE__ */new Set(['renderWithHooks', 'processChild', 'finishClassComponent', 'renderToString']); // These identifiers come from error stacks, so they have to be valid JS
// identifiers, thus we only need to replace what is a valid character for JS,
// but not for CSS.

var sanitizeIdentifier = function sanitizeIdentifier(identifier) {
  return identifier.replace(/\$/g, '-');
};

var getLabelFromStackTrace = function getLabelFromStackTrace(stackTrace) {
  if (!stackTrace) return undefined;
  var lines = stackTrace.split('\n');

  for (var i = 0; i < lines.length; i++) {
    var functionName = getFunctionNameFromStackTraceLine(lines[i]); // The first line of V8 stack traces is just "Error"

    if (!functionName) continue; // If we reach one of these, we have gone too far and should quit

    if (internalReactFunctionNames.has(functionName)) break; // The component name is the first function in the stack that starts with an
    // uppercase letter

    if (/^[A-Z]/.test(functionName)) return sanitizeIdentifier(functionName);
  }

  return undefined;
};

var emotion_element_cbed451f_browser_esm_useInsertionEffect = react_namespaceObject['useInsertion' + 'Effect'] ? react_namespaceObject['useInsertion' + 'Effect'] : function useInsertionEffect(create) {
  create();
};
function emotion_element_cbed451f_browser_esm_useInsertionEffectMaybe(create) {

  emotion_element_cbed451f_browser_esm_useInsertionEffect(create);
}

var typePropName = '__EMOTION_TYPE_PLEASE_DO_NOT_USE__';
var labelPropName = '__EMOTION_LABEL_PLEASE_DO_NOT_USE__';
var emotion_element_cbed451f_browser_esm_createEmotionProps = function createEmotionProps(type, props) {
  if (false) {}

  var newProps = {};

  for (var key in props) {
    if (emotion_element_cbed451f_browser_esm_hasOwnProperty.call(props, key)) {
      newProps[key] = props[key];
    }
  }

  newProps[typePropName] = type; // For performance, only call getLabelFromStackTrace in development and when
  // the label hasn't already been computed

  if (false) { var label; }

  return newProps;
};

var emotion_element_cbed451f_browser_esm_Insertion = function Insertion(_ref) {
  var cache = _ref.cache,
      serialized = _ref.serialized,
      isStringTag = _ref.isStringTag;
  registerStyles(cache, serialized, isStringTag);
  var rules = emotion_element_cbed451f_browser_esm_useInsertionEffectMaybe(function () {
    return insertStyles(cache, serialized, isStringTag);
  });

  return null;
};

var emotion_element_cbed451f_browser_esm_Emotion = /* #__PURE__ */(/* unused pure expression or super */ null && (emotion_element_cbed451f_browser_esm_withEmotionCache(function (props, cache, ref) {
  var cssProp = props.css; // so that using `css` from `emotion` and passing the result to the css prop works
  // not passing the registered cache to serializeStyles because it would
  // make certain babel optimisations not possible

  if (typeof cssProp === 'string' && cache.registered[cssProp] !== undefined) {
    cssProp = cache.registered[cssProp];
  }

  var WrappedComponent = props[typePropName];
  var registeredStyles = [cssProp];
  var className = '';

  if (typeof props.className === 'string') {
    className = getRegisteredStyles(cache.registered, registeredStyles, props.className);
  } else if (props.className != null) {
    className = props.className + " ";
  }

  var serialized = serializeStyles(registeredStyles, undefined, useContext(emotion_element_cbed451f_browser_esm_ThemeContext));

  if (false) { var labelFromStack; }

  className += cache.key + "-" + serialized.name;
  var newProps = {};

  for (var key in props) {
    if (emotion_element_cbed451f_browser_esm_hasOwnProperty.call(props, key) && key !== 'css' && key !== typePropName && ( true || 0)) {
      newProps[key] = props[key];
    }
  }

  newProps.ref = ref;
  newProps.className = className;
  return /*#__PURE__*/createElement(Fragment, null, /*#__PURE__*/createElement(emotion_element_cbed451f_browser_esm_Insertion, {
    cache: cache,
    serialized: serialized,
    isStringTag: typeof WrappedComponent === 'string'
  }), /*#__PURE__*/createElement(WrappedComponent, newProps));
})));

if (false) {}



;// CONCATENATED MODULE: ./node_modules/@emotion/styled/node_modules/@emotion/utils/dist/emotion-utils.browser.esm.js
var emotion_utils_browser_esm_isBrowser = "object" !== 'undefined';
function emotion_utils_browser_esm_getRegisteredStyles(registered, registeredStyles, classNames) {
  var rawClassName = '';
  classNames.split(' ').forEach(function (className) {
    if (registered[className] !== undefined) {
      registeredStyles.push(registered[className] + ";");
    } else {
      rawClassName += className + " ";
    }
  });
  return rawClassName;
}
var emotion_utils_browser_esm_registerStyles = function registerStyles(cache, serialized, isStringTag) {
  var className = cache.key + "-" + serialized.name;

  if ( // we only need to add the styles to the registered cache if the
  // class name could be used further down
  // the tree but if it's a string tag, we know it won't
  // so we don't have to add it to registered cache.
  // this improves memory usage since we can avoid storing the whole style string
  (isStringTag === false || // we need to always store it if we're in compat mode and
  // in node since emotion-server relies on whether a style is in
  // the registered cache to know whether a style is global or not
  // also, note that this check will be dead code eliminated in the browser
  emotion_utils_browser_esm_isBrowser === false ) && cache.registered[className] === undefined) {
    cache.registered[className] = serialized.styles;
  }
};
var emotion_utils_browser_esm_insertStyles = function insertStyles(cache, serialized, isStringTag) {
  emotion_utils_browser_esm_registerStyles(cache, serialized, isStringTag);
  var className = cache.key + "-" + serialized.name;

  if (cache.inserted[serialized.name] === undefined) {
    var current = serialized;

    do {
      var maybeStyles = cache.insert(serialized === current ? "." + className : '', current, cache.sheet, true);

      current = current.next;
    } while (current !== undefined);
  }
};



;// CONCATENATED MODULE: ./node_modules/@emotion/styled/base/dist/emotion-styled-base.browser.esm.js








var testOmitPropsOnStringTag = emotion_is_prop_valid_browser_esm;

var testOmitPropsOnComponent = function testOmitPropsOnComponent(key) {
  return key !== 'theme';
};

var getDefaultShouldForwardProp = function getDefaultShouldForwardProp(tag) {
  return typeof tag === 'string' && // 96 is one less than the char code
  // for "a" so this is checking that
  // it's a lowercase character
  tag.charCodeAt(0) > 96 ? testOmitPropsOnStringTag : testOmitPropsOnComponent;
};
var composeShouldForwardProps = function composeShouldForwardProps(tag, options, isReal) {
  var shouldForwardProp;

  if (options) {
    var optionsShouldForwardProp = options.shouldForwardProp;
    shouldForwardProp = tag.__emotion_forwardProp && optionsShouldForwardProp ? function (propName) {
      return tag.__emotion_forwardProp(propName) && optionsShouldForwardProp(propName);
    } : optionsShouldForwardProp;
  }

  if (typeof shouldForwardProp !== 'function' && isReal) {
    shouldForwardProp = tag.__emotion_forwardProp;
  }

  return shouldForwardProp;
};

var emotion_styled_base_browser_esm_useInsertionEffect = react_namespaceObject['useInsertion' + 'Effect'] ? react_namespaceObject['useInsertion' + 'Effect'] : function useInsertionEffect(create) {
  create();
};
function emotion_styled_base_browser_esm_useInsertionEffectMaybe(create) {

  emotion_styled_base_browser_esm_useInsertionEffect(create);
}

var emotion_styled_base_browser_esm_ILLEGAL_ESCAPE_SEQUENCE_ERROR = "You have illegal escape sequence in your template literal, most likely inside content's property value.\nBecause you write your CSS inside a JavaScript string you actually have to do double escaping, so for example \"content: '\\00d7';\" should become \"content: '\\\\00d7';\".\nYou can read more about this here:\nhttps://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#ES2018_revision_of_illegal_escape_sequences";

var emotion_styled_base_browser_esm_Insertion = function Insertion(_ref) {
  var cache = _ref.cache,
      serialized = _ref.serialized,
      isStringTag = _ref.isStringTag;
  emotion_utils_browser_esm_registerStyles(cache, serialized, isStringTag);
  var rules = emotion_styled_base_browser_esm_useInsertionEffectMaybe(function () {
    return emotion_utils_browser_esm_insertStyles(cache, serialized, isStringTag);
  });

  return null;
};

var createStyled = function createStyled(tag, options) {
  if (false) {}

  var isReal = tag.__emotion_real === tag;
  var baseTag = isReal && tag.__emotion_base || tag;
  var identifierName;
  var targetClassName;

  if (options !== undefined) {
    identifierName = options.label;
    targetClassName = options.target;
  }

  var shouldForwardProp = composeShouldForwardProps(tag, options, isReal);
  var defaultShouldForwardProp = shouldForwardProp || getDefaultShouldForwardProp(baseTag);
  var shouldUseAs = !defaultShouldForwardProp('as');
  return function () {
    var args = arguments;
    var styles = isReal && tag.__emotion_styles !== undefined ? tag.__emotion_styles.slice(0) : [];

    if (identifierName !== undefined) {
      styles.push("label:" + identifierName + ";");
    }

    if (args[0] == null || args[0].raw === undefined) {
      styles.push.apply(styles, args);
    } else {
      if (false) {}

      styles.push(args[0][0]);
      var len = args.length;
      var i = 1;

      for (; i < len; i++) {
        if (false) {}

        styles.push(args[i], args[0][i]);
      }
    } // $FlowFixMe: we need to cast StatelessFunctionalComponent to our PrivateStyledComponent class


    var Styled = emotion_element_cbed451f_browser_esm_withEmotionCache(function (props, cache, ref) {
      var FinalTag = shouldUseAs && props.as || baseTag;
      var className = '';
      var classInterpolations = [];
      var mergedProps = props;

      if (props.theme == null) {
        mergedProps = {};

        for (var key in props) {
          mergedProps[key] = props[key];
        }

        mergedProps.theme = (0,react.useContext)(emotion_element_cbed451f_browser_esm_ThemeContext);
      }

      if (typeof props.className === 'string') {
        className = emotion_utils_browser_esm_getRegisteredStyles(cache.registered, classInterpolations, props.className);
      } else if (props.className != null) {
        className = props.className + " ";
      }

      var serialized = emotion_serialize_browser_esm_serializeStyles(styles.concat(classInterpolations), cache.registered, mergedProps);
      className += cache.key + "-" + serialized.name;

      if (targetClassName !== undefined) {
        className += " " + targetClassName;
      }

      var finalShouldForwardProp = shouldUseAs && shouldForwardProp === undefined ? getDefaultShouldForwardProp(FinalTag) : defaultShouldForwardProp;
      var newProps = {};

      for (var _key in props) {
        if (shouldUseAs && _key === 'as') continue;

        if ( // $FlowFixMe
        finalShouldForwardProp(_key)) {
          newProps[_key] = props[_key];
        }
      }

      newProps.className = className;
      newProps.ref = ref;
      return /*#__PURE__*/(0,react.createElement)(react.Fragment, null, /*#__PURE__*/(0,react.createElement)(emotion_styled_base_browser_esm_Insertion, {
        cache: cache,
        serialized: serialized,
        isStringTag: typeof FinalTag === 'string'
      }), /*#__PURE__*/(0,react.createElement)(FinalTag, newProps));
    });
    Styled.displayName = identifierName !== undefined ? identifierName : "Styled(" + (typeof baseTag === 'string' ? baseTag : baseTag.displayName || baseTag.name || 'Component') + ")";
    Styled.defaultProps = tag.defaultProps;
    Styled.__emotion_real = Styled;
    Styled.__emotion_base = baseTag;
    Styled.__emotion_styles = styles;
    Styled.__emotion_forwardProp = shouldForwardProp;
    Object.defineProperty(Styled, 'toString', {
      value: function value() {
        if (targetClassName === undefined && "production" !== 'production') {} // $FlowFixMe: coerce undefined to string


        return "." + targetClassName;
      }
    });

    Styled.withComponent = function (nextTag, nextOptions) {
      return createStyled(nextTag, extends_extends({}, options, nextOptions, {
        shouldForwardProp: composeShouldForwardProps(Styled, nextOptions, true)
      })).apply(void 0, styles);
    };

    return Styled;
  };
};

/* harmony default export */ const emotion_styled_base_browser_esm = (createStyled);

;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/view/component.js


/**
 * External dependencies
 */

/**
 * `View` is a core component that renders everything in the library.
 * It is the principle component in the entire library.
 *
 * @example
 * ```jsx
 * import { View } from `@wordpress/components`;
 *
 * function Example() {
 * 	return (
 * 		<View>
 * 			 Code is Poetry
 * 		</View>
 * 	);
 * }
 * ```
 *
 * @type {import('../ui/context').WordPressComponent<'div', { children?: import('react').ReactNode }, true>}
 */
// @ts-ignore
const View = emotion_styled_base_browser_esm("div",  true ? {
  target: "em57xhy0"
} : 0)( true ? "" : 0);

View.selector = '.components-view';
View.displayName = 'View';
/* harmony default export */ const component = (View);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/context/utils.js
/**
 * Internal dependencies
 */

/**
 * Creates a dedicated context namespace HTML attribute for components.
 * ns is short for "namespace"
 *
 * @example
 * ```jsx
 * <div {...ns('Container')} />
 * ```
 *
 * @param {string} componentName The name for the component.
 * @return {Record<string, any>} A props object with the namespaced HTML attribute.
 */

function getNamespace(componentName) {
  return {
    [COMPONENT_NAMESPACE]: componentName
  };
}
/**
 * Creates a dedicated connected context namespace HTML attribute for components.
 * ns is short for "namespace"
 *
 * @example
 * ```jsx
 * <div {...cns()} />
 * ```
 *
 * @return {Record<string, any>} A props object with the namespaced HTML attribute.
 */

function getConnectedNamespace() {
  return {
    [CONNECTED_NAMESPACE]: true
  };
}
//# sourceMappingURL=utils.js.map
;// CONCATENATED MODULE: ./node_modules/@emotion/utils/dist/emotion-utils.browser.esm.js
var dist_emotion_utils_browser_esm_isBrowser = "object" !== 'undefined';
function dist_emotion_utils_browser_esm_getRegisteredStyles(registered, registeredStyles, classNames) {
  var rawClassName = '';
  classNames.split(' ').forEach(function (className) {
    if (registered[className] !== undefined) {
      registeredStyles.push(registered[className] + ";");
    } else {
      rawClassName += className + " ";
    }
  });
  return rawClassName;
}
var dist_emotion_utils_browser_esm_insertStyles = function insertStyles(cache, serialized, isStringTag) {
  var className = cache.key + "-" + serialized.name;

  if ( // we only need to add the styles to the registered cache if the
  // class name could be used further down
  // the tree but if it's a string tag, we know it won't
  // so we don't have to add it to registered cache.
  // this improves memory usage since we can avoid storing the whole style string
  (isStringTag === false || // we need to always store it if we're in compat mode and
  // in node since emotion-server relies on whether a style is in
  // the registered cache to know whether a style is global or not
  // also, note that this check will be dead code eliminated in the browser
  dist_emotion_utils_browser_esm_isBrowser === false ) && cache.registered[className] === undefined) {
    cache.registered[className] = serialized.styles;
  }

  if (cache.inserted[serialized.name] === undefined) {
    var current = serialized;

    do {
      var maybeStyles = cache.insert(serialized === current ? "." + className : '', current, cache.sheet, true);

      current = current.next;
    } while (current !== undefined);
  }
};



;// CONCATENATED MODULE: ./node_modules/@emotion/css/create-instance/dist/emotion-css-create-instance.esm.js




function insertWithoutScoping(cache, serialized) {
  if (cache.inserted[serialized.name] === undefined) {
    return cache.insert('', serialized, cache.sheet, true);
  }
}

function emotion_css_create_instance_esm_merge(registered, css, className) {
  var registeredStyles = [];
  var rawClassName = dist_emotion_utils_browser_esm_getRegisteredStyles(registered, registeredStyles, className);

  if (registeredStyles.length < 2) {
    return className;
  }

  return rawClassName + css(registeredStyles);
}

var createEmotion = function createEmotion(options) {
  var cache = emotion_cache_browser_esm(options); // $FlowFixMe

  cache.sheet.speedy = function (value) {
    if (false) {}

    this.isSpeedy = value;
  };

  cache.compat = true;

  var css = function css() {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var serialized = emotion_serialize_browser_esm_serializeStyles(args, cache.registered, undefined);
    dist_emotion_utils_browser_esm_insertStyles(cache, serialized, false);
    return cache.key + "-" + serialized.name;
  };

  var keyframes = function keyframes() {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    var serialized = emotion_serialize_browser_esm_serializeStyles(args, cache.registered);
    var animation = "animation-" + serialized.name;
    insertWithoutScoping(cache, {
      name: serialized.name,
      styles: "@keyframes " + animation + "{" + serialized.styles + "}"
    });
    return animation;
  };

  var injectGlobal = function injectGlobal() {
    for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    var serialized = emotion_serialize_browser_esm_serializeStyles(args, cache.registered);
    insertWithoutScoping(cache, serialized);
  };

  var cx = function cx() {
    for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    return emotion_css_create_instance_esm_merge(cache.registered, css, emotion_css_create_instance_esm_classnames(args));
  };

  return {
    css: css,
    cx: cx,
    injectGlobal: injectGlobal,
    keyframes: keyframes,
    hydrate: function hydrate(ids) {
      ids.forEach(function (key) {
        cache.inserted[key] = true;
      });
    },
    flush: function flush() {
      cache.registered = {};
      cache.inserted = {};
      cache.sheet.flush();
    },
    // $FlowFixMe
    sheet: cache.sheet,
    cache: cache,
    getRegisteredStyles: dist_emotion_utils_browser_esm_getRegisteredStyles.bind(null, cache.registered),
    merge: emotion_css_create_instance_esm_merge.bind(null, cache.registered, css)
  };
};

var emotion_css_create_instance_esm_classnames = function classnames(args) {
  var cls = '';

  for (var i = 0; i < args.length; i++) {
    var arg = args[i];
    if (arg == null) continue;
    var toAdd = void 0;

    switch (typeof arg) {
      case 'boolean':
        break;

      case 'object':
        {
          if (Array.isArray(arg)) {
            toAdd = classnames(arg);
          } else {
            toAdd = '';

            for (var k in arg) {
              if (arg[k] && k) {
                toAdd && (toAdd += ' ');
                toAdd += k;
              }
            }
          }

          break;
        }

      default:
        {
          toAdd = arg;
        }
    }

    if (toAdd) {
      cls && (cls += ' ');
      cls += toAdd;
    }
  }

  return cls;
};

/* harmony default export */ const emotion_css_create_instance_esm = (createEmotion);

;// CONCATENATED MODULE: ./node_modules/@emotion/css/dist/emotion-css.esm.js





var _createEmotion = emotion_css_create_instance_esm({
  key: 'css'
}),
    flush = _createEmotion.flush,
    hydrate = _createEmotion.hydrate,
    emotion_css_esm_cx = _createEmotion.cx,
    emotion_css_esm_merge = _createEmotion.merge,
    emotion_css_esm_getRegisteredStyles = _createEmotion.getRegisteredStyles,
    injectGlobal = _createEmotion.injectGlobal,
    emotion_css_esm_keyframes = _createEmotion.keyframes,
    emotion_css_esm_css = _createEmotion.css,
    sheet = _createEmotion.sheet,
    cache = _createEmotion.cache;



;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/utils/hooks/use-cx.js
/**
 * External dependencies
 */

 // eslint-disable-next-line no-restricted-imports


/**
 * WordPress dependencies
 */



const isSerializedStyles = o => typeof o !== 'undefined' && o !== null && ['name', 'styles'].every(p => typeof o[p] !== 'undefined');
/**
 * Retrieve a `cx` function that knows how to handle `SerializedStyles`
 * returned by the `@emotion/react` `css` function in addition to what
 * `cx` normally knows how to handle. It also hooks into the Emotion
 * Cache, allowing `css` calls to work inside iframes.
 *
 * @example
 * import { css } from '@emotion/react';
 *
 * const styles = css`
 * 	color: red
 * `;
 *
 * function RedText( { className, ...props } ) {
 * 	const cx = useCx();
 *
 * 	const classes = cx(styles, className);
 *
 * 	return <span className={classes} {...props} />;
 * }
 */


const useCx = () => {
  const cache = __unsafe_useEmotionCache();
  const cx = (0,react.useCallback)(function () {
    if (cache === null) {
      throw new Error('The `useCx` hook should be only used within a valid Emotion Cache Context');
    }

    for (var _len = arguments.length, classNames = new Array(_len), _key = 0; _key < _len; _key++) {
      classNames[_key] = arguments[_key];
    }

    return emotion_css_esm_cx(...classNames.map(arg => {
      if (isSerializedStyles(arg)) {
        dist_emotion_utils_browser_esm_insertStyles(cache, arg, false);
        return `${cache.key}-${arg.name}`;
      }

      return arg;
    }));
  }, [cache]);
  return cx;
};
//# sourceMappingURL=use-cx.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/context/use-context-system.js
/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */





/**
 * @template TProps
 * @typedef {TProps & { className: string }} ConnectedProps
 */

/**
 * Custom hook that derives registered props from the Context system.
 * These derived props are then consolidated with incoming component props.
 *
 * @template {{ className?: string }} P
 * @param {P}      props     Incoming props from the component.
 * @param {string} namespace The namespace to register and to derive context props from.
 * @return {ConnectedProps<P>} The connected props.
 */

function useContextSystem(props, namespace) {
  const contextSystemProps = useComponentsContext();

  if (typeof namespace === 'undefined') {
    typeof process !== "undefined" && process.env && "production" !== "production" ? 0 : void 0;
  }

  const contextProps = (contextSystemProps === null || contextSystemProps === void 0 ? void 0 : contextSystemProps[namespace]) || {};
  /* eslint-disable jsdoc/no-undefined-types */

  /** @type {ConnectedProps<P>} */
  // @ts-ignore We fill in the missing properties below

  const finalComponentProps = { ...getConnectedNamespace(),
    ...getNamespace(namespace)
  };
  /* eslint-enable jsdoc/no-undefined-types */

  const {
    _overrides: overrideProps,
    ...otherContextProps
  } = contextProps;
  const initialMergedProps = Object.entries(otherContextProps).length ? Object.assign({}, otherContextProps, props) : props;
  const cx = useCx();
  const classes = cx(getStyledClassNameFromKey(namespace), props.className); // Provides the ability to customize the render of the component.

  const rendered = typeof initialMergedProps.renderChildren === 'function' ? initialMergedProps.renderChildren(initialMergedProps) : initialMergedProps.children;

  for (const key in initialMergedProps) {
    // @ts-ignore filling in missing props
    finalComponentProps[key] = initialMergedProps[key];
  }

  for (const key in overrideProps) {
    // @ts-ignore filling in missing props
    finalComponentProps[key] = overrideProps[key];
  } // @ts-ignore


  finalComponentProps.children = rendered;
  finalComponentProps.className = classes;
  return finalComponentProps;
}
//# sourceMappingURL=use-context-system.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/elevation/styles.js
function _EMOTION_STRINGIFIED_CSS_ERROR__() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */

const Elevation =  true ? {
  name: "12ip69d",
  styles: "background:transparent;display:block;margin:0!important;pointer-events:none;position:absolute;will-change:box-shadow"
} : 0;
//# sourceMappingURL=styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/utils/space.js
/**
 * A real number or something parsable as a number
 */
const GRID_BASE = '4px';
/**
 * A function that handles numbers, numeric strings, and unit values.
 *
 * When given a number or a numeric string, it will return the grid-based
 * value as a factor of GRID_BASE, defined above.
 *
 * When given a unit value or one of the named CSS values like `auto`,
 * it will simply return the value back.
 *
 * @param  value A number, numeric string, or a unit value.
 */

function space(value) {
  var _window$CSS, _window$CSS$supports;

  if (typeof value === 'undefined') {
    return undefined;
  } // Handle empty strings, if it's the number 0 this still works.


  if (!value) {
    return '0';
  }

  const asInt = typeof value === 'number' ? value : Number(value); // Test if the input has a unit, was NaN, or was one of the named CSS values (like `auto`), in which case just use that value.

  if (typeof window !== 'undefined' && (_window$CSS = window.CSS) !== null && _window$CSS !== void 0 && (_window$CSS$supports = _window$CSS.supports) !== null && _window$CSS$supports !== void 0 && _window$CSS$supports.call(_window$CSS, 'margin', value.toString()) || Number.isNaN(asInt)) {
    return value.toString();
  }

  return `calc(${GRID_BASE} * ${value})`;
}
//# sourceMappingURL=space.js.map
;// CONCATENATED MODULE: ./node_modules/colord/index.mjs
var r={grad:.9,turn:360,rad:360/(2*Math.PI)},t=function(r){return"string"==typeof r?r.length>0:"number"==typeof r},n=function(r,t,n){return void 0===t&&(t=0),void 0===n&&(n=Math.pow(10,t)),Math.round(n*r)/n+0},e=function(r,t,n){return void 0===t&&(t=0),void 0===n&&(n=1),r>n?n:r>t?r:t},u=function(r){return(r=isFinite(r)?r%360:0)>0?r:r+360},a=function(r){return{r:e(r.r,0,255),g:e(r.g,0,255),b:e(r.b,0,255),a:e(r.a)}},o=function(r){return{r:n(r.r),g:n(r.g),b:n(r.b),a:n(r.a,3)}},i=/^#([0-9a-f]{3,8})$/i,s=function(r){var t=r.toString(16);return t.length<2?"0"+t:t},h=function(r){var t=r.r,n=r.g,e=r.b,u=r.a,a=Math.max(t,n,e),o=a-Math.min(t,n,e),i=o?a===t?(n-e)/o:a===n?2+(e-t)/o:4+(t-n)/o:0;return{h:60*(i<0?i+6:i),s:a?o/a*100:0,v:a/255*100,a:u}},b=function(r){var t=r.h,n=r.s,e=r.v,u=r.a;t=t/360*6,n/=100,e/=100;var a=Math.floor(t),o=e*(1-n),i=e*(1-(t-a)*n),s=e*(1-(1-t+a)*n),h=a%6;return{r:255*[e,i,o,o,s,e][h],g:255*[s,e,e,i,o,o][h],b:255*[o,o,s,e,e,i][h],a:u}},g=function(r){return{h:u(r.h),s:e(r.s,0,100),l:e(r.l,0,100),a:e(r.a)}},d=function(r){return{h:n(r.h),s:n(r.s),l:n(r.l),a:n(r.a,3)}},f=function(r){return b((n=(t=r).s,{h:t.h,s:(n*=((e=t.l)<50?e:100-e)/100)>0?2*n/(e+n)*100:0,v:e+n,a:t.a}));var t,n,e},c=function(r){return{h:(t=h(r)).h,s:(u=(200-(n=t.s))*(e=t.v)/100)>0&&u<200?n*e/100/(u<=100?u:200-u)*100:0,l:u/2,a:t.a};var t,n,e,u},l=/^hsla?\(\s*([+-]?\d*\.?\d+)(deg|rad|grad|turn)?\s*,\s*([+-]?\d*\.?\d+)%\s*,\s*([+-]?\d*\.?\d+)%\s*(?:,\s*([+-]?\d*\.?\d+)(%)?\s*)?\)$/i,p=/^hsla?\(\s*([+-]?\d*\.?\d+)(deg|rad|grad|turn)?\s+([+-]?\d*\.?\d+)%\s+([+-]?\d*\.?\d+)%\s*(?:\/\s*([+-]?\d*\.?\d+)(%)?\s*)?\)$/i,v=/^rgba?\(\s*([+-]?\d*\.?\d+)(%)?\s*,\s*([+-]?\d*\.?\d+)(%)?\s*,\s*([+-]?\d*\.?\d+)(%)?\s*(?:,\s*([+-]?\d*\.?\d+)(%)?\s*)?\)$/i,m=/^rgba?\(\s*([+-]?\d*\.?\d+)(%)?\s+([+-]?\d*\.?\d+)(%)?\s+([+-]?\d*\.?\d+)(%)?\s*(?:\/\s*([+-]?\d*\.?\d+)(%)?\s*)?\)$/i,y={string:[[function(r){var t=i.exec(r);return t?(r=t[1]).length<=4?{r:parseInt(r[0]+r[0],16),g:parseInt(r[1]+r[1],16),b:parseInt(r[2]+r[2],16),a:4===r.length?n(parseInt(r[3]+r[3],16)/255,2):1}:6===r.length||8===r.length?{r:parseInt(r.substr(0,2),16),g:parseInt(r.substr(2,2),16),b:parseInt(r.substr(4,2),16),a:8===r.length?n(parseInt(r.substr(6,2),16)/255,2):1}:null:null},"hex"],[function(r){var t=v.exec(r)||m.exec(r);return t?t[2]!==t[4]||t[4]!==t[6]?null:a({r:Number(t[1])/(t[2]?100/255:1),g:Number(t[3])/(t[4]?100/255:1),b:Number(t[5])/(t[6]?100/255:1),a:void 0===t[7]?1:Number(t[7])/(t[8]?100:1)}):null},"rgb"],[function(t){var n=l.exec(t)||p.exec(t);if(!n)return null;var e,u,a=g({h:(e=n[1],u=n[2],void 0===u&&(u="deg"),Number(e)*(r[u]||1)),s:Number(n[3]),l:Number(n[4]),a:void 0===n[5]?1:Number(n[5])/(n[6]?100:1)});return f(a)},"hsl"]],object:[[function(r){var n=r.r,e=r.g,u=r.b,o=r.a,i=void 0===o?1:o;return t(n)&&t(e)&&t(u)?a({r:Number(n),g:Number(e),b:Number(u),a:Number(i)}):null},"rgb"],[function(r){var n=r.h,e=r.s,u=r.l,a=r.a,o=void 0===a?1:a;if(!t(n)||!t(e)||!t(u))return null;var i=g({h:Number(n),s:Number(e),l:Number(u),a:Number(o)});return f(i)},"hsl"],[function(r){var n=r.h,a=r.s,o=r.v,i=r.a,s=void 0===i?1:i;if(!t(n)||!t(a)||!t(o))return null;var h=function(r){return{h:u(r.h),s:e(r.s,0,100),v:e(r.v,0,100),a:e(r.a)}}({h:Number(n),s:Number(a),v:Number(o),a:Number(s)});return b(h)},"hsv"]]},N=function(r,t){for(var n=0;n<t.length;n++){var e=t[n][0](r);if(e)return[e,t[n][1]]}return[null,void 0]},x=function(r){return"string"==typeof r?N(r.trim(),y.string):"object"==typeof r&&null!==r?N(r,y.object):[null,void 0]},I=function(r){return x(r)[1]},M=function(r,t){var n=c(r);return{h:n.h,s:e(n.s+100*t,0,100),l:n.l,a:n.a}},H=function(r){return(299*r.r+587*r.g+114*r.b)/1e3/255},$=function(r,t){var n=c(r);return{h:n.h,s:n.s,l:e(n.l+100*t,0,100),a:n.a}},j=function(){function r(r){this.parsed=x(r)[0],this.rgba=this.parsed||{r:0,g:0,b:0,a:1}}return r.prototype.isValid=function(){return null!==this.parsed},r.prototype.brightness=function(){return n(H(this.rgba),2)},r.prototype.isDark=function(){return H(this.rgba)<.5},r.prototype.isLight=function(){return H(this.rgba)>=.5},r.prototype.toHex=function(){return r=o(this.rgba),t=r.r,e=r.g,u=r.b,i=(a=r.a)<1?s(n(255*a)):"","#"+s(t)+s(e)+s(u)+i;var r,t,e,u,a,i},r.prototype.toRgb=function(){return o(this.rgba)},r.prototype.toRgbString=function(){return r=o(this.rgba),t=r.r,n=r.g,e=r.b,(u=r.a)<1?"rgba("+t+", "+n+", "+e+", "+u+")":"rgb("+t+", "+n+", "+e+")";var r,t,n,e,u},r.prototype.toHsl=function(){return d(c(this.rgba))},r.prototype.toHslString=function(){return r=d(c(this.rgba)),t=r.h,n=r.s,e=r.l,(u=r.a)<1?"hsla("+t+", "+n+"%, "+e+"%, "+u+")":"hsl("+t+", "+n+"%, "+e+"%)";var r,t,n,e,u},r.prototype.toHsv=function(){return r=h(this.rgba),{h:n(r.h),s:n(r.s),v:n(r.v),a:n(r.a,3)};var r},r.prototype.invert=function(){return w({r:255-(r=this.rgba).r,g:255-r.g,b:255-r.b,a:r.a});var r},r.prototype.saturate=function(r){return void 0===r&&(r=.1),w(M(this.rgba,r))},r.prototype.desaturate=function(r){return void 0===r&&(r=.1),w(M(this.rgba,-r))},r.prototype.grayscale=function(){return w(M(this.rgba,-1))},r.prototype.lighten=function(r){return void 0===r&&(r=.1),w($(this.rgba,r))},r.prototype.darken=function(r){return void 0===r&&(r=.1),w($(this.rgba,-r))},r.prototype.rotate=function(r){return void 0===r&&(r=15),this.hue(this.hue()+r)},r.prototype.alpha=function(r){return"number"==typeof r?w({r:(t=this.rgba).r,g:t.g,b:t.b,a:r}):n(this.rgba.a,3);var t},r.prototype.hue=function(r){var t=c(this.rgba);return"number"==typeof r?w({h:r,s:t.s,l:t.l,a:t.a}):n(t.h)},r.prototype.isEqual=function(r){return this.toHex()===w(r).toHex()},r}(),w=function(r){return r instanceof j?r:new j(r)},S=[],k=function(r){r.forEach(function(r){S.indexOf(r)<0&&(r(j,y),S.push(r))})},E=function(){return new j({r:255*Math.random(),g:255*Math.random(),b:255*Math.random()})};

;// CONCATENATED MODULE: ./node_modules/colord/plugins/names.mjs
/* harmony default export */ function names(e,f){var a={white:"#ffffff",bisque:"#ffe4c4",blue:"#0000ff",cadetblue:"#5f9ea0",chartreuse:"#7fff00",chocolate:"#d2691e",coral:"#ff7f50",antiquewhite:"#faebd7",aqua:"#00ffff",azure:"#f0ffff",whitesmoke:"#f5f5f5",papayawhip:"#ffefd5",plum:"#dda0dd",blanchedalmond:"#ffebcd",black:"#000000",gold:"#ffd700",goldenrod:"#daa520",gainsboro:"#dcdcdc",cornsilk:"#fff8dc",cornflowerblue:"#6495ed",burlywood:"#deb887",aquamarine:"#7fffd4",beige:"#f5f5dc",crimson:"#dc143c",cyan:"#00ffff",darkblue:"#00008b",darkcyan:"#008b8b",darkgoldenrod:"#b8860b",darkkhaki:"#bdb76b",darkgray:"#a9a9a9",darkgreen:"#006400",darkgrey:"#a9a9a9",peachpuff:"#ffdab9",darkmagenta:"#8b008b",darkred:"#8b0000",darkorchid:"#9932cc",darkorange:"#ff8c00",darkslateblue:"#483d8b",gray:"#808080",darkslategray:"#2f4f4f",darkslategrey:"#2f4f4f",deeppink:"#ff1493",deepskyblue:"#00bfff",wheat:"#f5deb3",firebrick:"#b22222",floralwhite:"#fffaf0",ghostwhite:"#f8f8ff",darkviolet:"#9400d3",magenta:"#ff00ff",green:"#008000",dodgerblue:"#1e90ff",grey:"#808080",honeydew:"#f0fff0",hotpink:"#ff69b4",blueviolet:"#8a2be2",forestgreen:"#228b22",lawngreen:"#7cfc00",indianred:"#cd5c5c",indigo:"#4b0082",fuchsia:"#ff00ff",brown:"#a52a2a",maroon:"#800000",mediumblue:"#0000cd",lightcoral:"#f08080",darkturquoise:"#00ced1",lightcyan:"#e0ffff",ivory:"#fffff0",lightyellow:"#ffffe0",lightsalmon:"#ffa07a",lightseagreen:"#20b2aa",linen:"#faf0e6",mediumaquamarine:"#66cdaa",lemonchiffon:"#fffacd",lime:"#00ff00",khaki:"#f0e68c",mediumseagreen:"#3cb371",limegreen:"#32cd32",mediumspringgreen:"#00fa9a",lightskyblue:"#87cefa",lightblue:"#add8e6",midnightblue:"#191970",lightpink:"#ffb6c1",mistyrose:"#ffe4e1",moccasin:"#ffe4b5",mintcream:"#f5fffa",lightslategray:"#778899",lightslategrey:"#778899",navajowhite:"#ffdead",navy:"#000080",mediumvioletred:"#c71585",powderblue:"#b0e0e6",palegoldenrod:"#eee8aa",oldlace:"#fdf5e6",paleturquoise:"#afeeee",mediumturquoise:"#48d1cc",mediumorchid:"#ba55d3",rebeccapurple:"#663399",lightsteelblue:"#b0c4de",mediumslateblue:"#7b68ee",thistle:"#d8bfd8",tan:"#d2b48c",orchid:"#da70d6",mediumpurple:"#9370db",purple:"#800080",pink:"#ffc0cb",skyblue:"#87ceeb",springgreen:"#00ff7f",palegreen:"#98fb98",red:"#ff0000",yellow:"#ffff00",slateblue:"#6a5acd",lavenderblush:"#fff0f5",peru:"#cd853f",palevioletred:"#db7093",violet:"#ee82ee",teal:"#008080",slategray:"#708090",slategrey:"#708090",aliceblue:"#f0f8ff",darkseagreen:"#8fbc8f",darkolivegreen:"#556b2f",greenyellow:"#adff2f",seagreen:"#2e8b57",seashell:"#fff5ee",tomato:"#ff6347",silver:"#c0c0c0",sienna:"#a0522d",lavender:"#e6e6fa",lightgreen:"#90ee90",orange:"#ffa500",orangered:"#ff4500",steelblue:"#4682b4",royalblue:"#4169e1",turquoise:"#40e0d0",yellowgreen:"#9acd32",salmon:"#fa8072",saddlebrown:"#8b4513",sandybrown:"#f4a460",rosybrown:"#bc8f8f",darksalmon:"#e9967a",lightgoldenrodyellow:"#fafad2",snow:"#fffafa",lightgrey:"#d3d3d3",lightgray:"#d3d3d3",dimgray:"#696969",dimgrey:"#696969",olivedrab:"#6b8e23",olive:"#808000"},r={};for(var d in a)r[a[d]]=d;var l={};e.prototype.toName=function(f){if(!(this.rgba.a||this.rgba.r||this.rgba.g||this.rgba.b))return"transparent";var d,i,n=r[this.toHex()];if(n)return n;if(null==f?void 0:f.closest){var o=this.toRgb(),t=1/0,b="black";if(!l.length)for(var c in a)l[c]=new e(a[c]).toRgb();for(var g in a){var u=(d=o,i=l[g],Math.pow(d.r-i.r,2)+Math.pow(d.g-i.g,2)+Math.pow(d.b-i.b,2));u<t&&(t=u,b=g)}return b}};f.string.push([function(f){var r=f.toLowerCase(),d="transparent"===r?"#0000":a[r];return d?new e(d).toRgb():null},"name"])}

;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/utils/colors.js
/**
 * External dependencies
 */


k([names]);
/**
 * Generating a CSS compliant rgba() color value.
 *
 * @param {string} hexValue The hex value to convert to rgba().
 * @param {number} alpha    The alpha value for opacity.
 * @return {string} The converted rgba() color value.
 *
 * @example
 * rgba( '#000000', 0.5 )
 * // rgba(0, 0, 0, 0.5)
 */

function rgba() {
  let hexValue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  let alpha = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
  return w(hexValue).alpha(alpha).toRgbString();
}
//# sourceMappingURL=colors.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/utils/colors-values.js
/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


const BASE = {
  black: '#000',
  white: '#fff'
};
const G2 = {
  blue: {
    medium: {
      focus: '#007cba',
      focusDark: '#fff'
    }
  },
  gray: {
    900: '#1e1e1e',
    700: '#757575',
    // Meets 4.6:1 text contrast against white.
    600: '#949494',
    // Meets 3:1 UI or large text contrast against white.
    400: '#ccc',
    300: '#ddd',
    // Used for most borders.
    200: '#e0e0e0',
    // Used sparingly for light borders.
    100: '#f0f0f0' // Used for light gray backgrounds.

  },
  mediumGray: {
    text: '#757575'
  },
  lightGray: {
    ui: '#949494',
    secondary: '#ccc',
    tertiary: '#e7e8e9'
  }
};
const DARK_GRAY = {
  900: '#191e23',
  800: '#23282d',
  700: '#32373c',
  600: '#40464d',
  500: '#555d66',
  // Use this most of the time for dark items.
  400: '#606a73',
  300: '#6c7781',
  // Lightest gray that can be used for AA text contrast.
  200: '#7e8993',
  150: '#8d96a0',
  // Lightest gray that can be used for AA non-text contrast.
  100: '#8f98a1',
  placeholder: rgba(G2.gray[900], 0.62)
};
const DARK_OPACITY = {
  900: rgba('#000510', 0.9),
  800: rgba('#00000a', 0.85),
  700: rgba('#06060b', 0.8),
  600: rgba('#000913', 0.75),
  500: rgba('#0a1829', 0.7),
  400: rgba('#0a1829', 0.65),
  300: rgba('#0e1c2e', 0.62),
  200: rgba('#162435', 0.55),
  100: rgba('#223443', 0.5),
  backgroundFill: rgba(DARK_GRAY[700], 0.7)
};
const DARK_OPACITY_LIGHT = {
  900: rgba('#304455', 0.45),
  800: rgba('#425863', 0.4),
  700: rgba('#667886', 0.35),
  600: rgba('#7b86a2', 0.3),
  500: rgba('#9197a2', 0.25),
  400: rgba('#95959c', 0.2),
  300: rgba('#829493', 0.15),
  200: rgba('#8b8b96', 0.1),
  100: rgba('#747474', 0.05)
};
const LIGHT_GRAY = {
  900: '#a2aab2',
  800: '#b5bcc2',
  700: '#ccd0d4',
  600: '#d7dade',
  500: '#e2e4e7',
  // Good for "grayed" items and borders.
  400: '#e8eaeb',
  // Good for "readonly" input fields and special text selection.
  300: '#edeff0',
  200: '#f3f4f5',
  100: '#f8f9f9',
  placeholder: rgba(BASE.white, 0.65)
};
const LIGHT_OPACITY_LIGHT = {
  900: rgba(BASE.white, 0.5),
  800: rgba(BASE.white, 0.45),
  700: rgba(BASE.white, 0.4),
  600: rgba(BASE.white, 0.35),
  500: rgba(BASE.white, 0.3),
  400: rgba(BASE.white, 0.25),
  300: rgba(BASE.white, 0.2),
  200: rgba(BASE.white, 0.15),
  100: rgba(BASE.white, 0.1),
  backgroundFill: rgba(LIGHT_GRAY[300], 0.8)
}; // Additional colors.
// Some are from https://make.wordpress.org/design/handbook/foundations/colors/.

const BLUE = {
  wordpress: {
    700: '#00669b'
  },
  dark: {
    900: '#0071a1'
  },
  medium: {
    900: '#006589',
    800: '#00739c',
    700: '#007fac',
    600: '#008dbe',
    500: '#00a0d2',
    400: '#33b3db',
    300: '#66c6e4',
    200: '#bfe7f3',
    100: '#e5f5fa',
    highlight: '#b3e7fe',
    focus: '#007cba'
  }
};
const ALERT = {
  yellow: '#f0b849',
  red: '#d94f4f',
  green: '#4ab866'
};
const ADMIN = {
  theme: `var( --wp-admin-theme-color, ${BLUE.wordpress[700]})`,
  themeDark10: `var( --wp-admin-theme-color-darker-10, ${BLUE.medium.focus})`
}; // Namespaced values for raw colors hex codes.

const UI = {
  theme: ADMIN.theme,
  background: BASE.white,
  backgroundDisabled: LIGHT_GRAY[200],
  border: G2.gray[700],
  borderHover: G2.gray[700],
  borderFocus: ADMIN.themeDark10,
  borderDisabled: G2.gray[400],
  borderLight: G2.gray[300],
  label: DARK_GRAY[500],
  textDisabled: DARK_GRAY[150],
  textDark: BASE.white,
  textLight: BASE.black
}; // Using Object.assign instead of { ...spread } syntax helps TypeScript
// to extract the correct type defs here.

const COLORS = Object.assign({}, BASE, {
  darkGray: DARK_GRAY,
  darkOpacity: DARK_OPACITY,
  darkOpacityLight: DARK_OPACITY_LIGHT,
  mediumGray: G2.mediumGray,

  /**
   * The main gray color object (since Apr 16, 2022).
   *
   * We are in the process of simplifying the colors in this file,
   * please prefer this `gray` object in the meantime.
   */
  gray: G2.gray,
  lightGray: (0,lodash.merge)({}, LIGHT_GRAY, G2.lightGray),
  lightGrayLight: LIGHT_OPACITY_LIGHT,
  blue: (0,lodash.merge)({}, BLUE, G2.blue),
  alert: ALERT,
  admin: ADMIN,
  ui: UI
});
/* harmony default export */ const colors_values = ((/* unused pure expression or super */ null && (COLORS)));
//# sourceMappingURL=colors-values.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/utils/config-values.js
/**
 * Internal dependencies
 */


const CONTROL_HEIGHT = '36px';
const CONTROL_PADDING_X = '12px';
const CONTROL_PROPS = {
  controlSurfaceColor: COLORS.white,
  controlTextActiveColor: COLORS.ui.theme,
  controlPaddingX: CONTROL_PADDING_X,
  controlPaddingXLarge: `calc(${CONTROL_PADDING_X} * 1.3334)`,
  controlPaddingXSmall: `calc(${CONTROL_PADDING_X} / 1.3334)`,
  controlBackgroundColor: COLORS.white,
  controlBorderRadius: '2px',
  controlBorderColor: COLORS.gray[700],
  controlBoxShadow: 'transparent',
  controlBorderColorHover: COLORS.gray[700],
  controlBoxShadowFocus: `0 0 0 0.5px ${COLORS.admin.theme}`,
  controlDestructiveBorderColor: COLORS.alert.red,
  controlHeight: CONTROL_HEIGHT,
  controlHeightXSmall: `calc( ${CONTROL_HEIGHT} * 0.6 )`,
  controlHeightSmall: `calc( ${CONTROL_HEIGHT} * 0.8 )`,
  controlHeightLarge: `calc( ${CONTROL_HEIGHT} * 1.2 )`,
  controlHeightXLarge: `calc( ${CONTROL_HEIGHT} * 1.4 )`
};
const TOGGLE_GROUP_CONTROL_PROPS = {
  toggleGroupControlBackgroundColor: CONTROL_PROPS.controlBackgroundColor,
  toggleGroupControlBorderColor: COLORS.ui.border,
  toggleGroupControlBackdropBackgroundColor: CONTROL_PROPS.controlSurfaceColor,
  toggleGroupControlBackdropBorderColor: COLORS.ui.border,
  toggleGroupControlBackdropBoxShadow: 'transparent',
  toggleGroupControlButtonColorActive: CONTROL_PROPS.controlBackgroundColor
}; // Using Object.assign to avoid creating circular references when emitting
// TypeScript type declarations.

/* harmony default export */ const config_values = (Object.assign({}, CONTROL_PROPS, TOGGLE_GROUP_CONTROL_PROPS, {
  colorDivider: 'rgba(0, 0, 0, 0.1)',
  colorScrollbarThumb: 'rgba(0, 0, 0, 0.2)',
  colorScrollbarThumbHover: 'rgba(0, 0, 0, 0.5)',
  colorScrollbarTrack: 'rgba(0, 0, 0, 0.04)',
  elevationIntensity: 1,
  radiusBlockUi: '2px',
  borderWidth: '1px',
  borderWidthFocus: '1.5px',
  borderWidthTab: '4px',
  spinnerSize: 16,
  fontSize: '13px',
  fontSizeH1: 'calc(2.44 * 13px)',
  fontSizeH2: 'calc(1.95 * 13px)',
  fontSizeH3: 'calc(1.56 * 13px)',
  fontSizeH4: 'calc(1.25 * 13px)',
  fontSizeH5: '13px',
  fontSizeH6: 'calc(0.8 * 13px)',
  fontSizeInputMobile: '16px',
  fontSizeMobile: '15px',
  fontSizeSmall: 'calc(0.92 * 13px)',
  fontSizeXSmall: 'calc(0.75 * 13px)',
  fontLineHeightBase: '1.2',
  fontWeight: 'normal',
  fontWeightHeading: '600',
  gridBase: '4px',
  cardBorderRadius: '2px',
  cardPaddingXSmall: `${space(2)}`,
  cardPaddingSmall: `${space(4)}`,
  cardPaddingMedium: `${space(4)} ${space(6)}`,
  cardPaddingLarge: `${space(6)} ${space(8)}`,
  surfaceBackgroundColor: COLORS.white,
  surfaceBackgroundSubtleColor: '#F3F3F3',
  surfaceBackgroundTintColor: '#F5F5F5',
  surfaceBorderColor: 'rgba(0, 0, 0, 0.1)',
  surfaceBorderBoldColor: 'rgba(0, 0, 0, 0.15)',
  surfaceBorderSubtleColor: 'rgba(0, 0, 0, 0.05)',
  surfaceBackgroundTertiaryColor: COLORS.white,
  surfaceColor: COLORS.white,
  transitionDuration: '200ms',
  transitionDurationFast: '160ms',
  transitionDurationFaster: '120ms',
  transitionDurationFastest: '100ms',
  transitionTimingFunction: 'cubic-bezier(0.08, 0.52, 0.52, 1)',
  transitionTimingFunctionControl: 'cubic-bezier(0.12, 0.8, 0.32, 1)'
}));
//# sourceMappingURL=config-values.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/utils/reduce-motion.js
/**
 * Allows users to opt-out of animations via OS-level preferences.
 *
 * @param {'transition' | 'animation' | string} [prop='transition'] CSS Property name
 * @return {string} Generated CSS code for the reduced style
 */
function reduceMotion() {
  let prop = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'transition';
  let style;

  switch (prop) {
    case 'transition':
      style = 'transition-duration: 0ms;';
      break;

    case 'animation':
      style = 'animation-duration: 1ms;';
      break;

    default:
      style = `
				animation-duration: 1ms;
				transition-duration: 0ms;
			`;
  }

  return `
		@media ( prefers-reduced-motion: reduce ) {
			${style};
		}
	`;
}
//# sourceMappingURL=reduce-motion.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/elevation/hook.js
/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */





/**
 * @param {number} value
 * @return {string} The box shadow value.
 */

function getBoxShadow(value) {
  const boxShadowColor = `rgba(0 ,0, 0, ${value / 20})`;
  const boxShadow = `0 ${value}px ${value * 2}px 0
	${boxShadowColor}`;
  return boxShadow;
}
/**
 * @param {import('../ui/context').WordPressComponentProps<import('./types').Props, 'div'>} props
 */

function useElevation(props) {
  const {
    active,
    borderRadius = 'inherit',
    className,
    focus,
    hover,
    isInteractive = false,
    offset = 0,
    value = 0,
    ...otherProps
  } = useContextSystem(props, 'Elevation');
  const cx = useCx();
  const classes = (0,react.useMemo)(() => {
    /** @type {number | undefined} */
    let hoverValue = !(0,lodash.isNil)(hover) ? hover : value * 2;
    /** @type {number | undefined} */

    let activeValue = !(0,lodash.isNil)(active) ? active : value / 2;

    if (!isInteractive) {
      hoverValue = !(0,lodash.isNil)(hover) ? hover : undefined;
      activeValue = !(0,lodash.isNil)(active) ? active : undefined;
    }

    const transition = `box-shadow ${config_values.transitionDuration} ${config_values.transitionTimingFunction}`;
    const sx = {};
    sx.Base = /*#__PURE__*/css({
      borderRadius,
      bottom: offset,
      boxShadow: getBoxShadow(value),
      opacity: config_values.elevationIntensity,
      left: offset,
      right: offset,
      top: offset,
      transition
    }, reduceMotion('transition'),  true ? "" : 0,  true ? "" : 0);

    if (!(0,lodash.isNil)(hoverValue)) {
      sx.hover = /*#__PURE__*/css("*:hover>&{box-shadow:", getBoxShadow(hoverValue), ";}" + ( true ? "" : 0),  true ? "" : 0);
    }

    if (!(0,lodash.isNil)(activeValue)) {
      sx.active = /*#__PURE__*/css("*:active>&{box-shadow:", getBoxShadow(activeValue), ";}" + ( true ? "" : 0),  true ? "" : 0);
    }

    if (!(0,lodash.isNil)(focus)) {
      sx.focus = /*#__PURE__*/css("*:focus>&{box-shadow:", getBoxShadow(focus), ";}" + ( true ? "" : 0),  true ? "" : 0);
    }

    return cx(Elevation, sx.Base, sx.hover && sx.hover, sx.focus && sx.focus, sx.active && sx.active, className);
  }, [active, borderRadius, className, cx, focus, hover, isInteractive, offset, value]);
  return { ...otherProps,
    className: classes,
    'aria-hidden': true
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/elevation/component.js



/**
 * Internal dependencies
 */



/**
 * @param {import('../ui/context').WordPressComponentProps<import('./types').Props, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                               forwardedRef
 */

function component_Elevation(props, forwardedRef) {
  const elevationProps = useElevation(props);
  return (0,react.createElement)(component, extends_extends({}, elevationProps, {
    ref: forwardedRef
  }));
}
/**
 * `Elevation` is a core component that renders shadow, using the library's shadow system.
 *
 * The shadow effect is generated using the `value` prop.
 *
 * @example
 * ```jsx
 * import {
 *	__experimentalElevation as Elevation,
 *	__experimentalSurface as Surface,
 *	__experimentalText as Text,
 * } from '@wordpress/components';
 *
 * function Example() {
 * 	return (
 * 		<Surface>
 * 			<Text>Code is Poetry</Text>
 * 			<Elevation value={ 5 } />
 * 		</Surface>
 * 	);
 * }
 * ```
 */


const ConnectedElevation = contextConnect(component_Elevation, 'Elevation');
/* harmony default export */ const elevation_component = (ConnectedElevation);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/styles.js
function styles_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */

/**
 * Internal dependencies
 */

 // Since the border for `Card` is rendered via the `box-shadow` property
// (as opposed to the `border` property), the value of the border radius needs
// to be adjusted by removing 1px (this is because the `box-shadow` renders
// as an "outer radius").

const adjustedBorderRadius = `calc(${config_values.cardBorderRadius} - 1px)`;
const Card = /*#__PURE__*/css("box-shadow:0 0 0 1px ", config_values.surfaceBorderColor, ";outline:none;" + ( true ? "" : 0),  true ? "" : 0);
const Header =  true ? {
  name: "1showjb",
  styles: "border-bottom:1px solid;box-sizing:border-box;&:last-child{border-bottom:none;}"
} : 0;
const Footer =  true ? {
  name: "14n5oej",
  styles: "border-top:1px solid;box-sizing:border-box;&:first-of-type{border-top:none;}"
} : 0;
const Content =  true ? {
  name: "13udsys",
  styles: "height:100%"
} : 0;
const Body =  true ? {
  name: "6ywzd",
  styles: "box-sizing:border-box;height:auto;max-height:100%"
} : 0;
const Media =  true ? {
  name: "dq805e",
  styles: "box-sizing:border-box;overflow:hidden;&>img,&>iframe{display:block;height:auto;max-width:100%;width:100%;}"
} : 0;
const Divider =  true ? {
  name: "c990dr",
  styles: "box-sizing:border-box;display:block;width:100%"
} : 0;
const borderRadius = /*#__PURE__*/css("&:first-of-type{border-top-left-radius:", adjustedBorderRadius, ";border-top-right-radius:", adjustedBorderRadius, ";}&:last-of-type{border-bottom-left-radius:", adjustedBorderRadius, ";border-bottom-right-radius:", adjustedBorderRadius, ";}" + ( true ? "" : 0),  true ? "" : 0);
const borderColor = /*#__PURE__*/css("border-color:", config_values.colorDivider, ";" + ( true ? "" : 0),  true ? "" : 0);
const boxShadowless =  true ? {
  name: "1t90u8d",
  styles: "box-shadow:none"
} : 0;
const borderless =  true ? {
  name: "1e1ncky",
  styles: "border:none"
} : 0;
const rounded = /*#__PURE__*/css("border-radius:", adjustedBorderRadius, ";" + ( true ? "" : 0),  true ? "" : 0);
const xSmallCardPadding = /*#__PURE__*/css("padding:", config_values.cardPaddingXSmall, ";" + ( true ? "" : 0),  true ? "" : 0);
const cardPaddings = {
  large: /*#__PURE__*/css("padding:", config_values.cardPaddingLarge, ";" + ( true ? "" : 0),  true ? "" : 0),
  medium: /*#__PURE__*/css("padding:", config_values.cardPaddingMedium, ";" + ( true ? "" : 0),  true ? "" : 0),
  small: /*#__PURE__*/css("padding:", config_values.cardPaddingSmall, ";" + ( true ? "" : 0),  true ? "" : 0),
  xSmall: xSmallCardPadding,
  // The `extraSmall` size is not officially documented, but the following styles
  // are kept for legacy reasons to support older values of the `size` prop.
  extraSmall: xSmallCardPadding
};
const shady = /*#__PURE__*/css("background-color:", COLORS.lightGray[200], ";" + ( true ? "" : 0),  true ? "" : 0);
//# sourceMappingURL=styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/validateNamespace.js
/**
 * Validate a namespace string.
 *
 * @param {string} namespace The namespace to validate - should take the form
 *                           `vendor/plugin/function`.
 *
 * @return {boolean} Whether the namespace is valid.
 */
function validateNamespace(namespace) {
  if ('string' !== typeof namespace || '' === namespace) {
    // eslint-disable-next-line no-console
    console.error('The namespace must be a non-empty string.');
    return false;
  }

  if (!/^[a-zA-Z][a-zA-Z0-9_.\-\/]*$/.test(namespace)) {
    // eslint-disable-next-line no-console
    console.error('The namespace can only contain numbers, letters, dashes, periods, underscores and slashes.');
    return false;
  }

  return true;
}

/* harmony default export */ const build_module_validateNamespace = (validateNamespace);
//# sourceMappingURL=validateNamespace.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/validateHookName.js
/**
 * Validate a hookName string.
 *
 * @param {string} hookName The hook name to validate. Should be a non empty string containing
 *                          only numbers, letters, dashes, periods and underscores. Also,
 *                          the hook name cannot begin with `__`.
 *
 * @return {boolean} Whether the hook name is valid.
 */
function validateHookName(hookName) {
  if ('string' !== typeof hookName || '' === hookName) {
    // eslint-disable-next-line no-console
    console.error('The hook name must be a non-empty string.');
    return false;
  }

  if (/^__/.test(hookName)) {
    // eslint-disable-next-line no-console
    console.error('The hook name cannot begin with `__`.');
    return false;
  }

  if (!/^[a-zA-Z][a-zA-Z0-9_.-]*$/.test(hookName)) {
    // eslint-disable-next-line no-console
    console.error('The hook name can only contain numbers, letters, dashes, periods and underscores.');
    return false;
  }

  return true;
}

/* harmony default export */ const build_module_validateHookName = (validateHookName);
//# sourceMappingURL=validateHookName.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/createAddHook.js
/**
 * Internal dependencies
 */


/**
 * @callback AddHook
 *
 * Adds the hook to the appropriate hooks container.
 *
 * @param {string}               hookName      Name of hook to add
 * @param {string}               namespace     The unique namespace identifying the callback in the form `vendor/plugin/function`.
 * @param {import('.').Callback} callback      Function to call when the hook is run
 * @param {number}               [priority=10] Priority of this hook
 */

/**
 * Returns a function which, when invoked, will add a hook.
 *
 * @param {import('.').Hooks}    hooks    Hooks instance.
 * @param {import('.').StoreKey} storeKey
 *
 * @return {AddHook} Function that adds a new hook.
 */

function createAddHook(hooks, storeKey) {
  return function addHook(hookName, namespace, callback) {
    let priority = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 10;
    const hooksStore = hooks[storeKey];

    if (!build_module_validateHookName(hookName)) {
      return;
    }

    if (!build_module_validateNamespace(namespace)) {
      return;
    }

    if ('function' !== typeof callback) {
      // eslint-disable-next-line no-console
      console.error('The hook callback must be a function.');
      return;
    } // Validate numeric priority


    if ('number' !== typeof priority) {
      // eslint-disable-next-line no-console
      console.error('If specified, the hook priority must be a number.');
      return;
    }

    const handler = {
      callback,
      priority,
      namespace
    };

    if (hooksStore[hookName]) {
      // Find the correct insert index of the new hook.
      const handlers = hooksStore[hookName].handlers;
      /** @type {number} */

      let i;

      for (i = handlers.length; i > 0; i--) {
        if (priority >= handlers[i - 1].priority) {
          break;
        }
      }

      if (i === handlers.length) {
        // If append, operate via direct assignment.
        handlers[i] = handler;
      } else {
        // Otherwise, insert before index via splice.
        handlers.splice(i, 0, handler);
      } // We may also be currently executing this hook.  If the callback
      // we're adding would come after the current callback, there's no
      // problem; otherwise we need to increase the execution index of
      // any other runs by 1 to account for the added element.


      hooksStore.__current.forEach(hookInfo => {
        if (hookInfo.name === hookName && hookInfo.currentIndex >= i) {
          hookInfo.currentIndex++;
        }
      });
    } else {
      // This is the first hook of its type.
      hooksStore[hookName] = {
        handlers: [handler],
        runs: 0
      };
    }

    if (hookName !== 'hookAdded') {
      hooks.doAction('hookAdded', hookName, namespace, callback, priority);
    }
  };
}

/* harmony default export */ const build_module_createAddHook = (createAddHook);
//# sourceMappingURL=createAddHook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/createRemoveHook.js
/**
 * Internal dependencies
 */


/**
 * @callback RemoveHook
 * Removes the specified callback (or all callbacks) from the hook with a given hookName
 * and namespace.
 *
 * @param {string} hookName  The name of the hook to modify.
 * @param {string} namespace The unique namespace identifying the callback in the
 *                           form `vendor/plugin/function`.
 *
 * @return {number | undefined} The number of callbacks removed.
 */

/**
 * Returns a function which, when invoked, will remove a specified hook or all
 * hooks by the given name.
 *
 * @param {import('.').Hooks}    hooks             Hooks instance.
 * @param {import('.').StoreKey} storeKey
 * @param {boolean}              [removeAll=false] Whether to remove all callbacks for a hookName,
 *                                                 without regard to namespace. Used to create
 *                                                 `removeAll*` functions.
 *
 * @return {RemoveHook} Function that removes hooks.
 */

function createRemoveHook(hooks, storeKey) {
  let removeAll = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return function removeHook(hookName, namespace) {
    const hooksStore = hooks[storeKey];

    if (!build_module_validateHookName(hookName)) {
      return;
    }

    if (!removeAll && !build_module_validateNamespace(namespace)) {
      return;
    } // Bail if no hooks exist by this name.


    if (!hooksStore[hookName]) {
      return 0;
    }

    let handlersRemoved = 0;

    if (removeAll) {
      handlersRemoved = hooksStore[hookName].handlers.length;
      hooksStore[hookName] = {
        runs: hooksStore[hookName].runs,
        handlers: []
      };
    } else {
      // Try to find the specified callback to remove.
      const handlers = hooksStore[hookName].handlers;

      for (let i = handlers.length - 1; i >= 0; i--) {
        if (handlers[i].namespace === namespace) {
          handlers.splice(i, 1);
          handlersRemoved++; // This callback may also be part of a hook that is
          // currently executing.  If the callback we're removing
          // comes after the current callback, there's no problem;
          // otherwise we need to decrease the execution index of any
          // other runs by 1 to account for the removed element.

          hooksStore.__current.forEach(hookInfo => {
            if (hookInfo.name === hookName && hookInfo.currentIndex >= i) {
              hookInfo.currentIndex--;
            }
          });
        }
      }
    }

    if (hookName !== 'hookRemoved') {
      hooks.doAction('hookRemoved', hookName, namespace);
    }

    return handlersRemoved;
  };
}

/* harmony default export */ const build_module_createRemoveHook = (createRemoveHook);
//# sourceMappingURL=createRemoveHook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/createHasHook.js
/**
 * @callback HasHook
 *
 * Returns whether any handlers are attached for the given hookName and optional namespace.
 *
 * @param {string} hookName    The name of the hook to check for.
 * @param {string} [namespace] Optional. The unique namespace identifying the callback
 *                             in the form `vendor/plugin/function`.
 *
 * @return {boolean} Whether there are handlers that are attached to the given hook.
 */

/**
 * Returns a function which, when invoked, will return whether any handlers are
 * attached to a particular hook.
 *
 * @param {import('.').Hooks}    hooks    Hooks instance.
 * @param {import('.').StoreKey} storeKey
 *
 * @return {HasHook} Function that returns whether any handlers are
 *                   attached to a particular hook and optional namespace.
 */
function createHasHook(hooks, storeKey) {
  return function hasHook(hookName, namespace) {
    const hooksStore = hooks[storeKey]; // Use the namespace if provided.

    if ('undefined' !== typeof namespace) {
      return hookName in hooksStore && hooksStore[hookName].handlers.some(hook => hook.namespace === namespace);
    }

    return hookName in hooksStore;
  };
}

/* harmony default export */ const build_module_createHasHook = (createHasHook);
//# sourceMappingURL=createHasHook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/createRunHook.js
/**
 * Returns a function which, when invoked, will execute all callbacks
 * registered to a hook of the specified type, optionally returning the final
 * value of the call chain.
 *
 * @param {import('.').Hooks}    hooks                  Hooks instance.
 * @param {import('.').StoreKey} storeKey
 * @param {boolean}              [returnFirstArg=false] Whether each hook callback is expected to
 *                                                      return its first argument.
 *
 * @return {(hookName:string, ...args: unknown[]) => unknown} Function that runs hook callbacks.
 */
function createRunHook(hooks, storeKey) {
  let returnFirstArg = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  return function runHooks(hookName) {
    const hooksStore = hooks[storeKey];

    if (!hooksStore[hookName]) {
      hooksStore[hookName] = {
        handlers: [],
        runs: 0
      };
    }

    hooksStore[hookName].runs++;
    const handlers = hooksStore[hookName].handlers; // The following code is stripped from production builds.

    if (false) {}

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    if (!handlers || !handlers.length) {
      return returnFirstArg ? args[0] : undefined;
    }

    const hookInfo = {
      name: hookName,
      currentIndex: 0
    };

    hooksStore.__current.push(hookInfo);

    while (hookInfo.currentIndex < handlers.length) {
      const handler = handlers[hookInfo.currentIndex];
      const result = handler.callback.apply(null, args);

      if (returnFirstArg) {
        args[0] = result;
      }

      hookInfo.currentIndex++;
    }

    hooksStore.__current.pop();

    if (returnFirstArg) {
      return args[0];
    }
  };
}

/* harmony default export */ const build_module_createRunHook = (createRunHook);
//# sourceMappingURL=createRunHook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/createCurrentHook.js
/**
 * Returns a function which, when invoked, will return the name of the
 * currently running hook, or `null` if no hook of the given type is currently
 * running.
 *
 * @param {import('.').Hooks}    hooks    Hooks instance.
 * @param {import('.').StoreKey} storeKey
 *
 * @return {() => string | null} Function that returns the current hook name or null.
 */
function createCurrentHook(hooks, storeKey) {
  return function currentHook() {
    var _hooksStore$__current, _hooksStore$__current2;

    const hooksStore = hooks[storeKey];
    return (_hooksStore$__current = (_hooksStore$__current2 = hooksStore.__current[hooksStore.__current.length - 1]) === null || _hooksStore$__current2 === void 0 ? void 0 : _hooksStore$__current2.name) !== null && _hooksStore$__current !== void 0 ? _hooksStore$__current : null;
  };
}

/* harmony default export */ const build_module_createCurrentHook = (createCurrentHook);
//# sourceMappingURL=createCurrentHook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/createDoingHook.js
/**
 * @callback DoingHook
 * Returns whether a hook is currently being executed.
 *
 * @param {string} [hookName] The name of the hook to check for.  If
 *                            omitted, will check for any hook being executed.
 *
 * @return {boolean} Whether the hook is being executed.
 */

/**
 * Returns a function which, when invoked, will return whether a hook is
 * currently being executed.
 *
 * @param {import('.').Hooks}    hooks    Hooks instance.
 * @param {import('.').StoreKey} storeKey
 *
 * @return {DoingHook} Function that returns whether a hook is currently
 *                     being executed.
 */
function createDoingHook(hooks, storeKey) {
  return function doingHook(hookName) {
    const hooksStore = hooks[storeKey]; // If the hookName was not passed, check for any current hook.

    if ('undefined' === typeof hookName) {
      return 'undefined' !== typeof hooksStore.__current[0];
    } // Return the __current hook.


    return hooksStore.__current[0] ? hookName === hooksStore.__current[0].name : false;
  };
}

/* harmony default export */ const build_module_createDoingHook = (createDoingHook);
//# sourceMappingURL=createDoingHook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/createDidHook.js
/**
 * Internal dependencies
 */

/**
 * @callback DidHook
 *
 * Returns the number of times an action has been fired.
 *
 * @param {string} hookName The hook name to check.
 *
 * @return {number | undefined} The number of times the hook has run.
 */

/**
 * Returns a function which, when invoked, will return the number of times a
 * hook has been called.
 *
 * @param {import('.').Hooks}    hooks    Hooks instance.
 * @param {import('.').StoreKey} storeKey
 *
 * @return {DidHook} Function that returns a hook's call count.
 */

function createDidHook(hooks, storeKey) {
  return function didHook(hookName) {
    const hooksStore = hooks[storeKey];

    if (!build_module_validateHookName(hookName)) {
      return;
    }

    return hooksStore[hookName] && hooksStore[hookName].runs ? hooksStore[hookName].runs : 0;
  };
}

/* harmony default export */ const build_module_createDidHook = (createDidHook);
//# sourceMappingURL=createDidHook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/createHooks.js
/**
 * Internal dependencies
 */







/**
 * Internal class for constructing hooks. Use `createHooks()` function
 *
 * Note, it is necessary to expose this class to make its type public.
 *
 * @private
 */

class _Hooks {
  constructor() {
    /** @type {import('.').Store} actions */
    this.actions = Object.create(null);
    this.actions.__current = [];
    /** @type {import('.').Store} filters */

    this.filters = Object.create(null);
    this.filters.__current = [];
    this.addAction = build_module_createAddHook(this, 'actions');
    this.addFilter = build_module_createAddHook(this, 'filters');
    this.removeAction = build_module_createRemoveHook(this, 'actions');
    this.removeFilter = build_module_createRemoveHook(this, 'filters');
    this.hasAction = build_module_createHasHook(this, 'actions');
    this.hasFilter = build_module_createHasHook(this, 'filters');
    this.removeAllActions = build_module_createRemoveHook(this, 'actions', true);
    this.removeAllFilters = build_module_createRemoveHook(this, 'filters', true);
    this.doAction = build_module_createRunHook(this, 'actions');
    this.applyFilters = build_module_createRunHook(this, 'filters', true);
    this.currentAction = build_module_createCurrentHook(this, 'actions');
    this.currentFilter = build_module_createCurrentHook(this, 'filters');
    this.doingAction = build_module_createDoingHook(this, 'actions');
    this.doingFilter = build_module_createDoingHook(this, 'filters');
    this.didAction = build_module_createDidHook(this, 'actions');
    this.didFilter = build_module_createDidHook(this, 'filters');
  }

}
/** @typedef {_Hooks} Hooks */

/**
 * Returns an instance of the hooks object.
 *
 * @return {Hooks} A Hooks instance.
 */

function createHooks() {
  return new _Hooks();
}

/* harmony default export */ const build_module_createHooks = (createHooks);
//# sourceMappingURL=createHooks.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/hooks/build-module/index.js
/**
 * Internal dependencies
 */

/** @typedef {(...args: any[])=>any} Callback */

/**
 * @typedef Handler
 * @property {Callback} callback  The callback
 * @property {string}   namespace The namespace
 * @property {number}   priority  The namespace
 */

/**
 * @typedef Hook
 * @property {Handler[]} handlers Array of handlers
 * @property {number}    runs     Run counter
 */

/**
 * @typedef Current
 * @property {string} name         Hook name
 * @property {number} currentIndex The index
 */

/**
 * @typedef {Record<string, Hook> & {__current: Current[]}} Store
 */

/**
 * @typedef {'actions' | 'filters'} StoreKey
 */

/**
 * @typedef {import('./createHooks').Hooks} Hooks
 */

const defaultHooks = build_module_createHooks();
const {
  addAction,
  addFilter,
  removeAction,
  removeFilter,
  hasAction,
  hasFilter,
  removeAllActions,
  removeAllFilters,
  doAction,
  applyFilters,
  currentAction,
  currentFilter,
  doingAction,
  doingFilter,
  didAction,
  didFilter,
  actions,
  filters
} = defaultHooks;

//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/deprecated/build-module/index.js
/**
 * WordPress dependencies
 */

/**
 * Object map tracking messages which have been logged, for use in ensuring a
 * message is only logged once.
 *
 * @type {Record<string, true | undefined>}
 */

const logged = Object.create(null);
/**
 * Logs a message to notify developers about a deprecated feature.
 *
 * @param {string} feature               Name of the deprecated feature.
 * @param {Object} [options]             Personalisation options
 * @param {string} [options.since]       Version in which the feature was deprecated.
 * @param {string} [options.version]     Version in which the feature will be removed.
 * @param {string} [options.alternative] Feature to use instead
 * @param {string} [options.plugin]      Plugin name if it's a plugin feature
 * @param {string} [options.link]        Link to documentation
 * @param {string} [options.hint]        Additional message to help transition away from the deprecated feature.
 *
 * @example
 * ```js
 * import deprecated from '@wordpress/deprecated';
 *
 * deprecated( 'Eating meat', {
 * 	since: '2019.01.01'
 * 	version: '2020.01.01',
 * 	alternative: 'vegetables',
 * 	plugin: 'the earth',
 * 	hint: 'You may find it beneficial to transition gradually.',
 * } );
 *
 * // Logs: 'Eating meat is deprecated since version 2019.01.01 and will be removed from the earth in version 2020.01.01. Please use vegetables instead. Note: You may find it beneficial to transition gradually.'
 * ```
 */

function deprecated(feature) {
  let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  const {
    since,
    version,
    alternative,
    plugin,
    link,
    hint
  } = options;
  const pluginMessage = plugin ? ` from ${plugin}` : '';
  const sinceMessage = since ? ` since version ${since}` : '';
  const versionMessage = version ? ` and will be removed${pluginMessage} in version ${version}` : '';
  const useInsteadMessage = alternative ? ` Please use ${alternative} instead.` : '';
  const linkMessage = link ? ` See: ${link}` : '';
  const hintMessage = hint ? ` Note: ${hint}` : '';
  const message = `${feature} is deprecated${sinceMessage}${versionMessage}.${useInsteadMessage}${linkMessage}${hintMessage}`; // Skip if already logged.

  if (message in logged) {
    return;
  }
  /**
   * Fires whenever a deprecated feature is encountered
   *
   * @param {string}  feature             Name of the deprecated feature.
   * @param {?Object} options             Personalisation options
   * @param {string}  options.since       Version in which the feature was deprecated.
   * @param {?string} options.version     Version in which the feature will be removed.
   * @param {?string} options.alternative Feature to use instead
   * @param {?string} options.plugin      Plugin name if it's a plugin feature
   * @param {?string} options.link        Link to documentation
   * @param {?string} options.hint        Additional message to help transition away from the deprecated feature.
   * @param {?string} message             Message sent to console.warn
   */


  doAction('deprecated', feature, options, message); // eslint-disable-next-line no-console

  console.warn(message);
  logged[message] = true;
}
/** @typedef {import('utility-types').NonUndefined<Parameters<typeof deprecated>[1]>} DeprecatedOptions */
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/surface/styles.js
/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


const Surface = /*#__PURE__*/css("background-color:", config_values.surfaceColor, ";color:", COLORS.gray[900], ";position:relative;" + ( true ? "" : 0),  true ? "" : 0);
const background = /*#__PURE__*/css("background-color:", config_values.surfaceBackgroundColor, ";" + ( true ? "" : 0),  true ? "" : 0);
function getBorders(_ref) {
  let {
    borderBottom,
    borderLeft,
    borderRight,
    borderTop
  } = _ref;
  const borderStyle = `1px solid ${config_values.surfaceBorderColor}`;
  return /*#__PURE__*/css({
    borderBottom: borderBottom ? borderStyle : undefined,
    borderLeft: borderLeft ? borderStyle : undefined,
    borderRight: borderRight ? borderStyle : undefined,
    borderTop: borderTop ? borderStyle : undefined
  },  true ? "" : 0,  true ? "" : 0);
}
const primary = /*#__PURE__*/css( true ? "" : 0,  true ? "" : 0);
const secondary = /*#__PURE__*/css("background:", config_values.surfaceBackgroundTintColor, ";" + ( true ? "" : 0),  true ? "" : 0);
const tertiary = /*#__PURE__*/css("background:", config_values.surfaceBackgroundTertiaryColor, ";" + ( true ? "" : 0),  true ? "" : 0);

const customBackgroundSize = surfaceBackgroundSize => [surfaceBackgroundSize, surfaceBackgroundSize].join(' ');

const dottedBackground1 = surfaceBackgroundSizeDotted => ['90deg', [config_values.surfaceBackgroundColor, surfaceBackgroundSizeDotted].join(' '), 'transparent 1%'].join(',');

const dottedBackground2 = surfaceBackgroundSizeDotted => [[config_values.surfaceBackgroundColor, surfaceBackgroundSizeDotted].join(' '), 'transparent 1%'].join(',');

const dottedBackgroundCombined = surfaceBackgroundSizeDotted => [`linear-gradient( ${dottedBackground1(surfaceBackgroundSizeDotted)} ) center`, `linear-gradient( ${dottedBackground2(surfaceBackgroundSizeDotted)} ) center`, config_values.surfaceBorderBoldColor].join(',');

const getDotted = (surfaceBackgroundSize, surfaceBackgroundSizeDotted) => /*#__PURE__*/css("background:", dottedBackgroundCombined(surfaceBackgroundSizeDotted), ";background-size:", customBackgroundSize(surfaceBackgroundSize), ";" + ( true ? "" : 0),  true ? "" : 0);
const gridBackground1 = [`${config_values.surfaceBorderSubtleColor} 1px`, 'transparent 1px'].join(',');
const gridBackground2 = ['90deg', `${config_values.surfaceBorderSubtleColor} 1px`, 'transparent 1px'].join(',');
const gridBackgroundCombined = [`linear-gradient( ${gridBackground1} )`, `linear-gradient( ${gridBackground2} )`].join(',');
const getGrid = surfaceBackgroundSize => {
  return /*#__PURE__*/css("background:", config_values.surfaceBackgroundColor, ";background-image:", gridBackgroundCombined, ";background-size:", customBackgroundSize(surfaceBackgroundSize), ";" + ( true ? "" : 0),  true ? "" : 0);
};
const getVariant = (variant, surfaceBackgroundSize, surfaceBackgroundSizeDotted) => {
  switch (variant) {
    case 'dotted':
      {
        return getDotted(surfaceBackgroundSize, surfaceBackgroundSizeDotted);
      }

    case 'grid':
      {
        return getGrid(surfaceBackgroundSize);
      }

    case 'primary':
      {
        return primary;
      }

    case 'secondary':
      {
        return secondary;
      }

    case 'tertiary':
      {
        return tertiary;
      }
  }
};
//# sourceMappingURL=styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/surface/hook.js
/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */




function useSurface(props) {
  const {
    backgroundSize = 12,
    borderBottom = false,
    borderLeft = false,
    borderRight = false,
    borderTop = false,
    className,
    variant = 'primary',
    ...otherProps
  } = useContextSystem(props, 'Surface');
  const cx = useCx();
  const classes = (0,react.useMemo)(() => {
    const sx = {
      borders: getBorders({
        borderBottom,
        borderLeft,
        borderRight,
        borderTop
      })
    };
    return cx(Surface, sx.borders, getVariant(variant, `${backgroundSize}px`, `${backgroundSize - 1}px`), className);
  }, [backgroundSize, borderBottom, borderLeft, borderRight, borderTop, className, cx, variant]);
  return { ...otherProps,
    className: classes
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/card/hook.js
/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */





/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').Props, 'div'>} props
 */

function useDeprecatedProps(_ref) {
  let {
    elevation,
    isElevated,
    ...otherProps
  } = _ref;

  /**@type {import('../../ui/context').WordPressComponentProps<import('../types').Props, 'div'>} */
  const propsToReturn = { ...otherProps
  };
  let computedElevation = elevation;

  if (isElevated) {
    var _computedElevation;

    deprecated('Card isElevated prop', {
      since: '5.9',
      alternative: 'elevation'
    });
    (_computedElevation = computedElevation) !== null && _computedElevation !== void 0 ? _computedElevation : computedElevation = 2;
  } // The `elevation` prop should only be passed when it's not `undefined`,
  // otherwise it will override the value that gets derived from `useContextSystem`.


  if (typeof computedElevation !== 'undefined') {
    propsToReturn.elevation = computedElevation;
  }

  return propsToReturn;
}
/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').Props, 'div'>} props
 */


function useCard(props) {
  const {
    className,
    elevation = 0,
    isBorderless = false,
    isRounded = true,
    size = 'medium',
    ...otherProps
  } = useContextSystem(useDeprecatedProps(props), 'Card');
  const cx = useCx();
  const classes = (0,react.useMemo)(() => {
    return cx(Card, isBorderless && boxShadowless, isRounded && rounded, className);
  }, [className, cx, isBorderless, isRounded]);
  const surfaceProps = useSurface({ ...otherProps,
    className: classes
  });
  return { ...surfaceProps,
    elevation,
    isBorderless,
    isRounded,
    size
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/card/component.js



/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */








/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').Props, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                                   forwardedRef
 */

function component_Card(props, forwardedRef) {
  const {
    children,
    elevation,
    isBorderless,
    isRounded,
    size,
    ...otherProps
  } = useCard(props);
  const elevationBorderRadius = isRounded ? config_values.cardBorderRadius : 0;
  const cx = useCx();
  const elevationClassName = (0,react.useMemo)(() => cx( /*#__PURE__*/css({
    borderRadius: elevationBorderRadius
  },  true ? "" : 0,  true ? "" : 0)), [cx, elevationBorderRadius]);
  const contextProviderValue = (0,react.useMemo)(() => {
    const contextProps = {
      size,
      isBorderless
    };
    return {
      CardBody: contextProps,
      CardHeader: contextProps,
      CardFooter: contextProps
    };
  }, [isBorderless, size]);
  return (0,react.createElement)(ContextSystemProvider, {
    value: contextProviderValue
  }, (0,react.createElement)(component, extends_extends({}, otherProps, {
    ref: forwardedRef
  }), (0,react.createElement)(component, {
    className: cx(Content)
  }, children), (0,react.createElement)(elevation_component, {
    className: elevationClassName,
    isInteractive: false,
    value: elevation ? 1 : 0
  }), (0,react.createElement)(elevation_component, {
    className: elevationClassName,
    isInteractive: false,
    value: elevation
  })));
}
/**
 * `Card` provides a flexible and extensible content container.
 * `Card` also provides a convenient set of sub-components such as `CardBody`,
 * `CardHeader`, `CardFooter`, and more.
 *
 * @example
 * ```jsx
 * import {
 *   Card,
 *   CardHeader,
 *   CardBody,
 *   CardFooter,
 *   Text,
 *   Heading,
 * } from `@wordpress/components`;
 *
 * function Example() {
 *   return (
 *     <Card>
 *       <CardHeader>
 *         <Heading size={ 4 }>Card Title</Heading>
 *       </CardHeader>
 *       <CardBody>
 *         <Text>Card Content</Text>
 *       </CardBody>
 *       <CardFooter>
 *         <Text>Card Footer</Text>
 *       </CardFooter>
 *     </Card>
 *   );
 * }
 * ```
 */


const ConnectedCard = contextConnect(component_Card, 'Card');
/* harmony default export */ const card_component = (ConnectedCard);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/utils/use-responsive-value.js
/**
 * WordPress dependencies
 */

const breakpoints = ['40em', '52em', '64em'];
const useBreakpointIndex = function () {
  let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  const {
    defaultIndex = 0
  } = options;

  if (typeof defaultIndex !== 'number') {
    throw new TypeError(`Default breakpoint index should be a number. Got: ${defaultIndex}, ${typeof defaultIndex}`);
  } else if (defaultIndex < 0 || defaultIndex > breakpoints.length - 1) {
    throw new RangeError(`Default breakpoint index out of range. Theme has ${breakpoints.length} breakpoints, got index ${defaultIndex}`);
  }

  const [value, setValue] = (0,react.useState)(defaultIndex);
  (0,react.useEffect)(() => {
    const getIndex = () => breakpoints.filter(bp => {
      return typeof window !== 'undefined' ? window.matchMedia(`screen and (min-width: ${bp})`).matches : false;
    }).length;

    const onResize = () => {
      const newValue = getIndex();

      if (value !== newValue) {
        setValue(newValue);
      }
    };

    onResize();

    if (typeof window !== 'undefined') {
      window.addEventListener('resize', onResize);
    }

    return () => {
      if (typeof window !== 'undefined') {
        window.removeEventListener('resize', onResize);
      }
    };
  }, [value]);
  return value;
};
function useResponsiveValue(values) {
  let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  const index = useBreakpointIndex(options); // Allow calling the function with a "normal" value without having to check on the outside.

  if (!Array.isArray(values) && typeof values !== 'function') return values;
  const array = values || [];
  /* eslint-disable jsdoc/no-undefined-types */

  return (
    /** @type {T[]} */
    array[
    /* eslint-enable jsdoc/no-undefined-types */
    index >= array.length ? array.length - 1 : index]
  );
}
//# sourceMappingURL=use-responsive-value.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/flex/styles.js
function flex_styles_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */

const Flex =  true ? {
  name: "zjik7",
  styles: "display:flex"
} : 0;
const Item =  true ? {
  name: "qgaee5",
  styles: "display:block;max-height:100%;max-width:100%;min-height:0;min-width:0"
} : 0;
const block =  true ? {
  name: "82a6rk",
  styles: "flex:1"
} : 0;
/**
 * Workaround to optimize DOM rendering.
 * We'll enhance alignment with naive parent flex assumptions.
 *
 * Trade-off:
 * Far less DOM less. However, UI rendering is not as reliable.
 */

/**
 * Improves stability of width/height rendering.
 * https://github.com/ItsJonQ/g2/pull/149
 */

const ItemsColumn =  true ? {
  name: "13nosa1",
  styles: ">*{min-height:0;}"
} : 0;
const ItemsRow =  true ? {
  name: "1pwxzk4",
  styles: ">*{min-width:0;}"
} : 0;
//# sourceMappingURL=styles.js.map
// EXTERNAL MODULE: ./node_modules/sprintf-js/src/sprintf.js
var sprintf = __webpack_require__(8975);
var sprintf_default = /*#__PURE__*/__webpack_require__.n(sprintf);
;// CONCATENATED MODULE: ./node_modules/@wordpress/i18n/build-module/sprintf.js
/**
 * External dependencies
 */


/**
 * Log to console, once per message; or more precisely, per referentially equal
 * argument set. Because Jed throws errors, we log these to the console instead
 * to avoid crashing the application.
 *
 * @param {...*} args Arguments to pass to `console.error`
 */

const logErrorOnce = memize_default()(console.error); // eslint-disable-line no-console

/**
 * Returns a formatted string. If an error occurs in applying the format, the
 * original format string is returned.
 *
 * @param {string} format The format of the string to generate.
 * @param {...*}   args   Arguments to apply to the format.
 *
 * @see https://www.npmjs.com/package/sprintf-js
 *
 * @return {string} The formatted string.
 */

function sprintf_sprintf(format) {
  try {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return sprintf_default().sprintf(format, ...args);
  } catch (error) {
    if (error instanceof Error) {
      logErrorOnce('sprintf error: \n\n' + error.toString());
    }

    return format;
  }
}
//# sourceMappingURL=sprintf.js.map
;// CONCATENATED MODULE: ./node_modules/@tannin/postfix/index.js
var PRECEDENCE, OPENERS, TERMINATORS, PATTERN;

/**
 * Operator precedence mapping.
 *
 * @type {Object}
 */
PRECEDENCE = {
	'(': 9,
	'!': 8,
	'*': 7,
	'/': 7,
	'%': 7,
	'+': 6,
	'-': 6,
	'<': 5,
	'<=': 5,
	'>': 5,
	'>=': 5,
	'==': 4,
	'!=': 4,
	'&&': 3,
	'||': 2,
	'?': 1,
	'?:': 1,
};

/**
 * Characters which signal pair opening, to be terminated by terminators.
 *
 * @type {string[]}
 */
OPENERS = [ '(', '?' ];

/**
 * Characters which signal pair termination, the value an array with the
 * opener as its first member. The second member is an optional operator
 * replacement to push to the stack.
 *
 * @type {string[]}
 */
TERMINATORS = {
	')': [ '(' ],
	':': [ '?', '?:' ],
};

/**
 * Pattern matching operators and openers.
 *
 * @type {RegExp}
 */
PATTERN = /<=|>=|==|!=|&&|\|\||\?:|\(|!|\*|\/|%|\+|-|<|>|\?|\)|:/;

/**
 * Given a C expression, returns the equivalent postfix (Reverse Polish)
 * notation terms as an array.
 *
 * If a postfix string is desired, simply `.join( ' ' )` the result.
 *
 * @example
 *
 * ```js
 * import postfix from '@tannin/postfix';
 *
 * postfix( 'n > 1' );
 * // ⇒ [ 'n', '1', '>' ]
 * ```
 *
 * @param {string} expression C expression.
 *
 * @return {string[]} Postfix terms.
 */
function postfix( expression ) {
	var terms = [],
		stack = [],
		match, operator, term, element;

	while ( ( match = expression.match( PATTERN ) ) ) {
		operator = match[ 0 ];

		// Term is the string preceding the operator match. It may contain
		// whitespace, and may be empty (if operator is at beginning).
		term = expression.substr( 0, match.index ).trim();
		if ( term ) {
			terms.push( term );
		}

		while ( ( element = stack.pop() ) ) {
			if ( TERMINATORS[ operator ] ) {
				if ( TERMINATORS[ operator ][ 0 ] === element ) {
					// Substitution works here under assumption that because
					// the assigned operator will no longer be a terminator, it
					// will be pushed to the stack during the condition below.
					operator = TERMINATORS[ operator ][ 1 ] || operator;
					break;
				}
			} else if ( OPENERS.indexOf( element ) >= 0 || PRECEDENCE[ element ] < PRECEDENCE[ operator ] ) {
				// Push to stack if either an opener or when pop reveals an
				// element of lower precedence.
				stack.push( element );
				break;
			}

			// For each popped from stack, push to terms.
			terms.push( element );
		}

		if ( ! TERMINATORS[ operator ] ) {
			stack.push( operator );
		}

		// Slice matched fragment from expression to continue match.
		expression = expression.substr( match.index + operator.length );
	}

	// Push remainder of operand, if exists, to terms.
	expression = expression.trim();
	if ( expression ) {
		terms.push( expression );
	}

	// Pop remaining items from stack into terms.
	return terms.concat( stack.reverse() );
}

;// CONCATENATED MODULE: ./node_modules/@tannin/evaluate/index.js
/**
 * Operator callback functions.
 *
 * @type {Object}
 */
var OPERATORS = {
	'!': function( a ) {
		return ! a;
	},
	'*': function( a, b ) {
		return a * b;
	},
	'/': function( a, b ) {
		return a / b;
	},
	'%': function( a, b ) {
		return a % b;
	},
	'+': function( a, b ) {
		return a + b;
	},
	'-': function( a, b ) {
		return a - b;
	},
	'<': function( a, b ) {
		return a < b;
	},
	'<=': function( a, b ) {
		return a <= b;
	},
	'>': function( a, b ) {
		return a > b;
	},
	'>=': function( a, b ) {
		return a >= b;
	},
	'==': function( a, b ) {
		return a === b;
	},
	'!=': function( a, b ) {
		return a !== b;
	},
	'&&': function( a, b ) {
		return a && b;
	},
	'||': function( a, b ) {
		return a || b;
	},
	'?:': function( a, b, c ) {
		if ( a ) {
			throw b;
		}

		return c;
	},
};

/**
 * Given an array of postfix terms and operand variables, returns the result of
 * the postfix evaluation.
 *
 * @example
 *
 * ```js
 * import evaluate from '@tannin/evaluate';
 *
 * // 3 + 4 * 5 / 6 ⇒ '3 4 5 * 6 / +'
 * const terms = [ '3', '4', '5', '*', '6', '/', '+' ];
 *
 * evaluate( terms, {} );
 * // ⇒ 6.333333333333334
 * ```
 *
 * @param {string[]} postfix   Postfix terms.
 * @param {Object}   variables Operand variables.
 *
 * @return {*} Result of evaluation.
 */
function evaluate( postfix, variables ) {
	var stack = [],
		i, j, args, getOperatorResult, term, value;

	for ( i = 0; i < postfix.length; i++ ) {
		term = postfix[ i ];

		getOperatorResult = OPERATORS[ term ];
		if ( getOperatorResult ) {
			// Pop from stack by number of function arguments.
			j = getOperatorResult.length;
			args = Array( j );
			while ( j-- ) {
				args[ j ] = stack.pop();
			}

			try {
				value = getOperatorResult.apply( null, args );
			} catch ( earlyReturn ) {
				return earlyReturn;
			}
		} else if ( variables.hasOwnProperty( term ) ) {
			value = variables[ term ];
		} else {
			value = +term;
		}

		stack.push( value );
	}

	return stack[ 0 ];
}

;// CONCATENATED MODULE: ./node_modules/@tannin/compile/index.js



/**
 * Given a C expression, returns a function which can be called to evaluate its
 * result.
 *
 * @example
 *
 * ```js
 * import compile from '@tannin/compile';
 *
 * const evaluate = compile( 'n > 1' );
 *
 * evaluate( { n: 2 } );
 * // ⇒ true
 * ```
 *
 * @param {string} expression C expression.
 *
 * @return {(variables?:{[variable:string]:*})=>*} Compiled evaluator.
 */
function compile_compile( expression ) {
	var terms = postfix( expression );

	return function( variables ) {
		return evaluate( terms, variables );
	};
}

;// CONCATENATED MODULE: ./node_modules/@tannin/plural-forms/index.js


/**
 * Given a C expression, returns a function which, when called with a value,
 * evaluates the result with the value assumed to be the "n" variable of the
 * expression. The result will be coerced to its numeric equivalent.
 *
 * @param {string} expression C expression.
 *
 * @return {Function} Evaluator function.
 */
function pluralForms( expression ) {
	var evaluate = compile_compile( expression );

	return function( n ) {
		return +evaluate( { n: n } );
	};
}

;// CONCATENATED MODULE: ./node_modules/tannin/index.js


/**
 * Tannin constructor options.
 *
 * @typedef {Object} TanninOptions
 *
 * @property {string}   [contextDelimiter] Joiner in string lookup with context.
 * @property {Function} [onMissingKey]     Callback to invoke when key missing.
 */

/**
 * Domain metadata.
 *
 * @typedef {Object} TanninDomainMetadata
 *
 * @property {string}            [domain]       Domain name.
 * @property {string}            [lang]         Language code.
 * @property {(string|Function)} [plural_forms] Plural forms expression or
 *                                              function evaluator.
 */

/**
 * Domain translation pair respectively representing the singular and plural
 * translation.
 *
 * @typedef {[string,string]} TanninTranslation
 */

/**
 * Locale data domain. The key is used as reference for lookup, the value an
 * array of two string entries respectively representing the singular and plural
 * translation.
 *
 * @typedef {{[key:string]:TanninDomainMetadata|TanninTranslation,'':TanninDomainMetadata|TanninTranslation}} TanninLocaleDomain
 */

/**
 * Jed-formatted locale data.
 *
 * @see http://messageformat.github.io/Jed/
 *
 * @typedef {{[domain:string]:TanninLocaleDomain}} TanninLocaleData
 */

/**
 * Default Tannin constructor options.
 *
 * @type {TanninOptions}
 */
var DEFAULT_OPTIONS = {
	contextDelimiter: '\u0004',
	onMissingKey: null,
};

/**
 * Given a specific locale data's config `plural_forms` value, returns the
 * expression.
 *
 * @example
 *
 * ```
 * getPluralExpression( 'nplurals=2; plural=(n != 1);' ) === '(n != 1)'
 * ```
 *
 * @param {string} pf Locale data plural forms.
 *
 * @return {string} Plural forms expression.
 */
function getPluralExpression( pf ) {
	var parts, i, part;

	parts = pf.split( ';' );

	for ( i = 0; i < parts.length; i++ ) {
		part = parts[ i ].trim();
		if ( part.indexOf( 'plural=' ) === 0 ) {
			return part.substr( 7 );
		}
	}
}

/**
 * Tannin constructor.
 *
 * @class
 *
 * @param {TanninLocaleData} data      Jed-formatted locale data.
 * @param {TanninOptions}    [options] Tannin options.
 */
function Tannin( data, options ) {
	var key;

	/**
	 * Jed-formatted locale data.
	 *
	 * @name Tannin#data
	 * @type {TanninLocaleData}
	 */
	this.data = data;

	/**
	 * Plural forms function cache, keyed by plural forms string.
	 *
	 * @name Tannin#pluralForms
	 * @type {Object<string,Function>}
	 */
	this.pluralForms = {};

	/**
	 * Effective options for instance, including defaults.
	 *
	 * @name Tannin#options
	 * @type {TanninOptions}
	 */
	this.options = {};

	for ( key in DEFAULT_OPTIONS ) {
		this.options[ key ] = options !== undefined && key in options
			? options[ key ]
			: DEFAULT_OPTIONS[ key ];
	}
}

/**
 * Returns the plural form index for the given domain and value.
 *
 * @param {string} domain Domain on which to calculate plural form.
 * @param {number} n      Value for which plural form is to be calculated.
 *
 * @return {number} Plural form index.
 */
Tannin.prototype.getPluralForm = function( domain, n ) {
	var getPluralForm = this.pluralForms[ domain ],
		config, plural, pf;

	if ( ! getPluralForm ) {
		config = this.data[ domain ][ '' ];

		pf = (
			config[ 'Plural-Forms' ] ||
			config[ 'plural-forms' ] ||
			// Ignore reason: As known, there's no way to document the empty
			// string property on a key to guarantee this as metadata.
			// @ts-ignore
			config.plural_forms
		);

		if ( typeof pf !== 'function' ) {
			plural = getPluralExpression(
				config[ 'Plural-Forms' ] ||
				config[ 'plural-forms' ] ||
				// Ignore reason: As known, there's no way to document the empty
				// string property on a key to guarantee this as metadata.
				// @ts-ignore
				config.plural_forms
			);

			pf = pluralForms( plural );
		}

		getPluralForm = this.pluralForms[ domain ] = pf;
	}

	return getPluralForm( n );
};

/**
 * Translate a string.
 *
 * @param {string}      domain   Translation domain.
 * @param {string|void} context  Context distinguishing terms of the same name.
 * @param {string}      singular Primary key for translation lookup.
 * @param {string=}     plural   Fallback value used for non-zero plural
 *                               form index.
 * @param {number=}     n        Value to use in calculating plural form.
 *
 * @return {string} Translated string.
 */
Tannin.prototype.dcnpgettext = function( domain, context, singular, plural, n ) {
	var index, key, entry;

	if ( n === undefined ) {
		// Default to singular.
		index = 0;
	} else {
		// Find index by evaluating plural form for value.
		index = this.getPluralForm( domain, n );
	}

	key = singular;

	// If provided, context is prepended to key with delimiter.
	if ( context ) {
		key = context + this.options.contextDelimiter + singular;
	}

	entry = this.data[ domain ][ key ];

	// Verify not only that entry exists, but that the intended index is within
	// range and non-empty.
	if ( entry && entry[ index ] ) {
		return entry[ index ];
	}

	if ( this.options.onMissingKey ) {
		this.options.onMissingKey( singular, domain );
	}

	// If entry not found, fall back to singular vs. plural with zero index
	// representing the singular value.
	return index === 0 ? singular : plural;
};

;// CONCATENATED MODULE: ./node_modules/@wordpress/i18n/build-module/create-i18n.js
/**
 * External dependencies
 */

/**
 * @typedef {Record<string,any>} LocaleData
 */

/**
 * Default locale data to use for Tannin domain when not otherwise provided.
 * Assumes an English plural forms expression.
 *
 * @type {LocaleData}
 */

const DEFAULT_LOCALE_DATA = {
  '': {
    /** @param {number} n */
    plural_forms(n) {
      return n === 1 ? 0 : 1;
    }

  }
};
/*
 * Regular expression that matches i18n hooks like `i18n.gettext`, `i18n.ngettext`,
 * `i18n.gettext_domain` or `i18n.ngettext_with_context` or `i18n.has_translation`.
 */

const I18N_HOOK_REGEXP = /^i18n\.(n?gettext|has_translation)(_|$)/;
/**
 * @typedef {(domain?: string) => LocaleData} GetLocaleData
 *
 * Returns locale data by domain in a
 * Jed-formatted JSON object shape.
 *
 * @see http://messageformat.github.io/Jed/
 */

/**
 * @typedef {(data?: LocaleData, domain?: string) => void} SetLocaleData
 *
 * Merges locale data into the Tannin instance by domain. Note that this
 * function will overwrite the domain configuration. Accepts data in a
 * Jed-formatted JSON object shape.
 *
 * @see http://messageformat.github.io/Jed/
 */

/**
 * @typedef {(data?: LocaleData, domain?: string) => void} AddLocaleData
 *
 * Merges locale data into the Tannin instance by domain. Note that this
 * function will also merge the domain configuration. Accepts data in a
 * Jed-formatted JSON object shape.
 *
 * @see http://messageformat.github.io/Jed/
 */

/**
 * @typedef {(data?: LocaleData, domain?: string) => void} ResetLocaleData
 *
 * Resets all current Tannin instance locale data and sets the specified
 * locale data for the domain. Accepts data in a Jed-formatted JSON object shape.
 *
 * @see http://messageformat.github.io/Jed/
 */

/** @typedef {() => void} SubscribeCallback */

/** @typedef {() => void} UnsubscribeCallback */

/**
 * @typedef {(callback: SubscribeCallback) => UnsubscribeCallback} Subscribe
 *
 * Subscribes to changes of locale data
 */

/**
 * @typedef {(domain?: string) => string} GetFilterDomain
 * Retrieve the domain to use when calling domain-specific filters.
 */

/**
 * @typedef {(text: string, domain?: string) => string} __
 *
 * Retrieve the translation of text.
 *
 * @see https://developer.wordpress.org/reference/functions/__/
 */

/**
 * @typedef {(text: string, context: string, domain?: string) => string} _x
 *
 * Retrieve translated string with gettext context.
 *
 * @see https://developer.wordpress.org/reference/functions/_x/
 */

/**
 * @typedef {(single: string, plural: string, number: number, domain?: string) => string} _n
 *
 * Translates and retrieves the singular or plural form based on the supplied
 * number.
 *
 * @see https://developer.wordpress.org/reference/functions/_n/
 */

/**
 * @typedef {(single: string, plural: string, number: number, context: string, domain?: string) => string} _nx
 *
 * Translates and retrieves the singular or plural form based on the supplied
 * number, with gettext context.
 *
 * @see https://developer.wordpress.org/reference/functions/_nx/
 */

/**
 * @typedef {() => boolean} IsRtl
 *
 * Check if current locale is RTL.
 *
 * **RTL (Right To Left)** is a locale property indicating that text is written from right to left.
 * For example, the `he` locale (for Hebrew) specifies right-to-left. Arabic (ar) is another common
 * language written RTL. The opposite of RTL, LTR (Left To Right) is used in other languages,
 * including English (`en`, `en-US`, `en-GB`, etc.), Spanish (`es`), and French (`fr`).
 */

/**
 * @typedef {(single: string, context?: string, domain?: string) => boolean} HasTranslation
 *
 * Check if there is a translation for a given string in singular form.
 */

/** @typedef {import('@wordpress/hooks').Hooks} Hooks */

/**
 * An i18n instance
 *
 * @typedef I18n
 * @property {GetLocaleData}   getLocaleData   Returns locale data by domain in a Jed-formatted JSON object shape.
 * @property {SetLocaleData}   setLocaleData   Merges locale data into the Tannin instance by domain. Note that this
 *                                             function will overwrite the domain configuration. Accepts data in a
 *                                             Jed-formatted JSON object shape.
 * @property {AddLocaleData}   addLocaleData   Merges locale data into the Tannin instance by domain. Note that this
 *                                             function will also merge the domain configuration. Accepts data in a
 *                                             Jed-formatted JSON object shape.
 * @property {ResetLocaleData} resetLocaleData Resets all current Tannin instance locale data and sets the specified
 *                                             locale data for the domain. Accepts data in a Jed-formatted JSON object shape.
 * @property {Subscribe}       subscribe       Subscribes to changes of Tannin locale data.
 * @property {__}              __              Retrieve the translation of text.
 * @property {_x}              _x              Retrieve translated string with gettext context.
 * @property {_n}              _n              Translates and retrieves the singular or plural form based on the supplied
 *                                             number.
 * @property {_nx}             _nx             Translates and retrieves the singular or plural form based on the supplied
 *                                             number, with gettext context.
 * @property {IsRtl}           isRTL           Check if current locale is RTL.
 * @property {HasTranslation}  hasTranslation  Check if there is a translation for a given string.
 */

/**
 * Create an i18n instance
 *
 * @param {LocaleData} [initialData]   Locale data configuration.
 * @param {string}     [initialDomain] Domain for which configuration applies.
 * @param {Hooks}      [hooks]         Hooks implementation.
 *
 * @return {I18n} I18n instance.
 */

const createI18n = (initialData, initialDomain, hooks) => {
  /**
   * The underlying instance of Tannin to which exported functions interface.
   *
   * @type {Tannin}
   */
  const tannin = new Tannin({});
  const listeners = new Set();

  const notifyListeners = () => {
    listeners.forEach(listener => listener());
  };
  /**
   * Subscribe to changes of locale data.
   *
   * @param {SubscribeCallback} callback Subscription callback.
   * @return {UnsubscribeCallback} Unsubscribe callback.
   */


  const subscribe = callback => {
    listeners.add(callback);
    return () => listeners.delete(callback);
  };
  /** @type {GetLocaleData} */


  const getLocaleData = function () {
    let domain = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';
    return tannin.data[domain];
  };
  /**
   * @param {LocaleData} [data]
   * @param {string}     [domain]
   */


  const doSetLocaleData = function (data) {
    var _tannin$data$domain;

    let domain = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'default';
    tannin.data[domain] = { ...tannin.data[domain],
      ...data
    }; // Populate default domain configuration (supported locale date which omits
    // a plural forms expression).

    tannin.data[domain][''] = { ...DEFAULT_LOCALE_DATA[''],
      ...((_tannin$data$domain = tannin.data[domain]) === null || _tannin$data$domain === void 0 ? void 0 : _tannin$data$domain[''])
    }; // Clean up cached plural forms functions cache as it might be updated.

    delete tannin.pluralForms[domain];
  };
  /** @type {SetLocaleData} */


  const setLocaleData = (data, domain) => {
    doSetLocaleData(data, domain);
    notifyListeners();
  };
  /** @type {AddLocaleData} */


  const addLocaleData = function (data) {
    var _tannin$data$domain2;

    let domain = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'default';
    tannin.data[domain] = { ...tannin.data[domain],
      ...data,
      // Populate default domain configuration (supported locale date which omits
      // a plural forms expression).
      '': { ...DEFAULT_LOCALE_DATA[''],
        ...((_tannin$data$domain2 = tannin.data[domain]) === null || _tannin$data$domain2 === void 0 ? void 0 : _tannin$data$domain2['']),
        ...(data === null || data === void 0 ? void 0 : data[''])
      }
    }; // Clean up cached plural forms functions cache as it might be updated.

    delete tannin.pluralForms[domain];
    notifyListeners();
  };
  /** @type {ResetLocaleData} */


  const resetLocaleData = (data, domain) => {
    // Reset all current Tannin locale data.
    tannin.data = {}; // Reset cached plural forms functions cache.

    tannin.pluralForms = {};
    setLocaleData(data, domain);
  };
  /**
   * Wrapper for Tannin's `dcnpgettext`. Populates default locale data if not
   * otherwise previously assigned.
   *
   * @param {string|undefined} domain   Domain to retrieve the translated text.
   * @param {string|undefined} context  Context information for the translators.
   * @param {string}           single   Text to translate if non-plural. Used as
   *                                    fallback return value on a caught error.
   * @param {string}           [plural] The text to be used if the number is
   *                                    plural.
   * @param {number}           [number] The number to compare against to use
   *                                    either the singular or plural form.
   *
   * @return {string} The translated string.
   */


  const dcnpgettext = function () {
    let domain = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';
    let context = arguments.length > 1 ? arguments[1] : undefined;
    let single = arguments.length > 2 ? arguments[2] : undefined;
    let plural = arguments.length > 3 ? arguments[3] : undefined;
    let number = arguments.length > 4 ? arguments[4] : undefined;

    if (!tannin.data[domain]) {
      // Use `doSetLocaleData` to set silently, without notifying listeners.
      doSetLocaleData(undefined, domain);
    }

    return tannin.dcnpgettext(domain, context, single, plural, number);
  };
  /** @type {GetFilterDomain} */


  const getFilterDomain = function () {
    let domain = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'default';
    return domain;
  };
  /** @type {__} */


  const __ = (text, domain) => {
    let translation = dcnpgettext(domain, undefined, text);

    if (!hooks) {
      return translation;
    }
    /**
     * Filters text with its translation.
     *
     * @param {string} translation Translated text.
     * @param {string} text        Text to translate.
     * @param {string} domain      Text domain. Unique identifier for retrieving translated strings.
     */


    translation =
    /** @type {string} */

    /** @type {*} */
    hooks.applyFilters('i18n.gettext', translation, text, domain);
    return (
      /** @type {string} */

      /** @type {*} */
      hooks.applyFilters('i18n.gettext_' + getFilterDomain(domain), translation, text, domain)
    );
  };
  /** @type {_x} */


  const _x = (text, context, domain) => {
    let translation = dcnpgettext(domain, context, text);

    if (!hooks) {
      return translation;
    }
    /**
     * Filters text with its translation based on context information.
     *
     * @param {string} translation Translated text.
     * @param {string} text        Text to translate.
     * @param {string} context     Context information for the translators.
     * @param {string} domain      Text domain. Unique identifier for retrieving translated strings.
     */


    translation =
    /** @type {string} */

    /** @type {*} */
    hooks.applyFilters('i18n.gettext_with_context', translation, text, context, domain);
    return (
      /** @type {string} */

      /** @type {*} */
      hooks.applyFilters('i18n.gettext_with_context_' + getFilterDomain(domain), translation, text, context, domain)
    );
  };
  /** @type {_n} */


  const _n = (single, plural, number, domain) => {
    let translation = dcnpgettext(domain, undefined, single, plural, number);

    if (!hooks) {
      return translation;
    }
    /**
     * Filters the singular or plural form of a string.
     *
     * @param {string} translation Translated text.
     * @param {string} single      The text to be used if the number is singular.
     * @param {string} plural      The text to be used if the number is plural.
     * @param {string} number      The number to compare against to use either the singular or plural form.
     * @param {string} domain      Text domain. Unique identifier for retrieving translated strings.
     */


    translation =
    /** @type {string} */

    /** @type {*} */
    hooks.applyFilters('i18n.ngettext', translation, single, plural, number, domain);
    return (
      /** @type {string} */

      /** @type {*} */
      hooks.applyFilters('i18n.ngettext_' + getFilterDomain(domain), translation, single, plural, number, domain)
    );
  };
  /** @type {_nx} */


  const _nx = (single, plural, number, context, domain) => {
    let translation = dcnpgettext(domain, context, single, plural, number);

    if (!hooks) {
      return translation;
    }
    /**
     * Filters the singular or plural form of a string with gettext context.
     *
     * @param {string} translation Translated text.
     * @param {string} single      The text to be used if the number is singular.
     * @param {string} plural      The text to be used if the number is plural.
     * @param {string} number      The number to compare against to use either the singular or plural form.
     * @param {string} context     Context information for the translators.
     * @param {string} domain      Text domain. Unique identifier for retrieving translated strings.
     */


    translation =
    /** @type {string} */

    /** @type {*} */
    hooks.applyFilters('i18n.ngettext_with_context', translation, single, plural, number, context, domain);
    return (
      /** @type {string} */

      /** @type {*} */
      hooks.applyFilters('i18n.ngettext_with_context_' + getFilterDomain(domain), translation, single, plural, number, context, domain)
    );
  };
  /** @type {IsRtl} */


  const isRTL = () => {
    return 'rtl' === _x('ltr', 'text direction');
  };
  /** @type {HasTranslation} */


  const hasTranslation = (single, context, domain) => {
    var _tannin$data, _tannin$data2;

    const key = context ? context + '\u0004' + single : single;
    let result = !!((_tannin$data = tannin.data) !== null && _tannin$data !== void 0 && (_tannin$data2 = _tannin$data[domain !== null && domain !== void 0 ? domain : 'default']) !== null && _tannin$data2 !== void 0 && _tannin$data2[key]);

    if (hooks) {
      /**
       * Filters the presence of a translation in the locale data.
       *
       * @param {boolean} hasTranslation Whether the translation is present or not..
       * @param {string}  single         The singular form of the translated text (used as key in locale data)
       * @param {string}  context        Context information for the translators.
       * @param {string}  domain         Text domain. Unique identifier for retrieving translated strings.
       */
      result =
      /** @type { boolean } */

      /** @type {*} */
      hooks.applyFilters('i18n.has_translation', result, single, context, domain);
      result =
      /** @type { boolean } */

      /** @type {*} */
      hooks.applyFilters('i18n.has_translation_' + getFilterDomain(domain), result, single, context, domain);
    }

    return result;
  };

  if (initialData) {
    setLocaleData(initialData, initialDomain);
  }

  if (hooks) {
    /**
     * @param {string} hookName
     */
    const onHookAddedOrRemoved = hookName => {
      if (I18N_HOOK_REGEXP.test(hookName)) {
        notifyListeners();
      }
    };

    hooks.addAction('hookAdded', 'core/i18n', onHookAddedOrRemoved);
    hooks.addAction('hookRemoved', 'core/i18n', onHookAddedOrRemoved);
  }

  return {
    getLocaleData,
    setLocaleData,
    addLocaleData,
    resetLocaleData,
    subscribe,
    __,
    _x,
    _n,
    _nx,
    isRTL,
    hasTranslation
  };
};
//# sourceMappingURL=create-i18n.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/i18n/build-module/default-i18n.js
/**
 * Internal dependencies
 */

/**
 * WordPress dependencies
 */


const i18n = createI18n(undefined, undefined, defaultHooks);
/**
 * Default, singleton instance of `I18n`.
 */

/* harmony default export */ const default_i18n = ((/* unused pure expression or super */ null && (i18n)));
/*
 * Comments in this file are duplicated from ./i18n due to
 * https://github.com/WordPress/gutenberg/pull/20318#issuecomment-590837722
 */

/**
 * @typedef {import('./create-i18n').LocaleData} LocaleData
 * @typedef {import('./create-i18n').SubscribeCallback} SubscribeCallback
 * @typedef {import('./create-i18n').UnsubscribeCallback} UnsubscribeCallback
 */

/**
 * Returns locale data by domain in a Jed-formatted JSON object shape.
 *
 * @see http://messageformat.github.io/Jed/
 *
 * @param {string} [domain] Domain for which to get the data.
 * @return {LocaleData} Locale data.
 */

const getLocaleData = i18n.getLocaleData.bind(i18n);
/**
 * Merges locale data into the Tannin instance by domain. Accepts data in a
 * Jed-formatted JSON object shape.
 *
 * @see http://messageformat.github.io/Jed/
 *
 * @param {LocaleData} [data]   Locale data configuration.
 * @param {string}     [domain] Domain for which configuration applies.
 */

const setLocaleData = i18n.setLocaleData.bind(i18n);
/**
 * Resets all current Tannin instance locale data and sets the specified
 * locale data for the domain. Accepts data in a Jed-formatted JSON object shape.
 *
 * @see http://messageformat.github.io/Jed/
 *
 * @param {LocaleData} [data]   Locale data configuration.
 * @param {string}     [domain] Domain for which configuration applies.
 */

const resetLocaleData = i18n.resetLocaleData.bind(i18n);
/**
 * Subscribes to changes of locale data
 *
 * @param {SubscribeCallback} callback Subscription callback
 * @return {UnsubscribeCallback} Unsubscribe callback
 */

const subscribe = i18n.subscribe.bind(i18n);
/**
 * Retrieve the translation of text.
 *
 * @see https://developer.wordpress.org/reference/functions/__/
 *
 * @param {string} text     Text to translate.
 * @param {string} [domain] Domain to retrieve the translated text.
 *
 * @return {string} Translated text.
 */

const __ = i18n.__.bind(i18n);
/**
 * Retrieve translated string with gettext context.
 *
 * @see https://developer.wordpress.org/reference/functions/_x/
 *
 * @param {string} text     Text to translate.
 * @param {string} context  Context information for the translators.
 * @param {string} [domain] Domain to retrieve the translated text.
 *
 * @return {string} Translated context string without pipe.
 */

const _x = i18n._x.bind(i18n);
/**
 * Translates and retrieves the singular or plural form based on the supplied
 * number.
 *
 * @see https://developer.wordpress.org/reference/functions/_n/
 *
 * @param {string} single   The text to be used if the number is singular.
 * @param {string} plural   The text to be used if the number is plural.
 * @param {number} number   The number to compare against to use either the
 *                          singular or plural form.
 * @param {string} [domain] Domain to retrieve the translated text.
 *
 * @return {string} The translated singular or plural form.
 */

const _n = i18n._n.bind(i18n);
/**
 * Translates and retrieves the singular or plural form based on the supplied
 * number, with gettext context.
 *
 * @see https://developer.wordpress.org/reference/functions/_nx/
 *
 * @param {string} single   The text to be used if the number is singular.
 * @param {string} plural   The text to be used if the number is plural.
 * @param {number} number   The number to compare against to use either the
 *                          singular or plural form.
 * @param {string} context  Context information for the translators.
 * @param {string} [domain] Domain to retrieve the translated text.
 *
 * @return {string} The translated singular or plural form.
 */

const _nx = i18n._nx.bind(i18n);
/**
 * Check if current locale is RTL.
 *
 * **RTL (Right To Left)** is a locale property indicating that text is written from right to left.
 * For example, the `he` locale (for Hebrew) specifies right-to-left. Arabic (ar) is another common
 * language written RTL. The opposite of RTL, LTR (Left To Right) is used in other languages,
 * including English (`en`, `en-US`, `en-GB`, etc.), Spanish (`es`), and French (`fr`).
 *
 * @return {boolean} Whether locale is RTL.
 */

const isRTL = i18n.isRTL.bind(i18n);
/**
 * Check if there is a translation for a given string (in singular form).
 *
 * @param {string} single    Singular form of the string to look up.
 * @param {string} [context] Context information for the translators.
 * @param {string} [domain]  Domain to retrieve the translated text.
 * @return {boolean} Whether the translation exists or not.
 */

const hasTranslation = i18n.hasTranslation.bind(i18n);
//# sourceMappingURL=default-i18n.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/i18n/build-module/index.js



//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/utils/rtl.js
/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */


const LOWER_LEFT_REGEXP = new RegExp(/-left/g);
const LOWER_RIGHT_REGEXP = new RegExp(/-right/g);
const UPPER_LEFT_REGEXP = new RegExp(/Left/g);
const UPPER_RIGHT_REGEXP = new RegExp(/Right/g);
/**
 * Flips a CSS property from left <-> right.
 *
 * @param {string} key The CSS property name.
 *
 * @return {string} The flipped CSS property name, if applicable.
 */

function getConvertedKey(key) {
  if (key === 'left') {
    return 'right';
  }

  if (key === 'right') {
    return 'left';
  }

  if (LOWER_LEFT_REGEXP.test(key)) {
    return key.replace(LOWER_LEFT_REGEXP, '-right');
  }

  if (LOWER_RIGHT_REGEXP.test(key)) {
    return key.replace(LOWER_RIGHT_REGEXP, '-left');
  }

  if (UPPER_LEFT_REGEXP.test(key)) {
    return key.replace(UPPER_LEFT_REGEXP, 'Right');
  }

  if (UPPER_RIGHT_REGEXP.test(key)) {
    return key.replace(UPPER_RIGHT_REGEXP, 'Left');
  }

  return key;
}
/**
 * An incredibly basic ltr -> rtl converter for style properties
 *
 * @param {import('react').CSSProperties} ltrStyles
 *
 * @return {import('react').CSSProperties} Converted ltr -> rtl styles
 */


const convertLTRToRTL = function () {
  let ltrStyles = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  return (0,lodash.mapKeys)(ltrStyles, (_value, key) => getConvertedKey(key));
};
/**
 * A higher-order function that create an incredibly basic ltr -> rtl style converter for CSS objects.
 *
 * @param {import('react').CSSProperties} ltrStyles   Ltr styles. Converts and renders from ltr -> rtl styles, if applicable.
 * @param {import('react').CSSProperties} [rtlStyles] Rtl styles. Renders if provided.
 *
 * @return {() => import('@emotion/react').SerializedStyles} A function to output CSS styles for Emotion's renderer
 */

function rtl() {
  let ltrStyles = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  let rtlStyles = arguments.length > 1 ? arguments[1] : undefined;
  return () => {
    if (rtlStyles) {
      // @ts-ignore: `css` types are wrong, it can accept an object: https://emotion.sh/docs/object-styles#with-css
      return isRTL() ? /*#__PURE__*/css(rtlStyles,  true ? "" : 0) : /*#__PURE__*/css(ltrStyles,  true ? "" : 0);
    } // @ts-ignore: `css` types are wrong, it can accept an object: https://emotion.sh/docs/object-styles#with-css


    return isRTL() ? /*#__PURE__*/css(convertLTRToRTL(ltrStyles),  true ? "" : 0) : /*#__PURE__*/css(ltrStyles,  true ? "" : 0);
  };
}
/**
 * Call this in the `useMemo` dependency array to ensure that subsequent renders will
 * cause rtl styles to update based on the `isRTL` return value even if all other dependencies
 * remain the same.
 *
 * @example
 * const styles = useMemo( () => {
 *   return css`
 *     ${ rtl( { marginRight: '10px' } ) }
 *   `;
 * }, [ rtl.watch() ] );
 */

rtl.watch = () => isRTL();
//# sourceMappingURL=rtl.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/flex/flex/hook.js
/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */



/**
 * Internal dependencies
 */






/**
 *
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FlexProps, 'div'>} props
 * @return {import('../../ui/context').WordPressComponentProps<import('../types').FlexProps, 'div'>} Props with the deprecated props removed.
 */

function hook_useDeprecatedProps(_ref) {
  let {
    isReversed,
    ...otherProps
  } = _ref;

  if (typeof isReversed !== 'undefined') {
    deprecated('Flex isReversed', {
      alternative: 'Flex direction="row-reverse" or "column-reverse"',
      since: '5.9'
    });
    return { ...otherProps,
      direction: isReversed ? 'row-reverse' : 'row'
    };
  }

  return otherProps;
}
/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FlexProps, 'div'>} props
 */


function useFlex(props) {
  const {
    align = 'center',
    className,
    direction: directionProp = 'row',
    expanded = true,
    gap = 2,
    justify = 'space-between',
    wrap = false,
    ...otherProps
  } = useContextSystem(hook_useDeprecatedProps(props), 'Flex');
  const directionAsArray = Array.isArray(directionProp) ? directionProp : [directionProp];
  const direction = useResponsiveValue(directionAsArray);
  const isColumn = typeof direction === 'string' && !!direction.includes('column');
  const isReverse = typeof direction === 'string' && direction.includes('reverse');
  const cx = useCx();
  const rtlWatchResult = rtl.watch();
  const classes = (0,react.useMemo)(() => {
    const sx = {};
    sx.Base = /*#__PURE__*/css({
      alignItems: isColumn ? 'normal' : align,
      flexDirection: direction,
      flexWrap: wrap ? 'wrap' : undefined,
      justifyContent: justify,
      height: isColumn && expanded ? '100%' : undefined,
      width: !isColumn && expanded ? '100%' : undefined,
      marginBottom: wrap ? `calc(${space(gap)} * -1)` : undefined
    },  true ? "" : 0,  true ? "" : 0);
    /**
     * Workaround to optimize DOM rendering.
     * We'll enhance alignment with naive parent flex assumptions.
     *
     * Trade-off:
     * Far less DOM less. However, UI rendering is not as reliable.
     */

    sx.Items = /*#__PURE__*/css(">*+*:not( marquee ){margin-top:", isColumn ? space(gap) : undefined, ";", rtl({
      marginLeft: !isColumn && !isReverse ? space(gap) : undefined,
      marginRight: !isColumn && isReverse ? space(gap) : undefined
    })(), ";}" + ( true ? "" : 0),  true ? "" : 0);
    sx.WrapItems = /*#__PURE__*/css(">*:not( marquee ){margin-bottom:", space(gap), ";", rtl({
      marginLeft: !isColumn && isReverse ? space(gap) : undefined,
      marginRight: !isColumn && !isReverse ? space(gap) : undefined
    })(), ";}>*:last-child:not( marquee ){", rtl({
      marginLeft: !isColumn && isReverse ? 0 : undefined,
      marginRight: !isColumn && !isReverse ? 0 : undefined
    })(), ";}" + ( true ? "" : 0),  true ? "" : 0);
    return cx(Flex, sx.Base, wrap ? sx.WrapItems : sx.Items, isColumn ? ItemsColumn : ItemsRow, className); // rtlWatchResult is needed to refresh styles when the writing direction changes
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [align, className, cx, direction, expanded, gap, isColumn, isReverse, justify, wrap, rtlWatchResult]);
  return { ...otherProps,
    className: classes,
    isColumn
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/flex/context.js
/**
 * WordPress dependencies
 */

const FlexContext = (0,react.createContext)({
  flexItemDisplay: undefined
});
const useFlexContext = () => (0,react.useContext)(FlexContext);
//# sourceMappingURL=context.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/flex/flex/component.js



/**
 * Internal dependencies
 */




/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FlexProps, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                                       forwardedRef
 */

function component_Flex(props, forwardedRef) {
  const {
    children,
    isColumn,
    ...otherProps
  } = useFlex(props);
  return (0,react.createElement)(FlexContext.Provider, {
    value: {
      flexItemDisplay: isColumn ? 'block' : undefined
    }
  }, (0,react.createElement)(component, extends_extends({}, otherProps, {
    ref: forwardedRef
  }), children));
}
/**
 * `Flex` is a primitive layout component that adaptively aligns child content
 * horizontally or vertically. `Flex` powers components like `HStack` and
 * `VStack`.
 *
 * `Flex` is used with any of it's two sub-components, `FlexItem` and `FlexBlock`.
 *
 * @example
 * ```jsx
 * import {
 * 	__experimentalFlex as Flex,
 * 	__experimentalFlexBlock as FlexBlock,
 * 	__experimentalFlexItem as FlexItem,
 * 	__experimentalText as Text
 * } from `@wordpress/components`;
 *
 * function Example() {
 * 	return (
 * 		<Flex>
 * 			<FlexItem>
 * 				<Text>Code</Text>
 * 			</FlexItem>
 * 			<FlexBlock>
 * 				<Text>Poetry</Text>
 * 			</FlexBlock>
 * 		</Flex>
 * 	);
 * }
 * ```
 *
 */


const ConnectedFlex = contextConnect(component_Flex, 'Flex');
/* harmony default export */ const flex_component = (ConnectedFlex);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/card-header/hook.js
/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */




/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').HeaderProps, 'div'>} props
 */

function useCardHeader(props) {
  const {
    className,
    isBorderless = false,
    isShady = false,
    size = 'medium',
    ...otherProps
  } = useContextSystem(props, 'CardHeader');
  const cx = useCx();
  const classes = (0,react.useMemo)(() => cx(Header, borderRadius, borderColor, cardPaddings[size], isBorderless && borderless, isShady && shady, // This classname is added for legacy compatibility reasons.
  'components-card__header', className), [className, cx, isBorderless, isShady, size]);
  return { ...otherProps,
    className: classes
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/card-header/component.js



/**
 * Internal dependencies
 */



/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').HeaderProps, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                                         forwardedRef
 */

function CardHeader(props, forwardedRef) {
  const headerProps = useCardHeader(props);
  return (0,react.createElement)(flex_component, extends_extends({}, headerProps, {
    ref: forwardedRef
  }));
}
/**
 * `CardHeader` renders an optional header within a `Card`.
 *
 * @example
 * ```jsx
 * import { Card, CardBody, CardHeader } from `@wordpress/components`;
 *
 * <Card>
 * 	<CardHeader>...</CardHeader>
 * 	<CardBody>...</CardBody>
 * </Card>
 * ```
 */


const ConnectedCardHeader = contextConnect(CardHeader, 'CardHeader');
/* harmony default export */ const card_header_component = (ConnectedCardHeader);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/scrollable/styles.js
function scrollable_styles_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


const scrollableScrollbar = /*#__PURE__*/css("@media only screen and ( min-device-width: 40em ){&::-webkit-scrollbar{height:12px;width:12px;}&::-webkit-scrollbar-track{background-color:transparent;}&::-webkit-scrollbar-track{background:", config_values.colorScrollbarTrack, ";border-radius:8px;}&::-webkit-scrollbar-thumb{background-clip:padding-box;background-color:", config_values.colorScrollbarThumb, ";border:2px solid rgba( 0, 0, 0, 0 );border-radius:7px;}&:hover::-webkit-scrollbar-thumb{background-color:", config_values.colorScrollbarThumbHover, ";}}" + ( true ? "" : 0),  true ? "" : 0);
const Scrollable =  true ? {
  name: "13udsys",
  styles: "height:100%"
} : 0;
const styles_Content =  true ? {
  name: "bjn8wh",
  styles: "position:relative"
} : 0;
const styles_smoothScroll =  true ? {
  name: "7zq9w",
  styles: "scroll-behavior:smooth"
} : 0;
const scrollX =  true ? {
  name: "q33xhg",
  styles: "overflow-x:auto;overflow-y:hidden"
} : 0;
const scrollY =  true ? {
  name: "103x71s",
  styles: "overflow-x:hidden;overflow-y:auto"
} : 0;
const scrollAuto =  true ? {
  name: "umwchj",
  styles: "overflow-y:auto"
} : 0;
//# sourceMappingURL=styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/scrollable/hook.js
/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */




/* eslint-disable jsdoc/valid-types */

/**
 * @param {import('../ui/context').WordPressComponentProps<import('./types').Props, 'div'>} props
 */

/* eslint-enable jsdoc/valid-types */

function useScrollable(props) {
  const {
    className,
    scrollDirection = 'y',
    smoothScroll = false,
    ...otherProps
  } = useContextSystem(props, 'Scrollable');
  const cx = useCx();
  const classes = (0,react.useMemo)(() => cx(Scrollable, scrollableScrollbar, smoothScroll && styles_smoothScroll, scrollDirection === 'x' && scrollX, scrollDirection === 'y' && scrollY, scrollDirection === 'auto' && scrollAuto, className), [className, cx, scrollDirection, smoothScroll]);
  return { ...otherProps,
    className: classes
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/scrollable/component.js



/**
 * Internal dependencies
 */



/**
 * @param {import('../ui/context').WordPressComponentProps<import('./types').Props, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                               forwardedRef
 */

function component_Scrollable(props, forwardedRef) {
  const scrollableProps = useScrollable(props);
  return (0,react.createElement)(component, extends_extends({}, scrollableProps, {
    ref: forwardedRef
  }));
}
/**
 * `Scrollable` is a layout component that content in a scrollable container.
 *
 * @example
 * ```jsx
 * import { __experimentalScrollable as Scrollable } from `@wordpress/components`;
 *
 * function Example() {
 * 	return (
 * 		<Scrollable style={ { maxHeight: 200 } }>
 * 			<div style={ { height: 500 } }>...</div>
 * 		</Scrollable>
 * 	);
 * }
 * ```
 */


const ConnectedScrollable = contextConnect(component_Scrollable, 'Scrollable');
/* harmony default export */ const scrollable_component = (ConnectedScrollable);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/card-body/hook.js
/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */




/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').BodyProps, 'div'>} props
 */

function useCardBody(props) {
  const {
    className,
    isScrollable = false,
    isShady = false,
    size = 'medium',
    ...otherProps
  } = useContextSystem(props, 'CardBody');
  const cx = useCx();
  const classes = (0,react.useMemo)(() => cx(Body, borderRadius, cardPaddings[size], isShady && shady, // This classname is added for legacy compatibility reasons.
  'components-card__body', className), [className, cx, isShady, size]);
  return { ...otherProps,
    className: classes,
    isScrollable
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/card-body/component.js



/**
 * Internal dependencies
 */




/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').BodyProps, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                                       forwardedRef
 */

function CardBody(props, forwardedRef) {
  const {
    isScrollable,
    ...otherProps
  } = useCardBody(props);

  if (isScrollable) {
    return (0,react.createElement)(scrollable_component, extends_extends({}, otherProps, {
      ref: forwardedRef
    }));
  }

  return (0,react.createElement)(component, extends_extends({}, otherProps, {
    ref: forwardedRef
  }));
}
/**
 * `CardBody` renders an optional content area for a `Card`.
 * Multiple `CardBody` components can be used within `Card` if needed.
 *
 * @example
 * ```jsx
 * import { Card, CardBody } from `@wordpress/components`;
 *
 * <Card>
 * 	<CardBody>
 * 		...
 * 	</CardBody>
 * </Card>
 * ```
 */


const ConnectedCardBody = contextConnect(CardBody, 'CardBody');
/* harmony default export */ const card_body_component = (ConnectedCardBody);
//# sourceMappingURL=component.js.map
// EXTERNAL MODULE: ./node_modules/classnames/index.js
var node_modules_classnames = __webpack_require__(4184);
var classnames_default = /*#__PURE__*/__webpack_require__.n(node_modules_classnames);
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/spinner/styles.js


function spinner_styles_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


const spinAnimation = keyframes`
	from {
		transform: rotate(0deg);
	}
	to {
		transform: rotate(360deg);
	}
 `;
const StyledSpinner = emotion_styled_base_browser_esm("svg",  true ? {
  target: "e1bj2jdf2"
} : 0)("width:", config_values.spinnerSize, "px;height:", config_values.spinnerSize, "px;display:inline-block;margin:5px 11px 0;position:relative;color:var( --wp-admin-theme-color );overflow:visible;" + ( true ? "" : 0));
const commonPathProps =  true ? {
  name: "9s4963",
  styles: "fill:transparent;stroke-width:1.5px"
} : 0;
const SpinnerTrack = emotion_styled_base_browser_esm("circle",  true ? {
  target: "e1bj2jdf1"
} : 0)(commonPathProps, ";stroke:", COLORS.gray[300], ";" + ( true ? "" : 0));
const SpinnerIndicator = emotion_styled_base_browser_esm("path",  true ? {
  target: "e1bj2jdf0"
} : 0)(commonPathProps, ";stroke:currentColor;stroke-linecap:round;transform-origin:50% 50%;animation:1.4s linear infinite both ", spinAnimation, ";" + ( true ? "" : 0));
//# sourceMappingURL=styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/spinner/index.js



/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


/**
 * @typedef OwnProps
 *
 * @property {string} [className] Class name
 */

/** @typedef {import('react').ComponentPropsWithoutRef<'svg'> & OwnProps} Props */

/**
 * @param {Props} props
 * @return {JSX.Element} Element
 */

function Spinner(_ref) {
  let {
    className,
    ...props
  } = _ref;
  return (0,react.createElement)(StyledSpinner, extends_extends({
    className: classnames_default()('components-spinner', className),
    viewBox: "0 0 100 100",
    xmlns: "http://www.w3.org/2000/svg",
    role: "presentation",
    focusable: "false"
  }, props), (0,react.createElement)(SpinnerTrack, {
    cx: "50",
    cy: "50",
    r: "50",
    vectorEffect: "non-scaling-stroke"
  }), (0,react.createElement)(SpinnerIndicator, {
    d: "m 50 0 a 50 50 0 0 1 50 50",
    vectorEffect: "non-scaling-stroke"
  }));
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-instance-id/index.js
// Disable reason: Object and object are distinctly different types in TypeScript and we mean the lowercase object in thise case
// but eslint wants to force us to use `Object`. See https://stackoverflow.com/questions/49464634/difference-between-object-and-object-in-typescript

/* eslint-disable jsdoc/check-types */

/**
 * WordPress dependencies
 */

/**
 * @type {WeakMap<object, number>}
 */

const instanceMap = new WeakMap();
/**
 * Creates a new id for a given object.
 *
 * @param {object} object Object reference to create an id for.
 * @return {number} The instance id (index).
 */

function createId(object) {
  const instances = instanceMap.get(object) || 0;
  instanceMap.set(object, instances + 1);
  return instances;
}
/**
 * Provides a unique instance ID.
 *
 * @param {object}          object           Object reference to create an id for.
 * @param {string}          [prefix]         Prefix for the unique id.
 * @param {string | number} [preferredId=''] Default ID to use.
 * @return {string | number} The unique instance id.
 */


function useInstanceId(object, prefix) {
  let preferredId = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
  return (0,react.useMemo)(() => {
    if (preferredId) return preferredId;
    const id = createId(object);
    return prefix ? `${prefix}-${id}` : id;
  }, [object]);
}
/* eslint-enable jsdoc/check-types */
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/element/build-module/react.js
/**
 * External dependencies
 */
// eslint-disable-next-line @typescript-eslint/no-restricted-imports


/**
 * Object containing a React element.
 *
 * @typedef {import('react').ReactElement} WPElement
 */

/**
 * Object containing a React component.
 *
 * @typedef {import('react').ComponentType} WPComponent
 */

/**
 * Object containing a React synthetic event.
 *
 * @typedef {import('react').SyntheticEvent} WPSyntheticEvent
 */

/**
 * Object that provides utilities for dealing with React children.
 */


/**
 * Creates a copy of an element with extended props.
 *
 * @param {WPElement} element Element
 * @param {?Object}   props   Props to apply to cloned element
 *
 * @return {WPElement} Cloned element.
 */


/**
 * A base class to create WordPress Components (Refs, state and lifecycle hooks)
 */


/**
 * Creates a context object containing two components: a provider and consumer.
 *
 * @param {Object} defaultValue A default data stored in the context.
 *
 * @return {Object} Context object.
 */


/**
 * Returns a new element of given type. Type can be either a string tag name or
 * another function which itself returns an element.
 *
 * @param {?(string|Function)} type     Tag name or element creator
 * @param {Object}             props    Element properties, either attribute
 *                                      set to apply to DOM node or values to
 *                                      pass through to element creator
 * @param {...WPElement}       children Descendant elements
 *
 * @return {WPElement} Element.
 */


/**
 * Returns an object tracking a reference to a rendered element via its
 * `current` property as either a DOMElement or Element, dependent upon the
 * type of element rendered with the ref attribute.
 *
 * @return {Object} Ref object.
 */


/**
 * Component enhancer used to enable passing a ref to its wrapped component.
 * Pass a function argument which receives `props` and `ref` as its arguments,
 * returning an element using the forwarded ref. The return value is a new
 * component which forwards its ref.
 *
 * @param {Function} forwarder Function passed `props` and `ref`, expected to
 *                             return an element.
 *
 * @return {WPComponent} Enhanced component.
 */


/**
 * A component which renders its children without any wrapping element.
 */


/**
 * Checks if an object is a valid WPElement.
 *
 * @param {Object} objectToCheck The object to be checked.
 *
 * @return {boolean} true if objectToTest is a valid WPElement and false otherwise.
 */


/**
 * @see https://reactjs.org/docs/react-api.html#reactmemo
 */


/**
 * Component that activates additional checks and warnings for its descendants.
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#usecallback
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#usecontext
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#usedebugvalue
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#useeffect
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#useimperativehandle
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#uselayouteffect
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#usememo
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#usereducer
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#useref
 */


/**
 * @see https://reactjs.org/docs/hooks-reference.html#usestate
 */


/**
 * @see https://reactjs.org/docs/react-api.html#reactlazy
 */


/**
 * @see https://reactjs.org/docs/react-api.html#reactsuspense
 */


/**
 * Concatenate two or more React children objects.
 *
 * @param {...?Object} childrenArguments Array of children arguments (array of arrays/strings/objects) to concatenate.
 *
 * @return {Array} The concatenated value.
 */

function concatChildren() {
  for (var _len = arguments.length, childrenArguments = new Array(_len), _key = 0; _key < _len; _key++) {
    childrenArguments[_key] = arguments[_key];
  }

  return childrenArguments.reduce((accumulator, children, i) => {
    react.Children.forEach(children, (child, j) => {
      if (child && 'string' !== typeof child) {
        child = (0,react.cloneElement)(child, {
          key: [i, j].join()
        });
      }

      accumulator.push(child);
    });
    return accumulator;
  }, []);
}
/**
 * Switches the nodeName of all the elements in the children object.
 *
 * @param {?Object} children Children object.
 * @param {string}  nodeName Node name.
 *
 * @return {?Object} The updated children object.
 */

function switchChildrenNodeName(children, nodeName) {
  return children && Children.map(children, (elt, index) => {
    if (isString(elt)) {
      return createElement(nodeName, {
        key: index
      }, elt);
    }

    const {
      children: childrenProp,
      ...props
    } = elt.props;
    return createElement(nodeName, {
      key: index,
      ...props
    }, childrenProp);
  });
}
//# sourceMappingURL=react.js.map
;// CONCATENATED MODULE: ./node_modules/use-memo-one/dist/use-memo-one.esm.js


function areInputsEqual(newInputs, lastInputs) {
  if (newInputs.length !== lastInputs.length) {
    return false;
  }

  for (var i = 0; i < newInputs.length; i++) {
    if (newInputs[i] !== lastInputs[i]) {
      return false;
    }
  }

  return true;
}

function useMemoOne(getResult, inputs) {
  var initial = (0,react.useState)(function () {
    return {
      inputs: inputs,
      result: getResult()
    };
  })[0];
  var isFirstRun = (0,react.useRef)(true);
  var committed = (0,react.useRef)(initial);
  var useCache = isFirstRun.current || Boolean(inputs && committed.current.inputs && areInputsEqual(inputs, committed.current.inputs));
  var cache = useCache ? committed.current : {
    inputs: inputs,
    result: getResult()
  };
  (0,react.useEffect)(function () {
    isFirstRun.current = false;
    committed.current = cache;
  }, [cache]);
  return cache.result;
}
function useCallbackOne(callback, inputs) {
  return useMemoOne(function () {
    return callback;
  }, inputs);
}
var useMemo = (/* unused pure expression or super */ null && (useMemoOne));
var useCallback = (/* unused pure expression or super */ null && (useCallbackOne));



;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-debounce/index.js
/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */


/* eslint-disable jsdoc/valid-types */

/**
 * Debounces a function with Lodash's `debounce`. A new debounced function will
 * be returned and any scheduled calls cancelled if any of the arguments change,
 * including the function to debounce, so please wrap functions created on
 * render in components in `useCallback`.
 *
 * @see https://docs-lodash.com/v4/debounce/
 *
 * @template {(...args: any[]) => void} TFunc
 *
 * @param {TFunc}                             fn        The function to debounce.
 * @param {number}                            [wait]    The number of milliseconds to delay.
 * @param {import('lodash').DebounceSettings} [options] The options object.
 * @return {import('lodash').DebouncedFunc<TFunc>} Debounced function.
 */

function useDebounce(fn, wait, options) {
  /* eslint-enable jsdoc/valid-types */
  const debounced = useMemoOne(() => (0,lodash.debounce)(fn, wait, options), [fn, wait, options]);
  (0,react.useEffect)(() => () => debounced.cancel(), [debounced]);
  return debounced;
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@floating-ui/core/dist/floating-ui.core.esm.min.js
function floating_ui_core_esm_min_t(t){return t.split("-")[0]}function floating_ui_core_esm_min_e(t){return t.split("-")[1]}function floating_ui_core_esm_min_n(e){return["top","bottom"].includes(floating_ui_core_esm_min_t(e))?"x":"y"}function floating_ui_core_esm_min_r(t){return"y"===t?"height":"width"}function floating_ui_core_esm_min_i(i,o,a){let{reference:l,floating:s}=i;const c=l.x+l.width/2-s.width/2,f=l.y+l.height/2-s.height/2,u=floating_ui_core_esm_min_n(o),m=floating_ui_core_esm_min_r(u),g=l[m]/2-s[m]/2,d="x"===u;let p;switch(floating_ui_core_esm_min_t(o)){case"top":p={x:c,y:l.y-s.height};break;case"bottom":p={x:c,y:l.y+l.height};break;case"right":p={x:l.x+l.width,y:f};break;case"left":p={x:l.x-s.width,y:f};break;default:p={x:l.x,y:l.y}}switch(floating_ui_core_esm_min_e(o)){case"start":p[u]-=g*(a&&d?-1:1);break;case"end":p[u]+=g*(a&&d?-1:1)}return p}const floating_ui_core_esm_min_o=async(t,e,n)=>{const{placement:r="bottom",strategy:o="absolute",middleware:a=[],platform:l}=n,s=await(null==l.isRTL?void 0:l.isRTL(e));let c=await l.getElementRects({reference:t,floating:e,strategy:o}),{x:f,y:u}=floating_ui_core_esm_min_i(c,r,s),m=r,g={};for(let n=0;n<a.length;n++){const{name:d,fn:p}=a[n],{x:h,y:y,data:x,reset:w}=await p({x:f,y:u,initialPlacement:r,placement:m,strategy:o,middlewareData:g,rects:c,platform:l,elements:{reference:t,floating:e}});f=null!=h?h:f,u=null!=y?y:u,g={...g,[d]:{...g[d],...x}},w&&("object"==typeof w&&(w.placement&&(m=w.placement),w.rects&&(c=!0===w.rects?await l.getElementRects({reference:t,floating:e,strategy:o}):w.rects),({x:f,y:u}=floating_ui_core_esm_min_i(c,m,s))),n=-1)}return{x:f,y:u,placement:m,strategy:o,middlewareData:g}};function floating_ui_core_esm_min_a(t){return"number"!=typeof t?function(t){return{top:0,right:0,bottom:0,left:0,...t}}(t):{top:t,right:t,bottom:t,left:t}}function floating_ui_core_esm_min_l(t){return{...t,top:t.y,left:t.x,right:t.x+t.width,bottom:t.y+t.height}}async function floating_ui_core_esm_min_s(t,e){var n;void 0===e&&(e={});const{x:r,y:i,platform:o,rects:s,elements:c,strategy:f}=t,{boundary:u="clippingAncestors",rootBoundary:m="viewport",elementContext:g="floating",altBoundary:d=!1,padding:p=0}=e,h=floating_ui_core_esm_min_a(p),y=c[d?"floating"===g?"reference":"floating":g],x=floating_ui_core_esm_min_l(await o.getClippingRect({element:null==(n=await(null==o.isElement?void 0:o.isElement(y)))||n?y:y.contextElement||await(null==o.getDocumentElement?void 0:o.getDocumentElement(c.floating)),boundary:u,rootBoundary:m,strategy:f})),w=floating_ui_core_esm_min_l(o.convertOffsetParentRelativeRectToViewportRelativeRect?await o.convertOffsetParentRelativeRectToViewportRelativeRect({rect:"floating"===g?{...s.floating,x:r,y:i}:s.reference,offsetParent:await(null==o.getOffsetParent?void 0:o.getOffsetParent(c.floating)),strategy:f}):s[g]);return{top:x.top-w.top+h.top,bottom:w.bottom-x.bottom+h.bottom,left:x.left-w.left+h.left,right:w.right-x.right+h.right}}const floating_ui_core_esm_min_c=Math.min,floating_ui_core_esm_min_f=Math.max;function floating_ui_core_esm_min_u(t,e,n){return floating_ui_core_esm_min_f(t,floating_ui_core_esm_min_c(e,n))}const floating_ui_core_esm_min_m=t=>({name:"arrow",options:t,async fn(e){const{element:i,padding:o=0}=null!=t?t:{},{x:l,y:s,placement:c,rects:f,platform:m}=e;if(null==i)return{};const g=floating_ui_core_esm_min_a(o),d={x:l,y:s},p=floating_ui_core_esm_min_n(c),h=floating_ui_core_esm_min_r(p),y=await m.getDimensions(i),x="y"===p?"top":"left",w="y"===p?"bottom":"right",v=f.reference[h]+f.reference[p]-d[p]-f.floating[h],b=d[p]-f.reference[p],R=await(null==m.getOffsetParent?void 0:m.getOffsetParent(i)),A=R?"y"===p?R.clientHeight||0:R.clientWidth||0:0,P=v/2-b/2,T=g[x],O=A-y[h]-g[w],D=A/2-y[h]/2+P,L=floating_ui_core_esm_min_u(T,D,O);return{data:{[p]:L,centerOffset:D-L}}}}),floating_ui_core_esm_min_g={left:"right",right:"left",bottom:"top",top:"bottom"};function floating_ui_core_esm_min_d(t){return t.replace(/left|right|bottom|top/g,(t=>floating_ui_core_esm_min_g[t]))}function floating_ui_core_esm_min_p(t,i,o){void 0===o&&(o=!1);const a=floating_ui_core_esm_min_e(t),l=floating_ui_core_esm_min_n(t),s=floating_ui_core_esm_min_r(l);let c="x"===l?a===(o?"end":"start")?"right":"left":"start"===a?"bottom":"top";return i.reference[s]>i.floating[s]&&(c=floating_ui_core_esm_min_d(c)),{main:c,cross:floating_ui_core_esm_min_d(c)}}const floating_ui_core_esm_min_h={start:"end",end:"start"};function floating_ui_core_esm_min_y(t){return t.replace(/start|end/g,(t=>floating_ui_core_esm_min_h[t]))}const floating_ui_core_esm_min_x=["top","right","bottom","left"],floating_ui_core_esm_min_w=floating_ui_core_esm_min_x.reduce(((t,e)=>t.concat(e,e+"-start",e+"-end")),[]);const floating_ui_core_esm_min_v=function(n){return void 0===n&&(n={}),{name:"autoPlacement",options:n,async fn(r){var i,o,a,l,c;const{x:f,y:u,rects:m,middlewareData:g,placement:d,platform:h,elements:x}=r,{alignment:v=null,allowedPlacements:b=floating_ui_core_esm_min_w,autoAlignment:R=!0,...A}=n,P=function(n,r,i){return(n?[...i.filter((t=>floating_ui_core_esm_min_e(t)===n)),...i.filter((t=>floating_ui_core_esm_min_e(t)!==n))]:i.filter((e=>floating_ui_core_esm_min_t(e)===e))).filter((t=>!n||floating_ui_core_esm_min_e(t)===n||!!r&&floating_ui_core_esm_min_y(t)!==t))}(v,R,b),T=await floating_ui_core_esm_min_s(r,A),O=null!=(i=null==(o=g.autoPlacement)?void 0:o.index)?i:0,D=P[O];if(null==D)return{};const{main:L,cross:k}=floating_ui_core_esm_min_p(D,m,await(null==h.isRTL?void 0:h.isRTL(x.floating)));if(d!==D)return{x:f,y:u,reset:{placement:P[0]}};const E=[T[floating_ui_core_esm_min_t(D)],T[L],T[k]],C=[...null!=(a=null==(l=g.autoPlacement)?void 0:l.overflows)?a:[],{placement:D,overflows:E}],B=P[O+1];if(B)return{data:{index:O+1,overflows:C},reset:{placement:B}};const H=C.slice().sort(((t,e)=>t.overflows[0]-e.overflows[0])),V=null==(c=H.find((t=>{let{overflows:e}=t;return e.every((t=>t<=0))})))?void 0:c.placement,F=null!=V?V:H[0].placement;return F!==d?{data:{index:O+1,overflows:C},reset:{placement:F}}:{}}}};const floating_ui_core_esm_min_b=function(e){return void 0===e&&(e={}),{name:"flip",options:e,async fn(n){var r;const{placement:i,middlewareData:o,rects:a,initialPlacement:l,platform:c,elements:f}=n,{mainAxis:u=!0,crossAxis:m=!0,fallbackPlacements:g,fallbackStrategy:h="bestFit",flipAlignment:x=!0,...w}=e,v=floating_ui_core_esm_min_t(i),b=g||(v===l||!x?[floating_ui_core_esm_min_d(l)]:function(t){const e=floating_ui_core_esm_min_d(t);return[floating_ui_core_esm_min_y(t),e,floating_ui_core_esm_min_y(e)]}(l)),R=[l,...b],A=await floating_ui_core_esm_min_s(n,w),P=[];let T=(null==(r=o.flip)?void 0:r.overflows)||[];if(u&&P.push(A[v]),m){const{main:t,cross:e}=floating_ui_core_esm_min_p(i,a,await(null==c.isRTL?void 0:c.isRTL(f.floating)));P.push(A[t],A[e])}if(T=[...T,{placement:i,overflows:P}],!P.every((t=>t<=0))){var O,D;const t=(null!=(O=null==(D=o.flip)?void 0:D.index)?O:0)+1,e=R[t];if(e)return{data:{index:t,overflows:T},reset:{placement:e}};let n="bottom";switch(h){case"bestFit":{var L;const t=null==(L=T.map((t=>[t,t.overflows.filter((t=>t>0)).reduce(((t,e)=>t+e),0)])).sort(((t,e)=>t[1]-e[1]))[0])?void 0:L[0].placement;t&&(n=t);break}case"initialPlacement":n=l}if(i!==n)return{reset:{placement:n}}}return{}}}};function R(t,e){return{top:t.top-e.height,right:t.right-e.width,bottom:t.bottom-e.height,left:t.left-e.width}}function A(t){return floating_ui_core_esm_min_x.some((e=>t[e]>=0))}const P=function(t){let{strategy:e="referenceHidden",...n}=void 0===t?{}:t;return{name:"hide",async fn(t){const{rects:r}=t;switch(e){case"referenceHidden":{const e=R(await floating_ui_core_esm_min_s(t,{...n,elementContext:"reference"}),r.reference);return{data:{referenceHiddenOffsets:e,referenceHidden:A(e)}}}case"escaped":{const e=R(await floating_ui_core_esm_min_s(t,{...n,altBoundary:!0}),r.floating);return{data:{escapedOffsets:e,escaped:A(e)}}}default:return{}}}}};const T=function(r){return void 0===r&&(r=0),{name:"offset",options:r,async fn(i){const{x:o,y:a,placement:l,rects:s,platform:c,elements:f}=i,u=function(r,i,o,a){void 0===a&&(a=!1);const l=floating_ui_core_esm_min_t(r),s=floating_ui_core_esm_min_e(r),c="x"===floating_ui_core_esm_min_n(r),f=["left","top"].includes(l)?-1:1,u=a&&c?-1:1,m="function"==typeof o?o({...i,placement:r}):o;let{mainAxis:g,crossAxis:d,alignmentAxis:p}="number"==typeof m?{mainAxis:m,crossAxis:0,alignmentAxis:null}:{mainAxis:0,crossAxis:0,alignmentAxis:null,...m};return s&&"number"==typeof p&&(d="end"===s?-1*p:p),c?{x:d*u,y:g*f}:{x:g*f,y:d*u}}(l,s,r,await(null==c.isRTL?void 0:c.isRTL(f.floating)));return{x:o+u.x,y:a+u.y,data:u}}}};function O(t){return"x"===t?"y":"x"}const D=function(e){return void 0===e&&(e={}),{name:"shift",options:e,async fn(r){const{x:i,y:o,placement:a}=r,{mainAxis:l=!0,crossAxis:c=!1,limiter:f={fn:t=>{let{x:e,y:n}=t;return{x:e,y:n}}},...m}=e,g={x:i,y:o},d=await floating_ui_core_esm_min_s(r,m),p=floating_ui_core_esm_min_n(floating_ui_core_esm_min_t(a)),h=O(p);let y=g[p],x=g[h];if(l){const t="y"===p?"bottom":"right";y=floating_ui_core_esm_min_u(y+d["y"===p?"top":"left"],y,y-d[t])}if(c){const t="y"===h?"bottom":"right";x=floating_ui_core_esm_min_u(x+d["y"===h?"top":"left"],x,x-d[t])}const w=f.fn({...r,[p]:y,[h]:x});return{...w,data:{x:w.x-i,y:w.y-o}}}}},L=function(e){return void 0===e&&(e={}),{options:e,fn(r){const{x:i,y:o,placement:a,rects:l,middlewareData:s}=r,{offset:c=0,mainAxis:f=!0,crossAxis:u=!0}=e,m={x:i,y:o},g=floating_ui_core_esm_min_n(a),d=O(g);let p=m[g],h=m[d];const y="function"==typeof c?c({...l,placement:a}):c,x="number"==typeof y?{mainAxis:y,crossAxis:0}:{mainAxis:0,crossAxis:0,...y};if(f){const t="y"===g?"height":"width",e=l.reference[g]-l.floating[t]+x.mainAxis,n=l.reference[g]+l.reference[t]-x.mainAxis;p<e?p=e:p>n&&(p=n)}if(u){var w,v,b,R;const e="y"===g?"width":"height",n=["top","left"].includes(floating_ui_core_esm_min_t(a)),r=l.reference[d]-l.floating[e]+(n&&null!=(w=null==(v=s.offset)?void 0:v[d])?w:0)+(n?0:x.crossAxis),i=l.reference[d]+l.reference[e]+(n?0:null!=(b=null==(R=s.offset)?void 0:R[d])?b:0)-(n?x.crossAxis:0);h<r?h=r:h>i&&(h=i)}return{[g]:p,[d]:h}}}},floating_ui_core_esm_min_k=function(n){return void 0===n&&(n={}),{name:"size",options:n,async fn(r){const{placement:i,rects:o,platform:a,elements:l}=r,{apply:c,...u}=n,m=await floating_ui_core_esm_min_s(r,u),g=floating_ui_core_esm_min_t(i),d=floating_ui_core_esm_min_e(i);let p,h;"top"===g||"bottom"===g?(p=g,h=d===(await(null==a.isRTL?void 0:a.isRTL(l.floating))?"start":"end")?"left":"right"):(h=g,p="end"===d?"top":"bottom");const y=floating_ui_core_esm_min_f(m.left,0),x=floating_ui_core_esm_min_f(m.right,0),w=floating_ui_core_esm_min_f(m.top,0),v=floating_ui_core_esm_min_f(m.bottom,0),b={height:o.floating.height-(["left","right"].includes(i)?2*(0!==w||0!==v?w+v:floating_ui_core_esm_min_f(m.top,m.bottom)):m[p]),width:o.floating.width-(["top","bottom"].includes(i)?2*(0!==y||0!==x?y+x:floating_ui_core_esm_min_f(m.left,m.right)):m[h])},R=await a.getDimensions(l.floating);null==c||c({...b,...o});const A=await a.getDimensions(l.floating);return R.width!==A.width||R.height!==A.height?{reset:{rects:!0}}:{}}}},floating_ui_core_esm_min_E=function(e){return void 0===e&&(e={}),{name:"inline",options:e,async fn(r){var i;const{placement:o,elements:s,rects:u,platform:m,strategy:g}=r,{padding:d=2,x:p,y:h}=e,y=floating_ui_core_esm_min_l(m.convertOffsetParentRelativeRectToViewportRelativeRect?await m.convertOffsetParentRelativeRectToViewportRelativeRect({rect:u.reference,offsetParent:await(null==m.getOffsetParent?void 0:m.getOffsetParent(s.floating)),strategy:g}):u.reference),x=null!=(i=await(null==m.getClientRects?void 0:m.getClientRects(s.reference)))?i:[],w=floating_ui_core_esm_min_a(d);const v=await m.getElementRects({reference:{getBoundingClientRect:function(){var e;if(2===x.length&&x[0].left>x[1].right&&null!=p&&null!=h)return null!=(e=x.find((t=>p>t.left-w.left&&p<t.right+w.right&&h>t.top-w.top&&h<t.bottom+w.bottom)))?e:y;if(x.length>=2){if("x"===floating_ui_core_esm_min_n(o)){const e=x[0],n=x[x.length-1],r="top"===floating_ui_core_esm_min_t(o),i=e.top,a=n.bottom,l=r?e.left:n.left,s=r?e.right:n.right;return{top:i,bottom:a,left:l,right:s,width:s-l,height:a-i,x:l,y:i}}const e="left"===floating_ui_core_esm_min_t(o),r=floating_ui_core_esm_min_f(...x.map((t=>t.right))),i=floating_ui_core_esm_min_c(...x.map((t=>t.left))),a=x.filter((t=>e?t.left===i:t.right===r)),l=a[0].top,s=a[a.length-1].bottom;return{top:l,bottom:s,left:i,right:r,width:r-i,height:s-l,x:i,y:l}}return y}},floating:s.floating,strategy:g});return u.reference.x!==v.reference.x||u.reference.y!==v.reference.y||u.reference.width!==v.reference.width||u.reference.height!==v.reference.height?{reset:{rects:v}}:{}}}};

;// CONCATENATED MODULE: ./node_modules/@floating-ui/dom/dist/floating-ui.dom.esm.min.js
function floating_ui_dom_esm_min_n(t){return t&&t.document&&t.location&&t.alert&&t.setInterval}function floating_ui_dom_esm_min_o(t){if(null==t)return window;if(!floating_ui_dom_esm_min_n(t)){const e=t.ownerDocument;return e&&e.defaultView||window}return t}function floating_ui_dom_esm_min_i(t){return floating_ui_dom_esm_min_o(t).getComputedStyle(t)}function floating_ui_dom_esm_min_r(t){return floating_ui_dom_esm_min_n(t)?"":t?(t.nodeName||"").toLowerCase():""}function floating_ui_dom_esm_min_l(t){return t instanceof floating_ui_dom_esm_min_o(t).HTMLElement}function floating_ui_dom_esm_min_c(t){return t instanceof floating_ui_dom_esm_min_o(t).Element}function floating_ui_dom_esm_min_f(t){if("undefined"==typeof ShadowRoot)return!1;return t instanceof floating_ui_dom_esm_min_o(t).ShadowRoot||t instanceof ShadowRoot}function floating_ui_dom_esm_min_s(t){const{overflow:e,overflowX:n,overflowY:o}=floating_ui_dom_esm_min_i(t);return/auto|scroll|overlay|hidden/.test(e+o+n)}function floating_ui_dom_esm_min_u(t){return["table","td","th"].includes(floating_ui_dom_esm_min_r(t))}function floating_ui_dom_esm_min_d(t){const e=navigator.userAgent.toLowerCase().includes("firefox"),n=floating_ui_dom_esm_min_i(t);return"none"!==n.transform||"none"!==n.perspective||"paint"===n.contain||["transform","perspective"].includes(n.willChange)||e&&"filter"===n.willChange||e&&!!n.filter&&"none"!==n.filter}function floating_ui_dom_esm_min_h(){return!/^((?!chrome|android).)*safari/i.test(navigator.userAgent)}const floating_ui_dom_esm_min_a=Math.min,floating_ui_dom_esm_min_g=Math.max,floating_ui_dom_esm_min_p=Math.round;function floating_ui_dom_esm_min_m(t,e,n){var i,r,f,s;void 0===e&&(e=!1),void 0===n&&(n=!1);const u=t.getBoundingClientRect();let d=1,a=1;e&&floating_ui_dom_esm_min_l(t)&&(d=t.offsetWidth>0&&floating_ui_dom_esm_min_p(u.width)/t.offsetWidth||1,a=t.offsetHeight>0&&floating_ui_dom_esm_min_p(u.height)/t.offsetHeight||1);const g=floating_ui_dom_esm_min_c(t)?floating_ui_dom_esm_min_o(t):window,m=!floating_ui_dom_esm_min_h()&&n,w=(u.left+(m&&null!=(i=null==(r=g.visualViewport)?void 0:r.offsetLeft)?i:0))/d,v=(u.top+(m&&null!=(f=null==(s=g.visualViewport)?void 0:s.offsetTop)?f:0))/a,y=u.width/d,x=u.height/a;return{width:y,height:x,top:v,right:w+y,bottom:v+x,left:w,x:w,y:v}}function floating_ui_dom_esm_min_w(t){return(e=t,(e instanceof floating_ui_dom_esm_min_o(e).Node?t.ownerDocument:t.document)||window.document).documentElement;var e}function floating_ui_dom_esm_min_v(t){return floating_ui_dom_esm_min_c(t)?{scrollLeft:t.scrollLeft,scrollTop:t.scrollTop}:{scrollLeft:t.pageXOffset,scrollTop:t.pageYOffset}}function floating_ui_dom_esm_min_y(t){return floating_ui_dom_esm_min_m(floating_ui_dom_esm_min_w(t)).left+floating_ui_dom_esm_min_v(t).scrollLeft}function floating_ui_dom_esm_min_x(t,e,n){const o=floating_ui_dom_esm_min_l(e),i=floating_ui_dom_esm_min_w(e),c=floating_ui_dom_esm_min_m(t,o&&function(t){const e=floating_ui_dom_esm_min_m(t);return floating_ui_dom_esm_min_p(e.width)!==t.offsetWidth||floating_ui_dom_esm_min_p(e.height)!==t.offsetHeight}(e),"fixed"===n);let f={scrollLeft:0,scrollTop:0};const u={x:0,y:0};if(o||!o&&"fixed"!==n)if(("body"!==floating_ui_dom_esm_min_r(e)||floating_ui_dom_esm_min_s(i))&&(f=floating_ui_dom_esm_min_v(e)),floating_ui_dom_esm_min_l(e)){const t=floating_ui_dom_esm_min_m(e,!0);u.x=t.x+e.clientLeft,u.y=t.y+e.clientTop}else i&&(u.x=floating_ui_dom_esm_min_y(i));return{x:c.left+f.scrollLeft-u.x,y:c.top+f.scrollTop-u.y,width:c.width,height:c.height}}function floating_ui_dom_esm_min_L(t){return"html"===floating_ui_dom_esm_min_r(t)?t:t.assignedSlot||t.parentNode||(floating_ui_dom_esm_min_f(t)?t.host:null)||floating_ui_dom_esm_min_w(t)}function floating_ui_dom_esm_min_b(t){return floating_ui_dom_esm_min_l(t)&&"fixed"!==getComputedStyle(t).position?t.offsetParent:null}function floating_ui_dom_esm_min_R(t){const e=floating_ui_dom_esm_min_o(t);let n=floating_ui_dom_esm_min_b(t);for(;n&&floating_ui_dom_esm_min_u(n)&&"static"===getComputedStyle(n).position;)n=floating_ui_dom_esm_min_b(n);return n&&("html"===floating_ui_dom_esm_min_r(n)||"body"===floating_ui_dom_esm_min_r(n)&&"static"===getComputedStyle(n).position&&!floating_ui_dom_esm_min_d(n))?e:n||function(t){let e=floating_ui_dom_esm_min_L(t);for(floating_ui_dom_esm_min_f(e)&&(e=e.host);floating_ui_dom_esm_min_l(e)&&!["html","body"].includes(floating_ui_dom_esm_min_r(e));){if(floating_ui_dom_esm_min_d(e))return e;e=e.parentNode}return null}(t)||e}function floating_ui_dom_esm_min_T(t){if(floating_ui_dom_esm_min_l(t))return{width:t.offsetWidth,height:t.offsetHeight};const e=floating_ui_dom_esm_min_m(t);return{width:e.width,height:e.height}}function W(t){const e=floating_ui_dom_esm_min_L(t);return["html","body","#document"].includes(floating_ui_dom_esm_min_r(e))?t.ownerDocument.body:floating_ui_dom_esm_min_l(e)&&floating_ui_dom_esm_min_s(e)?e:W(e)}function C(t,e){var n;void 0===e&&(e=[]);const i=W(t),r=i===(null==(n=t.ownerDocument)?void 0:n.body),l=floating_ui_dom_esm_min_o(i),c=r?[l].concat(l.visualViewport||[],floating_ui_dom_esm_min_s(i)?i:[]):i,f=e.concat(c);return r?f:f.concat(C(c))}function floating_ui_dom_esm_min_E(e,n,r){return"viewport"===n?floating_ui_core_esm_min_l(function(t,e){const n=floating_ui_dom_esm_min_o(t),i=floating_ui_dom_esm_min_w(t),r=n.visualViewport;let l=i.clientWidth,c=i.clientHeight,f=0,s=0;if(r){l=r.width,c=r.height;const t=floating_ui_dom_esm_min_h();(t||!t&&"fixed"===e)&&(f=r.offsetLeft,s=r.offsetTop)}return{width:l,height:c,x:f,y:s}}(e,r)):floating_ui_dom_esm_min_c(n)?function(t,e){const n=floating_ui_dom_esm_min_m(t,!1,"fixed"===e),o=n.top+t.clientTop,i=n.left+t.clientLeft;return{top:o,left:i,x:i,y:o,right:i+t.clientWidth,bottom:o+t.clientHeight,width:t.clientWidth,height:t.clientHeight}}(n,r):floating_ui_core_esm_min_l(function(t){var e;const n=floating_ui_dom_esm_min_w(t),o=floating_ui_dom_esm_min_v(t),r=null==(e=t.ownerDocument)?void 0:e.body,l=floating_ui_dom_esm_min_g(n.scrollWidth,n.clientWidth,r?r.scrollWidth:0,r?r.clientWidth:0),c=floating_ui_dom_esm_min_g(n.scrollHeight,n.clientHeight,r?r.scrollHeight:0,r?r.clientHeight:0);let f=-o.scrollLeft+floating_ui_dom_esm_min_y(t);const s=-o.scrollTop;return"rtl"===floating_ui_dom_esm_min_i(r||n).direction&&(f+=floating_ui_dom_esm_min_g(n.clientWidth,r?r.clientWidth:0)-l),{width:l,height:c,x:f,y:s}}(floating_ui_dom_esm_min_w(e)))}function floating_ui_dom_esm_min_H(t){const e=C(t),n=["absolute","fixed"].includes(floating_ui_dom_esm_min_i(t).position)&&floating_ui_dom_esm_min_l(t)?floating_ui_dom_esm_min_R(t):t;return floating_ui_dom_esm_min_c(n)?e.filter((t=>floating_ui_dom_esm_min_c(t)&&function(t,e){const n=null==e||null==e.getRootNode?void 0:e.getRootNode();if(null!=t&&t.contains(e))return!0;if(n&&floating_ui_dom_esm_min_f(n)){let n=e;do{if(n&&t===n)return!0;n=n.parentNode||n.host}while(n)}return!1}(t,n)&&"body"!==floating_ui_dom_esm_min_r(t))):[]}const floating_ui_dom_esm_min_S={getClippingRect:function(t){let{element:e,boundary:n,rootBoundary:o,strategy:i}=t;const r=[..."clippingAncestors"===n?floating_ui_dom_esm_min_H(e):[].concat(n),o],l=r[0],c=r.reduce(((t,n)=>{const o=floating_ui_dom_esm_min_E(e,n,i);return t.top=floating_ui_dom_esm_min_g(o.top,t.top),t.right=floating_ui_dom_esm_min_a(o.right,t.right),t.bottom=floating_ui_dom_esm_min_a(o.bottom,t.bottom),t.left=floating_ui_dom_esm_min_g(o.left,t.left),t}),floating_ui_dom_esm_min_E(e,l,i));return{width:c.right-c.left,height:c.bottom-c.top,x:c.left,y:c.top}},convertOffsetParentRelativeRectToViewportRelativeRect:function(t){let{rect:e,offsetParent:n,strategy:o}=t;const i=floating_ui_dom_esm_min_l(n),c=floating_ui_dom_esm_min_w(n);if(n===c)return e;let f={scrollLeft:0,scrollTop:0};const u={x:0,y:0};if((i||!i&&"fixed"!==o)&&(("body"!==floating_ui_dom_esm_min_r(n)||floating_ui_dom_esm_min_s(c))&&(f=floating_ui_dom_esm_min_v(n)),floating_ui_dom_esm_min_l(n))){const t=floating_ui_dom_esm_min_m(n,!0);u.x=t.x+n.clientLeft,u.y=t.y+n.clientTop}return{...e,x:e.x-f.scrollLeft+u.x,y:e.y-f.scrollTop+u.y}},isElement:floating_ui_dom_esm_min_c,getDimensions:floating_ui_dom_esm_min_T,getOffsetParent:floating_ui_dom_esm_min_R,getDocumentElement:floating_ui_dom_esm_min_w,getElementRects:t=>{let{reference:e,floating:n,strategy:o}=t;return{reference:floating_ui_dom_esm_min_x(e,floating_ui_dom_esm_min_R(n),o),floating:{...floating_ui_dom_esm_min_T(n),x:0,y:0}}},getClientRects:t=>Array.from(t.getClientRects()),isRTL:t=>"rtl"===floating_ui_dom_esm_min_i(t).direction};function floating_ui_dom_esm_min_D(t,e,n,o){void 0===o&&(o={});const{ancestorScroll:i=!0,ancestorResize:r=!0,elementResize:l=!0,animationFrame:f=!1}=o;let s=!1;const u=i&&!f,d=r&&!f,h=l&&!f,a=u||d?[...floating_ui_dom_esm_min_c(t)?C(t):[],...C(e)]:[];a.forEach((t=>{u&&t.addEventListener("scroll",n,{passive:!0}),d&&t.addEventListener("resize",n)}));let g,p=null;h&&(p=new ResizeObserver(n),floating_ui_dom_esm_min_c(t)&&p.observe(t),p.observe(e));let w=f?floating_ui_dom_esm_min_m(t):null;return f&&function e(){if(s)return;const o=floating_ui_dom_esm_min_m(t);!w||o.x===w.x&&o.y===w.y&&o.width===w.width&&o.height===w.height||n();w=o,g=requestAnimationFrame(e)}(),()=>{var t;s=!0,a.forEach((t=>{u&&t.removeEventListener("scroll",n),d&&t.removeEventListener("resize",n)})),null==(t=p)||t.disconnect(),p=null,f&&cancelAnimationFrame(g)}}const floating_ui_dom_esm_min_N=(t,n,o)=>floating_ui_core_esm_min_o(t,n,{platform:floating_ui_dom_esm_min_S,...o});

// EXTERNAL MODULE: ./node_modules/react-dom/index.js
var react_dom = __webpack_require__(3935);
;// CONCATENATED MODULE: ./node_modules/@floating-ui/react-dom/dist/floating-ui.react-dom.esm.js





var index = typeof document !== 'undefined' ? react.useLayoutEffect : react.useEffect;

// Fork of `fast-deep-equal` that only does the comparisons we need and compares
// functions
// @ts-nocheck
function deepEqual(a, b) {
  if (a === b) {
    return true;
  }

  if (typeof a !== typeof b) {
    return false;
  }

  if (typeof a === 'function' && a.toString() === b.toString()) {
    return true;
  }

  let length, i, keys;

  if (a && b && typeof a == 'object') {
    if (Array.isArray(a)) {
      length = a.length;
      if (length != b.length) return false;

      for (i = length; i-- !== 0;) {
        if (!deepEqual(a[i], b[i])) {
          return false;
        }
      }

      return true;
    }

    keys = Object.keys(a);
    length = keys.length;

    if (length !== Object.keys(b).length) {
      return false;
    }

    for (i = length; i-- !== 0;) {
      if (!Object.prototype.hasOwnProperty.call(b, keys[i])) {
        return false;
      }
    }

    for (i = length; i-- !== 0;) {
      const key = keys[i];

      if (key === '_owner' && a.$$typeof) {
        continue;
      }

      if (!deepEqual(a[key], b[key])) {
        return false;
      }
    }

    return true;
  }

  return a !== a && b !== b;
}

function useFloating(_temp) {
  let {
    middleware,
    placement = 'bottom',
    strategy = 'absolute'
  } = _temp === void 0 ? {} : _temp;
  const reference = (0,react.useRef)(null);
  const floating = (0,react.useRef)(null);
  const [data, setData] = (0,react.useState)({
    // Setting these to `null` will allow the consumer to determine if
    // `computePosition()` has run yet
    x: null,
    y: null,
    strategy,
    placement,
    middlewareData: {}
  });
  const [latestMiddleware, setLatestMiddleware] = (0,react.useState)(middleware);

  if (!deepEqual(latestMiddleware == null ? void 0 : latestMiddleware.map(_ref => {
    let {
      options
    } = _ref;
    return options;
  }), middleware == null ? void 0 : middleware.map(_ref2 => {
    let {
      options
    } = _ref2;
    return options;
  }))) {
    setLatestMiddleware(middleware);
  }

  const isMountedRef = (0,react.useRef)(true);
  index(() => {
    isMountedRef.current = true;
    return () => {
      isMountedRef.current = false;
    };
  }, []);
  const update = (0,react.useCallback)(() => {
    if (!reference.current || !floating.current) {
      return;
    }

    floating_ui_dom_esm_min_N(reference.current, floating.current, {
      middleware: latestMiddleware,
      placement,
      strategy
    }).then(data => {
      if (isMountedRef.current) {
        (0,react_dom.flushSync)(() => {
          setData(data);
        });
      }
    });
  }, [latestMiddleware, placement, strategy]);
  index(update, [update]);
  const setReference = (0,react.useCallback)(node => {
    reference.current = node;
    update();
  }, [update]);
  const setFloating = (0,react.useCallback)(node => {
    floating.current = node;
    update();
  }, [update]);
  const refs = (0,react.useMemo)(() => ({
    reference,
    floating
  }), []);
  return (0,react.useMemo)(() => ({ ...data,
    update,
    refs,
    reference: setReference,
    floating: setFloating
  }), [data, update, refs, setReference, setFloating]);
}
const arrow = options => {
  const {
    element,
    padding
  } = options;

  function isRef(value) {
    return Object.prototype.hasOwnProperty.call(value, 'current');
  }

  return {
    name: 'arrow',
    options,

    fn(args) {
      if (isRef(element)) {
        if (element.current != null) {
          return floating_ui_core_esm_min_m({
            element: element.current,
            padding
          }).fn(args);
        }

        return {};
      } else if (element) {
        return floating_ui_core_esm_min_m({
          element,
          padding
        }).fn(args);
      }

      return {};
    }

  };
};



;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-media-query/index.js
/**
 * WordPress dependencies
 */

/**
 * Runs a media query and returns its value when it changes.
 *
 * @param {string} [query] Media Query.
 * @return {boolean} return value of the media query.
 */

function useMediaQuery(query) {
  const [match, setMatch] = (0,react.useState)(() => !!(query && typeof window !== 'undefined' && window.matchMedia(query).matches));
  (0,react.useEffect)(() => {
    if (!query) {
      return;
    }

    const updateMatch = () => setMatch(window.matchMedia(query).matches);

    updateMatch();
    const list = window.matchMedia(query);
    list.addListener(updateMatch);
    return () => {
      list.removeListener(updateMatch);
    };
  }, [query]);
  return !!query && match;
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-viewport-match/index.js
/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */


/**
 * @typedef {"huge" | "wide" | "large" | "medium" | "small" | "mobile"} WPBreakpoint
 */

/**
 * Hash of breakpoint names with pixel width at which it becomes effective.
 *
 * @see _breakpoints.scss
 *
 * @type {Record<WPBreakpoint, number>}
 */

const BREAKPOINTS = {
  huge: 1440,
  wide: 1280,
  large: 960,
  medium: 782,
  small: 600,
  mobile: 480
};
/**
 * @typedef {">=" | "<"} WPViewportOperator
 */

/**
 * Object mapping media query operators to the condition to be used.
 *
 * @type {Record<WPViewportOperator, string>}
 */

const CONDITIONS = {
  '>=': 'min-width',
  '<': 'max-width'
};
/**
 * Object mapping media query operators to a function that given a breakpointValue and a width evaluates if the operator matches the values.
 *
 * @type {Record<WPViewportOperator, (breakpointValue: number, width: number) => boolean>}
 */

const OPERATOR_EVALUATORS = {
  '>=': (breakpointValue, width) => width >= breakpointValue,
  '<': (breakpointValue, width) => width < breakpointValue
};
const ViewportMatchWidthContext = (0,react.createContext)(
/** @type {null | number} */
null);
/**
 * Returns true if the viewport matches the given query, or false otherwise.
 *
 * @param {WPBreakpoint}       breakpoint      Breakpoint size name.
 * @param {WPViewportOperator} [operator=">="] Viewport operator.
 *
 * @example
 *
 * ```js
 * useViewportMatch( 'huge', '<' );
 * useViewportMatch( 'medium' );
 * ```
 *
 * @return {boolean} Whether viewport matches query.
 */

const useViewportMatch = function (breakpoint) {
  let operator = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '>=';
  const simulatedWidth = (0,react.useContext)(ViewportMatchWidthContext);
  const mediaQuery = !simulatedWidth && `(${CONDITIONS[operator]}: ${BREAKPOINTS[breakpoint]}px)`;
  const mediaQueryResult = useMediaQuery(mediaQuery || undefined);

  if (simulatedWidth) {
    return OPERATOR_EVALUATORS[operator](BREAKPOINTS[breakpoint], simulatedWidth);
  }

  return mediaQueryResult;
};

useViewportMatch.__experimentalWidthProvider = ViewportMatchWidthContext.Provider;
/* harmony default export */ const use_viewport_match = (useViewportMatch);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/keycodes/build-module/platform.js
/**
 * External dependencies
 */

/**
 * Return true if platform is MacOS.
 *
 * @param {Window?} _window window object by default; used for DI testing.
 *
 * @return {boolean} True if MacOS; false otherwise.
 */

function isAppleOS() {
  let _window = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

  if (!_window) {
    if (typeof window === 'undefined') {
      return false;
    }

    _window = window;
  }

  const {
    platform
  } = _window.navigator;
  return platform.indexOf('Mac') !== -1 || (0,lodash.includes)(['iPad', 'iPhone'], platform);
}
//# sourceMappingURL=platform.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/keycodes/build-module/index.js
/**
 * Note: The order of the modifier keys in many of the [foo]Shortcut()
 * functions in this file are intentional and should not be changed. They're
 * designed to fit with the standard menu keyboard shortcuts shown in the
 * user's platform.
 *
 * For example, on MacOS menu shortcuts will place Shift before Command, but
 * on Windows Control will usually come first. So don't provide your own
 * shortcut combos directly to keyboardShortcut().
 */

/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */


/** @typedef {typeof ALT | CTRL | COMMAND | SHIFT } WPModifierPart */

/** @typedef {'primary' | 'primaryShift' | 'primaryAlt' | 'secondary' | 'access' | 'ctrl' | 'alt' | 'ctrlShift' | 'shift' | 'shiftAlt' | 'undefined'} WPKeycodeModifier */

/**
 * An object of handler functions for each of the possible modifier
 * combinations. A handler will return a value for a given key.
 *
 * @template T
 *
 * @typedef {Record<WPKeycodeModifier, T>} WPModifierHandler
 */

/**
 * @template T
 *
 * @typedef {(character: string, isApple?: () => boolean) => T} WPKeyHandler
 */

/** @typedef {(event: KeyboardEvent, character: string, isApple?: () => boolean) => boolean} WPEventKeyHandler */

/**
 * Keycode for BACKSPACE key.
 */

const BACKSPACE = 8;
/**
 * Keycode for TAB key.
 */

const TAB = 9;
/**
 * Keycode for ENTER key.
 */

const ENTER = 13;
/**
 * Keycode for ESCAPE key.
 */

const ESCAPE = 27;
/**
 * Keycode for SPACE key.
 */

const SPACE = 32;
/**
 * Keycode for PAGEUP key.
 */

const PAGEUP = 33;
/**
 * Keycode for PAGEDOWN key.
 */

const PAGEDOWN = 34;
/**
 * Keycode for END key.
 */

const END = 35;
/**
 * Keycode for HOME key.
 */

const HOME = 36;
/**
 * Keycode for LEFT key.
 */

const LEFT = 37;
/**
 * Keycode for UP key.
 */

const UP = 38;
/**
 * Keycode for RIGHT key.
 */

const RIGHT = 39;
/**
 * Keycode for DOWN key.
 */

const DOWN = 40;
/**
 * Keycode for DELETE key.
 */

const DELETE = 46;
/**
 * Keycode for F10 key.
 */

const F10 = 121;
/**
 * Keycode for ALT key.
 */

const ALT = 'alt';
/**
 * Keycode for CTRL key.
 */

const CTRL = 'ctrl';
/**
 * Keycode for COMMAND/META key.
 */

const COMMAND = 'meta';
/**
 * Keycode for SHIFT key.
 */

const SHIFT = 'shift';
/**
 * Keycode for ZERO key.
 */

const ZERO = 48;
/**
 * Object that contains functions that return the available modifier
 * depending on platform.
 *
 * @type {WPModifierHandler< ( isApple: () => boolean ) => WPModifierPart[]>}
 */

const modifiers = {
  primary: _isApple => _isApple() ? [COMMAND] : [CTRL],
  primaryShift: _isApple => _isApple() ? [SHIFT, COMMAND] : [CTRL, SHIFT],
  primaryAlt: _isApple => _isApple() ? [ALT, COMMAND] : [CTRL, ALT],
  secondary: _isApple => _isApple() ? [SHIFT, ALT, COMMAND] : [CTRL, SHIFT, ALT],
  access: _isApple => _isApple() ? [CTRL, ALT] : [SHIFT, ALT],
  ctrl: () => [CTRL],
  alt: () => [ALT],
  ctrlShift: () => [CTRL, SHIFT],
  shift: () => [SHIFT],
  shiftAlt: () => [SHIFT, ALT],
  undefined: () => []
};
/**
 * An object that contains functions to get raw shortcuts.
 *
 * These are intended for user with the KeyboardShortcuts.
 *
 * @example
 * ```js
 * // Assuming macOS:
 * rawShortcut.primary( 'm' )
 * // "meta+m""
 * ```
 *
 * @type {WPModifierHandler<WPKeyHandler<string>>} Keyed map of functions to raw
 *                                                 shortcuts.
 */

const rawShortcut = (0,lodash.mapValues)(modifiers, modifier => {
  return (
    /** @type {WPKeyHandler<string>} */
    function (character) {
      let _isApple = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : isAppleOS;

      return [...modifier(_isApple), character.toLowerCase()].join('+');
    }
  );
});
/**
 * Return an array of the parts of a keyboard shortcut chord for display.
 *
 * @example
 * ```js
 * // Assuming macOS:
 * displayShortcutList.primary( 'm' );
 * // [ "⌘", "M" ]
 * ```
 *
 * @type {WPModifierHandler<WPKeyHandler<string[]>>} Keyed map of functions to
 *                                                   shortcut sequences.
 */

const displayShortcutList = (0,lodash.mapValues)(modifiers, modifier => {
  return (
    /** @type {WPKeyHandler<string[]>} */
    function (character) {
      let _isApple = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : isAppleOS;

      const isApple = _isApple();

      const replacementKeyMap = {
        [ALT]: isApple ? '⌥' : 'Alt',
        [CTRL]: isApple ? '⌃' : 'Ctrl',
        // Make sure ⌃ is the U+2303 UP ARROWHEAD unicode character and not the caret character.
        [COMMAND]: '⌘',
        [SHIFT]: isApple ? '⇧' : 'Shift'
      };
      const modifierKeys = modifier(_isApple).reduce((accumulator, key) => {
        const replacementKey = (0,lodash.get)(replacementKeyMap, key, key); // If on the Mac, adhere to platform convention and don't show plus between keys.

        if (isApple) {
          return [...accumulator, replacementKey];
        }

        return [...accumulator, replacementKey, '+'];
      },
      /** @type {string[]} */
      []);
      const capitalizedCharacter = (0,lodash.capitalize)(character);
      return [...modifierKeys, capitalizedCharacter];
    }
  );
});
/**
 * An object that contains functions to display shortcuts.
 *
 * @example
 * ```js
 * // Assuming macOS:
 * displayShortcut.primary( 'm' );
 * // "⌘M"
 * ```
 *
 * @type {WPModifierHandler<WPKeyHandler<string>>} Keyed map of functions to
 *                                                 display shortcuts.
 */

const displayShortcut = (0,lodash.mapValues)(displayShortcutList, shortcutList => {
  return (
    /** @type {WPKeyHandler<string>} */
    function (character) {
      let _isApple = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : isAppleOS;

      return shortcutList(character, _isApple).join('');
    }
  );
});
/**
 * An object that contains functions to return an aria label for a keyboard
 * shortcut.
 *
 * @example
 * ```js
 * // Assuming macOS:
 * shortcutAriaLabel.primary( '.' );
 * // "Command + Period"
 * ```
 *
 * @type {WPModifierHandler<WPKeyHandler<string>>} Keyed map of functions to
 *                                                 shortcut ARIA labels.
 */

const shortcutAriaLabel = (0,lodash.mapValues)(modifiers, modifier => {
  return (
    /** @type {WPKeyHandler<string>} */
    function (character) {
      let _isApple = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : isAppleOS;

      const isApple = _isApple();

      const replacementKeyMap = {
        [SHIFT]: 'Shift',
        [COMMAND]: isApple ? 'Command' : 'Control',
        [CTRL]: 'Control',
        [ALT]: isApple ? 'Option' : 'Alt',

        /* translators: comma as in the character ',' */
        ',': __('Comma'),

        /* translators: period as in the character '.' */
        '.': __('Period'),

        /* translators: backtick as in the character '`' */
        '`': __('Backtick')
      };
      return [...modifier(_isApple), character].map(key => (0,lodash.capitalize)((0,lodash.get)(replacementKeyMap, key, key))).join(isApple ? ' ' : ' + ');
    }
  );
});
/**
 * From a given KeyboardEvent, returns an array of active modifier constants for
 * the event.
 *
 * @param {KeyboardEvent} event Keyboard event.
 *
 * @return {Array<WPModifierPart>} Active modifier constants.
 */

function getEventModifiers(event) {
  return (
    /** @type {WPModifierPart[]} */
    [ALT, CTRL, COMMAND, SHIFT].filter(key => event[
    /** @type {'altKey' | 'ctrlKey' | 'metaKey' | 'shiftKey'} */
    `${key}Key`])
  );
}
/**
 * An object that contains functions to check if a keyboard event matches a
 * predefined shortcut combination.
 *
 * @example
 * ```js
 * // Assuming an event for ⌘M key press:
 * isKeyboardEvent.primary( event, 'm' );
 * // true
 * ```
 *
 * @type {WPModifierHandler<WPEventKeyHandler>} Keyed map of functions
 *                                                       to match events.
 */


const isKeyboardEvent = (0,lodash.mapValues)(modifiers, getModifiers => {
  return (
    /** @type {WPEventKeyHandler} */
    function (event, character) {
      let _isApple = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : isAppleOS;

      const mods = getModifiers(_isApple);
      const eventMods = getEventModifiers(event);

      if ((0,lodash.xor)(mods, eventMods).length) {
        return false;
      }

      let key = event.key.toLowerCase();

      if (!character) {
        return (0,lodash.includes)(mods, key);
      }

      if (event.altKey && character.length === 1) {
        key = String.fromCharCode(event.keyCode).toLowerCase();
      } // For backwards compatibility.


      if (character === 'del') {
        character = 'delete';
      }

      return key === character.toLowerCase();
    }
  );
});
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/dom/build-module/focusable.js
/**
 * References:
 *
 * Focusable:
 *  - https://www.w3.org/TR/html5/editing.html#focus-management
 *
 * Sequential focus navigation:
 *  - https://www.w3.org/TR/html5/editing.html#sequential-focus-navigation-and-the-tabindex-attribute
 *
 * Disabled elements:
 *  - https://www.w3.org/TR/html5/disabled-elements.html#disabled-elements
 *
 * getClientRects algorithm (requiring layout box):
 *  - https://www.w3.org/TR/cssom-view-1/#extension-to-the-element-interface
 *
 * AREA elements associated with an IMG:
 *  - https://w3c.github.io/html/editing.html#data-model
 */

/**
 * Returns a CSS selector used to query for focusable elements.
 *
 * @param {boolean} sequential If set, only query elements that are sequentially
 *                             focusable. Non-interactive elements with a
 *                             negative `tabindex` are focusable but not
 *                             sequentially focusable.
 *                             https://html.spec.whatwg.org/multipage/interaction.html#the-tabindex-attribute
 *
 * @return {string} CSS selector.
 */
function buildSelector(sequential) {
  return [sequential ? '[tabindex]:not([tabindex^="-"])' : '[tabindex]', 'a[href]', 'button:not([disabled])', 'input:not([type="hidden"]):not([disabled])', 'select:not([disabled])', 'textarea:not([disabled])', 'iframe:not([tabindex^="-"])', 'object', 'embed', 'area[href]', '[contenteditable]:not([contenteditable=false])'].join(',');
}
/**
 * Returns true if the specified element is visible (i.e. neither display: none
 * nor visibility: hidden).
 *
 * @param {HTMLElement} element DOM element to test.
 *
 * @return {boolean} Whether element is visible.
 */


function isVisible(element) {
  return element.offsetWidth > 0 || element.offsetHeight > 0 || element.getClientRects().length > 0;
}
/**
 * Returns true if the specified area element is a valid focusable element, or
 * false otherwise. Area is only focusable if within a map where a named map
 * referenced by an image somewhere in the document.
 *
 * @param {HTMLAreaElement} element DOM area element to test.
 *
 * @return {boolean} Whether area element is valid for focus.
 */


function isValidFocusableArea(element) {
  /** @type {HTMLMapElement | null} */
  const map = element.closest('map[name]');

  if (!map) {
    return false;
  }
  /** @type {HTMLImageElement | null} */


  const img = element.ownerDocument.querySelector('img[usemap="#' + map.name + '"]');
  return !!img && isVisible(img);
}
/**
 * Returns all focusable elements within a given context.
 *
 * @param {Element} context              Element in which to search.
 * @param {Object}  [options]
 * @param {boolean} [options.sequential] If set, only return elements that are
 *                                       sequentially focusable.
 *                                       Non-interactive elements with a
 *                                       negative `tabindex` are focusable but
 *                                       not sequentially focusable.
 *                                       https://html.spec.whatwg.org/multipage/interaction.html#the-tabindex-attribute
 *
 * @return {Element[]} Focusable elements.
 */


function find(context) {
  let {
    sequential = false
  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  /* eslint-disable jsdoc/no-undefined-types */

  /** @type {NodeListOf<HTMLElement>} */

  /* eslint-enable jsdoc/no-undefined-types */
  const elements = context.querySelectorAll(buildSelector(sequential));
  return Array.from(elements).filter(element => {
    if (!isVisible(element)) {
      return false;
    }

    const {
      nodeName
    } = element;

    if ('AREA' === nodeName) {
      return isValidFocusableArea(
      /** @type {HTMLAreaElement} */
      element);
    }

    return true;
  });
}
//# sourceMappingURL=focusable.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/dom/build-module/tabbable.js
/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


/**
 * Returns the tab index of the given element. In contrast with the tabIndex
 * property, this normalizes the default (0) to avoid browser inconsistencies,
 * operating under the assumption that this function is only ever called with a
 * focusable node.
 *
 * @see https://bugzilla.mozilla.org/show_bug.cgi?id=1190261
 *
 * @param {Element} element Element from which to retrieve.
 *
 * @return {number} Tab index of element (default 0).
 */

function getTabIndex(element) {
  const tabIndex = element.getAttribute('tabindex');
  return tabIndex === null ? 0 : parseInt(tabIndex, 10);
}
/**
 * Returns true if the specified element is tabbable, or false otherwise.
 *
 * @param {Element} element Element to test.
 *
 * @return {boolean} Whether element is tabbable.
 */


function isTabbableIndex(element) {
  return getTabIndex(element) !== -1;
}
/** @typedef {Element & { type?: string, checked?: boolean, name?: string }} MaybeHTMLInputElement */

/**
 * Returns a stateful reducer function which constructs a filtered array of
 * tabbable elements, where at most one radio input is selected for a given
 * name, giving priority to checked input, falling back to the first
 * encountered.
 *
 * @return {(acc: MaybeHTMLInputElement[], el: MaybeHTMLInputElement) => MaybeHTMLInputElement[]} Radio group collapse reducer.
 */

function createStatefulCollapseRadioGroup() {
  /** @type {Record<string, MaybeHTMLInputElement>} */
  const CHOSEN_RADIO_BY_NAME = {};
  return function collapseRadioGroup(
  /** @type {MaybeHTMLInputElement[]} */
  result,
  /** @type {MaybeHTMLInputElement} */
  element) {
    const {
      nodeName,
      type,
      checked,
      name
    } = element; // For all non-radio tabbables, construct to array by concatenating.

    if (nodeName !== 'INPUT' || type !== 'radio' || !name) {
      return result.concat(element);
    }

    const hasChosen = CHOSEN_RADIO_BY_NAME.hasOwnProperty(name); // Omit by skipping concatenation if the radio element is not chosen.

    const isChosen = checked || !hasChosen;

    if (!isChosen) {
      return result;
    } // At this point, if there had been a chosen element, the current
    // element is checked and should take priority. Retroactively remove
    // the element which had previously been considered the chosen one.


    if (hasChosen) {
      const hadChosenElement = CHOSEN_RADIO_BY_NAME[name];
      result = (0,lodash.without)(result, hadChosenElement);
    }

    CHOSEN_RADIO_BY_NAME[name] = element;
    return result.concat(element);
  };
}
/**
 * An array map callback, returning an object with the element value and its
 * array index location as properties. This is used to emulate a proper stable
 * sort where equal tabIndex should be left in order of their occurrence in the
 * document.
 *
 * @param {Element} element Element.
 * @param {number}  index   Array index of element.
 *
 * @return {{ element: Element, index: number }} Mapped object with element, index.
 */


function mapElementToObjectTabbable(element, index) {
  return {
    element,
    index
  };
}
/**
 * An array map callback, returning an element of the given mapped object's
 * element value.
 *
 * @param {{ element: Element }} object Mapped object with element.
 *
 * @return {Element} Mapped object element.
 */


function mapObjectTabbableToElement(object) {
  return object.element;
}
/**
 * A sort comparator function used in comparing two objects of mapped elements.
 *
 * @see mapElementToObjectTabbable
 *
 * @param {{ element: Element, index: number }} a First object to compare.
 * @param {{ element: Element, index: number }} b Second object to compare.
 *
 * @return {number} Comparator result.
 */


function compareObjectTabbables(a, b) {
  const aTabIndex = getTabIndex(a.element);
  const bTabIndex = getTabIndex(b.element);

  if (aTabIndex === bTabIndex) {
    return a.index - b.index;
  }

  return aTabIndex - bTabIndex;
}
/**
 * Givin focusable elements, filters out tabbable element.
 *
 * @param {Element[]} focusables Focusable elements to filter.
 *
 * @return {Element[]} Tabbable elements.
 */


function filterTabbable(focusables) {
  return focusables.filter(isTabbableIndex).map(mapElementToObjectTabbable).sort(compareObjectTabbables).map(mapObjectTabbableToElement).reduce(createStatefulCollapseRadioGroup(), []);
}
/**
 * @param {Element} context
 * @return {Element[]} Tabbable elements within the context.
 */


function tabbable_find(context) {
  return filterTabbable(find(context));
}
/**
 * Given a focusable element, find the preceding tabbable element.
 *
 * @param {Element} element The focusable element before which to look. Defaults
 *                          to the active element.
 *
 * @return {Element|undefined} Preceding tabbable element.
 */

function findPrevious(element) {
  const focusables = find(element.ownerDocument.body);
  const index = focusables.indexOf(element);

  if (index === -1) {
    return undefined;
  } // Remove all focusables after and including `element`.


  focusables.length = index;
  return (0,lodash.last)(filterTabbable(focusables));
}
/**
 * Given a focusable element, find the next tabbable element.
 *
 * @param {Element} element The focusable element after which to look. Defaults
 *                          to the active element.
 */

function findNext(element) {
  const focusables = find(element.ownerDocument.body);
  const index = focusables.indexOf(element); // Remove all focusables before and including `element`.

  const remaining = focusables.slice(index + 1);
  return (0,lodash.first)(filterTabbable(remaining));
}
//# sourceMappingURL=tabbable.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/dom/build-module/index.js
/**
 * Internal dependencies
 */


/**
 * Object grouping `focusable` and `tabbable` utils
 * under the keys with the same name.
 */

const build_module_focus = {
  focusable: focusable_namespaceObject,
  tabbable: tabbable_namespaceObject
};



//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-ref-effect/index.js
/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */

/**
 * Effect-like ref callback. Just like with `useEffect`, this allows you to
 * return a cleanup function to be run if the ref changes or one of the
 * dependencies changes. The ref is provided as an argument to the callback
 * functions. The main difference between this and `useEffect` is that
 * the `useEffect` callback is not called when the ref changes, but this is.
 * Pass the returned ref callback as the component's ref and merge multiple refs
 * with `useMergeRefs`.
 *
 * It's worth noting that if the dependencies array is empty, there's not
 * strictly a need to clean up event handlers for example, because the node is
 * to be removed. It *is* necessary if you add dependencies because the ref
 * callback will be called multiple times for the same node.
 *
 * @param  callback     Callback with ref as argument.
 * @param  dependencies Dependencies of the callback.
 *
 * @return Ref callback.
 */

function useRefEffect(callback, dependencies) {
  const cleanup = (0,react.useRef)();
  return (0,react.useCallback)(node => {
    if (node) {
      cleanup.current = callback(node);
    } else if (cleanup.current) {
      cleanup.current();
    }
  }, dependencies);
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-constrained-tabbing/index.js
/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */


/**
 * In Dialogs/modals, the tabbing must be constrained to the content of
 * the wrapper element. This hook adds the behavior to the returned ref.
 *
 * @return {import('react').RefCallback<Element>} Element Ref.
 *
 * @example
 * ```js
 * import { useConstrainedTabbing } from '@wordpress/compose';
 *
 * const ConstrainedTabbingExample = () => {
 *     const constrainedTabbingRef = useConstrainedTabbing()
 *     return (
 *         <div ref={ constrainedTabbingRef }>
 *             <Button />
 *             <Button />
 *         </div>
 *     );
 * }
 * ```
 */

function useConstrainedTabbing() {
  return useRefEffect((
  /** @type {HTMLElement} */
  node) => {
    /** @type {number|undefined} */
    let timeoutId;

    function onKeyDown(
    /** @type {KeyboardEvent} */
    event) {
      const {
        keyCode,
        shiftKey,
        target
      } = event;

      if (keyCode !== TAB) {
        return;
      }

      const action = shiftKey ? 'findPrevious' : 'findNext';
      const nextElement = build_module_focus.tabbable[action](
      /** @type {HTMLElement} */
      target) || null; // If the element that is about to receive focus is outside the
      // area, move focus to a div and insert it at the start or end of
      // the area, depending on the direction. Without preventing default
      // behaviour, the browser will then move focus to the next element.

      if (node.contains(nextElement)) {
        return;
      }

      const domAction = shiftKey ? 'append' : 'prepend';
      const {
        ownerDocument
      } = node;
      const trap = ownerDocument.createElement('div');
      trap.tabIndex = -1;
      node[domAction](trap);
      trap.focus(); // Remove after the browser moves focus to the next element.

      timeoutId = setTimeout(() => node.removeChild(trap));
    }

    node.addEventListener('keydown', onKeyDown);
    return () => {
      node.removeEventListener('keydown', onKeyDown);
      clearTimeout(timeoutId);
    };
  }, []);
}

/* harmony default export */ const use_constrained_tabbing = (useConstrainedTabbing);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-focus-on-mount/index.js
/**
 * WordPress dependencies
 */


/**
 * Hook used to focus the first tabbable element on mount.
 *
 * @param {boolean | 'firstElement'} focusOnMount Focus on mount mode.
 * @return {import('react').RefCallback<HTMLElement>} Ref callback.
 *
 * @example
 * ```js
 * import { useFocusOnMount } from '@wordpress/compose';
 *
 * const WithFocusOnMount = () => {
 *     const ref = useFocusOnMount()
 *     return (
 *         <div ref={ ref }>
 *             <Button />
 *             <Button />
 *         </div>
 *     );
 * }
 * ```
 */

function useFocusOnMount() {
  let focusOnMount = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'firstElement';
  const focusOnMountRef = (0,react.useRef)(focusOnMount);
  (0,react.useEffect)(() => {
    focusOnMountRef.current = focusOnMount;
  }, [focusOnMount]);
  return (0,react.useCallback)(node => {
    var _node$ownerDocument$a, _node$ownerDocument;

    if (!node || focusOnMountRef.current === false) {
      return;
    }

    if (node.contains((_node$ownerDocument$a = (_node$ownerDocument = node.ownerDocument) === null || _node$ownerDocument === void 0 ? void 0 : _node$ownerDocument.activeElement) !== null && _node$ownerDocument$a !== void 0 ? _node$ownerDocument$a : null)) {
      return;
    }

    let target = node;

    if (focusOnMountRef.current === 'firstElement') {
      const firstTabbable = build_module_focus.tabbable.find(node)[0];

      if (firstTabbable) {
        target =
        /** @type {HTMLElement} */
        firstTabbable;
      }
    }

    target.focus({
      // When focusing newly mounted dialogs,
      // the position of the popover is often not right on the first render
      // This prevents the layout shifts when focusing the dialogs.
      preventScroll: true
    });
  }, []);
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-focus-return/index.js
/**
 * WordPress dependencies
 */

/**
 * When opening modals/sidebars/dialogs, the focus
 * must move to the opened area and return to the
 * previously focused element when closed.
 * The current hook implements the returning behavior.
 *
 * @param {() => void} [onFocusReturn] Overrides the default return behavior.
 * @return {import('react').RefCallback<HTMLElement>} Element Ref.
 *
 * @example
 * ```js
 * import { useFocusReturn } from '@wordpress/compose';
 *
 * const WithFocusReturn = () => {
 *     const ref = useFocusReturn()
 *     return (
 *         <div ref={ ref }>
 *             <Button />
 *             <Button />
 *         </div>
 *     );
 * }
 * ```
 */

function useFocusReturn(onFocusReturn) {
  /** @type {import('react').MutableRefObject<null | HTMLElement>} */
  const ref = (0,react.useRef)(null);
  /** @type {import('react').MutableRefObject<null | Element>} */

  const focusedBeforeMount = (0,react.useRef)(null);
  const onFocusReturnRef = (0,react.useRef)(onFocusReturn);
  (0,react.useEffect)(() => {
    onFocusReturnRef.current = onFocusReturn;
  }, [onFocusReturn]);
  return (0,react.useCallback)(node => {
    if (node) {
      // Set ref to be used when unmounting.
      ref.current = node; // Only set when the node mounts.

      if (focusedBeforeMount.current) {
        return;
      }

      focusedBeforeMount.current = node.ownerDocument.activeElement;
    } else if (focusedBeforeMount.current) {
      var _ref$current, _ref$current2, _ref$current3;

      const isFocused = (_ref$current = ref.current) === null || _ref$current === void 0 ? void 0 : _ref$current.contains((_ref$current2 = ref.current) === null || _ref$current2 === void 0 ? void 0 : _ref$current2.ownerDocument.activeElement);

      if ((_ref$current3 = ref.current) !== null && _ref$current3 !== void 0 && _ref$current3.isConnected && !isFocused) {
        return;
      } // Defer to the component's own explicit focus return behavior, if
      // specified. This allows for support that the `onFocusReturn`
      // decides to allow the default behavior to occur under some
      // conditions.


      if (onFocusReturnRef.current) {
        onFocusReturnRef.current();
      } else {
        var _focusedBeforeMount$c;

        /** @type {null | HTMLElement} */
        (_focusedBeforeMount$c = focusedBeforeMount.current) === null || _focusedBeforeMount$c === void 0 ? void 0 : _focusedBeforeMount$c.focus();
      }
    }
  }, []);
}

/* harmony default export */ const use_focus_return = (useFocusReturn);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-focus-outside/index.js
/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Input types which are classified as button types, for use in considering
 * whether element is a (focus-normalized) button.
 *
 * @type {string[]}
 */

const INPUT_BUTTON_TYPES = ['button', 'submit'];
/**
 * @typedef {HTMLButtonElement | HTMLLinkElement | HTMLInputElement} FocusNormalizedButton
 */
// Disable reason: Rule doesn't support predicate return types.

/* eslint-disable jsdoc/valid-types */

/**
 * Returns true if the given element is a button element subject to focus
 * normalization, or false otherwise.
 *
 * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#Clicking_and_focus
 *
 * @param {EventTarget} eventTarget The target from a mouse or touch event.
 *
 * @return {eventTarget is FocusNormalizedButton} Whether element is a button.
 */

function isFocusNormalizedButton(eventTarget) {
  if (!(eventTarget instanceof window.HTMLElement)) {
    return false;
  }

  switch (eventTarget.nodeName) {
    case 'A':
    case 'BUTTON':
      return true;

    case 'INPUT':
      return (0,lodash.includes)(INPUT_BUTTON_TYPES,
      /** @type {HTMLInputElement} */
      eventTarget.type);
  }

  return false;
}
/* eslint-enable jsdoc/valid-types */

/**
 * @typedef {import('react').SyntheticEvent} SyntheticEvent
 */

/**
 * @callback EventCallback
 * @param {SyntheticEvent} event input related event.
 */

/**
 * @typedef FocusOutsideReactElement
 * @property {EventCallback} handleFocusOutside callback for a focus outside event.
 */

/**
 * @typedef {import('react').MutableRefObject<FocusOutsideReactElement | undefined>} FocusOutsideRef
 */

/**
 * @typedef {Object} FocusOutsideReturnValue
 * @property {EventCallback} onFocus      An event handler for focus events.
 * @property {EventCallback} onBlur       An event handler for blur events.
 * @property {EventCallback} onMouseDown  An event handler for mouse down events.
 * @property {EventCallback} onMouseUp    An event handler for mouse up events.
 * @property {EventCallback} onTouchStart An event handler for touch start events.
 * @property {EventCallback} onTouchEnd   An event handler for touch end events.
 */

/**
 * A react hook that can be used to check whether focus has moved outside the
 * element the event handlers are bound to.
 *
 * @param {EventCallback} onFocusOutside A callback triggered when focus moves outside
 *                                       the element the event handlers are bound to.
 *
 * @return {FocusOutsideReturnValue} An object containing event handlers. Bind the event handlers
 *                                   to a wrapping element element to capture when focus moves
 *                                   outside that element.
 */


function useFocusOutside(onFocusOutside) {
  const currentOnFocusOutside = (0,react.useRef)(onFocusOutside);
  (0,react.useEffect)(() => {
    currentOnFocusOutside.current = onFocusOutside;
  }, [onFocusOutside]);
  const preventBlurCheck = (0,react.useRef)(false);
  /**
   * @type {import('react').MutableRefObject<number | undefined>}
   */

  const blurCheckTimeoutId = (0,react.useRef)();
  /**
   * Cancel a blur check timeout.
   */

  const cancelBlurCheck = (0,react.useCallback)(() => {
    clearTimeout(blurCheckTimeoutId.current);
  }, []); // Cancel blur checks on unmount.

  (0,react.useEffect)(() => {
    return () => cancelBlurCheck();
  }, []); // Cancel a blur check if the callback or ref is no longer provided.

  (0,react.useEffect)(() => {
    if (!onFocusOutside) {
      cancelBlurCheck();
    }
  }, [onFocusOutside, cancelBlurCheck]);
  /**
   * Handles a mousedown or mouseup event to respectively assign and
   * unassign a flag for preventing blur check on button elements. Some
   * browsers, namely Firefox and Safari, do not emit a focus event on
   * button elements when clicked, while others do. The logic here
   * intends to normalize this as treating click on buttons as focus.
   *
   * @see https://developer.mozilla.org/en-US/docs/Web/HTML/Element/button#Clicking_and_focus
   *
   * @param {SyntheticEvent} event Event for mousedown or mouseup.
   */

  const normalizeButtonFocus = (0,react.useCallback)(event => {
    const {
      type,
      target
    } = event;
    const isInteractionEnd = (0,lodash.includes)(['mouseup', 'touchend'], type);

    if (isInteractionEnd) {
      preventBlurCheck.current = false;
    } else if (isFocusNormalizedButton(target)) {
      preventBlurCheck.current = true;
    }
  }, []);
  /**
   * A callback triggered when a blur event occurs on the element the handler
   * is bound to.
   *
   * Calls the `onFocusOutside` callback in an immediate timeout if focus has
   * move outside the bound element and is still within the document.
   *
   * @param {SyntheticEvent} event Blur event.
   */

  const queueBlurCheck = (0,react.useCallback)(event => {
    // React does not allow using an event reference asynchronously
    // due to recycling behavior, except when explicitly persisted.
    event.persist(); // Skip blur check if clicking button. See `normalizeButtonFocus`.

    if (preventBlurCheck.current) {
      return;
    }

    blurCheckTimeoutId.current = setTimeout(() => {
      // If document is not focused then focus should remain
      // inside the wrapped component and therefore we cancel
      // this blur event thereby leaving focus in place.
      // https://developer.mozilla.org/en-US/docs/Web/API/Document/hasFocus.
      if (!document.hasFocus()) {
        event.preventDefault();
        return;
      }

      if ('function' === typeof currentOnFocusOutside.current) {
        currentOnFocusOutside.current(event);
      }
    }, 0);
  }, []);
  return {
    onFocus: cancelBlurCheck,
    onMouseDown: normalizeButtonFocus,
    onMouseUp: normalizeButtonFocus,
    onTouchStart: normalizeButtonFocus,
    onTouchEnd: normalizeButtonFocus,
    onBlur: queueBlurCheck
  };
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-merge-refs/index.js
/**
 * WordPress dependencies
 */

/* eslint-disable jsdoc/valid-types */

/**
 * @template T
 * @typedef {T extends import('react').Ref<infer R> ? R : never} TypeFromRef
 */

/* eslint-enable jsdoc/valid-types */

/**
 * @template T
 * @param {import('react').Ref<T>} ref
 * @param {T}                      value
 */

function assignRef(ref, value) {
  if (typeof ref === 'function') {
    ref(value);
  } else if (ref && ref.hasOwnProperty('current')) {
    /* eslint-disable jsdoc/no-undefined-types */

    /** @type {import('react').MutableRefObject<T>} */
    ref.current = value;
    /* eslint-enable jsdoc/no-undefined-types */
  }
}
/**
 * Merges refs into one ref callback.
 *
 * It also ensures that the merged ref callbacks are only called when they
 * change (as a result of a `useCallback` dependency update) OR when the ref
 * value changes, just as React does when passing a single ref callback to the
 * component.
 *
 * As expected, if you pass a new function on every render, the ref callback
 * will be called after every render.
 *
 * If you don't wish a ref callback to be called after every render, wrap it
 * with `useCallback( callback, dependencies )`. When a dependency changes, the
 * old ref callback will be called with `null` and the new ref callback will be
 * called with the same value.
 *
 * To make ref callbacks easier to use, you can also pass the result of
 * `useRefEffect`, which makes cleanup easier by allowing you to return a
 * cleanup function instead of handling `null`.
 *
 * It's also possible to _disable_ a ref (and its behaviour) by simply not
 * passing the ref.
 *
 * ```jsx
 * const ref = useRefEffect( ( node ) => {
 *   node.addEventListener( ... );
 *   return () => {
 *     node.removeEventListener( ... );
 *   };
 * }, [ ...dependencies ] );
 * const otherRef = useRef();
 * const mergedRefs useMergeRefs( [
 *   enabled && ref,
 *   otherRef,
 * ] );
 * return <div ref={ mergedRefs } />;
 * ```
 *
 * @template {import('react').Ref<any>} TRef
 * @param {Array<TRef>} refs The refs to be merged.
 *
 * @return {import('react').RefCallback<TypeFromRef<TRef>>} The merged ref callback.
 */


function useMergeRefs(refs) {
  const element = (0,react.useRef)();
  const didElementChange = (0,react.useRef)(false);
  /* eslint-disable jsdoc/no-undefined-types */

  /** @type {import('react').MutableRefObject<TRef[]>} */

  /* eslint-enable jsdoc/no-undefined-types */

  const previousRefs = (0,react.useRef)([]);
  const currentRefs = (0,react.useRef)(refs); // Update on render before the ref callback is called, so the ref callback
  // always has access to the current refs.

  currentRefs.current = refs; // If any of the refs change, call the previous ref with `null` and the new
  // ref with the node, except when the element changes in the same cycle, in
  // which case the ref callbacks will already have been called.

  (0,react.useLayoutEffect)(() => {
    if (didElementChange.current === false) {
      refs.forEach((ref, index) => {
        const previousRef = previousRefs.current[index];

        if (ref !== previousRef) {
          assignRef(previousRef, null);
          assignRef(ref, element.current);
        }
      });
    }

    previousRefs.current = refs;
  }, refs); // No dependencies, must be reset after every render so ref callbacks are
  // correctly called after a ref change.

  (0,react.useLayoutEffect)(() => {
    didElementChange.current = false;
  }); // There should be no dependencies so that `callback` is only called when
  // the node changes.

  return (0,react.useCallback)(value => {
    // Update the element so it can be used when calling ref callbacks on a
    // dependency change.
    assignRef(element, value);
    didElementChange.current = true; // When an element changes, the current ref callback should be called
    // with the new element and the previous one with `null`.

    const refsToAssign = value ? currentRefs.current : previousRefs.current; // Update the latest refs.

    for (const ref of refsToAssign) {
      assignRef(ref, value);
    }
  }, []);
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-dialog/index.js
/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */






/* eslint-disable jsdoc/valid-types */

/**
 * @typedef DialogOptions
 * @property {Parameters<useFocusOnMount>[0]} focusOnMount Focus on mount arguments.
 * @property {() => void}                     onClose      Function to call when the dialog is closed.
 */

/* eslint-enable jsdoc/valid-types */

/**
 * Returns a ref and props to apply to a dialog wrapper to enable the following behaviors:
 *  - constrained tabbing.
 *  - focus on mount.
 *  - return focus on unmount.
 *  - focus outside.
 *
 * @param {DialogOptions} options Dialog Options.
 */

function useDialog(options) {
  /**
   * @type {import('react').MutableRefObject<DialogOptions | undefined>}
   */
  const currentOptions = (0,react.useRef)();
  (0,react.useEffect)(() => {
    currentOptions.current = options;
  }, Object.values(options));
  const constrainedTabbingRef = use_constrained_tabbing();
  const focusOnMountRef = useFocusOnMount(options.focusOnMount);
  const focusReturnRef = use_focus_return();
  const focusOutsideProps = useFocusOutside(event => {
    var _currentOptions$curre, _currentOptions$curre2;

    // This unstable prop  is here only to manage backward compatibility
    // for the Popover component otherwise, the onClose should be enough.
    // @ts-ignore unstable property
    if ((_currentOptions$curre = currentOptions.current) !== null && _currentOptions$curre !== void 0 && _currentOptions$curre.__unstableOnClose) {
      // @ts-ignore unstable property
      currentOptions.current.__unstableOnClose('focus-outside', event);
    } else if ((_currentOptions$curre2 = currentOptions.current) !== null && _currentOptions$curre2 !== void 0 && _currentOptions$curre2.onClose) {
      currentOptions.current.onClose();
    }
  });
  const closeOnEscapeRef = (0,react.useCallback)(node => {
    if (!node) {
      return;
    }

    node.addEventListener('keydown', (
    /** @type {KeyboardEvent} */
    event) => {
      var _currentOptions$curre3;

      // Close on escape.
      if (event.keyCode === ESCAPE && !event.defaultPrevented && (_currentOptions$curre3 = currentOptions.current) !== null && _currentOptions$curre3 !== void 0 && _currentOptions$curre3.onClose) {
        event.preventDefault();
        currentOptions.current.onClose();
      }
    });
  }, []);
  return [useMergeRefs([options.focusOnMount !== false ? constrainedTabbingRef : null, options.focusOnMount !== false ? focusReturnRef : null, options.focusOnMount !== false ? focusOnMountRef : null, closeOnEscapeRef]), { ...focusOutsideProps,
    tabIndex: '-1'
  }];
}

/* harmony default export */ const use_dialog = (useDialog);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/primitives/build-module/svg/index.js
/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/** @typedef {{isPressed?: boolean} & import('react').ComponentPropsWithoutRef<'svg'>} SVGProps */

/**
 * @param {import('react').ComponentPropsWithoutRef<'circle'>} props
 *
 * @return {JSX.Element} Circle component
 */

const Circle = props => createElement('circle', props);
/**
 * @param {import('react').ComponentPropsWithoutRef<'g'>} props
 *
 * @return {JSX.Element} G component
 */

const G = props => createElement('g', props);
/**
 * @param {import('react').ComponentPropsWithoutRef<'path'>} props
 *
 * @return {JSX.Element} Path component
 */

const Path = props => (0,react.createElement)('path', props);
/**
 * @param {import('react').ComponentPropsWithoutRef<'polygon'>} props
 *
 * @return {JSX.Element} Polygon component
 */

const Polygon = props => createElement('polygon', props);
/**
 * @param {import('react').ComponentPropsWithoutRef<'rect'>} props
 *
 * @return {JSX.Element} Rect component
 */

const Rect = props => createElement('rect', props);
/**
 * @param {import('react').ComponentPropsWithoutRef<'defs'>} props
 *
 * @return {JSX.Element} Defs component
 */

const Defs = props => createElement('defs', props);
/**
 * @param {import('react').ComponentPropsWithoutRef<'radialGradient'>} props
 *
 * @return {JSX.Element} RadialGradient component
 */

const RadialGradient = props => createElement('radialGradient', props);
/**
 * @param {import('react').ComponentPropsWithoutRef<'linearGradient'>} props
 *
 * @return {JSX.Element} LinearGradient component
 */

const LinearGradient = props => createElement('linearGradient', props);
/**
 * @param {import('react').ComponentPropsWithoutRef<'stop'>} props
 *
 * @return {JSX.Element} Stop component
 */

const Stop = props => createElement('stop', props);
/**
 *
 * @param {SVGProps} props isPressed indicates whether the SVG should appear as pressed.
 *                         Other props will be passed through to svg component.
 *
 * @return {JSX.Element} Stop component
 */

const SVG = _ref => {
  let {
    className,
    isPressed,
    ...props
  } = _ref;
  const appliedProps = { ...props,
    className: classnames_default()(className, {
      'is-pressed': isPressed
    }) || undefined,
    'aria-hidden': true,
    focusable: false
  }; // Disable reason: We need to have a way to render HTML tag for web.
  // eslint-disable-next-line react/forbid-elements

  return (0,react.createElement)("svg", appliedProps);
};
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/icons/build-module/library/close.js


/**
 * WordPress dependencies
 */

const close_close = (0,react.createElement)(SVG, {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 24 24"
}, (0,react.createElement)(Path, {
  d: "M13 11.8l6.1-6.3-1-1-6.1 6.2-6.1-6.2-1 1 6.1 6.3-6.5 6.7 1 1 6.5-6.6 6.5 6.6 1-1z"
}));
/* harmony default export */ const library_close = (close_close);
//# sourceMappingURL=close.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/scroll-lock/index.js
/**
 * WordPress dependencies
 */

/*
 * Setting `overflow: hidden` on html and body elements resets body scroll in iOS.
 * Save scroll top so we can restore it after locking scroll.
 *
 * NOTE: It would be cleaner and possibly safer to find a localized solution such
 * as preventing default on certain touchmove events.
 */

let previousScrollTop = 0;
/**
 * @param {boolean} locked
 */

function setLocked(locked) {
  const scrollingElement = document.scrollingElement || document.body;

  if (locked) {
    previousScrollTop = scrollingElement.scrollTop;
  }

  const methodName = locked ? 'add' : 'remove';
  scrollingElement.classList[methodName]('lockscroll'); // Adding the class to the document element seems to be necessary in iOS.

  document.documentElement.classList[methodName]('lockscroll');

  if (!locked) {
    scrollingElement.scrollTop = previousScrollTop;
  }
}

let lockCounter = 0;
/**
 * A component that will lock scrolling when it is mounted and unlock scrolling when it is unmounted.
 *
 * @return {null} Render nothing.
 */

function ScrollLock() {
  (0,react.useEffect)(() => {
    if (lockCounter === 0) {
      setLocked(true);
    }

    ++lockCounter;
    return () => {
      if (lockCounter === 1) {
        setLocked(false);
      }

      --lockCounter;
    };
  }, []);
  return null;
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/context.js
// @ts-nocheck

/**
 * WordPress dependencies
 */

const SlotFillContext = (0,react.createContext)({
  registerSlot: () => {},
  unregisterSlot: () => {},
  registerFill: () => {},
  unregisterFill: () => {},
  getSlot: () => {},
  getFills: () => {},
  subscribe: () => {}
});
/* harmony default export */ const context = (SlotFillContext);
//# sourceMappingURL=context.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/use-slot.js
// @ts-nocheck

/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */


/**
 * React hook returning the active slot given a name.
 *
 * @param {string} name Slot name.
 * @return {Object} Slot object.
 */

const useSlot = name => {
  const {
    getSlot,
    subscribe
  } = (0,react.useContext)(context);
  const [slot, setSlot] = (0,react.useState)(getSlot(name));
  (0,react.useEffect)(() => {
    setSlot(getSlot(name));
    const unsubscribe = subscribe(() => {
      setSlot(getSlot(name));
    });
    return unsubscribe;
  }, [name]);
  return slot;
};

/* harmony default export */ const use_slot = (useSlot);
//# sourceMappingURL=use-slot.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/fill.js


// @ts-nocheck

/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */




function FillComponent(_ref) {
  let {
    name,
    children,
    registerFill,
    unregisterFill
  } = _ref;
  const slot = use_slot(name);
  const ref = (0,react.useRef)({
    name,
    children
  });
  (0,react.useLayoutEffect)(() => {
    registerFill(name, ref.current);
    return () => unregisterFill(name, ref.current);
  }, []);
  (0,react.useLayoutEffect)(() => {
    ref.current.children = children;

    if (slot) {
      slot.forceUpdate();
    }
  }, [children]);
  (0,react.useLayoutEffect)(() => {
    if (name === ref.current.name) {
      // Ignore initial effect.
      return;
    }

    unregisterFill(ref.current.name, ref.current);
    ref.current.name = name;
    registerFill(name, ref.current);
  }, [name]);

  if (!slot || !slot.node) {
    return null;
  } // If a function is passed as a child, provide it with the fillProps.


  if (typeof children === 'function') {
    children = children(slot.props.fillProps);
  }

  return (0,react_dom.createPortal)(children, slot.node);
}

const Fill = props => (0,react.createElement)(context.Consumer, null, _ref2 => {
  let {
    registerFill,
    unregisterFill
  } = _ref2;
  return (0,react.createElement)(FillComponent, extends_extends({}, props, {
    registerFill: registerFill,
    unregisterFill: unregisterFill
  }));
});

/* harmony default export */ const fill = (Fill);
//# sourceMappingURL=fill.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/element/build-module/utils.js
/**
 * External dependencies
 */

/**
 * Checks if the provided WP element is empty.
 *
 * @param {*} element WP element to check.
 * @return {boolean} True when an element is considered empty.
 */

const isEmptyElement = element => {
  if ((0,lodash.isNumber)(element)) {
    return false;
  }

  if ((0,lodash.isString)(element) || Array.isArray(element)) {
    return !element.length;
  }

  return !element;
};
//# sourceMappingURL=utils.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/slot.js


// @ts-nocheck

/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */


/**
 * Whether the argument is a function.
 *
 * @param {*} maybeFunc The argument to check.
 * @return {boolean} True if the argument is a function, false otherwise.
 */

function isFunction(maybeFunc) {
  return typeof maybeFunc === 'function';
}

class SlotComponent extends react.Component {
  constructor() {
    super(...arguments);
    this.isUnmounted = false;
    this.bindNode = this.bindNode.bind(this);
  }

  componentDidMount() {
    const {
      registerSlot
    } = this.props;
    registerSlot(this.props.name, this);
  }

  componentWillUnmount() {
    const {
      unregisterSlot
    } = this.props;
    this.isUnmounted = true;
    unregisterSlot(this.props.name, this);
  }

  componentDidUpdate(prevProps) {
    const {
      name,
      unregisterSlot,
      registerSlot
    } = this.props;

    if (prevProps.name !== name) {
      unregisterSlot(prevProps.name);
      registerSlot(name, this);
    }
  }

  bindNode(node) {
    this.node = node;
  }

  forceUpdate() {
    if (this.isUnmounted) {
      return;
    }

    super.forceUpdate();
  }

  render() {
    const {
      children,
      name,
      fillProps = {},
      getFills
    } = this.props;
    const fills = (0,lodash.map)(getFills(name, this), fill => {
      const fillChildren = isFunction(fill.children) ? fill.children(fillProps) : fill.children;
      return react.Children.map(fillChildren, (child, childIndex) => {
        if (!child || (0,lodash.isString)(child)) {
          return child;
        }

        const childKey = child.key || childIndex;
        return (0,react.cloneElement)(child, {
          key: childKey
        });
      });
    }).filter( // In some cases fills are rendered only when some conditions apply.
    // This ensures that we only use non-empty fills when rendering, i.e.,
    // it allows us to render wrappers only when the fills are actually present.
    element => !isEmptyElement(element));
    return (0,react.createElement)(react.Fragment, null, isFunction(children) ? children(fills) : fills);
  }

}

const Slot = props => (0,react.createElement)(context.Consumer, null, _ref => {
  let {
    registerSlot,
    unregisterSlot,
    getFills
  } = _ref;
  return (0,react.createElement)(SlotComponent, extends_extends({}, props, {
    registerSlot: registerSlot,
    unregisterSlot: unregisterSlot,
    getFills: getFills
  }));
});

/* harmony default export */ const slot = (Slot);
//# sourceMappingURL=slot.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/bubbles-virtually/slot-fill-context.js
// @ts-nocheck

/**
 * WordPress dependencies
 */


const slot_fill_context_SlotFillContext = (0,react.createContext)({
  slots: {},
  fills: {},
  registerSlot: () => {
    typeof process !== "undefined" && process.env && "production" !== "production" ? 0 : void 0;
  },
  updateSlot: () => {},
  unregisterSlot: () => {},
  registerFill: () => {},
  unregisterFill: () => {}
});
/* harmony default export */ const slot_fill_context = (slot_fill_context_SlotFillContext);
//# sourceMappingURL=slot-fill-context.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/bubbles-virtually/use-slot.js
// @ts-nocheck

/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */


function use_slot_useSlot(name) {
  const registry = (0,react.useContext)(slot_fill_context);
  const slot = registry.slots[name] || {};
  const slotFills = registry.fills[name];
  const fills = (0,react.useMemo)(() => slotFills || [], [slotFills]);
  const updateSlot = (0,react.useCallback)(fillProps => {
    registry.updateSlot(name, fillProps);
  }, [name, registry.updateSlot]);
  const unregisterSlot = (0,react.useCallback)(slotRef => {
    registry.unregisterSlot(name, slotRef);
  }, [name, registry.unregisterSlot]);
  const registerFill = (0,react.useCallback)(fillRef => {
    registry.registerFill(name, fillRef);
  }, [name, registry.registerFill]);
  const unregisterFill = (0,react.useCallback)(fillRef => {
    registry.unregisterFill(name, fillRef);
  }, [name, registry.unregisterFill]);
  return { ...slot,
    updateSlot,
    unregisterSlot,
    fills,
    registerFill,
    unregisterFill
  };
}
//# sourceMappingURL=use-slot.js.map
;// CONCATENATED MODULE: ./node_modules/uuid/dist/esm-browser/rng.js
// Unique ID creation requires a high quality random # generator. In the browser we therefore
// require the crypto API and do not support built-in fallback to lower quality random number
// generators (like Math.random()).
var getRandomValues;
var rnds8 = new Uint8Array(16);
function rng() {
  // lazy load so that environments that need to polyfill have a chance to do so
  if (!getRandomValues) {
    // getRandomValues needs to be invoked in a context where "this" is a Crypto implementation. Also,
    // find the complete implementation of crypto (msCrypto) on IE11.
    getRandomValues = typeof crypto !== 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto) || typeof msCrypto !== 'undefined' && typeof msCrypto.getRandomValues === 'function' && msCrypto.getRandomValues.bind(msCrypto);

    if (!getRandomValues) {
      throw new Error('crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported');
    }
  }

  return getRandomValues(rnds8);
}
;// CONCATENATED MODULE: ./node_modules/uuid/dist/esm-browser/regex.js
/* harmony default export */ const regex = (/^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i);
;// CONCATENATED MODULE: ./node_modules/uuid/dist/esm-browser/validate.js


function validate(uuid) {
  return typeof uuid === 'string' && regex.test(uuid);
}

/* harmony default export */ const esm_browser_validate = (validate);
;// CONCATENATED MODULE: ./node_modules/uuid/dist/esm-browser/stringify.js

/**
 * Convert array of 16 byte values to UUID string format of the form:
 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
 */

var byteToHex = [];

for (var stringify_i = 0; stringify_i < 256; ++stringify_i) {
  byteToHex.push((stringify_i + 0x100).toString(16).substr(1));
}

function stringify_stringify(arr) {
  var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  // Note: Be careful editing this code!  It's been tuned for performance
  // and works in ways you may not expect. See https://github.com/uuidjs/uuid/pull/434
  var uuid = (byteToHex[arr[offset + 0]] + byteToHex[arr[offset + 1]] + byteToHex[arr[offset + 2]] + byteToHex[arr[offset + 3]] + '-' + byteToHex[arr[offset + 4]] + byteToHex[arr[offset + 5]] + '-' + byteToHex[arr[offset + 6]] + byteToHex[arr[offset + 7]] + '-' + byteToHex[arr[offset + 8]] + byteToHex[arr[offset + 9]] + '-' + byteToHex[arr[offset + 10]] + byteToHex[arr[offset + 11]] + byteToHex[arr[offset + 12]] + byteToHex[arr[offset + 13]] + byteToHex[arr[offset + 14]] + byteToHex[arr[offset + 15]]).toLowerCase(); // Consistency check for valid UUID.  If this throws, it's likely due to one
  // of the following:
  // - One or more input array values don't map to a hex octet (leading to
  // "undefined" in the uuid)
  // - Invalid input values for the RFC `version` or `variant` fields

  if (!esm_browser_validate(uuid)) {
    throw TypeError('Stringified UUID is invalid');
  }

  return uuid;
}

/* harmony default export */ const esm_browser_stringify = (stringify_stringify);
;// CONCATENATED MODULE: ./node_modules/uuid/dist/esm-browser/v4.js



function v4(options, buf, offset) {
  options = options || {};
  var rnds = options.random || (options.rng || rng)(); // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`

  rnds[6] = rnds[6] & 0x0f | 0x40;
  rnds[8] = rnds[8] & 0x3f | 0x80; // Copy bytes to buffer, if provided

  if (buf) {
    offset = offset || 0;

    for (var i = 0; i < 16; ++i) {
      buf[offset + i] = rnds[i];
    }

    return buf;
  }

  return esm_browser_stringify(rnds);
}

/* harmony default export */ const esm_browser_v4 = (v4);
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/style-provider/index.js

// @ts-nocheck

/**
 * External dependencies
 */




const uuidCache = new Set();
const memoizedCreateCacheWithContainer = memize_default()(container => {
  // Emotion only accepts alphabetical and hyphenated keys so we just strip the numbers from the UUID. It _should_ be fine.
  let key = esm_browser_v4().replace(/[0-9]/g, '');

  while (uuidCache.has(key)) {
    key = esm_browser_v4().replace(/[0-9]/g, '');
  }

  uuidCache.add(key);
  return emotion_cache_browser_esm({
    container,
    key
  });
});
function StyleProvider(_ref) {
  let {
    children,
    document
  } = _ref;

  if (!document) {
    return null;
  }

  const cache = memoizedCreateCacheWithContainer(document.head);
  return (0,react.createElement)(CacheProvider, {
    value: cache
  }, children);
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/bubbles-virtually/fill.js

// @ts-nocheck

/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */




function useForceUpdate() {
  const [, setState] = (0,react.useState)({});
  const mounted = (0,react.useRef)(true);
  (0,react.useEffect)(() => {
    return () => {
      mounted.current = false;
    };
  }, []);
  return () => {
    if (mounted.current) {
      setState({});
    }
  };
}

function fill_Fill(_ref) {
  let {
    name,
    children
  } = _ref;
  const slot = use_slot_useSlot(name);
  const ref = (0,react.useRef)({
    rerender: useForceUpdate()
  });
  (0,react.useEffect)(() => {
    // We register fills so we can keep track of their existance.
    // Some Slot implementations need to know if there're already fills
    // registered so they can choose to render themselves or not.
    slot.registerFill(ref);
    return () => {
      slot.unregisterFill(ref);
    };
  }, [slot.registerFill, slot.unregisterFill]);

  if (!slot.ref || !slot.ref.current) {
    return null;
  }

  if (typeof children === 'function') {
    children = children(slot.fillProps);
  } // When using a `Fill`, the `children` will be rendered in the document of the
  // `Slot`. This means that we need to wrap the `children` in a `StyleProvider`
  // to make sure we're referencing the right document/iframe (instead of the
  // context of the `Fill`'s parent).


  const wrappedChildren = (0,react.createElement)(StyleProvider, {
    document: slot.ref.current.ownerDocument
  }, children);
  return (0,react_dom.createPortal)(wrappedChildren, slot.ref.current);
}
//# sourceMappingURL=fill.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/bubbles-virtually/slot.js


// @ts-nocheck

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */



function slot_Slot(_ref, forwardedRef) {
  let {
    name,
    fillProps = {},
    as: Component = 'div',
    ...props
  } = _ref;
  const registry = (0,react.useContext)(slot_fill_context);
  const ref = (0,react.useRef)();
  (0,react.useLayoutEffect)(() => {
    registry.registerSlot(name, ref, fillProps);
    return () => {
      registry.unregisterSlot(name, ref);
    }; // We are not including fillProps in the deps because we don't want to
    // unregister and register the slot whenever fillProps change, which would
    // cause the fill to be re-mounted. We are only considering the initial value
    // of fillProps.
  }, [registry.registerSlot, registry.unregisterSlot, name]); // fillProps may be an update that interacts with the layout, so we
  // useLayoutEffect.

  (0,react.useLayoutEffect)(() => {
    registry.updateSlot(name, fillProps);
  });
  return (0,react.createElement)(Component, extends_extends({
    ref: useMergeRefs([forwardedRef, ref])
  }, props));
}

/* harmony default export */ const bubbles_virtually_slot = ((0,react.forwardRef)(slot_Slot));
//# sourceMappingURL=slot.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/slot-fill/index.js


// @ts-nocheck

/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */








function slot_fill_Fill(props) {
  // We're adding both Fills here so they can register themselves before
  // their respective slot has been registered. Only the Fill that has a slot
  // will render. The other one will return null.
  return (0,react.createElement)(react.Fragment, null, (0,react.createElement)(fill, props), (0,react.createElement)(fill_Fill, props));
}
const slot_fill_Slot = (0,react.forwardRef)((_ref, ref) => {
  let {
    bubblesVirtually,
    ...props
  } = _ref;

  if (bubblesVirtually) {
    return (0,react.createElement)(bubbles_virtually_slot, extends_extends({}, props, {
      ref: ref
    }));
  }

  return (0,react.createElement)(slot, props);
});
function Provider(_ref2) {
  let {
    children,
    ...props
  } = _ref2;
  return createElement(SlotFillProvider, props, createElement(BubblesVirtuallySlotFillProvider, null, children));
}
function createSlotFill(name) {
  const FillComponent = props => createElement(slot_fill_Fill, _extends({
    name: name
  }, props));

  FillComponent.displayName = name + 'Fill';

  const SlotComponent = props => createElement(slot_fill_Slot, _extends({
    name: name
  }, props));

  SlotComponent.displayName = name + 'Slot';
  SlotComponent.__unstableName = name;
  return {
    Fill: FillComponent,
    Slot: SlotComponent
  };
}

//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/animate/index.js
/**
 * External dependencies
 */

/**
 * @typedef {'top' | 'top left' | 'top right' | 'middle' | 'middle left' | 'middle right' | 'bottom' | 'bottom left' | 'bottom right'} AppearOrigin
 * @typedef {'left' | 'right'} SlideInOrigin
 * @typedef {{ type: 'appear'; origin?: AppearOrigin }} AppearOptions
 * @typedef {{ type: 'slide-in'; origin?: SlideInOrigin }} SlideInOptions
 * @typedef {{ type: 'loading' }} LoadingOptions
 * @typedef {AppearOptions | SlideInOptions | LoadingOptions} GetAnimateOptions
 */

/* eslint-disable jsdoc/valid-types */

/**
 * @param {GetAnimateOptions['type']} type The animation type
 * @return {'top' | 'left'} Default origin
 */

function getDefaultOrigin(type) {
  return type === 'appear' ? 'top' : 'left';
}
/* eslint-enable jsdoc/valid-types */

/**
 * @param {GetAnimateOptions} options
 *
 * @return {string | void} ClassName that applies the animations
 */


function getAnimateClassName(options) {
  if (options.type === 'loading') {
    return classnames_default()('components-animate__loading');
  }

  const {
    type,
    origin = getDefaultOrigin(type)
  } = options;

  if (type === 'appear') {
    const [yAxis, xAxis = 'center'] = origin.split(' ');
    return classnames_default()('components-animate__appear', {
      ['is-from-' + xAxis]: xAxis !== 'center',
      ['is-from-' + yAxis]: yAxis !== 'middle'
    });
  }

  if (type === 'slide-in') {
    return classnames_default()('components-animate__slide-in', 'is-from-' + origin);
  }
} // @ts-ignore Reason: Planned for deprecation

function Animate(_ref) {
  let {
    type,
    options = {},
    children
  } = _ref;
  return children({
    className: getAnimateClassName({
      type,
      ...options
    })
  });
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/popover/index.js


// @ts-nocheck

/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */





/**
 * Internal dependencies
 */





/**
 * Name of slot in which popover should fill.
 *
 * @type {string}
 */

const SLOT_NAME = 'Popover';
const slotNameContext = (0,react.createContext)();

const positionToPlacement = position => {
  const [x, y, z] = position.split(' ');

  if (['top', 'bottom'].includes(x)) {
    let suffix = '';

    if (!!z && z === 'left' || y === 'right') {
      suffix = '-start';
    } else if (!!z && z === 'right' || y === 'left') {
      suffix = '-end';
    }

    return x + suffix;
  }

  return y;
};

const placementToAnimationOrigin = placement => {
  const [a, b] = placement.split('-');
  let x, y;

  if (a === 'top' || a === 'bottom') {
    x = a === 'top' ? 'bottom' : 'top';
    y = 'middle';

    if (b === 'start') {
      y = 'left';
    } else if (b === 'end') {
      y = 'right';
    }
  }

  if (a === 'left' || a === 'right') {
    x = 'center';
    y = a === 'left' ? 'right' : 'left';

    if (b === 'start') {
      x = 'top';
    } else if (b === 'end') {
      x = 'bottom';
    }
  }

  return x + ' ' + y;
};

const Popover = (_ref, ref) => {
  let {
    range,
    animate = true,
    headerTitle,
    onClose,
    children,
    className,
    noArrow = true,
    isAlternate,
    position,
    placement = 'bottom-start',
    offset,
    focusOnMount = 'firstElement',
    anchorRef,
    anchorRect,
    getAnchorRect,
    expandOnMobile,
    onFocusOutside,
    __unstableSlotName = SLOT_NAME,
    __unstableObserveElement,
    __unstableForcePosition,
    __unstableShift = false,
    ...contentProps
  } = _ref;

  if (range) {
    deprecated('range prop in Popover component', {
      since: '6.1',
      version: '6.3'
    });
  }

  const arrowRef = (0,react.useRef)(null);
  const isMobileViewport = use_viewport_match('medium', '<');
  const isExpanded = expandOnMobile && isMobileViewport;
  const hasArrow = !isExpanded && !noArrow;
  const usedPlacement = position ? positionToPlacement(position) : placement;
  const ownerDocument = (0,react.useMemo)(() => {
    if (anchorRef !== null && anchorRef !== void 0 && anchorRef.top) {
      return anchorRef === null || anchorRef === void 0 ? void 0 : anchorRef.top.ownerDocument;
    } else if (anchorRef !== null && anchorRef !== void 0 && anchorRef.startContainer) {
      return anchorRef.startContainer.ownerDocument;
    } else if (anchorRef !== null && anchorRef !== void 0 && anchorRef.current) {
      return anchorRef.current.ownerDocument;
    } else if (anchorRef) {
      // This one should be deprecated.
      return anchorRef.ownerDocument;
    } else if (anchorRect && anchorRect !== null && anchorRect !== void 0 && anchorRect.ownerDocument) {
      return anchorRect.ownerDocument;
    } else if (getAnchorRect) {
      var _getAnchorRect$ownerD, _getAnchorRect;

      return (_getAnchorRect$ownerD = (_getAnchorRect = getAnchorRect()) === null || _getAnchorRect === void 0 ? void 0 : _getAnchorRect.ownerDocument) !== null && _getAnchorRect$ownerD !== void 0 ? _getAnchorRect$ownerD : document;
    }

    return document;
  }, [anchorRef, anchorRect, getAnchorRect]);
  /**
   * Offsets the the position of the popover when the anchor is inside an iframe.
   */

  const frameOffset = (0,react.useMemo)(() => {
    const {
      defaultView
    } = ownerDocument;
    const {
      frameElement
    } = defaultView;

    if (!frameElement || ownerDocument === document) {
      return undefined;
    }

    const iframeRect = frameElement.getBoundingClientRect();
    return {
      name: 'iframeOffset',

      fn(_ref2) {
        let {
          x,
          y
        } = _ref2;
        return {
          x: x + iframeRect.left,
          y: y + iframeRect.top
        };
      }

    };
  }, [ownerDocument]);
  const middlewares = [frameOffset, offset ? T(offset) : undefined, __unstableForcePosition ? undefined : floating_ui_core_esm_min_b(), __unstableForcePosition ? undefined : floating_ui_core_esm_min_k({
    apply(sizeProps) {
      const {
        height
      } = sizeProps;
      if (!refs.floating.current) return; // Reduce the height of the popover to the available space.

      Object.assign(refs.floating.current.firstChild.style, {
        maxHeight: `${height}px`,
        overflow: 'auto'
      });
    }

  }), __unstableShift ? D({
    crossAxis: true,
    limiter: L(),
    padding: 1 // Necessary to avoid flickering at the edge of the viewport.

  }) : undefined, hasArrow ? arrow({
    element: arrowRef
  }) : undefined].filter(m => !!m);
  const anchorRefFallback = (0,react.useRef)(null);

  const slotName = (0,react.useContext)(slotNameContext) || __unstableSlotName;

  const slot = use_slot_useSlot(slotName);

  const onDialogClose = (type, event) => {
    // Ideally the popover should have just a single onClose prop and
    // not three props that potentially do the same thing.
    if (type === 'focus-outside' && onFocusOutside) {
      onFocusOutside(event);
    } else if (onClose) {
      onClose();
    }
  };

  const [dialogRef, dialogProps] = use_dialog({
    focusOnMount,
    __unstableOnClose: onDialogClose,
    onClose: onDialogClose
  });
  const {
    x,
    y,
    reference,
    floating,
    strategy,
    refs,
    update,
    placement: placementData,
    middlewareData: {
      arrow: arrowData = {}
    }
  } = useFloating({
    placement: usedPlacement,
    middleware: middlewares
  });
  const staticSide = {
    top: 'bottom',
    right: 'left',
    bottom: 'top',
    left: 'right'
  }[placementData.split('-')[0]];
  const mergedRefs = useMergeRefs([floating, dialogRef, ref]); // Updates references

  (0,react.useLayoutEffect)(() => {
    // No ref or position have been passed
    let usedRef;

    if (anchorRef !== null && anchorRef !== void 0 && anchorRef.top) {
      usedRef = {
        getBoundingClientRect() {
          const topRect = anchorRef.top.getBoundingClientRect();
          const bottomRect = anchorRef.bottom.getBoundingClientRect();
          return new window.DOMRect(topRect.x, topRect.y, topRect.width, bottomRect.bottom - topRect.top);
        }

      };
    } else if (anchorRef !== null && anchorRef !== void 0 && anchorRef.current) {
      usedRef = anchorRef.current;
    } else if (anchorRef) {
      usedRef = anchorRef;
    } else if (anchorRect) {
      usedRef = {
        getBoundingClientRect() {
          return anchorRect;
        }

      };
    } else if (getAnchorRect) {
      usedRef = {
        getBoundingClientRect() {
          var _rect$x, _rect$y, _rect$width, _rect$height;

          const rect = getAnchorRect();
          return new window.DOMRect((_rect$x = rect.x) !== null && _rect$x !== void 0 ? _rect$x : rect.left, (_rect$y = rect.y) !== null && _rect$y !== void 0 ? _rect$y : rect.top, (_rect$width = rect.width) !== null && _rect$width !== void 0 ? _rect$width : rect.right - rect.left, (_rect$height = rect.height) !== null && _rect$height !== void 0 ? _rect$height : rect.bottom - rect.top);
        }

      };
    } else if (anchorRefFallback.current) {
      usedRef = anchorRefFallback.current;
    }

    if (!usedRef) {
      return;
    }

    reference(usedRef);

    if (!refs.floating.current) {
      return;
    }

    return floating_ui_dom_esm_min_D(usedRef, refs.floating.current, update);
  }, [anchorRef, anchorRect, getAnchorRect]); // This is only needed for a smoth transition when moving blocks.

  (0,react.useLayoutEffect)(() => {
    if (!__unstableObserveElement) {
      return;
    }

    const observer = new window.MutationObserver(update);
    observer.observe(__unstableObserveElement, {
      attributes: true
    });
    return () => {
      observer.disconnect();
    };
  }, [__unstableObserveElement]); // If we're using getAnchorRect, we need to update the position as we scroll the iframe.

  (0,react.useLayoutEffect)(() => {
    if (ownerDocument === document) {
      return;
    }

    ownerDocument.addEventListener('scroll', update);
    return () => ownerDocument.removeEventListener('scroll', update);
  }, [ownerDocument]);
  /** @type {false | string} */

  const animateClassName = !!animate && getAnimateClassName({
    type: 'appear',
    origin: placementToAnimationOrigin(placementData)
  }); // Disable reason: We care to capture the _bubbled_ events from inputs
  // within popover as inferring close intent.

  let content = // eslint-disable-next-line jsx-a11y/no-noninteractive-element-interactions
  // eslint-disable-next-line jsx-a11y/no-static-element-interactions
  (0,react.createElement)("div", extends_extends({
    className: classnames_default()('components-popover', className, animateClassName, {
      'is-expanded': isExpanded,
      'is-alternate': isAlternate
    })
  }, contentProps, {
    ref: mergedRefs
  }, dialogProps, {
    tabIndex: "-1",
    style: isExpanded ? undefined : {
      position: strategy,
      left: Number.isNaN(x) ? 0 : x,
      top: Number.isNaN(y) ? 0 : y
    }
  }), isExpanded && (0,react.createElement)(ScrollLock, null), isExpanded && (0,react.createElement)("div", {
    className: "components-popover__header"
  }, (0,react.createElement)("span", {
    className: "components-popover__header-title"
  }, headerTitle), (0,react.createElement)(build_module_button, {
    className: "components-popover__close",
    icon: library_close,
    onClick: onClose
  })), (0,react.createElement)("div", {
    className: "components-popover__content"
  }, children), hasArrow && (0,react.createElement)("div", {
    className: "components-popover__arrow",
    ref: arrowRef,
    style: {
      left: !(arrowData !== null && arrowData !== void 0 && arrowData.x) || Number.isNaN(arrowData === null || arrowData === void 0 ? void 0 : arrowData.x) ? 0 : arrowData.x,
      top: !(arrowData !== null && arrowData !== void 0 && arrowData.y) || Number.isNaN(arrowData === null || arrowData === void 0 ? void 0 : arrowData.y) ? 0 : arrowData.y,
      right: undefined,
      bottom: undefined,
      [staticSide]: '-4px'
    }
  }));

  if (slot.ref) {
    content = (0,react.createElement)(slot_fill_Fill, {
      name: slotName
    }, content);
  }

  if (anchorRef || anchorRect) {
    return content;
  }

  return (0,react.createElement)("span", {
    ref: anchorRefFallback
  }, content);
};

const PopoverContainer = (0,react.forwardRef)(Popover);

function PopoverSlot(_ref3, ref) {
  let {
    name = SLOT_NAME
  } = _ref3;
  return (0,react.createElement)(slot_fill_Slot, {
    bubblesVirtually: true,
    name: name,
    className: "popover-slot",
    ref: ref
  });
}

PopoverContainer.Slot = (0,react.forwardRef)(PopoverSlot);
PopoverContainer.__unstableSlotNameProvider = slotNameContext.Provider;
/* harmony default export */ const popover = (PopoverContainer);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/shortcut/index.js


/**
 * External dependencies
 */

/** @typedef {string | { display: string, ariaLabel: string }} Shortcut */

/**
 * @typedef Props
 * @property {Shortcut} shortcut    Shortcut configuration
 * @property {string}   [className] Classname
 */

/**
 * @param {Props} props Props
 * @return {JSX.Element | null} Element
 */

function Shortcut(_ref) {
  let {
    shortcut,
    className
  } = _ref;

  if (!shortcut) {
    return null;
  }

  let displayText;
  let ariaLabel;

  if ((0,lodash.isString)(shortcut)) {
    displayText = shortcut;
  }

  if ((0,lodash.isObject)(shortcut)) {
    displayText = shortcut.display;
    ariaLabel = shortcut.ariaLabel;
  }

  return (0,react.createElement)("span", {
    className: className,
    "aria-label": ariaLabel
  }, displayText);
}

/* harmony default export */ const build_module_shortcut = (Shortcut);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/tooltip/index.js

// @ts-nocheck

/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */



/**
 * Internal dependencies
 */



/**
 * Time over children to wait before showing tooltip
 *
 * @type {number}
 */

const TOOLTIP_DELAY = 700;
const eventCatcher = (0,react.createElement)("div", {
  className: "event-catcher"
});

const getDisabledElement = _ref => {
  let {
    eventHandlers,
    child,
    childrenWithPopover
  } = _ref;
  return (0,react.cloneElement)((0,react.createElement)("span", {
    className: "disabled-element-wrapper"
  }, (0,react.cloneElement)(eventCatcher, eventHandlers), (0,react.cloneElement)(child, {
    children: childrenWithPopover
  })), eventHandlers);
};

const getRegularElement = _ref2 => {
  let {
    child,
    eventHandlers,
    childrenWithPopover
  } = _ref2;
  return (0,react.cloneElement)(child, { ...eventHandlers,
    children: childrenWithPopover
  });
};

const addPopoverToGrandchildren = _ref3 => {
  let {
    grandchildren,
    isOver,
    position,
    text,
    shortcut
  } = _ref3;
  return concatChildren(grandchildren, isOver && (0,react.createElement)(popover, {
    focusOnMount: false,
    position: position,
    className: "components-tooltip",
    "aria-hidden": "true",
    animate: false,
    offset: 12,
    __unstableShift: true
  }, text, (0,react.createElement)(build_module_shortcut, {
    className: "components-tooltip__shortcut",
    shortcut: shortcut
  })));
};

const emitToChild = (children, eventName, event) => {
  if (react.Children.count(children) !== 1) {
    return;
  }

  const child = react.Children.only(children); // If the underlying element is disabled, do not emit the event.

  if (child.props.disabled) {
    return;
  }

  if (typeof child.props[eventName] === 'function') {
    child.props[eventName](event);
  }
};

function Tooltip(props) {
  const {
    children,
    position = 'bottom middle',
    text,
    shortcut,
    delay = TOOLTIP_DELAY
  } = props;
  /**
   * Whether a mouse is currently pressed, used in determining whether
   * to handle a focus event as displaying the tooltip immediately.
   *
   * @type {boolean}
   */

  const [isMouseDown, setIsMouseDown] = (0,react.useState)(false);
  const [isOver, setIsOver] = (0,react.useState)(false);
  const delayedSetIsOver = useDebounce(setIsOver, delay);

  const createMouseDown = event => {
    // Preserve original child callback behavior.
    emitToChild(children, 'onMouseDown', event); // On mouse down, the next `mouseup` should revert the value of the
    // instance property and remove its own event handler. The bind is
    // made on the document since the `mouseup` might not occur within
    // the bounds of the element.

    document.addEventListener('mouseup', cancelIsMouseDown);
    setIsMouseDown(true);
  };

  const createMouseUp = event => {
    emitToChild(children, 'onMouseUp', event);
    document.removeEventListener('mouseup', cancelIsMouseDown);
    setIsMouseDown(false);
  };

  const createMouseEvent = type => {
    if (type === 'mouseUp') return createMouseUp;
    if (type === 'mouseDown') return createMouseDown;
  };
  /**
   * Prebound `isInMouseDown` handler, created as a constant reference to
   * assure ability to remove in component unmount.
   *
   * @type {Function}
   */


  const cancelIsMouseDown = createMouseEvent('mouseUp');

  const createToggleIsOver = (eventName, isDelayed) => {
    return event => {
      // Preserve original child callback behavior.
      emitToChild(children, eventName, event); // Mouse events behave unreliably in React for disabled elements,
      // firing on mouseenter but not mouseleave.  Further, the default
      // behavior for disabled elements in some browsers is to ignore
      // mouse events. Don't bother trying to to handle them.
      //
      // See: https://github.com/facebook/react/issues/4251

      if (event.currentTarget.disabled) {
        return;
      } // A focus event will occur as a result of a mouse click, but it
      // should be disambiguated between interacting with the button and
      // using an explicit focus shift as a cue to display the tooltip.


      if ('focus' === event.type && isMouseDown) {
        return;
      } // Needed in case unsetting is over while delayed set pending, i.e.
      // quickly blur/mouseleave before delayedSetIsOver is called.


      delayedSetIsOver.cancel();

      const _isOver = (0,lodash.includes)(['focus', 'mouseenter'], event.type);

      if (_isOver === isOver) {
        return;
      }

      if (isDelayed) {
        delayedSetIsOver(_isOver);
      } else {
        setIsOver(_isOver);
      }
    };
  };

  const clearOnUnmount = () => {
    delayedSetIsOver.cancel();
    document.removeEventListener('mouseup', cancelIsMouseDown);
  };

  (0,react.useEffect)(() => clearOnUnmount, []);

  if (react.Children.count(children) !== 1) {
    if (false) {}

    return children;
  }

  const eventHandlers = {
    onMouseEnter: createToggleIsOver('onMouseEnter', true),
    onMouseLeave: createToggleIsOver('onMouseLeave'),
    onClick: createToggleIsOver('onClick'),
    onFocus: createToggleIsOver('onFocus'),
    onBlur: createToggleIsOver('onBlur'),
    onMouseDown: createMouseEvent('mouseDown')
  };
  const child = react.Children.only(children);
  const {
    children: grandchildren,
    disabled
  } = child.props;
  const getElementWithPopover = disabled ? getDisabledElement : getRegularElement;
  const popoverData = {
    isOver,
    position,
    text,
    shortcut
  };
  const childrenWithPopover = addPopoverToGrandchildren({
    grandchildren,
    ...popoverData
  });
  return getElementWithPopover({
    child,
    eventHandlers,
    childrenWithPopover
  });
}

/* harmony default export */ const tooltip = (Tooltip);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/dashicon/index.js



/**
 * @typedef OwnProps
 *
 * @property {import('./types').IconKey} icon        Icon name
 * @property {string}                    [className] Class name
 */

/** @typedef {import('react').ComponentPropsWithoutRef<'span'> & OwnProps} Props */

/**
 * @param {Props} props
 * @return {JSX.Element} Element
 */
function Dashicon(_ref) {
  let {
    icon,
    className,
    ...extraProps
  } = _ref;
  const iconClass = ['dashicon', 'dashicons', 'dashicons-' + icon, className].filter(Boolean).join(' ');
  return (0,react.createElement)("span", extends_extends({
    className: iconClass
  }, extraProps));
}

/* harmony default export */ const dashicon = (Dashicon);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/icon/index.js


/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */



function Icon(_ref) {
  let {
    icon = null,
    size = 24,
    ...additionalProps
  } = _ref;

  if ('string' === typeof icon) {
    return (0,react.createElement)(dashicon, extends_extends({
      icon: icon
    }, additionalProps));
  }

  if ((0,react.isValidElement)(icon) && dashicon === icon.type) {
    return (0,react.cloneElement)(icon, { ...additionalProps
    });
  }

  if ('function' === typeof icon) {
    if (icon.prototype instanceof react.Component) {
      return (0,react.createElement)(icon, {
        size,
        ...additionalProps
      });
    }

    return icon({
      size,
      ...additionalProps
    });
  }

  if (icon && (icon.type === 'svg' || icon.type === SVG)) {
    const appliedProps = {
      width: size,
      height: size,
      ...icon.props,
      ...additionalProps
    };
    return (0,react.createElement)(SVG, appliedProps);
  }

  if ((0,react.isValidElement)(icon)) {
    return (0,react.cloneElement)(icon, {
      // @ts-ignore Just forwarding the size prop along
      size,
      ...additionalProps
    });
  }

  return icon;
}

/* harmony default export */ const build_module_icon = (Icon);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/visually-hidden/styles.js
/** @type {import('react').CSSProperties} */
const visuallyHidden = {
  border: 0,
  clip: 'rect(1px, 1px, 1px, 1px)',
  WebkitClipPath: 'inset( 50% )',
  clipPath: 'inset( 50% )',
  height: '1px',
  margin: '-1px',
  overflow: 'hidden',
  padding: 0,
  position: 'absolute',
  width: '1px',
  wordWrap: 'normal'
};
//# sourceMappingURL=styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/visually-hidden/component.js



/**
 * Internal dependencies
 */



/**
 * @param {import('../ui/context').WordPressComponentProps<{ children: import('react').ReactNode }, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                                               forwardedRef
 */

function VisuallyHidden(props, forwardedRef) {
  const {
    style: styleProp,
    ...contextProps
  } = useContextSystem(props, 'VisuallyHidden');
  return (0,react.createElement)(component, extends_extends({
    ref: forwardedRef
  }, contextProps, {
    style: { ...visuallyHidden,
      ...(styleProp || {})
    }
  }));
}
/**
 * `VisuallyHidden` is a component used to render text intended to be visually
 * hidden, but will show for alternate devices, for example a screen reader.
 *
 * @example
 * ```jsx
 * import { VisuallyHidden } from `@wordpress/components`;
 *
 * function Example() {
 * 	return (
 * 		<VisuallyHidden>
 * 			<label>Code is Poetry</label>
 * 		</VisuallyHidden>
 * 	);
 * }
 * ```
 */


const ConnectedVisuallyHidden = contextConnect(VisuallyHidden, 'VisuallyHidden');
/* harmony default export */ const visually_hidden_component = (ConnectedVisuallyHidden);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/button/index.js


// @ts-nocheck

/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */




/**
 * Internal dependencies
 */




const disabledEventsOnDisabledButton = ['onMouseDown', 'onClick'];

function button_useDeprecatedProps(_ref) {
  let {
    isDefault,
    isPrimary,
    isSecondary,
    isTertiary,
    isLink,
    variant,
    ...otherProps
  } = _ref;
  let computedVariant = variant;

  if (isPrimary) {
    var _computedVariant;

    (_computedVariant = computedVariant) !== null && _computedVariant !== void 0 ? _computedVariant : computedVariant = 'primary';
  }

  if (isTertiary) {
    var _computedVariant2;

    (_computedVariant2 = computedVariant) !== null && _computedVariant2 !== void 0 ? _computedVariant2 : computedVariant = 'tertiary';
  }

  if (isSecondary) {
    var _computedVariant3;

    (_computedVariant3 = computedVariant) !== null && _computedVariant3 !== void 0 ? _computedVariant3 : computedVariant = 'secondary';
  }

  if (isDefault) {
    var _computedVariant4;

    deprecated('Button isDefault prop', {
      since: '5.4',
      alternative: 'variant="secondary"',
      version: '6.2'
    });
    (_computedVariant4 = computedVariant) !== null && _computedVariant4 !== void 0 ? _computedVariant4 : computedVariant = 'secondary';
  }

  if (isLink) {
    var _computedVariant5;

    (_computedVariant5 = computedVariant) !== null && _computedVariant5 !== void 0 ? _computedVariant5 : computedVariant = 'link';
  }

  return { ...otherProps,
    variant: computedVariant
  };
}

function Button(props, ref) {
  const {
    href,
    target,
    isSmall,
    isPressed,
    isBusy,
    isDestructive,
    className,
    disabled,
    icon,
    iconPosition = 'left',
    iconSize,
    showTooltip,
    tooltipPosition,
    shortcut,
    label,
    children,
    text,
    variant,
    __experimentalIsFocusable: isFocusable,
    describedBy,
    ...additionalProps
  } = button_useDeprecatedProps(props);
  const instanceId = useInstanceId(Button, 'components-button__description');
  const classes = classnames_default()('components-button', className, {
    'is-secondary': variant === 'secondary',
    'is-primary': variant === 'primary',
    'is-small': isSmall,
    'is-tertiary': variant === 'tertiary',
    'is-pressed': isPressed,
    'is-busy': isBusy,
    'is-link': variant === 'link',
    'is-destructive': isDestructive,
    'has-text': !!icon && !!children,
    'has-icon': !!icon
  });
  const trulyDisabled = disabled && !isFocusable;
  const Tag = href !== undefined && !trulyDisabled ? 'a' : 'button';
  const tagProps = Tag === 'a' ? {
    href,
    target
  } : {
    type: 'button',
    disabled: trulyDisabled,
    'aria-pressed': isPressed
  };

  if (disabled && isFocusable) {
    // In this case, the button will be disabled, but still focusable and
    // perceivable by screen reader users.
    tagProps['aria-disabled'] = true;

    for (const disabledEvent of disabledEventsOnDisabledButton) {
      additionalProps[disabledEvent] = event => {
        event.stopPropagation();
        event.preventDefault();
      };
    }
  } // Should show the tooltip if...


  const shouldShowTooltip = !trulyDisabled && ( // An explicit tooltip is passed or...
  showTooltip && label || // There's a shortcut or...
  shortcut || // There's a label and...
  !!label && // The children are empty and...
  !(children !== null && children !== void 0 && children.length) && // The tooltip is not explicitly disabled.
  false !== showTooltip);
  const descriptionId = describedBy ? instanceId : null;
  const describedById = additionalProps['aria-describedby'] || descriptionId;
  const element = (0,react.createElement)(Tag, extends_extends({}, tagProps, additionalProps, {
    className: classes,
    "aria-label": additionalProps['aria-label'] || label,
    "aria-describedby": describedById,
    ref: ref
  }), icon && iconPosition === 'left' && (0,react.createElement)(build_module_icon, {
    icon: icon,
    size: iconSize
  }), text && (0,react.createElement)(react.Fragment, null, text), icon && iconPosition === 'right' && (0,react.createElement)(build_module_icon, {
    icon: icon,
    size: iconSize
  }), children);

  if (!shouldShowTooltip) {
    return (0,react.createElement)(react.Fragment, null, element, describedBy && (0,react.createElement)(visually_hidden_component, null, (0,react.createElement)("span", {
      id: descriptionId
    }, describedBy)));
  }

  return (0,react.createElement)(react.Fragment, null, (0,react.createElement)(tooltip, {
    text: children !== null && children !== void 0 && children.length && describedBy ? describedBy : label,
    shortcut: shortcut,
    position: tooltipPosition
  }, element), describedBy && (0,react.createElement)(visually_hidden_component, null, (0,react.createElement)("span", {
    id: descriptionId
  }, describedBy)));
}
/* harmony default export */ const build_module_button = ((0,react.forwardRef)(Button));
//# sourceMappingURL=index.js.map
// EXTERNAL MODULE: ./node_modules/axios/index.js
var axios = __webpack_require__(9669);
var axios_default = /*#__PURE__*/__webpack_require__.n(axios);
// EXTERNAL MODULE: ./node_modules/cookie/index.js
var cookie = __webpack_require__(6489);
;// CONCATENATED MODULE: ./node_modules/universal-cookie/es6/utils.js

function hasDocumentCookie() {
    // Can we get/set cookies on document.cookie?
    return typeof document === 'object' && typeof document.cookie === 'string';
}
function cleanCookies() {
    document.cookie.split(';').forEach(function (c) {
        document.cookie = c
            .replace(/^ +/, '')
            .replace(/=.*/, '=;expires=' + new Date().toUTCString() + ';path=/');
    });
}
function parseCookies(cookies, options) {
    if (typeof cookies === 'string') {
        return cookie/* parse */.Q(cookies, options);
    }
    else if (typeof cookies === 'object' && cookies !== null) {
        return cookies;
    }
    else {
        return {};
    }
}
function isParsingCookie(value, doNotParse) {
    if (typeof doNotParse === 'undefined') {
        // We guess if the cookie start with { or [, it has been serialized
        doNotParse =
            !value || (value[0] !== '{' && value[0] !== '[' && value[0] !== '"');
    }
    return !doNotParse;
}
function readCookie(value, options) {
    if (options === void 0) { options = {}; }
    var cleanValue = cleanupCookieValue(value);
    if (isParsingCookie(cleanValue, options.doNotParse)) {
        try {
            return JSON.parse(cleanValue);
        }
        catch (e) {
            // At least we tried
        }
    }
    // Ignore clean value if we failed the deserialization
    // It is not relevant anymore to trim those values
    return value;
}
function cleanupCookieValue(value) {
    // express prepend j: before serializing a cookie
    if (value && value[0] === 'j' && value[1] === ':') {
        return value.substr(2);
    }
    return value;
}

;// CONCATENATED MODULE: ./node_modules/universal-cookie/es6/Cookies.js
var __assign = (undefined && undefined.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};


var Cookies = /** @class */ (function () {
    function Cookies(cookies, options) {
        var _this = this;
        this.changeListeners = [];
        this.HAS_DOCUMENT_COOKIE = false;
        this.cookies = parseCookies(cookies, options);
        new Promise(function () {
            _this.HAS_DOCUMENT_COOKIE = hasDocumentCookie();
        }).catch(function () { });
    }
    Cookies.prototype._updateBrowserValues = function (parseOptions) {
        if (!this.HAS_DOCUMENT_COOKIE) {
            return;
        }
        this.cookies = cookie/* parse */.Q(document.cookie, parseOptions);
    };
    Cookies.prototype._emitChange = function (params) {
        for (var i = 0; i < this.changeListeners.length; ++i) {
            this.changeListeners[i](params);
        }
    };
    Cookies.prototype.get = function (name, options, parseOptions) {
        if (options === void 0) { options = {}; }
        this._updateBrowserValues(parseOptions);
        return readCookie(this.cookies[name], options);
    };
    Cookies.prototype.getAll = function (options, parseOptions) {
        if (options === void 0) { options = {}; }
        this._updateBrowserValues(parseOptions);
        var result = {};
        for (var name_1 in this.cookies) {
            result[name_1] = readCookie(this.cookies[name_1], options);
        }
        return result;
    };
    Cookies.prototype.set = function (name, value, options) {
        var _a;
        if (typeof value === 'object') {
            value = JSON.stringify(value);
        }
        this.cookies = __assign(__assign({}, this.cookies), (_a = {}, _a[name] = value, _a));
        if (this.HAS_DOCUMENT_COOKIE) {
            document.cookie = cookie/* serialize */.q(name, value, options);
        }
        this._emitChange({ name: name, value: value, options: options });
    };
    Cookies.prototype.remove = function (name, options) {
        var finalOptions = (options = __assign(__assign({}, options), { expires: new Date(1970, 1, 1, 0, 0, 1), maxAge: 0 }));
        this.cookies = __assign({}, this.cookies);
        delete this.cookies[name];
        if (this.HAS_DOCUMENT_COOKIE) {
            document.cookie = cookie/* serialize */.q(name, '', finalOptions);
        }
        this._emitChange({ name: name, value: undefined, options: options });
    };
    Cookies.prototype.addChangeListener = function (callback) {
        this.changeListeners.push(callback);
    };
    Cookies.prototype.removeChangeListener = function (callback) {
        var idx = this.changeListeners.indexOf(callback);
        if (idx >= 0) {
            this.changeListeners.splice(idx, 1);
        }
    };
    return Cookies;
}());
/* harmony default export */ const es6_Cookies = (Cookies);

;// CONCATENATED MODULE: ./node_modules/universal-cookie/es6/index.js

/* harmony default export */ const es6 = (es6_Cookies);

;// CONCATENATED MODULE: ./assets/app/dev/admin/core/vfAPI.ts


var cookies = new es6();
var vfAPI = axios_default().create({
  baseURL: "".concat(localized.apiURL, "/admin"),
  params: {
    apikey: localized.settings.general.api_key
  }
});
vfAPI.interceptors.request.use(function (config) {
  // Add tokens with each request, since the cookies may not be set or available when the Axios instance is created.
  var tokena = cookies.get('vendorfuel-admin-tokena');
  var tokenb = cookies.get('vendorfuel-admin-tokenb');

  if (tokena && tokenb) {
    config.params.tokena = tokena;
    config.params.tokenb = tokenb;
    return config;
  } // If tokens are missing, redirect to either login or billing page.


  if (localized.settings.general.api_key) {
    location.hash = '#!/login';
  } else {
    location.hash = '#!/subscribe';
  }
}, function (error) {
  return Promise.reject(error);
});
vfAPI.interceptors.response.use(function (response) {
  var _response$data, _response$data2, _response$data3;

  if ((_response$data = response.data) !== null && _response$data !== void 0 && _response$data.errors && (_response$data2 = response.data) !== null && _response$data2 !== void 0 && _response$data2.warnings && (_response$data3 = response.data) !== null && _response$data3 !== void 0 && _response$data3.notifications) {
    response.data.notices = [].concat(response.data.errors.map(function (error) {
      return {
        message: error,
        status: 'error'
      };
    })).concat(response.data.warnings.map(function (warning) {
      return {
        message: warning,
        status: 'warning'
      };
    })).concat(response.data.notifications.map(function (notification) {
      return {
        message: notification,
        status: 'info'
      };
    }));
  }

  return response;
}, function (error) {
  return Promise.reject(error);
});
// EXTERNAL MODULE: ./node_modules/react/jsx-runtime.js
var jsx_runtime = __webpack_require__(5893);
;// CONCATENATED MODULE: ./assets/app/dev/admin/shared/Breadcrumb.tsx
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }





var Breadcrumb = function Breadcrumb(_ref) {
  var breadcrumbs = _ref.breadcrumbs;
  var hrefWithoutHash = location.href.replace(location.hash, '');

  var _useState = (0,react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      last = _useState2[0],
      setLast = _useState2[1];

  (0,react.useEffect)(function () {
    setLast(breadcrumbs.length - 1);
  }, [breadcrumbs]);
  return /*#__PURE__*/(0,jsx_runtime.jsx)(jsx_runtime.Fragment, {
    children: breadcrumbs.length && /*#__PURE__*/(0,jsx_runtime.jsx)("nav", {
      "aria-label": "breadcrumb",
      children: /*#__PURE__*/(0,jsx_runtime.jsxs)("ol", {
        className: "breadcrumb",
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("li", {
          className: "breadcrumb-item",
          children: /*#__PURE__*/(0,jsx_runtime.jsx)("a", {
            href: "#!/dashboard",
            children: "Dashboard"
          })
        }), breadcrumbs.map(function (breadcrumb, i) {
          return /*#__PURE__*/(0,jsx_runtime.jsx)("li", {
            className: "breadcrumb-item ".concat(i === last ? 'active' : ''),
            children: i === last ? /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
              children: breadcrumb.name
            }) : /*#__PURE__*/(0,jsx_runtime.jsx)("a", {
              href: "".concat(hrefWithoutHash).concat(breadcrumb.hash),
              children: breadcrumb.name
            })
          }, i);
        })]
      })
    })
  });
};
;// CONCATENATED MODULE: ./node_modules/@wordpress/escape-html/build-module/escape-greater.js
/**
 * Returns a string with greater-than sign replaced.
 *
 * Note that if a resolution for Trac#45387 comes to fruition, it is no longer
 * necessary for `__unstableEscapeGreaterThan` to exist.
 *
 * See: https://core.trac.wordpress.org/ticket/45387
 *
 * @param {string} value Original string.
 *
 * @return {string} Escaped string.
 */
function __unstableEscapeGreaterThan(value) {
  return value.replace(/>/g, '&gt;');
}
//# sourceMappingURL=escape-greater.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/escape-html/build-module/index.js
/**
 * Internal dependencies
 */

/**
 * Regular expression matching invalid attribute names.
 *
 * "Attribute names must consist of one or more characters other than controls,
 * U+0020 SPACE, U+0022 ("), U+0027 ('), U+003E (>), U+002F (/), U+003D (=),
 * and noncharacters."
 *
 * @see https://html.spec.whatwg.org/multipage/syntax.html#attributes-2
 *
 * @type {RegExp}
 */

const REGEXP_INVALID_ATTRIBUTE_NAME = /[\u007F-\u009F "'>/="\uFDD0-\uFDEF]/;
/**
 * Returns a string with ampersands escaped. Note that this is an imperfect
 * implementation, where only ampersands which do not appear as a pattern of
 * named, decimal, or hexadecimal character references are escaped. Invalid
 * named references (i.e. ambiguous ampersand) are are still permitted.
 *
 * @see https://w3c.github.io/html/syntax.html#character-references
 * @see https://w3c.github.io/html/syntax.html#ambiguous-ampersand
 * @see https://w3c.github.io/html/syntax.html#named-character-references
 *
 * @param {string} value Original string.
 *
 * @return {string} Escaped string.
 */

function escapeAmpersand(value) {
  return value.replace(/&(?!([a-z0-9]+|#[0-9]+|#x[a-f0-9]+);)/gi, '&amp;');
}
/**
 * Returns a string with quotation marks replaced.
 *
 * @param {string} value Original string.
 *
 * @return {string} Escaped string.
 */

function escapeQuotationMark(value) {
  return value.replace(/"/g, '&quot;');
}
/**
 * Returns a string with less-than sign replaced.
 *
 * @param {string} value Original string.
 *
 * @return {string} Escaped string.
 */

function escapeLessThan(value) {
  return value.replace(/</g, '&lt;');
}
/**
 * Returns an escaped attribute value.
 *
 * @see https://w3c.github.io/html/syntax.html#elements-attributes
 *
 * "[...] the text cannot contain an ambiguous ampersand [...] must not contain
 * any literal U+0022 QUOTATION MARK characters (")"
 *
 * Note we also escape the greater than symbol, as this is used by wptexturize to
 * split HTML strings. This is a WordPress specific fix
 *
 * Note that if a resolution for Trac#45387 comes to fruition, it is no longer
 * necessary for `__unstableEscapeGreaterThan` to be used.
 *
 * See: https://core.trac.wordpress.org/ticket/45387
 *
 * @param {string} value Attribute value.
 *
 * @return {string} Escaped attribute value.
 */

function escapeAttribute(value) {
  return __unstableEscapeGreaterThan(escapeQuotationMark(escapeAmpersand(value)));
}
/**
 * Returns an escaped HTML element value.
 *
 * @see https://w3c.github.io/html/syntax.html#writing-html-documents-elements
 *
 * "the text must not contain the character U+003C LESS-THAN SIGN (<) or an
 * ambiguous ampersand."
 *
 * @param {string} value Element value.
 *
 * @return {string} Escaped HTML element value.
 */

function escapeHTML(value) {
  return escapeLessThan(escapeAmpersand(value));
}
/**
 * Returns an escaped Editable HTML element value. This is different from
 * `escapeHTML`, because for editable HTML, ALL ampersands must be escaped in
 * order to render the content correctly on the page.
 *
 * @param {string} value Element value.
 *
 * @return {string} Escaped HTML element value.
 */

function escapeEditableHTML(value) {
  return escapeLessThan(value.replace(/&/g, '&amp;'));
}
/**
 * Returns true if the given attribute name is valid, or false otherwise.
 *
 * @param {string} name Attribute name to test.
 *
 * @return {boolean} Whether attribute is valid.
 */

function isValidAttributeName(name) {
  return !REGEXP_INVALID_ATTRIBUTE_NAME.test(name);
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/element/build-module/raw-html.js
/**
 * Internal dependencies
 */
 // Disable reason: JSDoc linter doesn't seem to parse the union (`&`) correctly.

/** @typedef {{children: string} & import('react').ComponentPropsWithoutRef<'div'>} RawHTMLProps */

/**
 * Component used as equivalent of Fragment with unescaped HTML, in cases where
 * it is desirable to render dangerous HTML without needing a wrapper element.
 * To preserve additional props, a `div` wrapper _will_ be created if any props
 * aside from `children` are passed.
 *
 * @param {RawHTMLProps} props Children should be a string of HTML or an array
 *                             of strings. Other props will be passed through
 *                             to the div wrapper.
 *
 * @return {JSX.Element} Dangerously-rendering component.
 */

function RawHTML(_ref) {
  let {
    children,
    ...props
  } = _ref;
  let rawHtml = ''; // Cast children as an array, and concatenate each element if it is a string.

  react.Children.toArray(children).forEach(child => {
    if (typeof child === 'string' && child.trim() !== '') {
      rawHtml += child;
    }
  }); // The `div` wrapper will be stripped by the `renderElement` serializer in
  // `./serialize.js` unless there are non-children props present.

  return (0,react.createElement)('div', {
    dangerouslySetInnerHTML: {
      __html: rawHtml
    },
    ...props
  });
}
//# sourceMappingURL=raw-html.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/element/build-module/serialize.js
/**
 * Parts of this source were derived and modified from fast-react-render,
 * released under the MIT license.
 *
 * https://github.com/alt-j/fast-react-render
 *
 * Copyright (c) 2016 Andrey Morozov
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */



/** @typedef {import('./react').WPElement} WPElement */

const {
  Provider: serialize_Provider,
  Consumer
} = (0,react.createContext)(undefined);
const ForwardRef = (0,react.forwardRef)(() => {
  return null;
});
/**
 * Valid attribute types.
 *
 * @type {Set<string>}
 */

const ATTRIBUTES_TYPES = new Set(['string', 'boolean', 'number']);
/**
 * Element tags which can be self-closing.
 *
 * @type {Set<string>}
 */

const SELF_CLOSING_TAGS = new Set(['area', 'base', 'br', 'col', 'command', 'embed', 'hr', 'img', 'input', 'keygen', 'link', 'meta', 'param', 'source', 'track', 'wbr']);
/**
 * Boolean attributes are attributes whose presence as being assigned is
 * meaningful, even if only empty.
 *
 * See: https://html.spec.whatwg.org/multipage/common-microsyntaxes.html#boolean-attributes
 * Extracted from: https://html.spec.whatwg.org/multipage/indices.html#attributes-3
 *
 * Object.keys( [ ...document.querySelectorAll( '#attributes-1 > tbody > tr' ) ]
 *     .filter( ( tr ) => tr.lastChild.textContent.indexOf( 'Boolean attribute' ) !== -1 )
 *     .reduce( ( result, tr ) => Object.assign( result, {
 *         [ tr.firstChild.textContent.trim() ]: true
 *     } ), {} ) ).sort();
 *
 * @type {Set<string>}
 */

const BOOLEAN_ATTRIBUTES = new Set(['allowfullscreen', 'allowpaymentrequest', 'allowusermedia', 'async', 'autofocus', 'autoplay', 'checked', 'controls', 'default', 'defer', 'disabled', 'download', 'formnovalidate', 'hidden', 'ismap', 'itemscope', 'loop', 'multiple', 'muted', 'nomodule', 'novalidate', 'open', 'playsinline', 'readonly', 'required', 'reversed', 'selected', 'typemustmatch']);
/**
 * Enumerated attributes are attributes which must be of a specific value form.
 * Like boolean attributes, these are meaningful if specified, even if not of a
 * valid enumerated value.
 *
 * See: https://html.spec.whatwg.org/multipage/common-microsyntaxes.html#enumerated-attribute
 * Extracted from: https://html.spec.whatwg.org/multipage/indices.html#attributes-3
 *
 * Object.keys( [ ...document.querySelectorAll( '#attributes-1 > tbody > tr' ) ]
 *     .filter( ( tr ) => /^("(.+?)";?\s*)+/.test( tr.lastChild.textContent.trim() ) )
 *     .reduce( ( result, tr ) => Object.assign( result, {
 *         [ tr.firstChild.textContent.trim() ]: true
 *     } ), {} ) ).sort();
 *
 * Some notable omissions:
 *
 *  - `alt`: https://blog.whatwg.org/omit-alt
 *
 * @type {Set<string>}
 */

const ENUMERATED_ATTRIBUTES = new Set(['autocapitalize', 'autocomplete', 'charset', 'contenteditable', 'crossorigin', 'decoding', 'dir', 'draggable', 'enctype', 'formenctype', 'formmethod', 'http-equiv', 'inputmode', 'kind', 'method', 'preload', 'scope', 'shape', 'spellcheck', 'translate', 'type', 'wrap']);
/**
 * Set of CSS style properties which support assignment of unitless numbers.
 * Used in rendering of style properties, where `px` unit is assumed unless
 * property is included in this set or value is zero.
 *
 * Generated via:
 *
 * Object.entries( document.createElement( 'div' ).style )
 *     .filter( ( [ key ] ) => (
 *         ! /^(webkit|ms|moz)/.test( key ) &&
 *         ( e.style[ key ] = 10 ) &&
 *         e.style[ key ] === '10'
 *     ) )
 *     .map( ( [ key ] ) => key )
 *     .sort();
 *
 * @type {Set<string>}
 */

const CSS_PROPERTIES_SUPPORTS_UNITLESS = new Set(['animation', 'animationIterationCount', 'baselineShift', 'borderImageOutset', 'borderImageSlice', 'borderImageWidth', 'columnCount', 'cx', 'cy', 'fillOpacity', 'flexGrow', 'flexShrink', 'floodOpacity', 'fontWeight', 'gridColumnEnd', 'gridColumnStart', 'gridRowEnd', 'gridRowStart', 'lineHeight', 'opacity', 'order', 'orphans', 'r', 'rx', 'ry', 'shapeImageThreshold', 'stopOpacity', 'strokeDasharray', 'strokeDashoffset', 'strokeMiterlimit', 'strokeOpacity', 'strokeWidth', 'tabSize', 'widows', 'x', 'y', 'zIndex', 'zoom']);
/**
 * Returns true if the specified string is prefixed by one of an array of
 * possible prefixes.
 *
 * @param {string}   string   String to check.
 * @param {string[]} prefixes Possible prefixes.
 *
 * @return {boolean} Whether string has prefix.
 */

function hasPrefix(string, prefixes) {
  return prefixes.some(prefix => string.indexOf(prefix) === 0);
}
/**
 * Returns true if the given prop name should be ignored in attributes
 * serialization, or false otherwise.
 *
 * @param {string} attribute Attribute to check.
 *
 * @return {boolean} Whether attribute should be ignored.
 */

function isInternalAttribute(attribute) {
  return 'key' === attribute || 'children' === attribute;
}
/**
 * Returns the normal form of the element's attribute value for HTML.
 *
 * @param {string} attribute Attribute name.
 * @param {*}      value     Non-normalized attribute value.
 *
 * @return {*} Normalized attribute value.
 */


function getNormalAttributeValue(attribute, value) {
  switch (attribute) {
    case 'style':
      return renderStyle(value);
  }

  return value;
}
/**
 * This is a map of all SVG attributes that have dashes. Map(lower case prop => dashed lower case attribute).
 * We need this to render e.g strokeWidth as stroke-width.
 *
 * List from: https://developer.mozilla.org/en-US/docs/Web/SVG/Attribute.
 */


const SVG_ATTRIBUTE_WITH_DASHES_LIST = ['accentHeight', 'alignmentBaseline', 'arabicForm', 'baselineShift', 'capHeight', 'clipPath', 'clipRule', 'colorInterpolation', 'colorInterpolationFilters', 'colorProfile', 'colorRendering', 'dominantBaseline', 'enableBackground', 'fillOpacity', 'fillRule', 'floodColor', 'floodOpacity', 'fontFamily', 'fontSize', 'fontSizeAdjust', 'fontStretch', 'fontStyle', 'fontVariant', 'fontWeight', 'glyphName', 'glyphOrientationHorizontal', 'glyphOrientationVertical', 'horizAdvX', 'horizOriginX', 'imageRendering', 'letterSpacing', 'lightingColor', 'markerEnd', 'markerMid', 'markerStart', 'overlinePosition', 'overlineThickness', 'paintOrder', 'panose1', 'pointerEvents', 'renderingIntent', 'shapeRendering', 'stopColor', 'stopOpacity', 'strikethroughPosition', 'strikethroughThickness', 'strokeDasharray', 'strokeDashoffset', 'strokeLinecap', 'strokeLinejoin', 'strokeMiterlimit', 'strokeOpacity', 'strokeWidth', 'textAnchor', 'textDecoration', 'textRendering', 'underlinePosition', 'underlineThickness', 'unicodeBidi', 'unicodeRange', 'unitsPerEm', 'vAlphabetic', 'vHanging', 'vIdeographic', 'vMathematical', 'vectorEffect', 'vertAdvY', 'vertOriginX', 'vertOriginY', 'wordSpacing', 'writingMode', 'xmlnsXlink', 'xHeight'].reduce((map, attribute) => {
  // The keys are lower-cased for more robust lookup.
  map[attribute.toLowerCase()] = attribute;
  return map;
}, {});
/**
 * This is a map of all case-sensitive SVG attributes. Map(lowercase key => proper case attribute).
 * The keys are lower-cased for more robust lookup.
 * Note that this list only contains attributes that contain at least one capital letter.
 * Lowercase attributes don't need mapping, since we lowercase all attributes by default.
 */

const CASE_SENSITIVE_SVG_ATTRIBUTES = ['allowReorder', 'attributeName', 'attributeType', 'autoReverse', 'baseFrequency', 'baseProfile', 'calcMode', 'clipPathUnits', 'contentScriptType', 'contentStyleType', 'diffuseConstant', 'edgeMode', 'externalResourcesRequired', 'filterRes', 'filterUnits', 'glyphRef', 'gradientTransform', 'gradientUnits', 'kernelMatrix', 'kernelUnitLength', 'keyPoints', 'keySplines', 'keyTimes', 'lengthAdjust', 'limitingConeAngle', 'markerHeight', 'markerUnits', 'markerWidth', 'maskContentUnits', 'maskUnits', 'numOctaves', 'pathLength', 'patternContentUnits', 'patternTransform', 'patternUnits', 'pointsAtX', 'pointsAtY', 'pointsAtZ', 'preserveAlpha', 'preserveAspectRatio', 'primitiveUnits', 'refX', 'refY', 'repeatCount', 'repeatDur', 'requiredExtensions', 'requiredFeatures', 'specularConstant', 'specularExponent', 'spreadMethod', 'startOffset', 'stdDeviation', 'stitchTiles', 'suppressContentEditableWarning', 'suppressHydrationWarning', 'surfaceScale', 'systemLanguage', 'tableValues', 'targetX', 'targetY', 'textLength', 'viewBox', 'viewTarget', 'xChannelSelector', 'yChannelSelector'].reduce((map, attribute) => {
  // The keys are lower-cased for more robust lookup.
  map[attribute.toLowerCase()] = attribute;
  return map;
}, {});
/**
 * This is a map of all SVG attributes that have colons.
 * Keys are lower-cased and stripped of their colons for more robust lookup.
 */

const SVG_ATTRIBUTES_WITH_COLONS = ['xlink:actuate', 'xlink:arcrole', 'xlink:href', 'xlink:role', 'xlink:show', 'xlink:title', 'xlink:type', 'xml:base', 'xml:lang', 'xml:space', 'xmlns:xlink'].reduce((map, attribute) => {
  map[attribute.replace(':', '').toLowerCase()] = attribute;
  return map;
}, {});
/**
 * Returns the normal form of the element's attribute name for HTML.
 *
 * @param {string} attribute Non-normalized attribute name.
 *
 * @return {string} Normalized attribute name.
 */

function getNormalAttributeName(attribute) {
  switch (attribute) {
    case 'htmlFor':
      return 'for';

    case 'className':
      return 'class';
  }

  const attributeLowerCase = attribute.toLowerCase();

  if (CASE_SENSITIVE_SVG_ATTRIBUTES[attributeLowerCase]) {
    return CASE_SENSITIVE_SVG_ATTRIBUTES[attributeLowerCase];
  } else if (SVG_ATTRIBUTE_WITH_DASHES_LIST[attributeLowerCase]) {
    return (0,lodash.kebabCase)(SVG_ATTRIBUTE_WITH_DASHES_LIST[attributeLowerCase]);
  } else if (SVG_ATTRIBUTES_WITH_COLONS[attributeLowerCase]) {
    return SVG_ATTRIBUTES_WITH_COLONS[attributeLowerCase];
  }

  return attributeLowerCase;
}
/**
 * Returns the normal form of the style property name for HTML.
 *
 * - Converts property names to kebab-case, e.g. 'backgroundColor' → 'background-color'
 * - Leaves custom attributes alone, e.g. '--myBackgroundColor' → '--myBackgroundColor'
 * - Converts vendor-prefixed property names to -kebab-case, e.g. 'MozTransform' → '-moz-transform'
 *
 * @param {string} property Property name.
 *
 * @return {string} Normalized property name.
 */


function getNormalStylePropertyName(property) {
  if ((0,lodash.startsWith)(property, '--')) {
    return property;
  }

  if (hasPrefix(property, ['ms', 'O', 'Moz', 'Webkit'])) {
    return '-' + (0,lodash.kebabCase)(property);
  }

  return (0,lodash.kebabCase)(property);
}
/**
 * Returns the normal form of the style property value for HTML. Appends a
 * default pixel unit if numeric, not a unitless property, and not zero.
 *
 * @param {string} property Property name.
 * @param {*}      value    Non-normalized property value.
 *
 * @return {*} Normalized property value.
 */


function getNormalStylePropertyValue(property, value) {
  if (typeof value === 'number' && 0 !== value && !CSS_PROPERTIES_SUPPORTS_UNITLESS.has(property)) {
    return value + 'px';
  }

  return value;
}
/**
 * Serializes a React element to string.
 *
 * @param {import('react').ReactNode} element         Element to serialize.
 * @param {Object}                    [context]       Context object.
 * @param {Object}                    [legacyContext] Legacy context object.
 *
 * @return {string} Serialized element.
 */


function renderElement(element, context) {
  let legacyContext = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (null === element || undefined === element || false === element) {
    return '';
  }

  if (Array.isArray(element)) {
    return renderChildren(element, context, legacyContext);
  }

  switch (typeof element) {
    case 'string':
      return escapeHTML(element);

    case 'number':
      return element.toString();
  }

  const {
    type,
    props
  } =
  /** @type {{type?: any, props?: any}} */
  element;

  switch (type) {
    case react.StrictMode:
    case react.Fragment:
      return renderChildren(props.children, context, legacyContext);

    case RawHTML:
      const {
        children,
        ...wrapperProps
      } = props;
      return renderNativeComponent((0,lodash.isEmpty)(wrapperProps) ? null : 'div', { ...wrapperProps,
        dangerouslySetInnerHTML: {
          __html: children
        }
      }, context, legacyContext);
  }

  switch (typeof type) {
    case 'string':
      return renderNativeComponent(type, props, context, legacyContext);

    case 'function':
      if (type.prototype && typeof type.prototype.render === 'function') {
        return renderComponent(type, props, context, legacyContext);
      }

      return renderElement(type(props, legacyContext), context, legacyContext);
  }

  switch (type && type.$$typeof) {
    case serialize_Provider.$$typeof:
      return renderChildren(props.children, props.value, legacyContext);

    case Consumer.$$typeof:
      return renderElement(props.children(context || type._currentValue), context, legacyContext);

    case ForwardRef.$$typeof:
      return renderElement(type.render(props), context, legacyContext);
  }

  return '';
}
/**
 * Serializes a native component type to string.
 *
 * @param {?string} type            Native component type to serialize, or null if
 *                                  rendering as fragment of children content.
 * @param {Object}  props           Props object.
 * @param {Object}  [context]       Context object.
 * @param {Object}  [legacyContext] Legacy context object.
 *
 * @return {string} Serialized element.
 */

function renderNativeComponent(type, props, context) {
  let legacyContext = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  let content = '';

  if (type === 'textarea' && props.hasOwnProperty('value')) {
    // Textarea children can be assigned as value prop. If it is, render in
    // place of children. Ensure to omit so it is not assigned as attribute
    // as well.
    content = renderChildren(props.value, context, legacyContext);
    props = (0,lodash.omit)(props, 'value');
  } else if (props.dangerouslySetInnerHTML && typeof props.dangerouslySetInnerHTML.__html === 'string') {
    // Dangerous content is left unescaped.
    content = props.dangerouslySetInnerHTML.__html;
  } else if (typeof props.children !== 'undefined') {
    content = renderChildren(props.children, context, legacyContext);
  }

  if (!type) {
    return content;
  }

  const attributes = renderAttributes(props);

  if (SELF_CLOSING_TAGS.has(type)) {
    return '<' + type + attributes + '/>';
  }

  return '<' + type + attributes + '>' + content + '</' + type + '>';
}
/** @typedef {import('./react').WPComponent} WPComponent */

/**
 * Serializes a non-native component type to string.
 *
 * @param {WPComponent} Component       Component type to serialize.
 * @param {Object}      props           Props object.
 * @param {Object}      [context]       Context object.
 * @param {Object}      [legacyContext] Legacy context object.
 *
 * @return {string} Serialized element
 */

function renderComponent(Component, props, context) {
  let legacyContext = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
  const instance = new
  /** @type {import('react').ComponentClass} */
  Component(props, legacyContext);

  if (typeof // Ignore reason: Current prettier reformats parens and mangles type assertion
  // prettier-ignore

  /** @type {{getChildContext?: () => unknown}} */
  instance.getChildContext === 'function') {
    Object.assign(legacyContext,
    /** @type {{getChildContext?: () => unknown}} */
    instance.getChildContext());
  }

  const html = renderElement(instance.render(), context, legacyContext);
  return html;
}
/**
 * Serializes an array of children to string.
 *
 * @param {import('react').ReactNodeArray} children        Children to serialize.
 * @param {Object}                         [context]       Context object.
 * @param {Object}                         [legacyContext] Legacy context object.
 *
 * @return {string} Serialized children.
 */

function renderChildren(children, context) {
  let legacyContext = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  let result = '';
  children = (0,lodash.castArray)(children);

  for (let i = 0; i < children.length; i++) {
    const child = children[i];
    result += renderElement(child, context, legacyContext);
  }

  return result;
}
/**
 * Renders a props object as a string of HTML attributes.
 *
 * @param {Object} props Props object.
 *
 * @return {string} Attributes string.
 */


function renderAttributes(props) {
  let result = '';

  for (const key in props) {
    const attribute = getNormalAttributeName(key);

    if (!isValidAttributeName(attribute)) {
      continue;
    }

    let value = getNormalAttributeValue(key, props[key]); // If value is not of serializeable type, skip.

    if (!ATTRIBUTES_TYPES.has(typeof value)) {
      continue;
    } // Don't render internal attribute names.


    if (isInternalAttribute(key)) {
      continue;
    }

    const isBooleanAttribute = BOOLEAN_ATTRIBUTES.has(attribute); // Boolean attribute should be omitted outright if its value is false.

    if (isBooleanAttribute && value === false) {
      continue;
    }

    const isMeaningfulAttribute = isBooleanAttribute || hasPrefix(key, ['data-', 'aria-']) || ENUMERATED_ATTRIBUTES.has(attribute); // Only write boolean value as attribute if meaningful.

    if (typeof value === 'boolean' && !isMeaningfulAttribute) {
      continue;
    }

    result += ' ' + attribute; // Boolean attributes should write attribute name, but without value.
    // Mere presence of attribute name is effective truthiness.

    if (isBooleanAttribute) {
      continue;
    }

    if (typeof value === 'string') {
      value = escapeAttribute(value);
    }

    result += '="' + value + '"';
  }

  return result;
}
/**
 * Renders a style object as a string attribute value.
 *
 * @param {Object} style Style object.
 *
 * @return {string} Style attribute value.
 */

function renderStyle(style) {
  // Only generate from object, e.g. tolerate string value.
  if (!(0,lodash.isPlainObject)(style)) {
    return style;
  }

  let result;

  for (const property in style) {
    const value = style[property];

    if (null === value || undefined === value) {
      continue;
    }

    if (result) {
      result += ';';
    } else {
      result = '';
    }

    const normalName = getNormalStylePropertyName(property);
    const normalValue = getNormalStylePropertyValue(property, value);
    result += normalName + ':' + normalValue;
  }

  return result;
}
/* harmony default export */ const build_module_serialize = (renderElement);
//# sourceMappingURL=serialize.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/dom-ready/build-module/index.js
/**
 * @typedef {() => void} Callback
 *
 * TODO: Remove this typedef and inline `() => void` type.
 *
 * This typedef is used so that a descriptive type is provided in our
 * automatically generated documentation.
 *
 * An in-line type `() => void` would be preferable, but the generated
 * documentation is `null` in that case.
 *
 * @see https://github.com/WordPress/gutenberg/issues/18045
 */

/**
 * Specify a function to execute when the DOM is fully loaded.
 *
 * @param {Callback} callback A function to execute after the DOM is ready.
 *
 * @example
 * ```js
 * import domReady from '@wordpress/dom-ready';
 *
 * domReady( function() {
 * 	//do something after DOM loads.
 * } );
 * ```
 *
 * @return {void}
 */
function domReady(callback) {
  if (typeof document === 'undefined') {
    return;
  }

  if (document.readyState === 'complete' || // DOMContentLoaded + Images/Styles/etc loaded, so we call directly.
  document.readyState === 'interactive' // DOMContentLoaded fires at this point, so we call directly.
  ) {
    return void callback();
  } // DOMContentLoaded has not fired yet, delay callback until then.


  document.addEventListener('DOMContentLoaded', callback);
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/a11y/build-module/add-intro-text.js
/**
 * WordPress dependencies
 */

/**
 * Build the explanatory text to be placed before the aria live regions.
 *
 * This text is initially hidden from assistive technologies by using a `hidden`
 * HTML attribute which is then removed once a message fills the aria-live regions.
 *
 * @return {HTMLParagraphElement} The explanatory text HTML element.
 */

function addIntroText() {
  const introText = document.createElement('p');
  introText.id = 'a11y-speak-intro-text';
  introText.className = 'a11y-speak-intro-text';
  introText.textContent = __('Notifications');
  introText.setAttribute('style', 'position: absolute;' + 'margin: -1px;' + 'padding: 0;' + 'height: 1px;' + 'width: 1px;' + 'overflow: hidden;' + 'clip: rect(1px, 1px, 1px, 1px);' + '-webkit-clip-path: inset(50%);' + 'clip-path: inset(50%);' + 'border: 0;' + 'word-wrap: normal !important;');
  introText.setAttribute('hidden', 'hidden');
  const {
    body
  } = document;

  if (body) {
    body.appendChild(introText);
  }

  return introText;
}
//# sourceMappingURL=add-intro-text.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/a11y/build-module/add-container.js
/**
 * Build the live regions markup.
 *
 * @param {string} [ariaLive] Value for the 'aria-live' attribute; default: 'polite'.
 *
 * @return {HTMLDivElement} The ARIA live region HTML element.
 */
function addContainer() {
  let ariaLive = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'polite';
  const container = document.createElement('div');
  container.id = `a11y-speak-${ariaLive}`;
  container.className = 'a11y-speak-region';
  container.setAttribute('style', 'position: absolute;' + 'margin: -1px;' + 'padding: 0;' + 'height: 1px;' + 'width: 1px;' + 'overflow: hidden;' + 'clip: rect(1px, 1px, 1px, 1px);' + '-webkit-clip-path: inset(50%);' + 'clip-path: inset(50%);' + 'border: 0;' + 'word-wrap: normal !important;');
  container.setAttribute('aria-live', ariaLive);
  container.setAttribute('aria-relevant', 'additions text');
  container.setAttribute('aria-atomic', 'true');
  const {
    body
  } = document;

  if (body) {
    body.appendChild(container);
  }

  return container;
}
//# sourceMappingURL=add-container.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/a11y/build-module/clear.js
/**
 * Clears the a11y-speak-region elements and hides the explanatory text.
 */
function clear() {
  const regions = document.getElementsByClassName('a11y-speak-region');
  const introText = document.getElementById('a11y-speak-intro-text');

  for (let i = 0; i < regions.length; i++) {
    regions[i].textContent = '';
  } // Make sure the explanatory text is hidden from assistive technologies.


  if (introText) {
    introText.setAttribute('hidden', 'hidden');
  }
}
//# sourceMappingURL=clear.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/a11y/build-module/filter-message.js
let previousMessage = '';
/**
 * Filter the message to be announced to the screenreader.
 *
 * @param {string} message The message to be announced.
 *
 * @return {string} The filtered message.
 */

function filterMessage(message) {
  /*
   * Strip HTML tags (if any) from the message string. Ideally, messages should
   * be simple strings, carefully crafted for specific use with A11ySpeak.
   * When re-using already existing strings this will ensure simple HTML to be
   * stripped out and replaced with a space. Browsers will collapse multiple
   * spaces natively.
   */
  message = message.replace(/<[^<>]+>/g, ' ');
  /*
   * Safari + VoiceOver don't announce repeated, identical strings. We use
   * a `no-break space` to force them to think identical strings are different.
   */

  if (previousMessage === message) {
    message += '\u00A0';
  }

  previousMessage = message;
  return message;
}
//# sourceMappingURL=filter-message.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/a11y/build-module/index.js
/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */





/**
 * Create the live regions.
 */

function setup() {
  const introText = document.getElementById('a11y-speak-intro-text');
  const containerAssertive = document.getElementById('a11y-speak-assertive');
  const containerPolite = document.getElementById('a11y-speak-polite');

  if (introText === null) {
    addIntroText();
  }

  if (containerAssertive === null) {
    addContainer('assertive');
  }

  if (containerPolite === null) {
    addContainer('polite');
  }
}
/**
 * Run setup on domReady.
 */

domReady(setup);
/**
 * Allows you to easily announce dynamic interface updates to screen readers using ARIA live regions.
 * This module is inspired by the `speak` function in `wp-a11y.js`.
 *
 * @param {string} message    The message to be announced by assistive technologies.
 * @param {string} [ariaLive] The politeness level for aria-live; default: 'polite'.
 *
 * @example
 * ```js
 * import { speak } from '@wordpress/a11y';
 *
 * // For polite messages that shouldn't interrupt what screen readers are currently announcing.
 * speak( 'The message you want to send to the ARIA live region' );
 *
 * // For assertive messages that should interrupt what screen readers are currently announcing.
 * speak( 'The message you want to send to the ARIA live region', 'assertive' );
 * ```
 */

function speak(message, ariaLive) {
  /*
   * Clear previous messages to allow repeated strings being read out and hide
   * the explanatory text from assistive technologies.
   */
  clear();
  message = filterMessage(message);
  const introText = document.getElementById('a11y-speak-intro-text');
  const containerAssertive = document.getElementById('a11y-speak-assertive');
  const containerPolite = document.getElementById('a11y-speak-polite');

  if (containerAssertive && ariaLive === 'assertive') {
    containerAssertive.textContent = message;
  } else if (containerPolite) {
    containerPolite.textContent = message;
  }
  /*
   * Make the explanatory text available to assistive technologies by removing
   * the 'hidden' HTML attribute.
   */


  if (introText) {
    introText.removeAttribute('hidden');
  }
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/notice/index.js


/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */





/**
 * Internal dependencies
 */


/** @typedef {import('@wordpress/element').WPElement} WPElement */

const noop = () => {};
/**
 * Custom hook which announces the message with the given politeness, if a
 * valid message is provided.
 *
 * @param {string|WPElement}     [message]  Message to announce.
 * @param {'polite'|'assertive'} politeness Politeness to announce.
 */


function useSpokenMessage(message, politeness) {
  const spokenMessage = typeof message === 'string' ? message : build_module_serialize(message);
  (0,react.useEffect)(() => {
    if (spokenMessage) {
      speak(spokenMessage, politeness);
    }
  }, [spokenMessage, politeness]);
}
/**
 * Given a notice status, returns an assumed default politeness for the status.
 * Defaults to 'assertive'.
 *
 * @param {string} [status] Notice status.
 *
 * @return {'polite'|'assertive'} Notice politeness.
 */


function getDefaultPoliteness(status) {
  switch (status) {
    case 'success':
    case 'warning':
    case 'info':
      return 'polite';

    case 'error':
    default:
      return 'assertive';
  }
}

function Notice(_ref) {
  let {
    className,
    status = 'info',
    children,
    spokenMessage = children,
    onRemove = noop,
    isDismissible = true,
    actions = [],
    politeness = getDefaultPoliteness(status),
    __unstableHTML,
    // onDismiss is a callback executed when the notice is dismissed.
    // It is distinct from onRemove, which _looks_ like a callback but is
    // actually the function to call to remove the notice from the UI.
    onDismiss = noop
  } = _ref;
  useSpokenMessage(spokenMessage, politeness);
  const classes = classnames_default()(className, 'components-notice', 'is-' + status, {
    'is-dismissible': isDismissible
  });

  if (__unstableHTML) {
    children = (0,react.createElement)(RawHTML, null, children);
  }

  const onDismissNotice = event => {
    var _event$preventDefault;

    event === null || event === void 0 ? void 0 : (_event$preventDefault = event.preventDefault) === null || _event$preventDefault === void 0 ? void 0 : _event$preventDefault.call(event);
    onDismiss();
    onRemove();
  };

  return (0,react.createElement)("div", {
    className: classes
  }, (0,react.createElement)("div", {
    className: "components-notice__content"
  }, children, (0,react.createElement)("div", {
    className: "components-notice__actions"
  }, actions.map((_ref2, index) => {
    let {
      className: buttonCustomClasses,
      label,
      isPrimary,
      variant,
      noDefaultClasses = false,
      onClick,
      url
    } = _ref2;
    let computedVariant = variant;

    if (variant !== 'primary' && !noDefaultClasses) {
      computedVariant = !url ? 'secondary' : 'link';
    }

    if (typeof computedVariant === 'undefined' && isPrimary) {
      computedVariant = 'primary';
    }

    return (0,react.createElement)(build_module_button, {
      key: index,
      href: url,
      variant: computedVariant,
      onClick: url ? undefined : onClick,
      className: classnames_default()('components-notice__action', buttonCustomClasses)
    }, label);
  }))), isDismissible && (0,react.createElement)(build_module_button, {
    className: "components-notice__dismiss",
    icon: library_close,
    label: __('Dismiss this notice'),
    onClick: onDismissNotice,
    showTooltip: false
  }));
}

/* harmony default export */ const build_module_notice = (Notice);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./assets/app/dev/admin/shared/Notices.tsx
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || Notices_unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return Notices_arrayLikeToArray(arr); }

function Notices_slicedToArray(arr, i) { return Notices_arrayWithHoles(arr) || Notices_iterableToArrayLimit(arr, i) || Notices_unsupportedIterableToArray(arr, i) || Notices_nonIterableRest(); }

function Notices_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function Notices_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return Notices_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return Notices_arrayLikeToArray(o, minLen); }

function Notices_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function Notices_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function Notices_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }





var Notices = function Notices(_ref) {
  var notices = _ref.notices;

  var _useState = (0,react.useState)([]),
      _useState2 = Notices_slicedToArray(_useState, 2),
      myNotices = _useState2[0],
      setNotices = _useState2[1];

  var handleRemove = function handleRemove(index) {
    var updatedNotices = _toConsumableArray(notices);

    updatedNotices.splice(index, 1);
    setNotices(updatedNotices);
  };

  (0,react.useEffect)(function () {
    setNotices(notices);
  }, [notices]);
  return /*#__PURE__*/(0,jsx_runtime.jsx)(jsx_runtime.Fragment, {
    children: myNotices.map(function (notice, index) {
      return /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_notice, {
        className: "mx-0",
        status: notice.status,
        onRemove: function onRemove() {
          return handleRemove(index);
        },
        children: notice.message
      }, index);
    })
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/accounting/AccountingPage.tsx
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function AccountingPage_slicedToArray(arr, i) { return AccountingPage_arrayWithHoles(arr) || AccountingPage_iterableToArrayLimit(arr, i) || AccountingPage_unsupportedIterableToArray(arr, i) || AccountingPage_nonIterableRest(); }

function AccountingPage_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function AccountingPage_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return AccountingPage_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return AccountingPage_arrayLikeToArray(o, minLen); }

function AccountingPage_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function AccountingPage_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function AccountingPage_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }









var apiUrl = '/accounting/quickbooks';
var AccountingPage = /*#__PURE__*/function (_React$Component) {
  _inherits(AccountingPage, _React$Component);

  var _super = _createSuper(AccountingPage);

  function AccountingPage(props) {
    var _this;

    _classCallCheck(this, AccountingPage);

    _this = _super.call(this, props);
    _this.state = {
      breadcrumbs: [{
        name: 'Accounting',
        hash: '#!/accounting'
      }],
      isBusy: false,
      isLoading: true,
      notices: []
    };
    _this.handleClickLink = _this.handleClickLink.bind(_assertThisInitialized(_this));
    _this.handleClickUnlink = _this.handleClickUnlink.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(AccountingPage, [{
    key: "getData",
    value: function getData() {
      var _this2 = this;

      this.setState({
        isLoading: true
      });
      vfAPI.get(apiUrl).then(function (response) {
        var _response$data$quickb;

        _this2.setState({
          notices: response.data.notices
        });

        if ((_response$data$quickb = response.data.quickbooks) !== null && _response$data$quickb !== void 0 && _response$data$quickb.realm_id) {
          _this2.setState({
            quickbooks: response.data.quickbooks
          });
        }

        _this2.setState({
          isBusy: false
        });

        _this2.setState({
          isLoading: false
        });
      });
    }
  }, {
    key: "handleClickLink",
    value: function handleClickLink() {
      var _this3 = this;

      this.setState({
        isBusy: true
      });
      vfAPI.get("".concat(apiUrl, "/auth")).then(function (response) {
        _this3.setState({
          notices: response.data.notices
        });

        if (response.data.auth_url) {
          var popup = window.open(response.data.auth_url, '_blank', 'location=yes,scrollbars=no,status=no');
          var timer = setInterval(function () {
            if (popup.closed) {
              clearInterval(timer);

              _this3.getData();

              _this3.setState({
                isBusy: false
              });
            }
          }, 1000);
        }
      });
    }
  }, {
    key: "handleClickUnlink",
    value: function handleClickUnlink() {
      var _this4 = this;

      this.setState({
        isBusy: true
      });
      vfAPI.get("".concat(apiUrl, "/unlink")).then(function (response) {
        _this4.setState({
          notices: response.data.notices
        });

        if (response.data.connected === false) {
          _this4.setState({
            quickbooks: null
          });
        }

        _this4.setState({
          isBusy: false
        });
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getData();
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)(Breadcrumb, {
          breadcrumbs: this.state.breadcrumbs
        }), /*#__PURE__*/(0,jsx_runtime.jsx)("h2", {
          children: "Accounting"
        }), /*#__PURE__*/(0,jsx_runtime.jsx)(Notices, {
          notices: this.state.notices
        }), /*#__PURE__*/(0,jsx_runtime.jsxs)(card_component, {
          children: [/*#__PURE__*/(0,jsx_runtime.jsx)(card_header_component, {
            children: "QuickBooks"
          }), /*#__PURE__*/(0,jsx_runtime.jsx)(card_body_component, {
            children: this.state.isLoading ? /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
              className: "d-flex justify-content-center",
              children: /*#__PURE__*/(0,jsx_runtime.jsx)(Spinner, {})
            }) : /*#__PURE__*/(0,jsx_runtime.jsx)(jsx_runtime.Fragment, {
              children: this.state.quickbooks ? /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
                children: [/*#__PURE__*/(0,jsx_runtime.jsx)("table", {
                  className: "widefat striped mb-3",
                  children: /*#__PURE__*/(0,jsx_runtime.jsxs)("tbody", {
                    children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("tr", {
                      children: [/*#__PURE__*/(0,jsx_runtime.jsx)("th", {
                        scope: "row",
                        children: "Realm ID"
                      }), /*#__PURE__*/(0,jsx_runtime.jsx)("td", {
                        children: this.state.quickbooks.realm_id
                      })]
                    }), Object.entries(this.state.quickbooks.options).map(function (option) {
                      var _option = AccountingPage_slicedToArray(option, 2),
                          key = _option[0],
                          value = _option[1];

                      return /*#__PURE__*/(0,jsx_runtime.jsxs)("tr", {
                        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("th", {
                          scope: "row",
                          children: key
                        }), /*#__PURE__*/(0,jsx_runtime.jsx)("td", {
                          children: value ? 'Yes' : 'No'
                        })]
                      }, key);
                    })]
                  })
                }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                  isBusy: this.state.isBusy,
                  variant: "secondary",
                  isDestructive: true,
                  onClick: this.handleClickUnlink,
                  children: "Unlink from QuickBooks"
                })]
              }) : /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
                children: [/*#__PURE__*/(0,jsx_runtime.jsx)("p", {
                  children: "Click below to link your VendorFuel store accounting data to QuickBooks."
                }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                  isBusy: this.state.isBusy,
                  variant: "primary",
                  onClick: this.handleClickLink,
                  children: "Link to QuickBooks"
                })]
              })
            })
          })]
        })]
      });
    }
  }]);

  return AccountingPage;
}(react.Component);
;// CONCATENATED MODULE: ./assets/app/dev/admin/accounting/accounting-routing.module.ts

var states = [{
  name: 'accounting',
  url: '/accounting',
  component: 'accountingPage'
}];
var AccountingRoutingModule = angular.module('AccountingRoutingModule', []).config(["$stateProvider", function ($stateProvider) {
  'ngInject';

  states.forEach(function (state) {
    state.onEnter = function () {
      highlightMenuItem('accounting');
    };

    $stateProvider.state(state);
  });
}]).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/accounting/accounting.module.ts



var AccountingModule = angular.module('AccountingModule', [AccountingRoutingModule]).component('accountingPage', (0,react2angular.react2angular)(AccountingPage)).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-notes/customer-notes.service.ts
function customer_notes_service_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_notes_service_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_notes_service_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_notes_service_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_notes_service_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CustomerNotesService = /*#__PURE__*/function () {
  CustomerNotesService.$inject = ["$http", "Localized"];

  function CustomerNotesService($http, Localized) {
    'ngInject';

    customer_notes_service_classCallCheck(this, CustomerNotesService);

    _defineProperty(this, "apiRoot", "".concat(localized.apiURL, "/admin/customers"));

    this.$http = $http;
    this.Localized = Localized;
  }

  customer_notes_service_createClass(CustomerNotesService, [{
    key: "query",
    value: function query(id) {
      return this.$http.get("".concat(this.apiRoot, "/").concat(id, "/notes")).then(function (response) {
        if (!response.data.errors.length) {
          return response.data;
        }
      });
    }
  }, {
    key: "save",
    value: function save(id, data) {
      var _this = this;

      return this.$http.post("".concat(this.apiRoot, "/").concat(id, "/notes"), data).then(function (response) {
        _this.Localized.setNotifications(response.data);
      });
    }
  }, {
    key: "remove",
    value: function remove(customerId, noteId) {
      var _this2 = this;

      return this.$http["delete"]("".concat(this.apiRoot, "/").concat(customerId, "/notes/").concat(noteId)).then(function (response) {
        _this2.Localized.setNotifications(response.data);
      });
    }
  }]);

  return CustomerNotesService;
}();
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-send-email/customer-email.service.ts
function customer_email_service_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_email_service_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_email_service_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_email_service_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_email_service_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function customer_email_service_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CustomerEmailService = /*#__PURE__*/function () {
  CustomerEmailService.$inject = ["$http", "Localized"];

  function CustomerEmailService($http, Localized) {
    'ngInject';

    customer_email_service_classCallCheck(this, CustomerEmailService);

    customer_email_service_defineProperty(this, "apiRoot", "".concat(localized.apiURL, "/admin/customers"));

    this.$http = $http;
    this.Localized = Localized;
  }

  customer_email_service_createClass(CustomerEmailService, [{
    key: "send",
    value: function send(id, type) {
      var _this = this;

      return this.$http.get("".concat(this.apiRoot, "/").concat(id, "/email/").concat(type)).then(function (response) {
        _this.Localized.setNotifications(response.data);

        if (!response.data.errors.length) {
          return response.data;
        }
      });
    }
  }]);

  return CustomerEmailService;
}();
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-login/customer-login.service.ts
function customer_login_service_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_login_service_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_login_service_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_login_service_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_login_service_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function customer_login_service_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CustomerLoginService = /*#__PURE__*/function () {
  CustomerLoginService.$inject = ["$cookies", "$http", "$window", "Localized"];

  function CustomerLoginService($cookies, $http, $window, Localized) {
    'ngInject';

    customer_login_service_classCallCheck(this, CustomerLoginService);

    customer_login_service_defineProperty(this, "apiRoot", "".concat(localized.apiURL, "/admin/customers"));

    this.$cookies = $cookies;
    this.$http = $http;
    this.$window = $window;
    this.Localized = Localized;
    this.$http = $http;
    this.Localized = Localized;
  }

  customer_login_service_createClass(CustomerLoginService, [{
    key: "clearCookies",
    value: function clearCookies() {
      var _this = this;

      var cookies = ['vf.user.name', 'vf.user.email', 'vf.user.group_admin', 'vf.user.approver', 'vf.user.is-guest', 'vf.user.group', 'vf.user.remember', 'vf.user.last_login', 'vf.user.cartCount', 'vf.user.punchoutOnly', 'vf.user.mixedPunchout', 'vf.user.company', 'vf.user.defaultShippingProfile', 'vf.user.defaultBillingProfile', 'vf.user.group_id', 'vf.user.group_parent_id', 'vf.user.price_availability', 'vf.user.cost_center_is_required', 'vf.user.currentGroup_id', 'vf.cart', 'vf.auth.token', 'vf.cart.cartCount', 'force_password'];
      cookies.forEach(function (cookie) {
        _this.$cookies.remove(cookie, {
          samesite: 'none',
          secure: true,
          path: '/'
        });
      });
    }
  }, {
    key: "login",
    value: function login(id) {
      var _this2 = this;

      return this.$http.get("".concat(this.apiRoot, "/").concat(id, "/login")).then(function (response) {
        _this2.Localized.setNotifications(response.data);

        if (!response.data.errors.length) {
          _this2.isPunchoutOnly = response.data.punchout_only;

          _this2.clearCookies();

          _this2.updateCookies(response.data);
        }

        return response.data;
      });
    }
  }, {
    key: "openNewTab",
    value: function openNewTab() {
      var url = this.isPunchoutOnly ? '/welcome' : '/';
      this.$window.open(url, 'Logged In As Customer');
    }
  }, {
    key: "updateCookies",
    value: function updateCookies(data) {
      var options = {
        samesite: 'none',
        secure: true,
        path: '/'
      };
      this.$cookies.put('vf.auth.token', data.token, options);
      this.$cookies.put('vf.user.name', data.name, options);
      this.$cookies.put('vf.user.email', data.email, options);
      this.$cookies.put('vf.user.is-guest', data.guest.toString(), options);

      if (data.group) {
        this.$cookies.put('vf.user.group', JSON.stringify(data.group), options);
      }

      if (typeof data.group_admin !== 'undefined') {
        this.$cookies.put('vf.user.group_admin', data.group_admin.toString(), options);
      }

      if (typeof data.approver !== 'undefined') {
        this.$cookies.put('vf.user.approver', data.approver.toString(), options);
      }

      if (data.cart_count) {
        this.$cookies.put('vf.user.cartCount', data.cart_count.toString(), options);
      }

      if (typeof data.punchout_only !== 'undefined') {
        this.$cookies.put('vf.user.punchoutOnly', data.punchout_only.toString(), options);
      }

      if (data.company) {
        this.$cookies.put('vf.user.company', data.company, options);
      }

      if (data.default_billing_profile) {
        this.$cookies.put('vf.user.defaultBillingProfile', data.default_billing_profile.toString(), options);
      }

      if (data.default_shipping_profile) {
        this.$cookies.put('vf.user.defaultShippingProfile', data.default_shipping_profile.toString(), options);
      }

      if (data.group_id) {
        this.$cookies.put('vf.user.group_id', data.group_id.toString(), options);
        this.$cookies.put('vf.user.currentGroup_id', data.group_id.toString(), options);
      }

      if (data.group_parent_id) {
        this.$cookies.put('vf.user.group_parent_id', data.group_parent_id.toString(), options);
      }

      if (typeof data.mixed_punchout !== 'undefined') {
        this.$cookies.put('vf.user.mixedPunchout', data.mixed_punchout.toString(), options);
      }

      if (typeof data.price_availability !== 'undefined') {
        this.$cookies.put('vf.user.price_availability', data.price_availability.toString(), options);
      }

      if (typeof data.cost_center_is_required !== 'undefined') {
        this.$cookies.put('vf.user.cost_center_is_required', data.cost_center_is_required.toString(), options);
      }
    }
  }]);

  return CustomerLoginService;
}();
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customers.service.ts
function customers_service_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customers_service_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customers_service_createClass(Constructor, protoProps, staticProps) { if (protoProps) customers_service_defineProperties(Constructor.prototype, protoProps); if (staticProps) customers_service_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function customers_service_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var CustomersService = /*#__PURE__*/function () {
  CustomersService.$inject = ["$http", "Localized"];

  function CustomersService($http, Localized) {
    'ngInject';

    customers_service_classCallCheck(this, CustomersService);

    customers_service_defineProperty(this, "apiRoot", "".concat(localized.apiURL, "/admin/customers"));

    this.$http = $http;
    this.Localized = Localized;
  }

  customers_service_createClass(CustomersService, [{
    key: "copy",
    value: function copy(id, data) {
      var _this = this;

      return this.$http.post("".concat(this.apiRoot, "/").concat(id, "/copy"), data).then(function (response) {
        _this.Localized.setNotifications(response.data);

        return response.data;
      });
    }
  }, {
    key: "update",
    value: function update(id, data) {
      var _this2 = this;

      return this.$http.put("".concat(this.apiRoot, "/").concat(id), data).then(function (response) {
        _this2.Localized.setNotifications(response.data);

        return response.data;
      });
    }
  }]);

  return CustomersService;
}();
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-send-email/customer-send-email.html
// Module
var code = "<wp-button on-click=\"$ctrl.send()\" is-loading=\"$ctrl.isLoading\">Send {{ $ctrl.emailType === 'register' ? 'Welcome' : 'Verified' }} Email</wp-button> ";
// Exports
/* harmony default export */ const customer_send_email = (code);
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-send-email/customer-send-email.component.ts
function customer_send_email_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_send_email_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_send_email_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_send_email_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_send_email_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var CustomerEmailComponent = {
  bindings: {
    customerId: '<',
    emailType: '@'
  },
  template: customer_send_email,
  controller: /*#__PURE__*/function () {
    CustomerEmailsController.$inject = ["CustomerEmailService"];

    function CustomerEmailsController(CustomerEmailService) {
      'ngInject';

      customer_send_email_component_classCallCheck(this, CustomerEmailsController);

      this.CustomerEmailService = CustomerEmailService;
    }

    customer_send_email_component_createClass(CustomerEmailsController, [{
      key: "send",
      value: function send() {
        var _this = this;

        this.isLoading = true;
        this.CustomerEmailService.send(this.customerId, this.emailType).then(function () {
          _this.isLoading = false;
        });
      }
    }]);

    return CustomerEmailsController;
  }()
};
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-login/customer-login.html
// Module
var customer_login_code = "<wp-button on-click=\"$ctrl.login()\" is-loading=\"$ctrl.isLoading\">{{ $ctrl.isLoading ? 'Signing' : 'Sign' }} in as Customer</wp-button> ";
// Exports
/* harmony default export */ const customer_login = (customer_login_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-login/customer-login.component.ts
function customer_login_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_login_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_login_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_login_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_login_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var CustomerLoginComponent = {
  bindings: {
    customerId: '<'
  },
  template: customer_login,
  controller: /*#__PURE__*/function () {
    CustomerLoginController.$inject = ["CustomerLoginService"];

    function CustomerLoginController(CustomerLoginService) {
      'ngInject';

      customer_login_component_classCallCheck(this, CustomerLoginController);

      this.CustomerLoginService = CustomerLoginService;
    }

    customer_login_component_createClass(CustomerLoginController, [{
      key: "login",
      value: function login() {
        var _this = this;

        this.isLoading = true;
        this.CustomerLoginService.login(this.customerId).then(function () {
          _this.isLoading = false;

          _this.CustomerLoginService.openNewTab();
        });
      }
    }]);

    return CustomerLoginController;
  }()
};
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-notes/customer-notes.html
// Module
var customer_notes_code = "<wp-spinner ng-if=\"$ctrl.isLoading\"> </wp-spinner> <ul class=\"list-group mb-3\" ng-if=\"$ctrl.notes.data.length\"> <li class=\"list-group-item\" ng-repeat=\"note in $ctrl.notes.data\"> <p class=\"fs-6\">{{ note.content }}</p> <p class=\"small text-muted\"> Created {{ note.created_at | date: 'short' }} by <a ng-href=\"mailto:{{ note.admin.email }}\">{{ note.admin.name }}</a> </p> <wp-button on-delete=\"$ctrl.remove( note.id )\">Delete</wp-button> </li> </ul> <bs-pagination data=\"$ctrl.notes\" is-loading=\"$ctrl.isLoading\" ng-if=\"$ctrl.data.total\" on-change=\"$ctrl.changePage(page, rpp)\"> </bs-pagination> <form name=\"notesForm\"> <fieldset> <wp-form-field label=\"Add Note\" field=\"$ctrl.content\" type=\"textarea\" on-change=\"$ctrl.change('content', value)\"></wp-form-field> </fieldset> <wp-button on-click=\"$ctrl.save()\" is-primary=\"true\" is-loading=\"$ctrl.isSaving\">{{ $ctrl.isSaving ? 'Saving' : 'Save' }}</wp-button> </form> ";
// Exports
/* harmony default export */ const customer_notes = (customer_notes_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-notes/customer-notes.component.ts
function customer_notes_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_notes_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_notes_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_notes_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_notes_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var CustomerNotesComponent = {
  bindings: {
    customerId: '<'
  },
  template: customer_notes,
  controller: /*#__PURE__*/function () {
    CustomerNotesController.$inject = ["CustomerNotesService"];

    function CustomerNotesController(CustomerNotesService) {
      'ngInject';

      customer_notes_component_classCallCheck(this, CustomerNotesController);

      this.CustomerNotesService = CustomerNotesService;
    }

    customer_notes_component_createClass(CustomerNotesController, [{
      key: "$onInit",
      value: function $onInit() {
        this.params = {
          page: 1,
          rpp: 15
        };

        if (this.customerId) {
          this.queryNotes();
        }
      }
    }, {
      key: "change",
      value: function change(key, value) {
        this.content = value;
      }
    }, {
      key: "changePage",
      value: function changePage(page, rpp) {
        this.params.page = page;
        this.params.rpp = rpp;
        this.queryNotes();
      }
    }, {
      key: "queryNotes",
      value: function queryNotes() {
        var _this = this;

        this.isLoading = true;
        this.CustomerNotesService.query(this.customerId).then(function (response) {
          _this.notes = response.notes;
          _this.isLoading = false;
        });
      }
    }, {
      key: "remove",
      value: function remove(noteId) {
        var _this2 = this;

        this.CustomerNotesService.remove(this.customerId, noteId).then(function () {
          _this2.queryNotes();
        });
      }
    }, {
      key: "save",
      value: function save() {
        var _this3 = this;

        this.isSaving = true;
        var data = {
          content: this.content
        };
        this.CustomerNotesService.save(this.customerId, data).then(function () {
          _this3.content = '';
          _this3.isSaving = false;

          _this3.queryNotes();
        });
      }
    }]);

    return CustomerNotesController;
  }()
};
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-punchout-tab/customer-punchout-tab.html
// Module
var customer_punchout_tab_code = "<h4>Punchout</h4> <form name=\"punchoutForm\" class=\"mb-3\"> <fieldset ng-disabled=\"$ctrl.isUpdating\"> <wp-form-field description=\"Define an identity for this customer to punch in to your catalog.\" label=\"Punchin Identity\" field=\"$ctrl.customer.punchin_identity\" type=\"text\"></wp-form-field> <wp-form-field description=\"Define an identity secret for this customer to punch in to your catalog.\" label=\"Punchin Secret\" field=\"$ctrl.customer.punchin_secret\" type=\"text\"></wp-form-field> <wp-form-field description=\"Allow user to see both Punchout and non-Punchout catalogs.\" label=\"Enable Mixed Punchout\" field=\"$ctrl.customer.mixed_punchout\" type=\"checkbox\" on-change=\"$ctrl.change('mixed_punchout', value)\"></wp-form-field> <wp-form-field description=\"Performs a price and availability check on Punchout items during Checkout process.\" label=\"Enable Price Availability Check\" field=\"$ctrl.customer.price_availability\" type=\"checkbox\" on-change=\"$ctrl.change('price_availability', value)\"></wp-form-field> </fieldset> <wp-button on-click=\"$ctrl.update()\" is-primary=\"true\" is-loading=\"$ctrl.isUpdating\">{{ $ctrl.isUpdating ? 'Updating' : 'Update' }}</wp-button> </form> <h5>Punchout Suppliers</h5> <table class=\"table caption-top\" ng-if=\"$ctrl.customer.punchout_suppliers.length\"> <caption> Attached Suppliers </caption> <tbody> <tr class=\"align-center\" ng-repeat=\"supplier in $ctrl.customer.punchout_suppliers track by $index\"> <td class=\"col-sm-3\"> <img class=\"img-fluid\" ng-attr-alt=\"{{ supplier.name }}\" ng-if=\"supplier.logo\" ng-src=\"{{ supplier.logo }}\"/> </td> <td class=\"col-sm-4 align-bottom\"> <span>{{ supplier.name }}</span> </td> <td class=\"col-sm-4 text-end\"> <wp-button on-click=\"$ctrl.detachSupplier(supplier.id)\" is-loading=\"$ctrl.isDetaching[supplier.id]\">{{ $ctrl.isDetaching[supplier.id] ? 'Detaching' : 'Detach' }}</wp-button> </td> </tr> </tbody> </table> <table class=\"table caption-top\" ng-if=\"$ctrl.availableSuppliers.length\"> <caption> Available Suppliers </caption> <tbody> <tr class=\"align-center\" ng-repeat=\"supplier in $ctrl.availableSuppliers track by $index\"> <td class=\"col-sm-3\"> <img class=\"img-fluid\" ng-attr-alt=\"{{ supplier.name }}\" ng-if=\"supplier.logo\" ng-src=\"{{ supplier.logo }}\"/> </td> <td class=\"col align-bottom\"> <span>{{ supplier.name }}</span> </td> <td class=\"col-auto text-end\"> <wp-button on-click=\"$ctrl.attachSupplier( supplier.id )\" is-loading=\"$ctrl.isAttaching[ supplier.id ]\">{{ $ctrl.isAttaching[ supplier.id ] ? 'Attaching' : 'Attach' }}</wp-button> </td> </tr> </tbody> </table> ";
// Exports
/* harmony default export */ const customer_punchout_tab = (customer_punchout_tab_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-punchout-tab/customer-punchout-tab.component.ts
function customer_punchout_tab_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_punchout_tab_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_punchout_tab_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_punchout_tab_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_punchout_tab_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function customer_punchout_tab_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


var CustomerPunchoutTabComponent = {
  template: customer_punchout_tab,
  bindings: {
    customer: '<',
    suppliers: '<'
  },
  controller: /*#__PURE__*/function () {
    CustomerPunchoutTabController.$inject = ["CustomersService"];

    function CustomerPunchoutTabController(CustomersService) {
      'ngInject';

      customer_punchout_tab_component_classCallCheck(this, CustomerPunchoutTabController);

      customer_punchout_tab_component_defineProperty(this, "isAttaching", []);

      customer_punchout_tab_component_defineProperty(this, "isDetaching", []);

      this.CustomersService = CustomersService;
    }

    customer_punchout_tab_component_createClass(CustomerPunchoutTabController, [{
      key: "$onInit",
      value: function $onInit() {
        if (this.customer.punchout_suppliers) {
          this.availableSuppliers = this.getAvailableSuppliers(this.customer.punchout_suppliers, this.suppliers);
        }
      }
    }, {
      key: "attachSupplier",
      value: function attachSupplier(id) {
        var _this = this;

        this.isAttaching[id] = true;
        var data = {
          name: this.customer.name,
          punchout_suppliers: [{
            id: id
          }]
        };
        this.CustomersService.update(this.customer.id, data).then(function (response) {
          _this.customer = response.customer;
          _this.availableSuppliers = _this.getAvailableSuppliers(_this.customer.punchout_suppliers, _this.suppliers);
          _this.isAttaching[id] = false;
        });
      }
    }, {
      key: "change",
      value: function change(key, value) {
        this.customer[key] = value;
      }
    }, {
      key: "detachSupplier",
      value: function detachSupplier(id) {
        var _this2 = this;

        this.isDetaching[id] = true;
        var data = {
          name: this.customer.name,
          punchout_suppliers: [{
            id: id,
            deleted: true
          }]
        };
        this.CustomersService.update(this.customer.id, data).then(function (response) {
          _this2.customer = response.customer;
          _this2.availableSuppliers = _this2.getAvailableSuppliers(_this2.customer.punchout_suppliers, _this2.suppliers);
          _this2.isDetaching[id] = false;
        });
      }
    }, {
      key: "getAvailableSuppliers",
      value: function getAvailableSuppliers(attachedSuppliers, suppliers) {
        var ids = attachedSuppliers.map(function (el) {
          return el.id;
        });
        return suppliers.filter(function (supplier) {
          return !ids.includes(supplier.id);
        });
      }
    }, {
      key: "update",
      value: function update() {
        var _this3 = this;

        this.isUpdating = true;
        var data = {
          name: this.customer.name,
          mixed_punchout: this.customer.mixed_punchout,
          punchout_only: this.customer.punchout_only
        };
        this.CustomersService.update(this.customer.id, data).then(function () {
          _this3.isUpdating = false;
        });
      }
    }]);

    return CustomerPunchoutTabController;
  }()
};
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-copy-button/customer-copy-button.html
// Module
var customer_copy_button_code = "<wp-button on-click=\"$ctrl.openModal()\">Copy to New Customer </wp-button> <div class=\"modal fade\" id=\"copyCustomerModal\" tabindex=\"-1\" aria-labelledby=\"copyCustomerModalLabel\" aria-hidden=\"true\"> <div class=\"modal-dialog\"> <div class=\"modal-content\"> <form name=\"copyCustomerForm\" ng-submit=\"$ctrl.copyCustomer()\"> <div class=\"modal-header\"> <h5 class=\"modal-title\" id=\"copyCustomerModalLabel\"> Copy to New Customer </h5> <button type=\"button\" class=\"btn-close\" data-bs-dismiss=\"modal\" aria-label=\"Close\"></button> </div> <div class=\"modal-body\"> <wp-notice-list></wp-notice-list> <div class=\"mb-3\"> <label for=\"email\" class=\"form-label\">Email address</label> <input type=\"email\" id=\"email\" autocomplete=\"email\" name=\"email\" required ng-class=\"['form-control', {\n\t\t\t\t\t\t'is-valid': copyCustomerForm.email.$valid\n\t\t\t\t\t}]\" ng-model=\"$ctrl.email\"> <div class=\"form-text\">Please email a unique email address for the copied customer. The address must not be used for an existing customer account.</div> </div> <div class=\"mb-3\"> <label for=\"tempPassword\" class=\"form-label\">Temporary Password</label> <div class=\"hstack gap-1 align-items-stretch\"> <input name=\"tempPassword\" id=\"temp-password\" autocomplete=\"new-password\" required ng-class=\"['form-control', {\n\t\t\t\t\t\t\t'is-valid': $ctrl.passwordHas.all( $ctrl.tempPassword )\n\t\t\t\t\t\t}]\" ng-model=\"$ctrl.tempPassword\" ng-attr-type=\"{{ $ctrl.isShowingPassword ? 'text' : 'password' }}\"> <button class=\"button\" type=\"button\" ng-click=\"$ctrl.isShowingPassword = !$ctrl.isShowingPassword\" ng-attr-aria-label=\"{{ $ctrl.isShowingPassword ? 'Hide password' : 'Show password' }}\"> <i aria-hidden=\"true\" ng-class=\"['bi', {\n\t\t\t\t\t\t\t\t'bi-eye-fill': !$ctrl.isShowingPassword,\n\t\t\t\t\t\t\t\t'bi-eye-slash-fill': $ctrl.isShowingPassword\n\t\t\t\t\t\t\t}]\"></i> </button> </div> <ul class=\"list-inline form-text\"> <li class=\"list-inline-item mb-0 me-0\">Your password must contain at least</li> <li ng-class=\"['list-inline-item mb-0 me-0', {\n\t\t\t\t\t\t\t'text-success': $ctrl.passwordHas.length( $ctrl.tempPassword )\n\t\t\t\t\t\t}]\">8 characters,</li> <li ng-class=\"['list-inline-item mb-0 me-0', {\n\t\t\t\t\t\t\t'text-success': $ctrl.passwordHas.symbol( $ctrl.tempPassword )\n\t\t\t\t\t\t}]\">a special character,</li> <li ng-class=\"['list-inline-item mb-0 me-0', {\n\t\t\t\t\t\t\t'text-success': $ctrl.passwordHas.number( $ctrl.tempPassword )\n\t\t\t\t\t\t}]\">a number,</li> <li ng-class=\"['list-inline-item mb-0 me-0', {\n\t\t\t\t\t\t\t'text-success': $ctrl.passwordHas.uppercase( $ctrl.tempPassword )\n\t\t\t\t\t\t}]\">a uppercase letter,</li> <li ng-class=\"['list-inline-item mb-0 me-0', {\n\t\t\t\t\t\t\t'text-success': $ctrl.passwordHas.lowercase( $ctrl.tempPassword )\n\t\t\t\t\t\t}]\">a lowercase letter.</li> </ul> </div> <div class=\"mb-3\"> <label for=\"temp-password-confirmation\" class=\"form-label\">Temporary Password Confirmation</label> <div class=\"hstack gap-1 align-items-stretch\"> <input name=\"tempPasswordConfirmation\" id=\"tempPasswordConfirmation\" autocomplete=\"new-password\" required ng-class=\"['form-control', {\n\t\t\t\t\t\t\t'is-valid': $ctrl.passwordHas.all( $ctrl.tempPassword ) &&\n\t\t\t\t\t\t\t\t$ctrl.tempPassword === $ctrl.tempPasswordConfirmation\n\t\t\t\t\t\t}]\" ng-model=\"$ctrl.tempPasswordConfirmation\" ng-attr-type=\"{{ $ctrl.isShowingPasswordConfirmation ? 'text' : 'password' }}\"> <button class=\"button\" type=\"button\" ng-click=\"$ctrl.isShowingPasswordConfirmation = !$ctrl.isShowingPasswordConfirmation\" ng-attr-aria-label=\"{{ $ctrl.isShowingPasswordConfirmation ? 'Hide password' : 'Show password' }}\"> <i aria-hidden=\"true\" ng-class=\"['bi', {\n\t\t\t\t\t\t\t\t'bi-eye-fill': !$ctrl.isShowingPasswordConfirmation,\n\t\t\t\t\t\t\t\t'bi-eye-slash-fill': $ctrl.isShowingPasswordConfirmation\n\t\t\t\t\t\t\t}]\"></i> </button> </div> <div ng-class=\"['form-text', {\n\t\t\t\t\t\t'text-success': $ctrl.passwordHas.all( $ctrl.tempPassword ) && $ctrl.tempPassword === $ctrl.tempPasswordConfirmation\n\t\t\t\t\t}]\">Please retype your temporary password for confirmation.</div> </div> </div> <div class=\"modal-footer\"> <button type=\"button\" class=\"button me-1\" data-bs-dismiss=\"modal\"> Cancel </button> <button type=\"submit\" class=\"button button-primary\" ng-disabled=\"!( copyCustomerForm.$valid &&\n\t\t\t  \t$ctrl.passwordHas.all( $ctrl.tempPassword ) &&\n\t\t\t\t$ctrl.tempPassword === $ctrl.tempPasswordConfirmation) || $ctrl.isCopying\"> {{ $ctrl.isCopying ? 'Copying' : 'Copy' }}</button> </div></form> </div> </div> </div> ";
// Exports
/* harmony default export */ const customer_copy_button = (customer_copy_button_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-copy-button/customer-copy-button.component.ts
var _class;

function customer_copy_button_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_copy_button_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_copy_button_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_copy_button_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_copy_button_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function customer_copy_button_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


var CustomerCopyButtonComponent = {
  bindings: {
    customerId: '<',
    onCopy: '&'
  },
  template: customer_copy_button,
  controller: (_class = /*#__PURE__*/function () {
    function CustomerCopyButtonController(CustomersService) {
      var _this = this;

      customer_copy_button_component_classCallCheck(this, CustomerCopyButtonController);

      customer_copy_button_component_defineProperty(this, "passwordHas", {
        all: function all(password) {
          return _this.passwordHas.length(password) && _this.passwordHas.uppercase(password) && _this.passwordHas.lowercase(password) && _this.passwordHas.number(password) && _this.passwordHas.symbol(password);
        },
        length: function length(password) {
          return (password === null || password === void 0 ? void 0 : password.length) >= 8;
        },
        uppercase: function uppercase(password) {
          return password && RegExp('[A-Z]').test(password);
        },
        lowercase: function lowercase(password) {
          return password && RegExp('[a-z]').test(password);
        },
        number: function number(password) {
          return password && RegExp('[0-9]').test(password);
        },
        symbol: function symbol(password) {
          return password && /[ \xA0\u1680\u2000-\u200A\u2028\u2029\u202F\u205F\u3000]|(?:[\$\+<->\^`\|~\xA2-\xA6\xA8\xA9\xAC\xAE-\xB1\xB4\xB8\xD7\xF7\u02C2-\u02C5\u02D2-\u02DF\u02E5-\u02EB\u02ED\u02EF-\u02FF\u0375\u0384\u0385\u03F6\u0482\u058D-\u058F\u0606-\u0608\u060B\u060E\u060F\u06DE\u06E9\u06FD\u06FE\u07F6\u07FE\u07FF\u0888\u09F2\u09F3\u09FA\u09FB\u0AF1\u0B70\u0BF3-\u0BFA\u0C7F\u0D4F\u0D79\u0E3F\u0F01-\u0F03\u0F13\u0F15-\u0F17\u0F1A-\u0F1F\u0F34\u0F36\u0F38\u0FBE-\u0FC5\u0FC7-\u0FCC\u0FCE\u0FCF\u0FD5-\u0FD8\u109E\u109F\u1390-\u1399\u166D\u17DB\u1940\u19DE-\u19FF\u1B61-\u1B6A\u1B74-\u1B7C\u1FBD\u1FBF-\u1FC1\u1FCD-\u1FCF\u1FDD-\u1FDF\u1FED-\u1FEF\u1FFD\u1FFE\u2044\u2052\u207A-\u207C\u208A-\u208C\u20A0-\u20C0\u2100\u2101\u2103-\u2106\u2108\u2109\u2114\u2116-\u2118\u211E-\u2123\u2125\u2127\u2129\u212E\u213A\u213B\u2140-\u2144\u214A-\u214D\u214F\u218A\u218B\u2190-\u2307\u230C-\u2328\u232B-\u2426\u2440-\u244A\u249C-\u24E9\u2500-\u2767\u2794-\u27C4\u27C7-\u27E5\u27F0-\u2982\u2999-\u29D7\u29DC-\u29FB\u29FE-\u2B73\u2B76-\u2B95\u2B97-\u2BFF\u2CE5-\u2CEA\u2E50\u2E51\u2E80-\u2E99\u2E9B-\u2EF3\u2F00-\u2FD5\u2FF0-\u2FFB\u3004\u3012\u3013\u3020\u3036\u3037\u303E\u303F\u309B\u309C\u3190\u3191\u3196-\u319F\u31C0-\u31E3\u3200-\u321E\u322A-\u3247\u3250\u3260-\u327F\u328A-\u32B0\u32C0-\u33FF\u4DC0-\u4DFF\uA490-\uA4C6\uA700-\uA716\uA720\uA721\uA789\uA78A\uA828-\uA82B\uA836-\uA839\uAA77-\uAA79\uAB5B\uAB6A\uAB6B\uFB29\uFBB2-\uFBC2\uFD40-\uFD4F\uFDCF\uFDFC-\uFDFF\uFE62\uFE64-\uFE66\uFE69\uFF04\uFF0B\uFF1C-\uFF1E\uFF3E\uFF40\uFF5C\uFF5E\uFFE0-\uFFE6\uFFE8-\uFFEE\uFFFC\uFFFD]|\uD800[\uDD37-\uDD3F\uDD79-\uDD89\uDD8C-\uDD8E\uDD90-\uDD9C\uDDA0\uDDD0-\uDDFC]|\uD802[\uDC77\uDC78\uDEC8]|\uD805\uDF3F|\uD807[\uDFD5-\uDFF1]|\uD81A[\uDF3C-\uDF3F\uDF45]|\uD82F\uDC9C|\uD833[\uDF50-\uDFC3]|\uD834[\uDC00-\uDCF5\uDD00-\uDD26\uDD29-\uDD64\uDD6A-\uDD6C\uDD83\uDD84\uDD8C-\uDDA9\uDDAE-\uDDEA\uDE00-\uDE41\uDE45\uDF00-\uDF56]|\uD835[\uDEC1\uDEDB\uDEFB\uDF15\uDF35\uDF4F\uDF6F\uDF89\uDFA9\uDFC3]|\uD836[\uDC00-\uDDFF\uDE37-\uDE3A\uDE6D-\uDE74\uDE76-\uDE83\uDE85\uDE86]|\uD838[\uDD4F\uDEFF]|\uD83B[\uDCAC\uDCB0\uDD2E\uDEF0\uDEF1]|\uD83C[\uDC00-\uDC2B\uDC30-\uDC93\uDCA0-\uDCAE\uDCB1-\uDCBF\uDCC1-\uDCCF\uDCD1-\uDCF5\uDD0D-\uDDAD\uDDE6-\uDE02\uDE10-\uDE3B\uDE40-\uDE48\uDE50\uDE51\uDE60-\uDE65\uDF00-\uDFFF]|\uD83D[\uDC00-\uDED7\uDEDD-\uDEEC\uDEF0-\uDEFC\uDF00-\uDF73\uDF80-\uDFD8\uDFE0-\uDFEB\uDFF0]|\uD83E[\uDC00-\uDC0B\uDC10-\uDC47\uDC50-\uDC59\uDC60-\uDC87\uDC90-\uDCAD\uDCB0\uDCB1\uDD00-\uDE53\uDE60-\uDE6D\uDE70-\uDE74\uDE78-\uDE7C\uDE80-\uDE86\uDE90-\uDEAC\uDEB0-\uDEBA\uDEC0-\uDEC5\uDED0-\uDED9\uDEE0-\uDEE7\uDEF0-\uDEF6\uDF00-\uDF92\uDF94-\uDFCA])|(?:[!-#%-\*,-\/:;\?@\[-\]_\{\}\xA1\xA7\xAB\xB6\xB7\xBB\xBF\u037E\u0387\u055A-\u055F\u0589\u058A\u05BE\u05C0\u05C3\u05C6\u05F3\u05F4\u0609\u060A\u060C\u060D\u061B\u061D-\u061F\u066A-\u066D\u06D4\u0700-\u070D\u07F7-\u07F9\u0830-\u083E\u085E\u0964\u0965\u0970\u09FD\u0A76\u0AF0\u0C77\u0C84\u0DF4\u0E4F\u0E5A\u0E5B\u0F04-\u0F12\u0F14\u0F3A-\u0F3D\u0F85\u0FD0-\u0FD4\u0FD9\u0FDA\u104A-\u104F\u10FB\u1360-\u1368\u1400\u166E\u169B\u169C\u16EB-\u16ED\u1735\u1736\u17D4-\u17D6\u17D8-\u17DA\u1800-\u180A\u1944\u1945\u1A1E\u1A1F\u1AA0-\u1AA6\u1AA8-\u1AAD\u1B5A-\u1B60\u1B7D\u1B7E\u1BFC-\u1BFF\u1C3B-\u1C3F\u1C7E\u1C7F\u1CC0-\u1CC7\u1CD3\u2010-\u2027\u2030-\u2043\u2045-\u2051\u2053-\u205E\u207D\u207E\u208D\u208E\u2308-\u230B\u2329\u232A\u2768-\u2775\u27C5\u27C6\u27E6-\u27EF\u2983-\u2998\u29D8-\u29DB\u29FC\u29FD\u2CF9-\u2CFC\u2CFE\u2CFF\u2D70\u2E00-\u2E2E\u2E30-\u2E4F\u2E52-\u2E5D\u3001-\u3003\u3008-\u3011\u3014-\u301F\u3030\u303D\u30A0\u30FB\uA4FE\uA4FF\uA60D-\uA60F\uA673\uA67E\uA6F2-\uA6F7\uA874-\uA877\uA8CE\uA8CF\uA8F8-\uA8FA\uA8FC\uA92E\uA92F\uA95F\uA9C1-\uA9CD\uA9DE\uA9DF\uAA5C-\uAA5F\uAADE\uAADF\uAAF0\uAAF1\uABEB\uFD3E\uFD3F\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE61\uFE63\uFE68\uFE6A\uFE6B\uFF01-\uFF03\uFF05-\uFF0A\uFF0C-\uFF0F\uFF1A\uFF1B\uFF1F\uFF20\uFF3B-\uFF3D\uFF3F\uFF5B\uFF5D\uFF5F-\uFF65]|\uD800[\uDD00-\uDD02\uDF9F\uDFD0]|\uD801\uDD6F|\uD802[\uDC57\uDD1F\uDD3F\uDE50-\uDE58\uDE7F\uDEF0-\uDEF6\uDF39-\uDF3F\uDF99-\uDF9C]|\uD803[\uDEAD\uDF55-\uDF59\uDF86-\uDF89]|\uD804[\uDC47-\uDC4D\uDCBB\uDCBC\uDCBE-\uDCC1\uDD40-\uDD43\uDD74\uDD75\uDDC5-\uDDC8\uDDCD\uDDDB\uDDDD-\uDDDF\uDE38-\uDE3D\uDEA9]|\uD805[\uDC4B-\uDC4F\uDC5A\uDC5B\uDC5D\uDCC6\uDDC1-\uDDD7\uDE41-\uDE43\uDE60-\uDE6C\uDEB9\uDF3C-\uDF3E]|\uD806[\uDC3B\uDD44-\uDD46\uDDE2\uDE3F-\uDE46\uDE9A-\uDE9C\uDE9E-\uDEA2]|\uD807[\uDC41-\uDC45\uDC70\uDC71\uDEF7\uDEF8\uDFFF]|\uD809[\uDC70-\uDC74]|\uD80B[\uDFF1\uDFF2]|\uD81A[\uDE6E\uDE6F\uDEF5\uDF37-\uDF3B\uDF44]|\uD81B[\uDE97-\uDE9A\uDFE2]|\uD82F\uDC9F|\uD836[\uDE87-\uDE8B]|\uD83A[\uDD5E\uDD5F])/.test(password);
        }
      });

      this.CustomersService = CustomersService;
      this.modal = new bootstrap.Modal(document.getElementById('copyCustomerModal'));
    }

    customer_copy_button_component_createClass(CustomerCopyButtonController, [{
      key: "copyCustomer",
      value: function copyCustomer() {
        var _this2 = this;

        this.isCopying = true;
        var data = {
          email: this.email,
          temp_password: this.tempPassword,
          temp_password_confirmation: this.tempPasswordConfirmation
        };
        this.CustomersService.copy(this.customerId, data).then(function (response) {
          _this2.isCopying = false;

          if (!response.errors.length) {
            var copiedCustomer = response.customer;

            _this2.onCopy({
              copiedCustomer: copiedCustomer
            });

            _this2.modal.hide();
          }
        });
      }
    }, {
      key: "openModal",
      value: function openModal() {
        this.modal.show();
      }
    }]);

    return CustomerCopyButtonController;
  }(), customer_copy_button_component_defineProperty(_class, "$inject", ['CustomersService']), _class)
};
;// CONCATENATED MODULE: ./assets/app/dev/common/usStates.ts
var usStates = [{
  name: 'Alabama',
  val: 'AL'
}, {
  name: 'Alaska',
  val: 'AK'
}, {
  name: 'Arizona',
  val: 'AZ'
}, {
  name: 'Arkansas',
  val: 'AR'
}, {
  name: 'California',
  val: 'CA'
}, {
  name: 'Colorado',
  val: 'CO'
}, {
  name: 'Connecticut',
  val: 'CT'
}, {
  name: 'Delaware',
  val: 'DE'
}, {
  name: 'Florida',
  val: 'FL'
}, {
  name: 'Georgia',
  val: 'GA'
}, {
  name: 'Hawaii',
  val: 'HI'
}, {
  name: 'Idaho',
  val: 'ID'
}, {
  name: 'Illinois',
  val: 'IL'
}, {
  name: 'Indiana',
  val: 'IN'
}, {
  name: 'Iowa',
  val: 'IA'
}, {
  name: 'Kansas',
  val: 'KS'
}, {
  name: 'Kentucky',
  val: 'KY'
}, {
  name: 'Louisiana',
  val: 'LA'
}, {
  name: 'Maine',
  val: 'ME'
}, {
  name: 'Maryland',
  val: 'MD'
}, {
  name: 'Massachusetts',
  val: 'MA'
}, {
  name: 'Michigan',
  val: 'MI'
}, {
  name: 'Minnesota',
  val: 'MN'
}, {
  name: 'Mississippi',
  val: 'MS'
}, {
  name: 'Missouri',
  val: 'MO'
}, {
  name: 'Montana',
  val: 'MT'
}, {
  name: 'Nebraska',
  val: 'NE'
}, {
  name: 'Nevada',
  val: 'NV'
}, {
  name: 'New Hampshire',
  val: 'NH'
}, {
  name: 'New Jersey',
  val: 'NJ'
}, {
  name: 'New Mexico',
  val: 'NM'
}, {
  name: 'New York',
  val: 'NY'
}, {
  name: 'North Carolina',
  val: 'NC'
}, {
  name: 'North Dakota',
  val: 'ND'
}, {
  name: 'Ohio',
  val: 'OH'
}, {
  name: 'Oklahoma',
  val: 'OK'
}, {
  name: 'Oregon',
  val: 'OR'
}, {
  name: 'Pennsylvania',
  val: 'PA'
}, {
  name: 'Rhode Island',
  val: 'RI'
}, {
  name: 'South Carolina',
  val: 'SC'
}, {
  name: 'South Dakota',
  val: 'SD'
}, {
  name: 'Tennessee',
  val: 'TN'
}, {
  name: 'Texas',
  val: 'TX'
}, {
  name: 'Utah',
  val: 'UT'
}, {
  name: 'Vermont',
  val: 'VT'
}, {
  name: 'Virgin Islands',
  val: 'VI'
}, {
  name: 'Virginia',
  val: 'VA'
}, {
  name: 'Washington',
  val: 'WA'
}, {
  name: 'West Virginia',
  val: 'WV'
}, {
  name: 'Wisconsin',
  val: 'WI'
}, {
  name: 'Wyoming',
  val: 'WY'
}];
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-address-modal/customer-address-modal.html
// Module
var customer_address_modal_code = "<div class=\"modal-header justify-content-start align-items-center\"> <h3 class=\"h5 modal-title text-capitalize mr-2\" id=\"modal-title\"> {{ $ctrl.key }} Addresses </h3> <button class=\"btn btn-secondary\" ng-click=\"$ctrl.add()\" ng-disabled=\"$ctrl.isAdding\"> Add New </button> </div> <div class=\"modal-body\" id=\"modal-body\"> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <form ng-hide=\"$ctrl.isLoading || $ctrl.isAdding || $ctrl.isEditing\"> <p class=\"search-box\"> <label class=\"screen-reader-text\" for=\"address-filter-input\">Filter Addresses:</label> <input type=\"search\" id=\"address-filter-input\" ng-model=\"$ctrl.q\"/> <input type=\"submit\" id=\"search-submit\" class=\"btn btn-secondary\" value=\"Filter Addresses\"/> </p> <div class=\"tablenav top\"> <div class=\"tablenav-pages\"> <span class=\"displaying-num\"> {{ $ctrl.addresses.length }} items </span> </div> </div> <table class=\"wp-list-table widefat striped table-view-list\"> <thead> <tr> <th scope=\"col\">Profile Name</th> <th scope=\"col\">Recipient</th> <th scope=\"col\">Email</th> <th scope=\"col\">Phone</th> </tr> </thead> <tbody> <tr ng-repeat=\"item in $ctrl.addresses | filter:$ctrl.q track by $index\"> <td> {{ item.billing_name ? item.billing_name : item.shipping_name ? item.shipping_name : '&mdash;' }} </td> <td class=\"has-row-actions column-primary\"> <strong ng-if=\"item.first_name || item.last_name\"> {{ item.first_name }} {{ item.last_name }}<br/> </strong> {{ item.address1 }}<br ng-if=\"item.address2\"/> {{ item.address2 }}<br/> {{ item.city }}, {{ item.state }} {{ item.zip }} <div class=\"row-actions\"> <span class=\"edit\"> <a href=\"#\" ng-click=\"$ctrl.edit($event, item)\"> Edit </a> </span> | <span class=\"trash\"> <a href=\"#\" ng-click=\"$event.preventDefault(); $ctrl.isConfirmingDeletion[ $index ] = true\" ng-hide=\"$ctrl.isConfirmingDeletion[ $index ]\"> Delete </a> <span ng-if=\"$ctrl.isConfirmingDeletion[ $index ]\"> <span class=\"text-muted\">Delete this?</span> <a href=\"#\" class=\"text-dark\" ng-click=\"$event.preventDefault(); $ctrl.isConfirmingDeletion[ $index ] = false\"> Cancel </a> | <a href=\"#\" ng-click=\"$ctrl.trash($event, item)\"> <strong> {{ $ctrl.isDeleting ? 'Deleting' : 'Delete' }} </strong> </a> </span> </span> </div> </td> <td> <a ng-href=\"{{ 'mailto:' + item.email }}\" ng-if=\"item.email\"> {{ item.email }} </a> <span ng-if=\"!item.email\"> &mdash; </span> </td> <td> <span ng-if=\"item.phone\"> {{ item.phone | tel }} </span> <span ng-if=\"!item.phone\"> &mdash; </span> </td> </tr> <tr ng-if=\"!$ctrl.addresses.length\"> <td colspan=\"4\">No {{ $ctrl.key }} profiles created yet.</td> </tr> </tbody> </table> </form> <form name=\"form\" ng-if=\"$ctrl.isAdding || $ctrl.isEditing\" ng-hide=\"$ctrl.isLoading\"> <h4 class=\"h6 text-capitalize\"> {{ $ctrl.isAdding ? 'Add' : 'Edit' }} {{ $ctrl.key }} Address </h4> <table class=\"form-table\" role=\"presentation\"> <tbody> <tr> <th> <label class=\"form-label\" for=\"profile\"> Profile Name </label> </th> <td> <input class=\"regular-text\" id=\"profile\" name=\"profile\" type=\"text\" maxlength=\"250\" ng-model=\"$ctrl.address[ $ctrl.key + '_name' ]\"/> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"first_name\"> First Name </label> </th> <td> <input class=\"regular-text\" id=\"first_name\" name=\"first_name\" type=\"text\" autocomplete=\"given-name\" maxlength=\"250\" ng-model=\"$ctrl.address.first_name\"/> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"last_name\"> Last Name </label> </th> <td> <input class=\"regular-text\" id=\"last_name\" name=\"last_name\" type=\"text\" autocomplete=\"family-name\" ng-model=\"$ctrl.address.last_name\"/> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"email\"> Email </label> </th> <td> <input class=\"regular-text\" id=\"email\" name=\"email\" type=\"email\" autocomplete=\"email\" maxlength=\"250\" ng-model=\"$ctrl.address.email\"/> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"phone\"> Phone </label> </th> <td> <input class=\"regular-text\" id=\"phone\" name=\"phone\" type=\"tel\" autocomplete=\"tel\" ng-model=\"$ctrl.address.phone\" tel-input maxlength=\"14\"/> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"address1\"> Street Address <span class=\"description\">(required)</span> </label> </th> <td> <input class=\"regular-text\" id=\"address1\" name=\"address1\" type=\"text\" required autocomplete=\"street-address\" maxlength=\"250\" ng-model=\"$ctrl.address.address1\"/> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"address2\"> Apt., Suite, etc. </label> </th> <td> <input class=\"regular-text\" id=\"address2\" name=\"address2\" type=\"text\" ng-model=\"$ctrl.address.address2\"/> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"city\"> City <span class=\"description\">(required)</span> </label> </th> <td> <input id=\"city\" name=\"city\" type=\"text\" autocomplete=\"address-level2\" required ng-model=\"$ctrl.address.city\"/> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"state\"> State <span class=\"description\">(required)</span> </label> </th> <td> <select name=\"state\" id=\"state\" required ng-model=\"$ctrl.address.state\" ng-options=\"state.val as state.name for state in $ctrl.usStates\"> <option value=\"\" hidden disabled=\"disabled\">Select a State</option> </select> </td> </tr> <tr> <th> <label class=\"form-label\" for=\"zip\"> Zip <span class=\"description\">(required)</span> </label> </th> <td> <input id=\"zip\" name=\"zip\" type=\"text\" autocomplete=\"postal-code\" required maxlength=\"10\" ng-model=\"$ctrl.address.zip\"/> </td> </tr> </tbody> </table> <div class=\"d-flex justify-content-end\"> <button class=\"btn btn-primary\" ng-show=\"$ctrl.isAdding\" ng-click=\"$ctrl.create()\" ng-disabled=\"$ctrl.isCreating || form.$pristine || form.$invalid\"> <wp-spinner type=\"loading\" ng-show=\"$ctrl.isCreating\"> </wp-spinner> {{ $ctrl.isCreating ? 'Adding' : 'Add' }} New Address </button> <button class=\"btn btn-primary\" ng-show=\"$ctrl.isEditing\" ng-click=\"$ctrl.update()\" ng-disabled=\"$ctrl.isUpdating || form.$pristine || form.$invalid\"> <wp-spinner type=\"loading\" ng-show=\"$ctrl.isUpdating\"> </wp-spinner> {{ $ctrl.isUpdating ? 'Updating' : 'Update' }} Address </button> <button class=\"btn btn-outline-danger border-0 ml-1\" ng-show=\"$ctrl.isEditing\" ng-click=\"$ctrl.trash($event, $ctrl.address)\" ng-disabled=\"$ctrl.isUpdating || $ctrl.isDeleting\"> <wp-spinner type=\"loading\" ng-show=\"$ctrl.isDeleting\"> </wp-spinner> {{ $ctrl.isDeleting ? 'Deleting' : 'Delete' }} </button> <button class=\"btn btn-secondary ml-1\" ng-show=\"$ctrl.isAdding || $ctrl.isEditing\" ng-click=\"$ctrl.cancel()\" ng-disabled=\"$ctrl.isCreating || $ctrl.isUpdating || $ctrl.isDeleting\"> Cancel </button> </div> </form> </div> <div class=\"modal-footer\" ng-hide=\"$ctrl.isAdding || $ctrl.isEditing\"> <button class=\"btn btn-primary\" type=\"button\" ng-click=\"$ctrl.ok()\"> Close </button> </div> ";
// Exports
/* harmony default export */ const customer_address_modal = (customer_address_modal_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-address-modal/customer-address-modal.component.ts
var customer_address_modal_component_class;

function customer_address_modal_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function customer_address_modal_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function customer_address_modal_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) customer_address_modal_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) customer_address_modal_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function customer_address_modal_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }



var CustomerAddressModalComponent = {
  bindings: {
    resolve: '<',
    close: '&',
    dismiss: '&'
  },
  template: customer_address_modal,
  controller: (customer_address_modal_component_class = /*#__PURE__*/function () {
    function CustomerAddressModalController(Debug, Localized, Utils) {
      customer_address_modal_component_classCallCheck(this, CustomerAddressModalController);

      this.Debug = Debug;
      this.Localized = Localized;
      this.Utils = Utils;
      this.usStates = usStates;
    }

    customer_address_modal_component_createClass(CustomerAddressModalController, [{
      key: "$onInit",
      value: function $onInit() {
        this.key = this.resolve.key;
        this.customerId = this.resolve.customerId;
        this.getData();
      }
    }, {
      key: "add",
      value: function add() {
        this.address = {};
        this.isAdding = true;
        this.isEditing = false;
      }
    }, {
      key: "cancel",
      value: function cancel() {
        this.isAdding = false;
        this.isEditing = false;
        this.address = {};
      }
      /**
       *
       * @param {Array} addresses
       * @return {Array} Addresses with uppercase state property.
       */

    }, {
      key: "convertUsStates",
      value: function convertUsStates(addresses) {
        return addresses.map(function (address) {
          address.state = address.state.toLocaleUpperCase();
          return address;
        });
      }
    }, {
      key: "create",
      value: function create() {
        var _this = this;

        this.isCreating = true;
        var endpoint = "".concat(this.Localized.apiURL, "/admin/customers/").concat(this.customerId, "/addresses/").concat(this.key, "/");
        var params = {};
        var data = this.address;
        this.Utils.httpPost(endpoint, params, data).then(function () {
          _this.isCreating = false;
          _this.isAdding = false;

          _this.getData();
        });
      }
    }, {
      key: "edit",
      value: function edit(e, address) {
        e.preventDefault();
        this.address = address;
        this.isEditing = true;
        this.isAdding = false;
      }
    }, {
      key: "trash",
      value: function trash(e, address) {
        var _this2 = this;

        this.isDeleting = true;
        e.preventDefault();
        var id = address[this.key + '_id'];
        var endpoint = "".concat(this.Localized.apiURL, "/admin/customers/").concat(this.customerId, "/addresses/").concat(this.key, "/").concat(id);
        this.Utils.httpDelete(endpoint).then(function () {
          _this2.address = {};
          _this2.isEditing = false;
          _this2.isDeleting = false;

          _this2.getData();
        });
      }
    }, {
      key: "getData",
      value: function getData() {
        var _this3 = this;

        this.isLoading = true;
        var endpoint = "".concat(this.Localized.apiURL, "/admin/customers/").concat(this.customerId, "/addresses/").concat(this.key);
        this.Utils.httpGet(endpoint).then(function (response) {
          _this3.addresses = Object.values(response["".concat(_this3.key, "_addresses")]);
          _this3.addresses = _this3.convertUsStates(_this3.addresses);
        })["catch"](function (error) {
          _this3.Debug.error(error);
        })["finally"](function () {
          _this3.isLoading = false;
        });
      }
    }, {
      key: "ok",
      value: function ok() {
        this.close({
          $value: 'close'
        });
      }
    }, {
      key: "update",
      value: function update() {
        var _this4 = this;

        this.isUpdating = true;
        var id = this.address[this.key + '_id'];
        var endpoint = "".concat(this.Localized.apiURL, "/admin/customers/").concat(this.customerId, "/addresses/").concat(this.key, "/").concat(id);
        var params = {};
        var data = this.address;
        this.Utils.httpPut(endpoint, params, data).then(function () {
          _this4.isUpdating = false;
          _this4.isEditing = false;

          _this4.getData();
        });
      }
    }]);

    return CustomerAddressModalController;
  }(), customer_address_modal_component_defineProperty(customer_address_modal_component_class, "$inject", ['Debug', 'Localized', 'Utils']), customer_address_modal_component_class)
};
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-accounts/customer-accounts.component.html
// Module
var customer_accounts_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2>Customer Accounts</h2> <vf-check-auth></vf-check-auth> <wp-notice-list></wp-notice-list> <uib-tabset active=\"$ctrl.activeTab\" ng-if=\"$ctrl.isAuthed\" ng-init=\"$ctrl.searchCustomers()\" resize> <uib-tab heading=\"Search Customers\" select=\"$ctrl.tabChanged(0)\"> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\"> <bs-search-box-legacy q=\"$ctrl.searchParams.q\" on-submit=\"$ctrl.setQuery(query, searchBy)\" is-loading=\"loadingMore\" search-options=\"$ctrl.searchOptions\"> </bs-search-box-legacy> <table class=\"table table-hover\"> <thead> <tr> <th class=\"col-1\"> <a href=\"#\" class=\"text-decoration-none\" ng-click=\"$ctrl.changeSortBy('id', $event)\"> ID <i ng-class=\"['bi', {\r\n\t\t\t\t\t\t\t\t\t'bi-sort-numeric-down': $ctrl.sortAscending,\r\n\t\t\t\t\t\t\t\t\t'bi-sort-numeric-down-alt': !$ctrl.sortAscending,\r\n\t\t\t\t\t\t\t\t}]\" ng-if=\"$ctrl.searchParams.sortBy === 'id'\"> </i> </a> </th> <th class=\"col-4\"> <a href=\"#\" class=\"text-decoration-none\" ng-click=\"$ctrl.changeSortBy('name', $event)\"> Name <i ng-class=\"['bi', {\r\n\t\t\t\t\t\t\t\t\t'bi-sort-alpha-down': $ctrl.sortAscending,\r\n\t\t\t\t\t\t\t\t\t'bi-sort-alpha-down-alt': !$ctrl.sortAscending,\r\n\t\t\t\t\t\t\t\t}]\" ng-if=\"$ctrl.searchParams.sortBy === 'name'\"> </i> </a> </th> <th class=\"col-4\"> <a href=\"#\" class=\"text-decoration-none\" ng-click=\"$ctrl.changeSortBy('email', $event)\"> Email <i ng-class=\"['bi', {\r\n\t\t\t\t\t\t\t\t\t'bi-sort-alpha-down': $ctrl.sortAscending,\r\n\t\t\t\t\t\t\t\t\t'bi-sort-alpha-down-alt': !$ctrl.sortAscending,\r\n\t\t\t\t\t\t\t\t}]\" ng-if=\"$ctrl.searchParams.sortBy === 'email'\"> </i> </a> </th> <th class=\"col-3\"> <a href=\"#\" class=\"text-decoration-none\" ng-click=\"$ctrl.changeSortBy('status', $event)\"> Status <i ng-class=\"['bi', {\r\n\t\t\t\t\t\t\t\t\t'bi-sort-down': $ctrl.sortAscending,\r\n\t\t\t\t\t\t\t\t\t'bi-sort-down-alt': !$ctrl.sortAscending,\r\n\t\t\t\t\t\t\t\t}]\" ng-if=\"$ctrl.searchParams.sortBy === 'status'\"> </i> </a> </th> </tr> </thead> <tbody> <tr class=\"text-center\" ng-if=\"$ctrl.customers.data.length <= 0 && !$ctrl.isLoadingMore\"> <td colspan=\"4\" class=\"table-warning\"> No Customer(s) <span ng-if=\"$ctrl.searchTerm.length >= 1 && $ctrl.searchedBy.length <= 0\">matching '{{$ctrl.searchTerm}}'</span><span ng-if=\"$ctrl.searchTerm.length >= 1 && $ctrl.searchedBy.length >= 1\">with the {{$ctrl.searchedBy === 'id' ? 'Customer ID' : $ctrl.searchParams.searchBy}} of '{{$ctrl.searchTerm}}'</span> found. </td> </tr> <tr class=\"cursor-pointer\" ng-if=\"!$ctrl.isLoadingMore\" ng-click=\"$ctrl.changeTab(2, $index)\" ng-repeat=\"customer in $ctrl.customers.data track by $index\"> <td>{{customer.id}}</td> <td>{{customer.name}}</td> <td>{{customer.email}}</td> <td>{{customer.status}}</td> </tr> </tbody> </table> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoadingMore\"> </wp-spinner> <div class=\"row m-tb-10\"> <div class=\"col-sm-4\"> <span>Showing {{$ctrl.customers.from || 0}} to {{$ctrl.customers.to || 0}} of {{$ctrl.customers.total || 0}} entries<span> </span></span></div> <div class=\"col-sm-4 text-center m-t-10\"> <button class=\"button\" ng-if=\"$ctrl.customers.prev_page_url\" ng-click=\"$ctrl.setPage($ctrl.customers.current_page - 1)\">&lsaquo; Prev</button> <button class=\"button\" ng-if=\"$ctrl.customers.current_page - 2 > 0\" ng-click=\"$ctrl.setPage($ctrl.customers.current_page - 2)\">{{$ctrl.customers.current_page - 2}}</button> <button class=\"button\" ng-if=\"$ctrl.customers.current_page - 1 > 0\" ng-click=\"$ctrl.setPage($ctrl.customers.current_page - 1)\">{{$ctrl.customers.current_page - 1}}</button> <button class=\"button\" ng-disabled=\"true\">{{$ctrl.customers.current_page}}</button> <button class=\"button\" ng-if=\"$ctrl.customers.current_page + 1 <= $ctrl.customers.last_page\" ng-click=\"$ctrl.setPage($ctrl.customers.current_page + 1)\">{{$ctrl.customers.current_page + 1}}</button> <button class=\"button\" ng-if=\"$ctrl.customers.current_page + 2 <= $ctrl.customers.last_page\" ng-click=\"$ctrl.setPage($ctrl.customers.current_page + 2)\">{{$ctrl.customers.current_page + 2}}</button> <button class=\"button\" ng-if=\"$ctrl.customers.next_page_url\" ng-click=\"$ctrl.setPage($ctrl.customers.current_page + 1)\">Next &rsaquo;</button> </div> <div class=\"col-sm-4 justify-content-end\"> <label class=\"form-label\" for=\"rpp\">Per Page: </label> <select class=\"form-control\" style=\"display:inline-block\" id=\"rpp\" ng-model=\"$ctrl.searchParams.rpp\" ng-change=\"$ctrl.setRpp( $ctrl.searchParams.rpp )\" ng-options=\"value for value in $ctrl.rppValues\"> </select> </div> </div> </div> </uib-tab> <uib-tab heading=\"Add Customer\" select=\"$ctrl.tabChanged(1)\"> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\"> <h3>Add Customer</h3> <form class=\"row\" name=\"addForm\" autocomplete=\"off\"> <div class=\"col-md-5\"> <div class=\"mb-3\"> <label class=\"form-label\" for=\"new_status\"> Status <span class=\"small\">(required)</span> </label> <select class=\"form-select\" id=\"new_status\" required ng-model=\"$ctrl.newCustomer.status\" ng-options=\"key as value for (key, value) in $ctrl.statuses\"> </select> </div> <fieldset> <legend class=\"h6\"> Contact Info </legend> <div class=\"mb-3\"> <label class=\"form-label\" for=\"new_name\"> Name <span class=\"small\">(required)</span> </label> <input class=\"form-control\" name=\"name\" type=\"text\" id=\"new_name\" minlength=\"3\" required ng-model=\"$ctrl.newCustomer.name\"> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"edit_email\"> Email <span class=\"small\">(required)</span> </label> <input class=\"form-control\" name=\"customerEmail\" type=\"email\" id=\"edit_email\" autocomplete=\"off\" required ng-pattern=\"/^[^\\s@]+@[^\\s@]+\\.[^\\s@]{2,}$/\" ng-model=\"$ctrl.newCustomer.email\"> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"edit_org\"> Company/Organization </label> <input class=\"form-control\" type=\"text\" id=\"edit_org\" ng-model=\"$ctrl.newCustomer.organization\" autocomplete=\"organization\"> </div> </fieldset> <fieldset> <legend class=\"h6\"> Account Details </legend> <label class=\"form-label\" for=\"new_pricesheet\"> Price Sheet <span class=\"description\">(required)</span> </label> <div class=\"input-group mb-3\"> <input type=\"text\" class=\"form-control\" id=\"new_pricesheet\" name=\"pricesheet\" readonly=\"readonly\" required ng-model=\"$ctrl.selectedSheet\" ng-init=\"$ctrl.checkPriceSheet(2)\"> <button class=\"btn btn-outline-secondary dropdown-toggle\" type=\"button\" data-bs-toggle=\"dropdown\" aria-expanded=\"false\">Select</button> <div class=\"dropdown-menu dropdown-menu-end\"> <div class=\"input-group input-group-sm px-2\"> <span class=\"input-group-text\"> <i class=\"bi bi-filter\"></i> </span> <input type=\"search\" class=\"form-control\" ng-model=\"filterVal\" placeholder=\"Filter\"> </div> <div class=\"dropdown-divider\"></div> <a class=\"dropdown-item\" href=\"#\" ng-repeat=\"priceSheet in $ctrl.priceSheets | orderBy: 'sheet' | filter: filterVal as filtered track by $index\" ng-click=\"\r\n\t\t\t\t\t\t\t\t\t\t$event.preventDefault(); \r\n\t\t\t\t\t\t\t\t\t\t$ctrl.newCustomer.price_sheet_id = priceSheet.price_sheet_id;\r\n\t\t\t\t\t\t\t\t\t\t$ctrl.updatePriceSheet($ctrl.newCustomer.price_sheet_id);\r\n\t\t\t\t\t\t\t\t\t\t$ctrl.checkPriceSheet(1)\"> {{priceSheet.sheet}} </a> <p class=\"px-4 mb-0 text-muted\" ng-if=\"filtered.length <= 0\"> No results matching {{filterVal}}. </p> </div> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"new_terms\"> Terms </label> <input class=\"form-control\" type=\"text\" id=\"new_terms\" ng-model=\"$ctrl.newCustomer.terms\"> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"new_prefix\"> Order Prefix </label> <input class=\"form-control\" type=\"text\" id=\"new_prefix\" placeholder=\"'ACC123'\" ng-model=\"$ctrl.newCustomer.order_prefix\"> </div> </fieldset> <div class=\"form-wrap\"> <h4>Account Management</h4> <div class=\"form-field wp-pwd is-open\"> <label class=\"form-label\" for=\"view_password\"> New Password <span class=\"description\">(required)</span> </label> <div class=\"row g-1\"> <div class=\"col\"> <span class=\"password-input-wrapper\"> <input type=\"password\" id=\"view_password\" name=\"newPassword\" placeholder=\"New Password\" autocomplete=\"new-password\" minlength=\"8\" pattern=\"(?=.*[0-9])(?=.*[!@#$%^&*-])(?=.*[A-Z]+)[a-zA-Z0-9!@#$%^&*]{8,}\" ng-class=\"['w-100 h-100', {\r\n\t\t\t\t\t\t\t\t\t\t\t\t'empty': !$ctrl.newCustomer.password.length,\r\n\t\t\t\t\t\t\t\t\t\t\t\t'short': addForm.newPassword.$invalid,\r\n\t\t\t\t\t\t\t\t\t\t\t\t'strong': $ctrl.newCustomer.password && addForm.newPassword.$valid\r\n\t\t\t\t\t\t\t\t\t\t\t}]\" ng-required=\"$ctrl.newCustomer.password.length >= 1\" ng-attr-type=\"{{ $ctrl.isShowingPassword ? 'text':'password'}}\" ng-model=\"$ctrl.newCustomer.password\"> </span> <div id=\"pass-strength-result\" aria-live=\"polite\" ng-class=\"['w-100', {\r\n\t\t\t\t\t\t\t\t\t\t\t'short': addForm.newPassword.$invalid,\r\n\t\t\t\t\t\t\t\t\t\t\t'strong': $ctrl.newCustomer.password && addForm.newPassword.$valid\r\n\t\t\t\t\t\t\t\t\t\t}]\" ng-show=\"addForm.newPassword.$dirty && addForm.newPassword.$viewValue\"> {{ addForm.newPassword.$valid ? 'Valid' : 'Invalid'}} </div> </div> <div class=\"col-auto\"> <button type=\"button\" class=\"btn btn-secondary wp-hide-pw\" data-bs-toggle=\"0\" aria-label=\"Show password\" ng-click=\"$ctrl.isShowingPassword = !$ctrl.isShowingPassword\"> <span aria-hidden=\"true\" ng-class=\"$ctrl.isShowingPassword ? 'dashicons dashicons-hidden' : 'dashicons dashicons-visibility'\"></span> <span class=\"text\">{{ $ctrl.isShowingPassword ? 'Hide' : 'Show' }}</span> </button> </div> </div> <p>Password must have at least 8 characters with at least one Capital letter, at least one lower case letter, and at least one number as well as a special character.</p> </div> <div class=\"form-field wp-pwd is-open\"> <label for=\"view_confirmpassword\"> Confirm Password <span class=\"description\">(required)</span> </label> <div class=\"row g-1\"> <div class=\"col\"> <span class=\"password-input-wrapper\"> <input ng-class=\"['w-100 h-100', {\r\n\t\t\t\t\t\t\t\t\t\t\t'empty': !$ctrl.newCustomer.password_confirmation,\r\n\t\t\t\t\t\t\t\t\t\t\t'short': $ctrl.newCustomer.password !== $ctrl.newCustomer.password_confirmation,\r\n\t\t\t\t\t\t\t\t\t\t\t'strong': $ctrl.newCustomer.password === $ctrl.newCustomer.password_confirmation \r\n\t\t\t\t\t\t\t\t\t\t}]\" ng-attr-type=\"{{ showPasswordConfirmation ? 'text':'password'}}\" name=\"confirmPassword\" type=\"password\" id=\"view_confirmpassword\" placeholder=\"Confirm Password\" ng-model=\"$ctrl.newCustomer.password_confirmation\" autocomplete=\"new-password\"> </span> <div id=\"pass-strength-result\" aria-live=\"polite\" ng-show=\"$ctrl.newCustomer.password_confirmation\" ng-class=\"['w-100', {\r\n\t\t\t\t\t\t\t\t\t\t\t'short': $ctrl.newCustomer.password !== $ctrl.newCustomer.password_confirmation,\r\n\t\t\t\t\t\t\t\t\t\t\t'strong': $ctrl.newCustomer.password === $ctrl.newCustomer.password_confirmation\r\n\t\t\t\t\t\t\t\t\t\t}]\"> {{ $ctrl.newCustomer.password === $ctrl.newCustomer.password_confirmation ? 'Confirmed' : 'Password mismatch'}} </div> </div> <div class=\"col-auto\"> <button type=\"button\" class=\"btn btn-secondary wp-hide-pw\" data-bs-toggle=\"0\" aria-label=\"Show password\" ng-click=\"showPasswordConfirmation = !showPasswordConfirmation\"> <span aria-hidden=\"true\" ng-class=\"showPasswordConfirmation ? 'dashicons dashicons-hidden' : 'dashicons dashicons-visibility'\"></span> <span class=\"text\">{{ showPasswordConfirmation ? 'Hide' : 'Show' }}</span> </button> </div> </div> </div> <div class=\"form-field\"> <label for=\"view_change_pw\"> <input type=\"checkbox\" id=\"view_change_pw\" ng-model=\"$ctrl.newCustomer.change_pw\" ng-checked=\"true\"> Force Password Reset </label> <p>Checking this will force the user to reset their password the next time they sign in.</p> </div> <div class=\"form-field\"> <label for=\"view_punchout_only\"> <input type=\"checkbox\" id=\"view_punchout_only\" ng-model=\"$ctrl.newCustomer.punchout_only\"> Enable Punchout </label> <p>Checking this allows the customer to punchout to a partner.</p> </div> </div> </div> <div class=\"col-md-7\"> <uib-tabset> <uib-tab heading=\"Group\"> <table class=\"form-table\" role=\"presentation\"> <tbody> <tr> <th> Group </th> <td class=\"d-flex align-items-center justify-content-between\"> <em> {{ $ctrl.newCustomer.group.name }} </em> <span> <button class=\"btn btn-secondary\" ng-click=\"$ctrl.openGroupSearchModal()\"> {{ $ctrl.newCustomer.group.name ? 'Change' : 'Add' }} </button> <button class=\"btn btn-outline-danger border-0\" ng-show=\"$ctrl.newCustomer.group.name\" ng-click=\"$ctrl.removeGroup()\"> Remove </button> </span> </td> </tr> <tr ng-if=\"$ctrl.newCustomer.group\"> <th scope=\"row\"> Group Admin </th> <td> <label for=\"view_admin\"> <input type=\"checkbox\" id=\"view_admin\" ng-model=\"$ctrl.newCustomer.group.admin\" ng-change=\"$ctrl.updateGroupPermissions($ctrl.newCustomer , false)\"> Grant ability to manage group permissions. </label> </td> </tr> <tr ng-if=\"$ctrl.newCustomer.group\"> <th scope=\"row\"> Approve Orders </th> <td> <label class=\"form-label\" for=\"view_approver\"> <input type=\"checkbox\" id=\"view_approver\" ng-model=\"$ctrl.newCustomer.group.approver\" ng-change=\"$ctrl.updateGroupPermissions($ctrl.newCustomer, false)\"> Grant ability to approve group orders. </label> </td> </tr> <tr ng-if=\"$ctrl.newCustomer.group && $ctrl.newCustomer.group.approver\"> <th scope=\"row\"> Pending Emails </th> <td> <label class=\"form-label\" for=\"view_pending_emails\"> <input type=\"checkbox\" id=\"view_pending_emails\" ng-model=\"$ctrl.newCustomer.group.pending_emails\" ng-change=\"$ctrl.updateGroupPermissions($ctrl.newCustomer, false)\"> Receive an email whenever a member of <em>{{ $ctrl.newCustomer.group.name }}</em> submits an order that needs approval. </label> </td> </tr> <tr ng-if=\"$ctrl.newCustomer.group && !$ctrl.newCustomer.group.approver && !$ctrl.newCustomer.group.admin\"> <th scope=\"row\"> Request Orders for Approval </th> <td> <label class=\"form-label\" for=\"view_requestor\"> <input type=\"checkbox\" id=\"view_requestor\" ng-model=\"$ctrl.newCustomer.group.requestor\" ng-change=\"$ctrl.updateGroupPermissions($ctrl.newCustomer, false)\"> Grants ability to submit pending orders to be approved later by an authorized user in <em>{{ $ctrl.newCustomer.group.name }}</em>. </label> </td> </tr> </tbody> </table> </uib-tab> <uib-tab heading=\"Punchout\"> <table class=\"form-table\" role=\"presentation\"> <tbody> <tr> <th scope=\"row\"> <label for=\"view_punchin\"> Punchin ID </label> </th> <td> <input class=\"regular-text\" name=\"punch_id\" type=\"text\" id=\"view_punchout\" minlength=\"3\" ng-model=\"newCustomer.punchin_identity\"> </td> </tr> <tr> <th scope=\"row\"> <label for=\"view_secret\"> Shared Secret </label> </th> <td> <input class=\"regular-text\" type=\"text\" id=\"view_secret\" placeholder=\"Secret\" ng-model=\"newCustomer.punchin_secret\"> </td> </tr> <tr> <th scope=\"row\"> Enable Mixed Punchout </th> <td> <label class=\"form-label\" for=\"view_mixed_punchout\"> <input type=\"checkbox\" id=\"view_mixed_punchout\" ng-model=\"$ctrl.newCustomer.mixed_punchout\"> Allow user to see both Punchout and non-Punchout catalogs. </label> </td> </tr> <tr> <th scope=\"row\"> Enable Price Availability Check </th> <td> <label class=\"form-label\" for=\"view_price_availability\"> <input type=\"checkbox\" id=\"view_price_availability\" ng-model=\"$ctrl.newCustomer.price_availability\"> Performs a price and availability check on punchout items. </label> </td> </tr> </tbody> </table> <button type=\"button\" class=\"btn btn-primary\" ng-click=\"$ctrl.OpenSupplierSearch($ctrl.newCustomer)\">Add Profile </button> <div class=\"row p-15\"> <div ng-if=\"!profile.deleted\" ng-repeat=\"profile in $ctrl.newCustomer.punchout_suppliers track by $index\"> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">{{profile.supplier.name}}</span> <button type=\"button\" ng-click=\"$ctrl.removeProfile($index, $ctrl.newCustomer)\" class=\"btn btn-outline-danger border-0\">Remove</button> </div> </div> </div> </uib-tab> <uib-tab heading=\"Checkout\"> <fieldset class=\"mb-3\"> <legend>Checkout</legend> <div class=\"mb-2\"> <label class=\"form-label\" for=\"edit_limit_type\"> Limit frequency </label> <select id=\"edit_limit_type\" class=\"form-select\" ng-options=\"key as value for (key, value) in $ctrl.limitTypes\" ng-model=\"$ctrl.newCustomer.limit_type\"> </select> </div> <div class=\"mb-2\" ng-if=\"$ctrl.newCustomer.limit_type && $ctrl.newCustomer.limit_type !== 'none'\"> <label class=\"form-label\" for=\"edit_limit\"> Limit amount </label> <input class=\"form-control\" type=\"number\" step=\"0.01\" id=\"edit_limit\" ng-model=\"$ctrl.newCustomer.limit\"> </div> <div class=\"mb-2\"> <label class=\"form-label\" for=\"edit_item_limit\"> Line item limit </label> <input class=\"form-control\" type=\"number\" id=\"edit_item_limit\" ng-model=\"$ctrl.newCustomer.item_limit\"> </div> <div class=\"mb-2\"> <label class=\"form-label\" for=\"edit_avatax\"> Tax code </label> <input class=\"form-control\" type=\"text\" id=\"edit_avatax\" ng-model=\"$ctrl.newCustomer.avatax_entity_code\"> </div> <div class=\"mb-2\"> <label class=\"form-label\" for=\"edit_customer_class\"> Customer class </label> <select id=\"edit_customer_class\" class=\"form-select\" ng-model=\"$ctrl.newCustomer.customer_class\"> <option value=\"DEFAULT\">Default</option> <option value=\"COMMERCIAL\">Commercial</option> <option value=\"GOV/ED\">Gov/Ed</option> </select> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_promo_engine\" ng-model=\"$ctrl.newCustomer.promo_engine\"> <label class=\"form-check-label\" for=\"edit_promo_engine\"> Promo engine </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_taxable\" ng-model=\"$ctrl.newCustomer.taxable\"> <label class=\"form-check-label\" for=\"edit_taxable\"> Taxable </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_lock_billing\" ng-model=\"$ctrl.newCustomer.lock_billing\"> <label class=\"form-check-label\" for=\"edit_lock_billing\"> Lock billing addresses </label> <div class=\"form-text\"> Locks billing address fields during checkout so that customer must select a <a href=\"#\" ng-click=\"$ctrl.editAddresses('billing', $event)\" title=\"Edit Billing Addresses\">previously saved billing address</a>. </div> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_lock_shipping\" ng-model=\"$ctrl.newCustomer.lock_shipping\"> <label class=\"form-check-label\" for=\"edit_lock_shipping\"> Lock shipping addresses </label> <div class=\"form-text\"> Locks shipping address fields during checkout so that customer must select a <a href=\"#\" ng-click=\"$ctrl.editAddresses('shipping', $event)\" title=\"Edit Shipping Addresses\">previously saved shipping address</a>. </div> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_cost_center_is_required\" ng-model=\"$ctrl.newCustomer.cost_center_is_required\"> <label class=\"form-check-label\" for=\"edit_cost_center_is_required\"> Require cost center code </label> <div class=\"form-text\" ng-if=\"$ctrl.isCostCenterRequired\"> Cost center code is required for all customers. To change this setting, go to Settings > Plugin tab under Additional Checkout Fields. </div> </div> </fieldset> <fieldset class=\"mb-3\"> <legend>Payments</legend> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_enable_pay\" ng-model=\"$ctrl.newCustomer.allow_payment\"> <label class=\"form-check-label\" for=\"edit_enable_pay\"> Allow payments at checkout </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_credit_line\" ng-model=\"$ctrl.newCustomer.credit_line\"> <label class=\"form-check-label\" for=\"edit_credit_line\"> Enable credit line at checkout </label> </div> </fieldset> <div class=\"btn-toolbar\"> <button class=\"button\" data-bs-toggle=\"modal\" data-bs-target=\"#new-custom-checkout\"> Customize Checkout Fields </button> </div> </uib-tab> </uib-tabset> </div> </form> <div class=\"btn-toolbar\"> <button class=\"btn btn-primary\" ng-disabled=\"addForm.$invalid || $ctrl.newCustomer.password !== $ctrl.newCustomer.password_confirmation\" ng-click=\"$ctrl.addCustomer()\"> Add New Customer </button> </div> </div> </uib-tab> <uib-tab heading=\"Edit Customer\" select=\"$ctrl.tabChanged(2)\" ng-show=\"$ctrl.selectedCustomer\"> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\"> <h3>Edit Customer <small>Customer ID: {{ $ctrl.customer.id }}</small></h3> <form class=\"row mb-3\" name=\"customerForm\" autocomplete=\"off\"> <div class=\"col-md-5\"> <div class=\"mb-3\"> <label class=\"form-label\" for=\"edit_status\"> Status <span class=\"small\">(required)</span> </label> <select class=\"form-select\" id=\"edit_status\" required ng-model=\"$ctrl.customer.status\" ng-options=\"key as value for (key, value) in $ctrl.statuses\"> </select> </div> <fieldset> <legend class=\"h6\"> Contact Info </legend> <div class=\"mb-3\"> <label class=\"form-label\" for=\"edit_name\"> Name <span class=\"small\">(required)</span> </label> <input class=\"form-control\" name=\"name\" type=\"text\" id=\"edit_name\" minlength=\"3\" required ng-model=\"$ctrl.customer.name\"> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"edit_email\"> Email <span class=\"small\">(required)</span> </label> <input class=\"form-control\" name=\"customerEmail\" type=\"email\" id=\"edit_email\" autocomplete=\"off\" required ng-pattern=\"/^[^\\s@]+@[^\\s@]+\\.[^\\s@]{2,}$/\" ng-model=\"$ctrl.customer.email\"> <div class=\"mt-2\"> <customer-send-email customer-id=\"$ctrl.customer.id\" email-type=\"register\"> </customer-send-email> <customer-send-email customer-id=\"$ctrl.customer.id\" email-type=\"verified\"> </customer-send-email> </div> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"edit_org\"> Company/Organization </label> <input class=\"form-control\" type=\"text\" id=\"edit_org\" ng-model=\"$ctrl.customer.organization\" autocomplete=\"organization\"> </div> </fieldset> <fieldset> <legend class=\"h6\"> Account Details </legend> <label class=\"form-label\" for=\"edit_pricesheet\"> Price Sheet <span class=\"description\">(required)</span> </label> <div class=\"input-group mb-3\"> <input type=\"text\" class=\"form-control\" id=\"edit_pricesheet\" name=\"pricesheet\" readonly=\"readonly\" required ng-model=\"$ctrl.selectedSheet\" ng-init=\"$ctrl.checkPriceSheet(2)\"> <button class=\"btn btn-outline-secondary dropdown-toggle\" type=\"button\" data-bs-toggle=\"dropdown\" aria-expanded=\"false\">Select</button> <div class=\"dropdown-menu dropdown-menu-end\"> <div class=\"input-group input-group-sm px-2\"> <span class=\"input-group-text\"> <i class=\"bi bi-filter\"></i> </span> <input type=\"search\" class=\"form-control\" ng-model=\"filterVal\" placeholder=\"Filter\"> </div> <div class=\"dropdown-divider\"></div> <a class=\"dropdown-item\" href=\"#\" ng-repeat=\"priceSheet in $ctrl.priceSheets | orderBy: 'sheet' | filter: filterVal as filtered track by $index\" ng-click=\"\r\n\t\t\t\t\t\t\t\t\t\t$event.preventDefault();\r\n\t\t\t\t\t\t\t\t\t\t$ctrl.customer.price_sheet_id = priceSheet.price_sheet_id;\r\n\t\t\t\t\t\t\t\t\t\t$ctrl.updatePriceSheet(priceSheet.price_sheet_id);\r\n\t\t\t\t\t\t\t\t\t\t$ctrl.checkPriceSheet(2)\"> {{priceSheet.sheet}} </a> <p class=\"px-4 mb-0 text-muted\" ng-if=\"filtered.length <= 0\"> No results matching {{filterVal}}. </p> </div> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"edit_terms\"> Terms </label> <input class=\"form-control\" type=\"text\" id=\"edit_terms\" ng-model=\"$ctrl.customer.terms\"> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"edit_prefix\"> Order Prefix </label> <input class=\"form-control\" type=\"text\" id=\"edit_prefix\" placeholder=\"'ACC123'\" ng-model=\"$ctrl.customer.order_prefix\"> </div> </fieldset> <fieldset> <legend class=\"h6\"> Account Management </legend> <button class=\"btn btn-secondary btn-sm mb-3\" ng-click=\"$ctrl.isSettingNewPassword = true\"> Set New Password </button> <div class=\"mb-2\" ng-if=\"$ctrl.isSettingNewPassword\"> <label class=\"form-label\" for=\"edit_password\"> New Password </label> <div class=\"input-group mb-2\"> <input class=\"form-control\" type=\"password\" id=\"edit_password\" name=\"newPassword\" placeholder=\"New Password\" autocomplete=\"new-password\" minlength=\"8\" ng-pattern=\"$ctrl.passwordPattern\" ng-required=\"$ctrl.isSettingNewPassword\" ng-attr-type=\"{{ $ctrl.isShowingPassword ? 'text':'password'}}\" ng-model=\"$ctrl.customer.password\"> <button type=\"button\" class=\"btn btn-secondary\" data-bs-toggle=\"0\" aria-label=\"Show password\" ng-click=\"$ctrl.isShowingPassword = !$ctrl.isShowingPassword\"> <i aria-hidden=\"true\" ng-class=\"$ctrl.isShowingPassword ? 'bi bi-eye-slash-fill' : 'bi bi-eye-fill'\"></i> <span class=\"text\">{{ $ctrl.isShowingPassword ? 'Hide' : 'Show' }}</span> </button> <button class=\"btn btn-outline-danger border-0\" ng-click=\"$ctrl.cancelPasswordChange()\"> Cancel </button> </div> <div class=\"progress\"> <div class=\"progress-bar\" role=\"progressbar\" aria-valuemin=\"0\" aria-valuemax=\"100\" style=\"width:0\" ng-class=\"['progress-bar', {\r\n\t\t\t\t\t\t\t\t\t\t'w-25': customerForm.newPassword.$viewValue,\r\n\t\t\t\t\t\t\t\t\t\t'w-50': customerForm.newPassword.$viewValue.length > 3,\r\n\t\t\t\t\t\t\t\t\t\t'w-75': customerForm.newPassword.$viewValue.length > 6,\r\n\t\t\t\t\t\t\t\t\t\t'bg-danger': customerForm.newPassword.$error.required || ( customerForm.newPassword.$error.pattern && customerForm.newPassword.$error.minlength ),\r\n\t\t\t\t\t\t\t\t\t\t'bg-warning': customerForm.newPassword.$error.pattern,\r\n\t\t\t\t\t\t\t\t\t\t'bg-success w-100': $ctrl.customer.password && customerForm.newPassword.$valid\r\n\t\t\t\t\t\t\t\t\t}]\"></div> </div> <div class=\"form-text\">Password must have at least 8 characters with at least one Capital letter, at least one lower case letter, and at least one number as well as a special character.</div> </div> <div class=\"mb-2\" ng-if=\"$ctrl.isSettingNewPassword\"> <label class=\"form-label\" for=\"edit_confirmpassword\"> Confirm Password </label> <div class=\"input-group mb-2\"> <input class=\"form-control\" type=\"password\" id=\"edit_confirmpassword\" name=\"confirmPassword\" placeholder=\"Confirm Password\" autocomplete=\"new-password\" minlength=\"8\" ng-pattern=\"$ctrl.passwordPattern\" ng-required=\"$ctrl.isSettingNewPassword\" ng-attr-type=\"{{ $ctrl.isShowingPasswordConfirmation ? 'text':'password'}}\" ng-model=\"$ctrl.customer.password_confirmation\"> <button type=\"button\" class=\"btn btn-secondary\" data-bs-toggle=\"0\" aria-label=\"Show password\" ng-click=\"$ctrl.isShowingPasswordConfirmation = !$ctrl.isShowingPasswordConfirmation\"> <i aria-hidden=\"true\" ng-class=\"$ctrl.isShowingPasswordConfirmation ? 'bi bi-eye-slash-fill' : 'bi bi-eye-fill'\"></i> <span class=\"text\">{{ $ctrl.isShowingPasswordConfirmation ? 'Hide' : 'Show' }}</span> </button> <button class=\"btn btn-outline-danger border-0\" ng-click=\"$ctrl.cancelPasswordChange()\"> Cancel </button> </div> <div class=\"progress\"> <div class=\"progress-bar\" role=\"progressbar\" aria-valuemin=\"0\" aria-valuemax=\"100\" style=\"width:0\" ng-class=\"['progress-bar', {\r\n\t\t\t\t\t\t\t\t\t\t'w-25': customerForm.confirmPassword.$viewValue,\r\n\t\t\t\t\t\t\t\t\t\t'w-50': customerForm.confirmPassword.$viewValue.length > 3,\r\n\t\t\t\t\t\t\t\t\t\t'w-75': customerForm.confirmPassword.$viewValue.length > 6,\r\n\t\t\t\t\t\t\t\t\t\t'bg-danger': customerForm.confirmPassword.$error.required || ( customerForm.confirmPassword.$error.pattern && customerForm.confirmPassword.$error.minlength ),\r\n\t\t\t\t\t\t\t\t\t\t'bg-warning': customerForm.confirmPassword.$error.pattern,\r\n\t\t\t\t\t\t\t\t\t\t'bg-success w-100': customerForm.confirmPassword.$valid && $ctrl.customer.password === $ctrl.customer.password_confirmation\r\n\t\t\t\t\t\t\t\t\t}]\"></div> </div> </div> <div class=\"mb-3\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_change_pw\" ng-model=\"$ctrl.customer.change_pw\"> <label class=\"form-check-label\" for=\"edit_change_pw\"> Force Password Reset </label> </div> <div class=\"form-text\">Checking this will force the user to reset their password the next time they sign in.</div> </div> <div class=\"mb-3\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_punchout_only\" ng-model=\"$ctrl.customer.punchout_only\"> <label class=\"form-check-label\" for=\"edit_punchout_only\"> Enable Punchout </label> </div> <div class=\"form-text\">Checking this allows the customer to punchout to a partner.</div> </div> </fieldset> <div class=\"form-wrap\"> </div> </div> <div class=\"col-md-7\"> <uib-tabset> <uib-tab heading=\"Group\"> <table class=\"form-table\" role=\"presentation\"> <tbody> <tr> <th> Group </th> <td class=\"d-flex align-items-center justify-content-between\"> <em> {{ $ctrl.customer.group.name }} </em> <span> <button class=\"btn btn-secondary\" ng-click=\"$ctrl.openGroupSearchModal()\"> {{ $ctrl.customer.group.name ? 'Change' : 'Add' }} </button> <button class=\"btn btn-outline-danger border-0\" ng-show=\"$ctrl.customer.group.name\" ng-click=\"$ctrl.removeGroup()\"> Remove </button> </span> </td> </tr> <tr ng-if=\"$ctrl.customer.group\"> <th scope=\"row\"> Group Admin </th> <td> <label class=\"form-label\" for=\"edit_admin\"> <input type=\"checkbox\" id=\"edit_admin\" ng-model=\"$ctrl.customer.group.admin\" ng-change=\"$ctrl.updateGroupPermissions($ctrl.customer , false)\"> Grant ability to manage group permissions. </label> </td> </tr> <tr ng-if=\"$ctrl.customer.group\"> <th scope=\"row\"> Approve Orders </th> <td> <label class=\"form-label\" for=\"edit_approver\"> <input type=\"checkbox\" id=\"edit_approver\" ng-model=\"$ctrl.customer.group.approver\" ng-change=\"$ctrl.updateGroupPermissions($ctrl.customer, false)\"> Grant ability to approve group orders. </label> </td> </tr> <tr ng-if=\"$ctrl.customer.group && $ctrl.customer.group.approver\"> <th scope=\"row\"> Pending Emails </th> <td> <label class=\"form-label\" for=\"edit_pending_emails\"> <input type=\"checkbox\" id=\"edit_pending_emails\" ng-model=\"$ctrl.customer.group.pending_emails\" ng-change=\"$ctrl.updateGroupPermissions($ctrl.customer, false)\"> Receive an email whenever a member of <em>{{ $ctrl.customer.group.name }}</em> submits an order that needs approval. </label> </td> </tr> <tr ng-if=\"$ctrl.customer.group && !$ctrl.customer.group.approver && !$ctrl.customer.group.admin\"> <th scope=\"row\"> Request Orders for Approval </th> <td> <label class=\"form-label\" for=\"edit_requestor\"> <input type=\"checkbox\" id=\"edit_requestor\" ng-model=\"$ctrl.customer.group.requestor\" ng-change=\"$ctrl.updateGroupPermissions($ctrl.customer, false)\"> Grants ability to submit pending orders to be approved later by an authorized user in <em>{{ customer.group.name }}</em>. </label> </td> </tr> </tbody> </table> </uib-tab> <uib-tab heading=\"Punchout\"> <customer-punchout-tab customer=\"$ctrl.customer\" suppliers=\"$ctrl.suppliers\"> </customer-punchout-tab> </uib-tab> <uib-tab heading=\"Notes\"> <h4 class=\"h6\">Notes</h4> <customer-notes customer-id=\"$ctrl.customer.id\"> </customer-notes> </uib-tab> <uib-tab heading=\"Shipping\"> <div class=\"row p-15\"> <div class=\"col-12\"> <div> <button class=\"btn btn-secondary\" ng-click=\"$ctrl.openRatesSearchModal()\"> Modify Rates </button> <div class=\"row p-s-20 p-t-15\" ng-class=\"{'border-bottom':isXS}\"> <div class=\"col-5\">Name</div> <div class=\"col-4 p-0\">Cost</div> <div class=\"col-3\">Status</div> </div> <div class=\"p-10\" ng-class=\"{'min-scroll':!isXS}\"> <div class=\"text-center\" style=\"font-size:.9em\" ng-if=\"$ctrl.customer.flat_rates.data.length <= 0  &&  $ctrl.updatedRates.length <= 0\"> <h5>There are no rates specified for this customer.</h5> </div> <div class=\"col p-8 vf-item-card-inner vf-list-item cursor-pointer\" ng-class=\"{'remove':$ctrl.rateCheck(rate)}\" style=\"border:none\" ng-repeat=\"rate in $ctrl.customer.flat_rates.data track by $index\"> <div class=\"row\"> <div class=\"col-5 vf-list-text\"> {{rate.name | limitTo: 10}}{{rate.name.length >= 10 ? '...' : ''}} </div> <div class=\"col-4 vf-list-text p-0\">{{rate.cost}}</div> <div class=\"col-3 vf-list-text\"> {{rate.enabled === 1 ? 'Active' : 'Inactive'}}</div> </div> </div> <div class=\"col p-8 vf-item-card-inner vf-list-item cursor-pointer\" ng-class=\"rate.action\" style=\"border:none\" ng-repeat=\"rate in $ctrl.updatedRates track by $index\" ng-if=\"rate.action === 'add'\"> <div class=\"row\"> <div class=\"col-5 vf-list-text\"> {{rate.value.name | limitTo: 10}}{{rate.value.name.length >= 10 ? '...' : ''}} </div> <div class=\"col-4 vf-list-text p-0\">{{rate.value.cost}} </div> <div class=\"col-3 vf-list-text\"> {{rate.value.enabled === 1 ? 'Active' : 'Inactive'}} </div> </div> </div> </div> </div> </div> </div> </uib-tab> <uib-tab heading=\"Checkout\"> <fieldset class=\"mb-3\"> <legend>Checkout</legend> <div class=\"mb-2\"> <label class=\"form-label\" for=\"edit_limit_type\"> Limit frequency </label> <select id=\"edit_limit_type\" class=\"form-select\" ng-options=\"key as value for (key, value) in $ctrl.limitTypes\" ng-model=\"$ctrl.customer.limit_type\"> </select> </div> <div class=\"mb-2\" ng-if=\"$ctrl.customer.limit_type && $ctrl.customer.limit_type !== 'none'\"> <label class=\"form-label\" for=\"edit_limit\"> Limit amount </label> <input class=\"form-control\" type=\"number\" step=\"0.01\" id=\"edit_limit\" ng-model=\"$ctrl.customer.limit\"> </div> <div class=\"mb-2\"> <label class=\"form-label\" for=\"edit_item_limit\"> Line item limit </label> <input class=\"form-control\" type=\"number\" id=\"edit_item_limit\" ng-model=\"$ctrl.customer.item_limit\"> </div> <div class=\"mb-2\"> <label class=\"form-label\" for=\"edit_avatax\"> Tax code </label> <input class=\"form-control\" type=\"text\" id=\"edit_avatax\" ng-model=\"$ctrl.customer.avatax_entity_code\"> </div> <div class=\"mb-2\"> <label class=\"form-label\" for=\"edit_customer_class\"> Customer class </label> <select id=\"edit_customer_class\" class=\"form-select\" ng-model=\"$ctrl.customer.customer_class\"> <option value=\"DEFAULT\">Default</option> <option value=\"COMMERCIAL\">Commercial</option> <option value=\"GOV/ED\">Gov/Ed</option> </select> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_promo_engine\" ng-model=\"$ctrl.customer.promo_engine\"> <label class=\"form-check-label\" for=\"edit_promo_engine\"> Promo engine </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_taxable\" ng-model=\"$ctrl.customer.taxable\"> <label class=\"form-check-label\" for=\"edit_taxable\"> Taxable </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_lock_billing\" ng-model=\"$ctrl.customer.lock_billing\"> <label class=\"form-check-label\" for=\"edit_lock_billing\"> Lock billing addresses </label> <div class=\"form-text\"> Locks billing address fields during checkout so that customer must select a <a href=\"#\" ng-click=\"$ctrl.editAddresses('billing', $event)\" title=\"Edit Billing Addresses\">previously saved billing address</a>. </div> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_lock_shipping\" ng-model=\"$ctrl.customer.lock_shipping\"> <label class=\"form-check-label\" for=\"edit_lock_shipping\"> Lock shipping addresses </label> <div class=\"form-text\"> Locks shipping address fields during checkout so that customer must select a <a href=\"#\" ng-click=\"$ctrl.editAddresses('shipping', $event)\" title=\"Edit Shipping Addresses\">previously saved shipping address</a>. </div> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_cost_center_is_required\" ng-model=\"$ctrl.customer.cost_center_is_required\"> <label class=\"form-check-label\" for=\"edit_cost_center_is_required\"> Require cost center code </label> <div class=\"form-text\" ng-if=\"$ctrl.isCostCenterRequired\"> Cost center code is required for all customers. To change this setting, go to Settings > Plugin tab under Additional Checkout Fields. </div> </div> </fieldset> <fieldset class=\"mb-3\"> <legend>Payments</legend> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_enable_pay\" ng-model=\"$ctrl.customer.allow_payment\"> <label class=\"form-check-label\" for=\"edit_enable_pay\"> Allow payments at checkout </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"edit_credit_line\" ng-model=\"$ctrl.customer.credit_line\"> <label class=\"form-check-label\" for=\"edit_credit_line\"> Enable credit line at checkout </label> </div> </fieldset> <div class=\"btn-toolbar\"> <button class=\"button\" data-bs-toggle=\"modal\" data-bs-target=\"#edit-custom-checkout\"> Customize Checkout Fields </button> </div> </uib-tab> <uib-tab heading=\"Order Changes\" ng-show=\"$ctrl.customer.order_change_logs.data.length\"> <table class=\"table table-striped caption-top\"> <caption>Order changes logged as a result of a Price Availability check.</caption> <thead> <tr> <th scope=\"col\">Date</th> <th scope=\"col\">Customer ID</th> <th scope=\"col\">Order ID</th> <th scope=\"col\">Action</th> <th scope=\"col\">Product ID</th> </tr> </thead> <tbody> <tr ng-repeat=\"log in $ctrl.customer.order_change_logs.data track by $index\"> <td scope=\"row\" ng-bind=\"$ctrl.formatDate(log.created_at) |  date:'short'\"> </td> <td scope=\"row\" style=\"cursor:pointer\" ng-click=\"$ctrl.changeTab(2, $index)\"> {{log.customer_id}} </td> <td scope=\"row\"> <a ui-sref=\"orders.show({ id: log.order_id })\"> {{log.order_id}} </a> </td> <td scope=\"row\"> {{log.action}} </td> <td scope=\"row\" style=\"cursor:pointer\" ng-click=\"$ctrl.goToProduct(log.product)\"> {{log.product_id}} </td> </tr> </tbody> </table> </uib-tab> <uib-tab heading=\"Docs\" ng-show=\"$ctrl.customer.documents.data.length\"> <div class=\"row\"> <div class=\"col-12 m-tb-10\" ng-repeat=\"doc in $ctrl.customer.documents.data track by $index\"> <div class=\"row\"> <div class=\"input-group\"> <span class=\"input-group-text\">{{doc.document.name}}</span> <button class=\"btn btn-secondary\" ng-click=\"$ctrl.viewDocument(doc.id)\">Download Document</button> </div> </div> </div> </div> </uib-tab> </uib-tabset> </div> </form> <div class=\"btn-toolbar justify-content-between\"> <span> <button class=\"button button-primary\" ng-disabled=\"customerForm.$invalid || $ctrl.customer.password_confirmation != $ctrl.customer.password\" ng-click=\"$ctrl.updateCustomer()\"> Update </button> <button class=\"button\" ng-click=\"$ctrl.editAddresses('shipping', $event)\"> Edit Shipping Addresses </button> <button class=\"button\" ng-click=\"$ctrl.editAddresses('billing', $event)\"> Edit Billing Addresses </button> </span> <span> <customer-login customer-id=\"$ctrl.customer.id\"></customer-login> <customer-copy-button customer-id=\"$ctrl.customer.id\" on-copy=\"$ctrl.onCopy( copiedCustomer )\"> </customer-copy-button> </span> </div> </div> </uib-tab> <uib-tab select=\"$ctrl.tabChanged(3)\" heading=\"Upload Customer(s)\"> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\" class=\"col p-0 vf-tab-body\"> <form class=\"row\" enctype=\"multipart/form-data\" name=\"accountsUploadForm\"> <div class=\"col-md-5\"> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text w-104\">File</span> <input class=\"form-control\" ng-class=\"{'is-invalid':accountsUploadForm.psName.$invalid}\" name=\"psName\" ng-model=\"$ctrl.theFile.name\" placeholder=\"Upload a File\" disabled=\"disabled\" required> <label class=\"btn btn-secondary m-0\"> Browse <input class=\"custom-file\" type=\"file\" name=\"file\" id=\"uploadInput\" onchange=\"angular.element(this).scope().setFile(this)\" hidden/> </label> </div> <div class=\"d-flex align-items-center\" ng-if=\"$ctrl.uploading\"> <strong>Generating your Accounts Sheet, please wait...</strong> <div class=\"spinner is-active ml-auto\" role=\"status\" aria-hidden=\"true\"></div> </div> </div> <div class=\"col-md-12 p-15\"> <div class=\"min-scroll-table\" ng-if=\"$ctrl.accountSheetUpload && !$ctrl.uploading\"> <table class=\"table table-striped table-fixed\"> <thead> <tr> Displaying {{($ctrl.accountSheetUpload.length > 5)?5:$ctrl.accountSheetUpload.length}} results of total {{$ctrl.accountSheetUpload.length | number}} </tr> <tr> <th>Attach to User</th> <th>Group ID</th> <th>Price Sheet</th> <th>Name</th> <th>Email</th> <th>Company/Organization</th> <th>Limit Type</th> <th>Limit Amount</th> <th>Password</th> <th>Order Prefix</th> <th>Terms</th> <th>Credit Line</th> <th>Taxable</th> <th>Punchout Only</th> <th>Request Orders</th> <th>Group Admin</th> <th>Approve Orders</th> <th>Pending Order Emails</th> <th>Enable Payment Options</th> <th>Lock Shipping</th> <th>Lock Billing</th> <th>Custom</th> <th>Ship-To ID</th> <th>Ship-To First Name</th> <th>Ship-To Last Name</th> <th>Ship-To Email</th> <th>Ship-To Address 1</th> <th>Ship-To Address 2</th> <th>Ship-To City</th> <th>Ship-To State</th> <th>Ship-To Zip</th> <th>Ship-To Phone</th> <th>Bill-To ID</th> <th>Bill-To First Name</th> <th>Bill-To Last Name</th> <th>Bill-To Email</th> <th>Bill-To Address 1</th> <th>Bill-To Address 2</th> <th>Bill-To City</th> <th>Bill-To State</th> <th>Bill-To Zip</th> <th>Bill-To Phone</th> <th>F1 Field to Replace</th> <th>F1 Name</th> <th>F1 Value</th> <th>F2 Field to Replace</th> <th>F2 Name</th> <th>F2 Value</th> <th>F3 Name</th> <th>F3 Value</th> <th>F4 Name</th> <th>F4 Value</th> <th>F5 Name</th> <th>F5 Value</th> <th>F6 Name</th> <th>F6 Value</th> <th>Price Availability</th> <th>Avatax Entity Code</th> <th>GP Account</th> <th>Cost Center Is Required</th> </tr> </thead> <tbody ng-repeat=\"account in $ctrl.accountSheetUpload track by $index\"> <tr> <td ng-repeat=\"attribute in account track by $index\"> <span ng-if=\"attribute.length >= 1\" title=\"{{attribute}}\">{{attribute | limitTo: 25}}{{attribute.length >= 25 ? '...' : ''}}</span> <span ng-if=\"attribute.length <= 0\">----</span> </td> </tr> </tbody> </table> </div> </div> <div class=\"col-12\" ng-class=\"{'text-end':$ctrl.accountSheetUpload}\"> <button class=\"btn btn-primary m-tb-10\" ng-class=\"{'col': isXS || isSM}\" ng-disabled=\"accountUploadForm.$invalid\" ng-click=\"$ctrl.uploadCustomer()\" ng-if=\"$ctrl.accountSheetUpload\">Upload Customer(s)</button> <button class=\"btn btn-outline-danger border-0 m-tb-10\" ng-class=\"{'col': isXS || isSM}\" ng-disabled=\"\" ng-click=\"$ctrl.removeUploadFile()\" ng-if=\"$ctrl.accountSheetUpload\"> Remove </button> </div> </form> </div> </uib-tab> <uib-tab select=\"$ctrl.tabChanged(4)\" heading=\"Batches\"> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\"> <div> <div class=\"input-group\"> <span class=\"input-group-text\">Status</span> <select class=\"form-control h-38\" ng-options=\"key as value for (key, value) in $ctrl.batchListOptions\" ng-model=\"$ctrl.sortBatchParams.status\" ng-change=\"$ctrl.sortBatchIndex('batch_id')\"> </select> </div> <div class=\"row p-s-20 p-t-10\"> <div class=\"col\" ng-click=\"$ctrl.sortBatchIndex('batch_id')\">Batch ID</div> <div class=\"col\" ng-click=\"$ctrl.sortBatchIndex('time_uploaded')\">Upload Date</div> <div class=\"col\" ng-click=\"$ctrl.sortBatchIndex('filename')\">File Name</div> <div class=\"col\" ng-click=\"$ctrl.sortBatchIndex('status')\">Status</div> <div class=\"col\">Progress</div> </div> <div class=\"p-10\" ng-class=\"{'min-scroll-table':!isXS}\"> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoadingMore\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoadingMore && $ctrl.batches.length <= 0\" class=\"col text-center\"> <span class=\"col m-auto\"> <h3>No Batches found.</h3> </span> </div> <div ng-if=\"!$ctrl.isLoadingMore\" class=\"col p-15 vf-list-item cursor-pointer\" ng-click=\"batch.status == 'pending' || batch.status == 'confirmed' ? $ctrl.changeBatchTab(5, $index) : return;\" ng-repeat=\"batch in $ctrl.batches track by $index\"> <div class=\"row\"> <div class=\"col\">{{batch.batch_id}}</div> <div class=\"col\">{{batch.time_uploaded}}</div> <div class=\"col\">{{batch.filename}}</div> <div class=\"col\">{{batch.status}}</div> <div ng-if=\"batch.recordsProcessed\" class=\"col\"> {{((batch.recordsProcessed / batch.total_records) * 100).toFixed(2)}}%</div> <div ng-if=\"!batch.recordsProcessed && batch.status == 'processed'\" class=\"col\">Done </div> <div ng-if=\"!batch.recordsProcessed && batch.status != 'processed'\" class=\"col\"> {{batch.total_records ? '0%' : 'N/A'}}</div> </div> </div> </div> </div> </div> </uib-tab> <uib-tab select=\"$ctrl.tabChanged(5)\" ng-show=\"$ctrl.selectedBatch\"> <uib-tab-heading> Batch {{$ctrl.selectedBatch.batch_id}} <i class=\"dashicons dashicons-update\"></i> </uib-tab-heading> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\"> <div class=\"row\"> <div class=\"col-md-5\"> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">Batch ID</span> <input class=\"form-control\" ng-model=\"$ctrl.selectedBatch.batch_id\" type=\"text\" disabled=\"disabled\"> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">File Name</span> <input class=\"form-control\" ng-model=\"$ctrl.selectedBatch.filename\" type=\"text\" disabled=\"disabled\"> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">Time Uploaded</span> <input class=\"form-control\" ng-model=\"$ctrl.selectedBatch.time_uploaded\" type=\"text\" disabled=\"disabled\"> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">Status</span> <input class=\"form-control\" ng-model=\"$ctrl.selectedBatch.status\" type=\"text\" disabled=\"disabled\"> </div> </div> </div> <div class=\"col-12 m-tb-20\"> <div class=\"min-scroll-table\"> <table class=\"table table-striped table-fixed\"> <thead> <tr> <th scope=\"col\" class=\"padding: 10px;\" ng-repeat=\"(key, value) in $ctrl.batchHeaders\"> {{value}}</th> </tr> </thead> <tbody> <tr ng-repeat=\"data in $ctrl.selectedBatch.items | limitTo: 5\"> <td scope=\"row\" class=\"padding: 10px;\" ng-repeat=\"(x, y) in $ctrl.batchHeaders\"> {{data[x]}} </td> </tr> </tbody> </table> </div> </div> <div class=\"col-12 text-end\"> <button class=\"btn btn-primary m-tb-10\" ng-class=\"{'col': isXS || isSM}\" ng-click=\"$ctrl.confirmBatch()\" ng-if=\"$ctrl.selectedBatch.status == 'pending'\">Confirm Batch</button> </div> </div> </uib-tab> <uib-tab select=\"$ctrl.tabChanged(6)\" heading=\"Settings\"> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\" class=\"col p-0 vf-tab-body\"> <form name=\"settingsForm\" ng-class=\"{'p-15': isXS || isSM}\"> <div class=\"input-group wp-100 m-b-10\"> <span class=\"input-group-text w-260\">Default Customer Prefix</span> <input id=\"name\" type=\"text\" class=\"form-control\" name=\"name\" placeholder=\"Default Customer Prefix\" ng-model=\"$ctrl.settings.store.saved.default_customer_prefix\" required> </div> <div class=\"input-group wp-200 m-b-10\"> <span class=\"input-group-text w-260\">Default Order Prefix</span> <input id=\"url\" type=\"text\" class=\"form-control\" name=\"name\" placeholder=\"Default Order Prefix\" ng-model=\"$ctrl.settings.store.saved.default_order_prefix\" required> </div> </form> <div> <button class=\"btn btn-primary\" ng-click=\"$ctrl.updateDefaultPrefix()\"> Update </button> </div> </div> </uib-tab> </uib-tabset> <div class=\"modal\" id=\"edit-custom-checkout\"> <div class=\"modal-dialog modal-lg\"> <div class=\"modal-content\"> <div class=\"modal-header\"> <h4 class=\"modal-title\">Customize Checkout Fields</h4> <button type=\"button\" class=\"btn-close\" data-bs-dismiss=\"modal\" aria-label=\"close\"></button> </div> <div class=\"modal-body collapse border-bottom\" id=\"customFieldsHelp\"> <p class=\"mb-1\">To add or customize fields that appear on the Checkout page for this customer:</p> <ul class=\"list-unstyled\"> <li> Add at least a name to one of the fields below to enable the Custom Field. </li> <li> To replace an existing Additional Checkout field, select one from the <em>Replaces</em> field. Additional Checkout fields are configured in <em>Settings > Plugin</em>. </li> <li> If you leave the value blank, the customer will be able to fill out the Custom Field with any value. If you enter only one value, the Custom Field will appear as a read-only value on the Checkout page. If you fill out multiple values, the customer will be able to select from any of the values you provide. </li> </ul> </div> <ul class=\"list-group list-group-flush\"> <li ng-class=\"['list-group-item', {\r\n\t\t\t\t\t'list-group-item-primary': $ctrl.customer['f' + p + '_name']\r\n\t\t\t\t}]\" ng-repeat=\"p in [1, 2, 3, 4, 5, 6]\"> <fieldset> <legend class=\"h6 d-flex justify-content-between\"> Field {{ p }} <a data-bs-toggle=\"collapse\" href=\"#customFieldsHelp\" role=\"button\" aria-expanded=\"false\" aria-controls=\"customFieldsHelp\"> <i class=\"bi bi-info-circle-fill\"></i> </a> </legend> <div class=\"row\"> <div class=\"col\"> <div class=\"row mb-2\"> <label class=\"col-sm-3 col-form-label col-form-label-sm\" aria-label=\"Field {{p}} Name\" ng-attr-for=\"edit_f{{p}}_name\"> Name </label> <div class=\"col-sm-9\"> <input type=\"text\" class=\"form-control form-control-sm\" ng-attr-id=\"edit_f{{p}}_name\" ng-model=\"$ctrl.customer['f' + p + '_name']\"> </div> </div> <div class=\"row mb-2\" ng-if=\"p == 1 || p == 2\"> <label class=\"col-sm-3 col-form-label col-form-label-sm\" aria-label=\"Field {{p}} Replace Field\" ng-attr-for=\"edit_f{{p}}_replace\"> Replaces </label> <div class=\"col-sm-9\"> <select class=\"form-select form-select-sm\" ng-options=\"key as value for (key, value) in $ctrl.replaceFields\" ng-attr-id=\"edit_f{{p}}_replace\" ng-model=\"$ctrl.customer['f' + p + '_replace_field']\"> </select> </div> </div> <div class=\"form-check\"> <input type=\"checkbox\" class=\"form-check-input\" ng-attr-id=\"edit_f{{p}}_required\" ng-model=\"$ctrl.customer['f' + p + '_required']\"> <label class=\"form-check-label form-check-label-sm\" ng-attr-for=\"edit_f{{p}}_required\"> Required </label> </div> </div> <div class=\"col\"> <div class=\"row mb-2\" ng-repeat=\"value in $ctrl.customer['f' + p + '_value'] track by $index\"> <label class=\"col-sm-3 col-form-label col-form-label-sm\" aria-label=\"F{{p}} Value ({{$index}})\" ng-attr-for=\"f{{ p }}-value-{{ $index }}\"> Value </label> <div class=\"col-sm-9\"> <div class=\"d-flex\"> <input class=\"form-control form-control-sm me-1\" type=\"text\" ng-attr-id=\"f{{ p }}-value-{{ $index }}\" ng-model=\"$ctrl.customer['f' + p + '_value'][$index]\"> <button class=\"btn btn-outline-danger border-0 btn-sm\" ng-click=\"$ctrl.removeCustomCheckoutValue(p, $index)\"> Remove </button> </div> </div> </div> <button class=\"btn btn-secondary btn-sm mt-2\" ng-click=\"$ctrl.addCustomCheckoutValue(p)\"> Add F{{p}} Value </button> </div> </div> </fieldset> </li> </ul> <div class=\"modal-footer\"> <button type=\"button\" class=\"btn btn-primary\" data-bs-dismiss=\"modal\">Close</button> </div> </div> </div> </div> <div class=\"modal\" id=\"new-custom-checkout\"> <div class=\"modal-dialog modal-lg\"> <div class=\"modal-content\"> <div class=\"modal-header\"> <h4 class=\"modal-title\">Customize Checkout Fields</h4> <button type=\"button\" class=\"btn-close\" data-bs-dismiss=\"modal\" aria-label=\"close\"></button> </div> <div class=\"modal-body collapse border-bottom\" id=\"customFieldsHelp\"> <p class=\"mb-1\">To add or customize fields that appear on the Checkout page for this customer:</p> <ul class=\"list-unstyled\"> <li> Add at least a name to one of the fields below to enable the Custom Field. </li> <li> To replace an existing Additional Checkout field, select one from the <em>Replaces</em> field. Additional Checkout fields are configured in <em>Settings > Plugin</em>. </li> <li> If you leave the value blank, the customer will be able to fill out the Custom Field with any value. If you enter only one value, the Custom Field will appear as a read-only value on the Checkout page. If you fill out multiple values, the customer will be able to select from any of the values you provide. </li> </ul> </div> <ul class=\"list-group list-group-flush\"> <li ng-class=\"['list-group-item', {\r\n\t\t\t\t\t'list-group-item-primary': $ctrl.newCustomer['f' + p + '_name']\r\n\t\t\t\t}]\" ng-repeat=\"p in [1, 2, 3, 4, 5, 6]\"> <fieldset> <legend class=\"h6 d-flex justify-content-between\"> Field {{ p }} <a data-bs-toggle=\"collapse\" href=\"#customFieldsHelp\" role=\"button\" aria-expanded=\"false\" aria-controls=\"customFieldsHelp\"> <i class=\"bi bi-info-circle-fill\"></i> </a> </legend> <div class=\"row\"> <div class=\"col\"> <div class=\"row mb-2\"> <label class=\"col-sm-3 col-form-label col-form-label-sm\" aria-label=\"Field {{p}} Name\" ng-attr-for=\"edit_f{{p}}_name\"> Name </label> <div class=\"col-sm-9\"> <input type=\"text\" class=\"form-control form-control-sm\" ng-attr-id=\"edit_f{{p}}_name\" ng-model=\"$ctrl.newCustomer['f' + p + '_name']\"> </div> </div> <div class=\"row mb-2\" ng-if=\"p == 1 || p == 2\"> <label class=\"col-sm-3 col-form-label col-form-label-sm\" aria-label=\"Field {{p}} Replace Field\" ng-attr-for=\"edit_f{{p}}_replace\"> Replaces </label> <div class=\"col-sm-9\"> <select class=\"form-select form-select-sm\" ng-options=\"key as value for (key, value) in $ctrl.replaceFields\" ng-attr-id=\"edit_f{{p}}_replace\" ng-model=\"$ctrl.newCustomer['f' + p + '_replace_field']\"> </select> </div> </div> <div class=\"form-check\"> <input type=\"checkbox\" class=\"form-check-input\" ng-attr-id=\"edit_f{{p}}_required\" ng-model=\"$ctrl.newCustomer['f' + p + '_required']\"> <label class=\"form-check-label form-check-label-sm\" ng-attr-for=\"edit_f{{p}}_required\"> Required </label> </div> </div> <div class=\"col\"> <div class=\"row mb-2\" ng-repeat=\"value in $ctrl.newCustomer['f' + p + '_value'] track by $index\"> <label class=\"col-sm-3 col-form-label col-form-label-sm\" aria-label=\"F{{p}} Value ({{$index}})\" ng-attr-for=\"f{{ p }}-value-{{ $index }}\"> Value </label> <div class=\"col-sm-9\"> <div class=\"d-flex\"> <input class=\"form-control form-control-sm me-1\" type=\"text\" ng-attr-id=\"f{{ p }}-value-{{ $index }}\" ng-model=\"$ctrl.newCustomer['f' + p + '_value'][$index]\"> <button class=\"btn btn-outline-danger border-0 btn-sm\" ng-click=\"$ctrl.removeCustomCheckoutValue(p, $index)\"> Remove </button> </div> </div> </div> <button class=\"btn btn-secondary btn-sm mt-2\" ng-click=\"$ctrl.addCustomCheckoutValue(p)\"> Add F{{p}} Value </button> </div> </div> </fieldset> </li> </ul> <div class=\"modal-footer\"> <button type=\"button\" class=\"btn btn-secondary\" data-bs-dismiss=\"modal\">Close</button> </div> </div> </div> </div>";
// Exports
/* harmony default export */ const customer_accounts_component = (customer_accounts_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customer-accounts/customer-accounts.component.ts

var CustomerAccountsComponent = {
  template: customer_accounts_component,
  controller: CustomerAccountsController
};
CustomerAccountsController.$inject = ['$scope', '$window', '$state', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', 'customerAccounts', '$timeout', '$uibModal'];

function CustomerAccountsController($scope, $window, $state, $stateParams, Admin, Settings, Debug, Utils, Localized, SearchModal, customerAccounts, $timeout, $uibModal) {
  var _this = this;

  this.settings = Settings;

  this.$onInit = function () {
    _this.breadcrumbs = [{
      name: 'Customers',
      state: 'customers.page'
    }, {
      name: 'Accounts',
      state: 'customers-accounts'
    }];
    _this.activeTab = parseInt($stateParams.activeTab) || 0;
    _this.batches = [];
    _this.batchEndpoint = Localized.apiURL + '/admin/customers/batch/';
    _this.batchListOptions = {
      any: 'All',
      pending: 'Pending',
      confirmed: 'Confirmed',
      processing: 'Processing',
      processed: 'Processed'
    };
    _this.customer = {
      pricesheet: {}
    };
    _this.customerData = customerAccounts.customerData();
    _this.customerEndpoint = Localized.apiURL + '/admin/customers/';
    _this.customers = {};
    _this.isAuthed = Admin.Authed();
    _this.isLoading = false;
    _this.isLoadingMore = false;
    _this.isShowingPassword = false;
    _this.limitTypes = {
      none: 'None',
      monthly: 'Monthly',
      quarterly: 'Quarterly',
      flat: 'Flat'
    };
    _this.isCostCenterRequired = localized.settings.general.checkout.cost_center_option_required;
    _this.newCustomer = {
      pricesheet: {},
      promo_engine: true,
      punchout_suppliers: [],
      shipping_flat_rates: [],
      status: 'active'
    };
    _this.passwordPattern = /(?=.*[0-9])(?=.*[!@#$%^&*-])[a-zA-Z0-9!@#$%^&*]{8,}/;
    _this.replaceFields = {
      organization: 'Company/Organization',
      rr_po_num: 'Purchase Order Number',
      issuing_office: 'Issuing Office',
      cost_center_code: 'Cost Center Code',
      attention: 'Attention'
    };
    _this.role = null;
    _this.rppValues = [15, 30, 50, 100];
    _this.searchOptions = {
      id: 'ID',
      name: 'Name',
      email: 'Email'
    };
    _this.searchParams = {
      page: 1,
      q: '',
      searchBy: '',
      sortBy: 'id',
      sortType: 'asc',
      rpp: _this.rppValues[0] // Must be defined after rppValues is declared.

    };
    _this.searchTerm = '';
    _this.selectedBatch = null;
    _this.selectedCustomer = $stateParams.customer || null;
    _this.sortAscending = true;
    _this.sortBatchParams = {
      sort_by: 'batch_id',
      sort_type: '',
      status: 'any'
    };
    _this.states = _this.customerData.states;
    _this.statuses = {
      active: 'Active',
      inactive: 'Inactive',
      unverified: 'Unverified'
    };
    _this.updatedRates = []; //If the view tab is selected, redirect to the search page since selected product is null

    if (_this.activeTab === 2 && !_this.selectedCustomer) {
      _this.activeTab = 0;
    }
  };
  /**
   * Cancels changing the user account password.
   */


  this.cancelPasswordChange = function () {
    _this.customer.password = null;
    _this.customer.password_confirmation = null;
    _this.newCustomer.password = null;
    _this.newCustomer.password_confirmation = null;
    _this.isSettingNewPassword = false;
  };
  /**
   * Gets store settings used for default prefix
   */


  this.getDefaultPrefix = function () {
    Settings.store.Get()["finally"](function () {
      _this.isLoading = false;
    });
  };
  /**
   * Updates store settings user for default prefix
   */


  this.updateDefaultPrefix = function () {
    Settings.store.Set()["finally"](function () {
      _this.isLoading = false;
    });
  };
  /**
   * @param {number} i Tab index
   */


  this.tabChanged = function (i) {
    _this.activeTab = i;
    Settings.errors = {};
    _this.isLoading = true;
    var req = {
      method: 'GET',
      url: _this.customerEndpoint
    };

    switch (i) {
      case 0:
        //First tab selected
        Utils.getHttpPromise(req).then(function (resp) {
          _this.priceSheets = resp.price_sheets;
          _this.roles = resp.roles;
          _this.customers = resp.customers;
          _this.updatedRates = [];
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          _this.isLoading = false;
        });
        break;

      case 1:
        _this.isLoading = false;
        break;

      case 2:
        req.url += _this.selectedCustomer.id;
        Utils.getHttpPromise(req).then(function (resp) {
          _this.priceSheets = resp.price_sheets;
          _this.roles = resp.roles;
          _this.customer = _this.sanitizeCustomer(resp.customer);
          _this.suppliers = resp.suppliers;
          _this.customer.shipping_flat_rates = [];
          _this.updatedRates = [];
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          _this.isLoading = false;
        });
        break;

      case 3:
        _this.isLoading = false;
        break;

      case 4:
        req = {
          method: 'GET',
          url: _this.batchEndpoint,
          params: _this.sortBatchParams
        };
        Utils.getHttpPromise(req).then(function (resp) {
          _this.batches = resp.search_results; // eslint-disable-next-line no-shadow

          for (var _i = 0; _i < _this.batches.length; _i++) {
            if (_this.batches[_i].status === 'processing') {
              _this.updateBatchProgress();

              break;
            }
          }
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          _this.isLoading = false;
        });
        break;

      case 5:
        req = {
          method: 'GET',
          url: _this.batchEndpoint + _this.selectedBatch.batch_id
        };
        Utils.getHttpPromise(req).then(function (resp) {
          _this.selectedBatch = resp.batches[0];
          _this.batchHeaders = resp.batches[0].columns;
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          _this.isLoading = false;
        });
        break;

      case 6:
        _this.getDefaultPrefix();

        break;
    }
  };
  /**
   * @param {number} num Number
   */


  this.addCustomCheckoutValue = function (num) {
    if (_this.activeTab === 2) {
      _this.customer['f' + num + '_value'].push('');
    } else if (_this.activeTab === 1) {
      if (_this.newCustomer['f' + num + '_value']) {
        _this.newCustomer['f' + num + '_value'].push('');
      } else {
        _this.newCustomer['f' + num + '_value'] = [];

        _this.newCustomer['f' + num + '_value'].push('');
      }
    }
  };

  this.addCustomer = function () {
    _this.isLoading = true;
    var req = {
      method: 'POST',
      url: _this.customerEndpoint,
      data: _this.newCustomer
    };
    Utils.getHttpPromise(req).then(function (resp) {
      if (resp.errors.length <= 0) {
        _this.selectedCustomer = resp.customer;
        _this.newCustomer = {};
        _this.activeTab = 2;
      }
    }, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this.isLoading = false;
    });
  };

  this.changeTab = function (tabIndex, customerIndex) {
    _this.activeTab = tabIndex;
    _this.selectedCustomer = _this.customers.data[customerIndex];
  };

  this.changeBatchTab = function (tabIndex, batchIndex) {
    _this.activeTab = tabIndex;
    _this.selectedBatch = _this.batches[batchIndex];
  };

  this.checkPriceSheet = function (tabIndex) {
    if (tabIndex === 1) {
      angular.forEach(_this.priceSheets, function (sheet) {
        if (_this.newCustomer.price_sheet_id === sheet.price_sheet_id) {
          _this.selectedSheet = sheet.sheet;
        }
      });
    }

    if (tabIndex === 2) {
      angular.forEach(_this.priceSheets, function (sheet) {
        if (_this.customer.price_sheet_id === sheet.price_sheet_id) {
          _this.selectedSheet = sheet.sheet;
        }
      });
    }
  };

  this.confirmBatch = function () {
    _this.isLoading = true;
    var req = {
      method: 'POST',
      url: _this.batchEndpoint + 'confirm',
      data: {
        batch_id: _this.selectedBatch.batch_id
      }
    };
    Utils.getHttpPromise(req).then(function () {
      _this.selectedBatch = null;
      _this.activeTab = 4;
    }, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this.isLoading = false;
    });
  };

  this.formatDate = function (date) {
    var dateOut = new Date(date);
    return dateOut;
  };

  this.goToProduct = function (item) {
    $state.go('catalog-products', {
      activeTab: 2,
      product: item
    });
  };
  /**
   */


  this.openGroupSearchModal = function () {
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiURL + '/admin/groups/',
          params: {
            q: ''
          }
        },
        relationships: ['groups'],
        fields: ['group_id', 'name', 'parent_group_id', 'default_price_sheet'],
        fieldPrefixes: ['ID: ', '', 'Parent ID: ', 'Price Sheet: '],
        id: 'group_id',
        selectOne: true
      }]
    };
    callback = {
      confirm: _this.searchResults,
      cancel: _this.searchCancelled
    };
    SearchModal.Show(callback, _this.customer.name, data, 'Add items');
  };

  this.onCopy = function (copiedCustomer) {
    _this.customer = copiedCustomer;
  };

  this.openRatesSearchModal = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiURL + '/admin/shipping/flat-rate/',
          params: {
            q: '',
            excludedField: 'customer_id',
            excludedId: _this.selectedCustomer.id,
            excludedTable: 'shipping_flat_rate_customer'
          }
        },
        relationships: ['shipping_flat_rates'],
        fields: ['name', 'cost', 'enabled'],
        fieldPrefixes: ['Name: ', 'Cost: ', 'Enabled: '],
        id: 'id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: _this.customerEndpoint + _this.selectedCustomer.id
        },
        relationships: ['customer', 'flatrates'],
        fields: ['name', 'cost', 'enabled'],
        fieldPrefixes: ['Name: ', 'Cost: ', 'Enabled: '],
        id: 'id',
        selectOne: false
      }],
      updatedItems: _this.updatedRates
    };
    callback = {
      confirm: _this.rateResults,
      cancel: _this.searchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Flat Rates', config, 'Add Shipping Rates');
  };

  this.rateResults = function (resp) {
    if (_this.activeTab === 2) {
      _this.updatedRates = [];
      resp.forEach(function (rate) {
        if (rate.action === 'add') {
          _this.updatedRates.push(rate);

          _this.customer.shipping_flat_rates.push({
            id: rate.value.id
          });
        }

        if (rate.action === 'unselect') {
          angular.forEach(_this.customer.shipping_flat_rates, function (val, key) {
            if (val.id === rate.value.id) {
              _this.customer.shipping_flat_rates.splice(key, 1);
            }
          });
        }

        if (rate.action === 'remove') {
          _this.updatedRates.push(rate);

          _this.customer.shipping_flat_rates.push({
            id: rate.value.id,
            deleted: 1
          });
        }

        if (rate.action === 'deselect') {
          angular.forEach(_this.customer.shipping_flat_rates, function (val, key) {
            if (val.id === rate.value.id) {
              _this.customer.shipping_flat_rates.splice(key, 1);
            }
          });
        }
      });
    }
  };

  this.rateCheck = function (rate) {
    var check = false;
    angular.forEach(_this.updatedRates, function (key) {
      if (key.value.id === rate.id && key.action === 'remove') {
        check = true;
      }
    });
    return check;
  };

  this.removeCustomCheckoutValue = function (num, index) {
    if (_this.activeTab === 2) {
      _this.customer['f' + num + '_value'].splice(index, 1);
    } else if (_this.activeTab === 1) {
      _this.newCustomer['f' + num + '_value'].splice(index, 1);
    }
  };

  this.removeUploadFile = function () {
    _this.accountSheetUpload = null;
    Localized.setNotification({
      type: 'danger',
      message: 'File Successfully Removed'
    });
  };

  this.sanitizeCustomer = function (customer) {
    var hasMistypedValues = false;
    var sanitizedCustomer = customer;

    for (var index = 1; index <= 6; index++) {
      var key = "f".concat(index, "_value");

      if (typeof sanitizedCustomer[key] === 'string' || typeof sanitizedCustomer[key] === 'number') {
        sanitizedCustomer[key] = [sanitizedCustomer[key]];
        console.warn("The '".concat(key, "' property for ").concat(customer.name, " ID #").concat(customer.id, " has a mistyped value."));
        hasMistypedValues = true;
      }
    }

    if (hasMistypedValues) {
      Localized.setNotification({
        type: 'warning',
        message: 'One or more of the Custom Checkout Fields had a mistyped value that has been corrected. To review the changes, select the Checkout tab and click the Customize Checkout Fields button. To save the fixed changes, please click the Update button below.'
      });
    }

    return sanitizedCustomer;
  };
  /**
   * Callback that is used by the search modal
   */


  this.searchCancelled = function () {
    angular.noop();
  };

  this.searchCustomers = function () {
    _this.isLoadingMore = true;
    var req = {
      method: 'GET',
      url: _this.customerEndpoint,
      params: _this.searchParams
    };
    Utils.getHttpPromise(req).then(function (resp) {
      _this.customers = resp.customers;
      _this.roles = resp.roles;
      _this.priceSheets = resp.price_sheets;
    }, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this.isLoadingMore = false;
    });
  };
  /**
   * Callback that is used by the search modal
   *
   * @param {Object} resp Response
   */


  this.searchResults = function (resp) {
    if (_this.activeTab === 2) {
      _this.customer.group = resp[0].value;
      _this.customer.group_id = resp[0].value.group_id;
    } else if (_this.activeTab === 1) {
      _this.newCustomer.group = resp[0].value;
      _this.newCustomer.group_id = resp[0].value.group_id;
    }
  };

  this.setPage = function (page) {
    _this.searchParams.page = page;

    _this.searchCustomers();
  };

  this.setRpp = function (rpp) {
    _this.searchParams.rpp = rpp;

    _this.searchCustomers();
  };

  this.setQuery = function (query, searchBy) {
    _this.searchParams.page = 1; // Reset page when query changes.

    _this.searchParams.q = query;
    _this.searchParams.searchBy = searchBy;
    _this.searchTerm = _this.searchParams.q;
    _this.searchedBy = _this.searchParams.searchBy;

    _this.searchCustomers();
  };

  $scope.setUploading = function () {
    $scope.$apply(function () {
      _this.uploading = !_this.uploading;
    });
  };

  $scope.setFile = function (element) {
    var vm = _this;
    $scope.setUploading();
    $scope.$apply(function () {
      vm.theFile = element.files[0];
    });
    var totalBytes = vm.theFile.size;

    if (totalBytes < 1000000) {
      vm.fileSize = Math.floor(totalBytes / 1000) + 'KB';
    } else {
      vm.fileSize = Math.floor(totalBytes / 1000000) + 'MB';
    }

    var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

    if (regex.test(vm.theFile.name.toLowerCase())) {
      if (typeof FileReader !== 'undefined') {
        var reader = new FileReader();

        reader.onload = function () {
          // eslint-disable-next-line no-undef
          Papa.parse(reader.result, {
            complete: function complete(results) {
              var products = [];

              var _loop = function _loop(i) {
                var info = results.data[i];
                var product = [];
                angular.forEach(info, function (val, key) {
                  product[key] = val;
                });
                products.push(product);
              };

              for (var i = 0; i <= results.data.length; i++) {
                _loop(i);
              }

              $scope.$apply(function () {
                vm.accountSheetUpload = products;
              });
            }
          });
          $scope.setUploading();
        };

        reader.readAsText(vm.theFile);
      } else {
        $window.alert('This browser does not support HTML5.');
      }
    } else {
      vm.accountSheetUpload = null;
      vm.theFile = null;
      $scope.setUploading();
      $window.alert('Please upload a valid CSV file.');
    }
  };
  /**
   * @param {string} key Expecting 'shipping' or 'billing.
   * @param {Object} e   Click event
   */


  this.editAddresses = function (_key, e) {
    e.preventDefault();
    var _customerId = _this.customer.id;
    var modal = $uibModal.open({
      component: 'customerAddressModal',
      resolve: {
        customerId: function customerId() {
          return _customerId;
        },
        key: function key() {
          return _key;
        }
      },
      size: 'lg'
    });
    modal.result.then(function () {
      angular.noop();
    });
  };
  /**
   * @param {string} sortBy Sortby term
   * @param {Object} e      Click event
   */


  this.changeSortBy = function (sortBy, e) {
    e.preventDefault();
    _this.sortAscending = _this.searchParams.sortBy === sortBy ? !_this.sortAscending : true;
    _this.searchParams.sortBy = sortBy;
    _this.searchParams.sortType = _this.sortAscending ? 'asc' : 'desc';

    _this.searchCustomers();
  };

  this.sortBatchIndex = function (sortBy) {
    _this.sortAscending = _this.sortBatchParams.sort_by === sortBy ? !_this.sortAscending : true;
    _this.sortBatchParams.sort_by = sortBy;
    _this.sortBatchParams.sort_type = _this.sortAscending ? 'asc' : 'desc';

    _this.sortBatches();
  };
  /**
   */


  this.sortBatches = function () {
    _this.isLoadingMore = true;
    var req = {
      method: 'GET',
      url: _this.batchEndpoint,
      params: _this.sortBatchParams
    };
    Utils.getHttpPromise(req).then(function (resp) {
      _this.batches = resp.search_results;

      for (var i = 0; i < _this.batches.length; i++) {
        if (_this.batches[i].status === 'processing') {
          _this.updateBatchProgress();

          break;
        }
      }
    }, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this.isLoadingMore = false;
    });
  };
  /**
   */


  this.updateCustomer = function () {
    _this.isLoading = true;
    var endpoint = "".concat(_this.customerEndpoint).concat(_this.customer.id);
    var data = _this.customer; // Remove password property from data unless user is explicitly changing the password.

    if (!_this.isSettingNewPassword && 'password' in data) {
      delete data.password;
    }

    Utils.httpPut(endpoint, null, data).then(function (resp) {
      if (resp.errors.length <= 0) {
        angular.forEach(_this.updatedRates, function (rate) {
          if (rate.action === 'add') {
            _this.customer.flatrates.push(rate.value);
          } else {
            angular.forEach(_this.customer.flatrates, function (val, key) {
              if (val.id === rate.value.id) {
                _this.customer.flatrates.splice(key, 1);
              }
            });
          }
        });
        _this.updatedRates = [];
      }
    })["catch"](function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this.cancelPasswordChange();

      _this.isLoading = false;
    });
  };
  /**
   * @param {number} index Index
   * @param {any}    id    ID
   */


  this.postUpload = function (index, id) {
    _this.selectedBatch = {
      batch_id: id
    };
    _this.activeTab = index;
  };

  this.uploadCustomer = function () {
    _this.isLoading = true;
    var fd = new FormData();
    fd.append('file', _this.theFile);
    var req = {
      method: 'POST',
      url: _this.batchEndpoint + 'upload',
      data: fd,
      transformRequest: angular.identity,
      headers: {
        // eslint-disable-next-line no-undefined
        'Content-Type': undefined
      }
    };
    Utils.getHttpPromise(req).then(function (resp) {
      _this.postUpload(5, resp.batch_id);
    }, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this.isLoading = false;
      Localized.setNotification({
        type: 'success',
        message: 'File Successfully Uploaded'
      });
    });
  };
  /**
   */


  this.updateBatchProgress = function () {
    var req = {
      method: 'GET',
      url: _this.batchEndpoint,
      params: _this.sortBatchParams
    };
    var again = false;
    Utils.getHttpPromise(req).then(function (resp) {
      _this.batches = resp.search_results;

      for (var i = 0; i < _this.batches.length; i++) {
        if (_this.batches[i].status === 'processing' && _this.activeTab === 4) {
          again = true;
          break;
        }
      }

      if (again) {
        $timeout(function () {
          _this.updateBatchProgress();
        }, 5000);
      }
    }, function (errResp) {
      Debug.error(errResp);
    });
  };

  this.updatePriceSheet = function (priceSheetId, isNew) {
    if (!isNew) {
      _this.customer.price_sheet_id = priceSheetId;
    } else {
      _this.newCustomer.price_sheet_id = priceSheetId;
    }
  };

  this.viewDocument = function (id) {
    window.open(Admin.Download(Localized.apiURL + '/admin/customers/' + _this.customer.id + '/documents/' + id), '_blank');
  };
  /**
   */


  this.removeGroup = function () {
    _this.customer.group = null;
    _this.customer.group_id = null;
  };
  /**
   * Handles toggling approver/requestors values that won't mix
   *
   * @param {Object}  customer    Customer data
   * @param {boolean} isRequestor Is the user a requestor
   */


  this.updateGroupPermissions = function (customer, isRequestor) {
    if (customer.group) {
      if (isRequestor) {
        if (customer.group.requestor) {
          customer.group.approver = false;
          customer.group.pending_emails = false;
          customer.group.admin = false;
        }
      } else if (customer.group.approver || customer.group.admin || customer.group.pending_emails) {
        customer.group.requestor = false;

        if (customer.group.pending_emails && !customer.group.approver) {
          customer.group.pending_emails = false;
        }
      }
    }
  };

  this.OpenSupplierSearch = function (model) {
    _this.searchModalPage = 'supplier';
    var callback = {};
    var data = {
      tabs: [{
        http: {
          method: 'GET',
          url: Localized.apiURL + '/admin/punchout/supplier',
          params: {
            q: ''
          }
        },
        relationships: ['suppliers'],
        fields: ['id', 'name'],
        fieldPrefixes: ['ID: ', ''],
        id: 'id',
        selectOne: false
      }]
    };
    callback = {
      confirm: function confirm(resp) {
        model.punchout_suppliers.push({
          supplier: {
            name: resp[0].value.name,
            id: resp[0].value.id
          }
        });
      },
      cancel: function cancel() {
        angular.noop();
      }
    };
    SearchModal.Show(callback, 'Suppliers', data, 'Add Supplier');
  };

  this.removeProfile = function (index, customer) {
    customer.punchout_suppliers[index].deleted = true;
  };
}
;// CONCATENATED MODULE: ./assets/app/dev/components/customers/customers.module.ts











var CustomersModule = angular.module('CustomersModule', []).service('CustomerEmailService', CustomerEmailService).service('CustomerLoginService', CustomerLoginService).service('CustomerNotesService', CustomerNotesService).service('CustomersService', CustomersService).component('customerAccounts', CustomerAccountsComponent).component('customerAddressModal', CustomerAddressModalComponent).component('customerCopyButton', CustomerCopyButtonComponent).component('customerLogin', CustomerLoginComponent).component('customerNotes', CustomerNotesComponent).component('customerSendEmail', CustomerEmailComponent).component('customerPunchoutTab', CustomerPunchoutTabComponent).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/manufacturers/manufacturers.module.ts
var ManufacturersModule = angular.module('ManufacturersModule', []).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/products/products.module.ts
var ProductsModule = angular.module('ProductsModule', []).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/promo-codes/promo-codes.service.ts
function promo_codes_service_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function promo_codes_service_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function promo_codes_service_createClass(Constructor, protoProps, staticProps) { if (protoProps) promo_codes_service_defineProperties(Constructor.prototype, protoProps); if (staticProps) promo_codes_service_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function promo_codes_service_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var PromoCodesService = /*#__PURE__*/function () {
  PromoCodesService.$inject = ["$http", "Localized"];

  function PromoCodesService($http, Localized) {
    'ngInject';

    promo_codes_service_classCallCheck(this, PromoCodesService);

    promo_codes_service_defineProperty(this, "apiRoot", "".concat(localized.apiURL, "/admin/promo-codes"));

    this.$http = $http;
    this.Localized = Localized;
  }

  promo_codes_service_createClass(PromoCodesService, [{
    key: "delete",
    value: function _delete(id) {
      var _this = this;

      return this.$http["delete"]("".concat(this.apiRoot, "/").concat(id)).then(function (response) {
        _this.Localized.setNotifications(response.data);
      });
    }
  }, {
    key: "get",
    value: function get(id) {
      var _this2 = this;

      return this.$http.get("".concat(this.apiRoot, "/").concat(id)).then(function (response) {
        _this2.Localized.setNotifications(response.data);

        if (!response.data.errors.length) {
          return response.data;
        }
      });
    }
  }, {
    key: "query",
    value: function query(params) {
      var _this3 = this;

      return this.$http.get(this.apiRoot, {
        params: params
      }).then(function (response) {
        _this3.Localized.setNotifications(response.data);

        if (!response.data.errors.length) {
          return response.data;
        }
      });
    }
  }, {
    key: "save",
    value: function save(data) {
      var _this4 = this;

      return this.$http.post(this.apiRoot, data).then(function (response) {
        _this4.Localized.setNotifications(response.data);

        return response.data;
      });
    }
  }, {
    key: "update",
    value: function update(id, data) {
      var _this5 = this;

      return this.$http.put("".concat(this.apiRoot, "/").concat(id), data).then(function (response) {
        _this5.Localized.setNotifications(response.data);
      });
    }
  }]);

  return PromoCodesService;
}();
;// CONCATENATED MODULE: ./assets/app/dev/components/promo-codes/promo-codes.module.ts

var PromoCodesModule = angular.module('PromoCodesModule', []).service('PromoCodesService', PromoCodesService).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/punchout/punchout.module.ts
var PunchoutModule = angular.module('PunchoutModule', []).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-mapping/settings-mapping.service.ts
function settings_mapping_service_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function settings_mapping_service_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function settings_mapping_service_createClass(Constructor, protoProps, staticProps) { if (protoProps) settings_mapping_service_defineProperties(Constructor.prototype, protoProps); if (staticProps) settings_mapping_service_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function settings_mapping_service_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SettingsMappingService = /*#__PURE__*/function () {
  function SettingsMappingService($http, Localized) {
    settings_mapping_service_classCallCheck(this, SettingsMappingService);

    this.$http = $http;
    this.Localized = Localized;
    this.url = "".concat(Localized.wpRestUrl, "/vendorfuel/pages");
  }

  settings_mapping_service_createClass(SettingsMappingService, [{
    key: "get",
    value: function get() {
      return this.$http.get(this.url).then(function (response) {
        return response.data;
      });
    }
  }, {
    key: "update",
    value: function update(data) {
      var _this = this;

      return this.$http.post(this.url, data).then(function (response) {
        // Manually set a notification since the WP Rest API won't return a success message.
        if (response.status === 200) {
          _this.Localized.setNotification({
            type: 'success',
            message: 'Page mapping updated.'
          });
        }
      });
    }
  }]);

  return SettingsMappingService;
}();

settings_mapping_service_defineProperty(SettingsMappingService, "$inject", ['$http', 'Localized']);
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-mapping/settings-mapping.html
// Module
var settings_mapping_code = "<wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <form name=\"settingsMappingform\" ng-hide=\"$ctrl.isLoading\"> <fieldset ng-disabled=\"$ctrl.isUpdating\"> <legend>Page Link Mapping</legend> <p> VendorFuel uses special keys (e.g. account, cart) that are dynamically mapped to pages in WordPress in order to handle various e-commerce functions. If you want to have a key point to another page, you can select a different page to be mapped to that particular key and then click the Update button below. </p> <p> Note: Updating these mapped pages will not affect your permalinks settings. Also, you can update a mapped page's title and slug without affecting the map. </p> <div class=\"row g-2\" ng-repeat=\"(key, value) in $ctrl.map track by $index\"> <div class=\"col mb-3\"> <input type=\"text\" class=\"form-control\" aria-label=\"Key\" ng-attr-id=\"{{ key }}\" ng-attr-name=\"{{ 'key' + $index }}\" ng-model=\"value.template\" ng-pattern=\"$ctrl.pattern\" required/> <div class=\"form-text\" ng-if=\"settingsMappingform[ 'key' + $index ].$invalid\"> Please enter a key name, using lowercase letters and no spaces or special characters. </div> </div> <div class=\"col\"> <select class=\"form-select\" aria-label=\"Default select example\" ng-model=\"value.url\" ng-attr-name=\"{{ 'template' + $index }}\" required> <option ng-repeat=\"item in $ctrl.pages\" ng-value=\"item.url\" ng-if=\"item.title\"> {{ item.title }} </option> </select> <div class=\"form-text\" ng-if=\"settingsMappingform[ 'template' + $index ].$invalid\"> Please select a template to map to this key. </div> </div> </div> </fieldset> <wp-button is-disabled=\"settingsMappingform.$invalid\" is-primary=\"true\" on-click=\"$ctrl.update($ctrl.map)\" is-loading=\"$ctrl.isUpdating\"> {{ $ctrl.isUpdating ? 'Updating' : 'Update' }} </wp-button> <button type=\"button\" class=\"button\" ng-click=\"$ctrl.isAddingKey = true\" ng-hide=\"$ctrl.isAddingKey\"> Add New Key </button> </form> <form class=\"mt-3\" name=\"newKeyForm\" ng-if=\"$ctrl.isAddingKey\"> <fieldset> <legend>New Template Key</legend> <div class=\"row g-2\"> <div class=\"col mb-3\"> <input type=\"text\" class=\"form-control\" aria-label=\"Key\" id=\"key\" name=\"key\" ng-model=\"$ctrl.newKey.key\" ng-pattern=\"$ctrl.pattern\" required/> <div class=\"form-text\" ng-if=\"newKeyForm.key.$invalid\"> Please enter a key name, using lowercase letters and no spaces or special characters. </div> </div> <div class=\"col\"> <select class=\"form-select\" aria-label=\"Page\" ng-model=\"$ctrl.newKey.value\" name=\"value\" required> <option ng-repeat=\"item in $ctrl.pages\" ng-value=\"item\" ng-if=\"item.title\"> {{ item.title }} </option> </select> <div class=\"form-text\" ng-if=\"newKeyForm.value.$invalid\"> Please select a template to map to this key. </div> </div> <div class=\"col-auto\"> <button class=\"button button-primary\" ng-disabled=\"newKeyForm.$invalid\" ng-click=\"$ctrl.addKey( $ctrl.newKey.key, $ctrl.newKey.value )\"> Save </button> </div> </div> </fieldset> </form> ";
// Exports
/* harmony default export */ const settings_mapping = (settings_mapping_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-mapping/settings-mapping.component.ts
var settings_mapping_component_class;

function settings_mapping_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function settings_mapping_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function settings_mapping_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) settings_mapping_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) settings_mapping_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function settings_mapping_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


var SettingsMappingComponent = {
  template: settings_mapping,
  controller: (settings_mapping_component_class = /*#__PURE__*/function () {
    function SettingsMappingController(SettingsMappingService) {
      settings_mapping_component_classCallCheck(this, SettingsMappingController);

      settings_mapping_component_defineProperty(this, "lockedKeys", ['account', 'addresses', 'cart', 'catalog', 'checkout', 'favorites', 'forgot-password', 'group-account', 'group-orders', 'login', 'order-by-sku', 'orders', 'product-detail', 'punchout-return', 'register', 'reset-password', 'saved-cart', 'saved-carts', 'view-order']);

      settings_mapping_component_defineProperty(this, "isConfirmingDeletion", []);

      this.SettingsMappingService = SettingsMappingService;
      this.pattern = new RegExp('^[a-z\\-]*$');
    }

    settings_mapping_component_createClass(SettingsMappingController, [{
      key: "$onInit",
      value: function $onInit() {
        this.resetNewKey();
        this.getData();
      }
    }, {
      key: "addKey",
      value: function addKey(key, value) {
        this.map[key] = {
          id: value.id,
          url: value.url,
          title: value.title,
          template: key
        };
        this.isAddingKey = false;
        this.resetNewKey();
      }
    }, {
      key: "getData",
      value: function getData() {
        var _this = this;

        this.isLoading = true;
        this.SettingsMappingService.get().then(function (response) {
          _this.map = response[0];
          _this.pages = response[1];
          _this.isLoading = false;
        });
      }
    }, {
      key: "resetNewKey",
      value: function resetNewKey() {
        this.newKey = {
          key: '',
          value: null
        };
      }
    }, {
      key: "update",
      value: function update(newMap) {
        var _this2 = this;

        this.isUpdating = true;
        var data = {
          map: JSON.stringify(newMap)
        };
        this.SettingsMappingService.update(data).then(function () {
          _this2.isUpdating = false;

          _this2.getData();
        });
      }
    }]);

    return SettingsMappingController;
  }(), settings_mapping_component_defineProperty(settings_mapping_component_class, "$inject", ['SettingsMappingService']), settings_mapping_component_class)
};
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-plugin/settings-plugin.component.html
// Module
var settings_plugin_component_code = "<wp-spinner type=\"2x\" ng-if=\"$ctrl.isLoading\"> </wp-spinner> <form name=\"form\" ng-hide=\"$ctrl.isLoading\"> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <div class=\"mb-3\"> <label for=\"api-key\" class=\"form-label\">VendorFuel API key</label> <input type=\"text\" class=\"form-control\" id=\"api-key\" ng-model=\"$ctrl.settings.api_key\"/> </div> </fieldset> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend class=\"h5\">Catalog options</legend> <div class=\"row\"> <div class=\"col mb-3\"> <label for=\"product-slug\" class=\"form-label\"> Product slug </label> <input type=\"text\" class=\"form-control\" id=\"product-slug\" ng-model=\"$ctrl.settings.product_slug\"/> </div> <div class=\"col mb-3\"> <label for=\"cat-slug\" class=\"form-label\">Category slug</label> <input type=\"text\" class=\"form-control\" id=\"cat-slug\" ng-model=\"$ctrl.settings.cat_slug\"/> </div> </div> <fieldset class=\"mb-3\"> <legend class=\"h6\">Catalog filters</legend> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"enableRecyclable\" ng-model=\"$ctrl.settings.enableRecyclable\" ng-true-value=\"1\" ng-false-value=\"0\"/> <label class=\"form-check-label\" for=\"enableRecyclable\"> Enable Recyclable Options </label> <div class=\"form-text\"> Adds a 'Only recycled' filter on the catalog page, which allows users to filter only items with Post Consumer Recycled Content. </div> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"enableAbilityOne\" ng-model=\"$ctrl.settings.enableAbilityOne\"/> <label class=\"form-check-label\" for=\"enableAbilityOne\"> Enable AbilityOne </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"enableCoreList\" ng-model=\"$ctrl.settings.enableCoreList\"/> <label class=\"form-check-label\" for=\"enableCoreList\"> Enable Core List </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"enableGSA\" ng-model=\"$ctrl.settings.enableGSA\"/> <label class=\"form-check-label\" for=\"enableGSA\"> Enable <abbr title=\"U.S. General Services Administration\">GSA</abbr> </label> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"disableFacets\" ng-model=\"$ctrl.settings.disableFacets\"/> <label class=\"form-check-label\" for=\"disableFacets\"> Disable facet filters </label> <div class=\"form-text\"> Check this to disable facets such as brands, manufacturers and attributes from appearing as filters on the catalog. </div> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"excludeSoldOut\" ng-model=\"$ctrl.settings.excludeSoldOut\"/> <label class=\"form-check-label\" for=\"excludeSoldOut\"> Exclude sold out items by default </label> <div class=\"form-text\"> Enable this to exclude sold-out items by default on inventory controlled catalogs. If unchecked, users can still exclude sold-out items from the catalog if inventory control is enabled. </div> </div> </fieldset> <fieldset class=\"mb-3\"> <legend class=\"h6\">Subcategories</legend> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"showSubcategoryCards\" ng-model=\"$ctrl.settings.showSubcategoryCards\"/> <label class=\"form-check-label\" for=\"showSubcategoryCards\"> Show subcategory cards on Catalog pages </label> </div> <div ng-if=\"$ctrl.settings.showSubcategoryCards\"> <label for=\"subcategoryCardsLimit\">Limit of subcategory cards to show</label> <input class=\"form-control\" type=\"number\" min=\"0\" id=\"subcategoryCardsLimit\" ng-model=\"$ctrl.settings.subcategoryCardsLimit\"/> <div class=\"form-text\"> Leave blank or set to 0 to show all subcategory cards on Catalog pages. </div> </div> </fieldset> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"pagination\" ng-model=\"$ctrl.settings.pagination\" ng-true-value=\"1\" ng-false-value=\"0\"/> <label class=\"form-check-label\" for=\"pagination\"> Catalog pagination </label> <div class=\"form-text\"> Use pagination instead of infinite scroll for the catalog. </div> </div> </fieldset> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend class=\"h5\">Product detail options</legend> <div class=\"mb-3\"> <label for=\"relatedProductsTitle\" class=\"form-label\">Related products title</label> <input type=\"text\" class=\"form-control\" id=\"relatedProductsTitle\" ng-model=\"$ctrl.settings.relatedProductsTitle\" placeholder=\"Related Products\"/> <div class=\"form-text\"> The title for the related products on the product detail page. Defaults to 'Related products'. </div> </div> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"showRelatedAboveSpecs\" ng-model=\"$ctrl.settings.showRelatedAboveSpecs\"/> <label class=\"form-check-label\" for=\"showRelatedAboveSpecs\"> Show related products above specifications </label> <div class=\"form-text\"> Enabling this will display any related products above the products specifications on the product detail page. Leave this unchecked if you want to display related products underneath specifications. </div> </div> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"showReviews\" ng-model=\"$ctrl.settings.showReviews\"/> <label class=\"form-check-label\" for=\"showReviews\"> Show product reviews </label> </div> </fieldset> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend class=\"h5\">Cart options</legend> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"showFreeShipping\" ng-model=\"$ctrl.settings.showFreeShipping\"/> <label class=\"form-check-label\" for=\"showFreeShipping\"> Show free shipping minimum spend </label> <div class=\"form-text\"> Enable to show the free shipping minimum spend requirement in the cart menu and cart page. This can be used to encourage customers to spend more to qualify for free shipping, if available. </div> </div> </fieldset> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend class=\"h5\">Checkout options</legend> <fieldset> <legend class=\"h6\">Additional checkout fields</legend> <div class=\"form-text mb-3\"> Check any of the following fields to display them during checkout. Checking 'Required' will be make the field required. To replace any of these fields for a customer, go to the Customer Accounts Checkout tab. </div> <ul class=\"list-group mb-3\"> <li class=\"list-group-item\"> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"company-name\" ng-model=\"$ctrl.settings.checkout.company_name_option\"/> <label class=\"form-check-label\" for=\"company-name\">Company/Organization</label> </div> </div> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"company-name-required\" ng-model=\"$ctrl.settings.checkout.company_name_option_required\" ng-disabled=\"!$ctrl.settings.checkout.company_name_option\"/> <label class=\"form-check-label\" for=\"company-name-required\">Required</label> </div> </div> </div> </li> <li class=\"list-group-item\"> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"purchase-order\" ng-model=\"$ctrl.settings.checkout.purchase_order_option\"/> <label class=\"form-check-label\" for=\"purchase-order\"> Purchase order number </label> </div> </div> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"purchase-order-required\" ng-model=\"$ctrl.settings.checkout.purchase_order_option_required\" ng-disabled=\"!$ctrl.settings.checkout.purchase_order_option\"/> <label class=\"form-check-label\" for=\"purchase-order-required\"> Required </label> </div> </div> </div> </li> <li class=\"list-group-item\"> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"issuing-office\" ng-model=\"$ctrl.settings.checkout.issuing_office_option\"/> <label class=\"form-check-label\" for=\"issuing-office\"> Issuing office </label> </div> </div> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"issuing-office-required\" ng-model=\"$ctrl.settings.checkout.issuing_office_option_required\" ng-disabled=\"!$ctrl.settings.checkout.issuing_office_option\"/> <label class=\"form-check-label\" for=\"issuing-office-required\"> Required </label> </div> </div> </div> </li> <li class=\"list-group-item\"> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"cost-center\" ng-model=\"$ctrl.settings.checkout.cost_center_option\"/> <label class=\"form-check-label\" for=\"cost-center\">Cost center code</label> </div> </div> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"cost-center-required\" ng-model=\"$ctrl.settings.checkout.cost_center_option_required\" ng-disabled=\"!$ctrl.settings.checkout.cost_center_option\"/> <label class=\"form-check-label\" for=\"cost-center-required\">Required</label> </div> <small class=\"form-text\">To require this field per customer, go to the Customer Accounts Checkout tab.</small> </div> </div> </li> <li class=\"list-group-item\"> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"attention\" ng-model=\"$ctrl.settings.checkout.attention_option\"/> <label class=\"form-check-label\" for=\"attention\"> Attention </label> </div> </div> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"attention-required\" ng-model=\"$ctrl.settings.checkout.attention_option_required\" ng-disabled=\"!$ctrl.settings.checkout.attention_option\"/> <label class=\"form-check-label\" for=\"attention-required\">Required</label> </div> </div> </div> </li> <li class=\"list-group-item\"> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"notes\" ng-model=\"$ctrl.settings.checkout.notes_option\"/> <label class=\"form-check-label\" for=\"notes\"> Notes </label> </div> </div> <div class=\"col\"> <div class=\"form-check\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"notes-required\" ng-model=\"$ctrl.settings.checkout.notes_option_required\" ng-disabled=\"!$ctrl.settings.checkout.notes_option\"/> <label class=\"form-check-label\" for=\"notes-required\">Required</label> </div> </div> </div> </li> </ul> </fieldset> </fieldset> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend class=\"h5\">Registration options</legend> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"require-address\" ng-model=\"$ctrl.settings.requireAddress\" ng-true-value=\"1\" ng-false-value=\"0\"/> <label class=\"form-check-label\" for=\"require-address\"> Require address </label> <div class=\"form-text\"> Require address during registration of new users. </div> </div> </fieldset> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend class=\"h5\">Other Options</legend> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"bootstrap\" ng-model=\"$ctrl.settings.bootstrap\" ng-true-value=\"1\" ng-false-value=\"0\"/> <label class=\"form-check-label\" for=\"bootstrap\">Load Bootstrap 4</label> <div class=\"form-text\"> Load <a target=\"_blank\" href=\"https://getbootstrap.com/docs/4.6/getting-started/introduction/\">Bootstrap 4</a> CSS and JavaScript for VendorFuel-related templates. </div> </div> </fieldset> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend class=\"h5\">Development options</legend> <div class=\"mb-3\"> <label for=\"api-url\" class=\"form-label\"> API URL </label> <input type=\"text\" class=\"form-control\" id=\"api-url\" ng-model=\"$ctrl.settings.api_url\"/> </div> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"debug\" ng-model=\"$ctrl.settings.debug\"/> <label class=\"form-check-label\" for=\"debug\">Enable debug mode</label> <div class=\"form-text\"> Enabling this will load unminified versions of the plugin's JavaScript files and log additional messages to the browser console. </div> </div> </fieldset> <button class=\"button button-primary\" ng-click=\"$ctrl.update($ctrl.settings)\" ng-disabled=\"$ctrl.isUpdating\"> <wp-spinner type=\"loading\" ng-show=\"$ctrl.isUpdating\"> </wp-spinner> {{ $ctrl.isUpdating ? \"Updating\" : \"Update\" }} </button> </form> ";
// Exports
/* harmony default export */ const settings_plugin_component = (settings_plugin_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-plugin/settings-plugin.component.ts

var SettingsPluginComponent = {
  controller: PluginController,
  template: settings_plugin_component
};

function PluginController(Localized, Utils) {
  var vm = this;
  var wpEndpoint = "".concat(Localized.wpRestUrl, "/settings/general");
  vm.update = update;

  this.$onInit = function () {
    getData();
  };
  /**
   */


  function getData() {
    vm.isLoading = true;
    Utils.httpGet(wpEndpoint).then(function (settings) {
      vm.settings = settings;
      vm.isLoading = false;
    });
  }
  /**
   * @param {Object} settings Options data
   */


  function update(settings) {
    vm.isUpdating = true;
    var params = {
      settings: JSON.stringify(settings)
    };
    Utils.httpPost(wpEndpoint, params).then(function () {
      Localized.setNotification({
        type: 'success',
        message: 'Plugin settings have been updated.'
      });
      vm.isUpdating = false;
      getData();
    });
  }
}

PluginController.$inject = ['Localized', 'Utils'];
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-analytics/settings-analytics.component.html
// Module
var settings_analytics_component_code = "<wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <form name=\"form\" ng-hide=\"$ctrl.isLoading\"> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend>Analytics Settings</legend> <div class=\"mb-3\"> <label for=\"verification-code\" class=\"form-label\"> Site Verification Code </label> <input type=\"text\" class=\"form-control\" id=\"verification-code\" ng-model=\"$ctrl.settings.verification.code\"/> </div> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"enableUA\" ng-model=\"$ctrl.settings.UA.enabled\"/> <label class=\"form-check-label\" for=\"enableUA\"> Enable Universal Analytics </label> </div> </div> <div class=\"col\"> <div class=\"mb-3\" ng-show=\"$ctrl.settings.UA.enabled\"> <label for=\"ua-id\" class=\"form-label\"> Universal Analytics ID </label> <input type=\"text\" class=\"form-control\" id=\"ua-id\" ng-model=\"$ctrl.settings.UA.id\"/> </div> </div> </div> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"enableAW\" ng-model=\"$ctrl.settings.AW.enabled\"/> <label class=\"form-check-label\" for=\"enableAW\"> Enable AdWords/Google Ads </label> </div> </div> <div class=\"col\"> <div class=\"mb-3\" ng-show=\"$ctrl.settings.AW.enabled\"> <label for=\"aw-id\" class=\"form-label\"> AdWords/Google Ads ID </label> <input type=\"text\" class=\"form-control\" id=\"aw-id\" ng-model=\"$ctrl.settings.AW.id\"/> </div> </div> </div> </fieldset> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend class=\"fs-5\">Conversions</legend> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"enable-phone-leads\" ng-model=\"$ctrl.settings.conversions.phone.enabled\"/> <label class=\"form-check-label\" for=\"enable-phone-leads\"> Enable Phone Leads </label> </div> </div> <div class=\"col\" ng-show=\"$ctrl.settings.conversions.phone.enabled\"> <div class=\"mb-3\"> <label for=\"phone-number\" class=\"form-label\"> Phone number </label> <input type=\"tel\" class=\"form-control\" id=\"phone-number\" ng-model=\"$ctrl.settings.conversions.phone.number\"/> </div> <div class=\"mb-3\"> <label for=\"phone-tag\" class=\"form-label\"> Phone number tag </label> <input type=\"text\" class=\"form-control\" id=\"phone-tag\" ng-model=\"$ctrl.settings.conversions.phone.tag\"/> </div> </div> </div> <div class=\"row\"> <div class=\"col\"> <div class=\"form-check mb-3\"> <input class=\"form-check-input\" type=\"checkbox\" id=\"enableAW\" ng-model=\"$ctrl.settings.conversions\n                        .purchase.enabled\"/> <label class=\"form-check-label\" for=\"enableAW\"> Enable Purchase </label> </div> </div> <div class=\"col\"> <div class=\"mb-3\" ng-show=\"$ctrl.settings.conversions.purchase.enabled\"> <label for=\"aw-id\" class=\"form-label\"> Purchase Tag </label> <input type=\"text\" class=\"form-control\" id=\"aw-id\" ng-model=\"$ctrl.settings.conversions.purchase.tag\"/> </div> </div> </div> </fieldset> <button class=\"button button-primary\" ng-click=\"$ctrl.update($ctrl.settings)\" ng-disabled=\"$ctrl.isUpdating\"> <wp-spinner type=\"loading\" ng-show=\"$ctrl.isUpdating\"> </wp-spinner> {{ $ctrl.isUpdating ? \"Updating\" : \"Update\" }} </button> </form> ";
// Exports
/* harmony default export */ const settings_analytics_component = (settings_analytics_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-analytics/settings-analytics.component.ts

var SettingsAnalyticsComponent = {
  template: settings_analytics_component,
  controller: AnalyticsController
};

function AnalyticsController(Localized, Utils) {
  var vm = this;
  var wpEndpoint = "".concat(Localized.wpRestUrl, "/settings/analytics");
  vm.update = update;
  /**
   * Initialization
   */

  this.$onInit = function () {
    getData();
  };
  /**
   */


  function getData() {
    vm.isLoading = true;
    Utils.httpGet(wpEndpoint).then(function (data) {
      vm.settings = {
        AW: data.AW,
        conversions: data.conversions,
        UA: data.UA,
        verification: data.verification
      };
      vm.isLoading = false;
    });
  }
  /**
   * @param {Object} settings Options data
   */


  function update(settings) {
    vm.isUpdating = true;
    var params = {
      settings: JSON.stringify(settings)
    };
    Utils.httpPost(wpEndpoint, params).then(function () {
      Localized.setNotification({
        type: 'success',
        message: 'Analytics settings have been updated.'
      });
      vm.isUpdating = false;
      getData();
    });
  }
}

AnalyticsController.$inject = ['Localized', 'Utils'];
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-options/settings-options.component.html
// Module
var settings_options_component_code = "<wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <form name=\"form\" ng-hide=\"$ctrl.isLoading\"> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend>Options</legend> <div class=\"form-check mb-3\" ng-repeat=\"option in $ctrl.options track by $index\"> <input class=\"form-check-input\" type=\"checkbox\" ng-model=\"option.value\" ng-attr-id=\"{{ 'option-' + $index }}\"/> <label class=\"form-check-label\" ng-attr-for=\"{{ 'option-' + $index }}\"> {{ option.key }} </label> </div> </fieldset> <button class=\"button button-primary\" ng-click=\"$ctrl.update($ctrl.options)\" ng-disabled=\"$ctrl.isUpdating\"> <wp-spinner type=\"loading\" ng-show=\"$ctrl.isUpdating\"> </wp-spinner> {{ $ctrl.isUpdating ? \"Updating\" : \"Update\" }} </button> </form> ";
// Exports
/* harmony default export */ const settings_options_component = (settings_options_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-options/settings-options.component.ts
function settings_options_component_slicedToArray(arr, i) { return settings_options_component_arrayWithHoles(arr) || settings_options_component_iterableToArrayLimit(arr, i) || settings_options_component_unsupportedIterableToArray(arr, i) || settings_options_component_nonIterableRest(); }

function settings_options_component_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function settings_options_component_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return settings_options_component_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return settings_options_component_arrayLikeToArray(o, minLen); }

function settings_options_component_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function settings_options_component_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function settings_options_component_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }


var SettingsOptionsComponent = {
  template: settings_options_component,
  controller: OptionsController
};

function OptionsController(Localized, Utils) {
  var vm = this;
  var apiEndpoint = "".concat(Localized.apiURL, "/stores");
  var wpEndpoint = "".concat(Localized.wpRestUrl, "/settings/store");
  vm.update = update;
  /**
   * Initialization
   */

  this.$onInit = function () {
    getData();
  };
  /**
   */


  function getData() {
    vm.isLoading = true;
    Utils.httpGet(apiEndpoint).then(function (response) {
      vm.options = processOptions(response.store.options);
      vm.store = response.store;
      vm.isLoading = false;
    });
  }
  /**
   * @param {Object} options Settings options
   * @return {Array} Options
   */


  function processOptions(options) {
    var deprecated = ['Load Footer Template', 'Load Menu Nav Template'];
    return Object.entries(options).filter(function (option) {
      var _option = settings_options_component_slicedToArray(option, 1),
          key = _option[0];

      return !deprecated.includes(key);
    }).map(function (option) {
      var _option2 = settings_options_component_slicedToArray(option, 2),
          key = _option2[0],
          value = _option2[1];

      return {
        key: key,
        value: value
      };
    });
  }
  /**
   * @param {Object} data Options data
   */


  function update(data) {
    vm.isUpdating = true;
    var options = Object.fromEntries(data.map(function (option) {
      return [option.key, option.value];
    }));
    var body = {
      options: options
    };
    Utils.httpPut(apiEndpoint, null, body).then(function () {
      var params = body;
      Utils.httpPost(wpEndpoint, params).then(function () {
        Localized.setNotification({
          type: 'success',
          message: 'Setting options have been updated.'
        });
        vm.isUpdating = false;
        getData();
      });
    });
  }
}

OptionsController.$inject = ['Localized', 'Utils'];
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-store/settings-store.component.html
// Module
var settings_store_component_code = "<wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <form name=\"form\" ng-hide=\"$ctrl.isLoading\"> <fieldset class=\"mb-3\" ng-disabled=\"$ctrl.isUpdating\"> <legend>Store Settings</legend> <div class=\"row\"> <div class=\"col mb-3\"> <label for=\"name\" class=\"form-label\"> Store Name </label> <input type=\"text\" class=\"form-control\" id=\"name\" name=\"name\" ng-model=\"$ctrl.store.name\"/> </div> <div class=\"col mb-3\"> <label for=\"url\" class=\"form-label\"> Store URL </label> <input type=\"url\" class=\"form-control\" id=\"url\" name=\"url\" ng-model=\"$ctrl.store.url\"/> </div> </div> </fieldset> <button class=\"button button-primary\" ng-click=\"$ctrl.update($ctrl.store)\" ng-disabled=\"$ctrl.isUpdating\"> <wp-spinner type=\"loading\" ng-show=\"$ctrl.isUpdating\"> </wp-spinner> {{ $ctrl.isUpdating ? \"Updating\" : \"Update\" }} </button> </form> ";
// Exports
/* harmony default export */ const settings_store_component = (settings_store_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings-store/settings-store.component.ts


var SettingsStoreComponent = {
  bindings: {
    getMetrc: '&'
  },
  controller: StoreController,
  template: settings_store_component
};

function StoreController(Localized, Utils) {
  var vm = this;
  var apiEndpoint = "".concat(Localized.apiURL, "/stores");
  var wpEndpoint = "".concat(Localized.wpRestUrl, "/settings/store");
  vm.update = update;
  /**
   * Initialization
   */

  this.$onInit = function () {
    vm.stateOptions = usStates;
    getData();
  };
  /**
   */


  function getData() {
    vm.isLoading = true;
    Utils.httpGet(apiEndpoint).then(function (response) {
      vm.store = response.store;
      vm.getMetrc({
        hasMetrc: response.store.metrc_enabled
      });
      vm.isLoading = false;
    });
  }
  /**
   * @param {Object} store Store data
   */


  function update(store) {
    vm.isUpdating = true;
    var body = new FormData();
    body.append('name', store.name);
    body.append('url', store.url);
    var request = {
      method: 'POST',
      url: apiEndpoint,
      data: body,
      transformRequest: angular.identity,
      headers: {
        // eslint-disable-next-line no-undefined
        'Content-Type': undefined
      }
    };
    Utils.getHttpPromise(request).then(function () {
      // After updating the VF API, update the WP API with minimal data that's currently used.
      // eslint-disable-next-line no-shadow
      var body = {
        name: store.name,
        url: store.url,
        metrc_enabled: store.metrc_enabled
      };
      Utils.httpPost(wpEndpoint, null, body).then(function () {
        Localized.setNotification({
          type: 'success',
          message: 'Store settings have been updated.'
        });
        vm.isUpdating = false;
        getData();
      });
    });
  }
}

StoreController.$inject = ['Localized', 'Utils'];
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings.module.ts







var SettingsModule = angular.module('SettingsModule', []).config(["$stateProvider", function ($stateProvider) {
  'ngInject';

  $stateProvider.state({
    name: 'settings',
    url: '/settings',
    component: 'vfSettings',
    onEnter: function onEnter() {
      highlightMenuItem('settings');
    }
  });
}]).service('SettingsMappingService', SettingsMappingService).component('settingsMapping', SettingsMappingComponent).component('settingsPlugin', SettingsPluginComponent).component('settingsAnalytics', SettingsAnalyticsComponent).component('settingsOptions', SettingsOptionsComponent).component('settingsStore', SettingsStoreComponent).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/breadcrumb-control/breadcrumb-control.component.html
// Module
var breadcrumb_control_component_code = "<nav aria-label=\"breadcrumb\" ng-if=\"$ctrl.breadcrumbs.length\"> <ol class=\"breadcrumb\"> <li class=\"breadcrumb-item\"> <a ui-sref=\"dashboard\"> Dashboard </a> </li> <li ng-class=\"[\n        'breadcrumb-item',\n        {\n          active: $ctrl.$last\n        }\n      ]\" ng-repeat=\"breadcrumb in $ctrl.breadcrumbs\"> <a ui-sref=\"{{ breadcrumb.state }}\" ng-if=\"!$last\"> {{ breadcrumb.name }} </a> <span ng-if=\"$last\"> {{ breadcrumb.name }} </span> </li> </ol> </nav> ";
// Exports
/* harmony default export */ const breadcrumb_control_component = (breadcrumb_control_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/breadcrumb-control/breadcrumb-control.component.ts

var BreadcrumbControl = {
  bindings: {
    breadcrumbs: '<'
  },
  template: breadcrumb_control_component
};
;// CONCATENATED MODULE: ./assets/app/dev/components/components.module.ts







var ComponentsModule = angular.module('vendorfuelApp.components', [CustomersModule, ManufacturersModule, ProductsModule, PromoCodesModule, PunchoutModule, SettingsModule]).component('breadcrumbControl', BreadcrumbControl).name;
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-badge/bs-badge.html
// Module
var bs_badge_code = "<span ng-class=\"['badge text-capitalize', $ctrl.bgClass ]\"> {{ $ctrl.label }} </span>";
// Exports
/* harmony default export */ const bs_badge = (bs_badge_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-badge/bs-badge.component.ts
function bs_badge_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function bs_badge_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function bs_badge_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) bs_badge_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) bs_badge_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var BsBadgeComponent = {
  bindings: {
    label: '<'
  },
  template: bs_badge,
  transclude: true,
  controller: /*#__PURE__*/function () {
    function BadgeController() {
      bs_badge_component_classCallCheck(this, BadgeController);
    }

    bs_badge_component_createClass(BadgeController, [{
      key: "$onInit",
      value: function $onInit() {
        this.bgClass = this.getBgClass(this.label);
      }
    }, {
      key: "getBgClass",
      value: function getBgClass(label) {
        if (label.includes('approved')) {
          return 'bg-success';
        } else if (label.includes('denied')) {
          return 'bg-danger';
        } else if (label.includes('pending')) {
          return 'bg-warning';
        }

        return 'bg-secondary';
      }
    }]);

    return BadgeController;
  }()
};
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-pagination/bs-pagination.html
// Module
var bs_pagination_code = "<div class=\"hstack justify-content-between\"> <div class=\"hstack gap-2\"> <label for=\"rpp\" class=\"small text-nowrap\"> Items per page: </label> <select class=\"form-control\" id=\"rpp\" ng-change=\"$ctrl.changeRpp()\" ng-disabled=\"$ctrl.isLoading\" ng-model=\"$ctrl.rpp\" ng-options=\"value for value in $ctrl.rppValues\"></select> </div> <div class=\"hstack gap-2\"> <small> {{ $ctrl.data.total }} items </small> <ul class=\"pagination pagination-sm mb-0\" ng-if=\"$ctrl.data.last_page > 1\"> <li ng-class=\"['page-item mb-0', { \n                'disabled': $ctrl.data.current_page === 1 || $ctrl.isLoading }]\"> <a class=\"page-link\" href=\"#\" ng-click=\"$ctrl.changePage(1, $event)\"> <span class=\"screen-reader-text\"> First page </span> <i class=\"bi bi-chevron-double-left\" aria-hidden=\"true\"></i> </a> </li> <li ng-class=\"['page-item mb-0', { \n                'disabled': $ctrl.data.current_page === 1 || $ctrl.isLoading }]\"> <a class=\"page-link\" href=\"#\" ng-click=\"$ctrl.changePage( $ctrl.data.current_page - 1, $event )\" ng-disabled=\"$ctrl.data.current_page === 1\"> <span class=\"screen-reader-text\"> Previous page </span> <i class=\"bi bi-chevron-left\" aria-hidden=\"true\"></i> </a> </li> </ul> <small ng-if=\"$ctrl.data.last_page > 1\"> {{ $ctrl.data.current_page }} to {{ $ctrl.data.last_page }} </small> <ul class=\"pagination pagination-sm mb-0\" ng-if=\"$ctrl.data.last_page > 1\"> <li ng-class=\"['page-item mb-0', { \n                'disabled': $ctrl.data.current_page === $ctrl.data.last_page || $ctrl.isLoading }]\"> <a class=\"page-link\" href=\"#\" ng-click=\"$ctrl.changePage( $ctrl.data.current_page + 1, $event )\"> <span class=\"screen-reader-text\"> Next page </span> <i class=\"bi bi-chevron-right\" aria-hidden=\"true\"></i> </a> </li> <li ng-class=\"['page-item mb-0', { \n                'disabled': $ctrl.data.current_page === $ctrl.data.last_page || $ctrl.isLoading }]\"> <a class=\"page-link\" href=\"#\" ng-click=\"$ctrl.changePage( $ctrl.data.last_page, $event )\"> <span class=\"screen-reader-text\"> Last page </span> <i class=\"bi bi-chevron-double-right\" aria-hidden=\"true\"></i> </a> </li> </ul> </div> </div> ";
// Exports
/* harmony default export */ const bs_pagination = (bs_pagination_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-pagination/bs-pagination.component.ts
function bs_pagination_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function bs_pagination_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function bs_pagination_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) bs_pagination_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) bs_pagination_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function bs_pagination_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


var BsPaginationComponent = {
  bindings: {
    data: '<',
    isLoading: '<',
    onChange: '&'
  },
  controller: /*#__PURE__*/function () {
    function BsPaginationController() {
      bs_pagination_component_classCallCheck(this, BsPaginationController);

      bs_pagination_component_defineProperty(this, "rppValues", [15, 30, 50, 100]);
    }

    bs_pagination_component_createClass(BsPaginationController, [{
      key: "$onChanges",
      value: function $onChanges() {
        var _this$data;

        if ((_this$data = this.data) !== null && _this$data !== void 0 && _this$data.per_page) {
          this.rpp = Number(this.data.per_page);
        }
      }
    }, {
      key: "changePage",
      value: function changePage(page, e) {
        e.preventDefault();
        var rpp = this.rpp;
        this.onChange({
          page: page,
          rpp: rpp
        });
      }
    }, {
      key: "changeRpp",
      value: function changeRpp() {
        var page = 1;
        var rpp = this.rpp;
        this.onChange({
          page: page,
          rpp: rpp
        });
      }
    }]);

    return BsPaginationController;
  }(),
  template: bs_pagination
};
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-search-box/bs-search-box.html
// Module
var bs_search_box_code = "<form ng-submit=\"$ctrl.submit()\"> <fieldset ng-disabled=\"$ctrl.isLoading\"> <div class=\"hstack gap-2 mb-3\"> <button class=\"btn btn-secondary text-nowrap\" aria-label=\"Advanced filters\" type=\"button\" ng-click=\"$ctrl.toggleShowFilters()\" ng-if=\"$ctrl.filterFields\"> <i class=\"bi bi-filter\"></i> {{ $ctrl.isShowingFilters ? 'Hide' : 'Show' }} Filters </button> <div class=\"input-group\"> <input type=\"search\" class=\"form-control\" aria-label=\"Search query\" ng-change=\"$ctrl.changeInput( $ctrl.q )\" ng-model=\"$ctrl.q\"/> <button class=\"btn btn-secondary\" type=\"submit\"> <i class=\"bi bi-search\" aria-hidden=\"true\"></i> Search </button> </div> </div> <div class=\"collapse\" id=\"search-box-filters\"> <div class=\"row gx-5 row-cols-2\"> <div class=\"col mb-3\" ng-repeat=\"filter in $ctrl.filterFields\"> <div class=\"row\"> <label class=\"col-auto col-form-label col-form-label-sm\" ng-attr-for=\"{{ filter.field }}\"> {{ filter.label }} </label> <div class=\"col\"> <input type=\"search\" class=\"form-control form-control-sm\" ng-attr-id=\"{{ filter.field }}\" ng-change=\"$ctrl.changeInput( filter.term )\" ng-if=\"!filter.options\" ng-model=\"filter.term\"/> <select class=\"form-select\" ng-attr-id=\"{{ filter.field }}\" ng-if=\"filter.options\" ng-model=\"filter.term\"> <option value=\"\" selected=\"selected\">All</option> <option ng-repeat=\"(key, value) in filter.options track by $index\" ng-value=\"value\"> {{ key }} </option> </select> </div> </div> </div> </div> </div> </fieldset> </form> ";
// Exports
/* harmony default export */ const bs_search_box = (bs_search_box_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-search-box/bs-search-box.component.ts
function bs_search_box_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function bs_search_box_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function bs_search_box_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) bs_search_box_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) bs_search_box_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function bs_search_box_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


var BsSearchBoxComponent = {
  bindings: {
    filterFields: '<?',
    isLoading: '<?',
    isShowingFilters: '<?',
    onSubmit: '&',
    q: '<?'
  },
  controller: /*#__PURE__*/function () {
    function BsSearchBoxController() {
      bs_search_box_component_classCallCheck(this, BsSearchBoxController);

      bs_search_box_component_defineProperty(this, "page", 1);
    }

    bs_search_box_component_createClass(BsSearchBoxController, [{
      key: "$onInit",
      value: function $onInit() {
        this.isShowingFilters = this.isShowingFilters || false;
        var el = document.getElementById('search-box-filters');
        this.filtersCollapse = new bootstrap.Collapse(el, {
          toggle: this.isShowingFilters
        });
      }
    }, {
      key: "changeInput",
      value: function changeInput(val) {
        // Detect if a search-type input field has been cleared, and if so, trigger the form submission.
        if (!val) {
          this.submit();
        }
      }
    }, {
      key: "submit",
      value: function submit() {
        var q = this.q,
            filterFields = this.filterFields;
        this.onSubmit({
          q: q,
          filterFields: filterFields
        });
      }
    }, {
      key: "toggleShowFilters",
      value: function toggleShowFilters() {
        this.isShowingFilters = !this.isShowingFilters;
        this.filtersCollapse.toggle();
      }
    }]);

    return BsSearchBoxController;
  }(),
  template: bs_search_box
};
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-search-box-legacy/bs-search-box-legacy.html
// Module
var bs_search_box_legacy_code = "<form ng-submit=\"$ctrl.submit()\"> <fieldset class=\"input-group mb-3\" ng-disabled=\"$ctrl.isLoading\"> <button class=\"btn btn-secondary dropdown-toggle\" type=\"button\" data-bs-toggle=\"dropdown\" aria-expanded=\"false\" ng-if=\"$ctrl.searchOptions\"> Search by {{ $ctrl.searchOptions[$ctrl.searchBy] }} </button> <ul class=\"dropdown-menu\" ng-if=\"$ctrl.searchOptions\"> <li> <a class=\"dropdown-item\" href=\"#\" ng-click=\"$ctrl.changeSearchBy('', $event)\"> All </a> </li> <li><hr class=\"dropdown-divider\"></li> <li ng-repeat=\"(key, value) in $ctrl.searchOptions track by $index\"> <a class=\"dropdown-item\" href=\"#\" ng-click=\"$ctrl.changeSearchBy(key, $event)\"> {{ value }} </a> </li> </ul> <input type=\"search\" class=\"form-control\" aria-label=\"Search\" ng-model=\"$ctrl.q\" ng-change=\"$ctrl.changeQuery( $ctrl.q );\"> <button class=\"btn btn-secondary\" type=\"submit\"> <i class=\"bi bi-search\" aria-hidden=\"true\"></i> Search </button> </fieldset> </form>";
// Exports
/* harmony default export */ const bs_search_box_legacy = (bs_search_box_legacy_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-search-box-legacy/bs-search-box-legacy.component.ts
function bs_search_box_legacy_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function bs_search_box_legacy_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function bs_search_box_legacy_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) bs_search_box_legacy_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) bs_search_box_legacy_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var BsSearchBoxLegacyComponent = {
  bindings: {
    isLoading: '<',
    onSubmit: '&',
    q: '<',
    searchOptions: '<?'
  },
  controller: /*#__PURE__*/function () {
    function SearchFormController() {
      bs_search_box_legacy_component_classCallCheck(this, SearchFormController);
    }

    bs_search_box_legacy_component_createClass(SearchFormController, [{
      key: "$onInit",
      value: function $onInit() {
        this.searchBy = '';
      }
    }, {
      key: "changeQuery",
      value: function changeQuery(query) {
        // Refresh customers if the search field is cleared.
        if (!query) {
          this.onSubmit({
            query: query,
            searchBy: this.searchBy
          });
        }
      }
    }, {
      key: "changeSearchBy",
      value: function changeSearchBy(term, e) {
        e.preventDefault();
        this.searchBy = term;
      }
    }, {
      key: "submit",
      value: function submit() {
        this.onSubmit({
          query: this.q,
          searchBy: this.searchBy
        });
      }
    }]);

    return SearchFormController;
  }(),
  template: bs_search_box_legacy
};
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-table-sortable/bs-table-sortable.html
// Module
var bs_table_sortable_code = "<a href=\"#\" class=\"text-decoration-none\" ng-attr-title=\"{{ 'Sort by ' + $ctrl.label }}\" ng-click=\"$ctrl.click( $event )\"> {{ $ctrl.label }} <i ng-class=\"['bi', {\n        'bi-sort-down-alt': $ctrl.isAscending,\n        'bi-sort-down': !$ctrl.isAscending,\n    }]\" ng-if=\"$ctrl.params.sortBy === $ctrl.field\"> </i> </a>";
// Exports
/* harmony default export */ const bs_table_sortable = (bs_table_sortable_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bs-table-sortable/bs-table-sortable.component.ts
function bs_table_sortable_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function bs_table_sortable_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function bs_table_sortable_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) bs_table_sortable_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) bs_table_sortable_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var BsTableSortableComponent = {
  bindings: {
    field: '@',
    label: '@',
    onClick: '&',
    params: '<'
  },
  controller: /*#__PURE__*/function () {
    function BsTableSortableController() {
      bs_table_sortable_component_classCallCheck(this, BsTableSortableController);
    }

    bs_table_sortable_component_createClass(BsTableSortableController, [{
      key: "$onInit",
      value: function $onInit() {
        this.isAscending = this.params.sortBy !== this.field || this.params.sortType !== 'desc';
      }
    }, {
      key: "click",
      value: function click(e) {
        e.preventDefault();
        var sortBy = this.field;

        if (this.params.sortBy === this.field) {
          this.isAscending = !this.isAscending;
        }

        var sortType = this.isAscending ? 'asc' : 'desc';
        this.onClick({
          sortBy: sortBy,
          sortType: sortType
        });
      }
    }]);

    return BsTableSortableController;
  }(),
  template: bs_table_sortable
};
;// CONCATENATED MODULE: ./assets/app/dev/common/bootstrap/bootstrap.module.ts





var BootstrapModule = angular.module('BootstrapModule', []).component('bsBadge', BsBadgeComponent).component('bsPagination', BsPaginationComponent).component('bsSearchBox', BsSearchBoxComponent).component('bsSearchBoxLegacy', BsSearchBoxLegacyComponent).component('bsTableSortable', BsTableSortableComponent).name;
;// CONCATENATED MODULE: ./assets/app/dev/common/wordpress/wp-button/wp-button.html
// Module
var wp_button_code = "<button type=\"button\" ng-class=\"['button', {\n        'button-primary': $ctrl.isPrimary,\n        'button-delete': $ctrl.onDelete\n    }]\" ng-click=\"$ctrl.click()\" ng-disabled=\"$ctrl.isLoading\" ng-hide=\"$ctrl.isConfirming\"> <wp-spinner type=\"loading\" ng-if=\"$ctrl.isLoading\"></wp-spinner> <ng-transclude></ng-transclude> </button> <div class=\"ms-2 hstack gap-2 align-items-center\" ng-if=\"$ctrl.isConfirming\"> <strong class=\"small\">Delete this?</strong> <button class=\"button\" type=\"button\" ng-click=\"$ctrl.isConfirming = false\" ng-disabled=\"$ctrl.isLoading\"> Cancel, keep this </button> <button class=\"button button-delete\" type=\"button\" ng-click=\"$ctrl.onDelete()\" ng-disabled=\"$ctrl.isLoading\"> <wp-spinner type=\"loading\" ng-if=\"$ctrl.isLoading\"></wp-spinner> {{ $ctrl.isDeleting ? 'Deleting' : 'Yes, delete this' }} </button> </div> ";
// Exports
/* harmony default export */ const wp_button = (wp_button_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/wordpress/wp-button/wp-button.component.ts
function wp_button_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function wp_button_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function wp_button_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) wp_button_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) wp_button_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var WpButtonComponent = {
  bindings: {
    onClick: '&?',
    onDelete: '&?',
    isLoading: '<?',
    isPrimary: '<?'
  },
  template: wp_button,
  transclude: true,
  controller: /*#__PURE__*/function () {
    function ButtonController() {
      wp_button_component_classCallCheck(this, ButtonController);
    }

    wp_button_component_createClass(ButtonController, [{
      key: "click",
      value: function click() {
        if (this.onDelete) {
          this.isConfirming = true;
        } else {
          this.onClick();
        }
      }
    }, {
      key: "delete",
      value: function _delete(id) {
        this.onDelete(id);
      }
    }]);

    return ButtonController;
  }()
};
;// CONCATENATED MODULE: ./assets/app/dev/common/wordpress/wp-form-field/wp-form-field.html
// Module
var wp_form_field_code = "<div class=\"row mb-3\"> <label class=\"col-sm-3 col-form-label\" ng-attr-for=\"field-{{ $id }}\" ng-if=\"$ctrl.type != 'checkbox'\"> <strong>{{ $ctrl.label }}</strong> </label> <div ng-class=\"['col-sm-9', {\n      'offset-sm-3': $ctrl.type === 'checkbox',\n    }]\"> <select class=\"form-select\" ng-attr-id=\"field-{{ $id }}\" ng-change=\"$ctrl.change($ctrl.field)\" ng-disabled=\"$ctrl.isDisabled\" ng-if=\"$ctrl.options\" ng-model=\"$ctrl.field\" ng-readonly=\"$ctrl.isReadonly\"> <option ng-repeat=\"(key, value) in $ctrl.options\" ng-value=\"value\"> {{ key }} </option> </select> <textarea type=\"text\" class=\"form-control\" ng-attr-id=\"field-{{ $id }}\" ng-change=\"$ctrl.change($ctrl.field)\" ng-disabled=\"$ctrl.isDisabled\" ng-if=\"$ctrl.type === 'textarea' && !$ctrl.options\" ng-model=\"$ctrl.field\" ng-readonly=\"$ctrl.isReadonly\">\n    </textarea> <input class=\"form-control\" ng-attr-id=\"field-{{ $id }}\" ng-attr-type=\"{{ $ctrl.type }}\" ng-change=\"$ctrl.change($ctrl.field)\" ng-disabled=\"$ctrl.isDisabled\" ng-if=\"( $ctrl.type === 'text' || $ctrl.type === 'email' || $ctrl.type === 'password' ) && !$ctrl.options\" ng-model=\"$ctrl.field\" ng-readonly=\"$ctrl.isReadonly\"/> <div class=\"form-check\" ng-if=\"$ctrl.type === 'checkbox'\"> <input class=\"form-check-input\" type=\"checkbox\" ng-attr-id=\"field-{{ $id }}\" ng-change=\"$ctrl.change($ctrl.field)\" ng-disabled=\"$ctrl.isDisabled\" ng-model=\"$ctrl.field\" ng-readonly=\"$ctrl.isReadonly\"/> <label ng-attr-for=\"field-{{ $id }}\" class=\"form-check-label\"> {{ $ctrl.label }} </label> </div> <div class=\"form-text\" ng-if=\"$ctrl.description\"> {{ $ctrl.description }} </div> </div> </div> ";
// Exports
/* harmony default export */ const wp_form_field = (wp_form_field_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/wordpress/wp-form-field/wp-form-field.component.ts
function wp_form_field_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function wp_form_field_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function wp_form_field_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) wp_form_field_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) wp_form_field_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var WpFormFieldComponent = {
  bindings: {
    description: '@?',
    field: '<',
    header: '@?',
    isDisabled: '<?',
    isReadonly: '<?',
    label: '@',
    onChange: '&?',
    options: '<?',
    type: '@?'
  },
  controller: /*#__PURE__*/function () {
    function WpFormFieldController() {
      wp_form_field_component_classCallCheck(this, WpFormFieldController);

      this.type = this.type || 'text';
    }

    wp_form_field_component_createClass(WpFormFieldController, [{
      key: "change",
      value: function change(value) {
        this.onChange({
          value: value
        });
      }
    }]);

    return WpFormFieldController;
  }(),
  template: wp_form_field,
  transclude: true
};
;// CONCATENATED MODULE: ./assets/app/dev/common/wordpress/wp-spinner/wp-spinner.component.ts
var WpSpinnerComponent = {
  bindings: {
    type: '@?'
  },
  template: "\n\t\t<ng-switch on=\"$ctrl.type\">\n\t\t\t<div class=\"d-flex justify-content-center py-5\"\n\t\t\t\tng-switch-when=\"2x\">\n\t\t\t\t<img src=\"/wp-admin/images/spinner-2x.gif\" aria-hidden=\"true\"/>\n\t\t\t</div>    \n\t\t\t<img src=\"/wp-admin/images/loading.gif\" aria-hidden=\"true\"\n\t\t\t\tng-switch-when=\"loading\"/>\n\t\t\t<div class=\"d-flex justify-content-center py-3\" aria-hidden=\"true\"\n\t\t\t\tng-switch-default>\n\t\t\t\t<span class=\"spinner is-active\" role=\"status\"></span>\n\t\t\t</div>\n\t\t</ng-switch>\n\t\t"
};
;// CONCATENATED MODULE: ./assets/app/dev/common/wordpress/wp-notice-list/wp-notice-list.html
// Module
var wp_notice_list_code = "<div ng-class=\"'notice inline is-dismissible notice-'+notice.type\" ng-repeat=\"notice in $ctrl.noticeList track by $index\"> <p>{{ notice.message }}</p> <button type=\"button\" class=\"notice-dismiss\" ng-click=\"$ctrl.dismiss($index)\"> <span class=\"screen-reader-text\">Dismiss this notice.</span> </button> </div> ";
// Exports
/* harmony default export */ const wp_notice_list = (wp_notice_list_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/wordpress/wp-notice-list/wp-notice-list.component.ts
function wp_notice_list_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function wp_notice_list_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function wp_notice_list_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) wp_notice_list_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) wp_notice_list_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }


var WpNoticeListComponent = {
  controller: /*#__PURE__*/function () {
    NoticeController.$inject = ["Localized"];

    function NoticeController(Localized) {
      'ngInject';

      wp_notice_list_component_classCallCheck(this, NoticeController);

      this.Localized = Localized;
    }

    wp_notice_list_component_createClass(NoticeController, [{
      key: "$onInit",
      value: function $onInit() {
        this.noticeList = this.Localized.getNotifications();
      }
    }, {
      key: "dismiss",
      value: function dismiss(i) {
        this.Localized.deleteNotification(i);
      }
    }]);

    return NoticeController;
  }(),
  template: wp_notice_list
};
;// CONCATENATED MODULE: ./assets/app/dev/common/wordpress/wordpress.module.ts




var WordPressModule = angular.module('WordPressModule', []).component('wpButton', WpButtonComponent).component('wpFormField', WpFormFieldComponent).component('wpSpinner', WpSpinnerComponent).component('wpNoticeList', WpNoticeListComponent).name;
;// CONCATENATED MODULE: ./assets/app/dev/common/localized.service.ts
function localized_service_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function localized_service_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function localized_service_createClass(Constructor, protoProps, staticProps) { if (protoProps) localized_service_defineProperties(Constructor.prototype, protoProps); if (staticProps) localized_service_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

var LocalizedService = /*#__PURE__*/function () {
  function LocalizedService() {
    localized_service_classCallCheck(this, LocalizedService);

    this.debugMode = localized.settings.general.debug;
    this.root = {
      url: localized.dir.url,
      path: localized.dir.root
    };
    this.apiURL = localized.apiURL;
    this.api_key = localized.settings.general.api_key;
    this.wpRestUrl = localized.dir.wpRestUrl + 'vendorfuel';
    this.wpNonce = localized.nonce;
    this.plugin_data = localized.plugin_data;
    this.notifications = [];
  }

  localized_service_createClass(LocalizedService, [{
    key: "getNotifications",
    value: function getNotifications() {
      return this.notifications;
    }
  }, {
    key: "setNotification",
    value: function setNotification(notification) {
      var msg = notification.message;

      if (msg && msg !== 'undefined' && msg !== null && msg !== '' && msg !== 'OK') {
        this.notifications.push(notification);
      }
    }
  }, {
    key: "setNotifications",
    value: function setNotifications(data) {
      var _this = this;

      data.notifications.forEach(function (notification) {
        _this.setNotification({
          type: 'info',
          message: notification
        });
      });
      data.warnings.forEach(function (warning) {
        _this.setNotification({
          type: 'warning',
          message: warning
        });
      });
      data.errors.forEach(function (error) {
        _this.setNotification({
          type: 'error',
          message: error
        });
      });
    }
  }, {
    key: "deleteNotification",
    value: function deleteNotification(index) {
      if (this.notifications[index]) {
        this.notifications.splice(index, 1);
      } else {
        this.notifications.push({
          type: 'danger',
          message: 'Whoops! Unable to remove notification.'
        });
      }
    }
  }, {
    key: "deleteNotifications",
    value: function deleteNotifications() {
      this.notifications.splice(0, this.notifications.length);
    }
  }]);

  return LocalizedService;
}();
;// CONCATENATED MODULE: ./assets/app/dev/common/common.module.ts



var CommonModule = angular.module('vendorfuelApp.common', [BootstrapModule, WordPressModule]).service('Localized', LocalizedService).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/dashboard/dashboard-routing.module.ts

var dashboard_routing_module_states = [{
  name: 'dashboard',
  url: '/dashboard',
  component: 'dashboardPage'
}];
var DashboardRoutingModule = angular.module('DashboardRoutingModule', []).config(["$stateProvider", "$urlRouterProvider", function ($stateProvider, $urlRouterProvider) {
  'ngInject';

  $urlRouterProvider.otherwise('dashboard');
  dashboard_routing_module_states.forEach(function (state) {
    state.onEnter = function () {
      highlightMenuItem('dashboard');
    };

    $stateProvider.state(state);
  });
}]).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/dashboard/DashboardOrders.tsx
function DashboardOrders_slicedToArray(arr, i) { return DashboardOrders_arrayWithHoles(arr) || DashboardOrders_iterableToArrayLimit(arr, i) || DashboardOrders_unsupportedIterableToArray(arr, i) || DashboardOrders_nonIterableRest(); }

function DashboardOrders_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function DashboardOrders_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return DashboardOrders_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return DashboardOrders_arrayLikeToArray(o, minLen); }

function DashboardOrders_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function DashboardOrders_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function DashboardOrders_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }







var DashboardOrders_apiUrl = '/stats/dashboard/';
var DashboardOrders = function DashboardOrders() {
  var _useState = (0,react.useState)(true),
      _useState2 = DashboardOrders_slicedToArray(_useState, 2),
      isBusy = _useState2[0],
      setIsBusy = _useState2[1];

  var _useState3 = (0,react.useState)(),
      _useState4 = DashboardOrders_slicedToArray(_useState3, 2),
      orders = _useState4[0],
      setOrders = _useState4[1];

  var toCurrency = function toCurrency(num) {
    return num.toLocaleString('en-US', {
      style: 'currency',
      currency: 'USD'
    });
  };

  var toGrowth = function toGrowth(last, prev) {
    var iconClass = 'arrow-down-right';

    if (last === prev) {
      iconClass = 'arrow-right';
    } else if (last > prev) {
      iconClass = 'arrow-up-right';
    }

    var colorClass = 'text-muted';

    if (last > prev) {
      colorClass = 'text-success';
    } else if (last < prev) {
      colorClass = 'text-danger';
    }

    if (last && prev) {
      return /*#__PURE__*/(0,jsx_runtime.jsxs)("span", {
        className: colorClass,
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("i", {
          className: "bi bi-".concat(iconClass)
        }), "\xA0", Math.round((last / prev - 1) * 100), "%"]
      });
    }
  };

  var getOrders = function getOrders() {
    setIsBusy(true);
    vfAPI.get(DashboardOrders_apiUrl).then(function (response) {
      var _response$data;

      if ((_response$data = response.data) !== null && _response$data !== void 0 && _response$data.orders) {
        setOrders(response.data.orders);
      }

      setIsBusy(false);
    });
  };

  (0,react.useEffect)(function () {
    getOrders();
  }, []);
  return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
    children: [isBusy && /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
      className: "hstack justify-content-center py-5",
      children: /*#__PURE__*/(0,jsx_runtime.jsx)(Spinner, {})
    }), orders && /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
      children: [/*#__PURE__*/(0,jsx_runtime.jsx)("h3", {
        className: "h5",
        children: "Gross revenue"
      }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
        className: "row g-3 mb-4",
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("div", {
          className: "col-md-4",
          children: /*#__PURE__*/(0,jsx_runtime.jsxs)(card_component, {
            elevation: 2,
            children: [/*#__PURE__*/(0,jsx_runtime.jsx)(card_header_component, {
              children: "Today"
            }), /*#__PURE__*/(0,jsx_runtime.jsxs)(card_body_component, {
              children: [/*#__PURE__*/(0,jsx_runtime.jsx)("div", {
                children: /*#__PURE__*/(0,jsx_runtime.jsx)("strong", {
                  children: /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                    className: "fs-4",
                    children: toCurrency(orders.today_totals)
                  })
                })
              }), /*#__PURE__*/(0,jsx_runtime.jsxs)("small", {
                children: [orders.today ? orders.today.toLocaleString() : 'No', " orders"]
              })]
            })]
          })
        }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
          className: "col-md-4",
          children: /*#__PURE__*/(0,jsx_runtime.jsxs)(card_component, {
            elevation: 2,
            children: [/*#__PURE__*/(0,jsx_runtime.jsx)(card_header_component, {
              children: "Last 7 days"
            }), /*#__PURE__*/(0,jsx_runtime.jsxs)(card_body_component, {
              children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
                className: "hstack justify-content-between",
                children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("strong", {
                  children: [/*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                    className: "fs-4",
                    children: toCurrency(orders.last7_totals)
                  }), orders.last7 > 0 && /*#__PURE__*/(0,jsx_runtime.jsxs)("small", {
                    children: [" (", orders.last7.toLocaleString(), " order", orders.last7 > 1 ? 's' : '', ")"]
                  })]
                }), /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                  children: toGrowth(orders.last7_totals, orders.prev7_totals) || /*#__PURE__*/(0,jsx_runtime.jsx)(jsx_runtime.Fragment, {})
                })]
              }), /*#__PURE__*/(0,jsx_runtime.jsxs)("small", {
                children: ["Previous 7 days: ", toCurrency(orders.prev7_totals), orders.prev7 > 0 && /*#__PURE__*/(0,jsx_runtime.jsxs)("small", {
                  children: [" (", orders.prev7.toLocaleString(), " order", orders.prev7 > 1 ? 's' : '', ")"]
                })]
              })]
            })]
          })
        }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
          className: "col-md-4",
          children: /*#__PURE__*/(0,jsx_runtime.jsxs)(card_component, {
            elevation: 2,
            children: [/*#__PURE__*/(0,jsx_runtime.jsx)(card_header_component, {
              children: "Last 30 days"
            }), /*#__PURE__*/(0,jsx_runtime.jsxs)(card_body_component, {
              children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
                className: "hstack justify-content-between",
                children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("strong", {
                  children: [/*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                    className: "fs-4",
                    children: toCurrency(orders.last30_totals)
                  }), orders.last30 > 0 && /*#__PURE__*/(0,jsx_runtime.jsxs)("small", {
                    children: [" (", orders.last30.toLocaleString(), " order", orders.last30 > 1 ? 's' : '', ")"]
                  })]
                }), /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                  children: toGrowth(orders.last30_totals, orders.prev30_totals)
                })]
              }), /*#__PURE__*/(0,jsx_runtime.jsxs)("small", {
                children: ["Previous 30 days: ", toCurrency(orders.prev30_totals), orders.prev30 > 0 && /*#__PURE__*/(0,jsx_runtime.jsxs)("small", {
                  children: [" (", orders.prev30.toLocaleString(), " order", orders.prev30 > 1 ? 's' : '', ")"]
                })]
              })]
            })]
          })
        })]
      })]
    })]
  });
};
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/utils/font-values.js
/* harmony default export */ const font_values = ({
  'default.fontFamily': "-apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Oxygen-Sans, Ubuntu, Cantarell, 'Helvetica Neue', sans-serif",
  'default.fontSize': '13px',
  'helpText.fontSize': '12px',
  mobileTextMinFontSize: '16px'
});
//# sourceMappingURL=font-values.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/utils/font.js
/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


/**
 *
 * @param {keyof FONT} value Path of value from `FONT`
 * @return {string} Font rule value
 */

function font(value) {
  return (0,lodash.get)(font_values, value, '');
}
//# sourceMappingURL=font.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/base-control/styles/base-control-styles.js


function base_control_styles_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */

/**
 * Internal dependencies
 */



const Wrapper = emotion_styled_base_browser_esm("div",  true ? {
  target: "ej5x27r4"
} : 0)("font-family:", font('default.fontFamily'), ";font-size:", font('default.fontSize'), ";" + ( true ? "" : 0));

const deprecatedMarginField = _ref2 => {
  let {
    __nextHasNoMarginBottom = false
  } = _ref2;
  return !__nextHasNoMarginBottom && /*#__PURE__*/css("margin-bottom:", space(2), ";" + ( true ? "" : 0),  true ? "" : 0);
};

const StyledField = emotion_styled_base_browser_esm("div",  true ? {
  target: "ej5x27r3"
} : 0)(deprecatedMarginField, " .components-panel__row &{margin-bottom:inherit;}" + ( true ? "" : 0));
const labelStyles = /*#__PURE__*/css("display:inline-block;margin-bottom:", space(2), ";" + ( true ? "" : 0),  true ? "" : 0);
const StyledLabel = emotion_styled_base_browser_esm("label",  true ? {
  target: "ej5x27r2"
} : 0)(labelStyles, ";" + ( true ? "" : 0));

var _ref =  true ? {
  name: "11yad0w",
  styles: "margin-bottom:revert"
} : 0;

const deprecatedMarginHelp = _ref3 => {
  let {
    __nextHasNoMarginBottom = false
  } = _ref3;
  return !__nextHasNoMarginBottom && _ref;
};

const StyledHelp = emotion_styled_base_browser_esm("p",  true ? {
  target: "ej5x27r1"
} : 0)("margin-top:", space(2), ";margin-bottom:0;font-size:", font('helpText.fontSize'), ";font-style:normal;color:", COLORS.mediumGray.text, ";", deprecatedMarginHelp, ";" + ( true ? "" : 0));
const StyledVisualLabel = emotion_styled_base_browser_esm("span",  true ? {
  target: "ej5x27r0"
} : 0)(labelStyles, ";" + ( true ? "" : 0));
//# sourceMappingURL=base-control-styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/base-control/index.js


/**
 * External dependencies
 */


/**
 * Internal dependencies
 */


/**
 * `BaseControl` is a component used to generate labels and help text for components handling user inputs.
 *
 * @example
 * // Render a `BaseControl` for a textarea input
 * import { BaseControl } from '@wordpress/components';
 *
 * // The `id` prop is necessary to accessibly associate the label with the textarea
 * const MyBaseControl = () => (
 *   <BaseControl id="textarea-1" label="Text" help="Enter some text" __nextHasNoMarginBottom={ true }>
 *     <textarea id="textarea-1" />
 *   </BaseControl>
 * );
 */

const BaseControl = _ref => {
  let {
    __nextHasNoMarginBottom = false,
    id,
    label,
    hideLabelFromVision = false,
    help,
    className,
    children
  } = _ref;
  return (0,react.createElement)(Wrapper, {
    className: classnames_default()('components-base-control', className)
  }, (0,react.createElement)(StyledField, {
    className: "components-base-control__field" // TODO: Official deprecation for this should start after all internal usages have been migrated
    ,
    __nextHasNoMarginBottom: __nextHasNoMarginBottom
  }, label && id && (hideLabelFromVision ? (0,react.createElement)(visually_hidden_component, {
    as: "label",
    htmlFor: id
  }, label) : (0,react.createElement)(StyledLabel, {
    className: "components-base-control__label",
    htmlFor: id
  }, label)), label && !id && (hideLabelFromVision ? (0,react.createElement)(visually_hidden_component, {
    as: "label"
  }, label) : (0,react.createElement)(BaseControl.VisualLabel, null, label)), children), !!help && (0,react.createElement)(StyledHelp, {
    id: id ? id + '__help' : undefined,
    className: "components-base-control__help",
    __nextHasNoMarginBottom: __nextHasNoMarginBottom
  }, help));
};
/**
 * `BaseControl.VisualLabel` is used to render a purely visual label inside a `BaseControl` component.
 *
 * It should only be used in cases where the children being rendered inside `BaseControl` are already accessibly labeled,
 * e.g., a button, but we want an additional visual label for that section equivalent to the labels `BaseControl` would
 * otherwise use if the `label` prop was passed.
 *
 * @example
 * import { BaseControl } from '@wordpress/components';
 *
 * const MyBaseControl = () => (
 * 	<BaseControl help="This button is already accessibly labeled.">
 * 		<BaseControl.VisualLabel>Author</BaseControl.VisualLabel>
 * 		<Button>Select an author</Button>
 * 	</BaseControl>
 * );
 */

const VisualLabel = _ref2 => {
  let {
    className,
    children
  } = _ref2;
  return (0,react.createElement)(StyledVisualLabel, {
    className: classnames_default()('components-base-control__label', className)
  }, children);
};
BaseControl.VisualLabel = VisualLabel;
/* harmony default export */ const base_control = (BaseControl);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/text-control/index.js



/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */



function UnforwardedTextControl(props, ref) {
  const {
    label,
    hideLabelFromVision,
    value,
    help,
    className,
    onChange,
    type = 'text',
    ...additionalProps
  } = props;
  const instanceId = useInstanceId(TextControl);
  const id = `inspector-text-control-${instanceId}`;

  const onChangeValue = event => onChange(event.target.value);

  return (0,react.createElement)(base_control, {
    label: label,
    hideLabelFromVision: hideLabelFromVision,
    id: id,
    help: help,
    className: className
  }, (0,react.createElement)("input", extends_extends({
    className: "components-text-control__input",
    type: type,
    id: id,
    value: value,
    onChange: onChangeValue,
    "aria-describedby": !!help ? id + '__help' : undefined,
    ref: ref
  }, additionalProps)));
}
/**
 * TextControl components let users enter and edit text.
 *
 *
 * @example
 * ```jsx
 * import { TextControl } from '@wordpress/components';
 * import { useState } from '@wordpress/element';
 *
 * const MyTextControl = () => {
 *   const [ className, setClassName ] = useState( '' );
 *
 *   return (
 *     <TextControl
 *       label="Additional CSS Class"
 *       value={ className }
 *       onChange={ ( value ) => setClassName( value ) }
 *     />
 *   );
 * };
 * ```
 */


const TextControl = (0,react.forwardRef)(UnforwardedTextControl);
/* harmony default export */ const text_control = (TextControl);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/card-footer/hook.js
/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */




/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FooterProps, 'div'>} props
 */

function useCardFooter(props) {
  const {
    className,
    justify,
    isBorderless = false,
    isShady = false,
    size = 'medium',
    ...otherProps
  } = useContextSystem(props, 'CardFooter');
  const cx = useCx();
  const classes = (0,react.useMemo)(() => cx(Footer, borderRadius, borderColor, cardPaddings[size], isBorderless && borderless, isShady && shady, // This classname is added for legacy compatibility reasons.
  'components-card__footer', className), [className, cx, isBorderless, isShady, size]);
  return { ...otherProps,
    className: classes,
    justify
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/card/card-footer/component.js



/**
 * Internal dependencies
 */



/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FooterProps, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                                         forwardedRef
 */

function CardFooter(props, forwardedRef) {
  const footerProps = useCardFooter(props);
  return (0,react.createElement)(flex_component, extends_extends({}, footerProps, {
    ref: forwardedRef
  }));
}
/**
 * `CardFooter` renders an optional footer within a `Card`.
 *
 * @example
 * ```jsx
 * import { Card, CardBody, CardFooter } from `@wordpress/components`;
 *
 * <Card>
 * 	<CardBody>...</CardBody>
 * 	<CardFooter>...</CardFooter>
 * </Card>
 * ```
 */


const ConnectedCardFooter = contextConnect(CardFooter, 'CardFooter');
/* harmony default export */ const card_footer_component = (ConnectedCardFooter);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./assets/app/dev/components/dashboard/sections.ts
var sections = [{
  title: 'Accounting',
  icon: 'bank2',
  description: 'Link store data to QuickBooks.',
  href: '#!/accounting'
}, {
  title: 'Admin Accounts',
  icon: 'person-fill',
  description: 'Manage administrator accounts.',
  href: '#!/admin'
}, {
  title: 'Catalog',
  icon: 'book-fill',
  description: 'Manage Banners, Products, Categories, Collections, Manufacturers, Price Sheets, Promo Codes and Reviews.',
  href: '#!/catalog'
}, {
  title: 'Customers',
  icon: 'people-fill',
  description: 'Manage Customer Accounts, Groups and Roles.',
  href: '#!/customers'
}, {
  title: 'Email',
  icon: 'envelope-fill',
  description: 'Manage email templates and SMTP settings.',
  href: '#!/email'
}, {
  title: 'Orders',
  icon: 'bag-fill',
  description: 'Manage Orders and Order Tracking',
  href: '#!/orders'
}, {
  title: 'Payments',
  icon: 'credit-card-fill',
  description: 'Manage payments via PayPal, Stripe, Square, Qualpay, AuthorizeNet and PayFabric.',
  href: '#!/payments'
}, {
  title: 'Punchout',
  icon: 'cart-fill',
  description: 'Manage Punchout Suppliers.',
  href: '#!/punchout'
}, {
  title: 'Purchasing',
  icon: 'person-lines-fill',
  description: 'Manage Vendors, Cost Sheets and Document Profiles.',
  href: '#!/purchasing'
}, {
  title: 'Reports',
  icon: 'file-text-fill',
  description: 'Manage, download and schedule Reports.',
  href: '#!/reports'
}, {
  title: 'Settings',
  icon: 'gear-fill',
  description: 'Manage store, plugin and analytics settings.',
  href: '#!/settings'
}, {
  title: 'Shipping',
  icon: 'truck',
  description: 'Manage shipping modes, flat rates and parcels.',
  href: '#!/shipping'
}, {
  title: 'Taxes',
  icon: 'wallet-fill',
  description: 'Manage state taxes and connect with Avalara account.',
  href: '#!/taxes'
}];
;// CONCATENATED MODULE: ./assets/app/dev/components/dashboard/DashboardSections.tsx
function DashboardSections_slicedToArray(arr, i) { return DashboardSections_arrayWithHoles(arr) || DashboardSections_iterableToArrayLimit(arr, i) || DashboardSections_unsupportedIterableToArray(arr, i) || DashboardSections_nonIterableRest(); }

function DashboardSections_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function DashboardSections_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return DashboardSections_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return DashboardSections_arrayLikeToArray(o, minLen); }

function DashboardSections_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function DashboardSections_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function DashboardSections_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }







var DashboardSections = function DashboardSections() {
  var _useState = (0,react.useState)(''),
      _useState2 = DashboardSections_slicedToArray(_useState, 2),
      filter = _useState2[0],
      setFilter = _useState2[1];

  var getFilteredSections = function getFilteredSections(section) {
    return section.title.toLocaleLowerCase().includes(filter) || section.description.toLocaleLowerCase().includes(filter);
  };

  var handleClick = function handleClick() {
    setFilter('');
  };

  return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
    children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
      className: "row align-items-baseline",
      children: [/*#__PURE__*/(0,jsx_runtime.jsx)("div", {
        className: "col-md-3",
        children: /*#__PURE__*/(0,jsx_runtime.jsx)("h3", {
          className: "h5",
          children: "Sections"
        })
      }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
        className: "col-md-9",
        children: /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
          type: "search",
          label: "Filter sections",
          hideLabelFromVision: true,
          value: filter,
          onChange: setFilter,
          placeholder: "Filter sections by title or description."
        })
      })]
    }), !sections.filter(getFilteredSections).length && /*#__PURE__*/(0,jsx_runtime.jsx)(jsx_runtime.Fragment, {
      children: /*#__PURE__*/(0,jsx_runtime.jsxs)("p", {
        children: ["No sections found. ", /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
          variant: "link",
          onClick: handleClick,
          children: "Clear filter"
        })]
      })
    }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
      className: "row row-cols-1 row-cols-md-3 g-3",
      children: sections.filter(getFilteredSections).map(function (section, index) {
        return /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
          className: "col",
          children: /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
            className: "card h-100",
            children: [/*#__PURE__*/(0,jsx_runtime.jsx)(card_header_component, {
              children: /*#__PURE__*/(0,jsx_runtime.jsxs)("a", {
                className: "text-decoration-none",
                href: section.href,
                children: [/*#__PURE__*/(0,jsx_runtime.jsx)("i", {
                  className: "me-1 bi bi-".concat(section.icon)
                }), section.title]
              })
            }), /*#__PURE__*/(0,jsx_runtime.jsx)(card_body_component, {
              className: "h-100",
              children: section.description
            }), /*#__PURE__*/(0,jsx_runtime.jsx)(card_footer_component, {
              children: /*#__PURE__*/(0,jsx_runtime.jsxs)(build_module_button, {
                variant: "secondary",
                href: section.href,
                children: ["Go to ", section.title]
              })
            })]
          })
        }, index);
      })
    })]
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/components/dashboard/DashboardPage.tsx
function DashboardPage_typeof(obj) { "@babel/helpers - typeof"; return DashboardPage_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, DashboardPage_typeof(obj); }

function DashboardPage_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function DashboardPage_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function DashboardPage_createClass(Constructor, protoProps, staticProps) { if (protoProps) DashboardPage_defineProperties(Constructor.prototype, protoProps); if (staticProps) DashboardPage_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function DashboardPage_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) DashboardPage_setPrototypeOf(subClass, superClass); }

function DashboardPage_setPrototypeOf(o, p) { DashboardPage_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return DashboardPage_setPrototypeOf(o, p); }

function DashboardPage_createSuper(Derived) { var hasNativeReflectConstruct = DashboardPage_isNativeReflectConstruct(); return function _createSuperInternal() { var Super = DashboardPage_getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = DashboardPage_getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return DashboardPage_possibleConstructorReturn(this, result); }; }

function DashboardPage_possibleConstructorReturn(self, call) { if (call && (DashboardPage_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return DashboardPage_assertThisInitialized(self); }

function DashboardPage_assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function DashboardPage_isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function DashboardPage_getPrototypeOf(o) { DashboardPage_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return DashboardPage_getPrototypeOf(o); }







var DashboardPage = /*#__PURE__*/function (_React$Component) {
  DashboardPage_inherits(DashboardPage, _React$Component);

  var _super = DashboardPage_createSuper(DashboardPage);

  function DashboardPage() {
    DashboardPage_classCallCheck(this, DashboardPage);

    return _super.apply(this, arguments);
  }

  DashboardPage_createClass(DashboardPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("h2", {
          className: "mb-3",
          children: "Dashboard"
        }), /*#__PURE__*/(0,jsx_runtime.jsx)(DashboardOrders, {}), /*#__PURE__*/(0,jsx_runtime.jsx)(DashboardSections, {})]
      });
    }
  }]);

  return DashboardPage;
}(react.Component);
;// CONCATENATED MODULE: ./assets/app/dev/components/dashboard/dashboard.module.ts



var DashboardModule = angular.module('DashboardModule', [DashboardRoutingModule]).component('dashboardPage', (0,react2angular.react2angular)(DashboardPage)).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/email/email-routing.module.ts

var email_routing_module_states = [{
  name: 'email',
  url: '/email',
  component: 'emailPage'
}];
var EmailRoutingModule = angular.module('EmailRoutingModule', []).config(["$stateProvider", function ($stateProvider) {
  'ngInject';

  email_routing_module_states.forEach(function (state) {
    state.onEnter = function () {
      highlightMenuItem('email');
    };

    $stateProvider.state(state);
  });
}]).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/email/email-page.component.html
// Module
var email_page_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2 class=\"wp-heading-inline\">Email</h2> <vf-check-auth></vf-check-auth> <div class=\"container-fluid p-0\"> <div ng-if=\"isAuthed\" class=\"col p-0\"> <uib-tabset active=\"activeTab\" resize> <uib-tab index=\"0\" select=\"TabChanged(0)\" heading=\"Email Template Editor\"> <wp-spinner type=\"2x\" ng-show=\"loading || savingTemplate\"> </wp-spinner> <div ng-show=\"!loading\"> <form name=\"emailForm\"> <div class=\"row\" ng-if=\"!loading && !savingTemplate\"> <div class=\"col-md-6\"> <div class=\"mb-3\"> <label for=\"fullName\" class=\"form-label\">Sender Name</label> <input class=\"form-control\" name=\"fullName\" id=\"fullName\" ng-class=\"{ 'is-invalid': emailForm.username.$invalid }\" ng-model=\"selectedEmail.sender_name\" minlength=\"3\" placeholder=\"UserName\" ng-pattern=\"/[A-Za-z0-9\\-\\s_\\.\\']/\" required/> </div> <div class=\"mb-3\"> <label for=\"senderEmail\" class=\"form-label\">Sender Email</label> <input class=\"form-control\" id=\"senderEmail\" name=\"email\" ng-class=\"{ 'is-invalid': emailForm.email.$invalid }\" type=\"email\" ng-pattern='/^(([^<>()\\[\\]\\\\.,;:\\s@\"]+(\\.[^<>()\\[\\]\\\\.,;:\\s@\"]+)*)|(\".+\"))@((\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}])|(([a-zA-Z\\-0-9]+\\.)+[a-zA-Z]{2,}))$/' placeholder=\"example@example.com\" ng-model=\"selectedEmail.sender_email\" required/> <div class=\"form-text text-danger\" ng-if=\"emailForm.email.$invalid\"> Your email does not match the correct format. </div> </div> <div class=\"mb-3\"> <label for=\"subject\" class=\"form-label\">Subject Line</label> <input class=\"form-control\" id=\"subject\" name=\"subject\" ng-class=\"{ 'is-invalid': emailForm.subject.$invalid }\" ng-model=\"selectedEmail.subject\" ng-minlength=\"3\" placeholder=\"Welcome to ...\" ng-pattern=\"/[A-Za-z0-9\\-\\s_\\.\\']/\" required/> </div> <div class=\"mb-3\"> <label for=\"notification-emails\" class=\"form-label\">Notification Email(s)</label> <input type=\"text\" class=\"form-control\" name=\"notification_emails\" ng-class=\"{\r\n                      'is-invalid': emailForm.notification_emails.$invalid\r\n                    }\" placeholder=\"example@example.com\" ng-model=\"selectedEmail.notification_emails\"/> <div class=\"form-text\"> Enter comma separated email addresses to receive Admin copy of email. </div> </div> <div class=\"mb-3\"> <label for=\"fileUpload\" class=\"form-label\">Upload <abbr title=\"JavaScript Object Notation\">JSON</abbr> file</label> <input class=\"form-control\" type=\"file\" id=\"fileUpload\" onchange=\"angular.element(this).scope().UploadTemplate(this)\"/> </div> <div class=\"btn-toolbar mb-3 gap-1\"> <button class=\"button\" ng-click=\"DownloadHtmlTemplate();\"> Download HTML </button> <button class=\"button\" ng-click=\"DownloadJsonTemplate();\"> Download JSON </button> </div> </div> <div class=\"col-md-6\"> <div class=\"mb-3\"> <label for=\"chooseTemplate\" class=\"form-label\">Select Template</label> <select class=\"form-select\" id=\"chooseTemplate\" name=\"select\" ng-model=\"selectedEmail\" ng-options=\"email as email.type for email in emailTemplates\" ng-change=\"SelectTemplate(selectedEmail)\" ng-disabled=\"savingTemplate\"> <option value=\"\" hidden disabled=\"disabled\">Select Template</option> </select> </div> <div class=\"mb-3\"> <label for=\"clipboardVal\" class=\"form-label\">Short-Codes</label> <div class=\"input-group\"> <select id=\"clipboardVal\" class=\"form-select\" ng-model=\"clipboardVal\" ng-options=\"shortCode.value as shortCode.name for shortCode in shortCodes\"> <option value=\"\" hidden disabled=\"disabled\">Copy Short-Code</option> </select> <a class=\"button\" copy-to-clipboard=\"{{ clipboardVal }}\">Copy</a> </div> </div> <div class=\"input-group\" ng-if=\"shortCodesConditional.length >= 1\"> <span class=\"input-group-text min-w-115\">Conditionals</span> <select class=\"form-select\" ng-model=\"clipboardValConditional\" ng-options=\"shortCodeCond.value as shortCodeCond.name for shortCodeCond in shortCodesConditional\"> <option value=\"\" hidden disabled=\"disabled\">Select Short-Code</option> </select> <a class=\"btn btn-secondary\" copy-to-clipboard=\"{{ clipboardValConditional }}\">Copy</a> </div> </div> <clipboard style=\"height:.5px;overflow:hidden;opacity:0\"></clipboard> </div> <div ng-hide=\"savingTemplate\" style=\"min-height:1120px;position:relative;overflow:auto\"> <div id=\"bee-plugin-container\"></div> </div> </form> </div> <hr class=\"col-xs-12 p-0 m-tb-10\"/> </uib-tab> <uib-tab index=\"1\" select=\"TabChanged(1)\" heading=\"SMTP Settings\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-show=\"!loading\" class=\"row\"> <div ng-style=\"!isXS && { 'max-width': '500px' }\" class=\"wp-100 m-tb-0 m-s-auto\"> <form name=\"settingsForm\"> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text w-180\">Default</span> <div class=\"checkbox-addon p-10\"> <input class=\"form-control\" type=\"radio\" value=\"default\" ng-model=\"emailSettings.mode\"/> </div> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text w-180\">SMTP</span> <div class=\"checkbox-addon p-10\"> <input class=\"form-control\" type=\"radio\" value=\"smtp\" ng-model=\"emailSettings.mode\"/> </div> </div> <div ng-show=\"emailSettings.mode === 'smtp'\"> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text w-180\">Host</span> <input class=\"form-control\" type=\"text\" placeholder=\"Host\" ng-model=\"emailSettings.credentials.mail_host\" ng-required=\"emailSettings.mode === 'smtp'\"/> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text w-180\">Username</span> <input class=\"form-control\" type=\"text\" placeholder=\"Username\" ng-model=\"emailSettings.credentials.mail_user\" ng-required=\"emailSettings.mode === 'smtp'\"/> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text w-180\">Password</span> <input ng-attr-type=\"{{ showPassword ? 'text' : 'password' }}\" class=\"form-control\" type=\"password\" placeholder=\"Password\" ng-model=\"emailSettings.credentials.mail_pass\" ng-required=\"emailSettings.credentials.mode === 'smtp'\"/> <button ng-click=\"showPassword = !showPassword\" class=\"btn btn-primary\" type=\"button\"> <span ng-class=\"\r\n                        showPassword\r\n                          ? 'dashicons dashicons-visibility'\r\n                          : 'dashicons dashicons-hidden'\r\n                      \"></span> </button> </div> </div> <div ng-if=\"!saving\"> <button class=\"btn btn-primary\" type=\"button\" ng-click=\"UpdateSettings(emailSettings)\"> Update </button> </div> <div class=\"d-flex align-items-center\" ng-if=\"saving\"> <strong>Submitting, please wait...</strong> <div class=\"spinner is-active ml-auto\" role=\"status\" aria-hidden=\"true\"></div> </div> <wp-notice-list></wp-notice-list> </form> </div> </div> </uib-tab> </uib-tabset> </div> </div> ";
// Exports
/* harmony default export */ const email_page_component = (email_page_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/admin/email/email-page.component.ts
function email_page_component_slicedToArray(arr, i) { return email_page_component_arrayWithHoles(arr) || email_page_component_iterableToArrayLimit(arr, i) || email_page_component_unsupportedIterableToArray(arr, i) || email_page_component_nonIterableRest(); }

function email_page_component_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function email_page_component_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return email_page_component_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return email_page_component_arrayLikeToArray(o, minLen); }

function email_page_component_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function email_page_component_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function email_page_component_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function email_page_component_typeof(obj) { "@babel/helpers - typeof"; return email_page_component_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, email_page_component_typeof(obj); }


var EmailPageComponent = {
  template: email_page_component,
  controller: EmailPageController
};
EmailPageController.$inject = ['$scope', '$state', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'EmailsData'];

function EmailPageController($scope, $state, Admin, Settings, Debug, Utils, Localized, EmailsData) {
  this.breadcrumbs = [{
    name: 'Email',
    state: 'email'
  }];
  var bee = null;
  $scope.data = EmailsData.dataEmail();
  $scope.activeTab = 0;
  $scope.loading = false;
  $scope.saving = false;
  $scope.emails = [];
  $scope.emailEndpoint = Localized.apiURL + '/admin/email/';
  $scope.selectedEmail = {};
  $scope.emailSettings = {};
  $scope.showPassword = false;
  $scope.shortCodes = [];
  $scope.shortCodesConditional = [];
  $scope.pendingOptions = [];
  $scope.verifiedOptions = [];
  $scope.shipmentOptions = $scope.data.shipmentOptions;
  $scope.shipmentConditionals = $scope.data.shipmentConditionals;
  $scope.checkoutOptions = $scope.data.checkoutOptions;
  $scope.checkoutConditionals = $scope.data.checkoutConditionals;
  $scope.registerOptions = $scope.data.registerOptions;
  $scope.rmaOptions = $scope.data.rmaOptions;
  $scope.isAuthed = Admin.Authed();
  $scope.loadingBee = false; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TransitionState = function () {
    $state.go('email', {
      activeTab: $scope.activeTab
    });
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    Settings.errors = {};
    $scope.loading = true;
    $scope.saving = false;
    $scope.saved = false;
    var req = {
      method: 'GET',
      url: $scope.emailEndpoint
    };

    switch (i) {
      case 0:
        //First tab selected
        req.url += 'template/';
        Utils.getHttpPromise(req).then(function (resp) {
          $scope.emailTemplates = resp.email_templates;
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          $scope.selectedEmail = $scope.emailTemplates[0];
          $scope.shortCodes = $scope.registerOptions;
          $scope.loading = false;
        });
        break;

      case 1:
        req.url += 'mode/';
        Utils.getHttpPromise(req).then(function (resp) {
          $scope.emailSettings = resp;

          if (email_page_component_typeof($scope.emailSettings.credentials) !== 'object') {
            $scope.emailSettings.credentials = {
              mail_host: '',
              mail_pass: '',
              mail_user: ''
            };
          }
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          $scope.loading = false;
        });
        break;

      case 2:
        break;
    }
  };

  $scope.SelectTemplate = function (email) {
    $scope.selectedEmail = email;

    if ($scope.selectedEmail.type === 'shipment') {
      $scope.shortCodes = $scope.shipmentOptions;
      $scope.shortCodesConditional = $scope.shipmentConditionals;
    }

    if ($scope.selectedEmail.type === 'checkout') {
      $scope.shortCodes = $scope.checkoutOptions;
      $scope.shortCodesConditional = $scope.checkoutConditionals;
    }

    if ($scope.selectedEmail.type === 'rma') {
      $scope.shortCodes = $scope.rmaOptions;
      $scope.shortCodesConditional = [];
    }

    if ($scope.selectedEmail.type === 'register') {
      $scope.shortCodes = $scope.registerOptions;
      $scope.shortCodesConditional = [];
    }

    if ($scope.selectedEmail.type === 'verified') {
      $scope.shortCodes = $scope.verifiedOptions;
      $scope.shortCodesConditional = [];
    }

    if ($scope.selectedEmail.type === 'pending-approval') {
      $scope.shortCodes = $scope.pendingOptions;
      $scope.shortCodesConditional = [];
    }

    var template = JSON.parse(email.json);
    bee.load(JSON.parse(template));
  };

  $scope.UpdateSettings = function () {
    $scope.saving = true;
    var params = {
      mode: $scope.emailSettings.mode
    };

    if ($scope.emailSettings.mode === 'smtp') {
      params.credentials = {
        mail_user: $scope.emailSettings.credentials.mail_user,
        mail_host: $scope.emailSettings.credentials.mail_host,
        mail_pass: $scope.emailSettings.credentials.mail_pass
      };
    }

    var req = {
      method: 'PUT',
      url: $scope.emailEndpoint + 'mode',
      data: params
    };
    Utils.getHttpPromise(req).then(function () {}, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      $scope.loading = false;
      $scope.saving = false;
    });
  };

  $scope.UpdateTemplate = function (html, json) {
    var params = {
      notification: $scope.selectedEmail.notification_emails,
      sender: $scope.selectedEmail.sender_email,
      name: $scope.selectedEmail.sender_name,
      subject: $scope.selectedEmail.subject,
      message: html,
      json: json
    }; // params.type = $scope.selectedEmail.type;

    var req = {
      method: 'PUT',
      url: $scope.emailEndpoint + 'template/' + $scope.selectedEmail.type,
      data: params
    };
    Utils.getHttpPromise(req).then(function (resp) {
      angular.forEach($scope.emailTemplates, function (val, key) {
        if (val.id === resp.email_template.id) {
          // $scope.emailTemplates[key];
          $scope.emailTemplates[key] = resp.email_template;
          $scope.selectedEmail = $scope.emailTemplates[key];
        }
      });
    }, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      $scope.loading = false;
      $scope.savingTemplate = false;
    });
  };

  $scope.UploadTemplate = function (e) {
    var templateFile = e.files[0];
    var reader = new FileReader();

    reader.onload = function () {
      var templateString = reader.result; // @ts-ignore

      var template = JSON.parse(templateString);
      bee.load(JSON.parse(template));
    };

    reader.readAsText(templateFile);
  };

  var save = function save(filename, content) {
    // @ts-ignore
    saveAs(new Blob([content], {
      type: 'text/plain;charset=utf-8'
    }), filename);
  };

  $scope.DownloadHtmlTemplate = function () {
    save($scope.selectedEmail.type + '.html', $scope.selectedEmail.message);
  };

  $scope.DownloadJsonTemplate = function () {
    save($scope.selectedEmail.type + '.json', $scope.selectedEmail.json);
  };

  var request = function request(method, url, data, type, callback) {
    var req = new XMLHttpRequest();

    req.onreadystatechange = function () {
      if (req.readyState === 4 && req.status === 200) {
        var response = JSON.parse(req.responseText);
        callback(response);
      } else if (req.readyState === 4 && req.status !== 200) {
        Debug.error('Access denied, invalid credentials. Please check you entered a valid client_id and client_secret.');
      }
    };

    req.open(method, url, true);

    if (data && type) {
      if (type === 'multipart/form-data') {
        var formData = new FormData();

        for (var _i = 0, _Object$entries = Object.entries(data); _i < _Object$entries.length; _i++) {
          var _Object$entries$_i = email_page_component_slicedToArray(_Object$entries[_i], 1),
              key = _Object$entries$_i[0];

          formData.append(key, data[key]);
        }

        data = formData;
      } else {
        req.setRequestHeader('Content-type', type);
      }
    }

    req.send(data);
  };

  var specialLinks = [{
    type: 'unsubscribe',
    label: 'SpecialLink.Unsubscribe',
    link: 'http://[unsubscribe]/'
  }, {
    type: 'subscribe',
    label: 'SpecialLink.Subscribe',
    link: 'http://[subscribe]/'
  }];
  var mergeTags = [{
    name: 'tag 1',
    value: '[tag1]'
  }, {
    name: 'tag 2',
    value: '[tag2]'
  }];
  var mergeContents = [{
    name: 'test',
    value: '[content1]'
  }, {
    name: 'content 2',
    value: '[content1]'
  }];
  /**
   * @param {any} message Message
   * @param {any} sample  Sample
   * @return {Object} JSON
   */

  function userInput(message, sample) {
    return function handler(resolve, reject) {
      // eslint-disable-next-line no-alert
      var data = prompt(message, JSON.stringify(sample));
      return data === null || data === '' ? reject() : resolve(JSON.parse(data));
    };
  }

  var beeConfig = {
    uid: $scope.uid,
    container: 'bee-plugin-container',
    autosave: 15,
    language: 'en-US',
    trackChanges: true,
    specialLinks: specialLinks,
    mergeTags: mergeTags,
    mergeContents: mergeContents,
    contentDialog: {
      specialLinks: {
        label: 'Add a custom Special Link',
        handler: userInput('Enter the deep link:', {
          type: 'custom',
          label: 'external special link',
          link: 'http://www.example.com'
        })
      },
      mergeTags: {
        label: 'Add custom tag 2',
        handler: userInput('Enter the merge tag:', {
          name: 'name',
          value: 'name'
        })
      },
      mergeContents: {
        label: 'Choose a custom merge content',
        handler: userInput('Enter the merge content:', {
          name: 'my custom content',
          value: '{my-custom-content}'
        })
      },
      rowDisplayConditions: {
        label: 'Open builder',
        handler: userInput('Enter the row display condition:', {
          type: 'People',
          label: 'Person is a developer',
          description: 'Check if a person is a developer',
          before: '{if job === \'developer\'}',
          after: '{endif}'
        })
      }
    },
    onChange: function onChange(jsonFile, response) {
      Debug.log('json', jsonFile);
      Debug.log('response', response);
    },
    onSave: function onSave(jsonFile, htmlFile) {
      $scope.savingTemplate = true; // save('test.json', jsonFile);

      $scope.json = JSON.stringify(jsonFile);
      $scope.UpdateTemplate(htmlFile, $scope.json); // save('newsletter.html', htmlFile);
    },
    onSaveAsTemplate: function onSaveAsTemplate(jsonFile) {
      // + thumbnail?
      save('newsletter-template.json', jsonFile); // $scope.json = JSON.stringify(jsonFile);
      // $scope.UpdateTemplate(htmlFile, $scope.json);
    },
    onAutoSave: function onAutoSave(jsonFile) {
      // + thumbnail?
      window.localStorage.setItem('newsletter.autosave', jsonFile); // $scope.json = JSON.stringify(jsonFile);
      // $scope.UpdateTemplate(htmlFile, $scope.json);
    },
    // eslint-disable-next-line no-unused-vars
    onSend: function onSend(htmlFile) {//write your send test function here
    },
    onError: function onError(errorMessage) {
      Debug.error('onError ', errorMessage);
    }
  };

  var getBeeFreeAccessToken = function getBeeFreeAccessToken() {
    if (!$scope.loadingBee) {
      $scope.loadingBee = true;
      var req = {
        method: 'GET',
        url: Localized.apiURL + '/admin/beefree/token'
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.accessToken = resp.access_token;
        $scope.uid = resp.uid;
        beeConfig.uid = $scope.uid;
        $scope.SetupBee($scope.accessToken);
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {});
    }
  };

  $scope.SetupBee = function (token) {
    // eslint-disable-next-line no-undef
    BeePlugin.create(token, beeConfig, function (beePluginInstance) {
      bee = beePluginInstance;
      request('GET', 'https://rsrc.getbee.io/api/templates/m-bee', null, null, function () {
        var template = JSON.parse($scope.selectedEmail.json);
        bee.start(JSON.parse(template));
      });
    });
  };

  getBeeFreeAccessToken();
}
;// CONCATENATED MODULE: ./assets/app/dev/admin/email/email.module.ts


var EmailModule = angular.module('EmailModule', [EmailRoutingModule]).component('emailPage', EmailPageComponent).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders-routing.module.ts

var orders_routing_module_states = [{
  name: 'orders',
  url: '/orders',
  "abstract": true,
  template: '<ui-view/>'
}, {
  name: 'orders.index',
  url: '',
  component: 'ordersIndex'
}, {
  name: 'orders.show',
  url: '/:id',
  component: 'ordersDetail'
}, {
  name: 'orders.tracking',
  url: '/tracking',
  component: 'orderTracking'
}];
var OrdersRoutingModule = angular.module('OrdersRoutingModule', []).config(["$stateProvider", function ($stateProvider) {
  'ngInject';

  orders_routing_module_states.forEach(function (state) {
    state.onEnter = function () {
      highlightMenuItem('orders');
    };

    $stateProvider.state(state);
  });
}]).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders-index/orders-index.html
// Module
var orders_index_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <div class=\"d-flex justify-content-between mb-3\"> <h2>Orders</h2> <a class=\"btn btn-secondary btn-sm\" ui-sref=\"orders.tracking\"> Order Tracking </a> </div> <vf-check-auth></vf-check-auth> <wp-notice-list></wp-notice-list> <bs-search-box filter-fields=\"$ctrl.filterFields\" is-loading=\"$ctrl.isLoading\" is-showing-filters=\"true\" q=\"$ctrl.params.q\" on-submit=\"$ctrl.changeQuery(q, filterFields)\"> </bs-search-box> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\"> <table class=\"table table-hover\"> <thead> <tr> <th class=\"col-1\"> <bs-table-sortable label=\"ID\" field=\"order_id\" params=\"$ctrl.params\" on-click=\"$ctrl.changeSort(sortBy, sortType)\"> </bs-table-sortable> </th> <th class=\"col-2\"> <bs-table-sortable label=\"Status\" field=\"status\" params=\"$ctrl.params\" on-click=\"$ctrl.changeSort(sortBy, sortType)\"> </bs-table-sortable> </th> <th class=\"col-3\"> <bs-table-sortable label=\"Email\" field=\"email\" params=\"$ctrl.params\" on-click=\"$ctrl.changeSort(sortBy, sortType)\"> </bs-table-sortable> </th> <th class=\"col-3\"> <bs-table-sortable label=\"First\" field=\"first_name\" params=\"$ctrl.params\" on-click=\"$ctrl.changeSort(sortBy, sortType)\"> </bs-table-sortable> / <bs-table-sortable label=\"Last\" field=\"last_name\" params=\"$ctrl.params\" on-click=\"$ctrl.changeSort(sortBy, sortType)\"> </bs-table-sortable> </th> <th class=\"col-3 text-end\"> <bs-table-sortable label=\"Date\" field=\"order_date\" params=\"$ctrl.params\" on-click=\"$ctrl.changeSort(sortBy, sortType)\"> </bs-table-sortable> </th> </tr> </thead> <tbody> <tr class=\"table-warning text-center\" ng-if=\"!$ctrl.orders.data.length && !$ctrl.isLoadingMore\"> <td colspan=\"5\"> No Order(s) <span ng-if=\"$ctrl.params.q.length >= 1\">matching '{{ $ctrl.params.q }}'</span> found. </td> </tr> <tr class=\"cursor-pointer\" ng-if=\"!$ctrl.isLoadingMore\" ng-click=\"$ctrl.clickOrder(order.order_id)\" ng-repeat=\"order in $ctrl.orders.data track by $index\"> <td>{{ order.order_id }}</td> <td> <span ng-class=\"['badge text-uppercase', {\n\t\t\t\t\t\t'bg-primary': order.status === 'created',\n\t\t\t\t\t\t'bg-warning text-dark': order.status === 'pending' || order.status === 'pending-approval',\n\t\t\t\t\t\t'bg-success': order.status === 'completed',\n\t\t\t\t\t\t'bg-danger': order.status === 'canceled',\n\t\t\t\t\t\t}]\"> {{ order.status }} </span> </td> <td>{{order.email}}</td> <td>{{order.first_name}} {{order.last_name}}</td> <td class=\"text-end\">{{ order.order_date | date: 'short' }}</td> </tr> </tbody> </table> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoadingMore\"> </wp-spinner> </div> <bs-pagination data=\"$ctrl.orders\" is-loading=\"$ctrl.isLoading\" on-change=\"$ctrl.changePage(page, rpp)\"> </bs-pagination> ";
// Exports
/* harmony default export */ const orders_index = (orders_index_code);
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders-index/orders-index.component.ts
var orders_index_component_class;

function orders_index_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function orders_index_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function orders_index_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) orders_index_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) orders_index_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function orders_index_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


// eslint-disable-next-line no-shadow
var Status;

(function (Status) {
  Status["Created"] = "created";
  Status["Pending Approval"] = "pending-approval";
  Status["Completed"] = "completed";
  Status["Canceled"] = "canceled";
})(Status || (Status = {}));

var OrdersIndexComponent = {
  template: orders_index,
  controller: (orders_index_component_class = /*#__PURE__*/function () {
    function OrdersIndexController($rootScope, $state, OrdersService) {
      orders_index_component_classCallCheck(this, OrdersIndexController);

      orders_index_component_defineProperty(this, "isLoading", true);

      orders_index_component_defineProperty(this, "filterFields", [{
        label: 'Order Prefix',
        field: 'order_prefix'
      }, {
        label: 'Status',
        field: 'status',
        options: Status,
        term: Status.Completed
      }]);

      orders_index_component_defineProperty(this, "params", {
        page: 1,
        sortBy: 'order_id',
        sortType: 'desc'
      });

      orders_index_component_defineProperty(this, "rppValues", [15, 30, 50, 100]);

      orders_index_component_defineProperty(this, "searchParams", {
        q: '',
        sortBy: '',
        sortType: '',
        rpp: this.rppValues[0]
      });

      this.$rootScope = $rootScope;
      this.$state = $state;
      this.OrdersService = OrdersService;
      this.breadcrumbs = [{
        name: 'Orders',
        state: 'orders.index'
      }];
    }

    orders_index_component_createClass(OrdersIndexController, [{
      key: "$onInit",
      value: function $onInit() {
        // Set initial status filter to Completed
        this.params.filters = [{
          field: 'status',
          term: Status.Completed
        }];
        this.queryOrders();
      }
    }, {
      key: "changeQuery",
      value: function changeQuery(q, filterFields) {
        // Update q or delete from params
        if (q) {
          this.params.q = q;
        } else {
          delete this.params.q;
        } // Update filters or delete from params


        var activeFilters = filterFields.filter(function (filter) {
          return filter.term;
        });

        if (activeFilters.length) {
          this.params.filters = activeFilters.map(function (filter) {
            return {
              field: filter.field,
              term: filter.term
            };
          });
        } else if ('filters' in this.params) {
          delete this.params.filters;
        } // Reset page to 1 whenever query changes.


        this.params.page = 1;
        this.queryOrders();
      }
    }, {
      key: "queryOrders",
      value: function queryOrders() {
        var _this = this;

        this.isLoading = true;
        var params = this.params;
        this.OrdersService.query(params).then(function (response) {
          return response.data;
        }).then(function (data) {
          _this.orders = data.orders;
          _this.isLoading = false;
        });
      }
    }, {
      key: "clickOrder",
      value: function clickOrder(id) {
        this.$state.go('orders.show', {
          id: id
        });
      }
    }, {
      key: "changeSort",
      value: function changeSort(sortBy, sortType) {
        this.params.sortBy = sortBy;
        this.params.sortType = sortType;
        this.queryOrders();
      }
    }, {
      key: "changePage",
      value: function changePage(page, rpp) {
        this.params.page = page;
        this.params.rpp = rpp;
        this.queryOrders();
      }
    }]);

    return OrdersIndexController;
  }(), orders_index_component_defineProperty(orders_index_component_class, "$inject", ['$rootScope', '$state', 'OrdersService']), orders_index_component_class)
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders-detail/orders-detail.component.html
// Module
var orders_detail_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2> Order: <small class=\"text-muted\">{{ $ctrl.id }}</small> </h2> <vf-check-auth></vf-check-auth> <wp-notice-list></wp-notice-list> <wp-spinner type=\"2x\" ng-if=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\"> <form name=\"orderView\"> <div class=\"row mb-3\"> <div class=\"col-md-4\"> <table class=\"widefat striped mb-3\"> <tbody> <tr> <th class=\"text-end col-4\" scope=\"row\">ID</th> <td class=\"col-8\"> {{ $ctrl.selectedOrder.order_id }} </td> </tr> <tr> <th class=\"text-end\" scope=\"row\">Status</th> <td> <span ng-class=\"['badge text-uppercase', {\n\t\t\t\t\t\t\t\t\t\t\t'bg-primary': $ctrl.selectedOrder.status === 'created',\n\t\t\t\t\t\t\t\t\t\t\t'bg-warning text-dark': $ctrl.selectedOrder.status === 'pending' || $ctrl.selectedOrder.status === 'pending-approval',\n\t\t\t\t\t\t\t\t\t\t\t'bg-success': $ctrl.selectedOrder.status === 'completed',\n\t\t\t\t\t\t\t\t\t\t\t'bg-danger': $ctrl.selectedOrder.status === 'canceled',\n\t\t\t\t\t\t\t\t\t\t\t}]\"> {{ $ctrl.selectedOrder.status }} </span> </td> </tr> <tr> <th class=\"text-end\" scope=\"row\">Date</th> <td> {{ $ctrl.selectedOrder.order_date | date: \"short\" }} </td> </tr> <tr> <th class=\"text-end\" scope=\"row\">Customer</th> <td> {{ $ctrl.selectedOrder.customer.name }} <small>(<a ng-href=\"{{\n\t\t\t\t\t\t\t\t\t\t\t'mailto:' +\n\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.selectedOrder.customer\n\t\t\t\t\t\t\t\t\t\t\t\t\t.email\n\t\t\t\t\t\t\t\t\t\t}}\">{{ $ctrl.selectedOrder.customer.email }}</a>)</small> </td> </tr> </tbody> </table> <table class=\"widefat striped\"> <tbody> <tr> <th class=\"text-end col-4\" scope=\"row\">Subtotal</th> <td class=\"col-8\"> {{ $ctrl.selectedOrder.subtotal | currency }} </td> </tr> <tr> <th class=\"text-end\" scope=\"row\">Discount</th> <td> {{ $ctrl.selectedOrder.promo_discount | currency }} </td> </tr> <tr> <th class=\"text-end\" scope=\"row\">Shipping</th> <td> {{ $ctrl.selectedOrder.shipping | currency }} </td> </tr> <tr> <th class=\"text-end\" scope=\"row\">Tax</th> <td> {{ $ctrl.selectedOrder.tax | currency }} </td> </tr> </tbody> <tfoot> <tr> <th class=\"text-end\" scope=\"row\">Total</th> <td class=\"fw-bolder\"> {{ $ctrl.selectedOrder.total_amt | currency }} </td> </tr> </tfoot> </table> </div> <div class=\"col-md-8\"> <uib-tabset> <uib-tab heading=\"Shipments\"> <h3 class=\"h5\"> Shipments <button class=\"button\" ng-click=\"$ctrl.openShipmentModal()\"> Add Shipment </button> </h3> <table class=\"widefat striped\"> <tbody> <tr> <th class=\"col-3\" scope=\"row\"> Order Shipped </th> <td class=\"col-9\"> {{ $ctrl.selectedOrder.order_shipped ? \"Yes\" : \"No\" }} </td> </tr> <tr> <th scope=\"row\">Shipping Method</th> <td class=\"text-capitalize\"> {{ $ctrl.selectedOrder.shipping_method }} </td> </tr> </tbody> </table> <div class=\"mt-3\" ng-if=\"$ctrl.selectedOrder.order_shipments.length\"> <h4 class=\"h6\">Order Shipments</h4> <table class=\"widefat striped mb-2\" ng-repeat=\"shipment in $ctrl.selectedOrder.order_shipments\"> <tbody> <tr> <th class=\"col-3\" scope=\"row\"> Shipment Date </th> <td class=\"col-9\"> <time ng-attr-datetime=\"{{\n\t\t\t\t\t\t\t\t\t\t\t\t\tshipment.shipment_date\n\t\t\t\t\t\t\t\t\t\t\t\t}}\">{{ shipment.shipment_date | date: \"short\" }}</time> </td> </tr> <tr> <th scope=\"row\">Delivery Date</th> <td> <time ng-attr-datetime=\"{{\n\t\t\t\t\t\t\t\t\t\t\t\t\tshipment.shipment_date\n\t\t\t\t\t\t\t\t\t\t\t\t}}\">{{ shipment.delivery_date | date: \"short\" }}</time> </td> </tr> <tr> <th scope=\"row\">Carrier</th> <td> {{ shipment.carrier | date: \"short\" }} </td> </tr> <tr> <th scope=\"row\">Tracking Code</th> <td>{{ shipment.code }}</td> </tr> <tr> <th scope=\"row\">Items</th> <td class=\"p-0\"> <table class=\"widefat border-bottom-0 border-end-0\"> <thead> <tr> <th>Product</th> <th> <abbr title=\"Stock Keeping Unit\">SKU</abbr> </th> <th> <abbr title=\"Quantity\">QTY</abbr> Shipped </th> </tr> </thead> <tbody> <tr ng-repeat=\"item in shipment.items track by $index\"> <td> {{ item.product .description }} </td> <td> {{ item.product.sku }} </td> <td> {{ item.shipped.qty }} </td> </tr> </tbody> </table> </td> </tr> </tbody> </table> </div> </uib-tab> <uib-tab heading=\"Line Items\"> <h3 class=\"h5\">Line Items</h3> <table class=\"widefat striped\"> <thead> <tr> <th class=\"col-2\"> <abbr title=\"Stock Keeping Unit\">SKU</abbr> </th> <th class=\"col-1\"> <abbr title=\"Quantity\">QTY</abbr> </th> <th class=\"col-1\">Price</th> <th ng-class=\"{\n                    'col-6': !$ctrl.hasPurchaseOrders,\n                    'col-3': $ctrl.hasPurchaseOrders,\n                  }\"> Description </th> <th class=\"col-3\" ng-if=\"$ctrl.hasPurchaseOrders\"> Purchase Order </th> <th class=\"col-auto\">Actions</th> </tr> </thead> <tbody> <tr ng-repeat=\"item in $ctrl.selectedOrder.lineItems track by $index\"> <td> <a href=\"#\" title=\"Go to {{\n\t\t\t\t\t\t\t\t\t\t\t\titem.product.description\n\t\t\t\t\t\t\t\t\t\t\t}}\" ng-click=\"$ctrl.goToProduct( item, $event )\">{{ item.product.sku }}</a> </td> <td> <a href=\"#\" title=\"Go to {{\n\t\t\t\t\t\t\t\t\t\t\t\titem.product.description\n\t\t\t\t\t\t\t\t\t\t\t}}\" ng-click=\"$ctrl.goToProduct( item, $event )\">{{ item.qty }}</a> </td> <td>{{ item.price | currency }}</td> <td> <a href=\"#\" title=\"Go to {{\n\t\t\t\t\t\t\t\t\t\t\t\titem.product.description\n\t\t\t\t\t\t\t\t\t\t\t}}\" ng-click=\"$ctrl.goToProduct( item, $event )\"> {{ item.product.description }} </a> </td> <td ng-if=\"$ctrl.hasPurchaseOrders\"> <div class=\"text-nowrap\"> Vendor: {{ item.purchase_order .purchased_items[0] .cost_sheet.sheet.vendor .name }} </div> <div class=\"text-nowrap\"> Status: <span ng-class=\"['badge bg-primary text-uppercase', {\n                        'bg-danger': $ctrl.getLineItemStatus(item) === 'reject',\n                        'bg-warning text-dark': $ctrl.getLineItemStatus(item) === 'backordered',\n                        'bg-success': $ctrl.getLineItemStatus(item) === 'sent',\n                      }]\"> {{ $ctrl.getLineItemStatus( item ) }} </span> </div> <details title=\"See invoice details\" ng-repeat=\"invoice in item.purchase_order.invoices track by $index\"> <summary> Invoice {{ $index + 1 }} </summary> <dl class=\"small\"> <dt> <abbr title=\"Purchase Order\">PO</abbr> ID: </dt> <dd> {{ invoice.purchase_order_id }} </dd> <dt>Payload ID:</dt> <dd class=\"text-break\"> {{ invoice.payload_id }} </dd> <dt>Supplier Invoice ID:</dt> <dd> {{ invoice.supplier_invoice_id }} </dd> <dt>Filename:</dt> <dd class=\"text-break\"> {{ invoice.file_path }} </dd> <dt ng-if=\"\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tinvoice.export_details\n\t\t\t\t\t\t\t\t\t\t\t\t\t\"> Export Details: </dt> <dd ng-if=\"\n\t\t\t\t\t\t\t\t\t\t\t\t\t\tinvoice.export_details\n\t\t\t\t\t\t\t\t\t\t\t\t\t\"> {{ invoice.export_details }} </dd> </dl> </details> </td> <td> <div class=\"d-grid gap-1\"> <button class=\"button\" ng-click=\"$ctrl.openRmaModal(item)\" title=\"Add Return Merchandise Authorization\"> Add <abbr title=\"Return Merchandise Authorization\"> RMA </abbr> </button> <button ng-if=\"item.purchase_order\" class=\"button\" ng-click=\"$ctrl.downloadPurchaseOrder( item.purchase_order )\"> Download <abbr title=\"Purchase Order\">PO</abbr> </button> <button ng-if=\"item.purchase_order\" class=\"button\" ng-click=\"$ctrl.sendPurchaseOrder( item.purchase_order )\"> Send <abbr title=\"Purchase Order\">PO</abbr> </button> </div> </td> </tr> </tbody> </table> </uib-tab> <uib-tab heading=\"Costs\" ng-if=\"$ctrl.hasCosts\"> <h3 class=\"h5\">Costs</h3> <table class=\"widefat striped mb-3\"> <thead> <tr> <th> <abbr title=\"Stock Keeping Unit\">SKU</abbr> </th> <th>Price</th> <th>Description</th> <th>Costs</th> </tr> </thead> <tbody> <tr ng-repeat=\"item in $ctrl.selectedOrder.lineItems track by $index\"> <td> <a href=\"#\" title=\"Go to {{\n\t\t\t\t\t\t\t\t\t\t\t\titem.product.description\n\t\t\t\t\t\t\t\t\t\t\t}}\" ng-click=\"$ctrl.goToProduct( item, $event )\">{{ item.product.sku }}</a> </td> <td>{{ item.price | currency }}</td> <td> <a href=\"#\" title=\"Go to {{\n\t\t\t\t\t\t\t\t\t\t\t\titem.product.description\n\t\t\t\t\t\t\t\t\t\t\t}}\" ng-click=\"$ctrl.goToProduct( item, $event )\"> {{ item.product.description }} </a> </td> <td> <select name=\"mySelect\" id=\"mySelect\" ng-options=\"cost as (cost.cost + ' - ' + cost.sheet.name) for cost in item.costs track by cost.id\" ng-model=\"item.cost_sheet\" ng-disabled=\"item.cost_sheet_locked\"></select> </td> </tr> </tbody> </table> <div class=\"btn-toolbar gap-1\"> <button class=\"button\" ng-click=\"$ctrl.lockCosts()\"> Lock Costs </button> <button class=\"button\" ng-click=\"$ctrl.generatePurchaseOrders()\"> Generate Purchase Orders </button> </div> </uib-tab> <uib-tab heading=\"Payment\"> <h3 class=\"h5\">Payment</h3> <table class=\"widefat striped\"> <tbody> <tr> <th scope=\"row\">Payment Method</th> <td> {{ $ctrl.selectedOrder.payment_method }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.credit_card\"> <th scope=\"row\">Credit Card</th> <td> {{ $ctrl.selectedOrder.credit_card }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.credit_card\"> <th scope=\"row\">Credit Card Type</th> <td> {{ $ctrl.selectedOrder.cctype }} </td> </tr> </tbody> </table> </uib-tab> <uib-tab heading=\"Shipping/Billing\"> <h3 class=\"h5\">Shipping/Billing</h3> <div class=\"row\"> <div class=\"col\"> <table class=\"widefat striped\"> <caption> Shipping Address </caption> <tbody> <tr> <th scope=\"row\">Name</th> <td> {{ $ctrl.selectedOrder .first_name }} {{ $ctrl.selectedOrder .last_name }} </td> </tr> <tr> <th scope=\"row\">Email</th> <td> <a ng-href=\"mailto:{{\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.selectedOrder\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t.email\n\t\t\t\t\t\t\t\t\t\t\t\t\t}}\">{{ $ctrl.selectedOrder .email }}</a> </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.phone\"> <th scope=\"row\">Phone</th> <td> {{ $ctrl.selectedOrder.phone }} </td> </tr> <tr ng-if=\"\n\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.selectedOrder.attention\n\t\t\t\t\t\t\t\t\t\t\t\"> <th scope=\"row\">Attention</th> <td> {{ $ctrl.selectedOrder .attention }} </td> </tr> <tr ng-if=\"\n\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.selectedOrder.organization\n\t\t\t\t\t\t\t\t\t\t\t\"> <th scope=\"row\"> Company/Organization </th> <td> {{ $ctrl.selectedOrder .organization }} </td> </tr> <tr> <th scope=\"row\">Street Address</th> <td> {{ $ctrl.selectedOrder.address1 }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.address2\"> <th scope=\"row\"> Apt., Suite, etc. </th> <td> {{ $ctrl.selectedOrder.address2 }} </td> </tr> <tr> <th scope=\"row\">City</th> <td> {{ $ctrl.selectedOrder.city }} </td> </tr> <tr> <th scope=\"row\">State</th> <td> {{ $ctrl.selectedOrder.state }} </td> </tr> <tr> <th scope=\"row\">Zip Code</th> <td> {{ $ctrl.selectedOrder.zip }} </td> </tr> </tbody> </table> </div> <div class=\"col\"> <table class=\"widefat striped\"> <caption> Billing Address </caption> <tbody> <tr> <th scope=\"row\">Name</th> <td> {{ $ctrl.selectedOrder .bill_first_name }} {{ $ctrl.selectedOrder .bill_last_name }} </td> </tr> <tr> <th scope=\"row\">Email</th> <td> <a ng-href=\"mailto:{{\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.selectedOrder\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t.bill_email\n\t\t\t\t\t\t\t\t\t\t\t\t\t}}\">{{ $ctrl.selectedOrder .bill_email }}</a> </td> </tr> <tr ng-if=\"\n\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.selectedOrder.bill_phone\n\t\t\t\t\t\t\t\t\t\t\t\"> <th scope=\"row\">Phone</th> <td> {{ $ctrl.selectedOrder .bill_phone }} </td> </tr> <tr> <th scope=\"row\">Street Address</th> <td> {{ $ctrl.selectedOrder .bill_address1 }} </td> </tr> <tr ng-if=\"\n\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.selectedOrder\n\t\t\t\t\t\t\t\t\t\t\t\t\t.bill_address2\n\t\t\t\t\t\t\t\t\t\t\t\"> <th scope=\"row\"> Apt., Suite, etc. </th> <td> {{ $ctrl.selectedOrder .bill_address2 }} </td> </tr> <tr> <th scope=\"row\">City</th> <td> {{ $ctrl.selectedOrder .bill_city }} </td> </tr> <tr> <th scope=\"row\">State</th> <td> {{ $ctrl.selectedOrder .bill_state }} </td> </tr> <tr> <th scope=\"row\">Zip Code</th> <td> {{ $ctrl.selectedOrder.bill_zip }} </td> </tr> </tbody> </table> </div> </div> </uib-tab> <uib-tab heading=\"Additional\"> <h3 class=\"h5\">Additional</h3> <table class=\"widefat striped\"> <tbody> <tr ng-if=\"$ctrl.selectedOrder.approval_date\"> <th scope=\"row\">Approval Date</th> <td> {{ $ctrl.selectedOrder.approval_date }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.approver\"> <th scope=\"row\">Approver</th> <td> {{ $ctrl.selectedOrder.approver }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.approver_id\"> <th scope=\"row\">Approver ID</th> <td> {{ $ctrl.selectedOrder.approver_id }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.approver_notes\"> <th scope=\"row\">Approver Notes</th> <td> {{ $ctrl.selectedOrder.approver_notes }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.cost_center_code\"> <th scope=\"row\">Cost Center Code</th> <td> {{ $ctrl.selectedOrder.cost_center_code }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.cost_center_id\"> <th scope=\"row\">Cost Center ID</th> <td> {{ $ctrl.selectedOrder.cost_center_id }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.group_id\"> <th scope=\"row\">Group ID</th> <td> {{ $ctrl.selectedOrder.group_id }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.gsa_total\"> <th scope=\"row\"> <abbr title=\"U.S. General Services Administration\">GSA</abbr> Total </th> <td> {{ $ctrl.selectedOrder.gsa_total }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.issuing_office\"> <th scope=\"row\">Issuing Office</th> <td> {{ $ctrl.selectedOrder.issuing_office }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.issuing_office\"> <th scope=\"row\">Issuing Office</th> <td> {{ $ctrl.selectedOrder.issuing_office }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.notes\"> <th scope=\"row\">Notes</th> <td> {{ $ctrl.selectedOrder.notes }} </td> </tr> <tr ng-if=\"\n\t\t\t\t\t\t\t\t\t\t$ctrl.selectedOrder.price_availability\n\t\t\t\t\t\t\t\t\t\"> <th scope=\"row\">Price Availability</th> <td> {{ $ctrl.selectedOrder .price_availability }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.price_sheet\"> <th scope=\"row\">Price Sheet ID</th> <td> {{ $ctrl.selectedOrder.price_sheet }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.promo_codes\"> <th scope=\"row\">Promo Codes</th> <td> {{ $ctrl.selectedOrder.promo_codes }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.rr_po_num\"> <th scope=\"row\">Purchase Order</th> <td> {{ $ctrl.selectedOrder.rr_po_num }} </td> </tr> <tr ng-if=\"$ctrl.selectedOrder.tax_rate\"> <th scope=\"row\">Tax Rate</th> <td> {{ $ctrl.selectedOrder.tax_rate * 100 | number: 2 }}% </td> </tr> </tbody> </table> </uib-tab> <uib-tab heading=\"Notifications\" ng-if=\"$ctrl.selectedOrder.order_notifications.length\"> <h3 class=\"h5\">Notifications</h3> <table class=\"widefat striped\"> <thead> <tr> <th scope=\"row\">Status</th> <th scope=\"row\">Type</th> <th scope=\"row\">Date</th> <th scope=\"row\">Recipient</th> <th scope=\"row\" ng-if=\"$ctrl.hasNotificationDetails\"> Details </th> </tr> </thead> <tbody> <tr ng-repeat=\"notification in $ctrl.selectedOrder.order_notifications track by $index\"> <td> <span ng-class=\"['badge text-uppercase', {\n\t\t\t\t\t\t\t\t\t'bg-success': notification.status === 'success',\n\t\t\t\t\t\t\t\t\t'bg-warning text-dark': notification.status !== 'success',\n\t\t\t\t\t\t\t\t\t}]\"> {{ notification.status }} </span> </td> <td class=\"text-capitalize\"> {{ $ctrl.getNonUnderscored( notification.type ) }} </td> <td> <time ng-attr-datetime=\"{{\n\t\t\t\t\t\t\t\t\t\t\t\tnotification.notification_date\n\t\t\t\t\t\t\t\t\t\t\t}}\"> {{ notification.notification_date | date: \"short\" }} </time> </td> <td> <a ng-href=\"mailto:{{\n\t\t\t\t\t\t\t\t\t\t\t\tnotification.recipient\n\t\t\t\t\t\t\t\t\t\t\t}}\">{{ notification.recipient }}</a> </td> <td ng-if=\"$ctrl.hasNotificationDetails\"> <dl class=\"small\" ng-if=\"\n\t\t\t\t\t\t\t\t\t\t\t\tnotification.body ||\n\t\t\t\t\t\t\t\t\t\t\t\tnotification.response\n\t\t\t\t\t\t\t\t\t\t\t\"> <dt ng-if=\"notification.response\" class=\"text-muted\"> Response <a class=\"float-end\" href=\"#\" ng-click=\"$ctrl.copyToClipboard( notification.response, 'response', $index, $event )\" title=\"{{\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.isResponseCopied[\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t$index\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t]\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t? 'Copied'\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t: 'Copy'\n\t\t\t\t\t\t\t\t\t\t\t\t\t}} to Clipboard\"> {{ $ctrl.isResponseCopied[ $index ] ? \"Copied\" : \"Copy\" }} </a> </dt> <dd ng-if=\"notification.response\" class=\"lh-sm\"> {{ notification.response }} </dd> <dt ng-if=\"notification.body\" class=\"text-muted\"> Body <a class=\"float-end\" href=\"#\" ng-click=\"$ctrl.copyToClipboard( notification.body, 'body', $index, $event )\" title=\"{{\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t$ctrl.isBodyCopied[\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t$index\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t]\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t? 'Copied'\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t: 'Copy'\n\t\t\t\t\t\t\t\t\t\t\t\t\t}} to Clipboard\"> {{ $ctrl.isBodyCopied[ $index ] ? \"Copied\" : \"Copy\" }} </a> </dt> <dd ng-if=\"notification.body\" class=\"lh-sm\"> {{ notification.body }} </dd> </dl> </td> </tr> </tbody> </table> </uib-tab> </uib-tabset> </div> </div> <div class=\"btn-toolbar gap-1\"> <button class=\"button button-primary\" ng-disabled=\"$ctrl.isResendingEmail\" ng-click=\"$ctrl.resendEmail()\"> Resend order receipt email </button> <button class=\"button\" ng-disabled=\"$ctrl.isResendingNotification\" ng-click=\"$ctrl.resendNotification()\"> Resend order notification email </button> <button title=\"Resend order to Microsoft Dynamics GP (Great Plains)\" ng-disabled=\"$ctrl.isResendingToGP\" class=\"button\" ng-click=\"$ctrl.resendToGP()\"> Resend order to <abbr title=\"Microsoft Dynamics Great Plains\">GP</abbr> </button> <button title=\"Export to Quickbooks\" class=\"button\" ng-click=\"$ctrl.exportToQuickbooks()\" ng-disabled=\"$ctrl.isExportingToQuickbooks\"> Export to Quickbooks </button> </div> </form> </div> ";
// Exports
/* harmony default export */ const orders_detail_component = (orders_detail_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/common/countries.ts
var countries = [{
  name: 'Afghanistan',
  val: 'AF'
}, {
  name: 'Albania',
  val: 'AL'
}, {
  name: 'Algeria',
  val: 'DZ'
}, {
  name: 'American Samoa',
  val: 'AS'
}, {
  name: 'Andorra',
  val: 'AD'
}, {
  name: 'Angola',
  val: 'AO'
}, {
  name: 'Anguilla',
  val: 'AI'
}, {
  name: 'Antarctica',
  val: 'AQ'
}, {
  name: 'Antigua and Barbuda',
  val: 'AG'
}, {
  name: 'Argentina',
  val: 'AR'
}, {
  name: 'Armenia',
  val: 'AM'
}, {
  name: 'Aruba',
  val: 'AW'
}, {
  name: 'Australia',
  val: 'AU'
}, {
  name: 'Austria',
  val: 'AT'
}, {
  name: 'Azerbaijan',
  val: 'AZ'
}, {
  name: 'Bahamas',
  val: 'BS'
}, {
  name: 'Bahrain',
  val: 'BH'
}, {
  name: 'Bangladesh',
  val: 'BD'
}, {
  name: 'Barbados',
  val: 'BB'
}, {
  name: 'Belarus',
  val: 'BY'
}, {
  name: 'Belgium',
  val: 'BE'
}, {
  name: 'Belize',
  val: 'BZ'
}, {
  name: 'Benin',
  val: 'BJ'
}, {
  name: 'Bermuda',
  val: 'BM'
}, {
  name: 'Bhutan',
  val: 'BT'
}, {
  name: 'Bolivia, Plurinational State of',
  val: 'BO'
}, {
  name: 'Bonaire, Sint Eustatius and Saba',
  val: 'BQ'
}, {
  name: 'Bosnia and Herzegovina',
  val: 'BA'
}, {
  name: 'Botswana',
  val: 'BW'
}, {
  name: 'Bouvet Island',
  val: 'BV'
}, {
  name: 'Brazil',
  val: 'BR'
}, {
  name: 'British Indian Ocean Territory',
  val: 'IO'
}, {
  name: 'Brunei Darussalam',
  val: 'BN'
}, {
  name: 'Bulgaria',
  val: 'BG'
}, {
  name: 'Burkina Faso',
  val: 'BF'
}, {
  name: 'Burundi',
  val: 'BI'
}, {
  name: 'Cambodia',
  val: 'KH'
}, {
  name: 'Cameroon',
  val: 'CM'
}, {
  name: 'Canada',
  val: 'CA'
}, {
  name: 'Cape Verde',
  val: 'CV'
}, {
  name: 'Cayman Islands',
  val: 'KY'
}, {
  name: 'Central African Republic',
  val: 'CF'
}, {
  name: 'Chad',
  val: 'TD'
}, {
  name: 'Chile',
  val: 'CL'
}, {
  name: 'China',
  val: 'CN'
}, {
  name: 'Christmas Island',
  val: 'CX'
}, {
  name: 'Cocos (Keeling) Islands',
  val: 'CC'
}, {
  name: 'Colombia',
  val: 'CO'
}, {
  name: 'Comoros',
  val: 'KM'
}, {
  name: 'Congo',
  val: 'CG'
}, {
  name: 'Congo, the Democratic Republic of the',
  val: 'CD'
}, {
  name: 'Cook Islands',
  val: 'CK'
}, {
  name: 'Costa Rica',
  val: 'CR'
}, {
  name: 'Croatia',
  val: 'HR'
}, {
  name: 'Cuba',
  val: 'CU'
}, {
  name: 'Curaçao',
  val: 'CW'
}, {
  name: 'Cyprus',
  val: 'CY'
}, {
  name: 'Czech Republic',
  val: 'CZ'
}, {
  name: 'Côte d\'Ivoire',
  val: 'CI'
}, {
  name: 'Denmark',
  val: 'DK'
}, {
  name: 'Djibouti',
  val: 'DJ'
}, {
  name: 'Dominica',
  val: 'DM'
}, {
  name: 'Dominican Republic',
  val: 'DO'
}, {
  name: 'Ecuador',
  val: 'EC'
}, {
  name: 'Egypt',
  val: 'EG'
}, {
  name: 'El Salvador',
  val: 'SV'
}, {
  name: 'Equatorial Guinea',
  val: 'GQ'
}, {
  name: 'Eritrea',
  val: 'ER'
}, {
  name: 'Estonia',
  val: 'EE'
}, {
  name: 'Ethiopia',
  val: 'ET'
}, {
  name: 'Falkland Islands (Malvinas)',
  val: 'FK'
}, {
  name: 'Faroe Islands',
  val: 'FO'
}, {
  name: 'Fiji',
  val: 'FJ'
}, {
  name: 'Finland',
  val: 'FI'
}, {
  name: 'France',
  val: 'FR'
}, {
  name: 'French Guiana',
  val: 'GF'
}, {
  name: 'French Polynesia',
  val: 'PF'
}, {
  name: 'French Southern Territories',
  val: 'TF'
}, {
  name: 'Gabon',
  val: 'GA'
}, {
  name: 'Gambia',
  val: 'GM'
}, {
  name: 'Georgia',
  val: 'GE'
}, {
  name: 'Germany',
  val: 'DE'
}, {
  name: 'Ghana',
  val: 'GH'
}, {
  name: 'Gibraltar',
  val: 'GI'
}, {
  name: 'Greece',
  val: 'GR'
}, {
  name: 'Greenland',
  val: 'GL'
}, {
  name: 'Grenada',
  val: 'GD'
}, {
  name: 'Guadeloupe',
  val: 'GP'
}, {
  name: 'Guam',
  val: 'GU'
}, {
  name: 'Guatemala',
  val: 'GT'
}, {
  name: 'Guernsey',
  val: 'GG'
}, {
  name: 'Guinea',
  val: 'GN'
}, {
  name: 'Guinea-Bissau',
  val: 'GW'
}, {
  name: 'Guyana',
  val: 'GY'
}, {
  name: 'Haiti',
  val: 'HT'
}, {
  name: 'Heard Island and McDonald Islands',
  val: 'HM'
}, {
  name: 'Holy See (Vatican City State)',
  val: 'VA'
}, {
  name: 'Honduras',
  val: 'HN'
}, {
  name: 'Hong Kong',
  val: 'HK'
}, {
  name: 'Hungary',
  val: 'HU'
}, {
  name: 'Iceland',
  val: 'IS'
}, {
  name: 'India',
  val: 'IN'
}, {
  name: 'Indonesia',
  val: 'ID'
}, {
  name: 'Iran, Islamic Republic of',
  val: 'IR'
}, {
  name: 'Iraq',
  val: 'IQ'
}, {
  name: 'Ireland',
  val: 'IE'
}, {
  name: 'Isle of Man',
  val: 'IM'
}, {
  name: 'Israel',
  val: 'IL'
}, {
  name: 'Italy',
  val: 'IT'
}, {
  name: 'Jamaica',
  val: 'JM'
}, {
  name: 'Japan',
  val: 'JP'
}, {
  name: 'Jersey',
  val: 'JE'
}, {
  name: 'Jordan',
  val: 'JO'
}, {
  name: 'Kazakhstan',
  val: 'KZ'
}, {
  name: 'Kenya',
  val: 'KE'
}, {
  name: 'Kiribati',
  val: 'KI'
}, {
  name: 'Korea, Democratic People\'s Republic of',
  val: 'KP'
}, {
  name: 'Korea, Republic of',
  val: 'KR'
}, {
  name: 'Kuwait',
  val: 'KW'
}, {
  name: 'Kyrgyzstan',
  val: 'KG'
}, {
  name: 'Lao People\'s Democratic Republic',
  val: 'LA'
}, {
  name: 'Latvia',
  val: 'LV'
}, {
  name: 'Lebanon',
  val: 'LB'
}, {
  name: 'Lesotho',
  val: 'LS'
}, {
  name: 'Liberia',
  val: 'LR'
}, {
  name: 'Libya',
  val: 'LY'
}, {
  name: 'Liechtenstein',
  val: 'LI'
}, {
  name: 'Lithuania',
  val: 'LT'
}, {
  name: 'Luxembourg',
  val: 'LU'
}, {
  name: 'Macao',
  val: 'MO'
}, {
  name: 'Macedonia, the former Yugoslav Republic of',
  val: 'MK'
}, {
  name: 'Madagascar',
  val: 'MG'
}, {
  name: 'Malawi',
  val: 'MW'
}, {
  name: 'Malaysia',
  val: 'MY'
}, {
  name: 'Maldives',
  val: 'MV'
}, {
  name: 'Mali',
  val: 'ML'
}, {
  name: 'Malta',
  val: 'MT'
}, {
  name: 'Marshall Islands',
  val: 'MH'
}, {
  name: 'Martinique',
  val: 'MQ'
}, {
  name: 'Mauritania',
  val: 'MR'
}, {
  name: 'Mauritius',
  val: 'MU'
}, {
  name: 'Mayotte',
  val: 'YT'
}, {
  name: 'Mexico',
  val: 'MX'
}, {
  name: 'Micronesia, Federated States of',
  val: 'FM'
}, {
  name: 'Moldova, Republic of',
  val: 'MD'
}, {
  name: 'Monaco',
  val: 'MC'
}, {
  name: 'Mongolia',
  val: 'MN'
}, {
  name: 'Montenegro',
  val: 'ME'
}, {
  name: 'Montserrat',
  val: 'MS'
}, {
  name: 'Morocco',
  val: 'MA'
}, {
  name: 'Mozambique',
  val: 'MZ'
}, {
  name: 'Myanmar',
  val: 'MM'
}, {
  name: 'Namibia',
  val: 'NA'
}, {
  name: 'Nauru',
  val: 'NR'
}, {
  name: 'Nepal',
  val: 'NP'
}, {
  name: 'Netherlands',
  val: 'NL'
}, {
  name: 'New Caledonia',
  val: 'NC'
}, {
  name: 'New Zealand',
  val: 'NZ'
}, {
  name: 'Nicaragua',
  val: 'NI'
}, {
  name: 'Niger',
  val: 'NE'
}, {
  name: 'Nigeria',
  val: 'NG'
}, {
  name: 'Niue',
  val: 'NU'
}, {
  name: 'Norfolk Island',
  val: 'NF'
}, {
  name: 'Northern Mariana Islands',
  val: 'MP'
}, {
  name: 'Norway',
  val: 'NO'
}, {
  name: 'Oman',
  val: 'OM'
}, {
  name: 'Pakistan',
  val: 'PK'
}, {
  name: 'Palau',
  val: 'PW'
}, {
  name: 'Palestine, State of',
  val: 'PS'
}, {
  name: 'Panama',
  val: 'PA'
}, {
  name: 'Papua New Guinea',
  val: 'PG'
}, {
  name: 'Paraguay',
  val: 'PY'
}, {
  name: 'Peru',
  val: 'PE'
}, {
  name: 'Philippines',
  val: 'PH'
}, {
  name: 'Pitcairn',
  val: 'PN'
}, {
  name: 'Poland',
  val: 'PL'
}, {
  name: 'Portugal',
  val: 'PT'
}, {
  name: 'Puerto Rico',
  val: 'PR'
}, {
  name: 'Qatar',
  val: 'QA'
}, {
  name: 'Romania',
  val: 'RO'
}, {
  name: 'Russian Federation',
  val: 'RU'
}, {
  name: 'Rwanda',
  val: 'RW'
}, {
  name: 'Réunion',
  val: 'RE'
}, {
  name: 'Saint Barthélemy',
  val: 'BL'
}, {
  name: 'Saint Helena, Ascension and Tristan da Cunha',
  val: 'SH'
}, {
  name: 'Saint Kitts and Nevis',
  val: 'KN'
}, {
  name: 'Saint Lucia',
  val: 'LC'
}, {
  name: 'Saint Martin (French part)',
  val: 'MF'
}, {
  name: 'Saint Pierre and Miquelon',
  val: 'PM'
}, {
  name: 'Saint Vincent and the Grenadines',
  val: 'VC'
}, {
  name: 'Samoa',
  val: 'WS'
}, {
  name: 'San Marino',
  val: 'SM'
}, {
  name: 'Sao Tome and Principe',
  val: 'ST'
}, {
  name: 'Saudi Arabia',
  val: 'SA'
}, {
  name: 'Senegal',
  val: 'SN'
}, {
  name: 'Serbia',
  val: 'RS'
}, {
  name: 'Seychelles',
  val: 'SC'
}, {
  name: 'Sierra Leone',
  val: 'SL'
}, {
  name: 'Singapore',
  val: 'SG'
}, {
  name: 'Sint Maarten (Dutch part)',
  val: 'SX'
}, {
  name: 'Slovakia',
  val: 'SK'
}, {
  name: 'Slovenia',
  val: 'SI'
}, {
  name: 'Solomon Islands',
  val: 'SB'
}, {
  name: 'Somalia',
  val: 'SO'
}, {
  name: 'South Africa',
  val: 'ZA'
}, {
  name: 'South Georgia and the South Sandwich Islands',
  val: 'GS'
}, {
  name: 'South Sudan',
  val: 'SS'
}, {
  name: 'Spain',
  val: 'ES'
}, {
  name: 'Sri Lanka',
  val: 'LK'
}, {
  name: 'Sudan',
  val: 'SD'
}, {
  name: 'Suriname',
  val: 'SR'
}, {
  name: 'Svalbard and Jan Mayen',
  val: 'SJ'
}, {
  name: 'Swaziland',
  val: 'SZ'
}, {
  name: 'Sweden',
  val: 'SE'
}, {
  name: 'Switzerland',
  val: 'CH'
}, {
  name: 'Syrian Arab Republic',
  val: 'SY'
}, {
  name: 'Taiwan, Province of China',
  val: 'TW'
}, {
  name: 'Tajikistan',
  val: 'TJ'
}, {
  name: 'Tanzania, United Republic of',
  val: 'TZ'
}, {
  name: 'Thailand',
  val: 'TH'
}, {
  name: 'Timor-Leste',
  val: 'TL'
}, {
  name: 'Togo',
  val: 'TG'
}, {
  name: 'Tokelau',
  val: 'TK'
}, {
  name: 'Tonga',
  val: 'TO'
}, {
  name: 'Trinidad and Tobago',
  val: 'TT'
}, {
  name: 'Tunisia',
  val: 'TN'
}, {
  name: 'Turkey',
  val: 'TR'
}, {
  name: 'Turkmenistan',
  val: 'TM'
}, {
  name: 'Turks and Caicos Islands',
  val: 'TC'
}, {
  name: 'Tuvalu',
  val: 'TV'
}, {
  name: 'Uganda',
  val: 'UG'
}, {
  name: 'Ukraine',
  val: 'UA'
}, {
  name: 'United Arab Emirates',
  val: 'AE'
}, {
  name: 'United Kingdom',
  val: 'GB'
}, {
  name: 'United States',
  val: 'US'
}, {
  name: 'United States Minor Outlying Islands',
  val: 'UM'
}, {
  name: 'Uruguay',
  val: 'UY'
}, {
  name: 'Uzbekistan',
  val: 'UZ'
}, {
  name: 'Vanuatu',
  val: 'VU'
}, {
  name: 'Venezuela, Bolivarian Republic of',
  val: 'VE'
}, {
  name: 'Viet Nam',
  val: 'VN'
}, {
  name: 'Virgin Islands, British',
  val: 'VG'
}, {
  name: 'Virgin Islands, U.S.',
  val: 'VI'
}, {
  name: 'Wallis and Futuna',
  val: 'WF'
}, {
  name: 'Western Sahara',
  val: 'EH'
}, {
  name: 'Yemen',
  val: 'YE'
}, {
  name: 'Zambia',
  val: 'ZM'
}, {
  name: 'Zimbabwe',
  val: 'ZW'
}, {
  name: 'Åland Islands',
  val: 'AX'
}];
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders-detail/orders-detail.component.ts



var OrdersDetailComponent = {
  controller: OrderController,
  template: orders_detail_component
};
OrderController.$inject = ['$http', '$scope', '$state', '$stateParams', '$uibModal', 'Admin', 'Debug', 'Localized', 'Utils'];

function OrderController($http, $scope, $state, $stateParams, $uibModal, Admin, Debug, Localized, Utils) {
  var _this = this;

  var vm = this;
  this.isBodyCopied = [];
  this.isResponseCopied = [];
  vm.downloadPurchaseOrder = downloadPurchaseOrder;
  vm.exportToQuickbooks = exportToQuickbooks;
  vm.generatePurchaseOrders = generatePurchaseOrders;
  vm.lockCosts = lockCosts;
  vm.openRmaModal = openRmaModal;
  vm.openShipmentModal = openShipmentModal;
  vm.resendEmail = resendEmail;
  /**
   * Initialization
   */

  this.$onInit = function () {
    vm.id = $stateParams.id || null;
    vm.isLoading = true;
    vm.selectedOrder = {};
    _this.breadcrumbs = [{
      name: 'Orders',
      state: 'orders.index'
    }, {
      name: "Order ".concat(vm.id),
      state: "order({id:".concat(vm.id, "})")
    }];

    if (vm.id) {
      _this.getOrder();
    } else {
      $state.go('orders.index');
    }
  };

  this.copyToClipboard = function (content, type, index, e) {
    e.preventDefault();
    navigator.clipboard.writeText(content).then(function () {
      $scope.$apply(function () {
        _this.isBodyCopied.fill(false);

        _this.isResponseCopied.fill(false);

        if (type === 'body') {
          _this.isBodyCopied[index] = true;
        } else {
          _this.isResponseCopied[index] = true;
        }
      });
    }, function () {
      console.error('Could not copy to clipboard');
    });
  };

  this.includesCosts = function (order) {
    if (order.lineItems) {
      return order.lineItems.some(function (item) {
        return item.costs ? item.costs.length : false;
      });
    }

    return false;
  };

  this.includesNotificationDetails = function (order) {
    if (order.order_notifications) {
      return order.order_notifications.some(function (item) {
        return item.response || item.body;
      });
    }

    return false;
  };

  this.includesPurchaseOrders = function (order) {
    if (order.lineItems) {
      return order.lineItems.some(function (item) {
        return item.purchase_order;
      });
    }

    return false;
  };
  /**
   */


  this.getOrder = function () {
    vm.isLoading = true;
    var endpoint = "".concat(Localized.apiURL, "/admin/orders/").concat(vm.id);
    Utils.httpGet(endpoint).then(function (response) {
      vm.selectedOrder = response.order;
      _this.hasCosts = _this.includesCosts(response.order);
      _this.hasPurchaseOrders = _this.includesPurchaseOrders(response.order);
      _this.hasNotificationDetails = _this.includesNotificationDetails(response.order);
      vm.isLoading = false;
    });
  };

  this.getLineItemStatus = function (item) {
    var _item$purchase_order;

    var allowList = ['accept', 'reject', 'backordered', 'sent'];

    if ((_item$purchase_order = item.purchase_order) !== null && _item$purchase_order !== void 0 && _item$purchase_order.status && allowList.includes(item.purchase_order.status)) {
      return item.purchase_order.status;
    }

    return item.status;
  };

  this.getNonUnderscored = function (str) {
    return str.replace(/_/g, ' ');
  };

  this.goToProduct = function (item, e) {
    if (e) {
      e.preventDefault();
    }

    return $state.go('catalog-products', {
      activeTab: 2,
      product: item
    });
  };
  /**
   * @param {Object} item Product
   */


  function openRmaModal(item) {
    var _this2 = this;

    var order = vm.selectedOrder;
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/rma.html',
      size: 'lg',
      // eslint-disable-next-line no-shadow
      controller: function controller($scope, $uibModalInstance) {
        $scope.order = order;
        $scope.item = item;
        $scope.returnStatuses = {
          none: 'No return requested',
          requested: 'Requested',
          denied: 'Denied',
          approved: 'Approved',
          refunded: 'Refunded',
          replaced: 'Replaced'
        };
        $scope.returnReasons = {
          defective: 'Defective',
          'wrong item': 'Wrong Item',
          exchange: 'Exchange',
          other: 'Other'
        };

        $scope.Confirm = function () {
          vm.isLoading = true;
          var req = {
            method: 'PUT',
            url: Localized.apiURL + '/admin/rma/' + $scope.item.purch_id,
            data: $scope.item
          };
          Utils.getHttpPromise(req).then(function () {
            $uibModalInstance.close();
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            vm.isLoading = false;
          });
        };

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };
      }
    }).result.then(function () {
      _this2.getOrder();
    });
  }
  /**
   */


  function openShipmentModal() {
    var _this3 = this;

    var id = vm.id;
    $uibModal.open({
      templateUrl: Localized.root.url + '/assets/app/modals/shipment.html',
      size: 'lg',
      // eslint-disable-next-line no-shadow
      controller: function controller($scope, $uibModalInstance) {
        $scope.isLoading = false;
        $scope.shipment = {
          order_id: id,
          country_code: 'US',
          country_phone_code: 1
        };
        $scope.states = usStates;
        $scope.countries = countries;

        $scope.Confirm = function () {
          vm.isLoading = true;
          var req = {
            method: 'POST',
            url: Localized.apiURL + '/admin/order/shipment/add',
            data: $scope.shipment
          };
          Utils.getHttpPromise(req).then(function () {
            $uibModalInstance.close();
          }, function (errResp) {
            Debug.error(errResp);
            $scope.isLoading = false;
          });
        };

        $scope.Cancel = function () {
          $uibModalInstance.dismiss();
        };
      }
    }).result.then(function () {
      _this3.getOrder();
    });
  }
  /**
   */


  this.resendToGP = function () {
    _this.isResendingToGP = true;
    var req = {
      method: 'POST',
      url: Localized.apiURL + '/admin/order/resend',
      data: {
        order_id: vm.id
      }
    };
    Utils.getHttpPromise(req).then(function (response) {
      if (!response.data.errors.length && !response.data.warnings.length) {
        _this.getOrder();
      }
    })["catch"](function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this.isResendingToGP = false;
    });
  };
  /**
   * Attempt to export to quickbooks
   */


  function exportToQuickbooks() {
    var _this4 = this;

    this.isExportingToQuickbooks = true;
    var req = {
      method: 'POST',
      url: Localized.apiURL + '/admin/order/' + vm.id + '/quickbooks/export'
    };
    Utils.getHttpPromise(req).then(function () {
      angular.noop();
    })["catch"](function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this4.isExportingToQuickbooks = false;
    });
  }
  /**
   */


  function resendEmail() {
    var _this5 = this;

    this.isResendingEmail = true;
    var req = {
      method: 'POST',
      url: Localized.apiURL + '/admin/order/resend-email',
      data: {
        order_id: vm.id
      }
    };
    Utils.getHttpPromise(req).then(function () {
      angular.noop();
    })["catch"](function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      _this5.isResendingEmail = false;
    });
  }

  this.resendNotification = function () {
    _this.isResendingNotification = true;
    var url = "".concat(localized.apiURL, "/admin/order/resend-email");
    var data = {
      order_id: vm.id,
      notifications: true
    };
    $http.post(url, data).then(function (response) {
      Localized.setNotifications(response.data);
      _this.isResendingNotification = false;
    });
  };
  /**
   */


  function lockCosts() {
    vm.isLoading = true;
    var req = {
      method: 'POST',
      url: Localized.apiURL + '/admin/order/' + vm.id + '/costs/lock',
      data: {
        costs: vm.selectedOrder.purchased_items
      }
    };
    Utils.getHttpPromise(req).then(function () {
      angular.noop();
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      vm.isLoading = false;
    });
  }
  /**
   */


  function generatePurchaseOrders() {
    vm.isLoading = true;
    var req = {
      method: 'POST',
      url: Localized.apiURL + '/admin/order/' + vm.id + '/po/generate'
    };
    Utils.getHttpPromise(req).then(function () {
      angular.noop();
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      vm.isLoading = false;
    });
  }
  /**
   * @param {Object} purchaseOrder Purchase Order
   */


  this.sendPurchaseOrder = function (purchaseOrder) {
    vm.isLoading = true;
    var req = {
      method: 'POST',
      url: Localized.apiURL + '/admin/order/' + purchaseOrder.order_id + '/po/' + purchaseOrder.id + '/transmit'
    };
    Utils.getHttpPromise(req).then(function (resp) {
      $scope.order = resp.order;
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      vm.isLoading = false;
    });
  };
  /**
   * @param {Object} purchaseOrder Purchase Order
   */


  function downloadPurchaseOrder(purchaseOrder) {
    var url = "".concat(Localized.apiURL, "/admin/order/").concat(purchaseOrder.order_id, "/po/").concat(purchaseOrder.id, "/download");
    window.open(Admin.Download(url), '_blank');
  }
}
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders-tracking/orders-tracking.component.html
// Module
var orders_tracking_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2>Order Tracking</h2> <vf-check-auth></vf-check-auth> <wp-notice-list></wp-notice-list> <div> <form enctype=\"multipart/form-data\" name=\"shipmentUploadForm\"> <div class=\"col-md-5\"> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text w-104\">File</span> <input class=\"form-control\" ng-class=\"{'is-invalid':shipmentUploadForm.zipName.$invalid}\" name=\"zipName\" ng-model=\"$ctrl.theFile.name\" placeholder=\"Upload a .zip File\" disabled=\"disabled\" required/> <label class=\"btn btn-secondary m-0\"> Browse <input class=\"custom-file\" type=\"file\" name=\"file\" file-model=\"myFiles\" id=\"uploadInput\" onchange=\"angular.element(this).scope().setFile(this),angular.element(this).scope().setUploading()\" hidden/> </label> </div> <div class=\"d-flex align-items-center\" ng-if=\"$ctrl.isUploading\"> <strong>Uploading zip, please wait...</strong> <div class=\"spinner is-active ml-auto\" role=\"status\" aria-hidden=\"true\"></div> </div> </div> </form> </div> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-show=\"!$ctrl.isLoading && $ctrl.log\"> <h3 class=\"h6\">Upload Log</h3> <samp> <pre>\n{{ $ctrl.log }}\n</pre> </samp> </div> ";
// Exports
/* harmony default export */ const orders_tracking_component = (orders_tracking_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders-tracking/orders-tracking.component.ts

var OrderTrackingComponent = {
  controller: OrderTrackingController,
  template: orders_tracking_component
};

function OrderTrackingController($scope, Debug, Localized, Utils) {
  var _this = this;

  $scope.setUploading = setUploading;
  $scope.setFile = setFile;
  var vm = this;
  /**
   * Initialize
   */

  this.$onInit = function () {
    _this.breadcrumbs = [{
      name: 'Orders',
      state: 'orders.index'
    }, {
      name: 'Order Tracking',
      state: 'orders.tracking'
    }];
    getLog();
  };
  /**
   */


  function getLog() {
    vm.isLoading = true;
    var endpoint = "".concat(Localized.apiURL, "/admin/order/shipment/upload/log");
    Utils.httpGet(endpoint).then(function (response) {
      if (!response.errors.length) {
        vm.log = response.log;
      }
    }, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      vm.isLoading = false;
    });
  }
  /**
   */


  function setUploading() {
    // eslint-disable-next-line no-shadow
    $scope.$apply(function () {
      vm.isUploading = !vm.isUploading;
    });
  }
  /**
   * @param {Object} element DOM element
   */


  function setFile(element) {
    // eslint-disable-next-line no-shadow
    $scope.$apply(function () {
      vm.theFile = element.files[0];
    });
    var fd = new FormData();
    fd.append('file', vm.theFile);
    var req = {
      method: 'POST',
      url: Localized.apiURL + '/admin/order/shipment/upload/zip',
      data: fd,
      transformRequest: angular.identity,
      headers: {
        // eslint-disable-next-line no-undefined
        'Content-Type': undefined
      }
    };
    Utils.getHttpPromise(req).then(function () {
      angular.noop();
    }, function (errResp) {
      Debug.error(errResp);
    })["finally"](function () {
      vm.isUploading = false;
    });
  }
}

OrderTrackingController.$inject = ['$scope', 'Debug', 'Localized', 'Utils'];
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders.service.ts
function orders_service_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function orders_service_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function orders_service_createClass(Constructor, protoProps, staticProps) { if (protoProps) orders_service_defineProperties(Constructor.prototype, protoProps); if (staticProps) orders_service_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function orders_service_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var OrdersService = /*#__PURE__*/function () {
  function OrdersService($http) {
    orders_service_classCallCheck(this, OrdersService);

    orders_service_defineProperty(this, "apiRoot", "".concat(localized.apiURL, "/admin/orders/"));

    this.$http = $http;
  }

  orders_service_createClass(OrdersService, [{
    key: "query",
    value: function query(params) {
      return this.$http.get(this.apiRoot, {
        params: params,
        paramSerializer: '$httpParamSerializerJQLike'
      });
    }
  }, {
    key: "get",
    value: function get(id, params) {
      return this.$http.get(this.apiRoot + '/' + id, {
        params: params
      });
    }
  }, {
    key: "save",
    value: function save(data) {
      return this.$http.post(this.apiRoot, data);
    }
  }, {
    key: "update",
    value: function update(data) {
      return this.$http.put(this.apiRoot + '/' + data.id, data);
    }
  }, {
    key: "remove",
    value: function remove(data) {
      return this.$http["delete"](this.apiRoot + '/' + data.id);
    }
  }]);

  return OrdersService;
}();

orders_service_defineProperty(OrdersService, "$inject", ['$http']);
;// CONCATENATED MODULE: ./assets/app/dev/admin/orders/orders.module.ts





var OrdersModule = angular.module('OrdersModule', [OrdersRoutingModule]).service('OrdersService', OrdersService).component('ordersIndex', OrdersIndexComponent).component('ordersDetail', OrdersDetailComponent).component('orderTracking', OrderTrackingComponent).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/purchasing-routing.module.ts

var templateDir = localized.dir.templates;
var purchasing_routing_module_states = [{
  name: 'purchasing',
  url: '/purchasing',
  "abstract": true,
  template: '<ui-view/>'
}, {
  name: 'purchasing.page',
  url: '',
  component: 'purchasingPage'
}, {
  name: 'purchasing.document-profiles',
  url: '/document-profiles',
  "abstract": true,
  template: '<ui-view/>'
}, {
  name: 'purchasing.document-profiles.index',
  url: '',
  component: 'documentProfilesPage'
}, {
  name: 'purchasing.document-profiles.create',
  url: '/new',
  component: 'documentProfilePage'
}, {
  name: 'purchasing.document-profiles.edit',
  url: '/:id',
  component: 'documentProfilePage'
}, {
  name: 'purchasing.cost-sheets',
  url: '/cost-sheets/:activeTab',
  component: 'purchasingCostSheets',
  params: {
    activeTab: {
      dynamic: true
    },
    product: {
      dynamic: true
    }
  }
}, {
  name: 'purchasing.vendors',
  url: '/vendors/:activeTab',
  component: 'purchasingVendors',
  params: {
    activeTab: {
      dynamic: true
    },
    product: {
      dynamic: true
    }
  }
}];
var PurchasingRoutingModule = angular.module('PurchasingRoutingModule', []).config(["$stateProvider", function ($stateProvider) {
  'ngInject';

  purchasing_routing_module_states.forEach(function (state) {
    state.onEnter = function () {
      highlightMenuItem('purchasing');
    };

    $stateProvider.state(state);
  });
}]).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/purchasing-page/purchasing-page.component.html
// Module
var purchasing_page_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2 class=\"wp-heading-inline\">Purchasing</h2> <vf-check-auth></vf-check-auth> <div class=\"row row-cols-1 row-cols-md-3 g-3\"> <div class=\"col\"> <div class=\"card h-100\"> <div class=\"card-header\"> <a class=\"text-decoration-none\" ui-sref=\"purchasing.vendors({activeTab: 0})\"> Vendors </a> </div> <div class=\"card-body\"> <ul class=\"list-unstyled\"> <li> <a ui-sref=\"purchasing.vendors({activeTab: 0})\">Search</a> </li> <li> <a ui-sref=\"purchasing.vendors({activeTab: 1})\">Add</a> </li> </ul> </div> </div> </div> <div class=\"col\"> <div class=\"card h-100\"> <div class=\"card-header\"> <a class=\"text-decoration-none\" ui-sref=\"purchasing.cost-sheets({activeTab: 0})\"> Cost Sheets </a> </div> <div class=\"card-body\"> <ul class=\"list-unstyled\"> <li> <a ui-sref=\"purchasing.cost-sheets({activeTab: 0})\">Search</a> </li> <li> <a ui-sref=\"purchasing.cost-sheets({activeTab: 1})\">Add</a> </li> <li> <a ui-sref=\"purchasing.cost-sheets({activeTab: 3})\">Upload</a> </li> <li> <a ui-sref=\"purchasing.cost-sheets({activeTab: 4})\">Batches</a> </li> </ul> </div> </div> </div> <div class=\"col\"> <div class=\"card h-100\"> <div class=\"card-header\"> <a class=\"text-decoration-none\" ui-sref=\"purchasing.document-profiles.index\"> Document Profiles </a> </div> <div class=\"card-body\"> <ul class=\"list-unstyled\"> <li> <a ui-sref=\"purchasing.document-profiles.index\"> Search</a> </li> <li> <a ui-sref=\"purchasing.document-profiles.create\">Add</a> </li> </ul> </div> </div> </div> </div> ";
// Exports
/* harmony default export */ const purchasing_page_component = (purchasing_page_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/purchasing-page/purchasing-page.component.ts
function purchasing_page_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function purchasing_page_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) purchasing_page_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) purchasing_page_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function purchasing_page_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function purchasing_page_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


var PurchasingPageComponent = {
  template: purchasing_page_component,
  controller: /*#__PURE__*/purchasing_page_component_createClass(function PurchasingController() {
    purchasing_page_component_classCallCheck(this, PurchasingController);

    purchasing_page_component_defineProperty(this, "breadcrumbs", [{
      name: 'Purchasing',
      state: 'purchasing.page'
    }]);
  })
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/purchasing-vendors/purchasing-vendors.component.html
// Module
var purchasing_vendors_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2 class=\"wp-heading-inline\">Vendors</h2> <vf-check-auth></vf-check-auth> <div class=\"container-fluid p-0\"> <div ng-hide=\"true\" class=\"col p-0\"> <div class=\"m-b-20 text-center\"> <h2 class=\"m-0\">Vendors</h2> <hr class=\"col p-0\"> </div> </div> <div class=\"col p-0\"> <uib-tabset active=\"activeTab\" resize> <uib-tab index=\"0\" select=\"TabChanged(0)\" heading=\"Search Vendors\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-if=\"!loading\" class=\"col p-0 vf-tab-body\"> <div class=\"col p-15\"> <div class=\"input-group mb-3\"> <input ng-model=\"searchParams.q\" ng-keypress=\"$event.keyCode === 13 && Index()\" type=\"text\" class=\"form-control form-control-lg\" placeholder=\"Search\"> <button ng-click=\"Index()\" class=\"btn btn-secondary\" type=\"submit\">Search</button> </div> <hr class=\"col p-0\" ng-if=\"isXS\"> <div class=\"row p-s-20\"> <div class=\"col-3\" ng-click=\"SortIndex('id')\">ID</div> <div class=\"col-3\" ng-click=\"SortIndex('name')\">Name</div> <div class=\"col-3\" ng-click=\"SortIndex('lead_time')\">Lead Time</div> </div> <div class=\"p-10\" ng-class=\"{'min-scroll':!isXS}\"> <wp-spinner type=\"2x\" ng-show=\"loadingMore\"> </wp-spinner> <div class=\"text-center\" ng-if=\"vendors.data.length <= 0 && !loadingMore\"> <span class=\"col m-auto\"> <h3>No Vendor(s) <span ng-if=\"searchParams.q.length >= 1\">matching '{{searchParams.q}}'</span> found.</h3> </span> </div> <div class=\"col p-15 vf-list-item cursor-pointer\" ng-click=\"$ctrl.selectVendor( vendor.id )\" ng-repeat=\"vendor in vendors.data track by $index\" ng-if=\"!loadingMore\"> <div class=\"row\"> <div class=\"col-3\">{{vendor.id}}</div> <div class=\"col-3\">{{vendor.name}}</div> <div class=\"col-3\">{{vendor.lead_time}}</div> </div> </div> </div> <div class=\"row m-tb-10\"> <div class=\"col-sm-4\"> <span>Showing {{vendors.from || 0}} to {{vendors.to || 0}} of {{vendors.total || 0}} entries<span> </span></span></div> <div class=\"col-sm-4 text-center m-t-10\"> <button class=\"button\" ng-if=\"vendors.prev_page_url\" ng-click=\"Index(vendors.current_page - 1)\"><span class=\"dashicons dashicons-arrow-left-alt2\"></span> Prev</button> <button class=\"button\" ng-if=\"vendors.current_page - 2 > 0\" ng-click=\"Index(vendors.current_page - 2)\">{{vendors.current_page - 2}}</button> <button class=\"button\" ng-if=\"vendors.current_page - 1 > 0\" ng-click=\"Index(vendors.current_page - 1)\">{{vendors.current_page - 1}}</button> <button class=\"button\" ng-disabled=\"true\">{{vendors.current_page}}</button> <button class=\"button\" ng-if=\"vendors.current_page + 1 <= vendors.last_page\" ng-click=\"Index(vendors.current_page + 1)\">{{vendors.current_page + 1}}</button> <button class=\"button\" ng-if=\"vendors.current_page + 2 <= vendors.last_page\" ng-click=\"Index(vendors.current_page + 2)\">{{vendors.current_page + 2}}</button> <button class=\"button\" ng-if=\"vendors.next_page_url\" ng-click=\"Index(vendors.current_page + 1)\">Next <span class=\"dashicons dashicons-arrow-right-alt2\"></span></button> </div> <div class=\"col-sm-4 justify-content-end\"> <label for=\"rpp\">Per Page: </label> <select class=\"form-control\" style=\"display:inline-block\" id=\"rpp\" ng-model=\"searchParams.rpp\" ng-change=\"Index(1)\" ng-options=\"value for value in rppValues\"> </select> </div> </div> </div> </div> <div uib-alert class=\"col-6 alert m-t-10 p-15\" ng-class=\"'alert-' + (response.type || 'warning')\" ng-repeat=\"response in localized.GetResponseMsgs() track by $index\" close=\"localized.RemoveResponseMsg($index)\">{{response.message}} </div> </uib-tab> <uib-tab index=\"1\" select=\"TabChanged(1)\" heading=\"Add Vendor\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-if=\"!loading\" class=\"col p-tb-20 vf-tab-body\"> <div class=\"row\"> <form class=\"mf-form col-md-6\" name=\"addForm\"> <div class=\"mb-3\"> <label class=\"form-label\" for=\"add_vendor\">Name:</label> <input class=\"form-control\" ng-class=\"!addParams.name.length || (addParams.name.length < 3) ? 'is-invalid' : ''\" type=\"text\" id=\"add_name\" name=\"name\" ng-minlength=\"3\" placeholder=\"Vendor Name\" ng-model=\"addParams.name\" required> </div> </form> <div class=\"col-12\"> <button class=\"btn btn-primary\" ng-disabled=\"addForm.$invalid\" ng-click=\"Store()\"> Add Vendor </button> </div> </div> <div uib-alert class=\"col-12 alert m-t-10 p-15 m-l-auto\" ng-class=\"'alert-' + (response.type || 'warning')\" ng-repeat=\"response in localized.GetResponseMsgs() track by $index\" close=\"localized.RemoveResponseMsg($index)\">{{response.message}} </div> </div> </uib-tab> <uib-tab index=\"2\" ng-show=\"vendor.id\" select=\"TabChanged(2)\" heading=\"View Vendor\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-if=\"!loading\" class=\"col p-tb-20 vf-tab-body\"> <div class=\"row\"> <form class=\"mf-form col-md-6\" name=\"viewForm\"> <div class=\"m-tb-10\"> <label class=\"form-label\" for=\"add_vendor\">Name:</label> <input class=\"form-control\" ng-class=\"!vendor.name.length || (vendor.name.length < 3) ? 'is-invalid' : ''\" type=\"text\" id=\"view_name\" name=\"name\" ng-minlength=\"3\" placeholder=\"Vendor Name\" ng-model=\"vendor.name\" required> </div> </form> <div class=\"col-12\"> <button class=\"btn btn-outline-danger border-0 m-tb-10\" ng-class=\"{'col-12':isXS}\" ng-click=\"Delete(vendor.id)\">Delete</button> <button class=\"btn btn-primary\" ng-class=\"{'col-12':isXS}\" ng-disabled=\"viewForm.$invalid\" ng-click=\"Update(vendor.id)\">Update Vendor</button> </div> </div> <div uib-alert class=\"col-6 alert m-t-10 p-15\" ng-class=\"'alert-' + (response.type || 'warning')\" ng-repeat=\"response in localized.GetResponseMsgs() track by $index\" close=\"localized.RemoveResponseMsg($index)\">{{response.message}} </div> </div> </uib-tab> </uib-tabset> </div> </div>";
// Exports
/* harmony default export */ const purchasing_vendors_component = (purchasing_vendors_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/purchasing-vendors/purchasing-vendors.component.ts

var PurchasingVendorsComponent = {
  template: purchasing_vendors_component,
  controller: PurchasingVendorsController
};
PurchasingVendorsController.$inject = ['$scope', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized'];

function PurchasingVendorsController($scope, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
  this.breadcrumbs = [{
    name: 'Purchasing',
    state: 'purchasing.page'
  }, {
    name: 'Vendors',
    state: 'purchasing-vendors'
  }];
  /**
   * Sets the active tab based on whether it matches a index of accessible tabs.
   *
   * @param {number} tab
   * @return {number | Object} Sets activeTab to the tab number, or reloads the state to reset the activeTab.
   */

  var setActiveTab = function setActiveTab(tab) {
    var index = [0, 1];

    if (index.includes(tab)) {
      return $scope.activeTab = tab;
    }

    return $state.go($state.current, {
      activeTab: 0
    }, {
      reload: true
    });
  };

  setActiveTab(parseInt($stateParams.activeTab));
  $scope.addParams = {};
  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.loading = false;
  $scope.loadingMore = false;
  $scope.localized = Localized;
  $scope.rppValues = [15, 30, 50, 100];
  $scope.saved = false;
  $scope.saving = false;
  $scope.searchParams = {
    q: '',
    sortBy: '',
    sortType: 'asc',
    rpp: $scope.rppValues[0]
  };
  $scope.settings = Settings;
  $scope.utils = Utils;
  $scope.vendor = {};
  $scope.vendors = [];
  $scope.vendorsEndpoint = Localized.apiURL + '/admin/purchasing/vendor/'; //FUNCTIONS

  this.selectVendor = function (id) {
    $scope.vendor.id = id;
    $scope.activeTab = 2;
  };

  $scope.LoginCallback = function () {
    $scope.loading = true;
    $scope.init();
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.Index($scope.searchParams.page);
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;

    switch ($scope.activeTab) {
      case 0:
        if (!$scope.vendors.data) {
          $scope.Index();
        }

        break;

      case 2:
        if ($scope.vendor.id) {
          $scope.Show($scope.vendor.id);
        }

        break;
    }
  }; //RESTful Functions
  //Index


  $scope.Index = function (page) {
    $scope.loadingMore = true;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.vendorsEndpoint,
      params: $scope.searchParams
    };
    Utils.getHttpPromise(req).then(function (resp) {
      $scope.vendors = resp.vendors;
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loadingMore = false;
      $scope.loading = false;
    });
  }; //Show


  $scope.Show = function (id) {
    $scope.loading = true;
    $scope.vendor.id = id;
    var req = {
      method: 'GET',
      url: $scope.vendorsEndpoint + id
    };
    Utils.getHttpPromise(req).then(function (resp) {
      $scope.vendor = resp.vendor;
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  }; //Store


  $scope.Store = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.vendorsEndpoint,
      data: $scope.addParams
    };
    Utils.getHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        $scope.addParams = {};
        $scope.Show(resp.vendor.id);
        $scope.TabChanged(2);
      }
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  }; //Update


  $scope.Update = function (id) {
    $scope.loading = true;
    var req = {
      method: 'PUT',
      url: $scope.vendorsEndpoint + id,
      data: $scope.vendor
    };
    Utils.getHttpPromise(req).then(function () {}, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  }; //Delete


  $scope.Delete = function (id) {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.vendorsEndpoint + id
        };
        Utils.getHttpPromise(req).then(function () {
          $scope.vendor = {};
          $scope.activeTab = 0;
          $scope.Index();
        }, function (errResp) {
          Debug.log(errResp);
        })["finally"](function () {
          $scope.loading = false;
        });
      },
      cancel: function cancel() {}
    };
    $scope.confirm.Show(callback, 'Delete Vendor?', 'All related cost sheets to this vendor will also be deleted. This action cannot be undone.', 'Back', 'DELETE');
  };
}
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/purchasing-cost-sheets/purchasing-cost-sheets.component.html
// Module
var purchasing_cost_sheets_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2 class=\"wp-heading-inline\">Cost Sheets</h2> <vf-check-auth></vf-check-auth> <div class=\"container-fluid p-0\"> <div class=\"col p-0\"> <uib-tabset active=\"activeTab\" resize> <uib-tab index=\"0\" select=\"TabChanged(0)\" heading=\"Search Cost Sheets\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-if=\"!loading\" class=\"col p-tb-20 vf-tab-body\"> <div class=\"col p-15\"> <div class=\"input-group mb-3\"> <button class=\"btn btn-secondary dropdown-toggle\" type=\"button\" data-bs-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"> {{searchParams.searchBy === 'id' ? 'ID' : searchParams.searchBy === 'name' ? 'Name' : searchParams.searchBy || 'Search All'}} </button> <div class=\"dropdown-menu\"> <a class=\"dropdown-item\" ng-click=\"searchParams.searchBy = ''\" ng-if=\"searchParams.searchBy.length >= 1\">Search All</a> <a class=\"dropdown-item\" ng-click=\"searchParams.searchBy = 'id'\" ng-if=\"searchParams.searchBy != 'id'\">ID</a> <a class=\"dropdown-item\" ng-click=\"searchParams.searchBy = 'name'\" ng-if=\"searchParams.searchBy != 'name'\">Name</a> </div> <input ng-keypress=\"$event.keyCode === 13 && Index(1)\" ng-model=\"searchParams.q\" type=\"text\" class=\"form-control form-control-lg\" placeholder=\"Search\"> <button ng-click=\"Index()\" class=\"btn btn-secondary\" type=\"submit\">Search</button> <div uib-alert class=\"col-4 alert m-t-10 p-15 m-l-auto\" ng-class=\"'alert-' + (response.type || 'warning')\" ng-repeat=\"response in localized.GetResponseMsgs() track by $index\" close=\"localized.RemoveResponseMsg($index)\">{{response.message}} </div> </div> <hr class=\"col p-0\" ng-if=\"isXS\"> <div class=\"row p-s-20\"> <div class=\"col-3\" ng-click=\"SortIndex('id')\">ID</div> <div class=\"col-3\" ng-click=\"SortIndex('name')\">Name</div> <div class=\"col-3\" ng-click=\"SortIndex('cost_margin')\">Cost Margin</div> </div> <div class=\"p-10\" ng-class=\"{'min-scroll':!isXS}\"> <wp-spinner type=\"2x\" ng-show=\"loadingMore\"> </wp-spinner> <div class=\"text-center\" ng-if=\"costSheets.data.length <= 0 && !loadingMore\"> <span class=\"col m-auto\"> <h3>No Cost Sheet(s) <span ng-if=\"searchParams.q.length >= 1 && searchedBy.length <= 0\">matching '{{searchParams.q}}'</span><span ng-if=\"searchParams.q.length >= 1 && searchedBy.length >= 1\">with the {{searchedBy === 'id' ? 'ID' : searchedBy === 'name' ? 'Name'}} of '{{searchParams.q}}'</span> found.</h3> </span> </div> <div class=\"col p-15 vf-list-item cursor-pointer\" ng-click=\"costSheet.id = sheet.id; TabChanged(2)\" ng-repeat=\"sheet in costSheets.data track by $index\" ng-if=\"!loadingMore\"> <div class=\"row\"> <div class=\"col-3\">{{sheet.id || '----'}}</div> <div class=\"col-3\">{{sheet.name || '----'}} </div> <div class=\"col-3\">{{sheet.cost_margin * 100 || '----'}} %</div> </div> </div> </div> <div class=\"row m-tb-10\"> <div class=\"col-sm-4\"> <span>Showing {{costSheets.from || 0}} to {{costSheets.to || 0}} of {{costSheets.total || 0}} entries<span> </span></span></div> <div class=\"col-sm-4 text-center m-t-10\"> <button class=\"button\" ng-if=\"costSheets.prev_page_url\" ng-click=\"Index(costSheets.current_page - 1)\"><span class=\"dashicons dashicons-arrow-left-alt2\"></span> Prev</button> <button class=\"button\" ng-if=\"costSheets.current_page - 2 > 0\" ng-click=\"Index(costSheets.current_page - 2)\">{{costSheets.current_page - 2}}</button> <button class=\"button\" ng-if=\"costSheets.current_page - 1 > 0\" ng-click=\"Index(costSheets.current_page - 1)\">{{costSheets.current_page - 1}}</button> <button class=\"button\" ng-disabled=\"true\">{{costSheets.current_page}}</button> <button class=\"button\" ng-if=\"costSheets.current_page + 1 <= costSheets.last_page\" ng-click=\"Index(costSheets.current_page + 1)\">{{costSheets.current_page + 1}}</button> <button class=\"button\" ng-if=\"costSheets.current_page + 2 <= costSheets.last_page\" ng-click=\"Index(costSheets.current_page + 2)\">{{costSheets.current_page + 2}}</button> <button class=\"button\" ng-if=\"costSheets.next_page_url\" ng-click=\"Index(costSheets.current_page + 1)\">Next <span class=\"dashicons dashicons-arrow-right-alt2\"></span></button> </div> <div class=\"col-sm-4 justify-content-end\"> <label for=\"rpp\">Per Page: </label> <select class=\"form-control\" style=\"display:inline-block\" id=\"rpp\" ng-model=\"searchParams.rpp\" ng-change=\"Index(1)\" ng-options=\"value for value in rppValues\"> </select> </div> </div> </div> </div> </uib-tab> <uib-tab index=\"1\" select=\"TabChanged(1)\" heading=\"Add Cost Sheet\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-if=\"!loading\" class=\"col p-tb-20 vf-tab-body\"> <form class=\"row p-10\" name=\"new.costSheet\"> <div class=\"col-12 col-md-4\" class=\"needs-validation\"> <div ng-class=\"new.costSheet.name.$invalid ? 'has-danger' : 'has-success'\"> <label class=\"form-label\"> Name </label> <input class=\"form-control\" id=\"name\" ng-class=\"new.costSheet.name.$invalid ? 'is-invalid' : 'is-valid'\" ng-model=\"addParams.name\" name=\"name\" type=\"search\" placeholder=\"New Cost Sheet Name\" minlength=\"1\" required> <div class=\"invalid-feedback\"> Please set a name for the Cost Sheet. </div> </div> <hr class=\"col p-0\"> <div class=\"dropdown mb-3\"> <div class=\"input-group\" data-bs-toggle=\"dropdown\" data-bs-display=\"static\"> <span class=\"input-group-text w-135\">Vendor</span> <input class=\"form-control\" ng-model=\"vendor.name\" disabled=\"disabled\" required> <button class=\"btn btn-secondary\" ng-click=\"filterVal = ''\"> <i class=\"dashicons dashicons-arrow-down\"></i> </button> </div> <ul class=\"vf-dropdown-search dropdown-menu\"> <li class=\"input-group p-5\"> <span class=\"input-group-text\"><i class=\"dashicons dashicons-search\"></i></span> <input class=\"form-control\" ng-model=\"filterVendorVal\" placeholder=\"Filter Vendors\"> </li> <li class=\"border-top\"> <ul class=\"p-5\" style=\"max-height:300px;overflow:auto\"> <li class=\"vf-list-item p-3\" ng-class=\"{'border-bottom':!$last}\" ng-repeat=\"filterVendor in vendors | toArray | orderBy: 'name' | filter: filterVendorVal as filteredVendors track by $index\" ng-click=\"vendor.name = filterVendor.name; addParams.vendor_id = filterVendor.id;\"> {{filterVendor.name}} </li> <li class=\"text-center\" ng-if=\"filteredVendors.length <= 0\"> No results matching {{filterVal}}. </li> </ul> </li> </ul> </div> <div class=\"dropdown mb-3\"> <div class=\"input-group\" data-bs-toggle=\"dropdown\" data-bs-display=\"static\"> <span class=\"input-group-text w-135\">Supplier</span> <input class=\"form-control\" ng-model=\"supplier.name\" disabled=\"disabled\"> <button class=\"btn btn-secondary\" ng-click=\"filterSupVal = ''\"> <i class=\"dashicons dashicons-arrow-down\"></i> </button> </div> <ul class=\"vf-dropdown-search dropdown-menu\"> <li class=\"input-group p-5\"> <span class=\"input-group-text\"><i class=\"dashicons dashicons-search\"></i></span> <input class=\"form-control\" ng-model=\"filterSupplierVal\" placeholder=\"Filter Suppliers\"> </li> <li class=\"border-top\"> <ul class=\"p-5\" style=\"max-height:300px;overflow:auto\"> <li class=\"vf-list-item p-3\" ng-class=\"{'border-bottom':!$last}\" ng-repeat=\"filterSupplier in suppliers | toArray | orderBy: 'name' | filter: filterSupplierVal as filterSuppliers track by $index\" ng-click=\"supplier.name = filterSupplier.name; addParams.supplier_id = filterSupplier.id;\"> {{filterSupplier.name}} </li> <li class=\"text-center\" ng-if=\"filterSuppliers.length <= 0\"> No results matching {{filterSupVal}}. </li> </ul> </li> </ul> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"add_cost_margin\">Cost Margin %</label> <input type=\"number\" min=\"0\" id=\"add_cost_margin\" name=\"add_cost_margin\" ng-model=\"addParams.cost_margin\"/> </div> <div class=\"dropdown mb-3\"> <div class=\"input-group\" data-bs-toggle=\"dropdown\" data-bs-display=\"static\"> <span class=\"input-group-text w-135\">Transmitting Document Profile</span> <input class=\"form-control\" ng-model=\"transmitting_document_profile.name\" disabled=\"disabled\"> <button class=\"btn btn-secondary\" ng-click=\"filterVal = ''\"> <i class=\"dashicons dashicons-arrow-down\"></i> </button> </div> <ul class=\"vf-dropdown-search dropdown-menu\"> <li class=\"input-group p-5\"> <span class=\"input-group-text\"><i class=\"dashicons dashicons-search\"></i></span> <input class=\"form-control\" ng-model=\"filterTransmittingDocProfileVal\" placeholder=\"Filter Document Profiles\"> </li> <li class=\"border-top\"> <ul class=\"p-5\" style=\"max-height:300px;overflow:auto\"> <li class=\"vf-list-item p-3\" ng-class=\"{'border-bottom':!$last}\" ng-repeat=\"filterTransmittingDocProfile in document_profiles | toArray | orderBy: 'name' | filter: filterTransmittingDocProfileVal as filteredTransmittingDocProfile track by $index\" ng-click=\"transmitting_document_profile.name = filterTransmittingDocProfile.name; addParams.transmitting_document_profile_id = filterTransmittingDocProfile.id;\"> {{filterTransmittingDocProfile.name}} </li> <li class=\"text-center\" ng-if=\"filteredTransmittingDocProfile.length <= 0\"> No results matching {{filterTransmittingDocProfileVal}}. </li> </ul> </li> </ul> </div> <div class=\"dropdown mb-3\"> <div class=\"input-group\" data-bs-toggle=\"dropdown\" data-bs-display=\"static\"> <span class=\"input-group-text w-135\">Receiving Document Profile</span> <input class=\"form-control\" ng-model=\"receiving_document_profile.name\" disabled=\"disabled\"> <button class=\"btn btn-secondary\" ng-click=\"filterVal = ''\"> <i class=\"dashicons dashicons-arrow-down\"></i> </button> </div> <ul class=\"vf-dropdown-search dropdown-menu\"> <li class=\"input-group p-5\"> <span class=\"input-group-text\"><i class=\"dashicons dashicons-search\"></i></span> <input class=\"form-control\" ng-model=\"filterReceivingDocProfileVal\" placeholder=\"Filter Document Profiles\"> </li> <li class=\"border-top\"> <ul class=\"p-5\" style=\"max-height:300px;overflow:auto\"> <li class=\"vf-list-item p-3\" ng-class=\"{'border-bottom':!$last}\" ng-repeat=\"filterReceivingDocProfile in document_profiles | toArray | orderBy: 'name' | filter: filterReceivingDocProfileVal as filterReceivingDocProfile track by $index\" ng-click=\"receiving_document_profile.name = filterReceivingDocProfile.name; addParams.receiving_document_profile_id = filterReceivingDocProfile.id;\"> {{filterReceivingDocProfile.name}} </li> <li class=\"text-center\" ng-if=\"filterReceivingDocProfile.length <= 0\"> No results matching {{filterReceivingDocProfileVal}}. </li> </ul> </li> </ul> </div> <div ng-if=\"!isSM && !isXS\"> <button class=\"btn btn-primary m-tb-5\" style=\"min-width:138px\" type=\"button\" ng-click=\"Store()\" ng-disabled=\"new.costSheet.$invalid\">Add Cost Sheet</button> <div class=\"alert col-12 text-center\" ng-class=\"'alert-' + (response.type || 'warning')\" close=\"localized.RemoveResponseMsg($index)\" ng-repeat=\"response in localized.GetResponseMsgs()\"> {{response.message}} </div> </div> </div> <div class=\"col\" ng-if=\"isSM || isXS\"> <button class=\"btn btn-primary m-tb-5 col\" type=\"button\" ng-click=\"Store()\" ng-disabled=\"new.costSheet.$invalid\">Add Cost Sheet</button> <div class=\"alert col-12 text-center\" ng-class=\"'alert-' + (response.type || 'warning')\" close=\"localized.RemoveResponseMsg($index)\" ng-repeat=\"response in localized.GetResponseMsgs()\"> {{response.message}} </div> </div> </form> </div> </uib-tab> <uib-tab index=\"2\" select=\"TabChanged(2)\" ng-show=\"costSheet.id\" heading=\"View Cost Sheet\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <form ng-if=\"!loading\" class=\"col p-tb-20 vf-tab-body\" name=\"view.costSheetForm\"> <div class=\"row p-10\"> <div class=\"col-12 col-md-4\"> <div ng-if=\"editName === false\" ng-click=\"ChangeEdit()\"> <h2>{{costSheet.name}} <sup class=\"dashicons dashicons-edit f-15\"></sup></h2> </div> <div class=\"input-group\" ng-if=\"editName === true\"> <input class=\"form-control\" ng-class=\"{'is-invalid':view.costSheetForm.name.$invalid}\" name=\"name\" ng-model=\"costSheet.name\" required/> <button class=\"btn btn-primary\" type=\"button\" ng-click=\"ChangeEdit()\"><span class=\"dashicons dashicons-yes\"></span></button> </div> <hr class=\"col p-0\"> <div class=\"dropdown\"> <div class=\"input-group\" data-bs-toggle=\"dropdown\" data-bs-display=\"static\"> <span class=\"input-group-text w-135\">Vendor</span> <input class=\"form-control\" ng-model=\"costSheet.vendor.name\" disabled=\"disabled\"> <button class=\"btn btn-secondary\" ng-click=\"filterVal = ''\"> <i class=\"dashicons dashicons-arrow-down\"></i> </button> </div> <ul class=\"vf-dropdown-search dropdown-menu\"> <li class=\"input-group p-5\"> <span class=\"input-group-text\"><i class=\"dashicons dashicons-search\"></i></span> <input class=\"form-control\" ng-model=\"filterVendorVal\" placeholder=\"Filter Vendors\"> </li> <li class=\"border-top\"> <ul class=\"p-5\" style=\"max-height:300px;overflow:auto\"> <li class=\"vf-list-item p-3\" ng-class=\"{'border-bottom':!$last}\" ng-repeat=\"filterVendor in vendors | toArray | orderBy: 'name' | filter: filterVendorVal as filteredVendors track by $index\" ng-click=\"costSheet.vendor.name = filterVendor.name; costSheet.vendor_id = filterVendor.id;\"> {{filterVendor.name}} </li> <li class=\"text-center\" ng-if=\"filteredVendors.length <= 0\"> No results matching {{filterVal}}. </li> </ul> </li> </ul> </div> <div class=\"dropdown\"> <div class=\"input-group\" data-bs-toggle=\"dropdown\" data-bs-display=\"static\"> <span class=\"input-group-text w-135\">Supplier</span> <input class=\"form-control\" ng-model=\"costSheet.supplier.name\" disabled=\"disabled\"> <button class=\"btn btn-secondary\" ng-click=\"filterSupVal = ''\"> <i class=\"dashicons dashicons-arrow-down\"></i> </button> </div> <ul class=\"vf-dropdown-search dropdown-menu\"> <li class=\"input-group p-5\"> <span class=\"input-group-text\"><i class=\"dashicons dashicons-search\"></i></span> <input class=\"form-control\" ng-model=\"filterSupplierVal\" placeholder=\"Filter Suppliers\"> </li> <li class=\"border-top\"> <ul class=\"p-5\" style=\"max-height:300px;overflow:auto\"> <li class=\"vf-list-item p-3\" ng-class=\"{'border-bottom':!$last}\" ng-repeat=\"filterSupplier in suppliers | toArray | orderBy: 'name' | filter: filterSupplierVal as filterSuppliers track by $index\" ng-click=\"costSheet.supplier.name = filterSupplier.name; costSheet.supplier_id = filterSupplier.id;\"> {{filterSupplier.name}} </li> <li class=\"text-center\" ng-if=\"filterSuppliers.length <= 0\"> No results matching {{filterSupVal}}. </li> </ul> </li> </ul> </div> <div class=\"mb-3\"> <label class=\"form-label\" for=\"view_cost_margin\">Cost Margin %</label> <input type=\"number\" min=\"0\" id=\"add_cost_margin\" name=\"view_cost_margin\" ng-model=\"costSheet.cost_margin\"/> </div> <div class=\"dropdown\"> <div class=\"input-group\" data-bs-toggle=\"dropdown\" data-bs-display=\"static\"> <span class=\"input-group-text w-135\">Transmitting Document Profile</span> <input class=\"form-control\" ng-model=\"costSheet.transmitting_document_profile.name\" disabled=\"disabled\" required> <button class=\"btn btn-secondary\" ng-click=\"filterVal = ''\"> <i class=\"dashicons dashicons-arrow-down\"></i> </button> </div> <ul class=\"vf-dropdown-search dropdown-menu\"> <li class=\"input-group p-5\"> <span class=\"input-group-text\"><i class=\"dashicons dashicons-search\"></i></span> <input class=\"form-control\" ng-model=\"filterTransmittingDocProfileVal\" placeholder=\"Filter Document Profiles\"> </li> <li class=\"border-top\"> <ul class=\"p-5\" style=\"max-height:300px;overflow:auto\"> <li class=\"vf-list-item p-3\" ng-class=\"{'border-bottom':!$last}\" ng-repeat=\"filterTransmittingDocProfile in document_profiles | toArray | orderBy: 'name' | filter: filterTransmittingDocProfileVal as filteredTransmittingDocProfile track by $index\" ng-click=\"costSheet.transmitting_document_profile.name = filterTransmittingDocProfile.name; costSheet.transmitting_document_profile_id = filterTransmittingDocProfile.id;\"> {{filterTransmittingDocProfile.name}} </li> <li class=\"text-center\" ng-if=\"filteredTransmittingDocProfile.length <= 0\"> No results matching {{filterTransmittingDocProfileVal}}. </li> </ul> </li> </ul> </div> <div class=\"dropdown\"> <div class=\"input-group\" data-bs-toggle=\"dropdown\" data-bs-display=\"static\"> <span class=\"input-group-text w-135\">Receiving Document Profile</span> <input class=\"form-control\" ng-model=\"costSheet.receiving_document_profile.name\" disabled=\"disabled\" required> <button class=\"btn btn-secondary\" ng-click=\"filterVal = ''\"> <i class=\"dashicons dashicons-arrow-down\"></i> </button> </div> <ul class=\"vf-dropdown-search dropdown-menu\"> <li class=\"input-group p-5\"> <span class=\"input-group-text\"><i class=\"dashicons dashicons-search\"></i></span> <input class=\"form-control\" ng-model=\"filterReceivingDocProfileVal\" placeholder=\"Filter Document Profiles\"> </li> <li class=\"border-top\"> <ul class=\"p-5\" style=\"max-height:300px;overflow:auto\"> <li class=\"vf-list-item p-3\" ng-class=\"{'border-bottom':!$last}\" ng-repeat=\"filterReceivingDocProfile in document_profiles | toArray | orderBy: 'name' | filter: filterReceivingDocProfileVal as filterReceivingDocProfile track by $index\" ng-click=\"costSheet.receiving_document_profile.name = filterReceivingDocProfile.name; costSheet.receiving_document_profile_id = filterReceivingDocProfile.id;\"> {{filterReceivingDocProfile.name}} </li> <li class=\"text-center\" ng-if=\"filterReceivingDocProfile.length <= 0\"> No results matching {{filterReceivingDocProfileVal}}. </li> </ul> </li> </ul> </div> <hr class=\"col p-0\" ng-if=\"isXS\"> <div class=\"m-tb-10\"> <button class=\"btn btn-primary\" type=\"button\" ng-if=\"updatedCosts.length >= 1\" ng-click=\"ShowChanges()\"> <span ng-if=\"!showChanges\">Show Changes ({{updatedCosts.length}})</span> <span ng-if=\"showChanges\">Show Current</span> </button> </div> <div ng-if=\"!isXS && !isSM\"> <div> <button class=\"btn btn-secondary m-tb-5\" style=\"min-width:135px\" ng-click=\"OpenSearchModalUpdate()\"> <span ng-if=\"costSheet.costs.data.length\">Edit Cost Sheet</span><span ng-if=\"!costSheet.costs.data.length\">Add Products</span> </button> </div> <div> <button class=\"btn btn-outline-danger border-0 m-tb-5\" style=\"min-width:135px\" ng-click=\"Delete(costSheet.id)\">Delete</button> <button class=\"btn btn-primary m-tb-5\" style=\"min-width:135px\" type=\"button\" ng-click=\"Update(costSheet.id)\" ng-disabled=\"view.costSheetForm.$invalid\">Save Changes</button> </div> </div> </div> <div class=\"col-12 col-md-8\" ng-class=\"{'m-t-20':isXS || isSM}\" style=\"display:inline-grid;position:relative\"> <div ng-show=\"!showChanges\"> <div class=\"row\" ui-keypress=\"{13:'Show(costSheet.id)'}\"> <label class=\"form-label\" for=\"searchProducts\">Search:</label> <div class=\"input-group\" ng-form> <input class=\"form-control\" type=\"text\" id=\"searchProducts\" placeholder=\"Search 'Labels'\" ng-model=\"searchParams.q\"> <button class=\"btn btn-secondary\" ng-click=\"Show(costSheet.id)\"><span class=\"dashicons dashicons-search\"></span></button> </div> </div> <wp-spinner type=\"2x\" ng-show=\"productsLoading\"> </wp-spinner> <div ng-if=\"!productsLoading\"> <div class=\"row min-scroll\"> <div class=\"col text-center p-20\" ng-if=\"!costSheet.costs.data.length\"> <h3>Click 'Add Products' to get started.</h3> </div> <div class=\"col-6 col-md-3 vf-item-card-outer\" ng-repeat=\"item in costSheet.costs.data track by $index\"> <div class=\"vf-item-card-inner\" ng-click=\"editIndex = $index;\"> <div class=\"row\"> <p class=\"col-12\"><b>{{item.sku}}</b></p> <div class=\"col-12\" ng-if=\"!item.image\"> <img class=\"img-fluid\" src=\"{{rootUrl}}/assets/img/brand.png\"> </div> <div class=\"col-12\" ng-if=\"item.image\"> <img class=\"img-fluid vf-item-image\" ng-src=\"{{item.image.thumb_url}}\"> </div> <div class=\"col-12\"> <p>{{item.product.description | limitTo: 30}}{{item.product.description.length >= 30 ? '...' : ''}} </p> </div> <div class=\"col-12 text-center vf-item-card-input\"> Cost <input class=\"form-control\" ng-class=\"{'is-invalid':view.costSheetForm['cost'+$index].$invalid || !item.cost}\" name=\"cost{{$index}}\" format=\"currency\" ng-change=\"editParams(item)\" ng-model=\"item.cost\" ng-pattern=\"/(?=.*[1-9])^\\$?(([1-9]\\d{0,2}(,\\d{3})*)|\\d+)?(\\.\\d{1,2})?$/\" required/> </div> <div class=\"col-12 text-center vf-item-card-input\"> Unit of Measure <div class=\"row\"> <div class=\"col col-5\"> <input class=\"form-control\" placeholder=\"Qty\" ng-class=\"{'is-invalid':view.costSheetForm['uomqty'+$index].$invalid || !item.uomqty}\" name=\"uomqty{{$index}}\" ng-change=\"editParams(item)\" ng-model=\"item.uomqty\" required/> </div> <div class=\"col col-2 text-center\" style=\"text-align:center\"> / </div> <div class=\"col col-5\"> <input class=\"form-control\" placeholder=\"ID\" ng-class=\"{'is-invalid':view.costSheetForm['uomid'+$index].$invalid || !item.uomid}\" name=\"uomid{{$index}}\" ng-change=\"editParams(item)\" ng-model=\"item.uomid\" required/> </div> </div> </div> <div class=\"col-12 text-center vf-item-card-input\"> Vendor SKU <input class=\"form-control\" placeholder=\"Vendor SKU\" ng-class=\"{'is-invalid':view.costSheetForm['vendorSku'+$index].$invalid || !item.vendor_sku}\" name=\"vendorSku{{$index}}\" ng-change=\"editParams(item)\" ng-model=\"item.vendor_sku\" required/> </div> </div> </div> </div> </div> </div> <hr class=\"col p-0\" ng-if=\"isXS\"> <div class=\"row m-tb-10\" ng-hide=\"productsLoading\"> <div class=\"col-sm-4\"> <span>Showing {{costSheet.costs.from || 0}} to {{costSheet.costs.to || 0}} of {{costSheet.costs.total || 0}} entries</span> </div> <div class=\"col text-center m-tb-10\"> <button class=\"button\" ng-if=\"costSheet.costs.prev_page_url\" ng-click=\"searchParams.page = costSheet.costs.current_page - 1; Show(costSheet.id);\"><span class=\"dashicons dashicons-arrow-left-alt2\"></span> Prev</button> <button class=\"button\" ng-if=\"costSheet.costs.current_page - 2 > 0\" ng-click=\"searchParams.page = costSheet.costs.current_page - 2; Show(costSheet.id);\">{{costSheet.costs.current_page - 2}}</button> <button class=\"button\" ng-if=\"costSheet.costs.current_page - 1 > 0\" ng-click=\"searchParams.page = costSheet.costs.current_page - 1; Show(costSheet.id);\">{{costSheet.costs.current_page - 1}}</button> <button class=\"button\" ng-disabled=\"true\">{{costSheet.costs.current_page}}</button> <button class=\"button\" ng-if=\"costSheet.costs.current_page + 1 <= costSheet.costs.last_page\" ng-click=\"searchParams.page = costSheet.costs.current_page + 1; Show(costSheet.id);\">{{costSheet.costs.current_page + 1}}</button> <button class=\"button\" ng-if=\"costSheet.costs.current_page + 2 <= costSheet.costs.last_page\" ng-click=\"searchParams.page = costSheet.costs.current_page + 2; Show(costSheet.id);\">{{costSheet.costs.current_page + 2}}</button> <button class=\"button\" ng-if=\"costSheet.costs.next_page_url\" ng-click=\"searchParams.page = costSheet.costs.current_page + 1; Show(costSheet.id);\">Next <span class=\"dashicons dashicons-arrow-right-alt2\"></span></button> </div> <div class=\"col-sm-4 justify-content-end\"> <label for=\"rpp\">Per Page: </label> <select class=\"form-control\" style=\"display:inline-block\" id=\"rpp\" ng-model=\"searchParams.rpp\" ng-change=\"searchParams.page = 1;Show(costSheet.id);\" ng-options=\"value for value in rppValues\"> </select> </div> </div> </div> <div ng-show=\"showChanges\"> <div class=\"row\" ng-hide=\"productsLoading\"> <div class=\"input-group col-12 p-0\"> <input class=\"form-control\" type=\"text\" id=\"filterChanges\" ng-model=\"filterEdited\" placeholder=\"Filter Changes\"> </div> </div> <hr class=\"col p-0\" ng-if=\"isXS\"> <wp-spinner type=\"2x\" ng-show=\"productsLoading\"> </wp-spinner> <div ng-if=\"!productsLoading\"> <div class=\"row min-scroll\"> <div class=\"col text-center p-20\" ng-if=\"results.length <= 0\"> <h3>No results matching '{{filterBy}}'.</h3> </div> <div class=\"col-6 col-md-4 col-lg-3 vf-item-card-outer\" ng-repeat=\"item in updatedCosts | filter: filterEdited as results track by $index\"> <div class=\"vf-item-card-inner\" ng-class=\"item.action\"> <div class=\"row\"> <p class=\"col-12\"><b>{{item.value.sku}}</b></p> <div class=\"col-12\" style=\"min-height:80px\" ng-if=\"!item.value.image\"> <img class=\"img-fluid\" src=\"{{rootUrl}}/assets/img/brand.png\"> </div> <div class=\"col-12\" ng-if=\"item.value.image\"> <img class=\"img-fluid vf-item-image\" ng-src=\"{{item.value.image.thumb_url}}\"> </div> <div class=\"col-12\"> <p>{{item.value.product.description | limitTo: 30}}{{item.value.product.description.length >= 30 ? '...' : ''}} </p> </div> <div class=\"col-12 text-center vf-item-card-input\"> Cost <input ng-disabled=\"item.action == 'edited' || item.action == 'remove'\" class=\"form-control\" ng-class=\"{'is-invalid':view.costSheetForm['newCost'+$index].$invalid || !item.value.cost}\" format=\"currency\" name=\"newCost{{$index}}\" ng-model=\"item.value.cost\" ng-pattern=\"/(?=.*[1-9])^\\$?(([1-9]\\d{0,2}(,\\d{3})*)|\\d+)?(\\.\\d{1,2})?$/\" required/> </div> <div class=\"col-12 text-center vf-item-card-input\"> Unit of Measure <div class=\"row\"> <div class=\"col col-5\"> <input ng-disabled=\"item.action == 'edited' || item.action == 'remove'\" class=\"form-control\" placeholder=\"Qty\" ng-class=\"{'is-invalid':view.costSheetForm['newUomqty'+$index].$invalid || !item.value.uomqty}\" name=\"newUomqty{{$index}}\" ng-model=\"item.value.uomqty\" required/> </div> <div class=\"col col-2 text-center\" style=\"text-align:center\"> / </div> <div class=\"col col-5\"> <input ng-disabled=\"item.action == 'edited' || item.action == 'remove'\" class=\"form-control\" placeholder=\"ID\" ng-class=\"{'is-invalid':view.costSheetForm['newUomid'+$index].$invalid || !item.value.uomid}\" name=\"newUomid{{$index}}\" ng-model=\"item.value.uomid\" required/> </div> </div> </div> <div class=\"col-12 text-center vf-item-card-input\"> Vendor SKU <input ng-disabled=\"item.action == 'edited' || item.action == 'remove'\" class=\"form-control\" placeholder=\"Vendor SKU\" ng-class=\"{'is-invalid':view.costSheetForm['newVendorSku'+$index].$invalid || !item.value.vendor_sku}\" name=\"newVendorSku{{$index}}\" ng-model=\"item.value.vendor_sku\" required/> </div> </div> </div> </div> </div> </div> </div> </div> </div> <div class=\"col\" ng-if=\"isXS || isSM\"> <button class=\"btn btn-secondary m-tb-5 col\" ng-click=\"OpenSearchModalUpdate()\"> <span ng-if=\"costSheet.costs.data.length\">Edit Cost Sheet</span><span ng-if=\"!costSheet.costs.data.length\">Add Products</span> </button> <button class=\"btn btn-outline-danger border-0 m-tb-5 col\" ng-click=\"Delete(costSheet.id)\">Delete</button> <button class=\"btn btn-primary m-tb-5 col\" type=\"button\" ng-click=\"Update(costSheet.id)\" ng-disabled=\"view.costSheetForm.$invalid\">Save Changes</button> <div class=\"alert col-12 text-center\" ng-class=\"'alert-' + (response.type || 'warning')\" close=\"localized.RemoveResponseMsg($index)\" ng-repeat=\"response in localized.GetResponseMsgs()\"> {{response.message}} </div> </div> </form> </uib-tab> <uib-tab index=\"3\" select=\"TabChanged(3)\" heading=\"Upload Sheet(s)\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-if=\"!loading\" class=\"col p-0 vf-tab-body\"> <form class=\"row p-15\" enctype=\"multipart/form-data\" name=\"psUploadForm\"> <div class=\"col-md-5\"> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">Cost Sheet</span> <input class=\"form-control\" ng-class=\"{'is-invalid':psUploadForm.psID.$invalid}\" type=\"text\" id=\"psName\" name=\"psID\" placeholder=\"Select a Cost Sheet\" ng-model=\"uploadCostSheetName\" disabled=\"disabled\" required/> <button class=\"btn btn-secondary\" ng-click=\"OpenSearchModalCostSheetsIndex()\">Browse</button> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text w-104\">File</span> <input class=\"form-control\" ng-class=\"{'is-invalid':psUploadForm.psName.$invalid}\" name=\"psName\" ng-model=\"theFile.name\" placeholder=\"Upload a File\" disabled=\"disabled\" required> <label class=\"btn btn-secondary m-0\"> Browse <input class=\"custom-file\" type=\"file\" name=\"file\" id=\"uploadInput\" onchange=\"angular.element(this).scope().setFile(this),angular.element(this).scope().setUploading()\" hidden/> </label> </div> <div ng-if=\"uploading\" class=\"text-center\"> Generating your Cost Sheet, please wait <img class=\"h-46\" ng-src=\"{{rootUrl}}/assets/img/loading.gif\"> </div> </div> <div class=\"col-md-12 p-15 table-responsive\"> <div class=\"min-scroll-table\" ng-if=\"batchUpload && !uploading\"> <table class=\"table table-striped table-fixed\"> <thead> <tr> <th>SKU</th> <th>Cost</th> <th>Vendor SKU</th> <th>UoM ID</th> <th>UoM Qty</th> </tr> </thead> <tbody ng-repeat=\"product in batchUpload  | limitTo: 5 track by $index\"> <tr> <td ng-repeat=\"attribute in product track by $index \"> <span ng-if=\"attribute.length >= 1\" title=\"{{attribute}}\">{{attribute | limitTo: 25}}{{attribute.length >= 25 ? '...' : ''}}</span> <span ng-if=\"attribute.length <= 0\">----</span> </td> </tr> </tbody> </table> </div> </div> <div class=\"col-12\" ng-class=\"{'text-end':batchUpload}\"> <button class=\"btn btn-outline-danger border-0 m-tb-10\" ng-class=\"{'col': isXS || isSM}\" ng-click=\"RemoveUploadFile()\" ng-if=\"batchUpload\">Remove</button> <button class=\"btn btn-primary m-tb-10\" ng-class=\"{'col': isXS || isSM}\" ng-disabled=\"psUploadForm.$invalid\" ng-click=\"UploadBatch()\" ng-if=\"batchUpload\">Upload Cost Sheet</button> </div> </form> </div> <div uib-alert class=\"col-4 alert m-t-10 p-15 m-l-auto\" ng-class=\"'alert-' + (response.type || 'warning')\" ng-repeat=\"response in localized.GetResponseMsgs() track by $index\" close=\"localized.RemoveResponseMsg($index)\">{{response.message}} </div> </uib-tab> <uib-tab index=\"4\" select=\"TabChanged(4)\" heading=\"Batches\"> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-if=\"!loading\" class=\"col p-0 vf-tab-body\"> <div class=\"col p-15\"> <div class=\"input-group\"> <span class=\"input-group-text\">Status</span> <select class=\"form-control h-38\" ng-options=\"key as value for (key, value) in batchListOptions\" ng-model=\"sortBatchParams.status\" ng-change=\"SortBatchIndex('batch_id')\"></select> </div> <div class=\"row p-s-20 p-t-10\"> <div class=\"col\" ng-click=\"SortBatchIndex('batch_id')\">Batch ID</div> <div class=\"col\" ng-click=\"SortBatchIndex('time_uploaded')\">Upload Date</div> <div class=\"col\" ng-click=\"SortBatchIndex('filename')\">File Name</div> <div class=\"col\" ng-click=\"SortBatchIndex('status')\">Status</div> <div class=\"col\">Progress</div> </div> <div class=\"p-10\" ng-class=\"{'min-scroll':!isXS}\"> <wp-spinner type=\"2x\" ng-show=\"loadingMore\"> </wp-spinner> <div class=\"text-center\" ng-if=\"!loadingMore && batches.length <= 0\"> <span class=\"col m-auto\"> <h3>No Batches found.</h3> </span> </div> <div ng-if=\"!loadingMore\" class=\"col p-15 vf-list-item cursor-pointer\" ng-click=\"batch.status == 'pending' || batch.status == 'confirmed' ? ChangeBatchTab(batch.batch_id) : return;\" ng-repeat=\"batch in batches track by $index\"> <div class=\"row\"> <div class=\"col\">{{batch.batch_id}}</div> <div class=\"col\">{{batch.time_uploaded}}</div> <div class=\"col\">{{batch.filename}}</div> <div class=\"col\">{{batch.status}}</div> <div ng-if=\"batch.recordsProcessed\" class=\"col\"> {{((batch.recordsProcessed / batch.total_records) * 100).toFixed(2)}}%</div> <div ng-if=\"!batch.recordsProcessed && batch.status == 'processed'\" class=\"col\">Done </div> <div ng-if=\"!batch.recordsProcessed && batch.status != 'processed'\" class=\"col\"> {{batch.total_records ? '0%' : 'N/A'}}</div> </div> </div> </div> </div> </div> </uib-tab> <uib-tab index=\"5\" select=\"TabChanged(5)\" ng-show=\"selectedBatch.id\"> <uib-tab-heading> Batch {{selectedBatch.id}} <span class=\"dashicons dashicons-update\"></span> </uib-tab-heading> <wp-spinner type=\"2x\" ng-show=\"loading\"> </wp-spinner> <div ng-if=\"!loading\" class=\"col p-0 vf-tab-body\"> <div class=\"row p-15\"> <div class=\"col-md-5\"> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">Batch ID</span> <input class=\"form-control\" ng-model=\"selectedBatch.id\" type=\"text\" disabled=\"disabled\"> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">Cost Sheet ID</span> <input class=\"form-control\" ng-model=\"selectedBatch.cost_sheet_id\" type=\"text\" disabled=\"disabled\"> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">File Name</span> <input class=\"form-control\" ng-model=\"selectedBatch.filename\" type=\"text\" disabled=\"disabled\"> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">Time Uploaded</span> <input class=\"form-control\" ng-model=\"selectedBatch.time_uploaded\" type=\"text\" disabled=\"disabled\"> </div> <div class=\"input-group m-tb-10\"> <span class=\"input-group-text\">Status</span> <input class=\"form-control\" ng-model=\"selectedBatch.status\" type=\"text\" disabled=\"disabled\"> </div> </div> <div class=\"col-12 m-tb-20 table-responsive scrollbar\"> <div class=\"min-scroll-table\"> <table class=\"table table-striped table-fixed\"> <thead> <tr> <th scope=\"col\" class=\"padding: 10px;\" ng-repeat=\"(key, value) in batchHeaders\"> {{value}}</th> </tr> </thead> <tbody> <tr ng-repeat=\"data in selectedBatch.items  | limitTo: 5\"> <td scope=\"row\" class=\"padding: 10px;\" ng-repeat=\"(x, y) in batchHeaders\"> {{data[x]}} </td> </tr> </tbody> </table> </div> </div> <div class=\"col-12\"> <button class=\"btn btn-primary m-tb-10\" ng-class=\"{'col-12': isXS || isSM}\" ng-click=\"ConfirmBatch()\" ng-if=\"selectedBatch.status == 'pending'\">Confirm Batch</button> </div> </div> </div> <div uib-alert class=\"col-4 alert m-t-10 p-15 m-l-auto\" ng-class=\"'alert-' + (response.type || 'warning')\" ng-repeat=\"response in localized.GetResponseMsgs() track by $index\" close=\"localized.RemoveResponseMsg($index)\">{{response.message}} </div> </uib-tab> </uib-tabset> </div> </div>";
// Exports
/* harmony default export */ const purchasing_cost_sheets_component = (purchasing_cost_sheets_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/purchasing-cost-sheets/purchasing-cost-sheets.component.ts

var PurchasingCostSheetsComponent = {
  template: purchasing_cost_sheets_component,
  controller: PurchasingCostSheetsController
};

function PurchasingCostSheetsController($scope, $timeout, $state, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized, SearchModal, $window) {
  this.breadcrumbs = [{
    name: 'Purchasing',
    state: 'purchasing.page'
  }, {
    name: 'Cost Sheets',
    state: 'purchasing-suppliers'
  }];
  /**
   * Sets the active tab based on whether it matches a index of accessible tabs.
   *
   * @param {number} tab
   * @return {number | Object} Sets activeTab to the tab number, or reloads the state to reset the activeTab.
   */

  var setActiveTab = function setActiveTab(tab) {
    var index = [0, 1, 3, 4];

    if (index.includes(tab)) {
      return $scope.activeTab = tab;
    }

    return $state.go($state.current, {
      activeTab: 0
    }, {
      reload: true
    });
  };

  setActiveTab(parseInt($stateParams.activeTab));
  $scope.loading = false;
  $scope.loadingMore = false;
  $scope.productsLoading = false;
  $scope.saving = false;
  $scope.uploading = false;
  $scope.saved = false;
  $scope.loadingMore = false;
  $scope.costSheetEndpoint = Localized.apiURL + '/admin/purchasing/cost-sheet/';
  $scope.productEndpoint = Localized.apiURL + '/admin/products/';
  $scope.vendorEndpoint = Localized.apiURL + '/admin/purchasing/vendors/';
  $scope.supplierEndpoint = Localized.apiURL + '/admin/punchout/suppliers/';
  $scope.docProfileEndpoint = Localized.apiURL + '/admin/purchasing/document-profile/';
  $scope.batchEndpoint = Localized.apiURL + '/admin/purchasing/cost-sheet/batch/';
  $scope.costSheets = [];
  $scope.costSheet = {};
  $scope.vendor = {};
  $scope.supplier = {};
  $scope.transmitting_document_profile = {};
  $scope.receiving_document_profile = {};
  $scope.document_profiles = {};
  $scope.selectedBatch = {};
  $scope.addParams = {
    costs: []
  };
  $scope.editName = false;
  $scope.updatedCosts = [];
  $scope.editIndex = -1;
  $scope.object = Object;
  $scope.myFile = {};
  $scope.showChanges = false;
  $scope.rppValues = [15, 30, 50, 100];
  $scope.searchParams = {
    q: '',
    searchBy: '',
    sortBy: '',
    sortType: '',
    rpp: $scope.rppValues[0]
  };
  $scope.sortBatchParams = {
    sort_by: 'batch_id',
    sort_type: '',
    status: 'pending'
  };
  $scope.sortBatchParams.status = 'any';
  $scope.batchListOptions = {
    any: 'All',
    pending: 'Pending',
    confirmed: 'Confirmed',
    processing: 'Processing',
    processed: 'Processed'
  };
  $scope.sortAscending = true; //FACTORIES

  $scope.admin = Admin;
  $scope.confirm = ConfirmModal;
  $scope.settings = Settings;
  $scope.localized = Localized;
  $scope.utils = Utils; //FUNCTIONS

  $scope.LoginCallback = function () {
    $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
  };

  $scope.TabChanged = function (i) {
    $scope.activeTab = i;
    $scope.loading = true;

    switch ($scope.activeTab) {
      //Only retrieve new index if no data is present
      //This way previous searches are retained
      case 0:
        if (!$scope.costSheets.data) {
          $scope.Index();
        }

        break;

      case 2:
        if ($scope.costSheet.id) {
          $scope.searchParams = {
            q: '',
            searchBy: '',
            sortBy: '',
            sortType: '',
            rpp: $scope.rppValues[0]
          };
          $scope.Show($scope.costSheet.id);
        }

        break;

      case 4:
        $scope.BatchIndex();
        break;

      case 5:
        $scope.ShowBatch($scope.selectedBatch.id);
        break;
    }

    $scope.loading = false;
  };

  $scope.ChangeTab = function (tab) {
    $scope.activeTab = tab;
  };

  $scope.SortIndex = function (sortBy) {
    $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
    $scope.searchParams.sortBy = sortBy;
    $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
    $scope.Index($scope.searchParams.page);
  }; //Index


  $scope.Index = function (page) {
    $scope.loadingMore = true;
    $scope.searchParams.page = page || 1;
    var req = {
      method: 'GET',
      url: $scope.costSheetEndpoint,
      params: $scope.searchParams
    };
    Utils.getHttpPromise(req).then(function (resp) {
      $scope.costSheets = resp.cost_sheets;
      $scope.vendors = resp.vendors;
      $scope.suppliers = resp.suppliers;
      $scope.document_profiles = resp.document_profiles;
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loadingMore = false;
      $scope.loading = false;
    });
  }; //Show


  $scope.Show = function (id) {
    $scope.loading = true;
    $scope.costSheet.id = id;
    var req = {
      method: 'GET',
      url: $scope.costSheetEndpoint + id,
      params: $scope.searchParams
    };
    Utils.getHttpPromise(req).then(function (resp) {
      $scope.costSheet = resp.cost_sheet;
      $scope.costSheet.cost_margin *= 100;
      $scope.vendors = resp.vendors;
      $scope.suppliers = resp.suppliers;
      $scope.document_profiles = resp.document_profiles;
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.showChanges = false;
      $scope.loading = false;
    });
  }; //Store


  $scope.Store = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.costSheetEndpoint,
      data: $scope.addParams
    };
    Utils.getHttpPromise(req).then(function (resp) {
      if (!resp.errors.length) {
        $scope.addParams = {};
        $scope.vendor = {};
        $scope.supplier = {};
        $scope.Show(resp.cost_sheet.id);
        $scope.TabChanged(2);
      }
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  }; //Update


  $scope.Update = function (id) {
    $scope.loading = true;
    $scope.updatedCosts.forEach(function (cost) {
      if (cost.action === 'remove') {
        cost.value.cost = 0.00;
      }

      $scope.costSheet.costs.data.push(cost.value);
    });
    $scope.costSheet.costs = $scope.costSheet.costs.data;
    var req = {
      method: 'PUT',
      url: $scope.costSheetEndpoint + id,
      data: $scope.costSheet
    };
    Utils.getHttpPromise(req).then(function () {
      $scope.updatedCosts = [];
      $scope.Show(id);
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  }; //Delete


  $scope.Delete = function (id) {
    var callback = {
      confirm: function confirm() {
        $scope.loading = true;
        var req = {
          method: 'DELETE',
          url: $scope.costSheetEndpoint + id
        };
        Utils.getHttpPromise(req).then(function () {
          $scope.costSheet = {};
          $scope.activeTab = 0;
          $scope.Index();
        }, function (errResp) {
          Debug.log(errResp);
        })["finally"](function () {
          $scope.loading = false;
        });
      },
      cancel: function cancel() {}
    };
    $scope.confirm.Show(callback, 'Delete Cost Sheet?', 'This action cannot be undone.', 'Back', 'DELETE');
  };

  $scope.ChangeBatchTab = function (batchId) {
    $scope.activeTab = 5;
    $scope.selectedBatch.id = batchId;
  };

  $scope.ChangeEdit = function () {
    $scope.editName = !$scope.editName;
  };

  $scope.ConfirmBatch = function () {
    $scope.loading = true;
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'confirm',
      data: {
        id: $scope.selectedBatch.id
      }
    };
    Utils.getHttpPromise(req).then(function () {
      $scope.selectedBatch = null;
      $scope.activeTab = 4;
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  };

  $scope.SearchResults = function (resp) {
    //callback that is used by the search modal
    if ($scope.activeTab === 1) {
      if ($scope.addParams.costs) {
        resp.forEach(function (product) {
          $scope.addParams.costs.push(product); // eslint-disable-next-line no-shadow

          var currentIds = $scope.addParams.costs.map(function (product) {
            return product.value.product_id;
          });

          if (currentIds.includes(product.value.product_id)) {
            $scope.addParams.costs[$scope.addParams.costs.length - 1].cost = product.value.cost;
          }
        });
      } else {
        $scope.addParams.costs = [];
      }
    } else if ($scope.activeTab === 2) {
      var currentIds = $scope.updatedCosts.map(function (item) {
        return item.value.product_id;
      });
      $scope.updatedCosts = [];
      resp.forEach(function (item) {
        var included = currentIds.includes(item.value.product_id);

        if (item.action === 'add') {
          $scope.updatedCosts.push({
            action: 'add',
            value: {
              product_id: item.value.product_id,
              sku: item.value.sku,
              vendor_sku: item.value.sku,
              uomid: item.value.uomid,
              uomqty: item.value.uomqty,
              cost: included ? item.value.cost : 0.00,
              product: included ? item.value.product : item.value,
              image: item.value.image
            }
          });
        } else if (item.action === 'remove') {
          $scope.updatedCosts.push(item);
        }
      });
    }
  };

  $scope.editParams = function (item) {
    for (var i = 0; i < $scope.updatedCosts.length; i++) {
      if ($scope.updatedCosts[i].value.product_id === item.product_id) {
        if ($scope.updatedCosts[i].action === 'remove') {
          return;
        }

        $scope.updatedCosts[i].value.cost = item.cost;
        return;
      }
    }

    $scope.updatedCosts.push({
      action: 'edited',
      value: item
    });
  };

  $scope.ShowChanges = function () {
    $scope.showChanges = !$scope.showChanges;
  };

  $scope.OpenSearchModalUpdate = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.productEndpoint,
          params: {
            q: '',
            excludedField: 'cost_sheet_index_id',
            excludedId: $scope.costSheet.id,
            excludedTable: 'cost_sheets'
          }
        },
        relationships: ['products'],
        fields: ['sku', 'image', 'description', 'status'],
        fieldPrefixes: ['', '', '', 'Status: '],
        id: 'product_id',
        selectOne: false
      }, {
        http: {
          method: 'GET',
          url: $scope.costSheetEndpoint + $scope.costSheet.id,
          params: {
            q: ''
          }
        },
        relationships: ['cost_sheet', 'costs'],
        fields: ['sku', 'image', 'description', 'cost'],
        fieldPrefixes: ['', '', '', 'Cost: '],
        id: 'product_id'
      }],
      updatedItems: $scope.cost
    };
    callback = {
      confirm: $scope.SearchResults,
      cancel: function cancel() {}
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, $scope.costSheet.sheet, config, 'Add items');
  };

  $scope.OpenSearchModalCostSheetsIndex = function () {
    var callback = {};
    var config = {
      tabs: [{
        http: {
          method: 'GET',
          url: $scope.costSheetEndpoint,
          params: {
            q: ''
          }
        },
        relationships: ['cost_sheets'],
        fields: ['id', 'name'],
        fieldPrefixes: ['ID: ', ''],
        id: 'id',
        selectOne: true
      }]
    };
    callback = {
      confirm: function confirm(resp) {
        $scope.uploadCostSheetID = resp[0].value.id;
        $scope.uploadCostSheetName = resp[0].value.name;
      },
      cancel: $scope.SearchCancelled
    }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

    SearchModal.Show(callback, 'Select Cost Sheet', config, 'Add Cost Sheet');
  };

  $scope.RemoveUploadFile = function () {
    $scope.batchUpload = null;
    $scope.localized.PushResponseMsg({
      type: 'danger',
      message: 'File Successfully Removed'
    });
  };

  $scope.setFile = function (element) {
    // eslint-disable-next-line no-shadow
    $scope.$apply(function ($scope) {
      $scope.theFile = element.files[0];
    });
    var totalBytes = $scope.theFile.size;

    if (totalBytes < 1000000) {
      $scope.fileSize = Math.floor(totalBytes / 1000) + 'KB';
      Debug.log('FileSize: ', $scope.fileSize, ' KB');
    } else {
      $scope.fileSize = Math.floor(totalBytes / 1000000) + 'MB';
      Debug.log('FileSize: ', $scope.fileSize, ' MB');
    }

    Debug.log('File Size: ', $scope.fileSize);
    var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

    if (regex.test($scope.theFile.name.toLowerCase())) {
      if (typeof FileReader !== 'undefined') {
        var reader = new FileReader();

        reader.onload = function () {
          // eslint-disable-next-line no-undef
          Papa.parse(reader.result, {
            complete: function complete(results) {
              var rows = [];

              var _loop = function _loop(i) {
                var info = results.data[i];
                var row = [];
                angular.forEach(info, function (val, key) {
                  row[key] = val;
                });
                rows.push(row);
              };

              for (var i = 0; i <= results.data.length; i++) {
                _loop(i);
              } // eslint-disable-next-line no-shadow


              $scope.$apply(function ($scope) {
                $scope.batchUpload = rows;
                $scope.IsVisible = true;
              });
              Debug.log('Finished: ', results.data);
            }
          });
          $scope.setUploading();
        };

        reader.readAsText($scope.theFile);
      } else {
        $window.alert('This browser does not support HTML5.');
      }
    } else {
      $scope.batchUpload = null;
      $scope.theFile = null;
      $scope.setUploading();
      $window.alert('Please upload a valid CSV file.');
    }
  };

  $scope.setUploading = function () {
    // eslint-disable-next-line no-shadow
    $scope.$apply(function ($scope) {
      $scope.uploading = !$scope.uploading;
    });
  };

  $scope.SortBatchIndex = function (sortBy) {
    $scope.sortAscending = $scope.sortBatchParams.sort_by === sortBy ? !$scope.sortAscending : true;
    $scope.sortBatchParams.sort_by = sortBy;
    $scope.sortBatchParams.sort_type = $scope.sortAscending ? 'asc' : 'desc';
    $scope.BatchIndex();
  }; //Index


  $scope.BatchIndex = function () {
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint,
      params: $scope.sortBatchParams
    };
    Utils.getHttpPromise(req).then(function (resp) {
      $scope.batches = resp.search_results;
      var again = false;

      for (var i = 0; i < $scope.batches.length; i++) {
        if ($scope.batches[i].status === 'processing' && $scope.activeTab === 4) {
          again = true;
          break;
        }
      }

      if (again) {
        $timeout(function () {
          $scope.BatchIndex();
        }, 5000);
      }
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  };

  $scope.ShowBatch = function (batchId) {
    $scope.selectedBatch.batch_id = batchId;
    $scope.activeTab = 5;
    var req = {
      method: 'GET',
      url: $scope.batchEndpoint + 'view',
      params: {
        id: batchId
      }
    };
    Utils.getHttpPromise(req).then(function (resp) {
      $scope.selectedBatch = resp.batches[0];
      $scope.batchHeaders = resp.batches[0].columns;
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  };
  /**
   * Upload the batch file that has been set.
   */


  $scope.UploadBatch = function () {
    $scope.loading = true;
    var fd = new FormData();
    fd.append('file', $scope.theFile);
    fd.append('id', $scope.uploadCostSheetID);
    var req = {
      method: 'POST',
      url: $scope.batchEndpoint + 'upload',
      data: fd,
      transformRequest: angular.identity,
      headers: {
        // eslint-disable-next-line no-undefined
        'Content-Type': undefined
      }
    };
    Utils.getHttpPromise(req).then(function (resp) {
      if (resp.errors.length === 0) {
        $scope.selectedBatch = {
          batch_id: resp.batch_id
        };
        $scope.activeTab = 5;
        $scope.localized.PushResponseMsg({
          type: 'success',
          message: 'File Successfully Uploaded'
        });
      }
    }, function (errResp) {
      Debug.log(errResp);
    })["finally"](function () {
      $scope.loading = false;
    });
  };
}

PurchasingCostSheetsController.$inject = ['$scope', '$timeout', '$state', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', '$window'];
;// CONCATENATED MODULE: ./assets/app/dev/admin/shared/SearchBox.tsx




var SearchBox = function SearchBox(_ref) {
  var handleSubmit = _ref.handleSubmit,
      isBusy = _ref.isBusy,
      q = _ref.q,
      setQ = _ref.setQ;
  return /*#__PURE__*/(0,jsx_runtime.jsx)("form", {
    onSubmit: handleSubmit,
    children: /*#__PURE__*/(0,jsx_runtime.jsx)("fieldset", {
      disabled: isBusy,
      children: /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
        className: "input-group mb-3",
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("input", {
          id: "search-input",
          name: "q",
          className: "form-control",
          type: "search",
          value: q,
          onChange: function onChange(event) {
            return setQ(event.target.value);
          }
        }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
          isBusy: isBusy,
          id: "search-submit",
          variant: "secondary",
          type: "submit",
          children: "Search"
        })]
      })
    })
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/shared/TableNav.tsx





var TableNav = function TableNav(props) {
  var currentPage = props.currentPage,
      isBusy = props.isBusy,
      lastPage = props.lastPage,
      setPage = props.setPage,
      total = props.total;
  return /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
    className: "hstack justify-content-end gap-1 mt-3",
    children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("small", {
      className: "me-2",
      children: [total, " item", total !== 1 ? 's' : '']
    }), lastPage > 1 && /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
      children: [/*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
        disabled: currentPage === 1,
        isBusy: isBusy,
        variant: "secondary",
        onClick: function onClick() {
          return setPage(1);
        },
        children: "\xAB First"
      }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
        disabled: currentPage === 1,
        isBusy: isBusy,
        variant: "secondary",
        onClick: function onClick() {
          return setPage(currentPage - 1);
        },
        children: "\u2039 Previous"
      }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
        disabled: currentPage === lastPage,
        isBusy: isBusy,
        variant: "secondary",
        onClick: function onClick() {
          return setPage(currentPage + 1);
        },
        children: "Next \u203A"
      }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
        disabled: currentPage === lastPage,
        isBusy: isBusy,
        variant: "secondary",
        onClick: function onClick() {
          return setPage(lastPage);
        },
        children: "Last \xBB"
      })]
    })]
  });
};
;// CONCATENATED MODULE: ./node_modules/@wordpress/icons/build-module/library/close-small.js


/**
 * WordPress dependencies
 */

const closeSmall = (0,react.createElement)(SVG, {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 24 24"
}, (0,react.createElement)(Path, {
  d: "M12 13.06l3.712 3.713 1.061-1.06L13.061 12l3.712-3.712-1.06-1.06L12 10.938 8.288 7.227l-1.061 1.06L10.939 12l-3.712 3.712 1.06 1.061L12 13.061z"
}));
/* harmony default export */ const close_small = (closeSmall);
//# sourceMappingURL=close-small.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/modal/aria-helper.js
// @ts-nocheck

/**
 * External dependencies
 */

const LIVE_REGION_ARIA_ROLES = new Set(['alert', 'status', 'log', 'marquee', 'timer']);
let hiddenElements = [],
    isHidden = false;
/**
 * Hides all elements in the body element from screen-readers except
 * the provided element and elements that should not be hidden from
 * screen-readers.
 *
 * The reason we do this is because `aria-modal="true"` currently is bugged
 * in Safari, and support is spotty in other browsers overall. In the future
 * we should consider removing these helper functions in favor of
 * `aria-modal="true"`.
 *
 * @param {Element} unhiddenElement The element that should not be hidden.
 */

function hideApp(unhiddenElement) {
  if (isHidden) {
    return;
  }

  const elements = document.body.children;
  (0,lodash.forEach)(elements, element => {
    if (element === unhiddenElement) {
      return;
    }

    if (elementShouldBeHidden(element)) {
      element.setAttribute('aria-hidden', 'true');
      hiddenElements.push(element);
    }
  });
  isHidden = true;
}
/**
 * Determines if the passed element should not be hidden from screen readers.
 *
 * @param {HTMLElement} element The element that should be checked.
 *
 * @return {boolean} Whether the element should not be hidden from screen-readers.
 */

function elementShouldBeHidden(element) {
  const role = element.getAttribute('role');
  return !(element.tagName === 'SCRIPT' || element.hasAttribute('aria-hidden') || element.hasAttribute('aria-live') || LIVE_REGION_ARIA_ROLES.has(role));
}
/**
 * Makes all elements in the body that have been hidden by `hideApp`
 * visible again to screen-readers.
 */

function showApp() {
  if (!isHidden) {
    return;
  }

  (0,lodash.forEach)(hiddenElements, element => {
    element.removeAttribute('aria-hidden');
  });
  hiddenElements = [];
  isHidden = false;
}
//# sourceMappingURL=aria-helper.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/modal/index.js


// @ts-nocheck

/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */






/**
 * Internal dependencies
 */



 // Used to count the number of open modals.

let openModalCount = 0;

function Modal(props, forwardedRef) {
  const {
    bodyOpenClassName = 'modal-open',
    role = 'dialog',
    title = null,
    focusOnMount = true,
    shouldCloseOnEsc = true,
    shouldCloseOnClickOutside = true,
    isDismissible = true,

    /* Accessibility. */
    aria = {
      labelledby: null,
      describedby: null
    },
    onRequestClose,
    icon,
    closeButtonLabel,
    children,
    style,
    overlayClassName,
    className,
    contentLabel,
    onKeyDown,
    isFullScreen = false,
    __experimentalHideHeader = false
  } = props;
  const ref = (0,react.useRef)();
  const instanceId = useInstanceId(Modal);
  const headingId = title ? `components-modal-header-${instanceId}` : aria.labelledby;
  const focusOnMountRef = useFocusOnMount(focusOnMount);
  const constrainedTabbingRef = use_constrained_tabbing();
  const focusReturnRef = use_focus_return();
  const focusOutsideProps = useFocusOutside(onRequestClose);
  (0,react.useEffect)(() => {
    openModalCount++;

    if (openModalCount === 1) {
      hideApp(ref.current);
      document.body.classList.add(bodyOpenClassName);
    }

    return () => {
      openModalCount--;

      if (openModalCount === 0) {
        document.body.classList.remove(bodyOpenClassName);
        showApp();
      }
    };
  }, [bodyOpenClassName]);

  function handleEscapeKeyDown(event) {
    if (shouldCloseOnEsc && event.keyCode === ESCAPE && !event.defaultPrevented) {
      event.preventDefault();

      if (onRequestClose) {
        onRequestClose(event);
      }
    }
  }

  return (0,react_dom.createPortal)( // eslint-disable-next-line jsx-a11y/no-static-element-interactions
  (0,react.createElement)("div", {
    ref: useMergeRefs([ref, forwardedRef]),
    className: classnames_default()('components-modal__screen-overlay', overlayClassName),
    onKeyDown: handleEscapeKeyDown
  }, (0,react.createElement)(StyleProvider, {
    document: document
  }, (0,react.createElement)("div", extends_extends({
    className: classnames_default()('components-modal__frame', className, {
      'is-full-screen': isFullScreen
    }),
    style: style,
    ref: useMergeRefs([constrainedTabbingRef, focusReturnRef, focusOnMountRef]),
    role: role,
    "aria-label": contentLabel,
    "aria-labelledby": contentLabel ? null : headingId,
    "aria-describedby": aria.describedby,
    tabIndex: "-1"
  }, shouldCloseOnClickOutside ? focusOutsideProps : {}, {
    onKeyDown: onKeyDown
  }), (0,react.createElement)("div", {
    className: classnames_default()('components-modal__content', {
      'hide-header': __experimentalHideHeader
    }),
    role: "document"
  }, !__experimentalHideHeader && (0,react.createElement)("div", {
    className: "components-modal__header"
  }, (0,react.createElement)("div", {
    className: "components-modal__header-heading-container"
  }, icon && (0,react.createElement)("span", {
    className: "components-modal__icon-container",
    "aria-hidden": true
  }, icon), title && (0,react.createElement)("h1", {
    id: headingId,
    className: "components-modal__header-heading"
  }, title)), isDismissible && (0,react.createElement)(build_module_button, {
    onClick: onRequestClose,
    icon: close_small,
    label: closeButtonLabel || __('Close dialog')
  })), children)))), document.body);
}

/* harmony default export */ const modal = ((0,react.forwardRef)(Modal));
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./assets/app/dev/admin/shared/ListTable.tsx
function ListTable_slicedToArray(arr, i) { return ListTable_arrayWithHoles(arr) || ListTable_iterableToArrayLimit(arr, i) || ListTable_unsupportedIterableToArray(arr, i) || ListTable_nonIterableRest(); }

function ListTable_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function ListTable_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return ListTable_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return ListTable_arrayLikeToArray(o, minLen); }

function ListTable_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ListTable_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function ListTable_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }







var getBadgeColor = function getBadgeColor(context, value) {
  return context[value] ? context[value] : 'secondary';
};

var ListTable = function ListTable(_ref) {
  var addItem = _ref.addItem,
      caption = _ref.caption,
      deleteItem = _ref.deleteItem,
      editItem = _ref.editItem,
      isBusy = _ref.isBusy,
      headers = _ref.headers,
      removeItem = _ref.removeItem,
      rows = _ref.rows,
      sortBy = _ref.sortBy,
      setSortBy = _ref.setSortBy,
      setSortType = _ref.setSortType,
      sortType = _ref.sortType,
      viewItem = _ref.viewItem;

  var _useState = (0,react.useState)(),
      _useState2 = ListTable_slicedToArray(_useState, 2),
      isConfirming = _useState2[0],
      setIsConfirming = _useState2[1];

  var _useState3 = (0,react.useState)(false),
      _useState4 = ListTable_slicedToArray(_useState3, 2),
      canAdd = _useState4[0],
      setCanAdd = _useState4[1];

  var _useState5 = (0,react.useState)(false),
      _useState6 = ListTable_slicedToArray(_useState5, 2),
      canDelete = _useState6[0],
      setCanDelete = _useState6[1];

  var _useState7 = (0,react.useState)(false),
      _useState8 = ListTable_slicedToArray(_useState7, 2),
      canEdit = _useState8[0],
      setCanEdit = _useState8[1];

  var _useState9 = (0,react.useState)(false),
      _useState10 = ListTable_slicedToArray(_useState9, 2),
      canRemove = _useState10[0],
      setCanRemove = _useState10[1];

  var _useState11 = (0,react.useState)(false),
      _useState12 = ListTable_slicedToArray(_useState11, 2),
      canView = _useState12[0],
      setCanView = _useState12[1];

  var cancelDelete = function cancelDelete() {
    setIsConfirming(null);
  };

  var confirmDelete = function confirmDelete(id) {
    setIsConfirming(null);
    deleteItem(id);
  };

  var clickSortBy = function clickSortBy(key) {
    if (sortBy === key) {
      var updatedSortType = sortType === 'desc' ? 'asc' : 'desc';
      setSortType(updatedSortType);
    }

    setSortBy(key);
  };

  var showConfirmDialog = function showConfirmDialog(id) {
    setIsConfirming(id);
  };

  (0,react.useEffect)(function () {
    if (addItem) {
      setCanAdd(true);
    }

    if (deleteItem) {
      setCanDelete(true);
    }

    if (editItem) {
      setCanEdit(true);
    }

    if (removeItem) {
      setCanRemove(true);
    }

    if (viewItem) {
      setCanView(true);
    }
  }, []);
  return /*#__PURE__*/(0,jsx_runtime.jsxs)("table", {
    className: "widefat striped",
    children: [caption && /*#__PURE__*/(0,jsx_runtime.jsx)("caption", {
      children: caption
    }), /*#__PURE__*/(0,jsx_runtime.jsx)("thead", {
      children: /*#__PURE__*/(0,jsx_runtime.jsxs)("tr", {
        children: [headers.map(function (header) {
          return /*#__PURE__*/(0,jsx_runtime.jsxs)("th", {
            className: "".concat(sortBy === header.key ? 'sorted' : 'sortable', " ").concat(setSortBy ? sortType : 'p-2'),
            children: [setSortBy && /*#__PURE__*/(0,jsx_runtime.jsxs)("button", {
              type: "button",
              onClick: function onClick() {
                return clickSortBy(header.key);
              },
              title: "Sort by ".concat(header.label),
              children: [/*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                children: header.label
              }), /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                className: "sorting-indicator"
              })]
            }), !setSortBy && /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
              children: header.label
            })]
          }, header.key);
        }), (canAdd || canDelete || canEdit || canRemove || canView) && /*#__PURE__*/(0,jsx_runtime.jsx)("th", {
          className: "text-end",
          children: "Actions"
        })]
      })
    }), /*#__PURE__*/(0,jsx_runtime.jsxs)("tbody", {
      children: [!rows.length && /*#__PURE__*/(0,jsx_runtime.jsx)("tr", {
        children: /*#__PURE__*/(0,jsx_runtime.jsx)("td", {
          colSpan: headers.length + (canAdd || canDelete || canEdit || canRemove || canView ? 1 : 0),
          children: "No items found."
        })
      }), rows.map(function (row, index) {
        return /*#__PURE__*/(0,jsx_runtime.jsxs)("tr", {
          children: [headers.map(function (header, i) {
            return /*#__PURE__*/(0,jsx_runtime.jsx)("td", {
              className: "placeholder-glow",
              children: /*#__PURE__*/(0,jsx_runtime.jsxs)("span", {
                className: isBusy ? 'placeholder placeholder-sm align-baseline' : '',
                children: [i === 1 && /*#__PURE__*/(0,jsx_runtime.jsx)(jsx_runtime.Fragment, {
                  children: canEdit || canView ? /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                    type: "button",
                    variant: "link",
                    className: "row-title",
                    title: "".concat(canEdit ? 'Edit' : 'View', " ").concat(row[header.key]),
                    onClick: function onClick() {
                      if (canEdit) {
                        editItem(row.id);
                      } else {
                        viewItem(row.id);
                      }
                    },
                    children: row[header.key]
                  }) : /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                    className: "row-title",
                    children: row[header.key]
                  })
                }), i !== 1 && /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
                  children: [header.type === 'array' && row[header.key] && row[header.key].map(function (item, i) {
                    return /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                      className: "badge text-dark bg-light",
                      children: item
                    }, i);
                  }), header.type === 'badge' && /*#__PURE__*/(0,jsx_runtime.jsx)("span", {
                    className: "badge text-capitalize bg-".concat(getBadgeColor(header.context, row[header.key])),
                    children: row[header.key]
                  }), header.type === 'boolean' && row[header.key] && /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_icon, {
                    icon: "yes"
                  }), header.type === 'date' && new Date(row[header.key]).toLocaleDateString(), header.type !== 'array' && header.type !== 'badge' && header.type !== 'boolean' && header.type !== 'date' && row[header.key]]
                })]
              })
            }, header.key);
          }), (canAdd || canDelete || canEdit || canRemove || canView) && /*#__PURE__*/(0,jsx_runtime.jsxs)("td", {
            className: "text-end",
            children: [canAdd && /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
              isSmall: true,
              icon: "insert",
              label: "Add item",
              onClick: function onClick() {
                return addItem(row.id);
              }
            }), (canEdit || canView) && /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
              isSmall: true,
              icon: canEdit ? 'edit' : 'visibility',
              label: canEdit ? 'Edit' : 'View',
              onClick: function onClick() {
                if (canEdit) {
                  editItem(row.id);
                } else {
                  viewItem(row.id);
                }
              }
            }), canDelete && /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
              isSmall: true,
              icon: "trash",
              label: "Delete",
              onClick: function onClick() {
                return showConfirmDialog(row.id);
              }
            }), canRemove && /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
              isSmall: true,
              icon: "remove",
              label: "Remove attached item",
              onClick: function onClick() {
                return removeItem(row.id);
              }
            }), isConfirming === row.id && /*#__PURE__*/(0,jsx_runtime.jsxs)(modal, {
              title: "Delete this item?",
              onRequestClose: cancelDelete,
              children: [/*#__PURE__*/(0,jsx_runtime.jsx)("p", {
                children: "This will delete this item."
              }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
                className: "hstack gap-1 justify-content-end",
                children: [/*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                  variant: "secondary",
                  onClick: cancelDelete,
                  children: "Cancel"
                }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                  variant: "primary",
                  isDestructive: true,
                  onClick: function onClick() {
                    return confirmDelete(row.id);
                  },
                  children: "Delete"
                })]
              })]
            })]
          })]
        }, index);
      })]
    })]
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/document-profiles/DocumentProfiles.tsx
function DocumentProfiles_slicedToArray(arr, i) { return DocumentProfiles_arrayWithHoles(arr) || DocumentProfiles_iterableToArrayLimit(arr, i) || DocumentProfiles_unsupportedIterableToArray(arr, i) || DocumentProfiles_nonIterableRest(); }

function DocumentProfiles_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function DocumentProfiles_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return DocumentProfiles_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return DocumentProfiles_arrayLikeToArray(o, minLen); }

function DocumentProfiles_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function DocumentProfiles_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function DocumentProfiles_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }











var DocumentProfiles_apiUrl = '/purchasing/document-profile/';
var headers = [{
  key: 'id',
  label: 'ID'
}, {
  key: 'name',
  label: 'Name'
}, {
  key: 'doc_format',
  label: 'Format'
}];
var DocumentProfiles = function DocumentProfiles() {
  var _useState = (0,react.useState)(false),
      _useState2 = DocumentProfiles_slicedToArray(_useState, 2),
      isBusy = _useState2[0],
      setIsBusy = _useState2[1];

  var _useState3 = (0,react.useState)([]),
      _useState4 = DocumentProfiles_slicedToArray(_useState3, 2),
      notices = _useState4[0],
      setNotices = _useState4[1];

  var _useState5 = (0,react.useState)(1),
      _useState6 = DocumentProfiles_slicedToArray(_useState5, 2),
      page = _useState6[0],
      setPage = _useState6[1];

  var _useState7 = (0,react.useState)(''),
      _useState8 = DocumentProfiles_slicedToArray(_useState7, 2),
      q = _useState8[0],
      setQ = _useState8[1];

  var _useState9 = (0,react.useState)(),
      _useState10 = DocumentProfiles_slicedToArray(_useState9, 2),
      profiles = _useState10[0],
      setProfiles = _useState10[1];

  var _useState11 = (0,react.useState)('id'),
      _useState12 = DocumentProfiles_slicedToArray(_useState11, 2),
      sortBy = _useState12[0],
      setSortBy = _useState12[1];

  var _useState13 = (0,react.useState)('asc'),
      _useState14 = DocumentProfiles_slicedToArray(_useState13, 2),
      sortType = _useState14[0],
      setSortType = _useState14[1];

  var deleteProfile = function deleteProfile(id) {
    setIsBusy(true);
    vfAPI["delete"]("".concat(DocumentProfiles_apiUrl).concat(id)).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        getProfiles();
      }
    });
  };

  var editProfile = function editProfile(id) {
    var url = "".concat(location.href, "/").concat(id);
    location.assign(url);
  };

  var getProfiles = function getProfiles() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    setIsBusy(true);
    var config = {
      params: params
    };
    vfAPI.get(DocumentProfiles_apiUrl, config).then(function (response) {
      setProfiles(response.data.document_profiles);
      setIsBusy(false);
    });
  };

  var handleSubmit = function handleSubmit(e) {
    e.preventDefault();
    var params = {
      page: 1,
      q: q,
      sortBy: sortBy,
      sortType: sortType
    };
    getProfiles(params);
  };

  (0,react.useEffect)(function () {
    var params = {
      page: page,
      q: q,
      sortBy: sortBy,
      sortType: sortType
    };
    getProfiles(params);
  }, [page, sortBy, sortType]);
  return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
    children: [/*#__PURE__*/(0,jsx_runtime.jsx)(Notices, {
      notices: notices
    }), /*#__PURE__*/(0,jsx_runtime.jsx)(SearchBox, {
      isBusy: isBusy,
      handleSubmit: handleSubmit,
      q: q,
      setQ: setQ
    }), !profiles && /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
      className: "hstack justify-content-center",
      children: /*#__PURE__*/(0,jsx_runtime.jsx)(Spinner, {})
    }), profiles && /*#__PURE__*/(0,jsx_runtime.jsx)(ListTable, {
      deleteItem: deleteProfile,
      editItem: editProfile,
      headers: headers,
      isBusy: isBusy,
      rows: profiles.data,
      sortBy: sortBy,
      setSortBy: setSortBy,
      sortType: sortType,
      setSortType: setSortType
    }), profiles && /*#__PURE__*/(0,jsx_runtime.jsx)(TableNav, {
      isBusy: isBusy,
      currentPage: profiles.current_page,
      setPage: setPage,
      lastPage: profiles.last_page,
      total: profiles.total
    })]
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/document-profiles/DocumentProfilesPage.tsx
function DocumentProfilesPage_typeof(obj) { "@babel/helpers - typeof"; return DocumentProfilesPage_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, DocumentProfilesPage_typeof(obj); }

function DocumentProfilesPage_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function DocumentProfilesPage_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function DocumentProfilesPage_createClass(Constructor, protoProps, staticProps) { if (protoProps) DocumentProfilesPage_defineProperties(Constructor.prototype, protoProps); if (staticProps) DocumentProfilesPage_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function DocumentProfilesPage_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) DocumentProfilesPage_setPrototypeOf(subClass, superClass); }

function DocumentProfilesPage_setPrototypeOf(o, p) { DocumentProfilesPage_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return DocumentProfilesPage_setPrototypeOf(o, p); }

function DocumentProfilesPage_createSuper(Derived) { var hasNativeReflectConstruct = DocumentProfilesPage_isNativeReflectConstruct(); return function _createSuperInternal() { var Super = DocumentProfilesPage_getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = DocumentProfilesPage_getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return DocumentProfilesPage_possibleConstructorReturn(this, result); }; }

function DocumentProfilesPage_possibleConstructorReturn(self, call) { if (call && (DocumentProfilesPage_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return DocumentProfilesPage_assertThisInitialized(self); }

function DocumentProfilesPage_assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function DocumentProfilesPage_isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function DocumentProfilesPage_getPrototypeOf(o) { DocumentProfilesPage_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return DocumentProfilesPage_getPrototypeOf(o); }

function DocumentProfilesPage_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }








var DocumentProfilesPage = /*#__PURE__*/function (_React$Component) {
  DocumentProfilesPage_inherits(DocumentProfilesPage, _React$Component);

  var _super = DocumentProfilesPage_createSuper(DocumentProfilesPage);

  function DocumentProfilesPage() {
    var _this;

    DocumentProfilesPage_classCallCheck(this, DocumentProfilesPage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    DocumentProfilesPage_defineProperty(DocumentProfilesPage_assertThisInitialized(_this), "state", {
      breadcrumbs: [{
        name: 'Purchasing',
        hash: '#!/purchasing'
      }, {
        name: 'Document Profiles',
        hash: '#!/purchasing/document-profiles'
      }]
    });

    return _this;
  }

  DocumentProfilesPage_createClass(DocumentProfilesPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)(Breadcrumb, {
          breadcrumbs: this.state.breadcrumbs
        }), /*#__PURE__*/(0,jsx_runtime.jsxs)("h2", {
          children: ["Document Profiles ", /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
            variant: "secondary",
            href: "#!/purchasing/document-profiles/new",
            children: "Add New"
          })]
        }), /*#__PURE__*/(0,jsx_runtime.jsx)(DocumentProfiles, {})]
      });
    }
  }]);

  return DocumentProfilesPage;
}(react.Component);
;// CONCATENATED MODULE: ./node_modules/@wordpress/icons/build-module/icon/index.js
/**
 * WordPress dependencies
 */

/** @typedef {{icon: JSX.Element, size?: number} & import('@wordpress/primitives').SVGProps} IconProps */

/**
 * Return an SVG icon.
 *
 * @param {IconProps} props icon is the SVG component to render
 *                          size is a number specifiying the icon size in pixels
 *                          Other props will be passed to wrapped SVG component
 *
 * @return {JSX.Element}  Icon component
 */

function icon_Icon(_ref) {
  let {
    icon,
    size = 24,
    ...props
  } = _ref;
  return (0,react.cloneElement)(icon, {
    width: size,
    height: size,
    ...props
  });
}

/* harmony default export */ const icon = (icon_Icon);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/icons/build-module/library/chevron-down.js


/**
 * WordPress dependencies
 */

const chevronDown = (0,react.createElement)(SVG, {
  viewBox: "0 0 24 24",
  xmlns: "http://www.w3.org/2000/svg"
}, (0,react.createElement)(Path, {
  d: "M17.5 11.6L12 16l-5.5-4.4.9-1.2L12 14l4.5-3.6 1 1.2z"
}));
/* harmony default export */ const chevron_down = (chevronDown);
//# sourceMappingURL=chevron-down.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/flex/flex-item/hook.js
/**
 * External dependencies
 */

/**
 * Internal dependencies
 */





/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FlexItemProps, 'div'>} props
 */

function useFlexItem(props) {
  const {
    className,
    display: displayProp,
    isBlock = false,
    ...otherProps
  } = useContextSystem(props, 'FlexItem');
  const sx = {};
  const contextDisplay = useFlexContext().flexItemDisplay;
  sx.Base = /*#__PURE__*/css({
    display: displayProp || contextDisplay
  },  true ? "" : 0,  true ? "" : 0);
  const cx = useCx();
  const classes = cx(Item, sx.Base, isBlock && block, className);
  return { ...otherProps,
    className: classes
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/flex/flex-item/component.js



/**
 * Internal dependencies
 */



/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FlexItemProps, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                                           forwardedRef
 */

function FlexItem(props, forwardedRef) {
  const flexItemProps = useFlexItem(props);
  return (0,react.createElement)(component, extends_extends({}, flexItemProps, {
    ref: forwardedRef
  }));
}
/**
 * `FlexItem` is a primitive layout component that aligns content within layout containers like `Flex`.
 *
 * @example
 * ```jsx
 * <Flex>
 * 	<FlexItem>...</FlexItem>
 * </Flex>
 * ```
 */


const ConnectedFlexItem = contextConnect(FlexItem, 'FlexItem');
/* harmony default export */ const flex_item_component = (ConnectedFlexItem);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/truncate/styles.js
function truncate_styles_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */

const Truncate =  true ? {
  name: "hdknak",
  styles: "display:block;overflow:hidden;text-overflow:ellipsis;white-space:nowrap"
} : 0;
//# sourceMappingURL=styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/truncate/utils.js
/**
 * External dependencies
 */

const TRUNCATE_ELLIPSIS = '…';
const TRUNCATE_TYPE = {
  auto: 'auto',
  head: 'head',
  middle: 'middle',
  tail: 'tail',
  none: 'none'
};
const TRUNCATE_DEFAULT_PROPS = {
  ellipsis: TRUNCATE_ELLIPSIS,
  ellipsizeMode: TRUNCATE_TYPE.auto,
  limit: 0,
  numberOfLines: 0
}; // Source
// https://github.com/kahwee/truncate-middle

/**
 * @param {string} word
 * @param {number} headLength
 * @param {number} tailLength
 * @param {string} ellipsis
 */

function truncateMiddle(word, headLength, tailLength, ellipsis) {
  if (typeof word !== 'string') {
    return '';
  }

  const wordLength = word.length; // Setting default values
  // eslint-disable-next-line no-bitwise

  const frontLength = ~~headLength; // Will cast to integer
  // eslint-disable-next-line no-bitwise

  const backLength = ~~tailLength;
  /* istanbul ignore next */

  const truncateStr = !(0,lodash.isNil)(ellipsis) ? ellipsis : TRUNCATE_ELLIPSIS;

  if (frontLength === 0 && backLength === 0 || frontLength >= wordLength || backLength >= wordLength || frontLength + backLength >= wordLength) {
    return word;
  } else if (backLength === 0) {
    return word.slice(0, frontLength) + truncateStr;
  }

  return word.slice(0, frontLength) + truncateStr + word.slice(wordLength - backLength);
}
/**
 *
 * @param {string}                        words
 * @param {typeof TRUNCATE_DEFAULT_PROPS} props
 */

function truncateContent() {
  let words = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  let props = arguments.length > 1 ? arguments[1] : undefined;
  const mergedProps = { ...TRUNCATE_DEFAULT_PROPS,
    ...props
  };
  const {
    ellipsis,
    ellipsizeMode,
    limit
  } = mergedProps;

  if (ellipsizeMode === TRUNCATE_TYPE.none) {
    return words;
  }

  let truncateHead;
  let truncateTail;

  switch (ellipsizeMode) {
    case TRUNCATE_TYPE.head:
      truncateHead = 0;
      truncateTail = limit;
      break;

    case TRUNCATE_TYPE.middle:
      truncateHead = Math.floor(limit / 2);
      truncateTail = Math.floor(limit / 2);
      break;

    default:
      truncateHead = limit;
      truncateTail = 0;
  }

  const truncatedContent = ellipsizeMode !== TRUNCATE_TYPE.auto ? truncateMiddle(words, truncateHead, truncateTail, ellipsis) : words;
  return truncatedContent;
}
//# sourceMappingURL=utils.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/truncate/hook.js
/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */





/**
 * @param {import('../ui/context').WordPressComponentProps<import('./types').Props, 'span'>} props
 */

function useTruncate(props) {
  const {
    className,
    children,
    ellipsis = TRUNCATE_ELLIPSIS,
    ellipsizeMode = TRUNCATE_TYPE.auto,
    limit = 0,
    numberOfLines = 0,
    ...otherProps
  } = useContextSystem(props, 'Truncate');
  const cx = useCx();
  const truncatedContent = truncateContent(typeof children === 'string' ?
  /** @type {string} */
  children : '', {
    ellipsis,
    ellipsizeMode,
    limit,
    numberOfLines
  });
  const shouldTruncate = ellipsizeMode === TRUNCATE_TYPE.auto;
  const classes = (0,react.useMemo)(() => {
    const sx = {};
    sx.numberOfLines = /*#__PURE__*/css("-webkit-box-orient:vertical;-webkit-line-clamp:", numberOfLines, ";display:-webkit-box;overflow:hidden;" + ( true ? "" : 0),  true ? "" : 0);
    return cx(shouldTruncate && !numberOfLines && Truncate, shouldTruncate && !!numberOfLines && sx.numberOfLines, className);
  }, [className, cx, numberOfLines, shouldTruncate]);
  return { ...otherProps,
    className: classes,
    children: truncatedContent
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/utils/colors.js
/**
 * External dependencies
 */



/** @type {HTMLDivElement} */

let colorComputationNode;
k([names]);
/**
 * @return {HTMLDivElement | undefined} The HTML element for color computation.
 */

function getColorComputationNode() {
  if (typeof document === 'undefined') return;

  if (!colorComputationNode) {
    // Create a temporary element for style computation.
    const el = document.createElement('div');
    el.setAttribute('data-g2-color-computation-node', ''); // Inject for window computed style.

    document.body.appendChild(el);
    colorComputationNode = el;
  }

  return colorComputationNode;
}
/**
 * @param {string | unknown} value
 *
 * @return {boolean} Whether the value is a valid color.
 */


function isColor(value) {
  if (typeof value !== 'string') return false;
  const test = w(value);
  return test.isValid();
}
/**
 * Retrieves the computed background color. This is useful for getting the
 * value of a CSS variable color.
 *
 * @param {string | unknown} backgroundColor The background color to compute.
 *
 * @return {string} The computed background color.
 */


function _getComputedBackgroundColor(backgroundColor) {
  var _window;

  if (typeof backgroundColor !== 'string') return '';
  if (isColor(backgroundColor)) return backgroundColor;
  if (!backgroundColor.includes('var(')) return '';
  if (typeof document === 'undefined') return ''; // Attempts to gracefully handle CSS variables color values.

  const el = getColorComputationNode();
  if (!el) return '';
  el.style.background = backgroundColor; // Grab the style.

  const computedColor = (_window = window) === null || _window === void 0 ? void 0 : _window.getComputedStyle(el).background; // Reset.

  el.style.background = '';
  return computedColor || '';
}

const getComputedBackgroundColor = memize_default()(_getComputedBackgroundColor);
/**
 * Get the text shade optimized for readability, based on a background color.
 *
 * @param {string | unknown} backgroundColor The background color.
 *
 * @return {string} The optimized text color (black or white).
 */

function getOptimalTextColor(backgroundColor) {
  const background = getComputedBackgroundColor(backgroundColor);
  return w(background).isLight() ? '#000000' : '#ffffff';
}
/**
 * Get the text shade optimized for readability, based on a background color.
 *
 * @param {string | unknown} backgroundColor The background color.
 *
 * @return {string} The optimized text shade (dark or light).
 */

function getOptimalTextShade(backgroundColor) {
  const result = getOptimalTextColor(backgroundColor);
  return result === '#000000' ? 'dark' : 'light';
}
//# sourceMappingURL=colors.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/text/styles.js
function text_styles_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


const Text = /*#__PURE__*/css("color:", COLORS.gray[900], ";line-height:", config_values.fontLineHeightBase, ";margin:0;" + ( true ? "" : 0),  true ? "" : 0);
const styles_block =  true ? {
  name: "4zleql",
  styles: "display:block"
} : 0;
const positive = /*#__PURE__*/css("color:", COLORS.alert.green, ";" + ( true ? "" : 0),  true ? "" : 0);
const destructive = /*#__PURE__*/css("color:", COLORS.alert.red, ";" + ( true ? "" : 0),  true ? "" : 0);
const muted = /*#__PURE__*/css("color:", COLORS.mediumGray.text, ";" + ( true ? "" : 0),  true ? "" : 0);
const highlighterText = /*#__PURE__*/css("mark{background:", COLORS.alert.yellow, ";border-radius:2px;box-shadow:0 0 0 1px rgba( 0, 0, 0, 0.05 ) inset,0 -1px 0 rgba( 0, 0, 0, 0.1 ) inset;}" + ( true ? "" : 0),  true ? "" : 0);
const upperCase =  true ? {
  name: "50zrmy",
  styles: "text-transform:uppercase"
} : 0;
//# sourceMappingURL=styles.js.map
// EXTERNAL MODULE: ./node_modules/highlight-words-core/dist/index.js
var dist = __webpack_require__(6928);
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/text/utils.js
/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */


/**
 * Source:
 * https://github.com/bvaughn/react-highlight-words/blob/HEAD/src/Highlighter.js
 */

/* eslint-disable jsdoc/valid-types */

/**
 * @typedef Options
 * @property {string}                                                     [activeClassName='']      Classname for active highlighted areas.
 * @property {number}                                                     [activeIndex=-1]          The index of the active highlighted area.
 * @property {import('react').AllHTMLAttributes<HTMLDivElement>['style']} [activeStyle]             Styles to apply to the active highlighted area.
 * @property {boolean}                                                    [autoEscape]              Whether to automatically escape text.
 * @property {boolean}                                                    [caseSensitive=false]     Whether to highlight in a case-sensitive manner.
 * @property {string}                                                     children                  Children to highlight.
 * @property {import('highlight-words-core').FindAllArgs['findChunks']}   [findChunks]              Custom `findChunks` function to pass to `highlight-words-core`.
 * @property {string | Record<string, unknown>}                           [highlightClassName='']   Classname to apply to highlighted text or a Record of classnames to apply to given text (which should be the key).
 * @property {import('react').AllHTMLAttributes<HTMLDivElement>['style']} [highlightStyle={}]       Styles to apply to highlighted text.
 * @property {keyof JSX.IntrinsicElements}                                [highlightTag='mark']     Tag to use for the highlighted text.
 * @property {import('highlight-words-core').FindAllArgs['sanitize']}     [sanitize]                Custom `santize` function to pass to `highlight-words-core`.
 * @property {string[]}                                                   [searchWords=[]]          Words to search for and highlight.
 * @property {string}                                                     [unhighlightClassName=''] Classname to apply to unhighlighted text.
 * @property {import('react').AllHTMLAttributes<HTMLDivElement>['style']} [unhighlightStyle]        Style to apply to unhighlighted text.
 */

/**
 * Maps props to lowercase names.
 *
 * @template {Record<string, unknown>} T
 * @param {T} object Props to map.
 * @return {{[K in keyof T as Lowercase<string & K>]: T[K]}} The mapped props.
 */

/* eslint-enable jsdoc/valid-types */

const lowercaseProps = object => {
  /** @type {any} */
  const mapped = {};

  for (const key in object) {
    mapped[key.toLowerCase()] = object[key];
  }

  return mapped;
};

const memoizedLowercaseProps = memize_default()(lowercaseProps);
/**
 *
 * @param {Options} options
 */

function createHighlighterText(_ref) {
  let {
    activeClassName = '',
    activeIndex = -1,
    activeStyle,
    autoEscape,
    caseSensitive = false,
    children,
    findChunks,
    highlightClassName = '',
    highlightStyle = {},
    highlightTag = 'mark',
    sanitize,
    searchWords = [],
    unhighlightClassName = '',
    unhighlightStyle
  } = _ref;
  if (!children) return null;
  if (typeof children !== 'string') return children;
  const textToHighlight = children;
  const chunks = (0,dist.findAll)({
    autoEscape,
    caseSensitive,
    findChunks,
    sanitize,
    searchWords,
    textToHighlight
  });
  const HighlightTag = highlightTag;
  let highlightIndex = -1;
  let highlightClassNames = '';
  let highlightStyles;
  const textContent = chunks.map((chunk, index) => {
    const text = textToHighlight.substr(chunk.start, chunk.end - chunk.start);

    if (chunk.highlight) {
      highlightIndex++;
      let highlightClass;

      if (typeof highlightClassName === 'object') {
        if (!caseSensitive) {
          highlightClassName = memoizedLowercaseProps(highlightClassName);
          highlightClass = highlightClassName[text.toLowerCase()];
        } else {
          highlightClass = highlightClassName[text];
        }
      } else {
        highlightClass = highlightClassName;
      }

      const isActive = highlightIndex === +activeIndex;
      highlightClassNames = `${highlightClass} ${isActive ? activeClassName : ''}`;
      highlightStyles = isActive === true && activeStyle !== null ? Object.assign({}, highlightStyle, activeStyle) : highlightStyle;
      /** @type {Record<string, any>} */

      const props = {
        children: text,
        className: highlightClassNames,
        key: index,
        style: highlightStyles
      }; // Don't attach arbitrary props to DOM elements; this triggers React DEV warnings (https://fb.me/react-unknown-prop)
      // Only pass through the highlightIndex attribute for custom components.

      if (typeof HighlightTag !== 'string') {
        props.highlightIndex = highlightIndex;
      }

      return (0,react.createElement)(HighlightTag, props);
    }

    return (0,react.createElement)('span', {
      children: text,
      className: unhighlightClassName,
      key: index,
      style: unhighlightStyle
    });
  });
  return textContent;
}
//# sourceMappingURL=utils.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/ui/utils/font-size.js
/**
 * External dependencies
 */

/**
 * Internal dependencies
 */

const BASE_FONT_SIZE = 13;
const PRESET_FONT_SIZES = {
  body: BASE_FONT_SIZE,
  caption: 10,
  footnote: 11,
  largeTitle: 28,
  subheadline: 12,
  title: 20
};
const HEADING_FONT_SIZES = [1, 2, 3, 4, 5, 6].flatMap(n => [n, n.toString()]);
function getFontSize() {
  let size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : BASE_FONT_SIZE;

  if (size in PRESET_FONT_SIZES) {
    return getFontSize(PRESET_FONT_SIZES[size]);
  }

  if (typeof size !== 'number') {
    const parsed = parseFloat(size);
    if (Number.isNaN(parsed)) return size;
    size = parsed;
  }

  const ratio = `(${size} / ${BASE_FONT_SIZE})`;
  return `calc(${ratio} * ${config_values.fontSize})`;
}
function getHeadingFontSize() {
  let size = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 3;

  if (!HEADING_FONT_SIZES.includes(size)) {
    return getFontSize(size);
  }

  const headingSize = `fontSizeH${size}`;
  return CONFIG[headingSize];
}
//# sourceMappingURL=font-size.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/text/get-line-height.js
/**
 * External dependencies
 */

/**
 * Internal dependencies
 */


function getLineHeight(adjustLineHeightForInnerControls, lineHeight) {
  if (lineHeight) return lineHeight;
  if (!adjustLineHeightForInnerControls) return;
  let value = `calc(${config_values.controlHeight} + ${space(2)})`;

  switch (adjustLineHeightForInnerControls) {
    case 'large':
      value = `calc(${config_values.controlHeightLarge} + ${space(2)})`;
      break;

    case 'small':
      value = `calc(${config_values.controlHeightSmall} + ${space(2)})`;
      break;

    case 'xSmall':
      value = `calc(${config_values.controlHeightXSmall} + ${space(2)})`;
      break;

    default:
      break;
  }

  return value;
}
//# sourceMappingURL=get-line-height.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/text/hook.js
function hook_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */










/**
 * @param {import('../ui/context').WordPressComponentProps<import('./types').Props, 'span'>} props
 */

var hook_ref =  true ? {
  name: "50zrmy",
  styles: "text-transform:uppercase"
} : 0;

function useText(props) {
  const {
    adjustLineHeightForInnerControls,
    align,
    children,
    className,
    color,
    ellipsizeMode,
    isDestructive = false,
    display,
    highlightEscape = false,
    highlightCaseSensitive = false,
    highlightWords,
    highlightSanitize,
    isBlock = false,
    letterSpacing,
    lineHeight: lineHeightProp,
    optimizeReadabilityFor,
    size,
    truncate = false,
    upperCase = false,
    variant,
    weight = config_values.fontWeight,
    ...otherProps
  } = useContextSystem(props, 'Text');
  /** @type {import('react').ReactNode} */

  let content = children;
  const isHighlighter = Array.isArray(highlightWords);
  const isCaption = size === 'caption';

  if (isHighlighter) {
    if (typeof children !== 'string') {
      throw new TypeError('`children` of `Text` must only be `string` types when `highlightWords` is defined');
    }

    content = createHighlighterText({
      autoEscape: highlightEscape,
      // Disable reason: We need to disable this otherwise it erases the cast
      // eslint-disable-next-line object-shorthand
      children:
      /** @type {string} */
      children,
      caseSensitive: highlightCaseSensitive,
      searchWords: highlightWords,
      sanitize: highlightSanitize
    });
  }

  const cx = useCx();
  const classes = (0,react.useMemo)(() => {
    const sx = {};
    const lineHeight = getLineHeight(adjustLineHeightForInnerControls, lineHeightProp);
    sx.Base = /*#__PURE__*/css({
      color,
      display,
      fontSize: getFontSize(size),

      /* eslint-disable jsdoc/valid-types */
      fontWeight:
      /** @type {import('react').CSSProperties['fontWeight']} */
      weight,

      /* eslint-enable jsdoc/valid-types */
      lineHeight,
      letterSpacing,
      textAlign: align
    },  true ? "" : 0,  true ? "" : 0);
    sx.upperCase = hook_ref;
    sx.optimalTextColor = null;

    if (optimizeReadabilityFor) {
      const isOptimalTextColorDark = getOptimalTextShade(optimizeReadabilityFor) === 'dark';
      sx.optimalTextColor = isOptimalTextColorDark ? /*#__PURE__*/css({
        color: COLORS.gray[900]
      },  true ? "" : 0,  true ? "" : 0) : /*#__PURE__*/css({
        color: COLORS.white
      },  true ? "" : 0,  true ? "" : 0);
    }

    return cx(Text, sx.Base, sx.optimalTextColor, isDestructive && destructive, !!isHighlighter && highlighterText, isBlock && styles_block, isCaption && muted, variant && text_styles_namespaceObject[variant], upperCase && sx.upperCase, className);
  }, [adjustLineHeightForInnerControls, align, className, color, cx, display, isBlock, isCaption, isDestructive, isHighlighter, letterSpacing, lineHeightProp, optimizeReadabilityFor, size, upperCase, variant, weight]);
  /** @type {undefined | 'auto' | 'none'} */

  let finalEllipsizeMode;

  if (truncate === true) {
    finalEllipsizeMode = 'auto';
  }

  if (truncate === false) {
    finalEllipsizeMode = 'none';
  }

  const finalComponentProps = { ...otherProps,
    className: classes,
    children,
    ellipsizeMode: ellipsizeMode || finalEllipsizeMode
  };
  const truncateProps = useTruncate(finalComponentProps);
  /**
   * Enhance child `<Link />` components to inherit font size.
   */

  if (!truncate && Array.isArray(children)) {
    content = react.Children.map(children, child => {
      // @ts-ignore
      if (!(0,lodash.isPlainObject)(child) || !('props' in child)) {
        return child;
      }

      const isLink = hasConnectNamespace(child, ['Link']);

      if (isLink) {
        return (0,react.cloneElement)(child, {
          size: child.props.size || 'inherit'
        });
      }

      return child;
    });
  }

  return { ...truncateProps,
    children: truncate ? truncateProps.children : content
  };
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/text/component.js



/**
 * Internal dependencies
 */



/**
 * @param {import('../ui/context').WordPressComponentProps<import('./types').Props, 'span'>} props
 * @param {import('react').ForwardedRef<any>}                                                forwardedRef
 */

function component_Text(props, forwardedRef) {
  const textProps = useText(props);
  return (0,react.createElement)(component, extends_extends({
    as: "span"
  }, textProps, {
    ref: forwardedRef
  }));
}
/**
 * `Text` is a core component that renders text in the library, using the
 * library's typography system.
 *
 * `Text` can be used to render any text-content, like an HTML `p` or `span`.
 *
 * @example
 *
 * ```jsx
 * import { __experimentalText as Text } from `@wordpress/components`;
 *
 * function Example() {
 * 	return <Text>Code is Poetry</Text>;
 * }
 * ```
 */


const ConnectedText = contextConnect(component_Text, 'Text');
/* harmony default export */ const text_component = (ConnectedText);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/input-control/styles/input-control-styles.js




function input_control_styles_EMOTION_STRINGIFIED_CSS_ERROR_() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

/**
 * External dependencies
 */





var _ref6 =  true ? {
  name: "1739oy8",
  styles: "z-index:1"
} : 0;

const rootFocusedStyles = _ref7 => {
  let {
    isFocused
  } = _ref7;
  if (!isFocused) return '';
  return _ref6;
};

var _ref3 =  true ? {
  name: "2o6p8u",
  styles: "justify-content:space-between"
} : 0;

var _ref4 =  true ? {
  name: "14qk3ip",
  styles: "align-items:flex-start;flex-direction:column-reverse"
} : 0;

var _ref5 =  true ? {
  name: "hbng6e",
  styles: "align-items:flex-start;flex-direction:column"
} : 0;

const rootLabelPositionStyles = _ref8 => {
  let {
    labelPosition
  } = _ref8;

  switch (labelPosition) {
    case 'top':
      return _ref5;

    case 'bottom':
      return _ref4;

    case 'edge':
      return _ref3;

    default:
      return '';
  }
};

const Root = /*#__PURE__*/emotion_styled_base_browser_esm(flex_component,  true ? {
  target: "em5sgkm7"
} : 0)("position:relative;border-radius:2px;padding-top:0;", rootFocusedStyles, " ", rootLabelPositionStyles, ";" + ( true ? "" : 0));

const containerDisabledStyles = _ref9 => {
  let {
    disabled
  } = _ref9;
  const backgroundColor = disabled ? COLORS.ui.backgroundDisabled : COLORS.ui.background;
  return /*#__PURE__*/css({
    backgroundColor
  },  true ? "" : 0,  true ? "" : 0);
}; // Normalizes the margins from the <Flex /> (components/ui/flex/) container.


var _ref2 =  true ? {
  name: "wyxldh",
  styles: "margin:0 !important"
} : 0;

const containerMarginStyles = _ref10 => {
  let {
    hideLabel
  } = _ref10;
  return hideLabel ? _ref2 : null;
};

var input_control_styles_ref =  true ? {
  name: "1d3w5wq",
  styles: "width:100%"
} : 0;

const containerWidthStyles = _ref11 => {
  let {
    __unstableInputWidth,
    labelPosition
  } = _ref11;
  if (!__unstableInputWidth) return input_control_styles_ref;
  if (labelPosition === 'side') return '';

  if (labelPosition === 'edge') {
    return /*#__PURE__*/css({
      flex: `0 0 ${__unstableInputWidth}`
    },  true ? "" : 0,  true ? "" : 0);
  }

  return /*#__PURE__*/css({
    width: __unstableInputWidth
  },  true ? "" : 0,  true ? "" : 0);
};

const Container = emotion_styled_base_browser_esm("div",  true ? {
  target: "em5sgkm6"
} : 0)("align-items:center;box-sizing:border-box;border-radius:inherit;display:flex;flex:1;position:relative;", containerDisabledStyles, " ", containerMarginStyles, " ", containerWidthStyles, ";" + ( true ? "" : 0));

const disabledStyles = _ref12 => {
  let {
    disabled
  } = _ref12;
  if (!disabled) return '';
  return /*#__PURE__*/css({
    color: COLORS.ui.textDisabled
  },  true ? "" : 0,  true ? "" : 0);
};

const fontSizeStyles = _ref13 => {
  let {
    inputSize: size
  } = _ref13;
  const sizes = {
    default: '13px',
    small: '11px',
    '__unstable-large': '13px'
  };
  const fontSize = sizes[size] || sizes.default;
  const fontSizeMobile = '16px';
  if (!fontSize) return '';
  return /*#__PURE__*/css("font-size:", fontSizeMobile, ";@media ( min-width: 600px ){font-size:", fontSize, ";}" + ( true ? "" : 0),  true ? "" : 0);
};

const sizeStyles = _ref14 => {
  let {
    inputSize: size,
    __next36pxDefaultSize
  } = _ref14;
  const sizes = {
    default: {
      height: 36,
      lineHeight: 1,
      minHeight: 36,
      paddingLeft: 16,
      paddingRight: 16
    },
    small: {
      height: 24,
      lineHeight: 1,
      minHeight: 24,
      paddingLeft: 8,
      paddingRight: 8
    },
    '__unstable-large': {
      height: 40,
      lineHeight: 1,
      minHeight: 40,
      paddingLeft: 16,
      paddingRight: 16
    }
  };

  if (!__next36pxDefaultSize) {
    sizes.default = {
      height: 30,
      lineHeight: 1,
      minHeight: 30,
      paddingLeft: 8,
      paddingRight: 8
    };
  }

  const style = sizes[size] || sizes.default;
  return /*#__PURE__*/css(style,  true ? "" : 0,  true ? "" : 0);
};

const dragStyles = _ref15 => {
  let {
    isDragging,
    dragCursor
  } = _ref15;
  let defaultArrowStyles;
  let activeDragCursorStyles;

  if (isDragging) {
    defaultArrowStyles = /*#__PURE__*/css("cursor:", dragCursor, ";user-select:none;&::-webkit-outer-spin-button,&::-webkit-inner-spin-button{-webkit-appearance:none!important;margin:0!important;}" + ( true ? "" : 0),  true ? "" : 0);
  }

  if (isDragging && dragCursor) {
    activeDragCursorStyles = /*#__PURE__*/css("&:active{cursor:", dragCursor, ";}" + ( true ? "" : 0),  true ? "" : 0);
  }

  return /*#__PURE__*/css(defaultArrowStyles, " ", activeDragCursorStyles, ";" + ( true ? "" : 0),  true ? "" : 0);
}; // TODO: Resolve need to use &&& to increase specificity
// https://github.com/WordPress/gutenberg/issues/18483


const Input = emotion_styled_base_browser_esm("input",  true ? {
  target: "em5sgkm5"
} : 0)("&&&{background-color:transparent;box-sizing:border-box;border:none;box-shadow:none!important;color:", COLORS.gray[900], ";display:block;font-family:inherit;margin:0;outline:none;width:100%;", dragStyles, " ", disabledStyles, " ", fontSizeStyles, " ", sizeStyles, " &::-webkit-input-placeholder{line-height:normal;}}" + ( true ? "" : 0));

const labelMargin = _ref16 => {
  let {
    labelPosition
  } = _ref16;
  let marginBottom = 8;

  if (labelPosition === 'edge' || labelPosition === 'side') {
    marginBottom = 0;
  }

  return /*#__PURE__*/css({
    marginTop: 0,
    marginRight: 0,
    marginBottom,
    marginLeft: 0
  },  true ? "" : 0,  true ? "" : 0);
};

const BaseLabel = /*#__PURE__*/emotion_styled_base_browser_esm(text_component,  true ? {
  target: "em5sgkm4"
} : 0)("&&&{box-sizing:border-box;display:block;padding-top:0;padding-bottom:0;max-width:100%;z-index:1;", labelMargin, " overflow:hidden;text-overflow:ellipsis;white-space:nowrap;}" + ( true ? "" : 0));

const Label = props => (0,react.createElement)(BaseLabel, extends_extends({}, props, {
  as: "label"
}));
const LabelWrapper = /*#__PURE__*/emotion_styled_base_browser_esm(flex_item_component,  true ? {
  target: "em5sgkm3"
} : 0)( true ? {
  name: "1b6uupn",
  styles: "max-width:calc( 100% - 10px )"
} : 0);

const backdropFocusedStyles = _ref17 => {
  let {
    disabled,
    isFocused
  } = _ref17;
  let borderColor = isFocused ? COLORS.ui.borderFocus : COLORS.ui.border;
  let boxShadow;

  if (isFocused) {
    boxShadow = `0 0 0 1px ${COLORS.ui.borderFocus} inset`;
  }

  if (disabled) {
    borderColor = COLORS.ui.borderDisabled;
  }

  return /*#__PURE__*/css({
    boxShadow,
    borderColor,
    borderStyle: 'solid',
    borderWidth: 1
  },  true ? "" : 0,  true ? "" : 0);
};

const BackdropUI = emotion_styled_base_browser_esm("div",  true ? {
  target: "em5sgkm2"
} : 0)("&&&{box-sizing:border-box;border-radius:inherit;bottom:0;left:0;margin:0;padding:0;pointer-events:none;position:absolute;right:0;top:0;", backdropFocusedStyles, " ", rtl({
  paddingLeft: 2
}), ";}" + ( true ? "" : 0));
const Prefix = emotion_styled_base_browser_esm("span",  true ? {
  target: "em5sgkm1"
} : 0)( true ? {
  name: "pvvbxf",
  styles: "box-sizing:border-box;display:block"
} : 0);
const Suffix = emotion_styled_base_browser_esm("span",  true ? {
  target: "em5sgkm0"
} : 0)( true ? {
  name: "jgf79h",
  styles: "align-items:center;align-self:stretch;box-sizing:border-box;display:flex"
} : 0);
//# sourceMappingURL=input-control-styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/input-control/backdrop.js


/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */



function Backdrop(_ref) {
  let {
    disabled = false,
    isFocused = false
  } = _ref;
  return (0,react.createElement)(BackdropUI, {
    "aria-hidden": "true",
    className: "components-input-control__backdrop",
    disabled: disabled,
    isFocused: isFocused
  });
}

const MemoizedBackdrop = (0,react.memo)(Backdrop);
/* harmony default export */ const backdrop = (MemoizedBackdrop);
//# sourceMappingURL=backdrop.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/input-control/label.js



/**
 * Internal dependencies
 */


function label_Label(_ref) {
  let {
    children,
    hideLabelFromVision,
    htmlFor,
    ...props
  } = _ref;
  if (!children) return null;

  if (hideLabelFromVision) {
    return (0,react.createElement)(visually_hidden_component, {
      as: "label",
      htmlFor: htmlFor
    }, children);
  }

  return (0,react.createElement)(Label, extends_extends({
    htmlFor: htmlFor
  }, props), children);
}
//# sourceMappingURL=label.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/input-control/input-base.js



/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */





function useUniqueId(idProp) {
  const instanceId = useInstanceId(InputBase);
  const id = `input-base-control-${instanceId}`;
  return idProp || id;
} // Adapter to map props for the new ui/flex compopnent.


function getUIFlexProps(labelPosition) {
  const props = {};

  switch (labelPosition) {
    case 'top':
      props.direction = 'column';
      props.gap = 0;
      break;

    case 'bottom':
      props.direction = 'column-reverse';
      props.gap = 0;
      break;

    case 'edge':
      props.justify = 'space-between';
      break;
  }

  return props;
}

function InputBase(_ref, ref) {
  let {
    __unstableInputWidth,
    children,
    className,
    disabled = false,
    hideLabelFromVision = false,
    labelPosition,
    id: idProp,
    isFocused = false,
    label,
    prefix,
    size = 'default',
    suffix,
    ...props
  } = _ref;
  const id = useUniqueId(idProp);
  const hideLabel = hideLabelFromVision || !label;
  return (// @ts-expect-error The `direction` prop from Flex (FlexDirection) conflicts with legacy SVGAttributes `direction` (string) that come from React intrinsic prop definitions.
    (0,react.createElement)(Root, extends_extends({}, props, getUIFlexProps(labelPosition), {
      className: className,
      isFocused: isFocused,
      labelPosition: labelPosition,
      ref: ref
    }), (0,react.createElement)(LabelWrapper, null, (0,react.createElement)(label_Label, {
      className: "components-input-control__label",
      hideLabelFromVision: hideLabelFromVision,
      labelPosition: labelPosition,
      htmlFor: id,
      size: size
    }, label)), (0,react.createElement)(Container, {
      __unstableInputWidth: __unstableInputWidth,
      className: "components-input-control__container",
      disabled: disabled,
      hideLabel: hideLabel,
      labelPosition: labelPosition
    }, prefix && (0,react.createElement)(Prefix, {
      className: "components-input-control__prefix"
    }, prefix), children, suffix && (0,react.createElement)(Suffix, {
      className: "components-input-control__suffix"
    }, suffix), (0,react.createElement)(backdrop, {
      disabled: disabled,
      isFocused: isFocused
    })))
  );
}
/* harmony default export */ const input_base = ((0,react.forwardRef)(InputBase));
//# sourceMappingURL=input-base.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/select-control/styles/select-control-styles.js


/**
 * External dependencies
 */


/**
 * Internal dependencies
 */


const select_control_styles_disabledStyles = _ref => {
  let {
    disabled
  } = _ref;
  if (!disabled) return '';
  return /*#__PURE__*/css({
    color: COLORS.ui.textDisabled
  },  true ? "" : 0,  true ? "" : 0);
};

const select_control_styles_fontSizeStyles = _ref2 => {
  let {
    selectSize = 'default'
  } = _ref2;
  const sizes = {
    default: '13px',
    small: '11px',
    '__unstable-large': '13px'
  };
  const fontSize = sizes[selectSize];
  const fontSizeMobile = '16px';
  if (!fontSize) return '';
  return /*#__PURE__*/css("font-size:", fontSizeMobile, ";@media ( min-width: 600px ){font-size:", fontSize, ";}" + ( true ? "" : 0),  true ? "" : 0);
};

const select_control_styles_sizeStyles = _ref3 => {
  let {
    selectSize = 'default'
  } = _ref3;
  const sizes = {
    default: {
      height: 30,
      minHeight: 30,
      paddingTop: 0,
      paddingBottom: 0
    },
    small: {
      height: 24,
      minHeight: 24,
      paddingTop: 0,
      paddingBottom: 0
    },
    '__unstable-large': {
      height: 40,
      minHeight: 40,
      paddingTop: 0,
      paddingBottom: 0
    }
  };
  const style = sizes[selectSize];
  return /*#__PURE__*/css(style,  true ? "" : 0,  true ? "" : 0);
};

const sizePaddings = _ref4 => {
  let {
    selectSize = 'default'
  } = _ref4;
  const sizes = {
    default: {
      paddingLeft: 8,
      paddingRight: 24
    },
    small: {
      paddingLeft: 8,
      paddingRight: 24
    },
    '__unstable-large': {
      paddingLeft: 16,
      paddingRight: 32
    }
  };
  return rtl(sizes[selectSize]);
}; // TODO: Resolve need to use &&& to increase specificity
// https://github.com/WordPress/gutenberg/issues/18483


const Select = emotion_styled_base_browser_esm("select",  true ? {
  target: "e1mv6sxx1"
} : 0)("&&&{appearance:none;background:transparent;box-sizing:border-box;border:none;box-shadow:none!important;color:", COLORS.gray[900], ";display:block;font-family:inherit;margin:0;width:100%;", select_control_styles_disabledStyles, ";", select_control_styles_fontSizeStyles, ";", select_control_styles_sizeStyles, ";", sizePaddings, ";}" + ( true ? "" : 0));
const DownArrowWrapper = emotion_styled_base_browser_esm("div",  true ? {
  target: "e1mv6sxx0"
} : 0)("align-items:center;bottom:0;box-sizing:border-box;display:flex;padding:0 4px;pointer-events:none;position:absolute;top:0;", rtl({
  right: 0
}), " svg{display:block;}" + ( true ? "" : 0));
//# sourceMappingURL=select-control-styles.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/select-control/index.js



/**
 * External dependencies
 */



/**
 * WordPress dependencies
 */



/**
 * Internal dependencies
 */





const select_control_noop = () => {};

function select_control_useUniqueId(idProp) {
  const instanceId = useInstanceId(SelectControl);
  const id = `inspector-select-control-${instanceId}`;
  return idProp || id;
}

function UnforwardedSelectControl(_ref, ref) {
  let {
    className,
    disabled = false,
    help,
    hideLabelFromVision,
    id: idProp,
    label,
    multiple = false,
    onBlur = select_control_noop,
    onChange = select_control_noop,
    onFocus = select_control_noop,
    options = [],
    size = 'default',
    value: valueProp,
    labelPosition = 'top',
    children,
    prefix,
    suffix,
    __nextHasNoMarginBottom = false,
    ...props
  } = _ref;
  const [isFocused, setIsFocused] = (0,react.useState)(false);
  const id = select_control_useUniqueId(idProp);
  const helpId = help ? `${id}__help` : undefined; // Disable reason: A select with an onchange throws a warning.

  if ((0,lodash.isEmpty)(options) && !children) return null;

  const handleOnBlur = event => {
    onBlur(event);
    setIsFocused(false);
  };

  const handleOnFocus = event => {
    onFocus(event);
    setIsFocused(true);
  };

  const handleOnChange = event => {
    if (multiple) {
      const selectedOptions = Array.from(event.target.options).filter(_ref2 => {
        let {
          selected
        } = _ref2;
        return selected;
      });
      const newValues = selectedOptions.map(_ref3 => {
        let {
          value
        } = _ref3;
        return value;
      });
      onChange(newValues);
      return;
    }

    onChange(event.target.value, {
      event
    });
  };

  const classes = classnames_default()('components-select-control', className);
  /* eslint-disable jsx-a11y/no-onchange */

  return (0,react.createElement)(base_control, {
    help: help,
    id: id,
    __nextHasNoMarginBottom: __nextHasNoMarginBottom
  }, (0,react.createElement)(input_base, {
    className: classes,
    disabled: disabled,
    hideLabelFromVision: hideLabelFromVision,
    id: id,
    isFocused: isFocused,
    label: label,
    size: size,
    suffix: suffix || (0,react.createElement)(DownArrowWrapper, null, (0,react.createElement)(icon, {
      icon: chevron_down,
      size: 18
    })),
    prefix: prefix,
    labelPosition: labelPosition
  }, (0,react.createElement)(Select, extends_extends({}, props, {
    "aria-describedby": helpId,
    className: "components-select-control__input",
    disabled: disabled,
    id: id,
    multiple: multiple,
    onBlur: handleOnBlur,
    onChange: handleOnChange,
    onFocus: handleOnFocus,
    ref: ref,
    selectSize: size,
    value: valueProp
  }), children || options.map((option, index) => {
    const key = option.id || `${option.label}-${option.value}-${index}`;
    return (0,react.createElement)("option", {
      key: key,
      value: option.value,
      disabled: option.disabled
    }, option.label);
  }))));
  /* eslint-enable jsx-a11y/no-onchange */
}
/**
 * `SelectControl` allows users to select from a single or multiple option menu.
 * It functions as a wrapper around the browser's native `<select>` element.
 *
 * @example
 * import { SelectControl } from '@wordpress/components';
 * import { useState } from '@wordpress/element';
 *
 * const MySelectControl = () => {
 *   const [ size, setSize ] = useState( '50%' );
 *
 *   return (
 *     <SelectControl
 *       label="Size"
 *       value={ size }
 *       options={ [
 *         { label: 'Big', value: '100%' },
 *         { label: 'Medium', value: '50%' },
 *         { label: 'Small', value: '25%' },
 *       ] }
 *       onChange={ setSize }
 *     />
 *   );
 * };
 */


const SelectControl = (0,react.forwardRef)(UnforwardedSelectControl);
/* harmony default export */ const select_control = (SelectControl);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/radio-control/index.js



/**
 * External dependencies
 */



/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */



/**
 * Render a user interface to select the user type using radio inputs.
 *
 * ```jsx
 * import { RadioControl } from '@wordpress/components';
 * import { useState } from '@wordpress/element';
 *
 * const MyRadioControl = () => {
 *   const [ option, setOption ] = useState( 'a' );
 *
 *   return (
 *     <RadioControl
 *       label="User type"
 *       help="The type of the current user"
 *       selected={ option }
 *       options={ [
 *         { label: 'Author', value: 'a' },
 *         { label: 'Editor', value: 'e' },
 *       ] }
 *       onChange={ ( value ) => setOption( value ) }
 *     />
 *   );
 * };
 * ```
 */
function RadioControl( // ref is omitted until we have `WordPressComponentPropsWithoutRef` or add
// ref forwarding to RadioControl.
props) {
  const {
    label,
    className,
    selected,
    help,
    onChange,
    hideLabelFromVision,
    options = [],
    ...additionalProps
  } = props;
  const instanceId = useInstanceId(RadioControl);
  const id = `inspector-radio-control-${instanceId}`;

  const onChangeValue = event => onChange(event.target.value);

  if ((0,lodash.isEmpty)(options)) {
    return null;
  }

  return (0,react.createElement)(base_control, {
    label: label,
    id: id,
    hideLabelFromVision: hideLabelFromVision,
    help: help,
    className: classnames_default()(className, 'components-radio-control')
  }, options.map((option, index) => (0,react.createElement)("div", {
    key: `${id}-${index}`,
    className: "components-radio-control__option"
  }, (0,react.createElement)("input", extends_extends({
    id: `${id}-${index}`,
    className: "components-radio-control__input",
    type: "radio",
    name: id,
    value: option.value,
    onChange: onChangeValue,
    checked: option.value === selected,
    "aria-describedby": !!help ? `${id}__help` : undefined
  }, additionalProps)), (0,react.createElement)("label", {
    htmlFor: `${id}-${index}`
  }, option.label))));
}
/* harmony default export */ const radio_control = (RadioControl);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./assets/app/dev/admin/shared/stateOptions.ts
var stateOptions = [{
  label: 'Alabama',
  value: 'AL'
}, {
  label: 'Alaska',
  value: 'AK'
}, {
  label: 'Arizona',
  value: 'AZ'
}, {
  label: 'Arkansas',
  value: 'AR'
}, {
  label: 'California',
  value: 'CA'
}, {
  label: 'Colorado',
  value: 'CO'
}, {
  label: 'Connecticut',
  value: 'CT'
}, {
  label: 'Delaware',
  value: 'DE'
}, {
  label: 'Florida',
  value: 'FL'
}, {
  label: 'Georgia',
  value: 'GA'
}, {
  label: 'Hawaii',
  value: 'HI'
}, {
  label: 'Idaho',
  value: 'ID'
}, {
  label: 'Illinois',
  value: 'IL'
}, {
  label: 'Indiana',
  value: 'IN'
}, {
  label: 'Iowa',
  value: 'IA'
}, {
  label: 'Kansas',
  value: 'KS'
}, {
  label: 'Kentucky',
  value: 'KY'
}, {
  label: 'Louisiana',
  value: 'LA'
}, {
  label: 'Maine',
  value: 'ME'
}, {
  label: 'Maryland',
  value: 'MD'
}, {
  label: 'Massachusetts',
  value: 'MA'
}, {
  label: 'Michigan',
  value: 'MI'
}, {
  label: 'Minnesota',
  value: 'MN'
}, {
  label: 'Mississippi',
  value: 'MS'
}, {
  label: 'Missouri',
  value: 'MO'
}, {
  label: 'Montana',
  value: 'MT'
}, {
  label: 'Nebraska',
  value: 'NE'
}, {
  label: 'Nevada',
  value: 'NV'
}, {
  label: 'New Hampshire',
  value: 'NH'
}, {
  label: 'New Jersey',
  value: 'NJ'
}, {
  label: 'New Mexico',
  value: 'NM'
}, {
  label: 'New York',
  value: 'NY'
}, {
  label: 'North Carolina',
  value: 'NC'
}, {
  label: 'North Dakota',
  value: 'ND'
}, {
  label: 'Ohio',
  value: 'OH'
}, {
  label: 'Oklahoma',
  value: 'OK'
}, {
  label: 'Oregon',
  value: 'OR'
}, {
  label: 'Pennsylvania',
  value: 'PA'
}, {
  label: 'Rhode Island',
  value: 'RI'
}, {
  label: 'South Carolina',
  value: 'SC'
}, {
  label: 'South Dakota',
  value: 'SD'
}, {
  label: 'Tennessee',
  value: 'TN'
}, {
  label: 'Texas',
  value: 'TX'
}, {
  label: 'Utah',
  value: 'UT'
}, {
  label: 'Vermont',
  value: 'VT'
}, {
  label: 'Virgin Islands',
  value: 'VI'
}, {
  label: 'Virginia',
  value: 'VA'
}, {
  label: 'Washington',
  value: 'WA'
}, {
  label: 'West Virginia',
  value: 'WV'
}, {
  label: 'Wisconsin',
  value: 'WI'
}, {
  label: 'Wyoming',
  value: 'WY'
}];
;// CONCATENATED MODULE: ./assets/app/dev/admin/shared/PasswordControl.tsx
function PasswordControl_slicedToArray(arr, i) { return PasswordControl_arrayWithHoles(arr) || PasswordControl_iterableToArrayLimit(arr, i) || PasswordControl_unsupportedIterableToArray(arr, i) || PasswordControl_nonIterableRest(); }

function PasswordControl_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function PasswordControl_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return PasswordControl_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return PasswordControl_arrayLikeToArray(o, minLen); }

function PasswordControl_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function PasswordControl_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function PasswordControl_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }





var PasswordControl = function PasswordControl(props) {
  var _useState = (0,react.useState)("password-control-".concat(new Date().valueOf())),
      _useState2 = PasswordControl_slicedToArray(_useState, 1),
      uuId = _useState2[0];

  var _useState3 = (0,react.useState)(false),
      _useState4 = PasswordControl_slicedToArray(_useState3, 2),
      visible = _useState4[0],
      setVisible = _useState4[1];

  var _useState5 = (0,react.useState)('Show password'),
      _useState6 = PasswordControl_slicedToArray(_useState5, 2),
      buttonLabel = _useState6[0],
      setButtonLabel = _useState6[1];

  (0,react.useEffect)(function () {
    setButtonLabel(visible ? 'Hide password' : 'Show password');
  }, [visible]);
  return /*#__PURE__*/(0,jsx_runtime.jsx)(base_control, {
    id: uuId,
    label: props.label,
    children: /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
      className: "row gx-1",
      children: [/*#__PURE__*/(0,jsx_runtime.jsx)("div", {
        className: "col",
        children: /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
          id: uuId,
          value: props.value,
          onChange: props.onChange,
          type: visible ? 'text' : 'password',
          autoComplete: "new-password"
        })
      }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
        className: "col-auto",
        children: /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
          variant: "tertiary",
          icon: visible ? 'visibility' : 'hidden',
          style: {
            height: 'auto'
          },
          onClick: function onClick() {
            return setVisible(!visible);
          },
          label: buttonLabel
        })
      })]
    })
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/document-profiles/DocumentProfile.tsx
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { DocumentProfile_defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function DocumentProfile_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function DocumentProfile_toConsumableArray(arr) { return DocumentProfile_arrayWithoutHoles(arr) || DocumentProfile_iterableToArray(arr) || DocumentProfile_unsupportedIterableToArray(arr) || DocumentProfile_nonIterableSpread(); }

function DocumentProfile_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function DocumentProfile_iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function DocumentProfile_arrayWithoutHoles(arr) { if (Array.isArray(arr)) return DocumentProfile_arrayLikeToArray(arr); }

function DocumentProfile_slicedToArray(arr, i) { return DocumentProfile_arrayWithHoles(arr) || DocumentProfile_iterableToArrayLimit(arr, i) || DocumentProfile_unsupportedIterableToArray(arr, i) || DocumentProfile_nonIterableRest(); }

function DocumentProfile_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function DocumentProfile_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return DocumentProfile_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return DocumentProfile_arrayLikeToArray(o, minLen); }

function DocumentProfile_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function DocumentProfile_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function DocumentProfile_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }











var DocumentProfile_apiUrl = '/purchasing/document-profile/';
var formatOptions = [{
  label: 'cXML',
  value: 'cxml'
}, {
  label: 'PDF',
  value: 'pdf'
}, {
  label: 'CSV',
  value: 'csv'
}];
var receiverOptions = [{
  label: 'Network ID',
  value: 'NetworkID'
}, {
  label: 'DUNS',
  value: 'DUNS'
}];
var DocumentProfile = function DocumentProfile(_ref) {
  var isNew = _ref.isNew,
      profileId = _ref.profileId;

  var _useState = (0,react.useState)([{
    name: 'Purchasing',
    hash: '#!/purchasing'
  }, {
    name: 'Document Profiles',
    hash: '#!/purchasing/document-profiles'
  }]),
      _useState2 = DocumentProfile_slicedToArray(_useState, 2),
      breadcrumbs = _useState2[0],
      setBreadcrumbs = _useState2[1];

  var _useState3 = (0,react.useState)(true),
      _useState4 = DocumentProfile_slicedToArray(_useState3, 2),
      isBusy = _useState4[0],
      setIsBusy = _useState4[1];

  var _useState5 = (0,react.useState)(false),
      _useState6 = DocumentProfile_slicedToArray(_useState5, 2),
      isOpen = _useState6[0],
      setOpen = _useState6[1];

  var _useState7 = (0,react.useState)([]),
      _useState8 = DocumentProfile_slicedToArray(_useState7, 2),
      notices = _useState8[0],
      setNotices = _useState8[1];

  var _useState9 = (0,react.useState)({}),
      _useState10 = DocumentProfile_slicedToArray(_useState9, 2),
      profile = _useState10[0],
      setProfile = _useState10[1];

  (0,react.useEffect)(function () {
    if (profileId) {
      getProfile(profileId);
    }
  }, [profileId]);
  (0,react.useEffect)(function () {
    if (isNew) {
      setBreadcrumbs([].concat(DocumentProfile_toConsumableArray(breadcrumbs), [{
        name: 'Add New',
        hash: '#!/purchasing/document-profiles/new'
      }]));
      setIsBusy(false);
    }
  }, [isNew]);
  (0,react.useEffect)(function () {
    if (isNew && profile.id) {
      location.assign(location.href.replace('new', profile.id.toString()));
    }
  }, [profile]);

  var closeModal = function closeModal() {
    return setOpen(false);
  };

  var deleteProfile = function deleteProfile() {
    setIsBusy(true);
    vfAPI["delete"]("".concat(DocumentProfile_apiUrl).concat(profile.id)).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        location.assign(location.href.replace("/".concat(profile.id.toString()), ''));
      }
    });
  };

  var getProfile = function getProfile(id) {
    setIsBusy(true);
    vfAPI.get("".concat(DocumentProfile_apiUrl).concat(id)).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        setBreadcrumbs([].concat(DocumentProfile_toConsumableArray(breadcrumbs), [{
          name: response.data.document_profile.name,
          hash: "#!/purchasing/document-profiles/".concat(profileId)
        }]));
        setProfile(response.data.document_profile);
      }

      setIsBusy(false);
    });
  };

  var handleSubmit = function handleSubmit(e) {
    e.preventDefault();

    if (isNew) {
      save();
    } else {
      update();
    }
  };

  var openModal = function openModal() {
    return setOpen(true);
  };

  var save = function save() {
    setIsBusy(true);
    vfAPI.post(DocumentProfile_apiUrl, profile).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        setProfile(response.data.document_profile);
      }

      setIsBusy(false);
    });
  };

  var update = function update() {
    setIsBusy(true);
    vfAPI.put("".concat(DocumentProfile_apiUrl).concat(profile.id), profile).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        setProfile(response.data.document_profile);
      }

      setIsBusy(false);
    });
  };

  return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
    children: [/*#__PURE__*/(0,jsx_runtime.jsx)(Breadcrumb, {
      breadcrumbs: breadcrumbs
    }), /*#__PURE__*/(0,jsx_runtime.jsx)(Notices, {
      notices: notices
    }), /*#__PURE__*/(0,jsx_runtime.jsxs)("h2", {
      children: [isNew ? 'Add New' : 'Edit', " Document Profile"]
    }), /*#__PURE__*/(0,jsx_runtime.jsxs)("form", {
      onSubmit: handleSubmit,
      children: [/*#__PURE__*/(0,jsx_runtime.jsx)("fieldset", {
        disabled: isBusy,
        children: /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
          className: "row mb-3",
          children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
            className: "col-md-5",
            children: [/*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
              label: "Name (required)",
              value: profile.name,
              onChange: function onChange(value) {
                return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                  name: value
                }));
              },
              required: true
            }), /*#__PURE__*/(0,jsx_runtime.jsx)(select_control, {
              label: "Format (required)",
              value: profile.format,
              onChange: function onChange(value) {
                return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                  format: value
                }));
              },
              options: [{
                label: '',
                value: null
              }].concat(formatOptions),
              required: true
            }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
              label: "Endpoint",
              type: "url",
              value: profile.endpoint,
              onChange: function onChange(value) {
                return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                  endpoint: value
                }));
              }
            }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
              label: "Account User",
              value: profile.account_user,
              onChange: function onChange(value) {
                return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                  account_user: value
                }));
              }
            }), /*#__PURE__*/(0,jsx_runtime.jsx)(PasswordControl, {
              label: "Account Password",
              value: profile.account_password,
              onChange: function onChange(value) {
                return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                  account_password: value
                }));
              }
            }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
              label: "Receiver ID",
              value: profile.receiver_id,
              onChange: function onChange(value) {
                return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                  receiver_id: value
                }));
              }
            }), /*#__PURE__*/(0,jsx_runtime.jsx)(radio_control, {
              label: "Receiver ID Type",
              selected: profile.receiver_id_type,
              onChange: function onChange(value) {
                return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                  receiver_id_type: value
                }));
              },
              options: receiverOptions
            })]
          }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
            className: "col-md-7",
            children: /*#__PURE__*/(0,jsx_runtime.jsx)("fieldset", {
              children: /*#__PURE__*/(0,jsx_runtime.jsxs)(card_component, {
                children: [/*#__PURE__*/(0,jsx_runtime.jsx)(card_header_component, {
                  children: "Account Receivable"
                }), /*#__PURE__*/(0,jsx_runtime.jsxs)(card_body_component, {
                  children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
                    className: "row",
                    children: [/*#__PURE__*/(0,jsx_runtime.jsx)("div", {
                      className: "col-sm",
                      children: /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                        label: "Email (required)",
                        type: "email",
                        value: profile.email,
                        onChange: function onChange(value) {
                          return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                            email: value
                          }));
                        },
                        required: true
                      })
                    }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
                      className: "col-sm",
                      children: /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                        label: "Phone",
                        value: profile.phone,
                        onChange: function onChange(value) {
                          return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                            phone: value
                          }));
                        }
                      })
                    })]
                  }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                    label: "Street Address",
                    value: profile.address1,
                    onChange: function onChange(value) {
                      return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                        address1: value
                      }));
                    }
                  }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                    label: "Apt., Suite, etc.",
                    value: profile.address2,
                    onChange: function onChange(value) {
                      return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                        address2: value
                      }));
                    }
                  }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                    label: "Additional Address",
                    value: profile.address3,
                    onChange: function onChange(value) {
                      return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                        address3: value
                      }));
                    }
                  }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
                    className: "row align-items-baseline",
                    children: [/*#__PURE__*/(0,jsx_runtime.jsx)("div", {
                      className: "col-sm",
                      children: /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                        label: "City",
                        value: profile.city,
                        onChange: function onChange(value) {
                          return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                            city: value
                          }));
                        }
                      })
                    }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
                      className: "col-sm",
                      children: /*#__PURE__*/(0,jsx_runtime.jsx)(select_control, {
                        label: "State",
                        value: profile.state,
                        onChange: function onChange(value) {
                          return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                            state: value
                          }));
                        },
                        options: [{
                          label: '',
                          value: null
                        }].concat(DocumentProfile_toConsumableArray(stateOptions))
                      })
                    }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
                      className: "col-sm",
                      children: /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                        label: "Zip Code",
                        value: profile.zip,
                        onChange: function onChange(value) {
                          return setProfile(_objectSpread(_objectSpread({}, profile), {}, {
                            zip: value
                          }));
                        }
                      })
                    })]
                  })]
                })]
              })
            })
          })]
        })
      }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
        className: "hstack gap-1",
        children: [/*#__PURE__*/(0,jsx_runtime.jsxs)(build_module_button, {
          isBusy: isBusy,
          variant: "primary",
          type: "submit",
          children: [isNew ? 'Add New' : 'Update', " Document Profile"]
        }), profile.id && /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
          isBusy: isBusy,
          isDestructive: true,
          onClick: openModal,
          children: "Delete"
        })]
      })]
    }), isOpen && /*#__PURE__*/(0,jsx_runtime.jsxs)(modal, {
      title: "Delete this document profile?",
      onRequestClose: closeModal,
      children: [/*#__PURE__*/(0,jsx_runtime.jsx)("p", {
        children: "This will delete this document profile."
      }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
        className: "hstack gap-1 justify-content-end",
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
          variant: "secondary",
          onClick: closeModal,
          children: "Cancel"
        }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
          variant: "primary",
          isDestructive: true,
          onClick: deleteProfile,
          children: "Delete"
        })]
      })]
    })]
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/document-profiles/DocumentProfilePage.tsx
function DocumentProfilePage_typeof(obj) { "@babel/helpers - typeof"; return DocumentProfilePage_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, DocumentProfilePage_typeof(obj); }

function DocumentProfilePage_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function DocumentProfilePage_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function DocumentProfilePage_createClass(Constructor, protoProps, staticProps) { if (protoProps) DocumentProfilePage_defineProperties(Constructor.prototype, protoProps); if (staticProps) DocumentProfilePage_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function DocumentProfilePage_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) DocumentProfilePage_setPrototypeOf(subClass, superClass); }

function DocumentProfilePage_setPrototypeOf(o, p) { DocumentProfilePage_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return DocumentProfilePage_setPrototypeOf(o, p); }

function DocumentProfilePage_createSuper(Derived) { var hasNativeReflectConstruct = DocumentProfilePage_isNativeReflectConstruct(); return function _createSuperInternal() { var Super = DocumentProfilePage_getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = DocumentProfilePage_getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return DocumentProfilePage_possibleConstructorReturn(this, result); }; }

function DocumentProfilePage_possibleConstructorReturn(self, call) { if (call && (DocumentProfilePage_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return DocumentProfilePage_assertThisInitialized(self); }

function DocumentProfilePage_assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function DocumentProfilePage_isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function DocumentProfilePage_getPrototypeOf(o) { DocumentProfilePage_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return DocumentProfilePage_getPrototypeOf(o); }





var DocumentProfilePage = /*#__PURE__*/function (_React$Component) {
  DocumentProfilePage_inherits(DocumentProfilePage, _React$Component);

  var _super = DocumentProfilePage_createSuper(DocumentProfilePage);

  function DocumentProfilePage(props) {
    var _this;

    DocumentProfilePage_classCallCheck(this, DocumentProfilePage);

    _this = _super.call(this, props);
    _this.state = {
      profileId: null,
      isNew: false
    };
    return _this;
  }

  DocumentProfilePage_createClass(DocumentProfilePage, [{
    key: "isId",
    value: function isId(value) {
      return Number.isInteger(Number(value));
    }
  }, {
    key: "getId",
    value: function getId(value) {
      return Number(value);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var fragment = location.hash.split('/').pop();

      if (this.isId(fragment)) {
        this.setState({
          profileId: this.getId(fragment)
        });
      } else {
        this.setState({
          isNew: true
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0,jsx_runtime.jsx)(jsx_runtime.Fragment, {
        children: /*#__PURE__*/(0,jsx_runtime.jsx)(DocumentProfile, {
          profileId: this.state.profileId,
          isNew: this.state.isNew
        })
      });
    }
  }]);

  return DocumentProfilePage;
}(react.Component);
;// CONCATENATED MODULE: ./assets/app/dev/admin/purchasing/purchasing.module.ts







var PurchasingModule = angular.module('PurchasingModule', [PurchasingRoutingModule]).component('purchasingPage', PurchasingPageComponent).component('purchasingCostSheets', PurchasingCostSheetsComponent).component('documentProfilesPage', (0,react2angular.react2angular)(DocumentProfilesPage)).component('documentProfilePage', (0,react2angular.react2angular)(DocumentProfilePage)).component('purchasingVendors', PurchasingVendorsComponent).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/roles/roles-routing.module.ts

var roles_routing_module_states = [{
  name: 'customers.roles',
  url: '/roles',
  "abstract": true,
  template: '<ui-view/>'
}, {
  name: 'customers.roles.index',
  url: '',
  component: 'rolesPage'
}, {
  name: 'customers.roles.create',
  url: '/new',
  component: 'rolePage'
}, {
  name: 'customers.roles.edit',
  url: '/:id',
  component: 'rolePage'
}];
var RolesRoutingModule = angular.module('RolesRoutingModule', []).config(["$stateProvider", function ($stateProvider) {
  'ngInject';

  roles_routing_module_states.forEach(function (state) {
    state.onEnter = function () {
      highlightMenuItem('customers');
    };

    $stateProvider.state(state);
  });
}]).name;
;// CONCATENATED MODULE: ./assets/app/dev/admin/roles/Roles.tsx
function Roles_slicedToArray(arr, i) { return Roles_arrayWithHoles(arr) || Roles_iterableToArrayLimit(arr, i) || Roles_unsupportedIterableToArray(arr, i) || Roles_nonIterableRest(); }

function Roles_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function Roles_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return Roles_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return Roles_arrayLikeToArray(o, minLen); }

function Roles_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function Roles_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function Roles_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }











var Roles = function Roles() {
  var _useState = (0,react.useState)(false),
      _useState2 = Roles_slicedToArray(_useState, 2),
      isBusy = _useState2[0],
      setIsBusy = _useState2[1];

  var _useState3 = (0,react.useState)([]),
      _useState4 = Roles_slicedToArray(_useState3, 2),
      notices = _useState4[0],
      setNotices = _useState4[1];

  var _useState5 = (0,react.useState)(1),
      _useState6 = Roles_slicedToArray(_useState5, 2),
      page = _useState6[0],
      setPage = _useState6[1];

  var _useState7 = (0,react.useState)(''),
      _useState8 = Roles_slicedToArray(_useState7, 2),
      q = _useState8[0],
      setQ = _useState8[1];

  var _useState9 = (0,react.useState)(),
      _useState10 = Roles_slicedToArray(_useState9, 2),
      roles = _useState10[0],
      setRoles = _useState10[1];

  var _useState11 = (0,react.useState)('id'),
      _useState12 = Roles_slicedToArray(_useState11, 2),
      sortBy = _useState12[0],
      setSortBy = _useState12[1];

  var _useState13 = (0,react.useState)('asc'),
      _useState14 = Roles_slicedToArray(_useState13, 2),
      sortType = _useState14[0],
      setSortType = _useState14[1];

  var headers = [{
    key: 'id',
    label: 'ID'
  }, {
    key: 'name',
    label: 'Name'
  }, {
    key: 'registration',
    label: 'Registration',
    type: 'boolean'
  }, {
    key: 'allowed_email_domains',
    label: 'Allowed Email Domains',
    type: 'array'
  }];

  var deleteRole = function deleteRole(id) {
    setIsBusy(true);
    vfAPI["delete"]("/customer/roles/".concat(id)).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        getRoles();
      }
    });
  };

  var editRole = function editRole(id) {
    var url = "".concat(location.href, "/").concat(id);
    location.assign(url);
  };

  var getRoles = function getRoles() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    setIsBusy(true);
    var config = {
      params: params
    };
    vfAPI.get('/customer/roles', config).then(function (response) {
      setRoles(response.data.roles);
      setIsBusy(false);
    });
  };

  var handleSubmit = function handleSubmit(e) {
    e.preventDefault();
    var params = {
      page: 1,
      q: q,
      sortBy: sortBy,
      sortType: sortType
    };
    getRoles(params);
  };

  (0,react.useEffect)(function () {
    var params = {
      page: page,
      q: q,
      sortBy: sortBy,
      sortType: sortType
    };
    getRoles(params);
  }, [page, sortBy, sortType]);
  return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
    children: [/*#__PURE__*/(0,jsx_runtime.jsx)(Notices, {
      notices: notices
    }), /*#__PURE__*/(0,jsx_runtime.jsx)(SearchBox, {
      isBusy: isBusy,
      handleSubmit: handleSubmit,
      q: q,
      setQ: setQ
    }), !roles && /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
      className: "hstack justify-content-center",
      children: /*#__PURE__*/(0,jsx_runtime.jsx)(Spinner, {})
    }), roles && /*#__PURE__*/(0,jsx_runtime.jsx)(ListTable, {
      deleteItem: deleteRole,
      editItem: editRole,
      headers: headers,
      isBusy: isBusy,
      rows: roles.data,
      sortBy: sortBy,
      setSortBy: setSortBy,
      sortType: sortType,
      setSortType: setSortType
    }), roles && /*#__PURE__*/(0,jsx_runtime.jsx)(TableNav, {
      isBusy: isBusy,
      currentPage: roles.current_page,
      setPage: setPage,
      lastPage: roles.last_page,
      total: roles.total
    })]
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/roles/RolesPage.tsx
function RolesPage_typeof(obj) { "@babel/helpers - typeof"; return RolesPage_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, RolesPage_typeof(obj); }

function RolesPage_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function RolesPage_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function RolesPage_createClass(Constructor, protoProps, staticProps) { if (protoProps) RolesPage_defineProperties(Constructor.prototype, protoProps); if (staticProps) RolesPage_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function RolesPage_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) RolesPage_setPrototypeOf(subClass, superClass); }

function RolesPage_setPrototypeOf(o, p) { RolesPage_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return RolesPage_setPrototypeOf(o, p); }

function RolesPage_createSuper(Derived) { var hasNativeReflectConstruct = RolesPage_isNativeReflectConstruct(); return function _createSuperInternal() { var Super = RolesPage_getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = RolesPage_getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return RolesPage_possibleConstructorReturn(this, result); }; }

function RolesPage_possibleConstructorReturn(self, call) { if (call && (RolesPage_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return RolesPage_assertThisInitialized(self); }

function RolesPage_assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function RolesPage_isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function RolesPage_getPrototypeOf(o) { RolesPage_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return RolesPage_getPrototypeOf(o); }

function RolesPage_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }








var RolesPage = /*#__PURE__*/function (_React$Component) {
  RolesPage_inherits(RolesPage, _React$Component);

  var _super = RolesPage_createSuper(RolesPage);

  function RolesPage() {
    var _this;

    RolesPage_classCallCheck(this, RolesPage);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    RolesPage_defineProperty(RolesPage_assertThisInitialized(_this), "state", {
      breadcrumbs: [{
        name: 'Customers',
        hash: '#!/customers'
      }, {
        name: 'Roles',
        hash: '#!/customers/roles'
      }]
    });

    return _this;
  }

  RolesPage_createClass(RolesPage, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)(Breadcrumb, {
          breadcrumbs: this.state.breadcrumbs
        }), /*#__PURE__*/(0,jsx_runtime.jsxs)("h2", {
          children: ["Roles ", /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
            variant: "secondary",
            href: "#!/customers/roles/new",
            children: "Add New"
          })]
        }), /*#__PURE__*/(0,jsx_runtime.jsx)(Roles, {})]
      });
    }
  }]);

  return RolesPage;
}(react.Component);
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/form-token-field/token-input.js



/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */

/**
 * Internal dependencies
 */

function UnForwardedTokenInput(props, ref) {
  const {
    value,
    isExpanded,
    instanceId,
    selectedSuggestionIndex,
    className,
    onChange,
    ...restProps
  } = props;
  const size = value ? value.length + 1 : 0;

  const onChangeHandler = event => {
    if (onChange) {
      onChange({
        value: event.target.value
      });
    }
  };

  return (0,react.createElement)("input", extends_extends({
    ref: ref,
    id: `components-form-token-input-${instanceId}`,
    type: "text"
  }, restProps, {
    value: value || '',
    onChange: onChangeHandler,
    size: size,
    className: classnames_default()(className, 'components-form-token-field__input'),
    autoComplete: "off",
    role: "combobox",
    "aria-expanded": isExpanded,
    "aria-autocomplete": "list",
    "aria-owns": isExpanded ? `components-form-token-suggestions-${instanceId}` : undefined,
    "aria-activedescendant": selectedSuggestionIndex !== -1 ? `components-form-token-suggestions-${instanceId}-${selectedSuggestionIndex}` : undefined,
    "aria-describedby": `components-form-token-suggestions-howto-${instanceId}`
  }));
}
const TokenInput = (0,react.forwardRef)(UnForwardedTokenInput);
/* harmony default export */ const token_input = (TokenInput);
//# sourceMappingURL=token-input.js.map
// EXTERNAL MODULE: ./node_modules/dom-scroll-into-view/lib/index.js
var lib = __webpack_require__(4979);
var lib_default = /*#__PURE__*/__webpack_require__.n(lib);
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/form-token-field/suggestions-list.js


/**
 * External dependencies
 */




/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */

const {
  setTimeout: suggestions_list_setTimeout,
  clearTimeout: suggestions_list_clearTimeout
} = window;

const handleMouseDown = e => {
  // By preventing default here, we will not lose focus of <input> when clicking a suggestion.
  e.preventDefault();
};

function SuggestionsList(_ref) {
  let {
    selectedIndex,
    scrollIntoView,
    match,
    onHover,
    onSelect,
    suggestions = [],
    displayTransform,
    instanceId
  } = _ref;
  const [scrollingIntoView, setScrollingIntoView] = (0,react.useState)(false);
  const listRef = useRefEffect(listNode => {
    // only have to worry about scrolling selected suggestion into view
    // when already expanded.
    let id;

    if (selectedIndex > -1 && scrollIntoView && listNode.children[selectedIndex]) {
      setScrollingIntoView(true);
      lib_default()(listNode.children[selectedIndex], listNode, {
        onlyScrollIfNeeded: true
      });
      id = suggestions_list_setTimeout(() => {
        setScrollingIntoView(false);
      }, 100);
    }

    return () => {
      if (id !== undefined) {
        suggestions_list_clearTimeout(id);
      }
    };
  }, [selectedIndex, scrollIntoView]);

  const handleHover = suggestion => {
    return () => {
      if (!scrollingIntoView) {
        onHover === null || onHover === void 0 ? void 0 : onHover(suggestion);
      }
    };
  };

  const handleClick = suggestion => {
    return () => {
      onSelect === null || onSelect === void 0 ? void 0 : onSelect(suggestion);
    };
  };

  const computeSuggestionMatch = suggestion => {
    const matchText = displayTransform(match).toLocaleLowerCase();

    if (matchText.length === 0) {
      return null;
    }

    const transformedSuggestion = displayTransform(suggestion);
    const indexOfMatch = transformedSuggestion.toLocaleLowerCase().indexOf(matchText);
    return {
      suggestionBeforeMatch: transformedSuggestion.substring(0, indexOfMatch),
      suggestionMatch: transformedSuggestion.substring(indexOfMatch, indexOfMatch + matchText.length),
      suggestionAfterMatch: transformedSuggestion.substring(indexOfMatch + matchText.length)
    };
  };

  return (0,react.createElement)("ul", {
    ref: listRef,
    className: "components-form-token-field__suggestions-list",
    id: `components-form-token-suggestions-${instanceId}`,
    role: "listbox"
  }, (0,lodash.map)(suggestions, (suggestion, index) => {
    const matchText = computeSuggestionMatch(suggestion);
    const className = classnames_default()('components-form-token-field__suggestion', {
      'is-selected': index === selectedIndex
    });
    /* eslint-disable jsx-a11y/click-events-have-key-events */

    return (0,react.createElement)("li", {
      id: `components-form-token-suggestions-${instanceId}-${index}`,
      role: "option",
      className: className,
      key: typeof suggestion === 'object' && 'value' in suggestion ? suggestion === null || suggestion === void 0 ? void 0 : suggestion.value : displayTransform(suggestion),
      onMouseDown: handleMouseDown,
      onClick: handleClick(suggestion),
      onMouseEnter: handleHover(suggestion),
      "aria-selected": index === selectedIndex
    }, matchText ? (0,react.createElement)("span", {
      "aria-label": displayTransform(suggestion)
    }, matchText.suggestionBeforeMatch, (0,react.createElement)("strong", {
      className: "components-form-token-field__suggestion-match"
    }, matchText.suggestionMatch), matchText.suggestionAfterMatch) : displayTransform(suggestion));
    /* eslint-enable jsx-a11y/click-events-have-key-events */
  }));
}
/* harmony default export */ const suggestions_list = (SuggestionsList);
//# sourceMappingURL=suggestions-list.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/flex/flex-block/hook.js
/**
 * Internal dependencies
 */


/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FlexBlockProps, 'div'>} props
 */

function useFlexBlock(props) {
  const otherProps = useContextSystem(props, 'FlexBlock');
  const flexItemProps = useFlexItem({
    isBlock: true,
    ...otherProps
  });
  return flexItemProps;
}
//# sourceMappingURL=hook.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/flex/flex-block/component.js



/**
 * Internal dependencies
 */



/**
 * @param {import('../../ui/context').WordPressComponentProps<import('../types').FlexBlockProps, 'div'>} props
 * @param {import('react').ForwardedRef<any>}                                                            forwardedRef
 */

function FlexBlock(props, forwardedRef) {
  const flexBlockProps = useFlexBlock(props);
  return (0,react.createElement)(component, extends_extends({}, flexBlockProps, {
    ref: forwardedRef
  }));
}
/**
 * `FlexBlock` is a primitive layout component that adaptively resizes content within layout containers like `Flex`.
 *
 * @example
 * ```jsx
 * <Flex>
 * 	<FlexBlock>...</FlexBlock>
 * </Flex>
 * ```
 */


const ConnectedFlexBlock = contextConnect(FlexBlock, 'FlexBlock');
/* harmony default export */ const flex_block_component = (ConnectedFlexBlock);
//# sourceMappingURL=component.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/utils/create-higher-order-component/index.js
/**
 * External dependencies
 */


/**
 * Given a function mapping a component to an enhanced component and modifier
 * name, returns the enhanced component augmented with a generated displayName.
 *
 * @param  mapComponent Function mapping component to enhanced component.
 * @param  modifierName Seed name from which to generated display name.
 *
 * @return Component class with generated display name assigned.
 */
function createHigherOrderComponent(mapComponent, modifierName) {
  return Inner => {
    const Outer = mapComponent(Inner);
    Outer.displayName = hocName(modifierName, Inner);
    return Outer;
  };
}
/**
 * Returns a displayName for a higher-order component, given a wrapper name.
 *
 * @example
 *     hocName( 'MyMemo', Widget ) === 'MyMemo(Widget)';
 *     hocName( 'MyMemo', <div /> ) === 'MyMemo(Component)';
 *
 * @param  name  Name assigned to higher-order component's wrapper component.
 * @param  Inner Wrapped component inside higher-order component.
 * @return       Wrapped name of higher-order component.
 */

const hocName = (name, Inner) => {
  const inner = Inner.displayName || Inner.name || 'Component';
  const outer = (0,lodash.upperFirst)((0,lodash.camelCase)(name));
  return `${outer}(${inner})`;
};
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/higher-order/with-focus-outside/index.js


//@ts-nocheck

/**
 * WordPress dependencies
 */


/* harmony default export */ const with_focus_outside = (createHigherOrderComponent(WrappedComponent => props => {
  const [handleFocusOutside, setHandleFocusOutside] = (0,react.useState)();
  const bindFocusOutsideHandler = (0,react.useCallback)(node => setHandleFocusOutside(() => node !== null && node !== void 0 && node.handleFocusOutside ? node.handleFocusOutside.bind(node) : undefined), []);
  return (0,react.createElement)("div", useFocusOutside(handleFocusOutside), (0,react.createElement)(WrappedComponent, extends_extends({
    ref: bindFocusOutsideHandler
  }, props)));
}, 'withFocusOutside'));
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/combobox-control/index.js


/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */







/**
 * Internal dependencies
 */








const combobox_control_noop = () => {};

const DetectOutside = with_focus_outside(class extends react.Component {
  handleFocusOutside(event) {
    this.props.onFocusOutside(event);
  }

  render() {
    return this.props.children;
  }

});

function ComboboxControl(_ref) {
  var _currentOption$label;

  let {
    value,
    label,
    options,
    onChange,
    onFilterValueChange = combobox_control_noop,
    hideLabelFromVision,
    help,
    allowReset = true,
    className,
    messages = {
      selected: __('Item selected.')
    }
  } = _ref;
  const currentOption = options.find(option => option.value === value);
  const currentLabel = (_currentOption$label = currentOption === null || currentOption === void 0 ? void 0 : currentOption.label) !== null && _currentOption$label !== void 0 ? _currentOption$label : '';
  const instanceId = useInstanceId(ComboboxControl);
  const [selectedSuggestion, setSelectedSuggestion] = (0,react.useState)(currentOption || null);
  const [isExpanded, setIsExpanded] = (0,react.useState)(false);
  const [inputHasFocus, setInputHasFocus] = (0,react.useState)(false);
  const [inputValue, setInputValue] = (0,react.useState)('');
  const inputContainer = (0,react.useRef)();
  const matchingSuggestions = (0,react.useMemo)(() => {
    const startsWithMatch = [];
    const containsMatch = [];
    const match = (0,lodash.deburr)(inputValue.toLocaleLowerCase());
    options.forEach(option => {
      const index = (0,lodash.deburr)(option.label).toLocaleLowerCase().indexOf(match);

      if (index === 0) {
        startsWithMatch.push(option);
      } else if (index > 0) {
        containsMatch.push(option);
      }
    });
    return startsWithMatch.concat(containsMatch);
  }, [inputValue, options, value]);

  const onSuggestionSelected = newSelectedSuggestion => {
    onChange(newSelectedSuggestion.value);
    speak(messages.selected, 'assertive');
    setSelectedSuggestion(newSelectedSuggestion);
    setInputValue('');
    setIsExpanded(false);
  };

  const handleArrowNavigation = function () {
    let offset = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 1;
    const index = matchingSuggestions.indexOf(selectedSuggestion);
    let nextIndex = index + offset;

    if (nextIndex < 0) {
      nextIndex = matchingSuggestions.length - 1;
    } else if (nextIndex >= matchingSuggestions.length) {
      nextIndex = 0;
    }

    setSelectedSuggestion(matchingSuggestions[nextIndex]);
    setIsExpanded(true);
  };

  const onKeyDown = event => {
    let preventDefault = false;

    if (event.defaultPrevented) {
      return;
    }

    switch (event.keyCode) {
      case ENTER:
        if (selectedSuggestion) {
          onSuggestionSelected(selectedSuggestion);
          preventDefault = true;
        }

        break;

      case UP:
        handleArrowNavigation(-1);
        preventDefault = true;
        break;

      case DOWN:
        handleArrowNavigation(1);
        preventDefault = true;
        break;

      case ESCAPE:
        setIsExpanded(false);
        setSelectedSuggestion(null);
        preventDefault = true;
        break;

      default:
        break;
    }

    if (preventDefault) {
      event.preventDefault();
    }
  };

  const onBlur = () => {
    setInputHasFocus(false);
  };

  const onFocus = () => {
    setInputHasFocus(true);
    setIsExpanded(true);
    onFilterValueChange('');
    setInputValue('');
  };

  const onFocusOutside = () => {
    setIsExpanded(false);
  };

  const onInputChange = event => {
    const text = event.value;
    setInputValue(text);
    onFilterValueChange(text);

    if (inputHasFocus) {
      setIsExpanded(true);
    }
  };

  const handleOnReset = () => {
    onChange(null);
    inputContainer.current.focus();
  }; // Update current selections when the filter input changes.


  (0,react.useEffect)(() => {
    const hasMatchingSuggestions = matchingSuggestions.length > 0;
    const hasSelectedMatchingSuggestions = matchingSuggestions.indexOf(selectedSuggestion) > 0;

    if (hasMatchingSuggestions && !hasSelectedMatchingSuggestions) {
      // If the current selection isn't present in the list of suggestions, then automatically select the first item from the list of suggestions.
      setSelectedSuggestion(matchingSuggestions[0]);
    }
  }, [matchingSuggestions, selectedSuggestion]); // Announcements.

  (0,react.useEffect)(() => {
    const hasMatchingSuggestions = matchingSuggestions.length > 0;

    if (isExpanded) {
      const message = hasMatchingSuggestions ? sprintf_sprintf(
      /* translators: %d: number of results. */
      _n('%d result found, use up and down arrow keys to navigate.', '%d results found, use up and down arrow keys to navigate.', matchingSuggestions.length), matchingSuggestions.length) : __('No results.');
      speak(message, 'polite');
    }
  }, [matchingSuggestions, isExpanded]); // Disable reason: There is no appropriate role which describes the
  // input container intended accessible usability.
  // TODO: Refactor click detection to use blur to stop propagation.

  /* eslint-disable jsx-a11y/no-static-element-interactions */

  return (0,react.createElement)(DetectOutside, {
    onFocusOutside: onFocusOutside
  }, (0,react.createElement)(base_control, {
    className: classnames_default()(className, 'components-combobox-control'),
    tabIndex: "-1",
    label: label,
    id: `components-form-token-input-${instanceId}`,
    hideLabelFromVision: hideLabelFromVision,
    help: help
  }, (0,react.createElement)("div", {
    className: "components-combobox-control__suggestions-container",
    tabIndex: "-1",
    onKeyDown: onKeyDown
  }, (0,react.createElement)(flex_component, null, (0,react.createElement)(flex_block_component, null, (0,react.createElement)(token_input, {
    className: "components-combobox-control__input",
    instanceId: instanceId,
    ref: inputContainer,
    value: isExpanded ? inputValue : currentLabel,
    "aria-label": currentLabel ? `${currentLabel}, ${label}` : null,
    onFocus: onFocus,
    onBlur: onBlur,
    isExpanded: isExpanded,
    selectedSuggestionIndex: matchingSuggestions.indexOf(selectedSuggestion),
    onChange: onInputChange
  })), allowReset && (0,react.createElement)(flex_item_component, null, (0,react.createElement)(build_module_button, {
    className: "components-combobox-control__reset",
    icon: close_small,
    disabled: !value,
    onClick: handleOnReset,
    label: __('Reset')
  }))), isExpanded && (0,react.createElement)(suggestions_list, {
    instanceId: instanceId,
    match: {
      label: inputValue
    },
    displayTransform: suggestion => suggestion.label,
    suggestions: matchingSuggestions,
    selectedIndex: matchingSuggestions.indexOf(selectedSuggestion),
    onHover: setSelectedSuggestion,
    onSelect: onSuggestionSelected,
    scrollIntoView: true
  }))));
  /* eslint-enable jsx-a11y/no-static-element-interactions */
}

/* harmony default export */ const combobox_control = (ComboboxControl);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/icons/build-module/library/reset.js


/**
 * WordPress dependencies
 */

const reset_reset = (0,react.createElement)(SVG, {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 24 24"
}, (0,react.createElement)(Path, {
  d: "M7 11.5h10V13H7z"
}));
/* harmony default export */ const library_reset = (reset_reset);
//# sourceMappingURL=reset.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/icons/build-module/library/check.js


/**
 * WordPress dependencies
 */

const check = (0,react.createElement)(SVG, {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 24 24"
}, (0,react.createElement)(Path, {
  d: "M16.7 7.1l-6.3 8.5-3.3-2.5-.9 1.2 4.5 3.4L17.9 8z"
}));
/* harmony default export */ const library_check = (check);
//# sourceMappingURL=check.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/checkbox-control/index.js



/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */




/**
 * Internal dependencies
 */



/**
 * Checkboxes allow the user to select one or more items from a set.
 *
 * ```jsx
 * import { CheckboxControl } from '@wordpress/components';
 * import { useState } from '@wordpress/element';
 *
 * const MyCheckboxControl = () => {
 *   const [ isChecked, setChecked ] = useState( true );
 *   return (
 *     <CheckboxControl
 *       label="Is author"
 *       help="Is the user a author or not?"
 *       checked={ isChecked }
 *       onChange={ setChecked }
 *     />
 *   );
 * };
 * ```
 */
function CheckboxControl( // ref is omitted until we have `WordPressComponentPropsWithoutRef` or add
// ref forwarding to CheckboxControl.
props) {
  const {
    label,
    className,
    heading,
    checked,
    indeterminate,
    help,
    onChange,
    ...additionalProps
  } = props;

  if (heading) {
    deprecated('`heading` prop in `CheckboxControl`', {
      alternative: 'a separate element to implement a heading',
      since: '5.8'
    });
  }

  const [showCheckedIcon, setShowCheckedIcon] = (0,react.useState)(false);
  const [showIndeterminateIcon, setShowIndeterminateIcon] = (0,react.useState)(false); // Run the following callback every time the `ref` (and the additional
  // dependencies) change.

  const ref = useRefEffect(node => {
    if (!node) {
      return;
    } // It cannot be set using an HTML attribute.


    node.indeterminate = !!indeterminate;
    setShowCheckedIcon(node.matches(':checked'));
    setShowIndeterminateIcon(node.matches(':indeterminate'));
  }, [checked, indeterminate]);
  const instanceId = useInstanceId(CheckboxControl);
  const id = `inspector-checkbox-control-${instanceId}`;

  const onChangeValue = event => onChange(event.target.checked);

  return (0,react.createElement)(base_control, {
    label: heading,
    id: id,
    help: help,
    className: classnames_default()('components-checkbox-control', className)
  }, (0,react.createElement)("span", {
    className: "components-checkbox-control__input-container"
  }, (0,react.createElement)("input", extends_extends({
    ref: ref,
    id: id,
    className: "components-checkbox-control__input",
    type: "checkbox",
    value: "1",
    onChange: onChangeValue,
    checked: checked,
    "aria-describedby": !!help ? id + '__help' : undefined
  }, additionalProps)), showIndeterminateIcon ? (0,react.createElement)(icon, {
    icon: library_reset,
    className: "components-checkbox-control__indeterminate",
    role: "presentation"
  }) : null, showCheckedIcon ? (0,react.createElement)(icon, {
    icon: library_check,
    className: "components-checkbox-control__checked",
    role: "presentation"
  }) : null), (0,react.createElement)("label", {
    className: "components-checkbox-control__label",
    htmlFor: id
  }, label));
}
/* harmony default export */ const checkbox_control = (CheckboxControl);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/compose/build-module/hooks/use-previous/index.js
/**
 * WordPress dependencies
 */

/**
 * Use something's value from the previous render.
 * Based on https://usehooks.com/usePrevious/.
 *
 * @param  value The value to track.
 *
 * @return The value from the previous render.
 */

function usePrevious(value) {
  const ref = (0,react.useRef)(); // Store current value in ref.

  (0,react.useEffect)(() => {
    ref.current = value;
  }, [value]); // Re-run when value changes.
  // Return previous value (happens before update in useEffect above).

  return ref.current;
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/is-shallow-equal/build-module/objects.js
/**
 * Returns true if the two objects are shallow equal, or false otherwise.
 *
 * @param {import('.').ComparableObject} a First object to compare.
 * @param {import('.').ComparableObject} b Second object to compare.
 *
 * @return {boolean} Whether the two objects are shallow equal.
 */
function isShallowEqualObjects(a, b) {
  if (a === b) {
    return true;
  }

  const aKeys = Object.keys(a);
  const bKeys = Object.keys(b);

  if (aKeys.length !== bKeys.length) {
    return false;
  }

  let i = 0;

  while (i < aKeys.length) {
    const key = aKeys[i];
    const aValue = a[key];

    if ( // In iterating only the keys of the first object after verifying
    // equal lengths, account for the case that an explicit `undefined`
    // value in the first is implicitly undefined in the second.
    //
    // Example: isShallowEqualObjects( { a: undefined }, { b: 5 } )
    aValue === undefined && !b.hasOwnProperty(key) || aValue !== b[key]) {
      return false;
    }

    i++;
  }

  return true;
}
//# sourceMappingURL=objects.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/is-shallow-equal/build-module/arrays.js
/**
 * Returns true if the two arrays are shallow equal, or false otherwise.
 *
 * @param {any[]} a First array to compare.
 * @param {any[]} b Second array to compare.
 *
 * @return {boolean} Whether the two arrays are shallow equal.
 */
function isShallowEqualArrays(a, b) {
  if (a === b) {
    return true;
  }

  if (a.length !== b.length) {
    return false;
  }

  for (let i = 0, len = a.length; i < len; i++) {
    if (a[i] !== b[i]) {
      return false;
    }
  }

  return true;
}
//# sourceMappingURL=arrays.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/is-shallow-equal/build-module/index.js
/**
 * Internal dependencies
 */




/**
 * @typedef {Record<string, any>} ComparableObject
 */

/**
 * Returns true if the two arrays or objects are shallow equal, or false
 * otherwise.
 *
 * @param {any[]|ComparableObject} a First object or array to compare.
 * @param {any[]|ComparableObject} b Second object or array to compare.
 *
 * @return {boolean} Whether the two values are shallow equal.
 */

function isShallowEqual(a, b) {
  if (a && b) {
    if (a.constructor === Object && b.constructor === Object) {
      return isShallowEqualObjects(a, b);
    } else if (Array.isArray(a) && Array.isArray(b)) {
      return isShallowEqualArrays(a, b);
    }
  }

  return a === b;
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/form-token-field/token.js


/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */




/**
 * Internal dependencies
 */




const token_noop = () => {};

function Token(_ref) {
  let {
    value,
    status,
    title,
    displayTransform,
    isBorderless = false,
    disabled = false,
    onClickRemove = token_noop,
    onMouseEnter,
    onMouseLeave,
    messages,
    termPosition,
    termsCount
  } = _ref;
  const instanceId = useInstanceId(Token);
  const tokenClasses = classnames_default()('components-form-token-field__token', {
    'is-error': 'error' === status,
    'is-success': 'success' === status,
    'is-validating': 'validating' === status,
    'is-borderless': isBorderless,
    'is-disabled': disabled
  });

  const onClick = () => onClickRemove({
    value
  });

  const transformedValue = displayTransform(value);
  const termPositionAndCount = sprintf_sprintf(
  /* translators: 1: term name, 2: term position in a set of terms, 3: total term set count. */
  __('%1$s (%2$s of %3$s)'), transformedValue, termPosition, termsCount);
  return (0,react.createElement)("span", {
    className: tokenClasses,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave,
    title: title
  }, (0,react.createElement)("span", {
    className: "components-form-token-field__token-text",
    id: `components-form-token-field__token-text-${instanceId}`
  }, (0,react.createElement)(visually_hidden_component, {
    as: "span"
  }, termPositionAndCount), (0,react.createElement)("span", {
    "aria-hidden": "true"
  }, transformedValue)), (0,react.createElement)(build_module_button, {
    className: "components-form-token-field__remove-token",
    icon: close_small,
    onClick: !disabled && onClick,
    label: messages.remove,
    "aria-describedby": `components-form-token-field__token-text-${instanceId}`
  }));
}
//# sourceMappingURL=token.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/form-token-field/index.js



/**
 * External dependencies
 */



/**
 * WordPress dependencies
 */






/**
 * Internal dependencies
 */





/**
 * A `FormTokenField` is a field similar to the tags and categories fields in the interim editor chrome,
 * or the "to" field in Mail on OS X. Tokens can be entered by typing them or selecting them from a list of suggested tokens.
 *
 * Up to one hundred suggestions that match what the user has typed so far will be shown from which the user can pick from (auto-complete).
 * Tokens are separated by the "," character. Suggestions can be selected with the up or down arrows and added with the tab or enter key.
 *
 * The `value` property is handled in a manner similar to controlled form components.
 * See [Forms](http://facebook.github.io/react/docs/forms.html) in the React Documentation for more information.
 */
function FormTokenField(props) {
  const {
    autoCapitalize,
    autoComplete,
    maxLength,
    placeholder,
    label = __('Add item'),
    className,
    suggestions = [],
    maxSuggestions = 100,
    value = [],
    displayTransform = lodash.identity,
    saveTransform = token => token.trim(),
    onChange = () => {},
    onInputChange = () => {},
    onFocus = undefined,
    isBorderless = false,
    disabled = false,
    tokenizeOnSpace = false,
    messages = {
      added: __('Item added.'),
      removed: __('Item removed.'),
      remove: __('Remove item'),
      __experimentalInvalid: __('Invalid item')
    },
    __experimentalExpandOnFocus = false,
    __experimentalValidateInput = () => true,
    __experimentalShowHowTo = true
  } = props;
  const instanceId = useInstanceId(FormTokenField); // We reset to these initial values again in the onBlur

  const [incompleteTokenValue, setIncompleteTokenValue] = (0,react.useState)('');
  const [inputOffsetFromEnd, setInputOffsetFromEnd] = (0,react.useState)(0);
  const [isActive, setIsActive] = (0,react.useState)(false);
  const [isExpanded, setIsExpanded] = (0,react.useState)(false);
  const [selectedSuggestionIndex, setSelectedSuggestionIndex] = (0,react.useState)(-1);
  const [selectedSuggestionScroll, setSelectedSuggestionScroll] = (0,react.useState)(false);
  const prevSuggestions = usePrevious(suggestions);
  const prevValue = usePrevious(value);
  const input = (0,react.useRef)(null);
  const tokensAndInput = (0,react.useRef)(null);
  const debouncedSpeak = useDebounce(speak, 500);
  (0,react.useEffect)(() => {
    // Make sure to focus the input when the isActive state is true.
    if (isActive && !hasFocus()) {
      focus();
    }
  }, [isActive]);
  (0,react.useEffect)(() => {
    const suggestionsDidUpdate = !isShallowEqual(suggestions, prevSuggestions || []);

    if (suggestionsDidUpdate || value !== prevValue) {
      updateSuggestions(suggestionsDidUpdate);
    } // TODO: updateSuggestions() should first be refactored so its actual deps are clearer.
    // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [suggestions, prevSuggestions, value, prevValue]);
  (0,react.useEffect)(() => {
    updateSuggestions(); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [incompleteTokenValue]);

  if (disabled && isActive) {
    setIsActive(false);
    setIncompleteTokenValue('');
  }

  function focus() {
    var _input$current;

    (_input$current = input.current) === null || _input$current === void 0 ? void 0 : _input$current.focus();
  }

  function hasFocus() {
    var _input$current2;

    return input.current === ((_input$current2 = input.current) === null || _input$current2 === void 0 ? void 0 : _input$current2.ownerDocument.activeElement);
  }

  function onFocusHandler(event) {
    // If focus is on the input or on the container, set the isActive state to true.
    if (hasFocus() || event.target === tokensAndInput.current) {
      setIsActive(true);
      setIsExpanded(__experimentalExpandOnFocus || isExpanded);
    } else {
      /*
       * Otherwise, focus is on one of the token "remove" buttons and we
       * set the isActive state to false to prevent the input to be
       * re-focused, see componentDidUpdate().
       */
      setIsActive(false);
    }

    if ('function' === typeof onFocus) {
      onFocus(event);
    }
  }

  function onBlur() {
    if (inputHasValidValue()) {
      setIsActive(false);
    } else {
      // Reset to initial state
      setIncompleteTokenValue('');
      setInputOffsetFromEnd(0);
      setIsActive(false);
      setIsExpanded(false);
      setSelectedSuggestionIndex(-1);
      setSelectedSuggestionScroll(false);
    }
  }

  function onKeyDown(event) {
    let preventDefault = false;

    if (event.defaultPrevented) {
      return;
    } // TODO: replace to event.code;


    switch (event.keyCode) {
      case BACKSPACE:
        preventDefault = handleDeleteKey(deleteTokenBeforeInput);
        break;

      case ENTER:
        preventDefault = addCurrentToken();
        break;

      case LEFT:
        preventDefault = handleLeftArrowKey();
        break;

      case UP:
        preventDefault = handleUpArrowKey();
        break;

      case RIGHT:
        preventDefault = handleRightArrowKey();
        break;

      case DOWN:
        preventDefault = handleDownArrowKey();
        break;

      case DELETE:
        preventDefault = handleDeleteKey(deleteTokenAfterInput);
        break;

      case SPACE:
        if (tokenizeOnSpace) {
          preventDefault = addCurrentToken();
        }

        break;

      case ESCAPE:
        preventDefault = handleEscapeKey(event);
        break;

      default:
        break;
    }

    if (preventDefault) {
      event.preventDefault();
    }
  }

  function onKeyPress(event) {
    let preventDefault = false; // TODO: replace to event.code;

    switch (event.charCode) {
      case 44:
        // Comma.
        preventDefault = handleCommaKey();
        break;

      default:
        break;
    }

    if (preventDefault) {
      event.preventDefault();
    }
  }

  function onContainerTouched(event) {
    // Prevent clicking/touching the tokensAndInput container from blurring
    // the input and adding the current token.
    if (event.target === tokensAndInput.current && isActive) {
      event.preventDefault();
    }
  }

  function onTokenClickRemove(event) {
    deleteToken(event.value);
    focus();
  }

  function onSuggestionHovered(suggestion) {
    const index = getMatchingSuggestions().indexOf(suggestion);

    if (index >= 0) {
      setSelectedSuggestionIndex(index);
      setSelectedSuggestionScroll(false);
    }
  }

  function onSuggestionSelected(suggestion) {
    addNewToken(suggestion);
  }

  function onInputChangeHandler(event) {
    const text = event.value;
    const separator = tokenizeOnSpace ? /[ ,\t]+/ : /[,\t]+/;
    const items = text.split(separator);
    const tokenValue = (0,lodash.last)(items) || '';

    if (items.length > 1) {
      addNewTokens(items.slice(0, -1));
    }

    setIncompleteTokenValue(tokenValue);
    onInputChange(tokenValue);
  }

  function handleDeleteKey(_deleteToken) {
    let preventDefault = false;

    if (hasFocus() && isInputEmpty()) {
      _deleteToken();

      preventDefault = true;
    }

    return preventDefault;
  }

  function handleLeftArrowKey() {
    let preventDefault = false;

    if (isInputEmpty()) {
      moveInputBeforePreviousToken();
      preventDefault = true;
    }

    return preventDefault;
  }

  function handleRightArrowKey() {
    let preventDefault = false;

    if (isInputEmpty()) {
      moveInputAfterNextToken();
      preventDefault = true;
    }

    return preventDefault;
  }

  function handleUpArrowKey() {
    setSelectedSuggestionIndex(index => {
      return (index === 0 ? getMatchingSuggestions(incompleteTokenValue, suggestions, value, maxSuggestions, saveTransform).length : index) - 1;
    });
    setSelectedSuggestionScroll(true);
    return true; // PreventDefault.
  }

  function handleDownArrowKey() {
    setSelectedSuggestionIndex(index => {
      return (index + 1) % getMatchingSuggestions(incompleteTokenValue, suggestions, value, maxSuggestions, saveTransform).length;
    });
    setSelectedSuggestionScroll(true);
    return true; // PreventDefault.
  }

  function handleEscapeKey(event) {
    if (event.target instanceof HTMLInputElement) {
      setIncompleteTokenValue(event.target.value);
      setIsExpanded(false);
      setSelectedSuggestionIndex(-1);
      setSelectedSuggestionScroll(false);
    }

    return true; // PreventDefault.
  }

  function handleCommaKey() {
    if (inputHasValidValue()) {
      addNewToken(incompleteTokenValue);
    }

    return true; // PreventDefault.
  }

  function moveInputToIndex(index) {
    setInputOffsetFromEnd(value.length - Math.max(index, -1) - 1);
  }

  function moveInputBeforePreviousToken() {
    setInputOffsetFromEnd(prevInputOffsetFromEnd => {
      return Math.min(prevInputOffsetFromEnd + 1, value.length);
    });
  }

  function moveInputAfterNextToken() {
    setInputOffsetFromEnd(prevInputOffsetFromEnd => {
      return Math.max(prevInputOffsetFromEnd - 1, 0);
    });
  }

  function deleteTokenBeforeInput() {
    const index = getIndexOfInput() - 1;

    if (index > -1) {
      deleteToken(value[index]);
    }
  }

  function deleteTokenAfterInput() {
    const index = getIndexOfInput();

    if (index < value.length) {
      deleteToken(value[index]); // Update input offset since it's the offset from the last token.

      moveInputToIndex(index);
    }
  }

  function addCurrentToken() {
    let preventDefault = false;
    const selectedSuggestion = getSelectedSuggestion();

    if (selectedSuggestion) {
      addNewToken(selectedSuggestion);
      preventDefault = true;
    } else if (inputHasValidValue()) {
      addNewToken(incompleteTokenValue);
      preventDefault = true;
    }

    return preventDefault;
  }

  function addNewTokens(tokens) {
    const tokensToAdd = (0,lodash.uniq)(tokens.map(saveTransform).filter(Boolean).filter(token => !valueContainsToken(token)));

    if (tokensToAdd.length > 0) {
      const newValue = (0,lodash.clone)(value);
      newValue.splice(getIndexOfInput(), 0, ...tokensToAdd);
      onChange(newValue);
    }
  }

  function addNewToken(token) {
    if (!__experimentalValidateInput(token)) {
      speak(messages.__experimentalInvalid, 'assertive');
      return;
    }

    addNewTokens([token]);
    speak(messages.added, 'assertive');
    setIncompleteTokenValue('');
    setSelectedSuggestionIndex(-1);
    setSelectedSuggestionScroll(false);
    setIsExpanded(!__experimentalExpandOnFocus);

    if (isActive) {
      focus();
    }
  }

  function deleteToken(token) {
    const newTokens = value.filter(item => {
      return getTokenValue(item) !== getTokenValue(token);
    });
    onChange(newTokens);
    speak(messages.removed, 'assertive');
  }

  function getTokenValue(token) {
    if ('object' === typeof token) {
      return token.value;
    }

    return token;
  }

  function getMatchingSuggestions() {
    let searchValue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : incompleteTokenValue;

    let _suggestions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : suggestions;

    let _value = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : value;

    let _maxSuggestions = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : maxSuggestions;

    let _saveTransform = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : saveTransform;

    let match = _saveTransform(searchValue);

    const startsWithMatch = [];
    const containsMatch = [];

    const normalizedValue = _value.map(item => {
      if (typeof item === 'string') {
        return item;
      }

      return item.value;
    });

    if (match.length === 0) {
      _suggestions = (0,lodash.difference)(_suggestions, normalizedValue);
    } else {
      match = match.toLocaleLowerCase();

      _suggestions.forEach(suggestion => {
        const index = suggestion.toLocaleLowerCase().indexOf(match);

        if (normalizedValue.indexOf(suggestion) === -1) {
          if (index === 0) {
            startsWithMatch.push(suggestion);
          } else if (index > 0) {
            containsMatch.push(suggestion);
          }
        }
      });

      _suggestions = startsWithMatch.concat(containsMatch);
    }

    return _suggestions.slice(0, _maxSuggestions);
  }

  function getSelectedSuggestion() {
    if (selectedSuggestionIndex !== -1) {
      return getMatchingSuggestions()[selectedSuggestionIndex];
    }

    return undefined;
  }

  function valueContainsToken(token) {
    return (0,lodash.some)(value, item => {
      return getTokenValue(token) === getTokenValue(item);
    });
  }

  function getIndexOfInput() {
    return value.length - inputOffsetFromEnd;
  }

  function isInputEmpty() {
    return incompleteTokenValue.length === 0;
  }

  function inputHasValidValue() {
    return saveTransform(incompleteTokenValue).length > 0;
  }

  function updateSuggestions() {
    let resetSelectedSuggestion = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
    const inputHasMinimumChars = incompleteTokenValue.trim().length > 1;
    const matchingSuggestions = getMatchingSuggestions(incompleteTokenValue);
    const hasMatchingSuggestions = matchingSuggestions.length > 0;
    setIsExpanded(__experimentalExpandOnFocus || inputHasMinimumChars && hasMatchingSuggestions);

    if (resetSelectedSuggestion) {
      setSelectedSuggestionIndex(-1);
      setSelectedSuggestionScroll(false);
    }

    if (inputHasMinimumChars) {
      const message = hasMatchingSuggestions ? sprintf_sprintf(
      /* translators: %d: number of results. */
      _n('%d result found, use up and down arrow keys to navigate.', '%d results found, use up and down arrow keys to navigate.', matchingSuggestions.length), matchingSuggestions.length) : __('No results.');
      debouncedSpeak(message, 'assertive');
    }
  }

  function renderTokensAndInput() {
    const components = (0,lodash.map)(value, renderToken);
    components.splice(getIndexOfInput(), 0, renderInput());
    return components;
  }

  function renderToken(token, index, tokens) {
    const _value = getTokenValue(token);

    const status = typeof token !== 'string' ? token.status : undefined;
    const termPosition = index + 1;
    const termsCount = tokens.length;
    return (0,react.createElement)(Token, {
      key: 'token-' + _value,
      value: _value,
      status: status,
      title: typeof token !== 'string' ? token.title : undefined,
      displayTransform: displayTransform,
      onClickRemove: onTokenClickRemove,
      isBorderless: typeof token !== 'string' && token.isBorderless || isBorderless,
      onMouseEnter: typeof token !== 'string' ? token.onMouseEnter : undefined,
      onMouseLeave: typeof token !== 'string' ? token.onMouseLeave : undefined,
      disabled: 'error' !== status && disabled,
      messages: messages,
      termsCount: termsCount,
      termPosition: termPosition
    });
  }

  function renderInput() {
    const inputProps = {
      instanceId,
      autoCapitalize,
      autoComplete,
      placeholder: value.length === 0 ? placeholder : '',
      key: 'input',
      disabled,
      value: incompleteTokenValue,
      onBlur,
      isExpanded,
      selectedSuggestionIndex
    };
    return (0,react.createElement)(token_input, extends_extends({}, inputProps, {
      onChange: !(maxLength && value.length >= maxLength) ? onInputChangeHandler : undefined,
      ref: input
    }));
  }

  const classes = classnames_default()(className, 'components-form-token-field__input-container', {
    'is-active': isActive,
    'is-disabled': disabled
  });
  let tokenFieldProps = {
    className: 'components-form-token-field',
    tabIndex: -1
  };
  const matchingSuggestions = getMatchingSuggestions();

  if (!disabled) {
    tokenFieldProps = Object.assign({}, tokenFieldProps, {
      onKeyDown,
      onKeyPress,
      onFocus: onFocusHandler
    });
  } // Disable reason: There is no appropriate role which describes the
  // input container intended accessible usability.
  // TODO: Refactor click detection to use blur to stop propagation.

  /* eslint-disable jsx-a11y/no-static-element-interactions */


  return (0,react.createElement)("div", tokenFieldProps, (0,react.createElement)("label", {
    htmlFor: `components-form-token-input-${instanceId}`,
    className: "components-form-token-field__label"
  }, label), (0,react.createElement)("div", {
    ref: tokensAndInput,
    className: classes,
    tabIndex: -1,
    onMouseDown: onContainerTouched,
    onTouchStart: onContainerTouched
  }, renderTokensAndInput(), isExpanded && (0,react.createElement)(suggestions_list, {
    instanceId: instanceId,
    match: saveTransform(incompleteTokenValue),
    displayTransform: displayTransform,
    suggestions: matchingSuggestions,
    selectedIndex: selectedSuggestionIndex,
    scrollIntoView: selectedSuggestionScroll,
    onHover: onSuggestionHovered,
    onSelect: onSuggestionSelected
  })), __experimentalShowHowTo && (0,react.createElement)("p", {
    id: `components-form-token-suggestions-howto-${instanceId}`,
    className: "components-form-token-field__help"
  }, tokenizeOnSpace ? __('Separate with commas, spaces, or the Enter key.') : __('Separate with commas or the Enter key.')));
  /* eslint-enable jsx-a11y/no-static-element-interactions */
}
/* harmony default export */ const form_token_field = (FormTokenField);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/navigable-container/container.js


// @ts-nocheck

/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */




const container_noop = () => {};

const MENU_ITEM_ROLES = ['menuitem', 'menuitemradio', 'menuitemcheckbox'];

function cycleValue(value, total, offset) {
  const nextValue = value + offset;

  if (nextValue < 0) {
    return total + nextValue;
  } else if (nextValue >= total) {
    return nextValue - total;
  }

  return nextValue;
}

class NavigableContainer extends react.Component {
  constructor() {
    super(...arguments);
    this.onKeyDown = this.onKeyDown.bind(this);
    this.bindContainer = this.bindContainer.bind(this);
    this.getFocusableContext = this.getFocusableContext.bind(this);
    this.getFocusableIndex = this.getFocusableIndex.bind(this);
  }

  componentDidMount() {
    // We use DOM event listeners instead of React event listeners
    // because we want to catch events from the underlying DOM tree
    // The React Tree can be different from the DOM tree when using
    // portals. Block Toolbars for instance are rendered in a separate
    // React Trees.
    this.container.addEventListener('keydown', this.onKeyDown);
    this.container.addEventListener('focus', this.onFocus);
  }

  componentWillUnmount() {
    this.container.removeEventListener('keydown', this.onKeyDown);
    this.container.removeEventListener('focus', this.onFocus);
  }

  bindContainer(ref) {
    const {
      forwardedRef
    } = this.props;
    this.container = ref;

    if (typeof forwardedRef === 'function') {
      forwardedRef(ref);
    } else if (forwardedRef && 'current' in forwardedRef) {
      forwardedRef.current = ref;
    }
  }

  getFocusableContext(target) {
    const {
      onlyBrowserTabstops
    } = this.props;
    const finder = onlyBrowserTabstops ? build_module_focus.tabbable : build_module_focus.focusable;
    const focusables = finder.find(this.container);
    const index = this.getFocusableIndex(focusables, target);

    if (index > -1 && target) {
      return {
        index,
        target,
        focusables
      };
    }

    return null;
  }

  getFocusableIndex(focusables, target) {
    const directIndex = focusables.indexOf(target);

    if (directIndex !== -1) {
      return directIndex;
    }
  }

  onKeyDown(event) {
    if (this.props.onKeyDown) {
      this.props.onKeyDown(event);
    }

    const {
      getFocusableContext
    } = this;
    const {
      cycle = true,
      eventToOffset,
      onNavigate = container_noop,
      stopNavigationEvents
    } = this.props;
    const offset = eventToOffset(event); // eventToOffset returns undefined if the event is not handled by the component.

    if (offset !== undefined && stopNavigationEvents) {
      // Prevents arrow key handlers bound to the document directly interfering.
      event.stopImmediatePropagation(); // When navigating a collection of items, prevent scroll containers
      // from scrolling. The preventDefault also prevents Voiceover from
      // 'handling' the event, as voiceover will try to use arrow keys
      // for highlighting text.

      const targetRole = event.target.getAttribute('role');

      if (MENU_ITEM_ROLES.includes(targetRole)) {
        event.preventDefault();
      }
    }

    if (!offset) {
      return;
    }

    const context = getFocusableContext(event.target.ownerDocument.activeElement);

    if (!context) {
      return;
    }

    const {
      index,
      focusables
    } = context;
    const nextIndex = cycle ? cycleValue(index, focusables.length, offset) : index + offset;

    if (nextIndex >= 0 && nextIndex < focusables.length) {
      focusables[nextIndex].focus();
      onNavigate(nextIndex, focusables[nextIndex]);
    }
  }

  render() {
    const {
      children,
      ...props
    } = this.props;
    return (0,react.createElement)("div", extends_extends({
      ref: this.bindContainer
    }, (0,lodash.omit)(props, ['stopNavigationEvents', 'eventToOffset', 'onNavigate', 'onKeyDown', 'cycle', 'onlyBrowserTabstops', 'forwardedRef'])), children);
  }

}

const forwardedNavigableContainer = (props, ref) => {
  return (0,react.createElement)(NavigableContainer, extends_extends({}, props, {
    forwardedRef: ref
  }));
};

forwardedNavigableContainer.displayName = 'NavigableContainer';
/* harmony default export */ const container = ((0,react.forwardRef)(forwardedNavigableContainer));
//# sourceMappingURL=container.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/navigable-container/menu.js


// @ts-nocheck

/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */



/**
 * Internal dependencies
 */


function NavigableMenu(_ref, ref) {
  let {
    role = 'menu',
    orientation = 'vertical',
    ...rest
  } = _ref;

  const eventToOffset = evt => {
    const {
      keyCode
    } = evt;
    let next = [DOWN];
    let previous = [UP];

    if (orientation === 'horizontal') {
      next = [RIGHT];
      previous = [LEFT];
    }

    if (orientation === 'both') {
      next = [RIGHT, DOWN];
      previous = [LEFT, UP];
    }

    if ((0,lodash.includes)(next, keyCode)) {
      return 1;
    } else if ((0,lodash.includes)(previous, keyCode)) {
      return -1;
    } else if ((0,lodash.includes)([DOWN, UP, LEFT, RIGHT], keyCode)) {
      // Key press should be handled, e.g. have event propagation and
      // default behavior handled by NavigableContainer but not result
      // in an offset.
      return 0;
    }
  };

  return (0,react.createElement)(container, extends_extends({
    ref: ref,
    stopNavigationEvents: true,
    onlyBrowserTabstops: false,
    role: role,
    "aria-orientation": role === 'presentation' ? null : orientation,
    eventToOffset: eventToOffset
  }, rest));
}
/* harmony default export */ const menu = ((0,react.forwardRef)(NavigableMenu));
//# sourceMappingURL=menu.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/tab-panel/index.js



/**
 * External dependencies
 */


/**
 * WordPress dependencies
 */



/**
 * Internal dependencies
 */




const tab_panel_noop = () => {};

const TabButton = _ref => {
  let {
    tabId,
    onClick,
    children,
    selected,
    ...rest
  } = _ref;
  return (0,react.createElement)(build_module_button, extends_extends({
    role: "tab",
    tabIndex: selected ? null : -1,
    "aria-selected": selected,
    id: tabId,
    onClick: onClick
  }, rest), children);
};

function TabPanel(_ref2) {
  var _selectedTab$name;

  let {
    className,
    children,
    tabs,
    initialTabName,
    orientation = 'horizontal',
    activeClass = 'is-active',
    onSelect = tab_panel_noop
  } = _ref2;
  const instanceId = useInstanceId(TabPanel, 'tab-panel');
  const [selected, setSelected] = (0,react.useState)(null);

  const handleClick = tabKey => {
    setSelected(tabKey);
    onSelect(tabKey);
  };

  const onNavigate = (childIndex, child) => {
    child.click();
  };

  const selectedTab = (0,lodash.find)(tabs, {
    name: selected
  });
  const selectedId = `${instanceId}-${(_selectedTab$name = selectedTab === null || selectedTab === void 0 ? void 0 : selectedTab.name) !== null && _selectedTab$name !== void 0 ? _selectedTab$name : 'none'}`;
  (0,react.useEffect)(() => {
    const newSelectedTab = (0,lodash.find)(tabs, {
      name: selected
    });

    if (!newSelectedTab) {
      setSelected(initialTabName || (tabs.length > 0 ? tabs[0].name : null));
    }
  }, [tabs]);
  return (0,react.createElement)("div", {
    className: className
  }, (0,react.createElement)(menu, {
    role: "tablist",
    orientation: orientation,
    onNavigate: onNavigate,
    className: "components-tab-panel__tabs"
  }, tabs.map(tab => (0,react.createElement)(TabButton, {
    className: classnames_default()('components-tab-panel__tabs-item', tab.className, {
      [activeClass]: tab.name === selected
    }),
    tabId: `${instanceId}-${tab.name}`,
    "aria-controls": `${instanceId}-${tab.name}-view`,
    selected: tab.name === selected,
    key: tab.name,
    onClick: (0,lodash.partial)(handleClick, tab.name)
  }, tab.title))), selectedTab && (0,react.createElement)("div", {
    key: selectedId,
    "aria-labelledby": selectedId,
    role: "tabpanel",
    id: `${selectedId}-view`,
    className: "components-tab-panel__tab-content"
  }, children(selectedTab)));
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/form-toggle/index.js



/**
 * External dependencies
 */

const form_toggle_noop = () => {};

function FormToggle(_ref) {
  let {
    className,
    checked,
    id,
    disabled,
    onChange = form_toggle_noop,
    ...props
  } = _ref;
  const wrapperClasses = classnames_default()('components-form-toggle', className, {
    'is-checked': checked,
    'is-disabled': disabled
  });
  return (0,react.createElement)("span", {
    className: wrapperClasses
  }, (0,react.createElement)("input", extends_extends({
    className: "components-form-toggle__input",
    id: id,
    type: "checkbox",
    checked: checked,
    onChange: onChange,
    disabled: disabled
  }, props)), (0,react.createElement)("span", {
    className: "components-form-toggle__track"
  }), (0,react.createElement)("span", {
    className: "components-form-toggle__thumb"
  }));
}

/* harmony default export */ const form_toggle = (FormToggle);
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./node_modules/@wordpress/components/build-module/toggle-control/index.js


/**
 * External dependencies
 */

/**
 * WordPress dependencies
 */


/**
 * Internal dependencies
 */



function ToggleControl(_ref) {
  let {
    label,
    checked,
    help,
    className,
    onChange,
    disabled
  } = _ref;

  function onChangeToggle(event) {
    onChange(event.target.checked);
  }

  const instanceId = useInstanceId(ToggleControl);
  const id = `inspector-toggle-control-${instanceId}`;
  let describedBy, helpLabel;

  if (help) {
    describedBy = id + '__help';
    helpLabel = typeof help === 'function' ? help(checked) : help;
  }

  return (0,react.createElement)(base_control, {
    id: id,
    help: helpLabel,
    className: classnames_default()('components-toggle-control', className)
  }, (0,react.createElement)(form_toggle, {
    id: id,
    checked: checked,
    onChange: onChangeToggle,
    "aria-describedby": describedBy,
    disabled: disabled
  }), (0,react.createElement)("label", {
    htmlFor: id,
    className: "components-toggle-control__label"
  }, label));
}
//# sourceMappingURL=index.js.map
;// CONCATENATED MODULE: ./assets/app/dev/admin/core/convertToComboOptions.ts
var convertToComboOptions = function convertToComboOptions(_ref) {
  var data = _ref.data,
      labelKey = _ref.labelKey,
      valueKey = _ref.valueKey;
  return data.map(function (option) {
    var label = option[labelKey];
    var value = option[valueKey];
    return {
      label: label,
      value: value
    };
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/roles/Role.tsx
function Role_ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function Role_objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? Role_ownKeys(Object(source), !0).forEach(function (key) { Role_defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : Role_ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function Role_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function Role_toConsumableArray(arr) { return Role_arrayWithoutHoles(arr) || Role_iterableToArray(arr) || Role_unsupportedIterableToArray(arr) || Role_nonIterableSpread(); }

function Role_nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function Role_iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function Role_arrayWithoutHoles(arr) { if (Array.isArray(arr)) return Role_arrayLikeToArray(arr); }

function Role_slicedToArray(arr, i) { return Role_arrayWithHoles(arr) || Role_iterableToArrayLimit(arr, i) || Role_unsupportedIterableToArray(arr, i) || Role_nonIterableRest(); }

function Role_nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function Role_unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return Role_arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return Role_arrayLikeToArray(o, minLen); }

function Role_arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function Role_iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function Role_arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }










var tabs = [{
  name: 'options',
  title: 'Options'
}, {
  name: 'documents',
  title: 'Documents'
}];
var Role = function Role(_ref) {
  var isNew = _ref.isNew,
      roleId = _ref.roleId;

  var _useState = (0,react.useState)([{
    name: 'Customers',
    hash: '#!/customers'
  }, {
    name: 'Roles',
    hash: '#!/customers/roles'
  }]),
      _useState2 = Role_slicedToArray(_useState, 2),
      breadcrumbs = _useState2[0],
      setBreadcrumbs = _useState2[1];

  var _useState3 = (0,react.useState)([]),
      _useState4 = Role_slicedToArray(_useState3, 2),
      groups = _useState4[0],
      setGroups = _useState4[1];

  var _useState5 = (0,react.useState)(true),
      _useState6 = Role_slicedToArray(_useState5, 2),
      isBusy = _useState6[0],
      setIsBusy = _useState6[1];

  var _useState7 = (0,react.useState)(false),
      _useState8 = Role_slicedToArray(_useState7, 2),
      isOpen = _useState8[0],
      setOpen = _useState8[1];

  var _useState9 = (0,react.useState)([]),
      _useState10 = Role_slicedToArray(_useState9, 2),
      notices = _useState10[0],
      setNotices = _useState10[1];

  var _useState11 = (0,react.useState)([]),
      _useState12 = Role_slicedToArray(_useState11, 2),
      priceSheets = _useState12[0],
      setPriceSheets = _useState12[1];

  var _useState13 = (0,react.useState)({}),
      _useState14 = Role_slicedToArray(_useState13, 2),
      role = _useState14[0],
      setRole = _useState14[1];

  var _useState15 = (0,react.useState)([]),
      _useState16 = Role_slicedToArray(_useState15, 2),
      domains = _useState16[0],
      setDomains = _useState16[1];

  var addDocument = function addDocument() {
    var newDocument = {
      name: '',
      required: false
    };
    var updatedDocuments = role.documents ? [].concat(Role_toConsumableArray(role.documents), [newDocument]) : [newDocument];
    setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
      documents: updatedDocuments
    }));
  };

  var closeModal = function closeModal() {
    return setOpen(false);
  };

  var deleteDocument = function deleteDocument(index) {
    var updatedDocuments = role.documents;
    updatedDocuments.splice(index, 1);
    setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
      documents: updatedDocuments
    }));
  };

  var deleteRole = function deleteRole() {
    setIsBusy(true);
    vfAPI["delete"]("/customer/roles/".concat(role.id)).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        location.assign(location.href.replace("/".concat(role.id.toString()), ''));
      }
    });
  };

  var getGroups = function getGroups() {
    var config = {
      params: {
        rpp: 500 // Override pagination

      }
    };
    vfAPI.get("/groups", config).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        setGroups(convertToComboOptions({
          data: response.data.groups.data,
          labelKey: 'name',
          valueKey: 'group_id'
        }));
      }
    });
  };

  var getPriceSheets = function getPriceSheets() {
    setIsBusy(true);
    var config = {
      params: {
        rpp: 500 // Override pagination

      }
    };
    vfAPI.get("/pricesheets", config).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        setPriceSheets(convertToComboOptions({
          data: response.data.pricesheets.data,
          labelKey: 'sheet',
          valueKey: 'price_sheet_id'
        }));
        setIsBusy(false);
      }
    });
  };

  var getRole = function getRole(id) {
    setIsBusy(true);
    vfAPI.get("/customer/roles/".concat(id)).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        setBreadcrumbs([].concat(Role_toConsumableArray(breadcrumbs), [{
          name: response.data.role.name,
          hash: "#!/customers/roles/".concat(roleId)
        }]));
        setRole(response.data.role);
        setDomains(response.data.role.allowed_email_domains ? response.data.role.allowed_email_domains : []);
        setPriceSheets(convertToComboOptions({
          data: response.data.price_sheets,
          labelKey: 'sheet',
          valueKey: 'price_sheet_id'
        }));
      }

      setIsBusy(false);
    });
  };

  var openModal = function openModal() {
    return setOpen(true);
  };

  var save = function save() {
    setIsBusy(true);
    vfAPI.post("/customer/roles/", role).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        setRole(response.data.role);
      }

      setIsBusy(false);
    });
  };

  var setDocument = function setDocument(document, index) {
    var updatedDocuments = Role_toConsumableArray(role.documents);

    updatedDocuments[index] = document;
    setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
      documents: updatedDocuments
    }));
  };

  var submit = function submit(e) {
    e.preventDefault();

    if (isNew) {
      save();
    } else {
      update();
    }
  };

  var update = function update() {
    setIsBusy(true);
    vfAPI.put("/customer/roles/".concat(role.id), role).then(function (response) {
      setNotices(response.data.notices);

      if (!response.data.errors.length) {
        setRole(response.data.role);
      }

      setIsBusy(false);
    });
  }; // Get Groups when page loads.


  (0,react.useEffect)(function () {
    getGroups();
  }, []); // Get Role if a role ID is passed via props.

  (0,react.useEffect)(function () {
    if (roleId) {
      getRole(roleId);
    }
  }, [roleId]); // Initialize breadcrumb and price sheets if new role.

  (0,react.useEffect)(function () {
    if (isNew) {
      setBreadcrumbs([].concat(Role_toConsumableArray(breadcrumbs), [{
        name: 'Add New',
        hash: '#!/customers/roles/new'
      }]));
      getPriceSheets();
    }
  }, [isNew]); // Update allowed domains when changed. Fixes issue where null value causes FormTokenField component to break.

  (0,react.useEffect)(function () {
    if (domains) {
      setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
        allowed_email_domains: domains
      }));
    }
  }, [domains]); // Redirect from "Add New" to "Edit" route if a role is saved for the first time.

  (0,react.useEffect)(function () {
    if (isNew && role.id) {
      location.assign(location.href.replace('new', role.id.toString()));
    }
  }, [role]);
  return /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
    children: [/*#__PURE__*/(0,jsx_runtime.jsx)(Breadcrumb, {
      breadcrumbs: breadcrumbs
    }), /*#__PURE__*/(0,jsx_runtime.jsx)(Notices, {
      notices: notices
    }), /*#__PURE__*/(0,jsx_runtime.jsxs)("h2", {
      children: [isNew ? 'Add New' : 'Edit', " Role"]
    }), /*#__PURE__*/(0,jsx_runtime.jsx)("form", {
      onSubmit: submit,
      children: /*#__PURE__*/(0,jsx_runtime.jsx)("fieldset", {
        disabled: isBusy,
        children: /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
          className: "row",
          children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
            className: "col-md-5",
            children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("fieldset", {
              children: [/*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                label: "Name (required)",
                value: role.name,
                onChange: function onChange(value) {
                  return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                    name: value
                  }));
                },
                required: true
              }), /*#__PURE__*/(0,jsx_runtime.jsx)(combobox_control, {
                label: "Price Sheet",
                options: priceSheets,
                value: role.price_sheet_id,
                onChange: function onChange(value) {
                  return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                    price_sheet_id: value
                  }));
                }
              }), /*#__PURE__*/(0,jsx_runtime.jsx)(combobox_control, {
                label: "Group",
                options: groups,
                value: role.group_id,
                onChange: function onChange(value) {
                  return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                    group_id: value
                  }));
                }
              }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                label: "Order Prefix",
                value: role.order_prefix,
                onChange: function onChange(value) {
                  return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                    order_prefix: value
                  }));
                }
              }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                label: "Terms",
                value: role.terms,
                onChange: function onChange(value) {
                  return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                    terms: value
                  }));
                }
              }), /*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                label: "Customer Class",
                value: role.customer_class,
                onChange: function onChange(value) {
                  return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                    customer_class: value
                  }));
                }
              }), /*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                label: "Available During Registration",
                checked: role.registration,
                onChange: function onChange(value) {
                  return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                    registration: value
                  }));
                }
              })]
            }), /*#__PURE__*/(0,jsx_runtime.jsxs)("fieldset", {
              children: [/*#__PURE__*/(0,jsx_runtime.jsx)("legend", {
                className: "mt-3",
                children: "Allowed Email Domains"
              }), /*#__PURE__*/(0,jsx_runtime.jsx)(form_token_field, {
                id: "domains",
                label: "Add domain name",
                value: domains,
                onChange: function onChange(tokens) {
                  return setDomains(tokens);
                },
                placeholder: "domain.com, mywebsite.org, example.ca.gov"
              })]
            }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
              className: "hstack gap-1",
              children: [/*#__PURE__*/(0,jsx_runtime.jsxs)(build_module_button, {
                isBusy: isBusy,
                variant: "primary",
                type: "submit",
                children: [isNew ? 'Add New' : 'Update', " Role"]
              }), role.id && /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                isBusy: isBusy,
                isDestructive: true,
                onClick: openModal,
                children: "Delete"
              })]
            })]
          }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
            className: "col-md-7",
            children: /*#__PURE__*/(0,jsx_runtime.jsx)(TabPanel, {
              tabs: tabs,
              children: function children(tab) {
                return /*#__PURE__*/(0,jsx_runtime.jsxs)(card_component, {
                  className: "mb-3",
                  children: [tab.name === 'options' && /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
                    children: [/*#__PURE__*/(0,jsx_runtime.jsx)(card_header_component, {
                      children: tab.title
                    }), /*#__PURE__*/(0,jsx_runtime.jsxs)(card_body_component, {
                      children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("fieldset", {
                        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("legend", {
                          children: "Checkout Options"
                        }), /*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                          label: "Price Availability",
                          checked: role.price_availability,
                          onChange: function onChange(value) {
                            return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                              price_availability: value
                            }));
                          }
                        }), /*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                          label: "Credit Line",
                          checked: role.credit_line,
                          onChange: function onChange(value) {
                            return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                              credit_line: value
                            }));
                          }
                        }), /*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                          label: "Allow Payment",
                          checked: role.allow_payment,
                          onChange: function onChange(value) {
                            return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                              allow_payment: value
                            }));
                          }
                        }), /*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                          label: "Taxable",
                          checked: role.taxable,
                          onChange: function onChange(value) {
                            return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                              taxable: value
                            }));
                          }
                        })]
                      }), /*#__PURE__*/(0,jsx_runtime.jsxs)("fieldset", {
                        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("legend", {
                          children: "Billing and Shipping Options"
                        }), /*#__PURE__*/(0,jsx_runtime.jsxs)(base_control, {
                          id: "locked-addresses",
                          help: "Locking address fields will force any customer assigned to this role to select a previously saved address during checkout.",
                          children: [/*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                            label: "Lock Billing Address fields",
                            checked: role.lock_billing,
                            onChange: function onChange(value) {
                              return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                                lock_billing: value
                              }));
                            }
                          }), /*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                            label: "Lock Shipping Address fields",
                            checked: role.lock_shipping,
                            onChange: function onChange(value) {
                              return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                                lock_shipping: value
                              }));
                            }
                          })]
                        })]
                      }), /*#__PURE__*/(0,jsx_runtime.jsxs)("fieldset", {
                        children: [/*#__PURE__*/(0,jsx_runtime.jsx)("legend", {
                          children: "Punchout Options"
                        }), /*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                          label: "Enable Punchout",
                          checked: role.punchout_only,
                          onChange: function onChange(value) {
                            return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                              punchout_only: value
                            }));
                          }
                        }), role.punchout_only && /*#__PURE__*/(0,jsx_runtime.jsx)(checkbox_control, {
                          label: "Mixed Punchout",
                          checked: role.mixed_punchout,
                          onChange: function onChange(value) {
                            return setRole(Role_objectSpread(Role_objectSpread({}, role), {}, {
                              mixed_punchout: value
                            }));
                          }
                        })]
                      })]
                    })]
                  }), tab.name === 'documents' && /*#__PURE__*/(0,jsx_runtime.jsxs)(jsx_runtime.Fragment, {
                    children: [/*#__PURE__*/(0,jsx_runtime.jsxs)(card_header_component, {
                      children: [tab.title, /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                        variant: "secondary",
                        onClick: addDocument,
                        children: "Add New Document"
                      })]
                    }), /*#__PURE__*/(0,jsx_runtime.jsxs)(card_body_component, {
                      children: [role.documents && role.documents.map(function (document, index) {
                        return /*#__PURE__*/(0,jsx_runtime.jsx)(card_component, {
                          size: "small",
                          children: /*#__PURE__*/(0,jsx_runtime.jsx)(card_body_component, {
                            children: /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
                              className: "row",
                              children: [/*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
                                className: "col",
                                children: [/*#__PURE__*/(0,jsx_runtime.jsx)(text_control, {
                                  label: "Document Name",
                                  value: document.name,
                                  onChange: function onChange(value) {
                                    return setDocument(Role_objectSpread(Role_objectSpread({}, document), {}, {
                                      name: value
                                    }), index);
                                  }
                                }), /*#__PURE__*/(0,jsx_runtime.jsx)(ToggleControl, {
                                  label: "Required",
                                  checked: document.required,
                                  onChange: function onChange(value) {
                                    return setDocument(Role_objectSpread(Role_objectSpread({}, document), {}, {
                                      required: value
                                    }), index);
                                  }
                                })]
                              }), /*#__PURE__*/(0,jsx_runtime.jsx)("div", {
                                className: "col-auto",
                                children: /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                                  label: "Delete document",
                                  isDestructive: true,
                                  icon: "trash",
                                  onClick: function onClick() {
                                    return deleteDocument(index);
                                  }
                                })
                              })]
                            })
                          })
                        }, index);
                      }), (!role.documents || !role.documents.length) && /*#__PURE__*/(0,jsx_runtime.jsx)("p", {
                        children: "No documents found."
                      })]
                    })]
                  })]
                });
              }
            })
          })]
        })
      })
    }), isOpen && /*#__PURE__*/(0,jsx_runtime.jsxs)(modal, {
      title: "Delete this role?",
      onRequestClose: closeModal,
      children: [/*#__PURE__*/(0,jsx_runtime.jsx)("p", {
        children: "This will delete this role."
      }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
        className: "hstack gap-1 justify-content-end",
        children: [/*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
          variant: "secondary",
          onClick: closeModal,
          children: "Cancel"
        }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
          variant: "primary",
          isDestructive: true,
          onClick: deleteRole,
          children: "Delete"
        })]
      })]
    })]
  });
};
;// CONCATENATED MODULE: ./assets/app/dev/admin/roles/RolePage.tsx
function RolePage_typeof(obj) { "@babel/helpers - typeof"; return RolePage_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, RolePage_typeof(obj); }

function RolePage_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function RolePage_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function RolePage_createClass(Constructor, protoProps, staticProps) { if (protoProps) RolePage_defineProperties(Constructor.prototype, protoProps); if (staticProps) RolePage_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function RolePage_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) RolePage_setPrototypeOf(subClass, superClass); }

function RolePage_setPrototypeOf(o, p) { RolePage_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return RolePage_setPrototypeOf(o, p); }

function RolePage_createSuper(Derived) { var hasNativeReflectConstruct = RolePage_isNativeReflectConstruct(); return function _createSuperInternal() { var Super = RolePage_getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = RolePage_getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return RolePage_possibleConstructorReturn(this, result); }; }

function RolePage_possibleConstructorReturn(self, call) { if (call && (RolePage_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return RolePage_assertThisInitialized(self); }

function RolePage_assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function RolePage_isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function RolePage_getPrototypeOf(o) { RolePage_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return RolePage_getPrototypeOf(o); }





var RolePage = /*#__PURE__*/function (_React$Component) {
  RolePage_inherits(RolePage, _React$Component);

  var _super = RolePage_createSuper(RolePage);

  function RolePage(props) {
    var _this;

    RolePage_classCallCheck(this, RolePage);

    _this = _super.call(this, props);
    _this.state = {
      roleId: null,
      isNew: false
    };
    return _this;
  }

  RolePage_createClass(RolePage, [{
    key: "isId",
    value: function isId(value) {
      return Number.isInteger(Number(value));
    }
  }, {
    key: "getId",
    value: function getId(value) {
      return Number(value);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var fragment = location.hash.split('/').pop();

      if (this.isId(fragment)) {
        this.setState({
          roleId: this.getId(fragment)
        });
      } else {
        this.setState({
          isNew: true
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      return /*#__PURE__*/(0,jsx_runtime.jsx)(jsx_runtime.Fragment, {
        children: /*#__PURE__*/(0,jsx_runtime.jsx)(Role, {
          roleId: this.state.roleId,
          isNew: this.state.isNew
        })
      });
    }
  }]);

  return RolePage;
}(react.Component);
;// CONCATENATED MODULE: ./assets/app/dev/admin/roles/roles.module.ts




var RolesModule = angular.module('RolesModule', [RolesRoutingModule]).component('rolesPage', (0,react2angular.react2angular)(RolesPage)).component('rolePage', (0,react2angular.react2angular)(RolePage)).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/taxes/taxes-routing.module.ts

var taxes_routing_module_states = [{
  name: 'taxes',
  url: '/taxes',
  component: 'taxesPage'
}];
var TaxesRoutingModule = angular.module('TaxesRoutingModule', []).config(["$stateProvider", function ($stateProvider) {
  'ngInject';

  taxes_routing_module_states.forEach(function (state) {
    state.onEnter = function () {
      highlightMenuItem('taxes');
    };

    $stateProvider.state(state);
  });
}]).name;
;// CONCATENATED MODULE: ./assets/app/dev/components/taxes/taxes-page.component.html
// Module
var taxes_page_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2>Taxes</h2> <vf-check-auth></vf-check-auth> <wp-notice-list></wp-notice-list> <uib-tabset active=\"$ctrl.activeTab\"> <uib-tab heading=\"Options\"> <taxes-options></taxes-options> </uib-tab> <uib-tab heading=\"Avalara\"> <taxes-avalara ng-if=\"$ctrl.activeTab === 1\"> </taxes-avalara> </uib-tab> </uib-tabset> ";
// Exports
/* harmony default export */ const taxes_page_component = (taxes_page_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/taxes/taxes-page.component.ts
function taxes_page_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function taxes_page_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) taxes_page_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) taxes_page_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function taxes_page_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function taxes_page_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


var TaxesPageComponent = {
  template: taxes_page_component,
  controller: /*#__PURE__*/taxes_page_component_createClass(function TaxesPageController() {
    taxes_page_component_classCallCheck(this, TaxesPageController);

    taxes_page_component_defineProperty(this, "activeTab", 0);

    taxes_page_component_defineProperty(this, "breadcrumbs", [{
      name: 'Taxes',
      state: 'taxes'
    }]);
  })
};
;// CONCATENATED MODULE: ./assets/app/dev/components/taxes/taxes-avalara.component.html
// Module
var taxes_avalara_component_code = "<h3>Avalara</h3> <wp-spinner type=\"2x\" ng-show=\"$ctrl.isLoading\"> </wp-spinner> <div ng-if=\"!$ctrl.isLoading\"> <form name=\"settingsForm\"> <table class=\"form-table\" role=\"presentation\"> <tbody> <tr> <th> <label for=\"accountNumber\"> Account Number <span class=\"description\">(required)</span> </label> </th> <td> <input id=\"accountNumber\" name=\"accountNumber\" type=\"text\" class=\"regular-text\" required ng-model=\"$ctrl.form.account\"/> </td> </tr> <tr> <th> <label for=\"licenseKey\"> License Key <span class=\"description\">(required)</span> </label> </th> <td> <input id=\"licenseKey\" name=\"licenseKey\" type=\"text\" class=\"regular-text\" required ng-model=\"$ctrl.form.license_key\"/> </td> </tr> <tr> <th> <label for=\"environment\"> Environment </label> </th> <td> <select id=\"environment\" name=\"environment\" ng-model=\"$ctrl.form.service_url\"> <option selected=\"selected\" disabled=\"disabled\">Select Environment</option> <option value=\"https://rest.avatax.com\">Production</option> <option value=\"https://sandbox-rest.avatax.com\">Sandbox</option> </select> </td> </tr> <tr> <th> <label for=\"companyCode\"> Company Code </label> </th> <td> <input id=\"companyCode\" name=\"companyCode\" type=\"text\" class=\"regular-text\" ng-model=\"$ctrl.form.company_code\"/> </td> </tr> <tr> <th> <label for=\"shippingCode\"> Shipping Code </label> </th> <td> <input id=\"shippingCode\" name=\"shippingCode\" type=\"text\" class=\"regular-text\" ng-model=\"$ctrl.form.shipping_code\"/> </td> </tr> <tr> <th> <label for=\"addressLine1\"> Address Line 1 <span class=\"description\">(required)</span> </label> </th> <td> <input id=\"addressLine1\" name=\"addressLine1\" type=\"text\" class=\"regular-text\" required ng-model=\"$ctrl.form.street1\"/> </td> </tr> <tr> <th> <label for=\"addressLine2\"> Address Line 2 </label> </th> <td> <input id=\"addressLine2\" name=\"addressLine2\" type=\"text\" class=\"regular-text\" ng-model=\"$ctrl.form.street2\"/> </td> </tr> <tr> <th> <label for=\"city\"> City <span class=\"description\">(required)</span> </label> </th> <td> <input id=\"city\" name=\"city\" type=\"text\" class=\"regular-text\" required ng-model=\"$ctrl.form.city\"/> </td> </tr> <tr> <th> <label for=\"state\"> State <span class=\"description\">(required)</span> </label> </th> <td> <input id=\"state\" name=\"state\" type=\"text\" class=\"small-text\" required ng-model=\"$ctrl.form.state\"/> </td> </tr> <tr> <th> <label for=\"zip\"> Zip <span class=\"description\">(required)</span> </label> </th> <td> <input id=\"zip\" name=\"zip\" type=\"text\" class=\"regular-text\" ng-model=\"$ctrl.form.zip\" required/> </td> </tr> <tr> <th> <label for=\"avataxCalculation\"> AvaTax Calculation </label> </th> <td> <input id=\"avataxCalculation\" name=\"avataxCalculation\" type=\"checkbox\" ng-model=\"$ctrl.form.tax_enabled\"/> </td> </tr> <tr> <th scope=\"row\">Address Validation</th> <td> <label for=\"addressValidation\"> <input id=\"addressValidation\" name=\"addressValidation\" type=\"checkbox\" ng-model=\"$ctrl.form.address_validation\"/> Validate shipping addresses using Avalara </label> </td> </tr> <tr> <th> <label for=\"documentCommitting\"> Document Committing </label> </th> <td> <input id=\"documentCommitting\" name=\"documentCommitting\" type=\"checkbox\" ng-model=\"$ctrl.form.document_committing\"/> </td> </tr> <tr> <th> <label for=\"documentCommitting\"> Logging </label> </th> <td> <input id=\"logging\" name=\"logging\" type=\"checkbox\" ng-model=\"$ctrl.form.logging\"/> </td> </tr> </tbody> </table> </form> <button class=\"btn btn-primary\" ng-click=\"$ctrl.update()\" ng-disabled=\"$ctrl.isUpdating || settingsForm.$invalid\"> {{ $ctrl.isUpdating ? \"Updating\" : \"Update\" }} </button> <button class=\"btn btn-secondary\" ng-click=\"$ctrl.test()\">Test</button> <button class=\"btn btn-secondary\" ng-click=\"$ctrl.viewLog()\"> {{ $ctrl.isGettingLog ? \"Getting\" : \"View\" }} Log </button> <button class=\"btn btn-outline-danger border-0\" ng-click=\"$ctrl.delete()\" ng-disabled=\"$ctrl.isDeleting\"> {{ $ctrl.isDeleting ? \"Deleting\" : \"Delete\" }} Data </button> </div> ";
// Exports
/* harmony default export */ const taxes_avalara_component = (taxes_avalara_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/taxes/taxes-avalara.component.ts
var taxes_avalara_component_class;

function taxes_avalara_component_ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function taxes_avalara_component_objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? taxes_avalara_component_ownKeys(Object(source), !0).forEach(function (key) { taxes_avalara_component_defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : taxes_avalara_component_ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function taxes_avalara_component_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function taxes_avalara_component_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function taxes_avalara_component_createClass(Constructor, protoProps, staticProps) { if (protoProps) taxes_avalara_component_defineProperties(Constructor.prototype, protoProps); if (staticProps) taxes_avalara_component_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function taxes_avalara_component_defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }


var TaxesAvalaraComponent = {
  template: taxes_avalara_component,
  controller: (taxes_avalara_component_class = /*#__PURE__*/function () {
    function TaxesAvalaraController($window, AlertModal, Localized, Utils) {
      taxes_avalara_component_classCallCheck(this, TaxesAvalaraController);

      this.$window = $window;
      this.AlertModal = AlertModal;
      this.Localized = Localized;
      this.Utils = Utils;
      this.baseURL = "".concat(localized.apiURL, "/admin/tax/avalara");
    }

    taxes_avalara_component_createClass(TaxesAvalaraController, [{
      key: "$onInit",
      value: function $onInit() {
        this.getData();
      }
    }, {
      key: "deleteData",
      value: function deleteData() {
        var _this = this;

        this.isDeleting = true;
        this.Utils.httpDelete(this.baseURL).then(function () {
          _this.form = {};
          _this.isDeleting = false;
        });
      }
    }, {
      key: "getData",
      value: function getData() {
        var _this2 = this;

        this.isLoading = true;
        this.Utils.httpGet("".concat(this.baseURL, "/config")).then(function (response) {
          _this2.form = response.avalara_config;
          _this2.isLoading = false;
        });
      }
    }, {
      key: "test",
      value: function test() {
        var _this3 = this;

        this.isLoading = true;
        this.Utils.httpPost("".concat(this.baseURL, "/test"), this.form).then(function (response) {
          var testMessage = 'Avalara connection test successful!';

          if (response.errors.length) {
            testMessage = 'Avalara connection test failed!';
          }

          var callback = {
            confirm: function confirm() {
              this.isLoading = false;
            }
          };

          _this3.AlertModal.Show(callback, 'Connection Test Results', testMessage, 'Ok');
        });
      }
    }, {
      key: "update",
      value: function update() {
        var _this4 = this;

        this.isUpdating = true;

        var data = taxes_avalara_component_objectSpread({}, this.form);

        this.Utils.httpPut("".concat(this.baseURL, "/config"), null, data).then(function (response) {
          if (response.errors.length) {
            response.errors.forEach(function (message) {
              _this4.Localized.setNotification({
                type: 'error',
                message: message
              });
            });
          } else {
            _this4.Localized.setNotification({
              type: 'success',
              message: 'Avalara settings updated.'
            });
          }
        })["finally"](function () {
          _this4.isUpdating = false;
        });
      }
    }, {
      key: "viewLog",
      value: function viewLog() {
        var _this5 = this;

        this.isGettingLog = true;
        this.Utils.httpPost("".concat(this.baseURL, "/log"), this.form).then(function (response) {
          if (response.log) {
            var callback = {
              confirm: function confirm() {
                angular.noop();
              }
            };

            _this5.AlertModal.Show(callback, 'Connection Test Results', response.log, 'Ok');
          } else {
            _this5.Localized.setNotification({
              type: 'info',
              message: 'No saved logs found.'
            });

            _this5.$window.scrollTo({
              top: 0,
              left: 0,
              behavior: 'smooth'
            });
          }
        })["finally"](function () {
          _this5.isGettingLog = false;
        });
      }
    }]);

    return TaxesAvalaraController;
  }(), taxes_avalara_component_defineProperty(taxes_avalara_component_class, "$inject", ['$window', 'AlertModal', 'Localized', 'Utils']), taxes_avalara_component_class)
};
;// CONCATENATED MODULE: ./assets/app/dev/components/taxes/stateOptions.ts
var stateOptions_stateOptions = [{
  name: 'Alabama',
  value: 'AL'
}, {
  name: 'Alaska',
  value: 'AK'
}, {
  name: 'Arizona',
  value: 'AZ'
}, {
  name: 'Arkansas',
  value: 'AR'
}, {
  name: 'California',
  value: 'CA'
}, {
  name: 'Colorado',
  value: 'CO'
}, {
  name: 'Connecticut',
  value: 'CT'
}, {
  name: 'Delaware',
  value: 'DE'
}, {
  name: 'District of Columbia',
  value: 'DC'
}, {
  name: 'Florida',
  value: 'FL'
}, {
  name: 'Georgia',
  value: 'GA'
}, {
  name: 'Hawaii',
  value: 'HI'
}, {
  name: 'Idaho',
  value: 'ID'
}, {
  name: 'Illinois',
  value: 'IL'
}, {
  name: 'Indiana',
  value: 'IN'
}, {
  name: 'Iowa',
  value: 'IA'
}, {
  name: 'Kansas',
  value: 'KS'
}, {
  name: 'Kentucky',
  value: 'KY'
}, {
  name: 'Louisiana',
  value: 'LA'
}, {
  name: 'Maine',
  value: 'ME'
}, {
  name: 'Montana',
  value: 'MT'
}, {
  name: 'Nebraska',
  value: 'NE'
}, {
  name: 'Nevada',
  value: 'NV'
}, {
  name: 'New Hampshire',
  value: 'NH'
}, {
  name: 'New Jersey',
  value: 'NJ'
}, {
  name: 'New Mexico',
  value: 'NM'
}, {
  name: 'New York',
  value: 'NY'
}, {
  name: 'North Carolina',
  value: 'NC'
}, {
  name: 'North Dakota',
  value: 'ND'
}, {
  name: 'Ohio',
  value: 'OH'
}, {
  name: 'Oklahoma',
  value: 'OK'
}, {
  name: 'Oregon',
  value: 'OR'
}, {
  name: 'Maryland',
  value: 'MD'
}, {
  name: 'Massachusetts',
  value: 'MA'
}, {
  name: 'Michigan',
  value: 'MI'
}, {
  name: 'Minnesota',
  value: 'MN'
}, {
  name: 'Mississippi',
  value: 'MS'
}, {
  name: 'Missouri',
  value: 'MO'
}, {
  name: 'Pennsylvania',
  value: 'PA'
}, {
  name: 'Rhode Island',
  value: 'RI'
}, {
  name: 'South Carolina',
  value: 'SC'
}, {
  name: 'South Dakota',
  value: 'SD'
}, {
  name: 'Tennessee',
  value: 'TN'
}, {
  name: 'Texas',
  value: 'TX'
}, {
  name: 'Utah',
  value: 'UT'
}, {
  name: 'Vermont',
  value: 'VT'
}, {
  name: 'Virginia',
  value: 'VA'
}, {
  name: 'Washington',
  value: 'WA'
}, {
  name: 'West Virginia',
  value: 'WV'
}, {
  name: 'Wisconsin',
  value: 'WI'
}, {
  name: 'Wyoming',
  value: 'WY'
}];
;// CONCATENATED MODULE: ./assets/app/dev/components/taxes/TaxesOptions.tsx
function TaxesOptions_typeof(obj) { "@babel/helpers - typeof"; return TaxesOptions_typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, TaxesOptions_typeof(obj); }

function TaxesOptions_classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function TaxesOptions_defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function TaxesOptions_createClass(Constructor, protoProps, staticProps) { if (protoProps) TaxesOptions_defineProperties(Constructor.prototype, protoProps); if (staticProps) TaxesOptions_defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function TaxesOptions_inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) TaxesOptions_setPrototypeOf(subClass, superClass); }

function TaxesOptions_setPrototypeOf(o, p) { TaxesOptions_setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return TaxesOptions_setPrototypeOf(o, p); }

function TaxesOptions_createSuper(Derived) { var hasNativeReflectConstruct = TaxesOptions_isNativeReflectConstruct(); return function _createSuperInternal() { var Super = TaxesOptions_getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = TaxesOptions_getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return TaxesOptions_possibleConstructorReturn(this, result); }; }

function TaxesOptions_possibleConstructorReturn(self, call) { if (call && (TaxesOptions_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return TaxesOptions_assertThisInitialized(self); }

function TaxesOptions_assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function TaxesOptions_isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function TaxesOptions_getPrototypeOf(o) { TaxesOptions_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return TaxesOptions_getPrototypeOf(o); }




 // eslint-disable-next-line @typescript-eslint/no-empty-interface



var stateNames = stateOptions_stateOptions.map(function (state) {
  return state.name;
});
var stateValues = stateOptions_stateOptions.map(function (state) {
  return state.value;
});
var url = "".concat(localized.apiURL, "/admin/tax-states");
var TaxesOptions = /*#__PURE__*/function (_React$Component) {
  TaxesOptions_inherits(TaxesOptions, _React$Component);

  var _super = TaxesOptions_createSuper(TaxesOptions);

  function TaxesOptions(props) {
    var _this;

    TaxesOptions_classCallCheck(this, TaxesOptions);

    _this = _super.call(this, props);
    _this.state = {
      isBusy: false,
      taxStates: [],
      taxStateNames: []
    };
    _this.addAllStates = _this.addAllStates.bind(TaxesOptions_assertThisInitialized(_this));
    _this.handleSubmit = _this.handleSubmit.bind(TaxesOptions_assertThisInitialized(_this));
    _this.removeAllStates = _this.removeAllStates.bind(TaxesOptions_assertThisInitialized(_this));
    _this.setSelectedStates = _this.setSelectedStates.bind(TaxesOptions_assertThisInitialized(_this));
    return _this;
  }

  TaxesOptions_createClass(TaxesOptions, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getData();
    }
  }, {
    key: "addAllStates",
    value: function addAllStates() {
      this.setState({
        taxStates: stateValues
      });
      this.setState({
        taxStateNames: stateNames
      });
    }
  }, {
    key: "getData",
    value: function getData() {
      var _this2 = this;

      this.setState({
        isBusy: true
      });
      vfAPI.get(url).then(function (response) {
        if (response.data.tax_states) {
          _this2.setState({
            taxStates: response.data.tax_states
          });

          _this2.setState({
            taxStateNames: _this2.getStateNames(response.data.tax_states)
          });

          _this2.setState({
            isBusy: false
          });
        }
      });
    }
  }, {
    key: "getStateNames",
    value: function getStateNames(values) {
      return values.map(function (value) {
        return stateOptions_stateOptions.find(function (state) {
          return state.value === value;
        }).name;
      });
    }
  }, {
    key: "getStateValues",
    value: function getStateValues(tokens) {
      return tokens.map(function (token) {
        return stateOptions_stateOptions.find(function (state) {
          return state.name === token;
        }).value;
      });
    }
  }, {
    key: "handleSubmit",
    value: function handleSubmit(e) {
      var _this3 = this;

      e.preventDefault();
      this.setState({
        isBusy: true
      });
      var data = {
        state_id: this.state.taxStates
      };
      vfAPI.post(url, data).then(function (response) {
        if (response.data.success) {
          _this3.setState({
            isBusy: false
          });
        }
      });
    }
  }, {
    key: "removeAllStates",
    value: function removeAllStates() {
      this.setState({
        taxStates: []
      });
      this.setState({
        taxStateNames: []
      });
    }
  }, {
    key: "setSelectedStates",
    value: function setSelectedStates(tokens) {
      var allowedTokens = tokens.filter(function (token) {
        return stateNames.includes(token);
      });
      this.setState({
        taxStateNames: allowedTokens
      });
      this.setState({
        taxStates: this.getStateValues(allowedTokens)
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      return /*#__PURE__*/(0,jsx_runtime.jsx)("form", {
        onSubmit: this.handleSubmit,
        children: /*#__PURE__*/(0,jsx_runtime.jsxs)("fieldset", {
          disabled: this.state.isBusy,
          children: [/*#__PURE__*/(0,jsx_runtime.jsx)("legend", {
            children: "States to collect taxes from"
          }), /*#__PURE__*/(0,jsx_runtime.jsx)(form_token_field, {
            label: "Add States",
            value: this.state.taxStateNames,
            suggestions: stateNames,
            onChange: function onChange(tokens) {
              return _this4.setSelectedStates(tokens);
            },
            placeholder: "California, Oklahoma, District of Columbia, etc."
          }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
            className: "btn-toolbar justify-content-between gap-1",
            children: [/*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
              variant: "primary",
              type: "submit",
              isBusy: this.state.isBusy,
              children: "Update"
            }), /*#__PURE__*/(0,jsx_runtime.jsxs)("div", {
              className: "hstack gap-1",
              children: [/*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                variant: "secondary",
                onClick: this.addAllStates,
                isBusy: this.state.isBusy,
                children: "Add All States"
              }), /*#__PURE__*/(0,jsx_runtime.jsx)(build_module_button, {
                variant: "tertiary",
                isDestructive: true,
                onClick: this.removeAllStates,
                isBusy: this.state.isBusy,
                children: "Remove All States"
              })]
            })]
          })]
        })
      });
    }
  }]);

  return TaxesOptions;
}(react.Component);
;// CONCATENATED MODULE: ./assets/app/dev/components/taxes/taxes.module.ts





var TaxesModule = angular.module('TaxesModule', [TaxesRoutingModule]).component('taxesPage', TaxesPageComponent).component('taxesAvalara', TaxesAvalaraComponent).component('taxesOptions', (0,react2angular.react2angular)(TaxesOptions)).name;
;// CONCATENATED MODULE: ./assets/app/dev/app.module.ts










var AppModule = angular.module('vendorfuelApp', ['ngAnimate', // Required for UI Bootstrap
'ngCookies', 'ngResource', 'ngSanitize', 'ngTouch', // Required for UI Bootstrap
'ui.bootstrap', 'ui.router', 'ui.tinymce', 'slickCarousel', 'LocalStorageModule', 'angular-toArrayFilter', AccountingModule, ComponentsModule, CommonModule, DashboardModule, EmailModule, OrdersModule, PurchasingModule, RolesModule, TaxesModule]).config(["$httpProvider", "$sceDelegateProvider", "$stateProvider", "$urlRouterProvider", "localStorageServiceProvider", function ($httpProvider, $sceDelegateProvider, $stateProvider, $urlRouterProvider, localStorageServiceProvider) {
  'ngInject';

  var templateDir = localized.dir.templates;
  $stateProvider.state('reports', {
    url: '/reports',
    templateUrl: templateDir + '/reports.html',
    controller: 'ReportsController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('reports');
    }
  }).state('payments', {
    url: '/payments',
    templateUrl: templateDir + '/payments.html',
    controller: 'PaymentsController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('payments');
    }
  }).state('subscribe', {
    url: '/subscribe',
    templateUrl: templateDir + '/subscribe.html',
    controller: 'SubscribeController as $ctrl',
    onEnter: function onEnter() {
      highlightMenuItem('subscription');
    },
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state({
    name: 'login',
    url: '/login',
    templateUrl: templateDir + '/login.html',
    controller: 'LoginController as $ctrl'
  }).state('reset-password', {
    url: '/reset-password?code&auth',
    templateUrl: templateDir + '/reset-password.html',
    controller: 'ResetPasswordController as $ctrl',
    params: {
      activeTab: {
        dynamic: true,
        code: null,
        auth: null
      }
    }
  }).state('billing-reset-password', {
    url: '/billing-reset-password?code&auth',
    templateUrl: templateDir + '/billing-reset-password.html',
    controller: 'BillingResetPasswordController as $ctrl',
    params: {
      activeTab: {
        dynamic: true,
        code: null,
        auth: null
      }
    }
  }).state({
    name: 'logout',
    url: '/logout',
    component: 'vfLogout',
    onEnter: function onEnter() {
      highlightMenuItem('logout');
    }
  }).state('tenant-login', {
    url: '/tenant-login',
    templateUrl: templateDir + '/tenant-login.html',
    controller: 'TenantLoginController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('admin', {
    url: '/admin',
    templateUrl: templateDir + '/admin-accounts.html',
    controller: 'AdminAccountsController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('admin');
    }
  }).state('catalog', {
    url: '/catalog',
    component: 'vfCatalog',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('catalog');
    }
  }).state('catalog-products', {
    url: '/catalog-products/:activeTab',
    templateUrl: templateDir + '/catalog-products.html',
    controller: 'CatalogProductsController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      },
      product: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('catalog');
    }
  }).state('catalog-collections', {
    url: '/catalog-colllections/:activeTab',
    templateUrl: templateDir + '/catalog-collections.html',
    controller: 'CatalogCollectionsController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('catalog');
    }
  }).state('catalog-pricesheets', {
    url: '/catalog-pricesheets/:activeTab',
    templateUrl: templateDir + '/catalog-pricesheets.html',
    controller: 'CatalogPricesheetsController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('catalog');
    }
  }).state('catalog-categories', {
    url: '/catalog-categories/:activeTab',
    templateUrl: templateDir + '/catalog-categories.html',
    controller: 'CatalogCategoriesController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('catalog');
    }
  }).state('catalog-promocodes', {
    url: '/catalog-promocodes/:activeTab',
    templateUrl: templateDir + '/catalog-promocodes.html',
    controller: 'CatalogPromoCodesController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('catalog');
    }
  }).state('catalog-uom', {
    url: '/catalog-uom/:activeTab',
    templateUrl: templateDir + '/catalog-uom.html',
    controller: 'CatalogUomController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('catalog');
    }
  }).state('catalog-banners', {
    url: '/catalog-banners/:activeTab',
    templateUrl: templateDir + '/catalog-banners.html',
    controller: 'CatalogBannersController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('catalog');
    }
  }).state({
    name: 'customers',
    url: '/customers',
    "abstract": true,
    onEnter: function onEnter() {
      highlightMenuItem('customers');
    }
  }).state({
    name: 'customers.page',
    url: '',
    component: 'vfCustomers',
    onEnter: function onEnter() {
      highlightMenuItem('customers');
    }
  }).state('customers-groups', {
    url: '/customers-groups/:activeTab',
    templateUrl: templateDir + '/customers-groups.html',
    controller: 'GroupsController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      },
      customer: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('customers');
    }
  }).state('customers-accounts', {
    url: '/customers-accounts/:activeTab',
    component: 'customerAccounts',
    params: {
      activeTab: {
        dynamic: true
      },
      customer: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('customers');
    }
  }).state('shipping', {
    url: '/shipping',
    templateUrl: templateDir + '/shipping.html',
    controller: 'ShippingController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('shipping');
    }
  }).state('shipping-flat-rates', {
    url: '/shipping-flat-rates/:activeTab',
    templateUrl: templateDir + '/shipping-flat-rates.html',
    controller: 'ShippingFlatRatesController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('shipping');
    }
  }).state('shipping-parcels', {
    url: '/shipping-parcels/:activeTab',
    templateUrl: templateDir + '/shipping-parcels.html',
    controller: 'ShippingParcelsController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('shipping');
    }
  }).state('punchout', {
    url: '/punchout',
    component: 'vfPunchout',
    onEnter: function onEnter() {
      highlightMenuItem('punchout');
    }
  }).state('punchout-suppliers', {
    url: '/punchout-suppliers/:activeTab',
    templateUrl: templateDir + '/punchout-suppliers.html',
    controller: 'PunchoutSuppliersController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      },
      product: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('punchout');
    }
  }).state('tutorial', {
    url: '/tutorial',
    component: 'vfTutorial',
    params: {
      activeTab: {
        dynamic: true
      }
    }
  }).state('billing', {
    url: '/billing',
    templateUrl: templateDir + '/billing.html',
    controller: 'BillingController as $ctrl',
    params: {
      activeTab: {
        dynamic: true
      }
    },
    onEnter: function onEnter() {
      highlightMenuItem('billing');
    }
  });
  var states = [{
    name: 'manufacturers',
    url: '/manufacturers',
    "abstract": true,
    template: '<ui-view/>',
    menuSlug: 'catalog'
  }, {
    name: 'manufacturers.index',
    url: '',
    component: 'manufacturersIndex',
    menuSlug: 'catalog'
  }, {
    name: 'manufacturers.create',
    url: '/create',
    component: 'manufacturersDetail',
    menuSlug: 'catalog'
  }, {
    name: 'manufacturers.show',
    url: '/:id',
    component: 'manufacturersDetail',
    menuSlug: 'catalog'
  }, {
    name: 'reviews',
    url: '/products/reviews',
    "abstract": true,
    template: '<ui-view/>',
    menuSlug: 'catalog'
  }, {
    name: 'reviews.index',
    url: '',
    component: 'reviewsIndex',
    menuSlug: 'catalog'
  }, {
    name: 'reviews.show',
    url: '/:id',
    component: 'reviewsDetail',
    menuSlug: 'catalog'
  }];
  states.forEach(function (item) {
    var menuSlug = item.menuSlug;
    var state = item;

    state.onEnter = function () {
      highlightMenuItem(menuSlug);
    };

    $stateProvider.state(state);
  });
  $httpProvider.interceptors.push('vfAdminInterceptor');
  localStorageServiceProvider.setPrefix('vf').setStorageCookie(0, '/', false).setStorageType('sessionStorage');
  $sceDelegateProvider.resourceUrlWhitelist([// Allow same origin resource loads.
  'self', // Allow loading from our assets domain.  Notice the difference between * and **.
  'https://*.payfabric.com/**']);
}]).name;
// EXTERNAL MODULE: ./assets/app/dev/components/catalog/catalog.component.ts
var catalog_component = __webpack_require__(8227);
// EXTERNAL MODULE: ./assets/app/dev/components/customers/customers.component.ts
var customers_component = __webpack_require__(4999);
// EXTERNAL MODULE: ./assets/app/dev/components/header/header.component.ts
var header_component = __webpack_require__(3685);
;// CONCATENATED MODULE: ./assets/app/dev/components/logout/logout.component.html
// Module
var logout_component_code = "<div class=\"d-flex align-items-center\"> <strong>Signing out...</strong> <div class=\"spinner is-active ml-auto\" role=\"status\" aria-hidden=\"true\"></div> </div>";
// Exports
/* harmony default export */ const logout_component = (logout_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/logout/logout.component.ts

/**
 * Log Out Component
 *
 * @namespace Components
 */

(function () {
  'use strict';

  LogoutController.$inject = ["$state", "Admin", "Localized", "Utils"];
  angular.module('vendorfuelApp').component('vfLogout', {
    controller: LogoutController,
    template: logout_component
  });
  LogoutController.$inject = ['$state', 'Admin', 'Localized', 'Utils'];
  /**
   * @param {Object} $state    UI Router service
   * @param {Object} Admin     VendorFuel service
   * @param {Object} Localized VendorFuel service
   * @param {Object} Utils     VendorFuel service
   */

  function LogoutController($state, Admin, Localized, Utils) {
    this.$onInit = function () {
      if (Admin.Authed()) {
        Admin.Logout();
        $state.go('login');
      } else if (Localized.api_key) {
        Utils.setLocation('/login', true);
      } else {
        Utils.setLocation('/subscribe', true);
      }
    };
  }
})();
// EXTERNAL MODULE: ./assets/app/dev/components/manufacturers/manufacturers-index.component.ts
var manufacturers_index_component = __webpack_require__(9563);
// EXTERNAL MODULE: ./assets/app/dev/components/manufacturers/manufacturers-detail.component.ts
var manufacturers_detail_component = __webpack_require__(5386);
// EXTERNAL MODULE: ./assets/app/dev/components/manufacturers/manufacturers.factory.ts
var manufacturers_factory = __webpack_require__(3915);
;// CONCATENATED MODULE: ./assets/app/dev/components/manufacturers/index.ts



// EXTERNAL MODULE: ./assets/app/dev/components/products/products.factory.ts
var products_factory = __webpack_require__(9537);
;// CONCATENATED MODULE: ./assets/app/dev/common/tinymce-options.ts
var tinymceOptions = {
  plugins: 'charmap code image link lists'
};
;// CONCATENATED MODULE: ./assets/app/dev/components/products/catalog-products.controller.ts


(function () {
  'use strict';

  CatalogProductsController.$inject = ["$scope", "$rootScope", "$state", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized", "Products", "SearchModal", "$timeout", "$window"];
  angular.module('vendorfuelApp').controller('CatalogProductsController', CatalogProductsController);
  CatalogProductsController.$inject = ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'Products', 'SearchModal', '$timeout', '$window'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $state       UI Router service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} Products     VendorFuel service
   * @param {Object} SearchModal  VendorFuel service
   * @param {Object} $timeout     Angular service
   * @param {Object} $window      Angular service
   */

  function CatalogProductsController($scope, $rootScope, $state, $stateParams, Admin, Settings, Debug, Utils, Localized, Products, SearchModal, $timeout, $window) {
    var _this = this;

    var vm = this;
    this.placeholderImg = "".concat(localized.dir.url, "assets/img/placeholder-150px.png");
    this.tinymceOptions = tinymceOptions;
    vm.searchOptions = {
      product_id: 'ID',
      description: 'Name',
      sku: 'SKU'
    };
    /**
     * Initialization
     */

    this.init = function () {
      vm.productSlug = localized.settings.general.product_slug || 'products';
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Products',
        state: 'catalog-products'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab) || 0;
      $scope.attributesLength = 36;
      $scope.batchEndpoint = Localized.apiURL + '/admin/product/batch/';
      $scope.batchListOptions = {
        any: 'All',
        pending: 'Pending',
        confirmed: 'Confirmed',
        processing: 'Processing',
        processed: 'Processed'
      };
      $scope.isAuthed = Admin.Authed();
      $scope.loading = true;
      $scope.loadingMore = false;
      $scope.maxAttributes = 18;
      $scope.myFile = {};
      _this.product = {
        status: 'active',
        images: {},
        pricesheets: [],
        parcels: [],
        meta: {}
      };
      $scope.noteParams = {
        note: ''
      };
      $scope.numAttributes = [];
      $scope.parcelWeightUnits = {
        lb: 'Pounds',
        kg: 'Kilograms'
      };
      $scope.productEndpoint = Localized.apiURL + '/admin/products/';
      $scope.productNotes = [];
      $scope.products = [];
      $scope.productsFactory = Products;
      $scope.regValues = [{
        key: '1',
        value: 'Yes'
      }, {
        key: '0',
        value: 'No'
      }];
      $scope.removingImage = false;
      $scope.rppValues = [15, 30, 50, 100];
      $scope.saved = false;
      $scope.saving = false;
      $scope.scrollSlides = 0;
      $scope.savingNote = false;
      $scope.searchModalPage = '';
      $scope.searchTerm = '';
      $scope.selectedBatch = null;
      $scope.selectedProduct = $stateParams.product || null;
      $scope.slides = 0;
      $scope.sortBatchParams = {
        sort_by: 'batch_id',
        sort_type: '',
        status: 'any'
      };
      vm.searchParams = {
        page: 1,
        rpp: $scope.rppValues[0] // Must define after rppValues is declared.

      };

      if ($scope.activeTab === 2 && !$scope.selectedProduct || $scope.activeTab === 5 && !$scope.selectedBatch) {
        $scope.activeTab = 0;
      }
    };

    this.init();

    this.tabChanged = function (i) {
      $scope.activeTab = i;
      $state.go('catalog-products', {
        activeTab: $scope.activeTab
      });
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      $scope.cancelled = false;
      var req = {
        method: 'GET',
        url: $scope.productEndpoint
      };

      switch (i) {
        case 0:
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.products = resp.products;
            $scope.totalProducts = resp.products.total;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          _this.slickSetup();

          $scope.loading = false;
          break;

        case 2:
          // eslint-disable-next-line no-var
          var done = 0,
              total = 2;
          req.url += $scope.selectedProduct.product_id;
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.selectedProduct = resp.product;
            $scope.numAttributes = []; // eslint-disable-next-line no-shadow

            for (var _i = 1; _i <= 18; _i++) {
              if ($scope.selectedProduct['att' + _i + 'n'] || $scope.selectedProduct['att' + _i + 'd']) {
                $scope.numAttributes.push(_i);
              }
            }

            if (!$scope.selectedProduct.meta) {
              $scope.selectedProduct.meta = {};
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            if (++done >= total) {
              $scope.loading = false;
            }

            _this.slickSetup();
          });
          req = {
            method: 'GET',
            url: Localized.apiURL + '/admin/product/note',
            params: {
              product_id: $scope.selectedProduct.product_id
            }
          };
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.productNotes = resp.notes;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            if (++done >= total) {
              $scope.loading = false;
            }
          });
          break;

        case 3:
          $scope.loading = false;
          break;

        case 4:
          req = {
            method: 'GET',
            url: $scope.batchEndpoint,
            params: $scope.sortBatchParams
          };
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.batches = resp.search_results; // eslint-disable-next-line no-shadow

            for (var _i2 = 0; _i2 < $scope.batches.length; _i2++) {
              if ($scope.batches[_i2].status === 'processing') {
                _this.updateBatchProgress();

                break;
              }
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 5:
          req = {
            method: 'GET',
            url: $scope.batchEndpoint + $scope.selectedBatch.batch_id
          };
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.selectedBatch = resp.batches[0];
            $scope.batchHeaders = resp.batches[0].columns;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        default:
          $scope.loading = false;
          break;
      }
    };
    /**
     * @param {number} productIndex Product index
     * @param {Object} e            Click event
     */


    this.editProduct = function (productIndex, e) {
      if (e) {
        e.preventDefault();
      }

      var tabIndex = 2;
      $scope.activeTab = tabIndex;
      $scope.selectedProduct = $scope.products.data[productIndex];
    };
    /*
    	* Attributes
    	*/


    this.addAttribute = function () {
      if ($scope.numAttributes.length >= $scope.maxAttributes) {
        return;
      }

      var i = 1;

      while ($scope.numAttributes.indexOf(i) !== -1) {
        i++;
      }

      $scope.numAttributes.push(i);
    };

    this.removeAttribute = function (i) {
      if ($scope.activeTab === 1) {
        $scope.numAttributes.splice(i - 1, 1);
        _this.product['att' + i + 'n'] = '';
        _this.product['att' + i + 'd'] = '';
      } else if ($scope.activeTab === 2) {
        $scope.numAttributes.splice(i - 1, 1);
        $scope.selectedProduct['att' + i + 'n'] = '';
        $scope.selectedProduct['att' + i + 'd'] = '';
      }
    };
    /*
    	* Utilities
    	*/


    this.syncProductWPPosts = function () {
      var params = {};
      var data = {};
      Utils.httpGet(Localized.wpRestUrl + '/syncProductPosts', params, data).then(function () {
        $scope.saving = false;
      });
    };

    this.generateSlugs = function () {
      var req = {
        method: 'POST',
        url: $scope.productEndpoint + 'slug/generate'
      };
      Utils.getHttpPromise(req).then(function () {
        angular.noop();
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    this.searchProducts = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: $scope.productEndpoint,
        params: vm.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.products = resp.products;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    this.setPage = function (page) {
      _this.searchParams.page = page;

      _this.searchProducts();
    };

    this.setRpp = function (rpp) {
      _this.searchParams.rpp = rpp;

      _this.searchProducts();
    };

    this.setQuery = function (query, searchBy) {
      _this.searchParams.page = 1; // Reset page when query changes.

      _this.searchParams.q = query;
      _this.searchParams.searchBy = searchBy;
      $scope.searchTerm = _this.searchParams.q;
      _this.searchedBy = _this.searchParams.searchBy;

      _this.searchProducts();
    };

    this.addProduct = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: $scope.productEndpoint,
        data: _this.product
      };
      Utils.getHttpPromise(req).then(function (response) {
        if (!response.errors.length) {
          $scope.selectedProduct = {
            product_id: response.product_id
          };
          $scope.activeTab = 2;
          _this.product = {
            status: 'active',
            images: {},
            pricesheets: [],
            parcels: []
          };
          var params = {
            id: response.product_id
          };
          var data = {};
          Utils.httpGet(Localized.wpRestUrl + '/syncProductPosts', params, data).then(function () {
            $scope.loading = false;
          });
        }
      }, function (errResp) {
        Debug.log(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    this.checkImageLength = function () {
      if ($scope.activeTab === 2) {
        if ($scope.selectedProduct.images && Object.keys($scope.selectedProduct.images).length > 1) {
          if (Object.keys($scope.selectedProduct.images).length >= 4) {
            $scope.slides = 3;
            $scope.scrollSlides = 3;
          } else {
            $scope.slides = Object.keys($scope.selectedProduct.images).length - 1;
            $scope.scrollSlides = 1;
          }
        } else {
          $scope.slides = 1;
          $scope.scrollSlides = 2;
        }
      } else if ($scope.activeTab === 1) {
        if (_this.product.images && Object.keys(_this.product.images).length > 1) {
          if (Object.keys(_this.product.images).length >= 4) {
            $scope.slides = 3;
            $scope.scrollSlides = 3;
          } else {
            $scope.slides = Object.keys(_this.product.images).length - 1;
            $scope.scrollSlides = 1;
          }
        } else {
          $scope.slides = 1;
          $scope.scrollSlides = 2;
        }
      }
    };

    this.openCatSearch = function () {
      $scope.searchModalPage = 'cat';
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/category/',
            params: {
              q: ''
            }
          },
          relationships: ['categories'],
          fields: ['cat_id', 'title', 'parent_id'],
          fieldPrefixes: ['ID: ', '', 'Parent ID: '],
          id: 'cat_id',
          selectOne: true
        }]
      };
      callback = {
        confirm: _this.searchResults,
        cancel: _this.searchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Categories', data, 'Add items');
    };

    this.openMediaFrame = function () {
      // eslint-disable-next-line no-undef
      var fileFrame = wp.media({
        title: 'Select or Upload image',
        library: {
          type: 'image'
        },
        button: {
          text: 'Select'
        },
        multiple: false
      });
      fileFrame.on('select', function () {
        // We set multiple to false so only get one image from the uploader
        $scope.$apply(function () {
          $scope.attachment = fileFrame.state().get('selection').first().toJSON();
          $scope.removingImage = true;
          var assigned = false,
              i = 0;

          if ($scope.activeTab === 2) {
            while (!assigned) {
              // eslint-disable-next-line no-prototype-builtins
              if ($scope.selectedProduct.images.hasOwnProperty('new' + i)) {
                i++;
              } else {
                $scope.selectedProduct.images[i] = {
                  orig_url: $scope.attachment.sizes.full.url,
                  url: $scope.attachment.sizes.thumbnail.url
                };
                assigned = true;
              }
            }
          } else if ($scope.activeTab === 1) {
            while (!assigned) {
              // eslint-disable-next-line no-prototype-builtins
              if (_this.product.images.hasOwnProperty('new' + i)) {
                i++;
              } else {
                _this.product.images[i] = {
                  orig_url: $scope.attachment.sizes.full.url,
                  url: $scope.attachment.sizes.thumbnail.url
                };
                assigned = true;
              }
            }
          }

          _this.checkImageLength();

          $scope.slickConfig.slidesToShow = $scope.slides;
          $scope.slickConfig.slidesToScroll = $scope.scrollSlides;
          $timeout(function () {
            $scope.removingImage = false;
          }, 500);
        });
      }); // Finally, open the modal

      fileFrame.open();
    };

    this.openMfgSearch = function () {
      $scope.searchModalPage = 'mfg';
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/manufacturers/',
            params: {
              q: ''
            }
          },
          relationships: ['manufacturers'],
          fields: ['id', 'manufacturer', 'info', 'website'],
          fieldPrefixes: ['', '', 'Info: ', 'Website: '],
          id: 'id',
          selectOne: true
        }]
      };
      callback = {
        confirm: _this.searchResults,
        cancel: _this.searchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Manufacturers', data, 'Add items');
    };

    this.openPsSearch = function () {
      $scope.searchModalPage = 'ps';
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/pricesheets/',
            params: {
              q: ''
            }
          },
          relationships: ['pricesheets'],
          fields: ['price_sheet_id', 'sheet'],
          fieldPrefixes: ['ID: ', ''],
          id: 'price_sheet_id',
          selectOne: false
        }]
      };
      callback = {
        confirm: _this.searchResults,
        cancel: _this.searchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Price Sheets', data, 'Add items');
    };

    this.openParcelSearch = function () {
      $scope.searchModalPage = 'parcel';
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: Localized.apiURL + '/admin/shipping/parcel/',
            params: {
              q: ''
            }
          },
          relationships: ['parcels'],
          fields: ['id', 'title'],
          fieldPrefixes: ['ID: ', ''],
          id: 'id',
          selectOne: false
        }]
      };
      callback = {
        confirm: _this.searchResults,
        cancel: _this.searchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Parcels', data, 'Add items');
    };

    this.removeImage = function (i) {
      $scope.removingImage = true;

      if ($scope.activeTab === 1) {
        delete _this.product.images[i];
      } else if ($scope.activeTab === 2) {
        if ($scope.selectedProduct.images[i].wpImg) {
          delete $scope.selectedProduct.images[i];
        } else {
          $scope.selectedProduct.images[i].deleted = true;
        }
      }

      _this.checkImageLength();

      $scope.slickConfig.slidesToShow = $scope.slides;
      $scope.slickConfig.slidesToScroll = $scope.scrollSlides;
      $timeout(function () {
        $scope.removingImage = false;
      }, 500);
    };

    this.removeParcel = function (i) {
      if ($scope.activeTab === 1) {
        _this.product.parcels.splice(i, 1);
      } else if ($scope.activeTab === 2) {
        $scope.selectedProduct.parcels.splice(i, 1);
      }
    };

    this.removePricesheet = function (i) {
      if ($scope.activeTab === 1) {
        _this.product.pricesheets.splice(i, 1);
      } else if ($scope.activeTab === 2) {
        $scope.selectedProduct.pricesheets[i].deleted = true;
      }
    };

    this.searchCancelled = function () {
      angular.noop();
    };

    this.searchResults = function (resp) {
      if ($scope.activeTab === 1) {
        switch ($scope.searchModalPage) {
          case 'mfg':
            _this.product.manufacturer_id = resp[0].value.id;
            _this.product.manufacturer = resp[0].value.name;
            break;

          case 'cat':
            _this.product.category_id = resp[0].value.cat_id;
            _this.product.category = resp[0].value;
            break;

          case 'ps':
            for (var i = 0; i < resp.length; i++) {
              var skip = false;

              for (var j = 0; j < _this.product.pricesheets.length; j++) {
                if (resp[i].value.price_sheet_id === _this.product.pricesheets[j].price_sheet_id) {
                  skip = true;
                  break;
                }
              }

              if (!skip) {
                _this.product.pricesheets.push({
                  pricesheetindex: resp[i].value,
                  ps_item_id: 0,
                  price_sheet_id: resp[i].value.price_sheet_id,
                  price: 0
                });
              }
            }

            break;

          case 'parcel':
            for (var k = 0; k < resp.length; k++) {
              var skip2 = false;

              for (var l = 0; l < _this.product.parcels.length; l++) {
                if (resp[k].value.id === _this.product.parcels[l].id) {
                  skip2 = true;
                  break;
                }
              }

              if (!skip2) {
                _this.product.parcels.push(resp[k].value);

                _this.product.parcels[_this.product.parcels.length - 1].pivot = {
                  parcel_id: resp[k].value.id,
                  weight: '',
                  mass_unit: ''
                };
              }
            }

            break;
        }
      } else if ($scope.activeTab === 2) {
        switch ($scope.searchModalPage) {
          case 'mfg':
            $scope.selectedProduct.manufacturer_id = resp[0].value.id;
            $scope.selectedProduct.manufacturer = resp[0].value;
            break;

          case 'cat':
            $scope.selectedProduct.category_id = resp[0].value.cat_id;
            $scope.selectedProduct.category = resp[0].value;
            break;

          case 'ps':
            for (var q = 0; q < resp.length; q++) {
              var skip3 = false;

              for (var r = 0; r < $scope.selectedProduct.pricesheets.length; r++) {
                if (resp[q].value.price_sheet_id === $scope.selectedProduct.pricesheets[r].price_sheet_id) {
                  skip3 = true;
                  $scope.selectedProduct.pricesheets[r].deleted = false;
                  $scope.selectedProduct.pricesheets[r].price = 0.00;
                  break;
                }
              }

              if (!skip3) {
                $scope.selectedProduct.pricesheets.push({
                  pricesheetindex: resp[q].value,
                  ps_item_id: 0,
                  price_sheet_id: resp[q].value.price_sheet_id,
                  price: 0,
                  product_id: $scope.selectedProduct.product_id,
                  sku: $scope.selectedProduct.sku
                });
              }
            }

            break;

          case 'parcel':
            for (var t = 0; t < resp.length; t++) {
              var skip4 = false;

              for (var y = 0; y < $scope.selectedProduct.parcels.length; y++) {
                if (resp[t].value.id === $scope.selectedProduct.parcels[y].id) {
                  skip4 = true;
                  break;
                }
              }

              if (!skip4) {
                $scope.selectedProduct.parcels.push(resp[t].value);
                $scope.selectedProduct.parcels[$scope.selectedProduct.parcels.length - 1].pivot = {
                  parcel_id: resp[t].value.id,
                  product_id: $scope.selectedProduct.product_id,
                  weight: '',
                  mass_unit: ''
                };
              }
            }

            break;
        }
      }
    };
    /*
    	* Batches
    	*/


    $scope.SetUploading = function () {
      // eslint-disable-next-line no-shadow
      $scope.$apply(function ($scope) {
        $scope.uploading = !$scope.uploading;
      });
    };

    $scope.setFile = function (element) {
      // eslint-disable-next-line no-shadow
      $scope.$apply(function ($scope) {
        $scope.theFile = element.files[0];
      });
      var totalBytes = $scope.theFile.size;

      if (totalBytes < 1000000) {
        $scope.fileSize = Math.floor(totalBytes / 1000) + 'KB';
      } else {
        $scope.fileSize = Math.floor(totalBytes / 1000000) + 'MB';
      }

      var regex = /^([a-zA-Z0-9\s_\\.\-:])+(.csv|.txt)$/;

      if (regex.test($scope.theFile.name.toLowerCase())) {
        if (typeof FileReader !== 'undefined') {
          var reader = new FileReader();

          reader.onload = function () {
            // eslint-disable-next-line no-undef
            Papa.parse(reader.result, {
              complete: function complete(results) {
                var products = [];

                var _loop = function _loop(i) {
                  var info = results.data[i];
                  var product = []; // eslint-disable-next-line no-loop-func

                  angular.forEach(info, function (val, key) {
                    product[key] = val;
                  });
                  products.push(product);
                };

                for (var i = 0; i <= results.data.length; i++) {
                  _loop(i);
                }

                $scope.$apply(function () {
                  $scope.prodSheetUpload = products;
                  $scope.IsVisible = true;
                });
              }
            });
            $scope.SetUploading();
          };

          reader.readAsText($scope.theFile);
        } else {
          $window.alert('This browser does not support HTML5.');
        }
      } else {
        $scope.theFile = null;
        $scope.prodSheetUpload = null;
        $scope.SetUploading();
        $window.alert('Please upload a valid CSV file.');
      }
    };

    this.slickSetup = function () {
      _this.checkImageLength();

      $scope.slickConfig = {
        enabled: true,
        arrows: true,
        slidesToShow: $scope.slides,
        slidesToScroll: $scope.scrollSlides,
        autoplay: true,
        draggable: true,
        autoplaySpeed: 3000,
        method: {},
        event: {
          beforeChange: function beforeChange() {
            angular.noop();
          },
          afterChange: function afterChange() {
            angular.noop();
          }
        }
      };
    };
    /**
     * @param {string} sortBy Sortby term
     * @param {Object} e      Click event
     */


    this.changeSortBy = function (sortBy, e) {
      e.preventDefault();
      vm.sortAscending = vm.searchParams.sortBy === sortBy ? !vm.sortAscending : true;
      vm.searchParams.sortBy = sortBy;
      vm.searchParams.sortType = vm.sortAscending ? 'asc' : 'desc';

      _this.searchProducts(vm.searchParams.page);
    };

    this.updateProduct = function () {
      $scope.loading = true;
      var req = {
        method: 'PUT',
        url: $scope.productEndpoint + $scope.selectedProduct.product_id,
        data: $scope.selectedProduct
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.activeTab = 2;
        var req2 = {
          method: 'GET',
          url: Localized.wpRestUrl + '/syncProductPosts',
          params: {
            id: resp.product_id
          }
        };
        Utils.getHttpPromise(req2) // eslint-disable-next-line no-shadow
        .then(function () {
          $scope.loading = false;
        });
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    this.copyProduct = function (product) {
      var _product$attributes;

      _this.product = {
        description: "".concat(product.description, " copy"),
        sku: '',
        status: 'active',
        images: {},
        pricesheets: [],
        parcels: [],
        meta: {}
      }; // Loop through product props and add only if it exists, or the API will complain.

      var keys = ['upc', 'categories', 'uomid', 'uomdesc', 'includes', 'brand_name', 'long_description', 'mfg_part_num', 'ability_one_sku', 'green_attributes', 'hazmat', 'country', 'keywords', 'related', 'alernates', 'device', 'family', 'model', 'avatax_tax_code', 'prop65_warning', 'site_id', 'manufacturer_id', 'category_id', 'uomqty', 'rebate', 'green', 'truck_only', 'prop65', 'ignore_inventory', 'additional_shipping'];
      keys.forEach(function (key) {
        if (product[key]) {
          _this.product[key] = product[key];
        }
      }); // Loop through array props.

      var arrayKeys = ['documents'];
      arrayKeys.forEach(function (key) {
        if (product[key].length) {
          _this.product[key] = product[key];
        }
      }); // Loop through attributes.

      if ((_product$attributes = product.attributes) !== null && _product$attributes !== void 0 && _product$attributes.length) {
        product.attributes.forEach(function (attribute, index) {
          _this.product["att".concat(index + 1, "n")] = attribute.name;
          _this.product["att".concat(index + 1, "d")] = attribute.value;
        });
      }

      _this.tabChanged(1);
    };

    this.postUpload = function (index, id) {
      $scope.selectedBatch = {
        batch_id: id
      };
      $scope.activeTab = index;
    };

    this.uploadProduct = function () {
      $scope.loading = true;
      var fd = new FormData();
      fd.append('file', $scope.theFile, $scope.theFile.name);
      var req = {
        method: 'POST',
        url: $scope.batchEndpoint + 'upload',
        data: fd,
        transformRequest: angular.identity,
        headers: {
          // eslint-disable-next-line no-undefined
          'Content-Type': undefined
        }
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          _this.postUpload(5, resp.batch_id);
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    this.uploadInventory = function () {
      $scope.loading = true;
      var fd = new FormData();
      fd.append('file', $scope.theFile, $scope.theFile.name);
      var req = {
        method: 'POST',
        url: $scope.productEndpoint + 'inventory/upload',
        data: fd,
        transformRequest: angular.identity,
        headers: {
          // eslint-disable-next-line no-undefined
          'Content-Type': undefined
        }
      };
      Utils.getHttpPromise(req).then(function () {
        angular.noop();
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    this.sortBatchIndex = function (sortBy) {
      vm.sortAscending = $scope.sortBatchParams.sort_by === sortBy ? !vm.sortAscending : true;
      $scope.sortBatchParams.sort_by = sortBy;
      $scope.sortBatchParams.sort_type = vm.sortAscending ? 'asc' : 'desc';

      _this.sortBatches();
    };

    this.sortBatches = function () {
      $scope.loadingMore = true;
      var req = {
        method: 'GET',
        url: $scope.batchEndpoint,
        params: $scope.sortBatchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.batches = resp.search_results;

        for (var i = 0; i < $scope.batches.length; i++) {
          if ($scope.batches[i].status === 'processing') {
            _this.updateBatchProgress();

            break;
          }
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    this.confirmBatch = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: $scope.batchEndpoint + 'confirm',
        data: {
          batch_id: $scope.selectedBatch.batch_id
        }
      };
      Utils.getHttpPromise(req).then(function () {
        $scope.selectedBatch = null;
        $scope.activeTab = 4;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    this.changeBatchTab = function (tabIndex, batchIndex) {
      $scope.activeTab = tabIndex;
      $scope.selectedBatch = $scope.batches[batchIndex];
    };

    this.updateBatchProgress = function () {
      var req = {
        method: 'GET',
        url: $scope.batchEndpoint,
        params: $scope.sortBatchParams
      };
      var again = false;
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.batches = resp.search_results;

        for (var i = 0; i < $scope.batches.length; i++) {
          if ($scope.batches[i].status === 'processing' && $scope.activeTab === 4) {
            again = true;
            break;
          }
        }

        if (again) {
          $timeout(function () {
            _this.updateBatchProgress();
          }, 5000);
        }
      }, function (errResp) {
        Debug.error(errResp);
      });
    };
    /*
    	* Note Functions
    	*
    	*/


    this.LoadNotes = function () {
      var req = {
        method: 'GET',
        url: Localized.apiURL + '/admin/product/note',
        params: {
          product_id: $scope.selectedProduct.product_id
        }
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.productNotes = resp.notes;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.savingNote = false;
      });
    };

    this.saveNote = function () {
      $scope.savingNote = true;
      $scope.noteParams.product_id = $scope.selectedProduct.product_id;
      var req = {
        method: 'POST',
        url: Localized.apiURL + '/admin/product/note/',
        data: $scope.noteParams
      };
      Utils.getHttpPromise(req).then(function () {
        _this.LoadNotes();

        $scope.noteParams.note = '';
      }, function (errResp) {
        Debug.error(errResp);
      });
    };

    this.deleteNote = function (id) {
      $scope.savingNote = true;
      var req = {
        method: 'DELETE',
        url: Localized.apiURL + '/admin/product/note/' + id
      };
      Utils.getHttpPromise(req).then(function () {
        _this.LoadNotes();
      }, function (errResp) {
        Debug.error(errResp);
      });
    };

    $scope.AddDocument = function (documents) {
      documents.push({
        name: '',
        url: ''
      });
    };

    $scope.RemoveDocument = function (documents, index) {
      documents.splice(index, 1);
    };
  }
})();
// EXTERNAL MODULE: ./assets/app/dev/components/products/reviews/reviews-detail.component.ts
var reviews_detail_component = __webpack_require__(455);
;// CONCATENATED MODULE: ./assets/app/dev/components/products/reviews/reviews-index/reviews-index.html
// Module
var reviews_index_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <div class=\"hstack gap-2 align-items-baseline mb-3\"> <h2>Reviews</h2> </div> <vf-check-auth></vf-check-auth> <wp-notice-list></wp-notice-list> <form class=\"mb-3\" ng-submit=\"$ctrl.submit()\"> <fieldset class=\"input-group\" ng-disabled=\"$ctrl.isLoading\"> <input type=\"search\" class=\"form-control\" data-cy=\"search\" ng-model=\"$ctrl.params.q\" ng-change=\"$ctrl.changeQuery( $ctrl.params.q )\"/> <button class=\"btn btn-outline-secondary\" type=\"submit\" data-cy=\"submit\"> Search </button> </fieldset> <div class=\"form-text\"> Search by the review's content or status; or the reviewer's name or email address; or for a product ID. </div> </form> <wp-spinner type=\"2x\" ng-if=\"$ctrl.isLoading\"> </wp-spinner> <table class=\"wp-list-table widefat striped\" data-cy=\"table\" ng-if=\"$ctrl.reviews && !$ctrl.isLoading\"> <colgroup> <col class=\"col-md-1\"/> <col class=\"col-md-1\"/> <col span=\"3\"/> </colgroup> <thead> <th scope=\"col\" ng-class=\"[ $ctrl.params.sortType || 'desc', {\n                'sortable': $ctrl.params.sortBy !== 'id',\n                'sorted': $ctrl.params.sortBy === 'id',\n            }]\"> <a href=\"#\" class=\"text-decoration-none\" ng-click=\"$ctrl.changeSortBy('id', $event)\"> <span> ID </span> <span class=\"sorting-indicator\"></span> </a> </th> <th scope=\"col\" ng-class=\"[ $ctrl.params.sortType || 'desc', {\n                'sortable': $ctrl.params.sortBy !== 'rating',\n                'sorted': $ctrl.params.sortBy === 'rating',\n            }]\"> <a href=\"#\" class=\"text-decoration-none\" ng-click=\"$ctrl.changeSortBy('rating', $event)\"> <span> Rating </span> <span class=\"sorting-indicator\"></span> </a> </th> <th>Product</th> <th scope=\"col\" ng-class=\"[ $ctrl.params.sortType || 'desc', {\n                'sortable': $ctrl.params.sortBy !== 'product_id',\n                'sorted': $ctrl.params.sortBy === 'product_id',\n            }]\"> <a href=\"#\" class=\"text-decoration-none\" ng-click=\"$ctrl.changeSortBy('product_id', $event)\"> <span> Product ID </span> <span class=\"sorting-indicator\"></span> </a> </th> <th scope=\"col\" ng-class=\"[ $ctrl.params.sortType || 'desc', {\n                'sortable': $ctrl.params.sortBy !== 'status',\n                'sorted': $ctrl.params.sortBy === 'status',\n            }]\"> <a href=\"#\" class=\"text-decoration-none\" ng-click=\"$ctrl.changeSortBy('status', $event)\"> <span> Status </span> <span class=\"sorting-indicator\"></span> </a> </th> </thead> <tbody> <tr ng-repeat=\"review in $ctrl.reviews.data track by review.id\"> <td>{{ review.id }}</td> <td> <ng-pluralize count=\"review.rating\" when=\"{'one': '1 star', 'other': '{} stars'}\"> </ng-pluralize> </td> <td> <strong> <a class=\"text-decoration-none row-title\" ui-sref=\"reviews.show({ id: review.id })\"> {{ review.product.description }} </a> </strong> <div class=\"hstack gap-2 row-actions visible\"> <a class=\"text-decoration-none\" data-cy=\"edit\" ui-sref=\"reviews.show({ id: review.id })\"> Edit </a> | <a class=\"text-decoration-none text-danger\" href=\"#\" data-cy=\"confirm-delete\" ng-click=\"$ctrl.confirmDelete( $event, $index )\" ng-hide=\"$ctrl.isConfirmingDeletion[ $index ]\"> Delete </a> <span ng-if=\"$ctrl.isConfirmingDeletion[ $index ]\"> <strong class=\"text-dark\"> Delete this review? </strong> <a class=\"text-decoration-none\" href=\"#\" data-cy=\"cancel-delete\" ng-click=\"$ctrl.cancelDelete( $event, $index )\"> Cancel </a> | <a class=\"text-decoration-none text-danger\" href=\"#\" data-cy=\"remove\" ng-click=\"$ctrl.remove( $event, review.id, $index )\"> {{ $ctrl.isDeleting[ $index ] ? 'Deleting' : 'Delete' }} </a> </span> </div> <blockquote class=\"my-2\"> <strong>{{ review.title }}: </strong>{{ review.content | limitTo: 60 }} <span ng-if=\"review.content.length > 60\">&hellip;</span> &mdash; <cite><a ng-href=\"{{ 'mailto:' + review.email }}\">{{ review.display_name }}</a></cite> </blockquote> </td> <td>{{ review.product_id }}</td> <td>{{ review.status }}</td> </tr> <tr> <td colspan=\"5\" ng-if=\"!$ctrl.reviews.data.length\"> No reviews found{{ $ctrl.cachedQ ? ' for ' + $ctrl.cachedQ : ''}}. </td> </tr> </tbody> </table> <div class=\"tablenav\" ng-if=\"$ctrl.reviews && !$ctrl.isLoading && $ctrl.reviews.last_page > 1\"> <div class=\"tablenav-pages\"> <span class=\"displaying-num\"> {{ $ctrl.reviews.total }} items </span> <span class=\"pagination-links\"> <a href=\"#\" class=\"first-page button\" data-cy=\"first-page\" ng-click=\"$ctrl.changePage( $event, 1 )\" ng-if=\"$ctrl.reviews.current_page > 2\"> <span class=\"screen-reader-text\"> First page </span> <span aria-hidden=\"true\"> &laquo; </span> </a> <span class=\"tablenav-pages-navspan button disabled\" aria-hidden=\"true\" ng-if=\"$ctrl.reviews.current_page < 3\"> &laquo; </span> <a href=\"#\" class=\"prev-page button\" data-cy=\"prev-page\" ng-click=\"$ctrl.changePage( $event, $ctrl.reviews.current_page - 1 )\" ng-if=\"$ctrl.reviews.current_page > 1\"> <span class=\"screen-reader-text\"> Previous page </span> <span aria-hidden=\"true\"> &lsaquo; </span> </a> <span class=\"tablenav-pages-navspan button disabled\" aria-hidden=\"true\" ng-if=\"$ctrl.reviews.current_page === 1\"> &lsaquo; </span> <span class=\"paging-input\"> <label for=\"current-page-selector\" class=\"screen-reader-text\"> Current Page </label> <input type=\"number\" class=\"current-page\" min=\"1\" name=\"paged\" size=\"1\" data-cy=\"current-page\" max=\"{{ $ctrl.reviews.last_page }}\" ng-disabled=\"$ctrl.reviews.last_page === 1\" ng-model=\"$ctrl.params.page\"/> <span class=\"tablenav-paging-text\"> of <span class=\"total-pages\" data-cy=\"total-pages\"> {{ $ctrl.reviews.last_page }} </span> </span> </span> <a href=\"#\" class=\"next-page button\" data-cy=\"next-page\" ng-click=\"$ctrl.changePage( $event, $ctrl.reviews.current_page + 1 )\" ng-if=\"$ctrl.reviews.current_page < $ctrl.reviews.last_page\"> <span class=\"screen-reader-text\"> Next page </span> <span aria-hidden=\"true\"> &rsaquo; </span> </a> <span class=\"tablenav-pages-navspan button disabled\" aria-hidden=\"true\" ng-if=\"$ctrl.reviews.current_page === $ctrl.reviews.last_page\"> &rsaquo; </span> <a href=\"#\" class=\"last-page button\" data-cy=\"last-page\" ng-click=\"$ctrl.changePage( $event, $ctrl.reviews.last_page )\" ng-if=\"$ctrl.reviews.current_page < ( $ctrl.reviews.last_page - 1 )\"> <span class=\"screen-reader-text\"> Last page </span> <span aria-hidden=\"true\"> &raquo; </span> </a> <span class=\"tablenav-pages-navspan button disabled\" aria-hidden=\"true\" ng-if=\"$ctrl.reviews.current_page >= ( $ctrl.reviews.last_page - 1 )\"> &raquo; </span> </span> </div> </div> ";
// Exports
/* harmony default export */ const reviews_index = (reviews_index_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/products/reviews/reviews-index/reviews-index.component.ts


(function () {
  'use strict';

  ReviewsController.$inject = ["$location", "$state", "Reviews"];
  angular.module('vendorfuelApp').component('reviewsIndex', {
    controller: ReviewsController,
    template: reviews_index
  });
  ReviewsController.$inject = ['$location', '$state', 'Reviews'];

  function ReviewsController($location, $state, Reviews) {
    var _this = this;

    var vm = this;
    vm.cancelDelete = cancelDelete;
    vm.changePage = changePage;
    vm.changeQuery = changeQuery;
    vm.changeSortBy = changeSortBy;
    vm.remove = remove;
    vm.submit = submit;
    /**
     * Initialization
     */

    this.$onInit = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Products',
        state: 'catalog-products({ activeTab: 0 })'
      }, {
        name: 'Reviews',
        state: 'reviews.index'
      }];
      vm.isConfirmingDeletion = [];
      vm.isDeleting = [];
      vm.params = {
        page: $location.search().page || 1,
        q: $location.search().q || '',
        rpp: 15,
        sortBy: $location.search().sortBy || '',
        sortType: $location.search().sortType || ''
      };
      vm.cachedQ = vm.params.q;
      queryReviews();
    };

    function cancelDelete(e, i) {
      e.preventDefault();
      vm.isConfirmingDeletion[i] = false;
    }
    /**
     * @param {Object} e    Click event
     * @param {number} page Page number
     */


    function changePage(e, page) {
      if (e) {
        e.preventDefault();
      }

      vm.params.page = page;
      submit();
    }
    /**
     * @param {string} q Query
     */


    function changeQuery(q) {
      if (!q) {
        submit();
      }
    }
    /**
     * @param {string} sortBy Sortby term
     * @param {Object} e      Click event
     */


    function changeSortBy(sortBy, e) {
      e.preventDefault();

      if (vm.params.sortBy === sortBy) {
        vm.params.sortType = vm.params.sortType === 'desc' ? 'asc' : 'desc';
      } else {
        vm.params.sortType = 'asc';
        vm.params.sortBy = sortBy;
      }

      updateSearchParams();
      queryReviews();
    }

    this.confirmDelete = function (e, i) {
      e.preventDefault();
      vm.isConfirmingDeletion[i] = true;
    };
    /**
     * Get the reviews
     */


    function queryReviews() {
      vm.isLoading = true;
      Reviews.query(vm.params).$promise.then(function (reviews) {
        vm.reviews = reviews;
        vm.isLoading = false;
      });
    }

    function remove(e, id, index) {
      e.preventDefault();
      vm.isDeleting[index] = true;
      Reviews["delete"]({
        id: id
      }).$promise.then(function () {
        vm.isDeleting[index] = false;
        $state.reload();
      });
    }
    /**
     * Submit the search form.
     */


    function submit() {
      vm.cachedQ = vm.params.q;
      updateSearchParams();
      queryReviews();
    }
    /**
     * Update the search params in the URL.
     */


    function updateSearchParams() {
      var _vm$params = vm.params,
          q = _vm$params.q,
          page = _vm$params.page;
      $location.search('q', q ? q : null);
      $location.search('page', page > 1 ? page : null);
    }
  }
})();
// EXTERNAL MODULE: ./assets/app/dev/components/products/reviews/reviews.factory.ts
var reviews_factory = __webpack_require__(8134);
;// CONCATENATED MODULE: ./assets/app/dev/components/products/reviews/index.ts



;// CONCATENATED MODULE: ./assets/app/dev/components/products/index.ts



// EXTERNAL MODULE: ./assets/app/dev/components/punchout/punchout.component.ts
var punchout_component = __webpack_require__(8734);
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings.component.html
// Module
var settings_component_code = "<breadcrumb-control breadcrumbs=\"$ctrl.breadcrumbs\"></breadcrumb-control> <h2> Settings <button class=\"button\" ng-click=\"$ctrl.resetTutorial()\" ng-disabled=\"$ctrl.isResettingTutorial\"> {{ $ctrl.isResettingTutorial ? \"Resetting\" : \"Reset\" }} Tutorial </button> </h2> <wp-notice-list></wp-notice-list> <div class=\"notice notice-warning\" ng-if=\"!$ctrl.isAuthed\"> <p> You must be signed in to VendorFuel to view all the store settings. <a href=\"#!/login\">Sign In</a> </p> </div> <div class=\"notice notice-warning\" ng-if=\"$ctrl.isAuthed && !$ctrl.hasAPIKey\"> <p> You must have an active VendorFuel subscription to view this section. <a href=\"#!/subscribe\">Subscribe</a> </p> </div> <uib-tabset> <uib-tab heading=\"Plugin\" select=\"$ctrl.setActiveTab(0)\"> <settings-plugin ng-if=\"$ctrl.activeTab === 0\"></settings-plugin> </uib-tab> <uib-tab heading=\"Store\" select=\"$ctrl.setActiveTab(1)\" ng-if=\"$ctrl.isAuthed\"> <settings-store ng-if=\"$ctrl.activeTab === 1\"></settings-store> </uib-tab> <uib-tab heading=\"Options\" select=\"$ctrl.setActiveTab(2)\" ng-if=\"$ctrl.isAuthed\"> <settings-options ng-if=\"$ctrl.activeTab === 2\"></settings-options> </uib-tab> <uib-tab select=\"$ctrl.setActiveTab(3)\" heading=\"Analytics\" ng-if=\"$ctrl.isAuthed\"> <settings-analytics ng-if=\"$ctrl.activeTab === 3\"> </settings-analytics> </uib-tab> <uib-tab select=\"$ctrl.setActiveTab(4)\" heading=\"Page Mapping\" ng-if=\"$ctrl.isAuthed\"> <settings-mapping ng-if=\"$ctrl.activeTab === 4\"></settings-mapping> </uib-tab> </uib-tabset> ";
// Exports
/* harmony default export */ const settings_component = (settings_component_code);
;// CONCATENATED MODULE: ./assets/app/dev/components/settings/settings.component.ts

/**
 * Settings Component
 *
 * @namespace Components
 */

(function () {
  'use strict';

  SettingsController.$inject = ["$window", "Admin", "Localized", "Settings"];
  angular.module('SettingsModule').component('vfSettings', {
    controller: SettingsController,
    template: settings_component
  });
  SettingsController.$inject = ['$window', 'Admin', 'Localized', 'Settings'];
  /**
   * @param {Object} $window   AngularJS service
   * @param {Object} Admin     VendorFuel service
   * @param {Object} Localized VendorFuel service
   * @param {Object} Settings  VendorFuel service
   */

  function SettingsController($window, Admin, Localized, Settings) {
    var _this = this;

    var vm = this;
    vm.resetTutorial = resetTutorial;
    /**
     * Initialization
     */

    this.$onInit = function () {
      _this.breadcrumbs = [{
        name: 'Settings',
        state: 'settings'
      }];
      vm.activeTab = 0;
      vm.isAuthed = Admin.Authed();
      vm.isLoading = true;
      vm.isSaved = false;
      vm.isSaving = false;
      vm.hasAPIKey = Localized.api_key;
      vm.settings = Settings;
    };
    /**
     */


    function resetTutorial() {
      vm.isResettingTutorial = true;
      Settings.resetTutorial().then(function () {
        vm.isResettingTutorial = false;
        $window.scrollTo({
          top: 0,
          left: 0,
          behavior: 'smooth'
        });
      });
    }

    this.setActiveTab = function (index) {
      return _this.activeTab = index;
    };
    /**
     * @param {number} i Index
     */


    this.showTab = function (i) {
      vm.activeTab = i;
      Settings.errors = {};
      vm.isLoading = true;
      vm.isSaving = false;
      vm.isSaved = false;

      switch (i) {
        case 0:
          getSettings(Settings.general);
          break;

        case 1:
          getSettings(Settings.store);
          break;

        case 2:
          getSettings(Settings.analytics);
          break;

        case 3:
          break;
      }
    };
    /**
     * @param {number} i    Index
     * @param {Object} form Form data
     */


    this.submitUpdate = function (i, form) {
      switch (i) {
        case 0:
          _this.updateGeneralSettings(form);

          break;

        case 1:
          updateStoreSettings(form);
          break;

        case 2:
          updateAnalyticsSettings(form);
          break;

        case 3:
          updateImageSettings(form);
          break;
      }
    };
    /**
     * @param {Object} tab Settings
     * @return {Object} Promise
     */


    function getSettings(tab) {
      console.log('getSettings', tab);
      var promise = tab.Get().then(function () {
        vm.isLoading = false;
      }, function errorCallback() {
        vm.isLoading = false;
      });
      return promise;
    }
    /**
     * @param {Object} tab  Settings
     * @param {Object} form Form data
     * @return {Object} Promise
     */


    function updateSettings(tab, form) {
      Settings.errors = {};
      vm.isSaving = true;
      vm.isSaved = false;
      var promise = tab.Set().then(function successCallback() {
        vm.isSaving = false;
        vm.isSaved = Object.keys(Settings.errors).length === 0;

        if (vm.isSaved) {
          Localized.setNotification({
            type: 'success',
            message: 'Settings have been saved.'
          });
          $window.scrollTo({
            top: 0,
            left: 0,
            behavior: 'smooth'
          });
        }

        form.$setPristine();
        form.$setUntouched();
      }, function errorCallback() {
        vm.isSaving = false;
      });
      return promise;
    }
    /**
     * @param {Object} form Form data
     */


    this.updateGeneralSettings = function (form) {
      console.log('updateGeneralSettings', form, _this.settings.general);

      if (vm.settings.general.saved.api_url === '' || vm.settings.general.saved.api_key === '') {
        Admin.Logout();
      }

      updateSettings(Settings.general, form);
    };
    /**
     * @param {Object} form Form data
     */


    function updateStoreSettings(form) {
      updateSettings(Settings.store, form);
    }
    /**
     * @param {Object} form Form data
     */


    function updateAnalyticsSettings(form) {
      updateSettings(Settings.analytics, form);
    }
    /**
     * @param {Object} form Form data
     */


    function updateImageSettings(form) {
      updateSettings(Settings.image, form);
    }
  }
})();
// EXTERNAL MODULE: ./assets/app/dev/components/tutorial/tutorial.component.ts
var tutorial_component = __webpack_require__(4582);
// EXTERNAL MODULE: ./assets/app/dev/components/vf-check-auth/vf-check-auth.component.ts
var vf_check_auth_component = __webpack_require__(2588);
;// CONCATENATED MODULE: ./assets/app/dev/components/index.ts










// EXTERNAL MODULE: ./assets/app/dev/controllers/admin-accounts.controller.ts
var admin_accounts_controller = __webpack_require__(6111);
// EXTERNAL MODULE: ./assets/app/dev/controllers/billing.controller.ts
var billing_controller = __webpack_require__(8464);
// EXTERNAL MODULE: ./assets/app/dev/controllers/billing-reset-password.controller.ts
var billing_reset_password_controller = __webpack_require__(154);
;// CONCATENATED MODULE: ./assets/app/dev/controllers/catalog-banners.controller.ts


(function () {
  'use strict';

  CatalogBannersController.$inject = ["$scope", "$rootScope", "$stateParams", "Admin", "ConfirmModal", "Settings", "Debug", "Utils", "Localized"];
  angular.module('vendorfuelApp').controller('CatalogBannersController', CatalogBannersController);
  CatalogBannersController.$inject = ['$scope', '$rootScope', '$stateParams', 'Admin', 'ConfirmModal', 'Settings', 'Debug', 'Utils', 'Localized'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} ConfirmModal VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   */

  function CatalogBannersController($scope, $rootScope, $stateParams, Admin, ConfirmModal, Settings, Debug, Utils, Localized) {
    var _this = this;

    this.tinymceOptions = tinymceOptions;
    /**
     * Initialization
     */

    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Banners',
        state: 'catalog-banners'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab) || 0;
      $scope.bannerAreaEndpoint = Localized.apiURL + '/admin/banner-areas/';
      $scope.bannerEndpoint = Localized.apiURL + '/admin/banner/';
      $scope.isAuthed = Admin.Authed();
      $scope.loading = false;
      $scope.loadingMore = false;
      $scope.newBanner = {};
      $scope.newBannerArea = {};
      $scope.object = Object;
      $scope.rppValues = [15, 30, 50, 100];
      $scope.per_page = $scope.rppValues[0]; // Must come after $scope.rppValues declaration.

      $scope.searchParams = {
        q: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0]
      };
      $scope.searchTerm = '';
      $scope.selectedBanner = null;
      $scope.selectedBannerArea = null;
      $scope.sortAscending = true;
      $scope.TinyMCEOptions = {
        theme: 'modern',
        // skin: 'lightgray',
        plugins: 'advlist autolink link image lists charmap print preview fullscreen code',
        toolbar: 'numlist bullist | undo redo | styleselect | bold italic | link image alignleft aligncenter alignright | preview code | fullscreen'
      };
    };

    this.init(); //FUNCTIONS

    $scope.LoginCallback = function () {
      $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
    };

    $scope.TabChanged = function (i) {
      $scope.activeTab = i;
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      $scope.cancelled = false;
      var req = {
        method: 'GET',
        url: $scope.bannerAreaEndpoint
      };

      switch (i) {
        case 0:
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.bannerAreas = resp.banner_areas;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          $scope.loading = false;
          break;

        case 2:
          if ($scope.selectedBannerArea) {
            $scope.newBanner.area_id = $scope.selectedBannerArea.area_id;
          }

          $scope.loading = false;
          break;

        case 3:
          req.url += $scope.selectedBannerArea.area_id;
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.selectedBannerArea = resp.banner_area;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 4:
          $scope.loading = false;
          break;
      }
    };

    $scope.AddBanner = function () {
      $scope.addingBanner = true;
      var req = {
        method: 'POST',
        url: $scope.bannerEndpoint,
        data: $scope.newBanner
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (resp.errors.length <= 0) {
          $scope.activeTab = 3;
          $scope.newBanner = {};
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.addingBanner = false;
      });
    };

    $scope.AddBannerArea = function () {
      $scope.loading = true;
      var req = {
        method: 'POST',
        url: $scope.bannerAreaEndpoint,
        data: $scope.newBannerArea
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          $scope.selectedBannerArea = {
            area_id: resp.area_id
          };
          $scope.activeTab = 3;
          $scope.newBannerArea = {};
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loading = false;
      });
    };

    $scope.ChangeTab = function (tabIndex, index) {
      $scope.activeTab = tabIndex;
      $scope.selectedBannerArea = $scope.bannerAreas.data[index];
    };

    $scope.ChangeBannerTab = function (tabIndex, index) {
      $scope.activeTab = tabIndex;
      $scope.selectedBanner = $scope.selectedBannerArea.banners[index];
    };

    $scope.RemoveBanner = function () {
      var callback = {
        confirm: function confirm() {
          $scope.loading = true;
          var params = {
            bid: $scope.selectedBanner.banner_id
          };
          var req = {
            method: 'DELETE',
            url: $scope.bannerEndpoint,
            data: params
          };
          Utils.getHttpPromise(req).then(function (resp) {
            if (resp.errors.length <= 0) {
              $scope.selectedBanner = {};
              $scope.activeTab = 3;
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
        },
        cancel: function cancel() {}
      };
      ConfirmModal.Show(callback, 'Delete Banner?', 'This will completely remove the banner from the store. This action cannot be undone.', 'Back', 'DELETE');
    };

    $scope.RemoveBannerArea = function () {
      var callback = {
        confirm: function confirm() {
          $scope.loading = true;
          var req = {
            method: 'DELETE',
            url: $scope.bannerAreaEndpoint + $scope.selectedBannerArea.area_id
          };
          Utils.getHttpPromise(req).then(function (resp) {
            if (!resp.errors.length) {
              $scope.selectedBannerArea = null;
              $scope.activeTab = 0;
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
        },
        cancel: function cancel() {}
      };
      ConfirmModal.Show(callback, 'Delete Banner Area?', 'This will delete the area and all banners associated with it. This cannot be undone.', 'Back', 'DELETE');
    };

    $scope.SearchResults = function (resp) {
      //callback that is used by the search modal
      if ($scope.activeTab === 2) {
        $scope.addParams.products = [];
        resp.forEach(function (item) {
          $scope.addParams.products.push(item.value);
        });
      }

      if ($scope.activeTab === 3) {
        $scope.editedProducts = [];
        resp.forEach(function (item) {
          $scope.editedProducts.push(item.value.product_id);
        });
      }
    };

    $scope.SortIndex = function (sortBy) {
      $scope.sortAscending = $scope.searchParams.sortBy === sortBy ? !$scope.sortAscending : true;
      $scope.searchParams.sortBy = sortBy;
      $scope.searchParams.sortType = $scope.sortAscending ? 'asc' : 'desc';
      $scope.SearchBannerAreas($scope.searchParams.page);
    };

    $scope.SearchBannerAreas = function (page, query) {
      $scope.loadingMore = true;
      $scope.searchParams.q = query;
      $scope.searchTerm = $scope.searchParams.q;
      $scope.searchParams.page = page || 1;
      var req = {
        method: 'GET',
        url: $scope.bannerAreaEndpoint,
        params: $scope.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.bannerAreas = resp.banner_areas;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    $scope.UpdateBannerArea = function () {
      $scope.updatingArea = true;
      var req = {
        method: 'PUT',
        url: $scope.bannerAreaEndpoint + $scope.selectedBannerArea.area_id,
        data: $scope.selectedBannerArea
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.updatingArea = false;
      });
    };

    $scope.UpdateBannerContent = function () {
      $scope.updatingBanner = true; // var params = {};

      var params = $scope.selectedBanner;
      params.bid = $scope.selectedBanner.banner_id;
      var req = {
        method: 'PUT',
        url: $scope.bannerEndpoint + $scope.selectedBanner.banner_id,
        data: params
      };
      Utils.getHttpPromise(req).then(function () {}, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.updatingBanner = false;
      });
    };
  }
})();
;// CONCATENATED MODULE: ./assets/app/dev/controllers/catalog-categories.controller.ts


(function () {
  'use strict';

  CatalogCategoriesController.$inject = ["$scope", "$rootScope", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized", "SearchModal"];
  angular.module('vendorfuelApp').controller('CatalogCategoriesController', CatalogCategoriesController);
  CatalogCategoriesController.$inject = ['$scope', '$rootScope', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} SearchModal  VendorFuel service
   */

  function CatalogCategoriesController($scope, $rootScope, $stateParams, Admin, Settings, Debug, Utils, Localized, SearchModal) {
    var _this = this;

    var vm = this;
    this.tinymceOptions = tinymceOptions;
    vm.addCategory = addCategory;
    vm.changeEdit = changeEdit;
    vm.changeSortBy = changeSortBy;
    vm.changeView = changeView;
    vm.deleteCategory = deleteCategory;
    vm.editCategory = editCategory;
    vm.generateSlugs = generateSlugs;
    vm.openMediaFrame = openMediaFrame;
    vm.openParentCatSearchModal = openParentCatSearchModal;
    vm.openSearchModalAdd = openSearchModalAdd;
    vm.openSearchModalUpdate = openSearchModalUpdate;
    vm.searchCategory = searchCategory;
    vm.searchSubCategory = searchSubCategory;
    vm.ShowChanges = ShowChanges;
    vm.syncCategoryPosts = syncCategoryPosts;
    vm.tabChanged = tabChanged;
    vm.updateCategory = updateCategory;
    vm.viewParent = viewParent;
    /**
     * Initialization
     */

    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Categories',
        state: 'catalog-categories'
      }];
      vm.activeTab = parseInt($stateParams.activeTab);
      vm.addParams = {};
      vm.brandImg = "".concat(localized.dir.url, "/assets/img/brand.png");
      vm.categoryEndpoint = Localized.apiURL + '/admin/category/';
      vm.catSlug = localized.settings.general.cat_slug || 'categories';
      vm.editedProducts = [];
      vm.editName = false;
      vm.filterBy = '';
      vm.isAuthed = Admin.Authed();
      vm.loading = false;
      vm.object = Object;
      vm.productEndpoint = Localized.apiURL + '/admin/products/';
      vm.rppValues = [15, 30, 50, 100];
      vm.searchTerm = '';
      vm.selectedCategory = null;
      vm.showChanges = false;
      vm.searchParams = {
        page: 1,
        rpp: vm.rppValues[0]
      };
      vm.sortAscending = true;
    };

    this.init();
    /**
     * @param {number} i Tab index
     */

    function tabChanged(i) {
      vm.activeTab = i;
      Settings.errors = {};
      vm.loading = true;
      vm.editedProducts = [];
      vm.showChanges = false;
      var req = {
        method: 'GET',
        url: vm.categoryEndpoint
      };

      switch (i) {
        case 0:
          Utils.getHttpPromise(req).then(function (resp) {
            vm.categories = resp.categories;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            vm.loading = false;
          });
          break;

        case 1:
          vm.loading = false;
          break;

        case 2:
          req.url += vm.selectedCategory.cat_id;
          Utils.getHttpPromise(req).then(function (resp) {
            vm.selectedCategory = resp.category;

            if (vm.selectedCategory.parent_category) {
              vm.selectedCategory.parentCategoryTitle = vm.selectedCategory.parent_category.title;
            }
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            checkCategory();
            vm.loading = false;
          });
          break;

        default:
          vm.loading = false;
          break;
      }
    }
    /**
     */


    function syncCategoryPosts() {
      var params = {};
      var data = {};
      Utils.httpGet(Localized.wpRestUrl + '/syncCategoryPosts', params, data).then(function () {
        angular.noop();
      });
    }
    /**
     */


    function generateSlugs() {
      var req = {
        method: 'POST',
        url: vm.categoryEndpoint + 'slug/generate'
      };
      Utils.getHttpPromise(req).then(function () {
        angular.noop();
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        vm.loading = false;
      });
    }
    /**
     */


    function addCategory() {
      vm.loading = true;
      var params = {
        title: vm.addParams.title,
        parent_id: vm.addParams.parent_id,
        avatax_tax_code: vm.addParams.avatax_tax_code,
        unspsc: vm.addParams.unspsc,
        slug: vm.addParams.slug,
        image: vm.addParams.img_url,
        description: vm.addParams.description,
        products: []
      };
      angular.forEach(vm.addParams.products, function (value) {
        params.products.push(value.value.product_id);
      });
      params.image = vm.addParams.img_url;
      var req = {
        method: 'POST',
        url: vm.categoryEndpoint,
        data: params
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          vm.addParams = {};
          vm.selectedCategory = resp.category; // eslint-disable-next-line no-shadow

          var _params = {
            id: resp.category.cat_id
          };
          var data = {};
          Utils.httpGet(Localized.wpRestUrl + '/syncCategoryPosts', _params, data) // eslint-disable-next-line no-shadow
          .then(function () {
            angular.noop();
          });
          vm.activeTab = 2;
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        vm.loading = false;
      });
    }
    /**
     */


    function changeView() {
      vm.viewProducts = !vm.viewProducts;
    }
    /**
     */


    function checkCategory() {
      if (vm.selectedCategory.products.data.length >= 1) {
        vm.viewProducts = true;
      } else {
        vm.viewProducts = false;
      }
    }
    /**
     */


    function changeEdit() {
      vm.editName = !vm.editName;
    }
    /**
     * @param {number} i Category index
     * @param {Object} e Click event
     */


    function editCategory(i, e) {
      if (e) {
        e.preventDefault();
      }

      var tabIndex = 2; // Currently the Edit Category tab index.

      vm.activeTab = tabIndex;
      vm.selectedCategory = vm.categories.data[i];
    }
    /**
     * @param {number} id Category ID
     */


    function deleteCategory(id) {
      var endpoint = vm.categoryEndpoint + id;
      Utils.httpDelete(endpoint).then(function () {
        angular.noop();
      }, function (errResp) {
        Debug.log(errResp);
      })["finally"](function () {
        vm.tabChanged(0);
        vm.selectedCategory = null;
      });
    }
    /**
     * @param {string} image Image
     */


    function openMediaFrame(image) {
      // eslint-disable-next-line no-undef
      var fileFrame = wp.media({
        title: 'Select or Upload Logo image',
        library: {
          type: 'image'
        },
        button: {
          text: 'Select'
        },
        multiple: false
      });
      fileFrame.on('select', function () {
        $scope.$apply(function () {
          $scope.attachment = fileFrame.state().get('selection').first().toJSON();
          $scope.removingImage = true;

          if (image === 'add_img') {
            vm.addParams.img_url = $scope.attachment.url;
          } else if (image === 'update_img') {
            vm.selectedCategory.img_url = $scope.attachment.url;
          }
        });
      });
      fileFrame.open();
    }
    /**
     */


    function openSearchModalAdd() {
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: vm.productEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['products', 'category'],
          fields: ['sku', 'image', 'description', 'title'],
          fieldPrefixes: ['', '', '', 'Category: '],
          id: 'product_id',
          selectOne: false
        }],
        updatedItems: vm.addParams.products
      };
      callback = {
        confirm: productSearchResults,
        cancel: function cancel() {
          angular.noop();
        }
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, vm.addParams.title || 'New Category', data, 'Add items');
    }
    /**
     */


    function openSearchModalUpdate() {
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: vm.productEndpoint,
            params: {
              q: '',
              excludedField: 'category_id',
              excludedId: vm.selectedCategory.cat_id,
              excludedTable: 'products'
            }
          },
          relationships: ['products', 'category'],
          fields: ['sku', 'image', 'description', 'title'],
          fieldPrefixes: ['', '', '', 'Category: '],
          id: 'product_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: vm.categoryEndpoint + vm.selectedCategory.cat_id,
            params: {
              q: '',
              'searchFields[]': ['description', 'sku']
            }
          },
          relationships: ['category', 'products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Category: '],
          id: 'product_id'
        }],
        updatedItems: vm.editedProducts
      };
      callback = {
        confirm: productSearchResults,
        cancel: function cancel() {
          angular.noop();
        }
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, vm.selectedCategory.title, data, 'Add items');
    }
    /**
     */


    function openParentCatSearchModal() {
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: vm.categoryEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['categories', 'parent_category'],
          fields: ['cat_id', 'title', '.cat_id', '.title'],
          fieldPrefixes: ['ID: ', 'Category: ', 'Parent ID: ', 'Parent: '],
          id: 'cat_id',
          selectOne: true
        }]
      };
      callback = {
        confirm: categorySearchResults,
        cancel: function cancel() {
          angular.noop();
        }
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, 'Select Parent Category', data, 'Add items');
    }
    /**
     * @param {string} sortBy Sortby term
     * @param {Object} e      Click event
     */


    function changeSortBy(sortBy, e) {
      e.preventDefault();
      vm.sortAscending = vm.searchParams.sortBy === sortBy ? !vm.sortAscending : true;
      vm.searchParams.sortBy = sortBy;
      vm.searchParams.sortType = vm.sortAscending ? 'asc' : 'desc';
      this.searchCategories();
    }

    this.searchCategories = function () {
      vm.loadingMore = true;
      var req = {
        method: 'GET',
        url: vm.categoryEndpoint,
        params: vm.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        vm.categories = resp.categories;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        vm.loadingMore = false;
      });
    };

    this.setPage = function (page) {
      _this.searchParams.page = page;

      _this.searchCategories();
    };

    this.setRpp = function (rpp) {
      _this.searchParams.rpp = rpp;

      _this.searchCategories();
    };

    this.setQuery = function (query) {
      _this.searchParams.page = 1; // Reset page when query changes.

      _this.searchParams.q = query;
      _this.searchTerm = _this.searchParams.q;

      _this.searchCategories();
    };
    /**
     * @param {number} rpp  Results per page
     * @param {number} page Page number
     */


    function searchCategory(rpp, page) {
      vm.productsLoading = true;
      vm.searchParams.rpp = rpp;
      vm.searchParams.page = page || 1;
      vm.searchParams['searchFields[]'] = ['description', 'sku'];
      var req = {
        method: 'GET',
        url: vm.categoryEndpoint + vm.selectedCategory.cat_id,
        params: vm.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        vm.selectedCategory = resp.category;

        if (vm.selectedCategory.parent_category) {
          vm.selectedCategory.parentCategoryTitle = vm.selectedCategory.parent_category.title;
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        vm.productsLoading = false;
      });
    }
    /**
     * @param {Object} resp Response
     */


    function categorySearchResults(resp) {
      if (vm.activeTab === 1) {
        vm.addParams.parent_id = resp[0].value.cat_id;
        vm.addParams.parentCategoryTitle = resp[0].value.title;
      }

      if (vm.activeTab === 2) {
        vm.selectedCategory.parent_id = resp[0].value.cat_id;
        vm.selectedCategory.parentCategoryTitle = resp[0].value.title;
      }
    }
    /**
     * Callback that is used by the search modal
     *
     * @param {Object} resp Response
     */


    function productSearchResults(resp) {
      if (vm.activeTab === 1) {
        vm.addParams.products = resp;
      }

      if (vm.activeTab === 2) {
        vm.editedProducts = resp;
      }
    }
    /**
     * @param {number} id ID
     */


    function searchSubCategory(id) {
      vm.loading = true;
      var req = {
        method: 'GET',
        url: vm.categoryEndpoint + id
      };
      Utils.getHttpPromise(req).then(function (resp) {
        vm.selectedCategory = resp.category;

        if (vm.selectedCategory.parent_category) {
          vm.selectedCategory.parentCategoryTitle = vm.selectedCategory.parent_category.title;
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        checkCategory();
        vm.loading = false;
      });
    }
    /**
     */


    function ShowChanges() {
      vm.showChanges = !vm.showChanges;
    }
    /**
     */


    function updateCategory() {
      vm.loading = true;
      var params = {
        title: vm.selectedCategory.title,
        parent_id: vm.selectedCategory.parent_id,
        avatax_tax_code: vm.selectedCategory.avatax_tax_code,
        unspsc: vm.selectedCategory.unspsc,
        slug: vm.selectedCategory.slug,
        image: vm.selectedCategory.img_url,
        description: vm.selectedCategory.description,
        products: []
      };
      angular.forEach(vm.editedProducts, function (value) {
        params.products.push(value.value.product_id);
      });
      var req = {
        method: 'PUT',
        url: vm.categoryEndpoint + vm.selectedCategory.cat_id,
        data: params
      };
      Utils.getHttpPromise(req).then(function (resp) {
        if (!resp.errors.length) {
          vm.tabChanged(2); // eslint-disable-next-line no-shadow

          var _params2 = {
            id: resp.category.cat_id
          };
          var data = {};
          Utils.httpGet(Localized.wpRestUrl + '/syncCategoryPosts', _params2, data).then(function () {
            angular.noop();
          });
        } else {
          vm.loading = false;
        }
      }, function (errResp) {
        Debug.log(errResp);
      });
    }
    /**
     */


    function viewParent() {
      vm.loading = true;
      var req = {
        method: 'GET',
        url: vm.categoryEndpoint + vm.selectedCategory.parent_id
      };
      Utils.getHttpPromise(req).then(function (resp) {
        vm.selectedCategory = resp.category;

        if (vm.selectedCategory.parent_category) {
          vm.selectedCategory.parentCategoryTitle = vm.selectedCategory.parent_category.title;
        }
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        checkCategory();
        vm.loading = false;
      });
    }
  }
})();
;// CONCATENATED MODULE: ./assets/app/dev/controllers/catalog-collections.controller.ts


(function () {
  'use strict';

  CatalogCollectionsController.$inject = ["$scope", "$rootScope", "$state", "$stateParams", "Admin", "Settings", "Debug", "Utils", "Localized", "SearchModal", "ViewModal"];
  angular.module('vendorfuelApp').controller('CatalogCollectionsController', CatalogCollectionsController);
  CatalogCollectionsController.$inject = ['$scope', '$rootScope', '$state', '$stateParams', 'Admin', 'Settings', 'Debug', 'Utils', 'Localized', 'SearchModal', 'ViewModal'];
  /**
   * @param {Object} $scope       Angular service
   * @param {Object} $rootScope   Angular service
   * @param {Object} $state       UI Router service
   * @param {Object} $stateParams UI Router service
   * @param {Object} Admin        VendorFuel service
   * @param {Object} Settings     VendorFuel service
   * @param {Object} Debug        VendorFuel service
   * @param {Object} Utils        VendorFuel service
   * @param {Object} Localized    VendorFuel service
   * @param {Object} SearchModal  VendorFuel service
   * @param {Object} ViewModal    VendorFuel service
   */

  function CatalogCollectionsController($scope, $rootScope, $state, $stateParams, Admin, Settings, Debug, Utils, Localized, SearchModal, ViewModal) {
    var _this = this;

    var vm = this;
    this.tinymceOptions = tinymceOptions;
    vm.changeSortBy = changeSortBy;
    /**
     * Initialization
     */

    this.init = function () {
      _this.breadcrumbs = [{
        name: 'Catalog',
        state: 'catalog'
      }, {
        name: 'Collections',
        state: 'catalog-collection'
      }];
      $scope.activeTab = parseInt($stateParams.activeTab);
      $scope.addParams = {
        products: [],
        categories: []
      };
      $scope.categoryEndpoint = Localized.apiURL + '/admin/category/';
      $scope.collectionEndpoint = Localized.apiURL + '/admin/product/collection/';
      $scope.editedCategories = [];
      $scope.editedProducts = [];
      $scope.editName = false;
      $scope.isAuthed = Admin.Authed();
      $scope.loading = false;
      $scope.loadingMore = false;
      $scope.productEndpoint = Localized.apiURL + '/admin/products/';
      $scope.productsLoading = false;
      $scope.object = Object;
      $scope.rppValues = [15, 30, 50, 100];
      $scope.per_page = $scope.rppValues[0]; // Must be defined after rppValues declaration.

      $scope.saved = false;
      $scope.saving = false;
      $scope.searchParams = {};
      $scope.searchTerm = '';
      $scope.searchTypes = {
        PRODUCTS: 'PRODUCTS',
        CATEGORIES: 'CATEGORIES'
      };
      $scope.searchType = $scope.searchTypes.PRODUCTS; // Must be defined after searchTypes declaration.

      $scope.selectedCollection = null; //Collection to show in the view tab

      $scope.showChanges = false;
      vm.allColSearchParams = {
        q: '',
        sortBy: '',
        sortType: '',
        rpp: $scope.rppValues[0] // Must be defined after rppValues declaration.

      };
      vm.sortAscending = true; //If the view tab is selected, redirect to the search page since selected product is null

      if ($scope.activeTab === 2) {
        $scope.activeTab = 0;
        $scope.TransitionState();
      }
    };

    this.init(); //FUNCTIONS

    $scope.LoginCallback = function () {
      $scope.loading = true; //logged in, do something. i.e. make api calls to load current tab's data
    };

    $scope.ChangeEdit = function () {
      $scope.editName = !$scope.editName;
    };

    $scope.SearchResults = function (resp) {
      //callback that is used by the search modal
      if ($scope.activeTab === 1) {
        switch ($scope.searchType) {
          case $scope.searchTypes.PRODUCTS:
            $scope.addParams.products = resp;
            break;

          case $scope.searchTypes.CATEGORIES:
            $scope.addParams.categories = resp;
            break;
        }
      } else if ($scope.activeTab === 2) {
        switch ($scope.searchType) {
          case $scope.searchTypes.PRODUCTS:
            $scope.editedProducts = resp;
            break;

          case $scope.searchTypes.CATEGORIES:
            $scope.editedCategories = resp;
            break;
        }
      }
    };

    $scope.SearchCancelled = function () {//callback that is used by the search modal
    };

    $scope.TransitionState = function () {
      $state.go('catalog-collections', {
        activeTab: $scope.activeTab
      });
    };

    $scope.TabChanged = function (i) {
      $scope.activeTab = i;
      Settings.errors = {};
      $scope.loading = true;
      $scope.saving = false;
      $scope.saved = false;
      $scope.cancelled = false;
      var req = {
        method: 'GET',
        url: $scope.collectionEndpoint
      };

      switch (i) {
        case 0:
          //First tab selected
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.collections = resp.collections;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;

        case 1:
          //Second tab selected
          $scope.loading = false;
          break;

        case 2:
          req.url += $scope.selectedCollection.id;
          Utils.getHttpPromise(req).then(function (resp) {
            $scope.selectedCollection = resp.collection;
          }, function (errResp) {
            Debug.error(errResp);
          })["finally"](function () {
            $scope.loading = false;
          });
          break;
      }
    };

    $scope.ChangeTab = function (tabIndex, collectionIndex) {
      $scope.activeTab = tabIndex;
      $scope.selectedCollection = $scope.collections.data[collectionIndex];
    };

    $scope.OpenSearchModalUpdate = function () {
      $scope.searchType = $scope.searchTypes.PRODUCTS;
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.productEndpoint,
            params: {
              q: '',
              excludedField: 'collection_id',
              excludedId: $scope.selectedCollection.id,
              excludedTable: 'product_collection'
            }
          },
          relationships: ['products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Status: '],
          id: 'product_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: $scope.collectionEndpoint + $scope.selectedCollection.id,
            params: {
              q: '',
              'searchFields[]': ['description', 'sku']
            }
          },
          relationships: ['collection', 'products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Status: '],
          id: 'product_id'
        }],
        updatedItems: $scope.editedProducts
      };
      callback = {
        confirm: $scope.SearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, $scope.selectedCollection.name, data, 'Add Products');
    };

    $scope.OpenSearchModalAdd = function () {
      $scope.searchType = $scope.searchTypes.PRODUCTS;
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.productEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['products'],
          fields: ['sku', 'image', 'description', 'status'],
          fieldPrefixes: ['', '', '', 'Status: '],
          id: 'product_id',
          selectOne: false
        }],
        updatedItems: $scope.addParams.products
      };
      callback = {
        confirm: $scope.SearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, $scope.addParams.name || 'New Collection', data, 'Add Products');
    };

    $scope.OpenSearchModalCategoryUpdate = function () {
      $scope.searchType = $scope.searchTypes.CATEGORIES;
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.categoryEndpoint,
            params: {
              q: '',
              excludedField: 'collection_id',
              excludedId: $scope.selectedCollection.id,
              excludedTable: 'category_collection'
            }
          },
          relationships: ['categories'],
          fields: ['title'],
          fieldPrefixes: [''],
          id: 'cat_id',
          selectOne: false
        }, {
          http: {
            method: 'GET',
            url: $scope.collectionEndpoint + $scope.selectedCollection.id,
            params: {
              q: '',
              'searchFields[]': ['description', 'title']
            }
          },
          relationships: ['collection', 'categories'],
          fields: ['title'],
          fieldPrefixes: [''],
          id: 'cat_id'
        }],
        updatedItems: $scope.editedCategories
      };
      callback = {
        confirm: $scope.SearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, $scope.selectedCollection.name, data, 'Add Categories');
    };

    $scope.OpenSearchModalCategoryAdd = function () {
      $scope.searchType = $scope.searchTypes.CATEGORIES;
      var callback = {};
      var data = {
        tabs: [{
          http: {
            method: 'GET',
            url: $scope.categoryEndpoint,
            params: {
              q: ''
            }
          },
          relationships: ['categories'],
          fields: ['description', 'title'],
          fieldPrefixes: ['', ''],
          id: 'cat_id',
          selectOne: false
        }],
        updatedItems: $scope.addParams.categories
      };
      callback = {
        confirm: $scope.SearchResults,
        cancel: $scope.SearchCancelled
      }; //callback object (confirm, cancel), title, message, optionCancel, optionConfirm, httpConfig

      SearchModal.Show(callback, $scope.addParams.name || 'New Collection', data, 'Add Categories');
    };

    $scope.OpenViewModal = function (product) {
      $scope.callback = {};
      var callback = {
        confirm: function confirm() {
          $scope.TabChanged(2);
        },
        cancel: $scope.SearchCancelled
      };
      ViewModal.Show(callback, 'Quick View: ' + product.sku, product);
    };
    /**
     * @param {string} sortBy Sortby term
     * @param {Object} e      Click event
     */


    function changeSortBy(sortBy, e) {
      e.preventDefault();
      vm.sortAscending = vm.allColSearchParams.sortBy === sortBy ? !vm.sortAscending : true;
      vm.allColSearchParams.sortBy = sortBy;
      vm.allColSearchParams.sortType = vm.sortAscending ? 'asc' : 'desc';
      $scope.SearchCollections(vm.allColSearchParams.page);
    }

    $scope.SearchCollections = function (page, query) {
      $scope.loadingMore = true;
      vm.allColSearchParams.q = query;
      $scope.searchTerm = vm.allColSearchParams.q;
      vm.allColSearchParams.page = page || 1;
      var req = {
        method: 'GET',
        url: $scope.collectionEndpoint,
        params: vm.allColSearchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.collections = resp.collections;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.loadingMore = false;
      });
    };

    $scope.SearchCollection = function (rpp, page) {
      $scope.productsLoading = true;
      $scope.searchParams.rpp = rpp;
      $scope.searchParams.page = page || 1;
      $scope.searchParams['searchFields[]'] = ['description', 'sku'];
      var req = {
        method: 'GET',
        url: $scope.collectionEndpoint + $scope.selectedCollection.id,
        params: $scope.searchParams
      };
      Utils.getHttpPromise(req).then(function (resp) {
        $scope.selectedCollection = resp.collection;
      }, function (errResp) {
        Debug.error(errResp);
      })["finally"](function () {
        $scope.productsLoading = false;
      });
    };

    $scope.AddCollection = function (id) {
      // If id is null, we are adding new collection
      $scope.loading = true;
      var updateParams = {
        products: [],
        categories: []
      };
      var error = false;
      var req = {};

      if (id) {
        updateParams.name = $scope.selectedCollection.name;
        updateParams.image = $scope.selectedCollection.img_url;
        updateParams.description = $scope.selectedCollection.description;
        updateParams.products = $scope.editedProducts.map(function (product) {
          return product.value.product_id;
        });
        updateParams.categories = $scope.editedCategories.map(function (category) {
          return category.value.cat_id;
        });
        req = {
          method: 'PUT',
          url: $scope.collectionEndpoint + id,
          data: updateParams
        };
      } else if ($scope.addParams.name && ($scope.addParams.products.length || $scope.addParams.categories.length)) {
        for (var i = 0; i < $scope.addParams.products.length; i++) {
          updateParams.products.push($scope.addParams.products[i].value.product_id);
        }

        for (var j = 0; j < $scope.addParams.categories.length; j++) {
          updateParams.categories.push($scope.addParams.categories[j].value.cat_id);
        }

        updateParams.name = $scope.addParams.name;
        updateParams.description = $scope.addParams.description;
        updateParams.image = $scope.addParams.img_url;
        req = {
          method: 'POST',
          url: $scope.collectionEndpoint,
          data: updateParams
        };
      } else {
        error = true;
      }

      if (!error) {
        Utils.getHttpPromise(req).then(function (resp) {
          if (!resp.errors.length) {
            if (!id) {
              $scope.selectedCollection = {
                id: resp.collection_id,
                name: req.data.name,
                description: req.data.description
              };
              $scope.addParams = {
                products: [],
                categories: []
              };
              $scope.activeTab = 2;
            } else {
              $scope.TabChanged(2);
              $scope.showChanges = false;
              $scope.editedProducts = [];
              $scope.editedCategories = [];
            }
          }
        }, function (errResp) {
          Debug.error(errResp);
        })["finally"](function () {
          $scope.loading = false;
        });
      } else {
        $scope.loading = false;
      }
    };

    $scope.DeleteCollection = function (id) {
      var callback = {
        confirm: function confirm() {
          $scope.loading = true;
          var req = {
            method: 'DELETE',
            url: $scope.collectionEndpoint + id
          };
          Utils.getHttpPromise(req).then(function () {
            $scope.activeTab = 0;
            $scope.selectedCollection = null;
          }, function (errResp) {
            Debug.error(errResp);
          });
        },
        cancel: function cancel() {}
      };
      $scope.confirm.Show(callback, 'Delete Collection?', 'This will delete your collection and any products associated with it.', 'Back', 'DELETE');
    };

    $scope.ShowChanges = function () {
      $scope.showChanges = !$scope.showChanges;
    };

    $scope.ChangeView = function () {
      $scope.viewProducts = !$scope.viewProducts;
    };

    $scope.OpenMediaFrame = function (image) {
      // eslint-disable-next-line no-undef
      var fileFrame = wp.media({
        title: 'Select or Upload Logo image',
        library: {
          type: 'image'
        },
        button: {
          text: 'Select'
        },
        multiple: false
      });
      fileFrame.on('select', function () {
        $scope.$apply(function () {
          $scope.attachment = fileFrame.state().get('selection').first().toJSON();
          $scope.removingImage = true;

          if (image === 'add_img') {
            $scope.addParams.img_url = $scope.attachment.url;
          } else if (image === 'update_img') {
            $scope.selectedCollection.img_url = $scope.attachment.url;
          }
        });
      });
      fileFrame.open();
    };
  }
})();
// EXTERNAL MODULE: ./assets/app/dev/controllers/catalog-pricesheets.controller.ts
var catalog_pricesheets_controller = __webpack_require__(261);
// EXTERNAL MODULE: ./assets/app/dev/controllers/catalog-promocodes.controller.ts
var catalog_promocodes_controller = __webpack_require__(6679);
// EXTERNAL MODULE: ./assets/app/dev/controllers/catalog-uom.controller.ts
var catalog_uom_controller = __webpack_require__(9624);
// EXTERNAL MODULE: ./assets/app/dev/controllers/contact.controller.ts
var contact_controller = __webpack_require__(696);
// EXTERNAL MODULE: ./assets/app/dev/controllers/customers-groups.controller.ts
var customers_groups_controller = __webpack_require__(6951);
// EXTERNAL MODULE: ./assets/app/dev/controllers/login.controller.ts
var login_controller = __webpack_require__(8628);
// EXTERNAL MODULE: ./assets/app/dev/controllers/payment-processor.controller.ts
var payment_processor_controller = __webpack_require__(9493);
// EXTERNAL MODULE: ./assets/app/dev/controllers/payments.controller.ts
var payments_controller = __webpack_require__(6962);
// EXTERNAL MODULE: ./assets/app/dev/controllers/punchout-suppliers.controller.ts
var punchout_suppliers_controller = __webpack_require__(3599);
// EXTERNAL MODULE: ./assets/app/dev/controllers/reports.controller.ts
var reports_controller = __webpack_require__(7072);
// EXTERNAL MODULE: ./assets/app/dev/controllers/reset-password.controller.ts
var reset_password_controller = __webpack_require__(5077);
// EXTERNAL MODULE: ./assets/app/dev/controllers/shipping.controller.ts
var shipping_controller = __webpack_require__(7199);
// EXTERNAL MODULE: ./assets/app/dev/controllers/shipping-flat-rates.controller.ts
var shipping_flat_rates_controller = __webpack_require__(4104);
// EXTERNAL MODULE: ./assets/app/dev/controllers/shipping-parcels.controller.ts
var shipping_parcels_controller = __webpack_require__(7930);
// EXTERNAL MODULE: ./assets/app/dev/controllers/subscribe.controller.ts
var subscribe_controller = __webpack_require__(8147);
// EXTERNAL MODULE: ./assets/app/dev/controllers/tenant-login.controller.ts
var tenant_login_controller = __webpack_require__(5069);
;// CONCATENATED MODULE: ./assets/app/dev/controllers/index.ts






















// EXTERNAL MODULE: ./assets/app/dev/directives/compile-html.directive.ts
var compile_html_directive = __webpack_require__(5211);
// EXTERNAL MODULE: ./assets/app/dev/directives/copy-to-clipboard.directive.ts
var copy_to_clipboard_directive = __webpack_require__(4562);
// EXTERNAL MODULE: ./assets/app/dev/directives/file-model.directive.ts
var file_model_directive = __webpack_require__(3264);
// EXTERNAL MODULE: ./assets/app/dev/directives/group-file.directive.ts
var group_file_directive = __webpack_require__(9457);
// EXTERNAL MODULE: ./assets/app/dev/directives/format.directive.ts
var format_directive = __webpack_require__(7942);
// EXTERNAL MODULE: ./assets/app/dev/directives/resize.directive.ts
var resize_directive = __webpack_require__(1908);
// EXTERNAL MODULE: ./assets/app/dev/directives/tel-input.directive.ts
var tel_input_directive = __webpack_require__(9402);
// EXTERNAL MODULE: ./assets/app/dev/directives/tel.filter.ts
var tel_filter = __webpack_require__(1569);
;// CONCATENATED MODULE: ./assets/app/dev/directives/index.ts








// EXTERNAL MODULE: ./assets/app/dev/factories/admin.factory.ts
var admin_factory = __webpack_require__(2233);
// EXTERNAL MODULE: ./assets/app/dev/factories/customerAccounts.factory.ts
var customerAccounts_factory = __webpack_require__(8099);
// EXTERNAL MODULE: ./assets/app/dev/factories/debug.factory.ts
var debug_factory = __webpack_require__(9574);
// EXTERNAL MODULE: ./assets/app/dev/factories/emailData.factory.ts
var emailData_factory = __webpack_require__(6314);
// EXTERNAL MODULE: ./assets/app/dev/factories/interceptor.factory.ts
var interceptor_factory = __webpack_require__(6905);
// EXTERNAL MODULE: ./assets/app/dev/factories/modal-alert.factory.ts
var modal_alert_factory = __webpack_require__(2350);
// EXTERNAL MODULE: ./assets/app/dev/factories/modal-confirm.factory.ts
var modal_confirm_factory = __webpack_require__(5492);
// EXTERNAL MODULE: ./assets/app/dev/factories/modal-edit.factory.ts
var modal_edit_factory = __webpack_require__(9828);
// EXTERNAL MODULE: ./assets/app/dev/factories/modal-search.factory.ts
var modal_search_factory = __webpack_require__(1386);
// EXTERNAL MODULE: ./assets/app/dev/factories/modal-select.factory.ts
var modal_select_factory = __webpack_require__(4682);
// EXTERNAL MODULE: ./assets/app/dev/factories/modal-two-factor.factory.ts
var modal_two_factor_factory = __webpack_require__(8027);
// EXTERNAL MODULE: ./assets/app/dev/factories/modal-view.factory.ts
var modal_view_factory = __webpack_require__(9504);
// EXTERNAL MODULE: ./assets/app/dev/factories/pricesheets.factory.ts
var pricesheets_factory = __webpack_require__(5590);
// EXTERNAL MODULE: ./assets/app/dev/factories/relationship-search.factory.ts
var relationship_search_factory = __webpack_require__(8379);
// EXTERNAL MODULE: ./assets/app/dev/factories/reports.factory.ts
var reports_factory = __webpack_require__(8374);
// EXTERNAL MODULE: ./assets/app/dev/factories/settings.factory.ts
var settings_factory = __webpack_require__(1310);
// EXTERNAL MODULE: ./assets/app/dev/factories/tenant.factory.ts
var tenant_factory = __webpack_require__(4150);
// EXTERNAL MODULE: ./assets/app/dev/factories/uom.factory.ts
var uom_factory = __webpack_require__(3922);
// EXTERNAL MODULE: ./assets/app/dev/factories/utils.factory.ts
var utils_factory = __webpack_require__(6065);
// EXTERNAL MODULE: ./assets/app/dev/factories/warningModal.factory.ts
var warningModal_factory = __webpack_require__(8726);
;// CONCATENATED MODULE: ./assets/app/dev/factories/index.ts




















// EXTERNAL MODULE: ./assets/app/dev/run.ts
var run = __webpack_require__(9061);
;// CONCATENATED MODULE: ./assets/app/dev/admin.ts






})();

/******/ })()
;